%------------------------------------------------------------------------------
% File     : VBT00033^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_InsertCorrectness 00957_062583
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0067_VEBT_InsertCorrectness_00957_062583 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9625 (3017 unt; 626 typ;   0 def)
%            Number of atoms       : 28228 (9616 equ;   5 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 172803 (2132   ~; 334   |;2154   &;155318   @)
%                                         (   0 <=>;12865  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   12 (  11 usr)
%            Number of type conns  : 4098 (4098   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  619 ( 615 usr;  16 con; 0-9 aty)
%            Number of variables   : 29308 (2671   ^25246   !; 828   ?;29308   :)
%                                         ( 563  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 21:49:02.923
%------------------------------------------------------------------------------
% Could-be-implicit typings (17)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (609)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,type,
    counta4013691401010221786attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Def_OGr,type,
    bNF_Gr: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num__rel,type,
    bit_un5425074673868309765um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num__rel,type,
    bit_un3595099601533988841um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Complex_Orcis,type,
    rcis: real > real > complex ).

thf(sy_c_Countable__Set_Ocountable,type,
    countable_countable: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofinite__subsets__at__top,type,
    finite5375528669736107172at_top: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ ( set @ A ) ) ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__idem__on,type,
    finite673082921795544331dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__mult__class_Oprod__list,type,
    groups5270119922927024881d_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_OBleast,type,
    bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_Oabort__Bleast,type,
    abort_Bleast: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocoset,type,
    coset: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldl,type,
    foldl: 
      !>[B: $tType,A: $tType] : ( ( B > A > B ) > B > ( list @ A ) > B ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osort__key,type,
    linorder_sort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olinorder__class_Ostable__sort__key,type,
    linord3483353639454293061rt_key: 
      !>[B: $tType,A: $tType] : ( ( ( B > A ) > ( list @ B ) > ( list @ B ) ) > $o ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Orec__list,type,
    rec_list: 
      !>[C: $tType,A: $tType] : ( C > ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistrelp,type,
    listrelp: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olists,type,
    lists: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_Omin__list,type,
    min_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Omin__list__rel,type,
    min_list_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Partial__Function_Ofun__ord,type,
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) ).

thf(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( A > ( A > A > A ) > A > nat > A ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Real_OReal,type,
    real2: ( nat > rat ) > real ).

thf(sy_c_Real_Ocauchy,type,
    cauchy: ( nat > rat ) > $o ).

thf(sy_c_Real_Ocr__real,type,
    cr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opcr__real,type,
    pcr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opositive,type,
    positive2: real > $o ).

thf(sy_c_Real_Orealrel,type,
    realrel: ( nat > rat ) > ( nat > rat ) > $o ).

thf(sy_c_Real_Orep__real,type,
    rep_real: real > nat > rat ).

thf(sy_c_Real_Ovanishes,type,
    vanishes: ( nat > rat ) > $o ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odependent,type,
    real_V358717886546972837endent: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orefl__on,type,
    refl_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert2: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Oremove,type,
    remove: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Insert_Ovebt__insert,type,
    vEBT_vebt_insert: vEBT_VEBT > nat > vEBT_VEBT ).

thf(sy_c_VEBT__Insert_Ovebt__insert__rel,type,
    vEBT_vebt_insert_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull,type,
    vEBT_VEBT_minNull: vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_i____,type,
    i: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_ma____,type,
    ma: nat ).

thf(sy_v_mi____,type,
    mi: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

thf(sy_v_xa____,type,
    xa: nat ).

thf(sy_v_y____,type,
    y: nat ).

% Relevant facts (8182)
thf(fact_0__092_060open_062mi_A_092_060noteq_062_Ama_092_060close_062,axiom,
    mi != ma ).

% \<open>mi \<noteq> ma\<close>
thf(fact_1__C5_Ohyps_C_I7_J,axiom,
    ord_less_eq @ nat @ mi @ ma ).

% "5.hyps"(7)
thf(fact_2__092_060open_062x_A_092_060noteq_062_Amax_Ama_Ami_092_060close_062,axiom,
    xa
 != ( ord_max @ nat @ ma @ mi ) ).

% \<open>x \<noteq> max ma mi\<close>
thf(fact_3_False,axiom,
    ( vEBT_VEBT_low @ y @ na )
 != ( vEBT_VEBT_low @ mi @ na ) ).

% False
thf(fact_4_abcdef,axiom,
    ord_less @ nat @ xa @ mi ).

% abcdef
thf(fact_5_mimaxrel,axiom,
    ( ( xa != mi )
    & ( xa != ma ) ) ).

% mimaxrel
thf(fact_6_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_7_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_8_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ( ord_less @ A @ X @ Z )
            & ( ord_less @ A @ Y @ Z ) ) ) ) ).

% max_less_iff_conj
thf(fact_9_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_10_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_11_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_12_max_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A] :
          ( ( ord_max @ A @ A2 @ A2 )
          = A2 ) ) ).

% max.idem
thf(fact_13_max_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_max @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) )
          = ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.left_idem
thf(fact_14_max_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A2 @ B2 ) @ B2 )
          = ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.right_idem
thf(fact_15__C5_C,axiom,
    ( ( mi = ma )
   => ! [X2: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ treeList ) )
       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) ) ).

% "5"
thf(fact_16_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_17_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_18_bit__split__inv,axiom,
    ! [X: nat,D2: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X @ D2 ) @ ( vEBT_VEBT_low @ X @ D2 ) @ D2 )
      = X ) ).

% bit_split_inv
thf(fact_19_cc,axiom,
    ( i
    = ( vEBT_VEBT_high @ mi @ na ) ) ).

% cc
thf(fact_20_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% order_antisym_conv
thf(fact_21_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_le_cases
thf(fact_22_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_23_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_24_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_linear
thf(fact_25_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_eq_refl
thf(fact_26_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_27_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_28_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ( ord_less_eq @ A @ B3 @ A3 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_29_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B] :
            ! [X4: A] : ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( G @ X4 ) ) ) ) ) ).

% le_fun_def
thf(fact_30_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G2: A > B] :
          ( ! [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G2 ) ) ) ).

% le_funI
thf(fact_31_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G2: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ).

% le_funE
thf(fact_32_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G2: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ).

% le_funD
thf(fact_33_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_34_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_35_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_36_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ( ord_less_eq @ A @ A3 @ B3 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_37_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
             => ( P @ A4 @ B4 ) )
         => ( ! [A4: A,B4: A] :
                ( ( P @ B4 @ A4 )
               => ( P @ A4 @ B4 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_38_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% order_trans
thf(fact_39_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_40_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) ).

% order_antisym
thf(fact_41_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_42_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_43_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [X4: A,Y4: A] :
              ( ( ord_less_eq @ A @ X4 @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X4 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_44_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z ) )
           => ( ( ( ord_less_eq @ A @ X @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_45_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( collect @ A
        @ ^ [X4: A] : ( member @ A @ X4 @ A5 ) )
      = A5 ) ).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_48_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G2: A > B] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G2 @ X3 ) )
     => ( F2 = G2 ) ) ).

% ext
thf(fact_49_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_50_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_imp_not_less
thf(fact_51_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
thf(fact_52_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
thf(fact_53_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_less_linear
thf(fact_54_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_55_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_not_sym
thf(fact_56_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less @ A @ X3 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_57_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less @ B @ X3 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_58_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) ).

% order_less_irrefl
thf(fact_59_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less @ A @ X3 @ Y2 )
                 => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_60_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less @ B @ X3 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_61_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_less_trans
thf(fact_62_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_63_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ( X != Y ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neq_iff
thf(fact_64_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_asym
thf(fact_65_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE
thf(fact_66_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_67_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_68_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_69_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_70_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_71_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less @ A @ A4 @ B4 )
             => ( P @ A4 @ B4 ) )
         => ( ! [A4: A] : ( P @ A4 @ A4 )
           => ( ! [A4: A,B4: A] :
                  ( ( P @ B4 @ A4 )
                 => ( P @ A4 @ B4 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_72_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P2: A > $o] :
            ? [X5: A] : ( P2 @ X5 ) )
        = ( ^ [P3: A > $o] :
            ? [N: A] :
              ( ( P3 @ N )
              & ! [M: A] :
                  ( ( ord_less @ A @ M @ N )
                 => ~ ( P3 @ M ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_73_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_74_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_75_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_cases
thf(fact_76_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv3
thf(fact_77_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ A @ Y5 @ X3 )
                 => ( P @ Y5 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_78_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_79_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_80_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_81_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% less_imp_neq
thf(fact_82_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X @ Z3 )
              & ( ord_less @ A @ Z3 @ Y ) ) ) ) ).

% dense
thf(fact_83_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
        ? [X_12: A] : ( ord_less @ A @ X @ X_12 ) ) ).

% gt_ex
thf(fact_84_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
        ? [Y2: A] : ( ord_less @ A @ Y2 @ X ) ) ).

% lt_ex
thf(fact_85_max_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_max @ A @ B2 @ ( ord_max @ A @ A2 @ C2 ) )
          = ( ord_max @ A @ A2 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.left_commute
thf(fact_86_max_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( ord_max @ A @ B3 @ A3 ) ) ) ) ).

% max.commute
thf(fact_87_max_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A2 @ B2 ) @ C2 )
          = ( ord_max @ A @ A2 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.assoc
thf(fact_88_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ X @ Y )
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_89_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_90_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less @ A @ X3 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_91_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_92_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_93_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less @ B @ X3 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_94_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_less_le_trans
thf(fact_95_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_le_less_trans
thf(fact_96_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_97_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_98_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_less_imp_le
thf(fact_99_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_not_less
thf(fact_100_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_not_le
thf(fact_101_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X4: A,Y4: A] :
              ( ( ord_less_eq @ A @ X4 @ Y4 )
              & ( X4 != Y4 ) ) ) ) ) ).

% order_less_le
thf(fact_102_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X4: A,Y4: A] :
              ( ( ord_less @ A @ X4 @ Y4 )
              | ( X4 = Y4 ) ) ) ) ) ).

% order_le_less
thf(fact_103_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_104_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_105_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ~ ( ord_less_eq @ A @ A3 @ B3 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_106_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_107_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_108_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ( A3 != B3 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_109_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less @ A @ B3 @ A3 )
              | ( A3 = B3 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_110_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X @ W )
               => ( ( ord_less @ A @ W @ Y )
                 => ( ord_less_eq @ A @ W @ Z ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% dense_le_bounded
thf(fact_111_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z @ W )
               => ( ( ord_less @ A @ W @ X )
                 => ( ord_less_eq @ A @ Y @ W ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% dense_ge_bounded
thf(fact_112_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ~ ( ord_less_eq @ A @ B3 @ A3 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_113_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_114_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_115_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ( A3 != B3 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_116_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less @ A @ A3 @ B3 )
              | ( A3 = B3 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_117_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% not_le_imp_less
thf(fact_118_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X4: A,Y4: A] :
              ( ( ord_less_eq @ A @ X4 @ Y4 )
              & ~ ( ord_less_eq @ A @ Y4 @ X4 ) ) ) ) ) ).

% less_le_not_le
thf(fact_119_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y: A,Z: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) ).

% dense_le
thf(fact_120_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,Y: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z @ X3 )
             => ( ord_less_eq @ A @ Y @ X3 ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) ).

% dense_ge
thf(fact_121_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv2
thf(fact_122_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% antisym_conv1
thf(fact_123_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_124_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% leI
thf(fact_125_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ~ ( ord_less @ A @ X @ Y ) ) ) ).

% leD
thf(fact_126_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_max @ A @ X @ Y )
            = Y ) ) ) ).

% max_absorb2
thf(fact_127_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_max @ A @ X @ Y )
            = X ) ) ) ).

% max_absorb1
thf(fact_128_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_129_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_130_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_max @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% max.absorb_iff2
thf(fact_131_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_max @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% max.absorb_iff1
thf(fact_132_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less_eq @ A @ Z @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less_eq @ A @ Z @ X )
            | ( ord_less_eq @ A @ Z @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_133_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_134_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_135_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( A3
              = ( ord_max @ A @ A3 @ B3 ) ) ) ) ) ).

% max.order_iff
thf(fact_136_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_137_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_138_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_139_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_140_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_141_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ B3 @ A3 ) ) ) ) ).

% max_def
thf(fact_142_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_143_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_144_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( A3
                = ( ord_max @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_145_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_146_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z @ X )
            | ( ord_less @ A @ Z @ Y ) ) ) ) ).

% less_max_iff_disj
thf(fact_147__C7_C,axiom,
    ( ( mi != ma )
   => ! [I: nat] :
        ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
       => ( ( ( ( vEBT_VEBT_high @ ma @ na )
              = I )
           => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ ma @ na ) ) )
          & ! [Y5: nat] :
              ( ( ( ( vEBT_VEBT_high @ Y5 @ na )
                  = I )
                & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ Y5 @ na ) ) )
             => ( ( ord_less @ nat @ mi @ Y5 )
                & ( ord_less_eq @ nat @ Y5 @ ma ) ) ) ) ) ) ).

% "7"
thf(fact_148__C0_C,axiom,
    ! [X2: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( vEBT_invar_vebt @ X2 @ na ) ) ).

% "0"
thf(fact_149_not__min__Null__member,axiom,
    ! [T2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ T2 )
     => ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ T2 @ X_12 ) ) ).

% not_min_Null_member
thf(fact_150__C15_C,axiom,
    ( ( ord_less_eq @ nat @ xa @ ( ord_max @ nat @ ma @ mi ) )
    & ( ord_less @ nat @ ( ord_max @ nat @ ma @ mi ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ) ) ).

% "15"
thf(fact_151__C14_C,axiom,
    ( ( xa
      = ( ord_max @ nat @ ma @ mi ) )
   => ! [X2: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) ) )
       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) ) ).

% "14"
thf(fact_152_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: A] :
            ( ( P @ Y2 )
           => ( ord_less @ nat @ ( F2 @ Y2 ) @ B2 ) )
       => ? [X3: A] :
            ( ( P @ X3 )
            & ! [Y5: A] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ nat @ ( F2 @ Y5 ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_153_nat__descend__induct,axiom,
    ! [N2: nat,P: nat > $o,M2: nat] :
      ( ! [K2: nat] :
          ( ( ord_less @ nat @ N2 @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
           => ( ! [I: nat] :
                  ( ( ord_less @ nat @ K2 @ I )
                 => ( P @ I ) )
             => ( P @ K2 ) ) )
       => ( P @ M2 ) ) ) ).

% nat_descend_induct
thf(fact_154_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I2: nat,J: nat] :
      ( ! [I3: nat,J2: nat] :
          ( ( ord_less @ nat @ I3 @ J2 )
         => ( ord_less @ nat @ ( F2 @ I3 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ord_less_eq @ nat @ ( F2 @ I2 ) @ ( F2 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_155_le__neq__implies__less,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( M2 != N2 )
       => ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% le_neq_implies_less
thf(fact_156_less__or__eq__imp__le,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( ord_less @ nat @ M2 @ N2 )
        | ( M2 = N2 ) )
     => ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% less_or_eq_imp_le
thf(fact_157_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
          | ( M = N ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_158_less__imp__le__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% less_imp_le_nat
thf(fact_159__092_060open_062i_A_060_A2_A_094_Am_092_060close_062,axiom,
    ord_less @ nat @ i @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ).

% \<open>i < 2 ^ m\<close>
thf(fact_160__C5_Ohyps_C_I8_J,axiom,
    ord_less @ nat @ ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "5.hyps"(8)
thf(fact_161__C5_Oprems_C,axiom,
    ord_less @ nat @ xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "5.prems"
thf(fact_162__C1_C,axiom,
    vEBT_invar_vebt @ summary @ m ).

% "1"
thf(fact_163__C5_OIH_C_I1_J,axiom,
    ! [X2: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X2 @ na )
        & ! [Xa: nat] :
            ( ( ord_less @ nat @ Xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
           => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ X2 @ Xa ) @ na ) ) ) ) ).

% "5.IH"(1)
thf(fact_164__092_060open_062invar__vebt_A_ItreeList_A_B_Ai_J_An_092_060close_062,axiom,
    vEBT_invar_vebt @ ( nth @ vEBT_VEBT @ treeList @ i ) @ na ).

% \<open>invar_vebt (treeList ! i) n\<close>
thf(fact_165_valid__insert__both__member__options__pres,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat,Y: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
           => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ Y ) @ X ) ) ) ) ) ).

% valid_insert_both_member_options_pres
thf(fact_166_valid__insert__both__member__options__add,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ X ) @ X ) ) ) ).

% valid_insert_both_member_options_add
thf(fact_167_bb,axiom,
    ( ( ( vEBT_VEBT_high @ y @ na )
      = i )
    & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ i ) @ ( vEBT_VEBT_low @ y @ na ) ) ) ).

% bb
thf(fact_168__C6_C,axiom,
    ( ( ord_less_eq @ nat @ mi @ ma )
    & ( ord_less @ nat @ ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ) ) ).

% "6"
thf(fact_169_myIHs,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X @ na )
       => ( ( ord_less @ nat @ Xa2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
         => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ X @ Xa2 ) @ na ) ) ) ) ).

% myIHs
thf(fact_170_highlowprop,axiom,
    ( ( ord_less @ nat @ ( vEBT_VEBT_high @ mi @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_low @ mi @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) ) ).

% highlowprop
thf(fact_171_aa,axiom,
    ( ( nth @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ i )
    = ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ i ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) ).

% aa
thf(fact_172__C11_C,axiom,
    ! [X2: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) ) )
     => ( vEBT_invar_vebt @ X2 @ na ) ) ).

% "11"
thf(fact_173__092_060open_062invar__vebt_A_ItreeList_091high_Ami_An_A_058_061_Avebt__insert_A_ItreeList_A_B_Ahigh_Ami_An_J_A_Ilow_Ami_An_J_093_A_B_Ai_J_An_092_060close_062,axiom,
    vEBT_invar_vebt @ ( nth @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ i ) @ na ).

% \<open>invar_vebt (treeList[high mi n := vebt_insert (treeList ! high mi n) (low mi n)] ! i) n\<close>
thf(fact_174__092_060open_062high_A_Imax_Ama_Ami_J_An_A_061_Ai_A_092_060longrightarrow_062_Aboth__member__options_A_ItreeList_091high_Ami_An_A_058_061_Avebt__insert_A_ItreeList_A_B_Ahigh_Ami_An_J_A_Ilow_Ami_An_J_093_A_B_Ai_J_A_Ilow_A_Imax_Ama_Ami_J_An_J_092_060close_062,axiom,
    ( ( ( vEBT_VEBT_high @ ( ord_max @ nat @ ma @ mi ) @ na )
      = i )
   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ i ) @ ( vEBT_VEBT_low @ ( ord_max @ nat @ ma @ mi ) @ na ) ) ) ).

% \<open>high (max ma mi) n = i \<longrightarrow> both_member_options (treeList[high mi n := vebt_insert (treeList ! high mi n) (low mi n)] ! i) (low (max ma mi) n)\<close>
thf(fact_175__C4_C,axiom,
    ! [I: nat] :
      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ X6 ) )
        = ( vEBT_V8194947554948674370ptions @ summary @ I ) ) ) ).

% "4"
thf(fact_176__C3_C,axiom,
    ( deg
    = ( plus_plus @ nat @ na @ m ) ) ).

% "3"
thf(fact_177__C2_C,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "2"
thf(fact_178_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F3 @ G )
              & ~ ( ord_less_eq @ ( A > B ) @ G @ F3 ) ) ) ) ) ).

% less_fun_def
thf(fact_179_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ B @ ( F2 @ Y5 ) @ ( F2 @ X3 ) )
                 => ( P @ Y5 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_180_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ B @ ( F2 @ Y5 ) @ ( F2 @ X3 ) )
                 => ( P @ Y5 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_181_nat__neq__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( M2 != N2 ) )
      = ( ( ord_less @ nat @ M2 @ N2 )
        | ( ord_less @ nat @ N2 @ M2 ) ) ) ).

% nat_neq_iff
thf(fact_182_less__not__refl,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_not_refl
thf(fact_183_less__not__refl2,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ N2 @ M2 )
     => ( M2 != N2 ) ) ).

% less_not_refl2
thf(fact_184_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) ).

% less_not_refl3
thf(fact_185_less__irrefl__nat,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_irrefl_nat
thf(fact_186_nat__less__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N3 )
             => ( P @ M3 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% nat_less_induct
thf(fact_187_infinite__descent,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N3 )
              & ~ ( P @ M3 ) ) )
     => ( P @ N2 ) ) ).

% infinite_descent
thf(fact_188_linorder__neqE__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less @ nat @ X @ Y )
       => ( ord_less @ nat @ Y @ X ) ) ) ).

% linorder_neqE_nat
thf(fact_189_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V: A > nat,X: A] :
      ( ! [X3: A] :
          ( ~ ( P @ X3 )
         => ? [Y5: A] :
              ( ( ord_less @ nat @ ( V @ Y5 ) @ ( V @ X3 ) )
              & ~ ( P @ Y5 ) ) )
     => ( P @ X ) ) ).

% infinite_descent_measure
thf(fact_190_le__refl,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ N2 ) ).

% le_refl
thf(fact_191_le__trans,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I2 @ K ) ) ) ).

% le_trans
thf(fact_192_eq__imp__le,axiom,
    ! [M2: nat,N2: nat] :
      ( ( M2 = N2 )
     => ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% eq_imp_le
thf(fact_193_le__antisym,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M2 )
       => ( M2 = N2 ) ) ) ).

% le_antisym
thf(fact_194_nat__le__linear,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
      | ( ord_less_eq @ nat @ N2 @ M2 ) ) ).

% nat_le_linear
thf(fact_195_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y5: nat] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ nat @ Y5 @ X3 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_196_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M2: A > nat] :
      ( ( P @ K )
     => ? [X3: A] :
          ( ( P @ X3 )
          & ! [Y5: A] :
              ( ( P @ Y5 )
             => ( ord_less_eq @ nat @ ( M2 @ X3 ) @ ( M2 @ Y5 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_197_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
          & ( M != N ) ) ) ) ).

% nat_less_le
thf(fact_198__C13_C,axiom,
    ! [I: nat] :
      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ I ) @ X6 ) )
        = ( vEBT_V8194947554948674370ptions @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) ) @ ( vEBT_vebt_insert @ summary @ ( vEBT_VEBT_high @ mi @ na ) ) @ summary ) @ I ) ) ) ).

% "13"
thf(fact_199_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N: nat,TreeList: list @ vEBT_VEBT,X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X4 @ N ) ) @ ( vEBT_VEBT_low @ X4 @ N ) ) ) ) ).

% in_children_def
thf(fact_200__C12_C,axiom,
    vEBT_invar_vebt @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) ) @ ( vEBT_vebt_insert @ summary @ ( vEBT_VEBT_high @ mi @ na ) ) @ summary ) @ m ).

% "12"
thf(fact_201__092_060open_062vebt__member_A_ItreeList_A_B_Ai_J_A_Ilow_Ay_An_J_A_092_060or_062_Alow_Ay_An_A_061_Alow_Ami_An_092_060close_062,axiom,
    ( ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ i ) @ ( vEBT_VEBT_low @ y @ na ) )
    | ( ( vEBT_VEBT_low @ y @ na )
      = ( vEBT_VEBT_low @ mi @ na ) ) ) ).

% \<open>vebt_member (treeList ! i) (low y n) \<or> low y n = low mi n\<close>
thf(fact_202__092_060open_062vebt__member_A_ItreeList_A_B_Ai_J_A_Ilow_Ay_An_J_092_060close_062,axiom,
    vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ i ) @ ( vEBT_VEBT_low @ y @ na ) ).

% \<open>vebt_member (treeList ! i) (low y n)\<close>
thf(fact_203__C5_OIH_C_I2_J,axiom,
    ! [X: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ summary @ X ) @ m ) ) ).

% "5.IH"(2)
thf(fact_204__092_060open_062length_A_ItreeList_091high_Ami_An_A_058_061_Avebt__insert_A_ItreeList_A_B_Ahigh_Ami_An_J_A_Ilow_Ami_An_J_093_J_A_061_A2_A_094_Am_092_060close_062,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% \<open>length (treeList[high mi n := vebt_insert (treeList ! high mi n) (low mi n)]) = 2 ^ m\<close>
thf(fact_205_post__member__pre__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat,Y: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ( vEBT_vebt_member @ ( vEBT_vebt_insert @ T2 @ X ) @ Y )
           => ( ( vEBT_vebt_member @ T2 @ Y )
              | ( X = Y ) ) ) ) ) ) ).

% post_member_pre_member
thf(fact_206_member__bound,axiom,
    ! [Tree: vEBT_VEBT,X: nat,N2: nat] :
      ( ( vEBT_vebt_member @ Tree @ X )
     => ( ( vEBT_invar_vebt @ Tree @ N2 )
       => ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% member_bound
thf(fact_207_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_208_nth__list__update__neq,axiom,
    ! [A: $tType,I2: nat,J: nat,Xs: list @ A,X: A] :
      ( ( I2 != J )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% nth_list_update_neq
thf(fact_209_min__Null__member,axiom,
    ! [T2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ~ ( vEBT_vebt_member @ T2 @ X ) ) ).

% min_Null_member
thf(fact_210_both__member__options__equiv__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
        = ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% both_member_options_equiv_member
thf(fact_211_valid__member__both__member__options,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
       => ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% valid_member_both_member_options
thf(fact_212_inthall,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,N2: nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% inthall
thf(fact_213_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M2: num,N2: num] :
          ( ( ( numeral_numeral @ A @ M2 )
            = ( numeral_numeral @ A @ N2 ) )
          = ( M2 = N2 ) ) ) ).

% numeral_eq_iff
thf(fact_214_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A,Y: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I2 @ Y )
      = ( list_update @ A @ Xs @ I2 @ Y ) ) ).

% list_update_overwrite
thf(fact_215_member__correct,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_vebt_member @ T2 @ X )
        = ( member @ nat @ X @ ( vEBT_set_vebt @ T2 ) ) ) ) ).

% member_correct
thf(fact_216_high__bound__aux,axiom,
    ! [Ma: nat,N2: nat,M2: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M2 ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ).

% high_bound_aux
thf(fact_217_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: num,N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ num @ M2 @ N2 ) ) ) ).

% numeral_le_iff
thf(fact_218_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: num,N2: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ M2 @ N2 ) ) ) ).

% numeral_less_iff
thf(fact_219_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V2: num,W2: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W2 ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V2 @ W2 ) ) @ Z ) ) ) ).

% add_numeral_left
thf(fact_220_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M2 @ N2 ) ) ) ) ).

% numeral_plus_numeral
thf(fact_221_nat__add__left__cancel__less,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M2 ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less @ nat @ M2 @ N2 ) ) ).

% nat_add_left_cancel_less
thf(fact_222_nat__add__left__cancel__le,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M2 ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% nat_add_left_cancel_le
thf(fact_223_length__list__update,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs @ I2 @ X ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_list_update
thf(fact_224_list__update__id,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ I2 ) )
      = Xs ) ).

% list_update_id
thf(fact_225_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 )
     => ( ( list_update @ A @ Xs @ I2 @ X )
        = Xs ) ) ).

% list_update_beyond
thf(fact_226_nth__list__update__eq,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I2 )
        = X ) ) ).

% nth_list_update_eq
thf(fact_227_set__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I2 ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_228_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_229_Ex__list__of__length,axiom,
    ! [A: $tType,N2: nat] :
    ? [Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs2 )
      = N2 ) ).

% Ex_list_of_length
thf(fact_230_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs != Ys ) ) ).

% neq_if_length_neq
thf(fact_231_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs2: list @ A] :
          ( ! [Ys2: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys2 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) ).

% length_induct
thf(fact_232_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X: A,Y: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y ) )
         => ( X != Y ) ) ) ).

% size_neq_size_imp_neq
thf(fact_233_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M2 @ L )
          = ( plus_plus @ nat @ K @ N2 ) )
       => ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% less_add_eq_less
thf(fact_234_trans__less__add2,axiom,
    ! [I2: nat,J: nat,M2: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ M2 @ J ) ) ) ).

% trans_less_add2
thf(fact_235_trans__less__add1,axiom,
    ! [I2: nat,J: nat,M2: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ J @ M2 ) ) ) ).

% trans_less_add1
thf(fact_236_add__less__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_237_not__add__less2,axiom,
    ! [J: nat,I2: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I2 ) @ I2 ) ).

% not_add_less2
thf(fact_238_not__add__less1,axiom,
    ! [I2: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J ) @ I2 ) ).

% not_add_less1
thf(fact_239_add__less__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_less_mono
thf(fact_240_add__lessD1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K )
     => ( ord_less @ nat @ I2 @ K ) ) ).

% add_lessD1
thf(fact_241_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M: nat,N: nat] :
        ? [K3: nat] :
          ( N
          = ( plus_plus @ nat @ M @ K3 ) ) ) ) ).

% nat_le_iff_add
thf(fact_242_trans__le__add2,axiom,
    ! [I2: nat,J: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ M2 @ J ) ) ) ).

% trans_le_add2
thf(fact_243_trans__le__add1,axiom,
    ! [I2: nat,J: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ J @ M2 ) ) ) ).

% trans_le_add1
thf(fact_244_add__le__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_245_add__le__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_le_mono
thf(fact_246_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N3: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_247_add__leD2,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M2 @ K ) @ N2 )
     => ( ord_less_eq @ nat @ K @ N2 ) ) ).

% add_leD2
thf(fact_248_add__leD1,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M2 @ K ) @ N2 )
     => ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% add_leD1
thf(fact_249_le__add2,axiom,
    ! [N2: nat,M2: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ M2 @ N2 ) ) ).

% le_add2
thf(fact_250_le__add1,axiom,
    ! [N2: nat,M2: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M2 ) ) ).

% le_add1
thf(fact_251_add__leE,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M2 @ K ) @ N2 )
     => ~ ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ~ ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% add_leE
thf(fact_252_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_Bit0
thf(fact_253_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z2: list @ A] : ( Y3 = Z2 ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( nth @ A @ Xs3 @ I4 )
                  = ( nth @ A @ Ys3 @ I4 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_254_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ K )
           => ? [X6: A] : ( P @ I4 @ X6 ) ) )
      = ( ? [Xs3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = K )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K )
               => ( P @ I4 @ ( nth @ A @ Xs3 @ I4 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_255_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I3 )
              = ( nth @ A @ Ys @ I3 ) ) )
       => ( Xs = Ys ) ) ) ).

% nth_equalityI
thf(fact_256_nat__add__max__right,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( plus_plus @ nat @ M2 @ ( ord_max @ nat @ N2 @ Q2 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ ( plus_plus @ nat @ M2 @ Q2 ) ) ) ).

% nat_add_max_right
thf(fact_257_nat__add__max__left,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M2 @ N2 ) @ Q2 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M2 @ Q2 ) @ ( plus_plus @ nat @ N2 @ Q2 ) ) ) ).

% nat_add_max_left
thf(fact_258_nth__mem,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ ( nth @ A @ Xs @ N2 ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_259_list__ball__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) )
       => ( P @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% list_ball_nth
thf(fact_260_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I4 )
              = X ) ) ) ) ).

% in_set_conv_nth
thf(fact_261_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,X: A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I3 ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( P @ X ) ) ) ).

% all_nth_imp_all_set
thf(fact_262_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) )
      = ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_263_set__update__memI,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ X @ ( set2 @ A @ ( list_update @ A @ Xs @ N2 @ X ) ) ) ) ).

% set_update_memI
thf(fact_264_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N2: nat] :
      ( ( P @ K )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ? [Y5: A] :
                ( ( P @ Y5 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y5 ) @ ( F2 @ X3 ) ) ) )
       => ? [Y2: A] :
            ( ( P @ Y2 )
            & ~ ( ord_less @ nat @ ( F2 @ Y2 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N2 ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_265_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M2: nat,K: nat] :
      ( ! [M4: nat,N3: nat] :
          ( ( ord_less @ nat @ M4 @ N3 )
         => ( ord_less @ nat @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M2 ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M2 @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_266_list__update__same__conv,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I2 @ X )
          = Xs )
        = ( ( nth @ A @ Xs @ I2 )
          = X ) ) ) ).

% list_update_same_conv
thf(fact_267_nth__list__update,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I2 = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
            = X ) )
        & ( ( I2 != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ J )
            = ( nth @ A @ Xs @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_268_le__num__One__iff,axiom,
    ! [X: num] :
      ( ( ord_less_eq @ num @ X @ one2 )
      = ( X = one2 ) ) ).

% le_num_One_iff
thf(fact_269_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B5 )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( member @ A @ X4 @ B5 ) ) ) ) ).

% subset_code(1)
thf(fact_270_list__update__swap,axiom,
    ! [A: $tType,I2: nat,I5: nat,Xs: list @ A,X: A,X7: A] :
      ( ( I2 != I5 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ I5 @ X7 )
        = ( list_update @ A @ ( list_update @ A @ Xs @ I5 @ X7 ) @ I2 @ X ) ) ) ).

% list_update_swap
thf(fact_271_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A,X: A,I2: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
     => ( ( member @ A @ X @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I2 @ X ) ) @ A5 ) ) ) ).

% set_update_subsetI
thf(fact_272_set__n__deg__not__0,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,M2: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 ) ) ) ).

% set_n_deg_not_0
thf(fact_273_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H: nat,L2: nat,D3: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D3 ) ) @ L2 ) ) ) ).

% bit_concat_def
thf(fact_274_low__inv,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X ) @ N2 )
        = X ) ) ).

% low_inv
thf(fact_275_high__inv,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X ) @ N2 )
        = Y ) ) ).

% high_inv
thf(fact_276__C9_C,axiom,
    ( ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = na ) ).

% "9"
thf(fact_277_power2__nat__le__imp__le,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N2 )
     => ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% power2_nat_le_imp_le
thf(fact_278_power2__nat__le__eq__le,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% power2_nat_le_eq_le
thf(fact_279_self__le__ge2__pow,axiom,
    ! [K: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M2 @ ( power_power @ nat @ K @ M2 ) ) ) ).

% self_le_ge2_pow
thf(fact_280_enat__ord__number_I1_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M2 ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(1)
thf(fact_281_less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% less_exp
thf(fact_282_enat__ord__number_I2_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M2 ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(2)
thf(fact_283_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_284_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X4: nat,N: nat] : ( divide_divide @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% high_def
thf(fact_285_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N2 ) ) ) ) ).

% numeral_times_numeral
thf(fact_286_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V2: num,W2: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W2 ) ) @ Z ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_287_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_288_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_289_nat__1__eq__mult__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M2 @ N2 ) )
      = ( ( M2
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_290_nat__mult__eq__1__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( times_times @ nat @ M2 @ N2 )
        = ( one_one @ nat ) )
      = ( ( M2
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_291_set__vebt__set__vebt_H__valid,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_set_vebt @ T2 )
        = ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_set_vebt'_valid
thf(fact_292_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_293_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_294_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N2 ) )
          = ( one2 = N2 ) ) ) ).

% one_eq_numeral_iff
thf(fact_295_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( numeral_numeral @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_296_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M2 )
              = ( power_power @ A @ A2 @ N2 ) )
            = ( M2 = N2 ) ) ) ) ).

% power_inject_exp
thf(fact_297_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_298_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_299_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_300_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_301_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_302_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_303_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less @ nat @ X @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_304_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M2: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M2 ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M2 @ N2 ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_305_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M2: num,N2: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M2 ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M2 @ N2 ) ) ) ) ) ).

% power_add_numeral
thf(fact_306_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_307_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less_eq @ nat @ X @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_308_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% one_plus_numeral
thf(fact_309_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N2 @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_310_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N2 @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_311_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ one2 @ N2 ) ) ) ).

% one_less_numeral_iff
thf(fact_312_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N2: extended_enat] :
      ( ! [N3: extended_enat] :
          ( ! [M3: extended_enat] :
              ( ( ord_less @ extended_enat @ M3 @ N3 )
             => ( P @ M3 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% enat_less_induct
thf(fact_313_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_one_over
thf(fact_314_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N2: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_315_nat__mult__1,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N2 )
      = N2 ) ).

% nat_mult_1
thf(fact_316_nat__mult__1__right,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ N2 @ ( one_one @ nat ) )
      = N2 ) ).

% nat_mult_1_right
thf(fact_317_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_divide
thf(fact_318_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N2: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N2 ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_319_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_mult_distrib
thf(fact_320_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_commutes
thf(fact_321_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M2 @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M2 ) @ N2 ) ) ) ).

% power_mult
thf(fact_322_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_323_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_324_add__One__commute,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ N2 )
      = ( plus_plus @ num @ N2 @ one2 ) ) ).

% add_One_commute
thf(fact_325_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_326_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_327_le__cube,axiom,
    ! [M2: nat] : ( ord_less_eq @ nat @ M2 @ ( times_times @ nat @ M2 @ ( times_times @ nat @ M2 @ M2 ) ) ) ).

% le_cube
thf(fact_328_le__square,axiom,
    ! [M2: nat] : ( ord_less_eq @ nat @ M2 @ ( times_times @ nat @ M2 @ M2 ) ) ).

% le_square
thf(fact_329_mult__le__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ L ) ) ) ) ).

% mult_le_mono
thf(fact_330_mult__le__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_331_mult__le__mono2,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_332_add__mult__distrib,axiom,
    ! [M2: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M2 @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% add_mult_distrib
thf(fact_333_add__mult__distrib2,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M2 @ N2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% add_mult_distrib2
thf(fact_334_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% one_le_power
thf(fact_335_nat__mult__max__left,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M2 @ N2 ) @ Q2 )
      = ( ord_max @ nat @ ( times_times @ nat @ M2 @ Q2 ) @ ( times_times @ nat @ N2 @ Q2 ) ) ) ).

% nat_mult_max_left
thf(fact_336_nat__mult__max__right,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ M2 @ ( ord_max @ nat @ N2 @ Q2 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M2 @ N2 ) @ ( times_times @ nat @ M2 @ Q2 ) ) ) ).

% nat_mult_max_right
thf(fact_337_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M2 @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M2 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_add
thf(fact_338_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_339_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_340_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_341_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M2 ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less @ nat @ M2 @ N2 ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_342_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_343_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_344_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% one_le_numeral
thf(fact_345_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_346_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_347_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_348_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_349_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_350_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_351_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_352_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M2 ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_353_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_354_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_355_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2_right
thf(fact_356_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2
thf(fact_357_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_358_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_359_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_360_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_361_add__self__div__2,axiom,
    ! [M2: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M2 @ M2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M2 ) ).

% add_self_div_2
thf(fact_362_semiring__norm_I76_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit0 @ N2 ) ) ).

% semiring_norm(76)
thf(fact_363_semiring__norm_I69_J,axiom,
    ! [M2: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M2 ) @ one2 ) ).

% semiring_norm(69)
thf(fact_364_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_365_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_366_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_ding
thf(fact_367_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ) ) ).

% div_exp_eq
thf(fact_368_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less @ A @ X @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_369_semiring__norm_I75_J,axiom,
    ! [M2: num] :
      ~ ( ord_less @ num @ M2 @ one2 ) ).

% semiring_norm(75)
thf(fact_370_semiring__norm_I68_J,axiom,
    ! [N2: num] : ( ord_less_eq @ num @ one2 @ N2 ) ).

% semiring_norm(68)
thf(fact_371_semiring__norm_I78_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M2 @ N2 ) ) ).

% semiring_norm(78)
thf(fact_372_deg__deg__n,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( Deg = N2 ) ) ).

% deg_deg_n
thf(fact_373_semiring__norm_I87_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ( bit0 @ M2 )
        = ( bit0 @ N2 ) )
      = ( M2 = N2 ) ) ).

% semiring_norm(87)
thf(fact_374_semiring__norm_I85_J,axiom,
    ! [M2: num] :
      ( ( bit0 @ M2 )
     != one2 ) ).

% semiring_norm(85)
thf(fact_375_semiring__norm_I83_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit0 @ N2 ) ) ).

% semiring_norm(83)
thf(fact_376_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_377_semiring__norm_I6_J,axiom,
    ! [M2: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ M2 @ N2 ) ) ) ).

% semiring_norm(6)
thf(fact_378_semiring__norm_I13_J,axiom,
    ! [M2: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M2 @ N2 ) ) ) ) ).

% semiring_norm(13)
thf(fact_379_semiring__norm_I12_J,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ one2 @ N2 )
      = N2 ) ).

% semiring_norm(12)
thf(fact_380_semiring__norm_I11_J,axiom,
    ! [M2: num] :
      ( ( times_times @ num @ M2 @ one2 )
      = M2 ) ).

% semiring_norm(11)
thf(fact_381_semiring__norm_I71_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
      = ( ord_less_eq @ num @ M2 @ N2 ) ) ).

% semiring_norm(71)
thf(fact_382_num__double,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N2 )
      = ( bit0 @ N2 ) ) ).

% num_double
thf(fact_383_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M2: num,N2: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M2 ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M2 @ N2 ) ) ) ) ) ).

% power_mult_numeral
thf(fact_384_two__realpow__ge__one,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% two_realpow_ge_one
thf(fact_385_four__x__squared,axiom,
    ! [X: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_386_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_387_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_388_left__add__mult__distrib,axiom,
    ! [I2: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I2 @ J ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_389_div__le__dividend,axiom,
    ! [M2: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ M2 ) ).

% div_le_dividend
thf(fact_390_div__le__mono,axiom,
    ! [M2: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M2 @ K ) @ ( divide_divide @ nat @ N2 @ K ) ) ) ).

% div_le_mono
thf(fact_391_div__mult2__eq,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( divide_divide @ nat @ M2 @ ( times_times @ nat @ N2 @ Q2 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ Q2 ) ) ).

% div_mult2_eq
thf(fact_392_less__mult__imp__div__less,axiom,
    ! [M2: nat,I2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( times_times @ nat @ I2 @ N2 ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ I2 ) ) ).

% less_mult_imp_div_less
thf(fact_393_div__times__less__eq__dividend,axiom,
    ! [M2: nat,N2: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ N2 ) @ M2 ) ).

% div_times_less_eq_dividend
thf(fact_394_times__div__less__eq__dividend,axiom,
    ! [N2: nat,M2: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M2 @ N2 ) ) @ M2 ) ).

% times_div_less_eq_dividend
thf(fact_395_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit0_div_2
thf(fact_396_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X ) ) ).

% field_sum_of_halves
thf(fact_397_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_398_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_399_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_400_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_401_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_402_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_403_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_404_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_405_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_406_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_407_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_408_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_409_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_410_real__divide__square__eq,axiom,
    ! [R: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ R ) )
      = ( divide_divide @ real @ A2 @ R ) ) ).

% real_divide_square_eq
thf(fact_411_real__arch__pow,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ? [N3: nat] : ( ord_less @ real @ Y @ ( power_power @ real @ X @ N3 ) ) ) ).

% real_arch_pow
thf(fact_412_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X4: real,Y4: real] :
          ( ( ord_less @ real @ X4 @ Y4 )
          | ( X4 = Y4 ) ) ) ) ).

% less_eq_real_def
thf(fact_413_complete__real,axiom,
    ! [S2: set @ real] :
      ( ? [X2: real] : ( member @ real @ X2 @ S2 )
     => ( ? [Z4: real] :
          ! [X3: real] :
            ( ( member @ real @ X3 @ S2 )
           => ( ord_less_eq @ real @ X3 @ Z4 ) )
       => ? [Y2: real] :
            ( ! [X2: real] :
                ( ( member @ real @ X2 @ S2 )
               => ( ord_less_eq @ real @ X2 @ Y2 ) )
            & ! [Z4: real] :
                ( ! [X3: real] :
                    ( ( member @ real @ X3 @ S2 )
                   => ( ord_less_eq @ real @ X3 @ Z4 ) )
               => ( ord_less_eq @ real @ Y2 @ Z4 ) ) ) ) ) ).

% complete_real
thf(fact_414_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
        ? [Y2: A] : ( ord_less @ A @ Y2 @ X2 ) ) ).

% linordered_field_no_lb
thf(fact_415_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
        ? [X_12: A] : ( ord_less @ A @ X2 @ X_12 ) ) ).

% linordered_field_no_ub
thf(fact_416_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_417_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_418_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ B3 @ A3 ) ) ) ) ).

% mult.commute
thf(fact_419_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_420_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_421_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_422_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_423_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_424_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_425_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ B3 @ A3 ) ) ) ) ).

% add.commute
thf(fact_426_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_427_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_428_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_429_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B5: A,K: A,B2: A,A2: A] :
          ( ( B5
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B5 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_430_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: A,K: A,A2: A,B2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A5 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_431_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( I2 = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I2 @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_432_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_433_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_434_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( I2 = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_435_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_436_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_437_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_438_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_439_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_440_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
            ? [C4: A] :
              ( B3
              = ( plus_plus @ A @ A3 @ C4 ) ) ) ) ) ).

% le_iff_add
thf(fact_441_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_442_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_443_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_444_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( I2 = J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_445_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_446_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_447_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_448_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_449_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_450_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_451_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_452_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_453_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_454_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_455_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_456_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_457_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_458_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_459_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_460_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z: A,W2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W2 ) @ ( times_times @ A @ Y @ Z ) ) ) ) ).

% divide_divide_times_eq
thf(fact_461_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,Z: A,W2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ Z @ W2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ W2 ) ) ) ) ).

% times_divide_times_eq
thf(fact_462_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_463_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y @ Z ) ) ) ) ).

% max_add_distrib_left
thf(fact_464_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y @ Z ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% max_add_distrib_right
thf(fact_465_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_466_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_467_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_468_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_469_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M2: A,N2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M2 @ N2 ) ) ) ) ) ).

% less_1_mult
thf(fact_470_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_471_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_472_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_473_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_474__C10_C,axiom,
    ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ xa @ ( ord_max @ nat @ mi @ ma ) ) ) @ deg @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) ) @ ( vEBT_vebt_insert @ summary @ ( vEBT_VEBT_high @ mi @ na ) ) @ summary ) ) ) ).

% "10"
thf(fact_475_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_476_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X4: nat,N: nat] : ( modulo_modulo @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% low_def
thf(fact_477_insert__simp__excp,axiom,
    ! [Mi: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,X: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ X @ Mi )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ ( ord_max @ nat @ Mi @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_excp
thf(fact_478_insert__simp__norm,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ Mi @ X )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ ( ord_max @ nat @ X @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_norm
thf(fact_479__C8_C,axiom,
    ( ( suc @ na )
    = m ) ).

% "8"
thf(fact_480_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_481_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_482_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X: A,Y: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X @ Y ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_483_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_484_valid__0__not,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_0_not
thf(fact_485_valid__tree__deg__neq__0,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_tree_deg_neq_0
thf(fact_486_even__odd__cases,axiom,
    ! [X: nat] :
      ( ! [N3: nat] :
          ( X
         != ( plus_plus @ nat @ N3 @ N3 ) )
     => ~ ! [N3: nat] :
            ( X
           != ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) ) ) ).

% even_odd_cases
thf(fact_487_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% deg_not_0
thf(fact_488_deg__SUcn__Node,axiom,
    ! [Tree: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ Tree @ ( suc @ ( suc @ N2 ) ) )
     => ? [Info2: option @ ( product_prod @ nat @ nat ),TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
          ( Tree
          = ( vEBT_Node @ Info2 @ ( suc @ ( suc @ N2 ) ) @ TreeList3 @ S3 ) ) ) ).

% deg_SUcn_Node
thf(fact_489_zdiv__numeral__Bit0,axiom,
    ! [V2: num,W2: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W2 ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_490_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_491_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% nat.inject
thf(fact_492_less__nat__zero__code,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_493_neq0__conv,axiom,
    ! [N2: nat] :
      ( ( ( N2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% neq0_conv
thf(fact_494_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_495_le0,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% le0
thf(fact_496_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_497_Nat_Oadd__0__right,axiom,
    ! [M2: nat] :
      ( ( plus_plus @ nat @ M2 @ ( zero_zero @ nat ) )
      = M2 ) ).

% Nat.add_0_right
thf(fact_498_add__is__0,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M2
          = ( zero_zero @ nat ) )
        & ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_499_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_500_mult__cancel2,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( ( times_times @ nat @ M2 @ K )
        = ( times_times @ nat @ N2 @ K ) )
      = ( ( M2 = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_501_mult__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M2 )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( M2 = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_502_mult__0__right,axiom,
    ! [M2: nat] :
      ( ( times_times @ nat @ M2 @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_503_mult__is__0,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( times_times @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_504_max__0R,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ N2 @ ( zero_zero @ nat ) )
      = N2 ) ).

% max_0R
thf(fact_505_max__0L,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% max_0L
thf(fact_506_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_507_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_508_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_509_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_510_i0__less,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( ( N2
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_511_mi__eq__ma__no__ch,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg )
     => ( ( Mi = Ma )
       => ( ! [X2: vEBT_VEBT] :
              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
             => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) )
          & ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 ) ) ) ) ).

% mi_eq_ma_no_ch
thf(fact_512_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less_eq @ A @ N2 @ ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_513_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_514_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_515_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_516_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_517_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_518_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_519_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_520_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_521_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_522_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_523_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_524_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_525_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_526_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_527_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_528_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_529_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_530_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_531_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_532_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_533_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_534_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_535_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_536_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_537_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_538_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_539_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_540_zero__less__Suc,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ).

% zero_less_Suc
thf(fact_541_less__Suc0,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_542_Suc__less__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ M2 @ N2 ) ) ).

% Suc_less_eq
thf(fact_543_Suc__mono,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ord_less @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) ) ) ).

% Suc_mono
thf(fact_544_lessI,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( suc @ N2 ) ) ).

% lessI
thf(fact_545_Suc__le__mono,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( suc @ M2 ) )
      = ( ord_less_eq @ nat @ N2 @ M2 ) ) ).

% Suc_le_mono
thf(fact_546_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_547_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_548_add__Suc__right,axiom,
    ! [M2: nat,N2: nat] :
      ( ( plus_plus @ nat @ M2 @ ( suc @ N2 ) )
      = ( suc @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ).

% add_Suc_right
thf(fact_549_insert__simp__mima,axiom,
    ! [X: nat,Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( X = Mi )
        | ( X = Ma ) )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
       => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) ) ) ) ).

% insert_simp_mima
thf(fact_550_add__gr__0,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M2 @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% add_gr_0
thf(fact_551_one__eq__mult__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M2 @ N2 ) )
      = ( ( M2
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_552_mult__eq__1__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( times_times @ nat @ M2 @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M2
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_553_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_554_nat__0__less__mult__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M2 @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% nat_0_less_mult_iff
thf(fact_555_mult__less__cancel2,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M2 @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% mult_less_cancel2
thf(fact_556_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X @ X ) ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_557_div__by__Suc__0,axiom,
    ! [M2: nat] :
      ( ( divide_divide @ nat @ M2 @ ( suc @ ( zero_zero @ nat ) ) )
      = M2 ) ).

% div_by_Suc_0
thf(fact_558_less__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( one_one @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_559_div__less,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ( divide_divide @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_560_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M2: nat] :
      ( ( ( power_power @ nat @ X @ M2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M2
          = ( zero_zero @ nat ) )
        | ( X
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_561_power__Suc__0,axiom,
    ! [N2: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_562_nat__zero__less__power__iff,axiom,
    ! [X: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_563_mod__by__Suc__0,axiom,
    ! [M2: nat] :
      ( ( modulo_modulo @ nat @ M2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_564_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
          = ( divide_divide @ nat @ M2 @ N2 ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_565_mod__less,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ( modulo_modulo @ nat @ M2 @ N2 )
        = M2 ) ) ).

% mod_less
thf(fact_566_max__Suc__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_max @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ M2 @ N2 ) ) ) ).

% max_Suc_Suc
thf(fact_567_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_568_mi__ma__2__deg,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N2 )
     => ( ( ord_less_eq @ nat @ Mi @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_569_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_570_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_571_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_572_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_573_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_574_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_575_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_576_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_577_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_578_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_579_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_580_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_581_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_582_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_583_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_584_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_585_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_586_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_587_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_588_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_589_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_590_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_591_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_592_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_593_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_594_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_595_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_596_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_597_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_598_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_599_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_600_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_601_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_602_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_603_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_604_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_605_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N2 ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_606_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_607_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% power_eq_0_iff
thf(fact_608_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_609_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_610_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_611_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_612_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_613_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_614_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_615_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_616_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_617_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_618_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(3)
thf(fact_619_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(4)
thf(fact_620_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_621_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_622_one__le__mult__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M2 @ N2 ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M2 )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) ) ).

% one_le_mult_iff
thf(fact_623_mult__Suc__right,axiom,
    ! [M2: nat,N2: nat] :
      ( ( times_times @ nat @ M2 @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ M2 @ ( times_times @ nat @ M2 @ N2 ) ) ) ).

% mult_Suc_right
thf(fact_624_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_625_mult__le__cancel2,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M2 @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ).

% mult_le_cancel2
thf(fact_626_div__mult__self__is__m,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M2 @ N2 ) @ N2 )
        = M2 ) ) ).

% div_mult_self_is_m
thf(fact_627_div__mult__self1__is__m,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N2 @ M2 ) @ N2 )
        = M2 ) ) ).

% div_mult_self1_is_m
thf(fact_628_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_629_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X = Mi )
          | ( X = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_630_member__inv,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X = Mi )
          | ( X = Ma )
          | ( ( ord_less @ nat @ X @ Ma )
            & ( ord_less @ nat @ Mi @ X )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_631_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_632_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_633_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_634_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_635_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_636_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_637_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_638_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_639_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_640_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ( numeral_numeral @ A @ W2 )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_641_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_642_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_643_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_644_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_645_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_646_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_647_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_648_Suc__numeral,axiom,
    ! [N2: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% Suc_numeral
thf(fact_649_Suc__mod__mult__self4,axiom,
    ! [N2: nat,K: nat,M2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ M2 ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M2 ) @ N2 ) ) ).

% Suc_mod_mult_self4
thf(fact_650_Suc__mod__mult__self3,axiom,
    ! [K: nat,N2: nat,M2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N2 ) @ M2 ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M2 ) @ N2 ) ) ).

% Suc_mod_mult_self3
thf(fact_651_Suc__mod__mult__self2,axiom,
    ! [M2: nat,N2: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M2 @ ( times_times @ nat @ N2 @ K ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M2 ) @ N2 ) ) ).

% Suc_mod_mult_self2
thf(fact_652_Suc__mod__mult__self1,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M2 @ ( times_times @ nat @ K @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M2 ) @ N2 ) ) ).

% Suc_mod_mult_self1
thf(fact_653_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_654_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_655_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_656_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_657_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M2: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M2 ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less @ nat @ N2 @ M2 ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_658_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_659_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_660_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_661_add__2__eq__Suc,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc
thf(fact_662_add__2__eq__Suc_H,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc'
thf(fact_663_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_664_div2__Suc__Suc,axiom,
    ! [M2: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_665_mod2__Suc__Suc,axiom,
    ! [M2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_666_add__self__mod__2,axiom,
    ! [M2: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M2 @ M2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_667_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N2 ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_668_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_669_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_670_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M2: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M2 ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less_eq @ nat @ N2 @ M2 ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_671_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X = Y ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_672_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_673_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_674_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_675_mod2__gr__0,axiom,
    ! [M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_676_mod__eq__0D,axiom,
    ! [M2: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M2 @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q3: nat] :
          ( M2
          = ( times_times @ nat @ D2 @ Q3 ) ) ) ).

% mod_eq_0D
thf(fact_677_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_678_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_679_not0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ? [M4: nat] :
          ( N2
          = ( suc @ M4 ) ) ) ).

% not0_implies_Suc
thf(fact_680_Zero__not__Suc,axiom,
    ! [M2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M2 ) ) ).

% Zero_not_Suc
thf(fact_681_Zero__neq__Suc,axiom,
    ! [M2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M2 ) ) ).

% Zero_neq_Suc
thf(fact_682_Suc__neq__Zero,axiom,
    ! [M2: nat] :
      ( ( suc @ M2 )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_683_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_684_n__not__Suc__n,axiom,
    ! [N2: nat] :
      ( N2
     != ( suc @ N2 ) ) ).

% n_not_Suc_n
thf(fact_685_diff__induct,axiom,
    ! [P: nat > nat > $o,M2: nat,N2: nat] :
      ( ! [X3: nat] : ( P @ X3 @ ( zero_zero @ nat ) )
     => ( ! [Y2: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y2 ) )
       => ( ! [X3: nat,Y2: nat] :
              ( ( P @ X3 @ Y2 )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y2 ) ) )
         => ( P @ M2 @ N2 ) ) ) ) ).

% diff_induct
thf(fact_686_nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N2 ) ) ) ).

% nat_induct
thf(fact_687_Suc__inject,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) ).

% Suc_inject
thf(fact_688_old_Onat_Oexhaust,axiom,
    ! [Y: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ~ ! [Nat3: nat] :
            ( Y
           != ( suc @ Nat3 ) ) ) ).

% old.nat.exhaust
thf(fact_689_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_690_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_691_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat4: nat] :
      ( ( suc @ Nat4 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_692_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) ).

% nat.distinct(1)
thf(fact_693_mod__Suc__Suc__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M2 @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M2 ) ) @ N2 ) ) ).

% mod_Suc_Suc_eq
thf(fact_694_mod__Suc__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M2 @ N2 ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M2 ) @ N2 ) ) ).

% mod_Suc_eq
thf(fact_695_mod__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M2 @ N2 ) )
          = N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M2 ) @ N2 )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M2 @ N2 ) )
         != N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M2 ) @ N2 )
          = ( suc @ ( modulo_modulo @ nat @ M2 @ N2 ) ) ) ) ) ).

% mod_Suc
thf(fact_696_mod__induct,axiom,
    ! [P: nat > $o,N2: nat,P4: nat,M2: nat] :
      ( ( P @ N2 )
     => ( ( ord_less @ nat @ N2 @ P4 )
       => ( ( ord_less @ nat @ M2 @ P4 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P4 )
               => ( ( P @ N3 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P4 ) ) ) )
           => ( P @ M2 ) ) ) ) ) ).

% mod_induct
thf(fact_697_mod__Suc__le__divisor,axiom,
    ! [M2: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M2 @ ( suc @ N2 ) ) @ N2 ) ).

% mod_Suc_le_divisor
thf(fact_698_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_699_mod__less__divisor,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M2 @ N2 ) @ N2 ) ) ).

% mod_less_divisor
thf(fact_700_less__Suc__eq__0__disj,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( suc @ N2 ) )
      = ( ( M2
          = ( zero_zero @ nat ) )
        | ? [J3: nat] :
            ( ( M2
              = ( suc @ J3 ) )
            & ( ord_less @ nat @ J3 @ N2 ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_701_gr0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ? [M4: nat] :
          ( N2
          = ( suc @ M4 ) ) ) ).

% gr0_implies_Suc
thf(fact_702_All__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
           => ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
           => ( P @ ( suc @ I4 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_703_gr0__conv__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( ? [M: nat] :
            ( N2
            = ( suc @ M ) ) ) ) ).

% gr0_conv_Suc
thf(fact_704_Ex__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
            & ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
            & ( P @ ( suc @ I4 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_705_one__is__add,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M2 @ N2 ) )
      = ( ( ( M2
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M2
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_706_add__is__1,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M2 @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M2
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M2
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_707_realpow__pos__nth2,axiom,
    ! [A2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R2: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
          & ( ( power_power @ real @ R2 @ ( suc @ N2 ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_708_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_709_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_710_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_711_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_712_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_713_Suc__times__mod__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M2 )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M2 @ N2 ) ) @ M2 )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_714_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_715_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
            = ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_716_mod__le__divisor,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M2 @ N2 ) @ N2 ) ) ).

% mod_le_divisor
thf(fact_717_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_718_num_Osize_I5_J,axiom,
    ! [X22: num] :
      ( ( size_size @ num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_719_ex__least__nat__less,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less @ nat @ K2 @ N2 )
            & ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ K2 )
               => ~ ( P @ I ) )
            & ( P @ ( suc @ K2 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_720_n__less__n__mult__m,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M2 )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ N2 @ M2 ) ) ) ) ).

% n_less_n_mult_m
thf(fact_721_n__less__m__mult__n,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M2 )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ M2 @ N2 ) ) ) ) ).

% n_less_m_mult_n
thf(fact_722_one__less__mult,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M2 )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M2 @ N2 ) ) ) ) ).

% one_less_mult
thf(fact_723_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_724_nat__induct__non__zero,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_non_zero
thf(fact_725_power__gt__expt,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N2 @ K ) ) ) ).

% power_gt_expt
thf(fact_726_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_727_nat__one__le__power,axiom,
    ! [I2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I2 )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I2 @ N2 ) ) ) ).

% nat_one_le_power
thf(fact_728_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_729_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_730_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_731_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_732_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_733_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_734_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_735_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_736_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_737_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_738_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N2 ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 ) ) ) ).

% power_mod
thf(fact_739_realpow__pos__nth,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R2: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
            & ( ( power_power @ real @ R2 @ N2 )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_740_realpow__pos__nth__unique,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
            & ( ( power_power @ real @ X3 @ N2 )
              = A2 )
            & ! [Y5: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y5 )
                  & ( ( power_power @ real @ Y5 @ N2 )
                    = A2 ) )
               => ( Y5 = X3 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_741_mod__less__eq__dividend,axiom,
    ! [M2: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M2 @ N2 ) @ M2 ) ).

% mod_less_eq_dividend
thf(fact_742_not__less__less__Suc__eq,axiom,
    ! [N2: nat,M2: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M2 ) )
        = ( N2 = M2 ) ) ) ).

% not_less_less_Suc_eq
thf(fact_743_strict__inc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ! [I3: nat] :
            ( ( J
              = ( suc @ I3 ) )
           => ( P @ I3 ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ J )
             => ( ( P @ ( suc @ I3 ) )
               => ( P @ I3 ) ) )
         => ( P @ I2 ) ) ) ) ).

% strict_inc_induct
thf(fact_744_less__Suc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ! [I3: nat] : ( P @ I3 @ ( suc @ I3 ) )
       => ( ! [I3: nat,J2: nat,K2: nat] :
              ( ( ord_less @ nat @ I3 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K2 )
               => ( ( P @ I3 @ J2 )
                 => ( ( P @ J2 @ K2 )
                   => ( P @ I3 @ K2 ) ) ) ) )
         => ( P @ I2 @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_745_less__trans__Suc,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I2 ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_746_Suc__less__SucD,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
     => ( ord_less @ nat @ M2 @ N2 ) ) ).

% Suc_less_SucD
thf(fact_747_less__antisym,axiom,
    ! [N2: nat,M2: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M2 ) )
       => ( M2 = N2 ) ) ) ).

% less_antisym
thf(fact_748_Suc__less__eq2,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ M2 )
      = ( ? [M5: nat] :
            ( ( M2
              = ( suc @ M5 ) )
            & ( ord_less @ nat @ N2 @ M5 ) ) ) ) ).

% Suc_less_eq2
thf(fact_749_All__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
           => ( P @ I4 ) ) )
      = ( ( P @ N2 )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
           => ( P @ I4 ) ) ) ) ).

% All_less_Suc
thf(fact_750_not__less__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ~ ( ord_less @ nat @ M2 @ N2 ) )
      = ( ord_less @ nat @ N2 @ ( suc @ M2 ) ) ) ).

% not_less_eq
thf(fact_751_less__Suc__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( suc @ N2 ) )
      = ( ( ord_less @ nat @ M2 @ N2 )
        | ( M2 = N2 ) ) ) ).

% less_Suc_eq
thf(fact_752_Ex__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
            & ( P @ I4 ) ) )
      = ( ( P @ N2 )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
            & ( P @ I4 ) ) ) ) ).

% Ex_less_Suc
thf(fact_753_less__SucI,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ord_less @ nat @ M2 @ ( suc @ N2 ) ) ) ).

% less_SucI
thf(fact_754_less__SucE,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( suc @ N2 ) )
     => ( ~ ( ord_less @ nat @ M2 @ N2 )
       => ( M2 = N2 ) ) ) ).

% less_SucE
thf(fact_755_Suc__lessI,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ( ( suc @ M2 )
         != N2 )
       => ( ord_less @ nat @ ( suc @ M2 ) @ N2 ) ) ) ).

% Suc_lessI
thf(fact_756_Suc__lessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I2 @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_757_Suc__lessD,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M2 ) @ N2 )
     => ( ord_less @ nat @ M2 @ N2 ) ) ).

% Suc_lessD
thf(fact_758_Nat_OlessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ K )
     => ( ( K
         != ( suc @ I2 ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_759_transitive__stepwise__le,axiom,
    ! [M2: nat,N2: nat,R3: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ! [X3: nat] : ( R3 @ X3 @ X3 )
       => ( ! [X3: nat,Y2: nat,Z3: nat] :
              ( ( R3 @ X3 @ Y2 )
             => ( ( R3 @ Y2 @ Z3 )
               => ( R3 @ X3 @ Z3 ) ) )
         => ( ! [N3: nat] : ( R3 @ N3 @ ( suc @ N3 ) )
           => ( R3 @ M2 @ N2 ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_760_nat__induct__at__least,axiom,
    ! [M2: nat,N2: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( P @ M2 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M2 @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_at_least
thf(fact_761_full__nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M3 ) @ N3 )
             => ( P @ M3 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) ).

% full_nat_induct
thf(fact_762_not__less__eq__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M2 @ N2 ) )
      = ( ord_less_eq @ nat @ ( suc @ N2 ) @ M2 ) ) ).

% not_less_eq_eq
thf(fact_763_Suc__n__not__le__n,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N2 ) @ N2 ) ).

% Suc_n_not_le_n
thf(fact_764_le__Suc__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) )
      = ( ( ord_less_eq @ nat @ M2 @ N2 )
        | ( M2
          = ( suc @ N2 ) ) ) ) ).

% le_Suc_eq
thf(fact_765_Suc__le__D,axiom,
    ! [N2: nat,M6: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ M6 )
     => ? [M4: nat] :
          ( M6
          = ( suc @ M4 ) ) ) ).

% Suc_le_D
thf(fact_766_le__SucI,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) ) ) ).

% le_SucI
thf(fact_767_le__SucE,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) )
     => ( ~ ( ord_less_eq @ nat @ M2 @ N2 )
       => ( M2
          = ( suc @ N2 ) ) ) ) ).

% le_SucE
thf(fact_768_Suc__leD,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N2 )
     => ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% Suc_leD
thf(fact_769_add__Suc__shift,axiom,
    ! [M2: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M2 ) @ N2 )
      = ( plus_plus @ nat @ M2 @ ( suc @ N2 ) ) ) ).

% add_Suc_shift
thf(fact_770_add__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M2 ) @ N2 )
      = ( suc @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ).

% add_Suc
thf(fact_771_nat__arith_Osuc1,axiom,
    ! [A5: nat,K: nat,A2: nat] :
      ( ( A5
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A5 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_772_Suc__mult__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M2 )
        = ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( M2 = N2 ) ) ).

% Suc_mult_cancel1
thf(fact_773_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_774_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_775_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E2: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
                & ( ord_less @ A @ E2 @ D1 )
                & ( ord_less @ A @ E2 @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_776_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_777_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N2 )
          = ( ( N2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_778_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M2: A,N2: A] :
          ( ( ord_less @ A @ M2 @ N2 )
         => ( N2
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_779_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ~ ( ord_less @ A @ N2 @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_780_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( N2
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) ) ) ).

% gr_zeroI
thf(fact_781_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_neq_numeral
thf(fact_782_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_783_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_784_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_785_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_786_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_787_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_788_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_789_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_790_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_791_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_792_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_793_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_794_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_795_infinite__descent0__measure,axiom,
    ! [A: $tType,V: A > nat,P: A > $o,X: A] :
      ( ! [X3: A] :
          ( ( ( V @ X3 )
            = ( zero_zero @ nat ) )
         => ( P @ X3 ) )
     => ( ! [X3: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V @ X3 ) )
           => ( ~ ( P @ X3 )
             => ? [Y5: A] :
                  ( ( ord_less @ nat @ ( V @ Y5 ) @ ( V @ X3 ) )
                  & ~ ( P @ Y5 ) ) ) )
       => ( P @ X ) ) ) ).

% infinite_descent0_measure
thf(fact_796_infinite__descent0,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M3: nat] :
                  ( ( ord_less @ nat @ M3 @ N3 )
                  & ~ ( P @ M3 ) ) ) )
       => ( P @ N2 ) ) ) ).

% infinite_descent0
thf(fact_797_gr__implies__not0,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( N2
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_798_less__zeroE,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_799_not__less0,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_800_not__gr0,axiom,
    ! [N2: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_801_gr0I,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% gr0I
thf(fact_802_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_803_le__0__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( zero_zero @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_804_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_805_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_806_less__eq__nat_Osimps_I1_J,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% less_eq_nat.simps(1)
thf(fact_807_add__eq__self__zero,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M2 @ N2 )
        = M2 )
     => ( N2
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_808_plus__nat_Oadd__0,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% plus_nat.add_0
thf(fact_809_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M2 )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M2 = N2 ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_810_mult__0,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_811_nat__mod__eq__iff,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N2 )
        = ( modulo_modulo @ nat @ Y @ N2 ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X @ ( times_times @ nat @ N2 @ Q1 ) )
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N2 @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_812_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_813_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_814_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_815_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_816_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_817_enat__0__less__mult__iff,axiom,
    ! [M2: extended_enat,N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M2 @ N2 ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M2 )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ) ) ).

% enat_0_less_mult_iff
thf(fact_818_not__iless0,axiom,
    ! [N2: extended_enat] :
      ~ ( ord_less @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_819_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_820_split__mod,axiom,
    ! [P: nat > $o,M2: nat,N2: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M2 @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ M2 ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N2 )
             => ( ( M2
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I4 ) @ J3 ) )
               => ( P @ J3 ) ) ) ) ) ) ).

% split_mod
thf(fact_821_i0__lb,axiom,
    ! [N2: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ).

% i0_lb
thf(fact_822_ile0__eq,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = ( N2
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_823_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_824_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N2 )
                  = ( power_power @ A @ B2 @ N2 ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_825_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_826_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_827_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_828_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D4 ) ) ) ) ) ).

% mod_eqE
thf(fact_829_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_830_less__2__cases__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_831_less__2__cases,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_832_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_833_mod__eq__nat1E,axiom,
    ! [M2: nat,Q2: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M2 @ Q2 )
        = ( modulo_modulo @ nat @ N2 @ Q2 ) )
     => ( ( ord_less_eq @ nat @ N2 @ M2 )
       => ~ ! [S3: nat] :
              ( M2
             != ( plus_plus @ nat @ N2 @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_834_mod__eq__nat2E,axiom,
    ! [M2: nat,Q2: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M2 @ Q2 )
        = ( modulo_modulo @ nat @ N2 @ Q2 ) )
     => ( ( ord_less_eq @ nat @ M2 @ N2 )
       => ~ ! [S3: nat] :
              ( N2
             != ( plus_plus @ nat @ M2 @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_835_nat__mod__eq__lemma,axiom,
    ! [X: nat,N2: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N2 )
        = ( modulo_modulo @ nat @ Y @ N2 ) )
     => ( ( ord_less_eq @ nat @ Y @ X )
       => ? [Q3: nat] :
            ( X
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N2 @ Q3 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_836_split__div_H,axiom,
    ! [P: nat > $o,M2: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M2 @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q4 ) @ M2 )
            & ( ord_less @ nat @ M2 @ ( times_times @ nat @ N2 @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_837_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,M2: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ M2 ) )
            = ( ord_less @ nat @ N2 @ M2 ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_838_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N2 @ N5 )
           => ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_839_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_840_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_Suc
thf(fact_841_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N2 @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N5 ) @ ( F2 @ N2 ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_842_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N2 @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_843_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_844_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_845_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_846_le__imp__less__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less @ nat @ M2 @ ( suc @ N2 ) ) ) ).

% le_imp_less_Suc
thf(fact_847_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N: nat] : ( ord_less_eq @ nat @ ( suc @ N ) ) ) ) ).

% less_eq_Suc_le
thf(fact_848_less__Suc__eq__le,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% less_Suc_eq_le
thf(fact_849_le__less__Suc__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M2 ) )
        = ( N2 = M2 ) ) ) ).

% le_less_Suc_eq
thf(fact_850_Suc__le__lessD,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N2 )
     => ( ord_less @ nat @ M2 @ N2 ) ) ).

% Suc_le_lessD
thf(fact_851_inc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( P @ J )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ ( suc @ N3 ) )
                 => ( P @ N3 ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% inc_induct
thf(fact_852_dec__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( P @ I2 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ N3 )
                 => ( P @ ( suc @ N3 ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_853_Suc__le__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N2 )
      = ( ord_less @ nat @ M2 @ N2 ) ) ).

% Suc_le_eq
thf(fact_854_Suc__leI,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ ( suc @ M2 ) @ N2 ) ) ).

% Suc_leI
thf(fact_855_less__imp__Suc__add,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ? [K2: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M2 @ K2 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_856_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M: nat,N: nat] :
        ? [K3: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K3 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_857_less__add__Suc2,axiom,
    ! [I2: nat,M2: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ M2 @ I2 ) ) ) ).

% less_add_Suc2
thf(fact_858_less__add__Suc1,axiom,
    ! [I2: nat,M2: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ I2 @ M2 ) ) ) ).

% less_add_Suc1
thf(fact_859_less__natE,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ~ ! [Q3: nat] :
            ( N2
           != ( suc @ ( plus_plus @ nat @ M2 @ Q3 ) ) ) ) ).

% less_natE
thf(fact_860_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M2 ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less @ nat @ M2 @ N2 ) ) ).

% Suc_mult_less_cancel1
thf(fact_861_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X4: A] : ( plus_plus @ A @ X4 @ X4 ) ) ) ) ).

% dbl_def
thf(fact_862_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M2 ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% Suc_mult_le_cancel1
thf(fact_863_mult__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ M2 ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( times_times @ nat @ M2 @ N2 ) ) ) ).

% mult_Suc
thf(fact_864_Suc__div__le__mono,axiom,
    ! [M2: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ ( divide_divide @ nat @ ( suc @ M2 ) @ N2 ) ) ).

% Suc_div_le_mono
thf(fact_865_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_866_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_le_numeral
thf(fact_867_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_868_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_869_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N: nat] : ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_870_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_871_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_872_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_873_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_874_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_875_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_876_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_877_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_878_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_879_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_880_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_881_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_882_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_883_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_884_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_885_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_886_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_887_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_888_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_less_numeral
thf(fact_889_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_890_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_891_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_892_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_893_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_894_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_895_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_896_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_897_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_898_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_899_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_900_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_901_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_902_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_903_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_904_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_905_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_906_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_907_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_908_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_909_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_910_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_911_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_912_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_913_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_914_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_915_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_916_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_917_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_918_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_919_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_920_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_921_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_922_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_923_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_924_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_925_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_926_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X @ Y ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_927_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_928_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_929_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_930_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_931_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_932_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_933_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_934_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_935_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_neg_neg
thf(fact_936_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_937_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_938_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_pos_pos
thf(fact_939_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_940_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_941_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_942_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_943_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_944_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_power
thf(fact_945_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono
thf(fact_946_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_less_power
thf(fact_947_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y )
                = ( divide_divide @ A @ W2 @ Z ) )
              = ( ( times_times @ A @ X @ Z )
                = ( times_times @ A @ W2 @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_948_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_949_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_950_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_951_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_952_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_953_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_954_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_955_not__exp__less__eq__0__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_956_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_957_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_958_ex__least__nat__le,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ K2 )
               => ~ ( P @ I ) )
            & ( P @ K2 ) ) ) ) ).

% ex_least_nat_le
thf(fact_959_less__imp__add__positive,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I2 @ K2 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_960_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M2 )
          = ( times_times @ nat @ K @ N2 ) )
        = ( M2 = N2 ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_961_nat__mult__less__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% nat_mult_less_cancel1
thf(fact_962_mult__less__mono2,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_963_mult__less__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_964_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( divide_divide @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M2 @ N2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_965_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_966_nat__power__less__imp__less,axiom,
    ! [I2: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I2 )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I2 @ M2 ) @ ( power_power @ nat @ I2 @ N2 ) )
       => ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% nat_power_less_imp_less
thf(fact_967_real__arch__pow__inv,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X @ N3 ) @ Y ) ) ) ).

% real_arch_pow_inv
thf(fact_968_mult__eq__self__implies__10,axiom,
    ! [M2: nat,N2: nat] :
      ( ( M2
        = ( times_times @ nat @ M2 @ N2 ) )
     => ( ( N2
          = ( one_one @ nat ) )
        | ( M2
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_969_pow_Osimps_I1_J,axiom,
    ! [X: num] :
      ( ( pow @ X @ one2 )
      = X ) ).

% pow.simps(1)
thf(fact_970_nat__bit__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_bit_induct
thf(fact_971_Suc__n__div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_972_div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_973_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
                = ( modulo_modulo @ A @ X @ M2 ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M2 ) @ M2 ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_974_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_975_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_976_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_977_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_978_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_979_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_980_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_981_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_982_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_983_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_984_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) ) ) ) ).

% power_gt1
thf(fact_985_mod__mult2__eq,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( modulo_modulo @ nat @ M2 @ ( times_times @ nat @ N2 @ Q2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ Q2 ) ) @ ( modulo_modulo @ nat @ M2 @ N2 ) ) ) ).

% mod_mult2_eq
thf(fact_986_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_987_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_988_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_989_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_990_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_991_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_992_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_993_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_994_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_995_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_996_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_997_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_998_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_999_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_1000_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_1001_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_1002_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_1003_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_1004_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_1005_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_1006_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ X @ ( plus_plus @ A @ Y @ E2 ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_epsilon
thf(fact_1007_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_1008_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_1009_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_1010_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_1011_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_1012_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_1013_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_1014_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_1015_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_1016_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W2: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W2 )
             => ( ( ord_less @ A @ W2 @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W2 ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_1017_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W2 )
             => ( ( ord_less_eq @ A @ W2 @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W2 ) ) ) ) ) ) ) ).

% frac_less
thf(fact_1018_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,W2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W2 )
             => ( ( ord_less_eq @ A @ W2 @ Z )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W2 ) ) ) ) ) ) ) ).

% frac_le
thf(fact_1019_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_1020_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_1021_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_1022_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_1023_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_1024_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_1025_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_1026_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_1027_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_1028_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_1029_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_1030_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_1031_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ Z ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_1032_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z @ Y ) @ X )
           => ( ord_less @ A @ Z @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_1033_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_1034_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_1035_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1036_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1037_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_1038_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_1039_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W2 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_1040_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% divide_add_eq_iff
thf(fact_1041_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y @ Z ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ Y ) @ Z ) ) ) ) ).

% add_divide_eq_iff
thf(fact_1042_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z @ ( divide_divide @ A @ X @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_1043_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ Z )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_1044_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_1045_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_1046_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_1047_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1048_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1049_bounded__Max__nat,axiom,
    ! [P: nat > $o,X: nat,M7: nat] :
      ( ( P @ X )
     => ( ! [X3: nat] :
            ( ( P @ X3 )
           => ( ord_less_eq @ nat @ X3 @ M7 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X2: nat] :
                    ( ( P @ X2 )
                   => ( ord_less_eq @ nat @ X2 @ M4 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1050_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_1051_nat__mult__le__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ).

% nat_mult_le_cancel1
thf(fact_1052_div__greater__zero__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M2 @ N2 ) )
      = ( ( ord_less_eq @ nat @ N2 @ M2 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% div_greater_zero_iff
thf(fact_1053_div__le__mono2,axiom,
    ! [M2: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( ord_less_eq @ nat @ M2 @ N2 )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N2 ) @ ( divide_divide @ nat @ K @ M2 ) ) ) ) ).

% div_le_mono2
thf(fact_1054_nat__mult__div__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
        = ( divide_divide @ nat @ M2 @ N2 ) ) ) ).

% nat_mult_div_cancel1
thf(fact_1055_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M2 @ Q2 ) @ N2 )
        = ( ord_less @ nat @ M2 @ ( times_times @ nat @ N2 @ Q2 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_1056_div__less__dividend,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ M2 ) ) ) ).

% div_less_dividend
thf(fact_1057_div__eq__dividend__iff,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( ( divide_divide @ nat @ M2 @ N2 )
          = M2 )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1058_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1059_div__nat__eqI,axiom,
    ! [N2: nat,Q2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q2 ) @ M2 )
     => ( ( ord_less @ nat @ M2 @ ( times_times @ nat @ N2 @ ( suc @ Q2 ) ) )
       => ( ( divide_divide @ nat @ M2 @ N2 )
          = Q2 ) ) ) ).

% div_nat_eqI
thf(fact_1060_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_1061_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_1062_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_1063_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_1064_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_1065_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_1066_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_1067_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_1068_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z3 )
             => ( ( ord_less @ A @ Z3 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z3 @ X ) @ Y ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_1069_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_1070_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ Y ) @ X )
           => ( ord_less_eq @ A @ Z @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_1071_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ Z ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_1072_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_1073_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_1074_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_1075_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1076_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1077_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1078_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1079_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1080_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1081_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A2: A,Y: A,U: A,V2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1082_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_1083_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_1084_Suc__nat__number__of__add,axiom,
    ! [V2: num,N2: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N2 ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V2 @ one2 ) ) @ N2 ) ) ).

% Suc_nat_number_of_add
thf(fact_1085_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_Suc_less
thf(fact_1086_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1087_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_decreasing
thf(fact_1088_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_1089_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% self_le_power
thf(fact_1090_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power
thf(fact_1091_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_1092_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less_eq @ nat @ M2 @ ( divide_divide @ nat @ N2 @ Q2 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M2 @ Q2 ) @ N2 ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_1093_dividend__less__times__div,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M2 @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M2 @ N2 ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_1094_dividend__less__div__times,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M2 @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( divide_divide @ nat @ M2 @ N2 ) @ N2 ) ) ) ) ).

% dividend_less_div_times
thf(fact_1095_split__div,axiom,
    ! [P: nat > $o,M2: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M2 @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N2 )
             => ( ( M2
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I4 ) @ J3 ) )
               => ( P @ I4 ) ) ) ) ) ) ).

% split_div
thf(fact_1096_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A2: A,Y: A,U: A,V2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V2 )
               => ( ( ( plus_plus @ A @ U @ V2 )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V2 @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_1097_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W2 ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_1098_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_1099_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_1100_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_1101_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% power2_le_imp_le
thf(fact_1102_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( X = Y ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_1103_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_1104_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_1105_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M2 @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_1106_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M2 @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_1107_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat,M2: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M2 ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_1108_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_1109_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% power2_less_imp_less
thf(fact_1110_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_1111_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_1112_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_1113_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_1114_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% zero_le_even_power'
thf(fact_1115_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M2 )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
         => ( ( M2
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M2 ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                   => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X6 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_1116_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M2 )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
         => ( ( M2 = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M2 ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                   => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X6 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_1117_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_1118_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_1119_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_1120_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X: nat,N2: nat,M2: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M2 ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_1121_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X: nat,N2: nat,M2: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M2 ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_1122_verit__le__mono__div,axiom,
    ! [A5: nat,B5: nat,N2: nat] :
      ( ( ord_less @ nat @ A5 @ B5 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A5 @ N2 )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B5 @ N2 )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B5 @ N2 ) ) ) ) ).

% verit_le_mono_div
thf(fact_1123_buildup__gives__valid,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N2 ) @ N2 ) ) ).

% buildup_gives_valid
thf(fact_1124_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_1125_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
thf(fact_1126_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_1127_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = Q2 ) ).

% max_enat_simps(3)
thf(fact_1128_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = Q2 ) ).

% max_enat_simps(2)
thf(fact_1129_set__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_1130_set__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_1131_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1132_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1133_zmod__numeral__Bit0,axiom,
    ! [V2: num,W2: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W2 ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W2 ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_1134_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_1135_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_1136_split__zdiv,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) ) ) ) ).

% split_zdiv
thf(fact_1137_split__zmod,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N2 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) ) ) ) ).

% split_zmod
thf(fact_1138_zdiv__mono1,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A6 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_1139_zdiv__mono2,axiom,
    ! [A2: int,B6: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
       => ( ( ord_less_eq @ int @ B6 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B6 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_1140_q__pos__lemma,axiom,
    ! [B6: int,Q5: int,R4: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ R4 @ B6 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_1141_zdiv__eq__0__iff,axiom,
    ! [I2: int,K: int] :
      ( ( ( divide_divide @ int @ I2 @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
          & ( ord_less @ int @ I2 @ K ) )
        | ( ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I2 ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_1142_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_neg_eq
thf(fact_1143_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_pos_eq
thf(fact_1144_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1145_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1146_zdiv__mono1__neg,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A6 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_1147_zdiv__mono2__neg,axiom,
    ! [A2: int,B6: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
       => ( ( ord_less_eq @ int @ B6 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B6 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_1148_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_1149_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1150_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1151_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_1152_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B6: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
       => ( ( ord_less @ int @ R4 @ B6 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
             => ( ( ord_less_eq @ int @ B6 @ B2 )
               => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_1153_verit__le__mono__div__int,axiom,
    ! [A5: int,B5: int,N2: int] :
      ( ( ord_less @ int @ A5 @ B5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A5 @ N2 )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B5 @ N2 )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B5 @ N2 ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1154_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_1155_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_1156_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I2 @ K ) )
        = ( ord_less_eq @ int @ K @ I2 ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_1157_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B6: int,Q5: int,R4: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R4 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
             => ( ( ord_less_eq @ int @ B6 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_1158_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R4 )
       => ( ( ord_less @ int @ R4 @ B2 )
         => ( ( ord_less @ int @ R @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_1159_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_1160_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_1161_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1162_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1163_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_1164_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R4: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R4 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( ord_less @ int @ B2 @ R4 )
           => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_1165_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1166_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1167_div__mod__decomp__int,axiom,
    ! [A5: int,N2: int] :
      ( A5
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A5 @ N2 ) @ N2 ) @ ( modulo_modulo @ int @ A5 @ N2 ) ) ) ).

% div_mod_decomp_int
thf(fact_1168_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1169_imult__is__0,axiom,
    ! [M2: extended_enat,N2: extended_enat] :
      ( ( ( times_times @ extended_enat @ M2 @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M2
          = ( zero_zero @ extended_enat ) )
        | ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_1170_zmod__eq__0__iff,axiom,
    ! [M2: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M2 @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M2
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1171_zmod__eq__0D,axiom,
    ! [M2: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M2 @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q3: int] :
          ( M2
          = ( times_times @ int @ D2 @ Q3 ) ) ) ).

% zmod_eq_0D
thf(fact_1172_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1173_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_1174_iadd__is__0,axiom,
    ! [M2: extended_enat,N2: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M2 @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M2
          = ( zero_zero @ extended_enat ) )
        & ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_1175_zdiv__mono__strict,axiom,
    ! [A5: int,B5: int,N2: int] :
      ( ( ord_less @ int @ A5 @ B5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ( ( modulo_modulo @ int @ A5 @ N2 )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B5 @ N2 )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A5 @ N2 ) @ ( divide_divide @ int @ B5 @ N2 ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1176_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_1177_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_1178_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_1179_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_1180_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1181_set__bit__greater__eq,axiom,
    ! [K: int,N2: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) ) ).

% set_bit_greater_eq
thf(fact_1182_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1183_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_1184_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_1185_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_1186_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B6: B,A6: B] :
          ( ( ~ ( ord_less_eq @ B @ B6 @ A6 ) )
          = ( ord_less @ B @ A6 @ B6 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_1187_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_1188_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] :
      ( one2
     != ( bit0 @ X22 ) ) ).

% verit_eq_simplify(10)
thf(fact_1189_div__less__mono,axiom,
    ! [A5: nat,B5: nat,N2: nat] :
      ( ( ord_less @ nat @ A5 @ B5 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( modulo_modulo @ nat @ A5 @ N2 )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B5 @ N2 )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A5 @ N2 ) @ ( divide_divide @ nat @ B5 @ N2 ) ) ) ) ) ) ).

% div_less_mono
thf(fact_1190_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_1191_div__mod__decomp,axiom,
    ! [A5: nat,N2: nat] :
      ( A5
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A5 @ N2 ) @ N2 ) @ ( modulo_modulo @ nat @ A5 @ N2 ) ) ) ).

% div_mod_decomp
thf(fact_1192_double__not__eq__Suc__double,axiom,
    ! [M2: nat,N2: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% double_not_eq_Suc_double
thf(fact_1193_Suc__double__not__eq__double,axiom,
    ! [M2: nat,N2: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_double_not_eq_double
thf(fact_1194_nat__induct2,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct2
thf(fact_1195_zle__add1__eq__le,axiom,
    ! [W2: int,Z: int] :
      ( ( ord_less @ int @ W2 @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W2 @ Z ) ) ).

% zle_add1_eq_le
thf(fact_1196_vebt__member_Osimps_I4_J,axiom,
    ! [V2: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V2 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X ) ).

% vebt_member.simps(4)
thf(fact_1197_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X2: int] :
              ( ( P @ X2 )
             => ( P @ ( plus_plus @ int @ X2 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_1198_le__imp__0__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ).

% le_imp_0_less
thf(fact_1199_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_1200_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_1201_vebt__member_Osimps_I3_J,axiom,
    ! [V2: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V2 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X ) ).

% vebt_member.simps(3)
thf(fact_1202_vebt__insert_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S ) @ X )
      = ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S ) ) ).

% vebt_insert.simps(3)
thf(fact_1203_add1__zle__eq,axiom,
    ! [W2: int,Z: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W2 @ ( one_one @ int ) ) @ Z )
      = ( ord_less @ int @ W2 @ Z ) ) ).

% add1_zle_eq
thf(fact_1204_unset__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_1205_unset__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_1206_unset__bit__less__eq,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_1207_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z3 @ X2 )
               => ( ( ( P @ X2 )
                    & ( Q @ X2 ) )
                  = ( ( P5 @ X2 )
                    & ( Q6 @ X2 ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_1208_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z3 @ X2 )
               => ( ( ( P @ X2 )
                    | ( Q @ X2 ) )
                  = ( ( P5 @ X2 )
                    | ( Q6 @ X2 ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_1209_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ Z3 @ X2 )
         => ( X2 != T2 ) ) ) ).

% pinf(3)
thf(fact_1210_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ Z3 @ X2 )
         => ( X2 != T2 ) ) ) ).

% pinf(4)
thf(fact_1211_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ Z3 @ X2 )
         => ~ ( ord_less @ A @ X2 @ T2 ) ) ) ).

% pinf(5)
thf(fact_1212_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ Z3 @ X2 )
         => ( ord_less @ A @ T2 @ X2 ) ) ) ).

% pinf(7)
thf(fact_1213_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z3: C] :
        ! [X2: C] :
          ( ( ord_less @ C @ Z3 @ X2 )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_1214_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z3 )
               => ( ( ( P @ X2 )
                    & ( Q @ X2 ) )
                  = ( ( P5 @ X2 )
                    & ( Q6 @ X2 ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_1215_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z3 )
               => ( ( ( P @ X2 )
                    | ( Q @ X2 ) )
                  = ( ( P5 @ X2 )
                    | ( Q6 @ X2 ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_1216_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ X2 @ Z3 )
         => ( X2 != T2 ) ) ) ).

% minf(3)
thf(fact_1217_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ X2 @ Z3 )
         => ( X2 != T2 ) ) ) ).

% minf(4)
thf(fact_1218_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ X2 @ Z3 )
         => ( ord_less @ A @ X2 @ T2 ) ) ) ).

% minf(5)
thf(fact_1219_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ X2 @ Z3 )
         => ~ ( ord_less @ A @ T2 @ X2 ) ) ) ).

% minf(7)
thf(fact_1220_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z3: C] :
        ! [X2: C] :
          ( ( ord_less @ C @ X2 @ Z3 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_1221_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ Z3 @ X2 )
         => ~ ( ord_less_eq @ A @ X2 @ T2 ) ) ) ).

% pinf(6)
thf(fact_1222_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ Z3 @ X2 )
         => ( ord_less_eq @ A @ T2 @ X2 ) ) ) ).

% pinf(8)
thf(fact_1223_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ X2 @ Z3 )
         => ( ord_less_eq @ A @ X2 @ T2 ) ) ) ).

% minf(6)
thf(fact_1224_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X2: A] :
          ( ( ord_less @ A @ X2 @ Z3 )
         => ~ ( ord_less_eq @ A @ T2 @ X2 ) ) ) ).

% minf(8)
thf(fact_1225_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_1226_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_1227_int__distrib_I2_J,axiom,
    ! [W2: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W2 @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W2 @ Z1 ) @ ( times_times @ int @ W2 @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_1228_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W2: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W2 )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W2 ) @ ( times_times @ int @ Z22 @ W2 ) ) ) ).

% int_distrib(1)
thf(fact_1229_zmult__zless__mono2,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less @ int @ I2 @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I2 ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_1230_odd__nonzero,axiom,
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1231_int__ge__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I2 )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_ge_induct
thf(fact_1232_int__gr__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I2 )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_gr_induct
thf(fact_1233_zless__add1__eq,axiom,
    ! [W2: int,Z: int] :
      ( ( ord_less @ int @ W2 @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W2 @ Z )
        | ( W2 = Z ) ) ) ).

% zless_add1_eq
thf(fact_1234_vebt__insert_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S ) @ X )
      = ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S ) ) ).

% vebt_insert.simps(2)
thf(fact_1235_VEBT__internal_OminNull_Osimps_I5_J,axiom,
    ! [Uz: product_prod @ nat @ nat,Va: nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va @ Vb @ Vc ) ) ).

% VEBT_internal.minNull.simps(5)
thf(fact_1236_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% int_one_le_iff_zero_less
thf(fact_1237_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_1238_pos__zmult__eq__1__iff,axiom,
    ! [M2: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M2 )
     => ( ( ( times_times @ int @ M2 @ N2 )
          = ( one_one @ int ) )
        = ( ( M2
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1239_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1240_zless__imp__add1__zle,axiom,
    ! [W2: int,Z: int] :
      ( ( ord_less @ int @ W2 @ Z )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W2 @ ( one_one @ int ) ) @ Z ) ) ).

% zless_imp_add1_zle
thf(fact_1241_buildup__nothing__in__leaf,axiom,
    ! [N2: nat,X: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N2 ) @ X ) ).

% buildup_nothing_in_leaf
thf(fact_1242_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_1243_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ X ) @ ( times_times @ A @ Z @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_1244_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ Z ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_1245_product__nth,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) @ N2 )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_1246_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M2 )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
         => ( ( M2
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M2 ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_1247_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_1248_deg__1__Leafy,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( N2
          = ( one_one @ nat ) )
       => ? [A4: $o,B4: $o] :
            ( T2
            = ( vEBT_Leaf @ A4 @ B4 ) ) ) ) ).

% deg_1_Leafy
thf(fact_1249_deg__1__Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
     => ? [A4: $o,B4: $o] :
          ( T2
          = ( vEBT_Leaf @ A4 @ B4 ) ) ) ).

% deg_1_Leaf
thf(fact_1250_deg1Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
      = ( ? [A3: $o,B3: $o] :
            ( T2
            = ( vEBT_Leaf @ A3 @ B3 ) ) ) ) ).

% deg1Leaf
thf(fact_1251_flip__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_1252_flip__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_1253_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_1254_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu: $o,Uv: $o,D4: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ D4 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,Deg3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_1255_VEBT__internal_OminNull_Ocases,axiom,
    ! [X: vEBT_VEBT] :
      ( ( X
       != ( vEBT_Leaf @ $false @ $false ) )
     => ( ! [Uv: $o] :
            ( X
           != ( vEBT_Leaf @ $true @ Uv ) )
       => ( ! [Uu: $o] :
              ( X
             != ( vEBT_Leaf @ Uu @ $true ) )
         => ( ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy2 ) )
           => ~ ! [Uz2: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va2 @ Vb2 @ Vc2 ) ) ) ) ) ) ).

% VEBT_internal.minNull.cases
thf(fact_1256_VEBT__internal_OminNull_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ X )
     => ( ( X
         != ( vEBT_Leaf @ $false @ $false ) )
       => ~ ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy2 ) ) ) ) ).

% VEBT_internal.minNull.elims(2)
thf(fact_1257_VEBT_Oexhaust,axiom,
    ! [Y: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X21: $o,X222: $o] :
            ( Y
           != ( vEBT_Leaf @ X21 @ X222 ) ) ) ).

% VEBT.exhaust
thf(fact_1258_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X212: $o,X223: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X212 @ X223 ) ) ).

% VEBT.distinct(1)
thf(fact_1259_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_1260_VEBT__internal_OminNull_Osimps_I1_J,axiom,
    vEBT_VEBT_minNull @ ( vEBT_Leaf @ $false @ $false ) ).

% VEBT_internal.minNull.simps(1)
thf(fact_1261_VEBT__internal_OminNull_Osimps_I2_J,axiom,
    ! [Uv2: $o] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Leaf @ $true @ Uv2 ) ) ).

% VEBT_internal.minNull.simps(2)
thf(fact_1262_VEBT__internal_OminNull_Osimps_I3_J,axiom,
    ! [Uu2: $o] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Leaf @ Uu2 @ $true ) ) ).

% VEBT_internal.minNull.simps(3)
thf(fact_1263_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A4: $o,B4: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ X3 ) )
     => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ X3 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_1264_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu: $o,Uv: $o,Uw: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) )
     => ( ! [Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ X3 ) )
         => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ X3 ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ X3 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_1265_vebt__insert_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A4: $o,B4: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ X3 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) @ X3 ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) @ X3 ) )
         => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) @ X3 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) @ X3 ) ) ) ) ) ) ).

% vebt_insert.cases
thf(fact_1266_vebt__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A4: $o,B4: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ X3 ) )
     => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,X3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ X3 ) )
       => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X3 ) )
         => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X3 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) @ X3 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_1267_VEBT__internal_OminNull_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Y: $o] :
      ( ( ( vEBT_VEBT_minNull @ X )
        = Y )
     => ( ( ( X
            = ( vEBT_Leaf @ $false @ $false ) )
         => ~ Y )
       => ( ( ? [Uv: $o] :
                ( X
                = ( vEBT_Leaf @ $true @ Uv ) )
           => Y )
         => ( ( ? [Uu: $o] :
                  ( X
                  = ( vEBT_Leaf @ Uu @ $true ) )
             => Y )
           => ( ( ? [Uw: nat,Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy2 ) )
               => ~ Y )
             => ~ ( ? [Uz2: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va2 @ Vb2 @ Vc2 ) )
                 => Y ) ) ) ) ) ) ).

% VEBT_internal.minNull.elims(1)
thf(fact_1268_vebt__member_Osimps_I2_J,axiom,
    ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ X ) ).

% vebt_member.simps(2)
thf(fact_1269_VEBT__internal_OminNull_Osimps_I4_J,axiom,
    ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy: vEBT_VEBT] : ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy ) ) ).

% VEBT_internal.minNull.simps(4)
thf(fact_1270_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_1271_vebt__insert_Osimps_I1_J,axiom,
    ! [X: nat,A2: $o,B2: $o] :
      ( ( ( X
          = ( zero_zero @ nat ) )
       => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
          = ( vEBT_Leaf @ $true @ B2 ) ) )
      & ( ( X
         != ( zero_zero @ nat ) )
       => ( ( ( X
              = ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ $true ) ) )
          & ( ( X
             != ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ B2 ) ) ) ) ) ) ).

% vebt_insert.simps(1)
thf(fact_1272_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_1273_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_1274_VEBT__internal_OminNull_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ X )
     => ( ! [Uv: $o] :
            ( X
           != ( vEBT_Leaf @ $true @ Uv ) )
       => ( ! [Uu: $o] :
              ( X
             != ( vEBT_Leaf @ Uu @ $true ) )
         => ~ ! [Uz2: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va2 @ Vb2 @ Vc2 ) ) ) ) ) ).

% VEBT_internal.minNull.elims(3)
thf(fact_1275_vebt__insert_Osimps_I4_J,axiom,
    ! [V2: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V2 ) ) @ TreeList2 @ Summary ) @ X )
      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ X ) ) @ ( suc @ ( suc @ V2 ) ) @ TreeList2 @ Summary ) ) ).

% vebt_insert.simps(4)
thf(fact_1276_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( ( vEBT_invar_vebt @ A1 @ A22 )
     => ( ( ? [A4: $o,B4: $o] :
              ( A1
              = ( vEBT_Leaf @ A4 @ B4 ) )
         => ( A22
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( A22 = Deg2 )
               => ( ! [X2: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X2 @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                     => ( ( M4 = N3 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N3 @ M4 ) )
                         => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                           => ~ ! [X2: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A1
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( A22 = Deg2 )
                 => ( ! [X2: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X2 @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                       => ( ( M4
                            = ( suc @ N3 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N3 @ M4 ) )
                           => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                             => ~ ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                  ( ( A1
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                 => ( ( A22 = Deg2 )
                   => ( ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X2 @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                         => ( ( M4 = N3 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N3 @ M4 ) )
                             => ( ! [I: nat] :
                                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                   => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X6 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                               => ( ( ( Mi2 = Ma2 )
                                   => ! [X2: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                   => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi2 != Ma2 )
                                         => ! [I: nat] :
                                              ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                    = I )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                & ! [X2: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X2 @ N3 )
                                                        = I )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X2 @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi2 @ X2 )
                                                      & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                    ( ( A1
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                   => ( ( A22 = Deg2 )
                     => ( ! [X2: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X2 @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                           => ( ( M4
                                = ( suc @ N3 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N3 @ M4 ) )
                               => ( ! [I: nat] :
                                      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                     => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X6 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                                 => ( ( ( Mi2 = Ma2 )
                                     => ! [X2: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X_1 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                     => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi2 != Ma2 )
                                           => ! [I: nat] :
                                                ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                      = I )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                  & ! [X2: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X2 @ N3 )
                                                          = I )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X2 @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi2 @ X2 )
                                                        & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_1277_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A12: vEBT_VEBT,A23: nat] :
          ( ( ? [A3: $o,B3: $o] :
                ( A12
                = ( vEBT_Leaf @ A3 @ B3 ) )
            & ( A23
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ N )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
              & ( A23
                = ( plus_plus @ nat @ N @ N ) )
              & ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X6 )
              & ! [X4: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
              & ( A23
                = ( plus_plus @ nat @ N @ ( suc @ N ) ) )
              & ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X6 )
              & ! [X4: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ N )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
              & ( A23
                = ( plus_plus @ nat @ N @ N ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                 => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X6 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X4: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N ) ) )
                      & ! [X4: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X4 @ N )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X4 @ N ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X4 )
                            & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X4: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X4 @ N ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
              & ( A23
                = ( plus_plus @ nat @ N @ ( suc @ N ) ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
                 => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X6 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X4: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N ) ) )
                      & ! [X4: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X4 @ N )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X4 @ N ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X4 )
                            & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_1278_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ Z ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_1279_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M2: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M2 )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) )
         => ( ( M2 = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M2 ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_1280_member__valid__both__member__options,axiom,
    ! [Tree: vEBT_VEBT,N2: nat,X: nat] :
      ( ( vEBT_invar_vebt @ Tree @ N2 )
     => ( ( vEBT_vebt_member @ Tree @ X )
       => ( ( vEBT_V5719532721284313246member @ Tree @ X )
          | ( vEBT_VEBT_membermima @ Tree @ X ) ) ) ) ).

% member_valid_both_member_options
thf(fact_1281_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X4: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X4 )
          | ( vEBT_VEBT_membermima @ T3 @ X4 ) ) ) ) ).

% both_member_options_def
thf(fact_1282_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1283_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M2: nat,N2: nat] :
      ( ! [M4: nat] : ( P @ M4 @ ( zero_zero @ nat ) )
     => ( ! [M4: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P @ N3 @ ( modulo_modulo @ nat @ M4 @ N3 ) )
             => ( P @ M4 @ N3 ) ) )
       => ( P @ M2 @ N2 ) ) ) ).

% gcd_nat_induct
thf(fact_1284_concat__bit__Suc,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_concat_bit @ ( suc @ N2 ) @ K @ L )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N2 @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L ) ) ) ) ).

% concat_bit_Suc
thf(fact_1285_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1286_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1287_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1288_buildup__nothing__in__min__max,axiom,
    ! [N2: nat,X: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N2 ) @ X ) ).

% buildup_nothing_in_min_max
thf(fact_1289_nat__dvd__1__iff__1,axiom,
    ! [M2: nat] :
      ( ( dvd_dvd @ nat @ M2 @ ( one_one @ nat ) )
      = ( M2
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1290_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_1291_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_1292_dvd__1__iff__1,axiom,
    ! [M2: nat] :
      ( ( dvd_dvd @ nat @ M2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M2
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_1293_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_1294_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_1295_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M2 @ N2 ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1296_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_1297_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_1298_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1299_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1300_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1301_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1302_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1303_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1304_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1305_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1306_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1307_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1308_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1309_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_1310_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_1311_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1312_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1313_concat__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N2 @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1314_concat__bit__negative__iff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N2 @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1315_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1316_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1317_even__Suc,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_Suc
thf(fact_1318_even__Suc__Suc__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N2 ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% even_Suc_Suc_iff
thf(fact_1319_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1320_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1321_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_1322_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_1323_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_1324_odd__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_1325_even__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_1326_signed__take__bit__Suc__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_1327_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_1328_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_1329_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_1330_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1331_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) )
          = ( ( ( numeral_numeral @ nat @ W2 )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_1332_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1333_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1334_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1335_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% even_power
thf(fact_1336_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1337_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W2 ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_1338_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B7: A,C5: A] :
              ( ( A2
                = ( times_times @ A @ B7 @ C5 ) )
              & ( dvd_dvd @ A @ B7 @ B2 )
              & ( dvd_dvd @ A @ C5 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1339_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P4: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P4 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X3: A,Y2: A] :
                ( ( P4
                  = ( times_times @ A @ X3 @ Y2 ) )
               => ( ( dvd_dvd @ A @ X3 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y2 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1340_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K2: A] :
                ( A2
               != ( times_times @ A @ B2 @ K2 ) ) ) ) ).

% dvdE
thf(fact_1341_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_1342_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B3: A,A3: A] :
            ? [K3: A] :
              ( A3
              = ( times_times @ A @ B3 @ K3 ) ) ) ) ) ).

% dvd_def
thf(fact_1343_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1344_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1345_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1346_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1347_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1348_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1349_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_1350_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_1351_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_1352_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1353_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1354_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1355_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1356_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1357_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1358_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1359_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N2: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( dvd_dvd @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) ) ) ) ).

% dvd_power_same
thf(fact_1360_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A2 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_1361_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M2: A,N2: A] :
          ( ( dvd_dvd @ A @ K @ M2 )
         => ( ( dvd_dvd @ A @ K @ N2 )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M2 @ N2 ) ) ) ) ) ).

% dvd_mod
thf(fact_1362_signed__take__bit__mult,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ K @ L ) ) ) ).

% signed_take_bit_mult
thf(fact_1363_signed__take__bit__add,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ L ) ) ) ).

% signed_take_bit_add
thf(fact_1364_dvd__pos__nat,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ M2 @ N2 )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 ) ) ) ).

% dvd_pos_nat
thf(fact_1365_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X: nat,Y: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A2 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y ) @ D2 ) ) )
         => ? [X3: nat,Y2: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A2 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y2 ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1366_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D4 ) )
        | ( ( times_times @ nat @ B2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ D4 ) ) ) ) ).

% bezout_add_nat
thf(fact_1367_concat__bit__assoc,axiom,
    ! [N2: nat,K: int,M2: nat,L: int,R: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( bit_concat_bit @ M2 @ L @ R ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M2 @ N2 ) @ ( bit_concat_bit @ N2 @ K @ L ) @ R ) ) ).

% concat_bit_assoc
thf(fact_1368_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M2 @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1369_div__int__unique,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( divide_divide @ int @ K @ L )
        = Q2 ) ) ).

% div_int_unique
thf(fact_1370_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1371_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X2: B] :
          ( ( ord_less @ B @ Z3 @ X2 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_1372_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X2: B] :
          ( ( ord_less @ B @ Z3 @ X2 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1373_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X2: B] :
          ( ( ord_less @ B @ X2 @ Z3 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) ) ) ) ) ).

% minf(9)
thf(fact_1374_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z3: B] :
        ! [X2: B] :
          ( ( ord_less @ B @ X2 @ Z3 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X2 @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_1375_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1376_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1377_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1378_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1379_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1380_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1381_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1382_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1383_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1384_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1385_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1386_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1387_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1388_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1389_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1390_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1391_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1392_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1393_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1394_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% div_power
thf(fact_1395_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M2 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1396_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat,B2: A,M2: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 )
         => ( ( ord_less_eq @ nat @ M2 @ N2 )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M2 ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1397_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N2: nat,M2: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( ord_less_eq @ nat @ N2 @ M2 )
           => ( dvd_dvd @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ M2 ) ) ) ) ) ).

% dvd_power_le
thf(fact_1398_nat__dvd__not__less,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( ord_less @ nat @ M2 @ N2 )
       => ~ ( dvd_dvd @ nat @ N2 @ M2 ) ) ) ).

% nat_dvd_not_less
thf(fact_1399_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D4: nat,X3: nat,Y2: nat] :
          ( ( dvd_dvd @ nat @ D4 @ A2 )
          & ( dvd_dvd @ nat @ D4 @ B2 )
          & ( ( times_times @ nat @ A2 @ X3 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D4 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1400_zdvd__mult__cancel,axiom,
    ! [K: int,M2: int,N2: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M2 ) @ ( times_times @ int @ K @ N2 ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M2 @ N2 ) ) ) ).

% zdvd_mult_cancel
thf(fact_1401_zdvd__mono,axiom,
    ! [K: int,M2: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M2 @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M2 ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_1402_zdvd__period,axiom,
    ! [A2: int,D2: int,X: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_1403_zdvd__reduce,axiom,
    ! [K: int,N2: int,M2: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N2 @ ( times_times @ int @ K @ M2 ) ) )
      = ( dvd_dvd @ int @ K @ N2 ) ) ).

% zdvd_reduce
thf(fact_1404_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1405_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X4: A] : ( P @ ( times_times @ A @ L @ X4 ) ) )
          = ( ? [X4: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X4 @ ( zero_zero @ A ) ) )
                & ( P @ X4 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1406_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1407_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1408_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1409_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1410_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1411_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ).

% even_numeral
thf(fact_1412_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1413_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1414_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1415_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1416_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1417_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1418_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1419_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1420_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q2: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q2 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_1421_dvd__imp__le,axiom,
    ! [K: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% dvd_imp_le
thf(fact_1422_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
        = ( dvd_dvd @ nat @ M2 @ N2 ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1423_dvd__mult__cancel,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M2 @ N2 ) ) ) ).

% dvd_mult_cancel
thf(fact_1424_mod__greater__zero__iff__not__dvd,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M2 @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ N2 @ M2 ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_1425_eucl__rel__int,axiom,
    ! [K: int,L: int] : ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% eucl_rel_int
thf(fact_1426_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1427_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B4: A] :
                  ( ( B4
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B4 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B4 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B4 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B4 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B4 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1428_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1429_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1430_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B4: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) ) ) ) ).

% evenE
thf(fact_1431_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1432_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1433_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) )
              & ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1434_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M2: nat,N2: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ X @ N2 ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1435_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% dvd_power
thf(fact_1436_even__even__mod__4__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_1437_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux2: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_1438_dvd__mult__cancel2,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N2 @ M2 ) @ M2 )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1439_dvd__mult__cancel1,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M2 @ N2 ) @ M2 )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1440_power__dvd__imp__le,axiom,
    ! [I2: nat,M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I2 @ M2 ) @ ( power_power @ nat @ I2 @ N2 ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I2 )
       => ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ).

% power_dvd_imp_le
thf(fact_1441_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1442_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1443_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1444_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_odd
thf(fact_1445_odd__pos,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% odd_pos
thf(fact_1446_dvd__power__iff__le,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M2 ) @ ( power_power @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ).

% dvd_power_iff_le
thf(fact_1447_signed__take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1448_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M2 @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M2
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1449_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M2 @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M2
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1450_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M2 @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1451_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Va: list @ vEBT_VEBT,Vb: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) @ X )
      = ( ( X = Mi )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_1452_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B4: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1453_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1454_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1455_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_even_power
thf(fact_1456_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1457_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1458_signed__take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_1459_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_1460_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1461_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A4: nat,B4: nat] :
          ( ( P @ A4 @ B4 )
          = ( P @ B4 @ A4 ) )
     => ( ! [A4: nat] : ( P @ A4 @ ( zero_zero @ nat ) )
       => ( ! [A4: nat,B4: nat] :
              ( ( P @ A4 @ B4 )
             => ( P @ A4 @ ( plus_plus @ nat @ A4 @ B4 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1462_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q2 ) @ R ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
            & ( ord_less @ int @ R @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R )
                & ( ord_less_eq @ int @ R @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q2
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_1463_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1464_div2__even__ext__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y ) )
       => ( X = Y ) ) ) ).

% div2_even_ext_nat
thf(fact_1465_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1466_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1467_vebt__insert_Oelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa2 )
        = Y )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => ( Y
                    = ( vEBT_Leaf @ $true @ B4 ) ) )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => ( Y
                        = ( vEBT_Leaf @ A4 @ $true ) ) )
                    & ( ( Xa2
                       != ( one_one @ nat ) )
                     => ( Y
                        = ( vEBT_Leaf @ A4 @ B4 ) ) ) ) ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
             => ( Y
               != ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
               => ( Y
                 != ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) ) )
           => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) )
                 => ( Y
                   != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
                   => ( Y
                     != ( if @ vEBT_VEBT
                        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                          & ~ ( ( Xa2 = Mi2 )
                              | ( Xa2 = Ma2 ) ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Xa2 @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) ) ) ) ) ) ) ) ) ).

% vebt_insert.elims
thf(fact_1468_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_1469_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ord_less @ nat @ N2 @ M2 )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M2 @ N2 )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1470_num_Osize__gen_I2_J,axiom,
    ! [X22: num] :
      ( ( size_num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_1471_buildup__gives__empty,axiom,
    ! [N2: nat] :
      ( ( vEBT_VEBT_set_vebt @ ( vEBT_vebt_buildup @ N2 ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% buildup_gives_empty
thf(fact_1472_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T3 ) ) ) ) ).

% set_vebt'_def
thf(fact_1473_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B8: A > B,X4: A] : ( minus_minus @ B @ ( A7 @ X4 ) @ ( B8 @ X4 ) ) ) ) ) ).

% minus_apply
thf(fact_1474_bot__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( bot @ C )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X4: D] : ( bot_bot @ C ) ) ) ) ).

% bot_apply
thf(fact_1475_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_1476_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1477_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1478_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1479_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_1480_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_1481_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_1482_diff__Suc__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ M2 @ N2 ) ) ).

% diff_Suc_Suc
thf(fact_1483_Suc__diff__diff,axiom,
    ! [M2: nat,N2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M2 ) @ N2 ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ K ) ) ).

% Suc_diff_diff
thf(fact_1484_diff__self__eq__0,axiom,
    ! [M2: nat] :
      ( ( minus_minus @ nat @ M2 @ M2 )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_1485_diff__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_1486_diff__diff__cancel,axiom,
    ! [I2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ N2 )
     => ( ( minus_minus @ nat @ N2 @ ( minus_minus @ nat @ N2 @ I2 ) )
        = I2 ) ) ).

% diff_diff_cancel
thf(fact_1487_diff__diff__left,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J ) @ K )
      = ( minus_minus @ nat @ I2 @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_1488_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_1489_max__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% max_bot
thf(fact_1490_max__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% max_bot2
thf(fact_1491_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_1492_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_1493_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1494_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_1495_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_1496_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_1497_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_1498_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_1499_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1500_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1501_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V2: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1502_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V2: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1503_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1504_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_1505_zero__less__diff,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M2 ) )
      = ( ord_less @ nat @ M2 @ N2 ) ) ).

% zero_less_diff
thf(fact_1506_diff__is__0__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% diff_is_0_eq
thf(fact_1507_diff__is__0__eq_H,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( minus_minus @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_1508_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_1509_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_1510_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_1511_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I2 ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_1512_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_1513_diff__Suc__1,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( one_one @ nat ) )
      = N2 ) ).

% diff_Suc_1
thf(fact_1514_Suc__0__mod__eq,axiom,
    ! [N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_1515_Suc__pred,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% Suc_pred
thf(fact_1516_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I2 )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_1517_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I2 @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_1518_zle__diff1__eq,axiom,
    ! [W2: int,Z: int] :
      ( ( ord_less_eq @ int @ W2 @ ( minus_minus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W2 @ Z ) ) ).

% zle_diff1_eq
thf(fact_1519_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P4: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P4 ) ) )
          = P4 ) ) ).

% odd_of_bool_self
thf(fact_1520_Suc__diff__1,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
        = N2 ) ) ).

% Suc_diff_1
thf(fact_1521_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1522_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_1523_odd__Suc__minus__one,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% odd_Suc_minus_one
thf(fact_1524_even__diff__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M2 @ N2 ) )
      = ( ( ord_less @ nat @ M2 @ N2 )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ) ).

% even_diff_nat
thf(fact_1525_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1526_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1527_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1528_odd__two__times__div__two__nat,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1529_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1530_dvd__diff__nat,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ M2 )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M2 @ N2 ) ) ) ) ).

% dvd_diff_nat
thf(fact_1531_dvd__antisym,axiom,
    ! [M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M2 @ N2 )
     => ( ( dvd_dvd @ nat @ N2 @ M2 )
       => ( M2 = N2 ) ) ) ).

% dvd_antisym
thf(fact_1532_signed__take__bit__diff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L ) ) ) ).

% signed_take_bit_diff
thf(fact_1533_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B8: A > B,X4: A] : ( minus_minus @ B @ ( A7 @ X4 ) @ ( B8 @ X4 ) ) ) ) ) ).

% fun_diff_def
thf(fact_1534_bot__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot @ B )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X4: A] : ( bot_bot @ B ) ) ) ) ).

% bot_fun_def
thf(fact_1535_diff__commute,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ K ) @ J ) ) ).

% diff_commute
thf(fact_1536_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_1537_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X4: A] : X4 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_1538_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_1539_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ B3 @ A3 ) ) ) ) ).

% max_def_raw
thf(fact_1540_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_1541_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_1542_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_1543_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_1544_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_1545_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1546_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_1547_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_1548_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_1549_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_1550_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_1551_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_1552_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_1553_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_1554_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_1555_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_1556_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_1557_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_1558_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X2: A,K4: A] :
                ( ( ( P @ X2 )
                  | ( Q @ X2 ) )
                = ( ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K4 @ D5 ) ) )
                  | ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1559_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X2: A,K4: A] :
                ( ( ( P @ X2 )
                  & ( Q @ X2 ) )
                = ( ( P @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K4 @ D5 ) ) )
                  & ( Q @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1560_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1561_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1562_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1563_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1564_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1565_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1566_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1567_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1568_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: A,K: A,A2: A,B2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A5 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1569_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_1570_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1571_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1572_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I2: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K @ I2 ) ) ) ) ).

% zero_induct_lemma
thf(fact_1573_diffs0__imp__equal,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N2 @ M2 )
          = ( zero_zero @ nat ) )
       => ( M2 = N2 ) ) ) ).

% diffs0_imp_equal
thf(fact_1574_minus__nat_Odiff__0,axiom,
    ! [M2: nat] :
      ( ( minus_minus @ nat @ M2 @ ( zero_zero @ nat ) )
      = M2 ) ).

% minus_nat.diff_0
thf(fact_1575_diff__less__mono2,axiom,
    ! [M2: nat,N2: nat,L: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ( ord_less @ nat @ M2 @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N2 ) @ ( minus_minus @ nat @ L @ M2 ) ) ) ) ).

% diff_less_mono2
thf(fact_1576_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N2 ) @ K ) ) ).

% less_imp_diff_less
thf(fact_1577_dvd__minus__self,axiom,
    ! [M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M2 @ ( minus_minus @ nat @ N2 @ M2 ) )
      = ( ( ord_less @ nat @ N2 @ M2 )
        | ( dvd_dvd @ nat @ M2 @ N2 ) ) ) ).

% dvd_minus_self
thf(fact_1578_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_1579_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_1580_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_1581_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_1582_eq__diff__iff,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M2 )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ( minus_minus @ nat @ M2 @ K )
            = ( minus_minus @ nat @ N2 @ K ) )
          = ( M2 = N2 ) ) ) ) ).

% eq_diff_iff
thf(fact_1583_le__diff__iff,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M2 )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M2 @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ) ).

% le_diff_iff
thf(fact_1584_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M2 )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M2 @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( minus_minus @ nat @ M2 @ N2 ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_1585_diff__le__mono,axiom,
    ! [M2: nat,N2: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M2 @ L ) @ ( minus_minus @ nat @ N2 @ L ) ) ) ).

% diff_le_mono
thf(fact_1586_diff__le__self,axiom,
    ! [M2: nat,N2: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ M2 ) ).

% diff_le_self
thf(fact_1587_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_1588_diff__le__mono2,axiom,
    ! [M2: nat,N2: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N2 ) @ ( minus_minus @ nat @ L @ M2 ) ) ) ).

% diff_le_mono2
thf(fact_1589_less__eq__dvd__minus,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( dvd_dvd @ nat @ M2 @ N2 )
        = ( dvd_dvd @ nat @ M2 @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1590_dvd__diffD1,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M2 @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ M2 )
       => ( ( ord_less_eq @ nat @ N2 @ M2 )
         => ( dvd_dvd @ nat @ K @ N2 ) ) ) ) ).

% dvd_diffD1
thf(fact_1591_dvd__diffD,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M2 @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ N2 @ M2 )
         => ( dvd_dvd @ nat @ K @ M2 ) ) ) ) ).

% dvd_diffD
thf(fact_1592_Nat_Odiff__cancel,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M2 ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( minus_minus @ nat @ M2 @ N2 ) ) ).

% Nat.diff_cancel
thf(fact_1593_diff__cancel2,axiom,
    ! [M2: nat,K: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) )
      = ( minus_minus @ nat @ M2 @ N2 ) ) ).

% diff_cancel2
thf(fact_1594_diff__add__inverse,axiom,
    ! [N2: nat,M2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ M2 ) @ N2 )
      = M2 ) ).

% diff_add_inverse
thf(fact_1595_diff__add__inverse2,axiom,
    ! [M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ N2 )
      = M2 ) ).

% diff_add_inverse2
thf(fact_1596_diff__mult__distrib,axiom,
    ! [M2: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M2 @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% diff_mult_distrib
thf(fact_1597_diff__mult__distrib2,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M2 @ N2 ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% diff_mult_distrib2
thf(fact_1598_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y2 ) )
          = D4 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y2 ) )
          = D4 ) ) ) ).

% bezout1_nat
thf(fact_1599_int__distrib_I4_J,axiom,
    ! [W2: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W2 @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W2 @ Z1 ) @ ( times_times @ int @ W2 @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_1600_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W2: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W2 )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W2 ) @ ( times_times @ int @ Z22 @ W2 ) ) ) ).

% int_distrib(3)
thf(fact_1601_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z ) @ ( minus_minus @ A @ Y @ Z ) ) ) ) ).

% max_diff_distrib_left
thf(fact_1602_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_code(2)
thf(fact_1603_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T3 ) ) ) ) ).

% set_vebt_def
thf(fact_1604_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W2: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit0 @ W2 ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W2 ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_even
thf(fact_1605_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_1606_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1607_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ~ ( ( P4
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P4
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1608_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ( P4
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P4
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1609_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P6: $o] : ( if @ A @ P6 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1610_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1611_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] : ( ord_less @ A @ ( minus_minus @ A @ A3 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1612_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1613_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1614_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1615_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1616_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1617_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1618_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1619_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1620_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_1621_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N2: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N2 )
         => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N2 )
             => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N2 @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_1622_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_1623_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N2 )
         => ( ord_less_eq @ A @ I2 @ ( minus_minus @ A @ N2 @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_1624_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1625_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1626_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1627_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1628_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_1629_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_1630_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_1631_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X: A,Y: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ A @ X @ Y ) ) ) ) ).

% square_diff_square_factored
thf(fact_1632_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X: A,Y: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ Y ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ ( minus_minus @ A @ Y @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_1633_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1634_Suc__diff__Suc,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ N2 @ M2 )
     => ( ( suc @ ( minus_minus @ nat @ M2 @ ( suc @ N2 ) ) )
        = ( minus_minus @ nat @ M2 @ N2 ) ) ) ).

% Suc_diff_Suc
thf(fact_1635_diff__less__Suc,axiom,
    ! [M2: nat,N2: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ ( suc @ M2 ) ) ).

% diff_less_Suc
thf(fact_1636_diff__less,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ M2 ) ) ) ).

% diff_less
thf(fact_1637_Suc__diff__le,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ( minus_minus @ nat @ ( suc @ M2 ) @ N2 )
        = ( suc @ ( minus_minus @ nat @ M2 @ N2 ) ) ) ) ).

% Suc_diff_le
thf(fact_1638_less__diff__iff,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M2 )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M2 @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less @ nat @ M2 @ N2 ) ) ) ) ).

% less_diff_iff
thf(fact_1639_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_1640_diff__add__0,axiom,
    ! [N2: nat,M2: nat] :
      ( ( minus_minus @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M2 ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1641_less__diff__conv,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_1642_add__diff__inverse__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M2 @ N2 )
     => ( ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ M2 @ N2 ) )
        = M2 ) ) ).

% add_diff_inverse_nat
thf(fact_1643_le__diff__conv,axiom,
    ! [J: nat,K: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I2 @ K ) ) ) ).

% le_diff_conv
thf(fact_1644_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_1645_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K )
        = ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_1646_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I2 ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_1647_Nat_Ole__imp__diff__is__add,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ( minus_minus @ nat @ J @ I2 )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_1648_diff__Suc__eq__diff__pred,axiom,
    ! [M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ M2 @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) @ N2 ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1649_int__le__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I2 @ K )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_le_induct
thf(fact_1650_int__less__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I2 @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_less_induct
thf(fact_1651_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M: nat,N: nat] : ( if @ nat @ ( ord_less @ nat @ M @ N ) @ M @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ).

% mod_if
thf(fact_1652_mod__geq,axiom,
    ! [M2: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M2 @ N2 )
     => ( ( modulo_modulo @ nat @ M2 @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 ) ) ) ).

% mod_geq
thf(fact_1653_le__mod__geq,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ( modulo_modulo @ nat @ M2 @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 ) ) ) ).

% le_mod_geq
thf(fact_1654_mod__eq__dvd__iff__nat,axiom,
    ! [N2: nat,M2: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ( ( modulo_modulo @ nat @ M2 @ Q2 )
          = ( modulo_modulo @ nat @ N2 @ Q2 ) )
        = ( dvd_dvd @ nat @ Q2 @ ( minus_minus @ nat @ M2 @ N2 ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1655_nat__minus__add__max,axiom,
    ! [N2: nat,M2: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ M2 ) @ M2 )
      = ( ord_max @ nat @ N2 @ M2 ) ) ).

% nat_minus_add_max
thf(fact_1656_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_1657_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_1658_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1659_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1660_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1661_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y @ Z ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ Y ) @ Z ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1662_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1663_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1664_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1665_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X2: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X2 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1666_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X2: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X2 @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X2 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1667_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1668_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1669_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1670_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1671_diff__Suc__less,axiom,
    ! [N2: nat,I2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ I2 ) ) @ N2 ) ) ).

% diff_Suc_less
thf(fact_1672_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D3: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D3 ) )
                & ~ ( P @ D3 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1673_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D3: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D3 ) )
           => ( P @ D3 ) ) ) ) ).

% nat_diff_split
thf(fact_1674_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I2 @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_1675_nat__diff__add__eq2,axiom,
    ! [I2: nat,J: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ M2 @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1676_nat__diff__add__eq1,axiom,
    ! [J: nat,I2: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M2 ) @ N2 ) ) ) ).

% nat_diff_add_eq1
thf(fact_1677_nat__le__add__iff2,axiom,
    ! [I2: nat,J: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ M2 @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1678_nat__le__add__iff1,axiom,
    ! [J: nat,I2: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M2 ) @ N2 ) ) ) ).

% nat_le_add_iff1
thf(fact_1679_nat__eq__add__iff2,axiom,
    ! [I2: nat,J: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( M2
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1680_nat__eq__add__iff1,axiom,
    ! [J: nat,I2: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M2 )
          = N2 ) ) ) ).

% nat_eq_add_iff1
thf(fact_1681_dvd__minus__add,axiom,
    ! [Q2: nat,N2: nat,R: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ Q2 @ N2 )
     => ( ( ord_less_eq @ nat @ Q2 @ ( times_times @ nat @ R @ M2 ) )
       => ( ( dvd_dvd @ nat @ M2 @ ( minus_minus @ nat @ N2 @ Q2 ) )
          = ( dvd_dvd @ nat @ M2 @ ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ ( times_times @ nat @ R @ M2 ) @ Q2 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1682_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P1 @ X3 )
            = ( P1 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P1 @ X3 ) ) )
         => ( ? [X_1: int] : ( P1 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% minusinfinity
thf(fact_1683_plusinfinity,axiom,
    ! [D2: int,P5: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P5 @ X3 )
            = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [X_1: int] : ( P5 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% plusinfinity
thf(fact_1684_int__induct,axiom,
    ! [P: int > $o,K: int,I2: int] :
      ( ( P @ K )
     => ( ! [I3: int] :
            ( ( ord_less_eq @ int @ K @ I3 )
           => ( ( P @ I3 )
             => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_induct
thf(fact_1685_mod__nat__eqI,axiom,
    ! [R: nat,N2: nat,M2: nat] :
      ( ( ord_less @ nat @ R @ N2 )
     => ( ( ord_less_eq @ nat @ R @ M2 )
       => ( ( dvd_dvd @ nat @ N2 @ ( minus_minus @ nat @ M2 @ R ) )
         => ( ( modulo_modulo @ nat @ M2 @ N2 )
            = R ) ) ) ) ).

% mod_nat_eqI
thf(fact_1686_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M: nat,N: nat] : ( minus_minus @ nat @ M @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% modulo_nat_def
thf(fact_1687_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N2 @ M2 ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M2 @ N2 ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_1688_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1689_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A,W2: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W2 @ Z ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W2 @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1690_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_1691_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N2: nat,M2: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M2 @ N2 ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M2 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_diff
thf(fact_1692_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_diff_iff
thf(fact_1693_Suc__pred_H,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( N2
        = ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1694_Suc__diff__eq__diff__pred,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( minus_minus @ nat @ ( suc @ M2 ) @ N2 )
        = ( minus_minus @ nat @ M2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1695_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M: nat,N: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M @ N )
            | ( N
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_if
thf(fact_1696_div__geq,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ~ ( ord_less @ nat @ M2 @ N2 )
       => ( ( divide_divide @ nat @ M2 @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 ) ) ) ) ) ).

% div_geq
thf(fact_1697_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M: nat,N: nat] :
          ( if @ nat
          @ ( M
            = ( zero_zero @ nat ) )
          @ N
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ) ) ) ).

% add_eq_if
thf(fact_1698_nat__less__add__iff1,axiom,
    ! [J: nat,I2: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U ) @ M2 ) @ N2 ) ) ) ).

% nat_less_add_iff1
thf(fact_1699_nat__less__add__iff2,axiom,
    ! [I2: nat,J: nat,U: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U ) @ M2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ M2 @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U ) @ N2 ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1700_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M: nat,N: nat] :
          ( if @ nat
          @ ( M
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ) ) ) ).

% mult_eq_if
thf(fact_1701_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X2: int] :
              ( ( P @ X2 )
             => ( P @ ( minus_minus @ int @ X2 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1702_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_1703_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V2: A,R: A,S: A] :
          ( ( ord_less_eq @ A @ U @ V2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
           => ( ( ord_less_eq @ A @ R @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R @ ( minus_minus @ A @ V2 @ U ) ) @ S ) ) @ V2 ) ) ) ) ) ).

% scaling_mono
thf(fact_1704_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,M2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M2 ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_1705_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N2: nat,M2: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N2 @ M2 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M2 ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M2 @ N2 ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N2 @ M2 )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M2 ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1706_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P6: A,M: nat] :
              ( if @ A
              @ ( M
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P6 @ ( power_power @ A @ P6 @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1707_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus_mult
thf(fact_1708_diff__le__diff__pow,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M2 ) @ ( power_power @ nat @ K @ N2 ) ) ) ) ).

% diff_le_diff_pow
thf(fact_1709_le__div__geq,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M2 )
       => ( ( divide_divide @ nat @ M2 @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 ) ) ) ) ) ).

% le_div_geq
thf(fact_1710_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_1711_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V2: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V2 ) @ TreeList2 @ S ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_1712_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A4: A] :
              ( ( ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A4 )
             => ( P @ A4 ) )
         => ( ! [A4: A,B4: $o] :
                ( ( P @ A4 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B4 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A4 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B4 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_1713_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V2: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V2 ) @ TreeList2 @ Vd2 ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_1714_signed__take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1715_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1716_vebt__member_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
      = ( ( X != Mi )
       => ( ( X != Ma )
         => ( ~ ( ord_less @ nat @ X @ Mi )
            & ( ~ ( ord_less @ nat @ X @ Mi )
             => ( ~ ( ord_less @ nat @ Ma @ X )
                & ( ~ ( ord_less @ nat @ Ma @ X )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_1717_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi: nat,Ma: nat,V2: nat,TreeList2: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ V2 ) @ TreeList2 @ Vc ) @ X )
      = ( ( X = Mi )
        | ( X = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_1718_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_1719_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M2 @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ).

% exp_mod_exp
thf(fact_1720_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_1721_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W2: A,Y: A,X: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W2 @ Y ) @ ( times_times @ A @ X @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W2 @ Z ) @ ( times_times @ A @ X @ Y ) ) )
          = ( ( W2 = X )
            | ( Y = Z ) ) ) ) ).

% crossproduct_eq
thf(fact_1722_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_1723_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1724_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A4 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B4 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_1725_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A4 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B4 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_1726_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
        = Y )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( Y
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
           => Y )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( Y
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_1727_even__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1728_int__power__div__base,axiom,
    ! [M2: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M2 ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1729_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ! [Mi2: nat,Ma2: nat] :
            ( ? [Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
           => ~ ( ( Xa2 = Mi2 )
                | ( Xa2 = Ma2 ) ) )
       => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
             => ~ ( ( Xa2 = Mi2 )
                  | ( Xa2 = Ma2 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_1730_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1731_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ).

% even_mask_div_iff'
thf(fact_1732_vebt__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X @ Xa2 )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A4 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B4 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Summary2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
             => ~ ( ( Xa2 != Mi2 )
                 => ( ( Xa2 != Ma2 )
                   => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                      & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                       => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                          & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_1733_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa2 )
        = Y )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => Y )
       => ( ( ? [Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) )
           => Y )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
               => ( Y
                  = ( ~ ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 ) ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                 => ( Y
                    = ( ~ ( ( Xa2 = Mi2 )
                          | ( Xa2 = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                   => ( Y
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_1734_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ! [Uu: $o,Uv: $o] :
            ( X
           != ( vEBT_Leaf @ Uu @ Uv ) )
       => ( ! [Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
               => ( ( Xa2 = Mi2 )
                  | ( Xa2 = Ma2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                 => ( ( Xa2 = Mi2 )
                    | ( Xa2 = Ma2 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_1735_vebt__insert_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
      = ( if @ vEBT_VEBT
        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
          & ~ ( ( X = Mi )
              | ( X = Ma ) ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ X @ Mi ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ Ma ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) ) ) ).

% vebt_insert.simps(5)
thf(fact_1736_vebt__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa2 )
        = Y )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( Y
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
           => Y )
         => ( ( ? [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
             => Y )
           => ( ( ? [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
               => Y )
             => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
                   => ( Y
                      = ( ~ ( ( Xa2 != Mi2 )
                           => ( ( Xa2 != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_1737_vebt__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa2 )
     => ( ! [A4: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A4 @ B4 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A4 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B4 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
         => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
           => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
                   => ( ( Xa2 != Mi2 )
                     => ( ( Xa2 != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_1738_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ) ).

% even_mask_div_iff
thf(fact_1739_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1740_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R: A,Q2: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ R ) ) ) ) ) ).

% divmod_step_eq
thf(fact_1741_inrange,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less_eq @ ( set @ nat ) @ ( vEBT_VEBT_set_vebt @ T2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ).

% inrange
thf(fact_1742_empty__subsetI,axiom,
    ! [A: $tType,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A5 ) ).

% empty_subsetI
thf(fact_1743_subset__empty,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_1744_vebt__insert_Opelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => ( Y
                      = ( vEBT_Leaf @ $true @ B4 ) ) )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => ( Y
                          = ( vEBT_Leaf @ A4 @ $true ) ) )
                      & ( ( Xa2
                         != ( one_one @ nat ) )
                       => ( Y
                          = ( vEBT_Leaf @ A4 @ B4 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa2 ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
               => ( ( Y
                    = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) @ Xa2 ) ) ) )
           => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
                 => ( ( Y
                      = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) @ Xa2 ) ) ) )
             => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) )
                   => ( ( Y
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( Y
                          = ( if @ vEBT_VEBT
                            @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                              & ~ ( ( Xa2 = Mi2 )
                                  | ( Xa2 = Ma2 ) ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Xa2 @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_insert.pelims
thf(fact_1745_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H2: nat > A,G2: A,N2: nat] :
      ( ! [N3: nat] :
          ( ( F2 @ ( suc @ N3 ) )
          = ( H2 @ N3 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G2 )
       => ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = G2 ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = ( H2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1746_vebt__buildup_Oelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va3: nat] :
                ( ( X
                  = ( suc @ ( suc @ Va3 ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_1747_intind,axiom,
    ! [A: $tType,I2: nat,N2: nat,P: A > $o,X: A] :
      ( ( ord_less @ nat @ I2 @ N2 )
     => ( ( P @ X )
       => ( P @ ( nth @ A @ ( replicate @ A @ N2 @ X ) @ I2 ) ) ) ) ).

% intind
thf(fact_1748_subsetI,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A5 )
         => ( member @ A @ X3 @ B5 ) )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ).

% subsetI
thf(fact_1749_subset__antisym,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
       => ( A5 = B5 ) ) ) ).

% subset_antisym
thf(fact_1750_psubsetI,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( A5 != B5 )
       => ( ord_less @ ( set @ A ) @ A5 @ B5 ) ) ) ).

% psubsetI
thf(fact_1751_idiff__0,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_1752_idiff__0__right,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = N2 ) ).

% idiff_0_right
thf(fact_1753_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A5 @ B5 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ).

% Diff_eq_empty_iff
thf(fact_1754_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I2 )
            & ( ord_less_eq @ A @ I2 @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_1755_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,H2: A,L3: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L @ H2 )
            = ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) )
          = ( ( ( L = L3 )
              & ( H2 = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L @ H2 )
              & ~ ( ord_less_eq @ A @ L3 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_1756_replicate__eq__replicate,axiom,
    ! [A: $tType,M2: nat,X: A,N2: nat,Y: A] :
      ( ( ( replicate @ A @ M2 @ X )
        = ( replicate @ A @ N2 @ Y ) )
      = ( ( M2 = N2 )
        & ( ( M2
           != ( zero_zero @ nat ) )
         => ( X = Y ) ) ) ) ).

% replicate_eq_replicate
thf(fact_1757_length__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N2 @ X ) )
      = N2 ) ).

% length_replicate
thf(fact_1758_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_1759_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_1760_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_1761_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_1762_Ball__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
           => ( P @ X4 ) ) )
      = ( ( P @ A2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_1763_Bex__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ? [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
            & ( P @ X4 ) ) )
      = ( ( P @ A2 )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_1764_in__set__replicate,axiom,
    ! [A: $tType,X: A,N2: nat,Y: A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N2 @ Y ) ) )
      = ( ( X = Y )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_1765_nth__replicate,axiom,
    ! [A: $tType,I2: nat,N2: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ N2 )
     => ( ( nth @ A @ ( replicate @ A @ N2 @ X ) @ I2 )
        = X ) ) ).

% nth_replicate
thf(fact_1766_Diff__mono,axiom,
    ! [A: $tType,A5: set @ A,C6: set @ A,D5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ D5 @ B5 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) @ ( minus_minus @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Diff_mono
thf(fact_1767_Diff__subset,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) @ A5 ) ).

% Diff_subset
thf(fact_1768_double__diff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
       => ( ( minus_minus @ ( set @ A ) @ B5 @ ( minus_minus @ ( set @ A ) @ C6 @ A5 ) )
          = A5 ) ) ) ).

% double_diff
thf(fact_1769_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_1770_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_1771_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_1772_ex__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M: nat] :
            ( ( ord_less_eq @ nat @ M @ N2 )
            & ( P @ M ) ) )
      = ( ? [X4: nat] :
            ( ( member @ nat @ X4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X4 ) ) ) ) ).

% ex_nat_less
thf(fact_1773_all__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M: nat] :
            ( ( ord_less_eq @ nat @ M @ N2 )
           => ( P @ M ) ) )
      = ( ! [X4: nat] :
            ( ( member @ nat @ X4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X4 ) ) ) ) ).

% all_nat_less
thf(fact_1774_replicate__length__same,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( X3 = X ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X )
        = Xs ) ) ).

% replicate_length_same
thf(fact_1775_replicate__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = N2 )
     => ( ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( Y2 = X ) )
       => ( Xs
          = ( replicate @ A @ N2 @ X ) ) ) ) ).

% replicate_eqI
thf(fact_1776_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y: extended_enat,X: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z @ Y )
     => ( ( plus_plus @ extended_enat @ X @ ( minus_minus @ extended_enat @ Y @ Z ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ Z ) ) ) ).

% add_diff_assoc_enat
thf(fact_1777_in__mono,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( member @ A @ X @ A5 )
       => ( member @ A @ X @ B5 ) ) ) ).

% in_mono
thf(fact_1778_subsetD,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( member @ A @ C2 @ A5 )
       => ( member @ A @ C2 @ B5 ) ) ) ).

% subsetD
thf(fact_1779_equalityE,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( A5 = B5 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ) ).

% equalityE
thf(fact_1780_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A7 )
           => ( member @ A @ X4 @ B8 ) ) ) ) ).

% subset_eq
thf(fact_1781_equalityD1,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( A5 = B5 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ).

% equalityD1
thf(fact_1782_equalityD2,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( A5 = B5 )
     => ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ).

% equalityD2
thf(fact_1783_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A7 )
           => ( member @ A @ T3 @ B8 ) ) ) ) ).

% subset_iff
thf(fact_1784_subset__refl,axiom,
    ! [A: $tType,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ A5 @ A5 ) ).

% subset_refl
thf(fact_1785_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_1786_subset__trans,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ A5 @ C6 ) ) ) ).

% subset_trans
thf(fact_1787_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: set @ A,Z2: set @ A] : ( Y3 = Z2 ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% set_eq_subset
thf(fact_1788_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X4: A] :
            ( ( P @ X4 )
           => ( Q @ X4 ) ) ) ) ).

% Collect_mono_iff
thf(fact_1789_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
            | ( A7 = B8 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_1790_subset__psubset__trans,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( ord_less @ ( set @ A ) @ B5 @ C6 )
       => ( ord_less @ ( set @ A ) @ A5 @ C6 ) ) ) ).

% subset_psubset_trans
thf(fact_1791_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_1792_psubset__subset__trans,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
       => ( ord_less @ ( set @ A ) @ A5 @ C6 ) ) ) ).

% psubset_subset_trans
thf(fact_1793_psubset__imp__subset,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ).

% psubset_imp_subset
thf(fact_1794_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( A7 != B8 ) ) ) ) ).

% psubset_eq
thf(fact_1795_psubsetE,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B5 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ) ).

% psubsetE
thf(fact_1796_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X4: A] : ( member @ A @ X4 @ A7 )
            @ ^ [X4: A] : ( member @ A @ X4 @ B8 ) ) ) ) ).

% less_eq_set_def
thf(fact_1797_Collect__subset,axiom,
    ! [A: $tType,A5: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X4: A] :
            ( ( member @ A @ X4 @ A5 )
            & ( P @ X4 ) ) )
      @ A5 ) ).

% Collect_subset
thf(fact_1798_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_1799_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_1800_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_1801_vebt__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A4 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B4 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ Xa2 ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa2 ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) )
                       => ( ( Xa2 != Mi2 )
                         => ( ( Xa2 != Ma2 )
                           => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                              & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                               => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                  & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_1802_vebt__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( Y
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa2 ) ) ) )
         => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ Xa2 ) ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ( ~ Y
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa2 ) ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ( ~ Y
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( Y
                          = ( ( Xa2 != Mi2 )
                           => ( ( Xa2 != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_1803_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A4 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B4 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Xa2 ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa2 ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_1804_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa2 ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_1805_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( Y
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa2 ) ) ) )
         => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Xa2 ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
                 => ( ( Y
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa2 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_1806_bset_I1_J,axiom,
    ! [D5: int,B5: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B5 )
                 => ( X3
                   != ( plus_plus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B5 )
                   => ( X3
                     != ( plus_plus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X2
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
             => ( ( P @ ( minus_minus @ int @ X2 @ D5 ) )
                & ( Q @ ( minus_minus @ int @ X2 @ D5 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_1807_bset_I2_J,axiom,
    ! [D5: int,B5: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B5 )
                 => ( X3
                   != ( plus_plus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B5 )
                   => ( X3
                     != ( plus_plus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X2
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
             => ( ( P @ ( minus_minus @ int @ X2 @ D5 ) )
                | ( Q @ ( minus_minus @ int @ X2 @ D5 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_1808_aset_I1_J,axiom,
    ! [D5: int,A5: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A5 )
                 => ( X3
                   != ( minus_minus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A5 )
                   => ( X3
                     != ( minus_minus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X2 )
                & ( Q @ X2 ) )
             => ( ( P @ ( plus_plus @ int @ X2 @ D5 ) )
                & ( Q @ ( plus_plus @ int @ X2 @ D5 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_1809_aset_I2_J,axiom,
    ! [D5: int,A5: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A5 )
                 => ( X3
                   != ( minus_minus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A5 )
                   => ( X3
                     != ( minus_minus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ( P @ X2 )
                | ( Q @ X2 ) )
             => ( ( P @ ( plus_plus @ int @ X2 @ D5 ) )
                | ( Q @ ( plus_plus @ int @ X2 @ D5 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_1810_bset_I9_J,axiom,
    ! [D2: int,D5: int,B5: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B5 )
                 => ( X2
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X2 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_1811_bset_I10_J,axiom,
    ! [D2: int,D5: int,B5: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B5 )
                 => ( X2
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X2 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_1812_aset_I9_J,axiom,
    ! [D2: int,D5: int,A5: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X2
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X2 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_1813_aset_I10_J,axiom,
    ! [D2: int,D5: int,A5: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X2
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X2 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_1814_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X4: A] : ( times_times @ A @ X4 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_1815_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P @ X3 )
            = ( P @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ( ? [X6: int] : ( P @ X6 ) )
          = ( ? [X4: int] :
                ( ( member @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X4 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_1816_bset_I3_J,axiom,
    ! [D5: int,T2: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X2
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X2 = T2 )
             => ( ( minus_minus @ int @ X2 @ D5 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_1817_bset_I4_J,axiom,
    ! [D5: int,T2: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X2
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X2 != T2 )
             => ( ( minus_minus @ int @ X2 @ D5 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_1818_bset_I5_J,axiom,
    ! [D5: int,B5: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B5 )
                 => ( X2
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X2 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_1819_bset_I7_J,axiom,
    ! [D5: int,T2: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X2
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X2 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X2 @ D5 ) ) ) ) ) ) ).

% bset(7)
thf(fact_1820_aset_I3_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X2 = T2 )
             => ( ( plus_plus @ int @ X2 @ D5 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_1821_aset_I4_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( X2 != T2 )
             => ( ( plus_plus @ int @ X2 @ D5 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_1822_aset_I5_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X2 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_1823_aset_I7_J,axiom,
    ! [D5: int,A5: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X2
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X2 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X2 @ D5 ) ) ) ) ) ).

% aset(7)
thf(fact_1824_aset_I8_J,axiom,
    ! [D5: int,A5: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A5 )
                 => ( X2
                   != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X2 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X2 @ D5 ) ) ) ) ) ).

% aset(8)
thf(fact_1825_aset_I6_J,axiom,
    ! [D5: int,T2: int,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A5 )
                   => ( X2
                     != ( minus_minus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X2 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_1826_bset_I8_J,axiom,
    ! [D5: int,T2: int,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B5 )
       => ! [X2: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B5 )
                   => ( X2
                     != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X2 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X2 @ D5 ) ) ) ) ) ) ).

% bset(8)
thf(fact_1827_bset_I6_J,axiom,
    ! [D5: int,B5: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X2: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B5 )
                 => ( X2
                   != ( plus_plus @ int @ Xb2 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X2 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X2 @ D5 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_1828_cppi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,A5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ Z4 @ X3 )
           => ( ( P @ X3 )
              = ( P5 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ A5 )
                     => ( X3
                       != ( minus_minus @ int @ Xb @ Xa ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P5 @ X3 )
                = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X6: int] : ( P @ X6 ) )
              = ( ? [X4: int] :
                    ( ( member @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X4 ) )
                | ? [X4: int] :
                    ( ( member @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y4: int] :
                        ( ( member @ int @ Y4 @ A5 )
                        & ( P @ ( minus_minus @ int @ Y4 @ X4 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_1829_cpmi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,B5: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ X3 @ Z4 )
           => ( ( P @ X3 )
              = ( P5 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ B5 )
                     => ( X3
                       != ( plus_plus @ int @ Xb @ Xa ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P5 @ X3 )
                = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X6: int] : ( P @ X6 ) )
              = ( ? [X4: int] :
                    ( ( member @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X4 ) )
                | ? [X4: int] :
                    ( ( member @ int @ X4 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y4: int] :
                        ( ( member @ int @ Y4 @ B5 )
                        & ( P @ ( plus_plus @ int @ Y4 @ X4 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_1830_vebt__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A4: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A4 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A4 @ B4 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A4 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi2: nat,Ma2: nat,Va3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) )
                 => ~ ( ( Xa2 != Mi2 )
                     => ( ( Xa2 != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_1831_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) ) )
         => ( ! [Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) @ Xa2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ Xa2 ) )
                   => ( ( Xa2 = Mi2 )
                      | ( Xa2 = Ma2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) )
                     => ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa2 ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_1832_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ~ Y
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) ) ) )
         => ( ! [Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) @ Xa2 ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
                 => ( ( Y
                      = ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ Xa2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                   => ( ( Y
                        = ( ( Xa2 = Mi2 )
                          | ( Xa2 = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                     => ( ( Y
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_1833_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ Xa2 ) )
               => ~ ( ( Xa2 = Mi2 )
                    | ( Xa2 = Ma2 ) ) ) )
         => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) )
                 => ~ ( ( Xa2 = Mi2 )
                      | ( Xa2 = Ma2 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd ) @ Xa2 ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_1834_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1835_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A3: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1836_vebt__buildup_Opelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va3: nat] :
                  ( ( X
                    = ( suc @ ( suc @ Va3 ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va3 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_1837_set__decode__0,axiom,
    ! [X: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% set_decode_0
thf(fact_1838_uminus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: A > B,X4: A] : ( uminus_uminus @ B @ ( A7 @ X4 ) ) ) ) ) ).

% uminus_apply
thf(fact_1839_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A5 ) @ ( uminus_uminus @ ( set @ A ) @ B5 ) )
      = ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ).

% Compl_subset_Compl_iff
thf(fact_1840_Compl__anti__mono,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B5 ) @ ( uminus_uminus @ ( set @ A ) @ A5 ) ) ) ).

% Compl_anti_mono
thf(fact_1841_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1842_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1843_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M2: num,N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( M2 = N2 ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1844_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1845_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1846_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1847_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1848_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1849_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1850_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_1851_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_1852_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) ).

% real_add_minus_iff
thf(fact_1853_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1854_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1855_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1856_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1857_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1858_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1859_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1860_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1861_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1862_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1863_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1864_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1_right
thf(fact_1865_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1
thf(fact_1866_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1867_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1868_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_1869_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_1870_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_1871_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1872_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_1873_triangle__Suc,axiom,
    ! [N2: nat] :
      ( ( nat_triangle @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N2 ) @ ( suc @ N2 ) ) ) ).

% triangle_Suc
thf(fact_1874_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1875_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1876_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1877_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( N2 = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1878_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1879_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1880_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1881_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1882_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_1883_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_1884_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_1885_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V2: num,W2: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V2 @ W2 ) ) ) @ Y ) ) ) ).

% semiring_norm(168)
thf(fact_1886_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M2 @ N2 ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_1887_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M2 @ N2 ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_1888_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W2 ) ) @ Y ) ) ) ).

% semiring_norm(172)
thf(fact_1889_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V2 ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W2 ) ) ) @ Y ) ) ) ).

% semiring_norm(171)
thf(fact_1890_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V2: num,W2: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V2 @ W2 ) ) ) @ Y ) ) ) ).

% semiring_norm(170)
thf(fact_1891_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1892_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1893_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M2 @ N2 ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1894_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num,N2: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less_eq @ num @ N2 @ M2 ) ) ) ).

% neg_numeral_le_iff
thf(fact_1895_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num,N2: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less @ num @ N2 @ M2 ) ) ) ).

% neg_numeral_less_iff
thf(fact_1896_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) )
          = ( ( M2 != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1897_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1898_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1899_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1900_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1901_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M2 != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1902_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W2: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1903_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W2: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1904_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_1905_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1906_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1907_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1908_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1909_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1910_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1911_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_1912_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_minus_odd
thf(fact_1913_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_1914_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1915_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M2 @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1916_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_1917_set__decode__Suc,axiom,
    ! [N2: nat,X: nat] :
      ( ( member @ nat @ ( suc @ N2 ) @ ( nat_set_decode @ X ) )
      = ( member @ nat @ N2 @ ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_1918_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1919_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1920_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1921_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1922_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_1923_fun__Compl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: A > B,X4: A] : ( uminus_uminus @ B @ ( A7 @ X4 ) ) ) ) ) ).

% fun_Compl_def
thf(fact_1924_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1925_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1926_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1927_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1928_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1929_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1930_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M2: num,N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_1931_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M2: num,N2: num] :
          ( ( numeral_numeral @ A @ M2 )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_1932_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_1933_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_1934_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1935_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1936_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: A,K: A,A2: A] :
          ( ( A5
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A5 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1937_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1938_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1939_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_1940_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_1941_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_1942_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_1943_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_1944_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,A6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( modulo_modulo @ A @ A6 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A6 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_1945_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_1946_signed__take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_1947_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num,N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_1948_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num,N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_le_numeral
thf(fact_1949_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_1950_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num,N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_1951_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num,N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_less_numeral
thf(fact_1952_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1953_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1954_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1955_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1956_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1957_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1958_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1959_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1960_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1961_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1962_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W2: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1963_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1964_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1965_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1966_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ N2 )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1967_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_1968_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B5: A,K: A,B2: A,A2: A] :
          ( ( B5
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B5 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1969_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1970_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1971_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_1972_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_1973_subset__Compl__self__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ A5 ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_1974_real__minus__mult__self__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X @ X ) ) ).

% real_minus_mult_self_le
thf(fact_1975_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M2: int,N2: int] :
      ( ( ( times_times @ int @ M2 @ N2 )
        = ( one_one @ int ) )
     => ( ( M2
          = ( one_one @ int ) )
        | ( M2
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1976_zmult__eq__1__iff,axiom,
    ! [M2: int,N2: int] :
      ( ( ( times_times @ int @ M2 @ N2 )
        = ( one_one @ int ) )
      = ( ( ( M2
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) )
        | ( ( M2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1977_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X4: real,Y4: real] : ( plus_plus @ real @ X4 @ ( uminus_uminus @ real @ Y4 ) ) ) ) ).

% minus_real_def
thf(fact_1978_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_1979_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_1980_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_1981_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_1982_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1983_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1984_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1985_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1986_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1987_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1988_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1989_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M2 ) ) ) ).

% neg_one_le_numeral
thf(fact_1990_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1991_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1992_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1993_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1994_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M2 ) ) ) ).

% neg_one_less_numeral
thf(fact_1995_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1996_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1997_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1998_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1999_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_2000_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_2001_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_2002_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_2003_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_2004_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus
thf(fact_2005_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_2006_real__0__less__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_less_add_iff
thf(fact_2007_real__add__less__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_less_0_iff
thf(fact_2008_real__add__le__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_le_0_iff
thf(fact_2009_real__0__le__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_le_add_iff
thf(fact_2010_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_2011_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_2012_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_2013_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_2014_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_2015_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_2016_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_2017_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_2018_subset__decode__imp__le,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M2 ) @ ( nat_set_decode @ N2 ) )
     => ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% subset_decode_imp_le
thf(fact_2019_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_2020_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_2021_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_2022_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_2023_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_2024_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_2025_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% power2_eq_iff
thf(fact_2026_verit__less__mono__div__int2,axiom,
    ! [A5: int,B5: int,N2: int] :
      ( ( ord_less_eq @ int @ A5 @ B5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N2 ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B5 @ N2 ) @ ( divide_divide @ int @ A5 @ N2 ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_2027_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_2028_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_2029_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_2030_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_2031_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_2032_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_2033_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_2034_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_2035_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_2036_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_2037_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_power @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_2038_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N2 @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_2039_realpow__square__minus__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_2040_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_2041_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_2042_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_2043_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_2044_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q2 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q2 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_2045_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W2: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_2046_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W2: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_2047_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_2048_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% minus_power_mult_self
thf(fact_2049_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_2050_minus__1__div__exp__eq__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_2051_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_2052_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_2053_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_2054_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_2055_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2056_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2057_signed__take__bit__int__eq__self,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2058_signed__take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2059_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2060_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X4: nat] :
          ( collect @ nat
          @ ^ [N: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% set_decode_def
thf(fact_2061_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% compl_less_compl_iff
thf(fact_2062_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_2063_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2064_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( minus_minus @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% diff_shunt_var
thf(fact_2065_Sum__Icc__int,axiom,
    ! [M2: int,N2: int] :
      ( ( ord_less_eq @ int @ M2 @ N2 )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X4: int] : X4
          @ ( set_or1337092689740270186AtMost @ int @ M2 @ N2 ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N2 @ ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) @ ( times_times @ int @ M2 @ ( minus_minus @ int @ M2 @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_2066_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L2: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L2 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_2067_signed__take__bit__Suc__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2068_semiring__norm_I90_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ( bit1 @ M2 )
        = ( bit1 @ N2 ) )
      = ( M2 = N2 ) ) ).

% semiring_norm(90)
thf(fact_2069_semiring__norm_I88_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit0 @ M2 )
     != ( bit1 @ N2 ) ) ).

% semiring_norm(88)
thf(fact_2070_semiring__norm_I89_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit1 @ M2 )
     != ( bit0 @ N2 ) ) ).

% semiring_norm(89)
thf(fact_2071_semiring__norm_I84_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit1 @ N2 ) ) ).

% semiring_norm(84)
thf(fact_2072_semiring__norm_I86_J,axiom,
    ! [M2: num] :
      ( ( bit1 @ M2 )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2073_semiring__norm_I80_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
      = ( ord_less @ num @ M2 @ N2 ) ) ).

% semiring_norm(80)
thf(fact_2074_semiring__norm_I73_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M2 @ N2 ) ) ).

% semiring_norm(73)
thf(fact_2075_semiring__norm_I7_J,axiom,
    ! [M2: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M2 @ N2 ) ) ) ).

% semiring_norm(7)
thf(fact_2076_semiring__norm_I9_J,axiom,
    ! [M2: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M2 @ N2 ) ) ) ).

% semiring_norm(9)
thf(fact_2077_semiring__norm_I14_J,axiom,
    ! [M2: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ M2 @ ( bit1 @ N2 ) ) ) ) ).

% semiring_norm(14)
thf(fact_2078_semiring__norm_I15_J,axiom,
    ! [M2: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M2 ) @ N2 ) ) ) ).

% semiring_norm(15)
thf(fact_2079_semiring__norm_I81_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M2 @ N2 ) ) ).

% semiring_norm(81)
thf(fact_2080_semiring__norm_I72_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M2 @ N2 ) ) ).

% semiring_norm(72)
thf(fact_2081_semiring__norm_I77_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit1 @ N2 ) ) ).

% semiring_norm(77)
thf(fact_2082_semiring__norm_I70_J,axiom,
    ! [M2: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M2 ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2083_zdiv__numeral__Bit1,axiom,
    ! [V2: num,W2: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W2 ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_2084_semiring__norm_I3_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% semiring_norm(3)
thf(fact_2085_semiring__norm_I4_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2086_semiring__norm_I5_J,axiom,
    ! [M2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M2 ) @ one2 )
      = ( bit1 @ M2 ) ) ).

% semiring_norm(5)
thf(fact_2087_semiring__norm_I8_J,axiom,
    ! [M2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M2 ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M2 @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2088_semiring__norm_I10_J,axiom,
    ! [M2: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M2 @ N2 ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2089_semiring__norm_I16_J,axiom,
    ! [M2: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M2 @ N2 ) @ ( bit0 @ ( times_times @ num @ M2 @ N2 ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2090_semiring__norm_I79_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M2 @ N2 ) ) ).

% semiring_norm(79)
thf(fact_2091_semiring__norm_I74_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M2 @ N2 ) ) ).

% semiring_norm(74)
thf(fact_2092_div__Suc__eq__div__add3,axiom,
    ! [M2: nat,N2: nat] :
      ( ( divide_divide @ nat @ M2 @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( divide_divide @ nat @ M2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2093_Suc__div__eq__add3__div__numeral,axiom,
    ! [M2: nat,V2: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M2 ) ) ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M2 ) @ ( numeral_numeral @ nat @ V2 ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2094_mod__Suc__eq__mod__add3,axiom,
    ! [M2: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ M2 @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( modulo_modulo @ nat @ M2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2095_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M2: nat,V2: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M2 ) ) ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M2 ) @ ( numeral_numeral @ nat @ V2 ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2096_zmod__numeral__Bit1,axiom,
    ! [V2: num,W2: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V2 ) ) @ ( numeral_numeral @ int @ ( bit0 @ W2 ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ W2 ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2097_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2098_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2099_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q2: product_prod @ A @ B,F2: A > B > C,G2: A > B > C,P4: product_prod @ A @ B] :
      ( ! [X3: A,Y2: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y2 )
            = Q2 )
         => ( ( F2 @ X3 @ Y2 )
            = ( G2 @ X3 @ Y2 ) ) )
     => ( ( P4 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F2 @ P4 )
          = ( product_case_prod @ A @ B @ C @ G2 @ Q2 ) ) ) ) ).

% split_cong
thf(fact_2100_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A5: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I4: B] : ( modulo_modulo @ A @ ( F2 @ I4 ) @ A2 )
              @ A5 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ A2 ) ) ) ).

% mod_sum_eq
thf(fact_2101_xor__num_Ocases,axiom,
    ! [X: product_prod @ num @ num] :
      ( ( X
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M4: num] :
                ( X
               != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) )
           => ( ! [M4: num,N3: num] :
                  ( X
                 != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M4: num,N3: num] :
                    ( X
                   != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M4: num] :
                      ( X
                     != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) )
                 => ( ! [M4: num,N3: num] :
                        ( X
                       != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M4: num,N3: num] :
                          ( X
                         != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_2102_num_Oexhaust,axiom,
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X23: num] :
            ( Y
           != ( bit0 @ X23 ) )
       => ~ ! [X33: num] :
              ( Y
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2103_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2104_eval__nat__numeral_I3_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N2 ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2105_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_2106_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,Q2: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_2107_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_2108_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2109_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_2110_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W2: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit1 @ W2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W2 ) ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_numeral_odd
thf(fact_2111_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit1_div_2
thf(fact_2112_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ).

% odd_numeral
thf(fact_2113_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2114_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2115_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2116_Suc3__eq__add__3,axiom,
    ! [N2: nat] :
      ( ( suc @ ( suc @ ( suc @ N2 ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ).

% Suc3_eq_add_3
thf(fact_2117_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2118_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2119_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2120_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2121_Suc__div__eq__add3__div,axiom,
    ! [M2: nat,N2: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M2 ) ) ) @ N2 )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M2 ) @ N2 ) ) ).

% Suc_div_eq_add3_div
thf(fact_2122_Suc__mod__eq__add3__mod,axiom,
    ! [M2: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M2 ) @ N2 ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2123_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_le_swap2
thf(fact_2124_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_le_swap1
thf(fact_2125_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_2126_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_less_swap1
thf(fact_2127_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_less_swap2
thf(fact_2128_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L2: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L2 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L2 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_2129_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L2: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L2 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L2 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_2130_odd__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2131_mod__exhaust__less__4,axiom,
    ! [M2: nat] :
      ( ( ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2132_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M2 @ N2 ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_2133_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2134_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2135_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( ( ord_less @ num @ M2 @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M2 ) ) ) ) )
          & ( ~ ( ord_less @ num @ M2 @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M2 ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_2136_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( ( ord_less_eq @ num @ M2 @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M2 ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M2 @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M2 ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_2137_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2138_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2139_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2140_eq__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N2 ) )
      = ( ( pred_numeral @ K )
        = N2 ) ) ).

% eq_numeral_Suc
thf(fact_2141_Suc__eq__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ( suc @ N2 )
        = ( numeral_numeral @ nat @ K ) )
      = ( N2
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2142_less__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% less_numeral_Suc
thf(fact_2143_less__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2144_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2145_le__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% le_numeral_Suc
thf(fact_2146_le__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2147_diff__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2148_diff__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% diff_numeral_Suc
thf(fact_2149_max__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N2 ) ) ) ).

% max_numeral_Suc
thf(fact_2150_max__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N2 @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_2151_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2152_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M2: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_2153_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num] :
          ( ( unique8689654367752047608divmod @ A @ M2 @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M2 ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_2154_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_2155_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_2156_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2157_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M2 @ N2 ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_2158_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2159_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K3: num] : ( suc @ ( pred_numeral @ K3 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2160_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_2161_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M2: nat,I6: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M2 @ I4 ) )
            @ I6 )
          = ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I6 ) ) ) ) ).

% sum_power_add
thf(fact_2162_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M2 ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_2163_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K3: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K3 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2164_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_2165_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( plus_plus @ A @ ( G2 @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_2166_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G2 @ ( suc @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_2167_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G2 @ M2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_2168_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ M2 ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_2169_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ N2 @ P4 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P4 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_2170_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M: num,N: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% divmod_int_def
thf(fact_2171_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M: num,N: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ) ).

% divmod_def
thf(fact_2172_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M: num,N: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_2173_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X4: A] : ( minus_minus @ A @ ( plus_plus @ A @ X4 @ X4 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2174_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N2: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M2 @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
              = ( minus_minus @ A @ ( F2 @ M2 ) @ ( F2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M2 @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_2175_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M2 ) ) ) ) ) ).

% sum_telescope''
thf(fact_2176_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_2177_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M2: nat,N2: nat,X: A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_2178_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M2: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ).

% sum.in_pairs
thf(fact_2179_mask__eq__sum__exp__nat,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_2180_gauss__sum__nat,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_2181_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I4 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N2 @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_2182_Sum__Icc__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M2 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_2183_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M: num,N: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M @ N ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M ) ) @ ( unique1321980374590559556d_step @ A @ N @ ( unique8689654367752047608divmod @ A @ M @ ( bit0 @ N ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_2184_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N2 @ M2 ) ) ) ) ).

% dvd_numeral_simp
thf(fact_2185_minus__one__div__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_div_numeral
thf(fact_2186_one__div__minus__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% one_div_minus_numeral
thf(fact_2187_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M: nat,N: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M @ N ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% divmod_nat_if
thf(fact_2188_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2189_minus__numeral__div__numeral,axiom,
    ! [M2: num,N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M2 @ N2 ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_2190_numeral__div__minus__numeral,axiom,
    ! [M2: num,N2: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M2 @ N2 ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_2191_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2192_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2193_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2194_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2195_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2196_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X4: A] : ( plus_plus @ A @ ( plus_plus @ A @ X4 @ X4 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2197_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M: nat,N: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M @ N ) @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ).

% divmod_nat_def
thf(fact_2198_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A5: set @ A,N2: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 )
        = ( suc @ N2 ) )
     => ? [X3: A] :
          ( ( member @ A @ X3 @ A5 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) ).

% sum_SucD
thf(fact_2199_sum__subtractf__nat,axiom,
    ! [A: $tType,A5: set @ A,G2: A > nat,F2: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A5 )
         => ( ord_less_eq @ nat @ ( G2 @ X3 ) @ ( F2 @ X3 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X4: A] : ( minus_minus @ nat @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
          @ A5 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G2 @ A5 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_2200_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N2: nat,M2: nat,X: A] :
          ( ( ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M2 )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M2 ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_2201_divmod__BitM__2__eq,axiom,
    ! [M2: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M2 ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_2202_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_2203_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K3 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_2204_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_2205_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ M2 )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( M2 = N2 ) ) ) ).

% of_nat_eq_iff
thf(fact_2206_int__eq__iff__numeral,axiom,
    ! [M2: nat,V2: num] :
      ( ( ( semiring_1_of_nat @ int @ M2 )
        = ( numeral_numeral @ int @ V2 ) )
      = ( M2
        = ( numeral_numeral @ nat @ V2 ) ) ) ).

% int_eq_iff_numeral
thf(fact_2207_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M2: nat] :
          ( ( ( semiring_1_of_nat @ A @ M2 )
            = ( zero_zero @ A ) )
          = ( M2
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_2208_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( ( zero_zero @ nat )
            = N2 ) ) ) ).

% of_nat_0_eq_iff
thf(fact_2209_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_2210_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% of_nat_less_iff
thf(fact_2211_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ).

% of_nat_le_iff
thf(fact_2212_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% of_nat_numeral
thf(fact_2213_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M2 @ N2 ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_add
thf(fact_2214_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M2 @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mult
thf(fact_2215_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2216_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2217_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2218_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W2: int,Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ W2 @ Z ) ) ) ).

% of_int_le_iff
thf(fact_2219_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_2220_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int,N2: num] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( numeral_numeral @ A @ N2 ) )
          = ( Z
            = ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_2221_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W2: int,Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ W2 @ Z ) ) ) ).

% of_int_less_iff
thf(fact_2222_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_2223_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( one_one @ A ) )
          = ( Z
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_2224_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M2 @ N2 ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M2 ) @ N2 ) ) ) ).

% of_nat_power
thf(fact_2225_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W2: nat,X: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 )
            = ( semiring_1_of_nat @ A @ X ) )
          = ( ( power_power @ nat @ B2 @ W2 )
            = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_2226_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: nat,B2: nat,W2: nat] :
          ( ( ( semiring_1_of_nat @ A @ X )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) )
          = ( X
            = ( power_power @ nat @ B2 @ W2 ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_2227_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W2 @ Z ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_mult
thf(fact_2228_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W2 @ Z ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W2 ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_add
thf(fact_2229_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int,N2: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z @ N2 ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z ) @ N2 ) ) ) ).

% of_int_power
thf(fact_2230_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W2: nat,X: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 )
            = ( ring_1_of_int @ A @ X ) )
          = ( ( power_power @ int @ B2 @ W2 )
            = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_2231_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: int,B2: int,W2: nat] :
          ( ( ( ring_1_of_int @ A @ X )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) )
          = ( X
            = ( power_power @ int @ B2 @ W2 ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_2232_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_2233_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_2234_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( zero_zero @ A ) )
          = ( M2
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_2235_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M2: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M2 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M2 ) ) ) ) ).

% of_nat_Suc
thf(fact_2236_real__of__nat__less__numeral__iff,axiom,
    ! [N2: nat,W2: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( numeral_numeral @ real @ W2 ) )
      = ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ W2 ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2237_numeral__less__real__of__nat__iff,axiom,
    ! [W2: num,N2: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W2 ) @ ( semiring_1_of_nat @ real @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W2 ) @ N2 ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2238_numeral__le__real__of__nat__iff,axiom,
    ! [N2: num,M2: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N2 ) @ ( semiring_1_of_nat @ real @ M2 ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N2 ) @ M2 ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2239_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_2240_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% of_nat_0_less_iff
thf(fact_2241_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_le_iff
thf(fact_2242_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_2243_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_2244_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_less_iff
thf(fact_2245_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ B2 @ W2 ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_2246_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W2: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W2 ) @ X ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_2247_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ B2 @ W2 ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_2248_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W2: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W2 ) @ X ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_2249_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N2 ) @ Z ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2250_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N2: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ int @ Z @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2251_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: num,N2: nat,Y: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 )
            = ( semiring_1_of_nat @ A @ Y ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 )
            = Y ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2252_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y: nat,X: num,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( Y
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2253_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N2 ) @ Z ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2254_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N2: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ int @ Z @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2255_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_le_iff
thf(fact_2256_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_2257_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_less_iff
thf(fact_2258_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_2259_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) )
          = ( ord_less_eq @ int @ X @ ( power_power @ int @ B2 @ W2 ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_2260_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W2: nat,X: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W2 ) @ X ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_2261_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N2: nat,Y: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 )
            = Y ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2262_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( Y
            = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2263_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) )
          = ( ord_less @ int @ X @ ( power_power @ int @ B2 @ W2 ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_2264_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W2: nat,X: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W2 ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W2 ) @ X ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_2265_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X ) @ N2 ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_2266_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_of_nat
thf(fact_2267_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2268_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N2: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) @ X ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2269_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2270_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N2: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N2 ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N2 ) @ X ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2271_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2272_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2273_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2274_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2275_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) )
          = ( Y
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2276_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N2: nat,Y: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 )
            = Y ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2277_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2278_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2279_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2280_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2281_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,X: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N2 ) @ X ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_2282_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_2283_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2284_of__int__max,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y: int] :
          ( ( ring_1_of_int @ A @ ( ord_max @ int @ X @ Y ) )
          = ( ord_max @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y ) ) ) ) ).

% of_int_max
thf(fact_2285_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_2286_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% of_nat_0_le_iff
thf(fact_2287_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_2288_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N2 ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2289_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% div_mult2_eq'
thf(fact_2290_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) )
         => ( ord_less @ nat @ M2 @ N2 ) ) ) ).

% of_nat_less_imp_less
thf(fact_2291_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less @ nat @ M2 @ N2 )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_2292_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I2: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_2293_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M2 @ N2 ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_2294_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ M2 @ N2 ) ) ) ).

% of_nat_dvd_iff
thf(fact_2295_int__ops_I3_J,axiom,
    ! [N2: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ int @ N2 ) ) ).

% int_ops(3)
thf(fact_2296_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_2297_zle__int,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( semiring_1_of_nat @ int @ N2 ) )
      = ( ord_less_eq @ nat @ M2 @ N2 ) ) ).

% zle_int
thf(fact_2298_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_2299_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M2 @ N2 ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mod
thf(fact_2300_zadd__int__left,axiom,
    ! [M2: nat,N2: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M2 ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M2 @ N2 ) ) @ Z ) ) ).

% zadd_int_left
thf(fact_2301_int__plus,axiom,
    ! [N2: nat,M2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N2 @ M2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( semiring_1_of_nat @ int @ M2 ) ) ) ).

% int_plus
thf(fact_2302_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_2303_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_2304_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_2305_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_2306_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X @ Y ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_max
thf(fact_2307_semiring__norm_I28_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ N2 ) ) ) ).

% semiring_norm(28)
thf(fact_2308_semiring__norm_I27_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit0 @ N2 ) )
      = ( bit1 @ ( bitM @ N2 ) ) ) ).

% semiring_norm(27)
thf(fact_2309_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_less_as_int
thf(fact_2310_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_leq_as_int
thf(fact_2311_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N2: nat,M2: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M2 )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M2 @ N2 ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% of_nat_diff
thf(fact_2312_reals__Archimedean3,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ! [Y5: real] :
        ? [N3: nat] : ( ord_less @ real @ Y5 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X ) ) ) ).

% reals_Archimedean3
thf(fact_2313_real__of__int__div4,axiom,
    ! [N2: int,X: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X ) ) ) ).

% real_of_int_div4
thf(fact_2314_int__cases4,axiom,
    ! [M2: int] :
      ( ! [N3: nat] :
          ( M2
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M2
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_2315_real__of__nat__div4,axiom,
    ! [N2: nat,X: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X ) ) ) ).

% real_of_nat_div4
thf(fact_2316_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2317_int__Suc,axiom,
    ! [N2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2318_real__of__int__div,axiom,
    ! [D2: int,N2: int] :
      ( ( dvd_dvd @ int @ D2 @ N2 )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_2319_real__of__nat__div,axiom,
    ! [D2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N2 )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_2320_eval__nat__numeral_I2_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N2 ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_2321_BitM__plus__one,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ ( bitM @ N2 ) @ one2 )
      = ( bit0 @ N2 ) ) ).

% BitM_plus_one
thf(fact_2322_one__plus__BitM,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% one_plus_BitM
thf(fact_2323_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_nonneg
thf(fact_2324_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_pos
thf(fact_2325_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M2 ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2326_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_2327_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N: int,M: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_2328_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M2 @ N2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M2 @ N2 ) ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2329_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N: int,M: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M ) ) ) ) ).

% int_less_real_le
thf(fact_2330_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_2331_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_2332_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_2333_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N: nat,M: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% nat_less_real_le
thf(fact_2334_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N: nat,M: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_2335_zmult__zless__mono2__lemma,axiom,
    ! [I2: int,J: int,K: nat] :
      ( ( ord_less @ int @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I2 ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_2336_real__of__int__div__aux,axiom,
    ! [X: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_2337_real__of__nat__div__aux,axiom,
    ! [X: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2338_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N2 ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_2339_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W2: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W2 ) ) ) ) ).

% odd_numeral_BitM
thf(fact_2340_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% of_nat_less_two_power
thf(fact_2341_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: nat,M2: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M2 )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_2342_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M4 ) @ X ) @ C2 ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_2343_real__of__int__div2,axiom,
    ! [N2: int,X: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X ) ) ) ) ).

% real_of_int_div2
thf(fact_2344_real__of__int__div3,axiom,
    ! [N2: int,X: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_2345_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_2346_zdiff__int__split,axiom,
    ! [P: int > $o,X: nat,Y: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X @ Y ) ) )
      = ( ( ( ord_less_eq @ nat @ Y @ X )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X ) @ ( semiring_1_of_nat @ int @ Y ) ) ) )
        & ( ( ord_less @ nat @ X @ Y )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_2347_real__of__nat__div2,axiom,
    ! [N2: nat,X: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X ) ) ) ) ).

% real_of_nat_div2
thf(fact_2348_real__of__nat__div3,axiom,
    ! [N2: nat,X: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_2349_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_2350_Bernoulli__inequality,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N2 ) ) ) ).

% Bernoulli_inequality
thf(fact_2351_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G2 @ I3 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ K5 ) ) ) ) ).

% sum_mono
thf(fact_2352_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A5: set @ A,G2: C > B,B5: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G2 @ B5 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J3: C] : ( times_times @ B @ ( F2 @ I4 ) @ ( G2 @ J3 ) )
                @ B5 )
            @ A5 ) ) ) ).

% sum_product
thf(fact_2353_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A5: set @ B,R: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( times_times @ A @ ( F2 @ N ) @ R )
            @ A5 ) ) ) ).

% sum_distrib_right
thf(fact_2354_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R: A,F2: B > A,A5: set @ B] :
          ( ( times_times @ A @ R @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( times_times @ A @ R @ ( F2 @ N ) )
            @ A5 ) ) ) ).

% sum_distrib_left
thf(fact_2355_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: B > A,H2: B > A,A5: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X4: B] : ( plus_plus @ A @ ( G2 @ X4 ) @ ( H2 @ X4 ) )
            @ A5 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ A5 ) ) ) ) ).

% sum.distrib
thf(fact_2356_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A5: set @ B,R: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N: B] : ( divide_divide @ A @ ( F2 @ N ) @ R )
            @ A5 ) ) ) ).

% sum_divide_distrib
thf(fact_2357_Bernoulli__inequality__even,axiom,
    ! [N2: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N2 ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2358_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_2359_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_2360_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_2361_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_2362_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_2363_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M2: nat,N2: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ M2 @ N2 ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ M2 @ N2 ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_2364_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A5 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) ) ) ) ).

% sum_nonneg
thf(fact_2365_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_2366_linear__plus__1__le__power,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) @ N2 ) ) ) ).

% linear_plus_1_le_power
thf(fact_2367_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E ) ) ) ).

% nat_approx_posE
thf(fact_2368_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X3 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) ) )
          & ! [Y5: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y5 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y5 @ ( one_one @ int ) ) ) ) )
             => ( Y5 = X3 ) ) ) ) ).

% floor_exists1
thf(fact_2369_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z3 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_2370_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2371_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less_eq @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% real_arch_simple
thf(fact_2372_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_2373_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_le_of_int
thf(fact_2374_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_less_of_int
thf(fact_2375_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z3 ) @ X ) ) ).

% ex_of_int_less
thf(fact_2376_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y ) ) ) ) ).

% round_unique
thf(fact_2377_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H2: A,Z: A,K5: real,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z @ H2 ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2378_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N2 ) ) ) ) ).

% pochhammer_double
thf(fact_2379_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I4: A] : ( plus_plus @ A @ I4 @ ( one_one @ A ) )
              @ N
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_2380_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ int ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( zero_zero @ int ) )
              @ K3
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_2381_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_2382_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_2383_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_2384_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_2385_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_2386_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_2387_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% pochhammer_1
thf(fact_2388_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_2389_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_2390_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2391_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_2392_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_2393_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ int @ N2 ) ) ) ).

% round_numeral
thf(fact_2394_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_2395_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_2396_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(2)
thf(fact_2397_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% or_numerals(3)
thf(fact_2398_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_2399_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(1)
thf(fact_2400_or__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_2401_or__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_2402_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% round_neg_numeral
thf(fact_2403_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_2404_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_2405_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_2406_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M2 @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_or_eq
thf(fact_2407_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_or_eq
thf(fact_2408_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_2409_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A3: A,B3: A] : ( bit_se1065995026697491101ons_or @ A @ B3 @ A3 ) ) ) ) ).

% or.commute
thf(fact_2410_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_2411_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( zero_zero @ A ) )
          = X ) ) ).

% bit.disj_zero_right
thf(fact_2412_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_2413_OR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) ) ) ) ).

% OR_lower
thf(fact_2414_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_2415_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N2 ) ) ) ) ).

% pochhammer_pos
thf(fact_2416_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat,M2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_2417_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M2 )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_2418_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_round @ A @ Y ) ) ) ) ).

% round_mono
thf(fact_2419_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N2 ) ) ) ) ).

% pochhammer_nonneg
thf(fact_2420_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N2: nat,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N2 ) @ I2 )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N2 @ ( Inc @ I2 ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_2421_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I2 )
          = I2 ) ) ).

% of_nat_aux.simps(1)
thf(fact_2422_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2423_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_2424_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% pochhammer_rec
thf(fact_2425_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N2 ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2426_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) ) ) ) ).

% pochhammer_rec'
thf(fact_2427_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,K: nat] :
          ( ( ord_less @ nat @ N2 @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_2428_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N2: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N2 @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_2429_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ? [K3: nat] :
                ( ( ord_less @ nat @ K3 @ N2 )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K3 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_2430_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_2431_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N2: nat,M2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( plus_plus @ nat @ N2 @ M2 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N2 ) ) @ M2 ) ) ) ) ).

% pochhammer_product'
thf(fact_2432_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M2: nat,N2: nat,Z: A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ Z @ N2 )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ M2 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_2433_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R ) @ K ) )
          = ( times_times @ A @ R @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_2434_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_2435_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_2436_OR__upper,axiom,
    ! [X: int,N2: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% OR_upper
thf(fact_2437_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_2438_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_2439_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_2440_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2441_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_2442_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W2 ) ) ) ) ).

% norm_divide_numeral
thf(fact_2443_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W2: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W2 ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2444_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W2 ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W2 ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2445_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( numeral_numeral @ real @ W2 ) ) ) ).

% norm_neg_numeral
thf(fact_2446_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W2 ) )
          = ( numeral_numeral @ real @ W2 ) ) ) ).

% norm_numeral
thf(fact_2447_norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( one_one @ A ) )
        = ( one_one @ real ) ) ) ).

% norm_one
thf(fact_2448_or__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(4)
thf(fact_2449_or__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(2)
thf(fact_2450_or__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(3)
thf(fact_2451_or__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(1)
thf(fact_2452_Suc__0__or__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_or_eq
thf(fact_2453_or__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% or_Suc_0_eq
thf(fact_2454_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_2455_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M: nat,N: nat] :
          ( if @ nat
          @ ( M
            = ( zero_zero @ nat ) )
          @ N
          @ ( if @ nat
            @ ( N
              = ( zero_zero @ nat ) )
            @ M
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_2456_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult
thf(fact_2457_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_2458_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,N2: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N2 ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N2 ) ) ) ).

% norm_power
thf(fact_2459_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ Y ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% norm_uminus_minus
thf(fact_2460_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2461_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W2: A,N2: nat,Z: A] :
          ( ( ( power_power @ A @ W2 @ N2 )
            = ( power_power @ A @ Z @ N2 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( real_V7770717601297561774m_norm @ A @ W2 )
              = ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2462_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,R: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ R @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_2463_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult_ineq
thf(fact_2464_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_lt
thf(fact_2465_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,R: real,Y: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_2466_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2467_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2468_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E ) ) ) ).

% norm_triangle_le
thf(fact_2469_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2470_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A,N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N2 ) ) ) ).

% norm_power_ineq
thf(fact_2471_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2472_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W2: A,N2: nat] :
          ( ( ( power_power @ A @ W2 @ N2 )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W2 )
              = ( one_one @ real ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2473_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2474_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2475_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A,W2: A,M2: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W2 ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z @ M2 ) @ ( power_power @ A @ W2 @ M2 ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M2 ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z @ W2 ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2476_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_2477_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N2: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_2478_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H2: A,Z: A,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H2
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P6: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ Q4 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ P6 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_2479_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N: nat] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_2480_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_2481_or__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_2482_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I2 @ K ) ) ) ).

% lessThan_iff
thf(fact_2483_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu3: B] : ( one_one @ A )
            @ A5 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_2484_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X ) @ ( set_ord_lessThan @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% lessThan_subset_iff
thf(fact_2485_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_2486_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_2487_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_2488_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) )
            @ X )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X ) ) ) ).

% powser_sums_zero_iff
thf(fact_2489_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M2: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_2490_or__minus__numerals_I4_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M2 @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_2491_or__minus__numerals_I8_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M2 ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M2 @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_2492_or__minus__numerals_I3_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_2493_or__minus__numerals_I7_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M2 ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_2494_or__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_2495_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A5 )
             => ( ( G2 @ X3 )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_2496_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: B > A,A5: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
           != ( one_one @ A ) )
         => ~ ! [A4: B] :
                ( ( member @ B @ A4 @ A5 )
               => ( ( G2 @ A4 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_2497_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: B > A,H2: B > A,A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : ( times_times @ A @ ( G2 @ X4 ) @ ( H2 @ X4 ) )
            @ A5 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A5 ) ) ) ) ).

% prod.distrib
thf(fact_2498_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G2: B > A,A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
            @ A5 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ).

% prod_dividef
thf(fact_2499_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A5: set @ A,N2: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A5 ) @ N2 )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 )
            @ A5 ) ) ) ).

% prod_power_distrib
thf(fact_2500_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A5: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I4: B] : ( modulo_modulo @ A @ ( F2 @ I4 ) @ A2 )
              @ A5 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ A2 ) ) ) ).

% mod_prod_eq
thf(fact_2501_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_2502_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X4: A] : ( ord_less @ A @ X4 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_2503_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_2504_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A,G2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G2 @ I3 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ).

% prod_mono
thf(fact_2505_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A5 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_nonneg
thf(fact_2506_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A5 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_pos
thf(fact_2507_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A5 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ).

% prod_ge_1
thf(fact_2508_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A3: nat] : ( times_times @ A @ ( F2 @ A3 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_2509_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M2: A,N2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M2 ) @ ( set_ord_lessThan @ A @ N2 ) )
          = ( ord_less @ A @ M2 @ N2 ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_2510_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A5: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A5 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A3: B] : ( power_power @ A @ C2 @ ( F2 @ A3 ) )
            @ A5 ) ) ) ).

% power_sum
thf(fact_2511_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_2512_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_2513_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit1 @ M2 ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N2 @ M2 ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_2514_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_2515_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M2: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M2 ) )
      = ( bit1 @ M2 ) ) ).

% or_not_num_neg.simps(3)
thf(fact_2516_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) )
                & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_2517_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit0 @ M2 ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M2 ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_2518_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit1 @ M2 ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M2 ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_2519_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat,M2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M2 ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_2520_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N2: A] :
          ( ! [X3: A] : ( ord_less_eq @ nat @ ( Q @ X3 ) @ ( P @ X3 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N2 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N2 ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X4: A] : ( minus_minus @ nat @ ( P @ X4 ) @ ( Q @ X4 ) )
              @ ( set_ord_lessThan @ A @ N2 ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_2521_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M2: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M2 ) )
      = ( bit1 @ M2 ) ) ).

% or_not_num_neg.simps(2)
thf(fact_2522_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_2523_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_2524_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( times_times @ A @ ( G2 @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_2525_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G2 @ ( suc @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_2526_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit0 @ M2 ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M2 ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_2527_norm__prod__diff,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I6: set @ I7,Z: I7 > A,W2: I7 > A] :
          ( ! [I3: I7] :
              ( ( member @ I7 @ I3 @ I6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z @ I3 ) ) @ ( one_one @ real ) ) )
         => ( ! [I3: I7] :
                ( ( member @ I7 @ I3 @ I6 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W2 @ I3 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I7 @ A @ Z @ I6 ) @ ( groups7121269368397514597t_prod @ I7 @ A @ W2 @ I6 ) ) )
              @ ( groups7311177749621191930dd_sum @ I7 @ real
                @ ^ [I4: I7] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z @ I4 ) @ ( W2 @ I4 ) ) )
                @ I6 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_2528_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G2 @ M2 )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_2529_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_2530_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N2: nat,R: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ R ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ R )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_2531_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ ( plus_plus @ nat @ N2 @ P4 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P4 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_2532_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F3: nat > A > A,A3: nat,B3: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B3 @ A3 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F3 @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B3 @ ( F3 @ A3 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_2533_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa2: nat,Xb3: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa2 @ Xb3 @ Xc )
        = Y )
     => ( ( ( ord_less @ nat @ Xb3 @ Xa2 )
         => ( Y = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb3 @ Xa2 )
         => ( Y
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa2 @ ( one_one @ nat ) ) @ Xb3 @ ( X @ Xa2 @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_2534_or__not__num__neg_Oelims,axiom,
    ! [X: num,Xa2: num,Y: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y != one2 ) ) )
       => ( ( ( X = one2 )
           => ! [M4: num] :
                ( ( Xa2
                  = ( bit0 @ M4 ) )
               => ( Y
                 != ( bit1 @ M4 ) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa2
                    = ( bit1 @ M4 ) )
                 => ( Y
                   != ( bit1 @ M4 ) ) ) )
           => ( ( ? [N3: num] :
                    ( X
                    = ( bit0 @ N3 ) )
               => ( ( Xa2 = one2 )
                 => ( Y
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ! [M4: num] :
                        ( ( Xa2
                          = ( bit0 @ M4 ) )
                       => ( Y
                         != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa2
                            = ( bit1 @ M4 ) )
                         => ( Y
                           != ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                 => ( ( ? [N3: num] :
                          ( X
                          = ( bit1 @ N3 ) )
                     => ( ( Xa2 = one2 )
                       => ( Y != one2 ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ! [M4: num] :
                              ( ( Xa2
                                = ( bit0 @ M4 ) )
                             => ( Y
                               != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                     => ~ ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa2
                                  = ( bit1 @ M4 ) )
                               => ( Y
                                 != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_2535_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_2536_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N2 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_2537_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N2: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_2538_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_2539_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_2540_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z: A,H2: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M2 @ P6 ) ) @ ( power_power @ A @ Z @ P6 ) ) @ ( power_power @ A @ Z @ M2 ) )
            @ ( set_ord_lessThan @ nat @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ Z @ P6 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M2 @ P6 ) ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ M2 @ P6 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M2 ) ) ) ) ).

% lemma_termdiff1
thf(fact_2541_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N2 @ ( suc @ I4 ) ) ) @ ( power_power @ A @ X @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_2542_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N2 ) ) @ ( power_power @ A @ Y @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ X @ P6 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N2 @ P6 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_2543_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_2544_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,F2: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N2 )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_2545_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M2: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ).

% prod.in_pairs
thf(fact_2546_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A3: nat] : ( plus_plus @ A @ ( F2 @ A3 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_2547_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_2548_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ I4 ) ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_2549_sums__if_H,axiom,
    ! [G2: nat > real,X: real] :
      ( ( sums @ real @ G2 @ X )
     => ( sums @ real
        @ ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ real ) @ ( G2 @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X ) ) ).

% sums_if'
thf(fact_2550_sums__if,axiom,
    ! [G2: nat > real,X: real,F2: nat > real,Y: real] :
      ( ( sums @ real @ G2 @ X )
     => ( ( sums @ real @ F2 @ Y )
       => ( sums @ real
          @ ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( F2 @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G2 @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sums_if
thf(fact_2551_sum__split__even__odd,axiom,
    ! [F2: nat > real,G2: nat > real,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I4: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( F2 @ I4 ) @ ( G2 @ I4 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( G2 @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum_split_even_odd
thf(fact_2552_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_2553_power__half__series,axiom,
    ( sums @ real
    @ ^ [N: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_2554_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( F2 @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_2555_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S: A] :
          ( ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
          = ( sums @ A @ F2 @ S ) ) ) ).

% sums_iff_shift'
thf(fact_2556_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A,N2: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_2557_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S: A] :
          ( ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_2558_prod__int__plus__eq,axiom,
    ! [I2: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I2 @ ( plus_plus @ nat @ I2 @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X4: int] : X4
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I2 ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I2 @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_2559_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G2: nat > A,S: A,T2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G2 @ N3 ) )
         => ( ( sums @ A @ F2 @ S )
           => ( ( sums @ A @ G2 @ T2 )
             => ( ord_less_eq @ A @ S @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_2560_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_2561_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_2562_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,A2: A,G2: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G2 @ B2 )
           => ( sums @ A
              @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G2 @ N ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_2563_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 )
            @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_2564_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_2565_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_2566_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_2567_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_2568_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N: nat] : ( F2 @ ( suc @ N ) )
            @ L )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_2569_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N2: nat,F2: nat > A,S: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ N2 )
             => ( ( F2 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
              @ S )
            = ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_2570_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M2: nat,Z: A] :
          ( sums @ A
          @ ^ [N: nat] : ( times_times @ A @ ( if @ A @ ( N = M2 ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z @ N ) )
          @ ( power_power @ A @ Z @ M2 ) ) ) ).

% powser_sums_if
thf(fact_2571_sumr__cos__zero__one,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M: nat] : ( times_times @ real @ ( cos_coeff @ M ) @ ( power_power @ real @ ( zero_zero @ real ) @ M ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_2572_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ R @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R @ ( suc @ M2 ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_2573_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2574_central__binomial__lower__bound,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_2575_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X4 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X4 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_2576_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_double
thf(fact_2577_binomial__n__n,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ N2 )
      = ( one_one @ nat ) ) ).

% binomial_n_n
thf(fact_2578_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% gbinomial_1
thf(fact_2579_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_2580_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_2581_binomial__eq__0__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N2 @ K ) ) ).

% binomial_eq_0_iff
thf(fact_2582_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_2583_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_2584_binomial__Suc__Suc,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_2585_binomial__n__0,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_2586_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2587_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_2588_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_Suc
thf(fact_2589_zero__less__binomial__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) )
      = ( ord_less_eq @ nat @ K @ N2 ) ) ).

% zero_less_binomial_iff
thf(fact_2590_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_2591_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_iff
thf(fact_2592_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_2593_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_2594_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_2595_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_iff
thf(fact_2596_fact__ge__self,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_self
thf(fact_2597_fact__mono__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M2 ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% fact_mono_nat
thf(fact_2598_choose__one,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( one_one @ nat ) )
      = N2 ) ).

% choose_one
thf(fact_2599_binomial__fact__lemma,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( binomial @ N2 @ K ) )
        = ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% binomial_fact_lemma
thf(fact_2600_binomial__altdef__nat,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_2601_binomial__eq__0,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ N2 @ K )
     => ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_2602_Suc__times__binomial__eq,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_2603_Suc__times__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) ) ).

% Suc_times_binomial
thf(fact_2604_fact__less__mono__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( ord_less @ nat @ M2 @ N2 )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M2 ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% fact_less_mono_nat
thf(fact_2605_binomial__symmetric,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_2606_choose__mult__lemma,axiom,
    ! [M2: nat,R: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M2 @ R ) @ K ) @ ( plus_plus @ nat @ M2 @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M2 @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M2 @ R ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M2 @ R ) @ M2 ) ) ) ).

% choose_mult_lemma
thf(fact_2607_binomial__le__pow,axiom,
    ! [R: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R @ N2 )
     => ( ord_less_eq @ nat @ ( binomial @ N2 @ R ) @ ( power_power @ nat @ N2 @ R ) ) ) ).

% binomial_le_pow
thf(fact_2608_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_zero
thf(fact_2609_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_2610_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_gt_zero
thf(fact_2611_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_1
thf(fact_2612_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M2 ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_mono
thf(fact_2613_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,M2: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M2 )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M2 ) ) ) ) ).

% fact_dvd
thf(fact_2614_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_2615_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2616_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2617_zero__less__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) ) ) ).

% zero_less_binomial
thf(fact_2618_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_2619_ln__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_2620_ln__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_gt_zero
thf(fact_2621_ln__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_ge_zero
thf(fact_2622_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_2623_fact__ge__Suc__0__nat,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_Suc_0_nat
thf(fact_2624_choose__mult,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M2 )
     => ( ( ord_less_eq @ nat @ M2 @ N2 )
       => ( ( times_times @ nat @ ( binomial @ N2 @ M2 ) @ ( binomial @ M2 @ K ) )
          = ( times_times @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ ( minus_minus @ nat @ N2 @ K ) @ ( minus_minus @ nat @ M2 @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_2625_binomial__Suc__Suc__eq__times,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_2626_binomial__absorb__comp,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N2 @ K ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_2627_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A3 ) @ K3 ) ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_2628_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K3 ) ) @ ( one_one @ A ) ) @ K3 ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_2629_dvd__fact,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M2 )
     => ( ( ord_less_eq @ nat @ M2 @ N2 )
       => ( dvd_dvd @ nat @ M2 @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% dvd_fact
thf(fact_2630_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_2631_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
         => ( ( ord_less @ nat @ M2 @ N2 )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M2 ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ) ).

% fact_less_mono
thf(fact_2632_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_2633_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N2 ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_2634_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_2635_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N2 @ N2 ) ) ) ) ).

% fact_le_power
thf(fact_2636_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X4: nat] : X4
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) ) ) ) ).

% fact_prod
thf(fact_2637_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_2638_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_2639_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self
thf(fact_2640_ln__mult,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( times_times @ real @ X @ Y ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_mult
thf(fact_2641_binomial__absorption,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_2642_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( minus_minus @ real @ X @ ( one_one @ real ) ) )
       => ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_2643_ln__div,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X @ Y ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_div
thf(fact_2644_fact__diff__Suc,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ M2 ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M2 ) @ N2 ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M2 ) @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M2 @ N2 ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_2645_fact__div__fact__le__pow,axiom,
    ! [R: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ R ) ) ) @ ( power_power @ nat @ N2 @ R ) ) ) ).

% fact_div_fact_le_pow
thf(fact_2646_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_2647_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_2648_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_2649_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_2650_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_2651_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% choose_dvd
thf(fact_2652_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2653_fact__eq__fact__times,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ( semiring_char_0_fact @ nat @ M2 )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N2 )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X4: nat] : X4
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M2 ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_2654_binomial__code,axiom,
    ( binomial
    = ( ^ [N: nat,K3: nat] : ( if @ nat @ ( ord_less @ nat @ N @ K3 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( binomial @ N @ ( minus_minus @ nat @ N @ K3 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N @ K3 ) @ ( one_one @ nat ) ) @ N @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K3 ) ) ) ) ) ) ).

% binomial_code
thf(fact_2655_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_2656_binomial__maximum_H,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% binomial_maximum'
thf(fact_2657_binomial__mono,axiom,
    ! [K: nat,K6: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K6 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K6 ) @ N2 )
       => ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K6 ) ) ) ) ).

% binomial_mono
thf(fact_2658_binomial__antimono,axiom,
    ! [K: nat,K6: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K6 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K6 @ N2 )
         => ( ord_less_eq @ nat @ ( binomial @ N2 @ K6 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_2659_binomial__maximum,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_2660_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2661_binomial__le__pow2,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% binomial_le_pow2
thf(fact_2662_choose__reduce__nat,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N2 @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_2663_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L2: nat] : ( times_times @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ L2 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_2664_times__binomial__minus1__eq,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N2 @ K ) )
        = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_2665_ln__le__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( minus_minus @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_2666_ln__diff__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X @ Y ) @ Y ) ) ) ) ).

% ln_diff_le
thf(fact_2667_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self2
thf(fact_2668_ln__realpow,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( power_power @ real @ X @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_realpow
thf(fact_2669_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_2670_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_2671_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M2 )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M2 ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M2 ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M2 @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_2672_fact__div__fact,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M2 ) @ ( semiring_char_0_fact @ nat @ N2 ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X4: nat] : X4
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M2 ) ) ) ) ).

% fact_div_fact
thf(fact_2673_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_2674_binomial__strict__antimono,axiom,
    ! [K: nat,K6: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K6 )
     => ( ( ord_less_eq @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K6 @ N2 )
         => ( ord_less @ nat @ ( binomial @ N2 @ K6 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_2675_binomial__strict__mono,axiom,
    ! [K: nat,K6: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K6 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K6 ) @ N2 )
       => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K6 ) ) ) ) ).

% binomial_strict_mono
thf(fact_2676_central__binomial__odd,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_2677_binomial__addition__formula,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_2678_square__fact__le__2__fact,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% square_fact_le_2_fact
thf(fact_2679_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) @ ( uminus_uminus @ real @ X ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2680_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_2681_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_2682_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_2683_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A3 ) @ ( one_one @ A ) ) @ K3 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_2684_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% gbinomial_index_swap
thf(fact_2685_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M: nat] :
              ( if @ A
              @ ( M
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_2686_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_2687_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_2688_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% pochhammer_same
thf(fact_2689_choose__two,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_2690_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_2691_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_2692_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: real,N2: nat,Diff: nat > A > real] :
          ( ( X
            = ( zero_zero @ real ) )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ X @ M ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_2693_Maclaurin__lemma,axiom,
    ! [H2: real,F2: real > real,J: nat > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ? [B9: real] :
          ( ( F2 @ H2 )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ H2 @ M ) )
              @ ( set_ord_lessThan @ nat @ N2 ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H2 @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_2694_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2695_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_2696_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_2697_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ).

% sin_coeff_def
thf(fact_2698_ln__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X )
          = ( suminf @ real
            @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ ( one_one @ real ) ) @ ( suc @ N ) ) ) ) ) ) ) ).

% ln_series
thf(fact_2699_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2700_tanh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( tanh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2701_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M2 @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_2702_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_even_sum
thf(fact_2703_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_numeral
thf(fact_2704_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_2705_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_2706_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_2707_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_2708_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I2 @ K ) ) ) ).

% atMost_iff
thf(fact_2709_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% abs_of_nat
thf(fact_2710_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_2711_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_2712_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2713_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2714_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_neg_numeral
thf(fact_2715_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2716_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% abs_power_minus
thf(fact_2717_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X ) @ ( set_ord_atMost @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% atMost_subset_iff
thf(fact_2718_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A5: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A5 ) ) ) ).

% sum_abs
thf(fact_2719_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_2720_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_2721_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2722_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ H2 @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_2723_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_2724_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G2 @ ( suc @ N2 ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_2725_artanh__minus__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X ) ) ) ) ).

% artanh_minus_real
thf(fact_2726_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A5: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A5 ) ) ) ).

% sum_abs_ge_zero
thf(fact_2727_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_2728_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_2729_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_2730_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_2731_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W2: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W2 ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W2 ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W2 ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_2732_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_2733_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_2734_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_2735_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_2736_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% power_abs
thf(fact_2737_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X4: A] : ( ord_less_eq @ A @ X4 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_2738_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_2739_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_2740_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_2741_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_2742_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_2743_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_2744_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_2745_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_2746_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_2747_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_2748_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_2749_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_2750_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_2751_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_2752_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Iic_le_Icc
thf(fact_2753_tanh__real__lt__1,axiom,
    ! [X: real] : ( ord_less @ real @ ( tanh @ real @ X ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_2754_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E2 ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_2755_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_2756_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_2757_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_2758_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_2759_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_2760_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X ) @ Y )
            = ( abs_abs @ A @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% abs_div_pos
thf(fact_2761_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% zero_le_power_abs
thf(fact_2762_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A3: A] : ( if @ A @ ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A3 ) @ A3 ) ) ) ) ).

% abs_if_raw
thf(fact_2763_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_2764_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A3: A] : ( if @ A @ ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A3 ) @ A3 ) ) ) ) ).

% abs_if
thf(fact_2765_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_2766_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_2767_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less_eq @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_2768_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_2769_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A3: real] : ( if @ real @ ( ord_less @ real @ A3 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A3 ) @ A3 ) ) ) ).

% abs_real_def
thf(fact_2770_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_2771_tanh__real__gt__neg1,axiom,
    ! [X: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X ) ) ).

% tanh_real_gt_neg1
thf(fact_2772_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2773_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_2774_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_2775_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: A,M2: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ M2 ) ) ) ) ) ).

% round_diff_minimal
thf(fact_2776_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_2777_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,D2: nat > A] :
          ( ( ! [X4: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X4 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( D2 @ I4 ) @ ( power_power @ A @ X4 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N2 )
               => ( ( C2 @ I4 )
                  = ( D2 @ I4 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_2778_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_2779_sum__choose__lower,axiom,
    ! [R: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ ( plus_plus @ nat @ R @ K3 ) @ K3 )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R @ N2 ) ) @ N2 ) ) ).

% sum_choose_lower
thf(fact_2780_choose__rising__sum_I2_J,axiom,
    ! [N2: nat,M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J3 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M2 ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M2 ) @ ( one_one @ nat ) ) @ M2 ) ) ).

% choose_rising_sum(2)
thf(fact_2781_choose__rising__sum_I1_J,axiom,
    ! [N2: nat,M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J3 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M2 ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M2 ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_2782_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( abs_abs @ A @ Y ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2783_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2784_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_even_abs
thf(fact_2785_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N2: nat,K: nat] :
          ( ! [W: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_2786_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( ! [X4: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X4 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N2 )
               => ( ( C2 @ I4 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_2787_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_2788_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M2: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M2 @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ M2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_2789_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ N2 ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G2 @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_2790_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K3 ) ) @ K3 )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ).

% gbinomial_parallel_sum
thf(fact_2791_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_2792_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_2793_sum__choose__diagonal,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K3: nat] : ( binomial @ ( minus_minus @ nat @ N2 @ K3 ) @ ( minus_minus @ nat @ M2 @ K3 ) )
          @ ( set_ord_atMost @ nat @ M2 ) )
        = ( binomial @ ( suc @ N2 ) @ M2 ) ) ) ).

% sum_choose_diagonal
thf(fact_2794_vandermonde,axiom,
    ! [M2: nat,N2: nat,R: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( binomial @ M2 @ K3 ) @ ( binomial @ N2 @ ( minus_minus @ nat @ R @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ R ) )
      = ( binomial @ ( plus_plus @ nat @ M2 @ N2 ) @ R ) ) ).

% vandermonde
thf(fact_2795_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ Y ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2796_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2797_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2798_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_even
thf(fact_2799_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,X: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I3: A] :
              ( ( member @ A @ I3 @ I6 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I3 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I6 )
              = ( one_one @ B ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I6 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I3 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I4: A] : ( times_times @ B @ ( A2 @ I4 ) @ ( X @ I4 ) )
                      @ I6 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_2800_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) ) ) ).

% sum_gp_basic
thf(fact_2801_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N2: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) )
         => ~ ! [B4: nat > A] :
                ~ ! [Z4: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( B4 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_2802_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N2: nat,A2: A] :
        ? [B4: nat > A] :
        ! [Z4: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( B4 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_2803_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M2: nat,N2: nat,X: A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_2804_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex
thf(fact_2805_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G2 )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G2 @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex
thf(fact_2806_choose__row__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N2 ) @ ( set_ord_atMost @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% choose_row_sum
thf(fact_2807_binomial,axiom,
    ! [A2: nat,B2: nat,N2: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N2 )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N2 @ K3 ) ) @ ( power_power @ nat @ A2 @ K3 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) ) ) ).

% binomial
thf(fact_2808_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_2809_sin__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( sin_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( cos_coeff @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% sin_coeff_Suc
thf(fact_2810_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.in_pairs_0
thf(fact_2811_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M2: nat,A2: nat > A,N2: nat,B2: nat > A,X: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ M2 @ I3 )
             => ( ( A2 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N2 @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                  @ ( set_ord_atMost @ nat @ M2 ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J3: nat] : ( times_times @ A @ ( B2 @ J3 ) @ ( power_power @ A @ X @ J3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_2812_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.in_pairs_0
thf(fact_2813_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,K: A] :
          ( ( ! [X4: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X4 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X4: nat] :
                ( ( member @ nat @ X4 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) )
               => ( ( C2 @ X4 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_2814_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M2 ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_2815_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K3 ) ) @ ( power_power @ A @ A2 @ K3 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% binomial_ring
thf(fact_2816_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_2817_polynomial__product__nat,axiom,
    ! [M2: nat,A2: nat > nat,N2: nat,B2: nat > nat,X: nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ M2 @ I3 )
         => ( ( A2 @ I3 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N2 @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( power_power @ nat @ X @ I4 ) )
              @ ( set_ord_atMost @ nat @ M2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J3: nat] : ( times_times @ nat @ ( B2 @ J3 ) @ ( power_power @ nat @ X @ J3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K3: nat] : ( times_times @ nat @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_2818_choose__square__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( power_power @ nat @ ( binomial @ N2 @ K3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% choose_square_sum
thf(fact_2819_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: nat,K: nat,G2: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_2820_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: nat,K: nat,G2: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G2 @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_2821_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ A2 ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_2822_cos__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( cos_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% cos_coeff_Suc
thf(fact_2823_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2824_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N2 ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N2 ) ) ) ).

% round_unique'
thf(fact_2825_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,Z: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( ( power_power @ A @ Z @ N2 )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I4
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I4 = N2 ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_2826_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N2: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_2827_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( N2
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_2828_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M2 @ K3 ) ) @ K3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_2829_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M2 ) @ A2 ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A2 ) @ ( one_one @ A ) ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M2 ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_2830_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J3 @ K3 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y @ K3 ) ) @ ( power_power @ A @ X @ J3 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ J3 ) ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_2831_binomial__r__part__sum,axiom,
    ! [M2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ).

% binomial_r_part_sum
thf(fact_2832_choose__linear__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( times_times @ nat @ I4 @ ( binomial @ N2 @ I4 ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( times_times @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_2833_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_2834_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E: real,C2: nat > A,N2: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ? [M8: real] :
            ! [Z4: A] :
              ( ( ord_less_eq @ real @ M8 @ ( real_V7770717601297561774m_norm @ A @ Z4 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) ) )
                @ ( times_times @ real @ E @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_2835_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2836_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ ( minus_minus @ nat @ I4 @ J3 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
                    @ ( power_power @ A @ X @ J3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_2837_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M2 ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M2 ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_2838_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_2839_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_odd_sum
thf(fact_2840_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X: A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
             => ( P @ X3 @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X ) @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2841_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_2842_arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arctan @ X )
        = ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_2843_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K3: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_2844_sin__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X ) ) ).

% sin_paired
thf(fact_2845_summable__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_2846_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N: nat] : N ) ) ).

% of_nat_id
thf(fact_2847_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2848_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_iff_shift
thf(fact_2849_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z ) @ ( one_one @ int ) )
      = ( Z
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_2850_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_2851_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_2852_sin__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2853_sin__npi2,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2854_sin__npi__int,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_2855_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_2856_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_2857_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_2858_sin__periodic,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X ) ) ).

% sin_periodic
thf(fact_2859_sin__2npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_2860_sin__2pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_2pi_minus
thf(fact_2861_sin__int__2pin,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_2862_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_2863_sin__cos__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% sin_cos_npi
thf(fact_2864_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G2: nat > real,N4: nat,F2: nat > A] :
          ( ( summable @ real @ G2 )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G2 @ N3 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_2865_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G2: nat > real] :
          ( ? [N6: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N6 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G2 @ N3 ) ) )
         => ( ( summable @ real @ G2 )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_2866_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_2867_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) ) ) ) ).

% summable_mult
thf(fact_2868_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G2 )
           => ( summable @ A
              @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G2 @ N ) ) ) ) ) ) ).

% summable_add
thf(fact_2869_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_2870_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_2871_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( X
            = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_2872_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ X @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_2873_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G2: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G2 @ N3 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G2 )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G2 ) ) ) ) ) ) ).

% suminf_le
thf(fact_2874_sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_2875_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_2876_abs__zmult__eq__1,axiom,
    ! [M2: int,N2: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M2 @ N2 ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M2 )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_2877_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_2878_abs__div,axiom,
    ! [Y: int,X: int] :
      ( ( dvd_dvd @ int @ Y @ X )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X ) @ ( abs_abs @ int @ Y ) ) ) ) ).

% abs_div
thf(fact_2879_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( F2 @ N ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mult
thf(fact_2880_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( times_times @ A @ ( suminf @ A @ F2 ) @ C2 )
            = ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_2881_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G2 )
           => ( ( plus_plus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G2 ) )
              = ( suminf @ A
                @ ^ [N: nat] : ( plus_plus @ A @ ( F2 @ N ) @ ( G2 @ N ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_2882_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( divide_divide @ A @ ( F2 @ N ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F2 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_2883_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( summable @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I4 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_2884_sin__pi__divide__n__ge__0,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_2885_arctan__ubound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2886_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_2887_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_2888_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N: nat] :
                    ( ( F2 @ N )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_2889_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_2890_sin__gt__zero2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero2
thf(fact_2891_sin__lt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_2892_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_2893_sin__monotone__2pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_2894_sin__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_2895_sin__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X )
                = ( sin @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_2896_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) ) ) ).

% summable_zero_power'
thf(fact_2897_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ ( zero_zero @ A ) @ N ) ) ) ) ).

% summable_0_powser
thf(fact_2898_sin__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X ) ) ).

% sin_ge_minus_one
thf(fact_2899_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) )
          = ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_2900_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_2901_abs__sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_2902_arctan__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2903_arctan__lbound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) ) ).

% arctan_lbound
thf(fact_2904_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M2: nat,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N @ M2 ) ) @ ( power_power @ A @ Z @ N ) ) )
          = ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_2905_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G2: nat > real] :
          ( ? [N6: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N6 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G2 @ N3 ) ) )
         => ( ( summable @ real @ G2 )
           => ( summable @ real
              @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_2906_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_2907_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G2: nat > real] :
      ( ? [N6: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N6 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N3 ) ) @ ( G2 @ N3 ) ) )
     => ( ( summable @ real @ G2 )
       => ( summable @ real
          @ ^ [N: nat] : ( abs_abs @ real @ ( F2 @ N ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_2908_sin__le__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_2909_sin__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_2910_sin__monotone__2pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_2911_sin__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_2912_sin__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X3 )
              = Y )
            & ! [Y5: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
                  & ( ord_less_eq @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y5 )
                    = Y ) )
               => ( Y5 = X3 ) ) ) ) ) ).

% sin_total
thf(fact_2913_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_2914_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I4: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_2915_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X ) ) ) ) ).

% suminf_le_const
thf(fact_2916_sin__pi__divide__n__gt__0,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_2917_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ X @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) ) ) ) ) ).

% powser_inside
thf(fact_2918_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_2919_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B5: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N3 ) ) @ B5 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_2920_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_2921_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_2922_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_2923_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_2924_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2925_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2926_zdvd__mult__cancel1,axiom,
    ! [M2: int,N2: int] :
      ( ( M2
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M2 @ N2 ) @ M2 )
        = ( ( abs_abs @ int @ N2 )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2927_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_2928_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_2929_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero_02
thf(fact_2930_sin__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_2931_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_2932_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A @ F2 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_2933_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_2934_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_abs_add_iff
thf(fact_2935_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_add_abs_iff
thf(fact_2936_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2937_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2938_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2939_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M4 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_2940_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
         => ( ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) )
                @ Z ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_2941_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( F2 @ ( suc @ N ) ) @ ( power_power @ A @ Z @ N ) ) )
              @ Z )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( F2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_2942_monoseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X ) ) ) ) ).

% monoseq_realpow
thf(fact_2943_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ~ ! [N7: nat] :
                  ~ ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ M3 )
                     => ! [N8: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M3 @ N8 ) ) ) @ E ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_2944_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ( summable @ A @ F2 )
           => ? [N7: nat] :
              ! [N8: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N8 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N8 ) ) ) )
                  @ R ) ) ) ) ) ).

% suminf_exist_split
thf(fact_2945_summable__power__series,axiom,
    ! [F2: nat > real,Z: real] :
      ( ! [I3: nat] : ( ord_less_eq @ real @ ( F2 @ I3 ) @ ( one_one @ real ) )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I3 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z )
         => ( ( ord_less @ real @ Z @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( F2 @ I4 ) @ ( power_power @ real @ Z @ I4 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_2946_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R )
         => ( ( ord_less @ real @ R @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N ) ) @ ( power_power @ real @ R @ N ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_2947_nat__intermed__int__val,axiom,
    ! [M2: nat,N2: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ( ord_less_eq @ nat @ M2 @ I3 )
            & ( ord_less @ nat @ I3 @ N2 ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M2 @ N2 )
       => ( ( ord_less_eq @ int @ ( F2 @ M2 ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
           => ? [I3: nat] :
                ( ( ord_less_eq @ nat @ M2 @ I3 )
                & ( ord_less_eq @ nat @ I3 @ N2 )
                & ( ( F2 @ I3 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_2948_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I4 ) ) )
                    @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_2949_decr__lemma,axiom,
    ! [D2: int,X: int,Z: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z ) ) ).

% decr_lemma
thf(fact_2950_incr__lemma,axiom,
    ! [D2: int,Z: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_2951_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2952_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2953_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2954_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N4: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_2955_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ( ord_less_eq @ nat @ N2 @ I2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_2956_Maclaurin__sin__expansion,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M: nat] : ( times_times @ real @ ( sin_coeff @ M ) @ ( power_power @ real @ X @ M ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_2957_nat__ivt__aux,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N2 )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_2958_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( sums @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I4 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_2959_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2960_Maclaurin__sin__expansion2,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( sin @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M: nat] : ( times_times @ real @ ( sin_coeff @ M ) @ ( power_power @ real @ X @ M ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_2961_nat0__intermed__int__val,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N2 )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_2962_Maclaurin__sin__expansion4,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X )
          & ( ( sin @ real @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M: nat] : ( times_times @ real @ ( sin_coeff @ M ) @ ( power_power @ real @ X @ M ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_2963_sum__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X4: complex] : X4
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_2964_sum__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X4: complex] : X4
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_2965_arctan__add,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_2966_Maclaurin__sin__expansion3,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( sin @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M: nat] : ( times_times @ real @ ( sin_coeff @ M ) @ ( power_power @ real @ X @ M ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_2967_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D4: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_2968_arctan__double,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2969_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) ) @ ( power_power @ A @ X @ N ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P6 @ N ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ).

% sin_x_sin_y
thf(fact_2970_Maclaurin__minus__cos__expansion,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M: nat] : ( times_times @ real @ ( cos_coeff @ M ) @ ( power_power @ real @ X @ M ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_2971_Maclaurin__cos__expansion2,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M: nat] : ( times_times @ real @ ( cos_coeff @ M ) @ ( power_power @ real @ X @ M ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_2972_Maclaurin__cos__expansion,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( cos @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M: nat] : ( times_times @ real @ ( cos_coeff @ M ) @ ( power_power @ real @ X @ M ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_2973_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
         => ( sums @ A
            @ ^ [N: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( C2 @ N ) ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_2974_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ Y )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) ).

% mult_scaleR_left
thf(fact_2975_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X: A,A2: real,Y: A] :
          ( ( times_times @ A @ X @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) ).

% mult_scaleR_right
thf(fact_2976_scaleR__one,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( one_one @ real ) @ X )
          = X ) ) ).

% scaleR_one
thf(fact_2977_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X ) ) ) ).

% scaleR_scaleR
thf(fact_2978_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2979_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_2980_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: real,Y: A,N2: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Y ) @ N2 )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X @ N2 ) @ ( power_power @ A @ Y @ N2 ) ) ) ) ).

% scaleR_power
thf(fact_2981_scaleR__minus1__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
          = ( uminus_uminus @ A @ X ) ) ) ).

% scaleR_minus1_left
thf(fact_2982_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_2983_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_scaleR
thf(fact_2984_cos__pi,axiom,
    ( ( cos @ real @ pi )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% cos_pi
thf(fact_2985_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W2: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W2 ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_2986_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ X ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_2987_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V2: num,W2: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W2 ) @ ( numeral_numeral @ real @ V2 ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_2988_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V2: num,W2: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W2 ) ) @ ( numeral_numeral @ real @ V2 ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_2989_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_2990_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_2991_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_2992_cos__periodic,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X ) ) ).

% cos_periodic
thf(fact_2993_cos__2pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( cos @ real @ X ) ) ).

% cos_2pi_minus
thf(fact_2994_cos__npi2,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi2
thf(fact_2995_cos__npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi
thf(fact_2996_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_2997_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_2998_cos__2npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_2999_cos__int__2pin,axiom,
    ! [N2: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_3000_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_3001_cos__npi__int,axiom,
    ! [N2: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_3002_cos__pi__eq__zero,axiom,
    ! [M2: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_3003_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ).

% scaleR_right_distrib
thf(fact_3004_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_3005_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X @ N ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_converges
thf(fact_3006_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X4: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X4 @ N ) ) ) ) ) ) ).

% cos_def
thf(fact_3007_cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_3008_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ).

% scaleR_left_distrib
thf(fact_3009_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: real,Y: real,Xa2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X @ Y ) @ Xa2 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Xa2 ) @ ( real_V8093663219630862766scaleR @ A @ Y @ Xa2 ) ) ) ) ).

% scaleR_left.add
thf(fact_3010_polar__Ex,axiom,
    ! [X: real,Y: real] :
    ? [R2: real,A4: real] :
      ( ( X
        = ( times_times @ real @ R2 @ ( cos @ real @ A4 ) ) )
      & ( Y
        = ( times_times @ real @ R2 @ ( sin @ real @ A4 ) ) ) ) ).

% polar_Ex
thf(fact_3011_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_minus_converges
thf(fact_3012_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_3013_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% sin_add
thf(fact_3014_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% sin_diff
thf(fact_3015_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3016_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3017_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3018_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3019_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3020_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3021_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3022_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V2: real,A2: A,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V2 ) @ A2 )
            = X )
          = ( ( ( V2
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V2
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V2 @ X ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3023_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,U: real,V2: real,A2: A] :
          ( ( X
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V2 ) @ A2 ) )
          = ( ( ( V2
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V2
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V2 @ X )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3024_cos__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X ) ) ).

% cos_ge_minus_one
thf(fact_3025_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3026_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3027_abs__cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_3028_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% cos_diff
thf(fact_3029_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ) ).

% cos_add
thf(fact_3030_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3031_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3032_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3033_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3034_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3035_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3036_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3037_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3038_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3039_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3040_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3041_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A,Y: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3042_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ X ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3043_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X )
          = ( plus_plus @ A @ X @ X ) ) ) ).

% scaleR_2
thf(fact_3044_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3045_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C4: nat > A,N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( C4 @ ( suc @ N ) ) ) ) ) ) ).

% diffs_def
thf(fact_3046_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X ) ) @ ( cos @ A @ X ) ) ) ) ).

% sin_double
thf(fact_3047_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [X3: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X3 @ N ) ) )
         => ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_3048_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3049_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X @ N ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_converges
thf(fact_3050_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X4: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X4 @ N ) ) ) ) ) ) ).

% sin_def
thf(fact_3051_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3052_cos__is__zero,axiom,
    ? [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
      & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X3 )
        = ( zero_zero @ real ) )
      & ! [Y5: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
            & ( ord_less_eq @ real @ Y5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y5 )
              = ( zero_zero @ real ) ) )
         => ( Y5 = X3 ) ) ) ).

% cos_is_zero
thf(fact_3053_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% summable_norm_sin
thf(fact_3054_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% summable_norm_cos
thf(fact_3055_cos__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ pi )
            & ( ( cos @ real @ X3 )
              = Y )
            & ! [Y5: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y5 )
                  & ( ord_less_eq @ real @ Y5 @ pi )
                  & ( ( cos @ real @ Y5 )
                    = Y ) )
               => ( Y5 = X3 ) ) ) ) ) ).

% cos_total
thf(fact_3056_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N ) ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_minus_converges
thf(fact_3057_sin__cos__le1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) ) @ ( times_times @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3058_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W2 ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W2 @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W2 @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3059_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W2 ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W2 @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W2 @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3060_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3061_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3062_cos__double__less__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3063_cos__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero
thf(fact_3064_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3065_cos__one__2pi__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X4: int] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X4 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3066_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3067_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3068_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W2 ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W2 @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z @ W2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3069_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W2 ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W2 @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W2 @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3070_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W2 ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W2 @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W2 @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3071_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W2 ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W2 @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W2 @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3072_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W2 ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W2 @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W2 @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3073_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W2 ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W2 @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W2 @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3074_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3075_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K5 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 )
               => ( summable @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X3 @ N ) ) ) )
           => ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_3076_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3077_cos__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_ge_zero
thf(fact_3078_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X4: nat] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X4 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X4: nat] :
            ( X
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X4 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3079_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W2 ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3080_sincos__total__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X
              = ( cos @ real @ T4 ) )
            & ( Y
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3081_sin__expansion__lemma,axiom,
    ! [X: real,M2: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M2 ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M2 ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3082_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3083_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X @ N ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P6 @ N ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ).

% cos_x_cos_y
thf(fact_3084_cos__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( cos @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3085_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3086_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X @ N ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P6 @ N ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_3087_cos__expansion__lemma,axiom,
    ! [X: real,M2: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M2 ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M2 ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3088_cos__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( power_power @ real @ X @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      @ ( cos @ real @ X ) ) ).

% cos_paired
thf(fact_3089_sincos__total__pi__half,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X
                = ( cos @ real @ T4 ) )
              & ( Y
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3090_sincos__total__2pi__le,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X
            = ( cos @ real @ T4 ) )
          & ( Y
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3091_sincos__total__2pi,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X
                  = ( cos @ real @ T4 ) )
               => ( Y
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3092_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3093_Maclaurin__exp__lt,axiom,
    ! [X: real,N2: nat] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( exp @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M ) @ ( semiring_char_0_fact @ real @ M ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_3094_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI1
thf(fact_3095_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ M4 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI2
thf(fact_3096_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X6: nat > A] :
              ( ! [M: nat,N: nat] :
                  ( ( ord_less_eq @ nat @ M @ N )
                 => ( ord_less_eq @ A @ ( X6 @ M ) @ ( X6 @ N ) ) )
              | ! [M: nat,N: nat] :
                  ( ( ord_less_eq @ nat @ M @ N )
                 => ( ord_less_eq @ A @ ( X6 @ N ) @ ( X6 @ M ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_3097_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_3098_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ X )
        = ( one_one @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_3099_tan__npi,axiom,
    ! [N2: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3100_one__less__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_less_exp_iff
thf(fact_3101_exp__less__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_3102_exp__le__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_3103_one__le__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_le_exp_iff
thf(fact_3104_tan__periodic__n,axiom,
    ! [X: real,N2: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_n
thf(fact_3105_tan__periodic__nat,axiom,
    ! [X: real,N2: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_nat
thf(fact_3106_tan__periodic__int,axiom,
    ! [X: real,I2: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( ring_1_of_int @ real @ I2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_int
thf(fact_3107_tan__periodic,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic
thf(fact_3108_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A5: A] :
          ( ( times_times @ A @ ( exp @ A @ A5 ) @ A5 )
          = ( times_times @ A @ A5 @ ( exp @ A @ A5 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_3109_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) ) ) ) ) ).

% exp_add_commuting
thf(fact_3110_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) )
          = ( exp @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% mult_exp_exp
thf(fact_3111_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( divide_divide @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y ) ) ) ) ).

% exp_diff
thf(fact_3112_exp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) ) ) ).

% exp_gt_one
thf(fact_3113_exp__ge__add__one__self,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ).

% exp_ge_add_one_self
thf(fact_3114_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_3115_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ X ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N2 ) ) ) ).

% exp_of_nat_mult
thf(fact_3116_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,N2: nat] :
          ( ( exp @ A @ ( times_times @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N2 ) ) ) ).

% exp_of_nat2_mult
thf(fact_3117_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( sin @ A @ X4 ) @ ( cos @ A @ X4 ) ) ) ) ) ).

% tan_def
thf(fact_3118_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_3119_lemma__exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less_eq @ real @ X3 @ ( minus_minus @ real @ Y @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X3 )
            = Y ) ) ) ).

% lemma_exp_total
thf(fact_3120_ln__x__over__x__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y ) @ Y ) @ ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_3121_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_3122_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ N2 )
            = ( exp @ A @ X ) ) ) ) ).

% exp_divide_power_eq
thf(fact_3123_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_3124_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_3125_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3126_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) )
          = ( power_power @ A @ ( exp @ A @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_3127_lemma__tan__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X3: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y @ ( tan @ real @ X3 ) ) ) ) ).

% lemma_tan_total
thf(fact_3128_tan__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_gt_zero
thf(fact_3129_lemma__tan__total1,axiom,
    ! [Y: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y ) ) ).

% lemma_tan_total1
thf(fact_3130_tan__mono__lt__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3131_tan__monotone_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
         => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y @ X )
              = ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3132_tan__monotone,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ).

% tan_monotone
thf(fact_3133_tan__total,axiom,
    ! [Y: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y )
      & ! [Y5: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y5 )
            & ( ord_less @ real @ Y5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y5 )
              = Y ) )
         => ( Y5 = X3 ) ) ) ).

% tan_total
thf(fact_3134_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3135_tan__inverse,axiom,
    ! [Y: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y ) ) ) ).

% tan_inverse
thf(fact_3136_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_3137_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3138_exp__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_3139_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3140_tan__total__pos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X3 )
            = Y ) ) ) ).

% tan_total_pos
thf(fact_3141_tan__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3142_tan__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3143_tan__mono__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) ) ) ) ) ).

% tan_mono_le
thf(fact_3144_tan__bound__pi2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3145_arctan__unique,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X )
            = Y )
         => ( ( arctan @ Y )
            = X ) ) ) ) ).

% arctan_unique
thf(fact_3146_arctan__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X ) )
          = X ) ) ) ).

% arctan_tan
thf(fact_3147_arctan,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y ) )
        = Y ) ) ).

% arctan
thf(fact_3148_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3149_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3150_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3151_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_3152_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ X ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_3153_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ ( uminus_uminus @ real @ X ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_3154_tan__total__pi4,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ? [Z3: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z3 )
          & ( ord_less @ real @ Z3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z3 )
            = X ) ) ) ).

% tan_total_pi4
thf(fact_3155_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_3156_Maclaurin__exp__le,axiom,
    ! [X: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( exp @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M ) @ ( semiring_char_0_fact @ real @ M ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_3157_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( divide_divide @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_3158_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X4: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_3159_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X4 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X4 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3160_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI1
thf(fact_3161_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI2
thf(fact_3162_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X6: nat > A] :
              ( ! [N: nat] : ( ord_less_eq @ A @ ( X6 @ N ) @ ( X6 @ ( suc @ N ) ) )
              | ! [N: nat] : ( ord_less_eq @ A @ ( X6 @ ( suc @ N ) ) @ ( X6 @ N ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_3163_sin__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X )
        = ( divide_divide @ real @ ( tan @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3164_cos__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3165_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X4: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X4 )
              @ ( suminf @ A
                @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X4 @ ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_3166_Maclaurin__sin__bound,axiom,
    ! [X: real,N2: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M: nat] : ( times_times @ real @ ( sin_coeff @ M ) @ ( power_power @ real @ X @ M ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( abs_abs @ real @ X ) @ N2 ) ) ) ).

% Maclaurin_sin_bound
thf(fact_3167_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3168_real__sqrt__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ X )
        = ( sqrt @ Y ) )
      = ( X = Y ) ) ).

% real_sqrt_eq_iff
thf(fact_3169_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3170_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3171_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3172_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_3173_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_3174_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_3175_real__sqrt__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% real_sqrt_less_iff
thf(fact_3176_real__sqrt__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% real_sqrt_le_iff
thf(fact_3177_real__sqrt__eq__1__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( one_one @ real ) )
      = ( X
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_3178_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_3179_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3180_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3181_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3182_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3183_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3184_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3185_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_3186_real__sqrt__gt__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_gt_0_iff
thf(fact_3187_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_3188_real__sqrt__ge__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_ge_0_iff
thf(fact_3189_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_3190_real__sqrt__gt__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_gt_1_iff
thf(fact_3191_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_3192_real__sqrt__ge__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_ge_1_iff
thf(fact_3193_real__sqrt__abs2,axiom,
    ! [X: real] :
      ( ( sqrt @ ( times_times @ real @ X @ X ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs2
thf(fact_3194_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_3195_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3196_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3197_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3198_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3199_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3200_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_3201_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W2: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3202_norm__cos__sin,axiom,
    ! [T2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ ( cos @ real @ T2 ) @ ( sin @ real @ T2 ) ) )
      = ( one_one @ real ) ) ).

% norm_cos_sin
thf(fact_3203_real__sqrt__abs,axiom,
    ! [X: real] :
      ( ( sqrt @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs
thf(fact_3204_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X ) ) ).

% real_sqrt_pow2
thf(fact_3205_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% real_sqrt_pow2_iff
thf(fact_3206_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y: real,Xa2: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_3207_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y: A,X: A] :
          ( ( ( times_times @ A @ Y @ X )
            = ( times_times @ A @ X @ Y ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3208_real__sqrt__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_less_mono
thf(fact_3209_real__sqrt__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_le_mono
thf(fact_3210_real__sqrt__inverse,axiom,
    ! [X: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_inverse
thf(fact_3211_real__sqrt__minus,axiom,
    ! [X: real] :
      ( ( sqrt @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_minus
thf(fact_3212_real__sqrt__power,axiom,
    ! [X: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X @ K ) )
      = ( power_power @ real @ ( sqrt @ X ) @ K ) ) ).

% real_sqrt_power
thf(fact_3213_real__sqrt__mult,axiom,
    ! [X: real,Y: real] :
      ( ( sqrt @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_mult
thf(fact_3214_real__sqrt__divide,axiom,
    ! [X: real,Y: real] :
      ( ( sqrt @ ( divide_divide @ real @ X @ Y ) )
      = ( divide_divide @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_divide
thf(fact_3215_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N2 )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_inverse
thf(fact_3216_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ B2 ) ) ) ).

% complex_scaleR
thf(fact_3217_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ ( sqrt @ X ) @ X )
        = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3218_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3219_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3220_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3221_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3222_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3223_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3224_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3225_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3226_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3227_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3228_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3229_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ ( inverse_inverse @ A @ B3 ) @ A3 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3230_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ A3 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% divide_inverse
thf(fact_3231_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ A3 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3232_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_gt_zero
thf(fact_3233_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3234_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M2 ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3235_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M2 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N2 ) @ ( power_power @ A @ X @ M2 ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3236_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sqrt @ X )
          = ( zero_zero @ real ) )
       => ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_3237_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_zero
thf(fact_3238_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3239_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_one
thf(fact_3240_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3241_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X4: real,Y4: real] : ( times_times @ real @ X4 @ ( inverse_inverse @ real @ Y4 ) ) ) ) ).

% divide_real_def
thf(fact_3242_complex__norm,axiom,
    ! [X: real,Y: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X @ Y ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3243_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3244_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3245_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3246_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3247_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3248_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3249_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3250_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3251_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3252_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3253_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3254_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3255_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3256_real__div__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ X @ ( sqrt @ X ) )
        = ( sqrt @ X ) ) ) ).

% real_div_sqrt
thf(fact_3257_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X @ Y ) ) @ ( plus_plus @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_3258_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X @ X ) @ ( times_times @ real @ Y @ Y ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_3259_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_3260_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3261_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3262_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3263_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3264_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3265_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3266_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3267_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3268_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X ) ) ) ).

% reals_Archimedean
thf(fact_3269_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_3270_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M2: real,Y: A,X: A,C2: A] :
          ( ( M2
           != ( zero_zero @ real ) )
         => ( ( Y
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M2 @ X ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M2 ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M2 ) @ C2 ) )
              = X ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3271_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M2: real,X: A,C2: A,Y: A] :
          ( ( M2
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M2 @ X ) @ C2 )
              = Y )
            = ( X
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M2 ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M2 ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3272_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3273_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3274_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3275_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3276_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3277_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3278_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3279_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3280_forall__pos__mono__1,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D4: real,E2: real] :
          ( ( ord_less @ real @ D4 @ E2 )
         => ( ( P @ D4 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3281_real__arch__inverse,axiom,
    ! [E: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
      = ( ? [N: nat] :
            ( ( N
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N ) ) @ E ) ) ) ) ).

% real_arch_inverse
thf(fact_3282_forall__pos__mono,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D4: real,E2: real] :
          ( ( ord_less @ real @ D4 @ E2 )
         => ( ( P @ D4 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono
thf(fact_3283_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3284_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N ) ) @ ( power_power @ A @ X @ N ) ) ) ) ).

% summable_exp
thf(fact_3285_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) ) ) ).

% summable_exp_generic
thf(fact_3286_real__less__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_less_rsqrt
thf(fact_3287_sqrt__le__D,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ Y )
     => ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_3288_real__le__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less_eq @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_le_rsqrt
thf(fact_3289_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3290_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: nat,N2: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M2 @ N2 )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ M2 ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N2 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M2 ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3291_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3292_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3293_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3294_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3295_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3296_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3297_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3298_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3299_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3300_real__le__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_le_lsqrt
thf(fact_3301_real__sqrt__unique,axiom,
    ! [Y: real,X: real] :
      ( ( ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( sqrt @ X )
          = Y ) ) ) ).

% real_sqrt_unique
thf(fact_3302_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) )
          @ ( exp @ A @ X ) ) ) ).

% exp_converges
thf(fact_3303_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X4: A] :
              ( suminf @ A
              @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X4 @ N ) ) ) ) ) ) ).

% exp_def
thf(fact_3304_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_3305_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% summable_norm_exp
thf(fact_3306_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y )
     => ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_3307_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X )
     => ( Y
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_3308_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_3309_real__sqrt__sum__squares__ge2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ Y @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_3310_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_3311_sqrt__ge__absD,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ Y ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y ) ) ).

% sqrt_ge_absD
thf(fact_3312_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3313_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_3314_tan__cot,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X ) ) ) ).

% tan_cot
thf(fact_3315_exp__plus__inverse__exp,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3316_real__less__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_less_lsqrt
thf(fact_3317_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_3318_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3319_sqrt__even__pow2,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_3320_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_3321_real__sqrt__ge__abs2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_3322_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ Y ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_3323_ln__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( sqrt @ X ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_3324_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3325_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_3326_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3327_arsinh__real__aux,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_3328_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y: real,Xa2: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_3329_real__sqrt__power__even,axiom,
    ! [N2: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( sqrt @ X ) @ N2 )
          = ( power_power @ real @ X @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_3330_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X @ Y ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_3331_real__le__x__sinh,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3332_real__le__abs__sinh,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3333_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A,N2: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I4 ) ) @ ( power_power @ A @ X @ I4 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ I4 ) ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N2 @ I4 ) ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_3334_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X4: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N ) ) ) @ ( power_power @ A @ X4 @ ( suc @ N ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_3335_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3336_cos__x__y__le__one,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_3337_real__sqrt__sum__squares__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_3338_arcosh__real__def,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( arcosh @ real @ X )
        = ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_3339_cos__arctan,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3340_sin__arctan,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3341_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ X @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_3342_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X4: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X4 @ N ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N @ K ) ) ) @ ( power_power @ A @ X4 @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_3343_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) )
     => ( ( sin @ real @ X )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3344_arctan__half,axiom,
    ( arctan
    = ( ^ [X4: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X4 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_3345_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X4: real] : ( ln_ln @ real @ ( plus_plus @ real @ X4 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_3346_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) )
          @ ( sinh @ A @ X ) ) ) ).

% sinh_converges
thf(fact_3347_cos__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3348_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ X @ N ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X ) ) ) ).

% cosh_converges
thf(fact_3349_sin__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3350_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3351_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3352_arccos__minus__1,axiom,
    ( ( arccos @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = pi ) ).

% arccos_minus_1
thf(fact_3353_cos__arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y ) )
          = Y ) ) ) ).

% cos_arccos
thf(fact_3354_sin__arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y ) )
          = Y ) ) ) ).

% sin_arcsin
thf(fact_3355_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3356_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3357_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3358_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% cosh_plus_sinh
thf(fact_3359_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% sinh_plus_cosh
thf(fact_3360_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X4: complex,Y4: complex] : ( times_times @ complex @ X4 @ ( inverse_inverse @ complex @ Y4 ) ) ) ) ).

% divide_complex_def
thf(fact_3361_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% sinh_add
thf(fact_3362_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% cosh_add
thf(fact_3363_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% sinh_diff
thf(fact_3364_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X @ Y ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y ) ) ) ) ) ).

% cosh_diff
thf(fact_3365_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( sinh @ A @ X4 ) @ ( cosh @ A @ X4 ) ) ) ) ) ).

% tanh_def
thf(fact_3366_cosh__real__ge__1,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_ge_1
thf(fact_3367_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X ) ) @ ( cosh @ A @ X ) ) ) ) ).

% sinh_double
thf(fact_3368_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3369_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3370_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3371_arccos__le__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3372_arccos__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X )
          = ( arccos @ Y ) )
        = ( X = Y ) ) ) ).

% arccos_eq_iff
thf(fact_3373_arccos__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% arccos_le_mono
thf(fact_3374_arcsin__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ real @ ( arcsin @ X ) ) ) ) ) ).

% arcsin_minus
thf(fact_3375_arcsin__le__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_3376_arcsin__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X )
            = ( arcsin @ Y ) )
          = ( X = Y ) ) ) ) ).

% arcsin_eq_iff
thf(fact_3377_arcsin__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% arcsin_le_mono
thf(fact_3378_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3379_arccos__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) ) ) ) ).

% arccos_lbound
thf(fact_3380_arccos__less__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3381_arccos__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% arccos_less_mono
thf(fact_3382_arccos__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3383_arcsin__less__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3384_arcsin__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% arcsin_less_mono
thf(fact_3385_cos__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y ) )
        = Y ) ) ).

% cos_arccos_abs
thf(fact_3386_arccos__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3387_arccos__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3388_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3389_arccos__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ) ).

% arccos_minus
thf(fact_3390_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3391_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3392_arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y ) )
            = Y ) ) ) ) ).

% arccos
thf(fact_3393_arccos__minus__abs,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ).

% arccos_minus_abs
thf(fact_3394_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z5: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z5 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3395_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3396_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z5 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3397_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3398_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3399_arccos__le__pi2,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3400_cosh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( cosh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3401_arcsin__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3402_arcsin__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3403_arcsin__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3404_arcsin__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) ) ) ) ).

% arcsin_lbound
thf(fact_3405_arcsin__sin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X ) )
          = X ) ) ) ).

% arcsin_sin
thf(fact_3406_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X4 ) @ ( exp @ A @ ( uminus_uminus @ A @ X4 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3407_sinh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( sinh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3408_le__arcsin__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y @ ( arcsin @ X ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y ) @ X ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3409_arcsin__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ Y )
              = ( ord_less_eq @ real @ X @ ( sin @ real @ Y ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3410_arcsin__pi,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin_pi
thf(fact_3411_arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin
thf(fact_3412_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3413_sin__arccos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3414_cot__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3415_i__even__power,axiom,
    ! [N2: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N2 ) ) ).

% i_even_power
thf(fact_3416_log__base__10__eq1,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq1
thf(fact_3417_cot__periodic,axiom,
    ! [X: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X ) ) ).

% cot_periodic
thf(fact_3418_arctan__def,axiom,
    ( arctan
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X4: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X4 )
              & ( ord_less @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X4 )
                = Y4 ) ) ) ) ) ).

% arctan_def
thf(fact_3419_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_3420_norm__ii,axiom,
    ( ( real_V7770717601297561774m_norm @ complex @ imaginary_unit )
    = ( one_one @ real ) ) ).

% norm_ii
thf(fact_3421_complex__i__mult__minus,axiom,
    ! [X: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X ) )
      = ( uminus_uminus @ complex @ X ) ) ).

% complex_i_mult_minus
thf(fact_3422_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_3423_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less @ real @ X @ Y ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_3424_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_3425_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ A2 @ X ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_3426_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_3427_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_3428_divide__numeral__i,axiom,
    ! [Z: complex,N2: num] :
      ( ( divide_divide @ complex @ Z @ ( times_times @ complex @ ( numeral_numeral @ complex @ N2 ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) @ ( numeral_numeral @ complex @ N2 ) ) ) ).

% divide_numeral_i
thf(fact_3429_divide__i,axiom,
    ! [X: complex] :
      ( ( divide_divide @ complex @ X @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X ) ) ).

% divide_i
thf(fact_3430_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3431_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) )
            = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_3432_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_3433_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ A2 @ X ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_3434_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_3435_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_3436_cot__npi,axiom,
    ! [N2: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3437_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_3438_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3439_complex__i__not__one,axiom,
    imaginary_unit
 != ( one_one @ complex ) ).

% complex_i_not_one
thf(fact_3440_log__def,axiom,
    ( log
    = ( ^ [A3: real,X4: real] : ( divide_divide @ real @ ( ln_ln @ real @ X4 ) @ ( ln_ln @ real @ A3 ) ) ) ) ).

% log_def
thf(fact_3441_i__times__eq__iff,axiom,
    ! [W2: complex,Z: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W2 )
        = Z )
      = ( W2
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) ) ) ).

% i_times_eq_iff
thf(fact_3442_log__ln,axiom,
    ( ( ln_ln @ real )
    = ( log @ ( exp @ real @ ( one_one @ real ) ) ) ) ).

% log_ln
thf(fact_3443_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3444_Complex__eq__i,axiom,
    ! [X: real,Y: real] :
      ( ( ( complex2 @ X @ Y )
        = imaginary_unit )
      = ( ( X
          = ( zero_zero @ real ) )
        & ( Y
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3445_Complex__mult__i,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% Complex_mult_i
thf(fact_3446_i__mult__Complex,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% i_mult_Complex
thf(fact_3447_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X )
          = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_3448_log__of__power__eq,axiom,
    ! [M2: nat,B2: real,N2: nat] :
      ( ( ( semiring_1_of_nat @ real @ M2 )
        = ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N2 )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M2 ) ) ) ) ) ).

% log_of_power_eq
thf(fact_3449_less__log__of__power,axiom,
    ! [B2: real,N2: nat,M2: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N2 ) @ M2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M2 ) ) ) ) ).

% less_log_of_power
thf(fact_3450_log__mult,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( times_times @ real @ X @ Y ) )
              = ( plus_plus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_mult
thf(fact_3451_log__divide,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log @ A2 @ ( divide_divide @ real @ X @ Y ) )
              = ( minus_minus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y ) ) ) ) ) ) ) ).

% log_divide
thf(fact_3452_le__log__of__power,axiom,
    ! [B2: real,N2: nat,M2: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N2 ) @ M2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M2 ) ) ) ) ).

% le_log_of_power
thf(fact_3453_log__base__pow,axiom,
    ! [A2: real,N2: nat,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N2 ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log_base_pow
thf(fact_3454_log__nat__power,axiom,
    ! [X: real,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ B2 @ ( power_power @ real @ X @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X ) ) ) ) ).

% log_nat_power
thf(fact_3455_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X ) ) ) ) ) ) ).

% log_inverse
thf(fact_3456_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X4: A] : ( divide_divide @ A @ ( cos @ A @ X4 ) @ ( sin @ A @ X4 ) ) ) ) ) ).

% cot_def
thf(fact_3457_log2__of__power__eq,axiom,
    ! [M2: nat,N2: nat] :
      ( ( M2
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( semiring_1_of_nat @ real @ N2 )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M2 ) ) ) ) ).

% log2_of_power_eq
thf(fact_3458_log__of__power__less,axiom,
    ! [M2: nat,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M2 ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_less
thf(fact_3459_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( ( log @ A2 @ X )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_3460_log__of__power__le,axiom,
    ! [M2: nat,B2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M2 ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_le
thf(fact_3461_less__log2__of__power,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M2 )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M2 ) ) ) ) ).

% less_log2_of_power
thf(fact_3462_le__log2__of__power,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M2 )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M2 ) ) ) ) ).

% le_log2_of_power
thf(fact_3463_log2__of__power__less,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_less
thf(fact_3464_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
          & ( ord_less_eq @ real @ X4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X4 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_3465_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X4 )
            & ( ord_less_eq @ real @ X4 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X4 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_3466_cot__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X ) ) ) ) ).

% cot_gt_zero
thf(fact_3467_log2__of__power__le,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_le
thf(fact_3468_log__base__10__eq2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq2
thf(fact_3469_tan__cot_H,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( cot @ real @ X ) ) ).

% tan_cot'
thf(fact_3470_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X4: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X4 )
              & ( ord_less_eq @ real @ X4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X4 )
                = Y4 ) ) ) ) ) ).

% arcsin_def
thf(fact_3471_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3472_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_3473_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3474_ceiling__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_3475_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_3476_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) )
            = X )
          = ( ? [N: int] :
                ( X
                = ( ring_1_of_int @ A @ N ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_3477_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V2 ) )
          = ( numeral_numeral @ int @ V2 ) ) ) ).

% ceiling_numeral
thf(fact_3478_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_3479_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ Z ) ) ) ).

% ceiling_add_of_int
thf(fact_3480_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_3481_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_less_ceiling
thf(fact_3482_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less_eq @ A @ X @ ( numeral_numeral @ A @ V2 ) ) ) ) ).

% ceiling_le_numeral
thf(fact_3483_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_3484_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_3485_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V2 ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V2 ) @ X ) ) ) ).

% numeral_less_ceiling
thf(fact_3486_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_3487_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_3488_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_add_numeral
thf(fact_3489_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_3490_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_3491_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_3492_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_3493_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N2: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% ceiling_numeral_power
thf(fact_3494_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_3495_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_3496_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_3497_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_3498_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V2 ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_3499_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_3500_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ X ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_3501_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_3502_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_3503_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_3504_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y ) @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% ceiling_mono
thf(fact_3505_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% le_of_int_ceiling
thf(fact_3506_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% ceiling_less_cancel
thf(fact_3507_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_3508_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% ceiling_le_iff
thf(fact_3509_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% less_ceiling_iff
thf(fact_3510_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) ) ) ) ).

% ceiling_add_le
thf(fact_3511_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( plus_plus @ A @ R @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_3512_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( one_one @ A ) ) @ R ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_3513_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_3514_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I4 ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% ceiling_split
thf(fact_3515_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3516_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z ) ) ) ) ).

% ceiling_unique
thf(fact_3517_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_3518_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_3519_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3520_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_3521_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ P4 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ Q2 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3522_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) @ P4 ) ) ) ).

% ceiling_divide_lower
thf(fact_3523_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: int,X: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N2 ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N2 ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X )
              = ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_3524_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3525_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X )
            & ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_3526_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_3527_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_3528_modulo__int__unfold,axiom,
    ! [L: int,K: int,N2: nat,M2: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M2 ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M2 ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M2 ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M2 @ N2 ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M2 ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N2
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N2 @ M2 ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M2 @ N2 ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_3529_sgn__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_one
thf(fact_3530_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_3531_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_3532_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N2 ) ) ) ).

% power_sgn
thf(fact_3533_powr__one__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% powr_one_eq_one
thf(fact_3534_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) )
            = X )
          = ( ? [N: int] :
                ( X
                = ( ring_1_of_int @ A @ N ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_3535_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_3536_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_3537_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_3538_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_3539_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V2 ) )
          = ( numeral_numeral @ int @ V2 ) ) ) ).

% floor_numeral
thf(fact_3540_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_3541_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_3542_norm__cis,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( cis @ A2 ) )
      = ( one_one @ real ) ) ).

% norm_cis
thf(fact_3543_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3544_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_3545_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_3546_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3547_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_3548_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% powr_one_gt_zero_iff
thf(fact_3549_powr__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) ).

% powr_one
thf(fact_3550_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_3551_numeral__powr__numeral__real,axiom,
    ! [M2: num,N2: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M2 ) @ ( numeral_numeral @ real @ N2 ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M2 ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% numeral_powr_numeral_real
thf(fact_3552_sgn__mult__dvd__iff,axiom,
    ! [R: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_3553_mult__sgn__dvd__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_3554_dvd__sgn__mult__iff,axiom,
    ! [L: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_3555_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_3556_cis__pi,axiom,
    ( ( cis @ pi )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% cis_pi
thf(fact_3557_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_3558_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_le_floor
thf(fact_3559_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_3560_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V2 ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V2 ) @ X ) ) ) ).

% numeral_le_floor
thf(fact_3561_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_3562_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_3563_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ V2 ) ) ) ) ).

% floor_less_numeral
thf(fact_3564_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_3565_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_3566_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% floor_neg_numeral
thf(fact_3567_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V2 ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) ) ) ) ).

% floor_diff_numeral
thf(fact_3568_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_3569_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% sgn_of_nat
thf(fact_3570_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% floor_numeral_power
thf(fact_3571_log__powr__cancel,axiom,
    ! [A2: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y ) )
          = Y ) ) ) ).

% log_powr_cancel
thf(fact_3572_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X ) )
            = X ) ) ) ) ).

% powr_log_cancel
thf(fact_3573_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_3574_powr__numeral,axiom,
    ! [X: real,N2: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( numeral_numeral @ real @ N2 ) )
        = ( power_power @ real @ X @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% powr_numeral
thf(fact_3575_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V2 ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_3576_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V2 ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_3577_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_3578_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_3579_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ X ) ) ) ).

% neg_numeral_le_floor
thf(fact_3580_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_3581_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3582_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_3583_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3584_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_3585_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V2: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_3586_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V2: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V2 ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_3587_square__powr__half,axiom,
    ! [X: real] :
      ( ( powr @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% square_powr_half
thf(fact_3588_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_3589_powr__powr,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ X @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_3590_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( sgn_sgn @ A @ Y ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_3591_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_3592_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_3593_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ).

% floor_mono
thf(fact_3594_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X ) ) ).

% of_int_floor_le
thf(fact_3595_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% floor_less_cancel
thf(fact_3596_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_3597_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_3598_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_mono
thf(fact_3599_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_3600_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) ).

% mult_sgn_abs
thf(fact_3601_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_3602_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_3603_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K3: A] : ( times_times @ A @ K3 @ ( sgn_sgn @ A @ K3 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_3604_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N3: nat,L4: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L4 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_sgnE
thf(fact_3605_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_3606_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L ) )
     => ( ( divide_divide @ int @ K @ L )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_3607_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3608_cis__divide,axiom,
    ! [A2: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% cis_divide
thf(fact_3609_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% le_floor_iff
thf(fact_3610_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% floor_less_iff
thf(fact_3611_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% le_floor_add
thf(fact_3612_powr__inj,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y ) )
          = ( X = Y ) ) ) ) ).

% powr_inj
thf(fact_3613_gr__one__powr,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X @ Y ) ) ) ) ).

% gr_one_powr
thf(fact_3614_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( plus_plus @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ) ).

% int_add_floor
thf(fact_3615_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ) ).

% floor_add_int
thf(fact_3616_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_3617_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ Y )
           => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_3618_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_3619_powr__divide,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( divide_divide @ real @ X @ Y ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_3620_powr__mult,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( times_times @ real @ X @ Y ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_3621_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_3622_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_3623_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N2: nat] :
          ( ( X
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X @ N2 ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X ) @ N2 ) ) ) ) ).

% floor_power
thf(fact_3624_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_3625_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_3626_log__base__powr,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_3627_ln__powr,axiom,
    ! [X: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_powr
thf(fact_3628_log__powr,axiom,
    ! [X: real,B2: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( log @ B2 @ X ) ) ) ) ).

% log_powr
thf(fact_3629_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_3630_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A,B2: A] :
          ( ( powr @ A @ X @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X @ A2 ) @ ( powr @ A @ X @ B2 ) ) ) ) ).

% powr_add
thf(fact_3631_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W2: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W2 @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W2 @ Z1 ) @ ( powr @ A @ W2 @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_3632_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_3633_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X )
            & ( ord_less @ real @ X @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_3634_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M2: nat,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M2 @ N2 ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_3635_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_3636_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X4: A] :
              ( if @ A
              @ ( X4
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X4 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_3637_powr__realpow,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) )
        = ( power_power @ real @ X @ N2 ) ) ) ).

% powr_realpow
thf(fact_3638_less__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% less_log_iff
thf(fact_3639_log__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_less_iff
thf(fact_3640_less__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% less_powr_iff
thf(fact_3641_powr__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_less_iff
thf(fact_3642_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I4: int] :
          ( if @ int
          @ ( I4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_3643_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X4: A] :
              ( if @ int
              @ ( X4
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X4 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X4 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X4 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_3644_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_3645_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_3646_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : ( ord_less @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_3647_floor__eq,axiom,
    ! [N2: int,X: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N2 ) ) ) ).

% floor_eq
thf(fact_3648_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : ( ord_less_eq @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_3649_div__sgn__abs__cancel,axiom,
    ! [V2: int,K: int,L: int] :
      ( ( V2
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V2 ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V2 ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_3650_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : ( ord_less @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_3651_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_3652_DeMoivre,axiom,
    ! [A2: real,N2: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N2 )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3653_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( dvd_dvd @ int @ L @ K )
     => ( ( divide_divide @ int @ K @ L )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_3654_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z ) ) ) ) ).

% floor_unique
thf(fact_3655_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_3656_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I4 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% floor_split
thf(fact_3657_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A] :
          ( ( powr @ A @ X @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_3658_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_3659_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_3660_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_3661_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_3662_powr__neg__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X ) ) ) ).

% powr_neg_one
thf(fact_3663_powr__mult__base,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y ) ) ) ) ).

% powr_mult_base
thf(fact_3664_powr__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_le_iff
thf(fact_3665_le__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y ) ) ) ) ).

% le_powr_iff
thf(fact_3666_log__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y )
          = ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_le_iff
thf(fact_3667_le__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ Y @ ( log @ B2 @ X ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% le_log_iff
thf(fact_3668_floor__eq2,axiom,
    ! [N2: int,X: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N2 ) ) ) ).

% floor_eq2
thf(fact_3669_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_3670_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ Q2 ) @ P4 ) ) ) ).

% floor_divide_lower
thf(fact_3671_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_3672_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X ) ) ) ) ).

% ln_powr_bound2
thf(fact_3673_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_3674_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_3675_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ Y @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_3676_eucl__rel__int__remainderI,axiom,
    ! [R: int,L: int,K: int,Q2: int] :
      ( ( ( sgn_sgn @ int @ R )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q2 @ L ) @ R ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q2 @ R ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_3677_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X4: A,A3: A] :
              ( if @ A
              @ ( X4
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A3 @ ( ln_ln @ A @ X4 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_3678_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ P4 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) ) ) ) ).

% floor_divide_upper
thf(fact_3679_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X4: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X4 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_3680_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ ( log @ B2 @ X ) @ Y )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_3681_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A12: int,A23: int,A32: product_prod @ int @ int] :
          ( ? [K3: int] :
              ( ( A12 = K3 )
              & ( A23
                = ( zero_zero @ int ) )
              & ( A32
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K3 ) ) )
          | ? [L2: int,K3: int,Q4: int] :
              ( ( A12 = K3 )
              & ( A23 = L2 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L2
               != ( zero_zero @ int ) )
              & ( K3
                = ( times_times @ int @ Q4 @ L2 ) ) )
          | ? [R5: int,L2: int,K3: int,Q4: int] :
              ( ( A12 = K3 )
              & ( A23 = L2 )
              & ( A32
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L2 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L2 ) )
              & ( K3
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L2 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_3682_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A33: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A1 @ A22 @ A33 )
     => ( ( ( A22
            = ( zero_zero @ int ) )
         => ( A33
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A1 ) ) )
       => ( ! [Q3: int] :
              ( ( A33
                = ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) )
             => ( ( A22
                 != ( zero_zero @ int ) )
               => ( A1
                 != ( times_times @ int @ Q3 @ A22 ) ) ) )
         => ~ ! [R2: int,Q3: int] :
                ( ( A33
                  = ( product_Pair @ int @ int @ Q3 @ R2 ) )
               => ( ( ( sgn_sgn @ int @ R2 )
                    = ( sgn_sgn @ int @ A22 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R2 ) @ ( abs_abs @ int @ A22 ) )
                   => ( A1
                     != ( plus_plus @ int @ ( times_times @ int @ Q3 @ A22 ) @ R2 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_3683_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_3684_powr__half__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X ) ) ) ).

% powr_half_sqrt
thf(fact_3685_powr__neg__numeral,axiom,
    ! [X: real,N2: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N2 ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_3686_floor__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_3687_divide__int__unfold,axiom,
    ! [L: int,K: int,N2: nat,M2: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M2 ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M2 ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M2 @ N2 ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M2 ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M2 @ N2 )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N2 @ M2 ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_3688_bij__betw__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( bij_betw @ nat @ complex
        @ ^ [K3: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K3 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        @ ( set_ord_lessThan @ nat @ N2 )
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N2 )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_3689_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X4: A] : ( ln_ln @ A @ ( plus_plus @ A @ X4 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_3690_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X4: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X4 ) ) @ ( archimedean_ceiling @ A @ X4 ) @ ( archim6421214686448440834_floor @ A @ X4 ) ) ) ) ) ).

% round_altdef
thf(fact_3691_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X4: A] : ( ln_ln @ A @ ( plus_plus @ A @ X4 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X4 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_3692_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ K3
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L2 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_3693_of__real__1,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( one_one @ real ) )
        = ( one_one @ A ) ) ) ).

% of_real_1
thf(fact_3694_of__real__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ real ) ) ) ) ).

% of_real_eq_1_iff
thf(fact_3695_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X @ Y ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_mult
thf(fact_3696_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W2: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W2 ) )
          = ( numeral_numeral @ A @ W2 ) ) ) ).

% of_real_numeral
thf(fact_3697_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_3698_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_divide
thf(fact_3699_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X @ Y ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ).

% of_real_add
thf(fact_3700_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,N2: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X @ N2 ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X ) @ N2 ) ) ) ).

% of_real_power
thf(fact_3701_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_3702_zless__nat__conj,axiom,
    ! [W2: int,Z: int] :
      ( ( ord_less @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
        & ( ord_less @ int @ W2 @ Z ) ) ) ).

% zless_nat_conj
thf(fact_3703_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% zero_less_nat_eq
thf(fact_3704_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W2: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% of_real_neg_numeral
thf(fact_3705_cos__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% cos_of_real_pi
thf(fact_3706_diff__nat__numeral,axiom,
    ! [V2: num,V4: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( numeral_numeral @ nat @ V4 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V2 ) @ ( numeral_numeral @ int @ V4 ) ) ) ) ).

% diff_nat_numeral
thf(fact_3707_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y: int,X: num,N2: nat] :
      ( ( ( nat2 @ Y )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) )
      = ( Y
        = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_3708_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,N2: nat,Y: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 )
        = ( nat2 @ Y ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 )
        = Y ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_3709_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) @ A2 )
      = ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_3710_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_3711_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_3712_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ).

% one_less_nat_eq
thf(fact_3713_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_3714_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_3715_nat__numeral__diff__1,axiom,
    ! [V2: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V2 ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_3716_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,N2: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_3717_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N2: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_3718_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,N2: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_3719_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N2 ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N2 ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_3720_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_3721_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_3722_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_3723_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_3724_sgn__eq,axiom,
    ( ( sgn_sgn @ complex )
    = ( ^ [Z5: complex] : ( divide_divide @ complex @ Z5 @ ( real_Vector_of_real @ complex @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) ) ) ) ) ).

% sgn_eq
thf(fact_3725_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A4: complex,R2: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( exp @ complex @ A4 ) ) ) ).

% complex_exp_exists
thf(fact_3726_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_3727_of__real__def,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A )
        = ( ^ [R5: real] : ( real_V8093663219630862766scaleR @ A @ R5 @ ( one_one @ A ) ) ) ) ) ).

% of_real_def
thf(fact_3728_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I4: num] : ( nat2 @ ( numeral_numeral @ int @ I4 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_3729_real__sgn__eq,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [X4: real] : ( divide_divide @ real @ X4 @ ( abs_abs @ real @ X4 ) ) ) ) ).

% real_sgn_eq
thf(fact_3730_nat__mono,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ X @ Y )
     => ( ord_less_eq @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ).

% nat_mono
thf(fact_3731_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_3732_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M: nat,N: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_3733_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) ) ) ).

% frac_ge_0
thf(fact_3734_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_3735_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_3736_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y: real,X: real] :
          ( ( Y
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_3737_nat__mono__iff,axiom,
    ! [Z: int,W2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W2 @ Z ) ) ) ).

% nat_mono_iff
thf(fact_3738_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ R @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_3739_zless__nat__eq__int__zless,axiom,
    ! [M2: nat,Z: int] :
      ( ( ord_less @ nat @ M2 @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M2 ) @ Z ) ) ).

% zless_nat_eq_int_zless
thf(fact_3740_nat__le__iff,axiom,
    ! [X: int,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X ) @ N2 )
      = ( ord_less_eq @ int @ X @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% nat_le_iff
thf(fact_3741_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_3742_nat__abs__mult__distrib,axiom,
    ! [W2: int,Z: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W2 @ Z ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W2 ) ) @ ( nat2 @ ( abs_abs @ int @ Z ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_3743_complex__of__real__mult__Complex,axiom,
    ! [R: real,X: real,Y: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X @ Y ) )
      = ( complex2 @ ( times_times @ real @ R @ X ) @ ( times_times @ real @ R @ Y ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_3744_Complex__mult__complex__of__real,axiom,
    ! [X: real,Y: real,R: real] :
      ( ( times_times @ complex @ ( complex2 @ X @ Y ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( times_times @ real @ X @ R ) @ ( times_times @ real @ Y @ R ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_3745_Complex__eq,axiom,
    ( complex2
    = ( ^ [A3: real,B3: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A3 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% Complex_eq
thf(fact_3746_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B3: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_3747_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_3748_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M: nat,N: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% or_nat_def
thf(fact_3749_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_3750_real__nat__ceiling__ge,axiom,
    ! [X: real] : ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_3751_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_3752_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_3753_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A3: real] :
          ( if @ real
          @ ( A3
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A3 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_3754_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R ) ) ) @ R ) ) ) ).

% of_nat_floor
thf(fact_3755_nat__less__eq__zless,axiom,
    ! [W2: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
     => ( ( ord_less @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W2 @ Z ) ) ) ).

% nat_less_eq_zless
thf(fact_3756_nat__le__eq__zle,axiom,
    ! [W2: int,Z: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W2 )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W2 ) @ ( nat2 @ Z ) )
        = ( ord_less_eq @ int @ W2 @ Z ) ) ) ).

% nat_le_eq_zle
thf(fact_3757_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_3758_le__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N2 @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N2 ) @ K ) ) ) ).

% le_nat_iff
thf(fact_3759_nat__add__distrib,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z6 )
       => ( ( nat2 @ ( plus_plus @ int @ Z @ Z6 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_3760_nat__mult__distrib,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z6 ) ) ) ) ).

% nat_mult_distrib
thf(fact_3761_Suc__as__int,axiom,
    ( suc
    = ( ^ [A3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_3762_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_3763_nat__div__distrib_H,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib'
thf(fact_3764_nat__div__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib
thf(fact_3765_nat__floor__neg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_3766_nat__power__eq,axiom,
    ! [Z: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( power_power @ int @ Z @ N2 ) )
        = ( power_power @ nat @ ( nat2 @ Z ) @ N2 ) ) ) ).

% nat_power_eq
thf(fact_3767_nat__mod__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( modulo_modulo @ int @ X @ Y ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_3768_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_3769_floor__eq3,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N2 ) ) ) ).

% floor_eq3
thf(fact_3770_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X ) @ A2 )
     => ( ord_less_eq @ nat @ X @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_3771_complex__of__real__i,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% complex_of_real_i
thf(fact_3772_i__complex__of__real,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% i_complex_of_real
thf(fact_3773_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R2: real,A4: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A4 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A4 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_3774_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_3775_sgn__power__injE,axiom,
    ! [A2: real,N2: nat,X: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N2 ) )
        = X )
     => ( ( X
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N2 ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_3776_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( suc @ ( nat2 @ Z ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_3777_nat__less__iff,axiom,
    ! [W2: int,M2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W2 )
     => ( ( ord_less @ nat @ ( nat2 @ W2 ) @ M2 )
        = ( ord_less @ int @ W2 @ ( semiring_1_of_nat @ int @ M2 ) ) ) ) ).

% nat_less_iff
thf(fact_3778_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z6: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z6 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z6 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_3779_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_3780_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_3781_floor__eq4,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N2 ) ) ) ).

% floor_eq4
thf(fact_3782_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_3783_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M2: int,X: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M2 ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M2 ) @ X ) ) ) ) ) ).

% cos_int_times_real
thf(fact_3784_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M2: int,X: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M2 ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M2 ) @ X ) ) ) ) ) ).

% sin_int_times_real
thf(fact_3785_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_3786_cmod__complex__polar,axiom,
    ! [R: real,A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) ) )
      = ( abs_abs @ real @ R ) ) ).

% cmod_complex_polar
thf(fact_3787_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X4: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_3788_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X4: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X4 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_3789_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_3790_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_3791_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X ) )
          = ( cos @ A @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_3792_powr__real__of__int,axiom,
    ! [X: real,N2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N2 ) )
            = ( power_power @ real @ X @ ( nat2 @ N2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N2 ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ N2 ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_3793_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X ) ) ) ) ).

% arctan_inverse
thf(fact_3794_powr__int,axiom,
    ! [X: real,I2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( power_power @ real @ X @ ( nat2 @ I2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ I2 ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_3795_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_3796_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_3797_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N2 ) ) ) ) ) ) ).

% mask_numeral
thf(fact_3798_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A3: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_3799_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( zero_zero @ int ) )
            | ( L2
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K3
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_3800_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_3801_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_3802_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_3803_mask__nat__positive__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% mask_nat_positive_iff
thf(fact_3804_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_3805_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_3806_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_3807_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_3808_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_3809_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_3810_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_3811_concat__bit__of__zero__2,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_3812_csqrt__eq__1,axiom,
    ! [Z: complex] :
      ( ( ( csqrt @ Z )
        = ( one_one @ complex ) )
      = ( Z
        = ( one_one @ complex ) ) ) ).

% csqrt_eq_1
thf(fact_3813_csqrt__1,axiom,
    ( ( csqrt @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% csqrt_1
thf(fact_3814_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_3815_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_3816_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_3817_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_3818_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_3819_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_3820_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_3821_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N2 )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_3822_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_3823_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_3824_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_3825_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_3826_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_3827_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_3828_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_3829_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_3830_take__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% take_bit_of_Suc_0
thf(fact_3831_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_3832_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_3833_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(3)
thf(fact_3834_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% take_bit_of_1
thf(fact_3835_and__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_3836_and__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_3837_power2__csqrt,axiom,
    ! [Z: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z ) ).

% power2_csqrt
thf(fact_3838_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(4)
thf(fact_3839_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(6)
thf(fact_3840_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_3841_and__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_3842_and__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_3843_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_3844_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_3845_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N2 @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_of_exp
thf(fact_3846_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_3847_nat__mask__eq,axiom,
    ! [N2: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% nat_mask_eq
thf(fact_3848_concat__bit__take__bit__eq,axiom,
    ! [N2: nat,B2: int] :
      ( ( bit_concat_bit @ N2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ B2 ) )
      = ( bit_concat_bit @ N2 @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_3849_concat__bit__eq__iff,axiom,
    ! [N2: nat,K: int,L: int,R: int,S: int] :
      ( ( ( bit_concat_bit @ N2 @ K @ L )
        = ( bit_concat_bit @ N2 @ R @ S ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N2 @ R ) )
        & ( L = S ) ) ) ).

% concat_bit_eq_iff
thf(fact_3850_less__eq__mask,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% less_eq_mask
thf(fact_3851_take__bit__mult,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ K @ L ) ) ) ).

% take_bit_mult
thf(fact_3852_take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_3853_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ Z ) @ X )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y @ X ) @ ( bit_se1065995026697491101ons_or @ A @ Z @ X ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_3854_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y @ Z ) @ X )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_3855_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_se5824344872417868541ns_and @ A @ Y @ Z ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ A @ X @ Z ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_3856_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se1065995026697491101ons_or @ A @ Y @ Z ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_3857_take__bit__diff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L ) ) ) ).

% take_bit_diff
thf(fact_3858_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M2 ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M2 ) ) ) ) ).

% take_bit_of_nat
thf(fact_3859_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_nat_mask_eq
thf(fact_3860_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M2 @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_and_eq
thf(fact_3861_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A,M2: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) )
         => ( ( ord_less_eq @ nat @ M2 @ N2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M2 @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_3862_take__bit__tightened__less__eq__nat,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M2 @ Q2 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ Q2 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_3863_take__bit__nat__less__eq__self,axiom,
    ! [N2: nat,M2: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M2 ) @ M2 ) ).

% take_bit_nat_less_eq_self
thf(fact_3864_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_3865_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A3: A,B3: A] : ( bit_se5824344872417868541ns_and @ A @ B3 @ A3 ) ) ) ) ).

% and.commute
thf(fact_3866_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_3867_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A3: A] : ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_3868_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_and_eq
thf(fact_3869_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_int_mask_eq
thf(fact_3870_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_3871_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_3872_take__bit__nat__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_3873_nat__take__bit__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_3874_take__bit__eq__mask__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_3875_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_3876_AND__upper2_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z ) ) ) ).

% AND_upper2'
thf(fact_3877_AND__upper1_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z ) ) ) ).

% AND_upper1'
thf(fact_3878_AND__upper2,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Y ) ) ).

% AND_upper2
thf(fact_3879_AND__upper1,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ X ) ) ).

% AND_upper1
thf(fact_3880_AND__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) ) ) ).

% AND_lower
thf(fact_3881_take__bit__tightened__less__eq__int,axiom,
    ! [M2: nat,N2: nat,K: int] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_3882_take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_3883_take__bit__nonnegative,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% take_bit_nonnegative
thf(fact_3884_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N2 @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_3885_not__take__bit__negative,axiom,
    ! [N2: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_3886_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_3887_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M2 @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N2 @ M2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 ) @ ( bit_ri4674362597316999326ke_bit @ A @ M2 ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_3888_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M2: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M2 @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M2 @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M2 @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_3889_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M2: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M2 @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M2 @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M2 @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_3890_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M2: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M2 @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M2 @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M2 @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_3891_plus__and__or,axiom,
    ! [X: int,Y: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) )
      = ( plus_plus @ int @ X @ Y ) ) ).

% plus_and_or
thf(fact_3892_mask__nonnegative__int,axiom,
    ! [N2: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N2 ) ) ).

% mask_nonnegative_int
thf(fact_3893_not__mask__negative__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_3894_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M2 @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_3895_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_3896_AND__upper1_H_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z ) ) ) ).

% AND_upper1''
thf(fact_3897_AND__upper2_H_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z ) ) ) ).

% AND_upper2''
thf(fact_3898_take__bit__decr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_3899_less__mask,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ) ).

% less_mask
thf(fact_3900_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_3901_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_3902_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_3903_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ).

% even_and_iff_int
thf(fact_3904_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_3905_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A3: A] : ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_3906_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_3907_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_3908_take__bit__nat__eq__self,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M2 )
        = M2 ) ) ).

% take_bit_nat_eq_self
thf(fact_3909_take__bit__nat__less__exp,axiom,
    ! [N2: nat,M2: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_nat_less_exp
thf(fact_3910_take__bit__nat__eq__self__iff,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M2 )
        = M2 )
      = ( ord_less @ nat @ M2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_3911_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N: nat,M: nat] : ( modulo_modulo @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_nat_def
thf(fact_3912_take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_int_less_exp
thf(fact_3913_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( modulo_modulo @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_def
thf(fact_3914_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_3915_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_3916_take__bit__nat__less__self__iff,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M2 ) @ M2 )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M2 ) ) ).

% take_bit_nat_less_self_iff
thf(fact_3917_Suc__mask__eq__exp,axiom,
    ! [N2: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_mask_eq_exp
thf(fact_3918_mask__nat__less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% mask_nat_less_exp
thf(fact_3919_take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_3920_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_3921_take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_3922_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_3923_take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_3924_take__bit__int__eq__self,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_3925_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_3926_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_3927_mask__half__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_3928_take__bit__incr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_3929_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_3930_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_3931_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_3932_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_3933_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_3934_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_3935_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% mask_Suc_exp
thf(fact_3936_take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_3937_take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_3938_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( plus_plus @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_3939_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_3940_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_3941_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_3942_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% mask_Suc_double
thf(fact_3943_take__bit__minus__small__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_3944_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_3945_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( member @ int @ K3 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_3946_and__int_Oelims,axiom,
    ! [X: int,Xa2: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa2 )
        = Y )
     => ( ( ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_3947_take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_3948_insert__subset,axiom,
    ! [A: $tType,X: A,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ B5 )
      = ( ( member @ A @ X @ B5 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ) ).

% insert_subset
thf(fact_3949_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A5: set @ A,B2: A] :
      ( ( ( insert2 @ A @ A2 @ A5 )
        = ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_3950_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A5: set @ A] :
      ( ( ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert2 @ A @ A2 @ A5 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_3951_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_3952_subset__Compl__singleton,axiom,
    ! [A: $tType,A5: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ ( insert2 @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A5 ) ) ) ).

% subset_Compl_singleton
thf(fact_3953_set__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N2 @ X ) )
        = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_3954_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_3955_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M2 ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_3956_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M2 ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_3957_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_3958_and__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_3959_and__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_3960_and__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_3961_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_3962_Suc__0__and__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_3963_and__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_3964_insert__mono,axiom,
    ! [A: $tType,C6: set @ A,D5: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ D5 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ A2 @ C6 ) @ ( insert2 @ A @ A2 @ D5 ) ) ) ).

% insert_mono
thf(fact_3965_subset__insert,axiom,
    ! [A: $tType,X: A,A5: set @ A,B5: set @ A] :
      ( ~ ( member @ A @ X @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B5 ) )
        = ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ) ).

% subset_insert
thf(fact_3966_subset__insertI,axiom,
    ! [A: $tType,B5: set @ A,A2: A] : ( ord_less_eq @ ( set @ A ) @ B5 @ ( insert2 @ A @ A2 @ B5 ) ) ).

% subset_insertI
thf(fact_3967_subset__insertI2,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ B2 @ B5 ) ) ) ).

% subset_insertI2
thf(fact_3968_num__induct,axiom,
    ! [P: num > $o,X: num] :
      ( ( P @ one2 )
     => ( ! [X3: num] :
            ( ( P @ X3 )
           => ( P @ ( inc @ X3 ) ) )
       => ( P @ X ) ) ) ).

% num_induct
thf(fact_3969_add__inc,axiom,
    ! [X: num,Y: num] :
      ( ( plus_plus @ num @ X @ ( inc @ Y ) )
      = ( inc @ ( plus_plus @ num @ X @ Y ) ) ) ).

% add_inc
thf(fact_3970_subset__singleton__iff,axiom,
    ! [A: $tType,X8: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( insert2 @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X8
          = ( bot_bot @ ( set @ A ) ) )
        | ( X8
          = ( insert2 @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_3971_subset__singletonD,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        | ( A5
          = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_3972_subset__Diff__insert,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,X: A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B5 @ ( insert2 @ A @ X @ C6 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B5 @ C6 ) )
        & ~ ( member @ A @ X @ A5 ) ) ) ).

% subset_Diff_insert
thf(fact_3973_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_3974_inc_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit1 @ X ) )
      = ( bit0 @ ( inc @ X ) ) ) ).

% inc.simps(3)
thf(fact_3975_inc_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit0 @ X ) )
      = ( bit1 @ X ) ) ).

% inc.simps(2)
thf(fact_3976_add__One,axiom,
    ! [X: num] :
      ( ( plus_plus @ num @ X @ one2 )
      = ( inc @ X ) ) ).

% add_One
thf(fact_3977_inc__BitM__eq,axiom,
    ! [N2: num] :
      ( ( inc @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% inc_BitM_eq
thf(fact_3978_BitM__inc__eq,axiom,
    ! [N2: num] :
      ( ( bitM @ ( inc @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% BitM_inc_eq
thf(fact_3979_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M: nat,N: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% and_nat_def
thf(fact_3980_subset__insert__iff,axiom,
    ! [A: $tType,A5: set @ A,X: A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B5 ) )
      = ( ( ( member @ A @ X @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B5 ) )
        & ( ~ ( member @ A @ X @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ) ) ).

% subset_insert_iff
thf(fact_3981_Diff__single__insert,axiom,
    ! [A: $tType,A5: set @ A,X: A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B5 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B5 ) ) ) ).

% Diff_single_insert
thf(fact_3982_mult__inc,axiom,
    ! [X: num,Y: num] :
      ( ( times_times @ num @ X @ ( inc @ Y ) )
      = ( plus_plus @ num @ ( times_times @ num @ X @ Y ) @ X ) ) ).

% mult_inc
thf(fact_3983_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I2 @ X ) ) @ ( insert2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_update_subset_insert
thf(fact_3984_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_3985_psubset__insert__iff,axiom,
    ! [A: $tType,A5: set @ A,X: A,B5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ B5 ) )
      = ( ( ( member @ A @ X @ B5 )
         => ( ord_less @ ( set @ A ) @ A5 @ B5 ) )
        & ( ~ ( member @ A @ X @ B5 )
         => ( ( ( member @ A @ X @ A5 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B5 ) )
            & ( ~ ( member @ A @ X @ A5 )
             => ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_3986_set__replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N2 ) @ X ) )
      = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_3987_set__replicate__conv__if,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X ) )
          = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_3988_atLeastAtMostPlus1__int__conv,axiom,
    ! [M2: int,N2: int] :
      ( ( ord_less_eq @ int @ M2 @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M2 @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
        = ( insert2 @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) @ ( set_or1337092689740270186AtMost @ int @ M2 @ N2 ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_3989_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert2 @ int @ I4 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_3990_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sinh @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X ) @ ( insert2 @ A @ ( one_one @ A ) @ ( insert2 @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_3991_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M: nat,N: nat] :
          ( if @ nat
          @ ( ( M
              = ( zero_zero @ nat ) )
            | ( N
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_3992_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_3993_and__int_Opelims,axiom,
    ! [X: int,Xa2: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) ) ) ) ) ).

% and_int.pelims
thf(fact_3994_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_3995_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K3 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_3996_cis__multiple__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_3997_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_3998_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M2 ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M2 ) @ N2 ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_3999_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M2 ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M2 ) @ N2 ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_4000_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ) ).

% floor_add2
thf(fact_4001_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) )
          = ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_4002_signed__take__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_4003_signed__take__bit__negative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ).

% signed_take_bit_negative_iff
thf(fact_4004_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W2: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W2 ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W2 ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_4005_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W2: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W2 ) ) ) @ ( suc @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W2 ) ) @ N2 ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_4006_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W2: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W2 ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W2 ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_4007_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W2: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W2 ) ) ) @ ( suc @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W2 ) @ N2 ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_4008_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_4009_bit__minus__numeral__int_I1_J,axiom,
    ! [W2: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W2 ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W2 ) ) @ ( pred_numeral @ N2 ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_4010_bit__minus__numeral__int_I2_J,axiom,
    ! [W2: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W2 ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W2 ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_4011_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 )
          = ( ( N2
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_4012_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_and_iff
thf(fact_4013_bit__and__int__iff,axiom,
    ! [K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ L @ N2 ) ) ) ).

% bit_and_int_iff
thf(fact_4014_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M2 ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M2 ) @ N2 ) ) ) ).

% bit_numeral_iff
thf(fact_4015_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: num] : ( member @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_4016_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_4017_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_4018_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_4019_bit__or__int__iff,axiom,
    ! [K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        | ( bit_se5641148757651400278ts_bit @ int @ L @ N2 ) ) ) ).

% bit_or_int_iff
thf(fact_4020_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_or_iff
thf(fact_4021_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M2 ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ M2 @ N2 ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_4022_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_4023_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M2 @ A2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( M2 != N2 ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_4024_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_4025_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N2 ) ) ) ).

% not_bit_1_Suc
thf(fact_4026_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N2 )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_4027_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% bit_numeral_simps(1)
thf(fact_4028_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_4029_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M2 @ A2 ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ M2 )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_take_bit_iff
thf(fact_4030_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N2 )
          = ( B2
            & ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_4031_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_4032_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_4033_bit__not__int__iff_H,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff'
thf(fact_4034_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_4035_atLeastAtMost__insertL,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( insert2 @ nat @ M2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N2 ) )
        = ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4036_atLeastAtMostSuc__conv,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ ( suc @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M2 @ ( suc @ N2 ) )
        = ( insert2 @ nat @ ( suc @ N2 ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4037_Icc__eq__insert__lb__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 )
        = ( insert2 @ nat @ M2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M2 ) @ N2 ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4038_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert2 @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_4039_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert2 @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_4040_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_4041_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N: nat,A3: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N @ A3 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_4042_bit__imp__take__bit__positive,axiom,
    ! [N2: nat,M2: nat,K: int] :
      ( ( ord_less @ nat @ N2 @ M2 )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M2 @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_4043_bit__concat__bit__iff,axiom,
    ! [M2: nat,K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M2 @ K @ L ) @ N2 )
      = ( ( ( ord_less @ nat @ N2 @ M2 )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) )
        | ( ( ord_less_eq @ nat @ M2 @ N2 )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_4044_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_4045_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_4046_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_4047_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_4048_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_4049_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_concat_bit @ N @ K3 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_4050_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_4051_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) ) ).

% bit_Suc
thf(fact_4052_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_4053_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_4054_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M3 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_4055_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_4056_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_4057_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_4058_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K3: int,N: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% bit_int_def
thf(fact_4059_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_4060_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_4061_set__decode__plus__power__2,axiom,
    ! [N2: nat,Z: nat] :
      ( ~ ( member @ nat @ N2 @ ( nat_set_decode @ Z ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ Z ) )
        = ( insert2 @ nat @ N2 @ ( nat_set_decode @ Z ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4062_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_4063_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_4064_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_4065_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N2 )
            = ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N2 ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_4066_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N: nat] :
              ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_4067_sin__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_4068_cos__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_4069_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K2: int,L4: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L4 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L4 @ ( insert2 @ int @ ( zero_zero @ int ) @ ( insert2 @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L4 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_4070_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N: nat,K3: int] :
          ( plus_plus @ int @ K3
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% set_bit_eq
thf(fact_4071_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N: nat,K3: int] : ( minus_minus @ int @ K3 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% unset_bit_eq
thf(fact_4072_take__bit__Suc__from__most,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_4073_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I3: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I3 @ J2 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I3 @ J2 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_4074_pred__subset__eq,axiom,
    ! [A: $tType,R3: set @ A,S2: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X4: A] : ( member @ A @ X4 @ R3 )
        @ ^ [X4: A] : ( member @ A @ X4 @ S2 ) )
      = ( ord_less_eq @ ( set @ A ) @ R3 @ S2 ) ) ).

% pred_subset_eq
thf(fact_4075_xor__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_4076_Suc__0__xor__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_4077_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) )
          = Y ) ) ).

% bit.xor_left_self
thf(fact_4078_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_4079_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_4080_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_4081_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_4082_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_4083_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_4084_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_4085_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_4086_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y ) ) ) ) ).

% xor_numerals(2)
thf(fact_4087_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% xor_numerals(1)
thf(fact_4088_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_4089_xor__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% xor_nat_numerals(1)
thf(fact_4090_xor__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y ) ) ) ).

% xor_nat_numerals(2)
thf(fact_4091_xor__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% xor_nat_numerals(3)
thf(fact_4092_xor__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X ) ) ) ).

% xor_nat_numerals(4)
thf(fact_4093_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_4094_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_4095_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N2 )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_xor_iff
thf(fact_4096_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_xor_eq
thf(fact_4097_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_4098_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A3: A,B3: A] : ( bit_se5824344971392196577ns_xor @ A @ B3 @ A3 ) ) ) ) ).

% xor.commute
thf(fact_4099_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_4100_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M2 @ N2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M2 ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_xor_eq
thf(fact_4101_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y @ Z ) @ X )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_4102_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ Y @ Z ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_4103_not__bit__Suc__0__Suc,axiom,
    ! [N2: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N2 ) ) ).

% not_bit_Suc_0_Suc
thf(fact_4104_bit__Suc__0__iff,axiom,
    ! [N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_4105_not__bit__Suc__0__numeral,axiom,
    ! [N2: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N2 ) ) ).

% not_bit_Suc_0_numeral
thf(fact_4106_bit__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N2 )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_nat_iff
thf(fact_4107_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_4108_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M: nat,N: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% bit_nat_def
thf(fact_4109_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M: nat,N: nat] :
          ( if @ nat
          @ ( M
            = ( zero_zero @ nat ) )
          @ N
          @ ( if @ nat
            @ ( N
              = ( zero_zero @ nat ) )
            @ M
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_4110_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M: nat,N: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_4111_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_4112_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_4113_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_4114_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_4115_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N2 ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_4116_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4117_push__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_4118_push__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_4119_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_4120_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_4121_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M2 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M2 @ N2 ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_4122_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_4123_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_4124_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_4125_concat__bit__of__zero__1,axiom,
    ! [N2: nat,L: int] :
      ( ( bit_concat_bit @ N2 @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N2 @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_4126_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_4127_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_4128_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_4129_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_4130_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_4131_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_4132_push__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% push_bit_of_Suc_0
thf(fact_4133_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_of_1
thf(fact_4134_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( ( N2
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_4135_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_4136_bit__xor__int__iff,axiom,
    ! [K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ N2 )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
         != ( bit_se5641148757651400278ts_bit @ int @ L @ N2 ) ) ) ) ).

% bit_xor_int_iff
thf(fact_4137_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_se5824344971392196577ns_xor @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_4138_push__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_4139_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_4140_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M2 ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N2 @ M2 ) ) ) ) ).

% push_bit_of_nat
thf(fact_4141_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M2 @ N2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_push_bit
thf(fact_4142_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_4143_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_4144_XOR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) ) ) ) ).

% XOR_lower
thf(fact_4145_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M2 @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M2 @ N2 ) @ ( bit_se4730199178511100633sh_bit @ A @ M2 @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_4146_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M2 @ N2 ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_4147_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M: nat,N: nat] : ( bit_se1065995026697491101ons_or @ nat @ N @ ( bit_se4730199178511100633sh_bit @ nat @ M @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_4148_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M: nat,N: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N @ ( bit_se4730199178511100633sh_bit @ nat @ M @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_4149_bit__push__bit__iff__int,axiom,
    ! [M2: nat,K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M2 @ K ) @ N2 )
      = ( ( ord_less_eq @ nat @ M2 @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_4150_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M: nat,N: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% xor_nat_def
thf(fact_4151_bit__push__bit__iff__nat,axiom,
    ! [M2: nat,Q2: nat,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M2 @ Q2 ) @ N2 )
      = ( ( ord_less_eq @ nat @ M2 @ N2 )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q2 @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_4152_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N: nat,K3: int,L2: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ L2 ) ) ) ) ).

% concat_bit_eq
thf(fact_4153_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N: nat,A3: A] : ( bit_se1065995026697491101ons_or @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4154_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N: nat,K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ L2 ) ) ) ) ).

% concat_bit_def
thf(fact_4155_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N: nat,A3: A] : ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_4156_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_se1065995026697491101ons_or @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4157_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_4158_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_4159_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N: nat,K3: int] : ( times_times @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% push_bit_int_def
thf(fact_4160_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N: nat,M: nat] : ( times_times @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% push_bit_nat_def
thf(fact_4161_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N: nat,A3: A] : ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_4162_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 )
         => ~ ! [B4: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N2 @ B4 ) ) ) ) ).

% exp_dvdE
thf(fact_4163_push__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_minus_one
thf(fact_4164_XOR__upper,axiom,
    ! [X: int,N2: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% XOR_upper
thf(fact_4165_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A3: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A3 ) @ N ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A3 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A3 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4166_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_4167_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( K3
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L2 )
          @ ( if @ int
            @ ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K3 )
            @ ( if @ int
              @ ( K3
                = ( zero_zero @ int ) )
              @ L2
              @ ( if @ int
                @ ( L2
                  = ( zero_zero @ int ) )
                @ K3
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_4168_set__encode__insert,axiom,
    ! [A5: set @ nat,N2: nat] :
      ( ( finite_finite @ nat @ A5 )
     => ( ~ ( member @ nat @ N2 @ A5 )
       => ( ( nat_set_encode @ ( insert2 @ nat @ N2 @ A5 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( nat_set_encode @ A5 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4169_Sum__Ico__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M2 @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4170_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_4171_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_4172_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_4173_set__vebt__finite,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_finite
thf(fact_4174_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X )
            = ( bit_ri4277139882892585799ns_not @ A @ Y ) )
          = ( X = Y ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_4175_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = X ) ) ).

% bit.double_compl
thf(fact_4176_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list @ A] : ( finite_finite @ A @ ( set2 @ A @ Xs ) ) ).

% List.finite_set
thf(fact_4177_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ Y ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) ) ) ) ).

% bit.xor_compl_right
thf(fact_4178_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ Y )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) ) ) ) ).

% bit.xor_compl_left
thf(fact_4179_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I2 )
            & ( ord_less @ A @ I2 @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4180_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4181_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4182_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,J: A,M2: A,N2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ N2 ) )
          = ( ( ord_less_eq @ A @ J @ I2 )
            | ( ( ord_less_eq @ A @ M2 @ I2 )
              & ( ord_less_eq @ A @ J @ N2 ) ) ) ) ) ).

% ivl_subset
thf(fact_4183_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_4184_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_4185_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4186_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G2: B > A] :
          ( ~ ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_4187_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,N2: A,M2: A] :
          ( ( ord_less_eq @ A @ I2 @ N2 )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ N2 ) )
            = ( set_or7035219750837199246ssThan @ A @ N2 @ M2 ) ) ) ) ).

% ivl_diff
thf(fact_4188_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_4189_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_4190_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_4191_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_4192_prod__eq__1__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A5 )
          = ( one_one @ nat ) )
        = ( ! [X4: A] :
              ( ( member @ A @ X4 @ A5 )
             => ( ( F2 @ X4 )
                = ( one_one @ nat ) ) ) ) ) ) ).

% prod_eq_1_iff
thf(fact_4193_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_4194_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_4195_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,X: B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ~ ( member @ B @ X @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
              = ( plus_plus @ A @ ( G2 @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) ) ) ) ) ) ).

% sum.insert
thf(fact_4196_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_4197_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_4198_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,X: B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ~ ( member @ B @ X @ A5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
              = ( times_times @ A @ ( G2 @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ) ) ).

% prod.insert
thf(fact_4199_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_4200_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_4201_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_4202_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_4203_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_4204_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_4205_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_4206_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_4207_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_4208_prod__pos__nat__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A5 ) )
        = ( ! [X4: A] :
              ( ( member @ A @ X4 @ A5 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X4 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4209_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_4210_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_4211_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_4212_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M2: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4213_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M2: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4214_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A5: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A5 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A5 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A5 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4215_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A5: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A5 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A5 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A5 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A5 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A5 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4216_or__minus__minus__numerals,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_4217_and__minus__minus__numerals,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_4218_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_4219_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4220_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4221_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4222_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4223_finite__list,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [Xs2: list @ A] :
          ( ( set2 @ A @ Xs2 )
          = A5 ) ) ).

% finite_list
thf(fact_4224_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N9: set @ nat] :
        ? [M: nat] :
        ! [X4: nat] :
          ( ( member @ nat @ X4 @ N9 )
         => ( ord_less_eq @ nat @ X4 @ M ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_4225_bounded__nat__set__is__finite,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ! [X3: nat] :
          ( ( member @ nat @ X3 @ N4 )
         => ( ord_less @ nat @ X3 @ N2 ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4226_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N9: set @ nat] :
        ? [M: nat] :
        ! [X4: nat] :
          ( ( member @ nat @ X4 @ N9 )
         => ( ord_less @ nat @ X4 @ M ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4227_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_4228_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_4229_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_4230_bit__not__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff
thf(fact_4231_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I2: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K3: nat] :
            ( ( P @ K3 )
            & ( ord_less @ nat @ K3 @ I2 ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4232_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F2 @ N3 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N: nat] : ( ord_less_eq @ nat @ ( F2 @ N ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4233_finite__lists__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
              & ( ( size_size @ ( list @ A ) @ Xs3 )
                = N2 ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_4234_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4235_all__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M: nat] :
            ( ( ord_less @ nat @ M @ N2 )
           => ( P @ M ) ) )
      = ( ! [X4: nat] :
            ( ( member @ nat @ X4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X4 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4236_ex__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M: nat] :
            ( ( ord_less @ nat @ M @ N2 )
            & ( P @ M ) ) )
      = ( ? [X4: nat] :
            ( ( member @ nat @ X4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X4 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4237_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_4238_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_4239_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X8: set @ A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ? [Xa: A] :
                    ( ( member @ A @ Xa @ X8 )
                    & ( ord_less @ A @ X3 @ Xa ) ) )
           => ~ ( finite_finite @ A @ X8 ) ) ) ) ).

% infinite_growing
thf(fact_4240_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ~ ? [Xa: A] :
                      ( ( member @ A @ Xa @ S2 )
                      & ( ord_less @ A @ Xa @ X3 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_4241_sum__mono__inv,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I7 > A,I6: set @ I7,G2: I7 > A,I2: I7] :
          ( ( ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ I6 )
            = ( groups7311177749621191930dd_sum @ I7 @ A @ G2 @ I6 ) )
         => ( ! [I3: I7] :
                ( ( member @ I7 @ I3 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G2 @ I3 ) ) )
           => ( ( member @ I7 @ I2 @ I6 )
             => ( ( finite_finite @ I7 @ I6 )
               => ( ( F2 @ I2 )
                  = ( G2 @ I2 ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_4242_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4243_finite__lists__length__le,axiom,
    ! [A: $tType,A5: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N2 ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4244_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A3: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_4245_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A3: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_4246_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) ) ) ) ).

% or_int_def
thf(fact_4247_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4248_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I6 )
                  & ( ( X @ I4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( Y @ I4 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( plus_plus @ A @ ( X @ I4 ) @ ( Y @ I4 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4249_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I6 )
                  & ( ( X @ I4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( Y @ I4 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( times_times @ A @ ( X @ I4 ) @ ( Y @ I4 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_4250_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4251_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2
              @ ( collect @ B
                @ ^ [X4: B] :
                    ( ( member @ B @ X4 @ A5 )
                    & ( P @ X4 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( P @ X4 ) @ ( G2 @ X4 ) @ ( one_one @ A ) )
              @ A5 ) ) ) ) ).

% prod.inter_filter
thf(fact_4252_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X4 )
                & ( ord_less_eq @ A @ X4 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4253_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G2: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G2 @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4254_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G2: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G2 @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4255_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu2: $o,Uv2: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_4256_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A3: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_4257_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_4258_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A3: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_4259_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,P4: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P4 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ P4 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4260_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N2: nat,P4: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P4 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ P4 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P4 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4261_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_4262_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,P4: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P4 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ P4 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4263_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_4264_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4265_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A5 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 )
                = ( zero_zero @ A ) )
              = ( ! [X4: B] :
                    ( ( member @ B @ X4 @ A5 )
                   => ( ( F2 @ X4 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4266_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T2: set @ C,G2: C > A,I2: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G2 @ X3 ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ? [Xa: C] :
                        ( ( member @ C @ Xa @ T2 )
                        & ( ( I2 @ Xa )
                          = X3 )
                        & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ Xa ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G2 @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4267_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A5: set @ I7,F2: I7 > A,G2: I7 > A] :
          ( ( finite_finite @ I7 @ A5 )
         => ( ! [X3: I7] :
                ( ( member @ I7 @ X3 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
           => ( ? [X2: I7] :
                  ( ( member @ I7 @ X2 @ A5 )
                  & ( ord_less @ A @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ I7 @ A @ G2 @ A5 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4268_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R3: A > A > $o,S2: set @ B,H2: B > A,G2: B > A] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( ( R3 @ X1 @ X23 )
                  & ( R3 @ Y1 @ Y23 ) )
               => ( R3 @ ( plus_plus @ A @ X1 @ Y1 ) @ ( plus_plus @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( R3 @ ( H2 @ X3 ) @ ( G2 @ X3 ) ) )
               => ( R3 @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4269_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B,S4: set @ B] :
                  ( ( finite_finite @ B @ S4 )
                 => ( ! [Y5: B] :
                        ( ( member @ B @ Y5 @ S4 )
                       => ( ord_less_eq @ A @ ( F2 @ Y5 ) @ ( F2 @ X3 ) ) )
                   => ( ( P @ S4 )
                     => ( P @ ( insert2 @ B @ X3 @ S4 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4270_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A5 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X2: A] :
                        ( ( member @ A @ X2 @ A8 )
                       => ( ord_less @ A @ B4 @ X2 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert2 @ A @ B4 @ A8 ) ) ) ) )
             => ( P @ A5 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4271_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A5 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X2: A] :
                        ( ( member @ A @ X2 @ A8 )
                       => ( ord_less @ A @ X2 @ B4 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert2 @ A @ B4 @ A8 ) ) ) ) )
             => ( P @ A5 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4272_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A5: set @ B,F2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A5 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_4273_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R3: A > A > $o,S2: set @ B,H2: B > A,G2: B > A] :
          ( ( R3 @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y23: A] :
                ( ( ( R3 @ X1 @ X23 )
                  & ( R3 @ Y1 @ Y23 ) )
               => ( R3 @ ( times_times @ A @ X1 @ Y1 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( R3 @ ( H2 @ X3 ) @ ( G2 @ X3 ) ) )
               => ( R3 @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_4274_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,X: B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ( member @ B @ X @ A5 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) ) )
            & ( ~ ( member @ B @ X @ A5 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
                = ( plus_plus @ A @ ( G2 @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_4275_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_4276_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,X: B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ( member @ B @ X @ A5 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) )
            & ( ~ ( member @ B @ X @ A5 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
                = ( times_times @ A @ ( G2 @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_4277_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B5: set @ B,A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B5 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B5 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_4278_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B5: set @ B,A5: set @ B,F2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ B5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B5 )
           => ( ! [A4: B] :
                  ( ( member @ B @ A4 @ A5 )
                 => ( dvd_dvd @ A @ ( F2 @ A4 ) @ ( G2 @ A4 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ B5 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_4279_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S5: set @ B,T5: set @ C,S2: set @ B,I2: C > B,J: B > C,T6: set @ C,G2: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A4: B] :
                  ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) )
                 => ( ( I2 @ ( J @ A4 ) )
                    = A4 ) )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) )
                   => ( member @ C @ ( J @ A4 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B4: C] :
                      ( ( member @ C @ B4 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J @ ( I2 @ B4 ) )
                        = B4 ) )
                 => ( ! [B4: C] :
                        ( ( member @ C @ B4 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member @ B @ ( I2 @ B4 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) ) )
                   => ( ! [A4: B] :
                          ( ( member @ B @ A4 @ S5 )
                         => ( ( G2 @ A4 )
                            = ( one_one @ A ) ) )
                     => ( ! [B4: C] :
                            ( ( member @ C @ B4 @ T5 )
                           => ( ( H2 @ B4 )
                              = ( one_one @ A ) ) )
                       => ( ! [A4: B] :
                              ( ( member @ B @ A4 @ S2 )
                             => ( ( H2 @ ( J @ A4 ) )
                                = ( G2 @ A4 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_4280_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_4281_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_4282_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X4: A,Y4: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X4 @ Y4 ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X4 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y4 ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4283_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X4: A,Y4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X4 @ ( bit_ri4277139882892585799ns_not @ A @ Y4 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X4 ) @ Y4 ) ) ) ) ) ).

% bit.xor_def
thf(fact_4284_sum__eq__1__iff,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 )
          = ( one_one @ nat ) )
        = ( ? [X4: A] :
              ( ( member @ A @ X4 @ A5 )
              & ( ( F2 @ X4 )
                = ( one_one @ nat ) )
              & ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A5 )
                 => ( ( X4 != Y4 )
                   => ( ( F2 @ Y4 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4285_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N: nat,K3: int] : ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_4286_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ L2 ) ) ) ) ).

% xor_int_def
thf(fact_4287_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I2 @ S )
               => ( ( F2 @ I2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4288_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,B5: A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = B5 )
             => ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ B5 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4289_finite__divisors__nat,axiom,
    ! [M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D3: nat] : ( dvd_dvd @ nat @ D3 @ M2 ) ) ) ) ).

% finite_divisors_nat
thf(fact_4290_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2
              @ ( minus_minus @ ( set @ B ) @ A5
                @ ( collect @ B
                  @ ^ [X4: B] :
                      ( ( G2 @ X4 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_4291_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K3: A] :
                ( ( member @ A @ K3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K3 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4292_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_4293_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_4294_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4295_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4296_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4297_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) )
            = ( plus_plus @ A @ ( G2 @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4298_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G2 @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4299_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_4300_and__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_4301_and__not__numerals_I4_J,axiom,
    ! [M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M2 ) ) ) ).

% and_not_numerals(4)
thf(fact_4302_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4303_or__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4304_or__not__numerals_I4_J,axiom,
    ! [M2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4305_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less @ nat @ M2 @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) )
            = ( times_times @ A @ ( G2 @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M2 ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4306_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G2 @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4307_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( plus_plus @ A @ ( G2 @ N2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4308_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,I2: B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( member @ B @ I2 @ I6 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ I6 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4309_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( times_times @ A @ ( G2 @ N2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4310_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ I6 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ).

% sum_pos
thf(fact_4311_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,I2: A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( member @ A @ I2 @ I6 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) )
             => ( ! [I3: A] :
                    ( ( member @ A @ I3 @ I6 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4312_bit__minus__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N2 )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N2 ) ) ).

% bit_minus_int_iff
thf(fact_4313_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I6 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_4314_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_4315_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A5: set @ B,B5: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B5 @ C6 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C6 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C6 @ B5 ) )
                     => ( ( H2 @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B5 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4316_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A5: set @ B,B5: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B5 @ C6 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C6 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C6 @ B5 ) )
                     => ( ( H2 @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B5 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4317_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G2 @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4318_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4319_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,H2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G2 @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ S2 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4320_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G2 @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ T6 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4321_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B5: set @ B,A5: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B5 @ A5 )
         => ( ( finite_finite @ B @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ B5 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_4322_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: set @ B,B5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ord_less_eq @ ( set @ B ) @ B5 @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B5 ) ) ) ) ) ) ).

% sum_diff
thf(fact_4323_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_4324_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B5: set @ B,A5: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B5 @ A5 )
         => ( ( finite_finite @ B @ A5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ B5 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_4325_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G2 @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ T6 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_4326_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,H2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ( ( G2 @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_4327_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_4328_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( G2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G2 @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_4329_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A5: set @ B,B5: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B5 @ C6 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C6 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( one_one @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C6 @ B5 ) )
                     => ( ( H2 @ B4 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B5 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_4330_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A5: set @ B,B5: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B5 @ C6 )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ ( minus_minus @ ( set @ B ) @ C6 @ A5 ) )
                   => ( ( G2 @ A4 )
                      = ( one_one @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C6 @ B5 ) )
                     => ( ( H2 @ B4 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B5 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_4331_numeral__or__not__num__eq,axiom,
    ! [M2: num,N2: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M2 @ N2 ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_4332_int__numeral__not__or__num__neg,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N2 @ M2 ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_4333_int__numeral__or__not__num__neg,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M2 @ N2 ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_4334_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M2: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M2 ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4335_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M2 @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N2 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M2 ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_4336_sum__diff__nat,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B5 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_4337_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N: nat,A3: A] : ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_4338_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ ( suc @ I4 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M2 ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_4339_atLeastLessThanSuc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ( ord_less_eq @ nat @ M2 @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N2 ) )
          = ( insert2 @ nat @ N2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M2 @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( suc @ N2 ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_4340_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat,M2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ ( suc @ I4 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M2 ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_4341_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_4342_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_4343_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z5: A] :
                  ( ( power_power @ A @ Z5 @ N2 )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4344_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G2: nat > A,S2: A,A5: set @ nat,S5: A,F2: nat > A] :
          ( ( sums @ A @ G2 @ S2 )
         => ( ( finite_finite @ nat @ A5 )
           => ( ( S5
                = ( plus_plus @ A @ S2
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N: nat] : ( minus_minus @ A @ ( F2 @ N ) @ ( G2 @ N ) )
                    @ A5 ) ) )
             => ( sums @ A
                @ ^ [N: nat] : ( if @ A @ ( member @ nat @ N @ A5 ) @ ( F2 @ N ) @ ( G2 @ N ) )
                @ S5 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_4345_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S5: set @ B,T5: set @ C,H2: B > C,S2: set @ B,T6: set @ C,G2: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A4: B] :
                    ( ( member @ B @ A4 @ S5 )
                   => ( ( G2 @ ( H2 @ A4 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B4: C] :
                      ( ( member @ C @ B4 @ T5 )
                     => ( ( G2 @ B4 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X4: B] : ( G2 @ ( H2 @ X4 ) )
                      @ S2 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G2 @ T6 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_4346_and__not__numerals_I5_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_4347_and__not__numerals_I7_J,axiom,
    ! [M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M2 ) ) ) ).

% and_not_numerals(7)
thf(fact_4348_or__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4349_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M2: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4350_and__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_4351_or__not__numerals_I7_J,axiom,
    ! [M2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4352_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M2: nat,G2: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) @ ( G2 @ N2 ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4353_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_4354_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A5 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                  & ( ord_less @ A @ ( F2 @ I3 ) @ ( G2 @ I3 ) ) ) )
           => ( ( A5
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_4355_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B5: set @ B,A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B5 )
           => ( ! [B4: B] :
                  ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ B5 @ A5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B5 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4356_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) )
            = ( ? [X4: B] :
                  ( ( member @ B @ X4 @ A5 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4357_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,X: B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( member @ B @ X @ A5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
              = ( plus_plus @ A @ ( G2 @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_4358_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G2: B > A,X: B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
            = ( plus_plus @ A @ ( G2 @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_4359_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,X: B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( member @ B @ X @ A5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
              = ( times_times @ A @ ( G2 @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_4360_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G2: B > A,X: B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( insert2 @ B @ X @ A5 ) )
            = ( times_times @ A @ ( G2 @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_4361_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I6: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I6 )
           => ( ! [N3: nat] :
                  ( ( member @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I6 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I6 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4362_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat,M2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M2 ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4363_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat,M2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G2 @ ( minus_minus @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M2 ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4364_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4365_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4366_atLeastLessThan__nat__numeral,axiom,
    ! [M2: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M2 @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( numeral_numeral @ nat @ K ) )
          = ( insert2 @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M2 @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M2 @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M2 @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_4367_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_4368_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_4369_and__not__numerals_I6_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_4370_and__not__numerals_I9_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_4371_or__not__numerals_I6_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4372_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N2 )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_not_iff_eq
thf(fact_4373_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N9: nat] :
                ! [M: nat] :
                  ( ( ord_less_eq @ nat @ N9 @ M )
                 => ! [N: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4374_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_4375_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B5: set @ A,A5: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B5 @ A5 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ B5 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B5 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4376_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I2: C,A5: set @ C,F2: C > B] :
          ( ( member @ C @ I2 @ A5 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ ( minus_minus @ ( set @ C ) @ A5 @ ( insert2 @ C @ I2 @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
           => ( ( finite_finite @ C @ A5 )
             => ( ord_less_eq @ B @ ( F2 @ I2 ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A5 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4377_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B5: set @ A,A5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ ( minus_minus @ ( set @ A ) @ B5 @ A5 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B4 ) ) )
             => ( ! [A4: A] :
                    ( ( member @ A @ A4 @ A5 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A4 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B5 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4378_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A5: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A5 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A5 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4379_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_4380_even__set__encode__iff,axiom,
    ! [A5: set @ nat] :
      ( ( finite_finite @ nat @ A5 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A5 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A5 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4381_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N: nat,A3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( bit_se4730199178511100633sh_bit @ A @ K3 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A3 @ K3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% take_bit_sum
thf(fact_4382_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X4: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X4 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N2 )
                & ( ( C2 @ I4 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4383_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4384_or__not__numerals_I5_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4385_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N2 @ K ) @ N2 ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4386_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4387_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K3 @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4388_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4389_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4390_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) )
              @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4391_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N: nat,A3: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A3 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4392_and__not__numerals_I8_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_4393_or__not__numerals_I8_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4394_or__not__numerals_I9_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4395_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_4396_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4397_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ ( F3 @ ( nth @ B @ Xs3 @ N ) ) @ ( power_power @ A @ A3 @ N ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4398_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: nat > A,B2: nat > A] :
          ( ! [I3: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I3 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N2 )
               => ( ord_less_eq @ A @ ( A2 @ I3 ) @ ( A2 @ J2 ) ) ) )
         => ( ! [I3: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N2 )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I3 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ K3 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4399_Chebyshev__sum__upper__nat,axiom,
    ! [N2: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I3: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I3 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N2 )
           => ( ord_less_eq @ nat @ ( A2 @ I3 ) @ ( A2 @ J2 ) ) ) )
     => ( ! [I3: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I3 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N2 )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I3 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N2
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( B2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4400_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N: nat] : ( ord_less_eq @ nat @ N @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4401_finite__Collect__subsets,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A5 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_4402_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N: nat] : ( ord_less @ nat @ N @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4403_finite__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z5: complex] :
              ( ( power_power @ complex @ Z5 @ N2 )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_4404_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M7 )
     => ? [N3: nat] :
        ! [X2: list @ A] :
          ( ( member @ ( list @ A ) @ X2 @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X2 ) @ N3 ) ) ) ).

% finite_maxlen
thf(fact_4405_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ L @ ( plus_plus @ int @ U @ ( one_one @ int ) ) )
      = ( set_or1337092689740270186AtMost @ int @ L @ U ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
thf(fact_4406_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A5 )
                & ( ord_less_eq @ A @ X3 @ A2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A5 )
                   => ( ( ord_less_eq @ A @ Xa @ X3 )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_4407_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A5 )
                & ( ord_less_eq @ A @ A2 @ X3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A5 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_4408_finite__subset,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( finite_finite @ A @ B5 )
       => ( finite_finite @ A @ A5 ) ) ) ).

% finite_subset
thf(fact_4409_infinite__super,axiom,
    ! [A: $tType,S2: set @ A,T6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ T6 ) ) ) ).

% infinite_super
thf(fact_4410_rev__finite__subset,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
       => ( finite_finite @ A @ A5 ) ) ) ).

% rev_finite_subset
thf(fact_4411_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A5 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A5 )
                   => ( ( ord_less_eq @ A @ Xa @ X3 )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_4412_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A5 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A5 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_4413_finite__subset__induct_H,axiom,
    ! [A: $tType,F4: set @ A,A5: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A5 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A4: A,F5: set @ A] :
                ( ( finite_finite @ A @ F5 )
               => ( ( member @ A @ A4 @ A5 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F5 @ A5 )
                   => ( ~ ( member @ A @ A4 @ F5 )
                     => ( ( P @ F5 )
                       => ( P @ ( insert2 @ A @ A4 @ F5 ) ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_4414_finite__subset__induct,axiom,
    ! [A: $tType,F4: set @ A,A5: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A5 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A4: A,F5: set @ A] :
                ( ( finite_finite @ A @ F5 )
               => ( ( member @ A @ A4 @ A5 )
                 => ( ~ ( member @ A @ A4 @ F5 )
                   => ( ( P @ F5 )
                     => ( P @ ( insert2 @ A @ A4 @ F5 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_4415_finite__remove__induct,axiom,
    ! [A: $tType,B5: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B5 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B5 )
                 => ( ! [X2: A] :
                        ( ( member @ A @ X2 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B5 ) ) ) ) ).

% finite_remove_induct
thf(fact_4416_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B5: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B5 )
         => ( P @ B5 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B5 )
                 => ( ! [X2: A] :
                        ( ( member @ A @ X2 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert2 @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B5 ) ) ) ) ).

% remove_induct
thf(fact_4417_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N2 @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4418_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4419_sum__count__set,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs ) @ X8 )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% sum_count_set
thf(fact_4420_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I6: set @ A,F2: A > B,I2: A] :
          ( ( finite_finite @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I4: A] :
                    ( ( member @ A @ I4 @ I6 )
                    & ( ( F2 @ I4 )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member @ A @ I2 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert2 @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) @ ( F2 @ I2 ) ) ) )
              & ( ~ ( member @ A @ I2 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert2 @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_4421_real__root__zero,axiom,
    ! [N2: nat] :
      ( ( root @ N2 @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_4422_real__root__Suc__0,axiom,
    ! [X: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X )
      = X ) ).

% real_root_Suc_0
thf(fact_4423_root__0,axiom,
    ! [X: real] :
      ( ( root @ ( zero_zero @ nat ) @ X )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_4424_real__root__eq__iff,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X )
          = ( root @ N2 @ Y ) )
        = ( X = Y ) ) ) ).

% real_root_eq_iff
thf(fact_4425_count__notin,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_4426_real__root__eq__0__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_4427_real__root__less__iff,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) )
        = ( ord_less @ real @ X @ Y ) ) ) ).

% real_root_less_iff
thf(fact_4428_real__root__le__iff,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) )
        = ( ord_less_eq @ real @ X @ Y ) ) ) ).

% real_root_le_iff
thf(fact_4429_real__root__eq__1__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_4430_real__root__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_4431_real__root__gt__0__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_gt_0_iff
thf(fact_4432_real__root__lt__0__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_4433_real__root__le__0__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_4434_real__root__ge__0__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_ge_0_iff
thf(fact_4435_real__root__lt__1__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_4436_real__root__gt__1__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_gt_1_iff
thf(fact_4437_real__root__ge__1__iff,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N2 @ Y ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_ge_1_iff
thf(fact_4438_real__root__le__1__iff,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_4439_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,P4: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member @ B @ X4 @ I6 )
                  & ( ( P4 @ X4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert2 @ B @ I2 @ I6 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I6 ) ) )
            & ( ~ ( member @ B @ I2 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert2 @ B @ I2 @ I6 ) )
                = ( plus_plus @ A @ ( P4 @ I2 ) @ ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I6 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_4440_real__root__pow__pos2,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N2 @ X ) @ N2 )
          = X ) ) ) ).

% real_root_pow_pos2
thf(fact_4441_real__root__minus,axiom,
    ! [N2: nat,X: real] :
      ( ( root @ N2 @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( root @ N2 @ X ) ) ) ).

% real_root_minus
thf(fact_4442_real__root__inverse,axiom,
    ! [N2: nat,X: real] :
      ( ( root @ N2 @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( root @ N2 @ X ) ) ) ).

% real_root_inverse
thf(fact_4443_real__root__divide,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( root @ N2 @ ( divide_divide @ real @ X @ Y ) )
      = ( divide_divide @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ).

% real_root_divide
thf(fact_4444_real__root__commute,axiom,
    ! [M2: nat,N2: nat,X: real] :
      ( ( root @ M2 @ ( root @ N2 @ X ) )
      = ( root @ N2 @ ( root @ M2 @ X ) ) ) ).

% real_root_commute
thf(fact_4445_real__root__mult,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( root @ N2 @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ).

% real_root_mult
thf(fact_4446_real__root__mult__exp,axiom,
    ! [M2: nat,N2: nat,X: real] :
      ( ( root @ ( times_times @ nat @ M2 @ N2 ) @ X )
      = ( root @ M2 @ ( root @ N2 @ X ) ) ) ).

% real_root_mult_exp
thf(fact_4447_real__root__pos__pos__le,axiom,
    ! [X: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X ) ) ) ).

% real_root_pos_pos_le
thf(fact_4448_real__root__less__mono,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ) ).

% real_root_less_mono
thf(fact_4449_real__root__le__mono,axiom,
    ! [N2: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( root @ N2 @ Y ) ) ) ) ).

% real_root_le_mono
thf(fact_4450_real__root__power,axiom,
    ! [N2: nat,X: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X @ K ) )
        = ( power_power @ real @ ( root @ N2 @ X ) @ K ) ) ) ).

% real_root_power
thf(fact_4451_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I4: B] : ( plus_plus @ A @ ( G2 @ I4 ) @ ( H2 @ I4 ) )
              @ I6 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G2 @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I6 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_4452_real__root__abs,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( abs_abs @ real @ X ) )
        = ( abs_abs @ real @ ( root @ N2 @ X ) ) ) ) ).

% real_root_abs
thf(fact_4453_sgn__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( sgn_sgn @ real @ ( root @ N2 @ X ) )
        = ( sgn_sgn @ real @ X ) ) ) ).

% sgn_root
thf(fact_4454_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ S2 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G2 @ T6 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_4455_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ T6 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G2 @ S2 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_4456_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,H2: B > A,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( H2 @ I3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G2 @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ S2 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_4457_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G2 @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G2 @ T6 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_4458_real__root__gt__zero,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X ) ) ) ) ).

% real_root_gt_zero
thf(fact_4459_real__root__strict__decreasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N4 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X )
         => ( ord_less @ real @ ( root @ N4 @ X ) @ ( root @ N2 @ X ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_4460_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_4461_root__abs__power,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( abs_abs @ real @ ( root @ N2 @ ( power_power @ real @ Y @ N2 ) ) )
        = ( abs_abs @ real @ Y ) ) ) ).

% root_abs_power
thf(fact_4462_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member @ B @ X4 @ I6 )
                  & ( ( G2 @ X4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X4: B] :
                    ( ( member @ B @ X4 @ I6 )
                    & ( ( H2 @ X4 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I4: B] : ( plus_plus @ A @ ( G2 @ I4 ) @ ( H2 @ I4 ) )
                @ I6 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G2 @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I6 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_4463_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_4464_real__root__pos__pos,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X ) ) ) ) ).

% real_root_pos_pos
thf(fact_4465_real__root__strict__increasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N2 @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_4466_real__root__decreasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N4 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ord_less_eq @ real @ ( root @ N4 @ X ) @ ( root @ N2 @ X ) ) ) ) ) ).

% real_root_decreasing
thf(fact_4467_real__root__pow__pos,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N2 @ X ) @ N2 )
          = X ) ) ) ).

% real_root_pow_pos
thf(fact_4468_real__root__power__cancel,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N2 @ ( power_power @ real @ X @ N2 ) )
          = X ) ) ) ).

% real_root_power_cancel
thf(fact_4469_real__root__pos__unique,axiom,
    ! [N2: nat,Y: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( power_power @ real @ Y @ N2 )
            = X )
         => ( ( root @ N2 @ X )
            = Y ) ) ) ) ).

% real_root_pos_unique
thf(fact_4470_odd__real__root__pow,axiom,
    ! [N2: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( power_power @ real @ ( root @ N2 @ X ) @ N2 )
        = X ) ) ).

% odd_real_root_pow
thf(fact_4471_odd__real__root__unique,axiom,
    ! [N2: nat,Y: real,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ( power_power @ real @ Y @ N2 )
          = X )
       => ( ( root @ N2 @ X )
          = Y ) ) ) ).

% odd_real_root_unique
thf(fact_4472_odd__real__root__power__cancel,axiom,
    ! [N2: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X @ N2 ) )
        = X ) ) ).

% odd_real_root_power_cancel
thf(fact_4473_real__root__increasing,axiom,
    ! [N2: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N4 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N2 @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_4474_sgn__power__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N2 @ X ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N2 @ X ) ) @ N2 ) )
        = X ) ) ).

% sgn_power_root
thf(fact_4475_root__sgn__power,axiom,
    ! [N2: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N2 ) ) )
        = Y ) ) ).

% root_sgn_power
thf(fact_4476_ln__root,axiom,
    ! [N2: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N2 @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% ln_root
thf(fact_4477_log__root,axiom,
    ! [N2: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N2 @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_root
thf(fact_4478_log__base__root,axiom,
    ! [N2: nat,B2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N2 @ B2 ) @ X )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X ) ) ) ) ) ).

% log_base_root
thf(fact_4479_split__root,axiom,
    ! [P: real > $o,N2: nat,X: real] :
      ( ( P @ ( root @ N2 @ X ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ! [Y4: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N2 ) )
                = X )
             => ( P @ Y4 ) ) ) ) ) ).

% split_root
thf(fact_4480_root__powr__inverse,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N2 @ X )
          = ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_4481_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X6: nat > real] :
        ! [J3: nat] :
        ? [M9: nat] :
        ! [M: nat] :
          ( ( ord_less_eq @ nat @ M9 @ M )
         => ! [N: nat] :
              ( ( ord_less_eq @ nat @ M9 @ N )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X6 @ M ) @ ( X6 @ N ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_4482_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_4483_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L2: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L2 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L2 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4484_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] :
      ( ( re @ ( csqrt @ Z ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_4485_Re__divide__of__nat,axiom,
    ! [Z: complex,N2: nat] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Re_divide_of_nat
thf(fact_4486_Re__divide__of__real,axiom,
    ! [Z: complex,R: real] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ R ) ) ).

% Re_divide_of_real
thf(fact_4487_Re__sgn,axiom,
    ! [Z: complex] :
      ( ( re @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Re_sgn
thf(fact_4488_Re__divide__numeral,axiom,
    ! [Z: complex,W2: num] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W2 ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( numeral_numeral @ real @ W2 ) ) ) ).

% Re_divide_numeral
thf(fact_4489_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M: num,N: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M ) @ ( numeral_numeral @ code_integer @ N ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M ) @ ( numeral_numeral @ code_integer @ N ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_4490_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_4491_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_4492_subseqs__refl,axiom,
    ! [A: $tType,Xs: list @ A] : ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs_refl
thf(fact_4493_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K3: code_integer] :
          ( if @ code_integer
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_4494_one__complex_Osimps_I1_J,axiom,
    ( ( re @ ( one_one @ complex ) )
    = ( one_one @ real ) ) ).

% one_complex.simps(1)
thf(fact_4495_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,X: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( re @ X ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_4496_one__integer_Orsp,axiom,
    ( ( one_one @ int )
    = ( one_one @ int ) ) ).

% one_integer.rsp
thf(fact_4497_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) ) ).

% one_natural.rsp
thf(fact_4498_cos__n__Re__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_4499_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X6: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M9: nat] :
                ! [M: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X6 @ M ) @ ( X6 @ N ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_4500_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI
thf(fact_4501_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M8: nat] :
              ! [M3: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M3 )
               => ! [N8: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N8 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M3 ) @ ( X8 @ N8 ) ) ) @ E ) ) ) ) ) ) ).

% CauchyD
thf(fact_4502_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z5: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z5 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z5 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z5 ) @ ( re @ Z5 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_4503_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( ( im @ ( csqrt @ Z ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_4504_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K3: int] :
          ( if @ code_integer @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K3 ) ) )
          @ ( if @ code_integer
            @ ( K3
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_4505_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_4506_Im__power__real,axiom,
    ! [X: complex,N2: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X @ N2 ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_4507_Im__i__times,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( re @ Z ) ) ).

% Im_i_times
thf(fact_4508_Im__divide__of__real,axiom,
    ! [Z: complex,R: real] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ R ) ) ).

% Im_divide_of_real
thf(fact_4509_Im__sgn,axiom,
    ! [Z: complex] :
      ( ( im @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Im_sgn
thf(fact_4510_Re__power__real,axiom,
    ! [X: complex,N2: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X @ N2 ) )
        = ( power_power @ real @ ( re @ X ) @ N2 ) ) ) ).

% Re_power_real
thf(fact_4511_Re__i__times,axiom,
    ! [Z: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( uminus_uminus @ real @ ( im @ Z ) ) ) ).

% Re_i_times
thf(fact_4512_Im__divide__numeral,axiom,
    ! [Z: complex,W2: num] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W2 ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( numeral_numeral @ real @ W2 ) ) ) ).

% Im_divide_numeral
thf(fact_4513_Im__divide__of__nat,axiom,
    ! [Z: complex,N2: nat] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Im_divide_of_nat
thf(fact_4514_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( ( ord_less @ real @ ( im @ X ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X ) ) ) ) ).

% csqrt_minus
thf(fact_4515_divide__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( divide_divide @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( divide_divide @ int @ Xa2 @ X ) ) ) ).

% divide_integer.abs_eq
thf(fact_4516_imaginary__unit_Osimps_I2_J,axiom,
    ( ( im @ imaginary_unit )
    = ( one_one @ real ) ) ).

% imaginary_unit.simps(2)
thf(fact_4517_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_4518_times__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa2 @ X ) ) ) ).

% times_integer.abs_eq
thf(fact_4519_one__integer__def,axiom,
    ( ( one_one @ code_integer )
    = ( code_integer_of_int @ ( one_one @ int ) ) ) ).

% one_integer_def
thf(fact_4520_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,X: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( im @ X ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_4521_times__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( times_times @ complex @ X @ Y ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) ) ) ).

% times_complex.simps(2)
thf(fact_4522_times__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( times_times @ complex @ X @ Y ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) ) ).

% times_complex.simps(1)
thf(fact_4523_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X4: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X4 ) ) @ ( times_times @ real @ R5 @ ( im @ X4 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_4524_sin__n__Im__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_4525_Re__exp,axiom,
    ! [Z: complex] :
      ( ( re @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( cos @ real @ ( im @ Z ) ) ) ) ).

% Re_exp
thf(fact_4526_Im__exp,axiom,
    ! [Z: complex] :
      ( ( im @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( sin @ real @ ( im @ Z ) ) ) ) ).

% Im_exp
thf(fact_4527_complex__eq,axiom,
    ! [A2: complex] :
      ( A2
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A2 ) ) ) ) ) ).

% complex_eq
thf(fact_4528_fun__complex__eq,axiom,
    ! [A: $tType,F2: A > complex] :
      ( F2
      = ( ^ [X4: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F2 @ X4 ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_4529_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X4: complex,Y4: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X4 ) @ ( re @ Y4 ) ) @ ( times_times @ real @ ( im @ X4 ) @ ( im @ Y4 ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X4 ) @ ( im @ Y4 ) ) @ ( times_times @ real @ ( im @ X4 ) @ ( re @ Y4 ) ) ) ) ) ) ).

% times_complex.code
thf(fact_4530_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z5: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z5 ) ) ) @ ( cis @ ( im @ Z5 ) ) ) ) ) ).

% exp_eq_polar
thf(fact_4531_cmod__power2,axiom,
    ! [Z: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_4532_Im__power2,axiom,
    ! [X: complex] :
      ( ( im @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X ) ) @ ( im @ X ) ) ) ).

% Im_power2
thf(fact_4533_Re__power2,axiom,
    ! [X: complex] :
      ( ( re @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_4534_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_4535_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z5: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_4536_inverse__complex_Osimps_I1_J,axiom,
    ! [X: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( re @ X ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_4537_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( ( Z
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_4538_Re__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_4539_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_4540_csqrt__unique,axiom,
    ! [W2: complex,Z: complex] :
      ( ( ( power_power @ complex @ W2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W2 ) )
          | ( ( ( re @ W2 )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W2 ) ) ) )
       => ( ( csqrt @ Z )
          = W2 ) ) ) ).

% csqrt_unique
thf(fact_4541_inverse__complex_Osimps_I2_J,axiom,
    ! [X: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_4542_Im__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_4543_complex__abs__le__norm,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% complex_abs_le_norm
thf(fact_4544_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_4545_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X4: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X4 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X4 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_4546_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X4: complex,Y4: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X4 ) @ ( re @ Y4 ) ) @ ( times_times @ real @ ( im @ X4 ) @ ( im @ Y4 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X4 ) @ ( re @ Y4 ) ) @ ( times_times @ real @ ( re @ X4 ) @ ( im @ Y4 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_4547_length__mul__elem,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N2: nat] :
      ( ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xs ) )
         => ( ( size_size @ ( list @ A ) @ X3 )
            = N2 ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) @ N2 ) ) ) ).

% length_mul_elem
thf(fact_4548_Im__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R ) ) @ ( im @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_4549_Re__Reals__divide,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R ) @ ( re @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_4550_set__n__lists,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N2 @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_4551_Re__divide__Reals,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ Z @ R ) )
        = ( divide_divide @ real @ ( re @ Z ) @ ( re @ R ) ) ) ) ).

% Re_divide_Reals
thf(fact_4552_imaginary__eq__real__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y )
            = X )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_4553_real__eq__imaginary__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( X
            = ( times_times @ complex @ imaginary_unit @ Y ) )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_4554_Im__divide__Reals,axiom,
    ! [R: complex,Z: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ Z @ R ) )
        = ( divide_divide @ real @ ( im @ Z ) @ ( re @ R ) ) ) ) ).

% Im_divide_Reals
thf(fact_4555_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_4556_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_4557_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_4558_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W2: num] : ( member @ A @ ( numeral_numeral @ A @ W2 ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_4559_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_4560_Reals__1,axiom,
    ! [B: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ B )
     => ( member @ B @ ( one_one @ B ) @ ( real_Vector_Reals @ B ) ) ) ).

% Reals_1
thf(fact_4561_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_4562_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list @ A,N2: nat,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N2 @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N2 ) ) ).

% length_n_lists_elem
thf(fact_4563_length__n__lists,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N2 @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% length_n_lists
thf(fact_4564_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G2: nat > complex,N4: nat,F2: nat > A] :
          ( ( summable @ complex @ G2 )
         => ( ! [N3: nat] : ( member @ complex @ ( G2 @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G2 @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N4 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G2 @ N3 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4565_complex__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( times_times @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_4566_integer__of__num_I3_J,axiom,
    ! [N2: num] :
      ( ( code_integer_of_num @ ( bit1 @ N2 ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N2 ) @ ( code_integer_of_num @ N2 ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_4567_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K3 ) ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L2: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_4568_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K3 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_4569_complex__cnj__mult,axiom,
    ! [X: complex,Y: complex] :
      ( ( cnj @ ( times_times @ complex @ X @ Y ) )
      = ( times_times @ complex @ ( cnj @ X ) @ ( cnj @ Y ) ) ) ).

% complex_cnj_mult
thf(fact_4570_complex__cnj__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( cnj @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ complex @ ( cnj @ X ) @ ( cnj @ Y ) ) ) ).

% complex_cnj_divide
thf(fact_4571_complex__cnj__one,axiom,
    ( ( cnj @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% complex_cnj_one
thf(fact_4572_complex__cnj__one__iff,axiom,
    ! [Z: complex] :
      ( ( ( cnj @ Z )
        = ( one_one @ complex ) )
      = ( Z
        = ( one_one @ complex ) ) ) ).

% complex_cnj_one_iff
thf(fact_4573_complex__cnj__power,axiom,
    ! [X: complex,N2: nat] :
      ( ( cnj @ ( power_power @ complex @ X @ N2 ) )
      = ( power_power @ complex @ ( cnj @ X ) @ N2 ) ) ).

% complex_cnj_power
thf(fact_4574_times__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X @ Xa2 ) )
      = ( times_times @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% times_integer.rep_eq
thf(fact_4575_one__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ int ) ) ).

% one_integer.rep_eq
thf(fact_4576_divide__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( divide_divide @ code_integer @ X @ Xa2 ) )
      = ( divide_divide @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% divide_integer.rep_eq
thf(fact_4577_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_4578_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_4579_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_4580_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z5: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z5 @ ( cnj @ Z5 ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_4581_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_4582_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_4583_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_4584_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_4585_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_4586_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_4587_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_4588_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_4589_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_4590_integer__of__num_I2_J,axiom,
    ! [N2: num] :
      ( ( code_integer_of_num @ ( bit0 @ N2 ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N2 ) @ ( code_integer_of_num @ N2 ) ) ) ).

% integer_of_num(2)
thf(fact_4591_complex__mod__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_4592_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_4593_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_4594_complex__norm__square,axiom,
    ! [Z: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ).

% complex_norm_square
thf(fact_4595_complex__add__cnj,axiom,
    ! [Z: complex] :
      ( ( plus_plus @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z ) ) ) ) ).

% complex_add_cnj
thf(fact_4596_complex__diff__cnj,axiom,
    ! [Z: complex] :
      ( ( minus_minus @ complex @ Z @ ( cnj @ Z ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_4597_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A3: complex,B3: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A3 @ ( cnj @ B3 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_4598_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W2: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z @ ( cnj @ W2 ) ) @ ( times_times @ complex @ ( cnj @ Z ) @ W2 ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z @ ( cnj @ W2 ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_4599_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K3 @ L2 ) @ ( modulo_modulo @ code_integer @ K3 @ L2 ) ) ) ) ).

% divmod_integer_def
thf(fact_4600_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K3 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_4601_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S6: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S6 ) )
                @ ( S6
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_4602_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_4603_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A3: B] :
                      ( ( member @ B @ A3 @ A5 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A3 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_4604_card__Collect__less__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) )
      = N2 ) ).

% card_Collect_less_nat
thf(fact_4605_card__Collect__le__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less_eq @ nat @ I4 @ N2 ) ) )
      = ( suc @ N2 ) ) ).

% card_Collect_le_nat
thf(fact_4606_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: A,A5: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X4: B] : Y
            @ A5 )
          = ( power_power @ A @ Y @ ( finite_card @ B @ A5 ) ) ) ) ).

% prod_constant
thf(fact_4607_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A5: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X4: B] : Y
            @ A5 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_4608_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A5: set @ A,B5: set @ A] :
      ( ( member @ A @ A2 @ A5 )
     => ( ~ ( member @ A @ A2 @ B5 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ A2 @ B5 ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) ) @ ( one_one @ nat ) ) ) ) ) ).

% card_Diff_insert
thf(fact_4609_card__atLeastAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or1337092689740270186AtMost @ int @ L @ U ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ U @ L ) @ ( one_one @ int ) ) ) ) ).

% card_atLeastAtMost_int
thf(fact_4610_n__subsets,axiom,
    ! [A: $tType,A5: set @ A,K: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B8 @ A5 )
                & ( ( finite_card @ A @ B8 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A5 ) @ K ) ) ) ).

% n_subsets
thf(fact_4611_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A5: set @ A,N2: nat] :
      ( ~ ( finite_finite @ A @ A5 )
     => ? [B9: set @ A] :
          ( ( finite_finite @ A @ B9 )
          & ( ( finite_card @ A @ B9 )
            = N2 )
          & ( ord_less_eq @ ( set @ A ) @ B9 @ A5 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_4612_card__subset__eq,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
       => ( ( ( finite_card @ A @ A5 )
            = ( finite_card @ A @ B5 ) )
         => ( A5 = B5 ) ) ) ) ).

% card_subset_eq
thf(fact_4613_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B5: set @ A,A5: set @ B,R: B > A > $o] :
      ( ( finite_finite @ A @ B5 )
     => ( ! [A4: B] :
            ( ( member @ B @ A4 @ A5 )
           => ? [B10: A] :
                ( ( member @ A @ B10 @ B5 )
                & ( R @ A4 @ B10 ) ) )
       => ( ! [A13: B,A24: B,B4: A] :
              ( ( member @ B @ A13 @ A5 )
             => ( ( member @ B @ A24 @ A5 )
               => ( ( member @ A @ B4 @ B5 )
                 => ( ( R @ A13 @ B4 )
                   => ( ( R @ A24 @ B4 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A5 ) @ ( finite_card @ A @ B5 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_4614_card__insert__le,axiom,
    ! [A: $tType,A5: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ ( insert2 @ A @ X @ A5 ) ) ) ).

% card_insert_le
thf(fact_4615_card__lists__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N2 ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A5 ) @ N2 ) ) ) ).

% card_lists_length_eq
thf(fact_4616_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X4: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_4617_card__2__iff_H,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X4: A] :
            ( ( member @ A @ X4 @ S2 )
            & ? [Y4: A] :
                ( ( member @ A @ Y4 @ S2 )
                & ( X4 != Y4 )
                & ! [Z5: A] :
                    ( ( member @ A @ Z5 @ S2 )
                   => ( ( Z5 = X4 )
                      | ( Z5 = Y4 ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_4618_card__ge__0__finite,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A5 ) )
     => ( finite_finite @ A @ A5 ) ) ).

% card_ge_0_finite
thf(fact_4619_card__mono,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) ) ) ) ).

% card_mono
thf(fact_4620_card__seteq,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B5 ) @ ( finite_card @ A @ A5 ) )
         => ( A5 = B5 ) ) ) ) ).

% card_seteq
thf(fact_4621_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F4: set @ A,C6: nat] :
      ( ! [G3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G3 @ F4 )
         => ( ( finite_finite @ A @ G3 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G3 ) @ C6 ) ) )
     => ( ( finite_finite @ A @ F4 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F4 ) @ C6 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_4622_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N2: nat,S2: set @ A] :
      ( ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ S2 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S2 )
           => ( ( ( finite_card @ A @ T7 )
                = N2 )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_4623_card__less__sym__Diff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B5 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B5 @ A5 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_4624_card__le__sym__Diff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B5 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B5 @ A5 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_4625_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_4626_card__1__singletonE,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ( finite_card @ A @ A5 )
        = ( one_one @ nat ) )
     => ~ ! [X3: A] :
            ( A5
           != ( insert2 @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_4627_psubset__card__mono,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less @ ( set @ A ) @ A5 @ B5 )
       => ( ord_less @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) ) ) ) ).

% psubset_card_mono
thf(fact_4628_card__less,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I2 ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_4629_card__less__Suc,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] :
                  ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                  & ( ord_less @ nat @ K3 @ I2 ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_4630_card__less__Suc2,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                & ( ord_less @ nat @ K3 @ I2 ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_4631_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A5: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X4: A] : ( suc @ ( F2 @ X4 ) )
        @ A5 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( finite_card @ A @ A5 ) ) ) ).

% sum_Suc
thf(fact_4632_subset__card__intvl__is__intvl,axiom,
    ! [A5: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A5 ) ) ) )
     => ( A5
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A5 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_4633_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,T6: set @ B,R3: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T6 )
       => ( ! [X3: B] :
              ( ( member @ B @ X3 @ T6 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I4: A] :
                        ( ( member @ A @ I4 @ S2 )
                        & ( R3 @ I4 @ X3 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I4: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J3: B] :
                        ( ( member @ B @ J3 @ T6 )
                        & ( R3 @ I4 @ J3 ) ) ) )
              @ S2 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T6 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_4634_real__of__card,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A5 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X4: A] : ( one_one @ real )
        @ A5 ) ) ).

% real_of_card
thf(fact_4635_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_4636_nat__of__integer__code__post_I2_J,axiom,
    ( ( code_nat_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ nat ) ) ).

% nat_of_integer_code_post(2)
thf(fact_4637_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,K5: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) ) ) ) ).

% sum_bounded_below
thf(fact_4638_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_4639_card__gt__0__iff,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A5 ) )
      = ( ( A5
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A5 ) ) ) ).

% card_gt_0_iff
thf(fact_4640_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X4: A] :
              ( ( member @ A @ X4 @ A5 )
             => ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A5 )
                 => ( X4 = Y4 ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_4641_card__le__Suc__iff,axiom,
    ! [A: $tType,N2: nat,A5: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ A5 ) )
      = ( ? [A3: A,B8: set @ A] :
            ( ( A5
              = ( insert2 @ A @ A3 @ B8 ) )
            & ~ ( member @ A @ A3 @ B8 )
            & ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ B8 ) )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_4642_card__Diff1__le,axiom,
    ! [A: $tType,A5: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) ) ).

% card_Diff1_le
thf(fact_4643_card__Diff__subset,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_4644_card__psubset,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) )
         => ( ord_less @ ( set @ A ) @ A5 @ B5 ) ) ) ) ).

% card_psubset
thf(fact_4645_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( finite_finite @ A @ B5 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_4646_card__lists__length__le,axiom,
    ! [A: $tType,A5: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N2 ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A5 ) ) @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% card_lists_length_le
thf(fact_4647_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite_1
thf(fact_4648_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z5: A] :
                    ( ( power_power @ A @ Z5 @ N2 )
                    = ( one_one @ A ) ) ) )
            @ N2 ) ) ) ).

% card_roots_unity
thf(fact_4649_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N4 ) @ N2 ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_4650_card__sum__le__nat__sum,axiom,
    ! [S2: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S2 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X4: nat] : X4
        @ S2 ) ) ).

% card_sum_le_nat_sum
thf(fact_4651_card__nth__roots,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z5: complex] :
                  ( ( power_power @ complex @ Z5 @ N2 )
                  = C2 ) ) )
          = N2 ) ) ) ).

% card_nth_roots
thf(fact_4652_card__roots__unity__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z5: complex] :
                ( ( power_power @ complex @ Z5 @ N2 )
                = ( one_one @ complex ) ) ) )
        = N2 ) ) ).

% card_roots_unity_eq
thf(fact_4653_card__2__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X4: A,Y4: A] :
            ( ( S2
              = ( insert2 @ A @ X4 @ ( insert2 @ A @ Y4 @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X4 != Y4 ) ) ) ) ).

% card_2_iff
thf(fact_4654_card__3__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X4: A,Y4: A,Z5: A] :
            ( ( S2
              = ( insert2 @ A @ X4 @ ( insert2 @ A @ Y4 @ ( insert2 @ A @ Z5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X4 != Y4 )
            & ( Y4 != Z5 )
            & ( X4 != Z5 ) ) ) ) ).

% card_3_iff
thf(fact_4655_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A5 ) )
     => ( A5
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_4656_card__Diff1__less__iff,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) )
      = ( ( finite_finite @ A @ A5 )
        & ( member @ A @ X @ A5 ) ) ) ).

% card_Diff1_less_iff
thf(fact_4657_card__Diff2__less,axiom,
    ! [A: $tType,A5: set @ A,X: A,Y: A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( member @ A @ X @ A5 )
       => ( ( member @ A @ Y @ A5 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_4658_card__Diff1__less,axiom,
    ! [A: $tType,A5: set @ A,X: A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( member @ A @ X @ A5 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A5 ) ) ) ) ).

% card_Diff1_less
thf(fact_4659_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A5: set @ A] :
      ( ( member @ A @ X @ A5 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_4660_card__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A5: set @ A] :
      ( ( ( member @ A @ X @ A5 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ A5 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A5 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_4661_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,K5: real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S2 ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_4662_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A5: set @ B,F2: B > A,N2: A,K: nat] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ N2 ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A5 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N2 )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( power_power @ A @ N2 @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_4663_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A5: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A5 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_4664_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A5: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A5 ) ) ) ) )
         => ( ( finite_finite @ B @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_4665_card__insert__le__m1,axiom,
    ! [A: $tType,N2: nat,Y: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert2 @ A @ X @ Y ) ) @ N2 ) ) ) ).

% card_insert_le_m1
thf(fact_4666_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K3: code_integer,L2: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) ) ) ) ).

% divmod_abs_def
thf(fact_4667_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              @ N2 ) ) ) ) ).

% polyfun_roots_card
thf(fact_4668_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_4669_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z5: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z5: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                          @ ( set_ord_atMost @ nat @ N2 ) )
                        = ( zero_zero @ A ) ) ) )
                @ N2 ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_4670_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ ( code_divmod_abs @ K3 @ L2 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S6: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S6
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L2 @ S6 ) ) )
                @ ( code_divmod_abs @ K3 @ L2 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L2
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K3 @ L2 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S6: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S6
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L2 ) @ S6 ) ) )
                    @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_4671_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A5: set @ A,K: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A5 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = K )
                  & ( distinct @ A @ Xs3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X4: nat] : X4
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_4672_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A5: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A5 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = K )
                & ( distinct @ A @ Xs3 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X4: nat] : X4
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A5 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A5 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_4673_distinct__swap,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I2 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I2 ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_4674_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A5: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A5 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = N2 )
              & ( distinct @ A @ Xs3 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_4675_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ B @ Ys )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ) ).

% distinct_product
thf(fact_4676_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( distinct @ A @ Xs ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_4677_finite__distinct__list,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [Xs2: list @ A] :
          ( ( ( set2 @ A @ Xs2 )
            = A5 )
          & ( distinct @ A @ Xs2 ) ) ) ).

% finite_distinct_list
thf(fact_4678_subseqs__distinctD,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( ( distinct @ A @ Xs )
       => ( distinct @ A @ Ys ) ) ) ).

% subseqs_distinctD
thf(fact_4679_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat,J: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I2 )
              = ( nth @ A @ Xs @ J ) )
            = ( I2 = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_4680_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs3: list @ A] :
          ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
           => ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( I4 != J3 )
                 => ( ( nth @ A @ Xs3 @ I4 )
                   != ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_4681_distinct__card,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% distinct_card
thf(fact_4682_card__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( distinct @ A @ Xs ) ) ).

% card_distinct
thf(fact_4683_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ? [X3: nat] :
            ( ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X3 )
              = X )
            & ! [Y5: nat] :
                ( ( ( ord_less @ nat @ Y5 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y5 )
                    = X ) )
               => ( Y5 = X3 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_4684_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ nat,B5: set @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( A5
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( ( B5
            = ( set2 @ A @ Xs ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs ) @ A5 @ B5 ) ) ) ) ).

% bij_betw_nth
thf(fact_4685_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A2: A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ I2 ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I2 @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_4686_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N2 @ X ) )
          = ( insert2 @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ ( nth @ A @ Xs @ N2 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_4687_distinct__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys ) )
      = ( distinct @ A @ Ys ) ) ).

% distinct_union
thf(fact_4688_card__Pow,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A5 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A5 ) ) ) ) ).

% card_Pow
thf(fact_4689_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V2: num,N2: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N2 ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N2 ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_4690_Pow__iff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( member @ ( set @ A ) @ A5 @ ( pow2 @ A @ B5 ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ).

% Pow_iff
thf(fact_4691_PowI,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( member @ ( set @ A ) @ A5 @ ( pow2 @ A @ B5 ) ) ) ).

% PowI
thf(fact_4692_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_4693_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_4694_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V2: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V2 ) )
      = ( F2 @ ( pred_numeral @ V2 ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V2 ) ) ) ) ).

% rec_nat_numeral
thf(fact_4695_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% Pow_def
thf(fact_4696_PowD,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( member @ ( set @ A ) @ A5 @ ( pow2 @ A @ B5 ) )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ).

% PowD
thf(fact_4697_Pow__mono,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A5 ) @ ( pow2 @ A @ B5 ) ) ) ).

% Pow_mono
thf(fact_4698_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X4: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X4 ) ) ) ) ).

% old.rec_nat_def
thf(fact_4699_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V2: num,N2: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V2 ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V2 ) @ N2 ) ) ) ).

% case_nat_add_eq_if
thf(fact_4700_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_4701_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V2: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V2 ) )
      = ( F2 @ ( pred_numeral @ V2 ) ) ) ).

% case_nat_numeral
thf(fact_4702_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X4: nat] : ( H2 @ ( F22 @ X4 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_4703_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X22: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X22 ) )
      = ( F22 @ X22 ) ) ).

% old.nat.simps(5)
thf(fact_4704_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_4705_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_4706_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_4707_less__eq__nat_Osimps_I2_J,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N2 )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M2 ) @ N2 ) ) ).

% less_eq_nat.simps(2)
thf(fact_4708_max__Suc1,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ M2 )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ N2 @ M5 ) )
        @ M2 ) ) ).

% max_Suc1
thf(fact_4709_max__Suc2,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_max @ nat @ M2 @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ M5 @ N2 ) )
        @ M2 ) ) ).

% max_Suc2
thf(fact_4710_diff__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ M2 @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K3: nat] : K3
        @ ( minus_minus @ nat @ M2 @ N2 ) ) ) ).

% diff_Suc
thf(fact_4711_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W2: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W2 ) ) @ N2 )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W2 ) ) @ N2 ) ) ) ).

% bit_numeral_rec(1)
thf(fact_4712_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W2: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W2 ) ) @ N2 )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W2 ) ) @ N2 ) ) ) ).

% bit_numeral_rec(2)
thf(fact_4713_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X4: real] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z5 ) @ X4 )
              & ( ord_less @ real @ X4 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_4714_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X4: A,F3: nat > A,N: nat] :
            ( if @ A
            @ ( N
              = ( zero_zero @ nat ) )
            @ X4
            @ ( F3 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_4715_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X4: rat] :
          ( the @ int
          @ ^ [Z5: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z5 ) @ X4 )
              & ( ord_less @ rat @ X4 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_4716_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_4717_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R
                 != ( plus_plus @ rat @ S3 @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_4718_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A3: rat] :
          ( if @ rat
          @ ( A3
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A3 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_4719_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X24: nat] : X24 ) ) ).

% pred_def
thf(fact_4720_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_4721_rat__inverse__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A3: int,B3: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A3
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A3 ) @ B3 ) @ ( abs_abs @ int @ A3 ) ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_inverse_code
thf(fact_4722_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K3: nat,M: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M @ K3 ) @ ( product_Pair @ nat @ nat @ M @ ( minus_minus @ nat @ K3 @ M ) ) @ ( nat_prod_decode_aux @ ( suc @ K3 ) @ ( minus_minus @ nat @ M @ ( suc @ K3 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_4723_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa2 )
        = Y )
     => ( ( ( ord_less_eq @ nat @ Xa2 @ X )
         => ( Y
            = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa2 @ X )
         => ( Y
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_4724_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_4725_rat__one__code,axiom,
    ( ( quotient_of @ ( one_one @ rat ) )
    = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% rat_one_code
thf(fact_4726_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_4727_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_4728_quotient__of__number_I4_J,axiom,
    ( ( quotient_of @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
    = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(4)
thf(fact_4729_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_4730_quotient__of__div,axiom,
    ! [R: rat,N2: int,D2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ N2 @ D2 ) )
     => ( R
        = ( divide_divide @ rat @ ( ring_1_of_int @ rat @ N2 ) @ ( ring_1_of_int @ rat @ D2 ) ) ) ) ).

% quotient_of_div
thf(fact_4731_rat__floor__code,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [P6: rat] : ( product_case_prod @ int @ int @ int @ ( divide_divide @ int ) @ ( quotient_of @ P6 ) ) ) ) ).

% rat_floor_code
thf(fact_4732_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A3: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D3: int] : ( ord_less @ int @ ( times_times @ int @ A3 @ D3 ) @ ( times_times @ int @ C4 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_code
thf(fact_4733_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A3: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D3: int] : ( ord_less_eq @ int @ ( times_times @ int @ A3 @ D3 ) @ ( times_times @ int @ C4 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_eq_code
thf(fact_4734_quotient__of__int,axiom,
    ! [A2: int] :
      ( ( quotient_of @ ( of_int @ A2 ) )
      = ( product_Pair @ int @ int @ A2 @ ( one_one @ int ) ) ) ).

% quotient_of_int
thf(fact_4735_rat__plus__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A3: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A3 @ D3 ) @ ( times_times @ int @ B3 @ C4 ) ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_plus_code
thf(fact_4736_rat__minus__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A3: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A3 @ D3 ) @ ( times_times @ int @ B3 @ C4 ) ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_minus_code
thf(fact_4737_normalize__denom__zero,axiom,
    ! [P4: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P4 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_4738_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P4: int,R: int] :
      ( ( Q2
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q2 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R @ S ) ) )
         => ( ( times_times @ int @ P4 @ S )
            = ( times_times @ int @ R @ Q2 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_4739_rat__divide__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A3: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A3 @ D3 ) @ ( times_times @ int @ C4 @ B3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_divide_code
thf(fact_4740_rat__times__code,axiom,
    ! [P4: rat,Q2: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P4 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A3: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A3 @ B3 ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_times_code
thf(fact_4741_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_4742_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L ) ) ) ).

% Frct_code_post(6)
thf(fact_4743_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_4744_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_div_numeral
thf(fact_4745_fst__divmod__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M2 @ N2 ) )
      = ( divide_divide @ nat @ M2 @ N2 ) ) ).

% fst_divmod_nat
thf(fact_4746_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_div_numeral
thf(fact_4747_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M2 @ N2 ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% fst_divmod
thf(fact_4748_Frct__code__post_I3_J,axiom,
    ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) )
    = ( one_one @ rat ) ) ).

% Frct_code_post(3)
thf(fact_4749_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_4750_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_4751_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_4752_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L2
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L2
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K3 )
                  = ( sgn_sgn @ code_integer @ L2 ) )
                @ ( code_divmod_abs @ K3 @ L2 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S6: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S6
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L2 ) @ S6 ) ) )
                  @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_4753_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_4754_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M2 @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M2 @ N2 ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_4755_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_4756_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_4757_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_4758_fst__divmod__integer,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_integer @ K @ L ) )
      = ( divide_divide @ code_integer @ K @ L ) ) ).

% fst_divmod_integer
thf(fact_4759_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N2
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_4760_drop__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_4761_drop__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_4762_drop__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_4763_fst__divmod__abs,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_abs @ K @ L ) )
      = ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K ) @ ( abs_abs @ code_integer @ L ) ) ) ).

% fst_divmod_abs
thf(fact_4764_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_4765_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_4766_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_4767_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_mod_numeral
thf(fact_4768_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_4769_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_4770_drop__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_4771_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_mod_numeral
thf(fact_4772_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_4773_drop__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_4774_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M2 ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N2 @ M2 ) ) ) ) ).

% drop_bit_of_nat
thf(fact_4775_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M2 @ N2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ M2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_drop_bit
thf(fact_4776_comp__cong,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E4: $tType,F2: B > A,G2: C > B,X: C,F6: D > A,G4: E4 > D,X7: E4] :
      ( ( ( F2 @ ( G2 @ X ) )
        = ( F6 @ ( G4 @ X7 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X )
        = ( comp @ D @ A @ E4 @ F6 @ G4 @ X7 ) ) ) ).

% comp_cong
thf(fact_4777_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_4778_drop__bit__push__bit__int,axiom,
    ! [M2: nat,N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M2 @ N2 ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N2 @ M2 ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_4779_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M2 @ N2 ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_4780_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M2 @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ M2 ) @ ( bit_se4197421643247451524op_bit @ A @ M2 @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_4781_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G2: C > B,A5: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X3: B,Y2: B] :
                ( ( H2 @ ( plus_plus @ B @ X3 @ Y2 ) )
                = ( plus_plus @ A @ ( H2 @ X3 ) @ ( H2 @ Y2 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G2 ) @ A5 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G2 @ A5 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_4782_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M2: num,N2: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M2 @ N2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% snd_divmod
thf(fact_4783_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_4784_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_4785_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_4786_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_4787_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_4788_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N: nat,K3: int] : ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% drop_bit_int_def
thf(fact_4789_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_4790_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N: nat,A3: A] : ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_4791_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_4792_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A3 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_4793_rat__sgn__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( sgn_sgn @ rat @ P4 ) )
      = ( product_Pair @ int @ int @ ( sgn_sgn @ int @ ( product_fst @ int @ int @ ( quotient_of @ P4 ) ) ) @ ( one_one @ int ) ) ) ).

% rat_sgn_code
thf(fact_4794_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,M2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M2 @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_4795_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N: nat,A3: A] :
              ( if @ A
              @ ( N
                = ( zero_zero @ nat ) )
              @ A3
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_4796_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F3: A > nat,G: B > nat,P6: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F3 @ ( product_fst @ A @ B @ P6 ) ) @ ( G @ ( product_snd @ A @ B @ P6 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_4797_in__set__enumerate__eq,axiom,
    ! [A: $tType,P4: product_prod @ nat @ A,N2: nat,Xs: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P4 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N2 @ ( product_fst @ nat @ A @ P4 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P4 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P4 ) @ N2 ) )
          = ( product_snd @ nat @ A @ P4 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_4798_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X4: nat,Y4: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y4
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X4 @ Y4 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X4 @ Y4 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X4 @ Y4 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X4 @ Y4 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_4799_length__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N2 @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_enumerate
thf(fact_4800_drop__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_4801_distinct__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) ).

% distinct_enumerate
thf(fact_4802_drop__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_4803_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_4804_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_4805_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_4806_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M2: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M2 @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_4807_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N2 ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_4808_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_4809_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_4810_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_4811_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_4812_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G2 @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_4813_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: nat > A,M2: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M2 ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_4814_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: nat > A,M2: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M2 ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_4815_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N: nat,M: nat] : ( divide_divide @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% drop_bit_nat_def
thf(fact_4816_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M2 ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_4817_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G2 @ ( plus_plus @ nat @ M2 ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_4818_nth__enumerate__eq,axiom,
    ! [A: $tType,M2: nat,Xs: list @ A,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) @ M2 )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N2 @ M2 ) @ ( nth @ A @ Xs @ M2 ) ) ) ) ).

% nth_enumerate_eq
thf(fact_4819_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y )
     => ( ( bezw @ X @ Y )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_4820_bezw_Oelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa2 )
        = Y )
     => ( ( ( Xa2
            = ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa2
           != ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa2 ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_4821_minus__one__mod__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_4822_one__mod__minus__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_4823_bezw_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa2 ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% bezw.pelims
thf(fact_4824_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa2 @ X )
               => ( Y
                  = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa2 @ X )
               => ( Y
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_4825_normalize__def,axiom,
    ( normalize
    = ( ^ [P6: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P6 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P6 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_4826_nth__rotate1,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_4827_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_4828_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_4829_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M2: A,N2: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M2 @ N2 ) @ N2 )
          = ( gcd_gcd @ A @ M2 @ N2 ) ) ) ).

% gcd_add1
thf(fact_4830_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M2: A,N2: A] :
          ( ( gcd_gcd @ A @ M2 @ ( plus_plus @ A @ M2 @ N2 ) )
          = ( gcd_gcd @ A @ M2 @ N2 ) ) ) ).

% gcd_add2
thf(fact_4831_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N2 ) ) ) ).

% gcd_exp
thf(fact_4832_gcd__1__int,axiom,
    ! [M2: int] :
      ( ( gcd_gcd @ int @ M2 @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% gcd_1_int
thf(fact_4833_set__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate1
thf(fact_4834_length__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate1
thf(fact_4835_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct1_rotate
thf(fact_4836_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N2: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N2 ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_4837_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N2: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_4838_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_4839_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_4840_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M2: A,K: A,N2: A] :
          ( ( gcd_gcd @ A @ M2 @ ( plus_plus @ A @ ( times_times @ A @ K @ M2 ) @ N2 ) )
          = ( gcd_gcd @ A @ M2 @ N2 ) ) ) ).

% gcd_add_mult
thf(fact_4841_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_4842_bezout__int,axiom,
    ! [X: int,Y: int] :
    ? [U3: int,V3: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U3 @ X ) @ ( times_times @ int @ V3 @ Y ) )
      = ( gcd_gcd @ int @ X @ Y ) ) ).

% bezout_int
thf(fact_4843_gcd__mult__distrib__int,axiom,
    ! [K: int,M2: int,N2: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M2 @ N2 ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M2 ) @ ( times_times @ int @ K @ N2 ) ) ) ).

% gcd_mult_distrib_int
thf(fact_4844_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_4845_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_4846_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_4847_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_4848_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_4849_card__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( finite_card @ int @ ( set_or5935395276787703475ssThan @ int @ L @ U ) )
      = ( nat2 @ ( minus_minus @ int @ U @ ( plus_plus @ int @ L @ ( one_one @ int ) ) ) ) ) ).

% card_greaterThanLessThan_int
thf(fact_4850_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M: nat] :
          ? [N: nat] :
            ( ( ord_less_eq @ nat @ M @ N )
            & ( member @ nat @ N @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_4851_gcd__1__nat,axiom,
    ! [M2: nat] :
      ( ( gcd_gcd @ nat @ M2 @ ( one_one @ nat ) )
      = ( one_one @ nat ) ) ).

% gcd_1_nat
thf(fact_4852_gcd__pos__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M2 @ N2 ) )
      = ( ( M2
         != ( zero_zero @ nat ) )
        | ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_4853_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I2 )
            & ( ord_less @ A @ I2 @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_4854_in__set__remove1,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( A2 != B2 )
     => ( ( member @ A @ A2 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs ) ) )
        = ( member @ A @ A2 @ ( set2 @ A @ Xs ) ) ) ) ).

% in_set_remove1
thf(fact_4855_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_4856_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_4857_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_4858_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_4859_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M2: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M2 @ N2 ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M2 ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_4860_remove1__idem,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( remove1 @ A @ X @ Xs )
        = Xs ) ) ).

% remove1_idem
thf(fact_4861_notin__set__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( remove1 @ A @ Y @ Xs ) ) ) ) ).

% notin_set_remove1
thf(fact_4862_remove1__commute,axiom,
    ! [A: $tType,X: A,Y: A,Zs: list @ A] :
      ( ( remove1 @ A @ X @ ( remove1 @ A @ Y @ Zs ) )
      = ( remove1 @ A @ Y @ ( remove1 @ A @ X @ Zs ) ) ) ).

% remove1_commute
thf(fact_4863_distinct__remove1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( remove1 @ A @ X @ Xs ) ) ) ).

% distinct_remove1
thf(fact_4864_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_4865_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_4866_gcd__diff2__nat,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N2 @ M2 ) @ N2 )
        = ( gcd_gcd @ nat @ M2 @ N2 ) ) ) ).

% gcd_diff2_nat
thf(fact_4867_gcd__diff1__nat,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ N2 )
        = ( gcd_gcd @ nat @ M2 @ N2 ) ) ) ).

% gcd_diff1_nat
thf(fact_4868_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_4869_set__remove1__subset,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_remove1_subset
thf(fact_4870_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X3: nat,Y2: nat] :
          ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_4871_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X3: nat,Y2: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ ( times_times @ nat @ A2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y2 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ ( times_times @ nat @ B2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y2 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_4872_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_4873_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or7035219750837199246ssThan @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or5935395276787703475ssThan @ int @ L @ U ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
thf(fact_4874_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_4875_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_4876_length__remove1,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs ) )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_remove1
thf(fact_4877_bezw__aux,axiom,
    ! [X: nat,Y: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X @ Y ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ Y ) ) ) ) ).

% bezw_aux
thf(fact_4878_unbounded__k__infinite,axiom,
    ! [K: nat,S2: set @ nat] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K @ M4 )
         => ? [N8: nat] :
              ( ( ord_less @ nat @ M4 @ N8 )
              & ( member @ nat @ N8 @ S2 ) ) )
     => ~ ( finite_finite @ nat @ S2 ) ) ).

% unbounded_k_infinite
thf(fact_4879_infinite__nat__iff__unbounded,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M: nat] :
          ? [N: nat] :
            ( ( ord_less @ nat @ M @ N )
            & ( member @ nat @ N @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_4880_finite__enumerate,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [R2: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R2 @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S2 ) ) )
          & ! [N8: nat] :
              ( ( ord_less @ nat @ N8 @ ( finite_card @ nat @ S2 ) )
             => ( member @ nat @ ( R2 @ N8 ) @ S2 ) ) ) ) ).

% finite_enumerate
thf(fact_4881_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N2: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_4882_xor__minus__numerals_I1_J,axiom,
    ! [N2: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N2 @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_4883_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_4884_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ M2 @ N2 ) ) ) ).

% diff_numeral_simps(1)
thf(fact_4885_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_4886_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_4887_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V2: num,W2: num,Y: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V2 ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V2 @ W2 ) @ Y ) ) ) ).

% semiring_norm(166)
thf(fact_4888_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V2: num,W2: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W2 @ V2 ) @ Y ) ) ) ).

% semiring_norm(167)
thf(fact_4889_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ M2 @ N2 ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_4890_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ M2 ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_4891_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ M2 ) ) ) ).

% diff_numeral_simps(4)
thf(fact_4892_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_4893_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_4894_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M2 ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M2 @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_4895_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ one2 @ N2 ) ) ) ).

% diff_numeral_special(1)
thf(fact_4896_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_4897_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_4898_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_4899_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_4900_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_4901_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M2 @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_4902_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_4903_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M2 @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_4904_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_4905_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M2 ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M2 ) ) ) ).

% diff_numeral_special(8)
thf(fact_4906_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_4907_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_4908_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K3: num,L2: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K3 ) @ ( numeral_numeral @ A @ L2 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_4909_tanh__real__bounds,axiom,
    ! [X: real] : ( member @ real @ ( tanh @ real @ X ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) ).

% tanh_real_bounds
thf(fact_4910_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M2: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M2 ) )
          = ( ord_less_eq @ num @ M2 @ N2 ) ) ) ).

% sub_non_negative
thf(fact_4911_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M2: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N2 @ M2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N2 @ M2 ) ) ) ).

% sub_non_positive
thf(fact_4912_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M2: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M2 ) )
          = ( ord_less @ num @ M2 @ N2 ) ) ) ).

% sub_positive
thf(fact_4913_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M2: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N2 @ M2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N2 @ M2 ) ) ) ).

% sub_negative
thf(fact_4914_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N2 ) @ one2 )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% sub_inc_One_eq
thf(fact_4915_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_4916_sub__BitM__One__eq,axiom,
    ! [N2: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N2 ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_4917_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A5: set @ A,R: A,S: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A5 )
         => ( ( member @ A @ R @ A5 )
           => ( ( member @ A @ S @ A5 )
             => ( ( ord_less @ A @ R @ S )
               => ( ord_less @ B @ ( F2 @ R ) @ ( F2 @ S ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_4918_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A5: set @ A,F2: A > B] :
          ( ! [R2: A,S3: A] :
              ( ( member @ A @ R2 @ A5 )
             => ( ( member @ A @ S3 @ A5 )
               => ( ( ord_less @ A @ R2 @ S3 )
                 => ( ord_less @ B @ ( F2 @ R2 ) @ ( F2 @ S3 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A5 ) ) ) ).

% strict_mono_onI
thf(fact_4919_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F3: A > B,A7: set @ A] :
            ! [R5: A,S6: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S6 @ A7 )
                & ( ord_less @ A @ R5 @ S6 ) )
             => ( ord_less @ B @ ( F3 @ R5 ) @ ( F3 @ S6 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_4920_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A5: set @ A,X: A,Y: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( member @ A @ Y @ A5 )
             => ( ( ord_less_eq @ A @ X @ Y )
               => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_4921_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_4922_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_4923_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F3: A > B] :
            ? [K7: real] :
            ! [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X4 ) @ K7 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_4924_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_4925_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X @ Y ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_4926_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_4927_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_4928_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_4929_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_4930_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N2: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% power_minus'
thf(fact_4931_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_4932_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_4933_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_4934_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N: nat] : ( compow @ ( A > A ) @ N @ ( times_times @ A @ A3 ) @ ( F3 @ ( nth @ B @ Xs3 @ N ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_4935_card__UNION,axiom,
    ! [A: $tType,A5: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A5 )
     => ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ A5 )
           => ( finite_finite @ A @ X3 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I8: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I8 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I8 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I8 @ A5 )
                    & ( I8
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_4936_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X4: nat,Y4: nat] : ( ord_less_eq @ nat @ Y4 @ X4 )
    @ ^ [X4: nat,Y4: nat] : ( ord_less @ nat @ Y4 @ X4 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_4937_Suc__funpow,axiom,
    ! [N2: nat] :
      ( ( compow @ ( nat > nat ) @ N2 @ suc )
      = ( plus_plus @ nat @ N2 ) ) ).

% Suc_funpow
thf(fact_4938_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X )
      = X ) ).

% funpow_0
thf(fact_4939_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastAtMost
thf(fact_4940_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastAtMost
thf(fact_4941_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastLessThan
thf(fact_4942_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastLessThan
thf(fact_4943_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_4944_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_4945_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S2: set @ A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S2 @ S2 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ S2 @ S2 ) ) ).

% bij_betw_funpow
thf(fact_4946_funpow__mod__eq,axiom,
    ! [A: $tType,N2: nat,F2: A > A,X: A,M2: nat] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ X )
        = X )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M2 @ N2 ) @ F2 @ X )
        = ( compow @ ( A > A ) @ M2 @ F2 @ X ) ) ) ).

% funpow_mod_eq
thf(fact_4947_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N2: nat,X: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N2 @ F2 @ X ) )
      = ( compow @ ( A > A ) @ N2 @ F2 @ ( F2 @ X ) ) ) ).

% funpow_swap1
thf(fact_4948_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( ( F2 @ A2 @ B2 )
          = Z )
        = ( ( A2 = Z )
          & ( B2 = Z ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
thf(fact_4949_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( Z
          = ( F2 @ A2 @ B2 ) )
        = ( ( A2 = Z )
          & ( B2 = Z ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
thf(fact_4950_funpow__mult,axiom,
    ! [A: $tType,N2: nat,M2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N2 @ ( compow @ ( A > A ) @ M2 @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M2 @ N2 ) @ F2 ) ) ).

% funpow_mult
thf(fact_4951_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N2 @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% comp_funpow
thf(fact_4952_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_4953_funpow__Suc__right,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_4954_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_4955_funpow__add,axiom,
    ! [A: $tType,M2: nat,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M2 @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M2 @ F2 ) @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow_add
thf(fact_4956_card__Union__le__sum__card,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ).

% card_Union_le_sum_card
thf(fact_4957_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_4958_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B5: set @ ( set @ B ),G2: B > A] :
          ( ! [X3: set @ B] :
              ( ( member @ ( set @ B ) @ X3 @ B5 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B5 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B5 )
                   => ( ( A14 != A25 )
                     => ! [X3: B] :
                          ( ( member @ B @ X3 @ A14 )
                         => ( ( member @ B @ X3 @ A25 )
                           => ( ( G2 @ X3 )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( complete_Sup_Sup @ ( set @ B ) @ B5 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G2 @ B5 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_4959_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ U4 )
         => ( finite_finite @ A @ X3 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_4960_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N: nat] : ( compow @ ( A > A ) @ N @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_4961_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_4962_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L ) ) @ E ) ) ) ) ).

% cInf_asclose
thf(fact_4963_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L ) ) @ E ) ) ) ) ).

% cSup_asclose
thf(fact_4964_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K3: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K3 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_4965_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_4966_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_4967_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastLessThan
thf(fact_4968_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastAtMost
thf(fact_4969_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastAtMost
thf(fact_4970_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastLessThan
thf(fact_4971_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
          | ( ord_less @ A @ B4 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_4972_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X2: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X2 )
                        & ( ord_less @ A @ X2 @ C3 ) )
                     => ( P @ X2 ) )
                  & ! [D6: A] :
                      ( ! [X3: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X3 )
                            & ( ord_less @ A @ X3 @ D6 ) )
                         => ( P @ X3 ) )
                     => ( ord_less_eq @ A @ D6 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_4973_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ( ord_less_eq @ A @ X3 @ A2 ) )
         => ( ! [Y2: A] :
                ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X8 )
                   => ( ord_less_eq @ A @ X2 @ Y2 ) )
               => ( ord_less_eq @ A @ A2 @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_4974_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X8: set @ A] :
          ( ( member @ A @ Z @ X8 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = Z ) ) ) ) ).

% cSup_eq_maximum
thf(fact_4975_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ( ord_less_eq @ A @ A2 @ X3 ) )
         => ( ! [Y2: A] :
                ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X8 )
                   => ( ord_less_eq @ A @ Y2 @ X2 ) )
               => ( ord_less_eq @ A @ Y2 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_4976_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X8: set @ A] :
          ( ( member @ A @ Z @ X8 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = Z ) ) ) ) ).

% cInf_eq_minimum
thf(fact_4977_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ! [Y2: A] :
                  ( ! [X2: A] :
                      ( ( member @ A @ X2 @ X8 )
                     => ( ord_less_eq @ A @ X2 @ Y2 ) )
                 => ( ord_less_eq @ A @ A2 @ Y2 ) )
             => ( ( complete_Sup_Sup @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_4978_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X8 ) @ Z ) ) ) ) ).

% cSup_least
thf(fact_4979_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_4980_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z @ ( complete_Sup_Sup @ A @ X8 ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X8 )
                & ( ord_less @ A @ Z @ X3 ) ) ) ) ) ).

% less_cSupD
thf(fact_4981_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y: A,X8: set @ A] :
          ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X8 ) )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ~ ( ord_less @ A @ Y @ X3 ) ) ) ) ) ).

% less_cSupE
thf(fact_4982_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ( ord_less @ A @ X3 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_4983_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ A2 @ X3 ) )
           => ( ! [Y2: A] :
                  ( ! [X2: A] :
                      ( ( member @ A @ X2 @ X8 )
                     => ( ord_less_eq @ A @ Y2 @ X2 ) )
                 => ( ord_less_eq @ A @ Y2 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_4984_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ).

% cInf_greatest
thf(fact_4985_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ X ) ) ) ) ).

% cInf_le_finite
thf(fact_4986_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Z )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X8 )
                & ( ord_less @ A @ X3 @ Z ) ) ) ) ) ).

% cInf_lessD
thf(fact_4987_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ( ord_less @ A @ A2 @ X3 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_4988_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ X8 )
                   => ( ord_less @ A @ X4 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_4989_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ X8 )
                   => ( ord_less @ A @ A2 @ X4 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_4990_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_4991_Sup__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A,X: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ S2 ) )
                = X ) )
            & ( ( S2
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert2 @ A @ X @ S2 ) )
                = ( ord_max @ A @ X @ ( complete_Sup_Sup @ A @ S2 ) ) ) ) ) ) ) ).

% Sup_insert_finite
thf(fact_4992_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A5 )
            = ( bot_bot @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X4 )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ A5 )
                    & ( ord_less @ A @ Y4 @ X4 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_4993_finite__subset__Union,axiom,
    ! [A: $tType,A5: set @ A,B11: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( complete_Sup_Sup @ ( set @ A ) @ B11 ) )
       => ~ ! [F7: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F7 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F7 @ B11 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A5 @ ( complete_Sup_Sup @ ( set @ A ) @ F7 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_4994_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( A5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ).

% Inf_le_Sup
thf(fact_4995_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ! [Y2: A] :
              ( ( member @ A @ Y2 @ A5 )
             => ( ord_less_eq @ A @ Y2 @ X ) )
         => ( ! [Y2: A] :
                ( ! [Z4: A] :
                    ( ( member @ A @ Z4 @ A5 )
                   => ( ord_less_eq @ A @ Z4 @ Y2 ) )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ A5 )
              = X ) ) ) ) ).

% Sup_eqI
thf(fact_4996_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ! [A4: A] :
              ( ( member @ A @ A4 @ A5 )
             => ? [X2: A] :
                  ( ( member @ A @ X2 @ B5 )
                  & ( ord_less_eq @ A @ A4 @ X2 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B5 ) ) ) ) ).

% Sup_mono
thf(fact_4997_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A5 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ Z ) ) ) ).

% Sup_least
thf(fact_4998_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A5: set @ A] :
          ( ( member @ A @ X @ A5 )
         => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ).

% Sup_upper
thf(fact_4999_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ B2 )
          = ( ! [X4: A] :
                ( ( member @ A @ X4 @ A5 )
               => ( ord_less_eq @ A @ X4 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5000_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A5: set @ A,V2: A] :
          ( ( member @ A @ U @ A5 )
         => ( ( ord_less_eq @ A @ V2 @ U )
           => ( ord_less_eq @ A @ V2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5001_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S2: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) )
          = ( ? [X4: A] :
                ( ( member @ A @ X4 @ S2 )
                & ( ord_less @ A @ A2 @ X4 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5002_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ! [I3: A] :
              ( ( member @ A @ I3 @ A5 )
             => ( ord_less_eq @ A @ X @ I3 ) )
         => ( ! [Y2: A] :
                ( ! [I: A] :
                    ( ( member @ A @ I @ A5 )
                   => ( ord_less_eq @ A @ Y2 @ I ) )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( complete_Inf_Inf @ A @ A5 )
              = X ) ) ) ) ).

% Inf_eqI
thf(fact_5003_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: set @ A,A5: set @ A] :
          ( ! [B4: A] :
              ( ( member @ A @ B4 @ B5 )
             => ? [X2: A] :
                  ( ( member @ A @ X2 @ A5 )
                  & ( ord_less_eq @ A @ X2 @ B4 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B5 ) ) ) ) ).

% Inf_mono
thf(fact_5004_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A5: set @ A] :
          ( ( member @ A @ X @ A5 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ X ) ) ) ).

% Inf_lower
thf(fact_5005_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A5: set @ A,V2: A] :
          ( ( member @ A @ U @ A5 )
         => ( ( ord_less_eq @ A @ U @ V2 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ V2 ) ) ) ) ).

% Inf_lower2
thf(fact_5006_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A5: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A5 ) )
          = ( ! [X4: A] :
                ( ( member @ A @ X4 @ A5 )
               => ( ord_less_eq @ A @ B2 @ X4 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5007_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A5 )
             => ( ord_less_eq @ A @ Z @ X3 ) )
         => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A5 ) ) ) ) ).

% Inf_greatest
thf(fact_5008_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 )
          = ( ? [X4: A] :
                ( ( member @ A @ X4 @ S2 )
                & ( ord_less @ A @ X4 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5009_Union__subsetI,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B5: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ A5 )
         => ? [Y5: set @ A] :
              ( ( member @ ( set @ A ) @ Y5 @ B5 )
              & ( ord_less_eq @ ( set @ A ) @ X3 @ Y5 ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B5 ) ) ) ).

% Union_subsetI
thf(fact_5010_Union__upper,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B5 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ B5 @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) ) ) ).

% Union_upper
thf(fact_5011_Union__least,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),C6: set @ A] :
      ( ! [X9: set @ A] :
          ( ( member @ ( set @ A ) @ X9 @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ X9 @ C6 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ C6 ) ) ).

% Union_least
thf(fact_5012_Inter__greatest,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),C6: set @ A] :
      ( ! [X9: set @ A] :
          ( ( member @ ( set @ A ) @ X9 @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ C6 @ X9 ) )
     => ( ord_less_eq @ ( set @ A ) @ C6 @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) ) ) ).

% Inter_greatest
thf(fact_5013_Inter__lower,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B5 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ B5 ) ) ).

% Inter_lower
thf(fact_5014_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,A5: set @ A] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A5 ) )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ Y4 @ X )
               => ? [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                    & ( ord_less @ A @ Y4 @ X4 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5015_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ X )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ X @ Y4 )
               => ? [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                    & ( ord_less @ A @ X4 @ Y4 ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5016_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A5 )
             => ( ord_less_eq @ A @ U @ V3 ) )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5017_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B5 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5018_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A5 )
             => ( ord_less_eq @ A @ V3 @ U ) )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_5019_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: set @ A,A5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B5 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5020_Union__mono,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B5: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B5 ) ) ) ).

% Union_mono
thf(fact_5021_Inter__anti__mono,axiom,
    ! [A: $tType,B5: set @ ( set @ A ),A5: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B5 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B5 ) ) ) ).

% Inter_anti_mono
thf(fact_5022_Inter__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B5: set @ A] :
      ( ! [X9: set @ A] :
          ( ( member @ ( set @ A ) @ X9 @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ X9 @ B5 ) )
     => ( ( A5
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ B5 ) ) ) ).

% Inter_subset
thf(fact_5023_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N: nat,P3: A > A > $o,X4: A,Y4: A] :
          ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = X4 )
            & ( ( F3 @ N )
              = Y4 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N )
               => ( P3 @ ( F3 @ I4 ) @ ( F3 @ ( suc @ I4 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5024_relpowp__1,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( one_one @ nat ) @ P )
      = P ) ).

% relpowp_1
thf(fact_5025_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5026_relpowp__bot,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( compow @ ( A > A > $o ) @ N2 @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5027_card__partition,axiom,
    ! [A: $tType,C6: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C6 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
       => ( ! [C3: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C6 )
             => ( ( finite_card @ A @ C3 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C6 )
               => ( ( member @ ( set @ A ) @ C22 @ C6 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C6 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5028_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5029_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5030_inf_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ A2 )
          = A2 ) ) ).

% inf.idem
thf(fact_5031_inf__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) ).

% inf_idem
thf(fact_5032_inf_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ A2 @ ( inf_inf @ A @ A2 @ B2 ) )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) ).

% inf.left_idem
thf(fact_5033_inf__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_left_idem
thf(fact_5034_inf_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) ).

% inf.right_idem
thf(fact_5035_inf__right__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Y )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_right_idem
thf(fact_5036_inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B,X4: A] : ( inf_inf @ B @ ( F3 @ X4 ) @ ( G @ X4 ) ) ) ) ) ).

% inf_apply
thf(fact_5037_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% le_inf_iff
thf(fact_5038_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_5039_inf__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_left
thf(fact_5040_inf__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_right
thf(fact_5041_Int__subset__iff,axiom,
    ! [A: $tType,C6: set @ A,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C6 @ A5 )
        & ( ord_less_eq @ ( set @ A ) @ C6 @ B5 ) ) ) ).

% Int_subset_iff
thf(fact_5042_removeAll__id,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X @ Xs )
        = Xs ) ) ).

% removeAll_id
thf(fact_5043_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A5: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X4 ) ) @ ( F2 @ X4 ) )
              @ A5 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5044_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A5: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X4 ) ) )
              @ A5 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5045_inf__sup__aci_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_sup_aci(4)
thf(fact_5046_inf__sup__aci_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) ).

% inf_sup_aci(3)
thf(fact_5047_inf__sup__aci_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) ).

% inf_sup_aci(2)
thf(fact_5048_inf__sup__aci_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X4: A,Y4: A] : ( inf_inf @ A @ Y4 @ X4 ) ) ) ) ).

% inf_sup_aci(1)
thf(fact_5049_inf_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.assoc
thf(fact_5050_inf__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) ).

% inf_assoc
thf(fact_5051_inf_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [A3: A,B3: A] : ( inf_inf @ A @ B3 @ A3 ) ) ) ) ).

% inf.commute
thf(fact_5052_inf__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X4: A,Y4: A] : ( inf_inf @ A @ Y4 @ X4 ) ) ) ) ).

% inf_commute
thf(fact_5053_inf_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A2 @ C2 ) )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.left_commute
thf(fact_5054_inf__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) ).

% inf_left_commute
thf(fact_5055_inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B,X4: A] : ( inf_inf @ B @ ( F3 @ X4 ) @ ( G @ X4 ) ) ) ) ) ).

% inf_fun_def
thf(fact_5056_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_5057_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_5058_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( inf_inf @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_5059_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_5060_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_5061_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_5062_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_5063_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_5064_Int__mono,axiom,
    ! [A: $tType,A5: set @ A,C6: set @ A,B5: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) @ ( inf_inf @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Int_mono
thf(fact_5065_Int__lower1,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) @ A5 ) ).

% Int_lower1
thf(fact_5066_Int__lower2,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) @ B5 ) ).

% Int_lower2
thf(fact_5067_Int__absorb1,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B5 )
        = B5 ) ) ).

% Int_absorb1
thf(fact_5068_Int__absorb2,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( inf_inf @ ( set @ A ) @ A5 @ B5 )
        = A5 ) ) ).

% Int_absorb2
thf(fact_5069_Int__greatest,axiom,
    ! [A: $tType,C6: set @ A,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ B5 )
       => ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) ) ) ).

% Int_greatest
thf(fact_5070_Int__Collect__mono,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A5 )
           => ( ( P @ X3 )
             => ( Q @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B5 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_5071_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_5072_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_5073_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_le1
thf(fact_5074_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_5075_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A2 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_5076_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_5077_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_5078_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_5079_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_5080_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_5081_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_5082_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X3: A,Y2: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y2 ) @ X3 )
         => ( ! [X3: A,Y2: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y2 ) @ Y2 )
           => ( ! [X3: A,Y2: A,Z3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ( ord_less_eq @ A @ X3 @ Z3 )
                   => ( ord_less_eq @ A @ X3 @ ( F2 @ Y2 @ Z3 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_5083_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X4: A,Y4: A] :
              ( ( inf_inf @ A @ X4 @ Y4 )
              = X4 ) ) ) ) ).

% le_iff_inf
thf(fact_5084_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_5085_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_5086_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( inf_inf @ A @ X @ Y )
            = X ) ) ) ).

% inf_absorb1
thf(fact_5087_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( inf_inf @ A @ X @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_5088_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_5089_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_5090_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Z )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) ) ).

% inf_greatest
thf(fact_5091_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( A3
              = ( inf_inf @ A @ A3 @ B3 ) ) ) ) ) ).

% inf.order_iff
thf(fact_5092_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_5093_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_5094_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( inf_inf @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_5095_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( inf_inf @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_5096_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_5097_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_5098_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_removeAll
thf(fact_5099_bot2E,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X @ Y ) ).

% bot2E
thf(fact_5100_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B5: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B5 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5101_Union__Int__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B5: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A5 @ B5 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A5 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B5 ) ) ) ).

% Union_Int_subset
thf(fact_5102_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_5103_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_5104_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A5 @ B5 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ ( uminus_uminus @ ( set @ A ) @ B5 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_5105_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ Xs )
        = ( removeAll @ A @ X @ Xs ) ) ) ).

% distinct_remove1_removeAll
thf(fact_5106_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G2: B > A,B5: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( member @ B @ X4 @ B5 ) @ ( G2 @ X4 ) @ ( one_one @ A ) )
              @ A5 ) ) ) ) ).

% prod.inter_restrict
thf(fact_5107_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_5108_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,G2: B > A,B5: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5109_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,G2: B > A,B5: set @ B] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5110_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S2: set @ B,H2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
                 => ( ( H2 @ I3 )
                    = ( one_one @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T6 ) )
                   => ( ( G2 @ I3 )
                      = ( one_one @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S2 @ T6 ) )
                     => ( ( G2 @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ S2 )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_5111_length__removeAll__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_5112_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,P: B > $o,H2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( P @ X4 ) @ ( H2 @ X4 ) @ ( G2 @ X4 ) )
              @ A5 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5113_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,P: B > $o,H2: B > A,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X4: B] : ( if @ A @ ( P @ X4 ) @ ( H2 @ X4 ) @ ( G2 @ X4 ) )
              @ A5 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5114_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A5: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A3: B] : ( divide_divide @ A @ ( F2 @ A3 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A5
                  @ ( collect @ B
                    @ ^ [A3: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A3 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A5
                    @ ( collect @ B
                      @ ^ [A3: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A3 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5115_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys4: list @ A] :
            ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys4 ) )
       => ( ! [Ys4: list @ A,Zs2: list @ A] :
              ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys4 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_5116_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5117_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X2: A] :
                  ( ( member @ A @ X2 @ S2 )
                  & ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5118_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y: A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y @ S2 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) @ ( F2 @ Y ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5119_finite__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( finite_finite @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% finite_shuffles
thf(fact_5120_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] : ( shuffles @ A @ Ys3 @ Xs3 ) ) ) ).

% shuffles_commutes
thf(fact_5121_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_5122_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_5123_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) @ S2 ) ) ) ) ).

% arg_min_if_finite(1)
thf(fact_5124_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
        & ! [Ys3: list @ A,Zs3: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys3 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_5125_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xss ) )
         => ( distinct @ A @ X3 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) ) ).

% distinct_product_lists
thf(fact_5126_times__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X4: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) )
          @ Xa2
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_5127_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X: A] :
      ( ( ( list_update @ A @ Xs @ K @ X )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_5128_concat__replicate__trivial,axiom,
    ! [A: $tType,I2: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I2 @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_5129_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_5130_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N2: nat] :
      ( ( enumerate @ A @ N2 @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_5131_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_5132_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_5133_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_5134_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_5135_empty__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N2 @ X ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_5136_replicate__empty,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( replicate @ A @ N2 @ X )
        = ( nil @ A ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_5137_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss )
        = ( nil @ A ) )
      = ( ! [X4: list @ A] :
            ( ( member @ ( list @ A ) @ X4 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X4
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_5138_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss ) )
      = ( ! [X4: list @ A] :
            ( ( member @ ( list @ A ) @ X4 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X4
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_5139_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_5140_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert2 @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_5141_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_5142_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_5143_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( Ys
          = ( nil @ A ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_5144_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_5145_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu2: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu2 )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_5146_list__update__code_I1_J,axiom,
    ! [A: $tType,I2: nat,Y: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ Y )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_5147_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I2: nat,V2: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ V2 )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_5148_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_5149_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remove1 @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_5150_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( removeAll @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_5151_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_5152_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_5153_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_5154_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_5155_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert2 @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_5156_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5157_less__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X4: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) )
        @ Xa2
        @ X ) ) ).

% less_int.abs_eq
thf(fact_5158_less__eq__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X4: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) )
        @ Xa2
        @ X ) ) ).

% less_eq_int.abs_eq
thf(fact_5159_plus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X4: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) )
          @ Xa2
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_5160_minus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X4: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) )
          @ Xa2
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_5161_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_5162_insert__subsetI,axiom,
    ! [A: $tType,X: A,A5: set @ A,X8: set @ A] :
      ( ( member @ A @ X @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ X8 @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ X8 ) @ A5 ) ) ) ).

% insert_subsetI
thf(fact_5163_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_5164_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_5165_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W2: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% iszero_neg_numeral
thf(fact_5166_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W2: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W2 ) ) ) ).

% not_iszero_numeral
thf(fact_5167_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [X4: A,Y4: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X4 @ Y4 ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_5168_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_5169_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z5: A] :
              ( Z5
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_5170_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_5171_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_5172_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_5173_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_5174_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_5175_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_5176_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_5177_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_5178_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_5179_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_5180_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_5181_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y @ X ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_5182_Collect__restrict,axiom,
    ! [A: $tType,X8: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X4: A] :
            ( ( member @ A @ X4 @ X8 )
            & ( P @ X4 ) ) )
      @ X8 ) ).

% Collect_restrict
thf(fact_5183_prop__restrict,axiom,
    ! [A: $tType,X: A,Z7: set @ A,X8: set @ A,P: A > $o] :
      ( ( member @ A @ X @ Z7 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z7
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ X8 )
                & ( P @ X4 ) ) ) )
       => ( P @ X ) ) ) ).

% prop_restrict
thf(fact_5184_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_5185_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_5186_subset__emptyI,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ! [X3: A] :
          ~ ( member @ A @ X3 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_5187_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_5188_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X4: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y4: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X4 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5189_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X4: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y4: nat,Z5: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z5 ) ) )
          @ ( rep_Integ @ X4 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5190_num__of__nat_Osimps_I2_J,axiom,
    ! [N2: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = ( inc @ ( num_of_nat @ N2 ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_5191_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,P4: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member @ B @ X4 @ I6 )
                  & ( ( P4 @ X4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert2 @ B @ I2 @ I6 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P4 @ I6 ) ) )
            & ( ~ ( member @ B @ I2 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert2 @ B @ I2 @ I6 ) )
                = ( times_times @ A @ ( P4 @ I2 ) @ ( groups1962203154675924110t_prod @ B @ A @ P4 @ I6 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5192_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5193_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q2 ) )
      = Q2 ) ).

% num_of_nat_numeral_eq
thf(fact_5194_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_5195_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ A5 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_5196_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A5 ) )
            = A5 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_5197_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_5198_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) )
          = ( finite_card @ A @ A5 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_5199_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( nil @ A ) )
            = ( A5
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5200_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A5 )
            = ( linord4507533701916653071of_set @ A @ B5 ) )
         => ( ( finite_finite @ A @ A5 )
           => ( ( finite_finite @ A @ B5 )
             => ( A5 = B5 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_5201_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: B > A,I6: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G2
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member @ B @ X4 @ I6 )
                  & ( ( G2 @ X4 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G2 @ I6 ) ) ) ).

% prod.non_neutral'
thf(fact_5202_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_5203_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_5204_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I4: B] : ( times_times @ A @ ( G2 @ I4 ) @ ( H2 @ I4 ) )
              @ I6 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G2 @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I6 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5205_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G2 @ S2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G2 @ T6 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_5206_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G2 @ T6 )
              = ( groups1962203154675924110t_prod @ B @ A @ G2 @ S2 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_5207_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,H2: B > A,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( H2 @ I3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G2 @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G2 @ S2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_5208_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ B,G2: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S2 ) )
               => ( ( G2 @ X3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S2 )
                 => ( ( G2 @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G2 @ T6 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_5209_numeral__num__of__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N2 ) )
        = N2 ) ) ).

% numeral_num_of_nat
thf(fact_5210_num__of__nat__One,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N2 )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_5211_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G2: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X4: B] :
                  ( ( member @ B @ X4 @ I6 )
                  & ( ( G2 @ X4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X4: B] :
                    ( ( member @ B @ X4 @ I6 )
                    & ( ( H2 @ X4 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I4: B] : ( times_times @ A @ ( G2 @ I4 ) @ ( H2 @ I4 ) )
                @ I6 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G2 @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I6 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5212_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P6: B > A,I8: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X4: B] :
                      ( ( member @ B @ X4 @ I8 )
                      & ( ( P6 @ X4 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X4: B] :
                      ( ( member @ B @ X4 @ I8 )
                      & ( ( P6 @ X4 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_5213_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N2: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ ( suc @ I2 ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I2 @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5214_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_5215_num__of__nat__double,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N2 @ N2 ) )
        = ( bit0 @ ( num_of_nat @ N2 ) ) ) ) ).

% num_of_nat_double
thf(fact_5216_num__of__nat__plus__distrib,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M2 @ N2 ) )
          = ( plus_plus @ num @ ( num_of_nat @ M2 ) @ ( num_of_nat @ N2 ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_5217_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5218_pow_Osimps_I3_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit1 @ Y ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X @ Y ) ) @ X ) ) ).

% pow.simps(3)
thf(fact_5219_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X4: A] : X4 ) ) ) ).

% sorted_list_of_set_def
thf(fact_5220_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X: B,F2: B > A,Xs: list @ B] :
          ( ( remove1 @ B @ X @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = Xs ) ) ).

% remove1_insort_key
thf(fact_5221_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% length_insort
thf(fact_5222_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ X
                @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_5223_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ Y )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ Y ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_5224_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X4: A] : X4
            @ X
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ Y
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X4: A] : X4
            @ Y
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_5225_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Xs: list @ B] :
          ( ( ( F2 @ X )
           != ( F2 @ Y ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_insort_key @ B @ A @ F2 @ Y @ Xs ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_5226_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,A2: B,Xs: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_5227_sqr_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N2 ) ) ) ) ).

% sqr.simps(2)
thf(fact_5228_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_5229_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( insert2 @ B @ X @ ( set2 @ B @ Xs ) ) ) ) ).

% set_insort_key
thf(fact_5230_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
          = ( ~ ( member @ B @ X @ ( set2 @ B @ Xs ) )
            & ( distinct @ B @ Xs ) ) ) ) ).

% distinct_insort
thf(fact_5231_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X4: num] : ( times_times @ num @ X4 @ X4 ) ) ) ).

% sqr_conv_mult
thf(fact_5232_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5233_pow_Osimps_I2_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit0 @ Y ) )
      = ( sqr @ ( pow @ X @ Y ) ) ) ).

% pow.simps(2)
thf(fact_5234_sqr_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N2 ) @ N2 ) ) ) ) ).

% sqr.simps(3)
thf(fact_5235_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ X
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5236_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N2: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ I2 ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I2 @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_5237_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y )
       => ( ( image @ nat @ nat
            @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y )
       => ( ( ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( insert2 @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_5238_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_5239_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N4: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N4 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N4 ) ) ).

% bij_betw_Suc
thf(fact_5240_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S2 )
          = S2 ) ) ).

% image_add_0
thf(fact_5241_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I2 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_5242_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_5243_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_5244_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A5: set @ A,B5: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A5 @ B5 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A5 )
            = B5 ) ) ) ).

% bij_betw_add
thf(fact_5245_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L: A,U: A] :
          ( ( member @ A @ I2 @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I2 )
            & ( ord_less_eq @ A @ I2 @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_5246_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_5247_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_5248_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_5249_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_5250_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_5251_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_5252_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_5253_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_5254_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_5255_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N: A] : ( plus_plus @ A @ N @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I2 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_5256_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N: A] : ( plus_plus @ A @ N @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_5257_mult__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( times_times @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ C2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ).

% mult_rat
thf(fact_5258_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( divide_divide @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_5259_floor__Fract,axiom,
    ! [A2: int,B2: int] :
      ( ( archim6421214686448440834_floor @ rat @ ( fract @ A2 @ B2 ) )
      = ( divide_divide @ int @ A2 @ B2 ) ) ).

% floor_Fract
thf(fact_5260_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) )
            = ( bot_bot @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X4 )
               => ? [Y4: B] :
                    ( ( member @ B @ Y4 @ A5 )
                    & ( ord_less @ A @ ( F2 @ Y4 ) @ X4 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_5261_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_5262_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C4: A] : ( divide_divide @ A @ C4 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_5263_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_5264_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_5265_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_5266_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_5267_sgn__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( sgn_sgn @ rat @ ( fract @ A2 @ B2 ) )
      = ( ring_1_of_int @ rat @ ( times_times @ int @ ( sgn_sgn @ int @ A2 ) @ ( sgn_sgn @ int @ B2 ) ) ) ) ).

% sgn_rat
thf(fact_5268_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ B,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B5 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( pow2 @ B @ A5 ) ) @ ( pow2 @ A @ B5 ) ) ) ).

% image_Pow_mono
thf(fact_5269_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,F2: B > A,A5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ ( image @ B @ A @ F2 @ A5 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A5 )
            & ( B5
              = ( image @ B @ A @ F2 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_5270_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B5 )
      = ( ! [X4: B] :
            ( ( member @ B @ X4 @ A5 )
           => ( member @ A @ ( F2 @ X4 ) @ B5 ) ) ) ) ).

% image_subset_iff
thf(fact_5271_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,F2: B > A,A5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ ( image @ B @ A @ F2 @ A5 ) )
     => ~ ! [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A5 )
           => ( B5
             != ( image @ B @ A @ F2 @ C7 ) ) ) ) ).

% subset_imageE
thf(fact_5272_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,F2: A > B,B5: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A5 )
         => ( member @ B @ ( F2 @ X3 ) @ B5 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B5 ) ) ).

% image_subsetI
thf(fact_5273_image__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B5 ) ) ) ).

% image_mono
thf(fact_5274_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_5275_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A5 ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B8 @ A5 )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_subset_image
thf(fact_5276_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B5: set @ B] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( member @ B @ ( F2 @ X3 ) @ B5 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B5 ) ) ).

% image_Collect_subsetI
thf(fact_5277_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B5: set @ C,F2: B > A,G2: C > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ? [X2: C] :
                  ( ( member @ C @ X2 @ B5 )
                  & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G2 @ X2 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B5 )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A5 )
                    & ( ord_less_eq @ A @ ( G2 @ J2 ) @ ( F2 @ X2 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G2 @ B5 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_5278_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B5: set @ C,G2: C > A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ? [X2: C] :
                  ( ( member @ C @ X2 @ B5 )
                  & ( ord_less_eq @ A @ ( G2 @ X2 ) @ ( F2 @ I3 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B5 )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A5 )
                    & ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G2 @ B5 ) ) ) ) ) ) ).

% INF_eq
thf(fact_5279_finite__surj,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,B5: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ B5 @ ( image @ A @ B @ F2 @ A5 ) )
       => ( finite_finite @ B @ B5 ) ) ) ).

% finite_surj
thf(fact_5280_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,F2: B > A,A5: set @ B] :
      ( ( finite_finite @ A @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ ( image @ B @ A @ F2 @ A5 ) )
       => ? [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A5 )
            & ( finite_finite @ B @ C7 )
            & ( B5
              = ( image @ B @ A @ F2 @ C7 ) ) ) ) ) ).

% finite_subset_image
thf(fact_5281_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B8: set @ A] :
            ( ( finite_finite @ A @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A5 ) )
            & ( P @ B8 ) ) )
      = ( ? [B8: set @ B] :
            ( ( finite_finite @ B @ B8 )
            & ( ord_less_eq @ ( set @ B ) @ B8 @ A5 )
            & ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_5282_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ( finite_finite @ A @ B8 )
              & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A5 ) ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ( finite_finite @ B @ B8 )
              & ( ord_less_eq @ ( set @ B ) @ B8 @ A5 ) )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_5283_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_5284_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_5285_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,B5: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ ( image @ B @ A @ F2 @ B5 ) ) ) ).

% image_Int_subset
thf(fact_5286_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B,B5: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ ( image @ B @ A @ F2 @ B5 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) ) ) ).

% image_diff_subset
thf(fact_5287_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_5288_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_5289_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A2 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_5290_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,A9: set @ B,B5: set @ A,B12: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A5 @ A9 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
       => ( ( ( image @ A @ B @ F2 @ B5 )
            = B12 )
         => ( bij_betw @ A @ B @ F2 @ B5 @ B12 ) ) ) ) ).

% bij_betw_subset
thf(fact_5291_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,F6: B > A,F2: A > B,A9: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A5 )
         => ( ( F6 @ ( F2 @ X3 ) )
            = X3 ) )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ A9 )
           => ( ( F2 @ ( F6 @ X3 ) )
              = X3 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ A9 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F6 @ A9 ) @ A5 )
           => ( bij_betw @ A @ B @ F2 @ A5 @ A9 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_5292_Fract__of__nat__eq,axiom,
    ! [K: nat] :
      ( ( fract @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) )
      = ( semiring_1_of_nat @ rat @ K ) ) ).

% Fract_of_nat_eq
thf(fact_5293_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_5294_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_5295_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_5296_Fract__coprime,axiom,
    ! [A2: int,B2: int] :
      ( ( fract @ ( divide_divide @ int @ A2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) @ ( divide_divide @ int @ B2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) )
      = ( fract @ A2 @ B2 ) ) ).

% Fract_coprime
thf(fact_5297_One__rat__def,axiom,
    ( ( one_one @ rat )
    = ( fract @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% One_rat_def
thf(fact_5298_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A5: set @ B,U: A,F2: B > A] :
          ( ( member @ B @ I2 @ A5 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I2 ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_5299_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A5: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U )
          = ( ! [X4: B] :
                ( ( member @ B @ X4 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X4 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_5300_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A5: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A5 )
         => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ).

% SUP_upper
thf(fact_5301_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G2: B > A,A5: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ A5 ) ) ) ) ) ).

% SUP_mono'
thf(fact_5302_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_5303_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B5: set @ C,F2: B > A,G2: C > A] :
          ( ! [N3: B] :
              ( ( member @ B @ N3 @ A5 )
             => ? [X2: C] :
                  ( ( member @ C @ X2 @ B5 )
                  & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G2 @ X2 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G2 @ B5 ) ) ) ) ) ).

% SUP_mono
thf(fact_5304_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,F2: B > A,X: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ X ) )
         => ( ! [Y2: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A5 )
                   => ( ord_less_eq @ A @ ( F2 @ I ) @ Y2 ) )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = X ) ) ) ) ).

% SUP_eqI
thf(fact_5305_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A5: set @ B,Y: A,I2: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ Y )
         => ( ( member @ B @ I2 @ A5 )
           => ( ord_less @ A @ ( F2 @ I2 ) @ Y ) ) ) ) ).

% SUP_lessD
thf(fact_5306_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A5: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
          = ( ? [X4: B] :
                ( ( member @ B @ X4 @ A5 )
                & ( ord_less @ A @ A2 @ ( F2 @ X4 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_5307_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,U: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ).

% INF_greatest
thf(fact_5308_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A5: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
          = ( ! [X4: B] :
                ( ( member @ B @ X4 @ A5 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X4 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_5309_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A5: set @ B,F2: B > A,U: A] :
          ( ( member @ B @ I2 @ A5 )
         => ( ( ord_less_eq @ A @ ( F2 @ I2 ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_5310_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G2: B > A,A5: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ A5 ) ) ) ) ) ).

% INF_mono'
thf(fact_5311_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A5: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A5 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( F2 @ I2 ) ) ) ) ).

% INF_lower
thf(fact_5312_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: set @ B,A5: set @ C,F2: C > A,G2: B > A] :
          ( ! [M4: B] :
              ( ( member @ B @ M4 @ B5 )
             => ? [X2: C] :
                  ( ( member @ C @ X2 @ A5 )
                  & ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ M4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ B5 ) ) ) ) ) ).

% INF_mono
thf(fact_5313_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,X: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A5 )
             => ( ord_less_eq @ A @ X @ ( F2 @ I3 ) ) )
         => ( ! [Y2: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A5 )
                   => ( ord_less_eq @ A @ Y2 @ ( F2 @ I ) ) )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) )
              = X ) ) ) ) ).

% INF_eqI
thf(fact_5314_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y: A,F2: B > A,A5: set @ B,I2: B] :
          ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
         => ( ( member @ B @ I2 @ A5 )
           => ( ord_less @ A @ Y @ ( F2 @ I2 ) ) ) ) ) ).

% less_INF_D
thf(fact_5315_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ A2 )
          = ( ? [X4: B] :
                ( ( member @ B @ X4 @ A5 )
                & ( ord_less @ A @ ( F2 @ X4 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_5316_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N: nat,F3: nat > A] :
            ( A7
            = ( image @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_5317_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A5: set @ A,F2: nat > A,N2: nat] :
      ( ( A5
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) ) )
     => ( finite_finite @ A @ A5 ) ) ).

% nat_seg_image_imp_finite
thf(fact_5318_Fract__of__int__eq,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( one_one @ int ) )
      = ( ring_1_of_int @ rat @ K ) ) ).

% Fract_of_int_eq
thf(fact_5319_Fract__of__int__quotient,axiom,
    ( fract
    = ( ^ [K3: int,L2: int] : ( divide_divide @ rat @ ( ring_1_of_int @ rat @ K3 ) @ ( ring_1_of_int @ rat @ L2 ) ) ) ) ).

% Fract_of_int_quotient
thf(fact_5320_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,F2: B > A,A5: set @ B] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ Y4 @ X )
               => ? [X4: B] :
                    ( ( member @ B @ X4 @ A5 )
                    & ( ord_less @ A @ Y4 @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_5321_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ X )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ X @ Y4 )
               => ? [X4: B] :
                    ( ( member @ B @ X4 @ A5 )
                    & ( ord_less @ A @ ( F2 @ X4 ) @ Y4 ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_5322_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,F2: B > A,M7: A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_5323_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,C2: A,F2: B > A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I6 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I3 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X4: B] :
                    ( ( member @ B @ X4 @ I6 )
                   => ( ( F2 @ X4 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_5324_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A5: set @ B,M2: A,F2: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A5 )
               => ( ord_less_eq @ A @ M2 @ ( F2 @ X3 ) ) )
           => ( ord_less_eq @ A @ M2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_5325_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,F2: B > A,C2: A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X4: B] :
                    ( ( member @ B @ X4 @ I6 )
                   => ( ( F2 @ X4 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_5326_card__image__le,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A5 ) ) @ ( finite_card @ A @ A5 ) ) ) ).

% card_image_le
thf(fact_5327_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F6: A > B,A9: set @ A,A10: set @ B,F2: C > A,A5: set @ C] :
      ( ( bij_betw @ A @ B @ F6 @ A9 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ A5 ) @ A9 )
       => ( ( bij_betw @ C @ A @ F2 @ A5 @ A9 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F6 @ F2 ) @ A5 @ A10 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_5328_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_5329_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_5330_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,B5: set @ B,F2: B > A,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A5 @ B5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ B5 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_5331_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B5: set @ B,A5: set @ B,F2: B > A,G2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B5 @ A5 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ B5 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ B5 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_5332_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T6: set @ C,G2: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G2 @ S2 ) @ T6 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y4: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X4: B] :
                            ( ( member @ B @ X4 @ S2 )
                            & ( ( G2 @ X4 )
                              = Y4 ) ) ) )
                  @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% sum.group
thf(fact_5333_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T6: set @ C,G2: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G2 @ S2 ) @ T6 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y4: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X4: B] :
                            ( ( member @ B @ X4 @ S2 )
                            & ( ( G2 @ X4 )
                              = Y4 ) ) ) )
                  @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.group
thf(fact_5334_rat__number__collapse_I3_J,axiom,
    ! [W2: num] :
      ( ( fract @ ( numeral_numeral @ int @ W2 ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W2 ) ) ).

% rat_number_collapse(3)
thf(fact_5335_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K3: num] : ( fract @ ( numeral_numeral @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_5336_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ B,F2: B > A] :
          ( ( A5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_5337_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,H2: B > C,G2: C > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ! [X3: B,Y2: B] :
                ( ( member @ B @ X3 @ A5 )
               => ( ( member @ B @ Y2 @ A5 )
                 => ( ( X3 != Y2 )
                   => ( ( ( H2 @ X3 )
                        = ( H2 @ Y2 ) )
                     => ( ( G2 @ ( H2 @ X3 ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G2 @ ( image @ B @ C @ H2 @ A5 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G2 @ H2 ) @ A5 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_5338_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ B5 @ ( image @ A @ B @ F2 @ A5 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B5 ) @ ( finite_card @ A @ A5 ) ) ) ) ).

% surj_card_le
thf(fact_5339_image__Suc__lessThan,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ).

% image_Suc_lessThan
thf(fact_5340_image__Suc__atMost,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N2 ) ) ) ).

% image_Suc_atMost
thf(fact_5341_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( plus_plus @ A @ ( G2 @ M2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G2 @ ( set_or3652927894154168847AtMost @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% sum.head
thf(fact_5342_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M2: nat,N2: nat,G2: nat > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N2 ) )
            = ( times_times @ A @ ( G2 @ M2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G2 @ ( set_or3652927894154168847AtMost @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% prod.head
thf(fact_5343_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_5344_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_5345_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_5346_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_5347_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_5348_rat__number__collapse_I5_J,axiom,
    ( ( fract @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) )
    = ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ).

% rat_number_collapse(5)
thf(fact_5349_Fract__add__one,axiom,
    ! [N2: int,M2: int] :
      ( ( N2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M2 @ N2 ) @ N2 )
        = ( plus_plus @ rat @ ( fract @ M2 @ N2 ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_5350_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I6: set @ C,G2: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I6 )
         => ( ! [I3: C] :
                ( ( member @ C @ I3 @ I6 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G2 @ ( F2 @ I3 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G2 @ ( image @ C @ A @ F2 @ I6 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G2 @ F2 ) @ I6 ) ) ) ) ) ).

% sum_image_le
thf(fact_5351_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_5352_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_5353_rat__number__collapse_I4_J,axiom,
    ! [W2: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W2 ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W2 ) ) ) ).

% rat_number_collapse(4)
thf(fact_5354_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_5355_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_5356_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( times_times @ A @ X4 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( times_times @ A @ X4 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( times_times @ A @ X4 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5357_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X4 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M2 @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( times_times @ A @ M2 @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M2 @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5358_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X4 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M2 @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( times_times @ A @ M2 @ X4 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M2 @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M2 @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5359_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( plus_plus @ A @ ( divide_divide @ A @ X4 @ M2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( divide_divide @ A @ X4 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M2 ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( plus_plus @ A @ ( divide_divide @ A @ X4 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M2 ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5360_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M2: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X4: A] : ( minus_minus @ A @ ( divide_divide @ A @ X4 @ M2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( divide_divide @ A @ X4 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M2 ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M2 )
               => ( ( image @ A @ A
                    @ ^ [X4: A] : ( minus_minus @ A @ ( divide_divide @ A @ X4 @ M2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M2 ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5361_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R3: set @ B,G2: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S2 )
         => ( ( finite_finite @ B @ R3 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G2 @ S2 ) @ R3 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X4: A] : ( F2 @ ( G2 @ X4 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y4: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X4: A] :
                                ( ( member @ A @ X4 @ S2 )
                                & ( ( G2 @ X4 )
                                  = Y4 ) ) ) ) )
                      @ ( F2 @ Y4 ) )
                  @ R3 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5362_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: A,B5: A] :
          ( ( inf_inf @ A @ A5
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X4: nat] : B5
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A5 @ B5 ) ) ) ).

% INF_nat_binary
thf(fact_5363_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( sums @ A @ F2
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_5364_sorted__key__list__of__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord144544945434240204of_set @ B @ A )
        = ( ^ [F3: B > A] : ( finite_folding_F @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 ) @ ( nil @ B ) ) ) ) ) ).

% sorted_key_list_of_set_def
thf(fact_5365_top__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( top @ C )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X4: D] : ( top_top @ C ) ) ) ) ).

% top_apply
thf(fact_5366_inf__top__left,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% inf_top_left
thf(fact_5367_inf__top__right,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% inf_top_right
thf(fact_5368_inf__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% inf_eq_top_iff
thf(fact_5369_top__eq__inf__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ X @ Y ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% top_eq_inf_iff
thf(fact_5370_inf__top_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inf_inf @ A @ A2 @ B2 )
            = ( top_top @ A ) )
          = ( ( A2
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.eq_neutr_iff
thf(fact_5371_inf__top_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ A2 )
          = A2 ) ) ).

% inf_top.left_neutral
thf(fact_5372_inf__top_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A,B2: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ A2 @ B2 ) )
          = ( ( A2
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.neutr_eq_iff
thf(fact_5373_inf__top_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ ( top_top @ A ) )
          = A2 ) ) ).

% inf_top.right_neutral
thf(fact_5374_max__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% max_top2
thf(fact_5375_max__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% max_top
thf(fact_5376_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_5377_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_5378_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A5 )
            = ( top_top @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ X4 @ ( top_top @ A ) )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ A5 )
                    & ( ord_less @ A @ X4 @ Y4 ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_5379_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_5380_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A5: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) )
            = ( top_top @ A ) )
          = ( ! [X4: A] :
                ( ( ord_less @ A @ X4 @ ( top_top @ A ) )
               => ? [Y4: B] :
                    ( ( member @ B @ Y4 @ A5 )
                    & ( ord_less @ A @ X4 @ ( F2 @ Y4 ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_5381_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_5382_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_5383_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X6: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X6 ) ) ) ) ) ).

% Inf_real_def
thf(fact_5384_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_5385_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_5386_subset__UNIV,axiom,
    ! [A: $tType,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ A5 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_5387_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_5388_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_5389_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_5390_UN__finite__subset,axiom,
    ! [A: $tType,A5: nat > ( set @ A ),C6: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( top_top @ ( set @ nat ) ) ) ) @ C6 ) ) ).

% UN_finite_subset
thf(fact_5391_UN__finite2__eq,axiom,
    ! [A: $tType,A5: nat > ( set @ A ),B5: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_5392_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,B5: set @ A,I2: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) @ B5 )
     => ( member @ A @ ( F2 @ I2 ) @ B5 ) ) ).

% range_subsetD
thf(fact_5393_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) ) ) ).

% not_UNIV_le_Icc
thf(fact_5394_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_UNIV_le_Iic
thf(fact_5395_UN__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ A,F2: A > ( set @ B ),G2: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A5 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G2 @ B5 ) ) ) ) ) ).

% UN_mono
thf(fact_5396_UN__least,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,B5: A > ( set @ B ),C6: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A5 )
         => ( ord_less_eq @ ( set @ B ) @ ( B5 @ X3 ) @ C6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A5 ) ) @ C6 ) ) ).

% UN_least
thf(fact_5397_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A5: set @ A,B5: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A5 )
     => ( ord_less_eq @ ( set @ B ) @ ( B5 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A5 ) ) ) ) ).

% UN_upper
thf(fact_5398_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A5: B > ( set @ A ),I6: set @ B,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) @ B5 )
      = ( ! [X4: B] :
            ( ( member @ B @ X4 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ ( A5 @ X4 ) @ B5 ) ) ) ) ).

% UN_subset_iff
thf(fact_5399_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_5400_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A5: set @ A,B5: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A5 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A5 ) ) @ ( B5 @ A2 ) ) ) ).

% INT_lower
thf(fact_5401_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,C6: set @ B,B5: A > ( set @ B )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A5 )
         => ( ord_less_eq @ ( set @ B ) @ C6 @ ( B5 @ X3 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C6 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B5 @ A5 ) ) ) ) ).

% INT_greatest
thf(fact_5402_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ A,F2: A > ( set @ B ),G2: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A5 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ B5 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G2 @ A5 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_5403_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,A5: B > ( set @ A ),I6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A5 @ I6 ) ) )
      = ( ! [X4: B] :
            ( ( member @ B @ X4 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ B5 @ ( A5 @ X4 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_5404_UN__finite2__subset,axiom,
    ! [A: $tType,A5: nat > ( set @ A ),B5: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A5 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B5 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_5405_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) ) @ ( image @ B @ A @ F2 @ ( uminus_uminus @ ( set @ B ) @ A5 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_5406_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L: int,U: int] :
      ( ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ L @ ( one_one @ int ) ) @ U )
      = ( set_or3652927894154168847AtMost @ int @ L @ U ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
thf(fact_5407_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I6: set @ A,A5: A > ( set @ B ),F2: B > C,A9: A > ( set @ C )] :
      ( ! [I3: A,J2: A] :
          ( ( member @ A @ I3 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A5 @ I3 ) @ ( A5 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A5 @ J2 ) @ ( A5 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I6 )
           => ( bij_betw @ B @ C @ F2 @ ( A5 @ I3 ) @ ( A9 @ I3 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A5 @ I6 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A9 @ I6 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_5408_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S2: set @ A] :
      ( ! [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I3 ) @ S2 )
     => ( ( finite_finite @ A @ S2 )
       => ( ? [N6: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N6 )
                 => ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ M4 @ N6 )
                     => ( ( ord_less @ nat @ M4 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N3 )
                 => ( ( F2 @ N6 )
                    = ( F2 @ N3 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S2 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_5409_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_5410_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_5411_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I4: nat] : ( M7 @ ( plus_plus @ nat @ I4 @ K ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_5412_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I4: nat] : ( M7 @ ( plus_plus @ nat @ I4 @ K ) )
          @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_5413_subset__subseqs,axiom,
    ! [A: $tType,X8: set @ A,Xs: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( set2 @ A @ Xs ) )
     => ( member @ ( set @ A ) @ X8 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ) ).

% subset_subseqs
thf(fact_5414_subseqs__powset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
      = ( pow2 @ A @ ( set2 @ A @ Xs ) ) ) ).

% subseqs_powset
thf(fact_5415_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_5416_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,A5: A > ( set @ B )] :
      ( ( finite_finite @ A @ I6 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A5 @ I6 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I4: A] : ( finite_card @ B @ ( A5 @ I4 ) )
          @ I6 ) ) ) ).

% card_UN_le
thf(fact_5417_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F3: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_5418_range__mod,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( image @ nat @ nat
          @ ^ [M: nat] : ( modulo_modulo @ nat @ M @ N2 )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% range_mod
thf(fact_5419_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G2: C > ( set @ B ),X: C,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ ( G2 @ X ) ) ) @ X8 )
      = ( ord_less_eq @ ( set @ B ) @ ( G2 @ X )
        @ ( collect @ B
          @ ^ [X4: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X4 ) @ X8 ) ) ) ) ).

% UN_image_subset
thf(fact_5420_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,X: A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z @ A5 )
              = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% folding_on.remove
thf(fact_5421_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% folding_on.insert_remove
thf(fact_5422_card__UNIV__unit,axiom,
    ( ( finite_card @ product_unit @ ( top_top @ ( set @ product_unit ) ) )
    = ( one_one @ nat ) ) ).

% card_UNIV_unit
thf(fact_5423_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_5424_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert2 @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_5425_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_5426_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite_folding_on @ A @ ( list @ A ) @ ( top_top @ ( set @ A ) )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X4: A] : X4 ) ) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
thf(fact_5427_conj__subset__def,axiom,
    ! [A: $tType,A5: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A5
        @ ( collect @ A
          @ ^ [X4: A] :
              ( ( P @ X4 )
              & ( Q @ X4 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_5428_folding__on_Oinsert,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z @ ( insert2 @ A @ X @ A5 ) )
              = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z @ A5 ) ) ) ) ) ) ) ).

% folding_on.insert
thf(fact_5429_root__def,axiom,
    ( root
    = ( ^ [N: nat,X4: real] :
          ( if @ real
          @ ( N
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y4: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N ) )
            @ X4 ) ) ) ) ).

% root_def
thf(fact_5430_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_5431_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_5432_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_5433_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( remdups @ A @ X )
        = ( nil @ A ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_5434_set__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_remdups
thf(fact_5435_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% length_remdups_eq
thf(fact_5436_distinct__remdups,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs ) ) ).

% distinct_remdups
thf(fact_5437_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups @ A @ Xs )
        = Xs )
      = ( distinct @ A @ Xs ) ) ).

% remdups_id_iff_distinct
thf(fact_5438_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_remdups_leq
thf(fact_5439_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% distinct_remdups_id
thf(fact_5440_remdups__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ Xs ) ) ).

% remdups_remdups
thf(fact_5441_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_5442_remove1__remdups,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X @ ( remdups @ A @ Xs ) )
        = ( remdups @ A @ ( remove1 @ A @ X @ Xs ) ) ) ) ).

% remove1_remdups
thf(fact_5443_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs ) ) ) ).

% length_remdups_card_conv
thf(fact_5444_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_5445_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: A,N2: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M2 )
            = ( unique5772411509450598832har_of @ A @ N2 ) )
          = ( ( modulo_modulo @ A @ M2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_5446_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N2 ) ) ) ).

% char_of_mod_256
thf(fact_5447_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M2: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ M2 ) )
            = ( unique5772411509450598832har_of @ A @ M2 ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_5448_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_5449_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_5450_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_5451_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_5452_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_5453_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N2 )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_5454_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_5455_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_5456_folding__idem__on_Oinsert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z: B] :
      ( ( finite1890593828518410140dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_folding_F @ A @ B @ F2 @ Z @ A5 ) ) ) ) ) ) ).

% folding_idem_on.insert_idem
thf(fact_5457_list_Oinject,axiom,
    ! [A: $tType,X212: A,X223: list @ A,Y21: A,Y222: list @ A] :
      ( ( ( cons @ A @ X212 @ X223 )
        = ( cons @ A @ Y21 @ Y222 ) )
      = ( ( X212 = Y21 )
        & ( X223 = Y222 ) ) ) ).

% list.inject
thf(fact_5458_list_Osimps_I15_J,axiom,
    ! [A: $tType,X212: A,X223: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X212 @ X223 ) )
      = ( insert2 @ A @ X212 @ ( set2 @ A @ X223 ) ) ) ).

% list.simps(15)
thf(fact_5459_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ N2 ) )
      = ( nth @ A @ Xs @ N2 ) ) ).

% nth_Cons_Suc
thf(fact_5460_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_5461_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A,X: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( cons @ B @ X @ Xs ) )
          = ( plus_plus @ A @ ( F2 @ X ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_5462_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N2: nat,X: B,Xs: list @ B] :
      ( ( enumerate @ B @ N2 @ ( cons @ B @ X @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N2 @ X ) @ ( enumerate @ B @ ( suc @ N2 ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_5463_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs: list @ A,V2: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( numeral_numeral @ nat @ V2 ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_5464_nth__Cons__pos,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_5465_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X212: A,X223: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X212 @ X223 ) ) ).

% list.distinct(1)
thf(fact_5466_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X212: A,X223: list @ A] :
      ( ( List
        = ( cons @ A @ X212 @ X223 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_5467_list_Oexhaust,axiom,
    ! [A: $tType,Y: list @ A] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ! [X21: A,X222: list @ A] :
            ( Y
           != ( cons @ A @ X21 @ X222 ) ) ) ).

% list.exhaust
thf(fact_5468_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A] :
          ( ! [X3: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X3 @ Xs2 ) )
         => ( X
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_5469_transpose_Ocases,axiom,
    ! [A: $tType,X: list @ ( list @ A )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss2: list @ ( list @ A )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
       => ~ ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
              ( X
             != ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) ) ) ) ).

% transpose.cases
thf(fact_5470_remdups__adj_Ocases,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( X
           != ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ~ ! [X3: A,Y2: A,Xs2: list @ A] :
              ( X
             != ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_5471_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
         != ( nil @ A ) ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( Xs
            = ( cons @ A @ Y4 @ Ys3 ) ) ) ) ).

% neq_Nil_conv
thf(fact_5472_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys: list @ B] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: list @ A] : ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y2: B,Ys4: list @ B] : ( P @ ( nil @ A ) @ ( cons @ B @ Y2 @ Ys4 ) )
         => ( ! [X3: A,Xs2: list @ A,Y2: B,Ys4: list @ B] :
                ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) ).

% list_induct2'
thf(fact_5473_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] : ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% list_nonempty_induct
thf(fact_5474_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F8: A > B,Bs2: list @ B] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F8 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F8: A > B,A4: A,As: list @ A,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F8 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A4 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_5475_successively_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ( ! [P8: A > A > $o,X3: A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
       => ~ ! [P8: A > A > $o,X3: A,Y2: A,Xs2: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ).

% successively.cases
thf(fact_5476_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F8: A > B,X3: A] :
              ( X
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F8 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
         => ( ! [F8: A > B,X3: A,Y2: A,Zs2: list @ A] :
                ( X
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F8 @ ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Zs2 ) ) ) )
           => ~ ! [A4: A > B] :
                  ( X
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A4 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_5477_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ~ ! [P8: A > A > $o,X3: A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X3 @ Ys4 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_5478_shuffles_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ( ! [Xs2: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
       => ~ ! [X3: A,Xs2: list @ A,Y2: A,Ys4: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) ) ).

% shuffles.cases
thf(fact_5479_splice_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ~ ! [X3: A,Xs2: list @ A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) ) ).

% splice.cases
thf(fact_5480_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( removeAll @ A @ X @ Xs ) ) )
      & ( ( X != Y )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( removeAll @ A @ X @ Xs ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_5481_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = Xs ) )
      & ( ( X != Y )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y @ Xs ) )
          = ( cons @ A @ Y @ ( remove1 @ A @ X @ Xs ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_5482_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I2: nat,V2: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ I2 @ V2 )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V2 @ Xs )
        @ ^ [J3: nat] : ( cons @ A @ X @ ( list_update @ A @ Xs @ J3 @ V2 ) )
        @ I2 ) ) ).

% list_update.simps(2)
thf(fact_5483_not__Cons__self2,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) ).

% not_Cons_self2
thf(fact_5484_set__ConsD,axiom,
    ! [A: $tType,Y: A,X: A,Xs: list @ A] :
      ( ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
     => ( ( Y = X )
        | ( member @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) ).

% set_ConsD
thf(fact_5485_list_Oset__cases,axiom,
    ! [A: $tType,E: A,A2: list @ A] :
      ( ( member @ A @ E @ ( set2 @ A @ A2 ) )
     => ( ! [Z23: list @ A] :
            ( A2
           != ( cons @ A @ E @ Z23 ) )
       => ~ ! [Z12: A,Z23: list @ A] :
              ( ( A2
                = ( cons @ A @ Z12 @ Z23 ) )
             => ~ ( member @ A @ E @ ( set2 @ A @ Z23 ) ) ) ) ) ).

% list.set_cases
thf(fact_5486_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X212: A,X223: list @ A] : ( member @ A @ X212 @ ( set2 @ A @ ( cons @ A @ X212 @ X223 ) ) ) ).

% list.set_intros(1)
thf(fact_5487_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y: A,X223: list @ A,X212: A] :
      ( ( member @ A @ Y @ ( set2 @ A @ X223 ) )
     => ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X212 @ X223 ) ) ) ) ).

% list.set_intros(2)
thf(fact_5488_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z @ Xs ) @ Ys ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_5489_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Z @ Ys ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_5490_distinct__length__2__or__more,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A2 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A2 != B2 )
        & ( distinct @ A @ ( cons @ A @ A2 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_5491_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_5492_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_5493_Suc__length__conv,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( suc @ N2 )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y4 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% Suc_length_conv
thf(fact_5494_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N2 ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y4 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv
thf(fact_5495_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% set_subset_Cons
thf(fact_5496_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,Ws: list @ D,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X3: A,Xs2: list @ A,Y2: B,Ys4: list @ B,Z3: C,Zs2: list @ C,W: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P @ Xs2 @ Ys4 @ Zs2 @ Ws2 )
                       => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) @ ( cons @ C @ Z3 @ Zs2 ) @ ( cons @ D @ W @ Ws2 ) ) ) ) ) )
             => ( P @ Xs @ Ys @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_5497_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X3: A,Xs2: list @ A,Y2: B,Ys4: list @ B,Z3: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P @ Xs2 @ Ys4 @ Zs2 )
                   => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) @ ( cons @ C @ Z3 @ Zs2 ) ) ) ) )
           => ( P @ Xs @ Ys @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_5498_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Xs2: list @ A,Y2: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) ) ) )
         => ( P @ Xs @ Ys ) ) ) ) ).

% list_induct2
thf(fact_5499_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs
       != ( cons @ A @ X @ Ys ) ) ) ).

% impossible_Cons
thf(fact_5500_distinct__singleton,axiom,
    ! [A: $tType,X: A] : ( distinct @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_5501_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) ).

% distinct.simps(2)
thf(fact_5502_replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N2 ) @ X )
      = ( cons @ A @ X @ ( replicate @ A @ N2 @ X ) ) ) ).

% replicate_Suc
thf(fact_5503_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I2: nat,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( suc @ I2 ) @ Y )
      = ( cons @ A @ X @ ( list_update @ A @ Xs @ I2 @ Y ) ) ) ).

% list_update_code(3)
thf(fact_5504_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) @ Y )
      = ( cons @ A @ Y @ Xs ) ) ).

% list_update_code(2)
thf(fact_5505_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ X @ ( cons @ B @ Y @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys ) )
              = ( cons @ B @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_5506_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( ( Zs = Xs )
         => ( Ys
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys )
           => ( Xs
             != ( nil @ A ) ) )
         => ( ! [X3: A,Xs4: list @ A] :
                ( ( Xs
                  = ( cons @ A @ X3 @ Xs4 ) )
               => ! [Z3: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z3 @ Zs4 ) )
                   => ( ( X3 = Z3 )
                     => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs4 @ Ys ) ) ) ) )
           => ~ ! [Y2: A,Ys5: list @ A] :
                  ( ( Ys
                    = ( cons @ A @ Y2 @ Ys5 ) )
                 => ! [Z3: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z3 @ Zs4 ) )
                     => ( ( Y2 = Z3 )
                       => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs @ Ys5 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_5507_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( nil @ B ) )
          = ( cons @ B @ X @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_5508_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( remdups @ A @ Xs ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( remdups @ A @ Xs ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_5509_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y: A,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Y @ Ys ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_5510_nth__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
      = ( case_nat @ A @ X @ ( nth @ A @ Xs ) @ N2 ) ) ).

% nth_Cons
thf(fact_5511_Suc__le__length__iff,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X4: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ X4 @ Ys3 ) )
            & ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_5512_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,A2: B] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X3 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
            = ( cons @ B @ A2 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_5513_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs @ Y ) @ ( one_one @ nat ) ) ) )
      & ( ( X != Y )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs ) @ Y )
          = ( count_list @ A @ Xs @ Y ) ) ) ) ).

% count_list.simps(2)
thf(fact_5514_list_Osize_I4_J,axiom,
    ! [A: $tType,X212: A,X223: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X212 @ X223 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X223 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_5515_nth__Cons_H,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
          = X ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_5516_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
            = X )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_5517_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A,N2: nat] :
      ( ( X != Y )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N2 )
          = Y )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
            = Y )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_5518_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N2: nat,Y: A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( replicate @ A @ N2 @ Y ) )
      = ( ( X = Y )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_5519_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( set_Cons @ A @ A5 @ ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image @ A @ ( list @ A )
        @ ^ [X4: A] : ( cons @ A @ X4 @ ( nil @ A ) )
        @ A5 ) ) ).

% set_Cons_sing_Nil
thf(fact_5520_length__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_Cons
thf(fact_5521_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_5522_n__lists__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_5523_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A5: set @ A,As2: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A5 @ As2 ) )
      = ( set_Cons @ A @ A5 @ ( listset @ A @ As2 ) ) ) ).

% listset.simps(2)
thf(fact_5524_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_5525_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_5526_subset__CollectI,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ B5 )
           => ( ( Q @ X3 )
             => ( P @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ B5 )
                & ( Q @ X4 ) ) )
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ A5 )
                & ( P @ X4 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_5527_subset__Collect__iff,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5
          @ ( collect @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ A5 )
                & ( P @ X4 ) ) ) )
        = ( ! [X4: A] :
              ( ( member @ A @ X4 @ B5 )
             => ( P @ X4 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_5528_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_5529_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_5530_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_5531_concat__inth,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% concat_inth
thf(fact_5532_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ Js @ ( upto_aux @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) @ ( cons @ int @ J3 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_5533_INF__filter__not__bot,axiom,
    ! [I7: $tType,A: $tType,B5: set @ I7,F4: I7 > ( filter @ A )] :
      ( ! [X9: set @ I7] :
          ( ( ord_less_eq @ ( set @ I7 ) @ X9 @ B5 )
         => ( ( finite_finite @ I7 @ X9 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ X9 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ B5 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_5534_same__append__eq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) ).

% same_append_eq
thf(fact_5535_append__same__eq,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) ).

% append_same_eq
thf(fact_5536_append__assoc,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) ).

% append_assoc
thf(fact_5537_append_Oassoc,axiom,
    ! [A: $tType,A2: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A2 @ B2 ) @ C2 )
      = ( append @ A @ A2 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_5538_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_5539_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_5540_self__append__conv2,axiom,
    ! [A: $tType,Y: list @ A,Xs: list @ A] :
      ( ( Y
        = ( append @ A @ Xs @ Y ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_5541_append__self__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_5542_self__append__conv,axiom,
    ! [A: $tType,Y: list @ A,Ys: list @ A] :
      ( ( Y
        = ( append @ A @ Y @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_5543_append__self__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_5544_append__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% append_Nil2
thf(fact_5545_append_Oright__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ A2 @ ( nil @ A ) )
      = A2 ) ).

% append.right_neutral
thf(fact_5546_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_5547_concat__append,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs @ Ys ) )
      = ( append @ A @ ( concat @ A @ Xs ) @ ( concat @ A @ Ys ) ) ) ).

% concat_append
thf(fact_5548_removeAll__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( removeAll @ A @ X @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( removeAll @ A @ X @ Xs ) @ ( removeAll @ A @ X @ Ys ) ) ) ).

% removeAll_append
thf(fact_5549_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X = Y ) ) ) ).

% append1_eq_conv
thf(fact_5550_length__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_5551_nth__append__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% nth_append_length
thf(fact_5552_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,N2: nat] :
      ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) )
      = ( nth @ A @ Ys @ N2 ) ) ).

% nth_append_length_plus
thf(fact_5553_list__update__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A] :
      ( ( list_update @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) @ Y )
      = ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) ).

% list_update_length
thf(fact_5554_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_5555_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_5556_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_5557_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( Xss
         != ( nil @ ( list @ A ) ) )
       => ? [Xss1: list @ ( list @ A ),Xs2: list @ A,Xs4: list @ A,Xss22: list @ ( list @ A )] :
            ( ( Xss
              = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs2 @ Xs4 ) @ Xss22 ) ) )
            & ( Ys
              = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs2 ) )
            & ( Zs
              = ( append @ A @ Xs4 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_5558_Cons__eq__appendI,axiom,
    ! [A: $tType,X: A,Xs1: list @ A,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_5559_append__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( append @ A @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( cons @ A @ X @ ( append @ A @ Xs @ Ys ) ) ) ).

% append_Cons
thf(fact_5560_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] : ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% rev_nonempty_induct
thf(fact_5561_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,X: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs ) ) )
        | ? [Ys6: list @ A] :
            ( ( Ys
              = ( cons @ A @ X @ Ys6 ) )
            & ( ( append @ A @ Ys6 @ Zs )
              = Xs ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_5562_Cons__eq__append__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs )
            = Zs ) )
        | ? [Ys6: list @ A] :
            ( ( ( cons @ A @ X @ Ys6 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys6 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_5563_rev__exhaust,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ! [Ys4: list @ A,Y2: A] :
            ( Xs
           != ( append @ A @ Ys4 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_5564_rev__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A,Xs2: list @ A] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) ).

% rev_induct
thf(fact_5565_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( P @ X4 ) ) )
      = ( ? [Ys3: list @ A,X4: A] :
            ( ? [Zs3: list @ A] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X4 @ Zs3 ) ) )
            & ( P @ X4 )
            & ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y4 ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_5566_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( P @ X4 ) ) )
      = ( ? [Ys3: list @ A,X4: A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X4 @ Zs3 ) ) )
            & ( P @ X4 )
            & ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Zs3 ) )
               => ~ ( P @ Y4 ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_5567_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Ys3 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_5568_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_5569_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
          & ( P @ X2 ) )
     => ~ ! [Ys4: list @ A,X3: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ( ( P @ X3 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_first_propE
thf(fact_5570_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
          & ( P @ X2 ) )
     => ~ ! [Ys4: list @ A,X3: A,Zs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ( ( P @ X3 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_last_propE
thf(fact_5571_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
          & ( P @ X2 ) )
     => ? [Ys4: list @ A,X3: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_first_prop
thf(fact_5572_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
          & ( P @ X2 ) )
     => ? [Ys4: list @ A,X3: A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_last_prop
thf(fact_5573_in__set__conv__decomp,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_5574_append__Cons__eq__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,Xs5: list @ A,Ys7: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ Ys ) )
       => ( ( ( append @ A @ Xs @ ( cons @ A @ X @ Ys ) )
            = ( append @ A @ Xs5 @ ( cons @ A @ X @ Ys7 ) ) )
          = ( ( Xs = Xs5 )
            & ( Ys = Ys7 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_5575_split__list__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
          & ( P @ X2 ) )
     => ~ ! [Ys4: list @ A,X3: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ~ ( P @ X3 ) ) ) ).

% split_list_propE
thf(fact_5576_split__list__first,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Ys4 ) ) ) ) ).

% split_list_first
thf(fact_5577_split__list__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
          & ( P @ X2 ) )
     => ? [Ys4: list @ A,X3: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 ) ) ) ).

% split_list_prop
thf(fact_5578_split__list__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_5579_split__list,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( Xs
          = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) ) ) ).

% split_list
thf(fact_5580_remdups__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs @ ( remdups @ A @ Ys ) ) )
      = ( remdups @ A @ ( append @ A @ Xs @ Ys ) ) ) ).

% remdups_append2
thf(fact_5581_enumerate__append__eq,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) @ ( enumerate @ A @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_5582_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,Ts: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_5583_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Xs1: list @ A,Zs: list @ A,Ys: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_5584_append__replicate__commute,axiom,
    ! [A: $tType,N2: nat,X: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N2 @ X ) @ ( replicate @ A @ K @ X ) )
      = ( append @ A @ ( replicate @ A @ K @ X ) @ ( replicate @ A @ N2 @ X ) ) ) ).

% append_replicate_commute
thf(fact_5585_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) ).

% eq_Nil_appendI
thf(fact_5586_append_Oleft__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A2 )
      = A2 ) ).

% append.left_neutral
thf(fact_5587_append__Nil,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% append_Nil
thf(fact_5588_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Xss
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss
           != ( nil @ ( list @ A ) ) )
         => ? [Xss12: list @ ( list @ A ),Xs3: list @ A,Xs6: list @ A,Xss23: list @ ( list @ A )] :
              ( ( Xss
                = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs3 @ Xs6 ) @ Xss23 ) ) )
              & ( Ys
                = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs3 ) )
              & ( Zs
                = ( append @ A @ Xs6 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_5589_replicate__app__Cons__same,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N2 @ X ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( append @ A @ ( replicate @ A @ N2 @ X ) @ Xs ) ) ) ).

% replicate_app_Cons_same
thf(fact_5590_replicate__add,axiom,
    ! [A: $tType,N2: nat,M2: nat,X: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N2 @ M2 ) @ X )
      = ( append @ A @ ( replicate @ A @ N2 @ X ) @ ( replicate @ A @ M2 @ X ) ) ) ).

% replicate_add
thf(fact_5591_remove1__append,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( remove1 @ A @ X @ Xs ) @ Ys ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( remove1 @ A @ X @ Ys ) ) ) ) ) ).

% remove1_append
thf(fact_5592_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X: list @ A,Xs: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X @ Xs ) )
      = ( append @ A @ X @ ( concat @ A @ Xs ) ) ) ).

% concat.simps(2)
thf(fact_5593_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Ys @ Xs ) )
     => ? [M4: nat,N3: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M4 @ Zs2 ) )
            = Xs )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
            = Ys ) ) ) ).

% comm_append_are_replicate
thf(fact_5594_same__length__different,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs != Ys )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ? [Pre: list @ A,X3: A,Xs4: list @ A,Y2: A,Ys5: list @ A] :
            ( ( X3 != Y2 )
            & ( Xs
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ Ys5 ) ) ) ) ) ) ).

% same_length_different
thf(fact_5595_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs2: list @ A,Ys4: list @ A,Zs2: list @ A,Y2: A] :
          ( Ws
          = ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ ( append @ A @ Ys4 @ ( append @ A @ ( cons @ A @ Y2 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_5596_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list @ A] :
      ( ( ~ ( distinct @ A @ As3 ) )
      = ( ? [Xs3: list @ A,Y4: A,Ys3: list @ A] :
            ( ( member @ A @ Y4 @ ( set2 @ A @ Xs3 ) )
            & ( distinct @ A @ Xs3 )
            & ( As3
              = ( append @ A @ Xs3 @ ( cons @ A @ Y4 @ Ys3 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_5597_replicate__append__same,axiom,
    ! [A: $tType,I2: nat,X: A] :
      ( ( append @ A @ ( replicate @ A @ I2 @ X ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( replicate @ A @ I2 @ X ) ) ) ).

% replicate_append_same
thf(fact_5598_list__update__append1,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ I2 @ X )
        = ( append @ A @ ( list_update @ A @ Xs @ I2 @ X ) @ Ys ) ) ) ).

% list_update_append1
thf(fact_5599_remove1__split,axiom,
    ! [A: $tType,A2: A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
     => ( ( ( remove1 @ A @ A2 @ Xs )
          = Ys )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs
                = ( append @ A @ Ls @ ( cons @ A @ A2 @ Rs ) ) )
              & ~ ( member @ A @ A2 @ ( set2 @ A @ Ls ) )
              & ( Ys
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_5600_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_5601_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N2 ) )
      = ( ? [Y4: A,Ys3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ Y4 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_5602_length__append__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_append_singleton
thf(fact_5603_nth__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N2 )
          = ( nth @ A @ Xs @ N2 ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N2 )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_5604_list__update__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N2 @ X )
          = ( append @ A @ ( list_update @ A @ Xs @ N2 @ X ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N2 @ X )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_5605_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_5606_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys )
            = ( append @ A @ Ys @ Xs ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_5607_upto_Opsimps,axiom,
    ! [I2: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J ) )
     => ( ( ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_5608_upto_Opelims,axiom,
    ! [X: int,Xa2: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa2 )
               => ( Y
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa2 )
               => ( Y
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) ) ) ) ) ).

% upto.pelims
thf(fact_5609_upto__rec__numeral_I2_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M2 ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_5610_upto__empty,axiom,
    ! [J: int,I2: int] :
      ( ( ord_less @ int @ J @ I2 )
     => ( ( upto @ I2 @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_5611_upto__Nil2,axiom,
    ! [I2: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I2 @ J ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil2
thf(fact_5612_upto__Nil,axiom,
    ! [I2: int,J: int] :
      ( ( ( upto @ I2 @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil
thf(fact_5613_upto__single,axiom,
    ! [I2: int] :
      ( ( upto @ I2 @ I2 )
      = ( cons @ int @ I2 @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_5614_nth__upto,axiom,
    ! [I2: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I2 @ J ) @ K )
        = ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_5615_length__upto,axiom,
    ! [I2: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I2 @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I2 ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_5616_upto__rec__numeral_I1_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M2 ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M2 ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M2 ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_5617_upto__rec__numeral_I4_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_5618_upto__rec__numeral_I3_J,axiom,
    ! [M2: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_5619_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int] : ( append @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% upto_aux_def
thf(fact_5620_upto__code,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( upto_aux @ I4 @ J3 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_5621_distinct__upto,axiom,
    ! [I2: int,J: int] : ( distinct @ int @ ( upto @ I2 @ J ) ) ).

% distinct_upto
thf(fact_5622_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_5623_upto__split2,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_5624_upto__split1,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_5625_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_5626_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_5627_upto_Oelims,axiom,
    ! [X: int,Xa2: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa2 )
        = Y )
     => ( ( ( ord_less_eq @ int @ X @ Xa2 )
         => ( Y
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa2 )
         => ( Y
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_5628_upto_Osimps,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I4 @ J3 ) @ ( cons @ int @ I4 @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_5629_upto__rec1,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_5630_upto__rec2,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_5631_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_5632_upto__split3,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_5633_DERIV__real__root__generic,axiom,
    ! [N2: nat,X: real,D5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( D5
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
             => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
               => ( D5
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
               => ( D5
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N2 ) @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_5634_DERIV__even__real__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_5635_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X10: real] :
            ( suminf @ real
            @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X10 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( power_power @ real @ X @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_5636_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_5637_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_5638_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,X: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X @ S ) @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ).

% at_le
thf(fact_5639_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G2: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G2 @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G2 @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G2 ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain
thf(fact_5640_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,X: A,Z: A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X @ Z ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ X4 @ Z ) )
            @ Y
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_5641_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ real @ B2 @ A2 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_5642_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_5643_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G2: A > A,M2: A,X: A] :
          ( ( has_field_derivative @ A @ G2 @ M2 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( exp @ A @ ( G2 @ X4 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G2 @ X ) ) @ M2 )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_5644_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S: set @ A,G2: A > A,G4: A > A,F2: A > A,F6: A,X: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S )
             => ( has_field_derivative @ A @ G2 @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F2 @ X ) @ S )
             => ( has_field_derivative @ A
                @ ^ [X4: A] : ( G2 @ ( F2 @ X4 ) )
                @ ( times_times @ A @ F6 @ ( G4 @ ( F2 @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_5645_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G2: A > A,G4: A > A,F2: A > A,F6: A,X: A] :
          ( ! [X3: A] : ( has_field_derivative @ A @ G2 @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( G2 @ ( F2 @ X4 ) )
              @ ( times_times @ A @ F6 @ ( G4 @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_5646_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G2: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G2 @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G2 @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( F2 @ ( G2 @ X4 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain2
thf(fact_5647_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G2: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ E5 @ ( topolo174197925503356063within @ A @ ( F2 @ X ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( G2 @ ( F2 @ X4 ) )
              @ ( times_times @ A @ E5 @ D5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain'
thf(fact_5648_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G2: A > A,M2: A,X: A] :
          ( ( has_field_derivative @ A @ G2 @ M2 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( sin @ A @ ( G2 @ X4 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G2 @ X ) ) @ M2 )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_5649_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ D5 ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_5650_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,X: A,S: set @ A,G2: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G2 @ X ) ) @ ( times_times @ A @ Db @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult
thf(fact_5651_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G2: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ E5 ) @ ( times_times @ A @ D5 @ ( G2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult'
thf(fact_5652_has__field__derivative__sinh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G2: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G2 @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X4: A11] : ( sinh @ A11 @ ( G2 @ X4 ) )
            @ ( times_times @ A11 @ ( cosh @ A11 @ ( G2 @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_5653_has__field__derivative__cosh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G2: A11 > A11,Db: A11,X: A11,S: set @ A11] :
          ( ( has_field_derivative @ A11 @ G2 @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
         => ( has_field_derivative @ A11
            @ ^ [X4: A11] : ( cosh @ A11 @ ( G2 @ X4 ) )
            @ ( times_times @ A11 @ ( sinh @ A11 @ ( G2 @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_5654_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
            @ ( times_times @ A @ C2 @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult
thf(fact_5655_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
            @ ( times_times @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult_right
thf(fact_5656_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( divide_divide @ A @ ( F2 @ X4 ) @ C2 )
            @ ( divide_divide @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cdivide
thf(fact_5657_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X: A,S: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ).

% DERIV_cmult_Id
thf(fact_5658_DERIV__ident,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X4: A] : X4
          @ ( one_one @ A )
          @ F4 ) ) ).

% DERIV_ident
thf(fact_5659_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G2: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( plus_plus @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( plus_plus @ A @ D5 @ E5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_add
thf(fact_5660_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F6: A,F4: filter @ A,G2: A > A,G4: A] :
          ( ( has_field_derivative @ A @ F2 @ F6 @ F4 )
         => ( ( has_field_derivative @ A @ G2 @ G4 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] : ( plus_plus @ A @ ( F2 @ Z5 ) @ ( G2 @ Z5 ) )
              @ ( plus_plus @ A @ F6 @ G4 )
              @ F4 ) ) ) ) ).

% field_differentiable_add
thf(fact_5661_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G2: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X4: A] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D5 @ ( G2 @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ E5 ) ) @ ( times_times @ A @ ( G2 @ X ) @ ( G2 @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_5662_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,Z: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S2 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ ( plus_plus @ A @ Z ) ) @ Y @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_5663_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G2: A > A,X: A,S: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G2 @ X ) @ ( image @ A @ A @ G2 @ S ) ) )
         => ( ( has_field_derivative @ A @ G2 @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G2 ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_5664_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y: A,Z: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S2 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ Z @ X4 ) )
            @ Y
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_5665_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F6: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F6 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z3: real] :
            ( ( ord_less @ real @ A2 @ Z3 )
            & ( ord_less @ real @ Z3 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F6 @ Z3 ) ) ) ) ) ) ).

% MVT2
thf(fact_5666_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G2: A > A,M2: A,X: A] :
          ( ( has_field_derivative @ A @ G2 @ M2 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( cos @ A @ ( G2 @ X4 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G2 @ X ) ) ) @ M2 )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_5667_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa2: A] :
          ( has_field_derivative @ A
          @ ^ [X4: A] : ( cos @ A @ ( plus_plus @ A @ X4 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa2 @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_5668_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( power_power @ A @ ( F2 @ X4 ) @ ( suc @ N2 ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_5669_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ V2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V2 @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V2 @ A2 ) @ ( V2 @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_5670_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_5671_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] : ( power_power @ A @ ( F2 @ X4 ) @ N2 )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power
thf(fact_5672_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_5673_DERIV__pow,axiom,
    ! [N2: nat,X: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X4: real] : ( power_power @ real @ X4 @ N2 )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X @ S ) ) ).

% DERIV_pow
thf(fact_5674_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y2: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Y2 @ N ) ) )
         => ( has_field_derivative @ A
            @ ^ [X4: A] :
                ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X4 @ N ) ) )
            @ ( suminf @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_5675_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo174197925503356063within @ A @ X @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_5676_DERIV__fun__pow,axiom,
    ! [G2: real > real,M2: real,X: real,N2: nat] :
      ( ( has_field_derivative @ real @ G2 @ M2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X4: real] : ( power_power @ real @ ( G2 @ X4 ) @ N2 )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( G2 @ X ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) @ M2 )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_5677_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_5678_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,G2: A > A,E: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G2 @ E @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y4: A] : ( divide_divide @ A @ ( F2 @ Y4 ) @ ( G2 @ Y4 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G2 @ X ) ) @ ( times_times @ A @ E @ ( F2 @ X ) ) ) @ ( power_power @ A @ ( G2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_5679_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_5680_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F2: A > A,F6: A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K5 )
             => ( sums @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z3 @ N ) )
                @ ( F2 @ Z3 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F6 @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
             => ( sums @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ Z @ N ) )
                @ F6 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_5681_has__real__derivative__powr,axiom,
    ! [Z: real,R: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z )
     => ( has_field_derivative @ real
        @ ^ [Z5: real] : ( powr @ real @ Z5 @ R )
        @ ( times_times @ real @ R @ ( powr @ real @ Z @ ( minus_minus @ real @ R @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_5682_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
           => ( ( summable @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N ) @ ( power_power @ A @ K5 @ N ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X4: A] :
                      ( suminf @ A
                      @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X4 @ N ) ) )
                  @ ( suminf @ A
                    @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_5683_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X4 @ N ) ) )
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ X @ N ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_5684_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K5 )
             => ( summable @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z3 @ N ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z5: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Z5 @ N ) ) )
              @ ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N ) @ ( power_power @ A @ Z @ N ) ) )
              @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_5685_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_5686_DERIV__fun__powr,axiom,
    ! [G2: real > real,M2: real,X: real,R: real] :
      ( ( has_field_derivative @ real @ G2 @ M2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
       => ( has_field_derivative @ real
          @ ^ [X4: real] : ( powr @ real @ ( G2 @ X4 ) @ R )
          @ ( times_times @ real @ ( times_times @ real @ R @ ( powr @ real @ ( G2 @ X ) @ ( minus_minus @ real @ R @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M2 )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_5687_DERIV__powr,axiom,
    ! [G2: real > real,M2: real,X: real,F2: real > real,R: real] :
      ( ( has_field_derivative @ real @ G2 @ M2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
       => ( ( has_field_derivative @ real @ F2 @ R @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X4: real] : ( powr @ real @ ( G2 @ X4 ) @ ( F2 @ X4 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G2 @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ R @ ( ln_ln @ real @ ( G2 @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M2 @ ( F2 @ X ) ) @ ( G2 @ X ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_5688_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_5689_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_5690_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F6: real > nat > real,X0: real,A2: real,B2: real,L5: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X4: real] : ( F2 @ X4 @ N3 )
          @ ( F6 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X3 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F6 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N3: nat,X3: real,Y2: real] :
                    ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X3 @ N3 ) @ ( F2 @ Y2 @ N3 ) ) ) @ ( times_times @ real @ ( L5 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y2 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X4: real] : ( suminf @ real @ ( F2 @ X4 ) )
                  @ ( suminf @ real @ ( F6 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_5691_DERIV__arctan,axiom,
    ! [X: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_5692_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A5: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A5 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_5693_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_5694_has__field__derivative__tanh,axiom,
    ! [A11: $tType] :
      ( ( ( real_Vector_banach @ A11 )
        & ( real_V3459762299906320749_field @ A11 ) )
     => ! [G2: A11 > A11,X: A11,Db: A11,S: set @ A11] :
          ( ( ( cosh @ A11 @ ( G2 @ X ) )
           != ( zero_zero @ A11 ) )
         => ( ( has_field_derivative @ A11 @ G2 @ Db @ ( topolo174197925503356063within @ A11 @ X @ S ) )
           => ( has_field_derivative @ A11
              @ ^ [X4: A11] : ( tanh @ A11 @ ( G2 @ X4 ) )
              @ ( times_times @ A11 @ ( minus_minus @ A11 @ ( one_one @ A11 ) @ ( power_power @ A11 @ ( tanh @ A11 @ ( G2 @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A11 @ X @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_5695_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D5: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( D5
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
           => ( D5
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_5696_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A5: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A5 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_5697_artanh__real__has__field__derivative,axiom,
    ! [X: real,A5: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A5 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_5698_DERIV__power__series_H,axiom,
    ! [R3: real,F2: nat > real,X0: real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R3 ) @ R3 ) )
         => ( summable @ real
            @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) @ ( power_power @ real @ X3 @ N ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R3 ) @ R3 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
         => ( has_field_derivative @ real
            @ ^ [X4: real] :
                ( suminf @ real
                @ ^ [N: nat] : ( times_times @ real @ ( F2 @ N ) @ ( power_power @ real @ X4 @ ( suc @ N ) ) ) )
            @ ( suminf @ real
              @ ^ [N: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) @ ( power_power @ real @ X0 @ N ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_5699_DERIV__real__root,axiom,
    ! [N2: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_5700_DERIV__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_5701_DERIV__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_5702_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N2: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ X @ M ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_5703_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N2: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
          & ( ( F2 @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ X @ M ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_5704_DERIV__odd__real__root,axiom,
    ! [N2: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_5705_Maclaurin,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N2 )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H2 ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H2 )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ H2 @ M ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_5706_Maclaurin2,axiom,
    ! [H2: real,Diff: nat > real > real,F2: real > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H2 )
              & ( ( F2 @ H2 )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ H2 @ M ) )
                    @ ( set_ord_lessThan @ nat @ N2 ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_5707_Maclaurin__minus,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N2 )
                  & ( ord_less_eq @ real @ H2 @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H2 @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ H2 @ M ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_5708_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( X
           != ( zero_zero @ real ) )
         => ( ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
                & ( ( F2 @ X )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ X @ M ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_5709_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,T4: real] :
            ( ( ( ord_less @ nat @ M4 @ N2 )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ X @ M ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_5710_Taylor,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X )
               => ( ( ord_less_eq @ real @ X @ B2 )
                 => ( ( X != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ X @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X ) ) )
                        & ( ( F2 @ X )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ C2 ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ M ) )
                              @ ( set_ord_lessThan @ nat @ N2 ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_5711_Taylor__up,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ C2 ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_5712_Taylor__down,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A2 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M @ C2 ) @ ( semiring_char_0_fact @ real @ M ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_5713_Maclaurin__lemma2,axiom,
    ! [N2: nat,H2: real,Diff: nat > real > real,K: nat,B5: real] :
      ( ! [M4: nat,T4: real] :
          ( ( ( ord_less @ nat @ M4 @ N2 )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H2 ) )
         => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N2
          = ( suc @ K ) )
       => ! [M3: nat,T8: real] :
            ( ( ( ord_less @ nat @ M3 @ N2 )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H2 ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M3 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M3 @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ U2 @ P6 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ M3 ) ) )
                    @ ( times_times @ real @ B5 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N2 @ M3 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ M3 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M3 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M3 ) @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ T8 @ P6 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ M3 ) ) ) )
                  @ ( times_times @ real @ B5 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N2 @ ( suc @ M3 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ ( suc @ M3 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_5714_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G2 @ X ) )
         => ( ( ord_less @ real @ ( G2 @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X4: A] : ( arcsin @ ( G2 @ X4 ) )
                @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G2 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_5715_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G2 @ X ) )
         => ( ( ord_less @ real @ ( G2 @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X4: A] : ( arccos @ ( G2 @ X4 ) )
                @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G2 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_5716_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G2 @ X ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( tan @ real @ ( G2 @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G2 @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_5717_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_5718_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F3: A > A,D7: A] : ( has_derivative @ A @ A @ F3 @ ( times_times @ A @ D7 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_5719_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A > A,F4: filter @ A,D8: A] :
          ( ( has_derivative @ A @ A @ F2 @ D5 @ F4 )
         => ( ! [X3: A] :
                ( ( times_times @ A @ X3 @ D8 )
                = ( D5 @ X3 ) )
           => ( has_field_derivative @ A @ F2 @ D8 @ F4 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_5720_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,F4: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ F4 )
         => ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ F4 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_5721_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: D > real,F6: D > real,X: D,S: set @ D,G2: D > C,G4: D > C] :
          ( ( has_derivative @ D @ real @ F2 @ F6 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ C @ G2 @ G4 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ C
              @ ^ [X4: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ^ [H: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G4 @ H ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F6 @ H ) @ ( G2 @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_5722_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,F4: filter @ A,G2: A > B,G4: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ F4 )
         => ( ( has_derivative @ A @ B @ G2 @ G4 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ^ [X4: A] : ( plus_plus @ B @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
              @ F4 ) ) ) ) ).

% has_derivative_add
thf(fact_5723_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G2: C > A,G4: C > A,F4: filter @ C,Y: A] :
          ( ( has_derivative @ C @ A @ G2 @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ ( G2 @ X4 ) @ Y )
            @ ^ [X4: C] : ( times_times @ A @ ( G4 @ X4 ) @ Y )
            @ F4 ) ) ) ).

% has_derivative_mult_left
thf(fact_5724_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G2: C > A,G4: C > A,F4: filter @ C,X: A] :
          ( ( has_derivative @ C @ A @ G2 @ G4 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ X @ ( G2 @ X4 ) )
            @ ^ [X4: C] : ( times_times @ A @ X @ ( G4 @ X4 ) )
            @ F4 ) ) ) ).

% has_derivative_mult_right
thf(fact_5725_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F2: D > A,F6: D > A,X: D,S: set @ D,G2: D > A,G4: D > A] :
          ( ( has_derivative @ D @ A @ F2 @ F6 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ A @ G2 @ G4 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ A
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ^ [H: D] : ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ ( G4 @ H ) ) @ ( times_times @ A @ ( F6 @ H ) @ ( G2 @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_mult
thf(fact_5726_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G2: A > B,G4: A > A > B,F2: C > A,S: set @ C,X: C,F6: C > A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ T2 )
             => ( has_derivative @ A @ B @ G2 @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
           => ( ( member @ C @ X @ S )
             => ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X4: C] : ( G2 @ ( F2 @ X4 ) )
                  @ ^ [Y4: C] : ( G4 @ ( F2 @ X ) @ ( F6 @ Y4 ) )
                  @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_5727_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( exp @ real @ ( G2 @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( exp @ real @ ( G2 @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_exp
thf(fact_5728_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( sin @ real @ ( G2 @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( cos @ real @ ( G2 @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sin
thf(fact_5729_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G2: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G2 @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X4: A] : ( cosh @ A @ ( G2 @ X4 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G2 @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cosh
thf(fact_5730_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G2: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G2 @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X4: A] : ( sinh @ A @ ( G2 @ X4 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G2 @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sinh
thf(fact_5731_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F6: C > A,X: C,S2: set @ C,G2: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G2 @ G4 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X4: C] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ^ [H: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F6 @ H ) @ ( G2 @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ ( G4 @ H ) ) ) @ ( times_times @ A @ ( G2 @ X ) @ ( G2 @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_5732_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X ) @ H ) @ ( inverse_inverse @ A @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_5733_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X: C,F6: C > A,S2: set @ C] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X4: C] : ( inverse_inverse @ A @ ( F2 @ X4 ) )
              @ ^ [H: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ ( F6 @ H ) ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_5734_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F6: real,G2: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( has_field_derivative @ real @ F2 @ F6 @ ( topolo174197925503356063within @ real @ ( G2 @ X ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( F2 @ ( G2 @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ F6 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_5735_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( cos @ real @ ( G2 @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G2 @ X ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cos
thf(fact_5736_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F6: A > B,X: A,S2: set @ A,N2: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_derivative @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 )
            @ ^ [Y4: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N2 ) @ ( F6 @ Y4 ) ) @ ( power_power @ B @ ( F2 @ X ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power
thf(fact_5737_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
         => ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( ln_ln @ real @ ( G2 @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( G2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_5738_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F6: C > A,X: C,S2: set @ C,G2: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G2 @ G4 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X4: C] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ^ [H: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G2 @ X ) ) @ ( G4 @ H ) ) @ ( inverse_inverse @ A @ ( G2 @ X ) ) ) ) @ ( divide_divide @ A @ ( F6 @ H ) @ ( G2 @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_5739_has__derivative__prod,axiom,
    ! [B: $tType,I7: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I6: set @ I7,F2: I7 > A > B,F6: I7 > A > B,X: A,S2: set @ A] :
          ( ! [I3: I7] :
              ( ( member @ I7 @ I3 @ I6 )
             => ( has_derivative @ A @ B @ ( F2 @ I3 ) @ ( F6 @ I3 ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X4: A] :
                ( groups7121269368397514597t_prod @ I7 @ B
                @ ^ [I4: I7] : ( F2 @ I4 @ X4 )
                @ I6 )
            @ ^ [Y4: A] :
                ( groups7311177749621191930dd_sum @ I7 @ B
                @ ^ [I4: I7] :
                    ( times_times @ B @ ( F6 @ I4 @ Y4 )
                    @ ( groups7121269368397514597t_prod @ I7 @ B
                      @ ^ [J3: I7] : ( F2 @ J3 @ X )
                      @ ( minus_minus @ ( set @ I7 ) @ I6 @ ( insert2 @ I7 @ I4 @ ( bot_bot @ ( set @ I7 ) ) ) ) ) )
                @ I6 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_prod
thf(fact_5740_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,G4: A > real,X: A,X8: set @ A,F2: A > real,F6: A > real] :
          ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
             => ( ( member @ A @ X @ X8 )
               => ( has_derivative @ A @ real
                  @ ^ [X4: A] : ( powr @ real @ ( G2 @ X4 ) @ ( F2 @ X4 ) )
                  @ ^ [H: A] : ( times_times @ real @ ( powr @ real @ ( G2 @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F6 @ H ) @ ( ln_ln @ real @ ( G2 @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G4 @ H ) @ ( F2 @ X ) ) @ ( G2 @ X ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ X8 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_5741_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,X: A,G4: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X ) )
         => ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X4: A] : ( sqrt @ ( G2 @ X4 ) )
              @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G2 @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_5742_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G2: A > real,G4: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X4: A] : ( arctan @ ( G2 @ X4 ) )
            @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G2 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_5743_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G2: A > real,X: A,F2: real > Aa,G4: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G2 @ X ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G2 @ G4 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X4: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G2 @ X4 ) ) ) )
                @ ^ [X4: A] : ( times_times @ real @ ( G4 @ X4 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_5744_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X @ H ) @ N ) @ ( power_power @ A @ X @ N ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_5745_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ K5 @ N ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] :
                  ( suminf @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X4 @ N ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_5746_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_5747_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_5748_power__tendsto__0__iff,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real
          @ ^ [X4: A] : ( power_power @ real @ ( F2 @ X4 ) @ N2 )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_5749_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > B,L: filter @ B,X: A,S2: set @ A,T6: set @ A] :
          ( ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ T6 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_5750_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_5751_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_5752_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_5753_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ X @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_5754_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ X4 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_5755_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
          = ( filterlim @ A @ A
            @ ^ [Y4: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y4 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_5756_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( filterlim @ A @ A
            @ ^ [Y4: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y4 @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivativeD
thf(fact_5757_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,G2: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_5758_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_5759_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X4: D] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_5760_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X4: B] : ( divide_divide @ A @ ( F2 @ X4 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_5761_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G2: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X4: B] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_5762_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: D > B,F4: filter @ D,G2: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X4: D] : ( times_times @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_one
thf(fact_5763_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_5764_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_5765_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F4: filter @ D,F2: D > B,G2: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G2 )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X4: D] : ( times_times @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_5766_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ D,F2: D > A,G2: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ G2 )
           => ( topolo3448309680560233919inuous @ D @ A @ F4
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_5767_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G2: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_mult
thf(fact_5768_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
            @ F4 ) ) ) ).

% tendsto_mult_left
thf(fact_5769_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_right
thf(fact_5770_tendsto__real__root,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A,N2: nat] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X4: A] : ( root @ N2 @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N2 @ X ) )
        @ F4 ) ) ).

% tendsto_real_root
thf(fact_5771_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X4: A] : ( root @ N2 @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_real_root
thf(fact_5772_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X4: A] : ( sqrt @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_5773_continuous__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F4: filter @ A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G2 )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X4: A] : ( ord_max @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_max
thf(fact_5774_tendsto__max,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: B > A,X: A,Net: filter @ B,Y6: B > A,Y: A] :
          ( ( filterlim @ B @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ Net )
         => ( ( filterlim @ B @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ Net )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( ord_max @ A @ ( X8 @ X4 ) @ ( Y6 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( ord_max @ A @ X @ Y ) )
              @ Net ) ) ) ) ).

% tendsto_max
thf(fact_5775_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N2 ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_5776_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F2: C > B,G2: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G2 )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_5777_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F4: filter @ C,G2: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G2 @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_5778_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X4: A] : ( sqrt @ ( F2 @ X4 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X ) )
        @ F4 ) ) ).

% tendsto_real_sqrt
thf(fact_5779_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 ) ) ) ) ).

% continuous_power
thf(fact_5780_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F2: B > A,D2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X4: B] : ( plus_plus @ A @ C2 @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F4 )
          = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F4 ) ) ) ).

% tendsto_add_const_iff
thf(fact_5781_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G2: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X4: B] : ( plus_plus @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_add
thf(fact_5782_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F4: filter @ D,F2: D > B,G2: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G2 )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X4: D] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_add
thf(fact_5783_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F4: filter @ D,G2: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X4: D] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_5784_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X4: B] : ( arcosh @ real @ ( F2 @ X4 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_5785_tendsto__one__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I6: set @ B,F2: A > B > C,F4: filter @ A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ I6 )
             => ( filterlim @ A @ C
                @ ^ [X4: A] : ( F2 @ X4 @ I3 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I4: A] : ( groups7121269368397514597t_prod @ B @ C @ ( F2 @ I4 ) @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
            @ F4 ) ) ) ).

% tendsto_one_prod'
thf(fact_5786_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F4: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_5787_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G2: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_5788_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( artanh @ real @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_5789_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_5790_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2
thf(fact_5791_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT
thf(fact_5792_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D5: A] :
          ( ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H ) ) @ ( F2 @ A2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X4: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X4 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X4 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_5793_isCont__real__sqrt,axiom,
    ! [X: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ sqrt ) ).

% isCont_real_sqrt
thf(fact_5794_isCont__real__root,axiom,
    ! [X: real,N2: nat] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( root @ N2 ) ) ).

% isCont_real_root
thf(fact_5795_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G2 )
           => ( ( ( G2 @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_5796_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( times_times @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_5797_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% isCont_add
thf(fact_5798_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 ) ) ) ) ).

% isCont_power
thf(fact_5799_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_5800_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_5801_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z5 ) @ ( one_one @ A ) ) @ Z5 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_5802_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_5803_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
              ! [X2: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X2 )
                  & ( ord_less_eq @ real @ X2 @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ M8 ) ) ) ) ) ).

% isCont_bounded
thf(fact_5804_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X2: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X2 )
                      & ( ord_less_eq @ real @ X2 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X2 ) @ M8 ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_5805_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X2: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X2 )
                      & ( ord_less_eq @ real @ X2 @ B2 ) )
                   => ( ord_less_eq @ A @ M8 @ ( F2 @ X2 ) ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_5806_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_5807_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
           => ( ( ( G2 @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_5808_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X4: A] : ( F2 @ ( plus_plus @ A @ X4 @ A2 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_5809_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ L @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G: A > A] :
                ( ! [Z5: A] :
                    ( ( minus_minus @ A @ ( F2 @ Z5 ) @ ( F2 @ X ) )
                    = ( times_times @ A @ ( G @ Z5 ) @ ( minus_minus @ A @ Z5 @ X ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ G )
                & ( ( G @ X )
                  = L ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_5810_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X2: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X2 )
                      & ( ord_less_eq @ real @ X2 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X2 ) @ M8 ) )
                & ! [N6: A] :
                    ( ( ord_less @ A @ N6 @ M8 )
                   => ? [X3: real] :
                        ( ( ord_less_eq @ real @ A2 @ X3 )
                        & ( ord_less_eq @ real @ X3 @ B2 )
                        & ( ord_less @ A @ N6 @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_5811_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A,D2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_5812_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,D2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_5813_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X3: A] :
                ( ( X3
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S )
                 => ( sums @ A
                    @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ X3 @ N ) )
                    @ ( F2 @ X3 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_5814_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S )
               => ( sums @ A
                  @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ ( power_power @ A @ X3 @ N ) )
                  @ ( F2 @ X3 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_5815_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G2: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N3: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G2 @ H4 @ N3 ) ) @ ( times_times @ real @ ( F2 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H: A] : ( suminf @ B @ ( G2 @ H ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_5816_isCont__arcosh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_5817_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S: set @ A,F2: A > real,G2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S )
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_5818_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X4: real] : ( divide_divide @ real @ ( cos @ real @ X4 ) @ ( sin @ real @ X4 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_5819_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N2: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W3 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% isCont_polynom
thf(fact_5820_isCont__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_5821_isCont__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_5822_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y2: A] :
              ( summable @ A
              @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ Y2 @ N ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
            @ ^ [X4: A] :
                ( suminf @ A
                @ ^ [N: nat] : ( times_times @ A @ ( C2 @ N ) @ ( power_power @ A @ X4 @ N ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_5823_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_5824_isCont__artanh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_5825_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G2: real > real,G4: real > real,F6: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ A2 @ Z3 )
           => ( ( ord_less_eq @ real @ Z3 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ G2 ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
               => ( ( ord_less @ real @ Z3 @ B2 )
                 => ( has_field_derivative @ real @ G2 @ ( G4 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z3: real] :
                  ( ( ord_less @ real @ A2 @ Z3 )
                 => ( ( ord_less @ real @ Z3 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F6 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G4 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G2 @ B2 ) @ ( G2 @ A2 ) ) @ ( F6 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_5826_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N: nat] : ( times_times @ Aa @ ( C2 @ N ) @ ( power_power @ Aa @ K5 @ N ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X4: A] :
                    ( suminf @ Aa
                    @ ^ [N: nat] : ( times_times @ Aa @ ( C2 @ N ) @ ( power_power @ Aa @ ( F2 @ X4 ) @ N ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_5827_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N8: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N8 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N8 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_5828_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N8: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N8 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N8 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_5829_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_5830_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ ( A2 @ N ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_5831_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( times_times @ A @ C2 @ ( A2 @ N ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_5832_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N: nat] : ( divide_divide @ A @ ( A2 @ N ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_5833_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ? [U3: nat > A] :
              ( ! [N8: nat] : ( ord_less @ A @ ( U3 @ N8 ) @ X )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_5834_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [U3: nat > A] :
              ( ! [N8: nat] : ( ord_less @ A @ X @ ( U3 @ N8 ) )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_5835_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_5836_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( F2 @ ( plus_plus @ nat @ N @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_5837_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N4: nat,X8: nat > A,Y6: nat > A,X: A,Y: A] :
          ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% lim_mono
thf(fact_5838_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,Y6: nat > A,Y: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y6 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
           => ( ? [N6: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N3 )
                 => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y6 @ N3 ) ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_5839_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,M7: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N3 )
               => ( ord_less_eq @ A @ ( F2 @ N3 ) @ C6 ) )
           => ( ord_less_eq @ A @ L @ C6 ) ) ) ) ).

% Lim_bounded
thf(fact_5840_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,N4: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ A @ C6 @ ( F2 @ N3 ) ) )
           => ( ord_less_eq @ A @ C6 @ L ) ) ) ) ).

% Lim_bounded2
thf(fact_5841_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N6: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N6 @ N3 )
               => ( ord_less_eq @ A @ A2 @ ( X8 @ N3 ) ) )
           => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_5842_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N6: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N6 @ N3 )
               => ( ord_less_eq @ A @ ( X8 @ N3 ) @ A2 ) )
           => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_5843_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ).

% Sup_lim
thf(fact_5844_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_5845_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_5846_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X4: nat] : ( times_times @ nat @ X4 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_5847_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( root @ N @ ( semiring_1_of_nat @ real @ N ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_5848_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( ! [N8: nat] : ( ord_less_eq @ A @ ( A2 @ N8 ) @ X )
                & ! [M3: nat,N8: nat] :
                    ( ( ord_less_eq @ nat @ M3 @ N8 )
                   => ( ord_less_eq @ A @ ( A2 @ M3 ) @ ( A2 @ N8 ) ) ) )
              | ( ! [N8: nat] : ( ord_less_eq @ A @ X @ ( A2 @ N8 ) )
                & ! [M3: nat,N8: nat] :
                    ( ( ord_less_eq @ nat @ M3 @ N8 )
                   => ( ord_less_eq @ A @ ( A2 @ N8 ) @ ( A2 @ M3 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_5849_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_5850_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X8: nat > A,X: A,L: nat] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N: nat] : ( X8 @ ( times_times @ nat @ N @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_5851_LIMSEQ__inverse__zero,axiom,
    ! [X8: nat > real] :
      ( ! [R2: real] :
        ? [N6: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N6 @ N3 )
         => ( ord_less @ real @ R2 @ ( X8 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( inverse_inverse @ real @ ( X8 @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_5852_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_5853_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( root @ N @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_5854_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_5855_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_5856_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_1_of_nat @ A @ N ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_5857_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_5858_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_5859_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_5860_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_5861_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X @ N ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_5862_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N: nat] : ( root @ N @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_5863_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ No @ N )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_5864_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N3 ) @ L5 ) ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_5865_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A,R: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N8: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N8 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N8 ) @ L5 ) ) @ R ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_5866_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_5867_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_5868_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F4: filter @ B,X: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y4: B] : ( power_power @ A @ X @ ( F2 @ Y4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_5869_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N: nat] : ( times_times @ real @ R @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_5870_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_5871_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( A2 @ N ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_5872_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z: A,S: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z @ ( S @ N ) ) ) @ ( F2 @ Z ) ) @ ( S @ N ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_5873_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_5874_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A
            @ ^ [N: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ X @ N ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_5875_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( summable @ real
            @ ^ [N: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) @ ( A2 @ N ) ) ) ) ) ) ).

% summable
thf(fact_5876_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J3 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K2: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_5877_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( Theta @ J3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K2: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_5878_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_5879_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_5880_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_5881_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_5882_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L4: real] :
              ( ! [N8: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N8 ) ) )
                  @ L4 )
              & ( filterlim @ nat @ real
                @ ^ [N: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) )
              & ! [N8: nat] :
                  ( ord_less_eq @ real @ L4
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N8 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_5883_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_5884_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_5885_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F6 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_5886_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D5 )
            & ( filterlim @ A @ real
              @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ ( D5 @ H ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_5887_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F6 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_5888_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X ) ) ) ).

% bounded_linear_mult_right
thf(fact_5889_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G2: C > A,Y: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G2 )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ ( G2 @ X4 ) @ Y ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_5890_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G2: C > A,X: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G2 )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X4: C] : ( times_times @ A @ X @ ( G2 @ X4 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_5891_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X4: A] : ( times_times @ A @ X4 @ Y ) ) ) ).

% bounded_linear_mult_left
thf(fact_5892_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X4: A] : ( divide_divide @ A @ X4 @ Y ) ) ) ).

% bounded_linear_divide
thf(fact_5893_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F3: real > real] :
        ? [C4: real] :
          ( F3
          = ( ^ [X4: real] : ( times_times @ real @ X4 @ C4 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_5894_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G2 )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_5895_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
            ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K9 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_5896_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K9 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_5897_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K9 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_5898_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K5: real] :
          ( ! [X3: A,Y2: A] :
              ( ( F2 @ ( plus_plus @ A @ X3 @ Y2 ) )
              = ( plus_plus @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
         => ( ! [R2: real,X3: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R2 @ X3 ) )
                = ( real_V8093663219630862766scaleR @ B @ R2 @ ( F2 @ X3 ) ) )
           => ( ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_5899_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ( filterlim @ A @ real
              @ ^ [Y4: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F6 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_5900_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F6: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
            & ? [E3: A > B] :
                ( ! [H: A] :
                    ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F6 @ H ) ) @ ( E3 @ H ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_5901_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X: A,S2: set @ A,F2: A > B,F6: A > B] :
          ( ( member @ A @ X @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F6 )
                & ? [E3: A > B] :
                    ( ! [H: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X @ H ) @ S2 )
                       => ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F6 @ H ) ) @ ( E3 @ H ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_5902_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E: real,F6: A > B,S: set @ A,X: A,F2: A > B,H5: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( ( real_V3181309239436604168linear @ A @ B @ F6 )
           => ( ! [Y2: A] :
                  ( ( member @ A @ Y2 @ S )
                 => ( ( Y2 != X )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X ) @ E )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y2 ) @ ( F2 @ X ) ) @ ( F6 @ ( minus_minus @ A @ Y2 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ X ) ) ) @ ( H5 @ Y2 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H5 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X @ S ) )
               => ( has_derivative @ A @ B @ F2 @ F6 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_5903_tendsto__exp__limit__at__right,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y4: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y4 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y4 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_5904_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I2 ) ) ) ).

% greaterThan_iff
thf(fact_5905_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_5906_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_5907_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X ) @ ( set_ord_greaterThan @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% greaterThan_subset_iff
thf(fact_5908_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ X @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_5909_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: real,A2: A,Y: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_5910_lessThan__Int__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( set_ord_greaterThan @ A @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% lessThan_Int_lessThan
thf(fact_5911_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A5: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A5 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ord_less @ A @ X @ X3 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A5 ) @ A5 ) ) ) ) ).

% Inf_notin_open
thf(fact_5912_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A5: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A5 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ord_less @ A @ X3 @ X ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A5 ) @ A5 ) ) ) ) ).

% Sup_notin_open
thf(fact_5913_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less @ A @ L2 ) ) ) ) ) ).

% greaterThan_def
thf(fact_5914_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S2 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member @ A @ X3 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S2 ) ) ) ).

% openI
thf(fact_5915_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S7: set @ A] :
            ! [X4: A] :
              ( ( member @ A @ X4 @ S7 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member @ A @ X4 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S7 ) ) ) ) ) ) ).

% open_subopen
thf(fact_5916_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I: nat] :
              ( ( member @ A @ X @ ( A8 @ I ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) ) )
          & ! [S8: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S8 )
                & ( member @ A @ X @ S8 ) )
             => ? [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I3 ) @ S8 ) ) ) ) ).

% first_countable_basis
thf(fact_5917_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S2: set @ A,T6: set @ A] :
          ( ( member @ A @ A2 @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ T6 )
             => ( ( topolo174197925503356063within @ A @ A2 @ T6 )
                = ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_5918_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ X @ Y )
             => ? [B4: A] :
                  ( ( ord_less @ A @ X @ B4 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X @ B4 ) @ S2 ) ) ) ) ) ) ).

% open_right
thf(fact_5919_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ Y @ X )
             => ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ X )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B4 @ X ) @ S2 ) ) ) ) ) ) ).

% open_left
thf(fact_5920_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_5921_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% metric_CauchyI
thf(fact_5922_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M8: nat] :
              ! [M3: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M3 )
               => ! [N8: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N8 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N8 ) ) @ E ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_5923_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S6: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N9: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N9 @ N )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S6 @ N ) @ ( S6 @ N9 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_5924_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X6: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M9: nat] :
                ! [M: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ M ) @ ( X6 @ N ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_5925_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S7: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S7 )
               => ( ( member @ A @ F0 @ S7 )
                 => ? [N9: nat] :
                    ! [N: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N )
                     => ( member @ A @ ( F2 @ N ) @ S7 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_5926_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [A4: A,B4: A] :
              ( ( member @ A @ X @ ( set_ord_lessThan @ A @ A4 ) )
              & ( member @ A @ Y @ ( set_ord_greaterThan @ A @ B4 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A4 ) @ ( set_ord_greaterThan @ A @ B4 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_5927_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y: A,X15: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X15 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_r
thf(fact_5928_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_l
thf(fact_5929_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,X22: A,E: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ X32 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X42 ) @ E ) ) ) ) ) ).

% dist_triangle_third
thf(fact_5930_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M9: nat] :
                ! [M: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M )
                 => ! [N: nat] :
                      ( ( ord_less @ nat @ M @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ M ) @ ( F3 @ N ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_5931_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M4 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI'
thf(fact_5932_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P4: A,F13: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P4 @ ( set_ord_greaterThan @ A @ P4 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P4 ) )
             => ( filterlim @ B @ A
                @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_5933_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A,R: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No3: nat] :
              ! [N8: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N8 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N8 ) @ L5 ) @ R ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_5934_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L5 ) @ R2 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_5935_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ No @ N )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_5936_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X6: nat > A] :
            ! [J3: nat] :
            ? [M9: nat] :
            ! [M: nat] :
              ( ( ord_less_eq @ nat @ M9 @ M )
             => ! [N: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ N )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X6 @ M ) @ ( X6 @ N ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_5937_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_5938_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S2: set @ A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S2 )
           => ( ( topolo1002775350975398744n_open @ A @ S2 )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
                = ( filterlim @ A @ D
                  @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_5939_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G2: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G2 )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X4: A] : ( if @ B @ ( ord_less_eq @ A @ X4 @ A2 ) @ ( G2 @ X4 ) @ ( F2 @ X4 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_5940_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No )
                    & ! [N: nat] :
                        ( ( ord_less_eq @ nat @ No @ N )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_5941_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S7: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K3: set @ A] :
                  ( ( finite_finite @ A @ K3 )
                  & ( ord_less_eq @ ( set @ A ) @ S7
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X4: A] :
                            ( collect @ A
                            @ ^ [Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X4 @ Y4 ) @ E3 ) )
                        @ K3 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_5942_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_5943_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A4: A,B4: A,X3: A] :
              ( ( member @ A @ A4 @ S2 )
             => ( ( member @ A @ B4 @ S2 )
               => ( ( ord_less_eq @ A @ A4 @ X3 )
                 => ( ( ord_less_eq @ A @ X3 @ B4 )
                   => ( member @ A @ X3 @ S2 ) ) ) ) )
         => ? [A4: A,B4: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B4 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B4 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A4 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A4 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A4 @ B4 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A4 @ B4 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A4 @ B4 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A4 @ B4 ) ) ) ) ) ).

% interval_cases
thf(fact_5944_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I2 ) ) ) ).

% atLeast_iff
thf(fact_5945_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X ) @ ( set_ord_atLeast @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% atLeast_subset_iff
thf(fact_5946_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I2 ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I2 ) ) ) ) ).

% image_add_atLeast
thf(fact_5947_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,L3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ L3 @ L ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_5948_Int__atLeastAtMostL2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_ord_atLeast @ A @ C2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% Int_atLeastAtMostL2
thf(fact_5949_Int__atLeastAtMostR2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ D2 ) ) ) ).

% Int_atLeastAtMostR2
thf(fact_5950_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less_eq @ A @ L2 ) ) ) ) ) ).

% atLeast_def
thf(fact_5951_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L ) ) ) ).

% not_UNIV_le_Ici
thf(fact_5952_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Ici_le_Icc
thf(fact_5953_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_ord_atMost @ A @ H3 ) ) ) ).

% not_Ici_le_Iic
thf(fact_5954_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) ) ) ).

% not_Iic_le_Ici
thf(fact_5955_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% Ioi_le_Ico
thf(fact_5956_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S2 )
           => ( topolo6688025880775521714ounded @ A @ T6 ) ) ) ) ).

% totally_bounded_subset
thf(fact_5957_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_5958_tanh__real__at__bot,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) @ ( at_bot @ real ) ).

% tanh_real_at_bot
thf(fact_5959_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G2 @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_5960_artanh__real__at__right__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ).

% artanh_real_at_right_1
thf(fact_5961_filterlim__pow__at__bot__odd,axiom,
    ! [N2: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X4: real] : ( power_power @ real @ ( F2 @ X4 ) @ N2 )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_5962_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_5963_filterlim__pow__at__bot__even,axiom,
    ! [N2: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X4: real] : ( power_power @ real @ ( F2 @ X4 ) @ N2 )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_5964_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X4: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_5965_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X3: real] :
              ( ( ( ord_less @ real @ A2 @ X3 )
                & ( ord_less @ real @ X3 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ G2 ) )
           => ( ! [X3: real] :
                  ( ( ( ord_less @ real @ A2 @ X3 )
                    & ( ord_less @ real @ X3 @ B2 ) )
                 => ( differentiable @ real @ real @ G2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G2 @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G2 @ B2 ) @ ( G2 @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_5966_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q2: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q2 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_5967_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q2: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q2 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_5968_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G2: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F4 )
         => ( ( differentiable @ A @ B @ G2 @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ F4 ) ) ) ) ).

% differentiable_add
thf(fact_5969_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_5970_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_5971_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_5972_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G2: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G2 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X4: A] : ( times_times @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_mult
thf(fact_5973_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,N2: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( differentiable @ A @ B
            @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% differentiable_power
thf(fact_5974_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G2: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G2 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G2 @ X )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_5975_filterlim__pow__at__top,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( power_power @ real @ ( F2 @ X4 ) @ N2 )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_5976_tanh__real__at__top,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) ) @ ( at_top @ real ) ).

% tanh_real_at_top
thf(fact_5977_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,C2: B,F4: filter @ A,G2: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
         => ( ( filterlim @ A @ B @ G2 @ ( at_infinity @ B ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_5978_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A,G2: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( filterlim @ A @ B @ G2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_5979_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X4: A] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_5980_artanh__real__at__left__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_lessThan @ real @ ( one_one @ real ) ) ) ).

% artanh_real_at_left_1
thf(fact_5981_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( G2 @ X4 ) @ ( F2 @ X4 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_5982_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_5983_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,G2: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G2 @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_5984_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X4: real] : ( divide_divide @ real @ ( ln_ln @ real @ X4 ) @ X4 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_5985_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F4: filter @ C,G2: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G2 @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X4: C] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_5986_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F4: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X4: A] : ( power_power @ B @ ( F2 @ X4 ) @ N2 )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_5987_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G2 @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X4: A] : ( times_times @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_5988_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X4: real] : ( divide_divide @ real @ ( power_power @ real @ X4 @ K ) @ ( exp @ real @ X4 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_5989_tendsto__exp__limit__at__top,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y4: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ Y4 ) ) @ Y4 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_5990_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F4: filter @ A,G2: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G2 @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X4: A] : ( divide_divide @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_5991_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_5992_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_5993_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_5994_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N2: nat,B5: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N2 )
             => ( eventually @ A
                @ ^ [Z5: A] :
                    ( ord_less_eq @ real @ B5
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z5 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_5995_lhopital__right__0__at__top,axiom,
    ! [G2: real > real,G4: real > real,F2: real > real,F6: real > real,X: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_5996_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N: nat] : ( P @ ( plus_plus @ nat @ N @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_5997_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ C2 @ X3 )
             => ( P @ X3 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_5998_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N9: A] :
              ! [N: A] :
                ( ( ord_less_eq @ A @ N9 @ N )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_5999_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X3: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X3 )
         => ( P @ X3 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6000_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N9: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ N9 @ N )
           => ( P @ N ) ) ) ) ).

% eventually_sequentially
thf(fact_6001_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N9: A] :
              ! [N: A] :
                ( ( ord_less @ A @ N9 @ N )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_6002_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6003_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_6004_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N9: A] :
              ! [N: A] :
                ( ( ord_less @ A @ N @ N9 )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_6005_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N9: A] :
              ! [N: A] :
                ( ( ord_less_eq @ A @ N @ N9 )
               => ( P @ N ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_6006_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N9: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N9 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_6007_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I4: nat] : ( P @ ( plus_plus @ nat @ I4 @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_6008_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X4: A] : ( ord_less_eq @ A @ X4 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_6009_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X4: A] : ( ord_less @ A @ X4 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_6010_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ ( top_top @ A ) )
                  & ! [Z5: A] :
                      ( ( ord_less @ A @ B3 @ Z5 )
                     => ( P @ Z5 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_6011_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G2: B > A] :
          ( ! [X3: A,Y2: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G2 @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G2 @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6012_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ B3 @ X )
                & ! [Y4: A] :
                    ( ( ord_less @ A @ B3 @ Y4 )
                   => ( ( ord_less @ A @ Y4 @ X )
                     => ( P @ Y4 ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_6013_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A,P: A > $o] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ X )
                  & ! [Y4: A] :
                      ( ( ord_less @ A @ B3 @ Y4 )
                     => ( ( ord_less @ A @ Y4 @ X )
                       => ( P @ Y4 ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_6014_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ X @ B3 )
                & ! [Y4: A] :
                    ( ( ord_less @ A @ X @ Y4 )
                   => ( ( ord_less @ A @ Y4 @ B3 )
                     => ( P @ Y4 ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_6015_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A,P: A > $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ X @ B3 )
                  & ! [Y4: A] :
                      ( ( ord_less @ A @ X @ Y4 )
                     => ( ( ord_less @ A @ Y4 @ B3 )
                       => ( P @ Y4 ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_6016_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G2: B > A,Net: filter @ B,H2: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ ( F2 @ N ) @ ( G2 @ N ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N: B] : ( ord_less_eq @ A @ ( G2 @ N ) @ ( H2 @ N ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6017_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
          = ( ! [L2: A] :
                ( ( ord_less @ A @ L2 @ X )
               => ( eventually @ B
                  @ ^ [X4: B] : ( ord_less @ A @ L2 @ ( F2 @ X4 ) )
                  @ F4 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X @ U2 )
               => ( eventually @ B
                  @ ^ [X4: B] : ( ord_less @ A @ ( F2 @ X4 ) @ U2 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_6018_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y: A,F2: B > A,F4: filter @ B] :
          ( ! [A4: A] :
              ( ( ord_less @ A @ A4 @ Y )
             => ( eventually @ B
                @ ^ [X4: B] : ( ord_less @ A @ A4 @ ( F2 @ X4 ) )
                @ F4 ) )
         => ( ! [A4: A] :
                ( ( ord_less @ A @ Y @ A4 )
               => ( eventually @ B
                  @ ^ [X4: B] : ( ord_less @ A @ ( F2 @ X4 ) @ A4 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_6019_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ A2 @ Y )
           => ( eventually @ B
              @ ^ [X4: B] : ( ord_less @ A @ A2 @ ( F2 @ X4 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_6020_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( eventually @ B
              @ ^ [X4: B] : ( ord_less @ A @ ( F2 @ X4 ) @ A2 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_6021_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F4: filter @ B,G2: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X4: B] : ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G2 @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6022_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less_eq @ B @ C2 @ Z8 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ Z8 @ ( F2 @ X4 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6023_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less_eq @ B @ Z8 @ ( F2 @ X4 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_6024_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less @ B @ Z8 @ ( F2 @ X4 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_6025_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A] : ( eventually @ A @ ( ord_less @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) ) ) ).

% eventually_at_right_less
thf(fact_6026_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less_eq @ B @ Z8 @ C2 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ Z8 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_6027_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ Z8 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_6028_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ Z8 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_6029_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) )
             => ( ! [I: nat] : ( member @ A @ X @ ( A8 @ I ) )
               => ~ ! [S8: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S8 )
                     => ( ( member @ A @ X @ S8 )
                       => ( eventually @ nat
                          @ ^ [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I4 ) @ S8 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_6030_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_6031_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_6032_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X4: A] : ( P @ ( plus_plus @ A @ X4 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6033_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ ( F2 @ N ) @ L )
            @ F4 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ X3 @ L )
               => ( eventually @ B
                  @ ^ [N: B] : ( ord_less @ A @ X3 @ ( F2 @ N ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_6034_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F2: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N: B] : ( ord_less_eq @ A @ L @ ( F2 @ N ) )
            @ F4 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ L @ X3 )
               => ( eventually @ B
                  @ ^ [N: B] : ( ord_less @ A @ ( F2 @ N ) @ X3 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6035_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less @ B @ C2 @ Z8 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ Z8 @ ( F2 @ X4 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6036_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less @ B @ Z8 @ C2 )
               => ( eventually @ A
                  @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ Z8 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_6037_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ ( F2 @ I4 ) @ A2 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6038_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I4 ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6039_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F2: B > A,X: A,G2: B > A,Y: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
           => ( ( filterlim @ B @ A @ G2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X4: B] : ( ord_less_eq @ A @ ( G2 @ X4 ) @ ( F2 @ X4 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6040_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F4: B > ( filter @ A ),B5: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ B5 ) ) )
      = ( ? [X6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X6 @ B5 )
            & ( finite_finite @ B @ X6 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ X6 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_6041_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X4 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X4: A] : ( arcosh @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6042_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ L5 )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_6043_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ L5 @ ( F2 @ X4 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_6044_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X4: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X4 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X4: B] : ( arcosh @ real @ ( F2 @ X4 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_6045_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G2: B > A,A2: A] :
          ( ! [X3: A,Y2: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G2 @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G2 @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B4: A] :
                      ( ( Q @ B4 )
                     => ( ord_less @ A @ B4 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_6046_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G2: B > A,A2: A] :
          ( ! [X3: A,Y2: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y2 )
               => ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G2 @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G2 @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B4: A] :
                      ( ( Q @ B4 )
                     => ( ord_less @ A @ A2 @ B4 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_6047_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G2: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G2 @ X4 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X4 ) ) @ K5 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G2 @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_6048_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L ) ) @ ( F2 @ X4 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_6049_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G2: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X4 ) )
              @ F4 )
           => ( filterlim @ A @ real
              @ ^ [X4: A] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( at_top @ real )
              @ F4 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_6050_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_6051_lhopital__left__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G2: real > real,F6: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
thf(fact_6052_lhopital__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G2: real > real,F6: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_top
thf(fact_6053_lhopital,axiom,
    ! [F2: real > real,X: real,G2: real > real,G4: real > real,F6: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G2 @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_6054_lhopital__left,axiom,
    ! [F2: real > real,X: real,G2: real > real,G4: real > real,F6: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G2 @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_6055_lhopital__right__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G2: real > real,F6: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
thf(fact_6056_lhopital__left__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G2: real > real,F6: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
thf(fact_6057_lhopital__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G2: real > real,F6: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_bot
thf(fact_6058_lhospital__at__top__at__top,axiom,
    ! [G2: real > real,G4: real > real,F2: real > real,F6: real > real,X: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_6059_lhopital__at__top,axiom,
    ! [G2: real > real,X: real,G4: real > real,F2: real > real,F6: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_6060_lhopital__left__at__top,axiom,
    ! [G2: real > real,X: real,G4: real > real,F2: real > real,F6: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_6061_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G4: real > real,F6: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G0 @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F0 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G0 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F0 @ X4 ) @ ( G0 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_6062_lhopital__right,axiom,
    ! [F2: real > real,X: real,G2: real > real,G4: real > real,F6: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] :
                ( ( G2 @ X4 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] :
                  ( ( G4 @ X4 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_6063_lhopital__right__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G2: real > real,F6: real > real,G4: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G2 @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
thf(fact_6064_lhopital__right__at__top,axiom,
    ! [G2: real > real,X: real,G4: real > real,F2: real > real,F6: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X4: real] :
              ( ( G4 @ X4 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X4: real] : ( has_field_derivative @ real @ F2 @ ( F6 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X4: real] : ( has_field_derivative @ real @ G2 @ ( G4 @ X4 ) @ ( topolo174197925503356063within @ real @ X4 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F6 @ X4 ) @ ( G4 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X4: real] : ( divide_divide @ real @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_6065_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G2: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A3: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A3 )
               => ! [B3: nat] :
                    ( ( ord_less @ nat @ A3 @ B3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A3 @ B3 ) ) ) @ ( G2 @ A3 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_6066_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G2: nat > real] :
          ( ( eventually @ nat
            @ ^ [M: nat] :
              ! [N: nat] :
                ( ( ord_less_eq @ nat @ M @ N )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) @ ( G2 @ M ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_6067_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X4: A] :
              ! [Y4: A] :
                ( ( ord_less_eq @ A @ X4 @ Y4 )
               => ( P @ Y4 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_6068_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X4: A] :
                  ( ( P3 @ X4 )
                  & ! [Y4: A] :
                      ( ( P3 @ Y4 )
                     => ( ord_less_eq @ A @ Y4 @ X4 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_6069_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F8: nat > A] :
                ( ! [N8: nat] : ( ord_less @ A @ A2 @ ( F8 @ N8 ) )
               => ( ! [N8: nat] : ( ord_less @ A @ ( F8 @ N8 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F8 )
                   => ( ( filterlim @ nat @ A @ F8 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N: nat] : ( P @ ( F8 @ N ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_6070_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X4: A,Y4: A] :
              ( ( ord_less_eq @ A @ X4 @ Y4 )
             => ( ord_less_eq @ B @ ( F3 @ Y4 ) @ ( F3 @ X4 ) ) ) ) ) ) ).

% antimono_def
thf(fact_6071_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y2: A] :
              ( ( ord_less_eq @ A @ X3 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_6072_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoE
thf(fact_6073_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoD
thf(fact_6074_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: nat > A,I2: nat] :
          ( ( order_antimono @ nat @ A @ A5 )
         => ( ord_less_eq @ A @ ( A5 @ ( suc @ I2 ) ) @ ( A5 @ I2 ) ) ) ) ).

% decseq_SucD
thf(fact_6075_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( order_antimono @ nat @ A @ X8 ) ) ) ).

% decseq_SucI
thf(fact_6076_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N: nat] : ( ord_less_eq @ A @ ( F3 @ ( suc @ N ) ) @ ( F3 @ N ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_6077_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X6: nat > A] :
            ! [M: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M @ N )
             => ( ord_less_eq @ A @ ( X6 @ N ) @ ( X6 @ M ) ) ) ) ) ) ).

% decseq_def
thf(fact_6078_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ord_less_eq @ A @ ( F2 @ J ) @ ( F2 @ I2 ) ) ) ) ) ).

% decseqD
thf(fact_6079_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_1: nat] : ( P @ X_1 )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_6080_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_6081_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq @ nat @ Y2 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_6082_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_6083_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y5: A] :
                        ( ( P @ Y5 )
                       => ( ord_less_eq @ A @ Y5 @ X3 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_6084_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N2: nat] :
          ( ( order_antimono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L5 @ ( X8 @ N2 ) ) ) ) ) ).

% decseq_ge
thf(fact_6085_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X8: B > C,L5: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S4: nat > B] :
                ( ! [N8: nat] : ( ord_less @ B @ A2 @ ( S4 @ N8 ) )
               => ( ! [N8: nat] : ( ord_less @ B @ ( S4 @ N8 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N: nat] : ( X8 @ ( S4 @ N ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X8 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_6086_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G2: B > A,Y6: set @ B,X8: set @ A,F4: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G2 @ Y6 ) @ X8 )
     => ( ( eventually @ B
          @ ^ [X4: B] : ( member @ B @ X4 @ Y6 )
          @ F4 )
       => ( ( map_filter_on @ A @ C @ X8 @ F2 @ ( map_filter_on @ B @ A @ Y6 @ G2 @ F4 ) )
          = ( map_filter_on @ B @ C @ Y6 @ ( comp @ A @ C @ B @ F2 @ G2 ) @ F4 ) ) ) ) ).

% map_filter_on_comp
thf(fact_6087_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L4: real,Z3: real] :
              ( ( ord_less @ real @ A2 @ Z3 )
              & ( ord_less @ real @ Z3 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L4 @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L4 ) ) ) ) ) ) ).

% MVT
thf(fact_6088_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S: set @ D,F2: D > B,G2: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G2 )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X4: D] : ( plus_plus @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_6089_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X4: A] : ( sqrt @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_6090_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A5: set @ C,F2: C > B,G2: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A5 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A5 @ G2 )
           => ( topolo81223032696312382ous_on @ C @ B @ A5
              @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_6091_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S: set @ C,F2: C > B,N2: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X4: C] : ( power_power @ B @ ( F2 @ X4 ) @ N2 ) ) ) ) ).

% continuous_on_power
thf(fact_6092_continuous__on__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A5: set @ A,F2: A > B,G2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ A5 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ A5 @ G2 )
           => ( topolo81223032696312382ous_on @ A @ B @ A5
              @ ^ [X4: A] : ( ord_max @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_on_max
thf(fact_6093_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,N2: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X4: A] : ( root @ N2 @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_6094_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_6095_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ D,F2: D > A,G2: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G2 )
           => ( topolo81223032696312382ous_on @ D @ A @ S
              @ ^ [X4: D] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_6096_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A5: set @ D,F2: D > B,G2: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A5 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A5 @ G2 )
           => ( topolo81223032696312382ous_on @ D @ B @ A5
              @ ^ [X4: D] : ( times_times @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_6097_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_6098_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_6099_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F2: A > B,G2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G2 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S )
                 => ( ( G2 @ X3 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_6100_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_6101_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT'
thf(fact_6102_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G2: A > B,S: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G2 )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F2 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X4: C] : ( G2 @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_6103_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,F2: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F2 ) ) ) ) ).

% continuous_on_subset
thf(fact_6104_continuous__on__arcosh,axiom,
    ! [A5: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A5 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A5 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_6105_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A5 ) )
         => ( ! [X3: A,Y2: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ( member @ A @ Y2 @ A5 )
                 => ( ( ord_less_eq @ A @ X3 @ Y2 )
                   => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A5 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_6106_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G2 )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X4: A] : ( ord_less @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_6107_continuous__on__arcosh_H,axiom,
    ! [A5: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A5 @ F2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ A5 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X3 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A5
          @ ^ [X4: real] : ( arcosh @ real @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_6108_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G2 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S )
                   => ( ( F2 @ X3 )
                     != ( one_one @ real ) ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G2 @ X3 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_6109_continuous__on__arccos_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arccos ).

% continuous_on_arccos'
thf(fact_6110_continuous__on__arcsin_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arcsin ).

% continuous_on_arcsin'
thf(fact_6111_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X4: A] : ( arccos @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_6112_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X4: A] : ( arcsin @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_6113_continuous__on__artanh,axiom,
    ! [A5: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A5 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A5 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_6114_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ A2 @ X3 )
             => ( ( ord_less_eq @ A @ X3 @ B2 )
               => ? [Y5: A] : ( has_field_derivative @ A @ F2 @ Y5 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_6115_continuous__on__artanh_H,axiom,
    ! [A5: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A5 @ F2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ A5 )
           => ( member @ real @ ( F2 @ X3 ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A5
          @ ^ [X4: real] : ( artanh @ real @ ( F2 @ X4 ) ) ) ) ) ).

% continuous_on_artanh'
thf(fact_6116_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_6117_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_6118_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X3: A] :
                  ( ( ord_less @ A @ A2 @ X3 )
                 => ( ( ord_less @ A @ X3 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X3 ) ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_6119_continuous__artanh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( member @ real
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X4: A] : X4 ) )
              @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X4: A] : ( artanh @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_artanh
thf(fact_6120_ord_OLeast__def,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( ^ [Less_eq2: A > A > $o,P3: A > $o] :
            ( the @ A
            @ ^ [X4: A] :
                ( ( P3 @ X4 )
                & ! [Y4: A] :
                    ( ( P3 @ Y4 )
                   => ( Less_eq2 @ X4 @ Y4 ) ) ) ) ) ) ).

% ord.Least_def
thf(fact_6121_ord_OLeast_Ocong,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( least @ A ) ) ).

% ord.Least.cong
thf(fact_6122_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F2: A > B,G2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G2 )
           => ( ( ( G2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X4: A] : X4 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X4: A] : ( divide_divide @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_6123_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X4: A] : X4 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X4: A] : ( arcosh @ real @ ( F2 @ X4 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_6124_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G2 )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X4: A] : X4 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X4: A] : X4 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G2
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X4: A] : X4 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X4: A] : ( log @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_6125_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ B,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B5 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( finite_Fpow @ B @ A5 ) ) @ ( finite_Fpow @ A @ B5 ) ) ) ).

% image_Fpow_mono
thf(fact_6126_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,C6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C6 )
               => ( topolo1002775350975398744n_open @ A @ ( F2 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C6 ) ) )
             => ~ ! [C8: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C8 @ C6 )
                   => ( ( finite_finite @ B @ C8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C8 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_6127_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S2 )
                   => ( ord_less_eq @ A @ X3 @ Xa ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_6128_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S2 )
                   => ( ord_less_eq @ A @ Xa @ X3 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_6129_Fpow__mono,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A5 ) @ ( finite_Fpow @ A @ B5 ) ) ) ).

% Fpow_mono
thf(fact_6130_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S )
                     => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Xa ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_6131_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S )
                     => ( ord_less_eq @ B @ ( F2 @ Xa ) @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_6132_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X6: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X6 @ A7 )
                & ( finite_finite @ A @ X6 ) ) ) ) ) ).

% Fpow_def
thf(fact_6133_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S7: set @ A] :
            ! [C9: set @ ( set @ A )] :
              ( ( ! [X4: set @ A] :
                    ( ( member @ ( set @ A ) @ X4 @ C9 )
                   => ( topolo1002775350975398744n_open @ A @ X4 ) )
                & ( ord_less_eq @ ( set @ A ) @ S7 @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) )
             => ? [D7: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D7 @ C9 )
                  & ( finite_finite @ ( set @ A ) @ D7 )
                  & ( ord_less_eq @ ( set @ A ) @ S7 @ ( complete_Sup_Sup @ ( set @ A ) @ D7 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_6134_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( ! [C7: set @ ( set @ A )] :
              ( ! [X2: set @ A] :
                  ( ( member @ ( set @ A ) @ X2 @ C7 )
                 => ( topolo1002775350975398744n_open @ A @ X2 ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C7 ) )
               => ? [C10: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C10 @ C7 )
                    & ( finite_finite @ ( set @ A ) @ C10 )
                    & ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C10 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S ) ) ) ).

% compactI
thf(fact_6135_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B9: set @ A] :
                  ( ( member @ ( set @ A ) @ B9 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B9 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_6136_the__elem__set,axiom,
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% the_elem_set
thf(fact_6137_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F8: nat > A] :
                ( ! [N8: nat] : ( ord_less @ A @ B2 @ ( F8 @ N8 ) )
               => ( ! [N8: nat] : ( ord_less @ A @ ( F8 @ N8 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F8 )
                   => ( ( filterlim @ nat @ A @ F8 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N: nat] : ( P @ ( F8 @ N ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_6138_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% mono_strict_invE
thf(fact_6139_max__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M2: A,N2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ M2 ) @ ( F2 @ N2 ) )
            = ( F2 @ ( ord_max @ A @ M2 @ N2 ) ) ) ) ) ).

% max_of_mono
thf(fact_6140_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_6141_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_6142_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ) ).

% mono_pow
thf(fact_6143_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_6144_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A5: A,B5: A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A5 @ B5 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ A5 ) @ ( compow @ ( A > A ) @ N2 @ F2 @ B5 ) ) ) ) ) ).

% funpow_mono
thf(fact_6145_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N: nat] : ( ord_less_eq @ A @ ( F3 @ N ) @ ( F3 @ ( suc @ N ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_6146_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X8 ) ) ) ).

% incseq_SucI
thf(fact_6147_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A5: nat > A,I2: nat] :
          ( ( order_mono @ nat @ A @ A5 )
         => ( ord_less_eq @ A @ ( A5 @ I2 ) @ ( A5 @ ( suc @ I2 ) ) ) ) ) ).

% incseq_SucD
thf(fact_6148_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X4: A,Y4: A] :
              ( ( ord_less_eq @ A @ X4 @ Y4 )
             => ( ord_less_eq @ B @ ( F3 @ X4 ) @ ( F3 @ Y4 ) ) ) ) ) ) ).

% mono_def
thf(fact_6149_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y2: A] :
              ( ( ord_less_eq @ A @ X3 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_6150_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoE
thf(fact_6151_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoD
thf(fact_6152_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( F2 @ J ) ) ) ) ) ).

% incseqD
thf(fact_6153_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X6: nat > A] :
            ! [M: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M @ N )
             => ( ord_less_eq @ A @ ( X6 @ M ) @ ( X6 @ N ) ) ) ) ) ) ).

% incseq_def
thf(fact_6154_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mono_invE
thf(fact_6155_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A5: A,B5: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A5 @ B5 ) ) @ ( inf_inf @ B @ ( F2 @ A5 ) @ ( F2 @ B5 ) ) ) ) ) ).

% mono_inf
thf(fact_6156_mono__times__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N2 ) ) ) ).

% mono_times_nat
thf(fact_6157_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_6158_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M2: A,N2: A,M6: B,N5: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M2 @ N2 ) )
              = ( set_or7035219750837199246ssThan @ B @ M6 @ N5 ) )
           => ( ( ord_less @ A @ M2 @ N2 )
             => ( ( F2 @ M2 )
                = M6 ) ) ) ) ) ).

% mono_image_least
thf(fact_6159_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P4 @ ( F2 @ P4 ) )
           => ( ord_less_eq @ A @ P4 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_6160_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P4 ) @ P4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P4 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_6161_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I2: nat,J: nat,X: A,Y: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less_eq @ A @ X @ Y )
             => ( ( ord_less_eq @ A @ X @ ( F2 @ X ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I2 @ F2 @ X ) @ ( compow @ ( A > A ) @ J @ F2 @ Y ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_6162_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X4: C] : ( F2 @ ( A5 @ X4 ) )
                @ I6 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A5 @ I6 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_6163_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A5 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% mono_Sup
thf(fact_6164_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A5 @ I6 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X4: C] : ( F2 @ ( A5 @ X4 ) )
                @ I6 ) ) ) ) ) ).

% mono_INF
thf(fact_6165_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A5 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ).

% mono_Inf
thf(fact_6166_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_6167_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N2: nat] :
          ( ( order_mono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X8 @ N2 ) @ L5 ) ) ) ) ).

% incseq_le
thf(fact_6168_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M2: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M2 @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_6169_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M2: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M2 @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M2 @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N2 @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_6170_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ M ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_6171_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N3: nat] :
                  ( ( ( F2 @ N3 )
                    = ( F2 @ ( suc @ N3 ) ) )
                 => ( ( F2 @ ( suc @ N3 ) )
                    = ( F2 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N7: nat] :
                  ( ! [N8: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ N7 )
                     => ! [M3: nat] :
                          ( ( ord_less_eq @ nat @ M3 @ N7 )
                         => ( ( ord_less @ nat @ M3 @ N8 )
                           => ( ord_less @ A @ ( F2 @ M3 ) @ ( F2 @ N8 ) ) ) ) )
                  & ! [N8: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ N8 )
                     => ( ( F2 @ N7 )
                        = ( F2 @ N8 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_6172_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X8: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S4: nat > B] :
                ( ! [N8: nat] : ( ord_less @ B @ ( S4 @ N8 ) @ A2 )
               => ( ! [N8: nat] : ( ord_less @ B @ B2 @ ( S4 @ N8 ) )
                 => ( ( order_mono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N: nat] : ( X8 @ ( S4 @ N ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_6173_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys )
      = ( ? [F3: nat > nat] :
            ( ( order_mono @ nat @ nat @ F3 )
            & ( ( image @ nat @ nat @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I4 )
                  = ( nth @ A @ Ys @ ( F3 @ I4 ) ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I4 )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) )
                  = ( ( F3 @ I4 )
                    = ( F3 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_6174_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I6 )
               => ( topolo7761053866217962861closed @ A @ ( F2 @ I3 ) ) )
           => ( ! [I9: set @ B] :
                  ( ( finite_finite @ B @ I9 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I9 @ I6 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I9 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I6 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_6175_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_6176_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% remdups_adj_set
thf(fact_6177_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A5: set @ A,B5: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A5 ) @ ( F2 @ B5 ) ) ) ) ).

% mono_Int
thf(fact_6178_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_6179_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups_adj @ A @ Xs )
        = Xs ) ) ).

% remdups_adj_distinct
thf(fact_6180_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A] :
      ( ( ( X = Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      & ( ( X != Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( cons @ A @ X @ ( remdups_adj @ A @ ( cons @ A @ Y @ Xs ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_6181_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_6182_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_6183_remdups__adj_Oelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( nil @ A ) ) )
       => ( ! [X3: A] :
              ( ( X
                = ( cons @ A @ X3 @ ( nil @ A ) ) )
             => ( Y
               != ( cons @ A @ X3 @ ( nil @ A ) ) ) )
         => ~ ! [X3: A,Y2: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) )
               => ~ ( ( ( X3 = Y2 )
                     => ( Y
                        = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs2 ) ) ) )
                    & ( ( X3 != Y2 )
                     => ( Y
                        = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_6184_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Y: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X = Y ) @ ( nil @ A ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_6185_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G2 )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X4: A] : ( ord_less_eq @ B @ ( F2 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_6186_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S2: set @ A,T6: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T6 )
           => ( ( ( inf_inf @ ( set @ A ) @ S2 @ T6 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U5: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U5 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ U5 )
                  & ( ord_less_eq @ ( set @ A ) @ T6 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_6187_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S2: set @ A,Y: A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ~ ( member @ A @ Y @ S2 )
           => ? [U5: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U5 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member @ A @ Y @ U5 )
                & ( ord_less_eq @ ( set @ A ) @ S2 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_6188_remdups__adj__adjacent,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I2 )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I2 ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_6189_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X: A,A5: set @ A] :
          ( ( member @ A @ X @ A5 )
         => ( ( topolo1002775350975398744n_open @ A @ A5 )
           => ? [A15: set @ A] :
                ( ( member @ A @ X @ A15 )
                & ( topolo7761053866217962861closed @ A @ A15 )
                & ( ord_less_eq @ ( set @ A ) @ A15 @ A5 )
                & ( eventually @ A
                  @ ^ [Y4: A] : ( member @ A @ Y4 @ A15 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X ) ) ) ) ) ) ).

% nhds_closed
thf(fact_6190_remdups__adj__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_6191_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
     => ( Xs
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X ) ) ) ).

% remdups_adj_singleton
thf(fact_6192_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_6193_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [X4: A] :
                  ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N ) @ ( uminus_uminus @ A @ X4 ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_6194_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [N9: nat] :
                  ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N ) @ ( uminus_uminus @ A @ ( X8 @ N9 ) ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_6195_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,G2: nat > A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G2 @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X4: nat] : ( times_times @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_6196_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X4: nat] : ( plus_plus @ A @ ( F2 @ X4 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_6197_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X4: nat] : ( plus_plus @ A @ ( F2 @ X4 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_6198_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N: nat] : ( X8 @ ( plus_plus @ nat @ N @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_6199_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N: nat] : ( X8 @ ( plus_plus @ nat @ N @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_6200_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X4: nat] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_6201_Bseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_6202_Cons__lenlex__iff,axiom,
    ! [A: $tType,M2: A,Ms: list @ A,N2: A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M2 @ Ms ) @ ( cons @ A @ N2 @ Ns ) ) @ ( lenlex @ A @ R ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M2 @ N2 ) @ R ) )
        | ( ( M2 = N2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_6203_inj__sgn__power,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( inj_on @ real @ real
        @ ^ [Y4: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N2 ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_6204_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_6205_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_6206_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B3: A] : ( divide_divide @ A @ B3 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_6207_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A5: set @ A,F2: A > B] :
          ( ! [X3: A,Y2: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
             => ( ( member @ A @ X3 @ A5 )
               => ( ( member @ A @ Y2 @ A5 )
                 => ( ( F2 @ X3 )
                   != ( F2 @ Y2 ) ) ) ) )
         => ( ! [X3: A,Y2: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ( member @ A @ Y2 @ A5 )
                 => ( ( ord_less_eq @ A @ X3 @ Y2 )
                    | ( ord_less_eq @ A @ Y2 @ X3 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A5 ) ) ) ) ).

% linorder_inj_onI
thf(fact_6208_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
       => ( inj_on @ A @ B @ F2 @ B5 ) ) ) ).

% inj_on_subset
thf(fact_6209_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B5: set @ A,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
       => ( inj_on @ A @ B @ F2 @ A5 ) ) ) ).

% subset_inj_on
thf(fact_6210_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A5: set @ A,B5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
         => ( ( ( image @ A @ B @ F2 @ A5 )
              = ( image @ A @ B @ F2 @ B5 ) )
            = ( A5 = B5 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_6211_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B5: set @ A,A2: A,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B5 )
     => ( ( member @ A @ A2 @ B5 )
       => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ A5 ) )
            = ( member @ A @ A2 @ A5 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_6212_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: B > A,T6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( image @ B @ A @ F2 @ T6 ) )
      = ( ? [U6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U6 @ T6 )
            & ( inj_on @ B @ A @ F2 @ U6 )
            & ( S2
              = ( image @ B @ A @ F2 @ U6 ) ) ) ) ) ).

% subset_image_inj
thf(fact_6213_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A5: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A5 ) ) ) ).

% inj_on_mult
thf(fact_6214_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A5: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B3: A] : ( plus_plus @ A @ B3 @ A2 )
          @ A5 ) ) ).

% inj_on_add'
thf(fact_6215_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A5: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A5 ) ) ).

% inj_on_add
thf(fact_6216_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_6217_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_6218_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X3: A,Y2: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
             => ( ( F2 @ X3 )
               != ( F2 @ Y2 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_6219_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X4: A] : X4
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_6220_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B5 ) )
        = ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ) ).

% inj_image_subset_iff
thf(fact_6221_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,A9: set @ B] :
      ( ( A5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F3: A > B] :
              ( ( inj_on @ A @ B @ F3 @ A5 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A5 ) @ A9 ) ) )
        = ( ? [G: B > A] :
              ( ( image @ B @ A @ G @ A9 )
              = A5 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_6222_endo__inj__surj,axiom,
    ! [A: $tType,A5: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F2 @ A5 ) @ A5 )
       => ( ( inj_on @ A @ A @ F2 @ A5 )
         => ( ( image @ A @ A @ F2 @ A5 )
            = A5 ) ) ) ) ).

% endo_inj_surj
thf(fact_6223_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,B5: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B5 )
       => ( ( finite_finite @ B @ B5 )
         => ( finite_finite @ A @ A5 ) ) ) ) ).

% inj_on_finite
thf(fact_6224_finite__surj__inj,axiom,
    ! [A: $tType,A5: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( image @ A @ A @ F2 @ A5 ) )
       => ( inj_on @ A @ A @ F2 @ A5 ) ) ) ).

% finite_surj_inj
thf(fact_6225_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A5: set @ A,B5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B5 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_6226_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A5: set @ A,B5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ ( image @ A @ B @ F2 @ B5 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_6227_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( finite_card @ B @ A5 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A5 ) ) ).

% pigeonhole
thf(fact_6228_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_6229_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,X: B,B5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( member @ B @ X @ ( image @ A @ B @ F2 @ A5 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( member @ A @ ( the_inv_into @ A @ B @ A5 @ F2 @ X ) @ B5 ) ) ) ) ).

% the_inv_into_into
thf(fact_6230_lenlex__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R ) ) ) ).

% lenlex_irreflexive
thf(fact_6231_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R ) ) ).

% Nil_lenlex_iff2
thf(fact_6232_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I6: set @ A,A5: A > ( set @ B ),F2: B > C] :
      ( ! [I3: A,J2: A] :
          ( ( member @ A @ I3 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A5 @ I3 ) @ ( A5 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A5 @ J2 ) @ ( A5 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I6 )
           => ( inj_on @ B @ C @ F2 @ ( A5 @ I3 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A5 @ I6 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_6233_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B5: set @ B,G2: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B5 )
       => ( ( inj_on @ B @ A @ G2 @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G2 @ B5 ) @ A5 )
           => ( ( finite_finite @ A @ A5 )
             => ( ( finite_finite @ B @ B5 )
               => ( ( finite_card @ A @ A5 )
                  = ( finite_card @ B @ B5 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_6234_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,T6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T6 )
       => ( ( ( finite_card @ A @ S2 )
            = ( finite_card @ B @ T6 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ S2 ) @ T6 )
           => ( ( ! [X4: B] :
                    ( ( member @ B @ X4 @ T6 )
                   => ? [Y4: A] :
                        ( ( member @ A @ Y4 @ S2 )
                        & ( ( F2 @ Y4 )
                          = X4 ) ) ) )
              = ( inj_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_6235_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ A5 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_6236_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C6: set @ A,A5: set @ C,B5: C > ( set @ A ),J: C] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ! [X3: C] :
            ( ( member @ C @ X3 @ A5 )
           => ( ord_less_eq @ ( set @ A ) @ ( B5 @ X3 ) @ C6 ) )
       => ( ( member @ C @ J @ A5 )
         => ( ( image @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B5 @ A5 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X4: C] : ( image @ A @ B @ F2 @ ( B5 @ X4 ) )
                @ A5 ) ) ) ) ) ) ).

% image_INT
thf(fact_6237_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_6238_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R3: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R3 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys ) ) @ ( lenlex @ A @ R3 ) ) ) ) ).

% lenlex_append1
thf(fact_6239_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,B5: set @ B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ B @ B5 )
       => ( ( ? [F3: A > B] :
                ( ( inj_on @ A @ B @ F3 @ A5 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A5 ) @ B5 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ B @ B5 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_6240_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B5: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B5 )
       => ( ( finite_finite @ B @ B5 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ B @ B5 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_6241_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ B] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ B @ B5 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ B @ B5 ) )
         => ? [F8: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F8 @ A5 ) @ B5 )
              & ( inj_on @ A @ B @ F8 @ A5 ) ) ) ) ) ).

% card_le_inj
thf(fact_6242_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_6243_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ A,B5: set @ B,G2: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B5 )
       => ( ( inj_on @ B @ A @ G2 @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G2 @ B5 ) @ A5 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A5 @ B5 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_6244_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T10: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
           => ( P @ T10 ) ) )
      = ( ! [T10: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T10 ) )
           => ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_6245_inj__on__diff__nat,axiom,
    ! [N4: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member @ nat @ N3 @ N4 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N: nat] : ( minus_minus @ nat @ N @ K )
        @ N4 ) ) ).

% inj_on_diff_nat
thf(fact_6246_inj__on__Cons1,axiom,
    ! [A: $tType,X: A,A5: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ A5 ) ).

% inj_on_Cons1
thf(fact_6247_inj__split__Cons,axiom,
    ! [A: $tType,X8: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs3: list @ A,N: A] : ( cons @ A @ N @ Xs3 ) )
      @ X8 ) ).

% inj_split_Cons
thf(fact_6248_inj__Suc,axiom,
    ! [N4: set @ nat] : ( inj_on @ nat @ nat @ suc @ N4 ) ).

% inj_Suc
thf(fact_6249_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_6250_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X6: $o > A,Y7: $o > A] :
              ( ( ord_less_eq @ A @ ( X6 @ $false ) @ ( Y7 @ $false ) )
              & ( ord_less_eq @ A @ ( X6 @ $true ) @ ( Y7 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_6251_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [N3: nat,F8: nat > A] :
          ( ( A5
            = ( image @ nat @ A @ F8
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) ) )
          & ( inj_on @ nat @ A @ F8
            @ ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_6252_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ? [F8: A > nat,N3: nat] :
          ( ( ( image @ A @ nat @ F8 @ A5 )
            = ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) )
          & ( inj_on @ A @ nat @ F8 @ A5 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_6253_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ I6 )
           => ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I6 ) ) ) ).

% inj_on_nth
thf(fact_6254_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ~ ( finite_finite @ A @ S2 ) )
      = ( ? [F3: nat > A] :
            ( ( inj_on @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_6255_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ? [F8: nat > A] :
          ( ( inj_on @ nat @ A @ F8 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F8 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ).

% infinite_countable_subset
thf(fact_6256_inj__on__funpow__least,axiom,
    ! [A: $tType,N2: nat,F2: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ S )
        = S )
     => ( ! [M4: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
           => ( ( ord_less @ nat @ M4 @ N2 )
             => ( ( compow @ ( A > A ) @ M4 @ F2 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K3: nat] : ( compow @ ( A > A ) @ K3 @ F2 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% inj_on_funpow_least
thf(fact_6257_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_6258_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T10: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T10 ) ) )
      = ( ? [T10: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T10 )
            & ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_6259_lenlex__append2,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( irrefl @ A @ R3 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys ) ) @ ( lenlex @ A @ R3 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lenlex @ A @ R3 ) ) ) ) ).

% lenlex_append2
thf(fact_6260_shuffles_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa2 )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( insert2 @ ( list @ A ) @ Xa2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ( Y
             != ( insert2 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ! [Y2: A,Ys4: list @ A] :
                    ( ( Xa2
                      = ( cons @ A @ Y2 @ Ys4 ) )
                   => ( Y
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_6261_sup_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) ).

% sup.idem
thf(fact_6262_sup__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) ).

% sup_idem
thf(fact_6263_sup_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.left_idem
thf(fact_6264_sup__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_left_idem
thf(fact_6265_sup_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.right_idem
thf(fact_6266_sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B,X4: A] : ( sup_sup @ B @ ( F3 @ X4 ) @ ( G @ X4 ) ) ) ) ) ).

% sup_apply
thf(fact_6267_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            & ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% le_sup_iff
thf(fact_6268_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_6269_sup__top__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% sup_top_right
thf(fact_6270_sup__top__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% sup_top_left
thf(fact_6271_sup__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% sup_bot_left
thf(fact_6272_sup__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% sup_bot_right
thf(fact_6273_bot__eq__sup__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% bot_eq_sup_iff
thf(fact_6274_sup__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_eq_bot_iff
thf(fact_6275_sup__bot_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A,B2: A] :
          ( ( ( sup_sup @ A @ A2 @ B2 )
            = ( bot_bot @ A ) )
          = ( ( A2
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.eq_neutr_iff
thf(fact_6276_sup__bot_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A2 )
          = A2 ) ) ).

% sup_bot.left_neutral
thf(fact_6277_sup__bot_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ A2 @ B2 ) )
          = ( ( A2
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.neutr_eq_iff
thf(fact_6278_sup__bot_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ ( bot_bot @ A ) )
          = A2 ) ) ).

% sup_bot.right_neutral
thf(fact_6279_inf__sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) ).

% inf_sup_absorb
thf(fact_6280_sup__inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) ).

% sup_inf_absorb
thf(fact_6281_Un__subset__iff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) @ C6 )
      = ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
        & ( ord_less_eq @ ( set @ A ) @ B5 @ C6 ) ) ) ).

% Un_subset_iff
thf(fact_6282_set__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( append @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_append
thf(fact_6283_set__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_union
thf(fact_6284_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A5: A,B5: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A5 ) @ ( F2 @ B5 ) ) @ ( F2 @ ( sup_sup @ A @ A5 @ B5 ) ) ) ) ) ).

% mono_sup
thf(fact_6285_Diff__partition,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( sup_sup @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B5 @ A5 ) )
        = B5 ) ) ).

% Diff_partition
thf(fact_6286_Diff__subset__conv,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) @ C6 )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B5 @ C6 ) ) ) ).

% Diff_subset_conv
thf(fact_6287_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_6288_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_6289_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_6290_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_6291_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_6292_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge1
thf(fact_6293_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge2
thf(fact_6294_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_6295_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_6296_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_6297_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_6298_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z ) @ X ) ) ) ) ).

% sup_least
thf(fact_6299_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X4: A,Y4: A] :
              ( ( sup_sup @ A @ X4 @ Y4 )
              = Y4 ) ) ) ) ).

% le_iff_sup
thf(fact_6300_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_6301_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_6302_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X3: A,Y2: A] : ( ord_less_eq @ A @ X3 @ ( F2 @ X3 @ Y2 ) )
         => ( ! [X3: A,Y2: A] : ( ord_less_eq @ A @ Y2 @ ( F2 @ X3 @ Y2 ) )
           => ( ! [X3: A,Y2: A,Z3: A] :
                  ( ( ord_less_eq @ A @ Y2 @ X3 )
                 => ( ( ord_less_eq @ A @ Z3 @ X3 )
                   => ( ord_less_eq @ A @ ( F2 @ Y2 @ Z3 ) @ X3 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_6303_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_6304_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_6305_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) ).

% sup_absorb1
thf(fact_6306_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_6307_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_6308_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_6309_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( A3
              = ( sup_sup @ A @ A3 @ B3 ) ) ) ) ) ).

% sup.order_iff
thf(fact_6310_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_6311_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_6312_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( sup_sup @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_6313_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( sup_sup @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_6314_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_6315_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_6316_Un__mono,axiom,
    ! [A: $tType,A5: set @ A,C6: set @ A,B5: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) @ ( sup_sup @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Un_mono
thf(fact_6317_Un__least,axiom,
    ! [A: $tType,A5: set @ A,C6: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B5 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) @ C6 ) ) ) ).

% Un_least
thf(fact_6318_Un__upper1,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] : ( ord_less_eq @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) ) ).

% Un_upper1
thf(fact_6319_Un__upper2,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ B5 @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) ) ).

% Un_upper2
thf(fact_6320_Un__absorb1,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( sup_sup @ ( set @ A ) @ A5 @ B5 )
        = B5 ) ) ).

% Un_absorb1
thf(fact_6321_Un__absorb2,axiom,
    ! [A: $tType,B5: set @ A,A5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
     => ( ( sup_sup @ ( set @ A ) @ A5 @ B5 )
        = A5 ) ) ).

% Un_absorb2
thf(fact_6322_subset__UnE,axiom,
    ! [A: $tType,C6: set @ A,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
     => ~ ! [A15: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A15 @ A5 )
           => ! [B13: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B13 @ B5 )
               => ( C6
                 != ( sup_sup @ ( set @ A ) @ A15 @ B13 ) ) ) ) ) ).

% subset_UnE
thf(fact_6323_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A7 @ B8 )
            = B8 ) ) ) ).

% subset_Un_eq
thf(fact_6324_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% distrib_inf_le
thf(fact_6325_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% distrib_sup_le
thf(fact_6326_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,C6: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) @ C6 )
        = ( inf_inf @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B5 @ C6 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C6 @ A5 ) ) ).

% Un_Int_assoc_eq
thf(fact_6327_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or3652927894154168847AtMost @ A @ M2 @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_6328_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_6329_distrib__imp1,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y2: A,Z3: A] :
              ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y2 @ Z3 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y2 ) @ ( inf_inf @ A @ X3 @ Z3 ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ) ).

% distrib_imp1
thf(fact_6330_distrib__imp2,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y2: A,Z3: A] :
              ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y2 @ Z3 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y2 ) @ ( sup_sup @ A @ X3 @ Z3 ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) ) ).

% distrib_imp2
thf(fact_6331_inf__sup__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) ).

% inf_sup_distrib1
thf(fact_6332_inf__sup__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z @ X ) ) ) ) ).

% inf_sup_distrib2
thf(fact_6333_sup__inf__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% sup_inf_distrib1
thf(fact_6334_sup__inf__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z @ X ) ) ) ) ).

% sup_inf_distrib2
thf(fact_6335_inf__sup__aci_I8_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_aci(8)
thf(fact_6336_inf__sup__aci_I7_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% inf_sup_aci(7)
thf(fact_6337_inf__sup__aci_I6_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% inf_sup_aci(6)
thf(fact_6338_inf__sup__aci_I5_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X4: A,Y4: A] : ( sup_sup @ A @ Y4 @ X4 ) ) ) ) ).

% inf_sup_aci(5)
thf(fact_6339_sup_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ C2 )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.assoc
thf(fact_6340_sup__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% sup_assoc
thf(fact_6341_sup_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [A3: A,B3: A] : ( sup_sup @ A @ B3 @ A3 ) ) ) ) ).

% sup.commute
thf(fact_6342_sup__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X4: A,Y4: A] : ( sup_sup @ A @ Y4 @ X4 ) ) ) ) ).

% sup_commute
thf(fact_6343_sup_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( sup_sup @ A @ B2 @ ( sup_sup @ A @ A2 @ C2 ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.left_commute
thf(fact_6344_sup__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% sup_left_commute
thf(fact_6345_sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G: A > B,X4: A] : ( sup_sup @ B @ ( F3 @ X4 ) @ ( G @ X4 ) ) ) ) ) ).

% sup_fun_def
thf(fact_6346_sup__max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% sup_max
thf(fact_6347_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_6348_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_6349_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( A3
                = ( sup_sup @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_6350_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_6351_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_6352_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_6353_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_6354_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_6355_complete__linorder__sup__max,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% complete_linorder_sup_max
thf(fact_6356_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ) ).

% set_shuffles
thf(fact_6357_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A5: set @ A,B5: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ A5 ) @ ( F2 @ B5 ) ) @ ( F2 @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) ) ) ) ).

% mono_Un
thf(fact_6358_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% sup_shunt
thf(fact_6359_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P4: A,Q2: A,R: A] :
          ( ( ord_less_eq @ A @ P4 @ ( sup_sup @ A @ Q2 @ R ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P4 @ ( uminus_uminus @ A @ Q2 ) ) @ R ) ) ) ).

% sup_neg_inf
thf(fact_6360_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% shunt2
thf(fact_6361_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z ) ) ) ) ).

% shunt1
thf(fact_6362_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A,B5: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B5 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_6363_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_6364_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_6365_card__Un__le,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) ) ) ).

% card_Un_le
thf(fact_6366_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or3652927894154168847AtMost @ A @ M2 @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_6367_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_6368_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_6369_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_6370_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ) ) ).

% shuffles.simps(3)
thf(fact_6371_Inter__Un__subset,axiom,
    ! [A: $tType,A5: set @ ( set @ A ),B5: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A5 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B5 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A5 @ B5 ) ) ) ).

% Inter_Un_subset
thf(fact_6372_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_6373_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ B5 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_6374_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ B5 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_6375_card__Un__Int,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B5 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_6376_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_6377_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_6378_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_6379_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or5935395276787703475ssThan @ A @ M2 @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_6380_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_6381_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_6382_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less @ A @ L @ M2 )
         => ( ( ord_less @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M2 ) @ ( set_or7035219750837199246ssThan @ A @ M2 @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_6383_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: A,B5: A] :
          ( ( sup_sup @ A @ A5
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X4: nat] : B5
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A5 @ B5 ) ) ) ).

% SUP_nat_binary
thf(fact_6384_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_6385_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X4: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X4 )
        @ ^ [X4: A,Y4: A] : ( ord_less @ A @ Y4 @ X4 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_6386_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) )
                 => ( ( G2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_6387_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A5: set @ B,B5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_6388_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ( ( inf_inf @ ( set @ B ) @ A5 @ B5 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ A5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_6389_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) )
                 => ( ( G2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_6390_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ( ( inf_inf @ ( set @ B ) @ A5 @ B5 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_6391_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_6392_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A5: set @ A,B5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A5 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B5 @ A5 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_6393_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ B5 @ A5 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_6394_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A5: set @ B,B5: set @ B,G2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ A5 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( minus_minus @ ( set @ B ) @ B5 @ A5 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_6395_card__Un__disjoint,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B5 )
       => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B5 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ A @ B5 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_6396_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_6397_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M2 )
         => ( ( ord_less @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M2 ) @ ( set_or5935395276787703475ssThan @ A @ M2 @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_6398_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_6399_sum__Un__nat,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ( finite_finite @ A @ B5 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B5 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_6400_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M2: A,U: A] :
          ( ( ord_less @ A @ L @ M2 )
         => ( ( ord_less_eq @ A @ M2 @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M2 ) @ ( set_or1337092689740270186AtMost @ A @ M2 @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_6401_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert2 @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_6402_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A5: set @ B,B5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( finite_finite @ B @ B5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A5 @ B5 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A5 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B5 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A5 @ B5 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_6403_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_6404_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G2: A > B,C6: set @ A,B5: set @ A,X: A] :
      ( ( inj_on @ A @ B @ G2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ B5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I4: B] : ( if @ A @ ( member @ B @ I4 @ ( image @ A @ B @ G2 @ C6 ) ) @ ( the_inv_into @ A @ B @ C6 @ G2 @ I4 ) @ X )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_6405_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( lex @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) ) ) ) ) ).

% Cons_in_lex
thf(fact_6406_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_6407_irrefl__lex,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R ) ) ) ).

% irrefl_lex
thf(fact_6408_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_6409_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) @ ( lex @ A @ R ) ) ).

% Nil_notin_lex
thf(fact_6410_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R ) ) ).

% Nil2_notin_lex
thf(fact_6411_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) ) ) ).

% lex_append_leftI
thf(fact_6412_atLeastLessThan__add__Un,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I2 @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I2 @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_6413_lexl__not__refl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( irrefl @ A @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ X ) @ ( lex @ A @ R ) ) ) ).

% lexl_not_refl
thf(fact_6414_lex__append__left__iff,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_left_iff
thf(fact_6415_lex__append__leftD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_leftD
thf(fact_6416_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_rightI
thf(fact_6417_Pow__set_I2_J,axiom,
    ! [B: $tType,X: B,Xs: list @ B] :
      ( ( pow2 @ B @ ( set2 @ B @ ( cons @ B @ X @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) @ ( image @ ( set @ B ) @ ( set @ B ) @ ( insert2 @ B @ X ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_6418_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs3 )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_6419_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A16: set @ B,B14: set @ A,F22: C > D,B23: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F1 @ A16 )
        = B14 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F22 @ B23 ) @ A26 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B14 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A16 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_6420_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F2 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X4: B] : ( set2 @ A @ ( F2 @ X4 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_6421_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) ).

% bind_simps(1)
thf(fact_6422_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: B,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) ).

% bind_simps(2)
thf(fact_6423_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > ( list @ B ),G2: A > ( list @ B )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( ( F2 @ X3 )
              = ( G2 @ X3 ) ) )
       => ( ( bind @ A @ B @ Xs @ F2 )
          = ( bind @ A @ B @ Ys @ G2 ) ) ) ) ).

% list_bind_cong
thf(fact_6424_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G2: A > B,A26: set @ A,A16: set @ B,F1: B > C,B14: set @ C,F22: D > A,B23: set @ D] :
      ( ( member @ ( A > B ) @ G2 @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A16 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F1 @ A16 ) @ B14 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F22 @ B23 ) @ A26 )
         => ( member @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B23 @ F1 @ F22 @ G2 ) @ ( bNF_Wellorder_Func @ D @ C @ B23 @ B14 ) ) ) ) ) ).

% Func_map
thf(fact_6425_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X: C,F6: C > A,S2: set @ C,N2: int] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F6 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X4: C] : ( power_int @ A @ ( F2 @ X4 ) @ N2 )
              @ ^ [H: C] : ( times_times @ A @ ( F6 @ H ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_6426_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,N2: int,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X4: A] : ( power_int @ A @ X4 @ N2 )
            @ ^ [Y4: A] : ( times_times @ A @ Y4 @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ X @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power_int'
thf(fact_6427_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_6428_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( one_one @ int ) )
          = Y ) ) ).

% power_int_1_right
thf(fact_6429_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W2: num,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W2 ) ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M2 ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_6430_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W2: num,Y: A,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W2 ) @ Y ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W2 ) @ M2 ) @ ( power_int @ A @ Y @ M2 ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_6431_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_6432_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N2: nat] :
          ( ( power_int @ A @ X @ ( semiring_1_of_nat @ int @ N2 ) )
          = ( power_power @ A @ X @ N2 ) ) ) ).

% power_int_of_nat
thf(fact_6433_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: num,N2: num] :
          ( ( power_int @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( times_times @ num @ M2 @ N2 ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_6434_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_6435_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M2 ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_6436_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N2: num] :
          ( ( power_int @ A @ X @ ( numeral_numeral @ int @ N2 ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% power_int_numeral
thf(fact_6437_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: num,N2: int,Y: real] :
          ( ( ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N2 )
            = ( real_Vector_of_real @ A @ Y ) )
          = ( ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N2 )
            = Y ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
thf(fact_6438_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [Y: real,X: num,N2: int] :
          ( ( ( real_Vector_of_real @ A @ Y )
            = ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N2 ) )
          = ( Y
            = ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N2 ) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
thf(fact_6439_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y ) ) ) ).

% power_int_minus1_right
thf(fact_6440_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: num,N2: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M2 ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N2 ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M2 @ N2 ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_6441_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M2 ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M2 @ N2 ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_6442_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_6443_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_odd
thf(fact_6444_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_int @ A @ A2 @ N2 ) ) ) ) ).

% power_int_minus_left_even
thf(fact_6445_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M2: num,N2: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M2 @ N2 ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_6446_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% zero_le_power_int
thf(fact_6447_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M2: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X @ Y ) @ M2 )
          = ( divide_divide @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ Y @ M2 ) ) ) ) ).

% power_int_divide_distrib
thf(fact_6448_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M2: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y ) @ M2 )
          = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ Y @ M2 ) ) ) ) ).

% power_int_mult_distrib
thf(fact_6449_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N2: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N2 ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% power_int_commutes
thf(fact_6450_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: int,N2: int] :
          ( ( power_int @ A @ X @ ( times_times @ int @ M2 @ N2 ) )
          = ( power_int @ A @ ( power_int @ A @ X @ M2 ) @ N2 ) ) ) ).

% power_int_mult
thf(fact_6451_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% zero_less_power_int
thf(fact_6452_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N2: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ).

% power_int_one_over
thf(fact_6453_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M2: int] :
          ( ( ( M2
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M2 )
              = ( one_one @ A ) ) )
          & ( ( M2
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_6454_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_increasing
thf(fact_6455_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_6456_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) ) ) ).

% power_int_minus_one_minus
thf(fact_6457_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,M2: int,N2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M2 != N2 ) )
         => ( ( power_int @ A @ X @ ( minus_minus @ int @ M2 @ N2 ) )
            = ( divide_divide @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ X @ N2 ) ) ) ) ) ).

% power_int_diff
thf(fact_6458_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A2 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A2 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_6459_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_6460_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,N2: int] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N2 ) @ ( power_int @ A @ Y @ N2 ) ) ) ) ) ) ).

% power_int_mono
thf(fact_6461_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_6462_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N2 ) ) ) ) ) ).

% one_le_power_int
thf(fact_6463_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power_int
thf(fact_6464_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: int,N2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M2 @ N2 )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M2 @ N2 ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ X @ N2 ) ) ) ) ) ).

% power_int_add
thf(fact_6465_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X: C,A2: A,N2: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_6466_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_6467_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_6468_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N4
                   != ( zero_zero @ int ) )
                  | ( N2
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_6469_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_6470_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M2: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ X @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less_eq @ int @ M2 @ N2 ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_6471_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M2: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M2 ) @ ( power_int @ A @ X @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ int @ M2 @ N2 ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_6472_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_int @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_minus_left
thf(fact_6473_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N2
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N2 ) ) ) ) ).

% power_int_minus_mult
thf(fact_6474_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M2
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M2 @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M2 ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_6475_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M2: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M2
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M2 @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M2 ) ) ) ) ) ).

% power_int_add_1'
thf(fact_6476_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X4: A,N: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N ) @ ( power_power @ A @ X4 @ ( nat2 @ N ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X4 ) @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_6477_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,N2: int] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X4: A] : ( power_int @ A @ ( F2 @ X4 ) @ N2 )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_power_int
thf(fact_6478_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A3: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X @ A3 ) )
                @ ( set_ord_greaterThan @ A @ X ) ) ) ) ) ) ).

% at_right_eq
thf(fact_6479_lists__length__Suc__eq,axiom,
    ! [A: $tType,A5: set @ A,N2: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs3: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
            & ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( suc @ N2 ) ) ) )
      = ( image @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs3: list @ A,N: A] : ( cons @ A @ N @ Xs3 ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A5 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N2 ) ) )
          @ ^ [Uu3: list @ A] : A5 ) ) ) ).

% lists_length_Suc_eq
thf(fact_6480_principal__le__iff,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A5 ) @ ( principal @ A @ B5 ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ B5 ) ) ).

% principal_le_iff
thf(fact_6481_set__product,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( product_Sigma @ A @ B @ ( set2 @ A @ Xs )
        @ ^ [Uu3: A] : ( set2 @ B @ Ys ) ) ) ).

% set_product
thf(fact_6482_card__cartesian__product,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,B5: set @ B] :
      ( ( finite_card @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B5 ) )
      = ( times_times @ nat @ ( finite_card @ A @ A5 ) @ ( finite_card @ B @ B5 ) ) ) ).

% card_cartesian_product
thf(fact_6483_Restr__subset,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
            @ ( product_Sigma @ A @ A @ B5
              @ ^ [Uu3: A] : B5 ) )
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu3: A] : A5 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R
          @ ( product_Sigma @ A @ A @ A5
            @ ^ [Uu3: A] : A5 ) ) ) ) ).

% Restr_subset
thf(fact_6484_subset__fst__imageI,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ B,S2: set @ ( product_prod @ A @ B ),Y: B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B5 )
        @ S2 )
     => ( ( member @ B @ Y @ B5 )
       => ( ord_less_eq @ ( set @ A ) @ A5 @ ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ S2 ) ) ) ) ).

% subset_fst_imageI
thf(fact_6485_subset__snd__imageI,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ B,S2: set @ ( product_prod @ A @ B ),X: A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B5 )
        @ S2 )
     => ( ( member @ A @ X @ A5 )
       => ( ord_less_eq @ ( set @ B ) @ B5 @ ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ S2 ) ) ) ) ).

% subset_snd_imageI
thf(fact_6486_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I6: set @ A,F4: A > ( set @ B ),F2: B > C,G5: D > ( set @ C ),J4: set @ D] :
      ( ( I6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I6 )
           => ! [J2: A] :
                ( ( member @ A @ J2 @ I6 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F4 @ I3 ) @ ( F4 @ J2 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F4 @ J2 ) @ ( F4 @ I3 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F2
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J3: D] : ( principal @ C @ ( G5 @ J3 ) )
                @ J4 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I4: A] : ( principal @ B @ ( F4 @ I4 ) )
                @ I6 ) ) )
          = ( ! [X4: D] :
                ( ( member @ D @ X4 @ J4 )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ I6 )
                    & ! [Z5: B] :
                        ( ( member @ B @ Z5 @ ( F4 @ Y4 ) )
                       => ( member @ C @ ( F2 @ Z5 ) @ ( G5 @ X4 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_6487_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A3: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A3 @ X ) )
                @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ).

% at_left_eq
thf(fact_6488_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,C6: set @ B,B5: set @ A,D5: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : C6 )
        @ ( product_Sigma @ A @ B @ B5
          @ ^ [Uu3: A] : D5 ) )
      = ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        | ( C6
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
          & ( ord_less_eq @ ( set @ B ) @ C6 @ D5 ) ) ) ) ).

% times_subset_iff
thf(fact_6489_Times__subset__cancel2,axiom,
    ! [A: $tType,B: $tType,X: A,C6: set @ A,A5: set @ B,B5: set @ B] :
      ( ( member @ A @ X @ C6 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ A ) )
          @ ( product_Sigma @ B @ A @ A5
            @ ^ [Uu3: B] : C6 )
          @ ( product_Sigma @ B @ A @ B5
            @ ^ [Uu3: B] : C6 ) )
        = ( ord_less_eq @ ( set @ B ) @ A5 @ B5 ) ) ) ).

% Times_subset_cancel2
thf(fact_6490_less__by__empty,axiom,
    ! [A: $tType,A5: set @ ( product_prod @ A @ A ),B5: set @ ( product_prod @ A @ A )] :
      ( ( A5
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A5 @ B5 ) ) ).

% less_by_empty
thf(fact_6491_pairs__le__eq__Sigma,axiom,
    ! [M2: nat] :
      ( ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ M2 ) ) )
      = ( product_Sigma @ nat @ nat @ ( set_ord_atMost @ nat @ M2 )
        @ ^ [R5: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M2 @ R5 ) ) ) ) ).

% pairs_le_eq_Sigma
thf(fact_6492_Sigma__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,C6: set @ A,B5: A > ( set @ B ),D5: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C6 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A5 )
           => ( ord_less_eq @ ( set @ B ) @ ( B5 @ X3 ) @ ( D5 @ X3 ) ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ A5 @ B5 ) @ ( product_Sigma @ A @ B @ C6 @ D5 ) ) ) ) ).

% Sigma_mono
thf(fact_6493_Gr__incl,axiom,
    ! [A: $tType,B: $tType,A5: set @ A,F2: A > B,B5: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( bNF_Gr @ A @ B @ A5 @ F2 )
        @ ( product_Sigma @ A @ B @ A5
          @ ^ [Uu3: A] : B5 ) )
      = ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A5 ) @ B5 ) ) ).

% Gr_incl
thf(fact_6494_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
      = ( ? [Y4: A,N: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N ) @ Y4 ) @ R )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys
              = ( list_update @ A @ Xs @ N @ Y4 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_6495_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
          & ( Xs = Ys ) )
        | ( ( X = Y )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_6496_listrel1__mono,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R ) @ ( listrel1 @ A @ S ) ) ) ).

% listrel1_mono
thf(fact_6497_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R ) ) ).

% not_Nil_listrel1
thf(fact_6498_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R ) ) ).

% not_listrel1_Nil
thf(fact_6499_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_6500_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R ) ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R ) ) ) ).

% append_listrel1I
thf(fact_6501_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I2
thf(fact_6502_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R ) )
     => ( ! [X3: A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Ys ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_6503_Cons__listrel1E1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ! [Y2: A] :
            ( ( Ys
              = ( cons @ A @ Y2 @ Xs ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_6504_listrel1I1,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Xs ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I1
thf(fact_6505_listrel1I,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y @ Vs ) ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% listrel1I
thf(fact_6506_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ~ ! [X3: A,Y2: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R )
           => ! [Us3: list @ A,Vs2: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us3 @ ( cons @ A @ X3 @ Vs2 ) ) )
               => ( Ys
                 != ( append @ A @ Us3 @ ( cons @ A @ Y2 @ Vs2 ) ) ) ) ) ) ).

% listrel1E
thf(fact_6507_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A,Y: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( X = Y ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_6508_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_6509_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => ( Xa2
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( Deg2 = Xa2 )
                & ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X6 )
                    & ! [X4: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi3: nat,Ma3: nat] :
                        ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                        & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I4: nat] :
                            ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X6 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                        & ( ( Mi3 = Ma3 )
                         => ! [X4: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                        & ( ( Mi3 != Ma3 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                            & ! [X4: nat] :
                                ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                 => ( ( ord_less @ nat @ Mi3 @ X4 )
                                    & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_6510_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A7: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z5: list @ A] :
              ? [X4: A,Xs3: list @ A] :
                ( ( Z5
                  = ( cons @ A @ X4 @ Xs3 ) )
                & ( member @ A @ X4 @ A7 )
                & ( member @ ( list @ A ) @ Xs3 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_6511_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y4 ) )
              & ( ord_less @ A @ Y4 @ X4 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_6512_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y4 ) )
              & ( ord_less @ A @ X4 @ Y4 ) ) ) ) ) ).

% open_subdiagonal
thf(fact_6513_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X16: list @ A,X24: list @ A] :
            ( ? [Y4: A,Ys3: list @ A] :
                ( ( X16
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y4 @ Ys3 ) ) )
            | ? [X4: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X16
                  = ( cons @ A @ X4 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y4 @ Ys3 ) )
                & ( ord_less @ A @ X4 @ Y4 ) )
            | ? [X4: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X16
                  = ( cons @ A @ X4 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y4 @ Ys3 ) )
                & ~ ( ord_less @ A @ X4 @ Y4 )
                & ~ ( ord_less @ A @ Y4 @ X4 )
                & ( P6 @ Xs3 @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_6514_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X16: list @ A,X24: list @ A] :
          ( ? [Y4: A,Ys3: list @ A] :
              ( ( X16
                = ( nil @ A ) )
              & ( X24
                = ( cons @ A @ Y4 @ Ys3 ) ) )
          | ? [X4: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X16
                = ( cons @ A @ X4 @ Xs3 ) )
              & ( X24
                = ( cons @ A @ Y4 @ Ys3 ) )
              & ( Less @ X4 @ Y4 ) )
          | ? [X4: A,Y4: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X16
                = ( cons @ A @ X4 @ Xs3 ) )
              & ( X24
                = ( cons @ A @ Y4 @ Ys3 ) )
              & ~ ( Less @ X4 @ Y4 )
              & ~ ( Less @ Y4 @ X4 )
              & ( P6 @ Xs3 @ Ys3 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_6515_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P3: A > $o] : ( ord_less_eq @ ( set @ A ) @ A7 @ ( collect @ A @ P3 ) ) ) ) ).

% Ball_Collect
thf(fact_6516_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y4 ) )
              & ( ord_less_eq @ A @ X4 @ Y4 ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_6517_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X4: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X4 @ Y4 ) )
              & ( ord_less_eq @ A @ Y4 @ X4 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_6518_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                ? [Us2: list @ A,Z5: A,Z9: A,Vs3: list @ A] :
                  ( ( Xs3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z5 @ Vs3 ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ Z9 ) @ R5 )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z9 @ Vs3 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_6519_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X4: A] :
                    ( ( member @ A @ X4 @ A7 )
                   => ( ord_less_eq @ A @ X4 @ B3 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_6520_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X4: A] :
                    ( ( member @ A @ X4 @ A7 )
                   => ( ord_less_eq @ A @ B3 @ X4 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_6521_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys: list @ A,X4: A,Y4: A,Xs6: list @ A,Ys6: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X4 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y4 @ Ys6 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y4 ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_6522_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs3: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I4: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs3 @ I4 ) )
                & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_6523_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList2 @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X4: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
           => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X6 )
            & ! [X4: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
               => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi3: nat,Ma3: nat] :
                ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X6 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
                & ( ( Mi3 = Ma3 )
                 => ! [X4: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                & ( ( Mi3 != Ma3 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                    & ! [X4: nat] :
                        ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X4 )
                         => ( ( ord_less @ nat @ Mi3 @ X4 )
                            & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_6524_funpow__inj__finite,axiom,
    ! [A: $tType,P4: A > A,X: A] :
      ( ( inj_on @ A @ A @ P4 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y4: A] :
              ? [N: nat] :
                ( Y4
                = ( compow @ ( A > A ) @ N @ P4 @ X ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P4 @ X )
               != X ) ) ) ) ).

% funpow_inj_finite
thf(fact_6525_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa2 )
        = Y )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => ( Y
            = ( ( Xa2
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( Y
                = ( ~ ( ( Deg2 = Xa2 )
                      & ! [X4: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X6 )
                          & ! [X4: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X6 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X4: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X4: nat] :
                                      ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                       => ( ( ord_less @ nat @ Mi3 @ X4 )
                                          & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_6526_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => ( Xa2
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ~ ( ( Deg2 = Xa2 )
                  & ! [X2: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X6 )
                      & ! [X4: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi3: nat,Ma3: nat] :
                          ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                          & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X6 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                          & ( ( Mi3 = Ma3 )
                           => ! [X4: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                          & ( ( Mi3 != Ma3 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                              & ! [X4: nat] :
                                  ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                   => ( ( ord_less @ nat @ Mi3 @ X4 )
                                      & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_6527_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) )
               => ( Xa2
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa2 ) )
                 => ( ( Deg2 = Xa2 )
                    & ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X6 )
                        & ! [X4: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi3: nat,Ma3: nat] :
                            ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                            & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I4: nat] :
                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X6 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                            & ( ( Mi3 = Ma3 )
                             => ! [X4: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                            & ( ( Mi3 != Ma3 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                & ! [X4: nat] :
                                    ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                     => ( ( ord_less @ nat @ Mi3 @ X4 )
                                        & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_6528_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) )
               => ( Xa2
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa2 ) )
                 => ~ ( ( Deg2 = Xa2 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X6 )
                          & ! [X4: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X6 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X4: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X4: nat] :
                                      ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                       => ( ( ord_less @ nat @ Mi3 @ X4 )
                                          & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_6529_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A5 ) )
                    & ! [X4: set @ A] :
                        ( ( member @ ( set @ A ) @ X4 @ A5 )
                       => ( member @ A @ ( F3 @ X4 ) @ X4 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A5 ) ) ) ) ).

% Sup_Inf_le
thf(fact_6530_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A5: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A5 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A5 ) )
                    & ! [X4: set @ A] :
                        ( ( member @ ( set @ A ) @ X4 @ A5 )
                       => ( member @ A @ ( F3 @ X4 ) @ X4 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_6531_mono__compose,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ C ) )
     => ! [Q: A > B > C,F2: D > B] :
          ( ( order_mono @ A @ ( B > C ) @ Q )
         => ( order_mono @ A @ ( D > C )
            @ ^ [I4: A,X4: D] : ( Q @ I4 @ ( F2 @ X4 ) ) ) ) ) ).

% mono_compose
thf(fact_6532_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ( Y
                  = ( Xa2
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( Y
                    = ( ( Deg2 = Xa2 )
                      & ! [X4: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X4 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X6 )
                          & ! [X4: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X6 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X4: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X4 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X6: nat] : ( vEBT_V8194947554948674370ptions @ X4 @ X6 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X4: nat] :
                                      ( ( ord_less @ nat @ X4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X4 )
                                       => ( ( ord_less @ nat @ Mi3 @ X4 )
                                          & ( ord_less_eq @ nat @ X4 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_6533_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A5: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A5 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A5 ) )
                    & ! [X4: set @ A] :
                        ( ( member @ ( set @ A ) @ X4 @ A5 )
                       => ( member @ A @ ( F3 @ X4 ) @ X4 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_6534_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = N )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N )
                  & ? [Xys: list @ A,X4: A,Y4: A,Xs6: list @ A,Ys6: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X4 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y4 @ Ys6 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y4 ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_6535_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_6536_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),N2: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexn @ A @ R @ N2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N2 )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N2 ) ) ) ).

% lexn_length
thf(fact_6537_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_6538_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X4: A,Y4: A] :
                  ( ( ord_less @ nat @ ( F3 @ X4 ) @ ( F3 @ Y4 ) )
                  | ( ( ord_less_eq @ nat @ ( F3 @ X4 ) @ ( F3 @ Y4 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ Y4 ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_6539_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X4: list @ A,Y4: list @ A] :
                ? [A3: A,V5: list @ A] :
                  ( ( Y4
                    = ( append @ A @ X4 @ ( cons @ A @ A3 @ V5 ) ) )
                  | ? [U2: list @ A,B3: A,C4: A,W3: list @ A,Z5: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C4 ) @ R5 )
                      & ( X4
                        = ( append @ A @ U2 @ ( cons @ A @ B3 @ W3 ) ) )
                      & ( Y4
                        = ( append @ A @ U2 @ ( cons @ A @ C4 @ Z5 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_6540_lexord__cons__cons,axiom,
    ! [A: $tType,A2: A,X: list @ A,B2: A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A2 @ X ) @ ( cons @ A @ B2 @ Y ) ) @ ( lexord @ A @ R ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
        | ( ( A2 = B2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_6541_lexord__Nil__left,axiom,
    ! [A: $tType,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y ) @ ( lexord @ A @ R ) )
      = ( ? [A3: A,X4: list @ A] :
            ( Y
            = ( cons @ A @ A3 @ X4 ) ) ) ) ).

% lexord_Nil_left
thf(fact_6542_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_6543_lexord__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R ) ) ) ).

% lexord_irreflexive
thf(fact_6544_lexord__linear,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: list @ A,Y: list @ A] :
      ( ! [A4: A,B4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B4 ) @ R )
          | ( A4 = B4 )
          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A4 ) @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) )
        | ( X = Y )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ X ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_linear
thf(fact_6545_lexord__Nil__right,axiom,
    ! [A: $tType,X: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) @ ( lexord @ A @ R ) ) ).

% lexord_Nil_right
thf(fact_6546_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V2: list @ A,R: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_leftI
thf(fact_6547_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A ),Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A,Y2: A,Z3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z3 ) @ R )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Z3 ) @ R ) ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R ) )
       => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_6548_lexord__append__leftD,axiom,
    ! [A: $tType,X: list @ A,U: list @ A,V2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R ) )
     => ( ! [A4: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A4 ) @ R )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_append_leftD
thf(fact_6549_lexord__append__rightI,axiom,
    ! [A: $tType,Y: list @ A,X: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ? [B10: A,Z4: list @ A] :
          ( Y
          = ( cons @ A @ B10 @ Z4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( append @ A @ X @ Y ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_rightI
thf(fact_6550_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs: list @ A,Ys: list @ A,Qs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R ) )
     => ( ( Xs != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_6551_lexord__lex,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lex @ A @ R ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) )
        & ( ( size_size @ ( list @ A ) @ X )
          = ( size_size @ ( list @ A ) @ Y ) ) ) ) ).

% lexord_lex
thf(fact_6552_lexord__irrefl,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R3 )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R3 ) ) ) ).

% lexord_irrefl
thf(fact_6553_lexord__append__left__rightI,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),U: list @ A,X: list @ A,Y: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A2 @ X ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y ) ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_left_rightI
thf(fact_6554_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R ) )
      = ( ? [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X4 @ X4 ) @ R ) )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_6555_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W2: list @ A,R: set @ ( product_prod @ A @ A ),V2: list @ A,Z: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W2 ) @ ( lexord @ A @ R ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W2 ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V2 ) @ ( append @ A @ W2 @ Z ) ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_sufI
thf(fact_6556_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_6557_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R3 ) ) ) ) ).

% mlex_leq
thf(fact_6558_mlex__iff,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R3 ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R3 ) ) ) ) ).

% mlex_iff
thf(fact_6559_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R3 ) ) ) ).

% mlex_less
thf(fact_6560_in__measure,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ).

% in_measure
thf(fact_6561_relpow__finite__bounded1,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R3 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 )
              @ ( collect @ nat
                @ ^ [N: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
                    & ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_6562_relpow__1,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( one_one @ nat ) @ R3 )
      = R3 ) ).

% relpow_1
thf(fact_6563_finite__relpow,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),N2: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 ) ) ) ) ).

% finite_relpow
thf(fact_6564_relpow__empty,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_6565_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N2: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 ) )
      = ( ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F3 @ N2 )
              = B2 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N2 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F3 @ I4 ) @ ( F3 @ ( suc @ I4 ) ) ) @ R3 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_6566_relpow__finite__bounded,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R3 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 )
            @ ( collect @ nat
              @ ^ [N: nat] : ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_6567_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I4: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I4 @ R6 )
              @ ( collect @ nat
                @ ^ [I4: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I4 )
                    & ( ord_less_eq @ nat @ I4 @ ( suc @ N ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_6568_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R3 )
     => ( ( transitive_trancl @ A @ R3 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 )
            @ ( collect @ nat
              @ ^ [N: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
                  & ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_6569_finite__trancl__ntranl,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R3 )
     => ( ( transitive_trancl @ A @ R3 )
        = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) @ ( one_one @ nat ) ) @ R3 ) ) ) ).

% finite_trancl_ntranl
thf(fact_6570_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% trancl_set_ntrancl
thf(fact_6571_trancl__power,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ R3 ) )
      = ( ? [N: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( member @ ( product_prod @ A @ A ) @ P4 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 ) ) ) ) ) ).

% trancl_power
thf(fact_6572_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R3 )
     => ( ( transitive_rtrancl @ A @ R3 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R3 )
            @ ( collect @ nat
              @ ^ [N: nat] : ( ord_less_eq @ nat @ N @ ( finite_card @ ( product_prod @ A @ A ) @ R3 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_6573_set__nths,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs @ I6 ) )
      = ( collect @ A
        @ ^ [Uu3: A] :
          ? [I4: nat] :
            ( ( Uu3
              = ( nth @ A @ Xs @ I4 ) )
            & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( member @ nat @ I4 @ I6 ) ) ) ) ).

% set_nths
thf(fact_6574_nths__nil,axiom,
    ! [A: $tType,A5: set @ nat] :
      ( ( nths @ A @ ( nil @ A ) @ A5 )
      = ( nil @ A ) ) ).

% nths_nil
thf(fact_6575_nths__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( nths @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_6576_nths__singleton,axiom,
    ! [A: $tType,A5: set @ nat,X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A5 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A5 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A5 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A5 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_6577_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_6578_in__set__nthsD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I6: set @ nat] :
      ( ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_nthsD
thf(fact_6579_notin__set__nthsI,axiom,
    ! [A: $tType,X: A,Xs: list @ A,I6: set @ nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) ) ) ).

% notin_set_nthsI
thf(fact_6580_distinct__nthsI,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( nths @ A @ Xs @ I6 ) ) ) ).

% distinct_nthsI
thf(fact_6581_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X: A,Y: A,R: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_6582_set__nths__subset,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs @ I6 ) ) @ ( set2 @ A @ Xs ) ) ).

% set_nths_subset
thf(fact_6583_nths__all,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( member @ nat @ I3 @ I6 ) )
     => ( ( nths @ A @ Xs @ I6 )
        = Xs ) ) ).

% nths_all
thf(fact_6584_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_6585_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( ( size_size @ ( list @ A ) @ X )
        = ( size_size @ ( list @ A ) @ Y ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_6586_nths__append,axiom,
    ! [A: $tType,L: list @ A,L3: list @ A,A5: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L @ L3 ) @ A5 )
      = ( append @ A @ ( nths @ A @ L @ A5 )
        @ ( nths @ A @ L3
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( plus_plus @ nat @ J3 @ ( size_size @ ( list @ A ) @ L ) ) @ A5 ) ) ) ) ) ).

% nths_append
thf(fact_6587_length__nths,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs @ I6 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( member @ nat @ I4 @ I6 ) ) ) ) ) ).

% length_nths
thf(fact_6588_nths__Cons,axiom,
    ! [A: $tType,X: A,L: list @ A,A5: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L ) @ A5 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A5 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( suc @ J3 ) @ A5 ) ) ) ) ) ).

% nths_Cons
thf(fact_6589_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,N: nat] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( semiring_1_of_nat @ real @ N ) ) )
          & ( N
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_6590_take__bit__numeral__minus__numeral__int,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M2 ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M2 ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M2 ) @ N2 ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_6591_Rats__abs__iff,axiom,
    ! [X: real] :
      ( ( member @ real @ ( abs_abs @ real @ X ) @ ( field_char_0_Rats @ real ) )
      = ( member @ real @ X @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_6592_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: num,N2: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M2 ) @ N2 ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_6593_Rats__number__of,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W2: num] : ( member @ A @ ( numeral_numeral @ A @ W2 ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_number_of
thf(fact_6594_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_6595_Rats__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_divide
thf(fact_6596_Rats__dense__in__real,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ? [X3: real] :
          ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X @ X3 )
          & ( ord_less @ real @ X3 @ Y ) ) ) ).

% Rats_dense_in_real
thf(fact_6597_Rats__no__bot__less,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X3 @ X ) ) ).

% Rats_no_bot_less
thf(fact_6598_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_6599_Rats__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_1
thf(fact_6600_Rats__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_add
thf(fact_6601_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X @ X3 ) ) ).

% Rats_no_top_le
thf(fact_6602_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( ring_1_Ints @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Ints_subset_Rats
thf(fact_6603_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,J3: int] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( ring_1_of_int @ real @ J3 ) ) )
          & ( J3
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_6604_and__minus__numerals_I7_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_6605_and__minus__numerals_I3_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_6606_and__minus__numerals_I4_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_6607_and__minus__numerals_I8_J,axiom,
    ! [N2: num,M2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_6608_int__numeral__not__and__num,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M2 ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N2 @ M2 ) ) ) ).

% int_numeral_not_and_num
thf(fact_6609_int__numeral__and__not__num,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M2 @ N2 ) ) ) ).

% int_numeral_and_not_num
thf(fact_6610_comp__fun__idem__on_Ocomp__comp__fun__idem__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F2: A > B > B,G2: C > A,R3: set @ C] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G2 @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite673082921795544331dem_on @ C @ B @ R3 @ ( comp @ A @ ( B > B ) @ C @ F2 @ G2 ) ) ) ) ).

% comp_fun_idem_on.comp_comp_fun_idem_on
thf(fact_6611_take__bit__num__simps_I7_J,axiom,
    ! [R: num,M2: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit1 @ M2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M2 ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_6612_take__bit__num__simps_I2_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_6613_take__bit__num__simps_I5_J,axiom,
    ! [R: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_6614_take__bit__num__simps_I4_J,axiom,
    ! [N2: nat,M2: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit1 @ M2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N2 @ M2 ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_6615_and__not__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_6616_and__not__num_Osimps_I4_J,axiom,
    ! [M2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M2 ) @ one2 )
      = ( some @ num @ ( bit0 @ M2 ) ) ) ).

% and_not_num.simps(4)
thf(fact_6617_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: num,Q2: num] :
          ( ( ( bit_take_bit_num @ M2 @ N2 )
            = ( some @ num @ Q2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_6618_and__not__num_Osimps_I7_J,axiom,
    ! [M2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M2 ) @ one2 )
      = ( some @ num @ ( bit0 @ M2 ) ) ) ).

% and_not_num.simps(7)
thf(fact_6619_and__not__num__eq__Some__iff,axiom,
    ! [M2: num,N2: num,Q2: num] :
      ( ( ( bit_and_not_num @ M2 @ N2 )
        = ( some @ num @ Q2 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( numeral_numeral @ int @ Q2 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_6620_and__not__num_Osimps_I8_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_and_not_num @ M2 @ N2 ) ) ) ).

% and_not_num.simps(8)
thf(fact_6621_take__bit__num__simps_I6_J,axiom,
    ! [R: num,M2: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit0 @ M2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M2 ) ) ) ).

% take_bit_num_simps(6)
thf(fact_6622_xor__num_Osimps_I6_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M2 @ N2 ) ) ) ) ).

% xor_num.simps(6)
thf(fact_6623_take__bit__num__simps_I1_J,axiom,
    ! [M2: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M2 )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_6624_take__bit__num__simps_I3_J,axiom,
    ! [N2: nat,M2: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit0 @ M2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N2 @ M2 ) ) ) ).

% take_bit_num_simps(3)
thf(fact_6625_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_6626_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M2 @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_6627_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_6628_and__not__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N2 ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_6629_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N2: nat,M2: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit0 @ M2 ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
            @ ( bit_take_bit_num @ N @ M2 ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_6630_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ N2 @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] : ( some @ num @ one2 )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_6631_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: num,Q2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M2 @ N2 )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_6632_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: num] :
          ( ( ( bit_take_bit_num @ M2 @ N2 )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_6633_xor__num_Osimps_I7_J,axiom,
    ! [M2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M2 ) @ one2 )
      = ( some @ num @ ( bit0 @ M2 ) ) ) ).

% xor_num.simps(7)
thf(fact_6634_xor__num_Osimps_I4_J,axiom,
    ! [M2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M2 ) @ one2 )
      = ( some @ num @ ( bit1 @ M2 ) ) ) ).

% xor_num.simps(4)
thf(fact_6635_xor__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ ( bit0 @ N2 ) ) ) ).

% xor_num.simps(3)
thf(fact_6636_xor__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ ( bit1 @ N2 ) ) ) ).

% xor_num.simps(2)
thf(fact_6637_and__not__num__eq__None__iff,axiom,
    ! [M2: num,N2: num] :
      ( ( ( bit_and_not_num @ M2 @ N2 )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M2 ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_6638_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M2 @ N2 ) ) ) ) ).

% numeral_xor_num
thf(fact_6639_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N2: nat,M2: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit1 @ M2 ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M2 ) ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_6640_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N: nat,M: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( numeral_numeral @ nat @ M ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ ( numeral_numeral @ nat @ M ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_6641_xor__num_Osimps_I8_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M2 @ N2 ) ) ) ) ).

% xor_num.simps(8)
thf(fact_6642_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N: nat,M: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A3: nat,X4: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P6: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
                      @ ( bit_take_bit_num @ O @ P6 ) )
                  @ ^ [P6: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P6 ) ) )
                  @ X4 )
              @ A3 )
          @ ( product_Pair @ nat @ num @ N @ M ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_6643_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_6644_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X22: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 ) ) ).

% verit_eq_simplify(17)
thf(fact_6645_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_6646_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F32: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F32 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X4: num] : ( H2 @ ( F22 @ X4 ) )
        @ ^ [X4: num] : ( H2 @ ( F32 @ X4 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_6647_and__not__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa2
                  = ( bit0 @ N3 ) )
             => ( Y
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa2
                    = ( bit1 @ N3 ) )
               => ( Y
                 != ( none @ num ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y
                     != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                  @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_6648_xor__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ! [N3: num] :
                ( ( Xa2
                  = ( bit0 @ N3 ) )
               => ( Y
                 != ( some @ num @ ( bit1 @ N3 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit1 @ N3 ) )
                 => ( Y
                   != ( some @ num @ ( bit0 @ N3 ) ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y
                     != ( some @ num @ ( bit1 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_6649_and__not__num_Osimps_I5_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M2 @ N2 ) ) ) ).

% and_not_num.simps(5)
thf(fact_6650_xor__num_Osimps_I5_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M2 @ N2 ) ) ) ).

% xor_num.simps(5)
thf(fact_6651_and__not__num_Osimps_I9_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M2 @ N2 ) ) ) ).

% and_not_num.simps(9)
thf(fact_6652_and__not__num_Osimps_I6_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M2 @ N2 ) ) ) ).

% and_not_num.simps(6)
thf(fact_6653_xor__num_Osimps_I9_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M2 @ N2 ) ) ) ).

% xor_num.simps(9)
thf(fact_6654_and__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa2 )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa2
                  = ( bit0 @ N3 ) )
             => ( Y
               != ( none @ num ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa2
                    = ( bit1 @ N3 ) )
               => ( Y
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M4: num] :
                    ( X
                    = ( bit0 @ M4 ) )
               => ( ( Xa2 = one2 )
                 => ( Y
                   != ( none @ num ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                 => ( ( ? [M4: num] :
                          ( X
                          = ( bit1 @ M4 ) )
                     => ( ( Xa2 = one2 )
                       => ( Y
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_6655_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( positive @ ( fract @ A2 @ B2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ A2 @ B2 ) ) ) ).

% positive_rat
thf(fact_6656_Rat_Opositive__mult,axiom,
    ! [X: rat,Y: rat] :
      ( ( positive @ X )
     => ( ( positive @ Y )
       => ( positive @ ( times_times @ rat @ X @ Y ) ) ) ) ).

% Rat.positive_mult
thf(fact_6657_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_6658_and__num_Osimps_I5_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M2 ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M2 @ N2 ) ) ) ).

% and_num.simps(5)
thf(fact_6659_and__num_Osimps_I7_J,axiom,
    ! [M2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M2 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_6660_and__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_6661_and__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N2 ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_6662_and__num_Osimps_I4_J,axiom,
    ! [M2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M2 ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_6663_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: num,Q2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M2 @ N2 )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_6664_and__num_Osimps_I6_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M2 ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M2 @ N2 ) ) ) ).

% and_num.simps(6)
thf(fact_6665_and__num_Osimps_I8_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M2 ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M2 @ N2 ) ) ) ).

% and_num.simps(8)
thf(fact_6666_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M2 @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_6667_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M2: num,N2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M2 ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M2 @ N2 ) ) ) ) ).

% numeral_and_num
thf(fact_6668_and__num_Osimps_I9_J,axiom,
    ! [M2: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M2 ) @ ( bit1 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_un7362597486090784418nd_num @ M2 @ N2 ) ) ) ).

% and_num.simps(9)
thf(fact_6669_Rat_Opositive_Orep__eq,axiom,
    ( positive
    = ( ^ [X4: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ ( rep_Rat @ X4 ) ) @ ( product_snd @ int @ int @ ( rep_Rat @ X4 ) ) ) ) ) ) ).

% Rat.positive.rep_eq
thf(fact_6670_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_6671_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs ) ) ) ) ).

% nth_image
thf(fact_6672_dual__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( min @ A
          @ ^ [X4: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X4 ) )
        = ( ord_max @ A ) ) ) ).

% dual_min
thf(fact_6673_take__Suc__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ ( suc @ N2 ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ N2 @ Xs ) ) ) ).

% take_Suc_Cons
thf(fact_6674_take__eq__Nil2,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N2 @ Xs ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_6675_take__eq__Nil,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( take @ A @ N2 @ Xs )
        = ( nil @ A ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_6676_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs3: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_6677_take__all__iff,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( take @ A @ N2 @ Xs )
        = Xs )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% take_all_iff
thf(fact_6678_take__all,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 )
     => ( ( take @ A @ N2 @ Xs )
        = Xs ) ) ).

% take_all
thf(fact_6679_nth__take,axiom,
    ! [A: $tType,I2: nat,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ N2 )
     => ( ( nth @ A @ ( take @ A @ N2 @ Xs ) @ I2 )
        = ( nth @ A @ Xs @ I2 ) ) ) ).

% nth_take
thf(fact_6680_take__update__cancel,axiom,
    ! [A: $tType,N2: nat,M2: nat,Xs: list @ A,Y: A] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ( take @ A @ N2 @ ( list_update @ A @ Xs @ M2 @ Y ) )
        = ( take @ A @ N2 @ Xs ) ) ) ).

% take_update_cancel
thf(fact_6681_nths__upt__eq__take,axiom,
    ! [A: $tType,L: list @ A,N2: nat] :
      ( ( nths @ A @ L @ ( set_ord_lessThan @ nat @ N2 ) )
      = ( take @ A @ N2 @ L ) ) ).

% nths_upt_eq_take
thf(fact_6682_take__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( take @ A @ N2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( take @ A @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% take_append
thf(fact_6683_take__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% take_Cons_numeral
thf(fact_6684_take__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( take @ A @ N2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% take_Nil
thf(fact_6685_take__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs )
      = ( nil @ A ) ) ).

% take_0
thf(fact_6686_take__update__swap,axiom,
    ! [A: $tType,M2: nat,Xs: list @ A,N2: nat,X: A] :
      ( ( take @ A @ M2 @ ( list_update @ A @ Xs @ N2 @ X ) )
      = ( list_update @ A @ ( take @ A @ M2 @ Xs ) @ N2 @ X ) ) ).

% take_update_swap
thf(fact_6687_take__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ! [I3: nat] :
          ( ( take @ A @ I3 @ Xs )
          = ( take @ A @ I3 @ Ys ) )
     => ( Xs = Ys ) ) ).

% take_equalityI
thf(fact_6688_ord_Omin_Ocong,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( min @ A ) ) ).

% ord.min.cong
thf(fact_6689_ord_Omin__def,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( ^ [Less_eq2: A > A > $o,A3: A,B3: A] : ( if @ A @ ( Less_eq2 @ A3 @ B3 ) @ A3 @ B3 ) ) ) ).

% ord.min_def
thf(fact_6690_distinct__take,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( take @ A @ I2 @ Xs ) ) ) ).

% distinct_take
thf(fact_6691_in__set__takeD,axiom,
    ! [A: $tType,X: A,N2: nat,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( take @ A @ N2 @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_takeD
thf(fact_6692_set__take__subset,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ N2 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_take_subset
thf(fact_6693_set__take__subset__set__take,axiom,
    ! [A: $tType,M2: nat,N2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M2 @ Xs ) ) @ ( set2 @ A @ ( take @ A @ N2 @ Xs ) ) ) ) ).

% set_take_subset_set_take
thf(fact_6694_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ K )
             => ( ( nth @ A @ Xs @ I3 )
                = ( nth @ A @ Ys @ I3 ) ) )
         => ( ( take @ A @ K @ Xs )
            = ( take @ A @ K @ Ys ) ) ) ) ) ).

% nth_take_lemma
thf(fact_6695_take__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( nil @ A )
        @ ^ [M: nat] : ( cons @ A @ X @ ( take @ A @ M @ Xs ) )
        @ N2 ) ) ).

% take_Cons
thf(fact_6696_take__Cons_H,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs ) ) ) ) ) ).

% take_Cons'
thf(fact_6697_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R ) )
     => ~ ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys ) )
             => ( ( ( take @ A @ I3 @ Xs )
                  = ( take @ A @ I3 @ Ys ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Ys @ I3 ) ) @ R ) ) ) ) ) ).

% lex_take_index
thf(fact_6698_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,Bs: list @ $o] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( take @ $o @ N2 @ Bs ) ) ) ) ).

% take_bit_horner_sum_bit_eq
thf(fact_6699_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ ( suc @ I2 ) @ Xs )
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_6700_nth__repl,axiom,
    ! [A: $tType,M2: nat,Xs: list @ A,N2: nat,X: A] :
      ( ( ord_less @ nat @ M2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( M2 != N2 )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs ) ) ) @ M2 )
            = ( nth @ A @ Xs @ M2 ) ) ) ) ) ).

% nth_repl
thf(fact_6701_pos__n__replace,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( append @ A @ ( cons @ A @ Y @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N2 ) @ Xs ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_6702_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X4: list @ A] : X4 ) ) ).

% drop0
thf(fact_6703_drop__drop,axiom,
    ! [A: $tType,N2: nat,M2: nat,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( drop @ A @ M2 @ Xs ) )
      = ( drop @ A @ ( plus_plus @ nat @ N2 @ M2 ) @ Xs ) ) ).

% drop_drop
thf(fact_6704_drop__Suc__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N2 ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ N2 @ Xs ) ) ).

% drop_Suc_Cons
thf(fact_6705_length__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( drop @ A @ N2 @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% length_drop
thf(fact_6706_drop__update__cancel,axiom,
    ! [A: $tType,N2: nat,M2: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N2 @ M2 )
     => ( ( drop @ A @ M2 @ ( list_update @ A @ Xs @ N2 @ X ) )
        = ( drop @ A @ M2 @ Xs ) ) ) ).

% drop_update_cancel
thf(fact_6707_append__take__drop__id,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( drop @ A @ N2 @ Xs ) )
      = Xs ) ).

% append_take_drop_id
thf(fact_6708_drop__replicate,axiom,
    ! [A: $tType,I2: nat,K: nat,X: A] :
      ( ( drop @ A @ I2 @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ K @ I2 ) @ X ) ) ).

% drop_replicate
thf(fact_6709_drop__eq__Nil2,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N2 @ Xs ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% drop_eq_Nil2
thf(fact_6710_drop__eq__Nil,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( drop @ A @ N2 @ Xs )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% drop_eq_Nil
thf(fact_6711_drop__all,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 )
     => ( ( drop @ A @ N2 @ Xs )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_6712_drop__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( drop @ A @ N2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( drop @ A @ N2 @ Xs ) @ ( drop @ A @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% drop_append
thf(fact_6713_drop__Cons__numeral,axiom,
    ! [A: $tType,V2: num,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V2 ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V2 ) @ ( one_one @ nat ) ) @ Xs ) ) ).

% drop_Cons_numeral
thf(fact_6714_nth__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,I2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( drop @ A @ N2 @ Xs ) @ I2 )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ N2 @ I2 ) ) ) ) ).

% nth_drop
thf(fact_6715_drop__take,axiom,
    ! [A: $tType,N2: nat,M2: nat,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( take @ A @ M2 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ M2 @ N2 ) @ ( drop @ A @ N2 @ Xs ) ) ) ).

% drop_take
thf(fact_6716_take__drop,axiom,
    ! [A: $tType,N2: nat,M2: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( drop @ A @ M2 @ Xs ) )
      = ( drop @ A @ M2 @ ( take @ A @ ( plus_plus @ nat @ N2 @ M2 ) @ Xs ) ) ) ).

% take_drop
thf(fact_6717_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( nths @ A @ Xs3 @ ( collect @ nat @ ( ord_less_eq @ nat @ N ) ) ) ) ) ).

% drop_eq_nths
thf(fact_6718_set__drop__subset,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ N2 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_drop_subset
thf(fact_6719_in__set__dropD,axiom,
    ! [A: $tType,X: A,N2: nat,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( drop @ A @ N2 @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_dropD
thf(fact_6720_distinct__drop,axiom,
    ! [A: $tType,Xs: list @ A,I2: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( drop @ A @ I2 @ Xs ) ) ) ).

% distinct_drop
thf(fact_6721_nth__via__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( drop @ A @ N2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ( ( nth @ A @ Xs @ N2 )
        = Y ) ) ).

% nth_via_drop
thf(fact_6722_drop__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs )
      = Xs ) ).

% drop_0
thf(fact_6723_drop__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( drop @ A @ N2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% drop_Nil
thf(fact_6724_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N2: nat,M2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N2 @ M2 )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M2 @ Xs ) ) @ ( set2 @ A @ ( drop @ A @ N2 @ Xs ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_6725_append__eq__conv__conj,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Zs )
      = ( ( Xs
          = ( take @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) )
        & ( Ys
          = ( drop @ A @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% append_eq_conv_conj
thf(fact_6726_take__add,axiom,
    ! [A: $tType,I2: nat,J: nat,Xs: list @ A] :
      ( ( take @ A @ ( plus_plus @ nat @ I2 @ J ) @ Xs )
      = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( take @ A @ J @ ( drop @ A @ I2 @ Xs ) ) ) ) ).

% take_add
thf(fact_6727_drop__update__swap,axiom,
    ! [A: $tType,M2: nat,N2: nat,Xs: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( drop @ A @ M2 @ ( list_update @ A @ Xs @ N2 @ X ) )
        = ( list_update @ A @ ( drop @ A @ M2 @ Xs ) @ ( minus_minus @ nat @ N2 @ M2 ) @ X ) ) ) ).

% drop_update_swap
thf(fact_6728_drop__Cons,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( cons @ A @ X @ Xs ) )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ X @ Xs )
        @ ^ [M: nat] : ( drop @ A @ M @ Xs )
        @ N2 ) ) ).

% drop_Cons
thf(fact_6729_nths__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,I6: set @ nat] :
      ( ( nths @ A @ ( drop @ A @ N2 @ Xs ) @ I6 )
      = ( nths @ A @ Xs @ ( image @ nat @ nat @ ( plus_plus @ nat @ N2 ) @ I6 ) ) ) ).

% nths_drop
thf(fact_6730_drop__Cons_H,axiom,
    ! [A: $tType,N2: nat,X: A,Xs: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N2 @ ( cons @ A @ X @ Xs ) )
          = ( drop @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% drop_Cons'
thf(fact_6731_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_6732_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs ) )
        = ( drop @ A @ I2 @ Xs ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_6733_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I2: nat,J: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I2 @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_6734_id__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( Xs
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I2 ) @ ( drop @ A @ ( suc @ I2 ) @ Xs ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_6735_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A,A2: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ Xs @ I2 @ A2 )
        = ( append @ A @ ( take @ A @ I2 @ Xs ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I2 ) @ Xs ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_6736_take__hd__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( append @ A @ ( take @ A @ N2 @ Xs ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N2 @ Xs ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N2 ) @ Xs ) ) ) ).

% take_hd_drop
thf(fact_6737_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X ) @ Y )
            = X ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) ) )
            & ( ( take @ A @ I4 @ X )
              = ( take @ A @ I4 @ Y ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X @ I4 ) @ ( nth @ A @ Y @ I4 ) ) @ R ) ) ) ) ).

% lexord_take_index_conv
thf(fact_6738_min_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 )
          = ( ord_min @ A @ A2 @ B2 ) ) ) ).

% min.right_idem
thf(fact_6739_min_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_min @ A @ A2 @ ( ord_min @ A @ A2 @ B2 ) )
          = ( ord_min @ A @ A2 @ B2 ) ) ) ).

% min.left_idem
thf(fact_6740_min_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A] :
          ( ( ord_min @ A @ A2 @ A2 )
          = A2 ) ) ).

% min.idem
thf(fact_6741_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_6742_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_6743_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_6744_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_6745_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_6746_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ ( ord_min @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z @ X )
            & ( ord_less @ A @ Z @ Y ) ) ) ) ).

% min_less_iff_conj
thf(fact_6747_min__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% min_top
thf(fact_6748_min__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% min_top2
thf(fact_6749_min__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% min_bot2
thf(fact_6750_min__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% min_bot
thf(fact_6751_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( ord_max @ A @ Y @ ( ord_min @ A @ X @ Y ) )
          = Y ) ) ).

% max_min_same(4)
thf(fact_6752_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ Y )
          = Y ) ) ).

% max_min_same(3)
thf(fact_6753_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ X )
          = X ) ) ).

% max_min_same(2)
thf(fact_6754_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ X @ ( ord_min @ A @ X @ Y ) )
          = X ) ) ).

% max_min_same(1)
thf(fact_6755_min__Suc__Suc,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_min @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_min @ nat @ M2 @ N2 ) ) ) ).

% min_Suc_Suc
thf(fact_6756_min__0R,axiom,
    ! [N2: nat] :
      ( ( ord_min @ nat @ N2 @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_6757_min__0L,axiom,
    ! [N2: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_6758_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M2 @ N2 ) @ A2 ) ) ) ).

% take_bit_take_bit
thf(fact_6759_take__take,axiom,
    ! [A: $tType,N2: nat,M2: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( take @ A @ M2 @ Xs ) )
      = ( take @ A @ ( ord_min @ nat @ N2 @ M2 ) @ Xs ) ) ).

% take_take
thf(fact_6760_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% hd_remdups_adj
thf(fact_6761_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M2 @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M2 @ N2 ) @ A2 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_6762_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% min_number_of(1)
thf(fact_6763_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_6764_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_6765_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_6766_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_6767_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_6768_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_6769_hd__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_append2
thf(fact_6770_hd__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N2 @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_6771_length__take,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( take @ A @ N2 @ Xs ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% length_take
thf(fact_6772_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M2 @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M2 @ N2 ) ) ) ) ).

% take_bit_of_mask
thf(fact_6773_take__replicate,axiom,
    ! [A: $tType,I2: nat,K: nat,X: A] :
      ( ( take @ A @ I2 @ ( replicate @ A @ K @ X ) )
      = ( replicate @ A @ ( ord_min @ nat @ I2 @ K ) @ X ) ) ).

% take_replicate
thf(fact_6774_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_6775_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V2 ) )
              = ( numeral_numeral @ A @ V2 ) ) ) ) ) ).

% min_number_of(3)
thf(fact_6776_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V2: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V2 ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_6777_Int__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastAtMost
thf(fact_6778_Int__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastLessThan
thf(fact_6779_hd__take,axiom,
    ! [A: $tType,J: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J )
     => ( ( hd @ A @ ( take @ A @ J @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_take
thf(fact_6780_Int__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( set_or5935395276787703475ssThan @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_greaterThanLessThan
thf(fact_6781_Int__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_greaterThanAtMost
thf(fact_6782_min__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N2 @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_6783_min__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N2 ) ) ) ).

% min_numeral_Suc
thf(fact_6784_max__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_min @ A @ X @ Y ) ) ) ) ) ).

% max_of_antimono
thf(fact_6785_min__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_max @ A @ X @ Y ) ) ) ) ) ).

% min_of_antimono
thf(fact_6786_hd__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Xs ) ) ) ) ).

% hd_append
thf(fact_6787_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
    ? [Ps: list @ A,Xs4: list @ A,Ys5: list @ A] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs4 ) )
      & ( Ys
        = ( append @ A @ Ps @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) ).

% longest_common_prefix
thf(fact_6788_hd__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( Xs
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_concat
thf(fact_6789_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X @ Y ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_min
thf(fact_6790_nat__mult__min__right,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ M2 @ ( ord_min @ nat @ N2 @ Q2 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M2 @ N2 ) @ ( times_times @ nat @ M2 @ Q2 ) ) ) ).

% nat_mult_min_right
thf(fact_6791_nat__mult__min__left,axiom,
    ! [M2: nat,N2: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M2 @ N2 ) @ Q2 )
      = ( ord_min @ nat @ ( times_times @ nat @ M2 @ Q2 ) @ ( times_times @ nat @ N2 @ Q2 ) ) ) ).

% nat_mult_min_left
thf(fact_6792_min__diff,axiom,
    ! [M2: nat,I2: nat,N2: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M2 @ I2 ) @ ( minus_minus @ nat @ N2 @ I2 ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M2 @ N2 ) @ I2 ) ) ).

% min_diff
thf(fact_6793_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ( ord_less @ A @ X @ Z )
            | ( ord_less @ A @ Y @ Z ) ) ) ) ).

% min_less_iff_disj
thf(fact_6794_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_6795_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( ord_min @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_6796_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_6797_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_6798_min_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_min @ A @ B2 @ ( ord_min @ A @ A2 @ C2 ) )
          = ( ord_min @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.left_commute
thf(fact_6799_min_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( ord_min @ A @ B3 @ A3 ) ) ) ) ).

% min.commute
thf(fact_6800_min_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 )
          = ( ord_min @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.assoc
thf(fact_6801_max__min__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ B2 @ C2 ) @ A2 )
          = ( ord_min @ A @ ( ord_max @ A @ B2 @ A2 ) @ ( ord_max @ A @ C2 @ A2 ) ) ) ) ).

% max_min_distrib1
thf(fact_6802_max__min__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_max @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ord_min @ A @ ( ord_max @ A @ A2 @ B2 ) @ ( ord_max @ A @ A2 @ C2 ) ) ) ) ).

% max_min_distrib2
thf(fact_6803_min__max__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_min @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ord_max @ A @ ( ord_min @ A @ B2 @ A2 ) @ ( ord_min @ A @ C2 @ A2 ) ) ) ) ).

% min_max_distrib1
thf(fact_6804_min__max__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_min @ A @ A2 @ ( ord_max @ A @ B2 @ C2 ) )
          = ( ord_max @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ A2 @ C2 ) ) ) ) ).

% min_max_distrib2
thf(fact_6805_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y @ Z ) ) ) ) ).

% min_add_distrib_left
thf(fact_6806_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y @ Z ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% min_add_distrib_right
thf(fact_6807_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_6808_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_6809_list_Osel_I1_J,axiom,
    ! [A: $tType,X212: A,X223: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X212 @ X223 ) )
      = X212 ) ).

% list.sel(1)
thf(fact_6810_concat__bit__assoc__sym,axiom,
    ! [M2: nat,N2: nat,K: int,L: int,R: int] :
      ( ( bit_concat_bit @ M2 @ ( bit_concat_bit @ N2 @ K @ L ) @ R )
      = ( bit_concat_bit @ ( ord_min @ nat @ M2 @ N2 ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M2 @ N2 ) @ L @ R ) ) ) ).

% concat_bit_assoc_sym
thf(fact_6811_inf__min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% inf_min
thf(fact_6812_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_6813_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( A2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ A2 ) @ ( set2 @ A @ A2 ) ) ) ).

% list.set_sel(1)
thf(fact_6814_hd__in__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) ).

% hd_in_set
thf(fact_6815_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ A3 @ B3 ) ) ) ) ).

% min_def_raw
thf(fact_6816_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ A3 @ B3 ) ) ) ) ).

% min_def
thf(fact_6817_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_6818_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_6819_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_6820_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_6821_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_6822_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( A3
              = ( ord_min @ A @ A3 @ B3 ) ) ) ) ) ).

% min.order_iff
thf(fact_6823_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_6824_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_6825_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_min @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% min.absorb_iff1
thf(fact_6826_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_min @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% min.absorb_iff2
thf(fact_6827_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_6828_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_6829_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            | ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% min_le_iff_disj
thf(fact_6830_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_min @ A @ X @ Y )
            = X ) ) ) ).

% min_absorb1
thf(fact_6831_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_min @ A @ X @ Y )
            = Y ) ) ) ).

% min_absorb2
thf(fact_6832_min__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M2: A,N2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ M2 ) @ ( F2 @ N2 ) )
            = ( F2 @ ( ord_min @ A @ M2 @ N2 ) ) ) ) ) ).

% min_of_mono
thf(fact_6833_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_6834_take__bit__concat__bit__eq,axiom,
    ! [M2: nat,N2: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M2 @ ( bit_concat_bit @ N2 @ K @ L ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M2 @ N2 ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M2 @ N2 ) @ L ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_6835_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_6836_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P4 ) @ ( times_times @ A @ Y @ P4 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_6837_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_6838_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( times_times @ A @ P4 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P4 @ X ) @ ( times_times @ A @ P4 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_6839_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_6840_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P4: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P4 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P4 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P4 ) @ ( divide_divide @ A @ Y @ P4 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_6841_min__Suc2,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_min @ nat @ M2 @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ M5 @ N2 ) )
        @ M2 ) ) ).

% min_Suc2
thf(fact_6842_min__Suc1,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_min @ nat @ ( suc @ N2 ) @ M2 )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ N2 @ M5 ) )
        @ M2 ) ) ).

% min_Suc1
thf(fact_6843_hd__drop__conv__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( drop @ A @ N2 @ Xs ) )
        = ( nth @ A @ Xs @ N2 ) ) ) ).

% hd_drop_conv_nth
thf(fact_6844_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M2: nat,N2: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M2 @ N2 ) ) ) ) ) ).

% mod_exp_eq
thf(fact_6845_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_6846_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat,M2: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M2 @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_6847_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu3: product_prod @ A @ B] :
          ? [I4: nat] :
            ( ( Uu3
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I4 ) @ ( nth @ B @ Ys @ I4 ) ) )
            & ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% set_zip
thf(fact_6848_rotate__drop__take,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( append @ A @ ( drop @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) @ ( take @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ) ).

% rotate_drop_take
thf(fact_6849_min__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_6850_min__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_6851_rotate__is__Nil__conv,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( rotate @ A @ N2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate_is_Nil_conv
thf(fact_6852_set__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate @ A @ N2 @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate
thf(fact_6853_length__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate @ A @ N2 @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate
thf(fact_6854_distinct__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate @ A @ N2 @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rotate
thf(fact_6855_zip__Nil,axiom,
    ! [B: $tType,A: $tType,Ys: list @ B] :
      ( ( zip @ A @ B @ ( nil @ A ) @ Ys )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip_Nil
thf(fact_6856_Nil__eq__zip__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( nil @ ( product_prod @ A @ B ) )
        = ( zip @ A @ B @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% Nil_eq_zip_iff
thf(fact_6857_zip__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( zip @ A @ B @ Xs @ Ys )
        = ( nil @ ( product_prod @ A @ B ) ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% zip_eq_Nil_iff
thf(fact_6858_rotate__Suc,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( rotate @ A @ ( suc @ N2 ) @ Xs )
      = ( rotate1 @ A @ ( rotate @ A @ N2 @ Xs ) ) ) ).

% rotate_Suc
thf(fact_6859_rotate__length01,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N2 @ Xs )
        = Xs ) ) ).

% rotate_length01
thf(fact_6860_rotate__id,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N2 @ Xs )
        = Xs ) ) ).

% rotate_id
thf(fact_6861_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I2: nat,X: A,J: nat,Y: B] :
      ( ( zip @ A @ B @ ( replicate @ A @ I2 @ X ) @ ( replicate @ B @ J @ Y ) )
      = ( replicate @ ( product_prod @ A @ B ) @ ( ord_min @ nat @ I2 @ J ) @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_replicate
thf(fact_6862_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_Cons_Cons
thf(fact_6863_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Us: list @ B,Ys: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Us ) @ ( zip @ A @ B @ Ys @ Vs ) ) ) ) ).

% zip_append
thf(fact_6864_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_zip
thf(fact_6865_nth__zip,axiom,
    ! [A: $tType,B: $tType,I2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I2 ) @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ).

% nth_zip
thf(fact_6866_distinct__zipI1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% distinct_zipI1
thf(fact_6867_distinct__zipI2,axiom,
    ! [B: $tType,A: $tType,Ys: list @ A,Xs: list @ B] :
      ( ( distinct @ A @ Ys )
     => ( distinct @ ( product_prod @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys ) ) ) ).

% distinct_zipI2
thf(fact_6868_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I2: nat,X: A,Ys: list @ B,Y: B] :
      ( ( zip @ A @ B @ ( list_update @ A @ Xs @ I2 @ X ) @ ( list_update @ B @ Ys @ I2 @ Y ) )
      = ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 @ ( product_Pair @ A @ B @ X @ Y ) ) ) ).

% zip_update
thf(fact_6869_rotate1__rotate__swap,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( rotate1 @ A @ ( rotate @ A @ N2 @ Xs ) )
      = ( rotate @ A @ N2 @ ( rotate1 @ A @ Xs ) ) ) ).

% rotate1_rotate_swap
thf(fact_6870_rotate__rotate,axiom,
    ! [A: $tType,M2: nat,N2: nat,Xs: list @ A] :
      ( ( rotate @ A @ M2 @ ( rotate @ A @ N2 @ Xs ) )
      = ( rotate @ A @ ( plus_plus @ nat @ M2 @ N2 ) @ Xs ) ) ).

% rotate_rotate
thf(fact_6871_zip_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A] :
      ( ( zip @ A @ B @ Xs @ ( nil @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip.simps(1)
thf(fact_6872_rotate__def,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat] : ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N @ ( rotate1 @ A ) ) ) ) ).

% rotate_def
thf(fact_6873_drop__zip,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( drop @ ( product_prod @ A @ B ) @ N2 @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( drop @ A @ N2 @ Xs ) @ ( drop @ B @ N2 @ Ys ) ) ) ).

% drop_zip
thf(fact_6874_take__zip,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( take @ ( product_prod @ A @ B ) @ N2 @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( zip @ A @ B @ ( take @ A @ N2 @ Xs ) @ ( take @ B @ N2 @ Ys ) ) ) ).

% take_zip
thf(fact_6875_rotate__append,axiom,
    ! [A: $tType,L: list @ A,Q2: list @ A] :
      ( ( rotate @ A @ ( size_size @ ( list @ A ) @ L ) @ ( append @ A @ L @ Q2 ) )
      = ( append @ A @ Q2 @ L ) ) ).

% rotate_append
thf(fact_6876_rotate__conv__mod,axiom,
    ! [A: $tType] :
      ( ( rotate @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( rotate @ A @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) @ Xs3 ) ) ) ).

% rotate_conv_mod
thf(fact_6877_hd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ( hd @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
          = ( product_Pair @ A @ B @ ( hd @ A @ Xs ) @ ( hd @ B @ Ys ) ) ) ) ) ).

% hd_zip
thf(fact_6878_zip__same,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs @ Xs ) ) )
      = ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
        & ( A2 = B2 ) ) ) ).

% zip_same
thf(fact_6879_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ~ ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ~ ( member @ B @ Y @ ( set2 @ B @ Ys ) ) ) ) ).

% in_set_zipE
thf(fact_6880_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_zip_leftD
thf(fact_6881_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ B @ Y @ ( set2 @ B @ Ys ) ) ) ).

% set_zip_rightD
thf(fact_6882_update__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,I2: nat,Xy: product_prod @ A @ B] :
      ( ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) @ I2 @ Xy )
      = ( zip @ A @ B @ ( list_update @ A @ Xs @ I2 @ ( product_fst @ A @ B @ Xy ) ) @ ( list_update @ B @ Ys @ I2 @ ( product_snd @ A @ B @ Xy ) ) ) ) ).

% update_zip
thf(fact_6883_zip__obtain__same__length,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P: ( list @ ( product_prod @ A @ B ) ) > $o] :
      ( ! [Zs2: list @ A,Ws2: list @ B,N3: nat] :
          ( ( ( size_size @ ( list @ A ) @ Zs2 )
            = ( size_size @ ( list @ B ) @ Ws2 ) )
         => ( ( N3
              = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
           => ( ( Zs2
                = ( take @ A @ N3 @ Xs ) )
             => ( ( Ws2
                  = ( take @ B @ N3 @ Ys ) )
               => ( P @ ( zip @ A @ B @ Zs2 @ Ws2 ) ) ) ) ) )
     => ( P @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_obtain_same_length
thf(fact_6884_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Xy: product_prod @ A @ B,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( zip @ A @ B @ Xs @ Ys )
        = ( cons @ ( product_prod @ A @ B ) @ Xy @ Xys2 ) )
     => ~ ! [X3: A,Xs4: list @ A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Xs4 ) )
           => ! [Y2: B,Ys5: list @ B] :
                ( ( Ys
                  = ( cons @ B @ Y2 @ Ys5 ) )
               => ( ( Xy
                    = ( product_Pair @ A @ B @ X3 @ Y2 ) )
                 => ( Xys2
                   != ( zip @ A @ B @ Xs4 @ Ys5 ) ) ) ) ) ) ).

% zip_eq_ConsE
thf(fact_6885_rotate__add,axiom,
    ! [A: $tType,M2: nat,N2: nat] :
      ( ( rotate @ A @ ( plus_plus @ nat @ M2 @ N2 ) )
      = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A ) @ ( rotate @ A @ M2 ) @ ( rotate @ A @ N2 ) ) ) ).

% rotate_add
thf(fact_6886_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z2: list @ A] : ( Y3 = Z2 ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [X4: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X4 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs3 @ Ys3 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
                  @ X4 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_6887_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ~ ! [Y2: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_6888_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Y: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ B @ Y @ ( set2 @ B @ Ys ) )
       => ~ ! [X3: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_6889_concat__injective,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs )
        = ( concat @ A @ Ys ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ! [X3: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y4: list @ A,Z5: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y4 )
                    = ( size_size @ ( list @ A ) @ Z5 ) )
                @ X3 ) )
         => ( Xs = Ys ) ) ) ) ).

% concat_injective
thf(fact_6890_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ! [X3: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X3 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y4: list @ A,Z5: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y4 )
                = ( size_size @ ( list @ A ) @ Z5 ) )
            @ X3 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ( ( concat @ A @ Xs )
            = ( concat @ A @ Ys ) )
          = ( Xs = Ys ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_6891_zip__append1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ B] :
      ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ ( take @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) @ ( zip @ A @ B @ Ys @ ( drop @ B @ ( size_size @ ( list @ A ) @ Xs ) @ Zs ) ) ) ) ).

% zip_append1
thf(fact_6892_zip__append2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( append @ B @ Ys @ Zs ) )
      = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ ( take @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) @ Ys ) @ ( zip @ A @ B @ ( drop @ A @ ( size_size @ ( list @ B ) @ Ys ) @ Xs ) @ Zs ) ) ) ).

% zip_append2
thf(fact_6893_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P4: product_prod @ A @ B,Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ P4 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
      = ( ? [N: nat] :
            ( ( ( nth @ A @ Xs @ N )
              = ( product_fst @ A @ B @ P4 ) )
            & ( ( nth @ B @ Ys @ N )
              = ( product_snd @ A @ B @ P4 ) )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ord_less @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ).

% in_set_zip
thf(fact_6894_nth__rotate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,M2: nat] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate @ A @ M2 @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M2 @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate
thf(fact_6895_hd__rotate__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rotate @ A @ N2 @ Xs ) )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_rotate_conv_nth
thf(fact_6896_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [X4: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ X4 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y4: A,Z5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y4 @ Z5 ) @ R )
              @ X4 ) ) ) ) ).

% listrel_iff_zip
thf(fact_6897_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y4: B,Ys3: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y4 ) @ ( zip @ A @ B @ Xs @ Ys3 ) )
        @ Ys ) ) ).

% zip_Cons1
thf(fact_6898_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ).

% listrel_rtrancl_refl
thf(fact_6899_inf__enat__def,axiom,
    ( ( inf_inf @ extended_enat )
    = ( ord_min @ extended_enat ) ) ).

% inf_enat_def
thf(fact_6900_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(4)
thf(fact_6901_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: B > C,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( H2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( case_list @ C @ A @ ( H2 @ F1 )
        @ ^ [X16: A,X24: list @ A] : ( H2 @ ( F22 @ X16 @ X24 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_6902_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > ( list @ A ) > B,X212: A,X223: list @ A] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( cons @ A @ X212 @ X223 ) )
      = ( F22 @ X212 @ X223 ) ) ).

% list.simps(5)
thf(fact_6903_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Zs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ).

% listrel_rtrancl_trans
thf(fact_6904_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% listrel_eq_len
thf(fact_6905_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) ) ).

% listrel.Nil
thf(fact_6906_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs ) @ ( listrel @ A @ B @ R ) )
     => ( Xs
        = ( nil @ B ) ) ) ).

% listrel_Nil1
thf(fact_6907_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) )
     => ( Xs
        = ( nil @ A ) ) ) ).

% listrel_Nil2
thf(fact_6908_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( listrel @ A @ B @ R ) @ ( listrel @ A @ B @ S ) ) ) ).

% listrel_mono
thf(fact_6909_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X: A,Y: B,R: set @ ( product_prod @ A @ B ),Xs: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R ) ) ) ) ).

% listrel.Cons
thf(fact_6910_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y: A,Ys: list @ A,Xs: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y @ Ys ) @ Xs ) @ ( listrel @ A @ B @ R ) )
     => ~ ! [Y2: B,Ys4: list @ B] :
            ( ( Xs
              = ( cons @ B @ Y2 @ Ys4 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Y2 ) @ R )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys @ Ys4 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel_Cons1
thf(fact_6911_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R ) )
     => ~ ! [X3: A,Xs2: list @ A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Xs2 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y ) @ R )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel_Cons2
thf(fact_6912_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% listrel_reflcl_if_listrel1
thf(fact_6913_listrel__rtrancl__eq__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) )
      = ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel_rtrancl_eq_rtrancl_listrel1
thf(fact_6914_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel @ A @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ).

% rtrancl_listrel1_if_listrel
thf(fact_6915_remdups__adj__Cons,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X @ ( nil @ A ) )
        @ ^ [Y4: A,Xs3: list @ A] : ( if @ ( list @ A ) @ ( X = Y4 ) @ ( cons @ A @ Y4 @ Xs3 ) @ ( cons @ A @ X @ ( cons @ A @ Y4 @ Xs3 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_6916_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( A1
            = ( nil @ A ) )
          & ( A22
            = ( nil @ B ) ) )
        | ? [X4: A,Y4: B,Xs3: list @ A,Ys3: list @ B] :
            ( ( A1
              = ( cons @ A @ X4 @ Xs3 ) )
            & ( A22
              = ( cons @ B @ Y4 @ Ys3 ) )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y4 ) @ R )
            & ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys3 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel.simps
thf(fact_6917_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R ) )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X3: A,Y2: B,Xs2: list @ A] :
              ( ( A1
                = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Ys4: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y2 @ Ys4 ) )
                 => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R )
                   => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys4 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ) ) ).

% listrel.cases
thf(fact_6918_listrel__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel_subset_rtrancl_listrel1
thf(fact_6919_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [N: nat] :
            ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs @ N ) @ ( nth @ B @ Ys @ N ) ) @ R ) ) ) ) ).

% listrel_iff_nth
thf(fact_6920_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( cons @ B @ Y @ Ys ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z5: A,Zs3: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z5 @ Y ) @ ( zip @ A @ B @ Zs3 @ Ys ) )
        @ Xs ) ) ).

% zip_Cons
thf(fact_6921_min__list_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( min_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( case_list @ A @ A @ X
            @ ^ [A3: A,List2: list @ A] : ( ord_min @ A @ X @ ( min_list @ A @ Xs ) )
            @ Xs ) ) ) ).

% min_list.simps
thf(fact_6922_listrel__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrel @ A @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ B )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ B ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ B ) @ $o
              @ ( listrelp @ A @ B
                @ ^ [X4: A,Y4: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y4 ) @ R5 ) ) ) ) ) ) ).

% listrel_def
thf(fact_6923_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu3: A,Uv3: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_6924_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu3: A,Uv3: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_6925_listrelp_OCons,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,X: A,Y: B,Xs: list @ A,Ys: list @ B] :
      ( ( R @ X @ Y )
     => ( ( listrelp @ A @ B @ R @ Xs @ Ys )
       => ( listrelp @ A @ B @ R @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) ) ) ).

% listrelp.Cons
thf(fact_6926_listrelp_ONil,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o] : ( listrelp @ A @ B @ R @ ( nil @ A ) @ ( nil @ B ) ) ).

% listrelp.Nil
thf(fact_6927_listrelp_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R5: A > B > $o,A12: list @ A,A23: list @ B] :
            ( ( ( A12
                = ( nil @ A ) )
              & ( A23
                = ( nil @ B ) ) )
            | ? [X4: A,Y4: B,Xs3: list @ A,Ys3: list @ B] :
                ( ( A12
                  = ( cons @ A @ X4 @ Xs3 ) )
                & ( A23
                  = ( cons @ B @ Y4 @ Ys3 ) )
                & ( R5 @ X4 @ Y4 )
                & ( listrelp @ A @ B @ R5 @ Xs3 @ Ys3 ) ) ) ) ) ).

% listrelp.simps
thf(fact_6928_listrelp_Ocases,axiom,
    ! [A: $tType,B: $tType,R: A > B > $o,A1: list @ A,A22: list @ B] :
      ( ( listrelp @ A @ B @ R @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X3: A,Y2: B,Xs2: list @ A] :
              ( ( A1
                = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Ys4: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y2 @ Ys4 ) )
                 => ( ( R @ X3 @ Y2 )
                   => ~ ( listrelp @ A @ B @ R @ Xs2 @ Ys4 ) ) ) ) ) ) ).

% listrelp.cases
thf(fact_6929_listrelp__listrel__eq,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B )] :
      ( ( listrelp @ A @ B
        @ ^ [X4: A,Y4: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y4 ) @ R ) )
      = ( ^ [X4: list @ A,Y4: list @ B] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X4 @ Y4 ) @ ( listrel @ A @ B @ R ) ) ) ) ).

% listrelp_listrel_eq
thf(fact_6930_min__list_Oelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ! [X3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ( Y
                 != ( case_list @ A @ A @ X3
                    @ ^ [A3: A,List2: list @ A] : ( ord_min @ A @ X3 @ ( min_list @ A @ Xs2 ) )
                    @ Xs2 ) ) )
           => ~ ( ( X
                  = ( nil @ A ) )
               => ( Y
                 != ( undefined @ A ) ) ) ) ) ) ).

% min_list.elims
thf(fact_6931_dual__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( max @ A
          @ ^ [X4: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X4 ) )
        = ( ord_min @ A ) ) ) ).

% dual_max
thf(fact_6932_ord_Omax_Ocong,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( max @ A ) ) ).

% ord.max.cong
thf(fact_6933_ord_Omax__def,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( ^ [Less_eq2: A > A > $o,A3: A,B3: A] : ( if @ A @ ( Less_eq2 @ A3 @ B3 ) @ B3 @ A3 ) ) ) ).

% ord.max_def
thf(fact_6934_hd__def,axiom,
    ! [A: $tType] :
      ( ( hd @ A )
      = ( case_list @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X224: list @ A] : X213 ) ) ).

% hd_def
thf(fact_6935_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa2: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa2 )
            = Y )
         => ( ! [X3: A] :
                ( ( Xa2
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ( Y != X3 ) )
           => ( ! [X3: A,Y2: A,Zs2: list @ A] :
                  ( ( Xa2
                    = ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Zs2 ) ) )
                 => ( Y
                   != ( if @ A @ ( ord_less_eq @ B @ ( X @ X3 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) @ X3 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y2 @ Zs2 ) ) ) ) )
             => ~ ( ( Xa2
                    = ( nil @ A ) )
                 => ( Y
                   != ( undefined @ A ) ) ) ) ) ) ) ).

% arg_min_list.elims
thf(fact_6936_listrel1__subset__listrel,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ R4 )
     => ( ( refl_on @ A @ ( top_top @ ( set @ A ) ) @ R4 )
       => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R ) @ ( listrel @ A @ A @ R4 ) ) ) ) ).

% listrel1_subset_listrel
thf(fact_6937_arg__min__list_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( nil @ A ) ) )
          = X ) ) ).

% arg_min_list.simps(1)
thf(fact_6938_arg__min__list__in,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( member @ A @ ( arg_min_list @ A @ B @ F2 @ Xs ) @ ( set2 @ A @ Xs ) ) ) ) ).

% arg_min_list_in
thf(fact_6939_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A,Y: A,Zs: list @ A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( if @ A @ ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) @ X @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% arg_min_list.simps(2)
thf(fact_6940_filterlim__finite__subsets__at__top,axiom,
    ! [A: $tType,B: $tType,F2: A > ( set @ B ),A5: set @ B,F4: filter @ A] :
      ( ( filterlim @ A @ ( set @ B ) @ F2 @ ( finite5375528669736107172at_top @ B @ A5 ) @ F4 )
      = ( ! [X6: set @ B] :
            ( ( ( finite_finite @ B @ X6 )
              & ( ord_less_eq @ ( set @ B ) @ X6 @ A5 ) )
           => ( eventually @ A
              @ ^ [Y4: A] :
                  ( ( finite_finite @ B @ ( F2 @ Y4 ) )
                  & ( ord_less_eq @ ( set @ B ) @ X6 @ ( F2 @ Y4 ) )
                  & ( ord_less_eq @ ( set @ B ) @ ( F2 @ Y4 ) @ A5 ) )
              @ F4 ) ) ) ) ).

% filterlim_finite_subsets_at_top
thf(fact_6941_card__Min__le__sum,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ ( finite_card @ A @ A5 ) @ ( lattic643756798350308766er_Min @ nat @ ( image @ A @ nat @ F2 @ A5 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) ) ) ).

% card_Min_le_sum
thf(fact_6942_Min__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Min_singleton
thf(fact_6943_eventually__finite__subsets__at__top__weakI,axiom,
    ! [A: $tType,A5: set @ A,P: ( set @ A ) > $o] :
      ( ! [X9: set @ A] :
          ( ( finite_finite @ A @ X9 )
         => ( ( ord_less_eq @ ( set @ A ) @ X9 @ A5 )
           => ( P @ X9 ) ) )
     => ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A5 ) ) ) ).

% eventually_finite_subsets_at_top_weakI
thf(fact_6944_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ X @ X4 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_6945_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less @ A @ X @ X4 ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_6946_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ B,C2: A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A5 ) )
              = C2 ) ) ) ) ).

% Min_const
thf(fact_6947_Min__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min_insert
thf(fact_6948_Min__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ X ) ) ) ) ).

% Min_le
thf(fact_6949_Min__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [Y2: A] :
                ( ( member @ A @ Y2 @ A5 )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( member @ A @ X @ A5 )
             => ( ( lattic643756798350308766er_Min @ A @ A5 )
                = X ) ) ) ) ) ).

% Min_eqI
thf(fact_6950_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ A2 ) ) ) ) ).

% Min.coboundedI
thf(fact_6951_Min__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ A5 ) ) ) ) ).

% Min_in
thf(fact_6952_Min_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ).

% Min.in_idem
thf(fact_6953_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A5 )
                = M2 )
              = ( ( member @ A @ M2 @ A5 )
                & ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ M2 @ X4 ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_6954_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ X )
              = ( ? [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                    & ( ord_less_eq @ A @ X4 @ X ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_6955_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M2
                = ( lattic643756798350308766er_Min @ A @ A5 ) )
              = ( ( member @ A @ M2 @ A5 )
                & ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ M2 @ X4 ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_6956_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A5 )
                 => ( ord_less_eq @ A @ X @ A17 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_6957_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ X @ A4 ) )
             => ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_6958_Min__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ X )
              = ( ? [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                    & ( ord_less @ A @ X4 @ X ) ) ) ) ) ) ) ).

% Min_less_iff
thf(fact_6959_Min__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [B4: A] :
                ( ( member @ A @ B4 @ A5 )
               => ( ord_less_eq @ A @ A2 @ B4 ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ A2 @ A5 ) )
              = A2 ) ) ) ) ).

% Min_insert2
thf(fact_6960_Min__Inf,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ A5 )
              = ( complete_Inf_Inf @ A @ A5 ) ) ) ) ) ).

% Min_Inf
thf(fact_6961_min__list__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( min_list @ A @ Xs )
            = ( lattic643756798350308766er_Min @ A @ ( set2 @ A @ Xs ) ) ) ) ) ).

% min_list_Min
thf(fact_6962_eventually__finite__subsets__at__top,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,A5: set @ A] :
      ( ( eventually @ ( set @ A ) @ P @ ( finite5375528669736107172at_top @ A @ A5 ) )
      = ( ? [X6: set @ A] :
            ( ( finite_finite @ A @ X6 )
            & ( ord_less_eq @ ( set @ A ) @ X6 @ A5 )
            & ! [Y7: set @ A] :
                ( ( ( finite_finite @ A @ Y7 )
                  & ( ord_less_eq @ ( set @ A ) @ X6 @ Y7 )
                  & ( ord_less_eq @ ( set @ A ) @ Y7 @ A5 ) )
               => ( P @ Y7 ) ) ) ) ) ).

% eventually_finite_subsets_at_top
thf(fact_6963_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N4 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N4 ) @ ( lattic643756798350308766er_Min @ A @ M7 ) ) ) ) ) ) ).

% Min_antimono
thf(fact_6964_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B5 ) @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_6965_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y2: A] :
              ( ( H2 @ ( ord_min @ A @ X3 @ Y2 ) )
              = ( ord_min @ A @ ( H2 @ X3 ) @ ( H2 @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798350308766er_Min @ A @ N4 ) )
                = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Min_commute
thf(fact_6966_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B5 ) @ ( lattic643756798350308766er_Min @ A @ A5 ) )
                = ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ).

% Min.subset
thf(fact_6967_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y2: A] : ( member @ A @ ( ord_min @ A @ X3 @ Y2 ) @ ( insert2 @ A @ X3 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Min.closed
thf(fact_6968_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A5 ) ) ) ) ) ) ) ).

% Min.insert_not_elem
thf(fact_6969_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798350308766er_Min @ A @ A5 ) )
                = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ) ) ).

% mono_Min_commute
thf(fact_6970_Min_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ( B5
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
                  = ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( lattic643756798350308766er_Min @ A @ B5 ) ) ) ) ) ) ) ) ).

% Min.union
thf(fact_6971_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [X4: B] : ( plus_plus @ A @ ( F2 @ X4 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_6972_f__arg__min__list__f,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [Xs: list @ A,F2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( F2 @ ( arg_min_list @ A @ B @ F2 @ Xs ) )
            = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ ( set2 @ A @ Xs ) ) ) ) ) ) ).

% f_arg_min_list_f
thf(fact_6973_finite__subsets__at__top__def,axiom,
    ! [A: $tType] :
      ( ( finite5375528669736107172at_top @ A )
      = ( ^ [A7: set @ A] :
            ( complete_Inf_Inf @ ( filter @ ( set @ A ) )
            @ ( image @ ( set @ A ) @ ( filter @ ( set @ A ) )
              @ ^ [X6: set @ A] :
                  ( principal @ ( set @ A )
                  @ ( collect @ ( set @ A )
                    @ ^ [Y7: set @ A] :
                        ( ( finite_finite @ A @ Y7 )
                        & ( ord_less_eq @ ( set @ A ) @ X6 @ Y7 )
                        & ( ord_less_eq @ ( set @ A ) @ Y7 @ A7 ) ) ) )
              @ ( collect @ ( set @ A )
                @ ^ [X6: set @ A] :
                    ( ( finite_finite @ A @ X6 )
                    & ( ord_less_eq @ ( set @ A ) @ X6 @ A7 ) ) ) ) ) ) ) ).

% finite_subsets_at_top_def
thf(fact_6974_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A5 )
                  = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_6975_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_6976_sorted__list__of__set__nonempty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( linord4507533701916653071of_set @ A @ A5 )
              = ( cons @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ ( lattic643756798350308766er_Min @ A @ A5 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set_nonempty
thf(fact_6977_dual__Max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Max @ A
          @ ^ [X4: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X4 ) )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% dual_Max
thf(fact_6978_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798349783984er_Max @ A @ S2 ) )
              = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Max_eq_Min
thf(fact_6979_Max__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Max_singleton
thf(fact_6980_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ X4 @ X ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_6981_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less @ A @ X4 @ X ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_6982_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ B,C2: A] :
          ( ( finite_finite @ B @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A5 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_6983_Max__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ) ).

% Max_insert
thf(fact_6984_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798350308766er_Min @ A @ S2 ) )
              = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S2 ) ) ) ) ) ) ).

% minus_Min_eq_Max
thf(fact_6985_linorder_OMax_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Max @ A )
      = ( lattices_Max @ A ) ) ).

% linorder.Max.cong
thf(fact_6986_Max__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ A5 ) ) ) ) ).

% Max_in
thf(fact_6987_Max_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ).

% Max.in_idem
thf(fact_6988_Max__ge,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ).

% Max_ge
thf(fact_6989_Max__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [Y2: A] :
                ( ( member @ A @ Y2 @ A5 )
               => ( ord_less_eq @ A @ Y2 @ X ) )
           => ( ( member @ A @ X @ A5 )
             => ( ( lattic643756798349783984er_Max @ A @ A5 )
                = X ) ) ) ) ) ).

% Max_eqI
thf(fact_6990_Max__eq__if,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( finite_finite @ A @ B5 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A5 )
                 => ? [Xa: A] :
                      ( ( member @ A @ Xa @ B5 )
                      & ( ord_less_eq @ A @ X3 @ Xa ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ B5 )
                   => ? [Xa: A] :
                        ( ( member @ A @ Xa @ A5 )
                        & ( ord_less_eq @ A @ X3 @ Xa ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A5 )
                  = ( lattic643756798349783984er_Max @ A @ B5 ) ) ) ) ) ) ) ).

% Max_eq_if
thf(fact_6991_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ A2 @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ).

% Max.coboundedI
thf(fact_6992_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ A4 @ X ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X ) ) ) ) ) ).

% Max.boundedI
thf(fact_6993_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ X )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A5 )
                 => ( ord_less_eq @ A @ A17 @ X ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_6994_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M2
                = ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( ( member @ A @ M2 @ A5 )
                & ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ X4 @ M2 ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_6995_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( ? [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                    & ( ord_less_eq @ A @ X @ X4 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_6996_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,M2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A5 )
                = M2 )
              = ( ( member @ A @ M2 @ A5 )
                & ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ X4 @ M2 ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_6997_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) )
              = ( ? [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                    & ( ord_less @ A @ X @ X4 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_6998_Max__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ! [B4: A] :
                ( ( member @ A @ B4 @ A5 )
               => ( ord_less_eq @ A @ B4 @ A2 ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ A2 @ A5 ) )
              = A2 ) ) ) ) ).

% Max_insert2
thf(fact_6999_Max__Sup,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ A5 )
              = ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% Max_Sup
thf(fact_7000_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ ( lattic643756798349783984er_Max @ A @ B5 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_7001_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M7: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M7 @ N4 )
         => ( ( M7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M7 ) @ ( lattic643756798349783984er_Max @ A @ N4 ) ) ) ) ) ) ).

% Max_mono
thf(fact_7002_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y2: A] :
              ( ( H2 @ ( ord_max @ A @ X3 @ Y2 ) )
              = ( ord_max @ A @ ( H2 @ X3 ) @ ( H2 @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798349783984er_Max @ A @ N4 ) )
                = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Max_commute
thf(fact_7003_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B5 ) @ ( lattic643756798349783984er_Max @ A @ A5 ) )
                = ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ) ).

% Max.subset
thf(fact_7004_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y2: A] : ( member @ A @ ( ord_max @ A @ X3 @ Y2 ) @ ( insert2 @ A @ X3 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Max.closed
thf(fact_7005_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A5 ) ) ) ) ) ) ) ).

% Max.insert_not_elem
thf(fact_7006_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798349783984er_Max @ A @ A5 ) )
                = ( lattic643756798349783984er_Max @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ) ) ).

% mono_Max_commute
thf(fact_7007_Max_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ( B5
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
                  = ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ A5 ) @ ( lattic643756798349783984er_Max @ A @ B5 ) ) ) ) ) ) ) ) ).

% Max.union
thf(fact_7008_card__le__Suc__Max,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ S2 ) @ ( suc @ ( lattic643756798349783984er_Max @ nat @ S2 ) ) ) ) ).

% card_le_Suc_Max
thf(fact_7009_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M: nat,N: nat] :
          ( if @ nat
          @ ( N
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K3 @ N ) @ M ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_7010_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S2: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [X4: B] : ( plus_plus @ A @ ( F2 @ X4 ) @ K )
                  @ S2 ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image @ B @ A @ F2 @ S2 ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_7011_gcd__is__Max__divisors__nat,axiom,
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( gcd_gcd @ nat @ M2 @ N2 )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D3: nat] :
                ( ( dvd_dvd @ nat @ D3 @ M2 )
                & ( dvd_dvd @ nat @ D3 @ N2 ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_7012_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_7013_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A5 )
                  = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_7014_sum__le__card__Max,axiom,
    ! [A: $tType,A5: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A5 )
     => ( ord_less_eq @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A5 ) @ ( times_times @ nat @ ( finite_card @ A @ A5 ) @ ( lattic643756798349783984er_Max @ nat @ ( image @ A @ nat @ F2 @ A5 ) ) ) ) ) ).

% sum_le_card_Max
thf(fact_7015_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X4: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X4 ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_7016_upt__rec__numeral,axiom,
    ! [M2: num,N2: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M2 ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M2 ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_7017_remdups__upt,axiom,
    ! [M2: nat,N2: nat] :
      ( ( remdups @ nat @ ( upt @ M2 @ N2 ) )
      = ( upt @ M2 @ N2 ) ) ).

% remdups_upt
thf(fact_7018_hd__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( hd @ nat @ ( upt @ I2 @ J ) )
        = I2 ) ) ).

% hd_upt
thf(fact_7019_drop__upt,axiom,
    ! [M2: nat,I2: nat,J: nat] :
      ( ( drop @ nat @ M2 @ ( upt @ I2 @ J ) )
      = ( upt @ ( plus_plus @ nat @ I2 @ M2 ) @ J ) ) ).

% drop_upt
thf(fact_7020_length__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I2 @ J ) )
      = ( minus_minus @ nat @ J @ I2 ) ) ).

% length_upt
thf(fact_7021_take__upt,axiom,
    ! [I2: nat,M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ M2 ) @ N2 )
     => ( ( take @ nat @ M2 @ ( upt @ I2 @ N2 ) )
        = ( upt @ I2 @ ( plus_plus @ nat @ I2 @ M2 ) ) ) ) ).

% take_upt
thf(fact_7022_upt__conv__Nil,axiom,
    ! [J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( upt @ I2 @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_7023_sorted__list__of__set__range,axiom,
    ! [M2: nat,N2: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) )
      = ( upt @ M2 @ N2 ) ) ).

% sorted_list_of_set_range
thf(fact_7024_upt__eq__Nil__conv,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( upt @ I2 @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I2 ) ) ) ).

% upt_eq_Nil_conv
thf(fact_7025_nth__upt,axiom,
    ! [I2: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I2 @ J ) @ K )
        = ( plus_plus @ nat @ I2 @ K ) ) ) ).

% nth_upt
thf(fact_7026_upt__0,axiom,
    ! [I2: nat] :
      ( ( upt @ I2 @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_7027_linorder_OMin_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Min @ A )
      = ( lattices_Min @ A ) ) ).

% linorder.Min.cong
thf(fact_7028_distinct__upt,axiom,
    ! [I2: nat,J: nat] : ( distinct @ nat @ ( upt @ I2 @ J ) ) ).

% distinct_upt
thf(fact_7029_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N: nat,M: nat] : ( set2 @ nat @ ( upt @ ( suc @ N ) @ M ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_7030_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N: nat,M: nat] : ( set2 @ nat @ ( upt @ N @ ( suc @ M ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_7031_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I4: nat,J3: nat] : ( set2 @ nat @ ( upt @ I4 @ J3 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_7032_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast_upt
thf(fact_7033_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N: nat,M: nat] : ( set2 @ nat @ ( upt @ ( suc @ N ) @ ( suc @ M ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_7034_upt__conv__Cons__Cons,axiom,
    ! [M2: nat,N2: nat,Ns: list @ nat,Q2: nat] :
      ( ( ( cons @ nat @ M2 @ ( cons @ nat @ N2 @ Ns ) )
        = ( upt @ M2 @ Q2 ) )
      = ( ( cons @ nat @ N2 @ Ns )
        = ( upt @ ( suc @ M2 ) @ Q2 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_7035_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) ) ) ) ).

% atMost_upto
thf(fact_7036_upt__conv__Cons,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( upt @ I2 @ J )
        = ( cons @ nat @ I2 @ ( upt @ ( suc @ I2 ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_7037_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N: nat,Xs3: list @ A] : ( zip @ nat @ A @ ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) @ Xs3 ) ) ) ).

% enumerate_eq_zip
thf(fact_7038_upt__add__eq__append,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_7039_upt__eq__Cons__conv,axiom,
    ! [I2: nat,J: nat,X: nat,Xs: list @ nat] :
      ( ( ( upt @ I2 @ J )
        = ( cons @ nat @ X @ Xs ) )
      = ( ( ord_less @ nat @ I2 @ J )
        & ( I2 = X )
        & ( ( upt @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) @ J )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_7040_upt__rec,axiom,
    ( upt
    = ( ^ [I4: nat,J3: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I4 @ J3 ) @ ( cons @ nat @ I4 @ ( upt @ ( suc @ I4 ) @ J3 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_7041_upt__Suc__append,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_7042_upt__Suc,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_7043_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_7044_map__fst__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% map_fst_enumerate
thf(fact_7045_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4 )
      = ( ^ [Xs3: list @ A] : Xs3 ) ) ).

% map_ident
thf(fact_7046_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_7047_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_7048_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: list @ A] :
      ( ( ( map @ A @ B @ F2 @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_7049_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G2: B > C,F2: A > B,V2: list @ A] :
      ( ( map @ B @ C @ G2 @ ( map @ A @ B @ F2 @ V2 ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G2 @ F2 ) @ V2 ) ) ).

% list.map_comp
thf(fact_7050_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C,G2: A > B,List: list @ A] :
      ( ( map @ B @ C @ F2 @ ( map @ A @ B @ G2 @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G2 ) @ List ) ) ).

% List.map.compositionality
thf(fact_7051_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > A,G2: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F2 @ ( map @ C @ B @ G2 @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F2 @ G2 ) @ Xs ) ) ).

% map_map
thf(fact_7052_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,G2: B > A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ G2 @ Xs ) )
      = ( ! [X4: B] :
            ( ( member @ B @ X4 @ ( set2 @ B @ Xs ) )
           => ( ( F2 @ X4 )
              = ( G2 @ X4 ) ) ) ) ) ).

% map_eq_conv
thf(fact_7053_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) ).

% length_map
thf(fact_7054_map__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys ) ) ) ).

% map_append
thf(fact_7055_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A,N2: nat,X: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N2 @ X ) )
      = ( replicate @ A @ N2 @ ( F2 @ X ) ) ) ).

% map_replicate
thf(fact_7056_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,V2: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F2 @ V2 ) )
      = ( image @ A @ B @ F2 @ ( set2 @ A @ V2 ) ) ) ).

% list.set_map
thf(fact_7057_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_map_eq_map
thf(fact_7058_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,G2: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F2 ) @ ( map @ A @ C @ G2 ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F2 @ G2 ) ) ) ).

% map_comp_map
thf(fact_7059_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > C,G2: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F2 ) @ ( map @ A @ B @ G2 ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G2 ) ) ) ).

% List.map.comp
thf(fact_7060_nth__map,axiom,
    ! [B: $tType,A: $tType,N2: nat,Xs: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs ) @ N2 )
        = ( F2 @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% nth_map
thf(fact_7061_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
        = Xs ) ) ).

% map_fst_zip
thf(fact_7062_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
        = Ys ) ) ).

% map_snd_zip
thf(fact_7063_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X4: B] : ( cons @ A @ ( F2 @ X4 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F2 @ Xs ) ) ).

% concat_map_singleton
thf(fact_7064_map__snd__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) )
      = Xs ) ).

% map_snd_enumerate
thf(fact_7065_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_7066_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_7067_enumerate__map__upt,axiom,
    ! [A: $tType,N2: nat,F2: nat > A,M2: nat] :
      ( ( enumerate @ A @ N2 @ ( map @ nat @ A @ F2 @ ( upt @ N2 @ M2 ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K3: nat] : ( product_Pair @ nat @ A @ K3 @ ( F2 @ K3 ) )
        @ ( upt @ N2 @ M2 ) ) ) ).

% enumerate_map_upt
thf(fact_7068_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( F2 @ ( hd @ A @ A2 ) ) ) ) ).

% list.map_sel(1)
thf(fact_7069_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( hd @ A @ Xs ) ) ) ) ).

% hd_map
thf(fact_7070_map2__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,H2: B > C > A,F2: D > B,Xs: list @ D,G2: D > C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ H2 ) @ ( zip @ B @ C @ ( map @ D @ B @ F2 @ Xs ) @ ( map @ D @ C @ G2 @ Xs ) ) )
      = ( map @ D @ A
        @ ^ [X4: D] : ( H2 @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
        @ Xs ) ) ).

% map2_map_map
thf(fact_7071_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( product_prod @ B @ C ) > A,Xs: list @ B,G2: D > C,Ys: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ Xs @ ( map @ D @ C @ G2 @ Ys ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X4: B,Y4: D] : ( F2 @ ( product_Pair @ B @ C @ X4 @ ( G2 @ Y4 ) ) ) )
        @ ( zip @ B @ D @ Xs @ Ys ) ) ) ).

% map_zip_map2
thf(fact_7072_zip__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,F2: C > A,Xs: list @ C,G2: D > B,Ys: list @ D] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ ( map @ D @ B @ G2 @ Ys ) )
      = ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X4: C,Y4: D] : ( product_Pair @ A @ B @ ( F2 @ X4 ) @ ( G2 @ Y4 ) ) )
        @ ( zip @ C @ D @ Xs @ Ys ) ) ) ).

% zip_map_map
thf(fact_7073_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( product_prod @ B @ C ) > A,G2: D > B,Xs: list @ D,Ys: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ ( map @ D @ B @ G2 @ Xs ) @ Ys ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X4: D,Y4: C] : ( F2 @ ( product_Pair @ B @ C @ ( G2 @ X4 ) @ Y4 ) ) )
        @ ( zip @ D @ C @ Xs @ Ys ) ) ) ).

% map_zip_map
thf(fact_7074_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,F2: C > B,Ys: list @ C] :
      ( ( zip @ A @ B @ Xs @ ( map @ C @ B @ F2 @ Ys ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X4: A,Y4: C] : ( product_Pair @ A @ B @ X4 @ ( F2 @ Y4 ) ) )
        @ ( zip @ A @ C @ Xs @ Ys ) ) ) ).

% zip_map2
thf(fact_7075_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,Xs: list @ C,Ys: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs ) @ Ys )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X4: C] : ( product_Pair @ A @ B @ ( F2 @ X4 ) ) )
        @ ( zip @ C @ B @ Xs @ Ys ) ) ) ).

% zip_map1
thf(fact_7076_take__map,axiom,
    ! [A: $tType,B: $tType,N2: nat,F2: B > A,Xs: list @ B] :
      ( ( take @ A @ N2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( take @ B @ N2 @ Xs ) ) ) ).

% take_map
thf(fact_7077_drop__map,axiom,
    ! [A: $tType,B: $tType,N2: nat,F2: B > A,Xs: list @ B] :
      ( ( drop @ A @ N2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( drop @ B @ N2 @ Xs ) ) ) ).

% drop_map
thf(fact_7078_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X4: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_7079_map__update,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,K: nat,Y: B] :
      ( ( map @ B @ A @ F2 @ ( list_update @ B @ Xs @ K @ Y ) )
      = ( list_update @ A @ ( map @ B @ A @ F2 @ Xs ) @ K @ ( F2 @ Y ) ) ) ).

% map_update
thf(fact_7080_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X212: A,X223: list @ A] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X212 @ X223 ) )
      = ( cons @ B @ ( F2 @ X212 ) @ ( map @ A @ B @ F2 @ X223 ) ) ) ).

% list.simps(9)
thf(fact_7081_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ? [Z3: B,Zs2: list @ B] :
          ( ( Ys
            = ( cons @ B @ Z3 @ Zs2 ) )
          & ( X
            = ( F2 @ Z3 ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_7082_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: B > A,Xs: list @ B,Y: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ? [Z3: B,Zs2: list @ B] :
          ( ( Xs
            = ( cons @ B @ Z3 @ Zs2 ) )
          & ( ( F2 @ Z3 )
            = Y )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys ) ) ) ).

% map_eq_Cons_D
thf(fact_7083_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
      = ( ? [Z5: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z5 @ Zs3 ) )
            & ( X
              = ( F2 @ Z5 ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_7084_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Y: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ? [Z5: B,Zs3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Z5 @ Zs3 ) )
            & ( ( F2 @ Z5 )
              = Y )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_7085_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ A,Zs: list @ A,F2: B > A,Xs: list @ B] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% append_eq_map_conv
thf(fact_7086_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% map_eq_append_conv
thf(fact_7087_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,F2: A > B] :
      ( ( ? [Xs3: list @ A] :
            ( Ys
            = ( map @ A @ B @ F2 @ Xs3 ) ) )
      = ( ! [X4: B] :
            ( ( member @ B @ X4 @ ( set2 @ B @ Ys ) )
           => ? [Y4: A] :
                ( X4
                = ( F2 @ Y4 ) ) ) ) ) ).

% ex_map_conv
thf(fact_7088_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > B,G2: A > B] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( F2 @ X3 )
              = ( G2 @ X3 ) ) )
       => ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ G2 @ Ys ) ) ) ) ).

% map_cong
thf(fact_7089_map__idI,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = X3 ) )
     => ( ( map @ A @ A @ F2 @ Xs )
        = Xs ) ) ).

% map_idI
thf(fact_7090_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B,G2: A > B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = ( G2 @ X3 ) ) )
     => ( ( map @ A @ B @ F2 @ Xs )
        = ( map @ A @ B @ G2 @ Xs ) ) ) ).

% map_ext
thf(fact_7091_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Xa2: list @ A,F2: A > B,Fa: A > B] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
         => ( ( member @ A @ Za @ ( set2 @ A @ Xa2 ) )
           => ( ( ( F2 @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ Fa @ Xa2 ) )
       => ( X = Xa2 ) ) ) ).

% list.inj_map_strong
thf(fact_7092_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X: list @ A,F2: A > B,G2: A > B] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
         => ( ( F2 @ Z3 )
            = ( G2 @ Z3 ) ) )
     => ( ( map @ A @ B @ F2 @ X )
        = ( map @ A @ B @ G2 @ X ) ) ) ).

% list.map_cong0
thf(fact_7093_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Ya: list @ A,F2: A > B,G2: A > B] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( set2 @ A @ Ya ) )
           => ( ( F2 @ Z3 )
              = ( G2 @ Z3 ) ) )
       => ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ G2 @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_7094_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs: list @ B,G2: C > A,Ys: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ C @ A @ G2 @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) ).

% map_eq_imp_length_eq
thf(fact_7095_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys ) )
       => ( Xs = Ys ) ) ) ).

% pair_list_eqI
thf(fact_7096_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate1 @ B @ Xs ) ) ) ).

% rotate1_map
thf(fact_7097_list_Omap__ident,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4
        @ T2 )
      = T2 ) ).

% list.map_ident
thf(fact_7098_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( concat @ B @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) ) ) ).

% map_concat
thf(fact_7099_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F2 @ ( remdups @ B @ Xs ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% remdups_map_remdups
thf(fact_7100_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_7101_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( Xs = Ys ) ) ) ).

% map_injective
thf(fact_7102_nths__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,I6: set @ nat] :
      ( ( nths @ A @ ( map @ B @ A @ F2 @ Xs ) @ I6 )
      = ( map @ B @ A @ F2 @ ( nths @ B @ Xs @ I6 ) ) ) ).

% nths_map
thf(fact_7103_rotate__map,axiom,
    ! [A: $tType,B: $tType,N2: nat,F2: B > A,Xs: list @ B] :
      ( ( rotate @ A @ N2 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate @ B @ N2 @ Xs ) ) ) ).

% rotate_map
thf(fact_7104_image__set,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
      = ( set2 @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% image_set
thf(fact_7105_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_on_map_eq_map
thf(fact_7106_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
       => ( Xs = Ys ) ) ) ).

% map_inj_on
thf(fact_7107_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( ( distinct @ B @ Xs )
        & ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) ) ) ).

% distinct_map
thf(fact_7108_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( map @ A @ B @ F2 @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_7109_zip__map__fst__snd,axiom,
    ! [B: $tType,A: $tType,Zs: list @ ( product_prod @ A @ B )] :
      ( ( zip @ A @ B @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs ) @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs ) )
      = Zs ) ).

% zip_map_fst_snd
thf(fact_7110_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj
thf(fact_7111_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I2: nat] :
      ( ( map @ nat @ A
        @ ^ [I4: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I2 ) )
      = ( replicate @ A @ I2 @ X ) ) ).

% map_replicate_trivial
thf(fact_7112_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ ( product_prod @ A @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( zip @ A @ B @ Xs @ Ys )
          = Zs )
        = ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs )
            = Xs )
          & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs )
            = Ys ) ) ) ) ).

% zip_eq_conv
thf(fact_7113_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( ~ ( member @ A @ ( F2 @ X ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% distinct_insort_key
thf(fact_7114_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert2 @ A @ X @ ( set2 @ A @ Xs ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_7115_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N2: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I4: nat] : ( F2 @ ( suc @ I4 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% map_upt_Suc
thf(fact_7116_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_7117_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_7118_nth__map__upt,axiom,
    ! [A: $tType,I2: nat,N2: nat,M2: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ N2 @ M2 ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M2 @ N2 ) ) @ I2 )
        = ( F2 @ ( plus_plus @ nat @ M2 @ I2 ) ) ) ) ).

% nth_map_upt
thf(fact_7119_map__fst__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) @ Xs ) ) ).

% map_fst_zip_take
thf(fact_7120_map__snd__zip__take,axiom,
    ! [B: $tType,A: $tType,Xs: list @ B,Ys: list @ A] :
      ( ( map @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( zip @ B @ A @ Xs @ Ys ) )
      = ( take @ A @ ( ord_min @ nat @ ( size_size @ ( list @ B ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ Ys ) ) ).

% map_snd_zip_take
thf(fact_7121_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A5 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ A5 ) ) ).

% inj_on_mapI
thf(fact_7122_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,M2: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N2 @ M2 ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I3 )
              = ( F2 @ ( plus_plus @ nat @ M2 @ I3 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M2 @ N2 ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_7123_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N2: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N2
          = ( zero_zero @ nat ) ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I3 ) )
              = N2 ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I4: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J3 ) @ I4 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% transpose_rectangle
thf(fact_7124_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X4: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X4 ) @ ( F2 @ X4 ) )
            @ X8 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_7125_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Ns ) )
               => ( X4
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_7126_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( plus_plus @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% sum_list.Cons
thf(fact_7127_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_7128_sum__list__upt,axiom,
    ! [M2: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M2 @ N2 )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M2 @ N2 ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X4: nat] : X4
          @ ( set_or7035219750837199246ssThan @ nat @ M2 @ N2 ) ) ) ) ).

% sum_list_upt
thf(fact_7129_map__Suc__upt,axiom,
    ! [M2: nat,N2: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M2 @ N2 ) )
      = ( upt @ ( suc @ M2 ) @ ( suc @ N2 ) ) ) ).

% map_Suc_upt
thf(fact_7130_transpose_Oelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ ( list @ A ) ) )
         => ( Y
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) )
               => ( Y
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X3
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs2
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_7131_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_7132_zip__same__conv__map,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( zip @ A @ A @ Xs @ Xs )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X4: A] : ( product_Pair @ A @ A @ X4 @ X4 )
        @ Xs ) ) ).

% zip_same_conv_map
thf(fact_7133_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N2 ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y4: A] : ( cons @ A @ Y4 @ Ys3 )
              @ Xs )
          @ ( n_lists @ A @ N2 @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_7134_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X4: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X4 ) @ ( product_lists @ A @ Xss ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_7135_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_7136_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X4: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 ) @ Ys3 )
              @ Xs3 ) ) ) ) ).

% product_concat_map
thf(fact_7137_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_7138_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G2: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( plus_plus @ A @ ( F2 @ X4 ) @ ( G2 @ X4 ) )
              @ Xs ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G2 @ Xs ) ) ) ) ) ).

% sum_list_addf
thf(fact_7139_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( transpose @ B @ Xs ) ) ) ).

% transpose_map_map
thf(fact_7140_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ ( F2 @ X4 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_7141_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X4: B] : ( times_times @ A @ C2 @ ( F2 @ X4 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_7142_List_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind @ A @ B )
      = ( ^ [Xs3: list @ A,F3: A > ( list @ B )] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F3 @ Xs3 ) ) ) ) ).

% List.bind_def
thf(fact_7143_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_7144_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
      = ( transpose @ A @ Xss ) ) ).

% transpose.simps(2)
thf(fact_7145_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_7146_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X4: A] :
                  ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
                 => ( X4
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_7147_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_7148_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_7149_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% distinct_set_subseqs
thf(fact_7150_map__add__upt,axiom,
    ! [N2: nat,M2: nat] :
      ( ( map @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ I4 @ N2 )
        @ ( upt @ ( zero_zero @ nat ) @ M2 ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ M2 @ N2 ) ) ) ).

% map_add_upt
thf(fact_7151_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N2 @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_7152_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X4: A,Y4: B,Z5: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X4 @ ( product_Pair @ B @ C @ Y4 @ Z5 ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs @ Ys ) @ Zs ) ) ) ).

% zip_assoc
thf(fact_7153_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y4: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X4: A,Z5: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X4 @ ( product_Pair @ B @ C @ Y4 @ Z5 ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys @ ( zip @ A @ C @ Xs @ Zs ) ) ) ) ).

% zip_left_commute
thf(fact_7154_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X4: B,Y4: A] : ( product_Pair @ A @ B @ Y4 @ X4 ) )
            @ ( zip @ B @ A @ Ys3 @ Xs3 ) ) ) ) ).

% zip_commute
thf(fact_7155_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G2: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G2 @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_7156_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( ( groups8242544230860333062m_list @ A @ Xs )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X4: A] : X4
              @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_7157_zip__replicate1,axiom,
    ! [A: $tType,B: $tType,N2: nat,X: A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( replicate @ A @ N2 @ X ) @ Ys )
      = ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ ( take @ B @ N2 @ Ys ) ) ) ).

% zip_replicate1
thf(fact_7158_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_7159_map__decr__upt,axiom,
    ! [M2: nat,N2: nat] :
      ( ( map @ nat @ nat
        @ ^ [N: nat] : ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M2 ) @ ( suc @ N2 ) ) )
      = ( upt @ M2 @ N2 ) ) ).

% map_decr_upt
thf(fact_7160_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G2: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G2 @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_7161_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_7162_transpose__empty,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X4: list @ A] :
            ( ( member @ ( list @ A ) @ X4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( X4
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_7163_zip__replicate2,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,N2: nat,Y: B] :
      ( ( zip @ A @ B @ Xs @ ( replicate @ B @ N2 @ Y ) )
      = ( map @ A @ ( product_prod @ A @ B )
        @ ^ [X4: A] : ( product_Pair @ A @ B @ X4 @ Y )
        @ ( take @ A @ N2 @ Xs ) ) ) ).

% zip_replicate2
thf(fact_7164_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ B,G2: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G2 @ Xs ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_7165_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs: list @ B,F2: B > C] :
          ( ( distinct @ B @ Xs )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F2 @ Xs ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F2 @ ( set2 @ B @ Xs ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_7166_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ X @ ( set2 @ B @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) )
            = ( plus_plus @ A @ ( F2 @ X ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_7167_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G2: B > A,Xs: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G2 @ ( remdups @ B @ Xs ) ) ) ) ) ).

% sum_code
thf(fact_7168_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ Ys ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ).

% product.simps(2)
thf(fact_7169_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X4: C] : R
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R ) ) ) ).

% sum_list_triv
thf(fact_7170_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X4: A] : ( suc @ ( F2 @ X4 ) )
          @ Xs ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% sum_list_Suc
thf(fact_7171_enumerate__replicate__eq,axiom,
    ! [A: $tType,N2: nat,M2: nat,A2: A] :
      ( ( enumerate @ A @ N2 @ ( replicate @ A @ M2 @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N2 @ ( plus_plus @ nat @ N2 @ M2 ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_7172_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs3: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_7173_card__length__sum__list__rec,axiom,
    ! [M2: nat,N4: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M2 )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L2: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L2 )
                  = M2 )
                & ( ( groups8242544230860333062m_list @ nat @ L2 )
                  = N4 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L2 )
                    = N4 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = M2 )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L2 ) @ ( one_one @ nat ) )
                    = N4 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_7174_card__length__sum__list,axiom,
    ! [M2: nat,N4: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L2: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L2 )
                = M2 )
              & ( ( groups8242544230860333062m_list @ nat @ L2 )
                = N4 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N4 @ M2 ) @ ( one_one @ nat ) ) @ N4 ) ) ).

% card_length_sum_list
thf(fact_7175_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X4: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X4 ) @ ( F2 @ X4 ) )
        @ ( set2 @ A @ Xs ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_7176_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_7177_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X4: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 ) @ Ys )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_7178_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y2 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_7179_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P3: A > A > $o,Xs3: list @ A] :
          ! [I4: nat,J3: nat] :
            ( ( ord_less @ nat @ I4 @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P3 @ ( nth @ A @ Xs3 @ I4 ) @ ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_7180_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,I2: nat,J: nat] :
      ( ( sorted_wrt @ A @ P @ Xs )
     => ( ( ord_less @ nat @ I2 @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_7181_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_7182_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X4: B,Y4: B] : ( ord_less_eq @ A @ ( F2 @ X4 ) @ ( F2 @ Y4 ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_7183_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R3: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R3 @ ( map @ B @ A @ F2 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X4: B,Y4: B] : ( R3 @ ( F2 @ X4 ) @ ( F2 @ Y4 ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_7184_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_7185_sorted__wrt__upt,axiom,
    ! [M2: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M2 @ N2 ) ) ).

% sorted_wrt_upt
thf(fact_7186_sorted__upt,axiom,
    ! [M2: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M2 @ N2 ) ) ).

% sorted_upt
thf(fact_7187_sorted__wrt1,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( sorted_wrt @ A @ P @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_7188_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N2: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N2 @ X ) ) ) ).

% sorted_replicate
thf(fact_7189_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_7190_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_7191_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7192_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_7193_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_7194_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_7195_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_7196_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4
              @ X
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_7197_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu3: A,Uv3: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_7198_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A5 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_7199_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_7200_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > A > $o] : ( sorted_wrt @ A @ P @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_7201_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I6: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs @ I6 ) ) ) ) ).

% sorted_nths
thf(fact_7202_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_7203_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_remdups
thf(fact_7204_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs ) ) ).

% sorted_wrt01
thf(fact_7205_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X @ X4 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_7206_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Ys ) )
               => ( ord_less @ A @ X @ X4 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_7207_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys )
           => ( ( ( set2 @ A @ Ys )
                = ( set2 @ A @ Xs ) )
             => ( Ys = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_7208_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o,Q: A > A > $o] :
      ( ! [X3: A,Y2: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( P @ X3 @ Y2 )
             => ( Q @ X3 @ Y2 ) ) ) )
     => ( ( sorted_wrt @ A @ P @ Xs )
       => ( sorted_wrt @ A @ Q @ Xs ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_7209_sorted__wrt__append,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( ( sorted_wrt @ A @ P @ Xs )
        & ( sorted_wrt @ A @ P @ Ys )
        & ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Ys ) )
               => ( P @ X4 @ Y4 ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_7210_sorted__wrt__drop,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N2: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( drop @ A @ N2 @ Xs ) ) ) ).

% sorted_wrt_drop
thf(fact_7211_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N2 @ Xs ) ) ) ) ).

% sorted_drop
thf(fact_7212_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N2: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N2 @ Xs ) ) ) ) ).

% sorted_take
thf(fact_7213_sorted__wrt__take,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,N2: nat] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( take @ A @ N2 @ Xs ) ) ) ).

% sorted_wrt_take
thf(fact_7214_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_7215_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa2 )
     => ~ ! [X3: A,Ys4: list @ A] :
            ( ( Xa2
              = ( cons @ A @ X3 @ Ys4 ) )
           => ( ! [Xa3: A] :
                  ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                 => ( X @ X3 @ Xa3 ) )
              & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_7216_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( cons @ A @ X @ Ys ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Ys ) )
           => ( P @ X @ X4 ) )
        & ( sorted_wrt @ A @ P @ Ys ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_7217_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
               => ! [Y4: A] :
                    ( ( member @ A @ Y4 @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X4 @ Y4 ) ) ) ) ) ) ).

% sorted_append
thf(fact_7218_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_7219_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_7220_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A,Y: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa2 )
        = Y )
     => ( ( ( Xa2
            = ( nil @ A ) )
         => ~ Y )
       => ~ ! [X3: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X3 @ Ys4 ) )
             => ( Y
                = ( ~ ( ! [Y4: A] :
                          ( ( member @ A @ Y4 @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X3 @ Y4 ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_7221_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa2 )
     => ( ( Xa2
         != ( nil @ A ) )
       => ~ ! [X3: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X3 @ Ys4 ) )
             => ~ ( ! [Xa: A] :
                      ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                     => ( X @ X3 @ Xa ) )
                  & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_7222_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ? [X3: list @ A] :
              ( ( ( set2 @ A @ X3 )
                = A5 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X3 )
              & ( distinct @ A @ X3 )
              & ! [Y5: list @ A] :
                  ( ( ( ( set2 @ A @ Y5 )
                      = A5 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y5 )
                    & ( distinct @ A @ Y5 ) )
                 => ( Y5 = X3 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_7223_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_7224_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ A2
                @ ( remove1 @ A @ A2 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_7225_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_7226_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ~ ! [L4: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L4 )
               => ( ( ( set2 @ A @ L4 )
                    = A5 )
                 => ( ( size_size @ ( list @ A ) @ L4 )
                   != ( finite_card @ A @ A5 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_7227_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_7228_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_7229_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I2 @ ( nth @ nat @ Ns @ I2 ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_7230_sorted__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_7231_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_7232_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,L: list @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A5 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A5 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A5 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_7233_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X4: A] : X4
                @ A2
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_7234_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_7235_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ~ ! [L4: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L4 ) )
               => ( ( ( set2 @ B @ L4 )
                    = A5 )
                 => ( ( size_size @ ( list @ B ) @ L4 )
                   != ( finite_card @ B @ A5 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_7236_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) ).

% rev_is_rev_conv
thf(fact_7237_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) ).

% rev_rev_ident
thf(fact_7238_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_7239_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_7240_set__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rev
thf(fact_7241_length__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rev
thf(fact_7242_rev__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) ).

% rev_append
thf(fact_7243_distinct__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rev
thf(fact_7244_rev__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( rev @ A @ ( replicate @ A @ N2 @ X ) )
      = ( replicate @ A @ N2 @ X ) ) ).

% rev_replicate
thf(fact_7245_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_rev
thf(fact_7246_inj__on__rev,axiom,
    ! [A: $tType,A5: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A5 ) ).

% inj_on_rev
thf(fact_7247_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_7248_singleton__rev__conv,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( ( cons @ A @ X @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( ( cons @ A @ X @ ( nil @ A ) )
        = Xs ) ) ).

% singleton_rev_conv
thf(fact_7249_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_7250_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs ) ) ) ).

% rev_map
thf(fact_7251_rev__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs ) ) ) ) ).

% rev_concat
thf(fact_7252_sorted__upto,axiom,
    ! [M2: int,N2: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M2 @ N2 ) ) ).

% sorted_upto
thf(fact_7253_sorted__wrt__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X4: A,Y4: A] : ( P @ Y4 @ X4 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_7254_sorted__wrt__upto,axiom,
    ! [I2: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I2 @ J ) ) ).

% sorted_wrt_upto
thf(fact_7255_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( zip @ A @ B @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys ) )
        = ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ) ).

% zip_rev
thf(fact_7256_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( inj_on @ B @ A @ F2 @ S2 ) ) ).

% folding_insort_key.inj_on
thf(fact_7257_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_7258_rev__swap,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) ).

% rev_swap
thf(fact_7259_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_7260_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
       => ( distinct @ B @ Xs ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_7261_drop__rev,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) @ Xs ) ) ) ).

% drop_rev
thf(fact_7262_rev__drop,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( rev @ A @ ( drop @ A @ I2 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_drop
thf(fact_7263_rev__take,axiom,
    ! [A: $tType,I2: nat,Xs: list @ A] :
      ( ( rev @ A @ ( take @ A @ I2 @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I2 ) @ ( rev @ A @ Xs ) ) ) ).

% rev_take
thf(fact_7264_take__rev,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( drop @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) @ Xs ) ) ) ).

% take_rev
thf(fact_7265_rotate__rev,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( rotate @ A @ N2 @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( rotate @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) @ Xs ) ) ) ).

% rotate_rev
thf(fact_7266_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X4: A] : X4 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_7267_rev__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N2 ) ) ) ) ) ).

% rev_nth
thf(fact_7268_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y ) ) ) ).

% rev_update
thf(fact_7269_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_7270_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I4 ) ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_7271_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J3 ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_7272_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J ) @ ( nth @ A @ Xs @ I2 ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_7273_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I2 ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J ) @ I2 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_7274_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I2 )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I2 ) ) ) ) ).

% transpose_column
thf(fact_7275_filter__filter,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P @ ( filter2 @ A @ Q @ Xs ) )
      = ( filter2 @ A
        @ ^ [X4: A] :
            ( ( Q @ X4 )
            & ( P @ X4 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_7276_filter__True,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = Xs ) ) ).

% filter_True
thf(fact_7277_filter__append,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( filter2 @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_append
thf(fact_7278_remove1__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P @ X )
     => ( ( remove1 @ A @ X @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% remove1_filter_not
thf(fact_7279_removeAll__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ~ ( P @ X )
     => ( ( removeAll @ A @ X @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% removeAll_filter_not
thf(fact_7280_set__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( collect @ A
        @ ^ [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
            & ( P @ X4 ) ) ) ) ).

% set_filter
thf(fact_7281_filter__False,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ~ ( P @ X3 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_7282_length__concat__rev,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) ) ) ).

% length_concat_rev
thf(fact_7283_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_7284_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_7285_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G2: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X4: A] :
                ( X4
                = ( G2 @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_7286_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,P: A > $o] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) ).

% sorted_wrt_filter
thf(fact_7287_rev__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( rev @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( rev @ A @ Xs ) ) ) ).

% rev_filter
thf(fact_7288_filter__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N2: nat] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( replicate @ A @ N2 @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_7289_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( filter2 @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( filter2 @ A @ P @ Xs ) ) ) ) ).

% filter.simps(2)
thf(fact_7290_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( member @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter2 @ A @ P @ Xs )
        @ ( filter2 @ A
          @ ^ [X4: A] :
              ~ ( P @ X4 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_7291_filter__remove1,axiom,
    ! [A: $tType,Q: A > $o,X: A,Xs: list @ A] :
      ( ( filter2 @ A @ Q @ ( remove1 @ A @ X @ Xs ) )
      = ( remove1 @ A @ X @ ( filter2 @ A @ Q @ Xs ) ) ) ).

% filter_remove1
thf(fact_7292_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X4: A] :
            ( filter2 @ A
            @ ^ [Y4: A] : ( X4 != Y4 ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_7293_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,X: B,F2: B > A,Xs: list @ B] :
          ( ~ ( P @ X )
         => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
            = ( filter2 @ B @ P @ Xs ) ) ) ) ).

% filter_insort_triv
thf(fact_7294_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( filter2 @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_7295_filter__shuffles,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( image @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( shuffles @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_shuffles
thf(fact_7296_inter__set__filter,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X4: A] : ( member @ A @ X4 @ A5 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_7297_remdups__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( remdups @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( remdups @ A @ Xs ) ) ) ).

% remdups_filter
thf(fact_7298_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X4: A] :
                ~ ( P @ X4 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_7299_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_7300_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_7301_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% filter_is_subset
thf(fact_7302_filter__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( filter2 @ A @ P @ Xs )
          = ( filter2 @ A @ Q @ Ys ) ) ) ) ).

% filter_cong
thf(fact_7303_filter__id__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = Xs )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) ) ) ).

% filter_id_conv
thf(fact_7304_empty__filter__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( filter2 @ A @ P @ Xs ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X4 ) ) ) ) ).

% empty_filter_conv
thf(fact_7305_filter__empty__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X4 ) ) ) ) ).

% filter_empty_conv
thf(fact_7306_replicate__length__filter,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
              @ X )
            @ Xs ) )
        @ X )
      = ( filter2 @ A
        @ ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
          @ X )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_7307_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X @ Xs ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs3 ) ) )
            & ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X4 ) )
            & ( P @ X )
            & ( Xs
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_7308_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter2 @ A @ P @ Ys ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs3 ) ) )
            & ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X4 ) )
            & ( P @ X )
            & ( Xs
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_7309_filter__eq__ConsD,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X @ Xs ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs2 ) ) )
          & ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X2 ) )
          & ( P @ X )
          & ( Xs
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_7310_Cons__eq__filterD,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( filter2 @ A @ P @ Ys ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs2 ) ) )
          & ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X2 ) )
          & ( P @ X )
          & ( Xs
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_7311_distinct__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( filter2 @ A @ P @ Xs ) ) ) ).

% distinct_filter
thf(fact_7312_filter__concat,axiom,
    ! [A: $tType,P4: A > $o,Xs: list @ ( list @ A )] :
      ( ( filter2 @ A @ P4 @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P4 ) @ Xs ) ) ) ).

% filter_concat
thf(fact_7313_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,P: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ).

% distinct_map_filter
thf(fact_7314_filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% filter_map
thf(fact_7315_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert2 @ A @ Y @ ( set2 @ A @ Xs ) ) )
     => ( ( filter2 @ A
          @ ^ [X4: A] :
              ( ( F2 @ Y )
              = ( F2 @ X4 ) )
          @ Xs )
        = ( filter2 @ A
          @ ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
            @ Y )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_7316_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G2: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X4: B] :
                  ( ( F2 @ X4 )
                  = ( G2 @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_7317_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) ) ).

% sum_list_filter_le_nat
thf(fact_7318_filter__in__nths,axiom,
    ! [A: $tType,Xs: list @ A,S: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ( filter2 @ A
          @ ^ [X4: A] : ( member @ A @ X4 @ ( set2 @ A @ ( nths @ A @ Xs @ S ) ) )
          @ Xs )
        = ( nths @ A @ Xs @ S ) ) ) ).

% filter_in_nths
thf(fact_7319_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P: B > $o,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ~ ( P @ X3 )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_7320_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( P @ X )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_7321_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert2 @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X4: A] : ( X4 != Y )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_7322_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] :
                ~ ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_7323_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] : ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_7324_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] :
                ~ ( member @ A @ X4 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_7325_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X4: A] : ( member @ A @ X4 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_7326_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( nths @ A @ Xs3
            @ ( collect @ nat
              @ ^ [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
                  & ( P3 @ ( nth @ A @ Xs3 @ I4 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_7327_length__filter__conv__card,axiom,
    ! [A: $tType,P4: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P4 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P4 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_7328_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_7329_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X4: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X4 ) )
                    @ Xs ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_7330_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_7331_nth__transpose,axiom,
    ! [A: $tType,I2: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I2 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs3: list @ A] : ( nth @ A @ Xs3 @ I2 )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_7332_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I2 ) ) ) ) ) ).

% transpose_column_length
thf(fact_7333_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L ) )
              & ( ( set2 @ B @ L )
                = A5 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A5 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_7334_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_7335_tl__upt,axiom,
    ! [M2: nat,N2: nat] :
      ( ( tl @ nat @ ( upt @ M2 @ N2 ) )
      = ( upt @ ( suc @ M2 ) @ N2 ) ) ).

% tl_upt
thf(fact_7336_tl__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys ) ) ) ).

% tl_append2
thf(fact_7337_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( cons @ A @ X @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_7338_length__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_7339_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_7340_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) ).

% hd_Cons_tl
thf(fact_7341_tl__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( tl @ A @ ( replicate @ A @ N2 @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X ) ) ).

% tl_replicate
thf(fact_7342_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_7343_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A2 ) ) ) ) ).

% list.map_sel(2)
thf(fact_7344_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_tl
thf(fact_7345_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X224: list @ A] : X224 ) ) ).

% tl_def
thf(fact_7346_distinct__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( tl @ A @ Xs ) ) ) ).

% distinct_tl
thf(fact_7347_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys )
        @ ^ [Z5: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys )
        @ Xs ) ) ).

% tl_append
thf(fact_7348_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List3: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List3
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List3
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List3 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List3 ) ) ) ) )
       => ( List = List3 ) ) ) ).

% list.expand
thf(fact_7349_take__tl,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( take @ A @ N2 @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( take @ A @ ( suc @ N2 ) @ Xs ) ) ) ).

% take_tl
thf(fact_7350_tl__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( tl @ A @ ( drop @ A @ N2 @ Xs ) )
      = ( drop @ A @ N2 @ ( tl @ A @ Xs ) ) ) ).

% tl_drop
thf(fact_7351_drop__Suc,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( drop @ A @ ( suc @ N2 ) @ Xs )
      = ( drop @ A @ N2 @ ( tl @ A @ Xs ) ) ) ).

% drop_Suc
thf(fact_7352_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A2: list @ A,X: A] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( member @ A @ X @ ( set2 @ A @ ( tl @ A @ A2 ) ) )
       => ( member @ A @ X @ ( set2 @ A @ A2 ) ) ) ) ).

% list.set_sel(2)
thf(fact_7353_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_7354_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_7355_list_Osel_I3_J,axiom,
    ! [A: $tType,X212: A,X223: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X212 @ X223 ) )
      = X223 ) ).

% list.sel(3)
thf(fact_7356_Nil__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X4: A] :
            ( Xs
            = ( cons @ A @ X4 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_7357_tl__Nil,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X4: A] :
            ( Xs
            = ( cons @ A @ X4 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_7358_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_7359_tl__take,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( tl @ A @ ( take @ A @ N2 @ Xs ) )
      = ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( tl @ A @ Xs ) ) ) ).

% tl_take
thf(fact_7360_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F12: B,F23: A > ( list @ A ) > B,List2: list @ A] :
            ( if @ B
            @ ( List2
              = ( nil @ A ) )
            @ F12
            @ ( F23 @ ( hd @ A @ List2 ) @ ( tl @ A @ List2 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_7361_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs3 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_7362_nth__tl,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( suc @ N2 ) ) ) ) ).

% nth_tl
thf(fact_7363_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_7364_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z: A,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( ( Xs
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs )
            = Z )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs ) @ Ys ) ) )
        | ( ( Ys
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys )
            = Z )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ ( tl @ A @ Ys ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_7365_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F1 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_7366_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_7367_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B,B5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( ord_less_eq @ ( set @ B ) @ B5 @ S2 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ B5 ) )
           => ( ( finite_finite @ B @ A5 )
             => ( ( finite_finite @ B @ B5 )
               => ( A5 = B5 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_7368_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_7369_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P6 ) ) )
          @ ( zip @ A @ nat @ Xs @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P6 ) )
          @ ( zip @ A @ nat @ Xs @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_7370_take__Suc,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N2 ) @ Xs )
        = ( cons @ A @ ( hd @ A @ Xs ) @ ( take @ A @ N2 @ ( tl @ A @ Xs ) ) ) ) ) ).

% take_Suc
thf(fact_7371_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_7372_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) )
            = A5 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_7373_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) )
          = ( finite_card @ B @ A5 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_7374_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_7375_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_7376_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_7377_nths__shift__lemma,axiom,
    ! [A: $tType,A5: set @ nat,Xs: list @ A,I2: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A5 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ I2 @ ( plus_plus @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P6 ) @ I2 ) @ A5 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_7378_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs3: list @ A,A7: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P6: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P6 ) @ A7 )
              @ ( zip @ A @ nat @ Xs3 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_7379_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 )
              = ( nil @ B ) )
            = ( A5
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_7380_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs ) @ S2 )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( distinct @ B @ Xs )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( set2 @ B @ Xs ) )
              = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_7381_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_7382_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert2 @ B @ X @ A5 ) )
            = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A5 @ ( insert2 @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_7383_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A5: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert2 @ B @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ B @ A5 )
         => ( ~ ( member @ B @ X @ A5 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert2 @ B @ X @ A5 ) )
              = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A5 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_7384_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_7385_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,Y: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( member @ B @ X @ S2 )
       => ( ( member @ B @ Y @ S2 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_7386_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X4: list @ A] :
              ( X4
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_7387_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X4: B] : ( if @ ( option @ A ) @ ( P @ X4 ) @ ( some @ A @ ( F2 @ X4 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_7388_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Xs: list @ B,Ys: list @ B,A2: A] :
      ( ( foldr @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) @ A2 )
      = ( foldr @ B @ A @ F2 @ Xs @ ( foldr @ B @ A @ F2 @ Ys @ A2 ) ) ) ).

% foldr_append
thf(fact_7389_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N2: nat,X: B] :
      ( ( foldr @ B @ A @ F2 @ ( replicate @ B @ N2 @ X ) )
      = ( compow @ ( A > A ) @ N2 @ ( F2 @ X ) ) ) ).

% foldr_replicate
thf(fact_7390_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G2: B > A > A,F2: C > B,Xs: list @ C,A2: A] :
      ( ( foldr @ B @ A @ G2 @ ( map @ C @ B @ F2 @ Xs ) @ A2 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G2 @ F2 ) @ Xs @ A2 ) ) ).

% foldr_map
thf(fact_7391_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,L: list @ B,K: list @ B,F2: B > A > A,G2: B > A > A] :
      ( ( A2 = B2 )
     => ( ( L = K )
       => ( ! [A4: A,X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ L ) )
             => ( ( F2 @ X3 @ A4 )
                = ( G2 @ X3 @ A4 ) ) )
         => ( ( foldr @ B @ A @ F2 @ L @ A2 )
            = ( foldr @ B @ A @ G2 @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_7392_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_7393_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F2 @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( F2 @ X ) @ ( foldr @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_Cons
thf(fact_7394_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs3 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_7395_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( foldr @ B @ A
              @ ^ [X4: B,B3: A] : ( plus_plus @ A @ ( F3 @ X4 ) @ ( times_times @ A @ A3 @ B3 ) )
              @ Xs3
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_7396_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_7397_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = Y ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_7398_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs3: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs3 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X4: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X4 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_7399_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X4: list @ A] :
              ( X4
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_7400_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_7401_takeWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( takeWhile @ A @ P @ ( takeWhile @ A @ P @ Xs ) )
      = ( takeWhile @ A @ P @ Xs ) ) ).

% takeWhile_idem
thf(fact_7402_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = Xs )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_7403_takeWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append1
thf(fact_7404_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys ) ) ) ) ).

% takeWhile_append2
thf(fact_7405_takeWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N2: nat] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( replicate @ A @ N2 @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_7406_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( takeWhile @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_7407_takeWhile__tail,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A,L: list @ A] :
      ( ~ ( P @ X )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ X @ L ) ) )
        = ( takeWhile @ A @ P @ Xs ) ) ) ).

% takeWhile_tail
thf(fact_7408_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( takeWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_7409_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_7410_set__takeWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
        & ( P @ X ) ) ) ).

% set_takeWhileD
thf(fact_7411_takeWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ L ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( takeWhile @ A @ P @ L )
          = ( takeWhile @ A @ Q @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_7412_takeWhile__eq__take,axiom,
    ! [A: $tType] :
      ( ( takeWhile @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] : ( take @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs3 ) ) @ Xs3 ) ) ) ).

% takeWhile_eq_take
thf(fact_7413_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_7414_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( takeWhile @ A @ P @ Xs ) ) ) ).

% distinct_takeWhile
thf(fact_7415_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_7416_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: A > $o,Xs: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( takeWhile @ A @ P @ Xs ) @ Ys )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ A @ $o @ ( product_prod @ A @ B ) @ P @ ( product_fst @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_fst
thf(fact_7417_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,P: B > $o,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs @ ( takeWhile @ B @ P @ Ys ) )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ B @ $o @ ( product_prod @ A @ B ) @ P @ ( product_snd @ A @ B ) ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) ).

% zip_takeWhile_snd
thf(fact_7418_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_7419_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% takeWhile_nth
thf(fact_7420_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_7421_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys ) ) ) )
      & ( ~ ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( P @ X2 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_7422_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_7423_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ J )
         => ( P @ ( nth @ A @ Xs @ I3 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_7424_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,P: A > $o] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N2 )
         => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I3 ) ) ) )
     => ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ~ ( P @ ( nth @ A @ Xs @ N2 ) ) )
       => ( ( takeWhile @ A @ P @ Xs )
          = ( take @ A @ N2 @ Xs ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_7425_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X4: B] : ( ord_less @ A @ T2 @ ( F2 @ X4 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X4: B] : ( ord_less @ A @ T2 @ ( F2 @ X4 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_7426_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_7427_transpose_Opelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ ( list @ A ) ) )
           => ( ( Y
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) )
                 => ( ( Y
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X3
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs2
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_7428_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
        = ( transpose @ A @ Xss ) ) ) ).

% transpose.psimps(2)
thf(fact_7429_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_7430_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P @ Xss2 )
               => ( P @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) )
               => ( ( P
                    @ ( cons @ ( list @ A ) @ Xs2
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) ) ) )
           => ( P @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_7431_min__list_Opelims,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A,Y: A] :
          ( ( ( min_list @ A @ X )
            = Y )
         => ( ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ X )
           => ( ! [X3: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ( ( Y
                      = ( case_list @ A @ A @ X3
                        @ ^ [A3: A,List2: list @ A] : ( ord_min @ A @ X3 @ ( min_list @ A @ Xs2 ) )
                        @ Xs2 ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( cons @ A @ X3 @ Xs2 ) ) ) )
             => ~ ( ( X
                    = ( nil @ A ) )
                 => ( ( Y
                      = ( undefined @ A ) )
                   => ~ ( accp @ ( list @ A ) @ ( min_list_rel @ A ) @ ( nil @ A ) ) ) ) ) ) ) ) ).

% min_list.pelims
thf(fact_7432_remdups__adj_Opelims,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ( ( Y
                    = ( cons @ A @ X3 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
           => ~ ! [X3: A,Y2: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) )
                 => ( ( ( ( X3 = Y2 )
                       => ( Y
                          = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs2 ) ) ) )
                      & ( ( X3 != Y2 )
                       => ( Y
                          = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_7433_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F3: A > nat,Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F3 @ ( hd @ A @ Xs3 ) ) @ ( size_list @ A @ F3 @ ( tl @ A @ Xs3 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_7434_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ? [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
                & ( P @ X2 ) )
           => ( ( find @ A @ P @ Xs )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X4: A] :
                        ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
                        & ( P @ X4 ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_7435_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: A > nat,G2: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F2 @ ( map @ B @ A @ G2 @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F2 @ G2 ) @ Xs ) ) ).

% size_list_map
thf(fact_7436_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ F2 @ Ys ) ) ) ).

% size_list_append
thf(fact_7437_find__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( find @ A @ P @ Xs )
          = ( find @ A @ Q @ Ys ) ) ) ) ).

% find_cong
thf(fact_7438_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less_eq @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_7439_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > nat,G2: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ G2 @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_7440_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_7441_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_7442_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: B > nat,G2: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F2 ) @ ( map @ A @ B @ G2 ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F2 @ G2 ) ) ) ).

% list.size_gen_o_map
thf(fact_7443_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( some @ A @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( find @ A @ P @ Xs ) ) ) ) ).

% find.simps(2)
thf(fact_7444_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu2: A > $o] :
      ( ( find @ A @ Uu2 @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_7445_find__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( find @ A @ P @ Xs )
        = ( none @ A ) )
      = ( ~ ? [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
              & ( P @ X4 ) ) ) ) ).

% find_None_iff
thf(fact_7446_find__None__iff2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P @ Xs ) )
      = ( ~ ? [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
              & ( P @ X4 ) ) ) ) ).

% find_None_iff2
thf(fact_7447_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_7448_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X212: A,X223: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X212 @ X223 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X212 ) @ ( size_list @ A @ X @ X223 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_7449_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X )
        = ( find @ A @ P @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_7450_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,X: A] :
      ( ( ( find @ A @ P @ Xs )
        = ( some @ A @ X ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_7451_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F3: B > nat,Xs3: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F3 @ Xs3 ) ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_7452_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_7453_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys2 ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy2: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy2 )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy2 ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys2 ) ) ) ) ).

% set_relcomp
thf(fact_7454_relpow__add,axiom,
    ! [A: $tType,M2: nat,N2: nat,R3: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( plus_plus @ nat @ M2 @ N2 ) @ R3 )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M2 @ R3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R3 ) ) ) ).

% relpow_add
thf(fact_7455_union__comp__emptyR,axiom,
    ! [A: $tType,A5: set @ ( product_prod @ A @ A ),B5: set @ ( product_prod @ A @ A ),C6: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A5 @ B5 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ A5 @ C6 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ A5 @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ B5 @ C6 ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyR
thf(fact_7456_union__comp__emptyL,axiom,
    ! [A: $tType,A5: set @ ( product_prod @ A @ A ),C6: set @ ( product_prod @ A @ A ),B5: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A5 @ C6 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ B5 @ C6 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ A5 @ B5 ) @ C6 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyL
thf(fact_7457_extract__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs ) ) )
        & ( P @ Y )
        & ~ ? [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Ys ) )
              & ( P @ X4 ) ) ) ) ).

% extract_Some_iff
thf(fact_7458_extract__SomeE,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y @ Zs ) ) )
        & ( P @ Y )
        & ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
              & ( P @ X2 ) ) ) ) ).

% extract_SomeE
thf(fact_7459_extract__Nil__code,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( extract @ A @ P @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_7460_extract__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X4: A] :
              ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
              & ( P @ X4 ) ) ) ) ).

% extract_None_iff
thf(fact_7461_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X @ Xs ) ) ) ) )
      & ( ~ ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys3: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y4: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X @ Ys3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y4 @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_7462_min__ext__compat,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R3 @ S2 ) @ R3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R3 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R3 ) ) ) ).

% min_ext_compat
thf(fact_7463_max__ext__compat,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R3 @ S2 ) @ R3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R3 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S2 ) @ ( insert2 @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R3 ) ) ) ).

% max_ext_compat
thf(fact_7464_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y4: A,Ys3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y4 @ Ys3 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% extract_def
thf(fact_7465_dropWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( dropWhile @ A @ P @ ( dropWhile @ A @ P @ Xs ) )
      = ( dropWhile @ A @ P @ Xs ) ) ).

% dropWhile_idem
thf(fact_7466_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_7467_dropWhile__append1,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append1
thf(fact_7468_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
        = ( dropWhile @ A @ P @ Ys ) ) ) ).

% dropWhile_append2
thf(fact_7469_dropWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N2: nat] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( nil @ A ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N2 @ X ) )
          = ( replicate @ A @ N2 @ X ) ) ) ) ).

% dropWhile_replicate
thf(fact_7470_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( dropWhile @ A @ P @ Xs ) )
      = Xs ) ).

% takeWhile_dropWhile_id
thf(fact_7471_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_7472_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_7473_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_7474_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ).

% distinct_dropWhile
thf(fact_7475_hd__dropWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
       != ( nil @ A ) )
     => ~ ( P @ ( hd @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% hd_dropWhile
thf(fact_7476_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = Xs )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_7477_set__dropWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% set_dropWhileD
thf(fact_7478_dropWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ L ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( dropWhile @ A @ P @ L )
          = ( dropWhile @ A @ Q @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_7479_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( dropWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_7480_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y4: A] : ( Y4 = X )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_7481_dropWhile__append3,axiom,
    ! [A: $tType,P: A > $o,Y: A,Xs: list @ A,Ys: list @ A] :
      ( ~ ( P @ Y )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) )
        = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ).

% dropWhile_append3
thf(fact_7482_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( dropWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_7483_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ( Xs
          = ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( cons @ A @ Y @ Ys ) ) )
        & ~ ( P @ Y ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_7484_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
         => ~ ( P @ X3 ) )
     => ( ( takeWhile @ A @ P @ Xs )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% takeWhile_eq_filter
thf(fact_7485_dropWhile__eq__drop,axiom,
    ! [A: $tType] :
      ( ( dropWhile @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] : ( drop @ A @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P3 @ Xs3 ) ) @ Xs3 ) ) ) ).

% dropWhile_eq_drop
thf(fact_7486_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( dropWhile @ A @ P @ Ys ) ) )
      & ( ~ ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
             => ( P @ X2 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append
thf(fact_7487_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X4: A,Xa4: list @ A] : ( some @ A @ X4 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% find_dropWhile
thf(fact_7488_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X4: A] : ( X4 = Y )
            @ Ys ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_7489_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X4: A] :
                ( X4
                = ( hd @ A @ Ys ) )
            @ ( tl @ A @ Ys ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_7490_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_7491_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y4: A] : ( Y4 != X )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y4: A] : ( Y4 != X )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_7492_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y4: A] : ( Y4 != X )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y4: A] : ( Y4 != X )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_7493_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F3: A > $o,Xs3: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F3 @ Xs3 ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F3 ) @ Xs3 ) ) ) ) ).

% partition_filter_conv
thf(fact_7494_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X4: A] : ( product_Pair @ A @ A @ X4 @ X4 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_7495_partition__filter1,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ Xs ) ) ).

% partition_filter1
thf(fact_7496_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( partition @ A @ P @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_7497_partition__P,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Yes ) )
           => ( P @ X2 ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ No4 ) )
           => ~ ( P @ X2 ) ) ) ) ).

% partition_P
thf(fact_7498_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes2: list @ A,No: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Yes2 ) @ No ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X @ No ) ) )
        @ ( partition @ A @ P @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_7499_partition__filter2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs ) ) ).

% partition_filter2
thf(fact_7500_partition__set,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes ) @ ( set2 @ A @ No4 ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_7501_prod_Oset__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G2: B > A,Xs: list @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
          = ( groups5270119922927024881d_list @ A @ ( map @ B @ A @ G2 @ ( remdups @ B @ Xs ) ) ) ) ) ).

% prod.set_conv_list
thf(fact_7502_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M2: nat] :
      ( ( nat_prod_encode @ ( nat_prod_decode_aux @ K @ M2 ) )
      = ( plus_plus @ nat @ ( nat_triangle @ K ) @ M2 ) ) ).

% prod_encode_prod_decode_aux
thf(fact_7503_prod__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( cons @ A @ X @ Xs ) )
          = ( times_times @ A @ X @ ( groups5270119922927024881d_list @ A @ Xs ) ) ) ) ).

% prod_list.Cons
thf(fact_7504_prod__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A @ ( nil @ A ) )
        = ( one_one @ A ) ) ) ).

% prod_list.Nil
thf(fact_7505_prod__list_Oappend,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups5270119922927024881d_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( times_times @ A @ ( groups5270119922927024881d_list @ A @ Xs ) @ ( groups5270119922927024881d_list @ A @ Ys ) ) ) ) ).

% prod_list.append
thf(fact_7506_prod__list__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( semiring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [Xs: list @ A] :
          ( ( ( groups5270119922927024881d_list @ A @ Xs )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( zero_zero @ A ) @ ( set2 @ A @ Xs ) ) ) ) ).

% prod_list_zero_iff
thf(fact_7507_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : ( ord_less_eq @ nat @ A2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_7508_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_7509_prod__encode__def,axiom,
    ( nat_prod_encode
    = ( product_case_prod @ nat @ nat @ nat
      @ ^ [M: nat,N: nat] : ( plus_plus @ nat @ ( nat_triangle @ ( plus_plus @ nat @ M @ N ) ) @ M ) ) ) ).

% prod_encode_def
thf(fact_7510_prod__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( groups5270119922927024881d_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( times_times @ A ) @ Xs3 @ ( one_one @ A ) ) ) ) ) ).

% prod_list.eq_foldr
thf(fact_7511_prod_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Xs: list @ B,G2: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G2 @ ( set2 @ B @ Xs ) )
            = ( groups5270119922927024881d_list @ A @ ( map @ B @ A @ G2 @ Xs ) ) ) ) ) ).

% prod.distinct_set_conv_list
thf(fact_7512_lists__empty,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert2 @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% lists_empty
thf(fact_7513_INF__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( inf_inf @ A ) @ F2 ) @ Xs @ ( top_top @ A ) ) ) ) ).

% INF_set_fold
thf(fact_7514_Cons__in__lists__iff,axiom,
    ! [A: $tType,X: A,Xs: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( lists @ A @ A5 ) )
      = ( ( member @ A @ X @ A5 )
        & ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) ) ) ) ).

% Cons_in_lists_iff
thf(fact_7515_in__listsI,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( member @ A @ X3 @ A5 ) )
     => ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) ) ) ).

% in_listsI
thf(fact_7516_lists__Int__eq,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( lists @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) )
      = ( inf_inf @ ( set @ ( list @ A ) ) @ ( lists @ A @ A5 ) @ ( lists @ A @ B5 ) ) ) ).

% lists_Int_eq
thf(fact_7517_append__in__lists__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( lists @ A @ A5 ) )
      = ( ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
        & ( member @ ( list @ A ) @ Ys @ ( lists @ A @ A5 ) ) ) ) ).

% append_in_lists_conv
thf(fact_7518_fold__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,Xs: list @ B,Ys: list @ B] :
      ( ( fold @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) )
      = ( comp @ A @ A @ A @ ( fold @ B @ A @ F2 @ Ys ) @ ( fold @ B @ A @ F2 @ Xs ) ) ) ).

% fold_append
thf(fact_7519_fold__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N2: nat,X: B] :
      ( ( fold @ B @ A @ F2 @ ( replicate @ B @ N2 @ X ) )
      = ( compow @ ( A > A ) @ N2 @ ( F2 @ X ) ) ) ).

% fold_replicate
thf(fact_7520_lists__UNIV,axiom,
    ! [A: $tType] :
      ( ( lists @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% lists_UNIV
thf(fact_7521_fold__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,G2: B > A > A,F2: C > B,Xs: list @ C] :
      ( ( fold @ B @ A @ G2 @ ( map @ C @ B @ F2 @ Xs ) )
      = ( fold @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G2 @ F2 ) @ Xs ) ) ).

% fold_map
thf(fact_7522_fold__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs: list @ A] :
      ( ( fold @ A @ B @ F2 @ ( cons @ A @ X @ Xs ) )
      = ( comp @ B @ B @ B @ ( fold @ A @ B @ F2 @ Xs ) @ ( F2 @ X ) ) ) ).

% fold_Cons
thf(fact_7523_fold__commute__apply,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H2: B > C,G2: A > B > B,F2: A > C > C,S: B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H2 @ ( G2 @ X3 ) )
            = ( comp @ C @ C @ B @ ( F2 @ X3 ) @ H2 ) ) )
     => ( ( H2 @ ( fold @ A @ B @ G2 @ Xs @ S ) )
        = ( fold @ A @ C @ F2 @ Xs @ ( H2 @ S ) ) ) ) ).

% fold_commute_apply
thf(fact_7524_fold__commute,axiom,
    ! [A: $tType,C: $tType,B: $tType,Xs: list @ A,H2: B > C,G2: A > B > B,F2: A > C > C] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( comp @ B @ C @ B @ H2 @ ( G2 @ X3 ) )
            = ( comp @ C @ C @ B @ ( F2 @ X3 ) @ H2 ) ) )
     => ( ( comp @ B @ C @ B @ H2 @ ( fold @ A @ B @ G2 @ Xs ) )
        = ( comp @ C @ C @ B @ ( fold @ A @ C @ F2 @ Xs ) @ H2 ) ) ) ).

% fold_commute
thf(fact_7525_foldr__conv__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F3: B > A > A,Xs3: list @ B] : ( fold @ B @ A @ F3 @ ( rev @ B @ Xs3 ) ) ) ) ).

% foldr_conv_fold
thf(fact_7526_fold__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,X: B,Xs: list @ B,S: A] :
      ( ( fold @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) @ S )
      = ( fold @ B @ A @ F2 @ Xs @ ( F2 @ X @ S ) ) ) ).

% fold_simps(2)
thf(fact_7527_lists_OCons,axiom,
    ! [A: $tType,A2: A,A5: set @ A,L: list @ A] :
      ( ( member @ A @ A2 @ A5 )
     => ( ( member @ ( list @ A ) @ L @ ( lists @ A @ A5 ) )
       => ( member @ ( list @ A ) @ ( cons @ A @ A2 @ L ) @ ( lists @ A @ A5 ) ) ) ) ).

% lists.Cons
thf(fact_7528_listsE,axiom,
    ! [A: $tType,X: A,L: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ X @ L ) @ ( lists @ A @ A5 ) )
     => ~ ( ( member @ A @ X @ A5 )
         => ~ ( member @ ( list @ A ) @ L @ ( lists @ A @ A5 ) ) ) ) ).

% listsE
thf(fact_7529_lists_Osimps,axiom,
    ! [A: $tType,A2: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ A2 @ ( lists @ A @ A5 ) )
      = ( ( A2
          = ( nil @ A ) )
        | ? [A3: A,L2: list @ A] :
            ( ( A2
              = ( cons @ A @ A3 @ L2 ) )
            & ( member @ A @ A3 @ A5 )
            & ( member @ ( list @ A ) @ L2 @ ( lists @ A @ A5 ) ) ) ) ) ).

% lists.simps
thf(fact_7530_lists_Ocases,axiom,
    ! [A: $tType,A2: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ A2 @ ( lists @ A @ A5 ) )
     => ( ( A2
         != ( nil @ A ) )
       => ~ ! [A4: A,L4: list @ A] :
              ( ( A2
                = ( cons @ A @ A4 @ L4 ) )
             => ( ( member @ A @ A4 @ A5 )
               => ~ ( member @ ( list @ A ) @ L4 @ ( lists @ A @ A5 ) ) ) ) ) ) ).

% lists.cases
thf(fact_7531_lists_ONil,axiom,
    ! [A: $tType,A5: set @ A] : ( member @ ( list @ A ) @ ( nil @ A ) @ ( lists @ A @ A5 ) ) ).

% lists.Nil
thf(fact_7532_fold__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,S: A] :
      ( ( fold @ B @ A @ F2 @ ( nil @ B ) @ S )
      = S ) ).

% fold_simps(1)
thf(fact_7533_lists__IntI,axiom,
    ! [A: $tType,L: list @ A,A5: set @ A,B5: set @ A] :
      ( ( member @ ( list @ A ) @ L @ ( lists @ A @ A5 ) )
     => ( ( member @ ( list @ A ) @ L @ ( lists @ A @ B5 ) )
       => ( member @ ( list @ A ) @ L @ ( lists @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) ) ) ) ).

% lists_IntI
thf(fact_7534_listrel__refl__on,axiom,
    ! [A: $tType,A5: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( refl_on @ A @ A5 @ R )
     => ( refl_on @ ( list @ A ) @ ( lists @ A @ A5 ) @ ( listrel @ A @ A @ R ) ) ) ).

% listrel_refl_on
thf(fact_7535_in__listsD,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( member @ A @ X2 @ A5 ) ) ) ).

% in_listsD
thf(fact_7536_in__lists__conv__set,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( member @ ( list @ A ) @ Xs @ ( lists @ A @ A5 ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( member @ A @ X4 @ A5 ) ) ) ) ).

% in_lists_conv_set
thf(fact_7537_List_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,Xs: list @ B,Ys: list @ B,F2: B > A > A,G2: B > A > A] :
      ( ( A2 = B2 )
     => ( ( Xs = Ys )
       => ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ( F2 @ X3 )
                = ( G2 @ X3 ) ) )
         => ( ( fold @ B @ A @ F2 @ Xs @ A2 )
            = ( fold @ B @ A @ G2 @ Ys @ B2 ) ) ) ) ) ).

% List.fold_cong
thf(fact_7538_fold__invariant,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Q: A > $o,P: B > $o,S: B,F2: A > B > B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( Q @ X3 ) )
     => ( ( P @ S )
       => ( ! [X3: A,S3: B] :
              ( ( Q @ X3 )
             => ( ( P @ S3 )
               => ( P @ ( F2 @ X3 @ S3 ) ) ) )
         => ( P @ ( fold @ A @ B @ F2 @ Xs @ S ) ) ) ) ) ).

% fold_invariant
thf(fact_7539_lists__eq__set,axiom,
    ! [A: $tType] :
      ( ( lists @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A7 ) ) ) ) ).

% lists_eq_set
thf(fact_7540_union__set__fold,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A5 )
      = ( fold @ A @ ( set @ A ) @ ( insert2 @ A ) @ Xs @ A5 ) ) ).

% union_set_fold
thf(fact_7541_rev__conv__fold,axiom,
    ! [A: $tType] :
      ( ( rev @ A )
      = ( ^ [Xs3: list @ A] : ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs3 @ ( nil @ A ) ) ) ) ).

% rev_conv_fold
thf(fact_7542_fold__Cons__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs )
      = ( append @ A @ ( rev @ A @ Xs ) ) ) ).

% fold_Cons_rev
thf(fact_7543_lists__mono,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( lists @ A @ A5 ) @ ( lists @ A @ B5 ) ) ) ).

% lists_mono
thf(fact_7544_fold__rev,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X3: A,Y2: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) )
              = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) )
     => ( ( fold @ A @ B @ F2 @ ( rev @ A @ Xs ) )
        = ( fold @ A @ B @ F2 @ Xs ) ) ) ).

% fold_rev
thf(fact_7545_fold__plus__sum__list__rev,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( fold @ A @ A @ ( plus_plus @ A ) @ Xs )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( rev @ A @ Xs ) ) ) ) ) ).

% fold_plus_sum_list_rev
thf(fact_7546_fold__remove1__split,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B,X: A] :
      ( ! [X3: A,Y2: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) )
              = ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) ) ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( ( fold @ A @ B @ F2 @ Xs )
          = ( comp @ B @ B @ B @ ( fold @ A @ B @ F2 @ ( remove1 @ A @ X @ Xs ) ) @ ( F2 @ X ) ) ) ) ) ).

% fold_remove1_split
thf(fact_7547_foldr__fold,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X3: A,Y2: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
           => ( ( comp @ B @ B @ B @ ( F2 @ Y2 ) @ ( F2 @ X3 ) )
              = ( comp @ B @ B @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) ) ) )
     => ( ( foldr @ A @ B @ F2 @ Xs )
        = ( fold @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_fold
thf(fact_7548_lists__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A5: set @ B] :
      ( ( lists @ A @ ( image @ B @ A @ F2 @ A5 ) )
      = ( image @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( lists @ B @ A5 ) ) ) ).

% lists_image
thf(fact_7549_fold__append__concat__rev,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( fold @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss )
      = ( append @ A @ ( concat @ A @ ( rev @ ( list @ A ) @ Xss ) ) ) ) ).

% fold_append_concat_rev
thf(fact_7550_Sup__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Sup_Sup @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% Sup_set_fold
thf(fact_7551_Inf__set__fold,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Xs: list @ A] :
          ( ( complete_Inf_Inf @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ ( top_top @ A ) ) ) ) ).

% Inf_set_fold
thf(fact_7552_Max_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic643756798349783984er_Max @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( ord_max @ A ) @ Xs @ X ) ) ) ).

% Max.set_eq_fold
thf(fact_7553_Min_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic643756798350308766er_Min @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( ord_min @ A ) @ Xs @ X ) ) ) ).

% Min.set_eq_fold
thf(fact_7554_Collect__finite__eq__lists,axiom,
    ! [A: $tType] :
      ( ( collect @ ( set @ A ) @ ( finite_finite @ A ) )
      = ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( lists @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% Collect_finite_eq_lists
thf(fact_7555_Collect__finite__subset__eq__lists,axiom,
    ! [A: $tType,T6: set @ A] :
      ( ( collect @ ( set @ A )
        @ ^ [A7: set @ A] :
            ( ( finite_finite @ A @ A7 )
            & ( ord_less_eq @ ( set @ A ) @ A7 @ T6 ) ) )
      = ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( lists @ A @ T6 ) ) ) ).

% Collect_finite_subset_eq_lists
thf(fact_7556_listrel__subset,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),A5: set @ A] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R
        @ ( product_Sigma @ A @ A @ A5
          @ ^ [Uu3: A] : A5 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R )
        @ ( product_Sigma @ ( list @ A ) @ ( list @ A ) @ ( lists @ A @ A5 )
          @ ^ [Uu3: list @ A] : ( lists @ A @ A5 ) ) ) ) ).

% listrel_subset
thf(fact_7557_SUP__set__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
          = ( fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( sup_sup @ A ) @ F2 ) @ Xs @ ( bot_bot @ A ) ) ) ) ).

% SUP_set_fold
thf(fact_7558_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( gcd_Gcd @ A @ A5 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_7559_sum__mult__sum__if__inj,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,G2: C > B,A5: set @ A,B5: set @ C] :
          ( ( inj_on @ ( product_prod @ A @ C ) @ B
            @ ( product_case_prod @ A @ C @ B
              @ ^ [A3: A,B3: C] : ( times_times @ B @ ( F2 @ A3 ) @ ( G2 @ B3 ) ) )
            @ ( product_Sigma @ A @ C @ A5
              @ ^ [Uu3: A] : B5 ) )
         => ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A5 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G2 @ B5 ) )
            = ( groups7311177749621191930dd_sum @ B @ B @ ( id @ B )
              @ ( collect @ B
                @ ^ [Uu3: B] :
                  ? [A3: A,B3: C] :
                    ( ( Uu3
                      = ( times_times @ B @ ( F2 @ A3 ) @ ( G2 @ B3 ) ) )
                    & ( member @ A @ A3 @ A5 )
                    & ( member @ C @ B3 @ B5 ) ) ) ) ) ) ) ).

% sum_mult_sum_if_inj
thf(fact_7560_of__nat__eq__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( id @ nat ) ) ).

% of_nat_eq_id
thf(fact_7561_list_Omap__id0,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A @ ( id @ A ) )
      = ( id @ ( list @ A ) ) ) ).

% list.map_id0
thf(fact_7562_id__funpow,axiom,
    ! [A: $tType,N2: nat] :
      ( ( compow @ ( A > A ) @ N2 @ ( id @ A ) )
      = ( id @ A ) ) ).

% id_funpow
thf(fact_7563_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_7564_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( top_top @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Gcd_UNIV
thf(fact_7565_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% push_bit_0_id
thf(fact_7566_drop__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% drop_bit_0
thf(fact_7567_fold__Nil,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B] :
      ( ( fold @ A @ B @ F2 @ ( nil @ A ) )
      = ( id @ B ) ) ).

% fold_Nil
thf(fact_7568_fold__id,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,F2: A > B > B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = ( id @ B ) ) )
     => ( ( fold @ A @ B @ F2 @ Xs )
        = ( id @ B ) ) ) ).

% fold_id
thf(fact_7569_fold__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P: B > $o,Xs: list @ B] :
      ( ( fold @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( fold @ B @ A
        @ ^ [X4: B] : ( if @ ( A > A ) @ ( P @ X4 ) @ ( F2 @ X4 ) @ ( id @ A ) )
        @ Xs ) ) ).

% fold_filter
thf(fact_7570_list_Omap__id,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A @ ( id @ A ) @ T2 )
      = T2 ) ).

% list.map_id
thf(fact_7571_List_Omap_Oidentity,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4 )
      = ( id @ ( list @ A ) ) ) ).

% List.map.identity
thf(fact_7572_Gcd__1,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A5: set @ A] :
          ( ( member @ A @ ( one_one @ A ) @ A5 )
         => ( ( gcd_Gcd @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_1
thf(fact_7573_Gcd__nat__eq__one,axiom,
    ! [N4: set @ nat] :
      ( ( member @ nat @ ( one_one @ nat ) @ N4 )
     => ( ( gcd_Gcd @ nat @ N4 )
        = ( one_one @ nat ) ) ) ).

% Gcd_nat_eq_one
thf(fact_7574_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: A,A5: set @ A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( member @ A @ A2 @ A5 )
           => ( ( gcd_Gcd @ A @ A5 )
              = ( one_one @ A ) ) ) ) ) ).

% Gcd_eq_1_I
thf(fact_7575_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 )
      = ( id @ A ) ) ).

% funpow_simps_right(1)
thf(fact_7576_foldr__Nil,axiom,
    ! [A: $tType,B: $tType,F2: A > B > B] :
      ( ( foldr @ A @ B @ F2 @ ( nil @ A ) )
      = ( id @ B ) ) ).

% foldr_Nil
thf(fact_7577_foldr__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,P: B > $o,Xs: list @ B] :
      ( ( foldr @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( foldr @ B @ A
        @ ^ [X4: B] : ( if @ ( A > A ) @ ( P @ X4 ) @ ( F2 @ X4 ) @ ( id @ A ) )
        @ Xs ) ) ).

% foldr_filter
thf(fact_7578_Gcd__set__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [Xs: list @ A] :
          ( ( gcd_Gcd @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ).

% Gcd_set_eq_fold
thf(fact_7579_Rat_Opositive__def,axiom,
    ( positive
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ $o @ $o @ rep_Rat @ ( id @ $o )
      @ ^ [X4: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ X4 ) ) ) ) ) ).

% Rat.positive_def
thf(fact_7580_sort__key__conv__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
         => ( ( linorder_sort_key @ B @ A @ F2 @ Xs )
            = ( fold @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 ) @ Xs @ ( nil @ B ) ) ) ) ) ).

% sort_key_conv_fold
thf(fact_7581_sort__upt,axiom,
    ! [M2: nat,N2: nat] :
      ( ( linorder_sort_key @ nat @ nat
        @ ^ [X4: nat] : X4
        @ ( upt @ M2 @ N2 ) )
      = ( upt @ M2 @ N2 ) ) ).

% sort_upt
thf(fact_7582_sort__upto,axiom,
    ! [I2: int,J: int] :
      ( ( linorder_sort_key @ int @ int
        @ ^ [X4: int] : X4
        @ ( upto @ I2 @ J ) )
      = ( upto @ I2 @ J ) ) ).

% sort_upto
thf(fact_7583_sort__key__simps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A] :
          ( ( linorder_sort_key @ B @ A @ F2 @ ( nil @ B ) )
          = ( nil @ B ) ) ) ).

% sort_key_simps(1)
thf(fact_7584_set__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( set2 @ B @ Xs ) ) ) ).

% set_sort
thf(fact_7585_length__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( size_size @ ( list @ B ) @ Xs ) ) ) ).

% length_sort
thf(fact_7586_distinct__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( distinct @ B @ Xs ) ) ) ).

% distinct_sort
thf(fact_7587_sort__key__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( linorder_sort_key @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
          = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) ) ) ) ).

% sort_key_simps(2)
thf(fact_7588_sort__key__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [C2: B,Xs: list @ A] :
          ( ( linorder_sort_key @ A @ B
            @ ^ [X4: A] : C2
            @ Xs )
          = Xs ) ) ).

% sort_key_const
thf(fact_7589_filter__sort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A,Xs: list @ B] :
          ( ( filter2 @ B @ P @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) )
          = ( linorder_sort_key @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ).

% filter_sort
thf(fact_7590_sort__key__stable,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,K: B,Xs: list @ A] :
          ( ( filter2 @ A
            @ ^ [Y4: A] :
                ( ( F2 @ Y4 )
                = K )
            @ ( linorder_sort_key @ A @ B @ F2 @ Xs ) )
          = ( filter2 @ A
            @ ^ [Y4: A] :
                ( ( F2 @ Y4 )
                = K )
            @ Xs ) ) ) ).

% sort_key_stable
thf(fact_7591_sorted__sort__id,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( linorder_sort_key @ A @ A
              @ ^ [X4: A] : X4
              @ Xs )
            = Xs ) ) ) ).

% sorted_sort_id
thf(fact_7592_sorted__sort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( linorder_sort_key @ A @ A
            @ ^ [X4: A] : X4
            @ Xs ) ) ) ).

% sorted_sort
thf(fact_7593_sorted__sort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_sort_key
thf(fact_7594_sorted__list__of__set__sort__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
          = ( linorder_sort_key @ A @ A
            @ ^ [X4: A] : X4
            @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_list_of_set_sort_remdups
thf(fact_7595_sort__conv__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( linorder_sort_key @ A @ A
            @ ^ [X4: A] : X4
            @ Xs )
          = ( fold @ A @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X4: A] : X4 )
            @ Xs
            @ ( nil @ A ) ) ) ) ).

% sort_conv_fold
thf(fact_7596_sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linorder_sort_key @ B @ A )
        = ( ^ [F3: B > A,Xs3: list @ B] : ( foldr @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F3 ) @ Xs3 @ ( nil @ B ) ) ) ) ) ).

% sort_key_def
thf(fact_7597_Bleast__code,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( bleast @ A @ ( set2 @ A @ Xs ) @ P )
          = ( case_list @ A @ A @ ( abort_Bleast @ A @ ( set2 @ A @ Xs ) @ P )
            @ ^ [X4: A,Xs3: list @ A] : X4
            @ ( filter2 @ A @ P
              @ ( linorder_sort_key @ A @ A
                @ ^ [X4: A] : X4
                @ Xs ) ) ) ) ) ).

% Bleast_code
thf(fact_7598_of__rat__def,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A )
        = ( map_fun @ rat @ ( product_prod @ int @ int ) @ A @ A @ rep_Rat @ ( id @ A )
          @ ^ [X4: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X4 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X4 ) ) ) ) ) ) ).

% of_rat_def
thf(fact_7599_one__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( one_one @ A )
            = ( field_char_0_of_rat @ A @ A2 ) )
          = ( ( one_one @ rat )
            = A2 ) ) ) ).

% one_eq_of_rat_iff
thf(fact_7600_of__rat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( field_char_0_of_rat @ A @ A2 )
            = ( one_one @ A ) )
          = ( A2
            = ( one_one @ rat ) ) ) ) ).

% of_rat_eq_1_iff
thf(fact_7601_of__rat__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( one_one @ rat ) )
        = ( one_one @ A ) ) ) ).

% of_rat_1
thf(fact_7602_of__rat__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W2: num] :
          ( ( field_char_0_of_rat @ A @ ( numeral_numeral @ rat @ W2 ) )
          = ( numeral_numeral @ A @ W2 ) ) ) ).

% of_rat_numeral_eq
thf(fact_7603_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less @ rat @ ( zero_zero @ rat ) @ R ) ) ) ).

% zero_less_of_rat_iff
thf(fact_7604_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( zero_zero @ A ) )
          = ( ord_less @ rat @ R @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_less_0_iff
thf(fact_7605_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R ) ) ) ).

% one_less_of_rat_iff
thf(fact_7606_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_7607_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ rat @ R @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_le_0_iff
thf(fact_7608_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ R ) ) ) ).

% zero_le_of_rat_iff
thf(fact_7609_of__rat__neg__one,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% of_rat_neg_one
thf(fact_7610_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R ) ) ) ).

% one_le_of_rat_iff
thf(fact_7611_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_7612_of__rat__neg__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W2: num] :
          ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W2 ) ) ) ) ).

% of_rat_neg_numeral_eq
thf(fact_7613_of__rat__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat,S: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R ) @ ( field_char_0_of_rat @ A @ S ) )
          = ( ord_less_eq @ rat @ R @ S ) ) ) ).

% of_rat_less_eq
thf(fact_7614_of__rat__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( times_times @ rat @ A2 @ B2 ) )
          = ( times_times @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_mult
thf(fact_7615_of__rat__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R: rat,S: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R ) @ ( field_char_0_of_rat @ A @ S ) )
          = ( ord_less @ rat @ R @ S ) ) ) ).

% of_rat_less
thf(fact_7616_of__rat__dense,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ? [Q3: rat] :
          ( ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ Q3 ) )
          & ( ord_less @ real @ ( field_char_0_of_rat @ real @ Q3 ) @ Y ) ) ) ).

% of_rat_dense
thf(fact_7617_of__rat__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,N2: nat] :
          ( ( field_char_0_of_rat @ A @ ( power_power @ rat @ A2 @ N2 ) )
          = ( power_power @ A @ ( field_char_0_of_rat @ A @ A2 ) @ N2 ) ) ) ).

% of_rat_power
thf(fact_7618_of__rat__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( plus_plus @ rat @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_add
thf(fact_7619_of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,B2: rat] :
          ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ).

% of_rat_divide
thf(fact_7620_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: rat,A2: rat] :
          ( ( B2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ) ).

% nonzero_of_rat_divide
thf(fact_7621_of__rat__rat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: int,A2: int] :
          ( ( B2
           != ( zero_zero @ int ) )
         => ( ( field_char_0_of_rat @ A @ ( fract @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) ) ) ) ).

% of_rat_rat
thf(fact_7622_of__rat_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A )
        = ( ^ [X4: rat] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ ( rep_Rat @ X4 ) ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ ( rep_Rat @ X4 ) ) ) ) ) ) ) ).

% of_rat.rep_eq
thf(fact_7623_plus__rat__def,axiom,
    ( ( plus_plus @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X4 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) ) ) ) ).

% plus_rat_def
thf(fact_7624_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X4: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X4 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_fst @ int @ int @ X4 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_7625_one__rat__def,axiom,
    ( ( one_one @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ) ).

% one_rat_def
thf(fact_7626_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X4: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X4
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X4 ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_7627_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_7628_times__rat__def,axiom,
    ( ( times_times @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ rep_Rat @ ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat )
      @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_fst @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) ) ) ) ).

% times_rat_def
thf(fact_7629_plus__rat_Oabs__eq,axiom,
    ! [Xa2: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa2 @ Xa2 )
     => ( ( ratrel @ X @ X )
       => ( ( plus_plus @ rat @ ( abs_Rat @ Xa2 ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa2 ) @ ( product_snd @ int @ int @ X ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa2 ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% plus_rat.abs_eq
thf(fact_7630_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_7631_ratrel__iff,axiom,
    ( ratrel
    = ( ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X4 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y4 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X4 ) ) ) ) ) ) ).

% ratrel_iff
thf(fact_7632_one__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ).

% one_rat.rsp
thf(fact_7633_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_7634_ratrel__def,axiom,
    ( ratrel
    = ( ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X4 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y4 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X4 ) ) ) ) ) ) ).

% ratrel_def
thf(fact_7635_of__rat_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X: product_prod @ int @ int] :
          ( ( ratrel @ X @ X )
         => ( ( field_char_0_of_rat @ A @ ( abs_Rat @ X ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ).

% of_rat.abs_eq
thf(fact_7636_times__rat_Oabs__eq,axiom,
    ! [Xa2: product_prod @ int @ int,X: product_prod @ int @ int] :
      ( ( ratrel @ Xa2 @ Xa2 )
     => ( ( ratrel @ X @ X )
       => ( ( times_times @ rat @ ( abs_Rat @ Xa2 ) @ ( abs_Rat @ X ) )
          = ( abs_Rat @ ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ Xa2 ) @ ( product_fst @ int @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ Xa2 ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ) ) ).

% times_rat.abs_eq
thf(fact_7637_Rat_Opositive_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( positive @ ( abs_Rat @ X ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% Rat.positive.abs_eq
thf(fact_7638_minus__set__fold,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( set2 @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A5 ) ) ).

% minus_set_fold
thf(fact_7639_finite__sequence__to__countable__set,axiom,
    ! [A: $tType,X8: set @ A] :
      ( ( countable_countable @ A @ X8 )
     => ~ ! [F5: nat > ( set @ A )] :
            ( ! [I: nat] : ( ord_less_eq @ ( set @ A ) @ ( F5 @ I ) @ X8 )
           => ( ! [I: nat] : ( ord_less_eq @ ( set @ A ) @ ( F5 @ I ) @ ( F5 @ ( suc @ I ) ) )
             => ( ! [I: nat] : ( finite_finite @ A @ ( F5 @ I ) )
               => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F5 @ ( top_top @ ( set @ nat ) ) ) )
                 != X8 ) ) ) ) ) ).

% finite_sequence_to_countable_set
thf(fact_7640_all__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T10: set @ A] :
            ( ( ( countable_countable @ A @ T10 )
              & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) ) )
           => ( P @ T10 ) ) )
      = ( ! [T10: set @ B] :
            ( ( ( countable_countable @ B @ T10 )
              & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T10 ) )
           => ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% all_countable_subset_image_inj
thf(fact_7641_ex__countable__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T10: set @ A] :
            ( ( countable_countable @ A @ T10 )
            & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T10 ) ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T10 )
            & ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% ex_countable_subset_image_inj
thf(fact_7642_countable__image__eq__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F2 @ S2 ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( ( image @ B @ A @ F2 @ S2 )
              = ( image @ B @ A @ F2 @ T10 ) )
            & ( inj_on @ B @ A @ F2 @ T10 ) ) ) ) ).

% countable_image_eq_inj
thf(fact_7643_countable__image__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B] :
      ( ( countable_countable @ A @ ( image @ B @ A @ F2 @ S2 ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( ( image @ B @ A @ F2 @ S2 )
              = ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% countable_image_eq
thf(fact_7644_countable__subset__image,axiom,
    ! [A: $tType,B: $tType,B5: set @ A,F2: B > A,A5: set @ B] :
      ( ( ( countable_countable @ A @ B5 )
        & ( ord_less_eq @ ( set @ A ) @ B5 @ ( image @ B @ A @ F2 @ A5 ) ) )
      = ( ? [A18: set @ B] :
            ( ( countable_countable @ B @ A18 )
            & ( ord_less_eq @ ( set @ B ) @ A18 @ A5 )
            & ( B5
              = ( image @ B @ A @ F2 @ A18 ) ) ) ) ) ).

% countable_subset_image
thf(fact_7645_ex__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T10: set @ A] :
            ( ( countable_countable @ A @ T10 )
            & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T10 ) ) )
      = ( ? [T10: set @ B] :
            ( ( countable_countable @ B @ T10 )
            & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 )
            & ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% ex_countable_subset_image
thf(fact_7646_all__countable__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T10: set @ A] :
            ( ( ( countable_countable @ A @ T10 )
              & ( ord_less_eq @ ( set @ A ) @ T10 @ ( image @ B @ A @ F2 @ S2 ) ) )
           => ( P @ T10 ) ) )
      = ( ! [T10: set @ B] :
            ( ( ( countable_countable @ B @ T10 )
              & ( ord_less_eq @ ( set @ B ) @ T10 @ S2 ) )
           => ( P @ ( image @ B @ A @ F2 @ T10 ) ) ) ) ) ).

% all_countable_subset_image
thf(fact_7647_infinite__countable__subset_H,axiom,
    ! [A: $tType,X8: set @ A] :
      ( ~ ( finite_finite @ A @ X8 )
     => ? [C7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ C7 @ X8 )
          & ( countable_countable @ A @ C7 )
          & ~ ( finite_finite @ A @ C7 ) ) ) ).

% infinite_countable_subset'
thf(fact_7648_countable__Collect__finite__subset,axiom,
    ! [A: $tType,T6: set @ A] :
      ( ( countable_countable @ A @ T6 )
     => ( countable_countable @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [A7: set @ A] :
              ( ( finite_finite @ A @ A7 )
              & ( ord_less_eq @ ( set @ A ) @ A7 @ T6 ) ) ) ) ) ).

% countable_Collect_finite_subset
thf(fact_7649_countable__subset,axiom,
    ! [A: $tType,A5: set @ A,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ( countable_countable @ A @ B5 )
       => ( countable_countable @ A @ A5 ) ) ) ).

% countable_subset
thf(fact_7650_remove__code_I1_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remove @ A @ X @ ( set2 @ A @ Xs ) )
      = ( set2 @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% remove_code(1)
thf(fact_7651_mono__ccINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I6: set @ C,A5: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I6 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A5 @ I6 ) ) )
              @ ( complete_Inf_Inf @ B
                @ ( image @ C @ B
                  @ ^ [X4: C] : ( F2 @ ( A5 @ X4 ) )
                  @ I6 ) ) ) ) ) ) ).

% mono_ccINF
thf(fact_7652_mono__ccInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A5 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A5 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ) ) ).

% mono_ccInf
thf(fact_7653_ccSup__upper2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,U: A,V2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ U @ A5 )
           => ( ( ord_less_eq @ A @ V2 @ U )
             => ( ord_less_eq @ A @ V2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ) ).

% ccSup_upper2
thf(fact_7654_ccSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ B2 )
            = ( ! [X4: A] :
                  ( ( member @ A @ X4 @ A5 )
                 => ( ord_less_eq @ A @ X4 @ B2 ) ) ) ) ) ) ).

% ccSup_le_iff
thf(fact_7655_ccSup__upper,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% ccSup_upper
thf(fact_7656_ccSup__least,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,Z: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ Z ) ) ) ) ).

% ccSup_least
thf(fact_7657_ccSup__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B5: set @ A,A5: set @ A] :
          ( ( countable_countable @ A @ B5 )
         => ( ( countable_countable @ A @ A5 )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ? [X2: A] :
                      ( ( member @ A @ X2 @ B5 )
                      & ( ord_less_eq @ A @ A4 @ X2 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B5 ) ) ) ) ) ) ).

% ccSup_mono
thf(fact_7658_less__ccSup__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( countable_countable @ A @ S2 )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) )
            = ( ? [X4: A] :
                  ( ( member @ A @ X4 @ S2 )
                  & ( ord_less @ A @ A2 @ X4 ) ) ) ) ) ) ).

% less_ccSup_iff
thf(fact_7659_ccInf__greatest,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,Z: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A5 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A5 ) ) ) ) ) ).

% ccInf_greatest
thf(fact_7660_le__ccInf__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A5 ) )
            = ( ! [X4: A] :
                  ( ( member @ A @ X4 @ A5 )
                 => ( ord_less_eq @ A @ B2 @ X4 ) ) ) ) ) ) ).

% le_ccInf_iff
thf(fact_7661_ccInf__lower2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,U: A,V2: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ U @ A5 )
           => ( ( ord_less_eq @ A @ U @ V2 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ V2 ) ) ) ) ) ).

% ccInf_lower2
thf(fact_7662_ccInf__lower,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ X ) ) ) ) ).

% ccInf_lower
thf(fact_7663_ccInf__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B5: set @ A,A5: set @ A] :
          ( ( countable_countable @ A @ B5 )
         => ( ( countable_countable @ A @ A5 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B5 )
                 => ? [X2: A] :
                      ( ( member @ A @ X2 @ A5 )
                      & ( ord_less_eq @ A @ X2 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B5 ) ) ) ) ) ) ).

% ccInf_mono
thf(fact_7664_ccInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( countable_countable @ A @ S2 )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 )
            = ( ? [X4: A] :
                  ( ( member @ A @ X4 @ S2 )
                  & ( ord_less @ A @ X4 @ A2 ) ) ) ) ) ) ).

% ccInf_less_iff
thf(fact_7665_ccSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B5: set @ A,A5: set @ A] :
          ( ( countable_countable @ A @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B5 ) ) ) ) ) ).

% ccSup_subset_mono
thf(fact_7666_ccInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B5 ) ) ) ) ) ).

% ccInf_superset_mono
thf(fact_7667_ccSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,B5: set @ C,F2: B > A,G2: C > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( countable_countable @ C @ B5 )
           => ( ! [N3: B] :
                  ( ( member @ B @ N3 @ A5 )
                 => ? [X2: C] :
                      ( ( member @ C @ X2 @ B5 )
                      & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G2 @ X2 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% ccSUP_mono
thf(fact_7668_ccSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A5 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ U ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ) ).

% ccSUP_least
thf(fact_7669_ccSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I2: B,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I2 @ A5 )
           => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% ccSUP_upper
thf(fact_7670_ccSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U )
            = ( ! [X4: B] :
                  ( ( member @ B @ X4 @ A5 )
                 => ( ord_less_eq @ A @ ( F2 @ X4 ) @ U ) ) ) ) ) ) ).

% ccSUP_le_iff
thf(fact_7671_ccSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I2: B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I2 @ A5 )
           => ( ( ord_less_eq @ A @ U @ ( F2 @ I2 ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ) ).

% ccSUP_upper2
thf(fact_7672_less__ccSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A5: set @ B,A2: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
            = ( ? [X4: B] :
                  ( ( member @ B @ X4 @ A5 )
                  & ( ord_less @ A @ A2 @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% less_ccSUP_iff
thf(fact_7673_ccINF__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,B5: set @ C,F2: B > A,G2: C > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( countable_countable @ C @ B5 )
           => ( ! [M4: C] :
                  ( ( member @ C @ M4 @ B5 )
                 => ? [X2: B] :
                      ( ( member @ B @ X2 @ A5 )
                      & ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G2 @ M4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% ccINF_mono
thf(fact_7674_ccINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I2: B,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I2 @ A5 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( F2 @ I2 ) ) ) ) ) ).

% ccINF_lower
thf(fact_7675_ccINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,I2: B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( member @ B @ I2 @ A5 )
           => ( ( ord_less_eq @ A @ ( F2 @ I2 ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ U ) ) ) ) ) ).

% ccINF_lower2
thf(fact_7676_le__ccINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) )
            = ( ! [X4: B] :
                  ( ( member @ B @ X4 @ A5 )
                 => ( ord_less_eq @ A @ U @ ( F2 @ X4 ) ) ) ) ) ) ) ).

% le_ccINF_iff
thf(fact_7677_ccINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A5 )
               => ( ord_less_eq @ A @ U @ ( F2 @ I3 ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ) ) ).

% ccINF_greatest
thf(fact_7678_ccINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A5: set @ B,F2: B > A,A2: A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ A2 )
            = ( ? [X4: B] :
                  ( ( member @ B @ X4 @ A5 )
                  & ( ord_less @ A @ ( F2 @ X4 ) @ A2 ) ) ) ) ) ) ).

% ccINF_less_iff
thf(fact_7679_ccSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( countable_countable @ A @ B5 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A5 ) @ ( complete_Sup_Sup @ A @ B5 ) ) ) ) ) ) ).

% ccSup_inter_less_eq
thf(fact_7680_less__eq__ccInf__inter,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( countable_countable @ A @ A5 )
         => ( ( countable_countable @ A @ B5 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A5 ) @ ( complete_Inf_Inf @ A @ B5 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A5 @ B5 ) ) ) ) ) ) ).

% less_eq_ccInf_inter
thf(fact_7681_ccSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B5: set @ B,A5: set @ B,F2: B > A,G2: B > A] :
          ( ( countable_countable @ B @ B5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A5 @ B5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A5 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% ccSUP_subset_mono
thf(fact_7682_ccINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A5: set @ B,B5: set @ B,F2: B > A,G2: B > A] :
          ( ( countable_countable @ B @ A5 )
         => ( ( ord_less_eq @ ( set @ B ) @ B5 @ A5 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ B5 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A5 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G2 @ B5 ) ) ) ) ) ) ) ).

% ccINF_superset_mono
thf(fact_7683_mono__ccSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A5: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A5 )
           => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A5 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ) ).

% mono_ccSup
thf(fact_7684_mono__ccSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I6: set @ C,A5: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I6 )
           => ( ord_less_eq @ B
              @ ( complete_Sup_Sup @ B
                @ ( image @ C @ B
                  @ ^ [X4: C] : ( F2 @ ( A5 @ X4 ) )
                  @ I6 ) )
              @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A5 @ I6 ) ) ) ) ) ) ) ).

% mono_ccSUP
thf(fact_7685_inter__coset__fold,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A5 @ ( coset @ A @ Xs ) )
      = ( fold @ A @ ( set @ A ) @ ( remove @ A ) @ Xs @ A5 ) ) ).

% inter_coset_fold
thf(fact_7686_Rat_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o @ ratrel
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X4: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ X4 ) ) )
    @ ^ [X4: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ X4 ) ) ) ) ).

% Rat.positive.rsp
thf(fact_7687_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
                  @ R3
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_7688_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
                @ R3
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_7689_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R3
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
                @ R3 )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_7690_UNIV__coset,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( coset @ A @ ( nil @ A ) ) ) ).

% UNIV_coset
thf(fact_7691_subset__code_I2_J,axiom,
    ! [B: $tType,A5: set @ B,Ys: list @ B] :
      ( ( ord_less_eq @ ( set @ B ) @ A5 @ ( coset @ B @ Ys ) )
      = ( ! [X4: B] :
            ( ( member @ B @ X4 @ ( set2 @ B @ Ys ) )
           => ~ ( member @ B @ X4 @ A5 ) ) ) ) ).

% subset_code(2)
thf(fact_7692_compl__coset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( coset @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% compl_coset
thf(fact_7693_coset__def,axiom,
    ! [A: $tType] :
      ( ( coset @ A )
      = ( ^ [Xs3: list @ A] : ( uminus_uminus @ ( set @ A ) @ ( set2 @ A @ Xs3 ) ) ) ) ).

% coset_def
thf(fact_7694_insert__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( insert2 @ A @ X @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( removeAll @ A @ X @ Xs ) ) ) ).

% insert_code(2)
thf(fact_7695_union__coset__filter,axiom,
    ! [A: $tType,Xs: list @ A,A5: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( coset @ A @ Xs ) @ A5 )
      = ( coset @ A
        @ ( filter2 @ A
          @ ^ [X4: A] :
              ~ ( member @ A @ X4 @ A5 )
          @ Xs ) ) ) ).

% union_coset_filter
thf(fact_7696_subset__code_I3_J,axiom,
    ! [C: $tType] :
      ~ ( ord_less_eq @ ( set @ C ) @ ( coset @ C @ ( nil @ C ) ) @ ( set2 @ C @ ( nil @ C ) ) ) ).

% subset_code(3)
thf(fact_7697_of__rat_Orsp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ A @ A @ ratrel
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
        @ ^ [X4: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X4 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X4 ) ) )
        @ ^ [X4: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X4 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X4 ) ) ) ) ) ).

% of_rat.rsp
thf(fact_7698_minus__coset__filter,axiom,
    ! [A: $tType,A5: set @ A,Xs: list @ A] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( coset @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X4: A] : ( member @ A @ X4 @ A5 )
          @ Xs ) ) ) ).

% minus_coset_filter
thf(fact_7699_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R3 @ ( bNF_rel_fun @ A @ B @ A @ B @ R3 @ R3 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
                @ R3
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_7700_butlast__power,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( compow @ ( ( list @ A ) > ( list @ A ) ) @ N2 @ ( butlast @ A ) @ Xs )
      = ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) @ Xs ) ) ).

% butlast_power
thf(fact_7701_butlast__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( butlast @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( tl @ A @ Xs ) ) ) ).

% butlast_rev
thf(fact_7702_butlast__snoc,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = Xs ) ).

% butlast_snoc
thf(fact_7703_length__butlast,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_butlast
thf(fact_7704_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ ratrel )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) ) ) ).

% Fract.rsp
thf(fact_7705_times__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_fst @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
    @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_fst @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) ) ) ).

% times_rat.rsp
thf(fact_7706_plus__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ratrel @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel )
    @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X4 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
    @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X4 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) ) ) ).

% plus_rat.rsp
thf(fact_7707_plus__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 ) )
    @ ( plus_plus @ nat )
    @ ( plus_plus @ nat ) ) ).

% plus_natural.rsp
thf(fact_7708_less__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less @ nat )
    @ ( ord_less @ nat ) ) ).

% less_natural.rsp
thf(fact_7709_times__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) )
    @ ( times_times @ int )
    @ ( times_times @ int ) ) ).

% times_integer.rsp
thf(fact_7710_times__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 ) )
    @ ( times_times @ nat )
    @ ( times_times @ nat ) ) ).

% times_natural.rsp
thf(fact_7711_divide__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 ) )
    @ ( divide_divide @ nat )
    @ ( divide_divide @ nat ) ) ).

% divide_natural.rsp
thf(fact_7712_divide__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > int ) @ ( int > int )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ int @ int
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) )
    @ ( divide_divide @ int )
    @ ( divide_divide @ int ) ) ).

% divide_integer.rsp
thf(fact_7713_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R3: A > B > $o] :
          ( ( R3 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R3 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
              @ R3
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_7714_num_Ocase__transfer,axiom,
    ! [A: $tType,B: $tType,S2: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A ) > ( num > A ) > num > A ) @ ( ( num > B ) > ( num > B ) > num > B ) @ S2
      @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( ( num > A ) > num > A ) @ ( ( num > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ A @ B
          @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
          @ S2 )
        @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
            @ S2 )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
            @ S2 ) ) )
      @ ( case_num @ A )
      @ ( case_num @ B ) ) ).

% num.case_transfer
thf(fact_7715_less__eq__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less_eq @ nat )
    @ ( ord_less_eq @ nat ) ) ).

% less_eq_natural.rsp
thf(fact_7716_map__butlast,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( butlast @ B @ Xs ) )
      = ( butlast @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_butlast
thf(fact_7717_butlast__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( butlast @ A @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( butlast @ A @ Xs ) ) ) ).

% butlast_tl
thf(fact_7718_distinct__butlast,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( butlast @ A @ Xs ) ) ) ).

% distinct_butlast
thf(fact_7719_drop__butlast,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( drop @ A @ N2 @ ( butlast @ A @ Xs ) )
      = ( butlast @ A @ ( drop @ A @ N2 @ Xs ) ) ) ).

% drop_butlast
thf(fact_7720_in__set__butlast__appendI,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
        | ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Ys ) ) ) )
     => ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ ( append @ A @ Xs @ Ys ) ) ) ) ) ).

% in_set_butlast_appendI
thf(fact_7721_in__set__butlastD,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% in_set_butlastD
thf(fact_7722_butlast_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% butlast.simps(1)
thf(fact_7723_butlast_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( butlast @ A @ Xs ) ) ) ) ) ).

% butlast.simps(2)
thf(fact_7724_butlast__append,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys ) ) ) ) ) ).

% butlast_append
thf(fact_7725_sorted__butlast,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( butlast @ A @ Xs ) ) ) ) ) ).

% sorted_butlast
thf(fact_7726_nth__butlast,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs ) ) )
     => ( ( nth @ A @ ( butlast @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ N2 ) ) ) ).

% nth_butlast
thf(fact_7727_take__butlast,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ N2 @ ( butlast @ A @ Xs ) )
        = ( take @ A @ N2 @ Xs ) ) ) ).

% take_butlast
thf(fact_7728_butlast__conv__take,axiom,
    ! [A: $tType] :
      ( ( butlast @ A )
      = ( ^ [Xs3: list @ A] : ( take @ A @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( one_one @ nat ) ) @ Xs3 ) ) ) ).

% butlast_conv_take
thf(fact_7729_butlast__list__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,X: A] :
      ( ( ( K
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs @ K @ X ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( K
         != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
       => ( ( butlast @ A @ ( list_update @ A @ Xs @ K @ X ) )
          = ( list_update @ A @ ( butlast @ A @ Xs ) @ K @ X ) ) ) ) ).

% butlast_list_update
thf(fact_7730_butlast__take,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( butlast @ A @ ( take @ A @ N2 @ Xs ) )
        = ( take @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% butlast_take
thf(fact_7731_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X4: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X4 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_fst @ int @ int @ X4 ) ) )
    @ ^ [X4: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X4 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_fst @ int @ int @ X4 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_7732_plus__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X4 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
    @ ( plus_plus @ rat ) ) ).

% plus_rat.transfer
thf(fact_7733_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X4: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X4 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_fst @ int @ int @ X4 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_7734_one__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) @ ( one_one @ rat ) ).

% one_rat.transfer
thf(fact_7735_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_7736_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ pcr_rat )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_7737_of__rat_Otransfer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ A @ A @ pcr_rat
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
        @ ^ [X4: product_prod @ int @ int] : ( divide_divide @ A @ ( ring_1_of_int @ A @ ( product_fst @ int @ int @ X4 ) ) @ ( ring_1_of_int @ A @ ( product_snd @ int @ int @ X4 ) ) )
        @ ( field_char_0_of_rat @ A ) ) ) ).

% of_rat.transfer
thf(fact_7738_times__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ) @ ( rat > rat ) @ pcr_rat @ ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat )
    @ ^ [X4: product_prod @ int @ int,Y4: product_prod @ int @ int] : ( product_Pair @ int @ int @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_fst @ int @ int @ Y4 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ X4 ) @ ( product_snd @ int @ int @ Y4 ) ) )
    @ ( times_times @ rat ) ) ).

% times_rat.transfer
thf(fact_7739_Rat_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ $o @ $o @ pcr_rat
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X4: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X4 ) @ ( product_snd @ int @ int @ X4 ) ) )
    @ positive ) ).

% Rat.positive.transfer
thf(fact_7740_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_7741_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_7742_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_7743_less__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( ord_less @ int ) ) ).

% less_int.transfer
thf(fact_7744_less__eq__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_int.transfer
thf(fact_7745_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_7746_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X4 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_7747_and__not__num_Opelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit0 @ N3 ) )
                 => ( ( Y
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa2
                      = ( bit1 @ N3 ) )
                   => ( ( Y
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y
                          = ( some @ num @ ( bit0 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit0 @ N3 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa2
                              = ( bit1 @ N3 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit0 @ N3 ) )
                               => ( ( Y
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                      @ ( bit_and_not_num @ M4 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_7748_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V2: nat] :
      ( ( intrel @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ U @ V2 ) )
      = ( ( plus_plus @ nat @ X @ V2 )
        = ( plus_plus @ nat @ U @ Y ) ) ) ).

% intrel_iff
thf(fact_7749_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_7750_intrel__def,axiom,
    ( intrel
    = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] :
              ( ( plus_plus @ nat @ X4 @ V5 )
              = ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% intrel_def
thf(fact_7751_less__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% less_int.rsp
thf(fact_7752_less__eq__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% less_eq_int.rsp
thf(fact_7753_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) ) ) ).

% minus_int.rsp
thf(fact_7754_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X4: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X4 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_7755_and__num_Opelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit0 @ N3 ) )
                 => ( ( Y
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa2
                      = ( bit1 @ N3 ) )
                   => ( ( Y
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit0 @ N3 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa2
                              = ( bit1 @ N3 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit0 @ N3 ) )
                               => ( ( Y
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_7756_xor__num_Opelims,axiom,
    ! [X: num,Xa2: num,Y: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit0 @ N3 ) )
                 => ( ( Y
                      = ( some @ num @ ( bit1 @ N3 ) ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa2
                      = ( bit1 @ N3 ) )
                   => ( ( Y
                        = ( some @ num @ ( bit0 @ N3 ) ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y
                          = ( some @ num @ ( bit1 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit0 @ N3 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa2
                              = ( bit1 @ N3 ) )
                           => ( ( Y
                                = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit0 @ N3 ) )
                               => ( ( Y
                                    = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y
                                      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
thf(fact_7757_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa2: num,Y: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa2
                    = ( bit0 @ M4 ) )
                 => ( ( Y
                      = ( bit1 @ M4 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M4 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [M4: num] :
                    ( ( Xa2
                      = ( bit1 @ M4 ) )
                   => ( ( Y
                        = ( bit1 @ M4 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M4 ) ) ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ one2 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa2
                            = ( bit0 @ M4 ) )
                         => ( ( Y
                              = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                 => ( ! [N3: num] :
                        ( ( X
                          = ( bit0 @ N3 ) )
                       => ! [M4: num] :
                            ( ( Xa2
                              = ( bit1 @ M4 ) )
                           => ( ( Y
                                = ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ one2 ) ) ) ) )
                     => ( ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa2
                                  = ( bit0 @ M4 ) )
                               => ( ( Y
                                    = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X
                                = ( bit1 @ N3 ) )
                             => ! [M4: num] :
                                  ( ( Xa2
                                    = ( bit1 @ M4 ) )
                                 => ( ( Y
                                      = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_7758_xor__num__rel__dict,axiom,
    bit_un2901131394128224187um_rel = bit_un3595099601533988841um_rel ).

% xor_num_rel_dict
thf(fact_7759_and__num__rel__dict,axiom,
    bit_un4731106466462545111um_rel = bit_un5425074673868309765um_rel ).

% and_num_rel_dict
thf(fact_7760_rcis__inverse,axiom,
    ! [R: real,A2: real] :
      ( ( inverse_inverse @ complex @ ( rcis @ R @ A2 ) )
      = ( rcis @ ( divide_divide @ real @ ( one_one @ real ) @ R ) @ ( uminus_uminus @ real @ A2 ) ) ) ).

% rcis_inverse
thf(fact_7761_Re__rcis,axiom,
    ! [R: real,A2: real] :
      ( ( re @ ( rcis @ R @ A2 ) )
      = ( times_times @ real @ R @ ( cos @ real @ A2 ) ) ) ).

% Re_rcis
thf(fact_7762_Im__rcis,axiom,
    ! [R: real,A2: real] :
      ( ( im @ ( rcis @ R @ A2 ) )
      = ( times_times @ real @ R @ ( sin @ real @ A2 ) ) ) ).

% Im_rcis
thf(fact_7763_cis__rcis__eq,axiom,
    ( cis
    = ( rcis @ ( one_one @ real ) ) ) ).

% cis_rcis_eq
thf(fact_7764_rcis__mult,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] :
      ( ( times_times @ complex @ ( rcis @ R1 @ A2 ) @ ( rcis @ R22 @ B2 ) )
      = ( rcis @ ( times_times @ real @ R1 @ R22 ) @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% rcis_mult
thf(fact_7765_rcis__divide,axiom,
    ! [R1: real,A2: real,R22: real,B2: real] :
      ( ( divide_divide @ complex @ ( rcis @ R1 @ A2 ) @ ( rcis @ R22 @ B2 ) )
      = ( rcis @ ( divide_divide @ real @ R1 @ R22 ) @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% rcis_divide
thf(fact_7766_rcis__def,axiom,
    ( rcis
    = ( ^ [R5: real,A3: real] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ R5 ) @ ( cis @ A3 ) ) ) ) ).

% rcis_def
thf(fact_7767_DeMoivre2,axiom,
    ! [R: real,A2: real,N2: nat] :
      ( ( power_power @ complex @ ( rcis @ R @ A2 ) @ N2 )
      = ( rcis @ ( power_power @ real @ R @ N2 ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) ) ) ).

% DeMoivre2
thf(fact_7768_shuffles_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa2 ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y
                = ( insert2 @ ( list @ A ) @ Xa2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa2 ) ) ) )
         => ( ( ( Xa2
                = ( nil @ A ) )
             => ( ( Y
                  = ( insert2 @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
           => ~ ! [X3: A,Xs2: list @ A] :
                  ( ( X
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y2: A,Ys4: list @ A] :
                      ( ( Xa2
                        = ( cons @ A @ Y2 @ Ys4 ) )
                     => ( ( Y
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_7769_list_Oin__rel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R6: A > B > $o,A3: list @ A,B3: list @ B] :
          ? [Z5: list @ ( product_prod @ A @ B )] :
            ( ( member @ ( list @ ( product_prod @ A @ B ) ) @ Z5
              @ ( collect @ ( list @ ( product_prod @ A @ B ) )
                @ ^ [X4: list @ ( product_prod @ A @ B )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( set2 @ ( product_prod @ A @ B ) @ X4 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R6 ) ) ) ) )
            & ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Z5 )
              = A3 )
            & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Z5 )
              = B3 ) ) ) ) ).

% list.in_rel
thf(fact_7770_list__all2__Nil2,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Xs: list @ A] :
      ( ( list_all2 @ A @ B @ P @ Xs @ ( nil @ B ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_all2_Nil2
thf(fact_7771_list__all2__Nil,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( nil @ A ) @ Ys )
      = ( Ys
        = ( nil @ B ) ) ) ).

% list_all2_Nil
thf(fact_7772_list__all2__rev,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( rev @ A @ Xs ) @ ( rev @ B @ Ys ) )
      = ( list_all2 @ A @ B @ P @ Xs @ Ys ) ) ).

% list_all2_rev
thf(fact_7773_foldr__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A5: A > C > $o,B5: B > D > $o] : ( bNF_rel_fun @ ( A > B > B ) @ ( C > D > D ) @ ( ( list @ A ) > B > B ) @ ( ( list @ C ) > D > D ) @ ( bNF_rel_fun @ A @ C @ ( B > B ) @ ( D > D ) @ A5 @ ( bNF_rel_fun @ B @ D @ B @ D @ B5 @ B5 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( B > B ) @ ( D > D ) @ ( list_all2 @ A @ C @ A5 ) @ ( bNF_rel_fun @ B @ D @ B @ D @ B5 @ B5 ) ) @ ( foldr @ A @ B ) @ ( foldr @ C @ D ) ) ).

% foldr_transfer
thf(fact_7774_List_Ofold__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A5: A > C > $o,B5: B > D > $o] : ( bNF_rel_fun @ ( A > B > B ) @ ( C > D > D ) @ ( ( list @ A ) > B > B ) @ ( ( list @ C ) > D > D ) @ ( bNF_rel_fun @ A @ C @ ( B > B ) @ ( D > D ) @ A5 @ ( bNF_rel_fun @ B @ D @ B @ D @ B5 @ B5 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( B > B ) @ ( D > D ) @ ( list_all2 @ A @ C @ A5 ) @ ( bNF_rel_fun @ B @ D @ B @ D @ B5 @ B5 ) ) @ ( fold @ A @ B ) @ ( fold @ C @ D ) ) ).

% List.fold_transfer
thf(fact_7775_dropWhile__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( dropWhile @ A )
      @ ( dropWhile @ B ) ) ).

% dropWhile_transfer
thf(fact_7776_takeWhile__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( takeWhile @ A )
      @ ( takeWhile @ B ) ) ).

% takeWhile_transfer
thf(fact_7777_list__update__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( nat > A > ( list @ A ) ) @ ( nat > B > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 )
      @ ( bNF_rel_fun @ nat @ nat @ ( A > ( list @ A ) ) @ ( B > ( list @ B ) )
        @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
        @ ( bNF_rel_fun @ A @ B @ ( list @ A ) @ ( list @ B ) @ A5 @ ( list_all2 @ A @ B @ A5 ) ) )
      @ ( list_update @ A )
      @ ( list_update @ B ) ) ).

% list_update_transfer
thf(fact_7778_replicate__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( A > ( list @ A ) ) @ ( B > ( list @ B ) )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ( bNF_rel_fun @ A @ B @ ( list @ A ) @ ( list @ B ) @ A5 @ ( list_all2 @ A @ B @ A5 ) )
      @ ( replicate @ A )
      @ ( replicate @ B ) ) ).

% replicate_transfer
thf(fact_7779_list_Octr__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o] : ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ R3 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R3 ) @ ( list_all2 @ A @ B @ R3 ) ) @ ( cons @ A ) @ ( cons @ B ) ) ).

% list.ctr_transfer(2)
thf(fact_7780_append__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( append @ A ) @ ( append @ B ) ) ).

% append_transfer
thf(fact_7781_rotate1__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( rotate1 @ A ) @ ( rotate1 @ B ) ) ).

% rotate1_transfer
thf(fact_7782_list_Orel__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: A > C > $o,Sc: B > D > $o] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( ( list @ C ) > ( list @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ C ) @ ( ( list @ B ) > $o ) @ ( ( list @ D ) > $o ) @ ( list_all2 @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( list @ B ) @ ( list @ D ) @ $o @ $o @ ( list_all2 @ B @ D @ Sc )
          @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) ) )
      @ ( list_all2 @ A @ B )
      @ ( list_all2 @ C @ D ) ) ).

% list.rel_transfer
thf(fact_7783_butlast__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( butlast @ A ) @ ( butlast @ B ) ) ).

% butlast_transfer
thf(fact_7784_subseqs__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( subseqs @ A ) @ ( subseqs @ B ) ) ).

% subseqs_transfer
thf(fact_7785_product__lists__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( product_lists @ A ) @ ( product_lists @ B ) ) ).

% product_lists_transfer
thf(fact_7786_list_Odisc__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R3 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
      @ ^ [List2: list @ A] :
          ( List2
          = ( nil @ A ) )
      @ ^ [List2: list @ B] :
          ( List2
          = ( nil @ B ) ) ) ).

% list.disc_transfer(1)
thf(fact_7787_list_Odisc__transfer_I2_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ $o @ $o @ ( list_all2 @ A @ B @ R3 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
      @ ^ [List2: list @ A] :
          ( List2
         != ( nil @ A ) )
      @ ^ [List2: list @ B] :
          ( List2
         != ( nil @ B ) ) ) ).

% list.disc_transfer(2)
thf(fact_7788_rotate__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( rotate @ A )
      @ ( rotate @ B ) ) ).

% rotate_transfer
thf(fact_7789_drop__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( drop @ A )
      @ ( drop @ B ) ) ).

% drop_transfer
thf(fact_7790_take__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ nat @ nat @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( take @ A )
      @ ( take @ B ) ) ).

% take_transfer
thf(fact_7791_concat__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ ( list @ A ) ) @ ( list @ ( list @ B ) ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( concat @ A ) @ ( concat @ B ) ) ).

% concat_transfer
thf(fact_7792_rev__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( rev @ A ) @ ( rev @ B ) ) ).

% rev_transfer
thf(fact_7793_tl__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) @ ( tl @ A ) @ ( tl @ B ) ) ).

% tl_transfer
thf(fact_7794_List_Ofilter__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
        @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
      @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) )
      @ ( filter2 @ A )
      @ ( filter2 @ B ) ) ).

% List.filter_transfer
thf(fact_7795_list_Omap__transfer,axiom,
    ! [A: $tType,B: $tType,F: $tType,E4: $tType,Rb: A > E4 > $o,Sd: B > F > $o] : ( bNF_rel_fun @ ( A > B ) @ ( E4 > F ) @ ( ( list @ A ) > ( list @ B ) ) @ ( ( list @ E4 ) > ( list @ F ) ) @ ( bNF_rel_fun @ A @ E4 @ B @ F @ Rb @ Sd ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ E4 ) @ ( list @ B ) @ ( list @ F ) @ ( list_all2 @ A @ E4 @ Rb ) @ ( list_all2 @ B @ F @ Sd ) ) @ ( map @ A @ B ) @ ( map @ E4 @ F ) ) ).

% list.map_transfer
thf(fact_7796_length__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] :
      ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ nat @ nat @ ( list_all2 @ A @ B @ A5 )
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ( size_size @ ( list @ A ) )
      @ ( size_size @ ( list @ B ) ) ) ).

% length_transfer
thf(fact_7797_list_Ocase__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S2: C > D > $o,R3: A > B > $o] : ( bNF_rel_fun @ C @ D @ ( ( A > ( list @ A ) > C ) > ( list @ A ) > C ) @ ( ( B > ( list @ B ) > D ) > ( list @ B ) > D ) @ S2 @ ( bNF_rel_fun @ ( A > ( list @ A ) > C ) @ ( B > ( list @ B ) > D ) @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ R3 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R3 ) @ S2 ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R3 ) @ S2 ) ) @ ( case_list @ C @ A ) @ ( case_list @ D @ B ) ) ).

% list.case_transfer
thf(fact_7798_list_Orel__distinct_I2_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o,Y21: A,Y222: list @ A] :
      ~ ( list_all2 @ A @ B @ R3 @ ( cons @ A @ Y21 @ Y222 ) @ ( nil @ B ) ) ).

% list.rel_distinct(2)
thf(fact_7799_list_Orel__distinct_I1_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o,Y21: B,Y222: list @ B] :
      ~ ( list_all2 @ A @ B @ R3 @ ( nil @ A ) @ ( cons @ B @ Y21 @ Y222 ) ) ).

% list.rel_distinct(1)
thf(fact_7800_list_Orel__cases,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o,A2: list @ A,B2: list @ B] :
      ( ( list_all2 @ A @ B @ R3 @ A2 @ B2 )
     => ( ( ( A2
            = ( nil @ A ) )
         => ( B2
           != ( nil @ B ) ) )
       => ~ ! [X1: A,X23: list @ A] :
              ( ( A2
                = ( cons @ A @ X1 @ X23 ) )
             => ! [Y1: B,Y23: list @ B] :
                  ( ( B2
                    = ( cons @ B @ Y1 @ Y23 ) )
                 => ( ( R3 @ X1 @ Y1 )
                   => ~ ( list_all2 @ A @ B @ R3 @ X23 @ Y23 ) ) ) ) ) ) ).

% list.rel_cases
thf(fact_7801_list_Orel__induct,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o,X: list @ A,Y: list @ B,Q: ( list @ A ) > ( list @ B ) > $o] :
      ( ( list_all2 @ A @ B @ R3 @ X @ Y )
     => ( ( Q @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [A21: A,A222: list @ A,B21: B,B222: list @ B] :
              ( ( R3 @ A21 @ B21 )
             => ( ( Q @ A222 @ B222 )
               => ( Q @ ( cons @ A @ A21 @ A222 ) @ ( cons @ B @ B21 @ B222 ) ) ) )
         => ( Q @ X @ Y ) ) ) ) ).

% list.rel_induct
thf(fact_7802_list__all2__induct,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,R3: ( list @ A ) > ( list @ B ) > $o] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( R3 @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Xs2: list @ A,Y2: B,Ys4: list @ B] :
              ( ( P @ X3 @ Y2 )
             => ( ( list_all2 @ A @ B @ P @ Xs2 @ Ys4 )
               => ( ( R3 @ Xs2 @ Ys4 )
                 => ( R3 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys4 ) ) ) ) )
         => ( R3 @ Xs @ Ys ) ) ) ) ).

% list_all2_induct
thf(fact_7803_list__all2__update__cong,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,X: A,Y: B,I2: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( P @ X @ Y )
       => ( list_all2 @ A @ B @ P @ ( list_update @ A @ Xs @ I2 @ X ) @ ( list_update @ B @ Ys @ I2 @ Y ) ) ) ) ).

% list_all2_update_cong
thf(fact_7804_list_Orel__inject_I2_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o,X212: A,X223: list @ A,Y21: B,Y222: list @ B] :
      ( ( list_all2 @ A @ B @ R3 @ ( cons @ A @ X212 @ X223 ) @ ( cons @ B @ Y21 @ Y222 ) )
      = ( ( R3 @ X212 @ Y21 )
        & ( list_all2 @ A @ B @ R3 @ X223 @ Y222 ) ) ) ).

% list.rel_inject(2)
thf(fact_7805_list_Orel__intros_I2_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o,X212: A,Y21: B,X223: list @ A,Y222: list @ B] :
      ( ( R3 @ X212 @ Y21 )
     => ( ( list_all2 @ A @ B @ R3 @ X223 @ Y222 )
       => ( list_all2 @ A @ B @ R3 @ ( cons @ A @ X212 @ X223 ) @ ( cons @ B @ Y21 @ Y222 ) ) ) ) ).

% list.rel_intros(2)
thf(fact_7806_list__all2__Cons,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) )
      = ( ( P @ X @ Y )
        & ( list_all2 @ A @ B @ P @ Xs @ Ys ) ) ) ).

% list_all2_Cons
thf(fact_7807_list__all2__Cons1,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( ? [Z5: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z5 @ Zs3 ) )
            & ( P @ X @ Z5 )
            & ( list_all2 @ A @ B @ P @ Xs @ Zs3 ) ) ) ) ).

% list_all2_Cons1
thf(fact_7808_list__all2__Cons2,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Xs: list @ A,Y: B,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs @ ( cons @ B @ Y @ Ys ) )
      = ( ? [Z5: A,Zs3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Z5 @ Zs3 ) )
            & ( P @ Z5 @ Y )
            & ( list_all2 @ A @ B @ P @ Zs3 @ Ys ) ) ) ) ).

% list_all2_Cons2
thf(fact_7809_list__all2__appendI,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,A2: list @ A,B2: list @ B,C2: list @ A,D2: list @ B] :
      ( ( list_all2 @ A @ B @ P @ A2 @ B2 )
     => ( ( list_all2 @ A @ B @ P @ C2 @ D2 )
       => ( list_all2 @ A @ B @ P @ ( append @ A @ A2 @ C2 ) @ ( append @ B @ B2 @ D2 ) ) ) ) ).

% list_all2_appendI
thf(fact_7810_list_Orel__eq,axiom,
    ! [A: $tType] :
      ( ( list_all2 @ A @ A
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
      = ( ^ [Y3: list @ A,Z2: list @ A] : ( Y3 = Z2 ) ) ) ).

% list.rel_eq
thf(fact_7811_list_Orel__refl,axiom,
    ! [B: $tType,Ra: B > B > $o,X: list @ B] :
      ( ! [X3: B] : ( Ra @ X3 @ X3 )
     => ( list_all2 @ B @ B @ Ra @ X @ X ) ) ).

% list.rel_refl
thf(fact_7812_list__all2__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z2: list @ A] : ( Y3 = Z2 ) )
      = ( list_all2 @ A @ A
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) ) ) ).

% list_all2_eq
thf(fact_7813_list__all2__mono,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,Q: A > B > $o] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [Xs2: A,Ys4: B] :
            ( ( P @ Xs2 @ Ys4 )
           => ( Q @ Xs2 @ Ys4 ) )
       => ( list_all2 @ A @ B @ Q @ Xs @ Ys ) ) ) ).

% list_all2_mono
thf(fact_7814_list__all2__refl,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ! [X3: A] : ( P @ X3 @ X3 )
     => ( list_all2 @ A @ A @ P @ Xs @ Xs ) ) ).

% list_all2_refl
thf(fact_7815_list__all2__trans,axiom,
    ! [B: $tType,A: $tType,C: $tType,P1: A > B > $o,P22: B > C > $o,P32: A > C > $o,As3: list @ A,Bs: list @ B,Cs: list @ C] :
      ( ! [A4: A,B4: B,C3: C] :
          ( ( P1 @ A4 @ B4 )
         => ( ( P22 @ B4 @ C3 )
           => ( P32 @ A4 @ C3 ) ) )
     => ( ( list_all2 @ A @ B @ P1 @ As3 @ Bs )
       => ( ( list_all2 @ B @ C @ P22 @ Bs @ Cs )
         => ( list_all2 @ A @ C @ P32 @ As3 @ Cs ) ) ) ) ).

% list_all2_trans
thf(fact_7816_list__all2__antisym,axiom,
    ! [A: $tType,P: A > A > $o,Q: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ! [X3: A,Y2: A] :
          ( ( P @ X3 @ Y2 )
         => ( ( Q @ Y2 @ X3 )
           => ( X3 = Y2 ) ) )
     => ( ( list_all2 @ A @ A @ P @ Xs @ Ys )
       => ( ( list_all2 @ A @ A @ Q @ Ys @ Xs )
         => ( Xs = Ys ) ) ) ) ).

% list_all2_antisym
thf(fact_7817_list_Octr__transfer_I1_J,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o] : ( list_all2 @ A @ B @ R3 @ ( nil @ A ) @ ( nil @ B ) ) ).

% list.ctr_transfer(1)
thf(fact_7818_list_Orel__cong,axiom,
    ! [A: $tType,B: $tType,X: list @ A,Ya: list @ A,Y: list @ B,Xa2: list @ B,R3: A > B > $o,Ra: A > B > $o] :
      ( ( X = Ya )
     => ( ( Y = Xa2 )
       => ( ! [Z3: A,Yb: B] :
              ( ( member @ A @ Z3 @ ( set2 @ A @ Ya ) )
             => ( ( member @ B @ Yb @ ( set2 @ B @ Xa2 ) )
               => ( ( R3 @ Z3 @ Yb )
                  = ( Ra @ Z3 @ Yb ) ) ) )
         => ( ( list_all2 @ A @ B @ R3 @ X @ Y )
            = ( list_all2 @ A @ B @ Ra @ Ya @ Xa2 ) ) ) ) ) ).

% list.rel_cong
thf(fact_7819_list_Orel__mono__strong,axiom,
    ! [A: $tType,B: $tType,R3: A > B > $o,X: list @ A,Y: list @ B,Ra: A > B > $o] :
      ( ( list_all2 @ A @ B @ R3 @ X @ Y )
     => ( ! [Z3: A,Yb: B] :
            ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
           => ( ( member @ B @ Yb @ ( set2 @ B @ Y ) )
             => ( ( R3 @ Z3 @ Yb )
               => ( Ra @ Z3 @ Yb ) ) ) )
       => ( list_all2 @ A @ B @ Ra @ X @ Y ) ) ) ).

% list.rel_mono_strong
thf(fact_7820_list_Orel__refl__strong,axiom,
    ! [A: $tType,X: list @ A,Ra: A > A > $o] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X ) )
         => ( Ra @ Z3 @ Z3 ) )
     => ( list_all2 @ A @ A @ Ra @ X @ X ) ) ).

% list.rel_refl_strong
thf(fact_7821_list__all2__same,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( list_all2 @ A @ A @ P @ Xs @ Xs )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
           => ( P @ X4 @ X4 ) ) ) ) ).

% list_all2_same
thf(fact_7822_list__all2__dropI,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,N2: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( list_all2 @ A @ B @ P @ ( drop @ A @ N2 @ Xs ) @ ( drop @ B @ N2 @ Ys ) ) ) ).

% list_all2_dropI
thf(fact_7823_list__all2__takeI,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,N2: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( list_all2 @ A @ B @ P @ ( take @ A @ N2 @ Xs ) @ ( take @ B @ N2 @ Ys ) ) ) ).

% list_all2_takeI
thf(fact_7824_list__all2__rev1,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( rev @ A @ Xs ) @ Ys )
      = ( list_all2 @ A @ B @ P @ Xs @ ( rev @ B @ Ys ) ) ) ).

% list_all2_rev1
thf(fact_7825_list_Orel__sel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [R6: A > B > $o,A3: list @ A,B3: list @ B] :
            ( ( ( A3
                = ( nil @ A ) )
              = ( B3
                = ( nil @ B ) ) )
            & ( ( A3
               != ( nil @ A ) )
             => ( ( B3
                 != ( nil @ B ) )
               => ( ( R6 @ ( hd @ A @ A3 ) @ ( hd @ B @ B3 ) )
                  & ( list_all2 @ A @ B @ R6 @ ( tl @ A @ A3 ) @ ( tl @ B @ B3 ) ) ) ) ) ) ) ) ).

% list.rel_sel
thf(fact_7826_list_Orel__map_I2_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sa: A > C > $o,X: list @ A,G2: B > C,Y: list @ B] :
      ( ( list_all2 @ A @ C @ Sa @ X @ ( map @ B @ C @ G2 @ Y ) )
      = ( list_all2 @ A @ B
        @ ^ [X4: A,Y4: B] : ( Sa @ X4 @ ( G2 @ Y4 ) )
        @ X
        @ Y ) ) ).

% list.rel_map(2)
thf(fact_7827_list_Orel__map_I1_J,axiom,
    ! [A: $tType,C: $tType,B: $tType,Sb: C > B > $o,I2: A > C,X: list @ A,Y: list @ B] :
      ( ( list_all2 @ C @ B @ Sb @ ( map @ A @ C @ I2 @ X ) @ Y )
      = ( list_all2 @ A @ B
        @ ^ [X4: A] : ( Sb @ ( I2 @ X4 ) )
        @ X
        @ Y ) ) ).

% list.rel_map(1)
thf(fact_7828_list__all2__map1,axiom,
    ! [C: $tType,A: $tType,B: $tType,P: A > B > $o,F2: C > A,As3: list @ C,Bs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( map @ C @ A @ F2 @ As3 ) @ Bs )
      = ( list_all2 @ C @ B
        @ ^ [X4: C] : ( P @ ( F2 @ X4 ) )
        @ As3
        @ Bs ) ) ).

% list_all2_map1
thf(fact_7829_list__all2__map2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: A > B > $o,As3: list @ A,F2: C > B,Bs: list @ C] :
      ( ( list_all2 @ A @ B @ P @ As3 @ ( map @ C @ B @ F2 @ Bs ) )
      = ( list_all2 @ A @ C
        @ ^ [X4: A,Y4: C] : ( P @ X4 @ ( F2 @ Y4 ) )
        @ As3
        @ Bs ) ) ).

% list_all2_map2
thf(fact_7830_list__all2__append2,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs @ ( append @ B @ Ys @ Zs ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Us2 @ Vs3 ) )
            & ( ( size_size @ ( list @ A ) @ Us2 )
              = ( size_size @ ( list @ B ) @ Ys ) )
            & ( ( size_size @ ( list @ A ) @ Vs3 )
              = ( size_size @ ( list @ B ) @ Zs ) )
            & ( list_all2 @ A @ B @ P @ Us2 @ Ys )
            & ( list_all2 @ A @ B @ P @ Vs3 @ Zs ) ) ) ) ).

% list_all2_append2
thf(fact_7831_list__all2__append1,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ A,Zs: list @ B] :
      ( ( list_all2 @ A @ B @ P @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Zs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( ( size_size @ ( list @ B ) @ Us2 )
              = ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( size_size @ ( list @ B ) @ Vs3 )
              = ( size_size @ ( list @ A ) @ Ys ) )
            & ( list_all2 @ A @ B @ P @ Xs @ Us2 )
            & ( list_all2 @ A @ B @ P @ Ys @ Vs3 ) ) ) ) ).

% list_all2_append1
thf(fact_7832_list__all2__append,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P: A > B > $o,Us: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( list_all2 @ A @ B @ P @ ( append @ A @ Xs @ Us ) @ ( append @ B @ Ys @ Vs ) )
        = ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
          & ( list_all2 @ A @ B @ P @ Us @ Vs ) ) ) ) ).

% list_all2_append
thf(fact_7833_list__all2__lengthD,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% list_all2_lengthD
thf(fact_7834_list__all2__nthD,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,P4: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( ord_less @ nat @ P4 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ P4 ) @ ( nth @ B @ Ys @ P4 ) ) ) ) ).

% list_all2_nthD
thf(fact_7835_list__all2__nthD2,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys: list @ B,P4: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( ord_less @ nat @ P4 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( P @ ( nth @ A @ Xs @ P4 ) @ ( nth @ B @ Ys @ P4 ) ) ) ) ).

% list_all2_nthD2
thf(fact_7836_list__all2__all__nthI,axiom,
    ! [A: $tType,B: $tType,A2: list @ A,B2: list @ B,P: A > B > $o] :
      ( ( ( size_size @ ( list @ A ) @ A2 )
        = ( size_size @ ( list @ B ) @ B2 ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ A2 ) )
           => ( P @ ( nth @ A @ A2 @ N3 ) @ ( nth @ B @ B2 @ N3 ) ) )
       => ( list_all2 @ A @ B @ P @ A2 @ B2 ) ) ) ).

% list_all2_all_nthI
thf(fact_7837_list__all2__conv__all__nth,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs3: list @ A,Ys3: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ B ) @ Ys3 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( P3 @ ( nth @ A @ Xs3 @ I4 ) @ ( nth @ B @ Ys3 @ I4 ) ) ) ) ) ) ).

% list_all2_conv_all_nth
thf(fact_7838_list_Orel__mono,axiom,
    ! [B: $tType,A: $tType,R3: A > B > $o,Ra: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R3 @ Ra )
     => ( ord_less_eq @ ( ( list @ A ) > ( list @ B ) > $o ) @ ( list_all2 @ A @ B @ R3 ) @ ( list_all2 @ A @ B @ Ra ) ) ) ).

% list.rel_mono
thf(fact_7839_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [Xs2: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
             => ( P @ Xs2 @ ( nil @ A ) ) )
         => ( ! [X3: A,Xs2: list @ A,Y2: A,Ys4: list @ A] :
                ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) )
               => ( ( P @ Xs2 @ ( cons @ A @ Y2 @ Ys4 ) )
                 => ( ( P @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 )
                   => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys4 ) ) ) ) )
           => ( P @ A0 @ A1 ) ) ) ) ) ).

% shuffles.pinduct
thf(fact_7840_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs @ ( nil @ A ) )
        = ( insert2 @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_7841_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys )
        = ( insert2 @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_7842_product__lists__set,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) )
      = ( collect @ ( list @ A )
        @ ^ [Xs3: list @ A] :
            ( list_all2 @ A @ ( list @ A )
            @ ^ [X4: A,Ys3: list @ A] : ( member @ A @ X4 @ ( set2 @ A @ Ys3 ) )
            @ Xs3
            @ Xss ) ) ) ).

% product_lists_set
thf(fact_7843_list__all2I,axiom,
    ! [A: $tType,B: $tType,A2: list @ A,B2: list @ B,P: A > B > $o] :
      ( ! [X3: product_prod @ A @ B] :
          ( ( member @ ( product_prod @ A @ B ) @ X3 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ A2 @ B2 ) ) )
         => ( product_case_prod @ A @ B @ $o @ P @ X3 ) )
     => ( ( ( size_size @ ( list @ A ) @ A2 )
          = ( size_size @ ( list @ B ) @ B2 ) )
       => ( list_all2 @ A @ B @ P @ A2 @ B2 ) ) ) ).

% list_all2I
thf(fact_7844_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) )
     => ( ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
        = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs ) @ Ys ) ) ) ) ) ).

% shuffles.psimps(3)
thf(fact_7845_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( monoid_add @ A ) )
     => ! [A5: A > B > $o] :
          ( ( A5 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A5 ) @ A5 @ ( groups8242544230860333062m_list @ A ) @ ( groups8242544230860333062m_list @ B ) ) ) ) ) ).

% sum_list_transfer
thf(fact_7846_prod__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_mult @ B )
        & ( monoid_mult @ A ) )
     => ! [A5: A > B > $o] :
          ( ( A5 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A5 ) @ A5 @ ( groups5270119922927024881d_list @ A ) @ ( groups5270119922927024881d_list @ B ) ) ) ) ) ).

% prod_list_transfer
thf(fact_7847_list__all2__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs3: list @ A,Ys3: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ B ) @ Ys3 ) )
            & ! [X4: product_prod @ A @ B] :
                ( ( member @ ( product_prod @ A @ B ) @ X4 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs3 @ Ys3 ) ) )
               => ( product_case_prod @ A @ B @ $o @ P3 @ X4 ) ) ) ) ) ).

% list_all2_iff
thf(fact_7848_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A5: A > B > $o,B5: C > D > $o] :
          ( ( A5 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A5 @ ( bNF_rel_fun @ A @ B @ A @ B @ A5 @ A5 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B5 @ A5 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A5 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B5 ) @ A5 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_7849_splice_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [X3: A,Xs2: list @ A,Ys4: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) )
             => ( ( P @ Ys4 @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) ).

% splice.pinduct
thf(fact_7850_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G2: nat > nat] :
          ( ! [X3: nat,Y2: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y2 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G2 )
           => ( ( bfun @ nat @ A
                @ ^ [X4: nat] : ( F2 @ ( G2 @ X4 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_7851_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N2: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N2 @ ( F2 @ N2 ) ) ) ).

% strict_mono_imp_increasing
thf(fact_7852_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R: A > B,M2: A,N2: A] :
          ( ( order_strict_mono @ A @ B @ R )
         => ( ( ord_less_eq @ A @ M2 @ N2 )
           => ( ord_less_eq @ B @ ( R @ M2 ) @ ( R @ N2 ) ) ) ) ) ).

% strict_mono_leD
thf(fact_7853_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% strict_mono_less_eq
thf(fact_7854_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N: nat] : ( ord_less @ A @ ( F3 @ N ) @ ( F3 @ ( suc @ N ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_7855_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X @ Y )
           => ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% strict_monoD
thf(fact_7856_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y2: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
             => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_7857_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X4: A,Y4: A] :
              ( ( ord_less @ A @ X4 @ Y4 )
             => ( ord_less @ B @ ( F3 @ X4 ) @ ( F3 @ Y4 ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_7858_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% strict_mono_less
thf(fact_7859_strict__mono__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ( F2 @ X )
              = ( F2 @ Y ) )
            = ( X = Y ) ) ) ) ).

% strict_mono_eq
thf(fact_7860_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N: A] : ( plus_plus @ A @ N @ K ) ) ) ).

% strict_mono_add
thf(fact_7861_strict__mono__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% strict_mono_mono
thf(fact_7862_foldl__transfer,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,B5: A > C > $o,A5: B > D > $o] : ( bNF_rel_fun @ ( A > B > A ) @ ( C > D > C ) @ ( A > ( list @ B ) > A ) @ ( C > ( list @ D ) > C ) @ ( bNF_rel_fun @ A @ C @ ( B > A ) @ ( D > C ) @ B5 @ ( bNF_rel_fun @ B @ D @ A @ C @ A5 @ B5 ) ) @ ( bNF_rel_fun @ A @ C @ ( ( list @ B ) > A ) @ ( ( list @ D ) > C ) @ B5 @ ( bNF_rel_fun @ ( list @ B ) @ ( list @ D ) @ A @ C @ ( list_all2 @ B @ D @ A5 ) @ B5 ) ) @ ( foldl @ A @ B ) @ ( foldl @ C @ D ) ) ).

% foldl_transfer
thf(fact_7863_list_Orec__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S2: C > D > $o,R3: A > B > $o] : ( bNF_rel_fun @ C @ D @ ( ( A > ( list @ A ) > C > C ) > ( list @ A ) > C ) @ ( ( B > ( list @ B ) > D > D ) > ( list @ B ) > D ) @ S2 @ ( bNF_rel_fun @ ( A > ( list @ A ) > C > C ) @ ( B > ( list @ B ) > D > D ) @ ( ( list @ A ) > C ) @ ( ( list @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ A ) > C > C ) @ ( ( list @ B ) > D > D ) @ R3 @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( C > C ) @ ( D > D ) @ ( list_all2 @ A @ B @ R3 ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S2 @ S2 ) ) ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ C @ D @ ( list_all2 @ A @ B @ R3 ) @ S2 ) ) @ ( rec_list @ C @ A ) @ ( rec_list @ D @ B ) ) ).

% list.rec_transfer
thf(fact_7864_foldl__append,axiom,
    ! [A: $tType,B: $tType,F2: A > B > A,A2: A,Xs: list @ B,Ys: list @ B] :
      ( ( foldl @ A @ B @ F2 @ A2 @ ( append @ B @ Xs @ Ys ) )
      = ( foldl @ A @ B @ F2 @ ( foldl @ A @ B @ F2 @ A2 @ Xs ) @ Ys ) ) ).

% foldl_append
thf(fact_7865_foldl__conv__fold,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,S6: A,Xs3: list @ B] :
            ( fold @ B @ A
            @ ^ [X4: B,T3: A] : ( F3 @ T3 @ X4 )
            @ Xs3
            @ S6 ) ) ) ).

% foldl_conv_fold
thf(fact_7866_list_Osimps_I7_J,axiom,
    ! [C: $tType,A: $tType,F1: C,F22: A > ( list @ A ) > C > C,X212: A,X223: list @ A] :
      ( ( rec_list @ C @ A @ F1 @ F22 @ ( cons @ A @ X212 @ X223 ) )
      = ( F22 @ X212 @ X223 @ ( rec_list @ C @ A @ F1 @ F22 @ X223 ) ) ) ).

% list.simps(7)
thf(fact_7867_foldl__Cons,axiom,
    ! [B: $tType,A: $tType,F2: B > A > B,A2: B,X: A,Xs: list @ A] :
      ( ( foldl @ B @ A @ F2 @ A2 @ ( cons @ A @ X @ Xs ) )
      = ( foldl @ B @ A @ F2 @ ( F2 @ A2 @ X ) @ Xs ) ) ).

% foldl_Cons
thf(fact_7868_foldl__Nil,axiom,
    ! [A: $tType,B: $tType,F2: B > A > B,A2: B] :
      ( ( foldl @ B @ A @ F2 @ A2 @ ( nil @ A ) )
      = A2 ) ).

% foldl_Nil
thf(fact_7869_list_Osimps_I6_J,axiom,
    ! [A: $tType,C: $tType,F1: C,F22: A > ( list @ A ) > C > C] :
      ( ( rec_list @ C @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(6)
thf(fact_7870_foldl__cong,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: A,L: list @ B,K: list @ B,F2: A > B > A,G2: A > B > A] :
      ( ( A2 = B2 )
     => ( ( L = K )
       => ( ! [A4: A,X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ L ) )
             => ( ( F2 @ A4 @ X3 )
                = ( G2 @ A4 @ X3 ) ) )
         => ( ( foldl @ A @ B @ F2 @ A2 @ L )
            = ( foldl @ A @ B @ G2 @ B2 @ K ) ) ) ) ) ).

% foldl_cong
thf(fact_7871_foldl__map,axiom,
    ! [A: $tType,B: $tType,C: $tType,G2: A > B > A,A2: A,F2: C > B,Xs: list @ C] :
      ( ( foldl @ A @ B @ G2 @ A2 @ ( map @ C @ B @ F2 @ Xs ) )
      = ( foldl @ A @ C
        @ ^ [A3: A,X4: C] : ( G2 @ A3 @ ( F2 @ X4 ) )
        @ A2
        @ Xs ) ) ).

% foldl_map
thf(fact_7872_foldl__conv__foldr,axiom,
    ! [B: $tType,A: $tType] :
      ( ( foldl @ A @ B )
      = ( ^ [F3: A > B > A,A3: A,Xs3: list @ B] :
            ( foldr @ B @ A
            @ ^ [X4: B,Y4: A] : ( F3 @ Y4 @ X4 )
            @ ( rev @ B @ Xs3 )
            @ A3 ) ) ) ).

% foldl_conv_foldr
thf(fact_7873_foldr__conv__foldl,axiom,
    ! [A: $tType,B: $tType] :
      ( ( foldr @ B @ A )
      = ( ^ [F3: B > A > A,Xs3: list @ B,A3: A] :
            ( foldl @ A @ B
            @ ^ [X4: A,Y4: B] : ( F3 @ Y4 @ X4 )
            @ A3
            @ ( rev @ B @ Xs3 ) ) ) ) ).

% foldr_conv_foldl
thf(fact_7874_list_Orec__o__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G2: C,Ga: B > ( list @ B ) > C > C,F2: A > B] :
      ( ( comp @ ( list @ B ) @ C @ ( list @ A ) @ ( rec_list @ C @ B @ G2 @ Ga ) @ ( map @ A @ B @ F2 ) )
      = ( rec_list @ C @ A @ G2
        @ ^ [X4: A,Xa4: list @ A] : ( Ga @ ( F2 @ X4 ) @ ( map @ A @ B @ F2 @ Xa4 ) ) ) ) ).

% list.rec_o_map
thf(fact_7875_set__rec,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( rec_list @ ( set @ A ) @ A @ ( bot_bot @ ( set @ A ) )
        @ ^ [X4: A,Uu3: list @ A] : ( insert2 @ A @ X4 ) ) ) ).

% set_rec
thf(fact_7876_map__rec,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map @ B @ A )
      = ( ^ [F3: B > A] :
            ( rec_list @ ( list @ A ) @ B @ ( nil @ A )
            @ ^ [X4: B,Uu3: list @ B] : ( cons @ A @ ( F3 @ X4 ) ) ) ) ) ).

% map_rec
thf(fact_7877_splice_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y: list @ A] :
      ( ( ( splice @ A @ X @ Xa2 )
        = Y )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa2 ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y = Xa2 )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa2 ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( X
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ( ( Y
                    = ( cons @ A @ X3 @ ( splice @ A @ Xa2 @ Xs2 ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xa2 ) ) ) ) ) ) ) ).

% splice.pelims
thf(fact_7878_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( splice @ A @ ( nil @ A ) @ Ys )
        = Ys ) ) ).

% splice.psimps(1)
thf(fact_7879_splice__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% splice_Nil2
thf(fact_7880_split__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( splice @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% split_Nil_iff
thf(fact_7881_splice__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( member @ ( list @ A ) @ ( splice @ A @ Xs @ Ys ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% splice_in_shuffles
thf(fact_7882_length__splice,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( splice @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_splice
thf(fact_7883_splice__replicate,axiom,
    ! [A: $tType,M2: nat,X: A,N2: nat] :
      ( ( splice @ A @ ( replicate @ A @ M2 @ X ) @ ( replicate @ A @ N2 @ X ) )
      = ( replicate @ A @ ( plus_plus @ nat @ M2 @ N2 ) @ X ) ) ).

% splice_replicate
thf(fact_7884_splice_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( splice @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% splice.simps(1)
thf(fact_7885_splice_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( cons @ A @ X @ ( splice @ A @ Ys @ Xs ) ) ) ).

% splice.simps(2)
thf(fact_7886_splice_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y: list @ A] :
      ( ( ( splice @ A @ X @ Xa2 )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa2 ) )
       => ~ ! [X3: A,Xs2: list @ A] :
              ( ( X
                = ( cons @ A @ X3 @ Xs2 ) )
             => ( Y
               != ( cons @ A @ X3 @ ( splice @ A @ Xa2 @ Xs2 ) ) ) ) ) ) ).

% splice.elims
thf(fact_7887_splice__transfer,axiom,
    ! [A: $tType,B: $tType,A5: A > B > $o] : ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( ( list @ A ) > ( list @ A ) ) @ ( ( list @ B ) > ( list @ B ) ) @ ( list_all2 @ A @ B @ A5 ) @ ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ A5 ) @ ( list_all2 @ A @ B @ A5 ) ) @ ( splice @ A ) @ ( splice @ B ) ) ).

% splice_transfer
thf(fact_7888_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) )
     => ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ Ys )
        = ( cons @ A @ X @ ( splice @ A @ Ys @ Xs ) ) ) ) ).

% splice.psimps(2)
thf(fact_7889_power_Opower__eq__if,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( ^ [One: A,Times: A > A > A,P6: A,M: nat] :
            ( if @ A
            @ ( M
              = ( zero_zero @ nat ) )
            @ One
            @ ( Times @ P6 @ ( power2 @ A @ One @ Times @ P6 @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ) ).

% power.power_eq_if
thf(fact_7890_Real_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ $o @ $o @ realrel
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X6: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ord_less @ rat @ R5 @ ( X6 @ N ) ) ) )
    @ ^ [X6: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ord_less @ rat @ R5 @ ( X6 @ N ) ) ) ) ) ).

% Real.positive.rsp
thf(fact_7891_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A,N2: nat] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( suc @ N2 ) )
      = ( Times2 @ A2 @ ( power2 @ A @ One2 @ Times2 @ A2 @ N2 ) ) ) ).

% power.power.power_Suc
thf(fact_7892_one__real_Orsp,axiom,
    ( realrel
    @ ^ [N: nat] : ( one_one @ rat )
    @ ^ [N: nat] : ( one_one @ rat ) ) ).

% one_real.rsp
thf(fact_7893_zero__real_Orsp,axiom,
    ( realrel
    @ ^ [N: nat] : ( zero_zero @ rat )
    @ ^ [N: nat] : ( zero_zero @ rat ) ) ).

% zero_real.rsp
thf(fact_7894_power_Opower_Ocong,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( power2 @ A ) ) ).

% power.power.cong
thf(fact_7895_power_Opower_Opower__0,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( zero_zero @ nat ) )
      = One2 ) ).

% power.power.power_0
thf(fact_7896_uminus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X6: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X6 @ N ) )
    @ ^ [X6: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X6 @ N ) ) ) ).

% uminus_real.rsp
thf(fact_7897_plus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X6 @ N ) @ ( Y7 @ N ) )
    @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X6 @ N ) @ ( Y7 @ N ) ) ) ).

% plus_real.rsp
thf(fact_7898_times__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X6 @ N ) @ ( Y7 @ N ) )
    @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X6 @ N ) @ ( Y7 @ N ) ) ) ).

% times_real.rsp
thf(fact_7899_mono__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ D )
        & ( order @ C )
        & ( order @ A ) )
     => ! [A5: A > B > $o,B5: C > D > $o] :
          ( ( bi_total @ A @ B @ A5 )
         => ( ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A5
              @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
                @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
              @ ( ord_less_eq @ A )
              @ ( ord_less_eq @ B ) )
           => ( ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B5
                @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B5
                  @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
                @ ( ord_less_eq @ C )
                @ ( ord_less_eq @ D ) )
             => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A5 @ B5 )
                @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
                @ ( order_mono @ A @ C )
                @ ( order_mono @ B @ D ) ) ) ) ) ) ).

% mono_transfer
thf(fact_7900_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N2: nat,S: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S2 @ ( set_ord_lessThan @ A @ S ) ) @ N2 )
              = ( infini527867602293511546merate @ A @ S2 @ N2 ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_7901_enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,M2: nat,N2: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M2 ) @ ( infini527867602293511546merate @ A @ S2 @ N2 ) )
            = ( ord_less @ nat @ M2 @ N2 ) ) ) ) ).

% enumerate_mono_iff
thf(fact_7902_finite__enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,M2: nat,N2: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ M2 @ ( finite_card @ A @ S2 ) )
           => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S2 ) )
             => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M2 ) @ ( infini527867602293511546merate @ A @ S2 @ N2 ) )
                = ( ord_less @ nat @ M2 @ N2 ) ) ) ) ) ) ).

% finite_enumerate_mono_iff
thf(fact_7903_le__enumerate,axiom,
    ! [S2: set @ nat,N2: nat] :
      ( ~ ( finite_finite @ nat @ S2 )
     => ( ord_less_eq @ nat @ N2 @ ( infini527867602293511546merate @ nat @ S2 @ N2 ) ) ) ).

% le_enumerate
thf(fact_7904_list_Obi__total__rel,axiom,
    ! [B: $tType,A: $tType,R3: A > B > $o] :
      ( ( bi_total @ A @ B @ R3 )
     => ( bi_total @ ( list @ A ) @ ( list @ B ) @ ( list_all2 @ A @ B @ R3 ) ) ) ).

% list.bi_total_rel
thf(fact_7905_enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N2: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N2 ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N2 ) ) ) ) ) ).

% enumerate_step
thf(fact_7906_enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M2: nat,N2: nat,S2: set @ A] :
          ( ( ord_less @ nat @ M2 @ N2 )
         => ( ~ ( finite_finite @ A @ S2 )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M2 ) @ ( infini527867602293511546merate @ A @ S2 @ N2 ) ) ) ) ) ).

% enumerate_mono
thf(fact_7907_finite__enum__ext,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X8: set @ A,Y6: set @ A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( finite_card @ A @ X8 ) )
             => ( ( infini527867602293511546merate @ A @ X8 @ I3 )
                = ( infini527867602293511546merate @ A @ Y6 @ I3 ) ) )
         => ( ( finite_finite @ A @ X8 )
           => ( ( finite_finite @ A @ Y6 )
             => ( ( ( finite_card @ A @ X8 )
                  = ( finite_card @ A @ Y6 ) )
               => ( X8 = Y6 ) ) ) ) ) ) ).

% finite_enum_ext
thf(fact_7908_finite__enumerate__Ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,S: A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( member @ A @ S @ S2 )
           => ? [N3: nat] :
                ( ( ord_less @ nat @ N3 @ ( finite_card @ A @ S2 ) )
                & ( ( infini527867602293511546merate @ A @ S2 @ N3 )
                  = S ) ) ) ) ) ).

% finite_enumerate_Ex
thf(fact_7909_finite__enumerate__in__set,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N2: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S2 ) )
           => ( member @ A @ ( infini527867602293511546merate @ A @ S2 @ N2 ) @ S2 ) ) ) ) ).

% finite_enumerate_in_set
thf(fact_7910_finite__enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M2: nat,N2: nat,S2: set @ A] :
          ( ( ord_less @ nat @ M2 @ N2 )
         => ( ( finite_finite @ A @ S2 )
           => ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S2 ) )
             => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ M2 ) @ ( infini527867602293511546merate @ A @ S2 @ N2 ) ) ) ) ) ) ).

% finite_enumerate_mono
thf(fact_7911_finite__le__enumerate,axiom,
    ! [S2: set @ nat,N2: nat] :
      ( ( finite_finite @ nat @ S2 )
     => ( ( ord_less @ nat @ N2 @ ( finite_card @ nat @ S2 ) )
       => ( ord_less_eq @ nat @ N2 @ ( infini527867602293511546merate @ nat @ S2 @ N2 ) ) ) ) ).

% finite_le_enumerate
thf(fact_7912_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N2: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ S2 ) )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N2 ) @ ( infini527867602293511546merate @ A @ S2 @ ( suc @ N2 ) ) ) ) ) ) ).

% finite_enumerate_step
thf(fact_7913_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X8: set @ A,Y6: set @ A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ ( finite_card @ A @ X8 ) )
             => ( ( infini527867602293511546merate @ A @ X8 @ I3 )
                = ( infini527867602293511546merate @ A @ Y6 @ I3 ) ) )
         => ( ( finite_finite @ A @ X8 )
           => ( ( finite_finite @ A @ Y6 )
             => ( ( ord_less_eq @ nat @ ( finite_card @ A @ X8 ) @ ( finite_card @ A @ Y6 ) )
               => ( ord_less_eq @ ( set @ A ) @ X8 @ Y6 ) ) ) ) ) ) ).

% finite_enum_subset
thf(fact_7914_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N2: nat] :
          ( ( finite_finite @ A @ S2 )
         => ( ( ord_less @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ S2 ) )
           => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N2 ) )
              = ( ord_Least @ A
                @ ^ [S6: A] :
                    ( ( member @ A @ S6 @ S2 )
                    & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N2 ) @ S6 ) ) ) ) ) ) ) ).

% finite_enumerate_Suc''
thf(fact_7915_monotone__parametric,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A5: A > B > $o,B5: C > D > $o] :
      ( ( bi_total @ A @ B @ A5 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( C > C > $o ) > ( A > C ) > $o ) @ ( ( D > D > $o ) > ( B > D ) > $o )
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A5
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A5
            @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) ) )
        @ ( bNF_rel_fun @ ( C > C > $o ) @ ( D > D > $o ) @ ( ( A > C ) > $o ) @ ( ( B > D ) > $o )
          @ ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B5
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B5
              @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) ) )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A5 @ B5 )
            @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) ) )
        @ ( comple7038119648293358887notone @ A @ C )
        @ ( comple7038119648293358887notone @ B @ D ) ) ) ).

% monotone_parametric
thf(fact_7916_Least__eq__0,axiom,
    ! [P: nat > $o] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( ord_Least @ nat @ P )
        = ( zero_zero @ nat ) ) ) ).

% Least_eq_0
thf(fact_7917_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_1: A] : ( P @ X_1 )
         => ( ! [A4: A] :
                ( ( P @ A4 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A4 @ B10 ) )
                 => ( Q @ A4 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_7918_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [A4: A] :
                ( ( P @ A4 )
               => ( ! [B10: A] :
                      ( ( P @ B10 )
                     => ( ord_less_eq @ A @ A4 @ B10 ) )
                 => ( Q @ A4 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_7919_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ( ord_Least @ A @ P )
              = X ) ) ) ) ).

% Least_equality
thf(fact_7920_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y2: A] :
                ( ( P @ Y2 )
               => ( ord_less_eq @ A @ X @ Y2 ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y5: A] :
                        ( ( P @ Y5 )
                       => ( ord_less_eq @ A @ X3 @ Y5 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_7921_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z: A] :
          ( ? [X2: A] :
              ( ( P @ X2 )
              & ! [Y2: A] :
                  ( ( P @ Y2 )
                 => ( ord_less_eq @ A @ X2 @ Y2 ) )
              & ! [Y2: A] :
                  ( ( ( P @ Y2 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y2 @ Ya2 ) ) )
                 => ( Y2 = X2 ) ) )
         => ( ( P @ Z )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z ) ) ) ) ).

% Least1_le
thf(fact_7922_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X2: A] :
              ( ( P @ X2 )
              & ! [Y2: A] :
                  ( ( P @ Y2 )
                 => ( ord_less_eq @ A @ X2 @ Y2 ) )
              & ! [Y2: A] :
                  ( ( ( P @ Y2 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y2 @ Ya2 ) ) )
                 => ( Y2 = X2 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_7923_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_7924_Least__Suc2,axiom,
    ! [P: nat > $o,N2: nat,Q: nat > $o,M2: nat] :
      ( ( P @ N2 )
     => ( ( Q @ M2 )
       => ( ~ ( P @ ( zero_zero @ nat ) )
         => ( ! [K2: nat] :
                ( ( P @ ( suc @ K2 ) )
                = ( Q @ K2 ) )
           => ( ( ord_Least @ nat @ P )
              = ( suc @ ( ord_Least @ nat @ Q ) ) ) ) ) ) ) ).

% Least_Suc2
thf(fact_7925_LeastI,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI
thf(fact_7926_LeastI2,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( Q @ X3 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2
thf(fact_7927_LeastI__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o] :
          ( ? [X_1: A] : ( P @ X_1 )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI_ex
thf(fact_7928_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_1: A] : ( P @ X_1 )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( Q @ X3 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_ex
thf(fact_7929_not__less__Least,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [K: A,P: A > $o] :
          ( ( ord_less @ A @ K @ ( ord_Least @ A @ P ) )
         => ~ ( P @ K ) ) ) ).

% not_less_Least
thf(fact_7930_Least__Suc,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ( ( ord_Least @ nat @ P )
          = ( suc
            @ ( ord_Least @ nat
              @ ^ [M: nat] : ( P @ ( suc @ M ) ) ) ) ) ) ) ).

% Least_Suc
thf(fact_7931_Least__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( finite_finite @ A @ ( collect @ A @ P ) )
         => ( ? [X_1: A] : ( P @ X_1 )
           => ( ( ord_Least @ A @ P )
              = ( lattic643756798350308766er_Min @ A @ ( collect @ A @ P ) ) ) ) ) ) ).

% Least_Min
thf(fact_7932_Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( bleast @ A )
        = ( ^ [S7: set @ A,P3: A > $o] :
              ( ord_Least @ A
              @ ^ [X4: A] :
                  ( ( member @ A @ X4 @ S7 )
                  & ( P3 @ X4 ) ) ) ) ) ) ).

% Bleast_def
thf(fact_7933_abort__Bleast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( abort_Bleast @ A )
        = ( ^ [S7: set @ A,P3: A > $o] :
              ( ord_Least @ A
              @ ^ [X4: A] :
                  ( ( member @ A @ X4 @ S7 )
                  & ( P3 @ X4 ) ) ) ) ) ) ).

% abort_Bleast_def
thf(fact_7934_Sup__real__def,axiom,
    ( ( complete_Sup_Sup @ real )
    = ( ^ [X6: set @ real] :
          ( ord_Least @ real
          @ ^ [Z5: real] :
            ! [X4: real] :
              ( ( member @ real @ X4 @ X6 )
             => ( ord_less_eq @ real @ X4 @ Z5 ) ) ) ) ) ).

% Sup_real_def
thf(fact_7935_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,S2: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ? [X2: A] :
                ( ( member @ A @ X2 @ S2 )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ S2 )
                   => ( ord_less_eq @ A @ X2 @ Xa3 ) ) )
           => ( ( ord_Least @ B
                @ ^ [Y4: B] : ( member @ B @ Y4 @ ( image @ A @ B @ F2 @ S2 ) ) )
              = ( F2
                @ ( ord_Least @ A
                  @ ^ [X4: A] : ( member @ A @ X4 @ S2 ) ) ) ) ) ) ) ).

% Least_mono
thf(fact_7936_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X4: A] :
                  ( ( P3 @ X4 )
                  & ! [Y4: A] :
                      ( ( P3 @ Y4 )
                     => ( ord_less_eq @ A @ X4 @ Y4 ) ) ) ) ) ) ) ).

% Least_def
thf(fact_7937_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S2: set @ A,N2: nat] :
          ( ~ ( finite_finite @ A @ S2 )
         => ( ( infini527867602293511546merate @ A @ S2 @ ( suc @ N2 ) )
            = ( ord_Least @ A
              @ ^ [S6: A] :
                  ( ( member @ A @ S6 @ S2 )
                  & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S2 @ N2 ) @ S6 ) ) ) ) ) ) ).

% enumerate_Suc''
thf(fact_7938_fun__ord__parametric,axiom,
    ! [C: $tType,D: $tType,A: $tType,B: $tType,F: $tType,E4: $tType,C6: A > B > $o,A5: C > E4 > $o,B5: D > F > $o] :
      ( ( bi_total @ A @ B @ C6 )
     => ( bNF_rel_fun @ ( C > D > $o ) @ ( E4 > F > $o ) @ ( ( A > C ) > ( A > D ) > $o ) @ ( ( B > E4 ) > ( B > F ) > $o )
        @ ( bNF_rel_fun @ C @ E4 @ ( D > $o ) @ ( F > $o ) @ A5
          @ ( bNF_rel_fun @ D @ F @ $o @ $o @ B5
            @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) ) )
        @ ( bNF_rel_fun @ ( A > C ) @ ( B > E4 ) @ ( ( A > D ) > $o ) @ ( ( B > F ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ E4 @ C6 @ A5 )
          @ ( bNF_rel_fun @ ( A > D ) @ ( B > F ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ D @ F @ C6 @ B5 )
            @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) ) )
        @ ( partial_fun_ord @ C @ D @ A )
        @ ( partial_fun_ord @ E4 @ F @ B ) ) ) ).

% fun_ord_parametric
thf(fact_7939_inverse__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X6: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X6 )
        @ ^ [N: nat] : ( zero_zero @ rat )
        @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X6 @ N ) ) )
    @ ^ [X6: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X6 )
        @ ^ [N: nat] : ( zero_zero @ rat )
        @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X6 @ N ) ) ) ) ).

% inverse_real.rsp
thf(fact_7940_vanishes__const,axiom,
    ! [C2: rat] :
      ( ( vanishes
        @ ^ [N: nat] : C2 )
      = ( C2
        = ( zero_zero @ rat ) ) ) ).

% vanishes_const
thf(fact_7941_vanishes__add,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( vanishes @ X8 )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N: nat] : ( plus_plus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% vanishes_add
thf(fact_7942_vanishes__diff,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( vanishes @ X8 )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N: nat] : ( minus_minus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% vanishes_diff
thf(fact_7943_vanishes__minus,axiom,
    ! [X8: nat > rat] :
      ( ( vanishes @ X8 )
     => ( vanishes
        @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X8 @ N ) ) ) ) ).

% vanishes_minus
thf(fact_7944_vanishes__def,axiom,
    ( vanishes
    = ( ^ [X6: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X6 @ N ) ) @ R5 ) ) ) ) ) ).

% vanishes_def
thf(fact_7945_vanishesI,axiom,
    ! [X8: nat > rat] :
      ( ! [R2: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
         => ? [K4: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N3 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N3 ) ) @ R2 ) ) )
     => ( vanishes @ X8 ) ) ).

% vanishesI
thf(fact_7946_vanishesD,axiom,
    ! [X8: nat > rat,R: rat] :
      ( ( vanishes @ X8 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
       => ? [K2: nat] :
          ! [N8: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N8 )
           => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N8 ) ) @ R ) ) ) ) ).

% vanishesD
thf(fact_7947_vanishes__mult__bounded,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ? [A17: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ A17 )
          & ! [N3: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N3 ) ) @ A17 ) )
     => ( ( vanishes @ Y6 )
       => ( vanishes
          @ ^ [N: nat] : ( times_times @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% vanishes_mult_bounded
thf(fact_7948_inverse__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X6: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X6 )
        @ ^ [N: nat] : ( zero_zero @ rat )
        @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X6 @ N ) ) )
    @ ( inverse_inverse @ real ) ) ).

% inverse_real.transfer
thf(fact_7949_inverse__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( inverse_inverse @ real @ ( real2 @ X ) )
        = ( real2
          @ ( if @ ( nat > rat ) @ ( vanishes @ X )
            @ ^ [N: nat] : ( zero_zero @ rat )
            @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X @ N ) ) ) ) ) ) ).

% inverse_real.abs_eq
thf(fact_7950_real_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > $o ) @ ( real > $o ) @ pcr_real
    @ ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ realrel
    @ ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) ) ).

% real.rel_eq_transfer
thf(fact_7951_one__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N: nat] : ( one_one @ rat )
    @ ( one_one @ real ) ) ).

% one_real.transfer
thf(fact_7952_zero__real__def,axiom,
    ( ( zero_zero @ real )
    = ( real2
      @ ^ [N: nat] : ( zero_zero @ rat ) ) ) ).

% zero_real_def
thf(fact_7953_one__real__def,axiom,
    ( ( one_one @ real )
    = ( real2
      @ ^ [N: nat] : ( one_one @ rat ) ) ) ).

% one_real_def
thf(fact_7954_of__int__Real,axiom,
    ( ( ring_1_of_int @ real )
    = ( ^ [X4: int] :
          ( real2
          @ ^ [N: nat] : ( ring_1_of_int @ rat @ X4 ) ) ) ) ).

% of_int_Real
thf(fact_7955_of__rat__Real,axiom,
    ( ( field_char_0_of_rat @ real )
    = ( ^ [X4: rat] :
          ( real2
          @ ^ [N: nat] : X4 ) ) ) ).

% of_rat_Real
thf(fact_7956_zero__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N: nat] : ( zero_zero @ rat )
    @ ( zero_zero @ real ) ) ).

% zero_real.transfer
thf(fact_7957_real_Oabs__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [Y2: nat > rat] :
          ( ( realrel @ Y2 @ Y2 )
         => ( P @ ( real2 @ Y2 ) ) )
     => ( P @ X ) ) ).

% real.abs_induct
thf(fact_7958_of__nat__Real,axiom,
    ( ( semiring_1_of_nat @ real )
    = ( ^ [X4: nat] :
          ( real2
          @ ^ [N: nat] : ( semiring_1_of_nat @ rat @ X4 ) ) ) ) ).

% of_nat_Real
thf(fact_7959_uminus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X6: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X6 @ N ) )
    @ ( uminus_uminus @ real ) ) ).

% uminus_real.transfer
thf(fact_7960_plus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X6 @ N ) @ ( Y7 @ N ) )
    @ ( plus_plus @ real ) ) ).

% plus_real.transfer
thf(fact_7961_uminus__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( uminus_uminus @ real @ ( real2 @ X ) )
        = ( real2
          @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X @ N ) ) ) ) ) ).

% uminus_real.abs_eq
thf(fact_7962_times__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X6 @ N ) @ ( Y7 @ N ) )
    @ ( times_times @ real ) ) ).

% times_real.transfer
thf(fact_7963_plus__real_Oabs__eq,axiom,
    ! [Xa2: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa2 @ Xa2 )
     => ( ( realrel @ X @ X )
       => ( ( plus_plus @ real @ ( real2 @ Xa2 ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N: nat] : ( plus_plus @ rat @ ( Xa2 @ N ) @ ( X @ N ) ) ) ) ) ) ).

% plus_real.abs_eq
thf(fact_7964_times__real_Oabs__eq,axiom,
    ! [Xa2: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa2 @ Xa2 )
     => ( ( realrel @ X @ X )
       => ( ( times_times @ real @ ( real2 @ Xa2 ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N: nat] : ( times_times @ rat @ ( Xa2 @ N ) @ ( X @ N ) ) ) ) ) ) ).

% times_real.abs_eq
thf(fact_7965_Real_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X6: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ord_less @ rat @ R5 @ ( X6 @ N ) ) ) )
    @ positive2 ) ).

% Real.positive.transfer
thf(fact_7966_Real_Opositive_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( positive2 @ ( real2 @ X ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less @ rat @ R5 @ ( X @ N ) ) ) ) ) ) ) ).

% Real.positive.abs_eq
thf(fact_7967_Real_Opositive__zero,axiom,
    ~ ( positive2 @ ( zero_zero @ real ) ) ).

% Real.positive_zero
thf(fact_7968_Real_Opositive__mult,axiom,
    ! [X: real,Y: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y )
       => ( positive2 @ ( times_times @ real @ X @ Y ) ) ) ) ).

% Real.positive_mult
thf(fact_7969_Real_Opositive__add,axiom,
    ! [X: real,Y: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y )
       => ( positive2 @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% Real.positive_add
thf(fact_7970_Real_Opositive__minus,axiom,
    ! [X: real] :
      ( ~ ( positive2 @ X )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( positive2 @ ( uminus_uminus @ real @ X ) ) ) ) ).

% Real.positive_minus
thf(fact_7971_less__real__def,axiom,
    ( ( ord_less @ real )
    = ( ^ [X4: real,Y4: real] : ( positive2 @ ( minus_minus @ real @ Y4 @ X4 ) ) ) ) ).

% less_real_def
thf(fact_7972_le__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( ord_less_eq @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( ! [R5: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
               => ? [K3: nat] :
                  ! [N: nat] :
                    ( ( ord_less_eq @ nat @ K3 @ N )
                   => ( ord_less_eq @ rat @ ( X8 @ N ) @ ( plus_plus @ rat @ ( Y6 @ N ) @ R5 ) ) ) ) ) ) ) ) ).

% le_Real
thf(fact_7973_Real_Opositive_Orep__eq,axiom,
    ( positive2
    = ( ^ [X4: real] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N )
             => ( ord_less @ rat @ R5 @ ( rep_real @ X4 @ N ) ) ) ) ) ) ).

% Real.positive.rep_eq
thf(fact_7974_cauchy__inverse,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ( cauchy
          @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X8 @ N ) ) ) ) ) ).

% cauchy_inverse
thf(fact_7975_cauchy__add,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N: nat] : ( plus_plus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% cauchy_add
thf(fact_7976_cauchy__const,axiom,
    ! [X: rat] :
      ( cauchy
      @ ^ [N: nat] : X ) ).

% cauchy_const
thf(fact_7977_cauchy__minus,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( cauchy
        @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X8 @ N ) ) ) ) ).

% cauchy_minus
thf(fact_7978_cauchy__mult,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N: nat] : ( times_times @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% cauchy_mult
thf(fact_7979_cauchy__diff,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( cauchy
          @ ^ [N: nat] : ( minus_minus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ).

% cauchy_diff
thf(fact_7980_realrel__refl,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( realrel @ X8 @ X8 ) ) ).

% realrel_refl
thf(fact_7981_Real__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [X9: nat > rat] :
          ( ( cauchy @ X9 )
         => ( P @ ( real2 @ X9 ) ) )
     => ( P @ X ) ) ).

% Real_induct
thf(fact_7982_cr__real__eq,axiom,
    ( pcr_real
    = ( ^ [X4: nat > rat,Y4: real] :
          ( ( cauchy @ X4 )
          & ( ( real2 @ X4 )
            = Y4 ) ) ) ) ).

% cr_real_eq
thf(fact_7983_cauchy__imp__bounded,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ? [B4: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
          & ! [N8: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N8 ) ) @ B4 ) ) ) ).

% cauchy_imp_bounded
thf(fact_7984_less__RealD,axiom,
    ! [Y6: nat > rat,X: real] :
      ( ( cauchy @ Y6 )
     => ( ( ord_less @ real @ X @ ( real2 @ Y6 ) )
       => ? [N3: nat] : ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ ( Y6 @ N3 ) ) ) ) ) ).

% less_RealD
thf(fact_7985_le__RealI,axiom,
    ! [Y6: nat > rat,X: real] :
      ( ( cauchy @ Y6 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ X @ ( field_char_0_of_rat @ real @ ( Y6 @ N3 ) ) )
       => ( ord_less_eq @ real @ X @ ( real2 @ Y6 ) ) ) ) ).

% le_RealI
thf(fact_7986_Real__leI,axiom,
    ! [X8: nat > rat,Y: real] :
      ( ( cauchy @ X8 )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( field_char_0_of_rat @ real @ ( X8 @ N3 ) ) @ Y )
       => ( ord_less_eq @ real @ ( real2 @ X8 ) @ Y ) ) ) ).

% Real_leI
thf(fact_7987_minus__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( uminus_uminus @ real @ ( real2 @ X8 ) )
        = ( real2
          @ ^ [N: nat] : ( uminus_uminus @ rat @ ( X8 @ N ) ) ) ) ) ).

% minus_Real
thf(fact_7988_add__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( plus_plus @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N: nat] : ( plus_plus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% add_Real
thf(fact_7989_mult__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( times_times @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N: nat] : ( times_times @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% mult_Real
thf(fact_7990_diff__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( minus_minus @ real @ ( real2 @ X8 ) @ ( real2 @ Y6 ) )
          = ( real2
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% diff_Real
thf(fact_7991_realrelI,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( vanishes
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) )
         => ( realrel @ X8 @ Y6 ) ) ) ) ).

% realrelI
thf(fact_7992_eq__Real,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( cauchy @ Y6 )
       => ( ( ( real2 @ X8 )
            = ( real2 @ Y6 ) )
          = ( vanishes
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) ) ) ) ) ).

% eq_Real
thf(fact_7993_vanishes__diff__inverse,axiom,
    ! [X8: nat > rat,Y6: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ( ( cauchy @ Y6 )
         => ( ~ ( vanishes @ Y6 )
           => ( ( vanishes
                @ ^ [N: nat] : ( minus_minus @ rat @ ( X8 @ N ) @ ( Y6 @ N ) ) )
             => ( vanishes
                @ ^ [N: nat] : ( minus_minus @ rat @ ( inverse_inverse @ rat @ ( X8 @ N ) ) @ ( inverse_inverse @ rat @ ( Y6 @ N ) ) ) ) ) ) ) ) ) ).

% vanishes_diff_inverse
thf(fact_7994_realrel__def,axiom,
    ( realrel
    = ( ^ [X6: nat > rat,Y7: nat > rat] :
          ( ( cauchy @ X6 )
          & ( cauchy @ Y7 )
          & ( vanishes
            @ ^ [N: nat] : ( minus_minus @ rat @ ( X6 @ N ) @ ( Y7 @ N ) ) ) ) ) ) ).

% realrel_def
thf(fact_7995_cauchy__not__vanishes__cases,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ? [B4: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
            & ? [K2: nat] :
                ( ! [N8: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N8 )
                   => ( ord_less @ rat @ B4 @ ( uminus_uminus @ rat @ ( X8 @ N8 ) ) ) )
                | ! [N8: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N8 )
                   => ( ord_less @ rat @ B4 @ ( X8 @ N8 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
thf(fact_7996_positive__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( positive2 @ ( real2 @ X8 ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less @ rat @ R5 @ ( X8 @ N ) ) ) ) ) ) ) ).

% positive_Real
thf(fact_7997_cauchy__not__vanishes,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ~ ( vanishes @ X8 )
       => ? [B4: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
            & ? [K2: nat] :
              ! [N8: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N8 )
               => ( ord_less @ rat @ B4 @ ( abs_abs @ rat @ ( X8 @ N8 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes
thf(fact_7998_cauchy__def,axiom,
    ( cauchy
    = ( ^ [X6: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [M: nat] :
              ( ( ord_less_eq @ nat @ K3 @ M )
             => ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X6 @ M ) @ ( X6 @ N ) ) ) @ R5 ) ) ) ) ) ) ).

% cauchy_def
thf(fact_7999_cauchyI,axiom,
    ! [X8: nat > rat] :
      ( ! [R2: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
         => ? [K4: nat] :
            ! [M4: nat] :
              ( ( ord_less_eq @ nat @ K4 @ M4 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N3 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) ) @ R2 ) ) ) )
     => ( cauchy @ X8 ) ) ).

% cauchyI
thf(fact_8000_cauchyD,axiom,
    ! [X8: nat > rat,R: rat] :
      ( ( cauchy @ X8 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
       => ? [K2: nat] :
          ! [M3: nat] :
            ( ( ord_less_eq @ nat @ K2 @ M3 )
           => ! [N8: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N8 )
               => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M3 ) @ ( X8 @ N8 ) ) ) @ R ) ) ) ) ) ).

% cauchyD
thf(fact_8001_inverse__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( ( vanishes @ X8 )
         => ( ( inverse_inverse @ real @ ( real2 @ X8 ) )
            = ( zero_zero @ real ) ) )
        & ( ~ ( vanishes @ X8 )
         => ( ( inverse_inverse @ real @ ( real2 @ X8 ) )
            = ( real2
              @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X8 @ N ) ) ) ) ) ) ) ).

% inverse_Real
thf(fact_8002_not__positive__Real,axiom,
    ! [X8: nat > rat] :
      ( ( cauchy @ X8 )
     => ( ( ~ ( positive2 @ ( real2 @ X8 ) ) )
        = ( ! [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
             => ? [K3: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N )
                 => ( ord_less_eq @ rat @ ( X8 @ N ) @ R5 ) ) ) ) ) ) ).

% not_positive_Real
thf(fact_8003_Real_Opositive__def,axiom,
    ( positive2
    = ( map_fun @ real @ ( nat > rat ) @ $o @ $o @ rep_real @ ( id @ $o )
      @ ^ [X6: nat > rat] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N )
             => ( ord_less @ rat @ R5 @ ( X6 @ N ) ) ) ) ) ) ).

% Real.positive_def
thf(fact_8004_inverse__real__def,axiom,
    ( ( inverse_inverse @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X6: nat > rat] :
          ( if @ ( nat > rat ) @ ( vanishes @ X6 )
          @ ^ [N: nat] : ( zero_zero @ rat )
          @ ^ [N: nat] : ( inverse_inverse @ rat @ ( X6 @ N ) ) ) ) ) ).

% inverse_real_def
thf(fact_8005_uminus__real__def,axiom,
    ( ( uminus_uminus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X6: nat > rat,N: nat] : ( uminus_uminus @ rat @ ( X6 @ N ) ) ) ) ).

% uminus_real_def
thf(fact_8006_times__real__def,axiom,
    ( ( times_times @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( times_times @ rat @ ( X6 @ N ) @ ( Y7 @ N ) ) ) ) ).

% times_real_def
thf(fact_8007_plus__real__def,axiom,
    ( ( plus_plus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X6: nat > rat,Y7: nat > rat,N: nat] : ( plus_plus @ rat @ ( X6 @ N ) @ ( Y7 @ N ) ) ) ) ).

% plus_real_def
thf(fact_8008_cr__real__def,axiom,
    ( cr_real
    = ( ^ [X4: nat > rat,Y4: real] :
          ( ( realrel @ X4 @ X4 )
          & ( ( real2 @ X4 )
            = Y4 ) ) ) ) ).

% cr_real_def
thf(fact_8009_stable__sort__key__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord3483353639454293061rt_key @ B @ A )
        = ( ^ [Sk: ( B > A ) > ( list @ B ) > ( list @ B )] :
            ! [F3: B > A,Xs3: list @ B,K3: A] :
              ( ( filter2 @ B
                @ ^ [Y4: B] :
                    ( ( F3 @ Y4 )
                    = K3 )
                @ ( Sk @ F3 @ Xs3 ) )
              = ( filter2 @ B
                @ ^ [Y4: B] :
                    ( ( F3 @ Y4 )
                    = K3 )
                @ Xs3 ) ) ) ) ) ).

% stable_sort_key_def
thf(fact_8010_real_Opcr__cr__eq,axiom,
    pcr_real = cr_real ).

% real.pcr_cr_eq
thf(fact_8011_stable__sort__key__sort__key,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ( linord3483353639454293061rt_key @ A @ B @ ( linorder_sort_key @ A @ B ) ) ) ).

% stable_sort_key_sort_key
thf(fact_8012_independent__explicit__finite__subsets,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ A5 ) )
          = ( ! [S7: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ S7 @ A5 )
               => ( ( finite_finite @ A @ S7 )
                 => ! [U2: A > real] :
                      ( ( ( groups7311177749621191930dd_sum @ A @ A
                          @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                          @ S7 )
                        = ( zero_zero @ A ) )
                     => ! [X4: A] :
                          ( ( member @ A @ X4 @ S7 )
                         => ( ( U2 @ X4 )
                            = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_finite_subsets
thf(fact_8013_independent__explicit__module,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ S ) )
          = ( ! [T3: set @ A,U2: A > real,V5: A] :
                ( ( finite_finite @ A @ T3 )
               => ( ( ord_less_eq @ ( set @ A ) @ T3 @ S )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ W3 ) @ W3 )
                        @ T3 )
                      = ( zero_zero @ A ) )
                   => ( ( member @ A @ V5 @ T3 )
                     => ( ( U2 @ V5 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_module
thf(fact_8014_independent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ~ ( real_V358717886546972837endent @ A @ A5 )
         => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
           => ~ ( real_V358717886546972837endent @ A @ B5 ) ) ) ) ).

% independent_mono
thf(fact_8015_dependent__mono,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B5: set @ A,A5: set @ A] :
          ( ( real_V358717886546972837endent @ A @ B5 )
         => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
           => ( real_V358717886546972837endent @ A @ A5 ) ) ) ) ).

% dependent_mono
thf(fact_8016_independent__Union__directed,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C6: set @ ( set @ A )] :
          ( ! [C3: set @ A,D4: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C6 )
             => ( ( member @ ( set @ A ) @ D4 @ C6 )
               => ( ( ord_less_eq @ ( set @ A ) @ C3 @ D4 )
                  | ( ord_less_eq @ ( set @ A ) @ D4 @ C3 ) ) ) )
         => ( ! [C3: set @ A] :
                ( ( member @ ( set @ A ) @ C3 @ C6 )
               => ~ ( real_V358717886546972837endent @ A @ C3 ) )
           => ~ ( real_V358717886546972837endent @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ).

% independent_Union_directed
thf(fact_8017_independentD__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B5: set @ A,X8: A > real,Y6: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ B5 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X4: A] :
                    ( ( X8 @ X4 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X4: A] :
                      ( ( X8 @ X4 )
                     != ( zero_zero @ real ) ) )
                @ B5 )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X4: A] :
                        ( ( Y6 @ X4 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X4: A] :
                          ( ( Y6 @ X4 )
                         != ( zero_zero @ real ) ) )
                    @ B5 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X4 ) @ X4 )
                        @ ( collect @ A
                          @ ^ [X4: A] :
                              ( ( X8 @ X4 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( Y6 @ X4 ) @ X4 )
                        @ ( collect @ A
                          @ ^ [X4: A] :
                              ( ( Y6 @ X4 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( X8 = Y6 ) ) ) ) ) ) ) ) ).

% independentD_unique
thf(fact_8018_independentD,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A,T2: set @ A,U: A > real,V2: A] :
          ( ~ ( real_V358717886546972837endent @ A @ S )
         => ( ( finite_finite @ A @ T2 )
           => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U @ V5 ) @ V5 )
                    @ T2 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ V2 @ T2 )
                 => ( ( U @ V2 )
                    = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independentD
thf(fact_8019_dependent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [B8: set @ A] :
            ? [X6: A > real] :
              ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [X4: A] :
                      ( ( X6 @ X4 )
                     != ( zero_zero @ real ) ) ) )
              & ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X4: A] :
                      ( ( X6 @ X4 )
                     != ( zero_zero @ real ) ) )
                @ B8 )
              & ( ( groups7311177749621191930dd_sum @ A @ A
                  @ ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( X6 @ X4 ) @ X4 )
                  @ ( collect @ A
                    @ ^ [X4: A] :
                        ( ( X6 @ X4 )
                       != ( zero_zero @ real ) ) ) )
                = ( zero_zero @ A ) )
              & ? [X4: A] :
                  ( ( X6 @ X4 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% dependent_alt
thf(fact_8020_independent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B5: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ B5 ) )
          = ( ! [X6: A > real] :
                ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X4: A] :
                        ( ( X6 @ X4 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X4: A] :
                          ( ( X6 @ X4 )
                         != ( zero_zero @ real ) ) )
                    @ B5 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( X6 @ X4 ) @ X4 )
                        @ ( collect @ A
                          @ ^ [X4: A] :
                              ( ( X6 @ X4 )
                             != ( zero_zero @ real ) ) ) )
                      = ( zero_zero @ A ) )
                   => ! [X4: A] :
                        ( ( X6 @ X4 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independent_alt
thf(fact_8021_independentD__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B5: set @ A,X8: A > real,X: A] :
          ( ~ ( real_V358717886546972837endent @ A @ B5 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X4: A] :
                    ( ( X8 @ X4 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X4: A] :
                      ( ( X8 @ X4 )
                     != ( zero_zero @ real ) ) )
                @ B5 )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [X4: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X4 ) @ X4 )
                    @ ( collect @ A
                      @ ^ [X4: A] :
                          ( ( X8 @ X4 )
                         != ( zero_zero @ real ) ) ) )
                  = ( zero_zero @ A ) )
               => ( ( X8 @ X )
                  = ( zero_zero @ real ) ) ) ) ) ) ) ).

% independentD_alt
thf(fact_8022_dependent__explicit,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [S6: set @ A] :
            ? [T3: set @ A] :
              ( ( finite_finite @ A @ T3 )
              & ( ord_less_eq @ ( set @ A ) @ T3 @ S6 )
              & ? [U2: A > real] :
                  ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ T3 )
                    = ( zero_zero @ A ) )
                  & ? [X4: A] :
                      ( ( member @ A @ X4 @ T3 )
                      & ( ( U2 @ X4 )
                       != ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% dependent_explicit
thf(fact_8023_possible__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se6407376104438227557le_bit @ A )
        = ( ^ [Tyrep: itself @ A,N: nat] :
              ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% possible_bit_def
thf(fact_8024_append__butlast__last__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) ).

% append_butlast_last_id
thf(fact_8025_last__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( last @ A @ ( remdups_adj @ A @ Xs ) )
      = ( last @ A @ Xs ) ) ).

% last_remdups_adj
thf(fact_8026_possible__bit__min,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I2: nat,J: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ ( ord_min @ nat @ I2 @ J ) )
          = ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I2 )
            | ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J ) ) ) ) ).

% possible_bit_min
thf(fact_8027_last__appendL,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( Ys
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Xs ) ) ) ).

% last_appendL
thf(fact_8028_last__appendR,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Ys ) ) ) ).

% last_appendR
thf(fact_8029_last__replicate,axiom,
    ! [A: $tType,N2: nat,X: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( last @ A @ ( replicate @ A @ N2 @ X ) )
        = X ) ) ).

% last_replicate
thf(fact_8030_last__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( last @ nat @ ( upt @ I2 @ J ) )
        = ( minus_minus @ nat @ J @ ( one_one @ nat ) ) ) ) ).

% last_upt
thf(fact_8031_last__snoc,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% last_snoc
thf(fact_8032_last__drop,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( last @ A @ ( drop @ A @ N2 @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_drop
thf(fact_8033_last__zip,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ B ) @ Ys ) )
         => ( ( last @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys ) )
            = ( product_Pair @ A @ B @ ( last @ A @ Xs ) @ ( last @ B @ Ys ) ) ) ) ) ) ).

% last_zip
thf(fact_8034_last__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( last @ A @ Xs ) ) ) ) ).

% last_map
thf(fact_8035_last__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( ( tl @ A @ Xs )
         != ( nil @ A ) ) )
     => ( ( last @ A @ ( tl @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_tl
thf(fact_8036_last__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( last @ A @ ( rev @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% last_rev
thf(fact_8037_hd__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( rev @ A @ Xs ) )
      = ( last @ A @ Xs ) ) ).

% hd_rev
thf(fact_8038_hd__Nil__eq__last,axiom,
    ! [A: $tType] :
      ( ( hd @ A @ ( nil @ A ) )
      = ( last @ A @ ( nil @ A ) ) ) ).

% hd_Nil_eq_last
thf(fact_8039_last__in__set,axiom,
    ! [A: $tType,As3: list @ A] :
      ( ( As3
       != ( nil @ A ) )
     => ( member @ A @ ( last @ A @ As3 ) @ ( set2 @ A @ As3 ) ) ) ).

% last_in_set
thf(fact_8040_possible__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Ty: itself @ A] : ( bit_se6407376104438227557le_bit @ A @ Ty @ ( zero_zero @ nat ) ) ) ).

% possible_bit_0
thf(fact_8041_longest__common__suffix,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
    ? [Ss: list @ A,Xs4: list @ A,Ys5: list @ A] :
      ( ( Xs
        = ( append @ A @ Xs4 @ Ss ) )
      & ( Ys
        = ( append @ A @ Ys5 @ Ss ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( last @ A @ Xs4 )
         != ( last @ A @ Ys5 ) ) ) ) ).

% longest_common_suffix
thf(fact_8042_last__append,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Ys ) ) ) ) ).

% last_append
thf(fact_8043_last_Osimps,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = X ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) ).

% last.simps
thf(fact_8044_last__ConsL,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = X ) ) ).

% last_ConsL
thf(fact_8045_last__ConsR,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_ConsR
thf(fact_8046_dropWhile__last,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( last @ A @ ( dropWhile @ A @ P @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) ).

% dropWhile_last
thf(fact_8047_possible__bit__less__imp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I2: nat,J: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I2 )
         => ( ( ord_less_eq @ nat @ J @ I2 )
           => ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J ) ) ) ) ).

% possible_bit_less_imp
thf(fact_8048_takeWhile__not__last,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( takeWhile @ A
          @ ^ [Y4: A] :
              ( Y4
             != ( last @ A @ Xs ) )
          @ Xs )
        = ( butlast @ A @ Xs ) ) ) ).

% takeWhile_not_last
thf(fact_8049_snoc__eq__iff__butlast,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = Ys )
      = ( ( Ys
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys )
          = Xs )
        & ( ( last @ A @ Ys )
          = X ) ) ) ).

% snoc_eq_iff_butlast
thf(fact_8050_remdups__adj__append_H,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ A ) )
        | ( ( last @ A @ Xs )
         != ( hd @ A @ Ys ) ) )
     => ( ( remdups_adj @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( remdups_adj @ A @ Xs ) @ ( remdups_adj @ A @ Ys ) ) ) ) ).

% remdups_adj_append'
thf(fact_8051_remdups__adj__append_H_H,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( remdups_adj @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( remdups_adj @ A @ Xs )
          @ ( remdups_adj @ A
            @ ( dropWhile @ A
              @ ^ [Y4: A] :
                  ( Y4
                  = ( last @ A @ Xs ) )
              @ Ys ) ) ) ) ) ).

% remdups_adj_append''
thf(fact_8052_last__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ Xs )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ) ) ).

% last_conv_nth
thf(fact_8053_last__list__update,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( ( K
            = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = X ) )
        & ( ( K
           != ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) )
         => ( ( last @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = ( last @ A @ Xs ) ) ) ) ) ).

% last_list_update
thf(fact_8054_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M2 @ N2 )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_8055_bit__minus__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% bit_minus_2_iff
thf(fact_8056_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
          = ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 ) ) ) ).

% bit_minus_1_iff
thf(fact_8057_bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N2 )
          = ( ~ ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_not_iff
thf(fact_8058_bit__imp__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 ) ) ) ).

% bit_imp_possible_bit
thf(fact_8059_impossible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ).

% impossible_bit
thf(fact_8060_bit__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
            ! [N: nat] :
              ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
             => ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N )
                = ( bit_se5641148757651400278ts_bit @ A @ B3 @ N ) ) ) ) ) ) ).

% bit_eq_iff
thf(fact_8061_bit__eqI,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
                = ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) ) )
         => ( A2 = B2 ) ) ) ).

% bit_eqI
thf(fact_8062_bit__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se8732182000553998342ip_bit @ A @ M2 @ A2 ) @ N2 )
          = ( ( ( M2 = N2 )
              = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 ) ) ) ) ).

% bit_flip_bit_iff
thf(fact_8063_bit__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5668285175392031749et_bit @ A @ M2 @ A2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            | ( ( M2 = N2 )
              & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 ) ) ) ) ) ).

% bit_set_bit_iff
thf(fact_8064_bit__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2239418461657761734s_mask @ A @ M2 ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( ord_less @ nat @ N2 @ M2 ) ) ) ) ).

% bit_mask_iff
thf(fact_8065_bit__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( ring_1_of_int @ A @ K ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ) ).

% bit_of_int_iff
thf(fact_8066_bit__of__nat__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M2 ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( bit_se5641148757651400278ts_bit @ nat @ M2 @ N2 ) ) ) ) ).

% bit_of_nat_iff
thf(fact_8067_bit__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4674362597316999326ke_bit @ A @ M2 @ A2 ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( ord_min @ nat @ M2 @ N2 ) ) ) ) ) ).

% bit_signed_take_bit_iff
thf(fact_8068_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% bit_minus_iff
thf(fact_8069_bit__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M2: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4730199178511100633sh_bit @ A @ M2 @ A2 ) @ N2 )
          = ( ( ord_less_eq @ nat @ M2 @ N2 )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) ).

% bit_push_bit_iff
thf(fact_8070_fold__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 ) ) ) ) ).

% fold_possible_bit
thf(fact_8071_bit__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( M2 = N2 ) ) ) ) ).

% bit_exp_iff
thf(fact_8072_bit__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ ( one_one @ nat ) )
            & ( N2
              = ( one_one @ nat ) ) ) ) ) ).

% bit_2_iff
thf(fact_8073_bit__not__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( N2 != M2 ) ) ) ) ).

% bit_not_exp_iff
thf(fact_8074_bit__minus__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( ord_less_eq @ nat @ M2 @ N2 ) ) ) ) ).

% bit_minus_exp_iff
thf(fact_8075_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M2: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M2 ) @ ( one_one @ A ) ) @ N2 )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
            & ( ord_less @ nat @ N2 @ M2 ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_8076_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
            & ( N2
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 ) ) ) ) ).

% bit_double_iff
thf(fact_8077_CHAR__pos__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( ? [N: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
              & ( ( semiring_1_of_nat @ A @ N )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_pos_iff
thf(fact_8078_CHAR__eq__posI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
         => ( ( ( semiring_1_of_nat @ A @ C2 )
              = ( zero_zero @ A ) )
           => ( ! [X3: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X3 )
                 => ( ( ord_less @ nat @ X3 @ C2 )
                   => ( ( semiring_1_of_nat @ A @ X3 )
                     != ( zero_zero @ A ) ) ) )
             => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
                = C2 ) ) ) ) ) ).

% CHAR_eq_posI
thf(fact_8079_CHAR__eq0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
          = ( zero_zero @ nat ) )
        = ( ! [N: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( semiring_1_of_nat @ A @ N )
               != ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_eq0_iff
thf(fact_8080_List_Ounion__def,axiom,
    ! [A: $tType] :
      ( ( union @ A )
      = ( fold @ A @ ( list @ A ) @ ( insert @ A ) ) ) ).

% List.union_def
thf(fact_8081_inv__image__partition,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( set2 @ A @ Ys ) )
           => ~ ( P @ Y2 ) )
       => ( ( vimage @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( partition @ A @ P ) @ ( insert2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) )
          = ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% inv_image_partition
thf(fact_8082_in__set__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = Xs ) ) ).

% in_set_insert
thf(fact_8083_distinct__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( distinct @ A @ ( insert @ A @ X @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_insert
thf(fact_8084_insert__Nil,axiom,
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% insert_Nil
thf(fact_8085_not__in__set__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = ( cons @ A @ X @ Xs ) ) ) ).

% not_in_set_insert
thf(fact_8086_List_Oset__insert,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( set2 @ A @ ( insert @ A @ X @ Xs ) )
      = ( insert2 @ A @ X @ ( set2 @ A @ Xs ) ) ) ).

% List.set_insert
thf(fact_8087_finite__vimageD_H,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ B] :
      ( ( finite_finite @ A @ ( vimage @ A @ B @ F2 @ A5 ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) )
       => ( finite_finite @ B @ A5 ) ) ) ).

% finite_vimageD'
thf(fact_8088_continuous__imp__open__vimage,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [S: set @ A,F2: A > B,B5: set @ B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( topolo1002775350975398744n_open @ B @ B5 )
             => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B5 ) @ S )
               => ( topolo1002775350975398744n_open @ A @ ( vimage @ A @ B @ F2 @ B5 ) ) ) ) ) ) ) ).

% continuous_imp_open_vimage
thf(fact_8089_subset__vimage__iff,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,F2: A > B,B5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( vimage @ A @ B @ F2 @ B5 ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ A5 )
           => ( member @ B @ ( F2 @ X4 ) @ B5 ) ) ) ) ).

% subset_vimage_iff
thf(fact_8090_vimage__mono,axiom,
    ! [B: $tType,A: $tType,A5: set @ A,B5: set @ A,F2: B > A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
     => ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ A5 ) @ ( vimage @ B @ A @ F2 @ B5 ) ) ) ).

% vimage_mono
thf(fact_8091_image__vimage__subset,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( vimage @ B @ A @ F2 @ A5 ) ) @ A5 ) ).

% image_vimage_subset
thf(fact_8092_image__subset__iff__subset__vimage,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A5: set @ B,B5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A5 ) @ B5 )
      = ( ord_less_eq @ ( set @ B ) @ A5 @ ( vimage @ B @ A @ F2 @ B5 ) ) ) ).

% image_subset_iff_subset_vimage
thf(fact_8093_vimage__subsetD,axiom,
    ! [A: $tType,B: $tType,F2: B > A,B5: set @ A,A5: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ B5 ) @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ B5 @ ( image @ B @ A @ F2 @ A5 ) ) ) ) ).

% vimage_subsetD
thf(fact_8094_insert__remdups,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( insert @ A @ X @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ ( insert @ A @ X @ Xs ) ) ) ).

% insert_remdups
thf(fact_8095_vimage__subsetI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B5: set @ B,A5: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ B5 @ ( image @ A @ B @ F2 @ A5 ) )
       => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B5 ) @ A5 ) ) ) ).

% vimage_subsetI
thf(fact_8096_countable__vimage,axiom,
    ! [B: $tType,A: $tType,B5: set @ A,F2: B > A] :
      ( ( ord_less_eq @ ( set @ A ) @ B5 @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ( countable_countable @ B @ ( vimage @ B @ A @ F2 @ B5 ) )
       => ( countable_countable @ A @ B5 ) ) ) ).

% countable_vimage
thf(fact_8097_vimage__subset__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B5: set @ B,A5: set @ A] :
      ( ( bij_betw @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ B5 ) @ A5 )
        = ( ord_less_eq @ ( set @ B ) @ B5 @ ( image @ A @ B @ F2 @ A5 ) ) ) ) ).

% vimage_subset_eq
thf(fact_8098_List_Oinsert__def,axiom,
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X4: A,Xs3: list @ A] : ( if @ ( list @ A ) @ ( member @ A @ X4 @ ( set2 @ A @ Xs3 ) ) @ Xs3 @ ( cons @ A @ X4 @ Xs3 ) ) ) ) ).

% List.insert_def
thf(fact_8099_card__vimage__inj,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A5: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A5 @ ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) )
       => ( ( finite_card @ A @ ( vimage @ A @ B @ F2 @ A5 ) )
          = ( finite_card @ B @ A5 ) ) ) ) ).

% card_vimage_inj
thf(fact_8100_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,D5: set @ A,A5: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ D5 )
     => ( ( finite_finite @ B @ A5 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A5 ) @ D5 ) ) @ ( finite_card @ B @ A5 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_8101_remove__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( remove @ A @ X @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( insert @ A @ X @ Xs ) ) ) ).

% remove_code(2)
thf(fact_8102_inj__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) )
        @ ( insert2 @ A
          @ ( the @ A
            @ ^ [X4: A] :
                ( ( F2 @ X4 )
                = A2 ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_vimage_singleton
thf(fact_8103_inj__on__vimage__singleton,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A5: set @ A,A2: B] :
      ( ( inj_on @ A @ B @ F2 @ A5 )
     => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ ( insert2 @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) @ A5 )
        @ ( insert2 @ A
          @ ( the @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ A5 )
                & ( ( F2 @ X4 )
                  = A2 ) ) )
          @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% inj_on_vimage_singleton
thf(fact_8104_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ( ( semiring_gcd_Gcd_fin @ A @ A5 )
            = ( zero_zero @ A ) )
          = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert2 @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) )
            & ( finite_finite @ A @ A5 ) ) ) ) ).

% Gcd_fin_0_iff
thf(fact_8105_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F3: A > ( option @ B ),Xs3: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F3 )
            @ ( filter2 @ A
              @ ^ [X4: A] :
                  ( ( F3 @ X4 )
                 != ( none @ B ) )
              @ Xs3 ) ) ) ) ).

% map_filter_def
thf(fact_8106_Gcd__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( semiring_gcd_Gcd_fin @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_fin.infinite
thf(fact_8107_is__unit__Gcd__fin__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A5: set @ A] :
          ( ( dvd_dvd @ A @ ( semiring_gcd_Gcd_fin @ A @ A5 ) @ ( one_one @ A ) )
          = ( ( semiring_gcd_Gcd_fin @ A @ A5 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_Gcd_fin_iff
thf(fact_8108_gcd__list__greatest,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Bs: list @ A,A2: A] :
          ( ! [B4: A] :
              ( ( member @ A @ B4 @ ( set2 @ A @ Bs ) )
             => ( dvd_dvd @ A @ A2 @ B4 ) )
         => ( dvd_dvd @ A @ A2 @ ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Bs ) ) ) ) ) ).

% gcd_list_greatest
thf(fact_8109_dvd__gcd__list__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B2: A,Xs: list @ A] :
          ( ( dvd_dvd @ A @ B2 @ ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Xs ) ) )
          = ( ! [X4: A] :
                ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
               => ( dvd_dvd @ A @ B2 @ X4 ) ) ) ) ) ).

% dvd_gcd_list_iff
thf(fact_8110_Gcd__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [B5: set @ A,A5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
         => ( ( gcd_gcd @ A @ ( semiring_gcd_Gcd_fin @ A @ B5 ) @ ( semiring_gcd_Gcd_fin @ A @ A5 ) )
            = ( semiring_gcd_Gcd_fin @ A @ A5 ) ) ) ) ).

% Gcd_fin.subset
thf(fact_8111_Max_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic643756798349783984er_Max @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Max.infinite
thf(fact_8112_Min_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic643756798350308766er_Min @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Min.infinite
thf(fact_8113_Gcd__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ).

% Gcd_fin.set_eq_fold
thf(fact_8114_set__decode__div__2,axiom,
    ! [X: nat] :
      ( ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( vimage @ nat @ nat @ suc @ ( nat_set_decode @ X ) ) ) ).

% set_decode_div_2
thf(fact_8115_set__encode__vimage__Suc,axiom,
    ! [A5: set @ nat] :
      ( ( nat_set_encode @ ( vimage @ nat @ nat @ suc @ A5 ) )
      = ( divide_divide @ nat @ ( nat_set_encode @ A5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% set_encode_vimage_Suc
thf(fact_8116_Min_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798350308766er_Min @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X4: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X4 @ ( ord_min @ A @ X4 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Min.eq_fold'
thf(fact_8117_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X4: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X4 @ ( ord_max @ A @ X4 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Max.eq_fold'
thf(fact_8118_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,Xs: list @ B] :
      ( ( map_filter @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F2 @ Xs )
        @ ^ [Y4: A] : ( cons @ A @ Y4 @ ( map_filter @ B @ A @ F2 @ Xs ) )
        @ ( F2 @ X ) ) ) ).

% map_filter_simps(1)
thf(fact_8119_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_8120_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_8121_Max_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic643756798349783984er_Max @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( ord_max @ A ) @ X @ A5 ) ) ) ) ).

% Max.eq_fold
thf(fact_8122_Min_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic643756798350308766er_Min @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( ord_min @ A ) @ X @ A5 ) ) ) ) ).

% Min.eq_fold
thf(fact_8123_comp__fun__idem__on_Ofold__insert__idem2,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z ) @ A5 ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem2
thf(fact_8124_comp__fun__idem__on_Ofold__insert__idem,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z @ A5 ) ) ) ) ) ) ).

% comp_fun_idem_on.fold_insert_idem
thf(fact_8125_comp__fun__idem__on_Ofold__set__fold,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: A > B > B,Xs: list @ A,Y: B] :
      ( ( finite673082921795544331dem_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ S2 )
       => ( ( finite_fold @ A @ B @ F2 @ Y @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ B @ F2 @ Xs @ Y ) ) ) ) ).

% comp_fun_idem_on.fold_set_fold
thf(fact_8126_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( ^ [A7: set @ A] : ( if @ A @ ( finite_finite @ A @ A7 ) @ ( finite_fold @ A @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ A7 ) @ ( one_one @ A ) ) ) ) ) ).

% Gcd_fin.eq_fold
thf(fact_8127_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X4: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X4 @ ( sup_sup @ A @ X4 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_8128_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X4: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X4 @ ( inf_inf @ A @ X4 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_8129_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ( inf_inf @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = A2 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_8130_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Sup_fin.singleton
thf(fact_8131_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Inf_fin.singleton
thf(fact_8132_sup__Inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ A2 )
              = A2 ) ) ) ) ).

% sup_Inf_absorb
thf(fact_8133_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_8134_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
              = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ) ).

% Sup_fin.insert
thf(fact_8135_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
              = ( complete_Inf_Inf @ A @ A5 ) ) ) ) ) ).

% Inf_fin_Inf
thf(fact_8136_Sup__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ).

% Sup_fin.in_idem
thf(fact_8137_Inf__fin__Min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% Inf_fin_Min
thf(fact_8138_Sup__fin__Max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% Sup_fin_Max
thf(fact_8139_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_8140_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ A2 ) ) ) ) ).

% Inf_fin.coboundedI
thf(fact_8141_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,A2: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ A2 @ A5 )
           => ( ord_less_eq @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ).

% Sup_fin.coboundedI
thf(fact_8142_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_8143_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ X )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ X4 @ X ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_8144_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
              = ( ! [X4: A] :
                    ( ( member @ A @ X4 @ A5 )
                   => ( ord_less_eq @ A @ X @ X4 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_8145_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ A4 @ X ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ X ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_8146_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ X )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A5 )
                 => ( ord_less_eq @ A @ A17 @ X ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_8147_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A4: A] :
                  ( ( member @ A @ A4 @ A5 )
                 => ( ord_less_eq @ A @ X @ A4 ) )
             => ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_8148_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
             => ! [A17: A] :
                  ( ( member @ A @ A17 @ A5 )
                 => ( ord_less_eq @ A @ X @ A17 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_8149_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ A5 )
              = ( complete_Sup_Sup @ A @ A5 ) ) ) ) ) ).

% Sup_fin_Sup
thf(fact_8150_Sup__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic5882676163264333800up_fin @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Sup_fin.infinite
thf(fact_8151_Inf__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A] :
          ( ~ ( finite_finite @ A @ A5 )
         => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Inf_fin.infinite
thf(fact_8152_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X4: A] : X4 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_8153_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ B5 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_8154_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B5 ) @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_8155_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y2: A] :
              ( ( H2 @ ( inf_inf @ A @ X3 @ Y2 ) )
              = ( inf_inf @ A @ ( H2 @ X3 ) @ ( H2 @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic7752659483105999362nf_fin @ A @ N4 ) )
                = ( lattic7752659483105999362nf_fin @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Inf_fin.hom_commute
thf(fact_8156_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y2: A] :
              ( ( H2 @ ( sup_sup @ A @ X3 @ Y2 ) )
              = ( sup_sup @ A @ ( H2 @ X3 ) @ ( H2 @ Y2 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic5882676163264333800up_fin @ A @ N4 ) )
                = ( lattic5882676163264333800up_fin @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Sup_fin.hom_commute
thf(fact_8157_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B5 ) @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_8158_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( B5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B5 @ A5 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B5 ) @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
                = ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_8159_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) ) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
thf(fact_8160_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y2: A] : ( member @ A @ ( inf_inf @ A @ X3 @ Y2 ) @ ( insert2 @ A @ X3 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Inf_fin.closed
thf(fact_8161_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( A5
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) ) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
thf(fact_8162_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y2: A] : ( member @ A @ ( sup_sup @ A @ X3 @ Y2 ) @ ( insert2 @ A @ X3 @ ( insert2 @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ A5 ) ) ) ) ) ).

% Sup_fin.closed
thf(fact_8163_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ( B5
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
                  = ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ ( lattic7752659483105999362nf_fin @ A @ B5 ) ) ) ) ) ) ) ) ).

% Inf_fin.union
thf(fact_8164_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ( B5
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
                  = ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ B5 ) ) ) ) ) ) ) ) ).

% Sup_fin.union
thf(fact_8165_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ X @ A5 ) ) ) ) ).

% Inf_fin.eq_fold
thf(fact_8166_Sup__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ X @ A5 ) ) ) ) ).

% Sup_fin.eq_fold
thf(fact_8167_Inf__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( inf_inf @ A ) @ Xs @ X ) ) ) ).

% Inf_fin.set_eq_fold
thf(fact_8168_Sup__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( sup_sup @ A ) @ Xs @ X ) ) ) ).

% Sup_fin.set_eq_fold
thf(fact_8169_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A5 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu3: A] :
                    ? [A3: A] :
                      ( ( Uu3
                        = ( inf_inf @ A @ X @ A3 ) )
                      & ( member @ A @ A3 @ A5 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_8170_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ( B5
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A5 ) @ ( lattic5882676163264333800up_fin @ A @ B5 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu3: A] :
                        ? [A3: A,B3: A] :
                          ( ( Uu3
                            = ( inf_inf @ A @ A3 @ B3 ) )
                          & ( member @ A @ A3 @ A5 )
                          & ( member @ A @ B3 @ B5 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_8171_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,B5: set @ A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B5 )
             => ( ( B5
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A5 ) @ ( lattic7752659483105999362nf_fin @ A @ B5 ) )
                  = ( lattic7752659483105999362nf_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu3: A] :
                        ? [A3: A,B3: A] :
                          ( ( Uu3
                            = ( sup_sup @ A @ A3 @ B3 ) )
                          & ( member @ A @ A3 @ A5 )
                          & ( member @ A @ B3 @ B5 ) ) ) ) ) ) ) ) ) ) ).

% sup_Inf2_distrib
thf(fact_8172_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( A5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( sup_sup @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A5 ) )
              = ( lattic7752659483105999362nf_fin @ A
                @ ( collect @ A
                  @ ^ [Uu3: A] :
                    ? [A3: A] :
                      ( ( Uu3
                        = ( sup_sup @ A @ X @ A3 ) )
                      & ( member @ A @ A3 @ A5 ) ) ) ) ) ) ) ) ).

% sup_Inf1_distrib
thf(fact_8173_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_8174_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A5 )
                  = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_8175_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( member @ A @ X @ A5 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A5 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A5 )
                  = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_8176_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A5: set @ A,X: A] :
          ( ( finite_finite @ A @ A5 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert2 @ A @ X @ A5 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_8177_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A5: set @ A,B5: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
       => ( ( ord_less_eq @ ( set @ A ) @ B5 @ S2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ( finite_finite @ A @ B5 )
             => ( ( ( inf_inf @ ( set @ A ) @ A5 @ B5 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F2 @ Z @ ( sup_sup @ ( set @ A ) @ A5 @ B5 ) )
                  = ( finite_fold @ A @ B @ F2 @ ( finite_fold @ A @ B @ F2 @ Z @ A5 ) @ B5 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_8178_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert2 @ A @ X @ A5 ) )
            = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert2 @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_8179_Finite__Set_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,G2: A > B > B,A5: set @ A,S: B,T2: B,B5: set @ A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ G2 )
       => ( ( ord_less_eq @ ( set @ A ) @ A5 @ S2 )
         => ( ( finite_finite @ A @ A5 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A5 )
                 => ( ( F2 @ X3 )
                    = ( G2 @ X3 ) ) )
             => ( ( S = T2 )
               => ( ( A5 = B5 )
                 => ( ( finite_fold @ A @ B @ F2 @ S @ A5 )
                    = ( finite_fold @ A @ B @ G2 @ T2 @ B5 ) ) ) ) ) ) ) ) ) ).

% Finite_Set.fold_cong
thf(fact_8180_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F2: A > B > B,G2: C > A,R3: set @ C] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G2 @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite4664212375090638736ute_on @ C @ B @ R3 @ ( comp @ A @ ( B > B ) @ C @ F2 @ G2 ) ) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
thf(fact_8181_comp__fun__commute__on_Ofold__insert,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A5: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert2 @ A @ X @ A5 ) @ S2 )
       => ( ( finite_finite @ A @ A5 )
         => ( ~ ( member @ A @ X @ A5 )
           => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert2 @ A @ X @ A5 ) )
              = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z @ A5 ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert

% Type constructors (813)
thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_2,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( filter @ A11 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_3,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_4,axiom,
    ! [A11: $tType] : ( bounded_lattice @ ( set @ A11 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_5,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounded_lattice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( comple592849572758109894attice @ A19 )
     => ( counta4013691401010221786attice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( condit1219197933456340205attice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( counta3822494911875563373attice @ A19 )
     => ( counta3822494911875563373attice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( comple592849572758109894attice @ A19 )
     => ( comple592849572758109894attice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounde4967611905675639751up_bot @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounde4346867609351753570nf_top @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( comple6319245703460814977attice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( boolea8198339166811842893lgebra @ A19 )
     => ( boolea8198339166811842893lgebra @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounded_lattice_top @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounded_lattice_bot @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( semilattice_sup @ A19 )
     => ( semilattice_sup @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( semilattice_inf @ A19 )
     => ( semilattice_inf @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( distrib_lattice @ A19 )
     => ( distrib_lattice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( order_top @ A19 )
     => ( order_top @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( order_bot @ A19 )
     => ( order_bot @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( preorder @ A19 )
     => ( preorder @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( lattice @ A19 )
     => ( lattice @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( order @ A19 )
     => ( order @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Otop,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( top @ A19 )
     => ( top @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( ord @ A19 )
     => ( ord @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Obot,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( bot @ A19 )
     => ( bot @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( uminus @ A19 )
     => ( uminus @ ( A11 > A19 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( minus @ A19 )
     => ( minus @ ( A11 > A19 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_7,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_8,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_9,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_10,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_11,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_12,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Orderings_Oord_13,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_14,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___Groups_Ominus_15,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_16,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_17,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_18,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_19,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_20,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_21,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_22,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_23,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_24,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_25,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_26,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_27,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_28,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_29,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_30,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_31,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_32,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_33,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_34,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_35,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_36,axiom,
    topolo4987421752381908075d_mult @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_37,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_38,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_39,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_40,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_41,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_42,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_43,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_44,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_45,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_46,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_47,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_48,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_49,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_50,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_51,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_52,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_53,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_54,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_55,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_56,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_57,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_58,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_59,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_60,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_61,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_62,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_63,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_64,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_65,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_66,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_67,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_68,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_69,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_70,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_71,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_72,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_73,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_74,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_75,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_76,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_77,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_78,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_79,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_80,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_81,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_82,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_83,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_84,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_85,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_86,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_87,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_88,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_89,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_90,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_91,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_92,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_93,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_94,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_95,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_96,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_97,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Orderings_Obot_98,axiom,
    bot @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_99,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_100,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_101,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_102,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_103,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_104,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_105,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_106,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_107,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_108,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_109,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_110,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_111,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_112,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_113,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_114,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_115,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_116,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_117,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_118,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_119,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_120,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_121,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_122,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_123,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_124,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_125,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_126,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_127,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_128,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_129,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_130,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_131,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_132,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_133,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_134,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_135,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_136,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_137,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_138,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_139,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_140,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_141,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_142,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_143,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_144,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_145,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_146,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_147,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_148,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_149,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_150,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_151,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_152,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_153,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_154,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_155,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_156,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_157,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_158,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_159,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_160,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_161,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_162,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_163,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_164,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_165,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_166,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_167,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_168,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_169,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_170,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_171,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_172,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_173,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_174,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_175,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_176,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_177,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_178,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_179,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_180,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_181,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_182,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_183,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_184,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_185,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_186,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_187,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_188,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_189,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_190,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_191,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_192,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_193,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_194,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_195,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_196,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_197,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_198,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_199,axiom,
    ! [A11: $tType] : ( counta4013691401010221786attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_200,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_201,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_202,axiom,
    ! [A11: $tType] : ( comple592849572758109894attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_203,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_204,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_205,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_206,axiom,
    ! [A11: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_207,axiom,
    ! [A11: $tType] : ( bounded_lattice_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_208,axiom,
    ! [A11: $tType] : ( bounded_lattice_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_209,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_210,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_211,axiom,
    ! [A11: $tType] : ( distrib_lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_212,axiom,
    ! [A11: $tType] : ( order_top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_213,axiom,
    ! [A11: $tType] : ( order_bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_214,axiom,
    ! [A11: $tType] : ( preorder @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_215,axiom,
    ! [A11: $tType] : ( lattice @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_216,axiom,
    ! [A11: $tType] : ( order @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Otop_217,axiom,
    ! [A11: $tType] : ( top @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_218,axiom,
    ! [A11: $tType] : ( ord @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Orderings_Obot_219,axiom,
    ! [A11: $tType] : ( bot @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_220,axiom,
    ! [A11: $tType] : ( uminus @ ( set @ A11 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_221,axiom,
    ! [A11: $tType] : ( minus @ ( set @ A11 ) ) ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_222,axiom,
    counta4013691401010221786attice @ $o ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_223,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_224,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_225,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_226,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_227,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_228,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_229,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_230,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_231,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_232,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_233,axiom,
    bounded_lattice_top @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_234,axiom,
    bounded_lattice_bot @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_235,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_236,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_237,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_238,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_239,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_240,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_241,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_242,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_243,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_244,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Otop_245,axiom,
    top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_246,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Orderings_Obot_247,axiom,
    bot @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_248,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_249,axiom,
    minus @ $o ).

thf(tcon_List_Olist___Nat_Osize_250,axiom,
    ! [A11: $tType] : ( size @ ( list @ A11 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_251,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_252,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_253,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_254,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_255,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_256,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_257,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_258,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_259,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_260,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_261,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_262,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_263,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_264,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_265,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_266,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_267,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_268,axiom,
    linord4140545234300271783up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_269,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_270,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_271,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_272,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_273,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_274,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_275,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_276,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_277,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_278,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_279,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_280,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_281,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_282,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_283,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_284,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_285,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_286,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_287,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_288,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_289,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_290,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_291,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_292,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_293,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_294,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_295,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_296,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Lattices_Odistrib__lattice_297,axiom,
    distrib_lattice @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_298,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_299,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_300,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_301,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_302,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_303,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_304,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_305,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_306,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_307,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_308,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_309,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_310,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_311,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_312,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_313,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_314,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_315,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_316,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_317,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_318,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_319,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_320,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_321,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_322,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_323,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_324,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_325,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_326,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_327,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_328,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_329,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_330,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_331,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_332,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_333,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_334,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_335,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_336,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_337,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_338,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_339,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_340,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_341,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_342,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_343,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_344,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_345,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_346,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_347,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Groups_Ominus_348,axiom,
    minus @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_349,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_350,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_351,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_352,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_353,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_354,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_355,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_356,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_357,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_358,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_359,axiom,
    ! [A11: $tType] : ( condit1219197933456340205attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_360,axiom,
    ! [A11: $tType] : ( counta3822494911875563373attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_361,axiom,
    ! [A11: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_362,axiom,
    ! [A11: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_363,axiom,
    ! [A11: $tType] : ( comple6319245703460814977attice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_364,axiom,
    ! [A11: $tType] : ( bounded_lattice_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_365,axiom,
    ! [A11: $tType] : ( bounded_lattice_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_366,axiom,
    ! [A11: $tType] : ( semilattice_sup @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_367,axiom,
    ! [A11: $tType] : ( semilattice_inf @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_368,axiom,
    ! [A11: $tType] : ( distrib_lattice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_369,axiom,
    ! [A11: $tType] : ( order_top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_370,axiom,
    ! [A11: $tType] : ( order_bot @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_371,axiom,
    ! [A11: $tType] : ( preorder @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_372,axiom,
    ! [A11: $tType] : ( lattice @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_373,axiom,
    ! [A11: $tType] : ( order @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Otop_374,axiom,
    ! [A11: $tType] : ( top @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_375,axiom,
    ! [A11: $tType] : ( ord @ ( filter @ A11 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Obot_376,axiom,
    ! [A11: $tType] : ( bot @ ( filter @ A11 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_377,axiom,
    ! [A11: $tType] : ( size @ ( option @ A11 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_378,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_379,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_380,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_381,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_382,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_383,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_384,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_385,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_386,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_387,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_388,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_389,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_390,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_391,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_392,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_393,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_394,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_395,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_396,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_397,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_398,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_399,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_400,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_401,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_402,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_403,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_404,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_405,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_406,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_407,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_408,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_409,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_410,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_411,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_412,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_413,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_414,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_415,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_416,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_417,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_418,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_419,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_420,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_421,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_422,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_423,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_424,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_425,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_426,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_427,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_428,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_429,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_430,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_431,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_432,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_433,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_434,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_435,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_436,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_437,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_438,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_439,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_440,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_441,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_442,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ominus_443,axiom,
    minus @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_444,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_445,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_446,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_447,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_448,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_449,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_450,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_451,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_452,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_453,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_454,axiom,
    counta4013691401010221786attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_455,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_456,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_457,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_458,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_459,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_460,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_461,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_462,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_463,axiom,
    linord4140545234300271783up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_464,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_465,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_466,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_467,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_468,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice__top_469,axiom,
    bounded_lattice_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice__bot_470,axiom,
    bounded_lattice_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_471,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_472,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_473,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Odistrib__lattice_474,axiom,
    distrib_lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_475,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_476,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_477,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_478,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_479,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_480,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_481,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_482,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_483,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_484,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_485,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_486,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_487,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_488,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_489,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_490,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_491,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_492,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_493,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_494,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_495,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_496,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_497,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_498,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_499,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_500,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_501,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Otop_502,axiom,
    top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_503,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Obot_504,axiom,
    bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ominus_505,axiom,
    minus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_506,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_507,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_508,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_509,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_510,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_511,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_512,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( ( topolo4958980785337419405_space @ A11 )
        & ( topolo4958980785337419405_space @ A19 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A11 @ A19 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_513,axiom,
    ! [A11: $tType,A19: $tType] :
      ( ( ( topological_t2_space @ A11 )
        & ( topological_t2_space @ A19 ) )
     => ( topological_t2_space @ ( product_prod @ A11 @ A19 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_514,axiom,
    ! [A11: $tType,A19: $tType] : ( size @ ( product_prod @ A11 @ A19 ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_515,axiom,
    condit6923001295902523014norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_516,axiom,
    counta4013691401010221786attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_517,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__lattice_518,axiom,
    counta3822494911875563373attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_519,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_520,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_521,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_522,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_523,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_524,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__top_525,axiom,
    bounded_lattice_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice__bot_526,axiom,
    bounded_lattice_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_527,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_528,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Odistrib__lattice_529,axiom,
    distrib_lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_530,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__top_531,axiom,
    order_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_532,axiom,
    order_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_533,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_534,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_535,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_536,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Otop_537,axiom,
    top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_538,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Obot_539,axiom,
    bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_540,axiom,
    uminus @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ominus_541,axiom,
    minus @ product_unit ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_542,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_543,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_544,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_545,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_546,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_547,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_548,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_549,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_550,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_551,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_552,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_553,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_554,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_555,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_556,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_557,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_558,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_559,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_560,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_561,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_562,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_563,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_564,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_565,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_566,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_567,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_568,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_569,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_570,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_571,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_572,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_573,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_574,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_575,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_576,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_577,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_578,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_579,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_580,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_581,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_582,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_583,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_584,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_585,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_586,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_587,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_588,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_589,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_590,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_591,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_592,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_593,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_594,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_595,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_596,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_597,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_598,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_599,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_600,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_601,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_602,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_603,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_604,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_605,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_606,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_607,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_608,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_609,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_610,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_611,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_612,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_613,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_614,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_615,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_616,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_617,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_618,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_619,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_620,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_621,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_622,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_623,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_624,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_625,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_626,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_627,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_628,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_629,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_630,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_631,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_632,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_633,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_634,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_635,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_636,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_637,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_638,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_639,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_640,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_641,axiom,
    size @ vEBT_VEBT ).

% Helper facts (3)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( ord_less @ nat @ xa @ y )
    & ( ord_less_eq @ nat @ y @ ( ord_max @ nat @ ma @ mi ) ) ) ).

%------------------------------------------------------------------------------
