%------------------------------------------------------------------------------
% File     : VBT00042^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_Succ 00333_019281
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0070_VEBT_Succ_00333_019281 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9550 (3092 unt; 595 typ;   0 def)
%            Number of atoms       : 27834 (9635 equ;   5 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 175288 (2252   ~; 339   |;2208   &;157704   @)
%                                         (   0 <=>;12785  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   13 (  12 usr)
%            Number of type conns  : 3691 (3691   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  587 ( 583 usr;  15 con; 0-9 aty)
%            Number of variables   : 29488 (2421   ^25642   !; 906   ?;29488   :)
%                                         ( 519  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-18 00:18:10.073
%------------------------------------------------------------------------------
% Could-be-implicit typings (17)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Code__Evaluation_Oterm,type,
    code_term: $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

% Explicit typings (578)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Odist__norm,type,
    real_V6936659425649961206t_norm: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num__rel,type,
    bit_un5425074673868309765um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num__rel,type,
    bit_un3595099601533988841um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onegative,type,
    code_negative: num > code_integer ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opositive,type,
    code_positive: num > code_integer ).

thf(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: num > int ).

thf(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: num > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ooverride__on,type,
    override_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: ( list @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: ( list @ nat ) > ( list @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( ( set @ ( option @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oof__int,type,
    of_int: int > rat ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Insert_Ovebt__insert,type,
    vEBT_vebt_insert: vEBT_VEBT > nat > vEBT_VEBT ).

thf(sy_c_VEBT__Insert_Ovebt__insert__rel,type,
    vEBT_vebt_insert_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull,type,
    vEBT_VEBT_minNull: vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull__rel,type,
    vEBT_V6963167321098673237ll_rel: vEBT_VEBT > vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Oadd,type,
    vEBT_VEBT_add: ( option @ nat ) > ( option @ nat ) > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Ogreater,type,
    vEBT_VEBT_greater: ( option @ nat ) > ( option @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Oless,type,
    vEBT_VEBT_less: ( option @ nat ) > ( option @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Olesseq,type,
    vEBT_VEBT_lesseq: ( option @ nat ) > ( option @ nat ) > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Omax__in__set,type,
    vEBT_VEBT_max_in_set: ( set @ nat ) > nat > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Omin__in__set,type,
    vEBT_VEBT_min_in_set: ( set @ nat ) > nat > $o ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Omul,type,
    vEBT_VEBT_mul: ( option @ nat ) > ( option @ nat ) > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Ooption__shift,type,
    vEBT_V2048590022279873568_shift: 
      !>[A: $tType] : ( ( A > A > A ) > ( option @ A ) > ( option @ A ) > ( option @ A ) ) ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Ooption__shift__rel,type,
    vEBT_V459564278314245337ft_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) ) > ( product_prod @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) ) > $o ) ).

thf(sy_c_VEBT__MinMax_OVEBT__internal_Opower,type,
    vEBT_VEBT_power: ( option @ nat ) > ( option @ nat ) > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_Ovebt__maxt,type,
    vEBT_vebt_maxt: vEBT_VEBT > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_Ovebt__maxt__rel,type,
    vEBT_vebt_maxt_rel: vEBT_VEBT > vEBT_VEBT > $o ).

thf(sy_c_VEBT__MinMax_Ovebt__mint,type,
    vEBT_vebt_mint: vEBT_VEBT > ( option @ nat ) ).

thf(sy_c_VEBT__MinMax_Ovebt__mint__rel,type,
    vEBT_vebt_mint_rel: vEBT_VEBT > vEBT_VEBT > $o ).

thf(sy_c_VEBT__Succ_Ois__succ__in__set,type,
    vEBT_is_succ_in_set: ( set @ nat ) > nat > nat > $o ).

thf(sy_c_VEBT__Succ_Ovebt__succ,type,
    vEBT_vebt_succ: vEBT_VEBT > nat > ( option @ nat ) ).

thf(sy_c_VEBT__Succ_Ovebt__succ__rel,type,
    vEBT_vebt_succ_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_ia____,type,
    ia: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_ma____,type,
    ma: nat ).

thf(sy_v_mi____,type,
    mi: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

thf(sy_v_xa____,type,
    xa: nat ).

% Relevant facts (8180)
thf(fact_0_bit__split__inv,axiom,
    ! [X: nat,D2: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X @ D2 ) @ ( vEBT_VEBT_low @ X @ D2 ) @ D2 )
      = X ) ).

% bit_split_inv
thf(fact_1_abe,axiom,
    vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% abe
thf(fact_2_abd,axiom,
    ( ( ia = ma )
   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abd
thf(fact_3__C33_C,axiom,
    ~ ? [U: nat] :
        ( ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U )
        & ( ord_less @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% "33"
thf(fact_4_abf,axiom,
    vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% abf
thf(fact_5_abh,axiom,
    vEBT_vebt_member @ summary @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% abh
thf(fact_6_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_7_semiring__norm_I83_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) ).

% semiring_norm(83)
thf(fact_8__092_060open_062deg_Adiv_A2_A_061_An_092_060close_062,axiom,
    ( ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = na ) ).

% \<open>deg div 2 = n\<close>
thf(fact_9__092_060open_0622_A_092_060le_062_Adeg_092_060close_062,axiom,
    ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ).

% \<open>2 \<le> deg\<close>
thf(fact_10_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit0_div_2
thf(fact_11_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X2: nat,N2: nat] : ( divide_divide @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% high_def
thf(fact_12_min__Null__member,axiom,
    ! [T2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ~ ( vEBT_vebt_member @ T2 @ X ) ) ).

% min_Null_member
thf(fact_13_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_14_not__min__Null__member,axiom,
    ! [T2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ T2 )
     => ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ T2 @ X_1 ) ) ).

% not_min_Null_member
thf(fact_15__C4_Ohyps_C_I5_J,axiom,
    m = na ).

% "4.hyps"(5)
thf(fact_16_min__in__set__def,axiom,
    ( vEBT_VEBT_min_in_set
    = ( ^ [Xs: set @ nat,X2: nat] :
          ( ( member @ nat @ X2 @ Xs )
          & ! [Y: nat] :
              ( ( member @ nat @ Y @ Xs )
             => ( ord_less_eq @ nat @ X2 @ Y ) ) ) ) ) ).

% min_in_set_def
thf(fact_17_max__in__set__def,axiom,
    ( vEBT_VEBT_max_in_set
    = ( ^ [Xs: set @ nat,X2: nat] :
          ( ( member @ nat @ X2 @ Xs )
          & ! [Y: nat] :
              ( ( member @ nat @ Y @ Xs )
             => ( ord_less_eq @ nat @ Y @ X2 ) ) ) ) ) ).

% max_in_set_def
thf(fact_18__C4_Ohyps_C_I10_J,axiom,
    ord_less @ nat @ ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "4.hyps"(10)
thf(fact_19_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) ).

% numeral_eq_iff
thf(fact_20_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(87)
thf(fact_21__C4_Ohyps_C_I9_J,axiom,
    ord_less_eq @ nat @ mi @ ma ).

% "4.hyps"(9)
thf(fact_22_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% numeral_le_iff
thf(fact_23_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% numeral_less_iff
thf(fact_24__092_060open_062i_A_060_A2_A_094_Adeg_092_060close_062,axiom,
    ord_less @ nat @ ia @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% \<open>i < 2 ^ deg\<close>
thf(fact_25__092_060open_062high_Ax_An_A_060_A2_A_094_An_A_092_060and_062_Alow_Ax_An_A_060_A2_A_094_An_092_060close_062,axiom,
    ( ( ord_less @ nat @ ( vEBT_VEBT_high @ xa @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_low @ xa @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) ) ).

% \<open>high x n < 2 ^ n \<and> low x n < 2 ^ n\<close>
thf(fact_26_abg,axiom,
    vEBT_V8194947554948674370ptions @ summary @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% abg
thf(fact_27__092_060open_062_092_060not_062_A_I_092_060exists_062i_062high_Ax_A_Ideg_Adiv_A2_J_O_Avebt__member_Asummary_Ai_J_092_060close_062,axiom,
    ~ ? [I: nat] :
        ( ( ord_less @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ I )
        & ( vEBT_vebt_member @ summary @ I ) ) ).

% \<open>\<not> (\<exists>i>high x (deg div 2). vebt_member summary i)\<close>
thf(fact_28_aa,axiom,
    ( ( ia = ma )
   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% aa
thf(fact_29_div__le__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ).

% div_le_dividend
thf(fact_30_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N @ K ) ) ) ).

% div_le_mono
thf(fact_31_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N2: nat,TreeList: list @ vEBT_VEBT,X2: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ N2 ) ) @ ( vEBT_VEBT_low @ X2 @ N2 ) ) ) ) ).

% in_children_def
thf(fact_32__C4_Ohyps_C_I11_J,axiom,
    ( ( mi != ma )
   => ! [I: nat] :
        ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
       => ( ( ( ( vEBT_VEBT_high @ ma @ na )
              = I )
           => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ ma @ na ) ) )
          & ! [X3: nat] :
              ( ( ( ( vEBT_VEBT_high @ X3 @ na )
                  = I )
                & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ X3 @ na ) ) )
             => ( ( ord_less @ nat @ mi @ X3 )
                & ( ord_less_eq @ nat @ X3 @ ma ) ) ) ) ) ) ).

% "4.hyps"(11)
thf(fact_33_abc,axiom,
    vEBT_invar_vebt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ na ).

% abc
thf(fact_34__092_060open_062invar__vebt_A_ItreeList_A_B_Ahigh_Ax_A_Ideg_Adiv_A2_J_J_An_092_060close_062,axiom,
    vEBT_invar_vebt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ na ).

% \<open>invar_vebt (treeList ! high x (deg div 2)) n\<close>
thf(fact_35__092_060open_062length_AtreeList_A_061_A2_A_094_An_092_060close_062,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) ).

% \<open>length treeList = 2 ^ n\<close>
thf(fact_36__C4_Ohyps_C_I7_J,axiom,
    ! [I: nat] :
      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ X4 ) )
        = ( vEBT_V8194947554948674370ptions @ summary @ I ) ) ) ).

% "4.hyps"(7)
thf(fact_37__092_060open_062_092_060nexists_062i_O_Ais__succ__in__set_A_Iset__vebt_H_Asummary_J_A_Ihigh_Ax_A_Ideg_Adiv_A2_J_J_Ai_092_060close_062,axiom,
    ~ ? [X_12: nat] : ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ summary ) @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ X_12 ) ).

% \<open>\<nexists>i. is_succ_in_set (set_vebt' summary) (high x (deg div 2)) i\<close>
thf(fact_38_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_imp_le
thf(fact_39_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_eq_le
thf(fact_40_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_41_less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% less_exp
thf(fact_42_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_43_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( collect @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A3 ) )
      = A3 ) ).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X5: A] :
          ( ( P @ X5 )
          = ( Q @ X5 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_46_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X5: A] :
          ( ( F2 @ X5 )
          = ( G @ X5 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_47__C4_Ohyps_C_I2_J,axiom,
    vEBT_invar_vebt @ summary @ m ).

% "4.hyps"(2)
thf(fact_48_both__member__options__equiv__member,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
        = ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% both_member_options_equiv_member
thf(fact_49_valid__member__both__member__options,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
       => ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% valid_member_both_member_options
thf(fact_50__C4_Ohyps_C_I6_J,axiom,
    ( deg
    = ( plus_plus @ nat @ na @ m ) ) ).

% "4.hyps"(6)
thf(fact_51__092_060open_062i_A_092_060noteq_062_Ami_092_060close_062,axiom,
    ia != mi ).

% \<open>i \<noteq> mi\<close>
thf(fact_52__092_060open_062mi_A_092_060noteq_062_Ama_092_060close_062,axiom,
    mi != ma ).

% \<open>mi \<noteq> ma\<close>
thf(fact_53__C4_Ohyps_C_I4_J,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "4.hyps"(4)
thf(fact_54__092_060open_062mi_A_092_060le_062_Ax_092_060close_062,axiom,
    ord_less_eq @ nat @ mi @ xa ).

% \<open>mi \<le> x\<close>
thf(fact_55_member__correct,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_vebt_member @ T2 @ X )
        = ( member @ nat @ X @ ( vEBT_set_vebt @ T2 ) ) ) ) ).

% member_correct
thf(fact_56_set__vebt__set__vebt_H__valid,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_set_vebt @ T2 )
        = ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_set_vebt'_valid
thf(fact_57_succ__member,axiom,
    ! [T2: vEBT_VEBT,X: nat,Y2: nat] :
      ( ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X @ Y2 )
      = ( ( vEBT_vebt_member @ T2 @ Y2 )
        & ( ord_less @ nat @ X @ Y2 )
        & ! [Z: nat] :
            ( ( ( vEBT_vebt_member @ T2 @ Z )
              & ( ord_less @ nat @ X @ Z ) )
           => ( ord_less_eq @ nat @ Y2 @ Z ) ) ) ) ).

% succ_member
thf(fact_58_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_59_member__bound,axiom,
    ! [Tree: vEBT_VEBT,X: nat,N: nat] :
      ( ( vEBT_vebt_member @ Tree @ X )
     => ( ( vEBT_invar_vebt @ Tree @ N )
       => ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% member_bound
thf(fact_60_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z2 ) ) ) ).

% add_numeral_left
thf(fact_61_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% numeral_plus_numeral
thf(fact_62_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(78)
thf(fact_63_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(71)
thf(fact_64_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_65_semiring__norm_I68_J,axiom,
    ! [N: num] : ( ord_less_eq @ num @ one2 @ N ) ).

% semiring_norm(68)
thf(fact_66_semiring__norm_I76_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit0 @ N ) ) ).

% semiring_norm(76)
thf(fact_67_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_68_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_69__C20_C,axiom,
    ( ( ia = mi )
    | ( ia = ma )
    | ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ treeList ) )
      & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% "20"
thf(fact_70__C4_Ohyps_C_I8_J,axiom,
    ( ( mi = ma )
   => ! [X3: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ treeList ) )
       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) ) ).

% "4.hyps"(8)
thf(fact_71_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_72_le__num__One__iff,axiom,
    ! [X: num] :
      ( ( ord_less_eq @ num @ X @ one2 )
      = ( X = one2 ) ) ).

% le_num_One_iff
thf(fact_73_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_Bit0
thf(fact_74_is__succ__in__set__def,axiom,
    ( vEBT_is_succ_in_set
    = ( ^ [Xs: set @ nat,X2: nat,Y: nat] :
          ( ( member @ nat @ Y @ Xs )
          & ( ord_less @ nat @ X2 @ Y )
          & ! [Z: nat] :
              ( ( member @ nat @ Z @ Xs )
             => ( ( ord_less @ nat @ X2 @ Z )
               => ( ord_less_eq @ nat @ Y @ Z ) ) ) ) ) ) ).

% is_succ_in_set_def
thf(fact_75_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_divide
thf(fact_76_post__member__pre__member,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat,Y2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
         => ( ( vEBT_vebt_member @ ( vEBT_vebt_insert @ T2 @ X ) @ Y2 )
           => ( ( vEBT_vebt_member @ T2 @ Y2 )
              | ( X = Y2 ) ) ) ) ) ) ).

% post_member_pre_member
thf(fact_77_valid__insert__both__member__options__add,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
       => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ X ) @ X ) ) ) ).

% valid_insert_both_member_options_add
thf(fact_78_valid__insert__both__member__options__pres,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat,Y2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
         => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
           => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ Y2 ) @ X ) ) ) ) ) ).

% valid_insert_both_member_options_pres
thf(fact_79_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_ding
thf(fact_80_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ).

% div_exp_eq
thf(fact_81_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ord_less @ A @ X @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_82_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H: nat,L: nat,D3: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D3 ) ) @ L ) ) ) ).

% bit_concat_def
thf(fact_83_low__inv,axiom,
    ! [X: nat,N: nat,Y2: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = X ) ) ).

% low_inv
thf(fact_84_high__inv,axiom,
    ! [X: nat,N: nat,Y2: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = Y2 ) ) ).

% high_inv
thf(fact_85_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% nat_add_left_cancel_le
thf(fact_86_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% nat_add_left_cancel_less
thf(fact_87_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(1)
thf(fact_88_deg__deg__n,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N )
     => ( Deg = N ) ) ).

% deg_deg_n
thf(fact_89_inthall,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,N: nat] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( P @ X5 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( P @ ( nth @ A @ Xs2 @ N ) ) ) ) ).

% inthall
thf(fact_90_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_91_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z2 ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_92_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(6)
thf(fact_93_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_94_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_95_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_96_enat__ord__number_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(2)
thf(fact_97_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_98_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_99_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_100_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_101_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_102_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_103_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_104_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_105_mult__le__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ K @ L2 )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ L2 ) ) ) ) ).

% mult_le_mono
thf(fact_106_mult__le__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_107_mult__le__mono2,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_108_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% add_mult_distrib
thf(fact_109_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% add_mult_distrib2
thf(fact_110_add__One__commute,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) ).

% add_One_commute
thf(fact_111_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_commutes
thf(fact_112_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_113_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y2: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y2 )
            = ( times_times @ A @ Y2 @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ Y2 )
            = ( times_times @ A @ Y2 @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_114_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N ) ) ) ).

% power_mult
thf(fact_115_left__add__mult__distrib,axiom,
    ! [I2: nat,U2: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I2 @ J ) @ U2 ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_116_div__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) ).

% div_mult2_eq
thf(fact_117_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_118_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_119_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_add
thf(fact_120_less__mult__imp__div__less,axiom,
    ! [M: nat,I2: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I2 @ N ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ I2 ) ) ).

% less_mult_imp_div_less
thf(fact_121_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_122_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_123_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X5: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ B @ ( F2 @ Y3 ) @ ( F2 @ X5 ) )
                 => ( P @ Y3 ) )
             => ( P @ X5 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_124_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X5: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ B @ ( F2 @ Y3 ) @ ( F2 @ X5 ) )
                 => ( P @ Y3 ) )
             => ( P @ X5 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_125_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M != N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) ).

% nat_neq_iff
thf(fact_126_less__not__refl,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_not_refl
thf(fact_127_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) ).

% less_not_refl2
thf(fact_128_less__not__refl3,axiom,
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) ).

% less_not_refl3
thf(fact_129_less__irrefl__nat,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_irrefl_nat
thf(fact_130_nat__less__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% nat_less_induct
thf(fact_131_infinite__descent,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N3 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) ).

% infinite_descent
thf(fact_132_linorder__neqE__nat,axiom,
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less @ nat @ X @ Y2 )
       => ( ord_less @ nat @ Y2 @ X ) ) ) ).

% linorder_neqE_nat
thf(fact_133_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V2: A > nat,X: A] :
      ( ! [X5: A] :
          ( ~ ( P @ X5 )
         => ? [Y3: A] :
              ( ( ord_less @ nat @ ( V2 @ Y3 ) @ ( V2 @ X5 ) )
              & ~ ( P @ Y3 ) ) )
     => ( P @ X ) ) ).

% infinite_descent_measure
thf(fact_134_le__refl,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ N ) ).

% le_refl
thf(fact_135_le__trans,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I2 @ K ) ) ) ).

% le_trans
thf(fact_136_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% eq_imp_le
thf(fact_137_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) ).

% le_antisym
thf(fact_138_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) ).

% nat_le_linear
thf(fact_139_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ? [X5: nat] :
            ( ( P @ X5 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ nat @ Y3 @ X5 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_140_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X: A,Y2: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y2 ) )
         => ( X != Y2 ) ) ) ).

% size_neq_size_imp_neq
thf(fact_141_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_142_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2_right
thf(fact_143_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 )
          = ( plus_plus @ A @ Z2 @ Z2 ) ) ) ).

% mult_2
thf(fact_144_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_145_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_146_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_147_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y2: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y2 ) ) ) ) ).

% power2_sum
thf(fact_148_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M3 @ N2 )
          & ( M3 != N2 ) ) ) ) ).

% nat_less_le
thf(fact_149_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_imp_le_nat
thf(fact_150_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( ( ord_less @ nat @ M3 @ N2 )
          | ( M3 = N2 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_151_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_or_eq_imp_le
thf(fact_152_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% le_neq_implies_less
thf(fact_153_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I2: nat,J: nat] :
      ( ! [I3: nat,J2: nat] :
          ( ( ord_less @ nat @ I3 @ J2 )
         => ( ord_less @ nat @ ( F2 @ I3 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ord_less_eq @ nat @ ( F2 @ I2 ) @ ( F2 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_154_add__lessD1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K )
     => ( ord_less @ nat @ I2 @ K ) ) ).

% add_lessD1
thf(fact_155_add__less__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ K @ L2 )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ L2 ) ) ) ) ).

% add_less_mono
thf(fact_156_not__add__less1,axiom,
    ! [I2: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ J ) @ I2 ) ).

% not_add_less1
thf(fact_157_not__add__less2,axiom,
    ! [J: nat,I2: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I2 ) @ I2 ) ).

% not_add_less2
thf(fact_158_add__less__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_159_trans__less__add1,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_less_add1
thf(fact_160_trans__less__add2,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ord_less @ nat @ I2 @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_less_add2
thf(fact_161_less__add__eq__less,axiom,
    ! [K: nat,L2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L2 )
     => ( ( ( plus_plus @ nat @ M @ L2 )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% less_add_eq_less
thf(fact_162_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) ).

% add_leE
thf(fact_163_le__add1,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) ).

% le_add1
thf(fact_164_le__add2,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) ).

% le_add2
thf(fact_165_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% add_leD1
thf(fact_166_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) ).

% add_leD2
thf(fact_167_le__Suc__ex,axiom,
    ! [K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ K @ L2 )
     => ? [N3: nat] :
          ( L2
          = ( plus_plus @ nat @ K @ N3 ) ) ) ).

% le_Suc_ex
thf(fact_168_add__le__mono,axiom,
    ! [I2: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ K @ L2 )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ L2 ) ) ) ) ).

% add_le_mono
thf(fact_169_add__le__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_170_trans__le__add1,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_le_add1
thf(fact_171_trans__le__add2,axiom,
    ! [I2: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ord_less_eq @ nat @ I2 @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_le_add2
thf(fact_172_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( plus_plus @ nat @ M3 @ K2 ) ) ) ) ).

% nat_le_iff_add
thf(fact_173_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N3: nat] :
          ( ( ord_less @ nat @ M4 @ N3 )
         => ( ord_less @ nat @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_174_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X ) ) ).

% field_sum_of_halves
thf(fact_175_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y2 ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_176_set__n__deg__not__0,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,M: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N ) ) ) ).

% set_n_deg_not_0
thf(fact_177__092_060open_062x_A_060_Ai_A_092_060and_062_Avebt__member_A_INode_A_ISome_A_Imi_M_Ama_J_J_Adeg_AtreeList_Asummary_J_Ai_092_060close_062,axiom,
    ( ( ord_less @ nat @ xa @ ia )
    & ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ ia ) ) ).

% \<open>x < i \<and> vebt_member (Node (Some (mi, ma)) deg treeList summary) i\<close>
thf(fact_178_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_179_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_180_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_181_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_182_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_183_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_184_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_185_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_186_power__minus__is__div,axiom,
    ! [B2: nat,A2: nat] :
      ( ( ord_less_eq @ nat @ B2 @ A2 )
     => ( ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ A2 @ B2 ) )
        = ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% power_minus_is_div
thf(fact_187__092_060open_0621_A_092_060le_062_An_092_060close_062,axiom,
    ord_less_eq @ nat @ ( one_one @ nat ) @ na ).

% \<open>1 \<le> n\<close>
thf(fact_188_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_189_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_190_mi__eq__ma__no__ch,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg )
     => ( ( Mi = Ma )
       => ( ! [X3: vEBT_VEBT] :
              ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
             => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) )
          & ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 ) ) ) ) ).

% mi_eq_ma_no_ch
thf(fact_191_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_192_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_193_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_194_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_195_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_196_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_197_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_198_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_199_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_200_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_201_insert__simp__mima,axiom,
    ! [X: nat,Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( X = Mi )
        | ( X = Ma ) )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
       => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) ) ) ) ).

% insert_simp_mima
thf(fact_202_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_203_diff__diff__cancel,axiom,
    ! [I2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ N )
     => ( ( minus_minus @ nat @ N @ ( minus_minus @ nat @ N @ I2 ) )
        = I2 ) ) ).

% diff_diff_cancel
thf(fact_204_diff__diff__left,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J ) @ K )
      = ( minus_minus @ nat @ I2 @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_205_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_206_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_207_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ).

% semiring_norm(13)
thf(fact_208_semiring__norm_I12_J,axiom,
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) ).

% semiring_norm(12)
thf(fact_209_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_210_mi__ma__2__deg,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( ord_less_eq @ nat @ Mi @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_211_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_212_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_213_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_214_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_215_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N ) )
            = ( M = N ) ) ) ) ).

% power_inject_exp
thf(fact_216_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_217_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I2 ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_218_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_219_num__double,axiom,
    ! [N: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N )
      = ( bit0 @ N ) ) ).

% num_double
thf(fact_220_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_mult_numeral
thf(fact_221_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X = Mi )
          | ( X = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_222_member__inv,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X = Mi )
          | ( X = Ma )
          | ( ( ord_less @ nat @ X @ Ma )
            & ( ord_less @ nat @ Mi @ X )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_223_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less @ nat @ X @ Y2 ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_224_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_225_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_226_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less_eq @ nat @ X @ Y2 ) ) ) ) ).

% power_increasing_iff
thf(fact_227_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_228_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_229_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_230_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_231_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N: extended_enat] :
      ( ! [N3: extended_enat] :
          ( ! [M2: extended_enat] :
              ( ( ord_less @ extended_enat @ M2 @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% enat_less_induct
thf(fact_232_diff__commute,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I2 @ K ) @ J ) ) ).

% diff_commute
thf(fact_233_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_234_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_235_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_236_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_237_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_238_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_239_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_240_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_241_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_242_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_243_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_244_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_245_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_246_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_247_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_248_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_249_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_250_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_251_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_252_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_253_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_254_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_255_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_256_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_257_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N ) @ K ) ) ).

% less_imp_diff_less
thf(fact_258_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L2: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ord_less @ nat @ M @ L2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L2 @ N ) @ ( minus_minus @ nat @ L2 @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_259_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L2 @ N ) @ ( minus_minus @ nat @ L2 @ M ) ) ) ).

% diff_le_mono2
thf(fact_260_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_261_diff__le__self,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ).

% diff_le_self
thf(fact_262_diff__le__mono,axiom,
    ! [M: nat,N: nat,L2: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L2 ) @ ( minus_minus @ nat @ N @ L2 ) ) ) ).

% diff_le_mono
thf(fact_263_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_264_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% le_diff_iff
thf(fact_265_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N @ K ) )
          = ( M = N ) ) ) ) ).

% eq_diff_iff
thf(fact_266_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ N )
      = M ) ).

% diff_add_inverse2
thf(fact_267_diff__add__inverse,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N @ M ) @ N )
      = M ) ).

% diff_add_inverse
thf(fact_268_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_cancel2
thf(fact_269_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% Nat.diff_cancel
thf(fact_270_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_271_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_272_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% diff_mult_distrib2
thf(fact_273_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% diff_mult_distrib
thf(fact_274_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_275_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_276_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_277_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_278_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_279_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_280_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_281_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_282_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_283_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_284_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_285_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_286_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_287_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_288_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_289_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_290_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X: A,Y2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ Y2 ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ ( minus_minus @ A @ Y2 @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_291_four__x__squared,axiom,
    ! [X: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_292_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_293_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L2: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L2 ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L2 ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_294_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_295_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_296_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_297_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less @ nat @ M @ N ) ) ) ) ).

% less_diff_iff
thf(fact_298_less__diff__conv,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_299_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( plus_plus @ nat @ N @ ( minus_minus @ nat @ M @ N ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_300_le__diff__conv,axiom,
    ! [J: nat,K: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I2 @ K ) ) ) ).

% le_diff_conv
thf(fact_301_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_302_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ J ) @ K )
        = ( plus_plus @ nat @ I2 @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_303_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I2 ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_304_Nat_Ole__imp__diff__is__add,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ( minus_minus @ nat @ J @ I2 )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_305_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_306_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_307_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_308_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_309_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% one_le_power
thf(fact_310_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y2: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y2 )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y2 @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_311_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_one_over
thf(fact_312_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_313_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I2 )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I2 @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_314_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
        ? [X_1: A] : ( ord_less @ A @ X3 @ X_1 ) ) ).

% linordered_field_no_ub
thf(fact_315_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X3: A] :
        ? [Y4: A] : ( ord_less @ A @ Y4 @ X3 ) ) ).

% linordered_field_no_lb
thf(fact_316_nat__eq__add__iff1,axiom,
    ! [J: nat,I2: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U2 ) @ M )
          = N ) ) ) ).

% nat_eq_add_iff1
thf(fact_317_nat__eq__add__iff2,axiom,
    ! [I2: nat,J: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U2 ) @ N ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_318_nat__le__add__iff1,axiom,
    ! [J: nat,I2: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U2 ) @ M ) @ N ) ) ) ).

% nat_le_add_iff1
thf(fact_319_nat__le__add__iff2,axiom,
    ! [I2: nat,J: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U2 ) @ N ) ) ) ) ).

% nat_le_add_iff2
thf(fact_320_nat__diff__add__eq1,axiom,
    ! [J: nat,I2: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U2 ) @ M ) @ N ) ) ) ).

% nat_diff_add_eq1
thf(fact_321_nat__diff__add__eq2,axiom,
    ! [I2: nat,J: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U2 ) @ N ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_322_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_323_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_324_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_325_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ B3 @ A4 ) ) ) ) ).

% mult.commute
thf(fact_326_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_327_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_328_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_329_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less @ nat @ M @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_330_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_331_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_332_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_333_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ B3 @ A4 ) ) ) ) ).

% add.commute
thf(fact_334_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_335_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_336_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_337_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B4 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_338_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_339_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( I2 = J )
            & ( K = L2 ) )
         => ( ( plus_plus @ A @ I2 @ K )
            = ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_340_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_341_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_342_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y2 @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_343_nat__less__add__iff2,axiom,
    ! [I2: nat,J: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I2 ) @ U2 ) @ N ) ) ) ) ).

% nat_less_add_iff2
thf(fact_344_nat__less__add__iff1,axiom,
    ! [J: nat,I2: nat,U2: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I2 @ U2 ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U2 ) @ N ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I2 @ J ) @ U2 ) @ M ) @ N ) ) ) ).

% nat_less_add_iff1
thf(fact_345_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_346_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_347_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_348_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) ) ) ) ).

% diff_le_diff_pow
thf(fact_349_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_350_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_351_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
            ? [C3: A] :
              ( B3
              = ( plus_plus @ A @ A4 @ C3 ) ) ) ) ) ).

% le_iff_add
thf(fact_352_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_353_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C4 ) ) ) ) ).

% less_eqE
thf(fact_354_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_355_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_356_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_357_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( I2 = J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_358_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( K = L2 ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_359_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_360_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_361_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_362_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_363_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_364_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( K = L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_365_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( I2 = J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_366_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_367_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y2: A,Z2: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y2 @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_368_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y2: A,Z2: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( divide_divide @ A @ Z2 @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X @ W ) @ ( times_times @ A @ Y2 @ Z2 ) ) ) ) ).

% divide_divide_times_eq
thf(fact_369_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_370_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_371_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y2 ) ) ) ) ).

% power2_diff
thf(fact_372_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N3: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_373_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N3: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N3 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_374_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_375_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_376_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I2 @ J )
            & ( ord_less_eq @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_377_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I2: A,J: A,K: A,L2: A] :
          ( ( ( ord_less_eq @ A @ I2 @ J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_378_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X5: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X5 @ N )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ X5 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X5 )
                                      & ( ord_less_eq @ nat @ X5 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_379_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_380_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_381_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_382_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L2: num,R: A,Q2: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L2 @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R @ ( numeral_numeral @ A @ L2 ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R )
           => ( ( unique1321980374590559556d_step @ A @ L2 @ ( product_Pair @ A @ A @ Q2 @ R ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q2 ) @ R ) ) ) ) ) ).

% divmod_step_eq
thf(fact_383_True,axiom,
    ( ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
    = ( none @ nat ) ) ).

% True
thf(fact_384_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X2 ) ) )
      = ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( P @ ( nth @ A @ Xs2 @ I4 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_385_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,X: A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( P @ ( nth @ A @ Xs2 @ I3 ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( P @ X ) ) ) ).

% all_nth_imp_all_set
thf(fact_386_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ( nth @ A @ Xs2 @ I4 )
              = X ) ) ) ) ).

% in_set_conv_nth
thf(fact_387_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X5 ) )
       => ( P @ ( nth @ A @ Xs2 @ N ) ) ) ) ).

% list_ball_nth
thf(fact_388_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( member @ A @ ( nth @ A @ Xs2 @ N ) @ ( set2 @ A @ Xs2 ) ) ) ).

% nth_mem
thf(fact_389_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_390_real__divide__square__eq,axiom,
    ! [R: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ R ) )
      = ( divide_divide @ real @ A2 @ R ) ) ).

% real_divide_square_eq
thf(fact_391_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_392_succ__list__to__short,axiom,
    ! [Deg: nat,Mi: nat,X: nat,TreeList2: list @ vEBT_VEBT,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less_eq @ nat @ Mi @ X )
       => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
            = ( none @ nat ) ) ) ) ) ).

% succ_list_to_short
thf(fact_393__092_060open_062vebt__succ_A_INode_A_ISome_A_Imi_M_Ama_J_J_Adeg_AtreeList_Asummary_J_Ax_A_061_ANone_092_060close_062,axiom,
    ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
    = ( none @ nat ) ) ).

% \<open>vebt_succ (Node (Some (mi, ma)) deg treeList summary) x = None\<close>
thf(fact_394__C4_Ohyps_C_I1_J,axiom,
    ! [X3: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X3 @ na )
        & ! [Xa: nat,Xb: nat] :
            ( ( ( vEBT_vebt_succ @ X3 @ Xa )
              = ( some @ nat @ Xb ) )
            = ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ X3 ) @ Xa @ Xb ) ) ) ) ).

% "4.hyps"(1)
thf(fact_395_real__arch__pow,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ? [N3: nat] : ( ord_less @ real @ Y2 @ ( power_power @ real @ X @ N3 ) ) ) ).

% real_arch_pow
thf(fact_396_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X2: real,Y: real] :
          ( ( ord_less @ real @ X2 @ Y )
          | ( X2 = Y ) ) ) ) ).

% less_eq_real_def
thf(fact_397_complete__real,axiom,
    ! [S2: set @ real] :
      ( ? [X3: real] : ( member @ real @ X3 @ S2 )
     => ( ? [Z3: real] :
          ! [X5: real] :
            ( ( member @ real @ X5 @ S2 )
           => ( ord_less_eq @ real @ X5 @ Z3 ) )
       => ? [Y4: real] :
            ( ! [X3: real] :
                ( ( member @ real @ X3 @ S2 )
               => ( ord_less_eq @ real @ X3 @ Y4 ) )
            & ! [Z3: real] :
                ( ! [X5: real] :
                    ( ( member @ real @ X5 @ S2 )
                   => ( ord_less_eq @ real @ X5 @ Z3 ) )
               => ( ord_less_eq @ real @ Y4 @ Z3 ) ) ) ) ) ).

% complete_real
thf(fact_398_add__diff__assoc__enat,axiom,
    ! [Z2: extended_enat,Y2: extended_enat,X: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z2 @ Y2 )
     => ( ( plus_plus @ extended_enat @ X @ ( minus_minus @ extended_enat @ Y2 @ Z2 ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y2 ) @ Z2 ) ) ) ).

% add_diff_assoc_enat
thf(fact_399_two__realpow__ge__one,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) ) ).

% two_realpow_ge_one
thf(fact_400_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( X != Y2 )
         => ( ~ ( ord_less @ A @ X @ Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_401_subset__code_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ B4 )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ( member @ A @ X2 @ B4 ) ) ) ) ).

% subset_code(1)
thf(fact_402_Ex__list__of__length,axiom,
    ! [A: $tType,N: nat] :
    ? [Xs3: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs3 )
      = N ) ).

% Ex_list_of_length
thf(fact_403_neq__if__length__neq,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs2 != Ys ) ) ).

% neq_if_length_neq
thf(fact_404_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_405_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_406_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_407_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_408_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_409_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_410_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_411_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_412_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_413_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_414_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs2: list @ A] :
      ( ! [Xs3: list @ A] :
          ( ! [Ys2: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys2 ) @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P @ Ys2 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs2 ) ) ).

% length_induct
thf(fact_415_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_416_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_417_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I2 @ K ) @ N )
         => ( ord_less_eq @ A @ I2 @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_418_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_419_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_420_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_421_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X: A,Y2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y2 @ Y2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( minus_minus @ A @ X @ Y2 ) ) ) ) ).

% square_diff_square_factored
thf(fact_422_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_423_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_424_nth__equalityI,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ Ys ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( nth @ A @ Xs2 @ I3 )
              = ( nth @ A @ Ys @ I3 ) ) )
       => ( Xs2 = Ys ) ) ) ).

% nth_equalityI
thf(fact_425_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ K )
           => ? [X4: A] : ( P @ I4 @ X4 ) ) )
      = ( ? [Xs: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs )
              = K )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K )
               => ( P @ I4 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_426_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y5: list @ A,Z4: list @ A] : ( Y5 = Z4 ) )
      = ( ^ [Xs: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I4 )
                  = ( nth @ A @ Ys3 @ I4 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_427_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_428_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_429_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_430_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_431_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_432_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ X ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_433_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_434_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_435_succ__min,axiom,
    ! [Deg: nat,X: nat,Mi: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less @ nat @ X @ Mi )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
          = ( some @ nat @ Mi ) ) ) ) ).

% succ_min
thf(fact_436_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I3: nat] :
                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I3 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I3: nat] :
                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I3 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X5: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X5 @ N )
                                        = I3 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I3 ) @ ( vEBT_VEBT_low @ X5 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X5 )
                                      & ( ord_less_eq @ nat @ X5 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_437_not__None__eq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( ( X
         != ( none @ A ) ) )
      = ( ? [Y: A] :
            ( X
            = ( some @ A @ Y ) ) ) ) ).

% not_None_eq
thf(fact_438_not__Some__eq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( ! [Y: A] :
            ( X
           != ( some @ A @ Y ) ) )
      = ( X
        = ( none @ A ) ) ) ).

% not_Some_eq
thf(fact_439_minNullmin,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ( ( vEBT_vebt_mint @ T2 )
        = ( none @ nat ) ) ) ).

% minNullmin
thf(fact_440_minminNull,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_mint @ T2 )
        = ( none @ nat ) )
     => ( vEBT_VEBT_minNull @ T2 ) ) ).

% minminNull
thf(fact_441__C4_Ohyps_C_I3_J,axiom,
    ! [X: nat,Sx: nat] :
      ( ( ( vEBT_vebt_succ @ summary @ X )
        = ( some @ nat @ Sx ) )
      = ( vEBT_is_succ_in_set @ ( vEBT_VEBT_set_vebt @ summary ) @ X @ Sx ) ) ).

% "4.hyps"(3)
thf(fact_442_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X2: nat,N2: nat] : ( modulo_modulo @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% low_def
thf(fact_443_VEBT__internal_OminNull_Osimps_I5_J,axiom,
    ! [Uz: product_prod @ nat @ nat,Va: nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va @ Vb @ Vc ) ) ).

% VEBT_internal.minNull.simps(5)
thf(fact_444_even__odd__cases,axiom,
    ! [X: nat] :
      ( ! [N3: nat] :
          ( X
         != ( plus_plus @ nat @ N3 @ N3 ) )
     => ~ ! [N3: nat] :
            ( X
           != ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) ) ) ).

% even_odd_cases
thf(fact_445_deg__SUcn__Node,axiom,
    ! [Tree: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ Tree @ ( suc @ ( suc @ N ) ) )
     => ? [Info2: option @ ( product_prod @ nat @ nat ),TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
          ( Tree
          = ( vEBT_Node @ Info2 @ ( suc @ ( suc @ N ) ) @ TreeList3 @ S3 ) ) ) ).

% deg_SUcn_Node
thf(fact_446_power__shift,axiom,
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( power_power @ nat @ X @ Y2 )
        = Z2 )
      = ( ( vEBT_VEBT_power @ ( some @ nat @ X ) @ ( some @ nat @ Y2 ) )
        = ( some @ nat @ Z2 ) ) ) ).

% power_shift
thf(fact_447_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% nat.inject
thf(fact_448_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_449_mint__member,axiom,
    ! [T2: vEBT_VEBT,N: nat,Maxi: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ Maxi ) )
       => ( vEBT_vebt_member @ T2 @ Maxi ) ) ) ).

% mint_member
thf(fact_450_option_Oinject,axiom,
    ! [A: $tType,X22: A,Y22: A] :
      ( ( ( some @ A @ X22 )
        = ( some @ A @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% option.inject
thf(fact_451_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_452_mint__corr__help,axiom,
    ! [T2: vEBT_VEBT,N: nat,Mini: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ Mini ) )
       => ( ( vEBT_vebt_member @ T2 @ X )
         => ( ord_less_eq @ nat @ Mini @ X ) ) ) ) ).

% mint_corr_help
thf(fact_453_mint__sound,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_VEBT_min_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X )
       => ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ X ) ) ) ) ).

% mint_sound
thf(fact_454_mint__corr,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( some @ nat @ X ) )
       => ( vEBT_VEBT_min_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X ) ) ) ).

% mint_corr
thf(fact_455_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_eq
thf(fact_456_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% Suc_mono
thf(fact_457_lessI,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( suc @ N ) ) ).

% lessI
thf(fact_458_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N @ M ) ) ).

% Suc_le_mono
thf(fact_459_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_460_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_461_add__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc_right
thf(fact_462_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_463_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_Suc_Suc
thf(fact_464_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N ) @ K ) ) ).

% Suc_diff_diff
thf(fact_465_misiz,axiom,
    ! [T2: vEBT_VEBT,N: nat,M: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( some @ nat @ M )
          = ( vEBT_vebt_mint @ T2 ) )
       => ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% misiz
thf(fact_466_mod__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = M ) ) ).

% mod_less
thf(fact_467_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_468_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_469_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_470_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_471_mult__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc_right
thf(fact_472_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_473_mintlistlength,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( Mi != Ma )
       => ( ( ord_less @ nat @ Mi @ Ma )
          & ? [M4: nat] :
              ( ( ( some @ nat @ M4 )
                = ( vEBT_vebt_mint @ Summary ) )
              & ( ord_less @ nat @ M4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% mintlistlength
thf(fact_474_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I2 @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I2 @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_475_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I2 )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I2 ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_476_Suc__numeral,axiom,
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% Suc_numeral
thf(fact_477_Suc__mod__mult__self4,axiom,
    ! [N: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N @ K ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self4
thf(fact_478_Suc__mod__mult__self3,axiom,
    ! [K: nat,N: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N ) @ M ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self3
thf(fact_479_Suc__mod__mult__self2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N @ K ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self2
thf(fact_480_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_mod_mult_self1
thf(fact_481_greater__shift,axiom,
    ( ( ord_less @ nat )
    = ( ^ [Y: nat,X2: nat] : ( vEBT_VEBT_greater @ ( some @ nat @ X2 ) @ ( some @ nat @ Y ) ) ) ) ).

% greater_shift
thf(fact_482_lesseq__shift,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [X2: nat,Y: nat] : ( vEBT_VEBT_lesseq @ ( some @ nat @ X2 ) @ ( some @ nat @ Y ) ) ) ) ).

% lesseq_shift
thf(fact_483_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_484_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_485_add__2__eq__Suc,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc
thf(fact_486_add__2__eq__Suc_H,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc'
thf(fact_487_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_488_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_489_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_490_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_491_Suc__inject,axiom,
    ! [X: nat,Y2: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y2 ) )
     => ( X = Y2 ) ) ).

% Suc_inject
thf(fact_492_n__not__Suc__n,axiom,
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) ).

% n_not_Suc_n
thf(fact_493_mod__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N ) ) ).

% mod_Suc_eq
thf(fact_494_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N ) ) ).

% mod_Suc_Suc_eq
thf(fact_495_mod__induct,axiom,
    ! [P: nat > $o,N: nat,P2: nat,M: nat] :
      ( ( P @ N )
     => ( ( ord_less @ nat @ N @ P2 )
       => ( ( ord_less @ nat @ M @ P2 )
         => ( ! [N3: nat] :
                ( ( ord_less @ nat @ N3 @ P2 )
               => ( ( P @ N3 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N3 ) @ P2 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_496_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N ) ) @ N ) ).

% mod_Suc_le_divisor
thf(fact_497_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_498_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A5 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_499_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_500_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_501_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_502_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_503_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_504_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A5 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_505_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_506_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_507_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_508_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A5: A,B2: A,B5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A5 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B5 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A5 @ B5 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_509_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_510_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_511_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N ) @ B2 ) ) ) ).

% power_mod
thf(fact_512_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ M ) ).

% mod_less_eq_dividend
thf(fact_513_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_514_strict__inc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ! [I3: nat] :
            ( ( J
              = ( suc @ I3 ) )
           => ( P @ I3 ) )
       => ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ J )
             => ( ( P @ ( suc @ I3 ) )
               => ( P @ I3 ) ) )
         => ( P @ I2 ) ) ) ) ).

% strict_inc_induct
thf(fact_515_less__Suc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ! [I3: nat] : ( P @ I3 @ ( suc @ I3 ) )
       => ( ! [I3: nat,J2: nat,K3: nat] :
              ( ( ord_less @ nat @ I3 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K3 )
               => ( ( P @ I3 @ J2 )
                 => ( ( P @ J2 @ K3 )
                   => ( P @ I3 @ K3 ) ) ) ) )
         => ( P @ I2 @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_516_less__trans__Suc,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I2 ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_517_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_SucD
thf(fact_518_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) ).

% less_antisym
thf(fact_519_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N ) @ M )
      = ( ? [M5: nat] :
            ( ( M
              = ( suc @ M5 ) )
            & ( ord_less @ nat @ N @ M5 ) ) ) ) ).

% Suc_less_eq2
thf(fact_520_All__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
           => ( P @ I4 ) ) )
      = ( ( P @ N )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
           => ( P @ I4 ) ) ) ) ).

% All_less_Suc
thf(fact_521_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N ) )
      = ( ord_less @ nat @ N @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_522_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( M = N ) ) ) ).

% less_Suc_eq
thf(fact_523_Ex__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
            & ( P @ I4 ) ) )
      = ( ( P @ N )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
            & ( P @ I4 ) ) ) ) ).

% Ex_less_Suc
thf(fact_524_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% less_SucI
thf(fact_525_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( M = N ) ) ) ).

% less_SucE
thf(fact_526_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less @ nat @ ( suc @ M ) @ N ) ) ) ).

% Suc_lessI
thf(fact_527_Suc__lessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I2 @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_528_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_lessD
thf(fact_529_Nat_OlessE,axiom,
    ! [I2: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ K )
     => ( ( K
         != ( suc @ I2 ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_530_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R2: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ! [X5: nat] : ( R2 @ X5 @ X5 )
       => ( ! [X5: nat,Y4: nat,Z5: nat] :
              ( ( R2 @ X5 @ Y4 )
             => ( ( R2 @ Y4 @ Z5 )
               => ( R2 @ X5 @ Z5 ) ) )
         => ( ! [N3: nat] : ( R2 @ N3 @ ( suc @ N3 ) )
           => ( R2 @ M @ N ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_531_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_at_least
thf(fact_532_full__nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N3 )
             => ( P @ M2 ) )
         => ( P @ N3 ) )
     => ( P @ N ) ) ).

% full_nat_induct
thf(fact_533_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N ) )
      = ( ord_less_eq @ nat @ ( suc @ N ) @ M ) ) ).

% not_less_eq_eq
thf(fact_534_Suc__n__not__le__n,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N ) @ N ) ).

% Suc_n_not_le_n
thf(fact_535_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq @ nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) ).

% le_Suc_eq
thf(fact_536_Suc__le__D,axiom,
    ! [N: nat,M6: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ M6 )
     => ? [M4: nat] :
          ( M6
          = ( suc @ M4 ) ) ) ).

% Suc_le_D
thf(fact_537_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ ( suc @ N ) ) ) ).

% le_SucI
thf(fact_538_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) ).

% le_SucE
thf(fact_539_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_leD
thf(fact_540_add__Suc__shift,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) ).

% add_Suc_shift
thf(fact_541_add__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc
thf(fact_542_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A3 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_543_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I2: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K @ I2 ) ) ) ) ).

% zero_induct_lemma
thf(fact_544_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( M = N ) ) ).

% Suc_mult_cancel1
thf(fact_545_vebt__member_Osimps_I2_J,axiom,
    ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ X ) ).

% vebt_member.simps(2)
thf(fact_546_VEBT__internal_OminNull_Osimps_I4_J,axiom,
    ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] : ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) ) ).

% VEBT_internal.minNull.simps(4)
thf(fact_547_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_548_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_549_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D4 ) ) ) ) ) ).

% mod_eqE
thf(fact_550_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_551_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N2: nat] : ( if @ nat @ ( ord_less @ nat @ M3 @ N2 ) @ M3 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ).

% mod_if
thf(fact_552_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% mod_geq
thf(fact_553_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% le_mod_geq
thf(fact_554_nat__mod__eq__iff,axiom,
    ! [X: nat,N: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y2 @ N ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X @ ( times_times @ nat @ N @ Q1 ) )
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_555_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,M: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_556_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N @ N5 )
           => ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_557_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_Suc
thf(fact_558_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_559_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N5 ) @ ( F2 @ N ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_560_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_561_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% le_imp_less_Suc
thf(fact_562_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat] : ( ord_less_eq @ nat @ ( suc @ N2 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_563_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% less_Suc_eq_le
thf(fact_564_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% le_less_Suc_eq
thf(fact_565_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_lessD
thf(fact_566_inc__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( P @ J )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ ( suc @ N3 ) )
                 => ( P @ N3 ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% inc_induct
thf(fact_567_dec__induct,axiom,
    ! [I2: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( P @ I2 )
       => ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N3 )
             => ( ( ord_less @ nat @ N3 @ J )
               => ( ( P @ N3 )
                 => ( P @ ( suc @ N3 ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_568_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_eq
thf(fact_569_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_leI
thf(fact_570_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ~ ! [Q3: nat] :
            ( N
           != ( suc @ ( plus_plus @ nat @ M @ Q3 ) ) ) ) ).

% less_natE
thf(fact_571_less__add__Suc1,axiom,
    ! [I2: nat,M: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ I2 @ M ) ) ) ).

% less_add_Suc1
thf(fact_572_less__add__Suc2,axiom,
    ! [I2: nat,M: nat] : ( ord_less @ nat @ I2 @ ( suc @ ( plus_plus @ nat @ M @ I2 ) ) ) ).

% less_add_Suc2
thf(fact_573_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N2: nat] :
        ? [K2: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M3 @ K2 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_574_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ? [K3: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K3 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_575_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_576_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N ) ) )
        = ( minus_minus @ nat @ M @ N ) ) ) ).

% Suc_diff_Suc
thf(fact_577_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_mult_less_cancel1
thf(fact_578_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( suc @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Suc_diff_le
thf(fact_579_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_mult_le_cancel1
thf(fact_580_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ ( divide_divide @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_div_le_mono
thf(fact_581_mult__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc
thf(fact_582_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N2: nat] : ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_583_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_584_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_585_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_586_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_587_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_588_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_589_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_590_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_591_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_592_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_593_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_594_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_595_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_596_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_597_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_598_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_599_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_600_mod__eq__nat1E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ~ ! [S3: nat] :
              ( M
             != ( plus_plus @ nat @ N @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_601_mod__eq__nat2E,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q2 )
        = ( modulo_modulo @ nat @ N @ Q2 ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ~ ! [S3: nat] :
              ( N
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q2 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_602_nat__mod__eq__lemma,axiom,
    ! [X: nat,N: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y2 @ N ) )
     => ( ( ord_less_eq @ nat @ Y2 @ X )
       => ? [Q3: nat] :
            ( X
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N @ Q3 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_603_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_604_mod__mult2__eq,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N @ Q2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N ) @ Q2 ) ) @ ( modulo_modulo @ nat @ M @ N ) ) ) ).

% mod_mult2_eq
thf(fact_605_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N2: nat] : ( minus_minus @ nat @ M3 @ ( times_times @ nat @ ( divide_divide @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ).

% modulo_nat_def
thf(fact_606_vebt__succ_Osimps_I3_J,axiom,
    ! [Ux: nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,Va: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux @ Uy @ Uz ) @ Va )
      = ( none @ nat ) ) ).

% vebt_succ.simps(3)
thf(fact_607_div__nat__eqI,axiom,
    ! [N: nat,Q2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q2 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q2 ) ) )
       => ( ( divide_divide @ nat @ M @ N )
          = Q2 ) ) ) ).

% div_nat_eqI
thf(fact_608_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N ) ) ).

% Suc_nat_number_of_add
thf(fact_609_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_610_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_611_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_612_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_613_combine__options__cases,axiom,
    ! [A: $tType,B: $tType,X: option @ A,P: ( option @ A ) > ( option @ B ) > $o,Y2: option @ B] :
      ( ( ( X
          = ( none @ A ) )
       => ( P @ X @ Y2 ) )
     => ( ( ( Y2
            = ( none @ B ) )
         => ( P @ X @ Y2 ) )
       => ( ! [A6: A,B6: B] :
              ( ( X
                = ( some @ A @ A6 ) )
             => ( ( Y2
                  = ( some @ B @ B6 ) )
               => ( P @ X @ Y2 ) ) )
         => ( P @ X @ Y2 ) ) ) ) ).

% combine_options_cases
thf(fact_614_split__option__all,axiom,
    ! [A: $tType] :
      ( ( ^ [P3: ( option @ A ) > $o] :
          ! [X6: option @ A] : ( P3 @ X6 ) )
      = ( ^ [P4: ( option @ A ) > $o] :
            ( ( P4 @ ( none @ A ) )
            & ! [X2: A] : ( P4 @ ( some @ A @ X2 ) ) ) ) ) ).

% split_option_all
thf(fact_615_split__option__ex,axiom,
    ! [A: $tType] :
      ( ( ^ [P3: ( option @ A ) > $o] :
          ? [X6: option @ A] : ( P3 @ X6 ) )
      = ( ^ [P4: ( option @ A ) > $o] :
            ( ( P4 @ ( none @ A ) )
            | ? [X2: A] : ( P4 @ ( some @ A @ X2 ) ) ) ) ) ).

% split_option_ex
thf(fact_616_option_Oexhaust,axiom,
    ! [A: $tType,Y2: option @ A] :
      ( ( Y2
       != ( none @ A ) )
     => ~ ! [X23: A] :
            ( Y2
           != ( some @ A @ X23 ) ) ) ).

% option.exhaust
thf(fact_617_option_OdiscI,axiom,
    ! [A: $tType,Option: option @ A,X22: A] :
      ( ( Option
        = ( some @ A @ X22 ) )
     => ( Option
       != ( none @ A ) ) ) ).

% option.discI
thf(fact_618_option_Odistinct_I1_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( none @ A )
     != ( some @ A @ X22 ) ) ).

% option.distinct(1)
thf(fact_619_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X5: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X5 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_620_nested__mint,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat,Va: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( N
          = ( suc @ ( suc @ Va ) ) )
       => ( ~ ( ord_less @ nat @ Ma @ Mi )
         => ( ( Ma != Mi )
           => ( ord_less @ nat @ ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ ( the2 @ nat @ ( vEBT_vebt_mint @ Summary ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Va @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( the2 @ nat @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_mint @ Summary ) ) ) ) ) ) @ ( suc @ ( divide_divide @ nat @ Va @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ).

% nested_mint
thf(fact_621_False,axiom,
    ~ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
       != ( none @ nat ) )
      & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% False
thf(fact_622_mul__shift,axiom,
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( times_times @ nat @ X @ Y2 )
        = Z2 )
      = ( ( vEBT_VEBT_mul @ ( some @ nat @ X ) @ ( some @ nat @ Y2 ) )
        = ( some @ nat @ Z2 ) ) ) ).

% mul_shift
thf(fact_623_add__shift,axiom,
    ! [X: nat,Y2: nat,Z2: nat] :
      ( ( ( plus_plus @ nat @ X @ Y2 )
        = Z2 )
      = ( ( vEBT_VEBT_add @ ( some @ nat @ X ) @ ( some @ nat @ Y2 ) )
        = ( some @ nat @ Z2 ) ) ) ).

% add_shift
thf(fact_624_maxt__sound,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_VEBT_max_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X )
       => ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ X ) ) ) ) ).

% maxt_sound
thf(fact_625_maxt__corr,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ X ) )
       => ( vEBT_VEBT_max_in_set @ ( vEBT_VEBT_set_vebt @ T2 ) @ X ) ) ) ).

% maxt_corr
thf(fact_626_maxt__corr__help,axiom,
    ! [T2: vEBT_VEBT,N: nat,Maxi: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ Maxi ) )
       => ( ( vEBT_vebt_member @ T2 @ X )
         => ( ord_less_eq @ nat @ X @ Maxi ) ) ) ) ).

% maxt_corr_help
thf(fact_627_less__shift,axiom,
    ( ( ord_less @ nat )
    = ( ^ [X2: nat,Y: nat] : ( vEBT_VEBT_less @ ( some @ nat @ X2 ) @ ( some @ nat @ Y ) ) ) ) ).

% less_shift
thf(fact_628_maxt__member,axiom,
    ! [T2: vEBT_VEBT,N: nat,Maxi: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( some @ nat @ Maxi ) )
       => ( vEBT_vebt_member @ T2 @ Maxi ) ) ) ).

% maxt_member
thf(fact_629_vebt__mint_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Ux: nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
      ( ( vEBT_vebt_mint @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Ux @ Uy @ Uz ) )
      = ( some @ nat @ Mi ) ) ).

% vebt_mint.simps(3)
thf(fact_630_vebt__insert_Osimps_I4_J,axiom,
    ! [V: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V ) ) @ TreeList2 @ Summary ) @ X )
      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ X ) ) @ ( suc @ ( suc @ V ) ) @ TreeList2 @ Summary ) ) ).

% vebt_insert.simps(4)
thf(fact_631_maxbmo,axiom,
    ! [T2: vEBT_VEBT,X: nat] :
      ( ( ( vEBT_vebt_maxt @ T2 )
        = ( some @ nat @ X ) )
     => ( vEBT_V8194947554948674370ptions @ T2 @ X ) ) ).

% maxbmo
thf(fact_632_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_633_summaxma,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg )
     => ( ( Mi != Ma )
       => ( ( the2 @ nat @ ( vEBT_vebt_maxt @ Summary ) )
          = ( vEBT_VEBT_high @ Ma @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% summaxma
thf(fact_634_option_Ocollapse,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( ( some @ A @ ( the2 @ A @ Option ) )
        = Option ) ) ).

% option.collapse
thf(fact_635_i1,axiom,
    ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
      = ( none @ nat ) )
    | ~ ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% i1
thf(fact_636_add__def,axiom,
    ( vEBT_VEBT_add
    = ( vEBT_V2048590022279873568_shift @ nat @ ( plus_plus @ nat ) ) ) ).

% add_def
thf(fact_637_mul__def,axiom,
    ( vEBT_VEBT_mul
    = ( vEBT_V2048590022279873568_shift @ nat @ ( times_times @ nat ) ) ) ).

% mul_def
thf(fact_638__C2_C,axiom,
    ( ( ( ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( none @ nat ) )
     => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
        = ( none @ nat ) ) )
    & ( ( ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
       != ( none @ nat ) )
     => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
        = ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ treeList @ ( the2 @ nat @ ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% "2"
thf(fact_639__C1_C,axiom,
    ( ( ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
         != ( none @ nat ) )
        & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
     => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
        = ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
    & ( ~ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
           != ( none @ nat ) )
          & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
     => ( ( ( ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
            = ( none @ nat ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
            = ( none @ nat ) ) )
        & ( ( ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
           != ( none @ nat ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
            = ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ treeList @ ( the2 @ nat @ ( vEBT_vebt_succ @ summary @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% "1"
thf(fact_640_local_Opower__def,axiom,
    ( vEBT_VEBT_power
    = ( vEBT_V2048590022279873568_shift @ nat @ ( power_power @ nat ) ) ) ).

% local.power_def
thf(fact_641_option_Osel,axiom,
    ! [A: $tType,X22: A] :
      ( ( the2 @ A @ ( some @ A @ X22 ) )
      = X22 ) ).

% option.sel
thf(fact_642_option_Oexpand,axiom,
    ! [A: $tType,Option: option @ A,Option2: option @ A] :
      ( ( ( Option
          = ( none @ A ) )
        = ( Option2
          = ( none @ A ) ) )
     => ( ( ( Option
           != ( none @ A ) )
         => ( ( Option2
             != ( none @ A ) )
           => ( ( the2 @ A @ Option )
              = ( the2 @ A @ Option2 ) ) ) )
       => ( Option = Option2 ) ) ) ).

% option.expand
thf(fact_643_vebt__maxt_Osimps_I2_J,axiom,
    ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
      ( ( vEBT_vebt_maxt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
      = ( none @ nat ) ) ).

% vebt_maxt.simps(2)
thf(fact_644_option_Oexhaust__sel,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( Option
        = ( some @ A @ ( the2 @ A @ Option ) ) ) ) ).

% option.exhaust_sel
thf(fact_645_vebt__maxt_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Ux: nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
      ( ( vEBT_vebt_maxt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Ux @ Uy @ Uz ) )
      = ( some @ nat @ Ma ) ) ).

% vebt_maxt.simps(3)
thf(fact_646_VEBT__internal_Ooption__comp__shift_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) )] :
      ( ! [Uu2: A > A > $o,Uv2: option @ A] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ Uu2 @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( none @ A ) @ Uv2 ) ) )
     => ( ! [Uw2: A > A > $o,V3: A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ Uw2 @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( some @ A @ V3 ) @ ( none @ A ) ) ) )
       => ~ ! [F3: A > A > $o,X5: A,Y4: A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ F3 @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( some @ A @ X5 ) @ ( some @ A @ Y4 ) ) ) ) ) ) ).

% VEBT_internal.option_comp_shift.cases
thf(fact_647_VEBT__internal_Ooption__shift_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) )] :
      ( ! [Uu2: A > A > A,Uv2: option @ A] :
          ( X
         != ( product_Pair @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ Uu2 @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( none @ A ) @ Uv2 ) ) )
     => ( ! [Uw2: A > A > A,V3: A] :
            ( X
           != ( product_Pair @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ Uw2 @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( some @ A @ V3 ) @ ( none @ A ) ) ) )
       => ~ ! [F3: A > A > A,A6: A,B6: A] :
              ( X
             != ( product_Pair @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ F3 @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( some @ A @ A6 ) @ ( some @ A @ B6 ) ) ) ) ) ) ).

% VEBT_internal.option_shift.cases
thf(fact_648_vebt__mint_Osimps_I2_J,axiom,
    ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
      ( ( vEBT_vebt_mint @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
      = ( none @ nat ) ) ).

% vebt_mint.simps(2)
thf(fact_649_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% double_not_eq_Suc_double
thf(fact_650_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_double_not_eq_double
thf(fact_651_succ__greatereq__min,axiom,
    ! [Deg: nat,Mi: nat,X: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less_eq @ nat @ Mi @ X )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
          = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            @ ( if @ ( option @ nat )
              @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                 != ( none @ nat ) )
                & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
              @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
              @ ( if @ ( option @ nat )
                @ ( ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  = ( none @ nat ) )
                @ ( none @ nat )
                @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
            @ ( none @ nat ) ) ) ) ) ).

% succ_greatereq_min
thf(fact_652_succ__less__length__list,axiom,
    ! [Deg: nat,Mi: nat,X: nat,TreeList2: list @ vEBT_VEBT,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
     => ( ( ord_less_eq @ nat @ Mi @ X )
       => ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
            = ( if @ ( option @ nat )
              @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                 != ( none @ nat ) )
                & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
              @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
              @ ( if @ ( option @ nat )
                @ ( ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  = ( none @ nat ) )
                @ ( none @ nat )
                @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% succ_less_length_list
thf(fact_653_mint__corr__help__empty,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_mint @ T2 )
          = ( none @ nat ) )
       => ( ( vEBT_VEBT_set_vebt @ T2 )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% mint_corr_help_empty
thf(fact_654_maxt__corr__help__empty,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ( vEBT_vebt_maxt @ T2 )
          = ( none @ nat ) )
       => ( ( vEBT_VEBT_set_vebt @ T2 )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% maxt_corr_help_empty
thf(fact_655_div__mod__decomp,axiom,
    ! [A3: nat,N: nat] :
      ( A3
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A3 @ N ) @ N ) @ ( modulo_modulo @ nat @ A3 @ N ) ) ) ).

% div_mod_decomp
thf(fact_656_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_657_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_658_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_659_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T3 ) ) ) ) ).

% set_vebt'_def
thf(fact_660_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
thf(fact_661_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X2: A] : ( times_times @ A @ X2 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_662_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X2: A] : X2 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_663_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_664_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T3 ) ) ) ) ).

% set_vebt_def
thf(fact_665_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_666_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I4: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs @ I4 ) )
                & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_667_VEBT__internal_Ooption__shift_Osimps_I3_J,axiom,
    ! [A: $tType,F2: A > A > A,A2: A,B2: A] :
      ( ( vEBT_V2048590022279873568_shift @ A @ F2 @ ( some @ A @ A2 ) @ ( some @ A @ B2 ) )
      = ( some @ A @ ( F2 @ A2 @ B2 ) ) ) ).

% VEBT_internal.option_shift.simps(3)
thf(fact_668_VEBT__internal_Ooption__shift_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: A > A > A,Uv: option @ A] :
      ( ( vEBT_V2048590022279873568_shift @ A @ Uu @ ( none @ A ) @ Uv )
      = ( none @ A ) ) ).

% VEBT_internal.option_shift.simps(1)
thf(fact_669_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_670_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_671_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_672_div__mod__decomp__int,axiom,
    ! [A3: int,N: int] :
      ( A3
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A3 @ N ) @ N ) @ ( modulo_modulo @ int @ A3 @ N ) ) ) ).

% div_mod_decomp_int
thf(fact_673_VEBT__internal_Ooption__shift_Osimps_I2_J,axiom,
    ! [A: $tType,Uw: A > A > A,V: A] :
      ( ( vEBT_V2048590022279873568_shift @ A @ Uw @ ( some @ A @ V ) @ ( none @ A ) )
      = ( none @ A ) ) ).

% VEBT_internal.option_shift.simps(2)
thf(fact_674_VEBT__internal_Ooption__shift_Oelims,axiom,
    ! [A: $tType,X: A > A > A,Xa2: option @ A,Xb2: option @ A,Y2: option @ A] :
      ( ( ( vEBT_V2048590022279873568_shift @ A @ X @ Xa2 @ Xb2 )
        = Y2 )
     => ( ( ( Xa2
            = ( none @ A ) )
         => ( Y2
           != ( none @ A ) ) )
       => ( ( ? [V3: A] :
                ( Xa2
                = ( some @ A @ V3 ) )
           => ( ( Xb2
                = ( none @ A ) )
             => ( Y2
               != ( none @ A ) ) ) )
         => ~ ! [A6: A] :
                ( ( Xa2
                  = ( some @ A @ A6 ) )
               => ! [B6: A] :
                    ( ( Xb2
                      = ( some @ A @ B6 ) )
                   => ( Y2
                     != ( some @ A @ ( X @ A6 @ B6 ) ) ) ) ) ) ) ) ).

% VEBT_internal.option_shift.elims
thf(fact_675_vebt__member_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
      = ( ( X != Mi )
       => ( ( X != Ma )
         => ( ~ ( ord_less @ nat @ X @ Mi )
            & ( ~ ( ord_less @ nat @ X @ Mi )
             => ( ~ ( ord_less @ nat @ Ma @ X )
                & ( ~ ( ord_less @ nat @ Ma @ X )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_676_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B5: B,A5: B] :
          ( ( ~ ( ord_less_eq @ B @ B5 @ A5 ) )
          = ( ord_less @ B @ A5 @ B5 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_677_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] :
      ( one2
     != ( bit0 @ X22 ) ) ).

% verit_eq_simplify(10)
thf(fact_678_vebt__succ_Osimps_I6_J,axiom,
    ! [X: nat,Mi: nat,Ma: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( ord_less @ nat @ X @ Mi )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
          = ( some @ nat @ Mi ) ) )
      & ( ~ ( ord_less @ nat @ X @ Mi )
       => ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
          = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            @ ( if @ ( option @ nat )
              @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                 != ( none @ nat ) )
                & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
              @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
              @ ( if @ ( option @ nat )
                @ ( ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  = ( none @ nat ) )
                @ ( none @ nat )
                @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList2 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
            @ ( none @ nat ) ) ) ) ) ).

% vebt_succ.simps(6)
thf(fact_679_buildup__gives__empty,axiom,
    ! [N: nat] :
      ( ( vEBT_VEBT_set_vebt @ ( vEBT_vebt_buildup @ N ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% buildup_gives_empty
thf(fact_680_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_eq_empty_iff
thf(fact_681_empty__subsetI,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) ).

% empty_subsetI
thf(fact_682_subset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_683_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi: nat,Ma: nat,V: nat,TreeList2: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ V ) @ TreeList2 @ Vc ) @ X )
      = ( ( X = Mi )
        | ( X = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_684_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy: option @ ( product_prod @ nat @ nat ),V: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy @ ( suc @ V ) @ TreeList2 @ S ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_685_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList2: list @ vEBT_VEBT,Vd: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList2 @ Vd ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_686_vebt__succ_Oelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: option @ nat] :
      ( ( ( vEBT_vebt_succ @ X @ Xa2 )
        = Y2 )
     => ( ! [Uu2: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ Uu2 @ B6 ) )
           => ( ( Xa2
                = ( zero_zero @ nat ) )
             => ~ ( ( B6
                   => ( Y2
                      = ( some @ nat @ ( one_one @ nat ) ) ) )
                  & ( ~ B6
                   => ( Y2
                      = ( none @ nat ) ) ) ) ) )
       => ( ( ? [Uv2: $o,Uw2: $o] :
                ( X
                = ( vEBT_Leaf @ Uv2 @ Uw2 ) )
           => ( ? [N3: nat] :
                  ( Xa2
                  = ( suc @ N3 ) )
             => ( Y2
               != ( none @ nat ) ) ) )
         => ( ( ? [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) )
             => ( Y2
               != ( none @ nat ) ) )
           => ( ( ? [V3: product_prod @ nat @ nat,Vc2: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) )
               => ( Y2
                 != ( none @ nat ) ) )
             => ( ( ? [V3: product_prod @ nat @ nat,Vg: list @ vEBT_VEBT,Vh: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg @ Vh ) )
                 => ( Y2
                   != ( none @ nat ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                     => ~ ( ( ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( Y2
                              = ( some @ nat @ Mi2 ) ) )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( Y2
                              = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                @ ( if @ ( option @ nat )
                                  @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                     != ( none @ nat ) )
                                    & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                                  @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  @ ( if @ ( option @ nat )
                                    @ ( ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                                      = ( none @ nat ) )
                                    @ ( none @ nat )
                                    @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList3 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
                                @ ( none @ nat ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_succ.elims
thf(fact_687_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs2: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs2 @ Ys ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_688_obtain__set__succ,axiom,
    ! [X: nat,Z2: nat,A3: set @ nat,B4: set @ nat] :
      ( ( ord_less @ nat @ X @ Z2 )
     => ( ( vEBT_VEBT_max_in_set @ A3 @ Z2 )
       => ( ( finite_finite @ nat @ B4 )
         => ( ( A3 = B4 )
           => ? [X_1: nat] : ( vEBT_is_succ_in_set @ A3 @ X @ X_1 ) ) ) ) ) ).

% obtain_set_succ
thf(fact_689_valid__0__not,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_0_not
thf(fact_690_valid__tree__deg__neq__0,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_tree_deg_neq_0
thf(fact_691_buildup__nothing__in__min__max,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_min_max
thf(fact_692_buildup__nothing__in__leaf,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_leaf
thf(fact_693_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% deg_not_0
thf(fact_694_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_695_deg1Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
      = ( ? [A4: $o,B3: $o] :
            ( T2
            = ( vEBT_Leaf @ A4 @ B3 ) ) ) ) ).

% deg1Leaf
thf(fact_696_deg__1__Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
     => ? [A6: $o,B6: $o] :
          ( T2
          = ( vEBT_Leaf @ A6 @ B6 ) ) ) ).

% deg_1_Leaf
thf(fact_697_deg__1__Leafy,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( N
          = ( one_one @ nat ) )
       => ? [A6: $o,B6: $o] :
            ( T2
            = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ).

% deg_1_Leafy
thf(fact_698_set__vebt__finite,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_finite
thf(fact_699_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X2: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X2 )
          | ( vEBT_VEBT_membermima @ T3 @ X2 ) ) ) ) ).

% both_member_options_def
thf(fact_700_succ__none__empty,axiom,
    ! [Xs2: set @ nat,A2: nat] :
      ( ~ ? [X_1: nat] : ( vEBT_is_succ_in_set @ Xs2 @ A2 @ X_1 )
     => ( ( finite_finite @ nat @ Xs2 )
       => ~ ? [X3: nat] :
              ( ( member @ nat @ X3 @ Xs2 )
              & ( ord_less @ nat @ A2 @ X3 ) ) ) ) ).

% succ_none_empty
thf(fact_701_buildup__gives__valid,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N ) @ N ) ) ).

% buildup_gives_valid
thf(fact_702_subsetI,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( member @ A @ X5 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% subsetI
thf(fact_703_subset__antisym,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( A3 = B4 ) ) ) ).

% subset_antisym
thf(fact_704_psubsetI,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( A3 != B4 )
       => ( ord_less @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% psubsetI
thf(fact_705_Diff__idemp,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ B4 )
      = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_idemp
thf(fact_706_Diff__iff,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( member @ A @ C2 @ A3 )
        & ~ ( member @ A @ C2 @ B4 ) ) ) ).

% Diff_iff
thf(fact_707_DiffI,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ A3 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% DiffI
thf(fact_708_member__valid__both__member__options,axiom,
    ! [Tree: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ Tree @ N )
     => ( ( vEBT_vebt_member @ Tree @ X )
       => ( ( vEBT_V5719532721284313246member @ Tree @ X )
          | ( vEBT_VEBT_membermima @ Tree @ X ) ) ) ) ).

% member_valid_both_member_options
thf(fact_709_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% VEBT.inject(2)
thf(fact_710_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_711_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_712_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_713_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_714_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_715_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_716_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_717_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_718_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_719_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_720_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_721_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_722_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_723_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y2: A] :
          ( ( ( plus_plus @ A @ X @ Y2 )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_724_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y2 ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_725_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_726_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_727_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_728_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_729_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_730_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_731_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_732_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_733_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_734_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_735_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_736_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_737_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_738_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_739_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_740_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_741_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_742_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_743_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_744_neq0__conv,axiom,
    ! [N: nat] :
      ( ( ( N
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% neq0_conv
thf(fact_745_less__nat__zero__code,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_746_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_747_le0,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% le0
thf(fact_748_List_Ofinite__set,axiom,
    ! [A: $tType,Xs2: list @ A] : ( finite_finite @ A @ ( set2 @ A @ Xs2 ) ) ).

% List.finite_set
thf(fact_749_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_750_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_751_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_752_diff__0__eq__0,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_753_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_754_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_755_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_756_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_757_Diff__cancel,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_cancel
thf(fact_758_empty__Diff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) ).

% empty_Diff
thf(fact_759_Diff__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) ).

% Diff_empty
thf(fact_760_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_761_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_762_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_763_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_764_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_765_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_766_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_767_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_768_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_769_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_770_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_771_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_772_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_773_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_774_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_775_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_776_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_777_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_778_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y2 @ Y2 ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_779_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_780_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_781_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_782_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_783_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_784_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_785_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_786_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_787_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_788_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_789_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_790_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_791_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_792_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_793_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_794_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_795_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_796_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_797_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_798_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_799_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_800_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_801_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_802_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_803_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_804_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_805_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_806_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_807_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_808_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_809_less__Suc0,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_810_zero__less__Suc,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) ).

% zero_less_Suc
thf(fact_811_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% add_gr_0
thf(fact_812_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_813_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_814_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% zero_less_diff
thf(fact_815_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_816_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% mult_less_cancel2
thf(fact_817_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% nat_0_less_mult_iff
thf(fact_818_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_819_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% diff_is_0_eq
thf(fact_820_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_821_div__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_822_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_823_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M: nat] :
      ( ( ( power_power @ nat @ X @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_824_power__Suc__0,axiom,
    ! [N: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_825_nat__zero__less__power__iff,axiom,
    ! [X: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_826_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( divide_divide @ nat @ M @ N ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_827_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_828_length__product,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs2 @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_829_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_830_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_831_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_832_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_833_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_834_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_835_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_836_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_837_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_838_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_839_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_840_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_841_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_842_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_843_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_844_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_845_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% power_eq_0_iff
thf(fact_846_Suc__pred,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% Suc_pred
thf(fact_847_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) ) ).

% one_le_mult_iff
thf(fact_848_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% mult_le_cancel2
thf(fact_849_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_850_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N ) @ N )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_851_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N @ M ) @ N )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_852_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_853_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_854_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_855_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_856_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_857_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_858_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_859_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_860_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_861_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_862_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_863_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X = Y2 ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_864_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_865_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_866_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_867_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_868_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_869_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_870_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_871_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_872_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_873_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_874_set__diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A7 )
                & ~ ( member @ A @ X2 @ B7 ) ) ) ) ) ).

% set_diff_eq
thf(fact_875_minus__set__def,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( collect @ A
            @ ( minus_minus @ ( A > $o )
              @ ^ [X2: A] : ( member @ A @ X2 @ A7 )
              @ ^ [X2: A] : ( member @ A @ X2 @ B7 ) ) ) ) ) ).

% minus_set_def
thf(fact_876_DiffD2,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( member @ A @ C2 @ B4 ) ) ).

% DiffD2
thf(fact_877_DiffD1,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ( member @ A @ C2 @ A3 ) ) ).

% DiffD1
thf(fact_878_DiffE,axiom,
    ! [A: $tType,C2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( ( member @ A @ C2 @ A3 )
         => ( member @ A @ C2 @ B4 ) ) ) ).

% DiffE
thf(fact_879_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_880_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ? [B6: A] : ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_881_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_882_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_883_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,Uw: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_884_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_885_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_886_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_887_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X5: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X5 ) )
     => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ X5 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_888_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_889_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_890_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_891_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_892_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,D4: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D4 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,Deg3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_893_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_894_VEBT_Oexhaust,axiom,
    ! [Y2: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y2
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y2
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_895_vebt__insert_Osimps_I1_J,axiom,
    ! [X: nat,A2: $o,B2: $o] :
      ( ( ( X
          = ( zero_zero @ nat ) )
       => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
          = ( vEBT_Leaf @ $true @ B2 ) ) )
      & ( ( X
         != ( zero_zero @ nat ) )
       => ( ( ( X
              = ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ $true ) ) )
          & ( ( X
             != ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ B2 ) ) ) ) ) ) ).

% vebt_insert.simps(1)
thf(fact_896_finite__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [Xs3: list @ A] :
          ( ( set2 @ A @ Xs3 )
          = A3 ) ) ).

% finite_list
thf(fact_897_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_898_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_899_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E2: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
                & ( ord_less @ A @ E2 @ D1 )
                & ( ord_less @ A @ E2 @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_900_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_901_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_902_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_903_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_904_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_905_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) ).

% zero_neq_numeral
thf(fact_906_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_907_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_908_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_909_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_910_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_911_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_912_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_913_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_914_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_915_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_916_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( minus_minus @ A @ A4 @ B3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_917_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_918_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_919_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_920_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% not0_implies_Suc
thf(fact_921_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_922_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_923_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_924_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_925_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X5: nat] : ( P @ X5 @ ( zero_zero @ nat ) )
     => ( ! [Y4: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y4 ) )
       => ( ! [X5: nat,Y4: nat] :
              ( ( P @ X5 @ Y4 )
             => ( P @ ( suc @ X5 ) @ ( suc @ Y4 ) ) )
         => ( P @ M @ N ) ) ) ) ).

% diff_induct
thf(fact_926_nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N ) ) ) ).

% nat_induct
thf(fact_927_old_Onat_Oexhaust,axiom,
    ! [Y2: nat] :
      ( ( Y2
       != ( zero_zero @ nat ) )
     => ~ ! [Nat3: nat] :
            ( Y2
           != ( suc @ Nat3 ) ) ) ).

% old.nat.exhaust
thf(fact_928_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_929_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_930_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat4: nat] :
      ( ( suc @ Nat4 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_931_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) ).

% nat.distinct(1)
thf(fact_932_vebt__buildup_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ( ( X
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va2: nat] :
              ( X
             != ( suc @ ( suc @ Va2 ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_933_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_934_gr0I,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% gr0I
thf(fact_935_not__gr0,axiom,
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_936_not__less0,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_937_less__zeroE,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_938_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_939_infinite__descent0,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N3 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) ).

% infinite_descent0
thf(fact_940_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P: A > $o,X: A] :
      ( ! [X5: A] :
          ( ( ( V2 @ X5 )
            = ( zero_zero @ nat ) )
         => ( P @ X5 ) )
     => ( ! [X5: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X5 ) )
           => ( ~ ( P @ X5 )
             => ? [Y3: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y3 ) @ ( V2 @ X5 ) )
                  & ~ ( P @ Y3 ) ) ) )
       => ( P @ X ) ) ) ).

% infinite_descent0_measure
thf(fact_941_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% less_eq_nat.simps(1)
thf(fact_942_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_943_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_944_le__0__eq,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_945_plus__nat_Oadd__0,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% plus_nat.add_0
thf(fact_946_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_947_VEBT__internal_OminNull_Osimps_I3_J,axiom,
    ! [Uu: $o] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Leaf @ Uu @ $true ) ) ).

% VEBT_internal.minNull.simps(3)
thf(fact_948_VEBT__internal_OminNull_Osimps_I2_J,axiom,
    ! [Uv: $o] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Leaf @ $true @ Uv ) ) ).

% VEBT_internal.minNull.simps(2)
thf(fact_949_VEBT__internal_OminNull_Osimps_I1_J,axiom,
    vEBT_VEBT_minNull @ ( vEBT_Leaf @ $false @ $false ) ).

% VEBT_internal.minNull.simps(1)
thf(fact_950_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N @ M )
          = ( zero_zero @ nat ) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
thf(fact_951_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_952_mult__0,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_953_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_954_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N )
                  = ( power_power @ A @ B2 @ N ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_955_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_956_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_957_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
              & ( ( size_size @ ( list @ A ) @ Xs )
                = N ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_958_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Va: list @ vEBT_VEBT,Vb: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( zero_zero @ nat ) @ Va @ Vb ) @ X )
      = ( ( X = Mi )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_959_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_960_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_961_vebt__succ_Osimps_I1_J,axiom,
    ! [B2: $o,Uu: $o] :
      ( ( B2
       => ( ( vEBT_vebt_succ @ ( vEBT_Leaf @ Uu @ B2 ) @ ( zero_zero @ nat ) )
          = ( some @ nat @ ( one_one @ nat ) ) ) )
      & ( ~ B2
       => ( ( vEBT_vebt_succ @ ( vEBT_Leaf @ Uu @ B2 ) @ ( zero_zero @ nat ) )
          = ( none @ nat ) ) ) ) ).

% vebt_succ.simps(1)
thf(fact_962_vebt__maxt_Osimps_I1_J,axiom,
    ! [B2: $o,A2: $o] :
      ( ( B2
       => ( ( vEBT_vebt_maxt @ ( vEBT_Leaf @ A2 @ B2 ) )
          = ( some @ nat @ ( one_one @ nat ) ) ) )
      & ( ~ B2
       => ( ( A2
           => ( ( vEBT_vebt_maxt @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( some @ nat @ ( zero_zero @ nat ) ) ) )
          & ( ~ A2
           => ( ( vEBT_vebt_maxt @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( none @ nat ) ) ) ) ) ) ).

% vebt_maxt.simps(1)
thf(fact_963_vebt__mint_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o] :
      ( ( A2
       => ( ( vEBT_vebt_mint @ ( vEBT_Leaf @ A2 @ B2 ) )
          = ( some @ nat @ ( zero_zero @ nat ) ) ) )
      & ( ~ A2
       => ( ( B2
           => ( ( vEBT_vebt_mint @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( some @ nat @ ( one_one @ nat ) ) ) )
          & ( ~ B2
           => ( ( vEBT_vebt_mint @ ( vEBT_Leaf @ A2 @ B2 ) )
              = ( none @ nat ) ) ) ) ) ) ).

% vebt_mint.simps(1)
thf(fact_964_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_le_numeral
thf(fact_965_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_966_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_967_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_968_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_969_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_970_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_971_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_972_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_973_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_974_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_975_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_976_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_977_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_978_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_979_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_980_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_981_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_982_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_983_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_less_numeral
thf(fact_984_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_985_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_986_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_987_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_988_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_989_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( plus_plus @ A @ X @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_990_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_991_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_992_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_993_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_994_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_995_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_996_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_997_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_998_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_999_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_1000_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_1001_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_1002_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_1003_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_1004_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_1005_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_1006_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_1007_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_1008_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_1009_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_1010_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_1011_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_1012_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_1013_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_1014_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_1015_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1016_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_1017_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_1018_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_1019_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y2 @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_1020_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_1021_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C4: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C4 ) )
               => ( C4
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_1022_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_1023_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_1024_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_1025_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_1026_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_1027_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_1028_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_1029_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_1030_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_1031_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_1032_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] : ( ord_less @ A @ ( minus_minus @ A @ A4 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1033_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% divide_neg_neg
thf(fact_1034_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_1035_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_1036_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% divide_pos_pos
thf(fact_1037_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_1038_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_1039_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_1040_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_1041_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_1042_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono
thf(fact_1043_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_power
thf(fact_1044_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_less_power
thf(fact_1045_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_1046_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_1047_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_1048_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_1049_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_1050_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_1051_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z2: A,X: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y2 )
                = ( divide_divide @ A @ W @ Z2 ) )
              = ( ( times_times @ A @ X @ Z2 )
                = ( times_times @ A @ W @ Y2 ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_1052_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_1053_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_1054_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_1055_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_1056_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_1057_Ex__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
            & ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
            & ( P @ ( suc @ I4 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_1058_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
      = ( ? [M3: nat] :
            ( N
            = ( suc @ M3 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_1059_All__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
           => ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
           => ( P @ ( suc @ I4 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_1060_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% gr0_implies_Suc
thf(fact_1061_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less @ nat @ J3 @ N ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_1062_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_1063_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_1064_ex__least__nat__le,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ K3 )
               => ~ ( P @ I ) )
            & ( P @ K3 ) ) ) ) ).

% ex_least_nat_le
thf(fact_1065_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_1066_less__imp__add__positive,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ? [K3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K3 )
          & ( ( plus_plus @ nat @ I2 @ K3 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_1067_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_1068_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ) ) ).

% diff_less
thf(fact_1069_mult__less__mono1,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I2 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_1070_mult__less__mono2,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I2 ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_1071_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N ) )
        = ( M = N ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_1072_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel1
thf(fact_1073_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_1074_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_1075_diff__add__0,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ N @ ( plus_plus @ nat @ N @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1076_nat__power__less__imp__less,axiom,
    ! [I2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I2 )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I2 @ M ) @ ( power_power @ nat @ I2 @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% nat_power_less_imp_less
thf(fact_1077_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_1078_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
          = N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
         != N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ).

% mod_Suc
thf(fact_1079_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_less_divisor
thf(fact_1080_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q3: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q3 ) ) ) ).

% mod_eq_0D
thf(fact_1081_vebt__insert_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X5: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X5 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT,X5: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) @ X5 ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) @ X5 ) )
         => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X5: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) @ X5 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X5: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ X5 ) ) ) ) ) ) ).

% vebt_insert.cases
thf(fact_1082_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) )
       => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X5 ) )
         => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X5: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ X5 ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X5: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) @ X5 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_1083_vebt__succ_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,B6: $o] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ B6 ) @ ( zero_zero @ nat ) ) )
     => ( ! [Uv2: $o,Uw2: $o,N3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uv2 @ Uw2 ) @ ( suc @ N3 ) ) )
       => ( ! [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,Va3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) @ Va3 ) )
         => ( ! [V3: product_prod @ nat @ nat,Vc2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,Ve: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) @ Ve ) )
           => ( ! [V3: product_prod @ nat @ nat,Vg: list @ vEBT_VEBT,Vh: vEBT_VEBT,Vi: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg @ Vh ) @ Vi ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X5: nat] :
                    ( X
                   != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ X5 ) ) ) ) ) ) ) ).

% vebt_succ.cases
thf(fact_1084_vebt__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A6: $o,B6: $o,X5: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ X5 ) )
     => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X5: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ X5 ) )
       => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X5: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X5 ) )
         => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X5: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X5 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X5: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ X5 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_1085_vebt__insert_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts2 @ S ) @ X )
      = ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts2 @ S ) ) ).

% vebt_insert.simps(2)
thf(fact_1086_VEBT__internal_OminNull_Ocases,axiom,
    ! [X: vEBT_VEBT] :
      ( ( X
       != ( vEBT_Leaf @ $false @ $false ) )
     => ( ! [Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ $true @ Uv2 ) )
       => ( ! [Uu2: $o] :
              ( X
             != ( vEBT_Leaf @ Uu2 @ $true ) )
         => ( ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) )
           => ~ ! [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) ) ) ) ) ) ).

% VEBT_internal.minNull.cases
thf(fact_1087_vebt__succ_Osimps_I2_J,axiom,
    ! [Uv: $o,Uw: $o,N: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Leaf @ Uv @ Uw ) @ ( suc @ N ) )
      = ( none @ nat ) ) ).

% vebt_succ.simps(2)
thf(fact_1088_VEBT__internal_OminNull_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ X )
     => ( ! [Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ $true @ Uv2 ) )
       => ( ! [Uu2: $o] :
              ( X
             != ( vEBT_Leaf @ Uu2 @ $true ) )
         => ~ ! [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) ) ) ) ) ).

% VEBT_internal.minNull.elims(3)
thf(fact_1089_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_1090_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_1091_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_1092_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_1093_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_1094_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_1095_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_1096_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_1097_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_1098_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_1099_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_1100_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_1101_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_1102_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_1103_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ X @ ( plus_plus @ A @ Y2 @ E2 ) ) )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) ).

% field_le_epsilon
thf(fact_1104_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_1105_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_1106_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_1107_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_1108_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_1109_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_1110_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_1111_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_1112_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X: A,W: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z2 )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_1113_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A,W: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ X @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_1114_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A,W: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z2 )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z2 ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_1115_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_1116_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_1117_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_1118_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_1119_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_1120_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y2 @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_1121_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y2 ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_1122_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_1123_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_1124_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y2 @ Y2 ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_1125_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_1126_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_1127_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_1128_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y2 @ Y2 ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_1129_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_1130_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_1131_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_1132_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_1133_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_1134_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_1135_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_1136_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_1137_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z2 @ Y2 ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y2 ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_1138_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ ( times_times @ A @ Z2 @ Y2 ) @ X )
           => ( ord_less @ A @ Z2 @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_1139_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_1140_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_1141_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1142_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1143_VEBT__internal_OminNull_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ X )
     => ( ( X
         != ( vEBT_Leaf @ $false @ $false ) )
       => ~ ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) ) ) ) ).

% VEBT_internal.minNull.elims(2)
thf(fact_1144_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_1145_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_1146_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_1147_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y2 @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_add_eq_iff
thf(fact_1148_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y2 @ Z2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ Y2 ) @ Z2 ) ) ) ) ).

% add_divide_eq_iff
thf(fact_1149_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z2: A,X: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ X @ Y2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_num_frac
thf(fact_1150_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,X: A,Z2: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y2 ) @ Z2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z2 @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_frac_num
thf(fact_1151_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z2: A,X: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z2 ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_1152_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_1153_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_1154_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N ) )
            = ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_1155_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_1156_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1157_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1158_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z2 ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y2 @ Z2 ) ) @ Z2 ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1159_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y2 @ Z2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ Y2 ) @ Z2 ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1160_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z2: A,X: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z2 ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1161_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = A2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z2 ) @ B2 ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1162_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_1163_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_1164_in__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B4 ) ) ) ).

% in_mono
thf(fact_1165_subsetD,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B4 ) ) ) ).

% subsetD
thf(fact_1166_equalityE,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( A3 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ) ).

% equalityE
thf(fact_1167_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A7 )
           => ( member @ A @ X2 @ B7 ) ) ) ) ).

% subset_eq
thf(fact_1168_equalityD1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( A3 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% equalityD1
thf(fact_1169_equalityD2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( A3 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ).

% equalityD2
thf(fact_1170_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A7 )
           => ( member @ A @ T3 @ B7 ) ) ) ) ).

% subset_iff
thf(fact_1171_subset__refl,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) ).

% subset_refl
thf(fact_1172_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( Q @ X5 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_1173_subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% subset_trans
thf(fact_1174_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y5: set @ A,Z4: set @ A] : ( Y5 = Z4 ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) ).

% set_eq_subset
thf(fact_1175_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) ) ) ) ).

% Collect_mono_iff
thf(fact_1176_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
            | ( A7 = B7 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_1177_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% subset_psubset_trans
thf(fact_1178_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_1179_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% psubset_subset_trans
thf(fact_1180_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% psubset_imp_subset
thf(fact_1181_double__diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ( minus_minus @ ( set @ A ) @ B4 @ ( minus_minus @ ( set @ A ) @ C5 @ A3 ) )
          = A3 ) ) ) ).

% double_diff
thf(fact_1182_Diff__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ A3 ) ).

% Diff_subset
thf(fact_1183_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ( A7 != B7 ) ) ) ) ).

% psubset_eq
thf(fact_1184_Diff__mono,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,D5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ D5 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ C5 @ D5 ) ) ) ) ).

% Diff_mono
thf(fact_1185_psubsetE,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ) ).

% psubsetE
thf(fact_1186_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_1187_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_1188_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_1189_num_Osize_I5_J,axiom,
    ! [X22: num] :
      ( ( size_size @ num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_1190_ex__least__nat__less,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K3: nat] :
            ( ( ord_less @ nat @ K3 @ N )
            & ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ K3 )
               => ~ ( P @ I ) )
            & ( P @ ( suc @ K3 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_1191_diff__Suc__less,axiom,
    ! [N: nat,I2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N @ ( suc @ I2 ) ) @ N ) ) ).

% diff_Suc_less
thf(fact_1192_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) ) ) ) ).

% one_less_mult
thf(fact_1193_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ) ).

% n_less_m_mult_n
thf(fact_1194_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ N @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_1195_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_pos_if_in_set
thf(fact_1196_nat__induct__non__zero,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( P @ N3 )
               => ( P @ ( suc @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_1197_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel1
thf(fact_1198_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D3: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D3 ) )
                & ~ ( P @ D3 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1199_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D3: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D3 ) )
           => ( P @ D3 ) ) ) ) ).

% nat_diff_split
thf(fact_1200_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N @ K ) ) ) ).

% power_gt_expt
thf(fact_1201_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_1202_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ N @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% div_greater_zero_iff
thf(fact_1203_nat__one__le__power,axiom,
    ! [I2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I2 )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I2 @ N ) ) ) ).

% nat_one_le_power
thf(fact_1204_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( divide_divide @ nat @ M @ N ) ) ) ).

% nat_mult_div_cancel1
thf(fact_1205_div__less__iff__less__mult,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q2 ) @ N )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N @ Q2 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_1206_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1207_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N )
          = M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1208_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_le_divisor
thf(fact_1209_div__less__mono,axiom,
    ! [A3: nat,B4: nat,N: nat] :
      ( ( ord_less @ nat @ A3 @ B4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( modulo_modulo @ nat @ A3 @ N )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B4 @ N )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A3 @ N ) @ ( divide_divide @ nat @ B4 @ N ) ) ) ) ) ) ).

% div_less_mono
thf(fact_1210_vebt__insert_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) @ X )
      = ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) ) ).

% vebt_insert.simps(3)
thf(fact_1211_vebt__member_Osimps_I3_J,axiom,
    ! [V: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X ) ).

% vebt_member.simps(3)
thf(fact_1212_vebt__mint_Ocases,axiom,
    ! [X: vEBT_VEBT] :
      ( ! [A6: $o,B6: $o] :
          ( X
         != ( vEBT_Leaf @ A6 @ B6 ) )
     => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
            ( X
           != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
       => ~ ! [Mi2: nat,Ma2: nat,Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) ) ) ) ).

% vebt_mint.cases
thf(fact_1213_VEBT__internal_OminNull_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Y2: $o] :
      ( ( ( vEBT_VEBT_minNull @ X )
        = Y2 )
     => ( ( ( X
            = ( vEBT_Leaf @ $false @ $false ) )
         => ~ Y2 )
       => ( ( ? [Uv2: $o] :
                ( X
                = ( vEBT_Leaf @ $true @ Uv2 ) )
           => Y2 )
         => ( ( ? [Uu2: $o] :
                  ( X
                  = ( vEBT_Leaf @ Uu2 @ $true ) )
             => Y2 )
           => ( ( ? [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) )
               => ~ Y2 )
             => ~ ( ? [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) )
                 => Y2 ) ) ) ) ) ) ).

% VEBT_internal.minNull.elims(1)
thf(fact_1214_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_1215_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_1216_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_1217_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_1218_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_1219_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_1220_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_1221_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_1222_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z5 )
             => ( ( ord_less @ A @ Z5 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z5 @ X ) @ Y2 ) ) )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) ).

% field_le_mult_one_interval
thf(fact_1223_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1224_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1225_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1226_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1227_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_1228_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_1229_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_1230_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X: A,Z2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z2 @ Y2 ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y2 ) @ Z2 ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_1231_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ Y2 ) @ X )
           => ( ord_less_eq @ A @ Z2 @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_1232_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_1233_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1234_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1235_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A2: A,Y2: A,U2: A,V: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U2 @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U2 @ X ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1236_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_1237_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_1238_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z2: A,X: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1239_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z2: A,X: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y2 ) @ ( divide_divide @ A @ W @ Z2 ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z2 ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1240_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_1241_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_1242_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_1243_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_1244_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_1245_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_1246_vebt__maxt_Oelims,axiom,
    ! [X: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_maxt @ X )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( B6
                 => ( Y2
                    = ( some @ nat @ ( one_one @ nat ) ) ) )
                & ( ~ B6
                 => ( ( A6
                     => ( Y2
                        = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                    & ( ~ A6
                     => ( Y2
                        = ( none @ nat ) ) ) ) ) ) )
       => ( ( ? [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
           => ( Y2
             != ( none @ nat ) ) )
         => ~ ! [Mi2: nat,Ma2: nat] :
                ( ? [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
               => ( Y2
                 != ( some @ nat @ Ma2 ) ) ) ) ) ) ).

% vebt_maxt.elims
thf(fact_1247_vebt__mint_Oelims,axiom,
    ! [X: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_mint @ X )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( A6
                 => ( Y2
                    = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                & ( ~ A6
                 => ( ( B6
                     => ( Y2
                        = ( some @ nat @ ( one_one @ nat ) ) ) )
                    & ( ~ B6
                     => ( Y2
                        = ( none @ nat ) ) ) ) ) ) )
       => ( ( ? [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
           => ( Y2
             != ( none @ nat ) ) )
         => ~ ! [Mi2: nat] :
                ( ? [Ma2: nat,Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
               => ( Y2
                 != ( some @ nat @ Mi2 ) ) ) ) ) ) ).

% vebt_mint.elims
thf(fact_1248_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_1249_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_1250_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_1251_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_1252_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_diff
thf(fact_1253_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_geq
thf(fact_1254_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M3 @ N2 )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ) ).

% div_if
thf(fact_1255_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1256_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1257_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q2 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N @ Q2 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q2 ) @ N ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_1258_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% add_eq_if
thf(fact_1259_split__div,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I4 ) @ J3 ) )
               => ( P @ I4 ) ) ) ) ) ) ).

% split_div
thf(fact_1260_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% dividend_less_div_times
thf(fact_1261_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_1262_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( Y2
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y2 )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( Y2
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_1263_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A6 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B6 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_1264_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A6 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B6 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_1265_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N2 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1266_split__mod,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I4 ) @ J3 ) )
               => ( P @ J3 ) ) ) ) ) ) ).

% split_mod
thf(fact_1267_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X2: A] : ( member @ A @ X2 @ A7 )
            @ ^ [X2: A] : ( member @ A @ X2 @ B7 ) ) ) ) ).

% less_eq_set_def
thf(fact_1268_Collect__subset,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ A3 )
            & ( P @ X2 ) ) )
      @ A3 ) ).

% Collect_subset
thf(fact_1269_vebt__member_Osimps_I4_J,axiom,
    ! [V: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X ) ).

% vebt_member.simps(4)
thf(fact_1270_vebt__succ_Osimps_I4_J,axiom,
    ! [V: product_prod @ nat @ nat,Vc: list @ vEBT_VEBT,Vd: vEBT_VEBT,Ve2: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( zero_zero @ nat ) @ Vc @ Vd ) @ Ve2 )
      = ( none @ nat ) ) ).

% vebt_succ.simps(4)
thf(fact_1271_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa2 )
        = Y2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => Y2 )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
           => Y2 )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( Y2
                  = ( ~ ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 ) ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                 => ( Y2
                    = ( ~ ( ( Xa2 = Mi2 )
                          | ( Xa2 = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd2: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) )
                   => ( Y2
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_1272_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ! [Uu2: $o,Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ Uu2 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
               => ( ( Xa2 = Mi2 )
                  | ( Xa2 = Ma2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                 => ( ( Xa2 = Mi2 )
                    | ( Xa2 = Ma2 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd2: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_1273_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A2: A,Y2: A,U2: A,V: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U2 @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U2 @ X ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_1274_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_1275_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_1276_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_1277_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_1278_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U2: A,V: A,R: A,S: A] :
          ( ( ord_less_eq @ A @ U2 @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
           => ( ( ord_less_eq @ A @ R @ S )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U2 @ ( divide_divide @ A @ ( times_times @ A @ R @ ( minus_minus @ A @ V @ U2 ) ) @ S ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1279_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ).

% power2_le_imp_le
thf(fact_1280_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y2: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( X = Y2 ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_1281_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_1282_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_1283_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1284_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_1285_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_1286_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_1287_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1288_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_1289_less__2__cases,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_1290_nat__induct2,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct2
thf(fact_1291_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P5: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P5 @ ( power_power @ A @ P5 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1292_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_1293_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% le_div_geq
thf(fact_1294_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_1295_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_1296_vebt__succ_Osimps_I5_J,axiom,
    ! [V: product_prod @ nat @ nat,Vg2: list @ vEBT_VEBT,Vh2: vEBT_VEBT,Vi2: nat] :
      ( ( vEBT_vebt_succ @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg2 @ Vh2 ) @ Vi2 )
      = ( none @ nat ) ) ).

% vebt_succ.simps(5)
thf(fact_1297_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ X @ Y2 ) ) ) ) ).

% power2_less_imp_less
thf(fact_1298_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_1299_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_1300_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_1301_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_1302_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_1303_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_1304_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% zero_le_even_power'
thf(fact_1305_nat__bit__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
       => ( ! [N3: nat] :
              ( ( P @ N3 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_bit_induct
thf(fact_1306_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_1307_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_1308_verit__le__mono__div,axiom,
    ! [A3: nat,B4: nat,N: nat] :
      ( ( ord_less @ nat @ A3 @ B4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A3 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B4 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B4 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_1309_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_1310_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_1311_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_1312_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_1313_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_1314_vebt__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A6 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B6 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Summary2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
             => ~ ( ( Xa2 != Mi2 )
                 => ( ( Xa2 != Ma2 )
                   => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                      & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                       => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                          & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_1315_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X @ M ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_1316_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1317_vebt__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa2 )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( Y2
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
           => Y2 )
         => ( ( ? [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
             => Y2 )
           => ( ( ? [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
               => Y2 )
             => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                   => ( Y2
                      = ( ~ ( ( Xa2 != Mi2 )
                           => ( ( Xa2 != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_1318_vebt__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A6 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B6 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
         => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
           => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                   => ( ( Xa2 != Mi2 )
                     => ( ( Xa2 != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_1319_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ! [Mi2: nat,Ma2: nat] :
            ( ? [Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
           => ~ ( ( Xa2 = Mi2 )
                | ( Xa2 = Ma2 ) ) )
       => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
             => ~ ( ( Xa2 = Mi2 )
                  | ( Xa2 = Ma2 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd2: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_1320_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U2: A,X: A,Y2: A] :
          ( ( ( power_power @ A @ U2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( ord_less_eq @ A @ U2 @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_1321_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( ( vEBT_invar_vebt @ A1 @ A22 )
     => ( ( ? [A6: $o,B6: $o] :
              ( A1
              = ( vEBT_Leaf @ A6 @ B6 ) )
         => ( A22
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( A22 = Deg2 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X3 @ N3 ) )
                 => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                     => ( ( M4 = N3 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N3 @ M4 ) )
                         => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_12 )
                           => ~ ! [X3: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A1
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( A22 = Deg2 )
                 => ( ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X3 @ N3 ) )
                   => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                       => ( ( M4
                            = ( suc @ N3 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N3 @ M4 ) )
                           => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_12 )
                             => ~ ! [X3: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                  ( ( A1
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                 => ( ( A22 = Deg2 )
                   => ( ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X3 @ N3 ) )
                     => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                         => ( ( M4 = N3 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N3 @ M4 ) )
                             => ( ! [I: nat] :
                                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X4 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                               => ( ( ( Mi2 = Ma2 )
                                   => ! [X3: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                   => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi2 != Ma2 )
                                         => ! [I: nat] :
                                              ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                    = I )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                & ! [X3: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N3 )
                                                        = I )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X3 @ N3 ) ) )
                                                   => ( ( ord_less @ nat @ Mi2 @ X3 )
                                                      & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,M4: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                    ( ( A1
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList3 @ Summary2 ) )
                   => ( ( A22 = Deg2 )
                     => ( ! [X3: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X3 @ N3 ) )
                       => ( ( vEBT_invar_vebt @ Summary2 @ M4 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                           => ( ( M4
                                = ( suc @ N3 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N3 @ M4 ) )
                               => ( ! [I: nat] :
                                      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                     => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ X4 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                                 => ( ( ( Mi2 = Ma2 )
                                     => ! [X3: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                     => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi2 != Ma2 )
                                           => ! [I: nat] :
                                                ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                                                      = I )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                                                  & ! [X3: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X3 @ N3 )
                                                          = I )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I ) @ ( vEBT_VEBT_low @ X3 @ N3 ) ) )
                                                     => ( ( ord_less @ nat @ Mi2 @ X3 )
                                                        & ( ord_less_eq @ nat @ X3 @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_1322_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A12: vEBT_VEBT,A23: nat] :
          ( ( ? [A4: $o,B3: $o] :
                ( A12
                = ( vEBT_Leaf @ A4 @ B3 ) )
            & ( A23
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N2 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ N2 ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X4 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X2: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X2: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X2 @ N2 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X2 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList @ Summary3 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N2 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N2 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X4 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X2: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                      & ! [X2: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X2 @ N2 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X2 @ N2 ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_1323_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1324_inrange,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less_eq @ ( set @ nat ) @ ( vEBT_VEBT_set_vebt @ T2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ).

% inrange
thf(fact_1325_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_1326_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N2: nat] : ( ord_less @ nat @ N2 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_1327_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B7: set @ A] : ( ord_less_eq @ ( set @ A ) @ B7 @ A3 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_1328_finite__Collect__bounded__ex,axiom,
    ! [B: $tType,A: $tType,P: A > $o,Q: B > A > $o] :
      ( ( finite_finite @ A @ ( collect @ A @ P ) )
     => ( ( finite_finite @ B
          @ ( collect @ B
            @ ^ [X2: B] :
              ? [Y: A] :
                ( ( P @ Y )
                & ( Q @ X2 @ Y ) ) ) )
        = ( ! [Y: A] :
              ( ( P @ Y )
             => ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X2: B] : ( Q @ X2 @ Y ) ) ) ) ) ) ) ).

% finite_Collect_bounded_ex
thf(fact_1329_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z: A] :
                  ( ( power_power @ A @ Z @ N )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_1330_vebt__succ_Opelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: option @ nat] :
      ( ( ( vEBT_vebt_succ @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ B6 ) )
             => ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( ( ( B6
                     => ( Y2
                        = ( some @ nat @ ( one_one @ nat ) ) ) )
                    & ( ~ B6
                     => ( Y2
                        = ( none @ nat ) ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ B6 ) @ ( zero_zero @ nat ) ) ) ) ) )
         => ( ! [Uv2: $o,Uw2: $o] :
                ( ( X
                  = ( vEBT_Leaf @ Uv2 @ Uw2 ) )
               => ! [N3: nat] :
                    ( ( Xa2
                      = ( suc @ N3 ) )
                   => ( ( Y2
                        = ( none @ nat ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uv2 @ Uw2 ) @ ( suc @ N3 ) ) ) ) ) )
           => ( ! [Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) )
                 => ( ( Y2
                      = ( none @ nat ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Ux2 @ Uy2 @ Uz2 ) @ Xa2 ) ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vc2: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) )
                   => ( ( Y2
                        = ( none @ nat ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Vc2 @ Vd2 ) @ Xa2 ) ) ) )
               => ( ! [V3: product_prod @ nat @ nat,Vg: list @ vEBT_VEBT,Vh: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg @ Vh ) )
                     => ( ( Y2
                          = ( none @ nat ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vg @ Vh ) @ Xa2 ) ) ) )
                 => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                        ( ( X
                          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                       => ( ( ( ( ord_less @ nat @ Xa2 @ Mi2 )
                             => ( Y2
                                = ( some @ nat @ Mi2 ) ) )
                            & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                             => ( Y2
                                = ( if @ ( option @ nat ) @ ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                  @ ( if @ ( option @ nat )
                                    @ ( ( ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                       != ( none @ nat ) )
                                      & ( vEBT_VEBT_less @ ( some @ nat @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_maxt @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                                    @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( some @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_succ @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                    @ ( if @ ( option @ nat )
                                      @ ( ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                                        = ( none @ nat ) )
                                      @ ( none @ nat )
                                      @ ( vEBT_VEBT_add @ ( vEBT_VEBT_mul @ ( some @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_mint @ ( nth @ vEBT_VEBT @ TreeList3 @ ( the2 @ nat @ ( vEBT_vebt_succ @ Summary2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
                                  @ ( none @ nat ) ) ) ) )
                         => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_succ_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_succ.pelims
thf(fact_1331_finite__Diff2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( finite_finite @ A @ A3 ) ) ) ).

% finite_Diff2
thf(fact_1332_finite__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% finite_Diff
thf(fact_1333_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_1334_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_1335_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_1336_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_1337_i0__less,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( ( N
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_1338_idiff__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_1339_idiff__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = N ) ).

% idiff_0_right
thf(fact_1340_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_1341_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_1342_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_1343_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X @ X ) ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_1344_zle__diff1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% zle_diff1_eq
thf(fact_1345_div__neg__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L2 @ K )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_1346_div__pos__pos__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L2 )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_1347_mod__neg__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L2 @ K )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1348_mod__pos__pos__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L2 )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1349_zle__add1__eq__le,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z2 ) ) ).

% zle_add1_eq_le
thf(fact_1350_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_1351_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_1352_int__le__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I2 @ K )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_le_induct
thf(fact_1353_int__one__le__iff__zero__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% int_one_le_iff_zero_less
thf(fact_1354_int__less__induct,axiom,
    ! [I2: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I2 @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_less_induct
thf(fact_1355_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_1356_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) ) ).

% set_bit_greater_eq
thf(fact_1357_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_1358_verit__la__generic,axiom,
    ! [A2: int,X: int] :
      ( ( ord_less_eq @ int @ A2 @ X )
      | ( A2 = X )
      | ( ord_less_eq @ int @ X @ A2 ) ) ).

% verit_la_generic
thf(fact_1359_times__int__code_I2_J,axiom,
    ! [L2: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L2 )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_1360_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_1361_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1362_zmult__zless__mono2,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less @ int @ I2 @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I2 ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_1363_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_1364_plus__int__code_I2_J,axiom,
    ! [L2: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L2 )
      = L2 ) ).

% plus_int_code(2)
thf(fact_1365_odd__nonzero,axiom,
    ! [Z2: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_1366_odd__less__0__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) @ Z2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_1367_le__imp__0__less,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% le_imp_0_less
thf(fact_1368_zdiv__mono1,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A5 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A5 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_1369_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B5 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_1370_zdiv__eq__0__iff,axiom,
    ! [I2: int,K: int] :
      ( ( ( divide_divide @ int @ I2 @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
          & ( ord_less @ int @ I2 @ K ) )
        | ( ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I2 ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_1371_zdiv__mono1__neg,axiom,
    ! [A2: int,A5: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A5 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A5 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_1372_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B5 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_1373_div__int__pos__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L2 ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L2
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_1374_div__positive__int,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ L2 @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L2 ) ) ) ) ).

% div_positive_int
thf(fact_1375_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_1376_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_1377_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I2 @ K ) )
        = ( ord_less_eq @ int @ K @ I2 ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_1378_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_1379_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_1380_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_1381_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_1382_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_1383_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1384_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_1385_mod__pos__geq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( ord_less_eq @ int @ L2 @ K )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L2 ) @ L2 ) ) ) ) ).

% mod_pos_geq
thf(fact_1386_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_1387_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_1388_zmod__trivial__iff,axiom,
    ! [I2: int,K: int] :
      ( ( ( modulo_modulo @ int @ I2 @ K )
        = I2 )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
          & ( ord_less @ int @ I2 @ K ) )
        | ( ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I2 ) ) ) ) ).

% zmod_trivial_iff
thf(fact_1389_neg__mod__sign,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L2 ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1390_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1391_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_1392_neg__mod__bound,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L2 @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% neg_mod_bound
thf(fact_1393_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L2 ) @ L2 ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1394_not__iless0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less @ extended_enat @ N @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_1395_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ) ) ).

% enat_0_less_mult_iff
thf(fact_1396_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_1397_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_1398_i0__lb,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ).

% i0_lb
thf(fact_1399_ex__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X2 ) ) ) ) ).

% ex_nat_less
thf(fact_1400_all__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X2 ) ) ) ) ).

% all_nat_less
thf(fact_1401_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M7 )
     => ? [N3: nat] :
        ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X3 ) @ N3 ) ) ) ).

% finite_maxlen
thf(fact_1402_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( ord_less @ int @ B2 @ R3 )
           => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_1403_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R3: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less @ int @ R @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_1404_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R3 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R3 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q2 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_1405_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q2: int,R: int,B5: int,Q5: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R3 ) )
       => ( ( ord_less @ int @ R3 @ B5 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q2 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_1406_q__pos__lemma,axiom,
    ! [B5: int,Q5: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q5 ) @ R3 ) )
     => ( ( ord_less @ int @ R3 @ B5 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_1407_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_1408_div__pos__geq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( ord_less_eq @ int @ L2 @ K )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L2 ) @ L2 ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1409_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q3: int] :
          ( M
          = ( times_times @ int @ D2 @ Q3 ) ) ) ).

% zmod_eq_0D
thf(fact_1410_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1411_mod__pos__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L2 ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L2 )
          = ( plus_plus @ int @ K @ L2 ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1412_not__exp__less__eq__0__int,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_1413_realpow__pos__nth2,axiom,
    ! [A2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
          & ( ( power_power @ real @ R4 @ ( suc @ N ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_1414_real__arch__pow__inv,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ? [N3: nat] : ( ord_less @ real @ ( power_power @ real @ X @ N3 ) @ Y2 ) ) ) ).

% real_arch_pow_inv
thf(fact_1415_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(3)
thf(fact_1416_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_1417_zless__imp__add1__zle,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ Z2 )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 ) ) ).

% zless_imp_add1_zle
thf(fact_1418_zless__add1__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z2 @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z2 )
        | ( W = Z2 ) ) ) ).

% zless_add1_eq
thf(fact_1419_int__gr__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I2 )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I3: int] :
              ( ( ord_less @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_gr_induct
thf(fact_1420_int__ge__induct,axiom,
    ! [K: int,I2: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I2 )
     => ( ( P @ K )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ K @ I3 )
             => ( ( P @ I3 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_ge_induct
thf(fact_1421_add1__zle__eq,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z2 )
      = ( ord_less @ int @ W @ Z2 ) ) ).

% add1_zle_eq
thf(fact_1422_int__induct,axiom,
    ! [P: int > $o,K: int,I2: int] :
      ( ( P @ K )
     => ( ! [I3: int] :
            ( ( ord_less_eq @ int @ K @ I3 )
           => ( ( P @ I3 )
             => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) ) ) )
       => ( ! [I3: int] :
              ( ( ord_less_eq @ int @ I3 @ K )
             => ( ( P @ I3 )
               => ( P @ ( minus_minus @ int @ I3 @ ( one_one @ int ) ) ) ) )
         => ( P @ I2 ) ) ) ) ).

% int_induct
thf(fact_1423_split__zdiv,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) ) ) ) ).

% split_zdiv
thf(fact_1424_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_neg_eq
thf(fact_1425_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q2 ) ) ) ) ).

% int_div_pos_eq
thf(fact_1426_split__zmod,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) ) ) ) ).

% split_zmod
thf(fact_1427_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ R @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1428_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q2 ) @ R ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
       => ( ( ord_less @ int @ R @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1429_verit__le__mono__div__int,axiom,
    ! [A3: int,B4: int,N: int] :
      ( ( ord_less @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B4 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B4 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1430_realpow__pos__nth,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ( ( power_power @ real @ R4 @ N )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_1431_realpow__pos__nth__unique,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X5: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X5 )
            & ( ( power_power @ real @ X5 @ N )
              = A2 )
            & ! [Y3: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y3 )
                  & ( ( power_power @ real @ Y3 @ N )
                    = A2 ) )
               => ( Y3 = X5 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_1432_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1433_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1434_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1435_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1436_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ( ord_less_eq @ A @ X5 @ A2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ Xa @ X5 )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_1437_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ( ord_less_eq @ A @ A2 @ X5 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ X5 @ Xa )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_1438_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_1439_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_1440_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1441_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1442_rev__finite__subset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% rev_finite_subset
thf(fact_1443_infinite__super,axiom,
    ! [A: $tType,S2: set @ A,T4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T4 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ T4 ) ) ) ).

% infinite_super
thf(fact_1444_finite__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( finite_finite @ A @ B4 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% finite_subset
thf(fact_1445_Diff__infinite__finite,axiom,
    ! [A: $tType,T4: set @ A,S2: set @ A] :
      ( ( finite_finite @ A @ T4 )
     => ( ~ ( finite_finite @ A @ S2 )
       => ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T4 ) ) ) ) ).

% Diff_infinite_finite
thf(fact_1446_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_1447_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(1)
thf(fact_1448_finite__image__set,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B] :
      ( ( finite_finite @ A @ ( collect @ A @ P ) )
     => ( finite_finite @ B
        @ ( collect @ B
          @ ^ [Uu3: B] :
            ? [X2: A] :
              ( ( Uu3
                = ( F2 @ X2 ) )
              & ( P @ X2 ) ) ) ) ) ).

% finite_image_set
thf(fact_1449_finite__image__set2,axiom,
    ! [A: $tType,B: $tType,C: $tType,P: A > $o,Q: B > $o,F2: A > B > C] :
      ( ( finite_finite @ A @ ( collect @ A @ P ) )
     => ( ( finite_finite @ B @ ( collect @ B @ Q ) )
       => ( finite_finite @ C
          @ ( collect @ C
            @ ^ [Uu3: C] :
              ? [X2: A,Y: B] :
                ( ( Uu3
                  = ( F2 @ X2 @ Y ) )
                & ( P @ X2 )
                & ( Q @ Y ) ) ) ) ) ) ).

% finite_image_set2
thf(fact_1450_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ X5 @ Xa )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_1451_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ Xa @ X5 )
                     => ( X5 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_1452_vebt__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( Y2
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa2 ) ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ( ~ Y2
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa2 ) ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ( ~ Y2
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( Y2
                          = ( ( Xa2 != Mi2 )
                           => ( ( Xa2 != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_1453_vebt__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A6 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B6 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa2 ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ Xa2 ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) )
                       => ( ( Xa2 != Mi2 )
                         => ( ( Xa2 != Ma2 )
                           => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                              & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                               => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                  & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_1454_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( Y2
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa2 ) ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
                 => ( ( Y2
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa2 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_1455_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa2 ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_1456_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A6 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B6 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa2 ) ) )
           => ~ ! [Uy2: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy2 @ ( suc @ V3 ) @ TreeList3 @ S3 ) @ Xa2 ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_1457_vebt__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A6 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B6 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) )
                 => ~ ( ( Xa2 != Mi2 )
                     => ( ( Xa2 != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_1458_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ~ Y2
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa2 ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( Y2
                      = ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                   => ( ( Y2
                        = ( ( Xa2 = Mi2 )
                          | ( Xa2 = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) )
                     => ( ( Y2
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_1459_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Xa2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa2 ) )
                   => ( ( Xa2 = Mi2 )
                      | ( Xa2 = Ma2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) )
                     => ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) @ Xa2 ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_1460_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_1461_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_1462_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_1463_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_1464_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1465_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_1466_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Mi2: nat,Ma2: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ Xa2 ) )
               => ~ ( ( Xa2 = Mi2 )
                    | ( Xa2 = Ma2 ) ) ) )
         => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList3: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList3 @ Vc2 ) @ Xa2 ) )
                 => ~ ( ( Xa2 = Mi2 )
                      | ( Xa2 = Ma2 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V3: nat,TreeList3: list @ vEBT_VEBT,Vd2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList3 @ Vd2 ) @ Xa2 ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_1467_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_1468_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_1469_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_1470_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_1471_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_1472_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B7: A > B,X2: A] : ( minus_minus @ B @ ( A7 @ X2 ) @ ( B7 @ X2 ) ) ) ) ) ).

% minus_apply
thf(fact_1473_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_1474_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z: complex] :
              ( ( power_power @ complex @ Z @ N )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_1475_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U2: A] :
          ( ( member @ A @ I2 @ ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) )
          = ( ( ord_less_eq @ A @ L2 @ I2 )
            & ( ord_less_eq @ A @ I2 @ U2 ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_1476_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,H2: A,L3: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L2 @ H2 )
            = ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) )
          = ( ( ( L2 = L3 )
              & ( H2 = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L2 @ H2 )
              & ~ ( ord_less_eq @ A @ L3 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_1477_bounded__Max__nat,axiom,
    ! [P: nat > $o,X: nat,M7: nat] :
      ( ( P @ X )
     => ( ! [X5: nat] :
            ( ( P @ X5 )
           => ( ord_less_eq @ nat @ X5 @ M7 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X3: nat] :
                    ( ( P @ X3 )
                   => ( ord_less_eq @ nat @ X3 @ M4 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1478_fold__atLeastAtMost__nat_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) )] :
      ~ ! [F3: nat > A > A,A6: nat,B6: nat,Acc: A] :
          ( X
         != ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F3 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A6 @ ( product_Pair @ nat @ A @ B6 @ Acc ) ) ) ) ).

% fold_atLeastAtMost_nat.cases
thf(fact_1479_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X2: nat] :
          ( ( member @ nat @ X2 @ N6 )
         => ( ord_less @ nat @ X2 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_1480_bounded__nat__set__is__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ! [X5: nat] :
          ( ( member @ nat @ X5 @ N4 )
         => ( ord_less @ nat @ X5 @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% bounded_nat_set_is_finite
thf(fact_1481_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X2: nat] :
          ( ( member @ nat @ X2 @ N6 )
         => ( ord_less_eq @ nat @ X2 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_1482_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I2: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K2: nat] :
            ( ( P @ K2 )
            & ( ord_less @ nat @ K2 @ I2 ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_1483_finite__less__ub,axiom,
    ! [F2: nat > nat,U2: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( F2 @ N3 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N2: nat] : ( ord_less_eq @ nat @ ( F2 @ N2 ) @ U2 ) ) ) ) ).

% finite_less_ub
thf(fact_1484_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B7: A > B,X2: A] : ( minus_minus @ B @ ( A7 @ X2 ) @ ( B7 @ X2 ) ) ) ) ) ).

% fun_diff_def
thf(fact_1485_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_1486_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_1487_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_1488_cpmi,axiom,
    ! [D5: int,P: int > $o,P6: int > $o,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less @ int @ X5 @ Z3 )
           => ( ( P @ X5 )
              = ( P6 @ X5 ) ) )
       => ( ! [X5: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ B4 )
                     => ( X5
                       != ( plus_plus @ int @ Xb @ Xa ) ) ) )
             => ( ( P @ X5 )
               => ( P @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
         => ( ! [X5: int,K3: int] :
                ( ( P6 @ X5 )
                = ( P6 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D5 ) ) ) )
           => ( ( ? [X4: int] : ( P @ X4 ) )
              = ( ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P6 @ X2 ) )
                | ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y: int] :
                        ( ( member @ int @ Y @ B4 )
                        & ( P @ ( plus_plus @ int @ Y @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_1489_cppi,axiom,
    ! [D5: int,P: int > $o,P6: int > $o,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z3: int] :
          ! [X5: int] :
            ( ( ord_less @ int @ Z3 @ X5 )
           => ( ( P @ X5 )
              = ( P6 @ X5 ) ) )
       => ( ! [X5: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb: int] :
                      ( ( member @ int @ Xb @ A3 )
                     => ( X5
                       != ( minus_minus @ int @ Xb @ Xa ) ) ) )
             => ( ( P @ X5 )
               => ( P @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
         => ( ! [X5: int,K3: int] :
                ( ( P6 @ X5 )
                = ( P6 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D5 ) ) ) )
           => ( ( ? [X4: int] : ( P @ X4 ) )
              = ( ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P6 @ X2 ) )
                | ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y: int] :
                        ( ( member @ int @ Y @ A3 )
                        & ( P @ ( minus_minus @ int @ Y @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_1490_aset_I8_J,axiom,
    ! [D5: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X3 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ).

% aset(8)
thf(fact_1491_aset_I6_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X3 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_1492_bset_I8_J,axiom,
    ! [D5: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B4 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X3 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ).

% bset(8)
thf(fact_1493_bset_I6_J,axiom,
    ! [D5: int,B4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X3 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_1494_aset_I7_J,axiom,
    ! [D5: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X3 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ).

% aset(7)
thf(fact_1495_aset_I5_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X3 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_1496_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z5: C] :
        ! [X3: C] :
          ( ( ord_less @ C @ X3 @ Z5 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_1497_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z5 )
         => ~ ( ord_less @ A @ T2 @ X3 ) ) ) ).

% minf(7)
thf(fact_1498_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z5 )
         => ( ord_less @ A @ X3 @ T2 ) ) ) ).

% minf(5)
thf(fact_1499_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z5 )
         => ( X3 != T2 ) ) ) ).

% minf(4)
thf(fact_1500_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z5 )
         => ( X3 != T2 ) ) ) ).

% minf(3)
thf(fact_1501_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ X5 @ Z3 )
             => ( ( P @ X5 )
                = ( P6 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z5 )
               => ( ( ( P @ X3 )
                    | ( Q @ X3 ) )
                  = ( ( P6 @ X3 )
                    | ( Q6 @ X3 ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_1502_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ X5 @ Z3 )
             => ( ( P @ X5 )
                = ( P6 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z5 )
               => ( ( ( P @ X3 )
                    & ( Q @ X3 ) )
                  = ( ( P6 @ X3 )
                    & ( Q6 @ X3 ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_1503_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z5: C] :
        ! [X3: C] :
          ( ( ord_less @ C @ Z5 @ X3 )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_1504_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z5 @ X3 )
         => ( ord_less @ A @ T2 @ X3 ) ) ) ).

% pinf(7)
thf(fact_1505_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z5 @ X3 )
         => ~ ( ord_less @ A @ X3 @ T2 ) ) ) ).

% pinf(5)
thf(fact_1506_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z5 @ X3 )
         => ( X3 != T2 ) ) ) ).

% pinf(4)
thf(fact_1507_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z5 @ X3 )
         => ( X3 != T2 ) ) ) ).

% pinf(3)
thf(fact_1508_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ Z3 @ X5 )
             => ( ( P @ X5 )
                = ( P6 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z5 @ X3 )
               => ( ( ( P @ X3 )
                    | ( Q @ X3 ) )
                  = ( ( P6 @ X3 )
                    | ( Q6 @ X3 ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_1509_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P6: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z3: A] :
            ! [X5: A] :
              ( ( ord_less @ A @ Z3 @ X5 )
             => ( ( P @ X5 )
                = ( P6 @ X5 ) ) )
         => ( ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( Q @ X5 )
                  = ( Q6 @ X5 ) ) )
           => ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z5 @ X3 )
               => ( ( ( P @ X3 )
                    & ( Q @ X3 ) )
                  = ( ( P6 @ X3 )
                    & ( Q6 @ X3 ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_1510_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z5 )
         => ~ ( ord_less_eq @ A @ T2 @ X3 ) ) ) ).

% minf(8)
thf(fact_1511_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ X3 @ Z5 )
         => ( ord_less_eq @ A @ X3 @ T2 ) ) ) ).

% minf(6)
thf(fact_1512_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z5 @ X3 )
         => ( ord_less_eq @ A @ T2 @ X3 ) ) ) ).

% pinf(8)
thf(fact_1513_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z5: A] :
        ! [X3: A] :
          ( ( ord_less @ A @ Z5 @ X3 )
         => ~ ( ord_less_eq @ A @ X3 @ T2 ) ) ) ).

% pinf(6)
thf(fact_1514_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X5: A,K3: A] :
              ( ( P @ X5 )
              = ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
         => ( ! [X5: A,K3: A] :
                ( ( Q @ X5 )
                = ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
           => ! [X3: A,K4: A] :
                ( ( ( P @ X3 )
                  | ( Q @ X3 ) )
                = ( ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) )
                  | ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1515_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X5: A,K3: A] :
              ( ( P @ X5 )
              = ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
         => ( ! [X5: A,K3: A] :
                ( ( Q @ X5 )
                = ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K3 @ D5 ) ) ) )
           => ! [X3: A,K4: A] :
                ( ( ( P @ X3 )
                  & ( Q @ X3 ) )
                = ( ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) )
                  & ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1516_imp__le__cong,axiom,
    ! [X: int,X7: int,P: $o,P6: $o] :
      ( ( X = X7 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
         => ( P = P6 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
           => P6 ) ) ) ) ).

% imp_le_cong
thf(fact_1517_conj__le__cong,axiom,
    ! [X: int,X7: int,P: $o,P6: $o] :
      ( ( X = X7 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
         => ( P = P6 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
            & P6 ) ) ) ) ).

% conj_le_cong
thf(fact_1518_bset_I1_J,axiom,
    ! [D5: int,B4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B4 )
                 => ( X5
                   != ( plus_plus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                & ( Q @ X3 ) )
             => ( ( P @ ( minus_minus @ int @ X3 @ D5 ) )
                & ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_1519_bset_I2_J,axiom,
    ! [D5: int,B4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B4 )
                 => ( X5
                   != ( plus_plus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B4 )
                   => ( X5
                     != ( plus_plus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                | ( Q @ X3 ) )
             => ( ( P @ ( minus_minus @ int @ X3 @ D5 ) )
                | ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_1520_aset_I1_J,axiom,
    ! [D5: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                & ( Q @ X3 ) )
             => ( ( P @ ( plus_plus @ int @ X3 @ D5 ) )
                & ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_1521_aset_I2_J,axiom,
    ! [D5: int,A3: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X5: int] :
          ( ! [Xa: int] :
              ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X5
                   != ( minus_minus @ int @ Xb @ Xa ) ) ) )
         => ( ( P @ X5 )
           => ( P @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
     => ( ! [X5: int] :
            ( ! [Xa: int] :
                ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X5
                     != ( minus_minus @ int @ Xb @ Xa ) ) ) )
           => ( ( Q @ X5 )
             => ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X3 )
                | ( Q @ X3 ) )
             => ( ( P @ ( plus_plus @ int @ X3 @ D5 ) )
                | ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_1522_plusinfinity,axiom,
    ! [D2: int,P6: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int,K3: int] :
            ( ( P6 @ X5 )
            = ( P6 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z3: int] :
            ! [X5: int] :
              ( ( ord_less @ int @ Z3 @ X5 )
             => ( ( P @ X5 )
                = ( P6 @ X5 ) ) )
         => ( ? [X_12: int] : ( P6 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% plusinfinity
thf(fact_1523_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int,K3: int] :
            ( ( P1 @ X5 )
            = ( P1 @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ? [Z3: int] :
            ! [X5: int] :
              ( ( ord_less @ int @ X5 @ Z3 )
             => ( ( P @ X5 )
                = ( P1 @ X5 ) ) )
         => ( ? [X_12: int] : ( P1 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% minusinfinity
thf(fact_1524_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int] :
            ( ( P @ X5 )
           => ( P @ ( plus_plus @ int @ X5 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X3: int] :
              ( ( P @ X3 )
             => ( P @ ( plus_plus @ int @ X3 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_1525_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int] :
            ( ( P @ X5 )
           => ( P @ ( minus_minus @ int @ X5 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X3: int] :
              ( ( P @ X3 )
             => ( P @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1526_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X5: int,K3: int] :
            ( ( P @ X5 )
            = ( P @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K3 @ D2 ) ) ) )
       => ( ( ? [X4: int] : ( P @ X4 ) )
          = ( ? [X2: int] :
                ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X2 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_1527_bset_I3_J,axiom,
    ! [D5: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B4 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X3 = T2 )
             => ( ( minus_minus @ int @ X3 @ D5 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_1528_bset_I4_J,axiom,
    ! [D5: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B4 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X3 != T2 )
             => ( ( minus_minus @ int @ X3 @ D5 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_1529_bset_I5_J,axiom,
    ! [D5: int,B4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X3 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_1530_bset_I7_J,axiom,
    ! [D5: int,T2: int,B4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B4 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B4 )
                   => ( X3
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X3 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X3 @ D5 ) ) ) ) ) ) ).

% bset(7)
thf(fact_1531_aset_I3_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X3 = T2 )
             => ( ( plus_plus @ int @ X3 @ D5 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_1532_aset_I4_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X3: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A3 )
                   => ( X3
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X3 != T2 )
             => ( ( plus_plus @ int @ X3 @ D5 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_1533_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A6: real,B6: real,C4: real] :
            ( ( P @ A6 @ B6 )
           => ( ( P @ B6 @ C4 )
             => ( ( ord_less_eq @ real @ A6 @ B6 )
               => ( ( ord_less_eq @ real @ B6 @ C4 )
                 => ( P @ A6 @ C4 ) ) ) ) )
       => ( ! [X5: real] :
              ( ( ord_less_eq @ real @ A2 @ X5 )
             => ( ( ord_less_eq @ real @ X5 @ B2 )
               => ? [D6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                    & ! [A6: real,B6: real] :
                        ( ( ( ord_less_eq @ real @ A6 @ X5 )
                          & ( ord_less_eq @ real @ X5 @ B6 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B6 @ A6 ) @ D6 ) )
                       => ( P @ A6 @ B6 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1534_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H2: nat > A,G: A,N: nat] :
      ( ! [N3: nat] :
          ( ( F2 @ ( suc @ N3 ) )
          = ( H2 @ N3 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = G ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = ( H2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1535_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y2 @ Z2 ) )
            = ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_1536_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z2 @ X ) @ ( times_times @ A @ Z2 @ Y2 ) )
            = ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_1537_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: A,R: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q2 @ R ) )
          = ( R
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_1538_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1539_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,X: B > A,Y2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I5 )
                  & ( ( X @ I4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I5 )
                    & ( ( Y2 @ I4 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I5 )
                    & ( ( times_times @ A @ ( X @ I4 ) @ ( Y2 @ I4 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_1540_unique__quotient,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R3: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R3 ) )
       => ( Q2 = Q5 ) ) ) ).

% unique_quotient
thf(fact_1541_unique__remainder,axiom,
    ! [A2: int,B2: int,Q2: int,R: int,Q5: int,R3: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q5 @ R3 ) )
       => ( R = R3 ) ) ) ).

% unique_remainder
thf(fact_1542_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_1543_div__int__unique,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( divide_divide @ int @ K @ L2 )
        = Q2 ) ) ).

% div_int_unique
thf(fact_1544_mod__int__unique,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
        = R ) ) ).

% mod_int_unique
thf(fact_1545_eucl__rel__int__dividesI,axiom,
    ! [L2: int,K: int,Q2: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q2 @ L2 ) )
       => ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_1546_eucl__rel__int,axiom,
    ! [K: int,L2: int] : ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L2 ) @ ( modulo_modulo @ int @ K @ L2 ) ) ) ).

% eucl_rel_int
thf(fact_1547_eucl__rel__int__iff,axiom,
    ! [K: int,L2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L2 @ Q2 ) @ R ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R )
            & ( ord_less @ int @ R @ L2 ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L2 )
         => ( ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L2 @ R )
                & ( ord_less_eq @ int @ R @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
             => ( Q2
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_1548_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z2 )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z2 ) @ ( times_times @ A @ Y2 @ Z2 ) )
            = ( ord_less @ A @ X @ Y2 ) ) ) ) ).

% mult_less_iff1
thf(fact_1549_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q2: int,R: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q2 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1550_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,X: B > A,Y2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I5 )
                  & ( ( X @ I4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I5 )
                    & ( ( Y2 @ I4 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I5 )
                    & ( ( plus_plus @ A @ ( X @ I4 ) @ ( Y2 @ I4 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_1551_prod__induct7,axiom,
    ! [G2: $tType,F: $tType,E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) )] :
      ( ! [A6: A,B6: B,C4: C,D4: D,E2: E3,F3: F,G3: G2] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) @ D4 @ ( product_Pair @ E3 @ ( product_prod @ F @ G2 ) @ E2 @ ( product_Pair @ F @ G2 @ F3 @ G3 ) ) ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct7
thf(fact_1552_prod__induct6,axiom,
    ! [F: $tType,E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) )] :
      ( ! [A6: A,B6: B,C4: C,D4: D,E2: E3,F3: F] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E3 @ F ) @ D4 @ ( product_Pair @ E3 @ F @ E2 @ F3 ) ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct6
thf(fact_1553_prod__induct5,axiom,
    ! [E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) )] :
      ( ! [A6: A,B6: B,C4: C,D4: D,E2: E3] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E3 ) @ C4 @ ( product_Pair @ D @ E3 @ D4 @ E2 ) ) ) ) )
     => ( P @ X ) ) ).

% prod_induct5
thf(fact_1554_prod__induct4,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ( ! [A6: A,B6: B,C4: C,D4: D] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D4 ) ) ) )
     => ( P @ X ) ) ).

% prod_induct4
thf(fact_1555_prod__cases7,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,F: $tType,G2: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) )] :
      ~ ! [A6: A,B6: B,C4: C,D4: D,E2: E3,F3: F,G3: G2] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) @ D4 @ ( product_Pair @ E3 @ ( product_prod @ F @ G2 ) @ E2 @ ( product_Pair @ F @ G2 @ F3 @ G3 ) ) ) ) ) ) ) ).

% prod_cases7
thf(fact_1556_prod__cases6,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,F: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) )] :
      ~ ! [A6: A,B6: B,C4: C,D4: D,E2: E3,F3: F] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E3 @ F ) @ D4 @ ( product_Pair @ E3 @ F @ E2 @ F3 ) ) ) ) ) ) ).

% prod_cases6
thf(fact_1557_prod__cases5,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) )] :
      ~ ! [A6: A,B6: B,C4: C,D4: D,E2: E3] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E3 ) @ C4 @ ( product_Pair @ D @ E3 @ D4 @ E2 ) ) ) ) ) ).

% prod_cases5
thf(fact_1558_prod__cases4,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ~ ! [A6: A,B6: B,C4: C,D4: D] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D4 ) ) ) ) ).

% prod_cases4
thf(fact_1559_prod_Oinject,axiom,
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) ).

% prod.inject
thf(fact_1560_old_Oprod_Oinject,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
      = ( ( A2 = A5 )
        & ( B2 = B5 ) ) ) ).

% old.prod.inject
thf(fact_1561_old_Oprod_Oexhaust,axiom,
    ! [A: $tType,B: $tType,Y2: product_prod @ A @ B] :
      ~ ! [A6: A,B6: B] :
          ( Y2
         != ( product_Pair @ A @ B @ A6 @ B6 ) ) ).

% old.prod.exhaust
thf(fact_1562_surj__pair,axiom,
    ! [A: $tType,B: $tType,P2: product_prod @ A @ B] :
    ? [X5: A,Y4: B] :
      ( P2
      = ( product_Pair @ A @ B @ X5 @ Y4 ) ) ).

% surj_pair
thf(fact_1563_prod__cases,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o,P2: product_prod @ A @ B] :
      ( ! [A6: A,B6: B] : ( P @ ( product_Pair @ A @ B @ A6 @ B6 ) )
     => ( P @ P2 ) ) ).

% prod_cases
thf(fact_1564_Pair__inject,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ~ ( ( A2 = A5 )
         => ( B2 != B5 ) ) ) ).

% Pair_inject
thf(fact_1565_prod__cases3,axiom,
    ! [A: $tType,B: $tType,C: $tType,Y2: product_prod @ A @ ( product_prod @ B @ C )] :
      ~ ! [A6: A,B6: B,C4: C] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) ) ).

% prod_cases3
thf(fact_1566_prod__induct3,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o,X: product_prod @ A @ ( product_prod @ B @ C )] :
      ( ! [A6: A,B6: B,C4: C] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) )
     => ( P @ X ) ) ).

% prod_induct3
thf(fact_1567_old_Oprod_Orec,axiom,
    ! [A: $tType,T: $tType,B: $tType,F1: A > B > T,A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) ).

% old.prod.rec
thf(fact_1568_insert__simp__norm,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ Mi @ X )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ ( ord_max @ nat @ X @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_norm
thf(fact_1569_insert__simp__excp,axiom,
    ! [Mi: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,X: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ X @ Mi )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ ( ord_max @ nat @ Mi @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_excp
thf(fact_1570_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( Q @ X5 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_1571_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [M4: nat] : ( P @ M4 @ ( zero_zero @ nat ) )
     => ( ! [M4: nat,N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ( P @ N3 @ ( modulo_modulo @ nat @ M4 @ N3 ) )
             => ( P @ M4 @ N3 ) ) )
       => ( P @ M @ N ) ) ) ).

% gcd_nat_induct
thf(fact_1572_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( bit_concat_bit @ ( suc @ N ) @ K @ L2 )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L2 ) ) ) ) ).

% concat_bit_Suc
thf(fact_1573_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_1574_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_1575_list__update__overwrite,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,X: A,Y2: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ I2 @ Y2 )
      = ( list_update @ A @ Xs2 @ I2 @ Y2 ) ) ).

% list_update_overwrite
thf(fact_1576_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_1577_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_1578_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_1579_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y2 ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            & ( ord_less @ A @ Y2 @ Z2 ) ) ) ) ).

% max_less_iff_conj
thf(fact_1580_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_1581_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_1582_length__list__update,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs2 @ I2 @ X ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_list_update
thf(fact_1583_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_Suc_Suc
thf(fact_1584_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_1585_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_1586_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_1587_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_1588_max__0L,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% max_0L
thf(fact_1589_max__0R,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ N @ ( zero_zero @ nat ) )
      = N ) ).

% max_0R
thf(fact_1590_list__update__id,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat] :
      ( ( list_update @ A @ Xs2 @ I2 @ ( nth @ A @ Xs2 @ I2 ) )
      = Xs2 ) ).

% list_update_id
thf(fact_1591_nth__list__update__neq,axiom,
    ! [A: $tType,I2: nat,J: nat,Xs2: list @ A,X: A] :
      ( ( I2 != J )
     => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ J )
        = ( nth @ A @ Xs2 @ J ) ) ) ).

% nth_list_update_neq
thf(fact_1592_concat__bit__0,axiom,
    ! [K: int,L2: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L2 )
      = L2 ) ).

% concat_bit_0
thf(fact_1593_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U2 ) ) ) ) ) ).

% max_number_of(1)
thf(fact_1594_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(3)
thf(fact_1595_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(4)
thf(fact_1596_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_1597_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_1598_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_1599_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_1600_list__update__beyond,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I2 )
     => ( ( list_update @ A @ Xs2 @ I2 @ X )
        = Xs2 ) ) ).

% list_update_beyond
thf(fact_1601_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N @ K @ L2 ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1602_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1603_nth__list__update__eq,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ I2 )
        = X ) ) ).

% nth_list_update_eq
thf(fact_1604_set__swap,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs2 @ I2 @ ( nth @ A @ Xs2 @ J ) ) @ J @ ( nth @ A @ Xs2 @ I2 ) ) )
          = ( set2 @ A @ Xs2 ) ) ) ) ).

% set_swap
thf(fact_1605_list__update__swap,axiom,
    ! [A: $tType,I2: nat,I6: nat,Xs2: list @ A,X: A,X7: A] :
      ( ( I2 != I6 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ I6 @ X7 )
        = ( list_update @ A @ ( list_update @ A @ Xs2 @ I6 @ X7 ) @ I2 @ X ) ) ) ).

% list_update_swap
thf(fact_1606_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_max @ A @ X @ Y2 )
            = Y2 ) ) ) ).

% max_absorb2
thf(fact_1607_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( ord_max @ A @ X @ Y2 )
            = X ) ) ) ).

% max_absorb1
thf(fact_1608_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ B3 @ A4 ) ) ) ) ).

% max_def
thf(fact_1609_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_1610_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_1611_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% max.absorb_iff2
thf(fact_1612_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_max @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% max.absorb_iff1
thf(fact_1613_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less_eq @ A @ Z2 @ ( ord_max @ A @ X @ Y2 ) )
          = ( ( ord_less_eq @ A @ Z2 @ X )
            | ( ord_less_eq @ A @ Z2 @ Y2 ) ) ) ) ).

% le_max_iff_disj
thf(fact_1614_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_1615_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_1616_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( ord_max @ A @ A4 @ B3 ) ) ) ) ) ).

% max.order_iff
thf(fact_1617_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_1618_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_1619_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_1620_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_1621_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_1622_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_max @ A @ X @ Y2 ) )
          = ( ( ord_less @ A @ Z2 @ X )
            | ( ord_less @ A @ Z2 @ Y2 ) ) ) ) ).

% less_max_iff_disj
thf(fact_1623_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_1624_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( A4
                = ( ord_max @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_1625_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_1626_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_1627_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y2 @ Z2 ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% max_add_distrib_right
thf(fact_1628_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y2 ) @ Z2 )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y2 @ Z2 ) ) ) ) ).

% max_add_distrib_left
thf(fact_1629_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y2 ) @ Z2 )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y2 @ Z2 ) ) ) ) ).

% max_diff_distrib_left
thf(fact_1630_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N ) @ ( plus_plus @ nat @ M @ Q2 ) ) ) ).

% nat_add_max_right
thf(fact_1631_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q2 ) @ ( plus_plus @ nat @ N @ Q2 ) ) ) ).

% nat_add_max_left
thf(fact_1632_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N @ Q2 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_max_right
thf(fact_1633_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N ) @ Q2 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_max_left
thf(fact_1634_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ B3 @ A4 ) ) ) ) ).

% max_def_raw
thf(fact_1635_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L2: int,R: int] :
      ( ( bit_concat_bit @ N @ K @ ( bit_concat_bit @ M @ L2 @ R ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N ) @ ( bit_concat_bit @ N @ K @ L2 ) @ R ) ) ).

% concat_bit_assoc
thf(fact_1636_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N @ M ) @ M )
      = ( ord_max @ nat @ N @ M ) ) ).

% nat_minus_add_max
thf(fact_1637_set__update__subsetI,axiom,
    ! [A: $tType,Xs2: list @ A,A3: set @ A,X: A,I2: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) ) @ A3 ) ) ) ).

% set_update_subsetI
thf(fact_1638_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( member @ A @ X @ ( set2 @ A @ ( list_update @ A @ Xs2 @ N @ X ) ) ) ) ).

% set_update_memI
thf(fact_1639_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) ).

% order_antisym_conv
thf(fact_1640_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X ) ) ) ).

% linorder_le_cases
thf(fact_1641_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X5: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_1642_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X5: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y4 )
                 => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_1643_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less_eq @ A @ Y2 @ X ) ) ) ).

% linorder_linear
thf(fact_1644_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A] :
          ( ( X = Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) ).

% order_eq_refl
thf(fact_1645_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y4 )
                 => ( ord_less_eq @ C @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_1646_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X5: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y4 )
                 => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_1647_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_1648_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_1649_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_1650_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_1651_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_1652_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A6: A,B6: A] :
              ( ( ord_less_eq @ A @ A6 @ B6 )
             => ( P @ A6 @ B6 ) )
         => ( ! [A6: A,B6: A] :
                ( ( P @ B6 @ A6 )
               => ( P @ A6 @ B6 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_1653_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z2 )
           => ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% order_trans
thf(fact_1654_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_1655_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ X )
           => ( X = Y2 ) ) ) ) ).

% order_antisym
thf(fact_1656_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_1657_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_1658_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
              & ( ord_less_eq @ A @ Y @ X2 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_1659_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y2 )
           => ~ ( ord_less_eq @ A @ Y2 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y2 @ X )
             => ~ ( ord_less_eq @ A @ X @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y2 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y2 )
                 => ~ ( ord_less_eq @ A @ Y2 @ X ) )
               => ( ( ( ord_less_eq @ A @ Y2 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_1660_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_1661_list__update__same__conv,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ( list_update @ A @ Xs2 @ I2 @ X )
          = Xs2 )
        = ( ( nth @ A @ Xs2 @ I2 )
          = X ) ) ) ).

% list_update_same_conv
thf(fact_1662_nth__list__update,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,J: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ( I2 = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ J )
            = X ) )
        & ( ( I2 != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ J )
            = ( nth @ A @ Xs2 @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_1663_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) ).

% order_less_imp_not_less
thf(fact_1664_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( Y2 != X ) ) ) ).

% order_less_imp_not_eq2
thf(fact_1665_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( X != Y2 ) ) ) ).

% order_less_imp_not_eq
thf(fact_1666_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
          | ( X = Y2 )
          | ( ord_less @ A @ Y2 @ X ) ) ) ).

% linorder_less_linear
thf(fact_1667_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A,P: $o] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ X )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_1668_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) ).

% order_less_not_sym
thf(fact_1669_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y4: A] :
                  ( ( ord_less @ A @ X5 @ Y4 )
                 => ( ord_less @ C @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_1670_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X5: B,Y4: B] :
                  ( ( ord_less @ B @ X5 @ Y4 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_1671_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) ).

% order_less_irrefl
thf(fact_1672_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X5: A,Y4: A] :
                  ( ( ord_less @ A @ X5 @ Y4 )
                 => ( ord_less @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_1673_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X5: B,Y4: B] :
                  ( ( ord_less @ B @ X5 @ Y4 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_1674_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_trans
thf(fact_1675_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_1676_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ( X != Y2 ) )
          = ( ( ord_less @ A @ X @ Y2 )
            | ( ord_less @ A @ Y2 @ X ) ) ) ) ).

% linorder_neq_iff
thf(fact_1677_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) ).

% order_less_asym
thf(fact_1678_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( X != Y2 )
         => ( ~ ( ord_less @ A @ X @ Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) ).

% linorder_neqE
thf(fact_1679_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_1680_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_1681_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_1682_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X @ Y2 ) )
          = ( ( ord_less @ A @ Y2 @ X )
            | ( X = Y2 ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_1683_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_1684_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A6: A,B6: A] :
              ( ( ord_less @ A @ A6 @ B6 )
             => ( P @ A6 @ B6 ) )
         => ( ! [A6: A] : ( P @ A6 @ A6 )
           => ( ! [A6: A,B6: A] :
                  ( ( P @ B6 @ A6 )
                 => ( P @ A6 @ B6 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_1685_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P3: A > $o] :
            ? [X6: A] : ( P3 @ X6 ) )
        = ( ^ [P4: A > $o] :
            ? [N2: A] :
              ( ( P4 @ N2 )
              & ! [M3: A] :
                  ( ( ord_less @ A @ M3 @ N2 )
                 => ~ ( P4 @ M3 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_1686_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_1687_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_1688_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ( X != Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) ).

% linorder_cases
thf(fact_1689_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X: A] :
          ( ~ ( ord_less @ A @ Y2 @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y2 ) )
            = ( X = Y2 ) ) ) ) ).

% antisym_conv3
thf(fact_1690_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X5: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ A @ Y3 @ X5 )
                 => ( P @ Y3 ) )
             => ( P @ X5 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_1691_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_1692_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_1693_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_1694_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( X != Y2 ) ) ) ).

% less_imp_neq
thf(fact_1695_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ? [Z5: A] :
              ( ( ord_less @ A @ X @ Z5 )
              & ( ord_less @ A @ Z5 @ Y2 ) ) ) ) ).

% dense
thf(fact_1696_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
        ? [X_1: A] : ( ord_less @ A @ X @ X_1 ) ) ).

% gt_ex
thf(fact_1697_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
        ? [Y4: A] : ( ord_less @ A @ Y4 @ X ) ) ).

% lt_ex
thf(fact_1698_small__lazy_H_Ocases,axiom,
    ! [X: product_prod @ int @ int] :
      ~ ! [D4: int,I3: int] :
          ( X
         != ( product_Pair @ int @ int @ D4 @ I3 ) ) ).

% small_lazy'.cases
thf(fact_1699_exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod @ ( int > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int )] :
      ~ ! [F3: int > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D4: int,I3: int] :
          ( X
         != ( product_Pair @ ( int > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int ) @ F3 @ ( product_Pair @ int @ int @ D4 @ I3 ) ) ) ).

% exhaustive_int'.cases
thf(fact_1700_full__exhaustive__int_H_Ocases,axiom,
    ! [X: product_prod @ ( ( product_prod @ int @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int )] :
      ~ ! [F3: ( product_prod @ int @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D4: int,I3: int] :
          ( X
         != ( product_Pair @ ( ( product_prod @ int @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ int @ int ) @ F3 @ ( product_Pair @ int @ int @ D4 @ I3 ) ) ) ).

% full_exhaustive_int'.cases
thf(fact_1701_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F5: A > B,G4: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F5 @ G4 )
              & ~ ( ord_less_eq @ ( A > B ) @ G4 @ F5 ) ) ) ) ) ).

% less_fun_def
thf(fact_1702_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X )
       => ( Q @ X ) ) ) ).

% predicate1D
thf(fact_1703_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X: A,Q: A > $o] :
      ( ( P @ X )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X ) ) ) ).

% rev_predicate1D
thf(fact_1704_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ X @ Y2 )
            | ( X = Y2 ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_1705_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less @ A @ Y2 @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_1706_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y4: A] :
                  ( ( ord_less @ A @ X5 @ Y4 )
                 => ( ord_less @ C @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_1707_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X5: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y4 )
                 => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_1708_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X5: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y4 )
                 => ( ord_less_eq @ C @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_1709_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X5: B,Y4: B] :
                  ( ( ord_less @ B @ X5 @ Y4 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_1710_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_less_le_trans
thf(fact_1711_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) ).

% order_le_less_trans
thf(fact_1712_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_1713_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_1714_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) ).

% order_less_imp_le
thf(fact_1715_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) ).

% linorder_not_less
thf(fact_1716_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X ) ) ) ).

% linorder_not_le
thf(fact_1717_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
              & ( X2 != Y ) ) ) ) ) ).

% order_less_le
thf(fact_1718_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less @ A @ X2 @ Y )
              | ( X2 = Y ) ) ) ) ) ).

% order_le_less
thf(fact_1719_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_1720_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_1721_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ~ ( ord_less_eq @ A @ A4 @ B3 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_1722_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_1723_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_1724_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less_eq @ A @ B3 @ A4 )
              & ( A4 != B3 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_1725_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_less @ A @ B3 @ A4 )
              | ( A4 = B3 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_1726_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ X @ W2 )
               => ( ( ord_less @ A @ W2 @ Y2 )
                 => ( ord_less_eq @ A @ W2 @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) ).

% dense_le_bounded
thf(fact_1727_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ Z2 @ W2 )
               => ( ( ord_less @ A @ W2 @ X )
                 => ( ord_less_eq @ A @ Y2 @ W2 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) ).

% dense_ge_bounded
thf(fact_1728_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ~ ( ord_less_eq @ A @ B3 @ A4 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_1729_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_1730_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_1731_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less_eq @ A @ A4 @ B3 )
              & ( A4 != B3 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_1732_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_less @ A @ A4 @ B3 )
              | ( A4 = B3 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_1733_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y2 @ X )
         => ( ord_less @ A @ X @ Y2 ) ) ) ).

% not_le_imp_less
thf(fact_1734_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
              & ~ ( ord_less_eq @ A @ Y @ X2 ) ) ) ) ) ).

% less_le_not_le
thf(fact_1735_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y2: A,Z2: A] :
          ( ! [X5: A] :
              ( ( ord_less @ A @ X5 @ Y2 )
             => ( ord_less_eq @ A @ X5 @ Z2 ) )
         => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ).

% dense_le
thf(fact_1736_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z2: A,Y2: A] :
          ( ! [X5: A] :
              ( ( ord_less @ A @ Z2 @ X5 )
             => ( ord_less_eq @ A @ Y2 @ X5 ) )
         => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ).

% dense_ge
thf(fact_1737_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ~ ( ord_less @ A @ X @ Y2 ) )
            = ( X = Y2 ) ) ) ) ).

% antisym_conv2
thf(fact_1738_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) ).

% antisym_conv1
thf(fact_1739_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_1740_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X ) ) ) ).

% leI
thf(fact_1741_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ~ ( ord_less @ A @ X @ Y2 ) ) ) ).

% leD
thf(fact_1742_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_1743_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_1744_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_1745_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_1746_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_1747_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A6: nat,B6: nat] :
          ( ( P @ A6 @ B6 )
          = ( P @ B6 @ A6 ) )
     => ( ! [A6: nat] : ( P @ A6 @ ( zero_zero @ nat ) )
       => ( ! [A6: nat,B6: nat] :
              ( ( P @ A6 @ B6 )
             => ( P @ A6 @ ( plus_plus @ nat @ A6 @ B6 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1748_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F5: A > B,G4: A > B] :
            ! [X2: A] : ( ord_less_eq @ B @ ( F5 @ X2 ) @ ( G4 @ X2 ) ) ) ) ) ).

% le_fun_def
thf(fact_1749_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_1750_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funE
thf(fact_1751_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funD
thf(fact_1752_vebt__insert_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) @ X )
      = ( if @ vEBT_VEBT
        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
          & ~ ( ( X = Mi )
              | ( X = Ma ) ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ X @ Mi ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ Ma ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary ) ) ) ).

% vebt_insert.simps(5)
thf(fact_1753_vebt__insert_Oelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa2 )
        = Y2 )
     => ( ! [A6: $o,B6: $o] :
            ( ( X
              = ( vEBT_Leaf @ A6 @ B6 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => ( Y2
                    = ( vEBT_Leaf @ $true @ B6 ) ) )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => ( Y2
                        = ( vEBT_Leaf @ A6 @ $true ) ) )
                    & ( ( Xa2
                       != ( one_one @ nat ) )
                     => ( Y2
                        = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) )
             => ( Y2
               != ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) )
               => ( Y2
                 != ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) ) )
           => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) )
                 => ( Y2
                   != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                   => ( Y2
                     != ( if @ vEBT_VEBT
                        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                          & ~ ( ( Xa2 = Mi2 )
                              | ( Xa2 = Ma2 ) ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Xa2 @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) ) ) ) ) ) ) ) ) ).

% vebt_insert.elims
thf(fact_1754_vebt__insert_Opelims,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => ( Y2
                      = ( vEBT_Leaf @ $true @ B6 ) ) )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => ( Y2
                          = ( vEBT_Leaf @ A6 @ $true ) ) )
                      & ( ( Xa2
                         != ( one_one @ nat ) )
                       => ( Y2
                          = ( vEBT_Leaf @ A6 @ B6 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A6 @ B6 ) @ Xa2 ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) )
               => ( ( Y2
                    = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts @ S3 ) @ Xa2 ) ) ) )
           => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) )
                 => ( ( Y2
                      = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S3 ) @ Xa2 ) ) ) )
             => ( ! [V3: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) )
                   => ( ( Y2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) )
                     => ( ( Y2
                          = ( if @ vEBT_VEBT
                            @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                              & ~ ( ( Xa2 = Mi2 )
                                  | ( Xa2 = Ma2 ) ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Xa2 @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va2 ) ) @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_insert.pelims
thf(fact_1755_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1756_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N: nat] :
      ( ( P @ K )
     => ( ! [X5: A] :
            ( ( P @ X5 )
           => ? [Y3: A] :
                ( ( P @ Y3 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y3 ) @ ( F2 @ X5 ) ) ) )
       => ? [Y4: A] :
            ( ( P @ Y4 )
            & ~ ( ord_less @ nat @ ( F2 @ Y4 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_1757_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1758_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X22: A] :
      ( ( size_option @ A @ X @ ( some @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_1759_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1760_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1761_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1762_max__enat__simps_I2_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ Q2 @ ( zero_zero @ extended_enat ) )
      = Q2 ) ).

% max_enat_simps(2)
thf(fact_1763_max__enat__simps_I3_J,axiom,
    ! [Q2: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q2 )
      = Q2 ) ).

% max_enat_simps(3)
thf(fact_1764_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_1765_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_1766_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_1767_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_1768_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_1769_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_1770_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_1771_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1772_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_1773_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_1774_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1775_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1776_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1777_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1778_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1779_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1780_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1781_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1782_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1783_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_1784_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1785_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1786_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_1787_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1788_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_1789_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1790_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1791_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_1792_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1793_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1794_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% even_Suc_Suc_iff
thf(fact_1795_even__Suc,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_Suc
thf(fact_1796_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1797_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1798_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_1799_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_1800_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_1801_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_1802_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_1803_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_1804_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_1805_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_1806_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_1807_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1808_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1809_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% odd_Suc_minus_one
thf(fact_1810_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ).

% even_diff_nat
thf(fact_1811_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_1812_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1813_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1814_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1815_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% even_power
thf(fact_1816_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1817_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1818_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_1819_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1820_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_1821_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ A2 ) ) ).

% dvd_refl
thf(fact_1822_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_1823_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( zero_zero @ A ) )
             => ( B3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_1824_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_1825_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K3: A] :
                ( A2
               != ( times_times @ A @ B2 @ K3 ) ) ) ) ).

% dvdE
thf(fact_1826_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_1827_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B3: A,A4: A] :
            ? [K2: A] :
              ( A4
              = ( times_times @ A @ B3 @ K2 ) ) ) ) ) ).

% dvd_def
thf(fact_1828_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1829_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1830_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1831_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1832_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1833_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1834_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_1835_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P2 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X5: A,Y4: A] :
                ( ( P2
                  = ( times_times @ A @ X5 @ Y4 ) )
               => ( ( dvd_dvd @ A @ X5 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y4 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1836_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B8: A,C6: A] :
              ( ( A2
                = ( times_times @ A @ B8 @ C6 ) )
              & ( dvd_dvd @ A @ B8 @ B2 )
              & ( dvd_dvd @ A @ C6 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1837_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_1838_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_1839_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1840_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1841_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1842_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1843_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( dvd_dvd @ A @ X @ Y2 )
         => ( ( dvd_dvd @ A @ X @ Z2 )
           => ( dvd_dvd @ A @ X @ ( minus_minus @ A @ Y2 @ Z2 ) ) ) ) ) ).

% dvd_diff
thf(fact_1844_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1845_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1846_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1847_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1848_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y2: A,N: nat] :
          ( ( dvd_dvd @ A @ X @ Y2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y2 @ N ) ) ) ) ).

% dvd_power_same
thf(fact_1849_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A2 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_1850_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M: A,N: A] :
          ( ( dvd_dvd @ A @ K @ M )
         => ( ( dvd_dvd @ A @ K @ N )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M @ N ) ) ) ) ) ).

% dvd_mod
thf(fact_1851_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_1852_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_iff
thf(fact_1853_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ K @ L2 ) ) ) ).

% signed_take_bit_mult
thf(fact_1854_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% signed_take_bit_add
thf(fact_1855_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% dvd_diff_nat
thf(fact_1856_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L2 ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ K @ L2 ) ) ) ).

% signed_take_bit_diff
thf(fact_1857_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ K @ ( minus_minus @ int @ M @ N ) )
     => ( ( dvd_dvd @ int @ K @ N )
       => ( dvd_dvd @ int @ K @ M ) ) ) ).

% zdvd_zdiffD
thf(fact_1858_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_1859_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ A2 ) )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_1860_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ A2 ) )
            @ ( collect @ A
              @ ^ [C3: A] : ( dvd_dvd @ A @ C3 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_1861_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1862_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1863_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ Z5 @ X3 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ).

% pinf(9)
thf(fact_1864_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ Z5 @ X3 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1865_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ X3 @ Z5 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ).

% minf(9)
thf(fact_1866_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S: B] :
        ? [Z5: B] :
        ! [X3: B] :
          ( ( ord_less @ B @ X3 @ Z5 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X3 @ S ) ) ) ) ) ) ).

% minf(10)
thf(fact_1867_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1868_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1869_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1870_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1871_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1872_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1873_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1874_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1875_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1876_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1877_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1878_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1879_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1880_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1881_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1882_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1883_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1884_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1885_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1886_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% div_power
thf(fact_1887_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_1888_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( modulo_modulo @ A @ B3 @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_1889_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_1890_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y2: A,N: nat,M: nat] :
          ( ( dvd_dvd @ A @ X @ Y2 )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y2 @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_1891_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1892_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1893_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_1894_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1895_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_1896_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_1897_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) )
      = ( ( ord_less @ nat @ N @ M )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_minus_self
thf(fact_1898_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
       => ( ( dvd_dvd @ int @ M @ N )
         => ( ( dvd_dvd @ int @ N @ M )
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_1899_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_1900_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ N ) ) ) ) ).

% dvd_diffD1
thf(fact_1901_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1902_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_1903_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N ) ) ) ).

% zdvd_mult_cancel
thf(fact_1904_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A2 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ D2 ) ) )
         => ? [X5: nat,Y4: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A2 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X5 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y4 ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X5 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y4 ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1905_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X5: nat,Y4: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X5 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ D4 ) )
        | ( ( times_times @ nat @ B2 @ X5 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y4 ) @ D4 ) ) ) ) ).

% bezout_add_nat
thf(fact_1906_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X5: nat,Y4: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X5 ) @ ( times_times @ nat @ B2 @ Y4 ) )
          = D4 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X5 ) @ ( times_times @ nat @ A2 @ Y4 ) )
          = D4 ) ) ) ).

% bezout1_nat
thf(fact_1907_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ X2 @ X2 ) ) ) ) ).

% dbl_def
thf(fact_1908_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N ) ) ).

% zdvd_reduce
thf(fact_1909_zdvd__period,axiom,
    ! [A2: int,D2: int,X: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_1910_div2__even__ext__nat,axiom,
    ! [X: nat,Y2: nat] :
      ( ( ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y2 ) )
       => ( X = Y2 ) ) ) ).

% div2_even_ext_nat
thf(fact_1911_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C4: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C4 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1912_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L2: A] :
          ( ( ? [X2: A] : ( P @ ( times_times @ A @ L2 @ X2 ) ) )
          = ( ? [X2: A] :
                ( ( dvd_dvd @ A @ L2 @ ( plus_plus @ A @ X2 @ ( zero_zero @ A ) ) )
                & ( P @ X2 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1913_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1914_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1915_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1916_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1917_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1918_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ).

% even_numeral
thf(fact_1919_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X3: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X3 @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1920_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X3: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X3 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1921_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1922_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1923_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1924_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1925_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1926_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1927_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1928_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1929_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat @ K @ N ) ) ) ).

% dvd_imp_le
thf(fact_1930_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_mult_cancel
thf(fact_1931_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1932_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D4: nat,X5: nat,Y4: nat] :
          ( ( dvd_dvd @ nat @ D4 @ A2 )
          & ( dvd_dvd @ nat @ D4 @ B2 )
          & ( ( times_times @ nat @ A2 @ X5 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ D4 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1933_zdvd__imp__le,axiom,
    ! [Z2: int,N: int] :
      ( ( dvd_dvd @ int @ Z2 @ N )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int @ Z2 @ N ) ) ) ).

% zdvd_imp_le
thf(fact_1934_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_1935_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q2 )
          = ( modulo_modulo @ nat @ N @ Q2 ) )
        = ( dvd_dvd @ nat @ Q2 @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1936_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X5: A] :
          ( ( P @ X5 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( ord_less_eq @ nat @ ( M @ X5 ) @ ( M @ Y3 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_1937_prod__decode__aux_Ocases,axiom,
    ! [X: product_prod @ nat @ nat] :
      ~ ! [K3: nat,M4: nat] :
          ( X
         != ( product_Pair @ nat @ nat @ K3 @ M4 ) ) ).

% prod_decode_aux.cases
thf(fact_1938_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D3: nat] : ( dvd_dvd @ nat @ D3 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_1939_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1940_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1941_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1942_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B6: A] :
                  ( ( B6
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B6 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B6 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B6 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B6 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B6 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1943_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) ) ) ) ).

% evenE
thf(fact_1944_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1945_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1946_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [A4: A,B3: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) )
              & ( ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1947_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ N ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1948_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N ) ) ) ) ).

% dvd_power
thf(fact_1949_even__even__mod__4__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_1950_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1951_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1952_dvd__minus__add,axiom,
    ! [Q2: nat,N: nat,R: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q2 @ N )
     => ( ( ord_less_eq @ nat @ Q2 @ ( times_times @ nat @ R @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ Q2 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N @ ( minus_minus @ nat @ ( times_times @ nat @ R @ M ) @ Q2 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1953_power__dvd__imp__le,axiom,
    ! [I2: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I2 @ M ) @ ( power_power @ nat @ I2 @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I2 )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_1954_mod__nat__eqI,axiom,
    ! [R: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ R @ N )
     => ( ( ord_less_eq @ nat @ R @ M )
       => ( ( dvd_dvd @ nat @ N @ ( minus_minus @ nat @ M @ R ) )
         => ( ( modulo_modulo @ nat @ M @ N )
            = R ) ) ) ) ).

% mod_nat_eqI
thf(fact_1955_mod__int__pos__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L2 ) )
      = ( ( dvd_dvd @ int @ L2 @ K )
        | ( ( L2
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% mod_int_pos_iff
thf(fact_1956_aset_I10_J,axiom,
    ! [D2: int,D5: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_1957_aset_I9_J,axiom,
    ! [D2: int,D5: int,A3: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A3 )
                 => ( X3
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_1958_bset_I10_J,axiom,
    ! [D2: int,D5: int,B4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_1959_bset_I9_J,axiom,
    ! [D2: int,D5: int,B4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X3: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B4 )
                 => ( X3
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X3 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X3 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_1960_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1961_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1962_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1963_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_odd
thf(fact_1964_odd__pos,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% odd_pos
thf(fact_1965_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% dvd_power_iff_le
thf(fact_1966_signed__take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1967_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1968_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1969_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1970_even__diff__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L2 ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_diff_iff
thf(fact_1971_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B6 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1972_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1973_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1974_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_even_power
thf(fact_1975_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1976_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1977_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_1978_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_1979_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1980_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: A] :
            ( ( P @ Y4 )
           => ( ord_less @ nat @ ( F2 @ Y4 ) @ B2 ) )
       => ? [X5: A] :
            ( ( P @ X5 )
            & ! [Y3: A] :
                ( ( P @ Y3 )
               => ( ord_less_eq @ nat @ ( F2 @ Y3 ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_1981_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1982_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_1983_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1984_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_option @ A @ X @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_1985_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1986_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_1987_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1988_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X8: set @ A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ? [Xa: A] :
                    ( ( member @ A @ Xa @ X8 )
                    & ( ord_less @ A @ X5 @ Xa ) ) )
           => ~ ( finite_finite @ A @ X8 ) ) ) ) ).

% infinite_growing
thf(fact_1989_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ S2 )
                & ~ ? [Xa: A] :
                      ( ( member @ A @ Xa @ S2 )
                      & ( ord_less @ A @ Xa @ X5 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_1990_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N2: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1991_vebt__buildup_Oelims,axiom,
    ! [X: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y2 )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y2
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y2
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va2: nat] :
                ( ( X
                  = ( suc @ ( suc @ Va2 ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_1992_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1993_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1994_set__decode__Suc,axiom,
    ! [N: nat,X: nat] :
      ( ( member @ nat @ ( suc @ N ) @ ( nat_set_decode @ X ) )
      = ( member @ nat @ N @ ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_1995_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( ( minus_minus @ A @ X @ Y2 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y2 ) ) ) ).

% diff_shunt_var
thf(fact_1996_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_1997_intind,axiom,
    ! [A: $tType,I2: nat,N: nat,P: A > $o,X: A] :
      ( ( ord_less @ nat @ I2 @ N )
     => ( ( P @ X )
       => ( P @ ( nth @ A @ ( replicate @ A @ N @ X ) @ I2 ) ) ) ) ).

% intind
thf(fact_1998_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1999_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_2000_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ B4 @ A3 ) ) ).

% Compl_subset_Compl_iff
thf(fact_2001_Compl__anti__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) ).

% Compl_anti_mono
thf(fact_2002_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_2003_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_2004_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_2005_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_2006_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_2007_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_2008_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_2009_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X ) ) ) ).

% compl_less_compl_iff
thf(fact_2010_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_2011_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) ).

% neg_numeral_eq_iff
thf(fact_2012_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_2013_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_2014_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_2015_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_2016_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_2017_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_2018_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_2019_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_2020_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y2: A] :
          ( ( dvd_dvd @ A @ X @ ( uminus_uminus @ A @ Y2 ) )
          = ( dvd_dvd @ A @ X @ Y2 ) ) ) ).

% dvd_minus_iff
thf(fact_2021_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y2: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X ) @ Y2 )
          = ( dvd_dvd @ A @ X @ Y2 ) ) ) ).

% minus_dvd_iff
thf(fact_2022_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_2023_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_2024_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_2025_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_2026_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) ).

% real_add_minus_iff
thf(fact_2027_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_2028_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_2029_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_2030_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N: nat,Y2: A] :
      ( ( ( replicate @ A @ M @ X )
        = ( replicate @ A @ N @ Y2 ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X = Y2 ) ) ) ) ).

% replicate_eq_replicate
thf(fact_2031_length__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N @ X ) )
      = N ) ).

% length_replicate
thf(fact_2032_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_2033_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_2034_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_2035_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_2036_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_2037_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_2038_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_2039_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_2040_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_2041_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_2042_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_2043_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_2044_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_2045_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_2046_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z2 )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1
thf(fact_2047_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: A] :
          ( ( times_times @ A @ Z2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z2 ) ) ) ).

% mult_minus1_right
thf(fact_2048_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_2049_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_2050_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( divide_divide @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X ) ) ) ).

% divide_minus1
thf(fact_2051_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_2052_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_2053_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_2054_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_2055_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_2056_Suc__0__mod__eq,axiom,
    ! [N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_2057_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_2058_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
           => ( P @ X2 ) ) )
      = ( ( P @ A2 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_2059_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
            & ( P @ X2 ) ) )
      = ( ( P @ A2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_2060_in__set__replicate,axiom,
    ! [A: $tType,X: A,N: nat,Y2: A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N @ Y2 ) ) )
      = ( ( X = Y2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_2061_nth__replicate,axiom,
    ! [A: $tType,I2: nat,N: nat,X: A] :
      ( ( ord_less @ nat @ I2 @ N )
     => ( ( nth @ A @ ( replicate @ A @ N @ X ) @ I2 )
        = X ) ) ).

% nth_replicate
thf(fact_2062_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_2063_triangle__Suc,axiom,
    ! [N: nat] :
      ( ( nat_triangle @ ( suc @ N ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N ) @ ( suc @ N ) ) ) ).

% triangle_Suc
thf(fact_2064_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_2065_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_2066_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_2067_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_2068_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_2069_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_2070_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_2071_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_2072_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U2 ) ) ) ) ) ).

% max_number_of(2)
thf(fact_2073_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_2074_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_2075_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(168)
thf(fact_2076_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_2077_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_2078_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y2 ) ) ) ).

% semiring_norm(172)
thf(fact_2079_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(171)
thf(fact_2080_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(170)
thf(fact_2081_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_2082_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_2083_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_2084_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_2085_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_2086_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_2087_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_2088_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_2089_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_2090_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_2091_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_2092_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_2093_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_2094_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_2095_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P2: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P2 ) ) )
          = P2 ) ) ).

% odd_of_bool_self
thf(fact_2096_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_2097_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_2098_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_2099_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_2100_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_2101_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_2102_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_2103_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_2104_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_minus_odd
thf(fact_2105_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_2106_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_2107_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_2108_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_2109_set__decode__0,axiom,
    ! [X: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% set_decode_0
thf(fact_2110_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_2111_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_2112_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_2113_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_2114_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_2115_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_2116_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_2117_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_2118_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y2 ) ) ) ).

% compl_le_swap2
thf(fact_2119_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% compl_le_swap1
thf(fact_2120_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_2121_signed__take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_2122_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ N @ M )
       => ( M = N ) ) ) ).

% dvd_antisym
thf(fact_2123_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ ( uminus_uminus @ A @ X ) )
         => ( ord_less @ A @ X @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% compl_less_swap1
thf(fact_2124_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y2 ) @ X )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ Y2 ) ) ) ).

% compl_less_swap2
thf(fact_2125_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P2: $o,Q2: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P2 )
            = ( zero_neq_one_of_bool @ A @ Q2 ) )
          = ( P2 = Q2 ) ) ) ).

% of_bool_eq_iff
thf(fact_2126_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_2127_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_2128_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_2129_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_2130_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_2131_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_2132_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_2133_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_2134_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_2135_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_2136_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_2137_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_2138_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_2139_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_2140_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_2141_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_2142_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_2143_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_2144_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_2145_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_2146_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_2147_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_2148_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_2149_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_2150_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,A5: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( modulo_modulo @ A @ A5 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A5 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_2151_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_2152_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_2153_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_2154_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ~ ( ( P2
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P2
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_2155_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ( P2
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P2
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_2156_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P5: $o] : ( if @ A @ P5 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_2157_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_2158_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_le_numeral
thf(fact_2159_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_2160_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_2161_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_less_numeral
thf(fact_2162_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_2163_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_2164_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_2165_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_2166_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_2167_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_2168_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_2169_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_2170_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_2171_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_2172_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_2173_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_2174_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_2175_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_2176_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_2177_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_2178_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_2179_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B3: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_2180_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B4: A,K: A,B2: A,A2: A] :
          ( ( B4
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B4 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_2181_replicate__eqI,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = N )
     => ( ! [Y4: A] :
            ( ( member @ A @ Y4 @ ( set2 @ A @ Xs2 ) )
           => ( Y4 = X ) )
       => ( Xs2
          = ( replicate @ A @ N @ X ) ) ) ) ).

% replicate_eqI
thf(fact_2182_replicate__length__same,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( X5 = X ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ X )
        = Xs2 ) ) ).

% replicate_length_same
thf(fact_2183_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_2184_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_2185_subset__Compl__self__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_2186_real__minus__mult__self__le,axiom,
    ! [U2: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U2 @ U2 ) ) @ ( times_times @ real @ X @ X ) ) ).

% real_minus_mult_self_le
thf(fact_2187_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_2188_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_2189_minus__int__code_I2_J,axiom,
    ! [L2: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L2 )
      = ( uminus_uminus @ int @ L2 ) ) ).

% minus_int_code(2)
thf(fact_2190_zmod__zminus1__not__zero,axiom,
    ! [K: int,L2: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L2 )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_2191_zmod__zminus2__not__zero,axiom,
    ! [K: int,L2: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L2 ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L2 )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_2192_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X2: real,Y: real] : ( plus_plus @ real @ X2 @ ( uminus_uminus @ real @ Y ) ) ) ) ).

% minus_real_def
thf(fact_2193_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_2194_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_2195_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_2196_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_2197_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_2198_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_2199_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_2200_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_2201_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_2202_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_2203_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_2204_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_2205_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_2206_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_2207_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_2208_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_2209_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_2210_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_2211_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_2212_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_2213_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_2214_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_2215_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_2216_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_2217_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_2218_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_2219_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus
thf(fact_2220_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_2221_real__add__less__0__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y2 @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_less_0_iff
thf(fact_2222_real__0__less__add__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y2 ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X ) @ Y2 ) ) ).

% real_0_less_add_iff
thf(fact_2223_real__0__le__add__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y2 ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ Y2 ) ) ).

% real_0_le_add_iff
thf(fact_2224_real__add__le__0__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y2 @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_le_0_iff
thf(fact_2225_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_2226_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_2227_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_2228_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_2229_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_2230_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_2231_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_2232_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_2233_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_2234_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_2235_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% subset_decode_imp_le
thf(fact_2236_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = B2 ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_2237_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y2 @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_2238_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z2 ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_2239_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,A2: A,B2: A] :
          ( ( ( Z2
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z2 ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z2 ) ) @ Z2 ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_2240_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( Z2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z2 ) ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y2 @ Z2 ) ) @ Z2 ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_2241_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_2242_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X = Y2 )
            | ( X
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% power2_eq_iff
thf(fact_2243_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( power_power @ A @ A2 @ N ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_2244_verit__less__mono__div__int2,axiom,
    ! [A3: int,B4: int,N: int] :
      ( ( ord_less_eq @ int @ A3 @ B4 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B4 @ N ) @ ( divide_divide @ int @ A3 @ N ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_2245_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_2246_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_2247_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_2248_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_2249_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_2250_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_2251_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_2252_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_2253_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_2254_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_2255_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_2256_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_2257_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_2258_realpow__square__minus__le,axiom,
    ! [U2: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_2259_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_2260_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_2261_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_2262_minus__mod__int__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L2 )
        = ( minus_minus @ int @ ( minus_minus @ int @ L2 @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L2 ) ) ) ) ).

% minus_mod_int_eq
thf(fact_2263_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_2264_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_2265_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_2266_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q2: int,R: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q2 @ R ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q2 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q2 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_2267_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A6: A] :
              ( ( ( divide_divide @ A @ A6 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A6 )
             => ( P @ A6 ) )
         => ( ! [A6: A,B6: $o] :
                ( ( P @ A6 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A6 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B6 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A6 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_2268_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_2269_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_2270_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_2271_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_2272_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2273_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2274_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_2275_div__pos__neg__trivial,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L2 ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_2276_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_2277_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_2278_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_2279_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y2: A,X: A,Z2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y2 ) @ ( times_times @ A @ X @ Z2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z2 ) @ ( times_times @ A @ X @ Y2 ) ) )
          = ( ( W = X )
            | ( Y2 = Z2 ) ) ) ) ).

% crossproduct_eq
thf(fact_2280_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2281_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K3: int] :
              ( ( P @ K3 )
             => ( ( K3
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K3: int] :
                ( ( P @ K3 )
               => ( ( K3
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2282_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2283_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X2: nat] :
          ( collect @ nat
          @ ^ [N2: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_2284_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_2285_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_2286_Divides_Oadjust__div__eq,axiom,
    ! [Q2: int,R: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q2 @ R ) )
      = ( plus_plus @ int @ Q2
        @ ( zero_neq_one_of_bool @ int
          @ ( R
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_2287_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2288_vebt__buildup_Opelims,axiom,
    ! [X: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y2 )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y2
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y2
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va2: nat] :
                  ( ( X
                    = ( suc @ ( suc @ Va2 ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va2 ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va2 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_2289_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2290_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X2 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_2291_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X2: int] : X2
          @ ( set_or1337092689740270186AtMost @ int @ M @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_2292_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_2293_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(90)
thf(fact_2294_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) ).

% semiring_norm(88)
thf(fact_2295_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) ).

% semiring_norm(89)
thf(fact_2296_semiring__norm_I84_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit1 @ N ) ) ).

% semiring_norm(84)
thf(fact_2297_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2298_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(73)
thf(fact_2299_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(80)
thf(fact_2300_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > C > A,A2: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( F2 @ A2 @ B2 ) ) ).

% case_prod_conv
thf(fact_2301_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_2302_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(9)
thf(fact_2303_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(7)
thf(fact_2304_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N ) ) ) ).

% semiring_norm(15)
thf(fact_2305_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N ) ) ) ) ).

% semiring_norm(14)
thf(fact_2306_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(72)
thf(fact_2307_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(81)
thf(fact_2308_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2309_semiring__norm_I77_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit1 @ N ) ) ).

% semiring_norm(77)
thf(fact_2310_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_2311_semiring__norm_I3_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) ).

% semiring_norm(3)
thf(fact_2312_semiring__norm_I4_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2313_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_2314_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2315_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2316_ln__le__cancel__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X @ Y2 ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_2317_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_2318_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_iff
thf(fact_2319_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_2320_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2321_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(74)
thf(fact_2322_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(79)
thf(fact_2323_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_2324_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_iff
thf(fact_2325_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2326_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2327_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2328_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2329_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2330_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2331_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2332_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2333_old_Oprod_Ocase,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > B > C,X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F2 @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F2 @ X1 @ X22 ) ) ).

% old.prod.case
thf(fact_2334_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_2335_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A3: set @ A,G: C > B,B4: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B4 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J3: C] : ( times_times @ B @ ( F2 @ I4 ) @ ( G @ J3 ) )
                @ B4 )
            @ A3 ) ) ) ).

% sum_product
thf(fact_2336_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A3: set @ B,R: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ ( F2 @ N2 ) @ R )
            @ A3 ) ) ) ).

% sum_distrib_right
thf(fact_2337_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R: A,F2: B > A,A3: set @ B] :
          ( ( times_times @ A @ R @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( times_times @ A @ R @ ( F2 @ N2 ) )
            @ A3 ) ) ) ).

% sum_distrib_left
thf(fact_2338_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( plus_plus @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A3 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ A3 ) ) ) ) ).

% sum.distrib
thf(fact_2339_sum__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ A3 )
          = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum_subtractf
thf(fact_2340_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A3: set @ B,R: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N2: B] : ( divide_divide @ A @ ( F2 @ N2 ) @ R )
            @ A3 ) ) ) ).

% sum_divide_distrib
thf(fact_2341_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I4: B] : ( modulo_modulo @ A @ ( F2 @ I4 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_sum_eq
thf(fact_2342_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: A > $o,P: B > C > A,Z2: product_prod @ B @ C] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P @ Z2 ) )
     => ~ ! [X5: B,Y4: C] :
            ( ( Z2
              = ( product_Pair @ B @ C @ X5 @ Y4 ) )
           => ~ ( Q @ ( P @ X5 @ Y4 ) ) ) ) ).

% case_prodE2
thf(fact_2343_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: ( product_prod @ A @ B ) > C] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X2: A,Y: B] : ( F2 @ ( product_Pair @ A @ B @ X2 @ Y ) ) )
      = F2 ) ).

% case_prod_eta
thf(fact_2344_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: A > B > C,G: ( product_prod @ A @ B ) > C] :
      ( ! [X5: A,Y4: B] :
          ( ( F2 @ X5 @ Y4 )
          = ( G @ ( product_Pair @ A @ B @ X5 @ Y4 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F2 )
        = G ) ) ).

% cond_case_prod_eta
thf(fact_2345_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_2346_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_nonneg
thf(fact_2347_sum__mono__inv,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I7 > A,I5: set @ I7,G: I7 > A,I2: I7] :
          ( ( ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ I5 )
            = ( groups7311177749621191930dd_sum @ I7 @ A @ G @ I5 ) )
         => ( ! [I3: I7] :
                ( ( member @ I7 @ I3 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) )
           => ( ( member @ I7 @ I2 @ I5 )
             => ( ( finite_finite @ I7 @ I5 )
               => ( ( F2 @ I2 )
                  = ( G @ I2 ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_2348_xor__num_Ocases,axiom,
    ! [X: product_prod @ num @ num] :
      ( ( X
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N3: num] :
            ( X
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) )
       => ( ! [N3: num] :
              ( X
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) )
         => ( ! [M4: num] :
                ( X
               != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) )
           => ( ! [M4: num,N3: num] :
                  ( X
                 != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) )
             => ( ! [M4: num,N3: num] :
                    ( X
                   != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) )
               => ( ! [M4: num] :
                      ( X
                     != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) )
                 => ( ! [M4: num,N3: num] :
                        ( X
                       != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) )
                   => ~ ! [M4: num,N3: num] :
                          ( X
                         != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_2349_num_Oexhaust,axiom,
    ! [Y2: num] :
      ( ( Y2 != one2 )
     => ( ! [X23: num] :
            ( Y2
           != ( bit0 @ X23 ) )
       => ~ ! [X33: num] :
              ( Y2
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2350_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 )
                = ( zero_zero @ A ) )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                   => ( ( F2 @ X2 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_2351_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,T2: set @ C,G: C > A,I2: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X5: C] :
                  ( ( member @ C @ X5 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X5 ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S )
                   => ? [Xa: C] :
                        ( ( member @ C @ Xa @ T2 )
                        & ( ( I2 @ Xa )
                          = X5 )
                        & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ Xa ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_2352_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: set @ I7,F2: I7 > A,G: I7 > A] :
          ( ( finite_finite @ I7 @ A3 )
         => ( ! [X5: I7] :
                ( ( member @ I7 @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ? [X3: I7] :
                  ( ( member @ I7 @ X3 @ A3 )
                  & ( ord_less @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ I7 @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_2353_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R2: A > A > $o,S2: set @ B,H2: B > A,G: B > A] :
          ( ( R2 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X15: A,Y15: A,X23: A,Y23: A] :
                ( ( ( R2 @ X15 @ X23 )
                  & ( R2 @ Y15 @ Y23 ) )
               => ( R2 @ ( plus_plus @ A @ X15 @ Y15 ) @ ( plus_plus @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S2 )
                   => ( R2 @ ( H2 @ X5 ) @ ( G @ X5 ) ) )
               => ( R2 @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_2354_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ A3 )
                 => ( ord_less @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_2355_ln__bound,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_bound
thf(fact_2356_ln__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_gt_zero
thf(fact_2357_ln__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_2358_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_2359_ln__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_ge_zero
thf(fact_2360_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S4: set @ B,T5: set @ C,S2: set @ B,I2: C > B,J: B > C,T4: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A6: B] :
                  ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                 => ( ( I2 @ ( J @ A6 ) )
                    = A6 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                   => ( member @ C @ ( J @ A6 ) @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) )
                     => ( ( J @ ( I2 @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) )
                       => ( member @ B @ ( I2 @ B6 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) ) )
                   => ( ! [A6: B] :
                          ( ( member @ B @ A6 @ S4 )
                         => ( ( G @ A6 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member @ C @ B6 @ T5 )
                           => ( ( H2 @ B6 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A6: B] :
                              ( ( member @ B @ A6 @ S2 )
                             => ( ( H2 @ ( J @ A6 ) )
                                = ( G @ A6 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H2 @ T4 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_2361_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2362_eval__nat__numeral_I3_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2363_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_2364_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_2365_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_2366_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2367_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I2 @ S )
               => ( ( F2 @ I2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_2368_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S: set @ B,F2: B > A,B4: A,I2: B] :
          ( ( finite_finite @ B @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ S )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S )
                = B4 )
             => ( ( member @ B @ I2 @ S )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ B4 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_2369_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( G @ X2 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_2370_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_2371_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z2: A,W: num] :
          ( ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z2 @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_2372_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,I2: B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( member @ B @ I2 @ I5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ I5 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_2373_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ I5 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ).

% sum_pos
thf(fact_2374_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_2375_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B4 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C5 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_2376_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C5 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B4 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_2377_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T4: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T4 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_2378_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T4: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T4 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_2379_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T4: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( H2 @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T4 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_2380_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T4: set @ B,S2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T4 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_2381_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B4: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_2382_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B4 ) ) ) ) ) ) ).

% sum_diff
thf(fact_2383_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self
thf(fact_2384_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self2
thf(fact_2385_ln__mult,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( times_times @ real @ X @ Y2 ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_mult
thf(fact_2386_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( minus_minus @ real @ X @ ( one_one @ real ) ) )
       => ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_2387_ln__div,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X @ Y2 ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_div
thf(fact_2388_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit1_div_2
thf(fact_2389_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ).

% odd_numeral
thf(fact_2390_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2391_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2392_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2393_Suc3__eq__add__3,axiom,
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ).

% Suc3_eq_add_3
thf(fact_2394_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B4: set @ B,A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( ! [B6: B] :
                  ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B6 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B4 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_2395_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2396_ln__le__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( minus_minus @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_2397_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) @ ( uminus_uminus @ real @ X ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2398_ln__diff__le,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y2 ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X @ Y2 ) @ Y2 ) ) ) ) ).

% ln_diff_le
thf(fact_2399_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q2: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2400_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q2 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2401_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_div_eq_add3_div
thf(fact_2402_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2403_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B4: set @ A,A3: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X5: A] :
                      ( ( member @ A @ X5 @ B4 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X5 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B4 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_2404_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_2405_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2406_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_2407_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2408_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2409_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2410_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_2411_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2412_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2413_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2414_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_abs
thf(fact_2415_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_2416_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B,C2: A > B > $o] :
      ( ! [A6: A,B6: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A6 @ B6 ) )
         => ( C2 @ A6 @ B6 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P2 ) ) ).

% case_prodI2
thf(fact_2417_case__prodI,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A2: A,B2: B] :
      ( ( F2 @ A2 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) ).

% case_prodI
thf(fact_2418_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P2: product_prod @ A @ B,Z2: C,C2: A > B > ( set @ C )] :
      ( ! [A6: A,B6: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A6 @ B6 ) )
         => ( member @ C @ Z2 @ ( C2 @ A6 @ B6 ) ) )
     => ( member @ C @ Z2 @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P2 ) ) ) ).

% mem_case_prodI2
thf(fact_2419_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: B > C > ( set @ A ),A2: B,B2: C] :
      ( ( member @ A @ Z2 @ ( C2 @ A2 @ B2 ) )
     => ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) ).

% mem_case_prodI
thf(fact_2420_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P2: product_prod @ A @ B,C2: A > B > C > $o,X: C] :
      ( ! [A6: A,B6: B] :
          ( ( ( product_Pair @ A @ B @ A6 @ B6 )
            = P2 )
         => ( C2 @ A6 @ B6 @ X ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ X ) ) ).

% case_prodI2'
thf(fact_2421_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_2422_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_2423_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_2424_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_2425_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_numeral
thf(fact_2426_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_2427_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_2428_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_2429_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_2430_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus
thf(fact_2431_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_2432_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_2433_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_2434_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_2435_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2436_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_2437_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_2438_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2439_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2440_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_neg_numeral
thf(fact_2441_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2442_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% abs_power_minus
thf(fact_2443_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2444_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N ) )
      = ( ( pred_numeral @ K )
        = N ) ) ).

% eq_numeral_Suc
thf(fact_2445_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ( suc @ N )
        = ( numeral_numeral @ nat @ K ) )
      = ( N
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2446_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A3 ) ) ) ).

% sum_abs
thf(fact_2447_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_2448_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_2449_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2450_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% less_numeral_Suc
thf(fact_2451_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2452_artanh__minus__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X ) ) ) ) ).

% artanh_minus_real
thf(fact_2453_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2454_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% le_numeral_Suc
thf(fact_2455_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2456_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% diff_numeral_Suc
thf(fact_2457_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2458_max__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_2459_max__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% max_numeral_Suc
thf(fact_2460_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A3 ) ) ) ).

% sum_abs_ge_zero
thf(fact_2461_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2462_minus__numeral__div__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_2463_numeral__div__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_2464_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_2465_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_2466_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_2467_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_2468_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_2469_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_2470_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A3 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_2471_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_2472_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_2473_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_2474_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A3 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_2475_one__div__minus__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% one_div_minus_numeral
thf(fact_2476_minus__one__div__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_div_numeral
thf(fact_2477_signed__take__bit__numeral__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2478_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_2479_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2480_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_2481_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_2482_signed__take__bit__numeral__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2483_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_2484_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_2485_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_2486_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_2487_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_2488_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_2489_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y2: A] :
          ( ( ( abs_abs @ A @ X )
            = ( abs_abs @ A @ Y2 ) )
          = ( ( X = Y2 )
            | ( X
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% abs_eq_iff
thf(fact_2490_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_abs
thf(fact_2491_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L2: A,K: A] :
          ( ( ( abs_abs @ A @ L2 )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L2 @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_2492_mem__case__prodE,axiom,
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: B > C > ( set @ A ),P2: product_prod @ B @ C] :
      ( ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P2 ) )
     => ~ ! [X5: B,Y4: C] :
            ( ( P2
              = ( product_Pair @ B @ C @ X5 @ Y4 ) )
           => ~ ( member @ A @ Z2 @ ( C2 @ X5 @ Y4 ) ) ) ) ).

% mem_case_prodE
thf(fact_2493_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: A > B > $o,P2: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P2 )
     => ~ ! [X5: A,Y4: B] :
            ( ( P2
              = ( product_Pair @ A @ B @ X5 @ Y4 ) )
           => ~ ( C2 @ X5 @ Y4 ) ) ) ).

% case_prodE
thf(fact_2494_case__prodD,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A2: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( F2 @ A2 @ B2 ) ) ).

% case_prodD
thf(fact_2495_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: A > B > C > $o,P2: product_prod @ A @ B,Z2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ Z2 )
     => ~ ! [X5: A,Y4: B] :
            ( ( P2
              = ( product_Pair @ A @ B @ X5 @ Y4 ) )
           => ~ ( C2 @ X5 @ Y4 @ Z2 ) ) ) ).

% case_prodE'
thf(fact_2496_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R2: A > B > C > $o,A2: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R2 @ ( product_Pair @ A @ B @ A2 @ B2 ) @ C2 )
     => ( R2 @ A2 @ B2 @ C2 ) ) ).

% case_prodD'
thf(fact_2497_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_2498_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_2499_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_2500_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_2501_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_2502_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_2503_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_2504_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_2505_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_2506_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_2507_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_2508_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_2509_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_2510_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_2511_sin__bound__lemma,axiom,
    ! [X: real,Y2: real,U2: real,V: real] :
      ( ( X = Y2 )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U2 ) @ V )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X @ U2 ) @ Y2 ) ) @ V ) ) ) ).

% sin_bound_lemma
thf(fact_2512_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K2: num] : ( suc @ ( pred_numeral @ K2 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2513_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ord_less_eq @ nat @ ( G @ X5 ) @ ( F2 @ X5 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X2: A] : ( minus_minus @ nat @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ A3 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A3 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_2514_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_2515_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E2: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E2 ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_2516_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_2517_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y2 ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y2 @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_2518_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_2519_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_2520_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_2521_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X ) @ Y2 )
            = ( abs_abs @ A @ ( divide_divide @ A @ X @ Y2 ) ) ) ) ) ).

% abs_div_pos
thf(fact_2522_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% zero_le_power_abs
thf(fact_2523_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_2524_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if
thf(fact_2525_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if_raw
thf(fact_2526_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_2527_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_2528_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less_eq @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_2529_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ A2 @ R ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_2530_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A,N: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
        = ( suc @ N ) )
     => ? [X5: A] :
          ( ( member @ A @ X5 @ A3 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X5 ) ) ) ) ).

% sum_SucD
thf(fact_2531_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
          = ( one_one @ nat ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ A3 )
              & ( ( F2 @ X2 )
                = ( one_one @ nat ) )
              & ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( ( X2 != Y )
                   => ( ( F2 @ Y )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_2532_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A4: real] : ( if @ real @ ( ord_less @ real @ A4 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A4 ) @ A4 ) ) ) ).

% abs_real_def
thf(fact_2533_lemma__interval__lt,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y3: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D4 )
               => ( ( ord_less @ real @ A2 @ Y3 )
                  & ( ord_less @ real @ Y3 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_2534_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,I5: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M @ I4 ) )
            @ I5 )
          = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I5 ) ) ) ) ).

% sum_power_add
thf(fact_2535_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_2536_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K2: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K2 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2537_sum__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X2: complex] : X2
          @ ( collect @ complex
            @ ^ [Z: complex] :
                ( ( power_power @ complex @ Z @ N )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_2538_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X2: complex] : X2
          @ ( collect @ complex
            @ ^ [Z: complex] :
                ( ( power_power @ complex @ Z @ N )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_2539_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2540_sum__diff__nat,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B4 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_2541_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_2542_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_2543_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_2544_lemma__interval,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y3: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y3 ) ) @ D4 )
               => ( ( ord_less_eq @ real @ A2 @ Y3 )
                  & ( ord_less_eq @ real @ Y3 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_2545_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_2546_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_2547_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( abs_abs @ A @ Y2 ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2548_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2549_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_even_abs
thf(fact_2550_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A,P2: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P2 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_2551_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M3: num,N2: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% divmod_int_def
thf(fact_2552_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q4: int,R5: int] :
          ( plus_plus @ int @ Q4
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_2553_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X: A] :
          ( ! [X5: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 )
             => ( P @ X5 @ ( power_power @ A @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X ) @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2554_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ Y2 ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2555_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2556_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N2: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ) ).

% divmod_def
thf(fact_2557_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2558_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_even
thf(fact_2559_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M3: num,N2: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N2 ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_2560_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,X: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I3: A] :
              ( ( member @ A @ I3 @ I5 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I3 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I5 )
              = ( one_one @ B ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I5 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I3 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I4: A] : ( times_times @ B @ ( A2 @ I4 ) @ ( X @ I4 ) )
                      @ I5 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_2561_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X2: A] : ( minus_minus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2562_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F2 @ K2 ) @ ( F2 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K2: nat] : ( minus_minus @ A @ ( F2 @ K2 ) @ ( F2 @ ( plus_plus @ nat @ K2 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_2563_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( minus_minus @ A @ ( F2 @ K2 ) @ ( F2 @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_2564_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_2565_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_2566_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.in_pairs
thf(fact_2567_eq__diff__eq_H,axiom,
    ! [X: real,Y2: real,Z2: real] :
      ( ( X
        = ( minus_minus @ real @ Y2 @ Z2 ) )
      = ( Y2
        = ( plus_plus @ real @ X @ Z2 ) ) ) ).

% eq_diff_eq'
thf(fact_2568_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_2569_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_2570_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I4 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_2571_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_2572_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N2: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M3 @ N2 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M3 ) ) @ ( unique1321980374590559556d_step @ A @ N2 @ ( unique8689654367752047608divmod @ A @ M3 @ ( bit0 @ N2 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_2573_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2574_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_2575_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N2: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N2
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M3 @ N2 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M3 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M3 @ N2 ) @ N2 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_2576_tanh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( tanh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2577_arctan__double,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2578_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2579_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M: nat,X: A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_2580_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K2: int] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K2 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_2581_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) ).

% of_nat_eq_iff
thf(fact_2582_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_2583_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% abs_of_nat
thf(fact_2584_negative__zle,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_2585_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2586_tanh__real__le__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X @ Y2 ) ) ).

% tanh_real_le_iff
thf(fact_2587_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_2588_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) ).

% of_nat_0_eq_iff
thf(fact_2589_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_2590_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_iff
thf(fact_2591_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% of_nat_numeral
thf(fact_2592_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% of_nat_le_iff
thf(fact_2593_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_add
thf(fact_2594_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_2595_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2596_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2597_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2598_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ W @ Z2 ) ) ) ).

% of_int_le_iff
thf(fact_2599_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int,N: num] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( numeral_numeral @ A @ N ) )
          = ( Z2
            = ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_2600_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_2601_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ W @ Z2 ) ) ) ).

% of_int_less_iff
thf(fact_2602_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_2603_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z2: int] :
          ( ( ( ring_1_of_int @ A @ Z2 )
            = ( one_one @ A ) )
          = ( Z2
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_2604_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N ) ) ) ).

% of_nat_power
thf(fact_2605_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_2606_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_2607_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z2 ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_mult
thf(fact_2608_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z2 ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_add
thf(fact_2609_zabs__less__one__iff,axiom,
    ! [Z2: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z2 ) @ ( one_one @ int ) )
      = ( Z2
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_2610_of__int__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z2: int] :
          ( ( ring_1_of_int @ A @ ( minus_minus @ int @ W @ Z2 ) )
          = ( minus_minus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_diff
thf(fact_2611_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int,N: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z2 @ N ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z2 ) @ N ) ) ) ).

% of_int_power
thf(fact_2612_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X ) )
          = ( ( power_power @ int @ B2 @ W )
            = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_2613_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_2614_arctan__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_2615_zero__le__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_arctan_iff
thf(fact_2616_tanh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_nonneg_iff
thf(fact_2617_tanh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2618_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2619_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_2620_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2621_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2622_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_2623_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_2624_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2625_real__of__nat__less__numeral__iff,axiom,
    ! [N: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2626_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2627_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% of_nat_0_less_iff
thf(fact_2628_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2629_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2630_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_2631_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_le_iff
thf(fact_2632_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% of_int_0_less_iff
thf(fact_2633_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z2 @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_2634_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_2635_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_2636_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y2: nat,X: num,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y2
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2637_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: num,N: nat,Y2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( semiring_1_of_nat @ A @ Y2 ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
            = Y2 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2638_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_2639_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_2640_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ int @ Z2 @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2641_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z2: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N ) @ Z2 ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2642_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int,N: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ int @ Z2 @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2643_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z2: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N ) @ Z2 ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2644_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_2645_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_le_iff
thf(fact_2646_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z2 ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ) ).

% of_int_1_less_iff
thf(fact_2647_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z2 @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_2648_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_2649_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_2650_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y2: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
            = Y2 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2651_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y2
            = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2652_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_2653_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_2654_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X ) @ N ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_2655_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_of_nat
thf(fact_2656_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) @ X ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2657_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2658_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I2: num,N: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) @ X ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2659_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I2: num,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I2 ) @ N ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I2 ) @ N ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2660_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2661_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2662_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2663_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2664_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( Y2
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2665_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y2: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N )
            = Y2 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2666_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2667_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2668_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2669_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2670_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A3: A > B > $o,B4: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A3 ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ B4 ) ) ) ) ).

% Collect_case_prod_mono
thf(fact_2671_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,X: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ X ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_2672_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y2: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_2673_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2674_arctan__monotone_H,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ X @ Y2 )
     => ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y2 ) ) ) ).

% arctan_monotone'
thf(fact_2675_arctan__le__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y2 ) )
      = ( ord_less_eq @ real @ X @ Y2 ) ) ).

% arctan_le_iff
thf(fact_2676_int__diff__cases,axiom,
    ! [Z2: int] :
      ~ ! [M4: nat,N3: nat] :
          ( Z2
         != ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_diff_cases
thf(fact_2677_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_nat_0_le_iff
thf(fact_2678_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_2679_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2680_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_2681_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_2682_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
         => ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_imp_less
thf(fact_2683_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I2: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I2 ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_2684_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_2685_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% of_nat_dvd_iff
thf(fact_2686_int__ops_I3_J,axiom,
    ! [N: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ int @ N ) ) ).

% int_ops(3)
thf(fact_2687_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_2688_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_2689_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_2690_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% zle_int
thf(fact_2691_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% nonneg_int_cases
thf(fact_2692_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_2693_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mod
thf(fact_2694_int__plus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_2695_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_2696_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z2: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z2 ) ) ).

% zadd_int_left
thf(fact_2697_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_2698_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_2699_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W3: int,Z: int] :
        ? [N2: nat] :
          ( Z
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_2700_abs__div,axiom,
    ! [Y2: int,X: int] :
      ( ( dvd_dvd @ int @ Y2 @ X )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X @ Y2 ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X ) @ ( abs_abs @ int @ Y2 ) ) ) ) ).

% abs_div
thf(fact_2701_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_2702_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y2: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X @ Y2 ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y2 ) ) ) ) ).

% of_nat_max
thf(fact_2703_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2704_tanh__real__lt__1,axiom,
    ! [X: real] : ( ord_less @ real @ ( tanh @ real @ X ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_2705_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_less_as_int
thf(fact_2706_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_leq_as_int
thf(fact_2707_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% of_nat_diff
thf(fact_2708_reals__Archimedean3,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ! [Y3: real] :
        ? [N3: nat] : ( ord_less @ real @ Y3 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ X ) ) ) ).

% reals_Archimedean3
thf(fact_2709_real__of__int__div4,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) ) ).

% real_of_int_div4
thf(fact_2710_int__cases4,axiom,
    ! [M: int] :
      ( ! [N3: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N3 ) )
     => ~ ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% int_cases4
thf(fact_2711_dvd__imp__le__int,axiom,
    ! [I2: int,D2: int] :
      ( ( I2
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I2 )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I2 ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2712_real__of__nat__div4,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) ) ).

% real_of_nat_div4
thf(fact_2713_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_2714_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2715_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2716_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z: int] :
        ? [N2: nat] :
          ( Z
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_2717_abs__mod__less,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L2 ) ) @ ( abs_abs @ int @ L2 ) ) ) ).

% abs_mod_less
thf(fact_2718_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% nonpos_int_cases
thf(fact_2719_negative__zle__0,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_2720_real__of__nat__div,axiom,
    ! [D2: nat,N: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_2721_real__of__int__div,axiom,
    ! [D2: int,N: int] :
      ( ( dvd_dvd @ int @ D2 @ N )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_2722_tanh__real__gt__neg1,axiom,
    ! [X: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X ) ) ).

% tanh_real_gt_neg1
thf(fact_2723_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_nonneg
thf(fact_2724_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_2725_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z2: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_int_pos
thf(fact_2726_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_2727_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2728_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_2729_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2730_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N2: int,M3: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_2731_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N2: int,M3: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M3 ) ) ) ) ).

% int_less_real_le
thf(fact_2732_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% pos_int_cases
thf(fact_2733_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N3: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
          & ( K
            = ( semiring_1_of_nat @ int @ N3 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_2734_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N3: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) )
       => ~ ! [N3: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% int_cases3
thf(fact_2735_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N2: nat,M3: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M3 ) ) ) ) ).

% nat_less_real_le
thf(fact_2736_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N2: nat,M3: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_2737_zmult__zless__mono2__lemma,axiom,
    ! [I2: int,J: int,K: nat] :
      ( ( ord_less @ int @ I2 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I2 ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_2738_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N ) @ M )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2739_not__zle__0__negative,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ).

% not_zle_0_negative
thf(fact_2740_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2741_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_2742_real__of__int__div__aux,axiom,
    ! [X: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_2743_real__of__nat__div__aux,axiom,
    ! [X: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2744_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% of_nat_less_two_power
thf(fact_2745_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_2746_even__abs__add__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L2 ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_abs_add_iff
thf(fact_2747_even__add__abs__iff,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L2 ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L2 ) ) ) ).

% even_add_abs_iff
thf(fact_2748_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M4 ) @ X ) @ C2 ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_2749_real__of__int__div2,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) ) ).

% real_of_int_div2
thf(fact_2750_real__of__int__div3,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_2751_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N3: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N3 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ).

% neg_int_cases
thf(fact_2752_zdiff__int__split,axiom,
    ! [P: int > $o,X: nat,Y2: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X @ Y2 ) ) )
      = ( ( ( ord_less_eq @ nat @ Y2 @ X )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) )
        & ( ( ord_less @ nat @ X @ Y2 )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_2753_real__of__nat__div2,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) ) ).

% real_of_nat_div2
thf(fact_2754_real__of__nat__div3,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_2755_ln__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_realpow
thf(fact_2756_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_2757_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I3 )
            & ( ord_less @ nat @ I3 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
           => ? [I3: nat] :
                ( ( ord_less_eq @ nat @ M @ I3 )
                & ( ord_less_eq @ nat @ I3 @ N )
                & ( ( F2 @ I3 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_2758_incr__lemma,axiom,
    ! [D2: int,Z2: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z2 @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_2759_decr__lemma,axiom,
    ! [D2: int,X: int,Z2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z2 ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z2 ) ) ).

% decr_lemma
thf(fact_2760_linear__plus__1__le__power,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) @ N ) ) ) ).

% linear_plus_1_le_power
thf(fact_2761_Bernoulli__inequality,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality
thf(fact_2762_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N2: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M3 @ N2 ) @ ( modulo_modulo @ nat @ M3 @ N2 ) ) ) ) ).

% divmod_nat_def
thf(fact_2763_nat__ivt__aux,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I3 ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_2764_nat0__intermed__int__val,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) ) @ ( F2 @ I3 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I3: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
              & ( ( F2 @ I3 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_2765_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_2766_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_2767_arctan__add,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X ) @ ( arctan @ Y2 ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y2 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y2 ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_2768_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_2769_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_2770_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_2771_Bernoulli__inequality__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2772_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_2773_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_2774_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M3: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_2775_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
         => ~ ! [N3: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ E ) ) ) ).

% nat_approx_posE
thf(fact_2776_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z5 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z5 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_2777_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X5: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X5 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X5 @ ( one_one @ int ) ) ) )
          & ! [Y3: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y3 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y3 @ ( one_one @ int ) ) ) ) )
             => ( Y3 = X5 ) ) ) ) ).

% floor_exists1
thf(fact_2778_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_2779_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H2: A,Z2: A,K5: real,N: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z2 @ H2 ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ N ) @ ( power_power @ A @ Z2 @ N ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2780_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X5: A,Y4: B] :
          ( ( P @ X5 @ Y4 )
         => ( Q @ X5 @ Y4 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_2781_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X: A,Y2: B,Q: A > B > $o] :
      ( ( P @ X @ Y2 )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X @ Y2 ) ) ) ).

% rev_predicate2D
thf(fact_2782_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X: A,Y2: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X @ Y2 )
       => ( Q @ X @ Y2 ) ) ) ).

% predicate2D
thf(fact_2783_complex__mod__minus__le__complex__mod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_2784_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_2785_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2786_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2787_monoseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X ) ) ) ) ).

% monoseq_realpow
thf(fact_2788_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less_eq @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% real_arch_simple
thf(fact_2789_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N3: nat] : ( ord_less @ A @ X @ ( semiring_1_of_nat @ A @ N3 ) ) ) ).

% reals_Archimedean2
thf(fact_2790_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z5 ) ) ) ).

% ex_le_of_int
thf(fact_2791_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] : ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z5 ) ) ) ).

% ex_less_of_int
thf(fact_2792_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z5: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z5 ) @ X ) ) ).

% ex_of_int_less
thf(fact_2793_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ Y2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2794_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_2795_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2796_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2797_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2798_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2799_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_2800_norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( one_one @ A ) )
        = ( one_one @ real ) ) ) ).

% norm_one
thf(fact_2801_norm__minus__commute,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% norm_minus_commute
thf(fact_2802_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% norm_ge_zero
thf(fact_2803_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y2 ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult
thf(fact_2804_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_2805_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,G: B > real] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) @ ( G @ X5 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S2 ) ) ) ) ).

% sum_norm_le
thf(fact_2806_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power
thf(fact_2807_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I4 ) )
            @ A3 ) ) ) ).

% norm_sum
thf(fact_2808_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ Y2 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y2 ) ) ) ) ).

% norm_uminus_minus
thf(fact_2809_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2810_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat,Z2: A] :
          ( ( ( power_power @ A @ W @ N )
            = ( power_power @ A @ Z2 @ N ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2811_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,R: real,Y2: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y2 ) ) @ ( times_times @ real @ R @ S ) ) ) ) ) ).

% norm_mult_less
thf(fact_2812_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult_ineq
thf(fact_2813_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y2 ) ) @ E ) ) ) ).

% norm_triangle_lt
thf(fact_2814_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,R: real,Y2: A,S: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y2 ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_add_less
thf(fact_2815_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A,N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power_ineq
thf(fact_2816_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R: real,B2: A,S: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R @ S ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2817_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2818_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y2 ) ) @ E ) ) ) ).

% norm_triangle_le
thf(fact_2819_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2820_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y2 ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ Z2 ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2821_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y2 ) ) @ E ) ) ) ).

% norm_triangle_le_diff
thf(fact_2822_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A,E1: real,Z2: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y2 ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ Z2 ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z2 ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2823_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2824_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y2 ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2825_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2826_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2827_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat] :
          ( ( ( power_power @ A @ W @ N )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2828_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2829_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_2830_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2831_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z2 @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z2 @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2832_ln__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X )
          = ( suminf @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ ( one_one @ real ) ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_2833_arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arctan @ X )
        = ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_2834_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y2 ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y2 ) ) ) ) ).

% round_unique
thf(fact_2835_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H2: A,Z2: A,N: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ N ) @ ( power_power @ A @ Z2 @ N ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H2
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P5: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ Q4 ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ P5 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_2836_summable__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_2837_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R2 )
        @ ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ S2 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S2 ) ) ).

% pred_subset_eq2
thf(fact_2838_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I2 @ K ) ) ) ).

% lessThan_iff
thf(fact_2839_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X ) @ ( set_ord_lessThan @ A @ Y2 ) )
          = ( ord_less_eq @ A @ X @ Y2 ) ) ) ).

% lessThan_subset_iff
thf(fact_2840_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ int @ N ) ) ) ).

% round_numeral
thf(fact_2841_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_2842_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_2843_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ).

% round_neg_numeral
thf(fact_2844_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_2845_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U3: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less @ A @ X2 @ U3 ) ) ) ) ) ).

% lessThan_def
thf(fact_2846_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_2847_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N ) )
          = ( ord_less @ A @ M @ N ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_2848_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D4: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_2849_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_round @ A @ Y2 ) ) ) ) ).

% round_mono
thf(fact_2850_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_2851_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N: A] :
          ( ! [X5: A] : ( ord_less_eq @ nat @ ( Q @ X5 ) @ ( P @ X5 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X2: A] : ( minus_minus @ nat @ ( P @ X2 ) @ ( Q @ X2 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_2852_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X: A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ) ).

% powser_inside
thf(fact_2853_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_2854_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N: nat,R: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ R ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ R )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_2855_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_2856_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_2857_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R2 ) )
        = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ S2 ) ) )
      = ( R2 = S2 ) ) ).

% pred_equals_eq2
thf(fact_2858_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% bot_empty_eq2
thf(fact_2859_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_2860_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_2861_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_2862_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z2 ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z2 @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_2863_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_2864_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z2: A,H2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P5: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ ( minus_minus @ nat @ M @ P5 ) ) @ ( power_power @ A @ Z2 @ P5 ) ) @ ( power_power @ A @ Z2 @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P5: nat] : ( times_times @ A @ ( power_power @ A @ Z2 @ P5 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z2 @ H2 ) @ ( minus_minus @ nat @ M @ P5 ) ) @ ( power_power @ A @ Z2 @ ( minus_minus @ nat @ M @ P5 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_2865_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N ) ) @ ( power_power @ A @ Y2 @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P5: nat] : ( times_times @ A @ ( power_power @ A @ X @ P5 ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N @ P5 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_2866_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y2 @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) ) @ ( power_power @ A @ X @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_2867_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,F2: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_2868_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_2869_subrelI,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ! [X5: A,Y4: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y4 ) @ R )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y4 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) ).

% subrelI
thf(fact_2870_sum__split__even__odd,axiom,
    ! [F2: nat > real,G: nat > real,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I4: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( F2 @ I4 ) @ ( G @ I4 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum_split_even_odd
thf(fact_2871_pred__subset__eq,axiom,
    ! [A: $tType,R2: set @ A,S2: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X2: A] : ( member @ A @ X2 @ R2 )
        @ ^ [X2: A] : ( member @ A @ X2 @ S2 ) )
      = ( ord_less_eq @ ( set @ A ) @ R2 @ S2 ) ) ).

% pred_subset_eq
thf(fact_2872_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2873_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_2874_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_2875_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2876_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N ) ) ) ).

% round_unique'
thf(fact_2877_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_2878_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_2879_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_2880_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_2881_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ( ord_less_eq @ nat @ N @ I2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_2882_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_iff_shift
thf(fact_2883_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) ) ) ) ).

% summable_mult
thf(fact_2884_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_2885_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_add
thf(fact_2886_summable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ).

% summable_diff
thf(fact_2887_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_2888_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_2889_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_2890_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_2891_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_2892_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( times_times @ A @ ( suminf @ A @ F2 ) @ C2 )
            = ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_2893_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mult
thf(fact_2894_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_2895_suminf__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) ) ) ) ) ) ) ).

% suminf_diff
thf(fact_2896_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F2 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_2897_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_2898_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N2: nat] :
                    ( ( F2 @ N2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_2899_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_2900_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_0_powser
thf(fact_2901_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ).

% summable_zero_power'
thf(fact_2902_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_2903_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_2904_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N2 @ M ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
          = ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_2905_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N7: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N7 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_2906_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ? [N7: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N3 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_2907_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N2: nat] : ( abs_abs @ real @ ( F2 @ N2 ) ) ) ) ) ).

% summable_rabs
thf(fact_2908_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I4: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_2909_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_2910_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X ) ) ) ) ).

% suminf_le_const
thf(fact_2911_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N4: nat,F2: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_2912_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N7: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N7 @ N3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_2913_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) ) @ X )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_2914_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_2915_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_2916_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_2917_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) ) ) ).

% summable_norm
thf(fact_2918_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I5: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I5 )
           => ( ! [N3: nat] :
                  ( ( member @ nat @ N3 @ ( uminus_uminus @ ( set @ nat ) @ I5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N3 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I5 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_2919_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A @ F2 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_2920_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_2921_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_2922_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
         => ( ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
                @ Z2 ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_2923_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z2: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) ) )
              @ Z2 )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_2924_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ~ ! [N8: nat] :
                  ~ ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ M2 )
                     => ! [N9: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N9 ) ) ) @ E ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_2925_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ( summable @ A @ F2 )
           => ? [N8: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N9 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N9 ) ) ) )
                  @ R ) ) ) ) ) ).

% suminf_exist_split
thf(fact_2926_summable__power__series,axiom,
    ! [F2: nat > real,Z2: real] :
      ( ! [I3: nat] : ( ord_less_eq @ real @ ( F2 @ I3 ) @ ( one_one @ real ) )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I3 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z2 )
         => ( ( ord_less @ real @ Z2 @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( F2 @ I4 ) @ ( power_power @ real @ Z2 @ I4 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_2927_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R )
         => ( ( ord_less @ real @ R @ R0 )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R0 @ N3 ) ) @ M7 )
             => ( summable @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N2 ) ) @ ( power_power @ real @ R @ N2 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_2928_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N4: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N3 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_2929_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( F2 @ ( suc @ K2 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_2930_sumr__cos__zero__one,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M3 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_2931_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K2: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_2932_finite__nat__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S5: set @ nat] :
        ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S5 @ ( set_ord_lessThan @ nat @ K2 ) ) ) ) ).

% finite_nat_iff_bounded
thf(fact_2933_finite__nat__bounded,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S2 @ ( set_ord_lessThan @ nat @ K3 ) ) ) ).

% finite_nat_bounded
thf(fact_2934_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2935_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_2936_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_2937_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_2938_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_2939_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_2940_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_2941_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_2942_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_2943_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_2944_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_2945_arctan__ubound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_2946_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_2947_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_2948_arctan__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_2949_arctan__lbound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) ) ).

% arctan_lbound
thf(fact_2950_infinite__nat__iff__unbounded,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M3: nat] :
          ? [N2: nat] :
            ( ( ord_less @ nat @ M3 @ N2 )
            & ( member @ nat @ N2 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_2951_unbounded__k__infinite,axiom,
    ! [K: nat,S2: set @ nat] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K @ M4 )
         => ? [N9: nat] :
              ( ( ord_less @ nat @ M4 @ N9 )
              & ( member @ nat @ N9 @ S2 ) ) )
     => ~ ( finite_finite @ nat @ S2 ) ) ).

% unbounded_k_infinite
thf(fact_2952_infinite__nat__iff__unbounded__le,axiom,
    ! [S2: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S2 ) )
      = ( ! [M3: nat] :
          ? [N2: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N2 )
            & ( member @ nat @ N2 @ S2 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_2953_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_2954_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_2955_infinite__int__iff__unbounded__le,axiom,
    ! [S2: set @ int] :
      ( ( ~ ( finite_finite @ int @ S2 ) )
      = ( ! [M3: int] :
          ? [N2: int] :
            ( ( ord_less_eq @ int @ M3 @ ( abs_abs @ int @ N2 ) )
            & ( member @ int @ N2 @ S2 ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_2956_sin__cos__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% sin_cos_npi
thf(fact_2957_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_2958_accp__subset,axiom,
    ! [A: $tType,R1: A > A > $o,R22: A > A > $o] :
      ( ( ord_less_eq @ ( A > A > $o ) @ R1 @ R22 )
     => ( ord_less_eq @ ( A > $o ) @ ( accp @ A @ R22 ) @ ( accp @ A @ R1 ) ) ) ).

% accp_subset
thf(fact_2959_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( power_power @ A @ Z2 @ N2 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_2960_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X4: nat > A] :
              ( ! [M3: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N2 )
                 => ( ord_less_eq @ A @ ( X4 @ M3 ) @ ( X4 @ N2 ) ) )
              | ! [M3: nat,N2: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N2 )
                 => ( ord_less_eq @ A @ ( X4 @ N2 ) @ ( X4 @ M3 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_2961_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_2962_sin__pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ pi @ X ) )
      = ( sin @ real @ X ) ) ).

% sin_pi_minus
thf(fact_2963_cos__pi,axiom,
    ( ( cos @ real @ pi )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% cos_pi
thf(fact_2964_cos__periodic__pi2,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi2
thf(fact_2965_cos__periodic__pi,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_periodic_pi
thf(fact_2966_sin__periodic__pi2,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi2
thf(fact_2967_sin__periodic__pi,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_periodic_pi
thf(fact_2968_cos__minus__pi,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_minus_pi
thf(fact_2969_cos__pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ pi @ X ) )
      = ( uminus_uminus @ real @ ( cos @ real @ X ) ) ) ).

% cos_pi_minus
thf(fact_2970_sin__minus__pi,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ X @ pi ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_minus_pi
thf(fact_2971_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ X ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_2972_sin__npi2,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_2973_sin__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_2974_sin__npi__int,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_2975_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
            @ X )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X ) ) ) ).

% powser_sums_zero_iff
thf(fact_2976_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_2977_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_2978_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_2979_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_2980_cos__periodic,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X ) ) ).

% cos_periodic
thf(fact_2981_sin__periodic,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X ) ) ).

% sin_periodic
thf(fact_2982_cos__2pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( cos @ real @ X ) ) ).

% cos_2pi_minus
thf(fact_2983_cos__npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi
thf(fact_2984_cos__npi2,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi2
thf(fact_2985_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_2986_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_2987_sin__2npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_2988_cos__2npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_2989_sin__2pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_2pi_minus
thf(fact_2990_sin__int__2pin,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_2991_cos__int__2pin,axiom,
    ! [N: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_2992_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_2993_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_2994_cos__npi__int,axiom,
    ! [N: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_2995_polar__Ex,axiom,
    ! [X: real,Y2: real] :
    ? [R4: real,A6: real] :
      ( ( X
        = ( times_times @ real @ R4 @ ( cos @ real @ A6 ) ) )
      & ( Y2
        = ( times_times @ real @ R4 @ ( sin @ real @ A6 ) ) ) ) ).

% polar_Ex
thf(fact_2996_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_diff
thf(fact_2997_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_2998_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_add
thf(fact_2999_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A,S: A,T2: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( sums @ A @ F2 @ S )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_3000_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_3001_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_3002_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( plus_plus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_3003_sums__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
              @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_diff
thf(fact_3004_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( F2 @ N2 ) @ C2 )
            @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_3005_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_add
thf(fact_3006_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_diff
thf(fact_3007_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3008_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3009_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X ) ) @ ( cos @ A @ X ) ) ) ) ).

% sin_double
thf(fact_3010_sincos__principal__value,axiom,
    ! [X: real] :
    ? [Y4: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y4 )
      & ( ord_less_eq @ real @ Y4 @ pi )
      & ( ( sin @ real @ Y4 )
        = ( sin @ real @ X ) )
      & ( ( cos @ real @ Y4 )
        = ( cos @ real @ X ) ) ) ).

% sincos_principal_value
thf(fact_3011_sin__x__le__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( sin @ real @ X ) @ X ) ) ).

% sin_x_le_x
thf(fact_3012_sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_3013_cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_3014_abs__sin__x__le__abs__x,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( abs_abs @ real @ X ) ) ).

% abs_sin_x_le_abs_x
thf(fact_3015_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_3016_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F2 @ N2 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_3017_sin__cos__le1,axiom,
    ! [X: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y2 ) ) @ ( times_times @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y2 ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3018_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3019_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3020_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( F2 @ N2 ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_3021_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L2: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ L2 )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_3022_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A] :
          ( ( sums @ A
            @ ^ [N2: nat] : ( F2 @ ( suc @ N2 ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_3023_sin__x__ge__neg__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ ( sin @ real @ X ) ) ) ).

% sin_x_ge_neg_x
thf(fact_3024_sin__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_ge_zero
thf(fact_3025_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N: nat,F2: nat > A,S: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ I3 @ N )
             => ( ( F2 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N ) )
              @ S )
            = ( sums @ A @ F2 @ S ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_3026_sin__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X ) ) ).

% sin_ge_minus_one
thf(fact_3027_cos__inj__pi,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ( cos @ real @ X )
                = ( cos @ real @ Y2 ) )
             => ( X = Y2 ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_3028_cos__mono__le__eq,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y2 ) )
              = ( ord_less_eq @ real @ Y2 @ X ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_3029_cos__monotone__0__pi__le,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_3030_cos__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X ) ) ).

% cos_ge_minus_one
thf(fact_3031_abs__sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_3032_abs__cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_3033_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z2 ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3034_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z2 ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3035_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z2 ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3036_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3037_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3038_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z2 @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3039_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3040_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3041_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z2: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( if @ A @ ( N2 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z2 @ N2 ) )
          @ ( power_power @ A @ Z2 @ M ) ) ) ).

% powser_sums_if
thf(fact_3042_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N2 ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_3043_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3044_cos__monotone__0__pi,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_3045_cos__mono__less__eq,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y2 ) )
              = ( ord_less @ real @ Y2 @ X ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_3046_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N ) )
            @ S )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_3047_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N: nat,S: A] :
          ( ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) )
          = ( sums @ A @ F2 @ S ) ) ) ).

% sums_iff_shift'
thf(fact_3048_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S: A,N: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N ) )
            @ ( minus_minus @ A @ S @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_3049_cos__monotone__minus__pi__0_H,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_3050_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S2: A,A3: set @ nat,S4: A,F2: nat > A] :
          ( ( sums @ A @ G @ S2 )
         => ( ( finite_finite @ nat @ A3 )
           => ( ( S4
                = ( plus_plus @ A @ S2
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
                    @ A3 ) ) )
             => ( sums @ A
                @ ^ [N2: nat] : ( if @ A @ ( member @ nat @ N2 @ A3 ) @ ( F2 @ N2 ) @ ( G @ N2 ) )
                @ S4 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_3051_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( X
            = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_3052_sincos__total__pi,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T6: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
            & ( ord_less_eq @ real @ T6 @ pi )
            & ( X
              = ( cos @ real @ T6 ) )
            & ( Y2
              = ( sin @ real @ T6 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3053_sin__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3054_cos__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3055_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero_02
thf(fact_3056_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3057_cos__is__zero,axiom,
    ? [X5: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
      & ( ord_less_eq @ real @ X5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X5 )
        = ( zero_zero @ real ) )
      & ! [Y3: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
            & ( ord_less_eq @ real @ Y3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y3 )
              = ( zero_zero @ real ) ) )
         => ( Y3 = X5 ) ) ) ).

% cos_is_zero
thf(fact_3058_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3059_cos__monotone__minus__pi__0,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_3060_cos__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X5: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
            & ( ord_less_eq @ real @ X5 @ pi )
            & ( ( cos @ real @ X5 )
              = Y2 )
            & ! [Y3: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 )
                  & ( ord_less_eq @ real @ Y3 @ pi )
                  & ( ( cos @ real @ Y3 )
                    = Y2 ) )
               => ( Y3 = X5 ) ) ) ) ) ).

% cos_total
thf(fact_3061_sincos__total__pi__half,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T6: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
              & ( ord_less_eq @ real @ T6 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X
                = ( cos @ real @ T6 ) )
              & ( Y2
                = ( sin @ real @ T6 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3062_sincos__total__2pi__le,axiom,
    ! [X: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T6: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
          & ( ord_less_eq @ real @ T6 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X
            = ( cos @ real @ T6 ) )
          & ( Y2
            = ( sin @ real @ T6 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3063_sincos__total__2pi,axiom,
    ! [X: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T6: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
           => ( ( ord_less @ real @ T6 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X
                  = ( cos @ real @ T6 ) )
               => ( Y2
                 != ( sin @ real @ T6 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3064_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_3065_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z2 ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3066_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z2: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3067_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_3068_power__half__series,axiom,
    ( sums @ real
    @ ^ [N2: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N2 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_3069_sin__gt__zero2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero2
thf(fact_3070_sin__lt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_3071_cos__double__less__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3072_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_3073_cos__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero
thf(fact_3074_sin__inj__pi,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X )
                = ( sin @ real @ Y2 ) )
             => ( X = Y2 ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_3075_sin__mono__le__eq,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X @ Y2 ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_3076_sin__monotone__2pi__le,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_3077_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3078_cos__one__2pi__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X2: int] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3079_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3080_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3081_sums__if_H,axiom,
    ! [G: nat > real,X: real] :
      ( ( sums @ real @ G @ X )
     => ( sums @ real
        @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X ) ) ).

% sums_if'
thf(fact_3082_sums__if,axiom,
    ! [G: nat > real,X: real,F2: nat > real,Y2: real] :
      ( ( sums @ real @ G @ X )
     => ( ( sums @ real @ F2 @ Y2 )
       => ( sums @ real
          @ ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( F2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X @ Y2 ) ) ) ) ).

% sums_if
thf(fact_3083_sin__le__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_3084_sin__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_3085_sin__monotone__2pi,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_3086_sin__mono__less__eq,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y2 ) )
              = ( ord_less @ real @ X @ Y2 ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_3087_sin__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X5: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
            & ( ord_less_eq @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X5 )
              = Y2 )
            & ! [Y3: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
                  & ( ord_less_eq @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y3 )
                    = Y2 ) )
               => ( Y3 = X5 ) ) ) ) ) ).

% sin_total
thf(fact_3088_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3089_cos__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_ge_zero
thf(fact_3090_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X2: nat] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X2: nat] :
            ( X
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3091_accp__subset__induct,axiom,
    ! [A: $tType,D5: A > $o,R2: A > A > $o,X: A,P: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ D5 @ ( accp @ A @ R2 ) )
     => ( ! [X5: A,Z5: A] :
            ( ( D5 @ X5 )
           => ( ( R2 @ Z5 @ X5 )
             => ( D5 @ Z5 ) ) )
       => ( ( D5 @ X )
         => ( ! [X5: A] :
                ( ( D5 @ X5 )
               => ( ! [Z3: A] :
                      ( ( R2 @ Z3 @ X5 )
                     => ( P @ Z3 ) )
                 => ( P @ X5 ) ) )
           => ( P @ X ) ) ) ) ) ).

% accp_subset_induct
thf(fact_3092_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_3093_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_3094_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3095_sin__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_3096_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_3097_cos__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( cos @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3098_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3099_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI1
thf(fact_3100_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI2
thf(fact_3101_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X4: nat > A] :
              ( ! [N2: nat] : ( ord_less_eq @ A @ ( X4 @ N2 ) @ ( X4 @ ( suc @ N2 ) ) )
              | ! [N2: nat] : ( ord_less_eq @ A @ ( X4 @ ( suc @ N2 ) ) @ ( X4 @ N2 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_3102_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI1
thf(fact_3103_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M4: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ M4 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI2
thf(fact_3104_vebt__mint_Opelims,axiom,
    ! [X: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_mint @ X )
        = Y2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ X )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( ( A6
                   => ( Y2
                      = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                  & ( ~ A6
                   => ( ( B6
                       => ( Y2
                          = ( some @ nat @ ( one_one @ nat ) ) ) )
                      & ( ~ B6
                       => ( Y2
                          = ( none @ nat ) ) ) ) ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ ( vEBT_Leaf @ A6 @ B6 ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ( ( Y2
                    = ( none @ nat ) )
                 => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) ) ) )
           => ~ ! [Mi2: nat,Ma2: nat,Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
                 => ( ( Y2
                      = ( some @ nat @ Mi2 ) )
                   => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_mint_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) ) ) ) ) ) ) ) ).

% vebt_mint.pelims
thf(fact_3105_vebt__maxt_Opelims,axiom,
    ! [X: vEBT_VEBT,Y2: option @ nat] :
      ( ( ( vEBT_vebt_maxt @ X )
        = Y2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ X )
       => ( ! [A6: $o,B6: $o] :
              ( ( X
                = ( vEBT_Leaf @ A6 @ B6 ) )
             => ( ( ( B6
                   => ( Y2
                      = ( some @ nat @ ( one_one @ nat ) ) ) )
                  & ( ~ B6
                   => ( ( A6
                       => ( Y2
                          = ( some @ nat @ ( zero_zero @ nat ) ) ) )
                      & ( ~ A6
                       => ( Y2
                          = ( none @ nat ) ) ) ) ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ ( vEBT_Leaf @ A6 @ B6 ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ( ( Y2
                    = ( none @ nat ) )
                 => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) ) ) )
           => ~ ! [Mi2: nat,Ma2: nat,Ux2: nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) )
                 => ( ( Y2
                      = ( some @ nat @ Ma2 ) )
                   => ~ ( accp @ vEBT_VEBT @ vEBT_vebt_maxt_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Ux2 @ Uy2 @ Uz2 ) ) ) ) ) ) ) ) ).

% vebt_maxt.pelims
thf(fact_3106_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ? [T6: real] :
            ( ( ord_less @ real @ X @ T6 )
            & ( ord_less @ real @ T6 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T6 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_3107_Maclaurin__cos__expansion2,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T6 )
            & ( ord_less @ real @ T6 @ X )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T6 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_3108_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A1: nat,A22: nat,A32: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A1 @ ( product_Pair @ nat @ A @ A22 @ A32 ) ) ) )
     => ( ! [F3: nat > A > A,A6: nat,B6: nat,Acc: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F3 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A6 @ ( product_Pair @ nat @ A @ B6 @ Acc ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B6 @ A6 )
               => ( P @ F3 @ ( plus_plus @ nat @ A6 @ ( one_one @ nat ) ) @ B6 @ ( F3 @ A6 @ Acc ) ) )
             => ( P @ F3 @ A6 @ B6 @ Acc ) ) )
       => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_3109_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_3110_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_3111_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_3112_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_3113_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_3114_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_zero
thf(fact_3115_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_3116_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_gt_zero
thf(fact_3117_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_3118_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_mono
thf(fact_3119_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_3120_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ) ).

% fact_less_mono
thf(fact_3121_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_3122_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_3123_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N @ N ) ) ) ) ).

% fact_le_power
thf(fact_3124_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_3125_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_3126_square__fact__le__2__fact,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% square_fact_le_2_fact
thf(fact_3127_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_3128_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_3129_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: real,N: nat,Diff: nat > A > real] :
          ( ( X
            = ( zero_zero @ real ) )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_3130_Maclaurin__lemma,axiom,
    ! [H2: real,F2: real > real,J: nat > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ? [B9: real] :
          ( ( F2 @ H2 )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
              @ ( set_ord_lessThan @ nat @ N ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H2 @ N ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_3131_cos__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ real @ X @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      @ ( cos @ real @ X ) ) ).

% cos_paired
thf(fact_3132_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_3133_sin__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X ) ) ).

% sin_paired
thf(fact_3134_Maclaurin__cos__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T6: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
      & ( ( cos @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T6 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_3135_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ? [T6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T6 )
            & ( ord_less @ real @ T6 @ X )
            & ( ( sin @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T6 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_3136_Maclaurin__sin__expansion4,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ? [T6: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T6 )
          & ( ord_less_eq @ real @ T6 @ X )
          & ( ( sin @ real @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T6 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_3137_Maclaurin__sin__expansion2,axiom,
    ! [X: real,N: nat] :
    ? [T6: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
      & ( ( sin @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T6 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_3138_Maclaurin__sin__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T6: real] :
      ( ( sin @ real @ X )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T6 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_3139_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N2: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_3140_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ).

% fact_mono_nat
thf(fact_3141_fact__ge__self,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_self
thf(fact_3142_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% fact_less_mono_nat
thf(fact_3143_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_Suc_0_nat
thf(fact_3144_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% dvd_fact
thf(fact_3145_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_3146_fact__div__fact__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ R ) ) ) @ ( power_power @ nat @ N @ R ) ) ) ).

% fact_div_fact_le_pow
thf(fact_3147_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: nat > A > A,A2: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A2 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F2 @ ( plus_plus @ nat @ A2 @ ( one_one @ nat ) ) @ B2 @ ( F2 @ A2 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_3148_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa2: nat,Xb2: nat,Xc: A,Y2: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa2 @ Xb2 @ Xc )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa2 @ ( product_Pair @ nat @ A @ Xb2 @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb2 @ Xa2 )
               => ( Y2 = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb2 @ Xa2 )
               => ( Y2
                  = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa2 @ ( one_one @ nat ) ) @ Xb2 @ ( X @ Xa2 @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa2 @ ( product_Pair @ nat @ A @ Xb2 @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_3149_VEBT__internal_Ooption__shift_Opelims,axiom,
    ! [A: $tType,X: A > A > A,Xa2: option @ A,Xb2: option @ A,Y2: option @ A] :
      ( ( ( vEBT_V2048590022279873568_shift @ A @ X @ Xa2 @ Xb2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) ) @ ( vEBT_V459564278314245337ft_rel @ A ) @ ( product_Pair @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ X @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ Xa2 @ Xb2 ) ) )
       => ( ( ( Xa2
              = ( none @ A ) )
           => ( ( Y2
                = ( none @ A ) )
             => ~ ( accp @ ( product_prod @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) ) @ ( vEBT_V459564278314245337ft_rel @ A ) @ ( product_Pair @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ X @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( none @ A ) @ Xb2 ) ) ) ) )
         => ( ! [V3: A] :
                ( ( Xa2
                  = ( some @ A @ V3 ) )
               => ( ( Xb2
                    = ( none @ A ) )
                 => ( ( Y2
                      = ( none @ A ) )
                   => ~ ( accp @ ( product_prod @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) ) @ ( vEBT_V459564278314245337ft_rel @ A ) @ ( product_Pair @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ X @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( some @ A @ V3 ) @ ( none @ A ) ) ) ) ) ) )
           => ~ ! [A6: A] :
                  ( ( Xa2
                    = ( some @ A @ A6 ) )
                 => ! [B6: A] :
                      ( ( Xb2
                        = ( some @ A @ B6 ) )
                     => ( ( Y2
                          = ( some @ A @ ( X @ A6 @ B6 ) ) )
                       => ~ ( accp @ ( product_prod @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) ) @ ( vEBT_V459564278314245337ft_rel @ A ) @ ( product_Pair @ ( A > A > A ) @ ( product_prod @ ( option @ A ) @ ( option @ A ) ) @ X @ ( product_Pair @ ( option @ A ) @ ( option @ A ) @ ( some @ A @ A6 ) @ ( some @ A @ B6 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.option_shift.pelims
thf(fact_3150_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( C2 @ N2 ) ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_3151_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3152_tan__periodic__pi,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ pi ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_pi
thf(fact_3153_tan__npi,axiom,
    ! [N: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3154_tan__periodic__n,axiom,
    ! [X: real,N: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_n
thf(fact_3155_tan__periodic__nat,axiom,
    ! [X: real,N: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_nat
thf(fact_3156_tan__periodic__int,axiom,
    ! [X: real,I2: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( ring_1_of_int @ real @ I2 ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_int
thf(fact_3157_tan__periodic,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic
thf(fact_3158_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ X2 ) ) ) ) ) ).

% tan_def
thf(fact_3159_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C3: nat > A,N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( C3 @ ( suc @ N2 ) ) ) ) ) ) ).

% diffs_def
thf(fact_3160_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [X5: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_3161_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa2: nat,Xb2: nat,Xc: A,Y2: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa2 @ Xb2 @ Xc )
        = Y2 )
     => ( ( ( ord_less @ nat @ Xb2 @ Xa2 )
         => ( Y2 = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb2 @ Xa2 )
         => ( Y2
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa2 @ ( one_one @ nat ) ) @ Xb2 @ ( X @ Xa2 @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_3162_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F5: nat > A > A,A4: nat,B3: nat,Acc3: A] : ( if @ A @ ( ord_less @ nat @ B3 @ A4 ) @ Acc3 @ ( set_fo6178422350223883121st_nat @ A @ F5 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B3 @ ( F5 @ A4 @ Acc3 ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_3163_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3164_lemma__tan__total,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y2 @ ( tan @ real @ X5 ) ) ) ) ).

% lemma_tan_total
thf(fact_3165_tan__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_gt_zero
thf(fact_3166_tan__total,axiom,
    ! [Y2: real] :
    ? [X5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
      & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X5 )
        = Y2 )
      & ! [Y3: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y3 )
            & ( ord_less @ real @ Y3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y3 )
              = Y2 ) )
         => ( Y3 = X5 ) ) ) ).

% tan_total
thf(fact_3167_tan__monotone,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X )
       => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X ) ) ) ) ) ).

% tan_monotone
thf(fact_3168_tan__monotone_H,axiom,
    ! [Y2: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
         => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y2 @ X )
              = ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3169_tan__mono__lt__eq,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y2 ) )
              = ( ord_less @ real @ X @ Y2 ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3170_lemma__tan__total1,axiom,
    ! [Y2: real] :
    ? [X5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
      & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X5 )
        = Y2 ) ) ).

% lemma_tan_total1
thf(fact_3171_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3172_tan__inverse,axiom,
    ! [Y2: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y2 ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ) ).

% tan_inverse
thf(fact_3173_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( plus_plus @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_3174_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y2 ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3175_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K5 )
         => ( ! [X5: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K5 )
               => ( summable @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) ) ) )
           => ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_3176_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3177_tan__total__pos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X5 )
            = Y2 ) ) ) ).

% tan_total_pos
thf(fact_3178_tan__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3179_tan__mono__le,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y2 )
       => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y2 ) ) ) ) ) ).

% tan_mono_le
thf(fact_3180_tan__mono__le__eq,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X @ Y2 ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3181_tan__bound__pi2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3182_arctan__unique,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X )
            = Y2 )
         => ( ( arctan @ Y2 )
            = X ) ) ) ) ).

% arctan_unique
thf(fact_3183_arctan__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X ) )
          = X ) ) ) ).

% arctan_tan
thf(fact_3184_arctan,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y2 ) )
        = Y2 ) ) ).

% arctan
thf(fact_3185_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X @ Y2 ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3186_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X @ Y2 ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3187_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y2 ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3188_tan__total__pi4,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ? [Z5: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z5 )
          & ( ord_less @ real @ Z5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z5 )
            = X ) ) ) ).

% tan_total_pi4
thf(fact_3189_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_3190_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3191_in__measure,axiom,
    ! [A: $tType,X: A,Y2: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y2 ) ) ) ).

% in_measure
thf(fact_3192_complex__unimodular__polar,axiom,
    ! [Z2: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z2 )
        = ( one_one @ real ) )
     => ~ ! [T6: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
           => ( ( ord_less @ real @ T6 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z2
               != ( complex2 @ ( cos @ real @ T6 ) @ ( sin @ real @ T6 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3193_Maclaurin__exp__lt,axiom,
    ! [X: real,N: nat] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T6 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
            & ( ( exp @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_3194_in__finite__psubset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A3 @ B4 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
        & ( finite_finite @ A @ B4 ) ) ) ).

% in_finite_psubset
thf(fact_3195_sin__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X )
        = ( divide_divide @ real @ ( tan @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3196_real__sqrt__eq__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ( sqrt @ X )
        = ( sqrt @ Y2 ) )
      = ( X = Y2 ) ) ).

% real_sqrt_eq_iff
thf(fact_3197_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_3198_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_3199_real__sqrt__less__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ X @ Y2 ) ) ).

% real_sqrt_less_iff
thf(fact_3200_real__sqrt__le__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ X @ Y2 ) ) ).

% real_sqrt_le_iff
thf(fact_3201_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_3202_real__sqrt__eq__1__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( one_one @ real ) )
      = ( X
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_3203_exp__le__cancel__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X @ Y2 ) ) ).

% exp_le_cancel_iff
thf(fact_3204_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_3205_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_3206_real__sqrt__gt__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_gt_0_iff
thf(fact_3207_real__sqrt__ge__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_ge_0_iff
thf(fact_3208_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_3209_real__sqrt__gt__1__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ).

% real_sqrt_gt_1_iff
thf(fact_3210_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_3211_real__sqrt__ge__1__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 ) ) ).

% real_sqrt_ge_1_iff
thf(fact_3212_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_3213_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ X )
        = ( one_one @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_3214_real__sqrt__abs2,axiom,
    ! [X: real] :
      ( ( sqrt @ ( times_times @ real @ X @ X ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs2
thf(fact_3215_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_3216_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_3217_exp__less__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_3218_one__less__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_less_exp_iff
thf(fact_3219_one__le__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_le_exp_iff
thf(fact_3220_exp__le__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_3221_norm__cos__sin,axiom,
    ! [T2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ ( cos @ real @ T2 ) @ ( sin @ real @ T2 ) ) )
      = ( one_one @ real ) ) ).

% norm_cos_sin
thf(fact_3222_real__sqrt__abs,axiom,
    ! [X: real] :
      ( ( sqrt @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs
thf(fact_3223_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% real_sqrt_pow2_iff
thf(fact_3224_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X ) ) ).

% real_sqrt_pow2
thf(fact_3225_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y2: real,Xa2: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_3226_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A3: A] :
          ( ( times_times @ A @ ( exp @ A @ A3 ) @ A3 )
          = ( times_times @ A @ A3 @ ( exp @ A @ A3 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_3227_real__sqrt__divide,axiom,
    ! [X: real,Y2: real] :
      ( ( sqrt @ ( divide_divide @ real @ X @ Y2 ) )
      = ( divide_divide @ real @ ( sqrt @ X ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_divide
thf(fact_3228_real__sqrt__mult,axiom,
    ! [X: real,Y2: real] :
      ( ( sqrt @ ( times_times @ real @ X @ Y2 ) )
      = ( times_times @ real @ ( sqrt @ X ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_mult
thf(fact_3229_real__sqrt__power,axiom,
    ! [X: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X @ K ) )
      = ( power_power @ real @ ( sqrt @ X ) @ K ) ) ).

% real_sqrt_power
thf(fact_3230_real__sqrt__le__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ X @ Y2 )
     => ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_le_mono
thf(fact_3231_real__sqrt__less__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ X @ Y2 )
     => ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_less_mono
thf(fact_3232_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_exp
thf(fact_3233_real__sqrt__minus,axiom,
    ! [X: real] :
      ( ( sqrt @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_minus
thf(fact_3234_complex__diff,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( minus_minus @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ A2 @ C2 ) @ ( minus_minus @ real @ B2 @ D2 ) ) ) ).

% complex_diff
thf(fact_3235_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_gt_zero
thf(fact_3236_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_zero
thf(fact_3237_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sqrt @ X )
          = ( zero_zero @ real ) )
       => ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_3238_exp__ge__zero,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_ge_zero
thf(fact_3239_not__exp__le__zero,axiom,
    ! [X: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_3240_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_one
thf(fact_3241_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ( times_times @ A @ X @ Y2 )
            = ( times_times @ A @ Y2 @ X ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X @ Y2 ) )
            = ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y2 ) ) ) ) ) ).

% exp_add_commuting
thf(fact_3242_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y2 ) )
          = ( exp @ A @ ( plus_plus @ A @ X @ Y2 ) ) ) ) ).

% mult_exp_exp
thf(fact_3243_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X @ Y2 ) )
          = ( divide_divide @ A @ ( exp @ A @ X ) @ ( exp @ A @ Y2 ) ) ) ) ).

% exp_diff
thf(fact_3244_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_3245_complex__add,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( plus_plus @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( plus_plus @ real @ A2 @ C2 ) @ ( plus_plus @ real @ B2 @ D2 ) ) ) ).

% complex_add
thf(fact_3246_complex__norm,axiom,
    ! [X: real,Y2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X @ Y2 ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3247_exp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) ) ) ).

% exp_gt_one
thf(fact_3248_real__div__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ X @ ( sqrt @ X ) )
        = ( sqrt @ X ) ) ) ).

% real_div_sqrt
thf(fact_3249_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X @ Y2 ) ) @ ( plus_plus @ real @ ( sqrt @ X ) @ ( sqrt @ Y2 ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_3250_exp__ge__add__one__self,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ).

% exp_ge_add_one_self
thf(fact_3251_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y2: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X @ X ) @ ( times_times @ real @ Y2 @ Y2 ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_3252_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( times_times @ A @ ( exp @ A @ X ) @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_3253_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat_mult
thf(fact_3254_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,N: nat] :
          ( ( exp @ A @ ( times_times @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat2_mult
thf(fact_3255_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_3256_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_3257_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3258_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3259_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_3260_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_3261_lemma__exp__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 )
     => ? [X5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less_eq @ real @ X5 @ ( minus_minus @ real @ Y2 @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X5 )
            = Y2 ) ) ) ).

% lemma_exp_total
thf(fact_3262_ln__ge__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ Y2 @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y2 ) @ X ) ) ) ).

% ln_ge_iff
thf(fact_3263_ln__x__over__x__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y2 )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y2 ) @ Y2 ) @ ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_3264_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3265_real__less__rsqrt,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less @ real @ X @ ( sqrt @ Y2 ) ) ) ).

% real_less_rsqrt
thf(fact_3266_real__le__rsqrt,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less_eq @ real @ X @ ( sqrt @ Y2 ) ) ) ).

% real_le_rsqrt
thf(fact_3267_sqrt__le__D,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ Y2 )
     => ( ord_less_eq @ real @ X @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_3268_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_3269_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3270_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) ) @ N )
            = ( exp @ A @ X ) ) ) ) ).

% exp_divide_power_eq
thf(fact_3271_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_3272_real__sqrt__unique,axiom,
    ! [Y2: real,X: real] :
      ( ( ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( sqrt @ X )
          = Y2 ) ) ) ).

% real_sqrt_unique
thf(fact_3273_real__le__lsqrt,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ X @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X ) @ Y2 ) ) ) ) ).

% real_le_lsqrt
thf(fact_3274_lemma__real__divide__sqrt__less,axiom,
    ! [U2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U2 )
     => ( ord_less @ real @ ( divide_divide @ real @ U2 @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U2 ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_3275_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y2 )
     => ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_3276_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X )
     => ( Y2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_3277_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_3278_real__sqrt__sum__squares__ge2,axiom,
    ! [Y2: real,X: real] : ( ord_less_eq @ real @ Y2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_3279_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y2: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_3280_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_3281_sqrt__ge__absD,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ Y2 ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ).

% sqrt_ge_absD
thf(fact_3282_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3283_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_3284_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) )
          = ( power_power @ A @ ( exp @ A @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_3285_real__less__lsqrt,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ X @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X ) @ Y2 ) ) ) ) ).

% real_less_lsqrt
thf(fact_3286_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X @ Y2 ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_3287_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3288_sqrt__even__pow2,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_3289_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ Y2 ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_3290_real__sqrt__ge__abs2,axiom,
    ! [Y2: real,X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_3291_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_3292_ln__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( sqrt @ X ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_3293_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3294_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_3295_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_3296_arsinh__real__aux,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_3297_exp__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_3298_real__sqrt__power__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( sqrt @ X ) @ N )
          = ( power_power @ real @ X @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_3299_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y2: real,Xa2: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_3300_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X @ Y2 ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_3301_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_3302_cos__x__y__le__one,axiom,
    ! [X: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_3303_real__sqrt__sum__squares__less,axiom,
    ! [X: real,U2: real,Y2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ U2 @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( divide_divide @ real @ U2 @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U2 ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_3304_arcosh__real__def,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( arcosh @ real @ X )
        = ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_3305_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ X ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_3306_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ ( uminus_uminus @ real @ X ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_3307_cos__arctan,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3308_sin__arctan,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3309_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z2 ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_3310_Maclaurin__exp__le,axiom,
    ! [X: real,N: nat] :
    ? [T6: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
      & ( ( exp @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_3311_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U2: real,Y2: real] :
      ( ( ord_less @ real @ X @ ( divide_divide @ real @ U2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ U2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U2 ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_3312_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( divide_divide @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_3313_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) )
     => ( ( sin @ real @ X )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3314_arctan__half,axiom,
    ( arctan
    = ( ^ [X2: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X2 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_3315_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X2: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_3316_cos__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3317_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X2: real] : ( ln_ln @ real @ ( plus_plus @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_3318_binomial__code,axiom,
    ( binomial
    = ( ^ [N2: nat,K2: nat] : ( if @ nat @ ( ord_less @ nat @ N2 @ K2 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K2 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ K2 ) @ ( one_one @ nat ) ) @ N2 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K2 ) ) ) ) ) ) ).

% binomial_code
thf(fact_3319_cos__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3320_sin__arccos__abs,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y2 ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3321_sin__arccos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3322_binomial__n__n,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ N )
      = ( one_one @ nat ) ) ).

% binomial_n_n
thf(fact_3323_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N @ K ) ) ).

% binomial_eq_0_iff
thf(fact_3324_binomial__Suc__Suc,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_3325_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_3326_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3327_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) )
      = ( ord_less_eq @ nat @ K @ N ) ) ).

% zero_less_binomial_iff
thf(fact_3328_arccos__minus__1,axiom,
    ( ( arccos @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = pi ) ).

% arccos_minus_1
thf(fact_3329_cos__arccos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y2 ) )
          = Y2 ) ) ) ).

% cos_arccos
thf(fact_3330_sin__arcsin,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y2 ) )
          = Y2 ) ) ) ).

% sin_arcsin
thf(fact_3331_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3332_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3333_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3334_choose__one,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( one_one @ nat ) )
      = N ) ).

% choose_one
thf(fact_3335_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ N @ K )
     => ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_3336_Suc__times__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) ) ).

% Suc_times_binomial
thf(fact_3337_Suc__times__binomial__eq,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_3338_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( binomial @ N @ ( minus_minus @ nat @ N @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_3339_choose__mult__lemma,axiom,
    ! [M: nat,R: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_3340_binomial__le__pow,axiom,
    ! [R: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R @ N )
     => ( ord_less_eq @ nat @ ( binomial @ N @ R ) @ ( power_power @ nat @ N @ R ) ) ) ).

% binomial_le_pow
thf(fact_3341_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) ) ) ).

% zero_less_binomial
thf(fact_3342_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_3343_binomial__Suc__Suc__eq__times,axiom,
    ! [N: nat,K: nat] :
      ( ( binomial @ ( suc @ N ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( binomial @ N @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_3344_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( times_times @ nat @ ( binomial @ N @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N @ K ) @ ( binomial @ ( minus_minus @ nat @ N @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_3345_binomial__absorb__comp,axiom,
    ! [N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N @ K ) @ ( binomial @ N @ K ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_3346_arccos__le__arccos,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3347_arccos__eq__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X )
          = ( arccos @ Y2 ) )
        = ( X = Y2 ) ) ) ).

% arccos_eq_iff
thf(fact_3348_arccos__le__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X ) @ ( arccos @ Y2 ) )
          = ( ord_less_eq @ real @ Y2 @ X ) ) ) ) ).

% arccos_le_mono
thf(fact_3349_arcsin__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ real @ ( arcsin @ X ) ) ) ) ) ).

% arcsin_minus
thf(fact_3350_arcsin__le__arcsin,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y2 ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_3351_arcsin__eq__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X )
            = ( arcsin @ Y2 ) )
          = ( X = Y2 ) ) ) ) ).

% arcsin_eq_iff
thf(fact_3352_arcsin__le__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y2 ) )
          = ( ord_less_eq @ real @ X @ Y2 ) ) ) ) ).

% arcsin_le_mono
thf(fact_3353_binomial__absorption,axiom,
    ! [K: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N @ ( suc @ K ) ) )
      = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_3354_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( binomial @ N @ K ) )
        = ( semiring_char_0_fact @ nat @ N ) ) ) ).

% binomial_fact_lemma
thf(fact_3355_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_3356_binomial__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_mono
thf(fact_3357_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% binomial_maximum'
thf(fact_3358_binomial__maximum,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_3359_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less_eq @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_3360_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% binomial_le_pow2
thf(fact_3361_arccos__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) ) ) ) ).

% arccos_lbound
thf(fact_3362_arccos__less__arccos,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y2 ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3363_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_3364_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_3365_arccos__less__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X ) @ ( arccos @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X ) ) ) ) ).

% arccos_less_mono
thf(fact_3366_arccos__ubound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3367_arccos__cos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( arccos @ ( cos @ real @ X ) )
          = X ) ) ) ).

% arccos_cos
thf(fact_3368_arcsin__less__arcsin,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y2 ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3369_arcsin__less__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y2 ) )
          = ( ord_less @ real @ X @ Y2 ) ) ) ) ).

% arcsin_less_mono
thf(fact_3370_cos__arccos__abs,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y2 ) )
        = Y2 ) ) ).

% cos_arccos_abs
thf(fact_3371_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3372_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_3373_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_3374_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N )
       => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K7 ) ) ) ) ).

% binomial_strict_mono
thf(fact_3375_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K7 @ N )
         => ( ord_less @ nat @ ( binomial @ N @ K7 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_3376_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( binomial @ N @ ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_3377_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_3378_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_3379_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_3380_arccos__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3381_arccos__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3382_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3383_arccos__cos2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( arccos @ ( cos @ real @ X ) )
          = ( uminus_uminus @ real @ X ) ) ) ) ).

% arccos_cos2
thf(fact_3384_arccos__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ) ).

% arccos_minus
thf(fact_3385_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3386_choose__two,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_3387_arccos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y2 ) )
            = Y2 ) ) ) ) ).

% arccos
thf(fact_3388_arccos__minus__abs,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ).

% arccos_minus_abs
thf(fact_3389_arccos__le__pi2,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3390_arcsin__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3391_arcsin__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3392_arcsin__ubound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3393_arcsin__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) ) ) ) ).

% arcsin_lbound
thf(fact_3394_arcsin__sin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X ) )
          = X ) ) ) ).

% arcsin_sin
thf(fact_3395_le__arcsin__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y2 @ ( arcsin @ X ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ X ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3396_arcsin__le__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ Y2 )
              = ( ord_less_eq @ real @ X @ ( sin @ real @ Y2 ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3397_arcsin__pi,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin_pi
thf(fact_3398_arcsin,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin
thf(fact_3399_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K3: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K3 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3400_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_3401_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_3402_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_3403_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_3404_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I4: A] : ( plus_plus @ A @ I4 @ ( one_one @ A ) )
              @ N2
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_3405_VEBT__internal_OminNull_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Y2: $o] :
      ( ( ( vEBT_VEBT_minNull @ X )
        = Y2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ X )
       => ( ( ( X
              = ( vEBT_Leaf @ $false @ $false ) )
           => ( Y2
             => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $false @ $false ) ) ) )
         => ( ! [Uv2: $o] :
                ( ( X
                  = ( vEBT_Leaf @ $true @ Uv2 ) )
               => ( ~ Y2
                 => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $true @ Uv2 ) ) ) )
           => ( ! [Uu2: $o] :
                  ( ( X
                    = ( vEBT_Leaf @ Uu2 @ $true ) )
                 => ( ~ Y2
                   => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ Uu2 @ $true ) ) ) )
             => ( ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) )
                   => ( Y2
                     => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) ) ) )
               => ~ ! [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) )
                     => ( ~ Y2
                       => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.minNull.pelims(1)
thf(fact_3406_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I2 @ K ) ) ) ).

% atMost_iff
thf(fact_3407_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% pochhammer_1
thf(fact_3408_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X ) @ ( set_ord_atMost @ A @ Y2 ) )
          = ( ord_less_eq @ A @ X @ Y2 ) ) ) ).

% atMost_subset_iff
thf(fact_3409_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_3410_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L2: A,H2: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L2 @ H2 )
            | ( ord_less_eq @ A @ H2 @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_3411_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_3412_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U3: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ U3 ) ) ) ) ) ).

% atMost_def
thf(fact_3413_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_pos
thf(fact_3414_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_3415_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_3416_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_3417_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Iic_le_Icc
thf(fact_3418_finite__nat__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S5: set @ nat] :
        ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S5 @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ).

% finite_nat_iff_bounded_le
thf(fact_3419_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_nonneg
thf(fact_3420_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N: nat,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N ) @ I2 )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N @ ( Inc @ I2 ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_3421_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K2 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_3422_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I2: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I2 )
          = I2 ) ) ).

% of_nat_aux.simps(1)
thf(fact_3423_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_3424_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_3425_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% pochhammer_rec
thf(fact_3426_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_3427_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_3428_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,K: nat] :
          ( ( ord_less @ nat @ N @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_3429_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_3430_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ? [K2: nat] :
                ( ( ord_less @ nat @ K2 @ N )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K2 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_3431_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_3432_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_3433_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ ( F2 @ ( suc @ I4 ) ) )
            @ ( set_ord_atMost @ nat @ I2 ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I2 ) ) ) ) ) ).

% sum_telescope
thf(fact_3434_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z2: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z2 @ ( plus_plus @ nat @ N @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ N ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_3435_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,D2: nat > A] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( D2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
               => ( ( C2 @ I4 )
                  = ( D2 @ I4 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_3436_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B4: A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N3 ) )
         => ( ! [N3: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N3 ) ) @ B4 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_3437_sum__choose__lower,axiom,
    ! [R: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( binomial @ ( plus_plus @ nat @ R @ K2 ) @ K2 )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R @ N ) ) @ N ) ) ).

% sum_choose_lower
thf(fact_3438_choose__rising__sum_I1_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N @ J3 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_3439_choose__rising__sum_I2_J,axiom,
    ! [N: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N @ J3 ) @ N )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_3440_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
               => ( ( C2 @ I4 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_3441_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N: nat,K: nat] :
          ( ! [W2: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_3442_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_3443_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_3444_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,Z2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z2 @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_3445_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_3446_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K2: nat] : ( binomial @ ( minus_minus @ nat @ N @ K2 ) @ ( minus_minus @ nat @ M @ K2 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_3447_vandermonde,axiom,
    ! [M: nat,N: nat,R: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( binomial @ M @ K2 ) @ ( binomial @ N @ ( minus_minus @ nat @ R @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ R ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N ) @ R ) ) ).

% vandermonde
thf(fact_3448_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_3449_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X2: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
                & ( ( C2 @ I4 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_3450_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_3451_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) )
         => ~ ! [B6: nat > A] :
                ~ ! [Z3: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z3 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z3 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( B6 @ I4 ) @ ( power_power @ A @ Z3 @ I4 ) )
                        @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_3452_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N: nat,A2: A] :
        ? [B6: nat > A] :
        ! [Z3: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z3 @ I4 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z3 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( B6 @ I4 ) @ ( power_power @ A @ Z3 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_3453_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_3454_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R ) @ K ) )
          = ( times_times @ A @ R @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_3455_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_3456_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_3457_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( summable @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I4 ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_3458_choose__row__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N ) @ ( set_ord_atMost @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% choose_row_sum
thf(fact_3459_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I4 ) ) )
                    @ ( set_ord_atMost @ nat @ K2 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_3460_binomial,axiom,
    ! [A2: nat,B2: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K2 ) ) @ ( power_power @ nat @ A2 @ K2 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_3461_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.in_pairs_0
thf(fact_3462_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N: nat,B2: nat > A,X: A] :
          ( ! [I3: nat] :
              ( ( ord_less @ nat @ M @ I3 )
             => ( ( A2 @ I3 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J3: nat] : ( times_times @ A @ ( B2 @ J3 ) @ ( power_power @ A @ X @ J3 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_3463_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,K: A] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X2: nat] :
                ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) )
               => ( ( C2 @ X2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_3464_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K2 ) ) @ ( power_power @ A @ A2 @ K2 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_3465_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_3466_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_3467_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N: nat,B2: nat > nat,X: nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ M @ I3 )
         => ( ( A2 @ I3 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( power_power @ nat @ X @ I4 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J3: nat] : ( times_times @ nat @ ( B2 @ J3 ) @ ( power_power @ nat @ X @ J3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K2: nat] : ( times_times @ nat @ ( A2 @ K2 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K2 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_3468_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K2: nat] : ( power_power @ nat @ ( binomial @ N @ K2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_3469_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K2 ) ) )
         => ( ( summable @ real
              @ ^ [K2: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K2 ) ) )
           => ( sums @ A
              @ ^ [K2: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K2 @ I4 ) ) )
                  @ ( set_ord_atMost @ nat @ K2 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_3470_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P2: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P2 )
         => ( ( ord_less_eq @ nat @ K @ P2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P2 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_3471_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,Z2: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( ( power_power @ A @ Z2 @ N )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I4
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I4 = N ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_3472_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_3473_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_3474_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J3 @ K2 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y2 @ K2 ) ) @ ( power_power @ A @ X @ J3 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ J3 ) ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_3475_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N2: nat] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_3476_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_3477_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( times_times @ nat @ I4 @ ( binomial @ N @ I4 ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_3478_VEBT__internal_OminNull_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ X )
     => ( ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ X )
       => ( ! [Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ $true @ Uv2 ) )
             => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $true @ Uv2 ) ) )
         => ( ! [Uu2: $o] :
                ( ( X
                  = ( vEBT_Leaf @ Uu2 @ $true ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ Uu2 @ $true ) ) )
           => ~ ! [Uz2: product_prod @ nat @ nat,Va3: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) )
                 => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb2 @ Vc2 ) ) ) ) ) ) ) ).

% VEBT_internal.minNull.pelims(3)
thf(fact_3479_VEBT__internal_OminNull_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ X )
     => ( ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ X )
       => ( ( ( X
              = ( vEBT_Leaf @ $false @ $false ) )
           => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) ) ) ) ) ) ).

% VEBT_internal.minNull.pelims(2)
thf(fact_3480_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_3481_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E: real,C2: nat > A,N: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ? [M8: real] :
            ! [Z3: A] :
              ( ( ord_less_eq @ real @ M8 @ ( real_V7770717601297561774m_norm @ A @ Z3 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z3 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N ) ) )
                @ ( times_times @ real @ E @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ ( suc @ N ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_3482_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ I4 @ J3 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
                    @ ( power_power @ A @ X @ J3 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_3483_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_3484_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P5 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y2 ) ) ) ) ).

% sin_x_sin_y
thf(fact_3485_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P5 @ N2 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X @ Y2 ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_3486_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N2 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P5 @ N2 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y2 ) ) ) ) ).

% cos_x_cos_y
thf(fact_3487_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z2: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z2 @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] : ( plus_plus @ A @ Z2 @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_3488_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_3489_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N2: nat] : N2 ) ) ).

% of_nat_id
thf(fact_3490_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X: A,A2: real,Y2: A] :
          ( ( times_times @ A @ X @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y2 ) ) ) ) ).

% mult_scaleR_right
thf(fact_3491_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X: A,Y2: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ Y2 )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X @ Y2 ) ) ) ) ).

% mult_scaleR_left
thf(fact_3492_scaleR__one,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( one_one @ real ) @ X )
          = X ) ) ).

% scaleR_one
thf(fact_3493_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X ) ) ) ).

% scaleR_scaleR
thf(fact_3494_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% gbinomial_1
thf(fact_3495_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu3: B] : ( one_one @ A )
            @ A3 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_3496_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_3497_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_3498_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U2: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U2 @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U2 @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U2
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_3499_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: real,Y2: A,N: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Y2 ) @ N )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X @ N ) @ ( power_power @ A @ Y2 @ N ) ) ) ) ).

% scaleR_power
thf(fact_3500_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_3501_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( A2 = K2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_3502_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( one_one @ A ) )
                  @ S2 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_3503_scaleR__minus1__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
          = ( uminus_uminus @ A @ X ) ) ) ).

% scaleR_minus1_left
thf(fact_3504_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U2: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U2 ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U2 @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_3505_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_3506_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_3507_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_scaleR
thf(fact_3508_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U2: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U2 ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_3509_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_3510_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U2: num,V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U2 ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U2 ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_3511_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_3512_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_3513_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% norm_prod_le
thf(fact_3514_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
           != ( one_one @ A ) )
         => ~ ! [A6: B] :
                ( ( member @ B @ A6 @ A3 )
               => ( ( G @ A6 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_3515_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ( G @ X5 )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_3516_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y2 ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ).

% scaleR_right_distrib
thf(fact_3517_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_3518_scaleR__right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X @ Y2 ) )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ).

% scaleR_right_diff_distrib
thf(fact_3519_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ ( G @ X2 ) @ ( H2 @ X2 ) )
            @ A3 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A3 ) ) ) ) ).

% prod.distrib
thf(fact_3520_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ A3 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_dividef
thf(fact_3521_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A3: set @ A,N: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ N )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ A3 ) ) ) ).

% prod_power_distrib
thf(fact_3522_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I4: B] : ( modulo_modulo @ A @ ( F2 @ I4 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_prod_eq
thf(fact_3523_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_mono
thf(fact_3524_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_nonneg
thf(fact_3525_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_pos
thf(fact_3526_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_ge_1
thf(fact_3527_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ).

% scaleR_left_distrib
thf(fact_3528_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: real,Y2: real,Xa2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X @ Y2 ) @ Xa2 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Xa2 ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ Xa2 ) ) ) ) ).

% scaleR_left.add
thf(fact_3529_scaleR__left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ).

% scaleR_left_diff_distrib
thf(fact_3530_scaleR__left_Odiff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: real,Y2: real,Xa2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ X @ Y2 ) @ Xa2 )
          = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Xa2 ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ Xa2 ) ) ) ) ).

% scaleR_left.diff
thf(fact_3531_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( P @ X2 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_filter
thf(fact_3532_complex__scaleR,axiom,
    ! [R: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R @ A2 ) @ ( times_times @ real @ R @ B2 ) ) ) ).

% complex_scaleR
thf(fact_3533_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A3: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A4: B] : ( power_power @ A @ C2 @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% power_sum
thf(fact_3534_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_3535_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X5 ) )
                & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_3536_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R2: A > A > $o,S2: set @ B,H2: B > A,G: B > A] :
          ( ( R2 @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X15: A,Y15: A,X23: A,Y23: A] :
                ( ( ( R2 @ X15 @ X23 )
                  & ( R2 @ Y15 @ Y23 ) )
               => ( R2 @ ( times_times @ A @ X15 @ Y15 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S2 )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S2 )
                   => ( R2 @ ( H2 @ X5 ) @ ( G @ X5 ) ) )
               => ( R2 @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_3537_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B4: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( ! [A6: B] :
                  ( ( member @ B @ A6 @ A3 )
                 => ( dvd_dvd @ A @ ( F2 @ A6 ) @ ( G @ A6 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_3538_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ B,A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B4 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B4 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_3539_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T5: set @ C,S2: set @ B,I2: C > B,J: B > C,T4: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A6: B] :
                  ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                 => ( ( I2 @ ( J @ A6 ) )
                    = A6 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) )
                   => ( member @ C @ ( J @ A6 ) @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) )
                     => ( ( J @ ( I2 @ B6 ) )
                        = B6 ) )
                 => ( ! [B6: C] :
                        ( ( member @ C @ B6 @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) )
                       => ( member @ B @ ( I2 @ B6 ) @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) ) )
                   => ( ! [A6: B] :
                          ( ( member @ B @ A6 @ S4 )
                         => ( ( G @ A6 )
                            = ( one_one @ A ) ) )
                     => ( ! [B6: C] :
                            ( ( member @ C @ B6 @ T5 )
                           => ( ( H2 @ B6 )
                              = ( one_one @ A ) ) )
                       => ( ! [A6: B] :
                              ( ( member @ B @ A6 @ S2 )
                             => ( ( H2 @ ( J @ A6 ) )
                                = ( G @ A6 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T4 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_3540_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3541_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3542_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3543_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3544_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3545_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,Y2: A,A2: real] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3546_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3547_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_3548_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3549_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3550_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_3551_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( G @ X2 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_3552_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_3553_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_3554_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_3555_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,I2: A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( member @ A @ I2 @ I5 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) )
             => ( ! [I3: A] :
                    ( ( member @ A @ I3 @ I5 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_3556_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I3: A] :
                  ( ( member @ A @ I3 @ I5 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I3 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_3557_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_3558_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B4 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C5 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_3559_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C5: set @ B,A3: set @ B,B4: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B4 @ C5 )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ ( minus_minus @ ( set @ B ) @ C5 @ A3 ) )
                   => ( ( G @ A6 )
                      = ( one_one @ A ) ) )
               => ( ! [B6: B] :
                      ( ( member @ B @ B6 @ ( minus_minus @ ( set @ B ) @ C5 @ B4 ) )
                     => ( ( H2 @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C5 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C5 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B4 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_3560_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T4: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T4 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_3561_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T4: set @ B,S2: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T4 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_3562_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T4: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( H2 @ X5 )
                    = ( one_one @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T4 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_3563_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T4: set @ B,S2: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ! [X5: B] :
                    ( ( member @ B @ X5 @ S2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T4 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_3564_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_3565_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_3566_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_3567_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3568_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3569_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A,Y2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y2 ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3570_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3571_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3572_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3573_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3574_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3575_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3576_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3577_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ X ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3578_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X )
          = ( plus_plus @ A @ X @ X ) ) ) ).

% scaleR_2
thf(fact_3579_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_3580_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_3581_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_3582_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_3583_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_3584_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_3585_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_3586_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_3587_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X2: nat] : X2
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod
thf(fact_3588_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( times_times @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_3589_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ A3 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                  & ( ord_less @ A @ ( F2 @ I3 ) @ ( G @ I3 ) ) ) )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_3590_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
            = ( ? [X2: B] :
                  ( ( member @ B @ X2 @ A3 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_3591_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A,P2: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P2 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_3592_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_converges
thf(fact_3593_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ) ).

% sin_def
thf(fact_3594_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_converges
thf(fact_3595_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ) ).

% cos_def
thf(fact_3596_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_3597_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_3598_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_3599_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_3600_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_3601_norm__prod__diff,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I5: set @ I7,Z2: I7 > A,W: I7 > A] :
          ( ! [I3: I7] :
              ( ( member @ I7 @ I3 @ I5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z2 @ I3 ) ) @ ( one_one @ real ) ) )
         => ( ! [I3: I7] :
                ( ( member @ I7 @ I3 @ I5 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I3 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I7 @ A @ Z2 @ I5 ) @ ( groups7121269368397514597t_prod @ I7 @ A @ W @ I5 ) ) )
              @ ( groups7311177749621191930dd_sum @ I7 @ real
                @ ^ [I4: I7] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z2 @ I4 ) @ ( W @ I4 ) ) )
                @ I5 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_3602_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_3603_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_3604_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B4: set @ A,A3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
           => ( ! [B6: A] :
                  ( ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B6 ) ) )
             => ( ! [A6: A] :
                    ( ( member @ A @ A6 @ A3 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A6 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B4 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_3605_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K2 ) ) @ K2 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_3606_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 ) ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_minus_converges
thf(fact_3607_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N2 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_minus_converges
thf(fact_3608_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_3609_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_3610_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A4 ) @ ( one_one @ A ) ) @ K2 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_3611_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_3612_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_3613_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_3614_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_3615_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_3616_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_3617_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_3618_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_3619_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_3620_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A4 ) @ K2 ) ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_3621_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K2 ) ) @ ( one_one @ A ) ) @ K2 ) @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_3622_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_3623_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P2: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P2 )
         => ( ( ord_less_eq @ nat @ K @ P2 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P2 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_3624_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_3625_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_3626_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_3627_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K2 ) ) @ K2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K2 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_3628_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K2 ) @ A2 ) @ ( one_one @ A ) ) @ K2 ) @ ( power_power @ A @ X @ K2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( minus_minus @ nat @ M @ K2 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_3629_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( if @ A
              @ ( K2
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L: nat] : ( times_times @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ L ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K2 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_3630_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K2: nat] : ( times_times @ A @ ( gbinomial @ A @ R @ K2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K2 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_3631_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_3632_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X2 )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X2 @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_3633_Maclaurin__sin__bound,axiom,
    ! [X: real,N: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( abs_abs @ real @ X ) @ N ) ) ) ).

% Maclaurin_sin_bound
thf(fact_3634_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_3635_cot__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3636_i__even__power,axiom,
    ! [N: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N ) ) ).

% i_even_power
thf(fact_3637_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
          = A2 ) ) ).

% inverse_inverse_eq
thf(fact_3638_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_3639_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3640_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3641_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3642_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A] :
          ( ( ( inverse_inverse @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3643_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3644_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_3645_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% inverse_minus_eq
thf(fact_3646_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ).

% abs_inverse
thf(fact_3647_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3648_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3649_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3650_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3651_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3652_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3653_norm__ii,axiom,
    ( ( real_V7770717601297561774m_norm @ complex @ imaginary_unit )
    = ( one_one @ real ) ) ).

% norm_ii
thf(fact_3654_prod__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A3 )
          = ( one_one @ nat ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( ( F2 @ X2 )
                = ( one_one @ nat ) ) ) ) ) ) ).

% prod_eq_1_iff
thf(fact_3655_divide__i,axiom,
    ! [X: complex] :
      ( ( divide_divide @ complex @ X @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X ) ) ).

% divide_i
thf(fact_3656_complex__i__mult__minus,axiom,
    ! [X: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X ) )
      = ( uminus_uminus @ complex @ X ) ) ).

% complex_i_mult_minus
thf(fact_3657_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_3658_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3659_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3660_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3661_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3662_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3663_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A3 ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_3664_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_3665_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3666_divide__numeral__i,axiom,
    ! [Z2: complex,N: num] :
      ( ( divide_divide @ complex @ Z2 @ ( times_times @ complex @ ( numeral_numeral @ complex @ N ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z2 ) ) @ ( numeral_numeral @ complex @ N ) ) ) ).

% divide_numeral_i
thf(fact_3667_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3668_cot__npi,axiom,
    ! [N: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3669_cot__periodic,axiom,
    ! [X: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X ) ) ).

% cot_periodic
thf(fact_3670_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3671_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y2: A,X: A] :
          ( ( ( times_times @ A @ Y2 @ X )
            = ( times_times @ A @ X @ Y2 ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y2 ) @ X )
            = ( times_times @ A @ X @ ( inverse_inverse @ A @ Y2 ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3672_real__sqrt__inverse,axiom,
    ! [X: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_inverse
thf(fact_3673_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_inverse
thf(fact_3674_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3675_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3676_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3677_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3678_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3679_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_3680_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_3681_complex__i__not__one,axiom,
    imaginary_unit
 != ( one_one @ complex ) ).

% complex_i_not_one
thf(fact_3682_complex__i__not__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( numeral_numeral @ complex @ W ) ) ).

% complex_i_not_numeral
thf(fact_3683_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R: real,X: A] :
          ( ( ord_less_eq @ real @ R @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X ) ) @ ( inverse_inverse @ real @ R ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3684_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3685_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3686_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3687_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3688_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3689_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3690_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3691_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3692_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3693_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3694_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3695_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3696_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ ( inverse_inverse @ A @ B3 ) @ A4 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3697_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% divide_inverse
thf(fact_3698_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B3: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B3 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3699_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3700_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3701_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3702_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3703_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3704_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3705_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X2: real,Y: real] : ( times_times @ real @ X2 @ ( inverse_inverse @ real @ Y ) ) ) ) ).

% divide_real_def
thf(fact_3706_semiring__norm_I27_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit0 @ N ) )
      = ( bit1 @ ( bitM @ N ) ) ) ).

% semiring_norm(27)
thf(fact_3707_semiring__norm_I28_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ N ) ) ) ).

% semiring_norm(28)
thf(fact_3708_i__times__eq__iff,axiom,
    ! [W: complex,Z2: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W )
        = Z2 )
      = ( W
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z2 ) ) ) ) ).

% i_times_eq_iff
thf(fact_3709_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3710_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3711_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3712_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3713_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3714_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3715_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3716_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3717_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3718_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3719_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3720_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3721_complex__i__not__neg__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_i_not_neg_numeral
thf(fact_3722_eval__nat__numeral_I2_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_3723_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3724_Complex__eq__i,axiom,
    ! [X: real,Y2: real] :
      ( ( ( complex2 @ X @ Y2 )
        = imaginary_unit )
      = ( ( X
          = ( zero_zero @ real ) )
        & ( Y2
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3725_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3726_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3727_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3728_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3729_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3730_one__plus__BitM,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% one_plus_BitM
thf(fact_3731_BitM__plus__one,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ ( bitM @ N ) @ one2 )
      = ( bit0 @ N ) ) ).

% BitM_plus_one
thf(fact_3732_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3733_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) ) @ X ) ) ) ).

% reals_Archimedean
thf(fact_3734_i__mult__Complex,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% i_mult_Complex
thf(fact_3735_Complex__mult__i,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% Complex_mult_i
thf(fact_3736_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X: A,C2: A,Y2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 )
              = Y2 )
            = ( X
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3737_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y2: A,X: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y2
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3738_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3739_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3740_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3741_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3742_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3743_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3744_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3745_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3746_forall__pos__mono__1,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D4: real,E2: real] :
          ( ( ord_less @ real @ D4 @ E2 )
         => ( ( P @ D4 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3747_real__arch__inverse,axiom,
    ! [E: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
      = ( ? [N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ E ) ) ) ) ).

% real_arch_inverse
thf(fact_3748_forall__pos__mono,axiom,
    ! [P: real > $o,E: real] :
      ( ! [D4: real,E2: real] :
          ( ( ord_less @ real @ D4 @ E2 )
         => ( ( P @ D4 )
           => ( P @ E2 ) ) )
     => ( ! [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( P @ E ) ) ) ) ).

% forall_pos_mono
thf(fact_3749_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ ( sqrt @ X ) @ X )
        = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3750_prod__int__plus__eq,axiom,
    ! [I2: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I2 @ ( plus_plus @ nat @ I2 @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X2: int] : X2
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I2 ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I2 @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_3751_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% summable_exp
thf(fact_3752_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ).

% summable_exp_generic
thf(fact_3753_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_3754_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_3755_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) ) @ X ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3756_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3757_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3758_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3759_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3760_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3761_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ X2 ) ) ) ) ) ).

% cot_def
thf(fact_3762_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3763_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3764_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3765_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3766_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) )
          @ ( exp @ A @ X ) ) ) ).

% exp_converges
thf(fact_3767_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ) ).

% exp_def
thf(fact_3768_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N2: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_3769_exp__plus__inverse__exp,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3770_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3771_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3772_tan__cot,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X ) ) ) ).

% tan_cot
thf(fact_3773_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_3774_real__le__x__sinh,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3775_real__le__abs__sinh,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3776_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K2: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K2 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_3777_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y2: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y2 )
            = ( times_times @ A @ Y2 @ X ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y2 ) @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I4 ) ) @ ( power_power @ A @ X @ I4 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ I4 ) ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N @ I4 ) ) ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_3778_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N2 ) ) ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_3779_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3780_cot__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X ) ) ) ) ).

% cot_gt_zero
thf(fact_3781_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X2: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X2 @ N2 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N2: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N2 @ K ) ) ) @ ( power_power @ A @ X2 @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_3782_tan__cot_H,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( cot @ real @ X ) ) ).

% tan_cot'
thf(fact_3783_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3784_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3785_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) )
          @ ( sinh @ A @ X ) ) ) ).

% sinh_converges
thf(fact_3786_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3787_sinh__real__le__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X @ Y2 ) ) ).

% sinh_real_le_iff
thf(fact_3788_sinh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3789_sinh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_nonneg_iff
thf(fact_3790_norm__cis,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( cis @ A2 ) )
      = ( one_one @ real ) ) ).

% norm_cis
thf(fact_3791_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3792_cis__pi,axiom,
    ( ( cis @ pi )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% cis_pi
thf(fact_3793_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3794_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3795_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X2: complex,Y: complex] : ( times_times @ complex @ X2 @ ( inverse_inverse @ complex @ Y ) ) ) ) ).

% divide_complex_def
thf(fact_3796_cis__divide,axiom,
    ! [A2: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% cis_divide
thf(fact_3797_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3798_DeMoivre,axiom,
    ! [A2: real,N: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3799_Arg__bounded,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
      & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ).

% Arg_bounded
thf(fact_3800_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3801_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z ) @ ( exp @ A @ ( uminus_uminus @ A @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3802_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3803_sinh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( sinh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3804_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( bij_betw @ nat @ complex
        @ ^ [K2: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        @ ( set_ord_lessThan @ nat @ N )
        @ ( collect @ complex
          @ ^ [Z: complex] :
              ( ( power_power @ complex @ Z @ N )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_3805_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N2: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ X @ N2 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X ) ) ) ).

% cosh_converges
thf(fact_3806_log__base__10__eq1,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq1
thf(fact_3807_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z6: int,Z: int] :
                ( ( ord_less_eq @ int @ D3 @ Z6 )
                & ( ord_less @ int @ Z6 @ Z ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_3808_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3809_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_3810_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_3811_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less @ real @ X @ Y2 ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_3812_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_3813_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ A2 @ X ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_3814_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_3815_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_3816_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_3817_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_3818_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X ) )
          = ( ord_less_eq @ real @ A2 @ X ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_3819_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_3820_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less_eq @ real @ X @ Y2 ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_3821_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_3822_sinh__le__cosh__real,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_le_cosh_real
thf(fact_3823_cosh__real__nonneg,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_nonneg
thf(fact_3824_cosh__real__nonneg__le__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X @ Y2 ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3825_cosh__real__nonpos__le__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ Y2 @ X ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3826_cosh__real__ge__1,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_ge_1
thf(fact_3827_cosh__real__nonpos__less__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3828_cosh__real__nonneg__less__iff,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ X @ Y2 ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3829_cosh__real__strict__mono,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ Y2 )
       => ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y2 ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3830_log__ln,axiom,
    ( ( ln_ln @ real )
    = ( log @ ( exp @ real @ ( one_one @ real ) ) ) ) ).

% log_ln
thf(fact_3831_arcosh__cosh__real,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( arcosh @ real @ ( cosh @ real @ X ) )
        = X ) ) ).

% arcosh_cosh_real
thf(fact_3832_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_add
thf(fact_3833_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_add
thf(fact_3834_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_diff
thf(fact_3835_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_diff
thf(fact_3836_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% sinh_plus_cosh
thf(fact_3837_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ X ) )
          = ( exp @ A @ X ) ) ) ).

% cosh_plus_sinh
thf(fact_3838_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ X2 ) ) ) ) ) ).

% tanh_def
thf(fact_3839_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X )
          = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_3840_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_3841_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_3842_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S4: set @ B,T5: set @ C,H2: B > C,S2: set @ B,T4: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ S4 )
                   => ( ( G @ ( H2 @ A6 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T5 )
                     => ( ( G @ B6 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                      @ S2 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T4 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_3843_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S4: set @ B,T5: set @ C,H2: B > C,S2: set @ B,T4: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S4 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S2 @ S4 ) @ ( minus_minus @ ( set @ C ) @ T4 @ T5 ) )
             => ( ! [A6: B] :
                    ( ( member @ B @ A6 @ S4 )
                   => ( ( G @ ( H2 @ A6 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B6: C] :
                      ( ( member @ C @ B6 @ T5 )
                     => ( ( G @ B6 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                      @ S2 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T4 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_3844_cosh__minus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( cosh @ A @ X ) @ ( sinh @ A @ X ) )
          = ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) ) ).

% cosh_minus_sinh
thf(fact_3845_sinh__minus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( sinh @ A @ X ) @ ( cosh @ A @ X ) )
          = ( uminus_uminus @ A @ ( exp @ A @ ( uminus_uminus @ A @ X ) ) ) ) ) ).

% sinh_minus_cosh
thf(fact_3846_log__mult,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( times_times @ real @ X @ Y2 ) )
              = ( plus_plus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_mult
thf(fact_3847_log__divide,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( divide_divide @ real @ X @ Y2 ) )
              = ( minus_minus @ real @ ( log @ A2 @ X ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_divide
thf(fact_3848_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_3849_log__base__pow,axiom,
    ! [A2: real,N: nat,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N ) @ X )
        = ( divide_divide @ real @ ( log @ A2 @ X ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log_base_pow
thf(fact_3850_log__nat__power,axiom,
    ! [X: real,B2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ B2 @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ).

% log_nat_power
thf(fact_3851_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X ) ) ) ) ) ) ).

% log_inverse
thf(fact_3852_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X ) ) @ ( cosh @ A @ X ) ) ) ) ).

% sinh_double
thf(fact_3853_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( semiring_1_of_nat @ real @ N )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_3854_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_less
thf(fact_3855_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( ( log @ A2 @ X )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_3856_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_le
thf(fact_3857_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X @ Y2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y2 ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3858_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_3859_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_3860_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z ) @ ( exp @ A @ ( uminus_uminus @ A @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3861_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3862_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3863_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3864_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_less
thf(fact_3865_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3866_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3867_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3868_cosh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( cosh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3869_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_le
thf(fact_3870_log__base__10__eq2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq2
thf(fact_3871_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z6: int,Z: int] :
                ( ( ord_less_eq @ int @ D3 @ Z )
                & ( ord_less @ int @ Z6 @ Z ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_3872_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_3873_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_3874_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_3875_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) )
            = X )
          = ( ? [N2: int] :
                ( X
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_3876_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_3877_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_3878_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 ) ) ) ).

% ceiling_add_of_int
thf(fact_3879_ceiling__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 ) ) ) ).

% ceiling_diff_of_int
thf(fact_3880_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_3881_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_less_ceiling
thf(fact_3882_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_3883_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_3884_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_3885_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_less_ceiling
thf(fact_3886_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_3887_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_3888_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_3889_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_3890_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_3891_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_3892_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_3893_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% ceiling_numeral_power
thf(fact_3894_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_3895_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_3896_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_3897_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_3898_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_3899_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_3900_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_3901_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_3902_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_3903_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_3904_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y2 ) @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% ceiling_mono
thf(fact_3905_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% le_of_int_ceiling
thf(fact_3906_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y2 ) )
         => ( ord_less @ A @ X @ Y2 ) ) ) ).

% ceiling_less_cancel
thf(fact_3907_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% ceiling_ge_round
thf(fact_3908_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% ceiling_le_iff
thf(fact_3909_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_3910_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ).

% less_ceiling_iff
thf(fact_3911_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ Y2 ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y2 ) ) ) ) ).

% ceiling_add_le
thf(fact_3912_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( plus_plus @ A @ R @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_3913_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R ) ) @ ( one_one @ A ) ) @ R ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_3914_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_3915_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I4 ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% ceiling_split
thf(fact_3916_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3917_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z2 ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z2 ) ) ) ) ).

% ceiling_unique
thf(fact_3918_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_3919_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_3920_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3921_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_3922_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ P2 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ Q2 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3923_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) @ P2 ) ) ) ).

% ceiling_divide_lower
thf(fact_3924_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X )
              = ( plus_plus @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_3925_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X )
            & ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_3926_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_3927_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_3928_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I3: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I3 @ J2 )
               => ( P @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I3 @ J2 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_3929_powr__one__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% powr_one_eq_one
thf(fact_3930_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) )
            = X )
          = ( ? [N2: int] :
                ( X
                = ( ring_1_of_int @ A @ N2 ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_3931_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_3932_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_3933_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_3934_powr__nonneg__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_3935_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_3936_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_3937_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% powr_one_gt_zero_iff
thf(fact_3938_powr__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) ).

% powr_one
thf(fact_3939_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_3940_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% numeral_powr_numeral_real
thf(fact_3941_floor__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 ) ) ) ).

% floor_diff_of_int
thf(fact_3942_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_le_floor
thf(fact_3943_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_3944_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_le_floor
thf(fact_3945_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_3946_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_3947_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_3948_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_3949_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_3950_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_3951_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_3952_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_3953_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% floor_numeral_power
thf(fact_3954_log__powr__cancel,axiom,
    ! [A2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y2 ) )
          = Y2 ) ) ) ).

% log_powr_cancel
thf(fact_3955_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X ) )
            = X ) ) ) ) ).

% powr_log_cancel
thf(fact_3956_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_3957_powr__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( numeral_numeral @ real @ N ) )
        = ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% powr_numeral
thf(fact_3958_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_3959_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_3960_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_3961_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_3962_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_le_floor
thf(fact_3963_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_3964_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_3965_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_3966_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_3967_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_3968_square__powr__half,axiom,
    ! [X: real] :
      ( ( powr @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% square_powr_half
thf(fact_3969_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_3970_powr__powr,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ X @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_3971_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) ) ).

% floor_mono
thf(fact_3972_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X ) ) ).

% of_int_floor_le
thf(fact_3973_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y2 ) )
         => ( ord_less @ A @ X @ Y2 ) ) ) ).

% floor_less_cancel
thf(fact_3974_powr__mono2,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_3975_powr__ge__pzero,axiom,
    ! [X: real,Y2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ Y2 ) ) ).

% powr_ge_pzero
thf(fact_3976_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_3977_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_3978_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_mono
thf(fact_3979_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% floor_le_ceiling
thf(fact_3980_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_round @ A @ X ) ) ) ).

% floor_le_round
thf(fact_3981_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ).

% le_floor_iff
thf(fact_3982_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% floor_less_iff
thf(fact_3983_powr__less__mono2,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y2 )
         => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_3984_powr__mono2_H,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ Y2 @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_3985_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y2 ) ) ) ) ).

% le_floor_add
thf(fact_3986_powr__inj,axiom,
    ! [A2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y2 ) )
          = ( X = Y2 ) ) ) ) ).

% powr_inj
thf(fact_3987_gr__one__powr,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X @ Y2 ) ) ) ) ).

% gr_one_powr
thf(fact_3988_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( plus_plus @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ X ) ) ) ) ).

% int_add_floor
thf(fact_3989_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z2 ) ) ) ) ) ).

% floor_add_int
thf(fact_3990_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_3991_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ Y2 )
           => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y2 @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_3992_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_3993_powr__divide,axiom,
    ! [X: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( divide_divide @ real @ X @ Y2 ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_3994_powr__mult,axiom,
    ! [X: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( times_times @ real @ X @ Y2 ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_3995_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L2: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) )
          = ( divide_divide @ int @ K @ L2 ) ) ) ).

% floor_divide_of_int_eq
thf(fact_3996_inverse__powr,axiom,
    ! [Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y2 ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y2 @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_3997_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: nat] :
          ( ( X
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X @ N ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X ) @ N ) ) ) ) ).

% floor_power
thf(fact_3998_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_3999_ln__powr,axiom,
    ! [X: real,Y2: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_powr
thf(fact_4000_log__powr,axiom,
    ! [X: real,B2: real,Y2: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( log @ B2 @ X ) ) ) ) ).

% log_powr
thf(fact_4001_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A,B2: A] :
          ( ( powr @ A @ X @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X @ A2 ) @ ( powr @ A @ X @ B2 ) ) ) ) ).

% powr_add
thf(fact_4002_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_4003_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_4004_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X )
            & ( ord_less @ real @ X @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_4005_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_4006_powr__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
        = ( power_power @ real @ X @ N ) ) ) ).

% powr_realpow
thf(fact_4007_powr__less__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X )
          = ( ord_less @ real @ Y2 @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_less_iff
thf(fact_4008_less__powr__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less @ real @ ( log @ B2 @ X ) @ Y2 ) ) ) ) ).

% less_powr_iff
thf(fact_4009_log__less__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log @ B2 @ X ) @ Y2 )
          = ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_less_iff
thf(fact_4010_less__log__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ Y2 @ ( log @ B2 @ X ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X ) ) ) ) ).

% less_log_iff
thf(fact_4011_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X2: A] :
              ( if @ int
              @ ( X2
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X2 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_4012_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_4013_floor__eq,axiom,
    ! [N: int,X: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq
thf(fact_4014_real__of__int__floor__add__one__gt,axiom,
    ! [R: real] : ( ord_less @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_4015_real__of__int__floor__add__one__ge,axiom,
    ! [R: real] : ( ord_less_eq @ real @ R @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_4016_real__of__int__floor__gt__diff__one,axiom,
    ! [R: real] : ( ord_less @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_4017_real__of__int__floor__ge__diff__one,axiom,
    ! [R: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_4018_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z2 ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z2 ) ) ) ) ).

% floor_unique
thf(fact_4019_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_4020_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I4 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% floor_split
thf(fact_4021_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X: A,A2: A] :
          ( ( powr @ A @ X @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_4022_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_4023_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z2: int,X: A] :
          ( ( ord_less @ int @ Z2 @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_4024_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z2: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z2 )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z2 ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_4025_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_4026_powr__neg__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X ) ) ) ).

% powr_neg_one
thf(fact_4027_powr__mult__base,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y2 ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y2 ) ) ) ) ).

% powr_mult_base
thf(fact_4028_powr__le__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X )
          = ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X ) ) ) ) ) ).

% powr_le_iff
thf(fact_4029_le__powr__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y2 ) ) ) ) ).

% le_powr_iff
thf(fact_4030_log__le__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X ) @ Y2 )
          = ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_le_iff
thf(fact_4031_le__log__iff,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X ) ) ) ) ).

% le_log_iff
thf(fact_4032_floor__eq2,axiom,
    ! [N: int,X: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq2
thf(fact_4033_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_4034_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ Q2 ) @ P2 ) ) ) ).

% floor_divide_lower
thf(fact_4035_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_4036_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X ) ) ) ) ).

% ln_powr_bound2
thf(fact_4037_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ ( log @ B2 @ X ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_4038_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ Y2 @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y2 ) @ X ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_4039_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ Y2 @ ( log @ B2 @ X ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y2 ) @ X ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_4040_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X2: A,A4: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A4 @ ( ln_ln @ A @ X2 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_4041_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q2: A,P2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q2 )
         => ( ord_less @ A @ P2 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P2 @ Q2 ) ) ) @ ( one_one @ A ) ) @ Q2 ) ) ) ) ).

% floor_divide_upper
thf(fact_4042_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_4043_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ ( log @ B2 @ X ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y2 ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_4044_powr__half__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X ) ) ) ).

% powr_half_sqrt
thf(fact_4045_powr__neg__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_4046_floor__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_4047_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X2: A] : ( ln_ln @ A @ ( plus_plus @ A @ X2 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_4048_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X2 ) ) @ ( archimedean_ceiling @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ) ).

% round_altdef
thf(fact_4049_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X2: A] : ( ln_ln @ A @ ( plus_plus @ A @ X2 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_4050_arctan__def,axiom,
    ( arctan
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
              & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X2 )
                = Y ) ) ) ) ) ).

% arctan_def
thf(fact_4051_of__real__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( one_one @ A ) )
          = ( X
            = ( one_one @ real ) ) ) ) ).

% of_real_eq_1_iff
thf(fact_4052_of__real__1,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( one_one @ real ) )
        = ( one_one @ A ) ) ) ).

% of_real_1
thf(fact_4053_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X @ Y2 ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_mult
thf(fact_4054_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_4055_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y2 ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_divide
thf(fact_4056_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,N: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X @ N ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X ) @ N ) ) ) ).

% of_real_power
thf(fact_4057_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X @ Y2 ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_add
thf(fact_4058_of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( minus_minus @ real @ X @ Y2 ) )
          = ( minus_minus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_diff
thf(fact_4059_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_4060_cos__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% cos_of_real_pi
thf(fact_4061_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_4062_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_4063_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_4064_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_4065_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_4066_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_4067_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_4068_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_4069_complex__exp__exists,axiom,
    ! [Z2: complex] :
    ? [A6: complex,R4: real] :
      ( Z2
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R4 ) @ ( exp @ complex @ A6 ) ) ) ).

% complex_exp_exists
thf(fact_4070_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_4071_of__real__def,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A )
        = ( ^ [R5: real] : ( real_V8093663219630862766scaleR @ A @ R5 @ ( one_one @ A ) ) ) ) ) ).

% of_real_def
thf(fact_4072_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) ) ) ).

% frac_ge_0
thf(fact_4073_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_4074_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_4075_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y2: real,X: real] :
          ( ( Y2
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y2 ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_4076_complex__of__real__mult__Complex,axiom,
    ! [R: real,X: real,Y2: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X @ Y2 ) )
      = ( complex2 @ ( times_times @ real @ R @ X ) @ ( times_times @ real @ R @ Y2 ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_4077_Complex__mult__complex__of__real,axiom,
    ! [X: real,Y2: real,R: real] :
      ( ( times_times @ complex @ ( complex2 @ X @ Y2 ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( times_times @ real @ X @ R ) @ ( times_times @ real @ Y2 @ R ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_4078_Complex__add__complex__of__real,axiom,
    ! [X: real,Y2: real,R: real] :
      ( ( plus_plus @ complex @ ( complex2 @ X @ Y2 ) @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( plus_plus @ real @ X @ R ) @ Y2 ) ) ).

% Complex_add_complex_of_real
thf(fact_4079_complex__of__real__add__Complex,axiom,
    ! [R: real,X: real,Y2: real] :
      ( ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( complex2 @ X @ Y2 ) )
      = ( complex2 @ ( plus_plus @ real @ R @ X ) @ Y2 ) ) ).

% complex_of_real_add_Complex
thf(fact_4080_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B3: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_4081_ln__neg__is__const,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X )
        = ( the @ real
          @ ^ [X2: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_4082_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_4083_frac__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_frac @ A )
        = ( ^ [X2: A] : ( minus_minus @ A @ X2 @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ) ) ).

% frac_def
thf(fact_4084_i__complex__of__real,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R ) )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% i_complex_of_real
thf(fact_4085_complex__of__real__i,axiom,
    ! [R: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R ) ) ).

% complex_of_real_i
thf(fact_4086_Complex__eq,axiom,
    ( complex2
    = ( ^ [A4: real,B3: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A4 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B3 ) ) ) ) ) ).

% Complex_eq
thf(fact_4087_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_4088_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_4089_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y2 ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y2 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_4090_complex__split__polar,axiom,
    ! [Z2: complex] :
    ? [R4: real,A6: real] :
      ( Z2
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R4 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A6 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A6 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_4091_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% cos_int_times_real
thf(fact_4092_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X ) ) ) ) ) ).

% sin_int_times_real
thf(fact_4093_arccos__def,axiom,
    ( arccos
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
              & ( ord_less_eq @ real @ X2 @ pi )
              & ( ( cos @ real @ X2 )
                = Y ) ) ) ) ) ).

% arccos_def
thf(fact_4094_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X2: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_4095_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X2: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_4096_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_4097_cmod__complex__polar,axiom,
    ! [R: real,A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) ) )
      = ( abs_abs @ real @ R ) ) ).

% cmod_complex_polar
thf(fact_4098_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y2 ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y2 ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_4099_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X ) )
          = ( cos @ A @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_4100_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X2: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X2 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_4101_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X2: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X2 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_4102_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
              & ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X2 )
                = Y ) ) ) ) ) ).

% arcsin_def
thf(fact_4103_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_4104_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z: complex] :
                ( ( power_power @ complex @ Z @ N )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z: complex] :
                ( ( power_power @ complex @ Z @ N )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4105_even__set__encode__iff,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A3 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4106_modulo__int__unfold,axiom,
    ! [L2: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L2 )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L2 )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L2 ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L2 ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L2 )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_4107_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% sgn_sgn
thf(fact_4108_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_4109_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_4110_sgn__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_one
thf(fact_4111_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_4112_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_4113_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_sgn
thf(fact_4114_real__root__zero,axiom,
    ! [N: nat] :
      ( ( root @ N @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_4115_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% sgn_inverse
thf(fact_4116_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% inverse_sgn
thf(fact_4117_csqrt__eq__1,axiom,
    ! [Z2: complex] :
      ( ( ( csqrt @ Z2 )
        = ( one_one @ complex ) )
      = ( Z2
        = ( one_one @ complex ) ) ) ).

% csqrt_eq_1
thf(fact_4118_csqrt__1,axiom,
    ( ( csqrt @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% csqrt_1
thf(fact_4119_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_4120_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_4121_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_4122_real__root__Suc__0,axiom,
    ! [X: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X )
      = X ) ).

% real_root_Suc_0
thf(fact_4123_root__0,axiom,
    ! [X: real] :
      ( ( root @ ( zero_zero @ nat ) @ X )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_4124_real__root__eq__iff,axiom,
    ! [N: nat,X: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( root @ N @ Y2 ) )
        = ( X = Y2 ) ) ) ).

% real_root_eq_iff
thf(fact_4125_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_4126_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_4127_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_4128_real__root__eq__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_4129_real__root__less__iff,axiom,
    ! [N: nat,X: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y2 ) )
        = ( ord_less @ real @ X @ Y2 ) ) ) ).

% real_root_less_iff
thf(fact_4130_real__root__le__iff,axiom,
    ! [N: nat,X: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y2 ) )
        = ( ord_less_eq @ real @ X @ Y2 ) ) ) ).

% real_root_le_iff
thf(fact_4131_real__root__eq__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( one_one @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_4132_real__root__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_4133_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_4134_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_4135_dvd__mult__sgn__iff,axiom,
    ! [L2: int,K: int,R: int] :
      ( ( dvd_dvd @ int @ L2 @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R ) ) )
      = ( ( dvd_dvd @ int @ L2 @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_4136_dvd__sgn__mult__iff,axiom,
    ! [L2: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ L2 @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ K ) )
      = ( ( dvd_dvd @ int @ L2 @ K )
        | ( R
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_4137_mult__sgn__dvd__iff,axiom,
    ! [L2: int,R: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L2 @ ( sgn_sgn @ int @ R ) ) @ K )
      = ( ( dvd_dvd @ int @ L2 @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_4138_sgn__mult__dvd__iff,axiom,
    ! [R: int,L2: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R ) @ L2 ) @ K )
      = ( ( dvd_dvd @ int @ L2 @ K )
        & ( ( R
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_4139_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_4140_real__root__lt__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_4141_real__root__gt__0__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_gt_0_iff
thf(fact_4142_real__root__ge__0__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_ge_0_iff
thf(fact_4143_real__root__le__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_4144_real__root__lt__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_4145_real__root__gt__1__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_gt_1_iff
thf(fact_4146_real__root__ge__1__iff,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N @ Y2 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_ge_1_iff
thf(fact_4147_real__root__le__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_4148_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sgn_of_nat
thf(fact_4149_power2__csqrt,axiom,
    ! [Z2: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z2 ) ).

% power2_csqrt
thf(fact_4150_real__root__pow__pos2,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos2
thf(fact_4151_real__root__divide,axiom,
    ! [N: nat,X: real,Y2: real] :
      ( ( root @ N @ ( divide_divide @ real @ X @ Y2 ) )
      = ( divide_divide @ real @ ( root @ N @ X ) @ ( root @ N @ Y2 ) ) ) ).

% real_root_divide
thf(fact_4152_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,X: real] :
      ( ( root @ ( times_times @ nat @ M @ N ) @ X )
      = ( root @ M @ ( root @ N @ X ) ) ) ).

% real_root_mult_exp
thf(fact_4153_real__root__mult,axiom,
    ! [N: nat,X: real,Y2: real] :
      ( ( root @ N @ ( times_times @ real @ X @ Y2 ) )
      = ( times_times @ real @ ( root @ N @ X ) @ ( root @ N @ Y2 ) ) ) ).

% real_root_mult
thf(fact_4154_real__root__minus,axiom,
    ! [N: nat,X: real] :
      ( ( root @ N @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( root @ N @ X ) ) ) ).

% real_root_minus
thf(fact_4155_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X @ Y2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( sgn_sgn @ A @ Y2 ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_4156_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_4157_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_4158_real__root__commute,axiom,
    ! [M: nat,N: nat,X: real] :
      ( ( root @ M @ ( root @ N @ X ) )
      = ( root @ N @ ( root @ M @ X ) ) ) ).

% real_root_commute
thf(fact_4159_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_4160_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_4161_real__root__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( root @ N @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( root @ N @ X ) ) ) ).

% real_root_inverse
thf(fact_4162_real__root__pos__pos__le,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ).

% real_root_pos_pos_le
thf(fact_4163_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_4164_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_4165_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) ).

% mult_sgn_abs
thf(fact_4166_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_4167_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_4168_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K2: A] : ( times_times @ A @ K2 @ ( sgn_sgn @ A @ K2 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_4169_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N3: nat,L4: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L4 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ).

% int_sgnE
thf(fact_4170_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_4171_div__eq__sgn__abs,axiom,
    ! [K: int,L2: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L2 ) )
     => ( ( divide_divide @ int @ K @ L2 )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_4172_real__root__less__mono,axiom,
    ! [N: nat,X: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ Y2 )
       => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y2 ) ) ) ) ).

% real_root_less_mono
thf(fact_4173_real__root__le__mono,axiom,
    ! [N: nat,X: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ X @ Y2 )
       => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y2 ) ) ) ) ).

% real_root_le_mono
thf(fact_4174_real__root__power,axiom,
    ! [N: nat,X: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ K ) )
        = ( power_power @ real @ ( root @ N @ X ) @ K ) ) ) ).

% real_root_power
thf(fact_4175_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_4176_real__root__abs,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( abs_abs @ real @ X ) )
        = ( abs_abs @ real @ ( root @ N @ X ) ) ) ) ).

% real_root_abs
thf(fact_4177_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_4178_sgn__mod,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L2 @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L2 ) )
          = ( sgn_sgn @ int @ L2 ) ) ) ) ).

% sgn_mod
thf(fact_4179_real__root__gt__zero,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_gt_zero
thf(fact_4180_real__root__strict__decreasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N4 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X )
         => ( ord_less @ real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_4181_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_4182_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_4183_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X2: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_4184_root__abs__power,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( abs_abs @ real @ ( root @ N @ ( power_power @ real @ Y2 @ N ) ) )
        = ( abs_abs @ real @ Y2 ) ) ) ).

% root_abs_power
thf(fact_4185_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I4: int] :
          ( if @ int
          @ ( I4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_4186_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_4187_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L2: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L2 ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_4188_div__dvd__sgn__abs,axiom,
    ! [L2: int,K: int] :
      ( ( dvd_dvd @ int @ L2 @ K )
     => ( ( divide_divide @ int @ K @ L2 )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L2 ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_4189_of__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X ) ) ) ) ).

% of_real_sqrt
thf(fact_4190_real__root__pos__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_pos_pos
thf(fact_4191_real__root__strict__increasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_4192_real__root__decreasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N4 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ord_less_eq @ real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_decreasing
thf(fact_4193_real__root__pow__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos
thf(fact_4194_real__root__pos__unique,axiom,
    ! [N: nat,Y2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( power_power @ real @ Y2 @ N )
            = X )
         => ( ( root @ N @ X )
            = Y2 ) ) ) ) ).

% real_root_pos_unique
thf(fact_4195_real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ ( power_power @ real @ X @ N ) )
          = X ) ) ) ).

% real_root_power_cancel
thf(fact_4196_odd__real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ N ) )
        = X ) ) ).

% odd_real_root_power_cancel
thf(fact_4197_odd__real__root__unique,axiom,
    ! [N: nat,Y2: real,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ( power_power @ real @ Y2 @ N )
          = X )
       => ( ( root @ N @ X )
          = Y2 ) ) ) ).

% odd_real_root_unique
thf(fact_4198_odd__real__root__pow,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( power_power @ real @ ( root @ N @ X ) @ N )
        = X ) ) ).

% odd_real_root_pow
thf(fact_4199_real__root__increasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N4 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_4200_eucl__rel__int__remainderI,axiom,
    ! [R: int,L2: int,K: int,Q2: int] :
      ( ( ( sgn_sgn @ int @ R )
        = ( sgn_sgn @ int @ L2 ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ L2 ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q2 @ L2 ) @ R ) )
         => ( eucl_rel_int @ K @ L2 @ ( product_Pair @ int @ int @ Q2 @ R ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_4201_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% ln_root
thf(fact_4202_log__root,axiom,
    ! [N: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_root
thf(fact_4203_log__base__root,axiom,
    ! [N: nat,B2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N @ B2 ) @ X )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log @ B2 @ X ) ) ) ) ) ).

% log_base_root
thf(fact_4204_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A12: int,A23: int,A33: product_prod @ int @ int] :
          ( ? [K2: int] :
              ( ( A12 = K2 )
              & ( A23
                = ( zero_zero @ int ) )
              & ( A33
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K2 ) ) )
          | ? [L: int,K2: int,Q4: int] :
              ( ( A12 = K2 )
              & ( A23 = L )
              & ( A33
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L
               != ( zero_zero @ int ) )
              & ( K2
                = ( times_times @ int @ Q4 @ L ) ) )
          | ? [R5: int,L: int,K2: int,Q4: int] :
              ( ( A12 = K2 )
              & ( A23 = L )
              & ( A33
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L ) )
              & ( K2
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_4205_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A1 @ A22 @ A32 )
     => ( ( ( A22
            = ( zero_zero @ int ) )
         => ( A32
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A1 ) ) )
       => ( ! [Q3: int] :
              ( ( A32
                = ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) )
             => ( ( A22
                 != ( zero_zero @ int ) )
               => ( A1
                 != ( times_times @ int @ Q3 @ A22 ) ) ) )
         => ~ ! [R4: int,Q3: int] :
                ( ( A32
                  = ( product_Pair @ int @ int @ Q3 @ R4 ) )
               => ( ( ( sgn_sgn @ int @ R4 )
                    = ( sgn_sgn @ int @ A22 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R4 ) @ ( abs_abs @ int @ A22 ) )
                   => ( A1
                     != ( plus_plus @ int @ ( times_times @ int @ Q3 @ A22 ) @ R4 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_4206_div__noneq__sgn__abs,axiom,
    ! [L2: int,K: int] :
      ( ( L2
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L2 ) )
       => ( ( divide_divide @ int @ K @ L2 )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L2 @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_4207_root__powr__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ X )
          = ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_4208_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4209_divide__int__unfold,axiom,
    ! [L2: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L2 )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L2 )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L2 ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L2 ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_4210_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( L
            = ( zero_zero @ int ) )
          @ K2
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L @ K2 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_4211_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( L
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K2 )
              = ( sgn_sgn @ int @ L ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K2 ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L @ K2 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_4212_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_4213_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_4214_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% mask_nat_positive_iff
thf(fact_4215_sgn__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_4216_zero__le__sgn__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_sgn_iff
thf(fact_4217_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_4218_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_4219_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_4220_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_4221_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_4222_nat__0__iff,axiom,
    ! [I2: int] :
      ( ( ( nat2 @ I2 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I2 @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_4223_nat__le__0,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z2 )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_4224_zless__nat__conj,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
        & ( ord_less @ int @ W @ Z2 ) ) ) ).

% zless_nat_conj
thf(fact_4225_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_4226_int__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
          = Z2 ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_4227_zero__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z2 ) ) ).

% zero_less_nat_eq
thf(fact_4228_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z2 ) )
            = ( ring_1_of_int @ A @ Z2 ) ) ) ) ).

% of_nat_nat
thf(fact_4229_diff__nat__numeral,axiom,
    ! [V: num,V4: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V4 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V4 ) ) ) ) ).

% diff_nat_numeral
thf(fact_4230_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,N: nat,Y2: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
        = ( nat2 @ Y2 ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
        = Y2 ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_4231_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y2: int,X: num,N: nat] :
      ( ( ( nat2 @ Y2 )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( Y2
        = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_4232_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) @ A2 )
      = ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_4233_one__less__nat__eq,axiom,
    ! [Z2: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z2 ) ) ).

% one_less_nat_eq
thf(fact_4234_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_4235_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_4236_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_4237_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_4238_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_4239_less__eq__mask,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% less_eq_mask
thf(fact_4240_nat__mask__eq,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% nat_mask_eq
thf(fact_4241_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_int_mask_eq
thf(fact_4242_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_nat_mask_eq
thf(fact_4243_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I4: num] : ( nat2 @ ( numeral_numeral @ int @ I4 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_4244_nat__mono,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ X @ Y2 )
     => ( ord_less_eq @ nat @ ( nat2 @ X ) @ ( nat2 @ Y2 ) ) ) ).

% nat_mono
thf(fact_4245_eq__nat__nat__iff,axiom,
    ! [Z2: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( ( nat2 @ Z2 )
            = ( nat2 @ Z7 ) )
          = ( Z2 = Z7 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_4246_all__nat,axiom,
    ( ( ^ [P3: nat > $o] :
        ! [X6: nat] : ( P3 @ X6 ) )
    = ( ^ [P4: nat > $o] :
        ! [X2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
         => ( P4 @ ( nat2 @ X2 ) ) ) ) ) ).

% all_nat
thf(fact_4247_ex__nat,axiom,
    ( ( ^ [P3: nat > $o] :
        ? [X6: nat] : ( P3 @ X6 ) )
    = ( ^ [P4: nat > $o] :
        ? [X2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
          & ( P4 @ ( nat2 @ X2 ) ) ) ) ) ).

% ex_nat
thf(fact_4248_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_4249_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M3 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_4250_mask__nonnegative__int,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N ) ) ).

% mask_nonnegative_int
thf(fact_4251_not__mask__negative__int,axiom,
    ! [N: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_4252_sgn__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( sgn_sgn @ real @ ( root @ N @ X ) )
        = ( sgn_sgn @ real @ X ) ) ) ).

% sgn_root
thf(fact_4253_nat__mono__iff,axiom,
    ! [Z2: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W @ Z2 ) ) ) ).

% nat_mono_iff
thf(fact_4254_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] : ( ord_less_eq @ A @ R @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_4255_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z2: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z2 ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z2 ) ) ).

% zless_nat_eq_int_zless
thf(fact_4256_nat__le__iff,axiom,
    ! [X: int,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X ) @ N )
      = ( ord_less_eq @ int @ X @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_le_iff
thf(fact_4257_nat__0__le,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z2 ) )
        = Z2 ) ) ).

% nat_0_le
thf(fact_4258_int__eq__iff,axiom,
    ! [M: nat,Z2: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z2 )
      = ( ( M
          = ( nat2 @ Z2 ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) ) ) ).

% int_eq_iff
thf(fact_4259_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_4260_int__minus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_4261_nat__abs__mult__distrib,axiom,
    ! [W: int,Z2: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z2 ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z2 ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_4262_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_4263_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_4264_real__nat__ceiling__ge,axiom,
    ! [X: real] : ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_4265_less__mask,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ) ).

% less_mask
thf(fact_4266_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_4267_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A4: nat,B3: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_4268_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A4: real] :
          ( if @ real
          @ ( A4
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A4 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_4269_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R ) ) ) @ R ) ) ) ).

% of_nat_floor
thf(fact_4270_nat__less__eq__zless,axiom,
    ! [W: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less @ int @ W @ Z2 ) ) ) ).

% nat_less_eq_zless
thf(fact_4271_nat__le__eq__zle,axiom,
    ! [W: int,Z2: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z2 ) )
        = ( ord_less_eq @ int @ W @ Z2 ) ) ) ).

% nat_le_eq_zle
thf(fact_4272_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_4273_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_4274_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_4275_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% le_nat_iff
thf(fact_4276_nat__add__distrib,axiom,
    ! [Z2: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( nat2 @ ( plus_plus @ int @ Z2 @ Z7 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_4277_nat__mult__distrib,axiom,
    ! [Z2: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) ) ) ) ).

% nat_mult_distrib
thf(fact_4278_Suc__as__int,axiom,
    ( suc
    = ( ^ [A4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_4279_nat__diff__distrib,axiom,
    ! [Z7: int,Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
     => ( ( ord_less_eq @ int @ Z7 @ Z2 )
       => ( ( nat2 @ ( minus_minus @ int @ Z2 @ Z7 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_4280_nat__diff__distrib_H,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( minus_minus @ int @ X @ Y2 ) )
          = ( minus_minus @ nat @ ( nat2 @ X ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_4281_nat__abs__triangle__ineq,axiom,
    ! [K: int,L2: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L2 ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_4282_nat__div__distrib,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib
thf(fact_4283_nat__div__distrib_H,axiom,
    ! [Y2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib'
thf(fact_4284_nat__power__eq,axiom,
    ! [Z2: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( nat2 @ ( power_power @ int @ Z2 @ N ) )
        = ( power_power @ nat @ ( nat2 @ Z2 ) @ N ) ) ) ).

% nat_power_eq
thf(fact_4285_nat__floor__neg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_4286_nat__mod__distrib,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( modulo_modulo @ int @ X @ Y2 ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_4287_div__abs__eq__div__nat,axiom,
    ! [K: int,L2: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_4288_floor__eq3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq3
thf(fact_4289_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X ) @ A2 )
     => ( ord_less_eq @ nat @ X @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_4290_mod__abs__eq__div__nat,axiom,
    ! [K: int,L2: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L2 ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_4291_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_4292_sgn__power__injE,axiom,
    ! [A2: real,N: nat,X: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N ) )
        = X )
     => ( ( X
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_4293_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
     => ( ( suc @ ( nat2 @ Z2 ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z2 ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_4294_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_4295_nat__mult__distrib__neg,axiom,
    ! [Z2: int,Z7: int] :
      ( ( ord_less_eq @ int @ Z2 @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z2 @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z2 ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z7 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_4296_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_4297_floor__eq4,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq4
thf(fact_4298_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_4299_diff__nat__eq__if,axiom,
    ! [Z7: int,Z2: int] :
      ( ( ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) )
          = ( nat2 @ Z2 ) ) )
      & ( ~ ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z2 ) @ ( nat2 @ Z7 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z2 @ Z7 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z2 @ Z7 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_4300_Suc__mask__eq__exp,axiom,
    ! [N: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_mask_eq_exp
thf(fact_4301_mask__nat__less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% mask_nat_less_exp
thf(fact_4302_sgn__power__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N @ X ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N @ X ) ) @ N ) )
        = X ) ) ).

% sgn_power_root
thf(fact_4303_root__sgn__power,axiom,
    ! [N: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( times_times @ real @ ( sgn_sgn @ real @ Y2 ) @ ( power_power @ real @ ( abs_abs @ real @ Y2 ) @ N ) ) )
        = Y2 ) ) ).

% root_sgn_power
thf(fact_4304_nat__dvd__iff,axiom,
    ! [Z2: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z2 ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( dvd_dvd @ int @ Z2 @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z2 )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_4305_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_4306_cis__Arg__unique,axiom,
    ! [Z2: complex,X: real] :
      ( ( ( sgn_sgn @ complex @ Z2 )
        = ( cis @ X ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ( arg @ Z2 )
            = X ) ) ) ) ).

% cis_Arg_unique
thf(fact_4307_split__root,axiom,
    ! [P: real > $o,N: nat,X: real] :
      ( ( P @ ( root @ N @ X ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ! [Y: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) )
                = X )
             => ( P @ Y ) ) ) ) ) ).

% split_root
thf(fact_4308_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N2: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_4309_mask__half__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_4310_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N2: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_4311_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N2: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_4312_Arg__correct,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z2 )
          = ( cis @ ( arg @ Z2 ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z2 ) )
        & ( ord_less_eq @ real @ ( arg @ Z2 ) @ pi ) ) ) ).

% Arg_correct
thf(fact_4313_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_4314_powr__real__of__int,axiom,
    ! [X: real,N: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( power_power @ real @ X @ ( nat2 @ N ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_4315_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X ) ) ) ) ).

% arctan_inverse
thf(fact_4316_num_Osize__gen_I2_J,axiom,
    ! [X22: num] :
      ( ( size_num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_4317_powr__int,axiom,
    ! [X: real,I2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( power_power @ real @ X @ ( nat2 @ I2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I2 )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I2 ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ I2 ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_4318_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_4319_sum__count__set,axiom,
    ! [A: $tType,Xs2: list @ A,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs2 ) @ X8 )
          = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% sum_count_set
thf(fact_4320_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( ( K2
              = ( zero_zero @ int ) )
            | ( L
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L
            @ ( if @ int
              @ ( L
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K2
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_4321_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L2 ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L2 ) ) ) ) ).

% power_numeral
thf(fact_4322_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_4323_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_4324_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_4325_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_4326_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_4327_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_4328_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_4329_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_4330_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_4331_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] :
      ( ( bit_concat_bit @ N @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_4332_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_4333_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_4334_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_4335_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_4336_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_4337_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_4338_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_4339_and__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% and_nonnegative_int_iff
thf(fact_4340_and__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_4341_count__notin,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( count_list @ A @ Xs2 @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_4342_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_4343_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_4344_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_4345_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_4346_take__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% take_bit_of_Suc_0
thf(fact_4347_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_4348_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_4349_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(3)
thf(fact_4350_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_4351_and__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_4352_and__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_4353_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(4)
thf(fact_4354_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(6)
thf(fact_4355_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_4356_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_4357_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_4358_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_4359_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_4360_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_4361_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_4362_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_4363_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_4364_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_4365_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_and_eq
thf(fact_4366_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_4367_take__bit__diff,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L2 ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ L2 ) ) ) ).

% take_bit_diff
thf(fact_4368_take__bit__mult,axiom,
    ! [N: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L2 ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ K @ L2 ) ) ) ).

% take_bit_mult
thf(fact_4369_take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_4370_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_4371_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_and_eq
thf(fact_4372_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_4373_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_4374_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B3: A] : ( bit_se5824344872417868541ns_and @ A @ B3 @ A4 ) ) ) ) ).

% and.commute
thf(fact_4375_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_4376_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q2 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N @ Q2 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_4377_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_4378_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_4379_concat__bit__eq__iff,axiom,
    ! [N: nat,K: int,L2: int,R: int,S: int] :
      ( ( ( bit_concat_bit @ N @ K @ L2 )
        = ( bit_concat_bit @ N @ R @ S ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N @ R ) )
        & ( L2 = S ) ) ) ).

% concat_bit_eq_iff
thf(fact_4380_concat__bit__take__bit__eq,axiom,
    ! [N: nat,B2: int] :
      ( ( bit_concat_bit @ N @ ( bit_se2584673776208193580ke_bit @ int @ N @ B2 ) )
      = ( bit_concat_bit @ N @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_4381_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_4382_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_4383_AND__lower,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X @ Y2 ) ) ) ).

% AND_lower
thf(fact_4384_AND__upper1,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y2 ) @ X ) ) ).

% AND_upper1
thf(fact_4385_AND__upper2,axiom,
    ! [Y2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y2 ) @ Y2 ) ) ).

% AND_upper2
thf(fact_4386_AND__upper1_H,axiom,
    ! [Y2: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z2 ) ) ) ).

% AND_upper1'
thf(fact_4387_AND__upper2_H,axiom,
    ! [Y2: int,Z2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z2 )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y2 ) @ Z2 ) ) ) ).

% AND_upper2'
thf(fact_4388_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% take_bit_nonnegative
thf(fact_4389_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_4390_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_4391_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_4392_not__take__bit__negative,axiom,
    ! [N: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_4393_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_4394_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_4395_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_4396_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_4397_pow_Osimps_I1_J,axiom,
    ! [X: num] :
      ( ( pow @ X @ one2 )
      = X ) ).

% pow.simps(1)
thf(fact_4398_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_4399_AND__upper2_H_H,axiom,
    ! [Y2: int,Z2: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y2 ) @ Z2 ) ) ) ).

% AND_upper2''
thf(fact_4400_AND__upper1_H_H,axiom,
    ! [Y2: int,Z2: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z2 )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z2 ) ) ) ).

% AND_upper1''
thf(fact_4401_and__less__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less @ int @ L2 @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ K ) ) ).

% and_less_eq
thf(fact_4402_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_4403_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_4404_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_4405_even__and__iff__int,axiom,
    ! [K: int,L2: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) ).

% even_and_iff_int
thf(fact_4406_count__le__length,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs2 @ X ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% count_le_length
thf(fact_4407_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_4408_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( modulo_modulo @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_4409_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_4410_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_4411_take__bit__nat__eq__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_4412_take__bit__nat__less__exp,axiom,
    ! [N: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_nat_less_exp
thf(fact_4413_take__bit__nat__eq__self,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_4414_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N2: nat,M3: nat] : ( modulo_modulo @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_nat_def
thf(fact_4415_take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_int_less_exp
thf(fact_4416_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( modulo_modulo @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_def
thf(fact_4417_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_4418_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_4419_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_4420_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_4421_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_4422_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_4423_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_4424_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_4425_take__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_4426_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_4427_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_4428_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_4429_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_4430_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_4431_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_4432_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_4433_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_4434_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( plus_plus @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_4435_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_4436_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_4437_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_4438_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_4439_take__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_4440_and__int_Oelims,axiom,
    ! [X: int,Xa2: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa2 )
        = Y2 )
     => ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4441_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4442_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_4443_insert__subset,axiom,
    ! [A: $tType,X: A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
      = ( ( member @ A @ X @ B4 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% insert_subset
thf(fact_4444_insert__Diff1,axiom,
    ! [A: $tType,X: A,B4: set @ A,A3: set @ A] :
      ( ( member @ A @ X @ B4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
        = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% insert_Diff1
thf(fact_4445_Diff__insert0,axiom,
    ! [A: $tType,X: A,A3: set @ A,B4: set @ A] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
        = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% Diff_insert0
thf(fact_4446_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A3: set @ A] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A3 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_4447_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B2: A] :
      ( ( ( insert @ A @ A2 @ A3 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_4448_insert__Diff__single,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A2 @ A3 ) ) ).

% insert_Diff_single
thf(fact_4449_finite__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) ) )
      = ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% finite_Diff_insert
thf(fact_4450_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_4451_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum.insert
thf(fact_4452_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod.insert
thf(fact_4453_single__Diff__lessThan,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A] :
          ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) @ ( set_ord_lessThan @ A @ K ) )
          = ( insert @ A @ K @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% single_Diff_lessThan
thf(fact_4454_subset__Compl__singleton,axiom,
    ! [A: $tType,A3: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A3 ) ) ) ).

% subset_Compl_singleton
thf(fact_4455_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4456_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_4457_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_4458_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_4459_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_4460_and__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_4461_and__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_4462_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_4463_and__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_4464_Suc__0__and__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_4465_and__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_4466_num__induct,axiom,
    ! [P: num > $o,X: num] :
      ( ( P @ one2 )
     => ( ! [X5: num] :
            ( ( P @ X5 )
           => ( P @ ( inc @ X5 ) ) )
       => ( P @ X ) ) ) ).

% num_induct
thf(fact_4467_insert__mono,axiom,
    ! [A: $tType,C5: set @ A,D5: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ D5 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C5 ) @ ( insert @ A @ A2 @ D5 ) ) ) ).

% insert_mono
thf(fact_4468_subset__insert,axiom,
    ! [A: $tType,X: A,A3: set @ A,B4: set @ A] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% subset_insert
thf(fact_4469_subset__insertI,axiom,
    ! [A: $tType,B4: set @ A,A2: A] : ( ord_less_eq @ ( set @ A ) @ B4 @ ( insert @ A @ A2 @ B4 ) ) ).

% subset_insertI
thf(fact_4470_subset__insertI2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ B4 ) ) ) ).

% subset_insertI2
thf(fact_4471_insert__Diff__if,axiom,
    ! [A: $tType,X: A,B4: set @ A,A3: set @ A] :
      ( ( ( member @ A @ X @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
          = ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) )
      & ( ~ ( member @ A @ X @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B4 )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ).

% insert_Diff_if
thf(fact_4472_add__inc,axiom,
    ! [X: num,Y2: num] :
      ( ( plus_plus @ num @ X @ ( inc @ Y2 ) )
      = ( inc @ ( plus_plus @ num @ X @ Y2 ) ) ) ).

% add_inc
thf(fact_4473_subset__singletonD,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( A3
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_4474_subset__singleton__iff,axiom,
    ! [A: $tType,X8: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X8
          = ( bot_bot @ ( set @ A ) ) )
        | ( X8
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_4475_Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Diff_insert
thf(fact_4476_insert__Diff,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A3 ) ) ).

% insert_Diff
thf(fact_4477_Diff__insert2,axiom,
    ! [A: $tType,A3: set @ A,A2: A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) ).

% Diff_insert2
thf(fact_4478_Diff__insert__absorb,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A3 ) ) ).

% Diff_insert_absorb
thf(fact_4479_subset__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,X: A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ ( insert @ A @ X @ C5 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ C5 ) )
        & ~ ( member @ A @ X @ A3 ) ) ) ).

% subset_Diff_insert
thf(fact_4480_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_4481_inc_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit1 @ X ) )
      = ( bit0 @ ( inc @ X ) ) ) ).

% inc.simps(3)
thf(fact_4482_inc_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit0 @ X ) )
      = ( bit1 @ X ) ) ).

% inc.simps(2)
thf(fact_4483_add__One,axiom,
    ! [X: num] :
      ( ( plus_plus @ num @ X @ one2 )
      = ( inc @ X ) ) ).

% add_One
thf(fact_4484_inc__BitM__eq,axiom,
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% inc_BitM_eq
thf(fact_4485_BitM__inc__eq,axiom,
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) ).

% BitM_inc_eq
thf(fact_4486_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S2: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X5: B,S6: set @ B] :
                  ( ( finite_finite @ B @ S6 )
                 => ( ! [Y3: B] :
                        ( ( member @ B @ Y3 @ S6 )
                       => ( ord_less_eq @ A @ ( F2 @ Y3 ) @ ( F2 @ X5 ) ) )
                   => ( ( P @ S6 )
                     => ( P @ ( insert @ B @ X5 @ S6 ) ) ) ) )
             => ( P @ S2 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4487_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( ord_less @ A @ B6 @ X3 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4488_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B6: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( ord_less @ A @ X3 @ B6 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B6 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4489_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% and_nat_def
thf(fact_4490_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_4491_finite__subset__induct,axiom,
    ! [A: $tType,F4: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A6: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A6 @ A3 )
                 => ( ~ ( member @ A @ A6 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ A6 @ F6 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_4492_finite__subset__induct_H,axiom,
    ! [A: $tType,F4: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A6: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A6 @ A3 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F6 @ A3 )
                   => ( ~ ( member @ A @ A6 @ F6 )
                     => ( ( P @ F6 )
                       => ( P @ ( insert @ A @ A6 @ F6 ) ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_4493_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
                = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_4494_finite__empty__induct,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A3 )
     => ( ( P @ A3 )
       => ( ! [A6: A,A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( member @ A @ A6 @ A8 )
               => ( ( P @ A8 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ A6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% finite_empty_induct
thf(fact_4495_infinite__coinduct,axiom,
    ! [A: $tType,X8: ( set @ A ) > $o,A3: set @ A] :
      ( ( X8 @ A3 )
     => ( ! [A8: set @ A] :
            ( ( X8 @ A8 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A8 )
                & ( ( X8 @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite @ A @ A3 ) ) ) ).

% infinite_coinduct
thf(fact_4496_infinite__remove,axiom,
    ! [A: $tType,S2: set @ A,A2: A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ~ ( finite_finite @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_remove
thf(fact_4497_Diff__single__insert,axiom,
    ! [A: $tType,A3: set @ A,X: A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) ) ) ).

% Diff_single_insert
thf(fact_4498_subset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
      = ( ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) )
        & ( ~ ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% subset_insert_iff
thf(fact_4499_mult__inc,axiom,
    ! [X: num,Y2: num] :
      ( ( times_times @ num @ X @ ( inc @ Y2 ) )
      = ( plus_plus @ num @ ( times_times @ num @ X @ Y2 ) @ X ) ) ).

% mult_inc
thf(fact_4500_set__update__subset__insert,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) ) @ ( insert @ A @ X @ ( set2 @ A @ Xs2 ) ) ) ).

% set_update_subset_insert
thf(fact_4501_Compl__insert,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) )
      = ( minus_minus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% Compl_insert
thf(fact_4502_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_4503_finite__remove__induct,axiom,
    ! [A: $tType,B4: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B4 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B4 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B4 ) ) ) ) ).

% finite_remove_induct
thf(fact_4504_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B4: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B4 )
         => ( P @ B4 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B4 )
                 => ( ! [X3: A] :
                        ( ( member @ A @ X3 @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B4 ) ) ) ) ).

% remove_induct
thf(fact_4505_finite__induct__select,axiom,
    ! [A: $tType,S2: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S2 )
             => ( ( P @ T7 )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ ( minus_minus @ ( set @ A ) @ S2 @ T7 ) )
                    & ( P @ ( insert @ A @ X3 @ T7 ) ) ) ) )
         => ( P @ S2 ) ) ) ) ).

% finite_induct_select
thf(fact_4506_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A,B4: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B4 ) )
      = ( ( ( member @ A @ X @ B4 )
         => ( ord_less @ ( set @ A ) @ A3 @ B4 ) )
        & ( ~ ( member @ A @ X @ B4 )
         => ( ( ( member @ A @ X @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) )
            & ( ~ ( member @ A @ X @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_4507_set__replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N ) @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4508_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4509_sum__diff1__nat,axiom,
    ! [A: $tType,A2: A,A3: set @ A,F2: A > nat] :
      ( ( ( member @ A @ A2 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
      & ( ~ ( member @ A @ A2 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) ) ) ) ).

% sum_diff1_nat
thf(fact_4510_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
        = ( insert @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N ) @ ( set_or1337092689740270186AtMost @ int @ M @ N ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4511_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I4 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_4512_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
            = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_4513_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( G @ X ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_4514_sum__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,A2: B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ A2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
            & ( ~ ( member @ B @ A2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% sum_diff1
thf(fact_4515_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_4516_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,X: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X @ A3 ) )
            = ( times_times @ A @ ( G @ X ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_4517_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_4518_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ ( C2 @ K2 ) )
                  @ S2 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S2 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_4519_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I2: C,A3: set @ C,F2: C > B] :
          ( ( member @ C @ I2 @ A3 )
         => ( ! [X5: C] :
                ( ( member @ C @ X5 @ ( minus_minus @ ( set @ C ) @ A3 @ ( insert @ C @ I2 @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X5 ) ) )
           => ( ( finite_finite @ C @ A3 )
             => ( ord_less_eq @ B @ ( F2 @ I2 ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A3 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4520_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4521_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sinh @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4522_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( ( M3
              = ( zero_zero @ nat ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_4523_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_4524_and__int_Opelims,axiom,
    ! [X: int,Xa2: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) ) ) ) ) ).

% and_int.pelims
thf(fact_4525_and__int_Opsimps,axiom,
    ! [K: int,L2: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L2 ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L2 )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L2 )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4526_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K3: int,L4: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K3 @ L4 ) )
           => ( ( ~ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L4 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K3 @ L4 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_4527_infinite__imp__bij__betw,axiom,
    ! [A: $tType,A3: set @ A,A2: A] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [H4: A > A] : ( bij_betw @ A @ A @ H4 @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% infinite_imp_bij_betw
thf(fact_4528_set__encode__insert,axiom,
    ! [A3: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ~ ( member @ nat @ N @ A3 )
       => ( ( nat_set_encode @ ( insert @ nat @ N @ A3 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( nat_set_encode @ A3 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4529_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4530_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) )
        = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4531_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4532_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_4533_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_4534_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4535_set__decode__plus__power__2,axiom,
    ! [N: nat,Z2: nat] :
      ( ~ ( member @ nat @ N @ ( nat_set_decode @ Z2 ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ Z2 ) )
        = ( insert @ nat @ N @ ( nat_set_decode @ Z2 ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4536_Arg__def,axiom,
    ( arg
    = ( ^ [Z: complex] :
          ( if @ real
          @ ( Z
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A4: real] :
                ( ( ( sgn_sgn @ complex @ Z )
                  = ( cis @ A4 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A4 )
                & ( ord_less_eq @ real @ A4 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4537_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K2 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_4538_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( ( K2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ int ) )
            @ L
            @ ( if @ int
              @ ( L
                = ( zero_zero @ int ) )
              @ K2
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4539_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_4540_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_4541_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_4542_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_4543_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4544_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_4545_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_4546_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_4547_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_4548_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_4549_or__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% or_nonnegative_int_iff
thf(fact_4550_or__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_4551_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_4552_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(2)
thf(fact_4553_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_4554_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_4555_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y2: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y2 @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y2 ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) ) ) ).

% floor_add2
thf(fact_4556_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) )
          = ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_4557_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_4558_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ).

% signed_take_bit_negative_iff
thf(fact_4559_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% or_numerals(3)
thf(fact_4560_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_4561_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(1)
thf(fact_4562_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_4563_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_4564_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_4565_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_4566_or__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_4567_or__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_4568_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_4569_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_4570_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_4571_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( N
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_4572_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_4573_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_4574_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_4575_exE__some,axiom,
    ! [A: $tType,P: A > $o,C2: A] :
      ( ? [X_12: A] : ( P @ X_12 )
     => ( ( C2
          = ( fChoice @ A @ P ) )
       => ( P @ C2 ) ) ) ).

% exE_some
thf(fact_4576_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( M != N ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_4577_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_4578_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N3: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_4579_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_4580_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_or_iff
thf(fact_4581_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B3: A] : ( bit_se1065995026697491101ons_or @ A @ B3 @ A4 ) ) ) ) ).

% or.commute
thf(fact_4582_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_4583_bit__or__int__iff,axiom,
    ! [K: int,L2: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        | ( bit_se5641148757651400278ts_bit @ int @ L2 @ N ) ) ) ).

% bit_or_int_iff
thf(fact_4584_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( zero_zero @ A ) )
          = X ) ) ).

% bit.disj_zero_right
thf(fact_4585_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_4586_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_or_eq
thf(fact_4587_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_4588_Ints__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_diff
thf(fact_4589_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_4590_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_4591_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_4592_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: num] : ( member @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_4593_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% bit_numeral_iff
thf(fact_4594_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_4595_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_or_eq
thf(fact_4596_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_and_iff
thf(fact_4597_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z2 ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_4598_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y2 ) @ ( bit_se1065995026697491101ons_or @ A @ X @ Z2 ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_4599_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z2: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z2 ) @ X )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z2 @ X ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_4600_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z2: A,X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z2 ) @ X )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ X ) @ ( bit_se1065995026697491101ons_or @ A @ Z2 @ X ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_4601_bit__and__int__iff,axiom,
    ! [K: int,L2: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L2 ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ L2 @ N ) ) ) ).

% bit_and_int_iff
thf(fact_4602_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_4603_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_4604_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_4605_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less @ nat @ N @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_take_bit_iff
thf(fact_4606_or__greater__eq,axiom,
    ! [L2: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L2 ) ) ) ).

% or_greater_eq
thf(fact_4607_OR__lower,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y2 ) ) ) ) ).

% OR_lower
thf(fact_4608_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N )
          = ( B2
            & ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_4609_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_4610_plus__and__or,axiom,
    ! [X: int,Y2: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y2 ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y2 ) )
      = ( plus_plus @ int @ X @ Y2 ) ) ).

% plus_and_or
thf(fact_4611_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_4612_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X2 )
                & ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4613_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff'
thf(fact_4614_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_4615_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_4616_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N2 ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N2 @ A4 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_4617_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K2: A] :
                ( ( member @ A @ K2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K2 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4618_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_4619_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y2 )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y2 )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y2 ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4620_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_4621_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L2: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L2 ) @ N )
      = ( ( ( ord_less @ nat @ N @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) )
        | ( ( ord_less_eq @ nat @ M @ N )
          & ( bit_se5641148757651400278ts_bit @ int @ L2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_4622_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_4623_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_4624_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_4625_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y2: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y2 @ ( ring_1_Ints @ A ) )
           => ( ( X = Y2 )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_4626_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_4627_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_concat_bit @ N2 @ K2 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_4628_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_4629_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) ) ).

% bit_Suc
thf(fact_4630_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_4631_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_4632_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N3: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ N3 @ M2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M2 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N3 ) ) ) ) ) ).

% int_bit_bound
thf(fact_4633_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_4634_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_4635_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_4636_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% mask_Suc_exp
thf(fact_4637_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K2: int,N2: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_int_def
thf(fact_4638_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_4639_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_4640_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_4641_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_4642_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_4643_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_4644_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_4645_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_4646_OR__upper,axiom,
    ! [X: int,N: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% OR_upper
thf(fact_4647_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_4648_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_4649_sin__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_4650_cos__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_4651_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_4652_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K2: int] :
          ( plus_plus @ int @ K2
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% set_bit_eq
thf(fact_4653_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( minus_minus @ int @ K2 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K2 @ N2 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_4654_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_4655_or__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4656_or__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4657_Suc__0__xor__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_4658_xor__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_4659_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y2 ) )
          = Y2 ) ) ).

% bit.xor_left_self
thf(fact_4660_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_4661_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_4662_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_4663_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_4664_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_4665_Eps__case__prod__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y2: B] :
      ( ( fChoice @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y6: B] :
              ( ( X = X9 )
              & ( Y2 = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y2 ) ) ).

% Eps_case_prod_eq
thf(fact_4666_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_4667_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% xor_numerals(1)
thf(fact_4668_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) ) ) ).

% xor_numerals(2)
thf(fact_4669_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_4670_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_4671_or__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(2)
thf(fact_4672_or__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(4)
thf(fact_4673_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_4674_or__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(3)
thf(fact_4675_or__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(1)
thf(fact_4676_xor__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X ) ) ) ).

% xor_nat_numerals(4)
thf(fact_4677_xor__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% xor_nat_numerals(3)
thf(fact_4678_xor__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) ) ).

% xor_nat_numerals(2)
thf(fact_4679_xor__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% xor_nat_numerals(1)
thf(fact_4680_or__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_4681_or__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_4682_or__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_4683_or__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_4684_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_4685_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_4686_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_xor_iff
thf(fact_4687_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z2: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z2 ) @ X )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z2 @ X ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_4688_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z2 ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_4689_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_4690_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_xor_eq
thf(fact_4691_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L2: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L2 ) ) ) ) ).

% of_int_xor_eq
thf(fact_4692_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_4693_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A4: A,B3: A] : ( bit_se5824344971392196577ns_xor @ A @ B3 @ A4 ) ) ) ) ).

% xor.commute
thf(fact_4694_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_4695_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_4696_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N ) ) ).

% not_bit_Suc_0_Suc
thf(fact_4697_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_4698_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_4699_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_4700_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_4701_split__paired__Eps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fChoice @ ( product_prod @ A @ B ) )
      = ( ^ [P4: ( product_prod @ A @ B ) > $o] :
            ( fChoice @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A4: A,B3: B] : ( P4 @ ( product_Pair @ A @ B @ A4 @ B3 ) ) ) ) ) ) ).

% split_paired_Eps
thf(fact_4702_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_4703_not__bit__Suc__0__numeral,axiom,
    ! [N: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N ) ) ).

% not_bit_Suc_0_numeral
thf(fact_4704_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_4705_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% or_nat_def
thf(fact_4706_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_4707_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_4708_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_nat_iff
thf(fact_4709_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_4710_or__not__num__neg_Oelims,axiom,
    ! [X: num,Xa2: num,Y2: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa2 )
        = Y2 )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2 != one2 ) ) )
       => ( ( ( X = one2 )
           => ! [M4: num] :
                ( ( Xa2
                  = ( bit0 @ M4 ) )
               => ( Y2
                 != ( bit1 @ M4 ) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa2
                    = ( bit1 @ M4 ) )
                 => ( Y2
                   != ( bit1 @ M4 ) ) ) )
           => ( ( ? [N3: num] :
                    ( X
                    = ( bit0 @ N3 ) )
               => ( ( Xa2 = one2 )
                 => ( Y2
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ! [M4: num] :
                        ( ( Xa2
                          = ( bit0 @ M4 ) )
                       => ( Y2
                         != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa2
                            = ( bit1 @ M4 ) )
                         => ( Y2
                           != ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                 => ( ( ? [N3: num] :
                          ( X
                          = ( bit1 @ N3 ) )
                     => ( ( Xa2 = one2 )
                       => ( Y2 != one2 ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ! [M4: num] :
                              ( ( Xa2
                                = ( bit0 @ M4 ) )
                             => ( Y2
                               != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) )
                     => ~ ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa2
                                  = ( bit1 @ M4 ) )
                               => ( Y2
                                 != ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_4711_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% bit_nat_def
thf(fact_4712_or__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4713_Suc__0__or__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4714_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_4715_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_4716_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_4717_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_4718_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_4719_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N2: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N2
          @ ( if @ nat
            @ ( N2
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4720_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa2: num,Y2: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2 = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa2
                    = ( bit0 @ M4 ) )
                 => ( ( Y2
                      = ( bit1 @ M4 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M4 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [M4: num] :
                    ( ( Xa2
                      = ( bit1 @ M4 ) )
                   => ( ( Y2
                        = ( bit1 @ M4 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M4 ) ) ) ) ) )
             => ( ! [N3: num] :
                    ( ( X
                      = ( bit0 @ N3 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ one2 ) ) ) ) )
               => ( ! [N3: num] :
                      ( ( X
                        = ( bit0 @ N3 ) )
                     => ! [M4: num] :
                          ( ( Xa2
                            = ( bit0 @ M4 ) )
                         => ( ( Y2
                              = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                 => ( ! [N3: num] :
                        ( ( X
                          = ( bit0 @ N3 ) )
                       => ! [M4: num] :
                            ( ( Xa2
                              = ( bit1 @ M4 ) )
                           => ( ( Y2
                                = ( bit0 @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) )
                   => ( ! [N3: num] :
                          ( ( X
                            = ( bit1 @ N3 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2 = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ one2 ) ) ) ) )
                     => ( ! [N3: num] :
                            ( ( X
                              = ( bit1 @ N3 ) )
                           => ! [M4: num] :
                                ( ( Xa2
                                  = ( bit0 @ M4 ) )
                               => ( ( Y2
                                    = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit0 @ M4 ) ) ) ) ) )
                       => ~ ! [N3: num] :
                              ( ( X
                                = ( bit1 @ N3 ) )
                             => ! [M4: num] :
                                  ( ( Xa2
                                    = ( bit1 @ M4 ) )
                                 => ( ( Y2
                                      = ( bitM @ ( bit_or_not_num_neg @ N3 @ M4 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N3 ) @ ( bit1 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_4721_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_4722_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P2 )
      = P2 ) ).

% case_prod_Pair_iden
thf(fact_4723_xor__nonnegative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L2 ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_4724_xor__negative__int__iff,axiom,
    ! [K: int,L2: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L2 @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_4725_bit__xor__int__iff,axiom,
    ! [K: int,L2: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L2 ) @ N )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
         != ( bit_se5641148757651400278ts_bit @ int @ L2 @ N ) ) ) ) ).

% bit_xor_int_iff
thf(fact_4726_XOR__lower,axiom,
    ! [X: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y2 ) ) ) ) ).

% XOR_lower
thf(fact_4727_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N2: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% xor_nat_def
thf(fact_4728_predicate2D__conj,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,R2: $o,X: A,Y2: B] :
      ( ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
        & R2 )
     => ( R2
        & ( ( P @ X @ Y2 )
         => ( Q @ X @ Y2 ) ) ) ) ).

% predicate2D_conj
thf(fact_4729_eq__subset,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ord_less_eq @ ( A > A > $o )
      @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
      @ ^ [A4: A,B3: A] :
          ( ( P @ A4 @ B3 )
          | ( A4 = B3 ) ) ) ).

% eq_subset
thf(fact_4730_XOR__upper,axiom,
    ! [X: int,N: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% XOR_upper
thf(fact_4731_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_4732_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N )
          = ( ( ord_less @ nat @ N @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_4733_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L: int] :
          ( if @ int
          @ ( K2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L )
          @ ( if @ int
            @ ( L
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K2 )
            @ ( if @ int
              @ ( K2
                = ( zero_zero @ int ) )
              @ L
              @ ( if @ int
                @ ( L
                  = ( zero_zero @ int ) )
                @ K2
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_4734_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_4735_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I5: set @ A,F2: A > B,I2: A] :
          ( ( finite_finite @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I4: A] :
                    ( ( member @ A @ I4 @ I5 )
                    & ( ( F2 @ I4 )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member @ A @ I2 @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I2 ) ) ) )
              & ( ~ ( member @ A @ I2 @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_4736_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X )
            = ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( X = Y2 ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_4737_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = X ) ) ).

% bit.double_compl
thf(fact_4738_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_4739_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_4740_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_4741_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_4742_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_4743_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_4744_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y2 ) ) ) ) ).

% bit.xor_compl_right
thf(fact_4745_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ Y2 )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y2 ) ) ) ) ).

% bit.xor_compl_left
thf(fact_4746_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_4747_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_4748_concat__bit__of__zero__1,axiom,
    ! [N: nat,L2: int] :
      ( ( bit_concat_bit @ N @ ( zero_zero @ int ) @ L2 )
      = ( bit_se4730199178511100633sh_bit @ int @ N @ L2 ) ) ).

% concat_bit_of_zero_1
thf(fact_4749_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_4750_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_4751_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_4752_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_4753_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_4754_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_4755_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_4756_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_4757_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_4758_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_4759_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_4760_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_4761_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_4762_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_4763_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_4764_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_4765_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_4766_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_4767_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_4768_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_4769_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,P2: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( P2 @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P2 @ ( insert @ B @ I2 @ I5 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P2 @ I5 ) ) )
            & ( ~ ( member @ B @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P2 @ ( insert @ B @ I2 @ I5 ) )
                = ( plus_plus @ A @ ( P2 @ I2 ) @ ( groups1027152243600224163dd_sum @ B @ A @ P2 @ I5 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_4770_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_4771_push__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% push_bit_of_Suc_0
thf(fact_4772_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_4773_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_4774_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( ( N
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_4775_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_4776_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_4777_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_4778_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_4779_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_4780_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_4781_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_4782_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se5824344872417868541ns_and @ int @ K2 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_4783_push__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_4784_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_4785_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_push_bit
thf(fact_4786_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_4787_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_4788_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_4789_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_4790_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_4791_bit__not__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff
thf(fact_4792_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_4793_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_4794_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_4795_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_4796_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K2: int,L: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K2 ) @ ( bit_ri4277139882892585799ns_not @ int @ L ) ) ) ) ) ).

% or_int_def
thf(fact_4797_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_4798_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_4799_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_4800_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M3: nat,N2: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_4801_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I4: B] : ( plus_plus @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
              @ I5 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I5 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_4802_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_4803_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_4804_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A4: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_4805_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K2 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_4806_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_4807_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4808_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N3: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N3 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N3 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_4809_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_4810_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_4811_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_4812_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X2: A,Y: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ Y ) ) ) ) ) ).

% bit.xor_def
thf(fact_4813_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X2: A,Y: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4814_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q2: nat,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q2 ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_4815_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K2: int,L: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K2 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L ) ) ) ) ).

% concat_bit_eq
thf(fact_4816_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K2: int,L: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K2 @ ( bit_ri4277139882892585799ns_not @ int @ L ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K2 ) @ L ) ) ) ) ).

% xor_int_def
thf(fact_4817_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4818_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N2: nat,K2: int,L: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K2 ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ L ) ) ) ) ).

% concat_bit_def
thf(fact_4819_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se5824344971392196577ns_xor @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_4820_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se1065995026697491101ons_or @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4821_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T4: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( G @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T4 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_4822_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T4: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( G @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T4 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_4823_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T4: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( H2 @ I3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S2 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S2 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ T4 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_4824_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T4: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( G @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S2 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T4 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_4825_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( bit_se5824344971392196577ns_xor @ int @ K2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_4826_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_4827_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_4828_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_4829_and__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_4830_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_4831_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( G @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I5 )
                    & ( ( H2 @ X2 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I4: B] : ( plus_plus @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
                @ I5 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I5 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_4832_or__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4833_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4834_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N ) ) ).

% bit_minus_int_iff
thf(fact_4835_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_4836_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_4837_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_4838_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_4839_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_4840_numeral__or__not__num__eq,axiom,
    ! [M: num,N: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_4841_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_4842_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_4843_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_4844_or__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4845_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_4846_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4847_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( times_times @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_int_def
thf(fact_4848_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N2: nat,M3: nat] : ( times_times @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% push_bit_nat_def
thf(fact_4849_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y2 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y2 ) ) ) ) ).

% bit.compl_unique
thf(fact_4850_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_4851_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 )
         => ~ ! [B6: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N @ B6 ) ) ) ) ).

% exp_dvdE
thf(fact_4852_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4853_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_4854_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_4855_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4856_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff_eq
thf(fact_4857_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_4858_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_4859_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4860_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I5: set @ A,F2: A > B,I2: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I4: A] :
                  ( ( member @ A @ I4 @ I5 )
                  & ( ( F2 @ I4 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I2 ) ) ) )
            & ( ~ ( member @ A @ I2 @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_4861_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A4 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4862_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_4863_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4864_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4865_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K2: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_4866_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A4 ) @ N2 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A4 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A4 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4867_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4868_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4869_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_4870_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U2: A] :
          ( ( member @ A @ I2 @ ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) )
          = ( ( ord_less_eq @ A @ L2 @ I2 )
            & ( ord_less @ A @ I2 @ U2 ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4871_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4872_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,J: A,M: A,N: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
          = ( ( ord_less_eq @ A @ J @ I2 )
            | ( ( ord_less_eq @ A @ M @ I2 )
              & ( ord_less_eq @ A @ J @ N ) ) ) ) ) ).

% ivl_subset
thf(fact_4873_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_4874_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_4875_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4876_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I2: A,N: A,M: A] :
          ( ( ord_less_eq @ A @ I2 @ N )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ N ) )
            = ( set_or7035219750837199246ssThan @ A @ N @ M ) ) ) ) ).

% ivl_diff
thf(fact_4877_lessThan__minus__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: A,M: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_ord_lessThan @ A @ N ) @ ( set_ord_lessThan @ A @ M ) )
          = ( set_or7035219750837199246ssThan @ A @ M @ N ) ) ) ).

% lessThan_minus_lessThan
thf(fact_4878_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4879_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4880_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4881_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4882_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4883_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4884_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4885_all__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X2 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4886_ex__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X2 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4887_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4888_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4889_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X5: B] :
                  ( ( ord_less_eq @ B @ C2 @ X5 )
                 => ( ( ord_less @ B @ X5 @ D2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4890_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X5: B] :
                  ( ( ord_less_eq @ B @ C2 @ X5 )
                 => ( ( ord_less @ B @ X5 @ D2 )
                   => ( ( G @ X5 )
                      = ( H2 @ X5 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4891_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,P2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P2 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4892_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,P2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P2 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N @ P2 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4893_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less @ nat @ Y2 @ ( F2 @ X ) )
       => ( ord_less @ nat @ Y2 @ ( size_list @ A @ F2 @ Xs2 ) ) ) ) ).

% size_list_estimation
thf(fact_4894_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ Y2 @ ( F2 @ X ) )
       => ( ord_less_eq @ nat @ Y2 @ ( size_list @ A @ F2 @ Xs2 ) ) ) ) ).

% size_list_estimation'
thf(fact_4895_size__list__pointwise,axiom,
    ! [A: $tType,Xs2: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ nat @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs2 ) @ ( size_list @ A @ G @ Xs2 ) ) ) ).

% size_list_pointwise
thf(fact_4896_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,P2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P2 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P2 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P2 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4897_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_4898_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4899_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4900_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4901_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4902_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4903_atLeastLessThan__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or7035219750837199246ssThan @ A )
        = ( ^ [A4: A,B3: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% atLeastLessThan_eq_atLeastAtMost_diff
thf(fact_4904_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4905_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4906_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4907_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ N ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4908_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4909_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4910_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_4911_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I4 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_4912_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ ( suc @ I4 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_4913_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_4914_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M3: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M3 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_4915_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4916_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4917_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4918_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4919_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4920_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_4921_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N2: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N2 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_4922_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F5: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [N6: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M3 )
                 => ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N2 ) ) ) @ E4 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4923_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S: A,K: nat] :
          ( ( sums @ A @ F2 @ S )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N2 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ K ) ) )
              @ S ) ) ) ) ).

% sums_group
thf(fact_4924_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K2: nat] : ( bit_se4730199178511100633sh_bit @ A @ K2 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ K2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% take_bit_sum
thf(fact_4925_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_4926_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4927_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4928_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K2 @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4929_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4930_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4931_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K2: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I4 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K2 ) )
              @ ( semiring_char_0_fact @ A @ K2 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4932_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4933_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( F5 @ ( nth @ B @ Xs @ N2 ) ) @ ( power_power @ A @ A4 @ N2 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4934_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: nat > A,B2: nat > A] :
          ( ! [I3: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I3 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N )
               => ( ord_less_eq @ A @ ( A2 @ I3 ) @ ( A2 @ J2 ) ) ) )
         => ( ! [I3: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I3 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I3 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K2: nat] : ( times_times @ A @ ( A2 @ K2 ) @ ( B2 @ K2 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4935_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I3: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I3 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N )
           => ( ord_less_eq @ nat @ ( A2 @ I3 ) @ ( A2 @ J2 ) ) ) )
     => ( ! [I3: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I3 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I3 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( B2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4936_atLeastLessThanPlusOne__atLeastAtMost__int,axiom,
    ! [L2: int,U2: int] :
      ( ( set_or7035219750837199246ssThan @ int @ L2 @ ( plus_plus @ int @ U2 @ ( one_one @ int ) ) )
      = ( set_or1337092689740270186AtMost @ int @ L2 @ U2 ) ) ).

% atLeastLessThanPlusOne_atLeastAtMost_int
thf(fact_4937_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_4938_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X4: nat > real] :
        ! [J3: nat] :
        ? [M9: nat] :
        ! [M3: nat] :
          ( ( ord_less_eq @ nat @ M9 @ M3 )
         => ! [N2: nat] :
              ( ( ord_less_eq @ nat @ M9 @ N2 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X4 @ M3 ) @ ( X4 @ N2 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_4939_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_4940_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_4941_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_4942_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu: $o,Uv: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu @ Uv ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_4943_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X4 @ M3 ) @ ( X4 @ N2 ) ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_4944_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI
thf(fact_4945_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M2 ) @ ( X8 @ N9 ) ) ) @ E ) ) ) ) ) ) ).

% CauchyD
thf(fact_4946_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_4947_length__subseqs,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_subseqs
thf(fact_4948_Code__Target__Int_Opositive__def,axiom,
    ( code_Target_positive
    = ( numeral_numeral @ int ) ) ).

% Code_Target_Int.positive_def
thf(fact_4949_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4950_minus__integer__code_I2_J,axiom,
    ! [L2: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
      = ( uminus_uminus @ code_integer @ L2 ) ) ).

% minus_integer_code(2)
thf(fact_4951_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_4952_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M3: num,N2: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N2 ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M3 ) @ ( numeral_numeral @ code_integer @ N2 ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_4953_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_4954_times__integer__code_I2_J,axiom,
    ! [L2: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_4955_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_4956_subseqs__refl,axiom,
    ! [A: $tType,Xs2: list @ A] : ( member @ ( list @ A ) @ Xs2 @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) ) ).

% subseqs_refl
thf(fact_4957_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_4958_plus__integer__code_I2_J,axiom,
    ! [L2: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
      = L2 ) ).

% plus_integer_code(2)
thf(fact_4959_full__exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod @ ( ( product_prod @ code_integer @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer )] :
      ~ ! [F3: ( product_prod @ code_integer @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D4: code_integer,I3: code_integer] :
          ( X
         != ( product_Pair @ ( ( product_prod @ code_integer @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer ) @ F3 @ ( product_Pair @ code_integer @ code_integer @ D4 @ I3 ) ) ) ).

% full_exhaustive_integer'.cases
thf(fact_4960_exhaustive__integer_H_Ocases,axiom,
    ! [X: product_prod @ ( code_integer > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer )] :
      ~ ! [F3: code_integer > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ),D4: code_integer,I3: code_integer] :
          ( X
         != ( product_Pair @ ( code_integer > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_integer @ code_integer ) @ F3 @ ( product_Pair @ code_integer @ code_integer @ D4 @ I3 ) ) ) ).

% exhaustive_integer'.cases
thf(fact_4961_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K2: code_integer] :
          ( if @ code_integer
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_4962_one__integer_Orsp,axiom,
    ( ( one_one @ int )
    = ( one_one @ int ) ) ).

% one_integer.rsp
thf(fact_4963_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) ) ).

% one_natural.rsp
thf(fact_4964_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K2: int] :
          ( if @ code_integer @ ( ord_less @ int @ K2 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K2 ) ) )
          @ ( if @ code_integer
            @ ( K2
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_4965_length__mul__elem,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N: nat] :
      ( ! [X5: list @ A] :
          ( ( member @ ( list @ A ) @ X5 @ ( set2 @ ( list @ A ) @ Xs2 ) )
         => ( ( size_size @ ( list @ A ) @ X5 )
            = N ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs2 ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) @ N ) ) ) ).

% length_mul_elem
thf(fact_4966_Code__Numeral_Opositive__def,axiom,
    ( code_positive
    = ( numeral_numeral @ code_integer ) ) ).

% Code_Numeral.positive_def
thf(fact_4967_plus__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( plus_plus @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( plus_plus @ int @ Xa2 @ X ) ) ) ).

% plus_integer.abs_eq
thf(fact_4968_times__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa2 @ X ) ) ) ).

% times_integer.abs_eq
thf(fact_4969_one__integer__def,axiom,
    ( ( one_one @ code_integer )
    = ( code_integer_of_int @ ( one_one @ int ) ) ) ).

% one_integer_def
thf(fact_4970_less__eq__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( ord_less_eq @ int @ Xa2 @ X ) ) ).

% less_eq_integer.abs_eq
thf(fact_4971_minus__integer_Oabs__eq,axiom,
    ! [Xa2: int,X: int] :
      ( ( minus_minus @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X ) )
      = ( code_integer_of_int @ ( minus_minus @ int @ Xa2 @ X ) ) ) ).

% minus_integer.abs_eq
thf(fact_4972_set__n__lists,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs2 ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys3 )
              = N )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Xs2 ) ) ) ) ) ).

% set_n_lists
thf(fact_4973_integer__of__num_I3_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit1 @ N ) )
      = ( plus_plus @ code_integer @ ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% integer_of_num(3)
thf(fact_4974_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K2 ) ) )
          @ ( if @ int
            @ ( K2
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_4975_int__of__integer__numeral,axiom,
    ! [K: num] :
      ( ( code_int_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ int @ K ) ) ).

% int_of_integer_numeral
thf(fact_4976_plus__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( plus_plus @ code_integer @ X @ Xa2 ) )
      = ( plus_plus @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% plus_integer.rep_eq
thf(fact_4977_times__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X @ Xa2 ) )
      = ( times_times @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% times_integer.rep_eq
thf(fact_4978_one__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ int ) ) ).

% one_integer.rep_eq
thf(fact_4979_minus__integer_Orep__eq,axiom,
    ! [X: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( minus_minus @ code_integer @ X @ Xa2 ) )
      = ( minus_minus @ int @ ( code_int_of_integer @ X ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% minus_integer.rep_eq
thf(fact_4980_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X2: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_4981_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K2: code_integer,L: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K2 ) @ ( code_int_of_integer @ L ) ) ) ) ).

% integer_less_eq_iff
thf(fact_4982_integer__of__num__def,axiom,
    ( code_integer_of_num
    = ( numeral_numeral @ code_integer ) ) ).

% integer_of_num_def
thf(fact_4983_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list @ A,N: nat,Xs2: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs2 ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N ) ) ).

% length_n_lists_elem
thf(fact_4984_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_4985_integer__of__num_I2_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) ) ).

% integer_of_num(2)
thf(fact_4986_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N @ Xs2 ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) ) ).

% length_n_lists
thf(fact_4987_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_4988_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K2 @ L ) @ ( modulo_modulo @ code_integer @ K2 @ L ) ) ) ) ).

% divmod_integer_def
thf(fact_4989_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K2 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L ) @ ( code_num_of_integer @ L ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L ) @ ( code_num_of_integer @ L ) ) @ one2 ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_4990_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K2: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L ) @ ( code_nat_of_integer @ L ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L ) @ ( code_nat_of_integer @ L ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_4991_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K2: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K2 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_4992_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_4993_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_4994_nat__of__integer__code__post_I2_J,axiom,
    ( ( code_nat_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ nat ) ) ).

% nat_of_integer_code_post(2)
thf(fact_4995_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K2: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S7: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S7 ) )
                @ ( S7
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K2 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_4996_csqrt_Osimps_I1_J,axiom,
    ! [Z2: complex] :
      ( ( re @ ( csqrt @ Z2 ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_4997_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A4: B] :
                      ( ( member @ B @ A4 @ A3 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A4 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_4998_card__Collect__less__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) )
      = N ) ).

% card_Collect_less_nat
thf(fact_4999_card__atLeastLessThan,axiom,
    ! [L2: nat,U2: nat] :
      ( ( finite_card @ nat @ ( set_or7035219750837199246ssThan @ nat @ L2 @ U2 ) )
      = ( minus_minus @ nat @ U2 @ L2 ) ) ).

% card_atLeastLessThan
thf(fact_5000_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less_eq @ nat @ I4 @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_5001_card__atLeastAtMost,axiom,
    ! [L2: nat,U2: nat] :
      ( ( finite_card @ nat @ ( set_or1337092689740270186AtMost @ nat @ L2 @ U2 ) )
      = ( minus_minus @ nat @ ( suc @ U2 ) @ L2 ) ) ).

% card_atLeastAtMost
thf(fact_5002_complex__Re__numeral,axiom,
    ! [V: num] :
      ( ( re @ ( numeral_numeral @ complex @ V ) )
      = ( numeral_numeral @ real @ V ) ) ).

% complex_Re_numeral
thf(fact_5003_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : Y2
            @ A3 )
          = ( power_power @ A @ Y2 @ ( finite_card @ B @ A3 ) ) ) ) ).

% prod_constant
thf(fact_5004_card__atLeastLessThan__int,axiom,
    ! [L2: int,U2: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ L2 @ U2 ) )
      = ( nat2 @ ( minus_minus @ int @ U2 @ L2 ) ) ) ).

% card_atLeastLessThan_int
thf(fact_5005_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : Y2
            @ A3 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ Y2 ) ) ) ).

% sum_constant
thf(fact_5006_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B4: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ A2 @ B4 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B4 ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( one_one @ nat ) ) ) ) ) ).

% card_Diff_insert
thf(fact_5007_card__atLeastAtMost__int,axiom,
    ! [L2: int,U2: int] :
      ( ( finite_card @ int @ ( set_or1337092689740270186AtMost @ int @ L2 @ U2 ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ U2 @ L2 ) @ ( one_one @ int ) ) ) ) ).

% card_atLeastAtMost_int
thf(fact_5008_Re__divide__numeral,axiom,
    ! [Z2: complex,W: num] :
      ( ( re @ ( divide_divide @ complex @ Z2 @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( re @ Z2 ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Re_divide_numeral
thf(fact_5009_n__subsets,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B7: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B7 @ A3 )
                & ( ( finite_card @ A @ B7 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A3 ) @ K ) ) ) ).

% n_subsets
thf(fact_5010_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [B9: set @ A] :
          ( ( finite_finite @ A @ B9 )
          & ( ( finite_card @ A @ B9 )
            = N )
          & ( ord_less_eq @ ( set @ A ) @ B9 @ A3 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_5011_card__subset__eq,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ( finite_card @ A @ A3 )
            = ( finite_card @ A @ B4 ) )
         => ( A3 = B4 ) ) ) ) ).

% card_subset_eq
thf(fact_5012_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B4: set @ A,A3: set @ B,R: B > A > $o] :
      ( ( finite_finite @ A @ B4 )
     => ( ! [A6: B] :
            ( ( member @ B @ A6 @ A3 )
           => ? [B10: A] :
                ( ( member @ A @ B10 @ B4 )
                & ( R @ A6 @ B10 ) ) )
       => ( ! [A13: B,A24: B,B6: A] :
              ( ( member @ B @ A13 @ A3 )
             => ( ( member @ B @ A24 @ A3 )
               => ( ( member @ A @ B6 @ B4 )
                 => ( ( R @ A13 @ B6 )
                   => ( ( R @ A24 @ B6 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_5013_card__insert__le,axiom,
    ! [A: $tType,A3: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( insert @ A @ X @ A3 ) ) ) ).

% card_insert_le
thf(fact_5014_complex__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( re @ X ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_Re_le_cmod
thf(fact_5015_one__complex_Osimps_I1_J,axiom,
    ( ( re @ ( one_one @ complex ) )
    = ( one_one @ real ) ) ).

% one_complex.simps(1)
thf(fact_5016_plus__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y2: complex] :
      ( ( re @ ( plus_plus @ complex @ X @ Y2 ) )
      = ( plus_plus @ real @ ( re @ X ) @ ( re @ Y2 ) ) ) ).

% plus_complex.simps(1)
thf(fact_5017_scaleR__complex_Osimps_I1_J,axiom,
    ! [R: real,X: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( re @ X ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_5018_minus__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y2: complex] :
      ( ( re @ ( minus_minus @ complex @ X @ Y2 ) )
      = ( minus_minus @ real @ ( re @ X ) @ ( re @ Y2 ) ) ) ).

% minus_complex.simps(1)
thf(fact_5019_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A3 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_5020_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_5021_card__2__iff_H,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ S2 )
            & ? [Y: A] :
                ( ( member @ A @ Y @ S2 )
                & ( X2 != Y )
                & ! [Z: A] :
                    ( ( member @ A @ Z @ S2 )
                   => ( ( Z = X2 )
                      | ( Z = Y ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_5022_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
     => ( finite_finite @ A @ A3 ) ) ).

% card_ge_0_finite
thf(fact_5023_card__mono,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ).

% card_mono
thf(fact_5024_card__seteq,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B4 ) @ ( finite_card @ A @ A3 ) )
         => ( A3 = B4 ) ) ) ) ).

% card_seteq
thf(fact_5025_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F4: set @ A,C5: nat] :
      ( ! [G5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G5 @ F4 )
         => ( ( finite_finite @ A @ G5 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G5 ) @ C5 ) ) )
     => ( ( finite_finite @ A @ F4 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F4 ) @ C5 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_5026_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S2: set @ A] :
      ( ( ord_less_eq @ nat @ N @ ( finite_card @ A @ S2 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S2 )
           => ( ( ( finite_card @ A @ T7 )
                = N )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_5027_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_5028_card__le__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_5029_card__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% card_length
thf(fact_5030_card__1__singletonE,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( one_one @ nat ) )
     => ~ ! [X5: A] :
            ( A3
           != ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_5031_psubset__card__mono,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B4 )
       => ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ).

% psubset_card_mono
thf(fact_5032_abs__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Re_le_cmod
thf(fact_5033_Re__csqrt,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) ) ).

% Re_csqrt
thf(fact_5034_card__less,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I2 ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_5035_card__less__Suc,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K2: nat] :
                  ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                  & ( ord_less @ nat @ K2 @ I2 ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_5036_card__less__Suc2,axiom,
    ! [M7: set @ nat,I2: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ ( suc @ K2 ) @ M7 )
                & ( ord_less @ nat @ K2 @ I2 ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K2: nat] :
                ( ( member @ nat @ K2 @ M7 )
                & ( ord_less @ nat @ K2 @ ( suc @ I2 ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_5037_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( suc @ ( F2 @ X2 ) )
        @ A3 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( finite_card @ A @ A3 ) ) ) ).

% sum_Suc
thf(fact_5038_subset__card__intvl__is__intvl,axiom,
    ! [A3: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) )
     => ( A3
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_5039_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,T4: set @ B,R2: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T4 )
       => ( ! [X5: B] :
              ( ( member @ B @ X5 @ T4 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I4: A] :
                        ( ( member @ A @ I4 @ S2 )
                        & ( R2 @ I4 @ X5 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I4: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J3: B] :
                        ( ( member @ B @ J3 @ T4 )
                        & ( R2 @ I4 @ J3 ) ) ) )
              @ S2 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T4 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_5040_real__of__card,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A3 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X2: A] : ( one_one @ real )
        @ A3 ) ) ).

% real_of_card
thf(fact_5041_divmod__abs__code_I6_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_5042_divmod__abs__code_I5_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ J @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J ) ) ) ).

% divmod_abs_code(5)
thf(fact_5043_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,K5: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_bounded_below
thf(fact_5044_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_5045_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A3 ) ) ) ).

% card_gt_0_iff
thf(fact_5046_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A3 )
             => ! [Y: A] :
                  ( ( member @ A @ Y @ A3 )
                 => ( X2 = Y ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_5047_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A3: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( finite_card @ A @ A3 ) )
      = ( ? [A4: A,B7: set @ A] :
            ( ( A3
              = ( insert @ A @ A4 @ B7 ) )
            & ~ ( member @ A @ A4 @ B7 )
            & ( ord_less_eq @ nat @ N @ ( finite_card @ A @ B7 ) )
            & ( finite_finite @ A @ B7 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_5048_card__Diff1__le,axiom,
    ! [A: $tType,A3: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ).

% card_Diff1_le
thf(fact_5049_card__Diff__subset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_5050_card__psubset,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
         => ( ord_less @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% card_psubset
thf(fact_5051_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_5052_card__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A3 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_5053_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite_1
thf(fact_5054_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z: A] :
                    ( ( power_power @ A @ Z @ N )
                    = ( one_one @ A ) ) ) )
            @ N ) ) ) ).

% card_roots_unity
thf(fact_5055_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N4 ) @ N ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_5056_card__sum__le__nat__sum,axiom,
    ! [S2: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S2 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ S2 ) ) ).

% card_sum_le_nat_sum
thf(fact_5057_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z: complex] :
                  ( ( power_power @ complex @ Z @ N )
                  = C2 ) ) )
          = N ) ) ) ).

% card_nth_roots
thf(fact_5058_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z: complex] :
                ( ( power_power @ complex @ Z @ N )
                = ( one_one @ complex ) ) ) )
        = N ) ) ).

% card_roots_unity_eq
thf(fact_5059_card__2__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X2: A,Y: A] :
            ( ( S2
              = ( insert @ A @ X2 @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X2 != Y ) ) ) ) ).

% card_2_iff
thf(fact_5060_card__3__iff,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ( finite_card @ A @ S2 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X2: A,Y: A,Z: A] :
            ( ( S2
              = ( insert @ A @ X2 @ ( insert @ A @ Y @ ( insert @ A @ Z @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X2 != Y )
            & ( Y != Z )
            & ( X2 != Z ) ) ) ) ).

% card_3_iff
thf(fact_5061_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) )
     => ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_5062_card_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ A3 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_5063_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ ( insert @ A @ X @ A3 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_5064_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_5065_card__Diff1__less,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff1_less
thf(fact_5066_card__Diff2__less,axiom,
    ! [A: $tType,A3: set @ A,X: A,Y2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X @ A3 )
       => ( ( member @ A @ Y2 @ A3 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_5067_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) )
      = ( ( finite_finite @ A @ A3 )
        & ( member @ A @ X @ A3 ) ) ) ).

% card_Diff1_less_iff
thf(fact_5068_card__Diff__singleton__if,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_5069_card__Diff__singleton,axiom,
    ! [A: $tType,X: A,A3: set @ A] :
      ( ( member @ A @ X @ A3 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_5070_cmod__plus__Re__le__0__iff,axiom,
    ! [Z2: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z2 )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_5071_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S2: set @ B,F2: B > A,K5: real] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ S2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S2 ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_5072_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_5073_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,N: A,K: nat] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
                & ( ord_less_eq @ A @ ( F2 @ I3 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_5074_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less @ A @ ( F2 @ I3 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A3 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_5075_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) ) ) )
         => ( ( finite_finite @ B @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_5076_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y2: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y2 ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X @ Y2 ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_5077_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K2: code_integer,L: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K2 ) @ ( abs_abs @ code_integer @ L ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K2 ) @ ( abs_abs @ code_integer @ L ) ) ) ) ) ).

% divmod_abs_def
thf(fact_5078_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              @ N ) ) ) ) ).

% polyfun_roots_card
thf(fact_5079_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S2 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S2 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S2 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K2: B] : ( if @ A @ ( K2 = A2 ) @ ( B2 @ K2 ) @ C2 )
                  @ S2 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S2 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_5080_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z @ I4 ) )
                          @ ( set_ord_atMost @ nat @ N ) )
                        = ( zero_zero @ A ) ) ) )
                @ N ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_5081_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K2 ) @ ( code_divmod_abs @ K2 @ L )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S7: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S7
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L @ S7 ) ) )
                @ ( code_divmod_abs @ K2 @ L ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K2 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K2 @ L )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S7: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S7
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L ) @ S7 ) ) )
                    @ ( code_divmod_abs @ K2 @ L ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_5082_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_5083_csqrt_Osimps_I2_J,axiom,
    ! [Z2: complex] :
      ( ( im @ ( csqrt @ Z2 ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z2 )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z2 ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( re @ Z2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_5084_apsnd__conv,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > B,X: A,Y2: C] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_Pair @ A @ C @ X @ Y2 ) )
      = ( product_Pair @ A @ B @ X @ ( F2 @ Y2 ) ) ) ).

% apsnd_conv
thf(fact_5085_Im__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X @ N ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_5086_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_5087_Im__i__times,axiom,
    ! [Z2: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z2 ) )
      = ( re @ Z2 ) ) ).

% Im_i_times
thf(fact_5088_Re__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X @ N ) )
        = ( power_power @ real @ ( re @ X ) @ N ) ) ) ).

% Re_power_real
thf(fact_5089_Re__i__times,axiom,
    ! [Z2: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z2 ) )
      = ( uminus_uminus @ real @ ( im @ Z2 ) ) ) ).

% Re_i_times
thf(fact_5090_Im__divide__numeral,axiom,
    ! [Z2: complex,W: num] :
      ( ( im @ ( divide_divide @ complex @ Z2 @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( im @ Z2 ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Im_divide_numeral
thf(fact_5091_csqrt__of__real__nonneg,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) )
       => ( ( csqrt @ X )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_5092_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( ( ord_less @ real @ ( im @ X ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X ) ) ) ) ).

% csqrt_minus
thf(fact_5093_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_5094_imaginary__unit_Osimps_I2_J,axiom,
    ( ( im @ imaginary_unit )
    = ( one_one @ real ) ) ).

% imaginary_unit.simps(2)
thf(fact_5095_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_5096_plus__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y2: complex] :
      ( ( im @ ( plus_plus @ complex @ X @ Y2 ) )
      = ( plus_plus @ real @ ( im @ X ) @ ( im @ Y2 ) ) ) ).

% plus_complex.simps(2)
thf(fact_5097_scaleR__complex_Osimps_I2_J,axiom,
    ! [R: real,X: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R @ X ) )
      = ( times_times @ real @ R @ ( im @ X ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_5098_minus__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y2: complex] :
      ( ( im @ ( minus_minus @ complex @ X @ Y2 ) )
      = ( minus_minus @ real @ ( im @ X ) @ ( im @ Y2 ) ) ) ).

% minus_complex.simps(2)
thf(fact_5099_abs__Im__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Im_le_cmod
thf(fact_5100_times__complex_Osimps_I2_J,axiom,
    ! [X: complex,Y2: complex] :
      ( ( im @ ( times_times @ complex @ X @ Y2 ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( im @ Y2 ) ) @ ( times_times @ real @ ( im @ X ) @ ( re @ Y2 ) ) ) ) ).

% times_complex.simps(2)
thf(fact_5101_cmod__Im__le__iff,axiom,
    ! [X: complex,Y2: complex] :
      ( ( ( re @ X )
        = ( re @ Y2 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y2 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( abs_abs @ real @ ( im @ Y2 ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_5102_cmod__Re__le__iff,axiom,
    ! [X: complex,Y2: complex] :
      ( ( ( im @ X )
        = ( im @ Y2 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y2 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( abs_abs @ real @ ( re @ Y2 ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_5103_times__complex_Osimps_I1_J,axiom,
    ! [X: complex,Y2: complex] :
      ( ( re @ ( times_times @ complex @ X @ Y2 ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y2 ) ) ) ) ).

% times_complex.simps(1)
thf(fact_5104_plus__complex_Ocode,axiom,
    ( ( plus_plus @ complex )
    = ( ^ [X2: complex,Y: complex] : ( complex2 @ ( plus_plus @ real @ ( re @ X2 ) @ ( re @ Y ) ) @ ( plus_plus @ real @ ( im @ X2 ) @ ( im @ Y ) ) ) ) ) ).

% plus_complex.code
thf(fact_5105_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X2: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X2 ) ) @ ( times_times @ real @ R5 @ ( im @ X2 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_5106_minus__complex_Ocode,axiom,
    ( ( minus_minus @ complex )
    = ( ^ [X2: complex,Y: complex] : ( complex2 @ ( minus_minus @ real @ ( re @ X2 ) @ ( re @ Y ) ) @ ( minus_minus @ real @ ( im @ X2 ) @ ( im @ Y ) ) ) ) ) ).

% minus_complex.code
thf(fact_5107_csqrt__principal,axiom,
    ! [Z2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z2 ) ) )
      | ( ( ( re @ ( csqrt @ Z2 ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z2 ) ) ) ) ) ).

% csqrt_principal
thf(fact_5108_cmod__le,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) ) ).

% cmod_le
thf(fact_5109_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_5110_Re__exp,axiom,
    ! [Z2: complex] :
      ( ( re @ ( exp @ complex @ Z2 ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z2 ) ) @ ( cos @ real @ ( im @ Z2 ) ) ) ) ).

% Re_exp
thf(fact_5111_Im__exp,axiom,
    ! [Z2: complex] :
      ( ( im @ ( exp @ complex @ Z2 ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z2 ) ) @ ( sin @ real @ ( im @ Z2 ) ) ) ) ).

% Im_exp
thf(fact_5112_fun__complex__eq,axiom,
    ! [A: $tType,F2: A > complex] :
      ( F2
      = ( ^ [X2: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F2 @ X2 ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_5113_complex__eq,axiom,
    ! [A2: complex] :
      ( A2
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A2 ) ) ) ) ) ).

% complex_eq
thf(fact_5114_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X2: complex,Y: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y ) ) ) ) ) ) ).

% times_complex.code
thf(fact_5115_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z ) ) ) @ ( cis @ ( im @ Z ) ) ) ) ) ).

% exp_eq_polar
thf(fact_5116_cmod__power2,axiom,
    ! [Z2: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_5117_Im__power2,axiom,
    ! [X: complex] :
      ( ( im @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X ) ) @ ( im @ X ) ) ) ).

% Im_power2
thf(fact_5118_Re__power2,axiom,
    ! [X: complex] :
      ( ( re @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_5119_complex__eq__0,axiom,
    ! [Z2: complex] :
      ( ( Z2
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_5120_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_5121_inverse__complex_Osimps_I1_J,axiom,
    ! [X: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( re @ X ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_5122_complex__neq__0,axiom,
    ! [Z2: complex] :
      ( ( ( Z2
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_5123_Re__divide,axiom,
    ! [X: complex,Y2: complex] :
      ( ( re @ ( divide_divide @ complex @ X @ Y2 ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_5124_csqrt__unique,axiom,
    ! [W: complex,Z2: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z2 )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z2 )
          = W ) ) ) ).

% csqrt_unique
thf(fact_5125_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_5126_inverse__complex_Osimps_I2_J,axiom,
    ! [X: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_5127_Im__divide,axiom,
    ! [X: complex,Y2: complex] :
      ( ( im @ ( divide_divide @ complex @ X @ Y2 ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_5128_complex__abs__le__norm,axiom,
    ! [Z2: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z2 ) ) @ ( abs_abs @ real @ ( im @ Z2 ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) ) ).

% complex_abs_le_norm
thf(fact_5129_complex__unit__circle,axiom,
    ! [Z2: complex] :
      ( ( Z2
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z2 ) @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_5130_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X2: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X2 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X2 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_5131_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X2: complex,Y: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_5132_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A3 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs )
                    = K )
                  & ( distinct @ A @ Xs )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_5133_Im__Reals__divide,axiom,
    ! [R: complex,Z2: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R ) ) @ ( im @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_5134_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A3 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs )
                  = K )
                & ( distinct @ A @ Xs )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_5135_real__eq__imaginary__iff,axiom,
    ! [Y2: complex,X: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( X
            = ( times_times @ complex @ imaginary_unit @ Y2 ) )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_5136_imaginary__eq__real__iff,axiom,
    ! [Y2: complex,X: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y2 )
            = X )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_5137_distinct__swap,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,J: nat] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs2 @ I2 @ ( nth @ A @ Xs2 @ J ) ) @ J @ ( nth @ A @ Xs2 @ I2 ) ) )
          = ( distinct @ A @ Xs2 ) ) ) ) ).

% distinct_swap
thf(fact_5138_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs )
                = N )
              & ( distinct @ A @ Xs )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_5139_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_5140_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs2 )
     => ( ( distinct @ B @ Ys )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs2 @ Ys ) ) ) ) ).

% distinct_product
thf(fact_5141_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( distinct @ A @ Xs2 )
         => ( distinct @ A @ Xs2 ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_5142_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_5143_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_5144_Reals__1,axiom,
    ! [B: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ B )
     => ( member @ B @ ( one_one @ B ) @ ( real_Vector_Reals @ B ) ) ) ).

% Reals_1
thf(fact_5145_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_5146_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_5147_Reals__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_diff
thf(fact_5148_finite__distinct__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [Xs3: list @ A] :
          ( ( ( set2 @ A @ Xs3 )
            = A3 )
          & ( distinct @ A @ Xs3 ) ) ) ).

% finite_distinct_list
thf(fact_5149_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_5150_subseqs__distinctD,axiom,
    ! [A: $tType,Ys: list @ A,Xs2: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) )
     => ( ( distinct @ A @ Xs2 )
       => ( distinct @ A @ Ys ) ) ) ).

% subseqs_distinctD
thf(fact_5151_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs: list @ A] :
          ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( I4 != J3 )
                 => ( ( nth @ A @ Xs @ I4 )
                   != ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_5152_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs2: list @ A,I2: nat,J: nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( ( ( nth @ A @ Xs2 @ I2 )
              = ( nth @ A @ Xs2 @ J ) )
            = ( I2 = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_5153_distinct__card,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs2 ) )
        = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% distinct_card
thf(fact_5154_card__distinct,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs2 ) )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( distinct @ A @ Xs2 ) ) ).

% card_distinct
thf(fact_5155_distinct__Ex1,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ? [X5: nat] :
            ( ( ord_less @ nat @ X5 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ( nth @ A @ Xs2 @ X5 )
              = X )
            & ! [Y3: nat] :
                ( ( ( ord_less @ nat @ Y3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                  & ( ( nth @ A @ Xs2 @ Y3 )
                    = X ) )
               => ( Y3 = X5 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_5156_bij__betw__nth,axiom,
    ! [A: $tType,Xs2: list @ A,A3: set @ nat,B4: set @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( A3
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
       => ( ( B4
            = ( set2 @ A @ Xs2 ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs2 ) @ A3 @ B4 ) ) ) ) ).

% bij_betw_nth
thf(fact_5157_distinct__list__update,axiom,
    ! [A: $tType,Xs2: list @ A,A2: A,I2: nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ ( nth @ A @ Xs2 @ I2 ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs2 @ I2 @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_5158_set__update__distinct,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs2 @ N @ X ) )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ ( nth @ A @ Xs2 @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5159_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N4: nat,F2: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N3: nat] : ( member @ complex @ ( G @ N3 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N3 ) ) )
             => ( ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ N4 @ N3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N3 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_5160_Re__Reals__divide,axiom,
    ! [R: complex,Z2: complex] :
      ( ( member @ complex @ R @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R @ Z2 ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R ) @ ( re @ Z2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_5161_complex__diff__cnj,axiom,
    ! [Z2: complex] :
      ( ( minus_minus @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z2 ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_5162_complex__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_5163_distinct__union,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs2 @ Ys ) )
      = ( distinct @ A @ Ys ) ) ).

% distinct_union
thf(fact_5164_complex__cnj__mult,axiom,
    ! [X: complex,Y2: complex] :
      ( ( cnj @ ( times_times @ complex @ X @ Y2 ) )
      = ( times_times @ complex @ ( cnj @ X ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_mult
thf(fact_5165_complex__cnj__one,axiom,
    ( ( cnj @ ( one_one @ complex ) )
    = ( one_one @ complex ) ) ).

% complex_cnj_one
thf(fact_5166_complex__cnj__one__iff,axiom,
    ! [Z2: complex] :
      ( ( ( cnj @ Z2 )
        = ( one_one @ complex ) )
      = ( Z2
        = ( one_one @ complex ) ) ) ).

% complex_cnj_one_iff
thf(fact_5167_complex__cnj__power,axiom,
    ! [X: complex,N: nat] :
      ( ( cnj @ ( power_power @ complex @ X @ N ) )
      = ( power_power @ complex @ ( cnj @ X ) @ N ) ) ).

% complex_cnj_power
thf(fact_5168_complex__cnj__add,axiom,
    ! [X: complex,Y2: complex] :
      ( ( cnj @ ( plus_plus @ complex @ X @ Y2 ) )
      = ( plus_plus @ complex @ ( cnj @ X ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_add
thf(fact_5169_complex__cnj__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( numeral_numeral @ complex @ W ) )
      = ( numeral_numeral @ complex @ W ) ) ).

% complex_cnj_numeral
thf(fact_5170_complex__cnj__diff,axiom,
    ! [X: complex,Y2: complex] :
      ( ( cnj @ ( minus_minus @ complex @ X @ Y2 ) )
      = ( minus_minus @ complex @ ( cnj @ X ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_diff
thf(fact_5171_complex__cnj__neg__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_cnj_neg_numeral
thf(fact_5172_complex__In__mult__cnj__zero,axiom,
    ! [Z2: complex] :
      ( ( im @ ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_5173_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_5174_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_5175_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_5176_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_5177_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_5178_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_5179_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_5180_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_5181_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_5182_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_5183_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_5184_complex__mod__mult__cnj,axiom,
    ! [Z2: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_5185_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_5186_complex__norm__square,axiom,
    ! [Z2: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z2 @ ( cnj @ Z2 ) ) ) ).

% complex_norm_square
thf(fact_5187_complex__add__cnj,axiom,
    ! [Z2: complex] :
      ( ( plus_plus @ complex @ Z2 @ ( cnj @ Z2 ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z2 ) ) ) ) ).

% complex_add_cnj
thf(fact_5188_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A4: complex,B3: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A4 @ ( cnj @ B3 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_5189_cnj__add__mult__eq__Re,axiom,
    ! [Z2: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z2 @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z2 ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z2 @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_5190_card__Pow,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A3 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Pow
thf(fact_5191_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num,N: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_5192_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num,N: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_5193_PowI,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B4 ) ) ) ).

% PowI
thf(fact_5194_Pow__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% Pow_iff
thf(fact_5195_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_5196_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_5197_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_5198_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_5199_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X2: nat] : ( H2 @ ( F22 @ X2 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_5200_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B7: set @ A] : ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) ).

% Pow_def
thf(fact_5201_PowD,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% PowD
thf(fact_5202_Pow__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A3 ) @ ( pow2 @ A @ B4 ) ) ) ).

% Pow_mono
thf(fact_5203_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_5204_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X22: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X22 ) )
      = ( F22 @ X22 ) ) ).

% old.nat.simps(5)
thf(fact_5205_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_5206_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_5207_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_5208_max__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ N @ M5 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_5209_max__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M5: nat] : ( suc @ ( ord_max @ nat @ M5 @ N ) )
        @ M ) ) ).

% max_Suc2
thf(fact_5210_diff__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K2: nat] : K2
        @ ( minus_minus @ nat @ M @ N ) ) ) ).

% diff_Suc
thf(fact_5211_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(1)
thf(fact_5212_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(2)
thf(fact_5213_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X2: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X2 ) ) ) ) ).

% old.rec_nat_def
thf(fact_5214_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X2: A,F5: nat > A,N2: nat] :
            ( if @ A
            @ ( N2
              = ( zero_zero @ nat ) )
            @ X2
            @ ( F5 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_5215_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_5216_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X: A,Y2: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y6: B] :
              ( ( X = X9 )
              & ( Y2 = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y2 ) ) ).

% The_split_eq
thf(fact_5217_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X24: nat] : X24 ) ) ).

% pred_def
thf(fact_5218_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X2: real] :
          ( the @ int
          @ ^ [Z: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z ) @ X2 )
              & ( ord_less @ real @ X2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_5219_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_5220_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X2: rat] :
          ( the @ int
          @ ^ [Z: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z ) @ X2 )
              & ( ord_less @ rat @ X2 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_5221_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_5222_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa2: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa2 )
        = Y2 )
     => ( ( ( ord_less_eq @ nat @ Xa2 @ X )
         => ( Y2
            = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa2 @ X )
         => ( Y2
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_5223_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X2: rat,Y: rat] :
          ( ( ord_less @ rat @ X2 @ Y )
          | ( X2 = Y ) ) ) ) ).

% less_eq_rat_def
thf(fact_5224_obtain__pos__sum,axiom,
    ! [R: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T6: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T6 )
               => ( R
                 != ( plus_plus @ rat @ S3 @ T6 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_5225_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A4: rat] :
          ( if @ rat
          @ ( A4
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A4 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_5226_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K2: nat,M3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M3 @ K2 ) @ ( product_Pair @ nat @ nat @ M3 @ ( minus_minus @ nat @ K2 @ M3 ) ) @ ( nat_prod_decode_aux @ ( suc @ K2 ) @ ( minus_minus @ nat @ M3 @ ( suc @ K2 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_5227_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa2 @ X )
               => ( Y2
                  = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa2 @ X )
               => ( Y2
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_5228_rat__inverse__code,axiom,
    ! [P2: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,B3: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A4
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A4 ) @ B3 ) @ ( abs_abs @ int @ A4 ) ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_inverse_code
thf(fact_5229_normalize__negative,axiom,
    ! [Q2: int,P2: int] :
      ( ( ord_less @ int @ Q2 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P2 @ Q2 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P2 ) @ ( uminus_uminus @ int @ Q2 ) ) ) ) ) ).

% normalize_negative
thf(fact_5230_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_5231_normalize__denom__zero,axiom,
    ! [P2: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P2 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_5232_rat__one__code,axiom,
    ( ( quotient_of @ ( one_one @ rat ) )
    = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% rat_one_code
thf(fact_5233_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_5234_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_5235_quotient__of__number_I4_J,axiom,
    ( ( quotient_of @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) )
    = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(4)
thf(fact_5236_diff__rat__def,axiom,
    ( ( minus_minus @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( plus_plus @ rat @ Q4 @ ( uminus_uminus @ rat @ R5 ) ) ) ) ).

% diff_rat_def
thf(fact_5237_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_5238_rat__divide__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C3 @ B3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_divide_code
thf(fact_5239_rat__times__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ B3 ) @ ( times_times @ int @ C3 @ D3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_times_code
thf(fact_5240_quotient__of__div,axiom,
    ! [R: rat,N: int,D2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ N @ D2 ) )
     => ( R
        = ( divide_divide @ rat @ ( ring_1_of_int @ rat @ N ) @ ( ring_1_of_int @ rat @ D2 ) ) ) ) ).

% quotient_of_div
thf(fact_5241_rat__plus__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ B3 @ C3 ) ) @ ( times_times @ int @ C3 @ D3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_plus_code
thf(fact_5242_rat__minus__code,axiom,
    ! [P2: rat,Q2: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P2 @ Q2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C3: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B3: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ B3 @ C3 ) ) @ ( times_times @ int @ C3 @ D3 ) ) )
            @ ( quotient_of @ Q2 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_minus_code
thf(fact_5243_quotient__of__denom__pos,axiom,
    ! [R: rat,P2: int,Q2: int] :
      ( ( ( quotient_of @ R )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% quotient_of_denom_pos
thf(fact_5244_rat__uminus__code,axiom,
    ! [P2: rat] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ P2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int] : ( product_Pair @ int @ int @ ( uminus_uminus @ int @ A4 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_uminus_code
thf(fact_5245_rat__abs__code,axiom,
    ! [P2: rat] :
      ( ( quotient_of @ ( abs_abs @ rat @ P2 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int] : ( product_Pair @ int @ int @ ( abs_abs @ int @ A4 ) )
        @ ( quotient_of @ P2 ) ) ) ).

% rat_abs_code
thf(fact_5246_normalize__denom__pos,axiom,
    ! [R: product_prod @ int @ int,P2: int,Q2: int] :
      ( ( ( normalize @ R )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q2 ) ) ).

% normalize_denom_pos
thf(fact_5247_normalize__crossproduct,axiom,
    ! [Q2: int,S: int,P2: int,R: int] :
      ( ( Q2
       != ( zero_zero @ int ) )
     => ( ( S
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P2 @ Q2 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R @ S ) ) )
         => ( ( times_times @ int @ P2 @ S )
            = ( times_times @ int @ R @ Q2 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_5248_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P5: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C3: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D3: int] : ( ord_less @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C3 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P5 ) ) ) ) ).

% rat_less_code
thf(fact_5249_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P5: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C3: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D3: int] : ( ord_less_eq @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C3 @ B3 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P5 ) ) ) ) ).

% rat_less_eq_code
thf(fact_5250_quotient__of__int,axiom,
    ! [A2: int] :
      ( ( quotient_of @ ( of_int @ A2 ) )
      = ( product_Pair @ int @ int @ A2 @ ( one_one @ int ) ) ) ).

% quotient_of_int
thf(fact_5251_drop__bit__numeral__minus__bit1,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_5252_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_5253_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_5254_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_5255_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_5256_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_5257_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_5258_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_5259_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_5260_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_5261_drop__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_5262_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_5263_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_5264_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_5265_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L2 ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L2 ) ) ) ) ).

% numeral_div_numeral
thf(fact_5266_fst__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( divide_divide @ nat @ M @ N ) ) ).

% fst_divmod_nat
thf(fact_5267_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_5268_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L2: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L2 ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_5269_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_5270_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_5271_drop__bit__numeral__minus__bit0,axiom,
    ! [L2: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_5272_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_5273_fst__eqD,axiom,
    ! [B: $tType,A: $tType,X: A,Y2: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X @ Y2 ) )
        = A2 )
     => ( X = A2 ) ) ).

% fst_eqD
thf(fact_5274_fst__conv,axiom,
    ! [B: $tType,A: $tType,X1: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = X1 ) ).

% fst_conv
thf(fact_5275_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_5276_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_drop_bit
thf(fact_5277_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_5278_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_5279_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_5280_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_5281_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% fst_divmod
thf(fact_5282_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_5283_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A4 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_5284_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_5285_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_5286_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_5287_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N2: nat,K2: int] : ( divide_divide @ int @ K2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_int_def
thf(fact_5288_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_5289_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A4: A] : ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_5290_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_5291_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N2: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A4 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_5292_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_5293_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N2: nat,A4: A] :
              ( if @ A
              @ ( N2
                = ( zero_zero @ nat ) )
              @ A4
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_5294_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_5295_Frct__code__post_I6_J,axiom,
    ! [K: num,L2: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L2 ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L2 ) ) ) ).

% Frct_code_post(6)
thf(fact_5296_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_5297_prod_Ocollapse,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) ).

% prod.collapse
thf(fact_5298_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L2 ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L2 ) ) ) ) ).

% numeral_mod_numeral
thf(fact_5299_drop__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_5300_snd__divmod__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( product_snd @ nat @ nat @ ( divmod_nat @ M @ N ) )
      = ( modulo_modulo @ nat @ M @ N ) ) ).

% snd_divmod_nat
thf(fact_5301_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_5302_snd__conv,axiom,
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X22 ) )
      = X22 ) ).

% snd_conv
thf(fact_5303_snd__eqD,axiom,
    ! [B: $tType,A: $tType,X: B,Y2: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y2 ) )
        = A2 )
     => ( Y2 = A2 ) ) ).

% snd_eqD
thf(fact_5304_prod_Oexhaust__sel,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ).

% prod.exhaust_sel
thf(fact_5305_surjective__pairing,axiom,
    ! [B: $tType,A: $tType,T2: product_prod @ A @ B] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) ).

% surjective_pairing
thf(fact_5306_drop__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_5307_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_5308_prod_Osplit__sel__asm,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F2: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) ).

% prod.split_sel_asm
thf(fact_5309_prod_Osplit__sel,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F2: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ).

% prod.split_sel
thf(fact_5310_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% snd_divmod
thf(fact_5311_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N2: nat,M3: nat] : ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% drop_bit_nat_def
thf(fact_5312_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_5313_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_5314_Frct__code__post_I7_J,axiom,
    ! [A2: int,B2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) )
      = ( uminus_uminus @ rat @ ( frct @ ( product_Pair @ int @ int @ A2 @ B2 ) ) ) ) ).

% Frct_code_post(7)
thf(fact_5315_Frct__code__post_I8_J,axiom,
    ! [A2: int,B2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( uminus_uminus @ int @ B2 ) ) )
      = ( uminus_uminus @ rat @ ( frct @ ( product_Pair @ int @ int @ A2 @ B2 ) ) ) ) ).

% Frct_code_post(8)
thf(fact_5316_Frct__code__post_I3_J,axiom,
    ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( one_one @ int ) ) )
    = ( one_one @ rat ) ) ).

% Frct_code_post(3)
thf(fact_5317_rat__sgn__code,axiom,
    ! [P2: rat] :
      ( ( quotient_of @ ( sgn_sgn @ rat @ P2 ) )
      = ( product_Pair @ int @ int @ ( sgn_sgn @ int @ ( product_fst @ int @ int @ ( quotient_of @ P2 ) ) ) @ ( one_one @ int ) ) ) ).

% rat_sgn_code
thf(fact_5318_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_5319_in__set__enumerate__eq,axiom,
    ! [A: $tType,P2: product_prod @ nat @ A,N: nat,Xs2: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P2 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P2 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P2 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) )
        & ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P2 ) @ N ) )
          = ( product_snd @ nat @ A @ P2 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_5320_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,X: A,Y2: B,A2: product_prod @ A @ B] :
      ( ( P @ X @ Y2 )
     => ( ( A2
          = ( product_Pair @ A @ B @ X @ Y2 ) )
       => ( P @ ( product_fst @ A @ B @ A2 ) @ ( product_snd @ A @ B @ A2 ) ) ) ) ).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_5321_conjI__realizer,axiom,
    ! [A: $tType,B: $tType,P: A > $o,P2: A,Q: B > $o,Q2: B] :
      ( ( P @ P2 )
     => ( ( Q @ Q2 )
       => ( ( P @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q2 ) ) )
          & ( Q @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q2 ) ) ) ) ) ) ).

% conjI_realizer
thf(fact_5322_length__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N @ Xs2 ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_enumerate
thf(fact_5323_distinct__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) ) ).

% distinct_enumerate
thf(fact_5324_subset__Collect__iff,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ B4 )
             => ( P @ X2 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_5325_subset__CollectI,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ B4 )
           => ( ( Q @ X5 )
             => ( P @ X5 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ B4 )
                & ( Q @ X2 ) ) )
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A3 )
                & ( P @ X2 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_5326_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs2: list @ A,N: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M ) @ ( nth @ A @ Xs2 @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5327_bezw__non__0,axiom,
    ! [Y2: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y2 )
     => ( ( bezw @ X @ Y2 )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X @ Y2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X @ Y2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X @ Y2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y2 ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_5328_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X2: nat,Y: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X2 @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X2 @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X2 @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Y ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_5329_bezw_Oelims,axiom,
    ! [X: nat,Xa2: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa2 )
        = Y2 )
     => ( ( ( Xa2
            = ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa2
           != ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa2 ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_5330_exI__realizer,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Y2: A,X: B] :
      ( ( P @ Y2 @ X )
     => ( P @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y2 ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X @ Y2 ) ) ) ) ).

% exI_realizer
thf(fact_5331_bezw_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa2 ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% bezw.pelims
thf(fact_5332_one__mod__minus__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_5333_minus__one__mod__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_5334_numeral__mod__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_5335_minus__numeral__mod__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_5336_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_5337_normalize__def,axiom,
    ( normalize
    = ( ^ [P5: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P5 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P5 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_5338_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F5: A > nat,G4: B > nat,P5: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F5 @ ( product_fst @ A @ B @ P5 ) ) @ ( G4 @ ( product_snd @ A @ B @ P5 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_5339_finite__enumerate,axiom,
    ! [S2: set @ nat] :
      ( ( finite_finite @ nat @ S2 )
     => ? [R4: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R4 @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S2 ) ) )
          & ! [N9: nat] :
              ( ( ord_less @ nat @ N9 @ ( finite_card @ nat @ S2 ) )
             => ( member @ nat @ ( R4 @ N9 ) @ S2 ) ) ) ) ).

% finite_enumerate
thf(fact_5340_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_5341_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_5342_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add1
thf(fact_5343_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add2
thf(fact_5344_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N ) ) ) ).

% gcd_exp
thf(fact_5345_gcd__1__int,axiom,
    ! [M: int] :
      ( ( gcd_gcd @ int @ M @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% gcd_1_int
thf(fact_5346_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_5347_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_5348_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_5349_gcd__neg__numeral__2__int,axiom,
    ! [X: int,N: num] :
      ( ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( gcd_gcd @ int @ X @ ( numeral_numeral @ int @ N ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_5350_gcd__neg__numeral__1__int,axiom,
    ! [N: num,X: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ X )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N ) @ X ) ) ).

% gcd_neg_numeral_1_int
thf(fact_5351_gcd__diff1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [M: A,N: A] :
          ( ( gcd_gcd @ A @ ( minus_minus @ A @ M @ N ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_diff1
thf(fact_5352_gcd__diff2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: A,M: A] :
          ( ( gcd_gcd @ A @ ( minus_minus @ A @ N @ M ) @ N )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_diff2
thf(fact_5353_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_5354_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N ) )
          = ( gcd_gcd @ A @ M @ N ) ) ) ).

% gcd_add_mult
thf(fact_5355_gcd__ge__0__int,axiom,
    ! [X: int,Y2: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X @ Y2 ) ) ).

% gcd_ge_0_int
thf(fact_5356_bezout__int,axiom,
    ! [X: int,Y2: int] :
    ? [U4: int,V3: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U4 @ X ) @ ( times_times @ int @ V3 @ Y2 ) )
      = ( gcd_gcd @ int @ X @ Y2 ) ) ).

% bezout_int
thf(fact_5357_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) ) ) ).

% gcd_mult_distrib_int
thf(fact_5358_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_5359_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_5360_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_5361_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_5362_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_5363_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5364_gcd__cases__int,axiom,
    ! [X: int,Y2: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
         => ( P @ ( gcd_gcd @ int @ X @ Y2 ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ Y2 ) ) ) )
         => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X @ Y2 ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_5365_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A2 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E4: int] :
            ( ( ( dvd_dvd @ int @ E4 @ A2 )
              & ( dvd_dvd @ int @ E4 @ B2 ) )
           => ( dvd_dvd @ int @ E4 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_5366_nat__descend__induct,axiom,
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K3: nat] :
          ( ( ord_less @ nat @ N @ K3 )
         => ( P @ K3 ) )
     => ( ! [K3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N )
           => ( ! [I: nat] :
                  ( ( ord_less @ nat @ K3 @ I )
                 => ( P @ I ) )
             => ( P @ K3 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_5367_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q2: product_prod @ A @ B,F2: A > B > C,G: A > B > C,P2: product_prod @ A @ B] :
      ( ! [X5: A,Y4: B] :
          ( ( ( product_Pair @ A @ B @ X5 @ Y4 )
            = Q2 )
         => ( ( F2 @ X5 @ Y4 )
            = ( G @ X5 @ Y4 ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F2 @ P2 )
          = ( product_case_prod @ A @ B @ C @ G @ Q2 ) ) ) ) ).

% split_cong
thf(fact_5368_less__by__empty,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A ),B4: set @ ( product_prod @ A @ A )] :
      ( ( A3
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A3 @ B4 ) ) ).

% less_by_empty
thf(fact_5369_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F5: A > B,A7: set @ A] :
            ! [R5: A,S7: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S7 @ A7 )
                & ( ord_less @ A @ R5 @ S7 ) )
             => ( ord_less @ B @ ( F5 @ R5 ) @ ( F5 @ S7 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_5370_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [R4: A,S3: A] :
              ( ( member @ A @ R4 @ A3 )
             => ( ( member @ A @ S3 @ A3 )
               => ( ( ord_less @ A @ R4 @ S3 )
                 => ( ord_less @ B @ ( F2 @ R4 ) @ ( F2 @ S3 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A3 ) ) ) ).

% strict_mono_onI
thf(fact_5371_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A3: set @ A,R: A,S: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ R @ A3 )
           => ( ( member @ A @ S @ A3 )
             => ( ( ord_less @ A @ R @ S )
               => ( ord_less @ B @ ( F2 @ R ) @ ( F2 @ S ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_5372_gcd__1__nat,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( one_one @ nat ) )
      = ( one_one @ nat ) ) ).

% gcd_1_nat
thf(fact_5373_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5374_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_5375_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_5376_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5377_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff1_nat
thf(fact_5378_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N @ M ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff2_nat
thf(fact_5379_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X5: nat,Y4: nat] :
          ( ( times_times @ nat @ A2 @ X5 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5380_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X5: nat,Y4: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ ( times_times @ nat @ A2 @ X5 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X5 ) @ ( times_times @ nat @ B2 @ Y4 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y4 ) @ ( times_times @ nat @ B2 @ X5 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X5 ) @ ( times_times @ nat @ A2 @ Y4 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5381_bezw__aux,axiom,
    ! [X: nat,Y2: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X @ Y2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X @ Y2 ) ) @ ( semiring_1_of_nat @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X @ Y2 ) ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) ) ).

% bezw_aux
thf(fact_5382_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A3: set @ A,X: A,Y2: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( member @ A @ Y2 @ A3 )
             => ( ( ord_less_eq @ A @ X @ Y2 )
               => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_5383_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa2: nat,Y2: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) )
       => ~ ( ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( Y2 = X ) )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( gcd_gcd @ nat @ Xa2 @ ( modulo_modulo @ nat @ X @ Xa2 ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa2 ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5384_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K2: code_integer,L: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K2
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K2 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K2 )
                  = ( sgn_sgn @ code_integer @ L ) )
                @ ( code_divmod_abs @ K2 @ L )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S7: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S7
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L ) @ S7 ) ) )
                  @ ( code_divmod_abs @ K2 @ L ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5385_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% nth_rotate1
thf(fact_5386_set__rotate1,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs2 ) )
      = ( set2 @ A @ Xs2 ) ) ).

% set_rotate1
thf(fact_5387_length__rotate1,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs2 ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_rotate1
thf(fact_5388_distinct1__rotate,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs2 ) )
      = ( distinct @ A @ Xs2 ) ) ).

% distinct1_rotate
thf(fact_5389_rotate1__length01,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs2 )
        = Xs2 ) ) ).

% rotate1_length01
thf(fact_5390_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G: C > B,A3: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X5: B,Y4: B] :
                ( ( H2 @ ( plus_plus @ B @ X5 @ Y4 ) )
                = ( plus_plus @ A @ ( H2 @ X5 ) @ ( H2 @ Y4 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G ) @ A3 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A3 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5391_set__remove1__eq,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( set2 @ A @ ( remove1 @ A @ X @ Xs2 ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_5392_card__greaterThanLessThan__int,axiom,
    ! [L2: int,U2: int] :
      ( ( finite_card @ int @ ( set_or5935395276787703475ssThan @ int @ L2 @ U2 ) )
      = ( nat2 @ ( minus_minus @ int @ U2 @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) ) ) ) ).

% card_greaterThanLessThan_int
thf(fact_5393_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A7: set @ C,F5: C > A,G4: C > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A4: C] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ ( F5 @ A4 ) @ ( G4 @ A4 ) ) )
                & ( member @ C @ A4 @ A7 ) ) ) ) ) ).

% image2_def
thf(fact_5394_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U2: A] :
          ( ( member @ A @ I2 @ ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) )
          = ( ( ord_less @ A @ L2 @ I2 )
            & ( ord_less @ A @ I2 @ U2 ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5395_in__set__remove1,axiom,
    ! [A: $tType,A2: A,B2: A,Xs2: list @ A] :
      ( ( A2 != B2 )
     => ( ( member @ A @ A2 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs2 ) ) )
        = ( member @ A @ A2 @ ( set2 @ A @ Xs2 ) ) ) ) ).

% in_set_remove1
thf(fact_5396_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,K: A] :
          ( ( ord_less_eq @ A @ L2 @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_5397_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_5398_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_5399_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5400_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] : ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% fst_diag_snd
thf(fact_5401_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% snd_diag_fst
thf(fact_5402_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] : ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% snd_diag_snd
thf(fact_5403_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% fst_diag_fst
thf(fact_5404_remove1__idem,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( remove1 @ A @ X @ Xs2 )
        = Xs2 ) ) ).

% remove1_idem
thf(fact_5405_notin__set__remove1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( remove1 @ A @ Y2 @ Xs2 ) ) ) ) ).

% notin_set_remove1
thf(fact_5406_remove1__commute,axiom,
    ! [A: $tType,X: A,Y2: A,Zs: list @ A] :
      ( ( remove1 @ A @ X @ ( remove1 @ A @ Y2 @ Zs ) )
      = ( remove1 @ A @ Y2 @ ( remove1 @ A @ X @ Zs ) ) ) ).

% remove1_commute
thf(fact_5407_distinct__remove1,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ A @ ( remove1 @ A @ X @ Xs2 ) ) ) ).

% distinct_remove1
thf(fact_5408_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5409_set__remove1__subset,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_remove1_subset
thf(fact_5410_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5411_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5412_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5413_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5414_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5415_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5416_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N2 ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_5417_image2__eqI,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: A,F2: B > A,X: B,C2: C,G: B > C,A3: set @ B] :
      ( ( B2
        = ( F2 @ X ) )
     => ( ( C2
          = ( G @ X ) )
       => ( ( member @ B @ X @ A3 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A3 @ F2 @ G ) ) ) ) ) ).

% image2_eqI
thf(fact_5418_atLeastPlusOneLessThan__greaterThanLessThan__int,axiom,
    ! [L2: int,U2: int] :
      ( ( set_or7035219750837199246ssThan @ int @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) @ U2 )
      = ( set_or5935395276787703475ssThan @ int @ L2 @ U2 ) ) ).

% atLeastPlusOneLessThan_greaterThanLessThan_int
thf(fact_5419_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5420_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5421_atLeastAtMost__diff__ends,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ).

% atLeastAtMost_diff_ends
thf(fact_5422_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5423_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5424_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5425_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5426_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5427_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5428_length__remove1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs2 ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X @ Xs2 ) )
          = ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% length_remove1
thf(fact_5429_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5430_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5431_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5432_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5433_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5434_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5435_Code__Numeral_Onegative__def,axiom,
    ( code_negative
    = ( comp @ code_integer @ code_integer @ num @ ( uminus_uminus @ code_integer ) @ ( numeral_numeral @ code_integer ) ) ) ).

% Code_Numeral.negative_def
thf(fact_5436_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X2: B,Y: A] : ( product_Pair @ A @ B @ Y @ X2 ) ) ) ) ).

% snd_fst_flip
thf(fact_5437_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X2: A,Y: B] : ( product_Pair @ B @ A @ Y @ X2 ) ) ) ) ).

% fst_snd_flip
thf(fact_5438_card__greaterThanLessThan,axiom,
    ! [L2: nat,U2: nat] :
      ( ( finite_card @ nat @ ( set_or5935395276787703475ssThan @ nat @ L2 @ U2 ) )
      = ( minus_minus @ nat @ U2 @ ( suc @ L2 ) ) ) ).

% card_greaterThanLessThan
thf(fact_5439_tanh__real__bounds,axiom,
    ! [X: real] : ( member @ real @ ( tanh @ real @ X ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) ).

% tanh_real_bounds
thf(fact_5440_refl__ge__eq,axiom,
    ! [A: $tType,R2: A > A > $o] :
      ( ! [X5: A] : ( R2 @ X5 @ X5 )
     => ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ R2 ) ) ).

% refl_ge_eq
thf(fact_5441_ge__eq__refl,axiom,
    ! [A: $tType,R2: A > A > $o,X: A] :
      ( ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
        @ R2 )
     => ( R2 @ X @ X ) ) ).

% ge_eq_refl
thf(fact_5442_fstI,axiom,
    ! [B: $tType,A: $tType,X: product_prod @ A @ B,Y2: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y2 @ Z2 ) )
     => ( ( product_fst @ A @ B @ X )
        = Y2 ) ) ).

% fstI
thf(fact_5443_sndI,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ A @ B,Y2: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y2 @ Z2 ) )
     => ( ( product_snd @ A @ B @ X )
        = Z2 ) ) ).

% sndI
thf(fact_5444_Code__Target__Int_Onegative__def,axiom,
    ( code_Target_negative
    = ( comp @ int @ int @ num @ ( uminus_uminus @ int ) @ ( numeral_numeral @ int ) ) ) ).

% Code_Target_Int.negative_def
thf(fact_5445_xor__minus__numerals_I1_J,axiom,
    ! [N: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_5446_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_5447_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_5448_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% diff_numeral_simps(1)
thf(fact_5449_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L2 ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(6)
thf(fact_5450_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L2 ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(9)
thf(fact_5451_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y2 ) ) ) ).

% semiring_norm(167)
thf(fact_5452_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y2 ) ) ) ).

% semiring_norm(166)
thf(fact_5453_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_5454_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_5455_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_5456_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L2 ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(7)
thf(fact_5457_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L2: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L2 ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L2 ) ) ) ) ).

% sub_num_simps(8)
thf(fact_5458_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_5459_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_5460_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_5461_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_5462_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_5463_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_5464_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_5465_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_5466_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_5467_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_5468_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_5469_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_5470_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L2: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L2 ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_5471_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L2: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L2 ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_5472_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K2: num,L: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K2 ) @ ( numeral_numeral @ A @ L ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_5473_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% sub_non_positive
thf(fact_5474_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% sub_non_negative
thf(fact_5475_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% sub_positive
thf(fact_5476_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% sub_negative
thf(fact_5477_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N ) @ one2 )
          = ( numeral_numeral @ A @ N ) ) ) ).

% sub_inc_One_eq
thf(fact_5478_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_5479_sub__BitM__One__eq,axiom,
    ! [N: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_5480_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5481_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5482_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_5483_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y2 ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_5484_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X @ Y2 ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_5485_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_5486_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_5487_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_5488_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_5489_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_minus'
thf(fact_5490_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_5491_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_5492_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F5: A > B] :
            ? [K6: real] :
            ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K6 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_5493_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( times_times @ A @ A4 ) @ ( F5 @ ( nth @ B @ Xs @ N2 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5494_apfst__apsnd,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F2: C > A,G: D > B,X: product_prod @ C @ D] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_apsnd @ D @ B @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( F2 @ ( product_fst @ C @ D @ X ) ) @ ( G @ ( product_snd @ C @ D @ X ) ) ) ) ).

% apfst_apsnd
thf(fact_5495_apsnd__apfst,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F2: C > B,G: D > A,X: product_prod @ D @ C] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_apfst @ D @ A @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( G @ ( product_fst @ D @ C @ X ) ) @ ( F2 @ ( product_snd @ D @ C @ X ) ) ) ) ).

% apsnd_apfst
thf(fact_5496_Suc__funpow,axiom,
    ! [N: nat] :
      ( ( compow @ ( nat > nat ) @ N @ suc )
      = ( plus_plus @ nat @ N ) ) ).

% Suc_funpow
thf(fact_5497_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X )
      = X ) ).

% funpow_0
thf(fact_5498_apfst__conv,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: C > A,X: C,Y2: B] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_Pair @ C @ B @ X @ Y2 ) )
      = ( product_Pair @ A @ B @ ( F2 @ X ) @ Y2 ) ) ).

% apfst_conv
thf(fact_5499_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N ) @ F2 ) ) ).

% funpow_mult
thf(fact_5500_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_5501_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N: nat,X: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N @ F2 @ X ) )
      = ( compow @ ( A > A ) @ N @ F2 @ ( F2 @ X ) ) ) ).

% funpow_swap1
thf(fact_5502_funpow__mod__eq,axiom,
    ! [A: $tType,N: nat,F2: A > A,X: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ X )
        = X )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N ) @ F2 @ X )
        = ( compow @ ( A > A ) @ M @ F2 @ X ) ) ) ).

% funpow_mod_eq
thf(fact_5503_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S2: set @ A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S2 @ S2 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ S2 @ S2 ) ) ).

% bij_betw_funpow
thf(fact_5504_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% comp_funpow
thf(fact_5505_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_5506_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_5507_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow_add
thf(fact_5508_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_5509_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N2: nat] : ( compow @ ( A > A ) @ N2 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_5510_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K2: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K2 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_5511_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5512_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N2: nat,P4: A > A > $o,X2: A,Y: A] :
          ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = X2 )
            & ( ( F5 @ N2 )
              = Y )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N2 )
               => ( P4 @ ( F5 @ I4 ) @ ( F5 @ ( suc @ I4 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5513_relpowp__1,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( one_one @ nat ) @ P )
      = P ) ).

% relpowp_1
thf(fact_5514_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5515_apfst__convE,axiom,
    ! [C: $tType,A: $tType,B: $tType,Q2: product_prod @ A @ B,F2: C > A,P2: product_prod @ C @ B] :
      ( ( Q2
        = ( product_apfst @ C @ A @ B @ F2 @ P2 ) )
     => ~ ! [X5: C,Y4: B] :
            ( ( P2
              = ( product_Pair @ C @ B @ X5 @ Y4 ) )
           => ( Q2
             != ( product_Pair @ A @ B @ ( F2 @ X5 ) @ Y4 ) ) ) ) ).

% apfst_convE
thf(fact_5516_card__UNION,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A3 )
     => ( ! [X5: set @ A] :
            ( ( member @ ( set @ A ) @ X5 @ A3 )
           => ( finite_finite @ A @ X5 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I8: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I8 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I8 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I8 @ A3 )
                    & ( I8
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5517_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_atLeastAtMost
thf(fact_5518_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
            = X ) ) ) ).

% Inf_atLeastAtMost
thf(fact_5519_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_atLeastLessThan
thf(fact_5520_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y2 ) )
            = X ) ) ) ).

% Inf_atLeastLessThan
thf(fact_5521_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_5522_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y2 ) )
            = X ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_5523_card__Union__le__sum__card,axiom,
    ! [A: $tType,U5: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U5 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U5 ) ) ).

% card_Union_le_sum_card
thf(fact_5524_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X5 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_5525_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B4: set @ ( set @ B ),G: B > A] :
          ( ! [X5: set @ B] :
              ( ( member @ ( set @ B ) @ X5 @ B4 )
             => ( finite_finite @ B @ X5 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B4 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B4 )
                   => ( ( A14 != A25 )
                     => ! [X5: B] :
                          ( ( member @ B @ X5 @ A14 )
                         => ( ( member @ B @ X5 @ A25 )
                           => ( ( G @ X5 )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B4 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ B4 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_5526_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U5: set @ ( set @ A )] :
      ( ! [X5: set @ A] :
          ( ( member @ ( set @ A ) @ X5 @ U5 )
         => ( finite_finite @ A @ X5 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U5 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U5 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_5527_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L2: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X5 @ L2 ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S2 ) @ L2 ) ) @ E ) ) ) ) ).

% cInf_asclose
thf(fact_5528_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,L2: A,E: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X5 @ L2 ) ) @ E ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S2 ) @ L2 ) ) @ E ) ) ) ) ).

% cSup_asclose
thf(fact_5529_finite__subset__Union,axiom,
    ! [A: $tType,A3: set @ A,B11: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ B11 ) )
       => ~ ! [F7: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F7 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F7 @ B11 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ F7 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_5530_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X ) )
            = Y2 ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_5531_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X ) )
            = X ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_5532_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X ) )
            = Y2 ) ) ) ).

% cInf_atLeastLessThan
thf(fact_5533_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y2 @ X ) )
            = X ) ) ) ).

% cSup_atLeastAtMost
thf(fact_5534_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y2 @ X ) )
            = Y2 ) ) ) ).

% cInf_atLeastAtMost
thf(fact_5535_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X ) )
            = X ) ) ) ).

% cSup_atLeastLessThan
thf(fact_5536_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B6: A] :
          ( ( ord_less @ A @ A2 @ B6 )
          | ( ord_less @ A @ B6 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_5537_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C4: A] :
                  ( ( ord_less_eq @ A @ A2 @ C4 )
                  & ( ord_less_eq @ A @ C4 @ B2 )
                  & ! [X3: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X3 )
                        & ( ord_less @ A @ X3 @ C4 ) )
                     => ( P @ X3 ) )
                  & ! [D6: A] :
                      ( ! [X5: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X5 )
                            & ( ord_less @ A @ X5 @ D6 ) )
                         => ( P @ X5 ) )
                     => ( ord_less_eq @ A @ D6 @ C4 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_5538_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X8: set @ A] :
          ( ( member @ A @ Z2 @ X8 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ X5 @ Z2 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = Z2 ) ) ) ) ).

% cSup_eq_maximum
thf(fact_5539_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ X8 )
             => ( ord_less_eq @ A @ X5 @ A2 ) )
         => ( ! [Y4: A] :
                ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                   => ( ord_less_eq @ A @ X3 @ Y4 ) )
               => ( ord_less_eq @ A @ A2 @ Y4 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_5540_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z2: A,X8: set @ A] :
          ( ( member @ A @ Z2 @ X8 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ Z2 @ X5 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = Z2 ) ) ) ) ).

% cInf_eq_minimum
thf(fact_5541_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ X8 )
             => ( ord_less_eq @ A @ A2 @ X5 ) )
         => ( ! [Y4: A] :
                ( ! [X3: A] :
                    ( ( member @ A @ X3 @ X8 )
                   => ( ord_less_eq @ A @ Y4 @ X3 ) )
               => ( ord_less_eq @ A @ Y4 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_5542_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ X5 @ A2 ) )
           => ( ! [Y4: A] :
                  ( ! [X3: A] :
                      ( ( member @ A @ X3 @ X8 )
                     => ( ord_less_eq @ A @ X3 @ Y4 ) )
                 => ( ord_less_eq @ A @ A2 @ Y4 ) )
             => ( ( complete_Sup_Sup @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_5543_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ X5 @ Z2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X8 ) @ Z2 ) ) ) ) ).

% cSup_least
thf(fact_5544_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_5545_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y2: A,X8: set @ A] :
          ( ( ord_less @ A @ Y2 @ ( complete_Sup_Sup @ A @ X8 ) )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X5: A] :
                  ( ( member @ A @ X5 @ X8 )
                 => ~ ( ord_less @ A @ Y2 @ X5 ) ) ) ) ) ).

% less_cSupE
thf(fact_5546_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z2 @ ( complete_Sup_Sup @ A @ X8 ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ X8 )
                & ( ord_less @ A @ Z2 @ X5 ) ) ) ) ) ).

% less_cSupD
thf(fact_5547_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ X8 )
                 => ( ord_less @ A @ X5 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_5548_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ A2 @ X5 ) )
           => ( ! [Y4: A] :
                  ( ! [X3: A] :
                      ( ( member @ A @ X3 @ X8 )
                     => ( ord_less_eq @ A @ Y4 @ X3 ) )
                 => ( ord_less_eq @ A @ Y4 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_5549_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ( ord_less_eq @ A @ Z2 @ X5 ) )
           => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ).

% cInf_greatest
thf(fact_5550_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ X ) ) ) ) ).

% cInf_le_finite
thf(fact_5551_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Z2 )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ X8 )
                & ( ord_less @ A @ X5 @ Z2 ) ) ) ) ) ).

% cInf_lessD
thf(fact_5552_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X @ X8 )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ X8 )
                 => ( ord_less @ A @ A2 @ X5 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_5553_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X8 )
                   => ( ord_less @ A @ X2 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_5554_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X8 )
                   => ( ord_less @ A @ A2 @ X2 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_5555_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S2: set @ A,A2: A] :
          ( ( S2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S2 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X5 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S2 ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_5556_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ A3 )
                    & ( ord_less @ A @ Y @ X2 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_5557_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Inf_le_Sup
thf(fact_5558_subset__Pow__Union,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ A3 @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) ) ) ).

% subset_Pow_Union
thf(fact_5559_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U2: A,A3: set @ A,V: A] :
          ( ( member @ A @ U2 @ A3 )
         => ( ( ord_less_eq @ A @ V @ U2 )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5560_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ B2 )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5561_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Sup_upper
thf(fact_5562_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ A3 )
             => ( ord_less_eq @ A @ X5 @ Z2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ Z2 ) ) ) ).

% Sup_least
thf(fact_5563_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ! [A6: A] :
              ( ( member @ A @ A6 @ A3 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ B4 )
                  & ( ord_less_eq @ A @ A6 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_mono
thf(fact_5564_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ! [Y4: A] :
              ( ( member @ A @ Y4 @ A3 )
             => ( ord_less_eq @ A @ Y4 @ X ) )
         => ( ! [Y4: A] :
                ( ! [Z3: A] :
                    ( ( member @ A @ Z3 @ A3 )
                   => ( ord_less_eq @ A @ Z3 @ Y4 ) )
               => ( ord_less_eq @ A @ X @ Y4 ) )
           => ( ( complete_Sup_Sup @ A @ A3 )
              = X ) ) ) ) ).

% Sup_eqI
thf(fact_5565_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S2: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ S2 )
                & ( ord_less @ A @ A2 @ X2 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5566_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z2: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ A3 )
             => ( ord_less_eq @ A @ Z2 @ X5 ) )
         => ( ord_less_eq @ A @ Z2 @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ).

% Inf_greatest
thf(fact_5567_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A3 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A3 )
               => ( ord_less_eq @ A @ B2 @ X2 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5568_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U2: A,A3: set @ A,V: A] :
          ( ( member @ A @ U2 @ A3 )
         => ( ( ord_less_eq @ A @ U2 @ V )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ V ) ) ) ) ).

% Inf_lower2
thf(fact_5569_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X ) ) ) ).

% Inf_lower
thf(fact_5570_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ! [B6: A] :
              ( ( member @ A @ B6 @ B4 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ A3 )
                  & ( ord_less_eq @ A @ X3 @ B6 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ).

% Inf_mono
thf(fact_5571_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X: A] :
          ( ! [I3: A] :
              ( ( member @ A @ I3 @ A3 )
             => ( ord_less_eq @ A @ X @ I3 ) )
         => ( ! [Y4: A] :
                ( ! [I: A] :
                    ( ( member @ A @ I @ A3 )
                   => ( ord_less_eq @ A @ Y4 @ I ) )
               => ( ord_less_eq @ A @ Y4 @ X ) )
           => ( ( complete_Inf_Inf @ A @ A3 )
              = X ) ) ) ) ).

% Inf_eqI
thf(fact_5572_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S2: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ S2 )
                & ( ord_less @ A @ X2 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5573_Union__subsetI,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] :
      ( ! [X5: set @ A] :
          ( ( member @ ( set @ A ) @ X5 @ A3 )
         => ? [Y3: set @ A] :
              ( ( member @ ( set @ A ) @ Y3 @ B4 )
              & ( ord_less_eq @ ( set @ A ) @ X5 @ Y3 ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) ) ) ).

% Union_subsetI
thf(fact_5574_Union__upper,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B4 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) ) ) ).

% Union_upper
thf(fact_5575_Union__least,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C5: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ C5 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ C5 ) ) ).

% Union_least
thf(fact_5576_Inter__greatest,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C5: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ C5 @ X10 ) )
     => ( ord_less_eq @ ( set @ A ) @ C5 @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) ) ) ).

% Inter_greatest
thf(fact_5577_Inter__lower,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B4 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B4 ) ) ).

% Inter_lower
thf(fact_5578_Union__SetCompr__eq,axiom,
    ! [B: $tType,A: $tType,F2: B > ( set @ A ),P: B > $o] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [Uu3: set @ A] :
            ? [X2: B] :
              ( ( Uu3
                = ( F2 @ X2 ) )
              & ( P @ X2 ) ) ) )
      = ( collect @ A
        @ ^ [A4: A] :
          ? [X2: B] :
            ( ( P @ X2 )
            & ( member @ A @ A4 @ ( F2 @ X2 ) ) ) ) ) ).

% Union_SetCompr_eq
thf(fact_5579_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less @ A @ Y @ X2 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5580_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X @ Y )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A3 )
                    & ( ord_less @ A @ X2 @ Y ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5581_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U2: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ U2 @ V3 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5582_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5583_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U2: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ V3 @ U2 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ U2 ) ) ) ) ).

% Inf_less_eq
thf(fact_5584_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ A,A3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5585_Union__mono,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) ) ) ).

% Union_mono
thf(fact_5586_Inter__anti__mono,axiom,
    ! [A: $tType,B4: set @ ( set @ A ),A3: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B4 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B4 ) ) ) ).

% Inter_anti_mono
thf(fact_5587_Inter__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ B4 ) )
     => ( ( A3
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B4 ) ) ) ).

% Inter_subset
thf(fact_5588_card__partition,axiom,
    ! [A: $tType,C5: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C5 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) )
       => ( ! [C4: set @ A] :
              ( ( member @ ( set @ A ) @ C4 @ C5 )
             => ( ( finite_card @ A @ C4 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C5 )
               => ( ( member @ ( set @ A ) @ C22 @ C5 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C5 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C5 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5589_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X2: nat,Y: nat] : ( ord_less_eq @ nat @ Y @ X2 )
    @ ^ [X2: nat,Y: nat] : ( ord_less @ nat @ Y @ X2 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5590_set__removeAll,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X @ Xs2 ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5591_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_5592_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y2 @ Z2 ) )
          = ( ( ord_less_eq @ A @ X @ Y2 )
            & ( ord_less_eq @ A @ X @ Z2 ) ) ) ) ).

% le_inf_iff
thf(fact_5593_Int__subset__iff,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C5 @ A3 )
        & ( ord_less_eq @ ( set @ A ) @ C5 @ B4 ) ) ) ).

% Int_subset_iff
thf(fact_5594_removeAll__id,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( removeAll @ A @ X @ Xs2 )
        = Xs2 ) ) ).

% removeAll_id
thf(fact_5595_Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_disjoint
thf(fact_5596_Diff__Compl,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_Compl
thf(fact_5597_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X2 ) ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5598_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X2 ) ) @ ( F2 @ X2 ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5599_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B4 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5600_Union__Int__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B4 ) ) ) ).

% Union_Int_subset
thf(fact_5601_diff__eq,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ( ( minus_minus @ A )
        = ( ^ [X2: A,Y: A] : ( inf_inf @ A @ X2 @ ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% diff_eq
thf(fact_5602_distinct__removeAll,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ A @ ( removeAll @ A @ X @ Xs2 ) ) ) ).

% distinct_removeAll
thf(fact_5603_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_5604_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_5605_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( inf_inf @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_5606_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_5607_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_5608_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_5609_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_5610_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_5611_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_5612_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_5613_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_5614_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( inf_inf @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_5615_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_5616_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_5617_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( inf_inf @ A @ A4 @ B3 ) ) ) ) ) ).

% inf.order_iff
thf(fact_5618_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ X @ Z2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y2 @ Z2 ) ) ) ) ) ).

% inf_greatest
thf(fact_5619_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_5620_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_5621_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( inf_inf @ A @ X @ Y2 )
            = Y2 ) ) ) ).

% inf_absorb2
thf(fact_5622_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( inf_inf @ A @ X @ Y2 )
            = X ) ) ) ).

% inf_absorb1
thf(fact_5623_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_5624_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_5625_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( inf_inf @ A @ X2 @ Y )
              = X2 ) ) ) ) ).

% le_iff_inf
thf(fact_5626_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X: A,Y2: A] :
          ( ! [X5: A,Y4: A] : ( ord_less_eq @ A @ ( F2 @ X5 @ Y4 ) @ X5 )
         => ( ! [X5: A,Y4: A] : ( ord_less_eq @ A @ ( F2 @ X5 @ Y4 ) @ Y4 )
           => ( ! [X5: A,Y4: A,Z5: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y4 )
                 => ( ( ord_less_eq @ A @ X5 @ Z5 )
                   => ( ord_less_eq @ A @ X5 @ ( F2 @ Y4 @ Z5 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y2 )
                = ( F2 @ X @ Y2 ) ) ) ) ) ) ).

% inf_unique
thf(fact_5627_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_5628_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_5629_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_5630_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_5631_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_5632_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_5633_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A2 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_5634_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y2 ) @ Y2 ) ) ).

% inf_le2
thf(fact_5635_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y2 ) @ X ) ) ).

% inf_le1
thf(fact_5636_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y2 ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_5637_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y2 ) @ Y2 ) ) ).

% inf_sup_ord(2)
thf(fact_5638_Int__mono,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( inf_inf @ ( set @ A ) @ C5 @ D5 ) ) ) ) ).

% Int_mono
thf(fact_5639_Int__lower1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ A3 ) ).

% Int_lower1
thf(fact_5640_Int__lower2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ B4 ) ).

% Int_lower2
thf(fact_5641_Int__absorb1,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = B4 ) ) ).

% Int_absorb1
thf(fact_5642_Int__absorb2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = A3 ) ) ).

% Int_absorb2
thf(fact_5643_Int__greatest,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ C5 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ C5 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% Int_greatest
thf(fact_5644_Int__Collect__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( ( P @ X5 )
             => ( Q @ X5 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B4 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_5645_Diff__Int__distrib2,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C5 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Diff_Int_distrib2
thf(fact_5646_Diff__Int__distrib,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ C5 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ C5 @ A3 ) @ ( inf_inf @ ( set @ A ) @ C5 @ B4 ) ) ) ).

% Diff_Int_distrib
thf(fact_5647_Diff__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ).

% Diff_Diff_Int
thf(fact_5648_Diff__Int2,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C5 ) @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ C5 ) @ B4 ) ) ).

% Diff_Int2
thf(fact_5649_Int__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Int_Diff
thf(fact_5650_Int__Diff__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Int_Diff_disjoint
thf(fact_5651_Diff__triv,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ B4 )
        = A3 ) ) ).

% Diff_triv
thf(fact_5652_Diff__eq,axiom,
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] : ( inf_inf @ ( set @ A ) @ A7 @ ( uminus_uminus @ ( set @ A ) @ B7 ) ) ) ) ).

% Diff_eq
thf(fact_5653_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_removeAll_less_eq
thf(fact_5654_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( ( inf_inf @ A @ X @ Y2 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% inf_shunt
thf(fact_5655_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B4 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_5656_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( remove1 @ A @ X @ Xs2 )
        = ( removeAll @ A @ X @ Xs2 ) ) ) ).

% distinct_remove1_removeAll
thf(fact_5657_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( member @ B @ X2 @ B4 ) @ ( G @ X2 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_restrict
thf(fact_5658_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T4: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( H2 @ I3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T4 ) )
                   => ( ( G @ I3 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X5: B] :
                      ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ S2 @ T4 ) )
                     => ( ( G @ X5 )
                        = ( H2 @ X5 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S2 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T4 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_5659_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_5660_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5661_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B4: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5662_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T4: set @ B,S2: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T4 )
         => ( ( finite_finite @ B @ S2 )
           => ( ! [I3: B] :
                  ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
                 => ( ( H2 @ I3 )
                    = ( one_one @ A ) ) )
             => ( ! [I3: B] :
                    ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ S2 @ T4 ) )
                   => ( ( G @ I3 )
                      = ( one_one @ A ) ) )
               => ( ! [X5: B] :
                      ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ S2 @ T4 ) )
                     => ( ( G @ X5 )
                        = ( H2 @ X5 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S2 )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T4 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_5663_card__Diff__subset__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ).

% card_Diff_subset_Int
thf(fact_5664_length__removeAll__less,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_removeAll_less
thf(fact_5665_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5666_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( H2 @ X2 ) @ ( G @ X2 ) )
              @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5667_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A4: B] : ( divide_divide @ A @ ( F2 @ A4 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A3
                  @ ( collect @ B
                    @ ^ [A4: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A3
                    @ ( collect @ B
                      @ ^ [A4: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5668_distinct__concat,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs2 )
     => ( ! [Ys4: list @ A] :
            ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs2 ) )
           => ( distinct @ A @ Ys4 ) )
       => ( ! [Ys4: list @ A,Zs2: list @ A] :
              ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs2 ) )
             => ( ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs2 ) )
               => ( ( Ys4 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs2 ) ) ) ) ) ).

% distinct_concat
thf(fact_5669_finite__inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( inf_inf @ A @ A2 @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( complete_Sup_Sup @ A
            @ ( collect @ A
              @ ^ [Uu3: A] :
                ? [B3: A] :
                  ( ( Uu3
                    = ( inf_inf @ A @ A2 @ B3 ) )
                  & ( member @ A @ B3 @ A3 ) ) ) ) ) ) ).

% finite_inf_Sup
thf(fact_5670_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs2 @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5671_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5672_finite__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] : ( finite_finite @ ( list @ A ) @ ( shuffles @ A @ Xs2 @ Ys ) ) ).

% finite_shuffles
thf(fact_5673_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R2 )
        @ ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ S2 ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S2 ) ) ) ) ).

% inf_Int_eq2
thf(fact_5674_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs: list @ A,Ys3: list @ A] : ( shuffles @ A @ Ys3 @ Xs ) ) ) ).

% shuffles_commutes
thf(fact_5675_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_5676_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_5677_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F5: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y: A] :
                  ( ( ord_less @ nat @ ( F5 @ X2 ) @ ( F5 @ Y ) )
                  | ( ( ord_less_eq @ nat @ ( F5 @ X2 ) @ ( F5 @ Y ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_5678_distinct__concat__iff,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs2 ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs2 ) )
        & ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs2 ) )
           => ( distinct @ A @ Ys3 ) )
        & ! [Ys3: list @ A,Zs3: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs2 ) )
              & ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs2 ) )
              & ( Ys3 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_5679_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ! [X5: list @ A] :
          ( ( member @ ( list @ A ) @ X5 @ ( set2 @ ( list @ A ) @ Xss ) )
         => ( distinct @ A @ X5 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) ) ).

% distinct_product_lists
thf(fact_5680_list__update__nonempty,axiom,
    ! [A: $tType,Xs2: list @ A,K: nat,X: A] :
      ( ( ( list_update @ A @ Xs2 @ K @ X )
        = ( nil @ A ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_5681_concat__replicate__trivial,axiom,
    ! [A: $tType,I2: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I2 @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_5682_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs2 @ Ys ) )
      = ( ( Xs2
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_5683_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N: nat] :
      ( ( enumerate @ A @ N @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_5684_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( rotate1 @ A @ Xs2 )
        = ( nil @ A ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_5685_set__empty,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( set2 @ A @ Xs2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_5686_set__empty2,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs2 ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_5687_length__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( zero_zero @ nat ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_5688_replicate__empty,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( replicate @ A @ N @ X )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_5689_empty__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_5690_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss )
        = ( nil @ A ) )
      = ( ! [X2: list @ A] :
            ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_5691_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss ) )
      = ( ! [X2: list @ A] :
            ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_5692_length__greater__0__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ( Xs2
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_5693_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2
        = ( nil @ A ) )
     => ( ( Ys
          = ( nil @ A ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs2 @ Ys ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_5694_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_5695_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( shuffles @ A @ Xs2 @ ( nil @ A ) )
      = ( insert @ ( list @ A ) @ Xs2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_5696_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_5697_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remove1 @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_5698_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_5699_list__update__code_I1_J,axiom,
    ! [A: $tType,I2: nat,Y2: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ Y2 )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_5700_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I2: nat,V: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I2 @ V )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_5701_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_5702_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_5703_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X: A] :
      ( ( removeAll @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_5704_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_5705_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_5706_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_5707_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_5708_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y2: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y2 )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_5709_mlex__iff,axiom,
    ! [A: $tType,X: A,Y2: A,F2: A > nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( mlex_prod @ A @ F2 @ R2 ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y2 ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y2 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R2 ) ) ) ) ).

% mlex_iff
thf(fact_5710_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y2 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( mlex_prod @ A @ F2 @ R2 ) ) ) ).

% mlex_less
thf(fact_5711_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y2 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( mlex_prod @ A @ F2 @ R2 ) ) ) ) ).

% mlex_leq
thf(fact_5712_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_5713_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs2: list @ A,Xss: list @ ( list @ A )] :
      ( ( member @ ( list @ A ) @ Xs2 @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_5714_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S2: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                  & ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5715_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S2: set @ A,Y2: A,F2: A > B] :
          ( ( finite_finite @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y2 @ S2 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S2 ) ) @ ( F2 @ Y2 ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5716_times__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U3: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U3 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y @ U3 ) ) ) )
          @ Xa2
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_5717_eq__Abs__Integ,axiom,
    ! [Z2: int] :
      ~ ! [X5: nat,Y4: nat] :
          ( Z2
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X5 @ Y4 ) ) ) ).

% eq_Abs_Integ
thf(fact_5718_nat_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( nat2 @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ X ) ) ).

% nat.abs_eq
thf(fact_5719_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5720_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N2: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N2 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5721_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X2: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X2 )
          @ X ) ) ) ).

% uminus_int.abs_eq
thf(fact_5722_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5723_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) )
            @ X ) ) ) ).

% of_int.abs_eq
thf(fact_5724_less__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U3: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U3 @ Y ) ) )
        @ Xa2
        @ X ) ) ).

% less_int.abs_eq
thf(fact_5725_less__eq__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U3: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U3 @ Y ) ) )
        @ Xa2
        @ X ) ) ).

% less_eq_int.abs_eq
thf(fact_5726_plus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U3: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U3 ) @ ( plus_plus @ nat @ Y @ V5 ) ) )
          @ Xa2
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_5727_minus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U3: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y @ U3 ) ) )
          @ Xa2
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_5728_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_5729_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs2 @ ( nil @ A ) )
        = ( insert @ ( list @ A ) @ Xs2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_5730_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys )
        = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_5731_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U3: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U3 @ Z ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5732_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y: nat,Z: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U3: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y @ V5 ) @ ( plus_plus @ nat @ U3 @ Z ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5733_lex__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: set @ ( product_prod @ A @ A ),Rb: set @ ( product_prod @ B @ B )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A4: A,B3: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A9: A,B12: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A9 ) @ Ra )
                        | ( ( A4 = A9 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B3 @ B12 ) @ Rb ) ) ) ) ) ) ) ) ) ).

% lex_prod_def
thf(fact_5734_in__lex__prod,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B5: B,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ ( lex_prod @ A @ B @ R @ S ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A5 ) @ R )
        | ( ( A2 = A5 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B2 @ B5 ) @ S ) ) ) ) ).

% in_lex_prod
thf(fact_5735_nat_Orep__eq,axiom,
    ( nat2
    = ( ^ [X2: int] : ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ ( rep_Integ @ X2 ) ) ) ) ).

% nat.rep_eq
thf(fact_5736_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X2: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) )
              @ ( rep_Integ @ X2 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_5737_same__fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P4: A > $o,R6: A > ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X9: A,Y6: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X2: A,Y: B] :
                        ( ( X9 = X2 )
                        & ( P4 @ X2 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y ) @ ( R6 @ X2 ) ) ) ) ) ) ) ) ) ).

% same_fst_def
thf(fact_5738_prod__encode__def,axiom,
    ( nat_prod_encode
    = ( product_case_prod @ nat @ nat @ nat
      @ ^ [M3: nat,N2: nat] : ( plus_plus @ nat @ ( nat_triangle @ ( plus_plus @ nat @ M3 @ N2 ) ) @ M3 ) ) ) ).

% prod_encode_def
thf(fact_5739_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X2: nat,Y: nat] : ( product_Pair @ nat @ nat @ Y @ X2 ) ) ) ) ).

% uminus_int_def
thf(fact_5740_same__fstI,axiom,
    ! [B: $tType,A: $tType,P: A > $o,X: A,Y7: B,Y2: B,R2: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ( P @ X )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y7 @ Y2 ) @ ( R2 @ X ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y7 ) @ ( product_Pair @ A @ B @ X @ Y2 ) ) @ ( same_fst @ A @ B @ P @ R2 ) ) ) ) ).

% same_fstI
thf(fact_5741_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_5742_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : ( ord_less_eq @ nat @ A2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_5743_prod__encode__prod__decode__aux,axiom,
    ! [K: nat,M: nat] :
      ( ( nat_prod_encode @ ( nat_prod_decode_aux @ K @ M ) )
      = ( plus_plus @ nat @ ( nat_triangle @ K ) @ M ) ) ).

% prod_encode_prod_decode_aux
thf(fact_5744_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U3: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U3 ) @ ( times_times @ nat @ Y @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y @ U3 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_5745_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U3: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y @ U3 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_5746_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U3: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U3 ) @ ( plus_plus @ nat @ Y @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_5747_eq__snd__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,P2: product_prod @ B @ A] :
      ( ( B2
        = ( product_snd @ B @ A @ P2 ) )
      = ( ? [A4: B] :
            ( P2
            = ( product_Pair @ B @ A @ A4 @ B2 ) ) ) ) ).

% eq_snd_iff
thf(fact_5748_Gcd__remove0__nat,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( gcd_Gcd @ nat @ M7 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M7 @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_5749_eq__fst__iff,axiom,
    ! [A: $tType,B: $tType,A2: A,P2: product_prod @ A @ B] :
      ( ( A2
        = ( product_fst @ A @ B @ P2 ) )
      = ( ? [B3: B] :
            ( P2
            = ( product_Pair @ A @ B @ A2 @ B3 ) ) ) ) ).

% eq_fst_iff
thf(fact_5750_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( gcd_Gcd @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_5751_Gcd__1,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( member @ A @ ( one_one @ A ) @ A3 )
         => ( ( gcd_Gcd @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_1
thf(fact_5752_Gcd__nat__eq__one,axiom,
    ! [N4: set @ nat] :
      ( ( member @ nat @ ( one_one @ nat ) @ N4 )
     => ( ( gcd_Gcd @ nat @ N4 )
        = ( one_one @ nat ) ) ) ).

% Gcd_nat_eq_one
thf(fact_5753_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( member @ A @ A2 @ A3 )
           => ( ( gcd_Gcd @ A @ A3 )
              = ( one_one @ A ) ) ) ) ) ).

% Gcd_eq_1_I
thf(fact_5754_insert__subsetI,axiom,
    ! [A: $tType,X: A,A3: set @ A,X8: set @ A] :
      ( ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ X8 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X8 ) @ A3 ) ) ) ).

% insert_subsetI
thf(fact_5755_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_5756_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_5757_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_5758_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_5759_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 ) )
        = ( ^ [X2: A,Y: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X2 @ Y ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_5760_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z: A] :
              ( Z
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_5761_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_5762_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_5763_Gcd__int__greater__eq__0,axiom,
    ! [K5: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_5764_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_5765_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_5766_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_5767_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_5768_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_5769_ssubst__Pair__rhs,axiom,
    ! [B: $tType,A: $tType,R: A,S: B,R2: set @ ( product_prod @ A @ B ),S8: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R2 )
     => ( ( S8 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S8 ) @ R2 ) ) ) ).

% ssubst_Pair_rhs
thf(fact_5770_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_5771_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_5772_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_5773_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_5774_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_5775_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y2 @ X ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_5776_prop__restrict,axiom,
    ! [A: $tType,X: A,Z8: set @ A,X8: set @ A,P: A > $o] :
      ( ( member @ A @ X @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ X8 )
                & ( P @ X2 ) ) ) )
       => ( P @ X ) ) ) ).

% prop_restrict
thf(fact_5777_Collect__restrict,axiom,
    ! [A: $tType,X8: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ X8 )
            & ( P @ X2 ) ) )
      @ X8 ) ).

% Collect_restrict
thf(fact_5778_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_5779_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_5780_subset__emptyI,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ! [X5: A] :
          ~ ( member @ A @ X5 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_5781_listrel1__iff__update,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) )
      = ( ? [Y: A,N2: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs2 @ N2 ) @ Y ) @ R )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( Ys
              = ( list_update @ A @ Xs2 @ N2 @ Y ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_5782_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = ( inc @ ( num_of_nat @ N ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_5783_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,P2: B > A,I2: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( P2 @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I2 @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( insert @ B @ I2 @ I5 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P2 @ I5 ) ) )
            & ( ~ ( member @ B @ I2 @ I5 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( insert @ B @ I2 @ I5 ) )
                = ( times_times @ A @ ( P2 @ I2 ) @ ( groups1962203154675924110t_prod @ B @ A @ P2 @ I5 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5784_num__of__nat__numeral__eq,axiom,
    ! [Q2: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q2 ) )
      = Q2 ) ).

% num_of_nat_numeral_eq
thf(fact_5785_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P2: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P2 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_5786_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I5: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) ) ) ).

% prod.non_neutral'
thf(fact_5787_listrel1__mono,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R ) @ ( listrel1 @ A @ S ) ) ) ).

% listrel1_mono
thf(fact_5788_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) @ ( listrel1 @ A @ R ) ) ).

% not_listrel1_Nil
thf(fact_5789_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs2 ) @ ( listrel1 @ A @ R ) ) ).

% not_Nil_listrel1
thf(fact_5790_listrel1__eq__len,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_5791_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_5792_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I4: B] : ( times_times @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
              @ I5 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I5 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5793_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T4: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( G @ X5 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T4 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_5794_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T4: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( G @ X5 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T4 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S2 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_5795_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T4: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( H2 @ I3 )
                  = ( one_one @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S2 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S2 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T4 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_5796_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T4: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S2 @ T4 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ ( minus_minus @ ( set @ B ) @ T4 @ S2 ) )
               => ( ( G @ X5 )
                  = ( one_one @ A ) ) )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ S2 )
                 => ( ( G @ X5 )
                    = ( H2 @ X5 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T4 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_5797_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N ) )
        = N ) ) ).

% numeral_num_of_nat
thf(fact_5798_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_5799_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( G @ X2 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I5 )
                    & ( ( H2 @ X2 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I4: B] : ( times_times @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
                @ I5 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I5 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I5 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5800_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P5: B > A,I8: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I8 )
                      & ( ( P5 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P5
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I8 )
                      & ( ( P5 @ X2 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_5801_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_5802_num__of__nat__double,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N @ N ) )
        = ( bit0 @ ( num_of_nat @ N ) ) ) ) ).

% num_of_nat_double
thf(fact_5803_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_5804_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys3 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_5805_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5806_pow_Osimps_I3_J,axiom,
    ! [X: num,Y2: num] :
      ( ( pow @ X @ ( bit1 @ Y2 ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X @ Y2 ) ) @ X ) ) ).

% pow.simps(3)
thf(fact_5807_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_5808_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_5809_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A3 ) )
            = A3 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_5810_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) )
          = ( finite_card @ A @ A3 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_5811_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( nil @ A ) )
            = ( A3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5812_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B4: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( linord4507533701916653071of_set @ A @ B4 ) )
         => ( ( finite_finite @ A @ A3 )
           => ( ( finite_finite @ A @ B4 )
             => ( A3 = B4 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_5813_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_5814_sqr_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) ).

% sqr.simps(2)
thf(fact_5815_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_5816_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X2: num] : ( times_times @ num @ X2 @ X2 ) ) ) ).

% sqr_conv_mult
thf(fact_5817_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5818_pow_Osimps_I2_J,axiom,
    ! [X: num,Y2: num] :
      ( ( pow @ X @ ( bit0 @ Y2 ) )
      = ( sqr @ ( pow @ X @ Y2 ) ) ) ).

% pow.simps(2)
thf(fact_5819_sqr_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N ) @ N ) ) ) ) ).

% sqr.simps(3)
thf(fact_5820_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ ( suc @ I2 ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I2 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_5821_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X @ A3 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5822_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X2: A] : X2 ) ) ) ).

% sorted_list_of_set_def
thf(fact_5823_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa2 )
        = Y2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Y2
            = ( ( Xa2
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( Y2
                = ( ~ ( ( Deg2 = Xa2 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi3 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_5824_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X: B,F2: B > A,Xs2: list @ B] :
          ( ( remove1 @ B @ X @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
          = Xs2 ) ) ).

% remove1_insort_key
thf(fact_5825_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs2: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs2 ) ) ) ) ).

% length_insort
thf(fact_5826_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X @ A3 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X
                @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_5827_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P4: A > $o] : ( ord_less_eq @ ( set @ A ) @ A7 @ ( collect @ A @ P4 ) ) ) ) ).

% Ball_Collect
thf(fact_5828_option_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( ( Option
         != ( none @ A ) ) )
      = ( case_option @ $o @ A @ $false
        @ ^ [Uu3: A] : $true
        @ Option ) ) ).

% option.disc_eq_case(2)
thf(fact_5829_option_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
        = ( none @ A ) )
      = ( case_option @ $o @ A @ $true
        @ ^ [Uu3: A] : $false
        @ Option ) ) ).

% option.disc_eq_case(1)
thf(fact_5830_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A,Xs2: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ X
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y2
              @ Xs2 ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Y2
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs2 ) ) ) ) ).

% insort_left_comm
thf(fact_5831_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y2: B,Xs2: list @ B] :
          ( ( ( F2 @ X )
           != ( F2 @ Y2 ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ Y2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
            = ( linorder_insort_key @ B @ A @ F2 @ X @ ( linorder_insort_key @ B @ A @ F2 @ Y2 @ Xs2 ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_5832_option_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > B] :
      ( ( case_option @ B @ A @ F1 @ F22 @ ( none @ A ) )
      = F1 ) ).

% option.simps(4)
thf(fact_5833_option_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > B,X22: A] :
      ( ( case_option @ B @ A @ F1 @ F22 @ ( some @ A @ X22 ) )
      = ( F22 @ X22 ) ) ).

% option.simps(5)
thf(fact_5834_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y2 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Y2 ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_5835_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,A2: B,Xs2: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs2 )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_5836_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs2: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
          = ( insert @ B @ X @ ( set2 @ B @ Xs2 ) ) ) ) ).

% set_insort_key
thf(fact_5837_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs2: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
          = ( ~ ( member @ B @ X @ ( set2 @ B @ Xs2 ) )
            & ( distinct @ B @ Xs2 ) ) ) ) ).

% distinct_insort
thf(fact_5838_case__optionE,axiom,
    ! [A: $tType,P: $o,Q: A > $o,X: option @ A] :
      ( ( case_option @ $o @ A @ P @ Q @ X )
     => ( ( ( X
            = ( none @ A ) )
         => ~ P )
       => ~ ! [Y4: A] :
              ( ( X
                = ( some @ A @ Y4 ) )
             => ~ ( Q @ Y4 ) ) ) ) ).

% case_optionE
thf(fact_5839_option_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_option @ B @ A )
      = ( ^ [F12: B,F23: A > B,Option3: option @ A] :
            ( if @ B
            @ ( Option3
              = ( none @ A ) )
            @ F12
            @ ( F23 @ ( the2 @ A @ Option3 ) ) ) ) ) ).

% option.case_eq_if
thf(fact_5840_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A7 )
                   => ( ord_less_eq @ A @ B3 @ X2 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_5841_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A7 )
                   => ( ord_less_eq @ A @ X2 @ B3 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_5842_option_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > B,Option: option @ A] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F22 @ Option ) )
      = ( ~ ( ( ( Option
                = ( none @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( Option
                = ( some @ A @ ( the2 @ A @ Option ) ) )
              & ~ ( P @ ( F22 @ ( the2 @ A @ Option ) ) ) ) ) ) ) ).

% option.split_sel_asm
thf(fact_5843_option_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > B,Option: option @ A] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F22 @ Option ) )
      = ( ( ( Option
            = ( none @ A ) )
         => ( P @ F1 ) )
        & ( ( Option
            = ( some @ A @ ( the2 @ A @ Option ) ) )
         => ( P @ ( F22 @ ( the2 @ A @ Option ) ) ) ) ) ) ).

% option.split_sel
thf(fact_5844_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ X
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5845_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList2 @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X2: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
           => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X4 )
            & ! [X2: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
               => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi3: nat,Ma3: nat] :
                ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
                & ( ( Mi3 = Ma3 )
                 => ! [X2: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                & ( ( Mi3 != Ma3 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                    & ! [X2: nat] :
                        ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X2 )
                         => ( ( ord_less @ nat @ Mi3 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_5846_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa2
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ( ( Deg2 = Xa2 )
                & ! [X5: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                    & ! [X2: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi3: nat,Ma3: nat] :
                        ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                        & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I4: nat] :
                            ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                        & ( ( Mi3 = Ma3 )
                         => ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        & ( ( Mi3 != Ma3 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                            & ! [X2: nat] :
                                ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                 => ( ( ord_less @ nat @ Mi3 @ X2 )
                                    & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_5847_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa2
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
             => ~ ( ( Deg2 = Xa2 )
                  & ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi3: nat,Ma3: nat] :
                          ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                          & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                          & ( ( Mi3 = Ma3 )
                           => ! [X2: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                          & ( ( Mi3 != Ma3 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                              & ! [X2: nat] :
                                  ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                   => ( ( ord_less @ nat @ Mi3 @ X2 )
                                      & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_5848_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( Y2
                  = ( Xa2
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( Y2
                    = ( ( Deg2 = Xa2 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi3 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_5849_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) )
               => ( Xa2
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa2 ) )
                 => ~ ( ( Deg2 = Xa2 )
                      & ! [X3: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi3 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_5850_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa2 ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa2 ) )
               => ( Xa2
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary2 ) @ Xa2 ) )
                 => ( ( Deg2 = Xa2 )
                    & ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                        & ! [X2: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi3: nat,Ma3: nat] :
                            ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                            & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I4: nat] :
                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                            & ( ( Mi3 = Ma3 )
                             => ! [X2: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X4 ) ) )
                            & ( ( Mi3 != Ma3 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma3 )
                                & ! [X2: nat] :
                                    ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                     => ( ( ord_less @ nat @ Mi3 @ X2 )
                                        & ( ord_less_eq @ nat @ X2 @ Ma3 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_5851_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X4: set @ int] :
          ( the @ int
          @ ^ [X2: int] :
              ( ( member @ int @ X2 @ X4 )
              & ! [Y: int] :
                  ( ( member @ int @ Y @ X4 )
                 => ( ord_less_eq @ int @ Y @ X2 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_5852_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_5853_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P4: A > $o] :
              ( the @ A
              @ ^ [X2: A] :
                  ( ( P4 @ X2 )
                  & ! [Y: A] :
                      ( ( P4 @ Y )
                     => ( ord_less_eq @ A @ Y @ X2 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_5854_and__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_5855_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_5856_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_5857_take__bit__num__simps_I5_J,axiom,
    ! [R: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_5858_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_5859_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_5860_take__bit__num__simps_I6_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ).

% take_bit_num_simps(6)
thf(fact_5861_take__bit__num__simps_I7_J,axiom,
    ! [R: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R ) @ M ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_5862_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_5863_and__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_5864_and__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_5865_and__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_5866_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit0 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
            @ ( bit_take_bit_num @ N2 @ M ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_5867_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_5868_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ N @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] : ( some @ num @ one2 )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_5869_and__not__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_5870_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(4)
thf(fact_5871_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_5872_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_5873_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_12: nat] : ( P @ X_12 )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_5874_and__not__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_5875_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num,Q2: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( some @ num @ Q2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_5876_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit1 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N2: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N2 @ M ) ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_5877_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ A @ Y4 @ X ) )
           => ( ! [X5: A] :
                  ( ( P @ X5 )
                 => ( ! [Y3: A] :
                        ( ( P @ Y3 )
                       => ( ord_less_eq @ A @ Y3 @ X5 ) )
                   => ( Q @ X5 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_5878_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ A @ Y4 @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_5879_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(7)
thf(fact_5880_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_5881_and__not__num__eq__Some__iff,axiom,
    ! [M: num,N: num,Q2: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( some @ num @ Q2 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( numeral_numeral @ int @ Q2 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_5882_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(8)
thf(fact_5883_and__not__num__eq__None__iff,axiom,
    ! [M: num,N: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_5884_int__numeral__and__not__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N ) ) ) ).

% int_numeral_and_not_num
thf(fact_5885_int__numeral__not__and__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_5886_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M3: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M3 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( numeral_numeral @ nat @ M3 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_5887_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N2: nat,M3: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A4: nat,X2: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P5: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
                      @ ( bit_take_bit_num @ O @ P5 ) )
                  @ ^ [P5: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P5 ) ) )
                  @ X2 )
              @ A4 )
          @ ( product_Pair @ nat @ num @ N2 @ M3 ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_5888_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J: nat,I2: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ I2 ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I2 @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_5889_set__nths,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) )
      = ( collect @ A
        @ ^ [Uu3: A] :
          ? [I4: nat] :
            ( ( Uu3
              = ( nth @ A @ Xs2 @ I4 ) )
            & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( member @ nat @ I4 @ I5 ) ) ) ) ).

% set_nths
thf(fact_5890_nths__nil,axiom,
    ! [A: $tType,A3: set @ nat] :
      ( ( nths @ A @ ( nil @ A ) @ A3 )
      = ( nil @ A ) ) ).

% nths_nil
thf(fact_5891_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,L2: A,U2: A] :
          ( ( member @ A @ I2 @ ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) )
          = ( ( ord_less @ A @ L2 @ I2 )
            & ( ord_less_eq @ A @ I2 @ U2 ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_5892_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L2: A,K: A] :
          ( ( ord_less_eq @ A @ L2 @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_5893_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L2 ) )
          = ( ~ ( ord_less @ A @ K @ L2 ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_5894_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L2 ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_5895_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_5896_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_5897_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X ) )
            = X ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_5898_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y2 ) )
            = X ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_5899_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X ) )
            = Y2 ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_5900_nths__empty,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( nths @ A @ Xs2 @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) ).

% nths_empty
thf(fact_5901_card__greaterThanAtMost,axiom,
    ! [L2: nat,U2: nat] :
      ( ( finite_card @ nat @ ( set_or3652927894154168847AtMost @ nat @ L2 @ U2 ) )
      = ( minus_minus @ nat @ U2 @ L2 ) ) ).

% card_greaterThanAtMost
thf(fact_5902_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_5903_in__set__nthsD,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,I5: set @ nat] :
      ( ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs2 ) ) ) ).

% in_set_nthsD
thf(fact_5904_notin__set__nthsI,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,I5: set @ nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ~ ( member @ A @ X @ ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) ) ) ) ).

% notin_set_nthsI
thf(fact_5905_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F32: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F32 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X2: num] : ( H2 @ ( F22 @ X2 ) )
        @ ^ [X2: num] : ( H2 @ ( F32 @ X2 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_5906_distinct__nthsI,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ A @ ( nths @ A @ Xs2 @ I5 ) ) ) ).

% distinct_nthsI
thf(fact_5907_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_5908_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_5909_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X22: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 ) ) ).

% verit_eq_simplify(17)
thf(fact_5910_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_5911_set__nths__subset,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( nths @ A @ Xs2 @ I5 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% set_nths_subset
thf(fact_5912_nths__all,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( member @ nat @ I3 @ I5 ) )
     => ( ( nths @ A @ Xs2 @ I5 )
        = Xs2 ) ) ).

% nths_all
thf(fact_5913_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_5914_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.head
thf(fact_5915_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_5916_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_5917_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_5918_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_5919_greaterThanAtMost__eq__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( set_or3652927894154168847AtMost @ A )
        = ( ^ [A4: A,B3: A] : ( minus_minus @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A4 @ B3 ) @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% greaterThanAtMost_eq_atLeastAtMost_diff
thf(fact_5920_length__nths,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs2 @ I5 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
              & ( member @ nat @ I4 @ I5 ) ) ) ) ) ).

% length_nths
thf(fact_5921_and__not__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa2 )
        = Y2 )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa2
                  = ( bit0 @ N3 ) )
             => ( Y2
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa2
                    = ( bit1 @ N3 ) )
               => ( Y2
                 != ( none @ num ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                  @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_5922_xor__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(6)
thf(fact_5923_xor__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(8)
thf(fact_5924_map__option__eq__Some,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xo: option @ B,Y2: A] :
      ( ( ( map_option @ B @ A @ F2 @ Xo )
        = ( some @ A @ Y2 ) )
      = ( ? [Z: B] :
            ( ( Xo
              = ( some @ B @ Z ) )
            & ( ( F2 @ Z )
              = Y2 ) ) ) ) ).

% map_option_eq_Some
thf(fact_5925_option_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: option @ A] :
      ( ( ( map_option @ A @ B @ F2 @ A2 )
        = ( none @ B ) )
      = ( A2
        = ( none @ A ) ) ) ).

% option.map_disc_iff
thf(fact_5926_map__option__is__None,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Opt: option @ B] :
      ( ( ( map_option @ B @ A @ F2 @ Opt )
        = ( none @ A ) )
      = ( Opt
        = ( none @ B ) ) ) ).

% map_option_is_None
thf(fact_5927_None__eq__map__option__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,X: option @ B] :
      ( ( ( none @ A )
        = ( map_option @ B @ A @ F2 @ X ) )
      = ( X
        = ( none @ B ) ) ) ).

% None_eq_map_option_iff
thf(fact_5928_card__greaterThanAtMost__int,axiom,
    ! [L2: int,U2: int] :
      ( ( finite_card @ int @ ( set_or3652927894154168847AtMost @ int @ L2 @ U2 ) )
      = ( nat2 @ ( minus_minus @ int @ U2 @ L2 ) ) ) ).

% card_greaterThanAtMost_int
thf(fact_5929_option_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map_option @ A @ B @ F2 @ ( none @ A ) )
      = ( none @ B ) ) ).

% option.simps(8)
thf(fact_5930_option_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X22: A] :
      ( ( map_option @ A @ B @ F2 @ ( some @ A @ X22 ) )
      = ( some @ B @ ( F2 @ X22 ) ) ) ).

% option.simps(9)
thf(fact_5931_map__option__cong,axiom,
    ! [B: $tType,A: $tType,X: option @ A,Y2: option @ A,F2: A > B,G: A > B] :
      ( ( X = Y2 )
     => ( ! [A6: A] :
            ( ( Y2
              = ( some @ A @ A6 ) )
           => ( ( F2 @ A6 )
              = ( G @ A6 ) ) )
       => ( ( map_option @ A @ B @ F2 @ X )
          = ( map_option @ A @ B @ G @ Y2 ) ) ) ) ).

% map_option_cong
thf(fact_5932_option_Omap__sel,axiom,
    ! [B: $tType,A: $tType,A2: option @ A,F2: A > B] :
      ( ( A2
       != ( none @ A ) )
     => ( ( the2 @ B @ ( map_option @ A @ B @ F2 @ A2 ) )
        = ( F2 @ ( the2 @ A @ A2 ) ) ) ) ).

% option.map_sel
thf(fact_5933_xor__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(9)
thf(fact_5934_xor__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(5)
thf(fact_5935_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(5)
thf(fact_5936_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(9)
thf(fact_5937_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(6)
thf(fact_5938_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_5939_atLeastPlusOneAtMost__greaterThanAtMost__int,axiom,
    ! [L2: int,U2: int] :
      ( ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ L2 @ ( one_one @ int ) ) @ U2 )
      = ( set_or3652927894154168847AtMost @ int @ L2 @ U2 ) ) ).

% atLeastPlusOneAtMost_greaterThanAtMost_int
thf(fact_5940_xor__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa2 )
        = Y2 )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ! [N3: num] :
                ( ( Xa2
                  = ( bit0 @ N3 ) )
               => ( Y2
                 != ( some @ num @ ( bit1 @ N3 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit1 @ N3 ) )
                 => ( Y2
                   != ( some @ num @ ( bit0 @ N3 ) ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit1 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_5941_map__option__case,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_option @ B @ A )
      = ( ^ [F5: B > A] :
            ( case_option @ ( option @ A ) @ B @ ( none @ A )
            @ ^ [X2: B] : ( some @ A @ ( F5 @ X2 ) ) ) ) ) ).

% map_option_case
thf(fact_5942_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_5943_xor__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ ( bit1 @ N ) ) ) ).

% xor_num.simps(2)
thf(fact_5944_xor__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ ( bit0 @ N ) ) ) ).

% xor_num.simps(3)
thf(fact_5945_xor__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit1 @ M ) ) ) ).

% xor_num.simps(4)
thf(fact_5946_xor__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% xor_num.simps(7)
thf(fact_5947_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_5948_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% numeral_xor_num
thf(fact_5949_map__option__o__empty,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: C > B] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 )
        @ ^ [X2: A] : ( none @ C ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% map_option_o_empty
thf(fact_5950_and__not__num_Opelims,axiom,
    ! [X: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit0 @ N3 ) )
                 => ( ( Y2
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa2
                      = ( bit1 @ N3 ) )
                   => ( ( Y2
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( some @ num @ ( bit0 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit0 @ N3 ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa2
                              = ( bit1 @ N3 ) )
                           => ( ( Y2
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit0 @ N3 ) )
                               => ( ( Y2
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                      @ ( bit_and_not_num @ M4 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y2
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_5951_xor__num_Opelims,axiom,
    ! [X: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit0 @ N3 ) )
                 => ( ( Y2
                      = ( some @ num @ ( bit1 @ N3 ) ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa2
                      = ( bit1 @ N3 ) )
                   => ( ( Y2
                        = ( some @ num @ ( bit0 @ N3 ) ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( some @ num @ ( bit1 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit0 @ N3 ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa2
                              = ( bit1 @ N3 ) )
                           => ( ( Y2
                                = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit0 @ N3 ) )
                               => ( ( Y2
                                    = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y2
                                      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
thf(fact_5952_and__num_Oelims,axiom,
    ! [X: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa2 )
        = Y2 )
     => ( ( ( X = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N3: num] :
                  ( Xa2
                  = ( bit0 @ N3 ) )
             => ( Y2
               != ( none @ num ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N3: num] :
                    ( Xa2
                    = ( bit1 @ N3 ) )
               => ( Y2
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M4: num] :
                    ( X
                    = ( bit0 @ M4 ) )
               => ( ( Xa2 = one2 )
                 => ( Y2
                   != ( none @ num ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N3: num] :
                        ( ( Xa2
                          = ( bit0 @ N3 ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit1 @ N3 ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                 => ( ( ? [M4: num] :
                          ( X
                          = ( bit1 @ M4 ) )
                     => ( ( Xa2 = one2 )
                       => ( Y2
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N3: num] :
                              ( ( Xa2
                                = ( bit0 @ N3 ) )
                             => ( Y2
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit1 @ N3 ) )
                               => ( Y2
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_5953_xor__num__rel__dict,axiom,
    bit_un2901131394128224187um_rel = bit_un3595099601533988841um_rel ).

% xor_num_rel_dict
thf(fact_5954_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_5955_and__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(5)
thf(fact_5956_and__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_5957_and__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_5958_and__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_5959_and__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_5960_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( some @ num @ Q2 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q2 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_5961_and__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(8)
thf(fact_5962_and__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(6)
thf(fact_5963_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_5964_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ) ).

% numeral_and_num
thf(fact_5965_and__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(9)
thf(fact_5966_and__num_Opelims,axiom,
    ! [X: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X @ Xa2 ) )
       => ( ( ( X = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N3: num] :
                  ( ( Xa2
                    = ( bit0 @ N3 ) )
                 => ( ( Y2
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N3 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N3: num] :
                    ( ( Xa2
                      = ( bit1 @ N3 ) )
                   => ( ( Y2
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N3 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N3: num] :
                          ( ( Xa2
                            = ( bit0 @ N3 ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N3: num] :
                            ( ( Xa2
                              = ( bit1 @ N3 ) )
                           => ( ( Y2
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N3: num] :
                                ( ( Xa2
                                  = ( bit0 @ N3 ) )
                               => ( ( Y2
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N3 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N3: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N3 ) )
                                 => ( ( Y2
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M4 @ N3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_5967_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_5968_and__num__rel__dict,axiom,
    bit_un4731106466462545111um_rel = bit_un5425074673868309765um_rel ).

% and_num_rel_dict
thf(fact_5969_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_5970_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,N2: nat] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
          & ( N2
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_5971_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_5972_Rats__abs__iff,axiom,
    ! [X: real] :
      ( ( member @ real @ ( abs_abs @ real @ X ) @ ( field_char_0_Rats @ real ) )
      = ( member @ real @ X @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_5973_mult__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( times_times @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ C2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ).

% mult_rat
thf(fact_5974_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( divide_divide @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_5975_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_5976_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_5977_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_5978_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_5979_sgn__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( sgn_sgn @ rat @ ( fract @ A2 @ B2 ) )
      = ( ring_1_of_int @ rat @ ( times_times @ int @ ( sgn_sgn @ int @ A2 ) @ ( sgn_sgn @ int @ B2 ) ) ) ) ).

% sgn_rat
thf(fact_5980_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_5981_Rats__diff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_diff
thf(fact_5982_Rats__number__of,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_number_of
thf(fact_5983_Rats__mult,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_mult
thf(fact_5984_Rats__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_divide
thf(fact_5985_Rats__no__bot__less,axiom,
    ! [X: real] :
    ? [X5: real] :
      ( ( member @ real @ X5 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X5 @ X ) ) ).

% Rats_no_bot_less
thf(fact_5986_Rats__dense__in__real,axiom,
    ! [X: real,Y2: real] :
      ( ( ord_less @ real @ X @ Y2 )
     => ? [X5: real] :
          ( ( member @ real @ X5 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X @ X5 )
          & ( ord_less @ real @ X5 @ Y2 ) ) ) ).

% Rats_dense_in_real
thf(fact_5987_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_5988_Rats__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_1
thf(fact_5989_Rats__add,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( ( member @ A @ B2 @ ( field_char_0_Rats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( field_char_0_Rats @ A ) ) ) ) ) ).

% Rats_add
thf(fact_5990_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_5991_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A2 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_5992_Fract__of__nat__eq,axiom,
    ! [K: nat] :
      ( ( fract @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) )
      = ( semiring_1_of_nat @ rat @ K ) ) ).

% Fract_of_nat_eq
thf(fact_5993_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X5: real] :
      ( ( member @ real @ X5 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X @ X5 ) ) ).

% Rats_no_top_le
thf(fact_5994_quotient__of__eq,axiom,
    ! [A2: int,B2: int,P2: int,Q2: int] :
      ( ( ( quotient_of @ ( fract @ A2 @ B2 ) )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ( fract @ P2 @ Q2 )
        = ( fract @ A2 @ B2 ) ) ) ).

% quotient_of_eq
thf(fact_5995_One__rat__def,axiom,
    ( ( one_one @ rat )
    = ( fract @ ( one_one @ int ) @ ( one_one @ int ) ) ) ).

% One_rat_def
thf(fact_5996_Fract__of__int__eq,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( one_one @ int ) )
      = ( ring_1_of_int @ rat @ K ) ) ).

% Fract_of_int_eq
thf(fact_5997_normalize__eq,axiom,
    ! [A2: int,B2: int,P2: int,Q2: int] :
      ( ( ( normalize @ ( product_Pair @ int @ int @ A2 @ B2 ) )
        = ( product_Pair @ int @ int @ P2 @ Q2 ) )
     => ( ( fract @ P2 @ Q2 )
        = ( fract @ A2 @ B2 ) ) ) ).

% normalize_eq
thf(fact_5998_Ints__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( ring_1_Ints @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Ints_subset_Rats
thf(fact_5999_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_6000_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_6001_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K2: num] : ( fract @ ( numeral_numeral @ int @ K2 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_6002_quotient__of__Fract,axiom,
    ! [A2: int,B2: int] :
      ( ( quotient_of @ ( fract @ A2 @ B2 ) )
      = ( normalize @ ( product_Pair @ int @ int @ A2 @ B2 ) ) ) ).

% quotient_of_Fract
thf(fact_6003_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_6004_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_6005_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,J3: int] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( ring_1_of_int @ real @ J3 ) ) )
          & ( J3
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_6006_rat__number__collapse_I5_J,axiom,
    ( ( fract @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( one_one @ int ) )
    = ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ).

% rat_number_collapse(5)
thf(fact_6007_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N ) @ N )
        = ( plus_plus @ rat @ ( fract @ M @ N ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_6008_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_6009_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_6010_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_6011_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_6012_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_6013_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_6014_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu3: A] :
            ? [N2: int] :
              ( ( Uu3
                = ( ring_1_of_int @ A @ N2 ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 ) ) ) ) ) ).

% Nats_altdef1
thf(fact_6015_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y2: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y2 )
       => ( ( image @ nat @ nat
            @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y2 ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y2 @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y2 )
       => ( ( ( ord_less @ nat @ X @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y2 ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y2 ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_6016_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N4: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N4 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N4 ) ) ).

% bij_betw_Suc
thf(fact_6017_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S2 )
          = S2 ) ) ).

% image_add_0
thf(fact_6018_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I2 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_6019_image__diff__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ D2 @ B2 ) @ ( minus_minus @ A @ D2 @ A2 ) ) ) ) ).

% image_diff_atLeastAtMost
thf(fact_6020_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_6021_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_6022_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A,B4: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 @ B4 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 )
            = B4 ) ) ) ).

% bij_betw_add
thf(fact_6023_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_6024_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I2 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_6025_image__minus__const__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( image @ A @ A
            @ ^ [T3: A] : ( minus_minus @ A @ T3 @ D2 )
            @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ).

% image_minus_const_atLeastAtMost'
thf(fact_6026_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I2 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I2 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_6027_image__diff__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( minus_minus @ A @ C2 @ B2 ) @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_diff_atLeastLessThan
thf(fact_6028_image__minus__const__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( minus_minus @ A @ C2 @ B2 ) @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_minus_const_greaterThanAtMost
thf(fact_6029_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y: B] :
                    ( ( member @ B @ Y @ A3 )
                    & ( ord_less @ A @ ( F2 @ Y ) @ X2 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_6030_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_6031_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C3: A] : ( divide_divide @ A @ C3 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_6032_Setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( collect @ A
        @ ^ [Uu3: A] :
          ? [X2: B] :
            ( ( Uu3
              = ( F2 @ X2 ) )
            & ( member @ B @ X2 @ A3 ) ) )
      = ( image @ B @ A @ F2 @ A3 ) ) ).

% Setcompr_eq_image
thf(fact_6033_setcompr__eq__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o] :
      ( ( collect @ A
        @ ^ [Uu3: A] :
          ? [X2: B] :
            ( ( Uu3
              = ( F2 @ X2 ) )
            & ( P @ X2 ) ) )
      = ( image @ B @ A @ F2 @ ( collect @ B @ P ) ) ) ).

% setcompr_eq_image
thf(fact_6034_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B4: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ ( image @ B @ A @ F2 @ B4 ) ) ) ).

% image_Int_subset
thf(fact_6035_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F8: B > A,F2: A > B,A10: set @ B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ( F8 @ ( F2 @ X5 ) )
            = X5 ) )
     => ( ! [X5: B] :
            ( ( member @ B @ X5 @ A10 )
           => ( ( F2 @ ( F8 @ X5 ) )
              = X5 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ A10 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F8 @ A10 ) @ A3 )
           => ( bij_betw @ A @ B @ F2 @ A3 @ A10 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_6036_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,A10: set @ B,B4: set @ A,B13: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A3 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( ( ( image @ A @ B @ F2 @ B4 )
            = B13 )
         => ( bij_betw @ A @ B @ F2 @ B4 @ B13 ) ) ) ) ).

% bij_betw_subset
thf(fact_6037_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B4: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ ( image @ B @ A @ F2 @ B4 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) ) ).

% image_diff_subset
thf(fact_6038_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B7: set @ A] :
            ( ( ( finite_finite @ A @ B7 )
              & ( ord_less_eq @ ( set @ A ) @ B7 @ ( image @ B @ A @ F2 @ A3 ) ) )
           => ( P @ B7 ) ) )
      = ( ! [B7: set @ B] :
            ( ( ( finite_finite @ B @ B7 )
              & ( ord_less_eq @ ( set @ B ) @ B7 @ A3 ) )
           => ( P @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_6039_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B7: set @ A] :
            ( ( finite_finite @ A @ B7 )
            & ( ord_less_eq @ ( set @ A ) @ B7 @ ( image @ B @ A @ F2 @ A3 ) )
            & ( P @ B7 ) ) )
      = ( ? [B7: set @ B] :
            ( ( finite_finite @ B @ B7 )
            & ( ord_less_eq @ ( set @ B ) @ B7 @ A3 )
            & ( P @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_6040_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,F2: B > A,A3: set @ B] :
      ( ( finite_finite @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F2 @ A3 ) )
       => ? [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
            & ( finite_finite @ B @ C7 )
            & ( B4
              = ( image @ B @ A @ F2 @ C7 ) ) ) ) ) ).

% finite_subset_image
thf(fact_6041_finite__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( finite_finite @ B @ B4 ) ) ) ).

% finite_surj
thf(fact_6042_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( pow2 @ B @ A3 ) ) @ ( pow2 @ A @ B4 ) ) ) ).

% image_Pow_mono
thf(fact_6043_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B7 @ ( image @ B @ A @ F2 @ A3 ) )
           => ( P @ B7 ) ) )
      = ( ! [B7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B7 @ A3 )
           => ( P @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ).

% all_subset_image
thf(fact_6044_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,F2: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F2 @ A3 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A3 )
            & ( B4
              = ( image @ B @ A @ F2 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_6045_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B4 )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ A3 )
           => ( member @ A @ ( F2 @ X2 ) @ B4 ) ) ) ) ).

% image_subset_iff
thf(fact_6046_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,F2: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( image @ B @ A @ F2 @ A3 ) )
     => ~ ! [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
           => ( B4
             != ( image @ B @ A @ F2 @ C7 ) ) ) ) ).

% subset_imageE
thf(fact_6047_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F2: A > B,B4: set @ B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( member @ B @ ( F2 @ X5 ) @ B4 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B4 ) ) ).

% image_subsetI
thf(fact_6048_image__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B4 ) ) ) ).

% image_mono
thf(fact_6049_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,G: C > A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ B4 )
                  & ( ord_less_eq @ A @ ( G @ X3 ) @ ( F2 @ I3 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B4 )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ).

% INF_eq
thf(fact_6050_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B4: set @ B] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( member @ B @ ( F2 @ X5 ) @ B4 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B4 ) ) ).

% image_Collect_subsetI
thf(fact_6051_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_6052_Nats__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_add
thf(fact_6053_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_6054_Nats__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_0
thf(fact_6055_Nats__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ~ ! [N3: nat] :
                ( X
               != ( semiring_1_of_nat @ A @ N3 ) ) ) ) ).

% Nats_cases
thf(fact_6056_Nats__induct,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A,P: A > $o] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ( ! [N3: nat] : ( P @ ( semiring_1_of_nat @ A @ N3 ) )
           => ( P @ X ) ) ) ) ).

% Nats_induct
thf(fact_6057_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_Nats @ A ) ) ) ).

% of_nat_in_Nats
thf(fact_6058_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_6059_Nats__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_numeral
thf(fact_6060_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_6061_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_6062_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,F2: B > A,G: C > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ B4 )
                  & ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( G @ X3 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B4 )
               => ? [X3: B] :
                    ( ( member @ B @ X3 @ A3 )
                    & ( ord_less_eq @ A @ ( G @ J2 ) @ ( F2 @ X3 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_6063_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,X: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ X ) )
         => ( ! [Y4: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ I ) @ Y4 ) )
               => ( ord_less_eq @ A @ X @ Y4 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X ) ) ) ) ).

% SUP_eqI
thf(fact_6064_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ C,F2: B > A,G: C > A] :
          ( ! [N3: B] :
              ( ( member @ B @ N3 @ A3 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ B4 )
                  & ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ X3 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B4 ) ) ) ) ) ).

% SUP_mono
thf(fact_6065_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,U2: A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I3 ) @ U2 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U2 ) ) ) ).

% SUP_least
thf(fact_6066_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% SUP_mono'
thf(fact_6067_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% SUP_upper
thf(fact_6068_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,U2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U2 )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ U2 ) ) ) ) ) ).

% SUP_le_iff
thf(fact_6069_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,U2: A,F2: B > A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ( ord_less_eq @ A @ U2 @ ( F2 @ I2 ) )
           => ( ord_less_eq @ A @ U2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_6070_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A3 )
                & ( ord_less @ A @ A2 @ ( F2 @ X2 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_6071_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,Y2: A,I2: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ Y2 )
         => ( ( member @ B @ I2 @ A3 )
           => ( ord_less @ A @ ( F2 @ I2 ) @ Y2 ) ) ) ) ).

% SUP_lessD
thf(fact_6072_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,X: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less_eq @ A @ X @ ( F2 @ I3 ) ) )
         => ( ! [Y4: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A3 )
                   => ( ord_less_eq @ A @ Y4 @ ( F2 @ I ) ) )
               => ( ord_less_eq @ A @ Y4 @ X ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X ) ) ) ) ).

% INF_eqI
thf(fact_6073_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ B,A3: set @ C,F2: C > A,G: B > A] :
          ( ! [M4: B] :
              ( ( member @ B @ M4 @ B4 )
             => ? [X3: C] :
                  ( ( member @ C @ X3 @ A3 )
                  & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ M4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ).

% INF_mono
thf(fact_6074_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( F2 @ I2 ) ) ) ) ).

% INF_lower
thf(fact_6075_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% INF_mono'
thf(fact_6076_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I2: B,A3: set @ B,F2: B > A,U2: A] :
          ( ( member @ B @ I2 @ A3 )
         => ( ( ord_less_eq @ A @ ( F2 @ I2 ) @ U2 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U2 ) ) ) ) ).

% INF_lower2
thf(fact_6077_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ U2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A3 )
               => ( ord_less_eq @ A @ U2 @ ( F2 @ X2 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_6078_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,U2: A,F2: B > A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ A3 )
             => ( ord_less_eq @ A @ U2 @ ( F2 @ I3 ) ) )
         => ( ord_less_eq @ A @ U2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_greatest
thf(fact_6079_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ A2 )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A3 )
                & ( ord_less @ A @ ( F2 @ X2 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_6080_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y2: A,F2: B > A,A3: set @ B,I2: B] :
          ( ( ord_less @ A @ Y2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
         => ( ( member @ B @ I2 @ A3 )
           => ( ord_less @ A @ Y2 @ ( F2 @ I2 ) ) ) ) ) ).

% less_INF_D
thf(fact_6081_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N2: nat,F5: nat > A] :
            ( A7
            = ( image @ nat @ A @ F5
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_6082_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set @ A,F2: nat > A,N: nat] :
      ( ( A3
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) ) )
     => ( finite_finite @ A @ A3 ) ) ).

% nat_seg_image_imp_finite
thf(fact_6083_translation__subtract__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
            @ ( inf_inf @ ( set @ A ) @ S @ T2 ) )
          = ( inf_inf @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
              @ S )
            @ ( image @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_Int
thf(fact_6084_translation__subtract__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S: set @ A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
            @ ( minus_minus @ ( set @ A ) @ S @ T2 ) )
          = ( minus_minus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
              @ S )
            @ ( image @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_diff
thf(fact_6085_translation__subtract__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
            @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A )
            @ ( image @ A @ A
              @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
              @ T2 ) ) ) ) ).

% translation_subtract_Compl
thf(fact_6086_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ Y @ X )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( ord_less @ A @ Y @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_6087_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ X )
          = ( ! [Y: A] :
                ( ( ord_less @ A @ X @ Y )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A3 )
                    & ( ord_less @ A @ ( F2 @ X2 ) @ Y ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_6088_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,M7: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_6089_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,C2: A,F2: B > A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I5 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I3 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I5 )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_6090_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,M: A,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X5 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_6091_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,F2: B > A,C2: A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I5 )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_6092_card__image__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( finite_card @ A @ A3 ) ) ) ).

% card_image_le
thf(fact_6093_Nats__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( ( ord_less_eq @ A @ B2 @ A2 )
             => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ) ).

% Nats_diff
thf(fact_6094_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F8: A > B,A10: set @ A,A11: set @ B,F2: C > A,A3: set @ C] :
      ( ( bij_betw @ A @ B @ F8 @ A10 @ A11 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ A3 ) @ A10 )
       => ( ( bij_betw @ C @ A @ F2 @ A3 @ A10 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F8 @ F2 ) @ A3 @ A11 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_6095_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Nats_subset_Ints
thf(fact_6096_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A3 @ B4 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_6097_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B4: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B4 @ A3 )
         => ( ! [X5: B] :
                ( ( member @ B @ X5 @ B4 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_6098_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S2: set @ B,T4: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T4 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T4 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X2: B] :
                            ( ( member @ B @ X2 @ S2 )
                            & ( ( G @ X2 )
                              = Y ) ) ) )
                  @ T4 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% sum.group
thf(fact_6099_Nats__subset__Rats,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Nats_subset_Rats
thf(fact_6100_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S2: set @ B,T4: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T4 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S2 ) @ T4 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X2: B] :
                            ( ( member @ B @ X2 @ S2 )
                            & ( ( G @ X2 )
                              = Y ) ) ) )
                  @ T4 )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S2 ) ) ) ) ) ) ).

% prod.group
thf(fact_6101_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_6102_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X5: B,Y4: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ( member @ B @ Y4 @ A3 )
                 => ( ( X5 != Y4 )
                   => ( ( ( H2 @ X5 )
                        = ( H2 @ Y4 ) )
                     => ( ( G @ ( H2 @ X5 ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image @ B @ C @ H2 @ A3 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A3 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_6103_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B4 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B4 ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% surj_card_le
thf(fact_6104_image__Suc__lessThan,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ).

% image_Suc_lessThan
thf(fact_6105_image__Suc__atMost,axiom,
    ! [N: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N ) ) ) ).

% image_Suc_atMost
thf(fact_6106_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I5: set @ C,G: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I5 )
         => ( ! [I3: C] :
                ( ( member @ C @ I3 @ I5 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F2 @ I3 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F2 @ I5 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F2 ) @ I5 ) ) ) ) ) ).

% sum_image_le
thf(fact_6107_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N2: A] :
              ( ( member @ A @ N2 @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N2 ) ) ) ) ) ).

% Nats_altdef2
thf(fact_6108_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y2: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y2 ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_6109_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y2: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y2 @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y2 @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y2 )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y2 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_6110_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_6111_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_6112_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_6113_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_6114_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S2: set @ A,R2: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S2 )
         => ( ( finite_finite @ B @ R2 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S2 ) @ R2 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
                  @ S2 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X2: A] :
                                ( ( member @ A @ X2 @ S2 )
                                & ( ( G @ X2 )
                                  = Y ) ) ) ) )
                      @ ( F2 @ Y ) )
                  @ R2 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_6115_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B4: A] :
          ( ( inf_inf @ A @ A3
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X2: nat] : B4
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A3 @ B4 ) ) ) ).

% INF_nat_binary
thf(fact_6116_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( sums @ A @ F2
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_6117_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A2: A,B2: B,A3: set @ ( product_prod @ A @ B ),F2: A > B > C] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ A3 )
     => ( member @ C @ ( F2 @ A2 @ B2 ) @ ( image @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F2 ) @ A3 ) ) ) ).

% pair_imageI
thf(fact_6118_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_6119_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_6120_range__diff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_diff
thf(fact_6121_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A3 )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ A3 )
                    & ( ord_less @ A @ X2 @ Y ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_6122_Diff__UNIV,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% Diff_UNIV
thf(fact_6123_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_6124_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( top_top @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Gcd_UNIV
thf(fact_6125_surj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A
            @ ^ [X2: A] : ( minus_minus @ A @ X2 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_diff_right
thf(fact_6126_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y: B] :
                    ( ( member @ B @ Y @ A3 )
                    & ( ord_less @ A @ X2 @ ( F2 @ Y ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_6127_set__concat,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs2 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs2 ) ) ) ) ).

% set_concat
thf(fact_6128_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_6129_INT__simps_I3_J,axiom,
    ! [E3: $tType,F: $tType,C5: set @ E3,A3: E3 > ( set @ F ),B4: set @ F] :
      ( ( ( C5
          = ( bot_bot @ ( set @ E3 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E3 @ ( set @ F )
              @ ^ [X2: E3] : ( minus_minus @ ( set @ F ) @ ( A3 @ X2 ) @ B4 )
              @ C5 ) )
          = ( top_top @ ( set @ F ) ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ E3 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E3 @ ( set @ F )
              @ ^ [X2: E3] : ( minus_minus @ ( set @ F ) @ ( A3 @ X2 ) @ B4 )
              @ C5 ) )
          = ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E3 @ ( set @ F ) @ A3 @ C5 ) ) @ B4 ) ) ) ) ).

% INT_simps(3)
thf(fact_6130_INT__simps_I4_J,axiom,
    ! [G2: $tType,H5: $tType,C5: set @ H5,A3: set @ G2,B4: H5 > ( set @ G2 )] :
      ( ( ( C5
          = ( bot_bot @ ( set @ H5 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G2 )
            @ ( image @ H5 @ ( set @ G2 )
              @ ^ [X2: H5] : ( minus_minus @ ( set @ G2 ) @ A3 @ ( B4 @ X2 ) )
              @ C5 ) )
          = ( top_top @ ( set @ G2 ) ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ H5 ) ) )
       => ( ( complete_Inf_Inf @ ( set @ G2 )
            @ ( image @ H5 @ ( set @ G2 )
              @ ^ [X2: H5] : ( minus_minus @ ( set @ G2 ) @ A3 @ ( B4 @ X2 ) )
              @ C5 ) )
          = ( minus_minus @ ( set @ G2 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G2 ) @ ( image @ H5 @ ( set @ G2 ) @ B4 @ C5 ) ) ) ) ) ) ).

% INT_simps(4)
thf(fact_6131_Collect__ex__eq,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o] :
      ( ( collect @ A
        @ ^ [X2: A] :
          ? [X4: B] : ( P @ X2 @ X4 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [Y: B] :
              ( collect @ A
              @ ^ [X2: A] : ( P @ X2 @ Y ) )
          @ ( top_top @ ( set @ B ) ) ) ) ) ).

% Collect_ex_eq
thf(fact_6132_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I4: set @ ( product_prod @ A @ B ),X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ I4 )
          @ S2 ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ S2 ) ) ) ) ).

% SUP_Sup_eq2
thf(fact_6133_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: C > ( set @ ( product_prod @ A @ B ) ),S2: set @ C] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I4: C,X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( R @ I4 ) )
          @ S2 ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ) ) ).

% SUP_UN_eq2
thf(fact_6134_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) )
      = ( ^ [S5: set @ ( A > B > $o ),X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S5 ) ) ) ) ) ) ).

% Sup_SUP_eq2
thf(fact_6135_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) )
      = ( ^ [S5: set @ ( A > B > $o ),X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S5 ) ) ) ) ) ) ).

% Inf_INT_eq2
thf(fact_6136_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R: C > ( set @ ( product_prod @ A @ B ) ),S2: set @ C] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I4: C,X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( R @ I4 ) )
          @ S2 ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ) ) ).

% INF_INT_eq2
thf(fact_6137_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S2: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I4: set @ ( product_prod @ A @ B ),X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ I4 )
          @ S2 ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ S2 ) ) ) ) ).

% INF_Int_eq2
thf(fact_6138_finite__range__Some,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ ( option @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) )
      = ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% finite_range_Some
thf(fact_6139_notin__range__Some,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( ~ ( member @ ( option @ A ) @ X @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) )
      = ( X
        = ( none @ A ) ) ) ).

% notin_range_Some
thf(fact_6140_None__notin__image__Some,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( member @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ) ).

% None_notin_image_Some
thf(fact_6141_UNIV__option__conv,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ ( option @ A ) ) )
      = ( insert @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% UNIV_option_conv
thf(fact_6142_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,B4: set @ A,I2: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) @ B4 )
     => ( member @ A @ ( F2 @ I2 ) @ B4 ) ) ).

% range_subsetD
thf(fact_6143_INT__extend__simps_I3_J,axiom,
    ! [F: $tType,E3: $tType,C5: set @ E3,A3: E3 > ( set @ F ),B4: set @ F] :
      ( ( ( C5
          = ( bot_bot @ ( set @ E3 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E3 @ ( set @ F ) @ A3 @ C5 ) ) @ B4 )
          = ( minus_minus @ ( set @ F ) @ ( top_top @ ( set @ F ) ) @ B4 ) ) )
      & ( ( C5
         != ( bot_bot @ ( set @ E3 ) ) )
       => ( ( minus_minus @ ( set @ F ) @ ( complete_Inf_Inf @ ( set @ F ) @ ( image @ E3 @ ( set @ F ) @ A3 @ C5 ) ) @ B4 )
          = ( complete_Inf_Inf @ ( set @ F )
            @ ( image @ E3 @ ( set @ F )
              @ ^ [X2: E3] : ( minus_minus @ ( set @ F ) @ ( A3 @ X2 ) @ B4 )
              @ C5 ) ) ) ) ) ).

% INT_extend_simps(3)
thf(fact_6144_UN__finite__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),C5: set @ A] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ C5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ C5 ) ) ).

% UN_finite_subset
thf(fact_6145_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X4: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X4 ) ) ) ) ) ).

% Inf_real_def
thf(fact_6146_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B4: B > ( set @ A ),A3: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X2: B] : ( pow2 @ A @ ( B4 @ X2 ) )
          @ A3 ) )
      @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B4 @ A3 ) ) ) ) ).

% UN_Pow_subset
thf(fact_6147_UN__finite2__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B4: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_6148_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L2: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) ) ) ).

% not_UNIV_le_Icc
thf(fact_6149_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_6150_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_6151_subset__UNIV,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_6152_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_6153_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_6154_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_6155_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_UNIV_le_Iic
thf(fact_6156_finite__int__iff__bounded__le,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S5: set @ int] :
        ? [K2: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S5 ) @ ( set_ord_atMost @ int @ K2 ) ) ) ) ).

% finite_int_iff_bounded_le
thf(fact_6157_finite__int__iff__bounded,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S5: set @ int] :
        ? [K2: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S5 ) @ ( set_ord_lessThan @ int @ K2 ) ) ) ) ).

% finite_int_iff_bounded
thf(fact_6158_Compl__eq__Diff__UNIV,axiom,
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) ) ) ).

% Compl_eq_Diff_UNIV
thf(fact_6159_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I5: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I5 ) ) @ B4 )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ ( A3 @ X2 ) @ B4 ) ) ) ) ).

% UN_subset_iff
thf(fact_6160_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B4: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( B4 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) ) ) ).

% UN_upper
thf(fact_6161_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: A > ( set @ B ),C5: set @ B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ ( B4 @ X5 ) @ C5 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) @ C5 ) ) ).

% UN_least
thf(fact_6162_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ B4 ) ) ) ) ) ).

% UN_mono
thf(fact_6163_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_6164_UN__extend__simps_I6_J,axiom,
    ! [L5: $tType,K9: $tType,A3: K9 > ( set @ L5 ),C5: set @ K9,B4: set @ L5] :
      ( ( minus_minus @ ( set @ L5 ) @ ( complete_Sup_Sup @ ( set @ L5 ) @ ( image @ K9 @ ( set @ L5 ) @ A3 @ C5 ) ) @ B4 )
      = ( complete_Sup_Sup @ ( set @ L5 )
        @ ( image @ K9 @ ( set @ L5 )
          @ ^ [X2: K9] : ( minus_minus @ ( set @ L5 ) @ ( A3 @ X2 ) @ B4 )
          @ C5 ) ) ) ).

% UN_extend_simps(6)
thf(fact_6165_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B4: set @ A,A3: B > ( set @ A ),I5: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I5 ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ I5 )
           => ( ord_less_eq @ ( set @ A ) @ B4 @ ( A3 @ X2 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_6166_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ B4 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ A3 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_6167_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C5: set @ B,B4: A > ( set @ B )] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ C5 @ ( B4 @ X5 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C5 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) ) ) ).

% INT_greatest
thf(fact_6168_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B4: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B4 @ A3 ) ) @ ( B4 @ A2 ) ) ) ).

% INT_lower
thf(fact_6169_full__SetCompr__eq,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( collect @ A
        @ ^ [U3: A] :
          ? [X2: B] :
            ( U3
            = ( F2 @ X2 ) ) )
      = ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ).

% full_SetCompr_eq
thf(fact_6170_UN__finite2__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B4: nat > ( set @ A ),K: nat] :
      ( ! [N3: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N3 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B4 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_6171_in__image__insert__iff,axiom,
    ! [A: $tType,B4: set @ ( set @ A ),X: A,A3: set @ A] :
      ( ! [C7: set @ A] :
          ( ( member @ ( set @ A ) @ C7 @ B4 )
         => ~ ( member @ A @ X @ C7 ) )
     => ( ( member @ ( set @ A ) @ A3 @ ( image @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X ) @ B4 ) )
        = ( ( member @ A @ X @ A3 )
          & ( member @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) ) ) ).

% in_image_insert_iff
thf(fact_6172_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) ) @ ( image @ B @ A @ F2 @ ( uminus_uminus @ ( set @ B ) @ A3 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_6173_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B ),F2: B > C,A10: A > ( set @ C )] :
      ( ! [I3: A,J2: A] :
          ( ( member @ A @ I3 @ I5 )
         => ( ( member @ A @ J2 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I3 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I5 )
           => ( bij_betw @ B @ C @ F2 @ ( A3 @ I3 ) @ ( A10 @ I3 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I5 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A10 @ I5 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_6174_suminf__eq__SUP__real,axiom,
    ! [X8: nat > real] :
      ( ( summable @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X8 @ I3 ) )
       => ( ( suminf @ real @ X8 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X8 @ ( set_ord_lessThan @ nat @ I4 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_6175_UN__extend__simps_I7_J,axiom,
    ! [M11: $tType,N11: $tType,A3: set @ M11,B4: N11 > ( set @ M11 ),C5: set @ N11] :
      ( ( minus_minus @ ( set @ M11 ) @ A3 @ ( complete_Inf_Inf @ ( set @ M11 ) @ ( image @ N11 @ ( set @ M11 ) @ B4 @ C5 ) ) )
      = ( complete_Sup_Sup @ ( set @ M11 )
        @ ( image @ N11 @ ( set @ M11 )
          @ ^ [X2: N11] : ( minus_minus @ ( set @ M11 ) @ A3 @ ( B4 @ X2 ) )
          @ C5 ) ) ) ).

% UN_extend_simps(7)
thf(fact_6176_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F5 @ X2 ) @ X2 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) ) ) ) ).

% Sup_Inf_le
thf(fact_6177_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F5 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_6178_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A3 )
                       => ( member @ A @ ( F5 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_6179_Nats__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Nats_def
thf(fact_6180_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S2: set @ A] :
      ( ! [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I3 ) @ S2 )
     => ( ( finite_finite @ A @ S2 )
       => ( ? [N7: nat] :
              ( ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N3 @ N7 )
                 => ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ M4 @ N7 )
                     => ( ( ord_less @ nat @ M4 @ N3 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M4 ) @ ( F2 @ N3 ) ) ) ) )
              & ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N3 )
                 => ( ( F2 @ N7 )
                    = ( F2 @ N3 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S2 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_6181_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X8: set @ A,A3: set @ ( product_prod @ A @ B ),Y8: set @ B,P: A > B > $o,Q: A > B > $o] :
      ( ( X8
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A3 ) )
     => ( ( Y8
          = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A3 ) )
       => ( ! [X5: A] :
              ( ( member @ A @ X5 @ X8 )
             => ! [Xa3: B] :
                  ( ( member @ B @ Xa3 @ Y8 )
                 => ( ( P @ X5 @ Xa3 )
                   => ( Q @ X5 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
           => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ Q ) ) ) ) ) ) ) ).

% Collect_split_mono_strong
thf(fact_6182_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_6183_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_6184_INT__extend__simps_I4_J,axiom,
    ! [G2: $tType,H5: $tType,C5: set @ H5,A3: set @ G2,B4: H5 > ( set @ G2 )] :
      ( ( ( C5
          = ( bot_bot @ ( set @ H5 ) ) )
       => ( ( minus_minus @ ( set @ G2 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G2 ) @ ( image @ H5 @ ( set @ G2 ) @ B4 @ C5 ) ) )
          = A3 ) )
      & ( ( C5
         != ( bot_bot @ ( set @ H5 ) ) )
       => ( ( minus_minus @ ( set @ G2 ) @ A3 @ ( complete_Sup_Sup @ ( set @ G2 ) @ ( image @ H5 @ ( set @ G2 ) @ B4 @ C5 ) ) )
          = ( complete_Inf_Inf @ ( set @ G2 )
            @ ( image @ H5 @ ( set @ G2 )
              @ ^ [X2: H5] : ( minus_minus @ ( set @ G2 ) @ A3 @ ( B4 @ X2 ) )
              @ C5 ) ) ) ) ) ).

% INT_extend_simps(4)
thf(fact_6185_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I4: nat] : ( M7 @ ( plus_plus @ nat @ I4 @ K ) )
          @ ( set_ord_lessThan @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_6186_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I4: nat] : ( M7 @ ( plus_plus @ nat @ I4 @ K ) )
          @ ( set_ord_atMost @ nat @ N ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_6187_subset__subseqs,axiom,
    ! [A: $tType,X8: set @ A,Xs2: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( set2 @ A @ Xs2 ) )
     => ( member @ ( set @ A ) @ X8 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) ) ) ) ).

% subset_subseqs
thf(fact_6188_subseqs__powset,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) )
      = ( pow2 @ A @ ( set2 @ A @ Xs2 ) ) ) ).

% subseqs_powset
thf(fact_6189_image__add__int__atLeastLessThan,axiom,
    ! [L2: int,U2: int] :
      ( ( image @ int @ int
        @ ^ [X2: int] : ( plus_plus @ int @ X2 @ L2 )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U2 @ L2 ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L2 @ U2 ) ) ).

% image_add_int_atLeastLessThan
thf(fact_6190_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_6191_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite @ A @ I5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I5 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I4: A] : ( finite_card @ B @ ( A3 @ I4 ) )
          @ I5 ) ) ) ).

% card_UN_le
thf(fact_6192_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F5: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N2: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_6193_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image @ nat @ nat
          @ ^ [M3: nat] : ( modulo_modulo @ nat @ M3 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_6194_image__atLeastZeroLessThan__int,axiom,
    ! [U2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U2 )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U2 )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U2 ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_6195_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G: C > ( set @ B ),X: C,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ ( G @ X ) ) ) @ X8 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X )
        @ ( collect @ B
          @ ^ [X2: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X2 ) @ X8 ) ) ) ) ).

% UN_image_subset
thf(fact_6196_INF__filter__not__bot,axiom,
    ! [I7: $tType,A: $tType,B4: set @ I7,F4: I7 > ( filter @ A )] :
      ( ! [X10: set @ I7] :
          ( ( ord_less_eq @ ( set @ I7 ) @ X10 @ B4 )
         => ( ( finite_finite @ I7 @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ X10 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F4 @ B4 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_6197_card__UNIV__unit,axiom,
    ( ( finite_card @ product_unit @ ( top_top @ ( set @ product_unit ) ) )
    = ( one_one @ nat ) ) ).

% card_UNIV_unit
thf(fact_6198_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_6199_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_6200_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,F4: A > ( filter @ B )] :
      ( ! [I3: A] :
          ( ( member @ A @ I3 @ I5 )
         => ! [J2: A] :
              ( ( member @ A @ J2 @ I5 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ I5 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X3 ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ I3 ) @ ( F4 @ J2 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ I5 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ I5 )
              & ( ( F4 @ X2 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_6201_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_6202_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% top_empty_eq2
thf(fact_6203_Inf__filter__not__bot,axiom,
    ! [A: $tType,B4: set @ ( filter @ A )] :
      ( ! [X10: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X10 @ B4 )
         => ( ( finite_finite @ ( filter @ A ) @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X10 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B4 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_6204_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S5: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F9: filter @ A] :
                ! [X2: filter @ A] :
                  ( ( member @ ( filter @ A ) @ X2 @ S5 )
                 => ( ord_less_eq @ ( filter @ A ) @ F9 @ X2 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_6205_conj__subset__def,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_6206_root__def,axiom,
    ( root
    = ( ^ [N2: nat,X2: real] :
          ( if @ real
          @ ( N2
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N2 ) )
            @ X2 ) ) ) ) ).

% root_def
thf(fact_6207_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_6208_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F9 @ F10 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F10 @ F9 ) ) ) ) ).

% less_filter_def
thf(fact_6209_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_6210_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_6211_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( remdups @ A @ X )
        = ( nil @ A ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_6212_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X ) )
      = ( X
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_6213_set__remdups,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs2 ) )
      = ( set2 @ A @ Xs2 ) ) ).

% set_remdups
thf(fact_6214_length__remdups__eq,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs2 ) )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ( remdups @ A @ Xs2 )
        = Xs2 ) ) ).

% length_remdups_eq
thf(fact_6215_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( remdups @ A @ Xs2 )
        = Xs2 )
      = ( distinct @ A @ Xs2 ) ) ).

% remdups_id_iff_distinct
thf(fact_6216_distinct__remdups,axiom,
    ! [A: $tType,Xs2: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs2 ) ) ).

% distinct_remdups
thf(fact_6217_length__remdups__leq,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_remdups_leq
thf(fact_6218_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_6219_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N ) ) ) ).

% char_of_mod_256
thf(fact_6220_distinct__remdups__id,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( remdups @ A @ Xs2 )
        = Xs2 ) ) ).

% distinct_remdups_id
thf(fact_6221_remdups__remdups,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs2 ) )
      = ( remdups @ A @ Xs2 ) ) ).

% remdups_remdups
thf(fact_6222_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_6223_remove1__remdups,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( remove1 @ A @ X @ ( remdups @ A @ Xs2 ) )
        = ( remdups @ A @ ( remove1 @ A @ X @ Xs2 ) ) ) ) ).

% remove1_remdups
thf(fact_6224_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs2 ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs2 ) ) ) ).

% length_remdups_card_conv
thf(fact_6225_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_6226_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_6227_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N2: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N2 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_6228_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_6229_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_6230_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_6231_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_6232_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_6233_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_6234_list_Oinject,axiom,
    ! [A: $tType,X21: A,X222: list @ A,Y21: A,Y222: list @ A] :
      ( ( ( cons @ A @ X21 @ X222 )
        = ( cons @ A @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% list.inject
thf(fact_6235_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X222 ) )
      = ( insert @ A @ X21 @ ( set2 @ A @ X222 ) ) ) ).

% list.simps(15)
thf(fact_6236_nth__Cons__Suc,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( suc @ N ) )
      = ( nth @ A @ Xs2 @ N ) ) ).

% nth_Cons_Suc
thf(fact_6237_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_6238_nths__singleton,axiom,
    ! [A: $tType,A3: set @ nat,X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A3 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A3 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_6239_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R )
          & ( Xs2 = Ys ) )
        | ( ( X = Y2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_6240_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A,X: B,Xs2: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( cons @ B @ X @ Xs2 ) )
          = ( plus_plus @ A @ ( F2 @ X ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs2 ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_6241_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N: nat,X: B,Xs2: list @ B] :
      ( ( enumerate @ B @ N @ ( cons @ B @ X @ Xs2 ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N @ X ) @ ( enumerate @ B @ ( suc @ N ) @ Xs2 ) ) ) ).

% enumerate_simps(2)
thf(fact_6242_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_6243_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_6244_set__subset__Cons,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ ( cons @ A @ X @ Xs2 ) ) ) ).

% set_subset_Cons
thf(fact_6245_impossible__Cons,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs2
       != ( cons @ A @ X @ Ys ) ) ) ).

% impossible_Cons
thf(fact_6246_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y2: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y2 @ Ys ) )
              = ( cons @ B @ X @ ( cons @ B @ Y2 @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y2 @ Ys ) )
              = ( cons @ B @ Y2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_6247_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( nil @ B ) )
          = ( cons @ B @ X @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_6248_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F3: A > B,Bs2: list @ B] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F3 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F3: A > B,A6: A,As: list @ A,Bs2: list @ B] :
            ( X
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F3 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A6 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_6249_shuffles_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ( ! [Xs3: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ ( nil @ A ) ) )
       => ~ ! [X5: A,Xs3: list @ A,Y4: A,Ys4: list @ A] :
              ( X
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) ) ).

% shuffles.cases
thf(fact_6250_splice_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ~ ! [X5: A,Xs3: list @ A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Ys4 ) ) ) ).

% splice.cases
thf(fact_6251_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ~ ! [P8: A > A > $o,X5: A,Ys4: list @ A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X5 @ Ys4 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_6252_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F3: A > B,X5: A] :
              ( X
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F3 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) )
         => ( ! [F3: A > B,X5: A,Y4: A,Zs2: list @ A] :
                ( X
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F3 @ ( cons @ A @ X5 @ ( cons @ A @ Y4 @ Zs2 ) ) ) )
           => ~ ! [A6: A > B] :
                  ( X
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A6 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_6253_successively_Ocases,axiom,
    ! [A: $tType,X: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ( ! [P8: A > A > $o,X5: A] :
            ( X
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) )
       => ~ ! [P8: A > A > $o,X5: A,Y4: A,Xs3: list @ A] :
              ( X
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X5 @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) ) ).

% successively.cases
thf(fact_6254_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,I2: nat,V: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs2 ) @ I2 @ V )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V @ Xs2 )
        @ ^ [J3: nat] : ( cons @ A @ X @ ( list_update @ A @ Xs2 @ J3 @ V ) )
        @ I2 ) ) ).

% list_update.simps(2)
thf(fact_6255_replicate__Suc,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( replicate @ A @ ( suc @ N ) @ X )
      = ( cons @ A @ X @ ( replicate @ A @ N @ X ) ) ) ).

% replicate_Suc
thf(fact_6256_distinct__singleton,axiom,
    ! [A: $tType,X: A] : ( distinct @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_6257_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X @ Xs2 ) )
      = ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
        & ( distinct @ A @ Xs2 ) ) ) ).

% distinct.simps(2)
thf(fact_6258_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys: list @ A,Z2: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z2 @ Xs2 ) @ Ys ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_6259_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys: list @ A,Z2: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Z2 @ Ys ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_6260_distinct__length__2__or__more,axiom,
    ! [A: $tType,A2: A,B2: A,Xs2: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A2 @ ( cons @ A @ B2 @ Xs2 ) ) )
      = ( ( A2 != B2 )
        & ( distinct @ A @ ( cons @ A @ A2 @ Xs2 ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs2 ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_6261_length__Suc__conv,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv
thf(fact_6262_Suc__length__conv,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ Y @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% Suc_length_conv
thf(fact_6263_length__Cons,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_Cons
thf(fact_6264_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y2: A,Xs2: list @ A] :
      ( ( ( X = Y2 )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) )
          = Xs2 ) )
      & ( ( X != Y2 )
       => ( ( remove1 @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) )
          = ( cons @ A @ Y2 @ ( remove1 @ A @ X @ Xs2 ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_6265_not__Cons__self2,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( cons @ A @ X @ Xs2 )
     != Xs2 ) ).

% not_Cons_self2
thf(fact_6266_set__ConsD,axiom,
    ! [A: $tType,Y2: A,X: A,Xs2: list @ A] :
      ( ( member @ A @ Y2 @ ( set2 @ A @ ( cons @ A @ X @ Xs2 ) ) )
     => ( ( Y2 = X )
        | ( member @ A @ Y2 @ ( set2 @ A @ Xs2 ) ) ) ) ).

% set_ConsD
thf(fact_6267_list_Oset__cases,axiom,
    ! [A: $tType,E: A,A2: list @ A] :
      ( ( member @ A @ E @ ( set2 @ A @ A2 ) )
     => ( ! [Z23: list @ A] :
            ( A2
           != ( cons @ A @ E @ Z23 ) )
       => ~ ! [Z12: A,Z23: list @ A] :
              ( ( A2
                = ( cons @ A @ Z12 @ Z23 ) )
             => ~ ( member @ A @ E @ ( set2 @ A @ Z23 ) ) ) ) ) ).

% list.set_cases
thf(fact_6268_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] : ( member @ A @ X21 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ).

% list.set_intros(1)
thf(fact_6269_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y2: A,X222: list @ A,X21: A] :
      ( ( member @ A @ Y2 @ ( set2 @ A @ X222 ) )
     => ( member @ A @ Y2 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ) ).

% list.set_intros(2)
thf(fact_6270_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y2: A,Xs2: list @ A] :
      ( ( ( X = Y2 )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) )
          = ( removeAll @ A @ X @ Xs2 ) ) )
      & ( ( X != Y2 )
       => ( ( removeAll @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) )
          = ( cons @ A @ Y2 @ ( removeAll @ A @ X @ Xs2 ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_6271_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ C,Ws: list @ D,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X5: A,Xs3: list @ A,Y4: B,Ys4: list @ B,Z5: C,Zs2: list @ C,W2: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P @ Xs3 @ Ys4 @ Zs2 @ Ws2 )
                       => ( P @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ B @ Y4 @ Ys4 ) @ ( cons @ C @ Z5 @ Zs2 ) @ ( cons @ D @ W2 @ Ws2 ) ) ) ) ) )
             => ( P @ Xs2 @ Ys @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_6272_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ C,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X5: A,Xs3: list @ A,Y4: B,Ys4: list @ B,Z5: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P @ Xs3 @ Ys4 @ Zs2 )
                   => ( P @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ B @ Y4 @ Ys4 ) @ ( cons @ C @ Z5 @ Zs2 ) ) ) ) )
           => ( P @ Xs2 @ Ys @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_6273_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,P: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X5: A,Xs3: list @ A,Y4: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P @ Xs3 @ Ys4 )
               => ( P @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ B @ Y4 @ Ys4 ) ) ) )
         => ( P @ Xs2 @ Ys ) ) ) ) ).

% list_induct2
thf(fact_6274_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X222 ) ) ).

% list.distinct(1)
thf(fact_6275_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X21: A,X222: list @ A] :
      ( ( List
        = ( cons @ A @ X21 @ X222 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_6276_list_Oexhaust,axiom,
    ! [A: $tType,Y2: list @ A] :
      ( ( Y2
       != ( nil @ A ) )
     => ~ ! [X212: A,X223: list @ A] :
            ( Y2
           != ( cons @ A @ X212 @ X223 ) ) ) ).

% list.exhaust
thf(fact_6277_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: list @ A] :
          ( ! [X5: A,Xs3: list @ A] :
              ( X
             != ( cons @ A @ X5 @ Xs3 ) )
         => ( X
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_6278_transpose_Ocases,axiom,
    ! [A: $tType,X: list @ ( list @ A )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss2: list @ ( list @ A )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
       => ~ ! [X5: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
              ( X
             != ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Xss2 ) ) ) ) ).

% transpose.cases
thf(fact_6279_remdups__adj_Ocases,axiom,
    ! [A: $tType,X: list @ A] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X5: A] :
            ( X
           != ( cons @ A @ X5 @ ( nil @ A ) ) )
       => ~ ! [X5: A,Y4: A,Xs3: list @ A] :
              ( X
             != ( cons @ A @ X5 @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_6280_neq__Nil__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( Xs2
         != ( nil @ A ) ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( Xs2
            = ( cons @ A @ Y @ Ys3 ) ) ) ) ).

% neq_Nil_conv
thf(fact_6281_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: ( list @ A ) > ( list @ B ) > $o,Xs2: list @ A,Ys: list @ B] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X5: A,Xs3: list @ A] : ( P @ ( cons @ A @ X5 @ Xs3 ) @ ( nil @ B ) )
       => ( ! [Y4: B,Ys4: list @ B] : ( P @ ( nil @ A ) @ ( cons @ B @ Y4 @ Ys4 ) )
         => ( ! [X5: A,Xs3: list @ A,Y4: B,Ys4: list @ B] :
                ( ( P @ Xs3 @ Ys4 )
               => ( P @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ B @ Y4 @ Ys4 ) ) )
           => ( P @ Xs2 @ Ys ) ) ) ) ) ).

% list_induct2'
thf(fact_6282_list__nonempty__induct,axiom,
    ! [A: $tType,Xs2: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ! [X5: A] : ( P @ ( cons @ A @ X5 @ ( nil @ A ) ) )
       => ( ! [X5: A,Xs3: list @ A] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( cons @ A @ X5 @ Xs3 ) ) ) )
         => ( P @ Xs2 ) ) ) ) ).

% list_nonempty_induct
thf(fact_6283_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs2 ) @ ( zero_zero @ nat ) @ Y2 )
      = ( cons @ A @ Y2 @ Xs2 ) ) ).

% list_update_code(2)
thf(fact_6284_list__update__code_I3_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,I2: nat,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs2 ) @ ( suc @ I2 ) @ Y2 )
      = ( cons @ A @ X @ ( list_update @ A @ Xs2 @ I2 @ Y2 ) ) ) ).

% list_update_code(3)
thf(fact_6285_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
     => ( ( ( Zs = Xs2 )
         => ( Ys
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys )
           => ( Xs2
             != ( nil @ A ) ) )
         => ( ! [X5: A,Xs4: list @ A] :
                ( ( Xs2
                  = ( cons @ A @ X5 @ Xs4 ) )
               => ! [Z5: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z5 @ Zs4 ) )
                   => ( ( X5 = Z5 )
                     => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs4 @ Ys ) ) ) ) )
           => ~ ! [Y4: A,Ys5: list @ A] :
                  ( ( Ys
                    = ( cons @ A @ Y4 @ Ys5 ) )
                 => ! [Z5: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z5 @ Zs4 ) )
                     => ( ( Y4 = Z5 )
                       => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs2 @ Ys5 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_6286_listrel1I2,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ X @ Ys ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I2
thf(fact_6287_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs2 ) )
          = ( remdups @ A @ Xs2 ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( remdups @ A @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ ( remdups @ A @ Xs2 ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_6288_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs2 @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs2 ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_6289_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y2: A,Xs2: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ Xs2 @ Ys ) ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_6290_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y2: A,Ys: list @ A,Xs2: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Y2 @ Ys ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) )
     => ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs2 ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_6291_nth__Cons,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
      = ( case_nat @ A @ X @ ( nth @ A @ Xs2 ) @ N ) ) ).

% nth_Cons
thf(fact_6292_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = ( ? [X2: A,Ys3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ X2 @ Ys3 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_6293_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ B,F2: B > A,A2: B] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ ( set2 @ B @ Xs2 ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X5 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs2 )
            = ( cons @ B @ A2 @ Xs2 ) ) ) ) ).

% insort_is_Cons
thf(fact_6294_listrel1I1,axiom,
    ! [A: $tType,X: A,Y2: A,R: set @ ( product_prod @ A @ A ),Xs2: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Xs2 ) ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1I1
thf(fact_6295_Cons__listrel1E1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ! [Y4: A] :
            ( ( Ys
              = ( cons @ A @ Y4 @ Xs2 ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Zs2 ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_6296_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs2: list @ A,Y2: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( cons @ A @ Y2 @ Ys ) ) @ ( listrel1 @ A @ R ) )
     => ( ! [X5: A] :
            ( ( Xs2
              = ( cons @ A @ X5 @ Ys ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y2 ) @ R ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs2
                = ( cons @ A @ Y2 @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_6297_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Y2: A,Xs2: list @ A] :
      ( ( ( X = Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs2 ) @ Y2 )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs2 @ Y2 ) @ ( one_one @ nat ) ) ) )
      & ( ( X != Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X @ Xs2 ) @ Y2 )
          = ( count_list @ A @ Xs2 @ Y2 ) ) ) ) ).

% count_list.simps(2)
thf(fact_6298_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_6299_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = X ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_6300_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X21 ) @ ( size_list @ A @ X @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_6301_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [Xs3: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ ( nil @ A ) ) )
             => ( P @ Xs3 @ ( nil @ A ) ) )
         => ( ! [X5: A,Xs3: list @ A,Y4: A,Ys4: list @ A] :
                ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) )
               => ( ( P @ Xs3 @ ( cons @ A @ Y4 @ Ys4 ) )
                 => ( ( P @ ( cons @ A @ X5 @ Xs3 ) @ Ys4 )
                   => ( P @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) )
           => ( P @ A0 @ A1 ) ) ) ) ) ).

% shuffles.pinduct
thf(fact_6302_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
            = X )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_6303_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y2: A,Xs2: list @ A,N: nat] :
      ( ( X != Y2 )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs2 ) @ N )
          = Y2 )
        = ( ( ( nth @ A @ Xs2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y2 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_6304_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,N: nat,Y2: A] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( replicate @ A @ N @ Y2 ) )
      = ( ( X = Y2 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs2
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_6305_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( set_Cons @ A @ A3 @ ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image @ A @ ( list @ A )
        @ ^ [X2: A] : ( cons @ A @ X2 @ ( nil @ A ) )
        @ A3 ) ) ).

% set_Cons_sing_Nil
thf(fact_6306_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_6307_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_6308_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A3: set @ A,As2: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A3 @ As2 ) )
      = ( set_Cons @ A @ A3 @ ( listset @ A @ As2 ) ) ) ).

% listset.simps(2)
thf(fact_6309_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_6310_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_6311_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs2 )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_6312_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_6313_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I2 @ J ) )
        = ( cons @ nat @ ( suc @ I2 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I2 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_6314_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A7: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z: list @ A] :
              ? [X2: A,Xs: list @ A] :
                ( ( Z
                  = ( cons @ A @ X2 @ Xs ) )
                & ( member @ A @ X2 @ A7 )
                & ( member @ ( list @ A ) @ Xs @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_6315_shuffles_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y2: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa2 ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y2
                = ( insert @ ( list @ A ) @ Xa2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa2 ) ) ) )
         => ( ( ( Xa2
                = ( nil @ A ) )
             => ( ( Y2
                  = ( insert @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
           => ~ ! [X5: A,Xs3: list @ A] :
                  ( ( X
                    = ( cons @ A @ X5 @ Xs3 ) )
                 => ! [Y4: A,Ys4: list @ A] :
                      ( ( Xa2
                        = ( cons @ A @ Y4 @ Ys4 ) )
                     => ( ( Y2
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 ) @ ( shuffles @ A @ Xs3 @ ( cons @ A @ Y4 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y4 ) @ ( shuffles @ A @ ( cons @ A @ X5 @ Xs3 ) @ Ys4 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_6316_concat__inth,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = X ) ).

% concat_inth
thf(fact_6317_same__append__eq,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs2 @ Ys )
        = ( append @ A @ Xs2 @ Zs ) )
      = ( Ys = Zs ) ) ).

% same_append_eq
thf(fact_6318_append__same__eq,axiom,
    ! [A: $tType,Ys: list @ A,Xs2: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys @ Xs2 )
        = ( append @ A @ Zs @ Xs2 ) )
      = ( Ys = Zs ) ) ).

% append_same_eq
thf(fact_6319_append__assoc,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs2 @ Ys ) @ Zs )
      = ( append @ A @ Xs2 @ ( append @ A @ Ys @ Zs ) ) ) ).

% append_assoc
thf(fact_6320_append_Oassoc,axiom,
    ! [A: $tType,A2: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A2 @ B2 ) @ C2 )
      = ( append @ A @ A2 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_6321_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_6322_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y2 ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            & ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) ).

% le_sup_iff
thf(fact_6323_Un__subset__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
        & ( ord_less_eq @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Un_subset_iff
thf(fact_6324_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs2 @ Ys )
        = ( nil @ A ) )
      = ( ( Xs2
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_6325_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs2 @ Ys ) )
      = ( ( Xs2
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_6326_self__append__conv2,axiom,
    ! [A: $tType,Y2: list @ A,Xs2: list @ A] :
      ( ( Y2
        = ( append @ A @ Xs2 @ Y2 ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_6327_append__self__conv2,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs2 @ Ys )
        = Ys )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_6328_self__append__conv,axiom,
    ! [A: $tType,Y2: list @ A,Ys: list @ A] :
      ( ( Y2
        = ( append @ A @ Y2 @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_6329_append__self__conv,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs2 @ Ys )
        = Xs2 )
      = ( Ys
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_6330_append__Nil2,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( append @ A @ Xs2 @ ( nil @ A ) )
      = Xs2 ) ).

% append_Nil2
thf(fact_6331_append_Oright__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ A2 @ ( nil @ A ) )
      = A2 ) ).

% append.right_neutral
thf(fact_6332_append__eq__append__conv,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs2 @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs2 = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_6333_Un__Diff__cancel2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) @ A3 )
      = ( sup_sup @ ( set @ A ) @ B4 @ A3 ) ) ).

% Un_Diff_cancel2
thf(fact_6334_Un__Diff__cancel,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ).

% Un_Diff_cancel
thf(fact_6335_concat__append,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs2 @ Ys ) )
      = ( append @ A @ ( concat @ A @ Xs2 ) @ ( concat @ A @ Ys ) ) ) ).

% concat_append
thf(fact_6336_removeAll__append,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] :
      ( ( removeAll @ A @ X @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ A @ ( removeAll @ A @ X @ Xs2 ) @ ( removeAll @ A @ X @ Ys ) ) ) ).

% removeAll_append
thf(fact_6337_append1__eq__conv,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A,Y2: A] :
      ( ( ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
      = ( ( Xs2 = Ys )
        & ( X = Y2 ) ) ) ).

% append1_eq_conv
thf(fact_6338_length__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_6339_set__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( append @ A @ Xs2 @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) ) ) ).

% set_append
thf(fact_6340_Compl__Diff__eq,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( uminus_uminus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = ( sup_sup @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ B4 ) ) ).

% Compl_Diff_eq
thf(fact_6341_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs2 @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs2 ) @ ( size_list @ A @ F2 @ Ys ) ) ) ).

% size_list_append
thf(fact_6342_set__union,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs2 @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) ) ) ).

% set_union
thf(fact_6343_nth__append__length,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
      = X ) ).

% nth_append_length
thf(fact_6344_nth__append__length__plus,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,N: nat] :
      ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ N ) )
      = ( nth @ A @ Ys @ N ) ) ).

% nth_append_length_plus
thf(fact_6345_list__update__length,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A,Y2: A] :
      ( ( list_update @ A @ ( append @ A @ Xs2 @ ( cons @ A @ X @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) @ Y2 )
      = ( append @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys ) ) ) ).

% list_update_length
thf(fact_6346_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_6347_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_6348_distinct__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs2 @ Ys ) )
      = ( ( distinct @ A @ Xs2 )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_6349_replicate__app__Cons__same,axiom,
    ! [A: $tType,N: nat,X: A,Xs2: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( cons @ A @ X @ Xs2 ) )
      = ( cons @ A @ X @ ( append @ A @ ( replicate @ A @ N @ X ) @ Xs2 ) ) ) ).

% replicate_app_Cons_same
thf(fact_6350_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X: list @ A,Xs2: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X @ Xs2 ) )
      = ( append @ A @ X @ ( concat @ A @ Xs2 ) ) ) ).

% concat.simps(2)
thf(fact_6351_Cons__eq__appendI,axiom,
    ! [A: $tType,X: A,Xs1: list @ A,Ys: list @ A,Xs2: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs1 )
        = Ys )
     => ( ( Xs2
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X @ Xs2 )
          = ( append @ A @ Ys @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_6352_append__Cons,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] :
      ( ( append @ A @ ( cons @ A @ X @ Xs2 ) @ Ys )
      = ( cons @ A @ X @ ( append @ A @ Xs2 @ Ys ) ) ) ).

% append_Cons
thf(fact_6353_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
            & ( P @ X2 ) ) )
      = ( ? [Ys3: list @ A,X2: A] :
            ( ? [Zs3: list @ A] :
                ( Xs2
                = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ( P @ X2 )
            & ! [Y: A] :
                ( ( member @ A @ Y @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_6354_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
            & ( P @ X2 ) ) )
      = ( ? [Ys3: list @ A,X2: A,Zs3: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ( P @ X2 )
            & ! [Y: A] :
                ( ( member @ A @ Y @ ( set2 @ A @ Zs3 ) )
               => ~ ( P @ Y ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_6355_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Ys3 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_6356_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_6357_split__list__first__propE,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
          & ( P @ X3 ) )
     => ~ ! [Ys4: list @ A,X5: A] :
            ( ? [Zs2: list @ A] :
                ( Xs2
                = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
           => ( ( P @ X5 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_first_propE
thf(fact_6358_split__list__last__propE,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
          & ( P @ X3 ) )
     => ~ ! [Ys4: list @ A,X5: A,Zs2: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
           => ( ( P @ X5 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_last_propE
thf(fact_6359_split__list__first__prop,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
          & ( P @ X3 ) )
     => ? [Ys4: list @ A,X5: A] :
          ( ? [Zs2: list @ A] :
              ( Xs2
              = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
          & ( P @ X5 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_first_prop
thf(fact_6360_split__list__last__prop,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
          & ( P @ X3 ) )
     => ? [Ys4: list @ A,X5: A,Zs2: list @ A] :
          ( ( Xs2
            = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
          & ( P @ X5 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_last_prop
thf(fact_6361_in__set__conv__decomp,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( Xs2
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_6362_append__Cons__eq__iff,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A,Xs5: list @ A,Ys6: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ~ ( member @ A @ X @ ( set2 @ A @ Ys ) )
       => ( ( ( append @ A @ Xs2 @ ( cons @ A @ X @ Ys ) )
            = ( append @ A @ Xs5 @ ( cons @ A @ X @ Ys6 ) ) )
          = ( ( Xs2 = Xs5 )
            & ( Ys = Ys6 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_6363_split__list__propE,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
          & ( P @ X3 ) )
     => ~ ! [Ys4: list @ A,X5: A] :
            ( ? [Zs2: list @ A] :
                ( Xs2
                = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
           => ~ ( P @ X5 ) ) ) ).

% split_list_propE
thf(fact_6364_split__list__first,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs2
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Ys4 ) ) ) ) ).

% split_list_first
thf(fact_6365_split__list__prop,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ? [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
          & ( P @ X3 ) )
     => ? [Ys4: list @ A,X5: A] :
          ( ? [Zs2: list @ A] :
              ( Xs2
              = ( append @ A @ Ys4 @ ( cons @ A @ X5 @ Zs2 ) ) )
          & ( P @ X5 ) ) ) ).

% split_list_prop
thf(fact_6366_split__list__last,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs2
            = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_6367_split__list,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( Xs2
          = ( append @ A @ Ys4 @ ( cons @ A @ X @ Zs2 ) ) ) ) ).

% split_list
thf(fact_6368_rev__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs2: list @ A] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X5: A,Xs3: list @ A] :
            ( ( P @ Xs3 )
           => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs2 ) ) ) ).

% rev_induct
thf(fact_6369_rev__exhaust,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ~ ! [Ys4: list @ A,Y4: A] :
            ( Xs2
           != ( append @ A @ Ys4 @ ( cons @ A @ Y4 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_6370_Cons__eq__append__conv,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs2 )
            = Zs ) )
        | ? [Ys7: list @ A] :
            ( ( ( cons @ A @ X @ Ys7 )
              = Ys )
            & ( Xs2
              = ( append @ A @ Ys7 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_6371_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,X: A,Xs2: list @ A] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X @ Xs2 ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs2 ) ) )
        | ? [Ys7: list @ A] :
            ( ( Ys
              = ( cons @ A @ X @ Ys7 ) )
            & ( ( append @ A @ Ys7 @ Zs )
              = Xs2 ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_6372_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs2: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ! [X5: A] : ( P @ ( cons @ A @ X5 @ ( nil @ A ) ) )
       => ( ! [X5: A,Xs3: list @ A] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X5 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs2 ) ) ) ) ).

% rev_nonempty_induct
thf(fact_6373_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Xss
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss
           != ( nil @ ( list @ A ) ) )
         => ? [Xss1: list @ ( list @ A ),Xs: list @ A,Xs6: list @ A,Xss22: list @ ( list @ A )] :
              ( ( Xss
                = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs @ Xs6 ) @ Xss22 ) ) )
              & ( Ys
                = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs ) )
              & ( Zs
                = ( append @ A @ Xs6 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_6374_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( Xss
         != ( nil @ ( list @ A ) ) )
       => ? [Xss12: list @ ( list @ A ),Xs3: list @ A,Xs4: list @ A,Xss23: list @ ( list @ A )] :
            ( ( Xss
              = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs3 @ Xs4 ) @ Xss23 ) ) )
            & ( Ys
              = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs3 ) )
            & ( Zs
              = ( append @ A @ Xs4 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_6375_append__listrel1I,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( Us = Vs ) )
        | ( ( Xs2 = Ys )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R ) ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R ) ) ) ).

% append_listrel1I
thf(fact_6376_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U2 ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_6377_Diff__partition,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) )
        = B4 ) ) ).

% Diff_partition
thf(fact_6378_Diff__subset__conv,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Diff_subset_conv
thf(fact_6379_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_6380_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_6381_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_6382_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( sup_sup @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_6383_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_6384_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_6385_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( A4
              = ( sup_sup @ A @ A4 @ B3 ) ) ) ) ) ).

% sup.order_iff
thf(fact_6386_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_6387_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_6388_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( sup_sup @ A @ X @ Y2 )
            = Y2 ) ) ) ).

% sup_absorb2
thf(fact_6389_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( sup_sup @ A @ X @ Y2 )
            = X ) ) ) ).

% sup_absorb1
thf(fact_6390_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_6391_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_6392_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X: A,Y2: A] :
          ( ! [X5: A,Y4: A] : ( ord_less_eq @ A @ X5 @ ( F2 @ X5 @ Y4 ) )
         => ( ! [X5: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ ( F2 @ X5 @ Y4 ) )
           => ( ! [X5: A,Y4: A,Z5: A] :
                  ( ( ord_less_eq @ A @ Y4 @ X5 )
                 => ( ( ord_less_eq @ A @ Z5 @ X5 )
                   => ( ord_less_eq @ A @ ( F2 @ Y4 @ Z5 ) @ X5 ) ) )
             => ( ( sup_sup @ A @ X @ Y2 )
                = ( F2 @ X @ Y2 ) ) ) ) ) ) ).

% sup_unique
thf(fact_6393_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_6394_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_6395_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( sup_sup @ A @ X2 @ Y )
              = Y ) ) ) ) ).

% le_iff_sup
thf(fact_6396_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X: A,Z2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( ord_less_eq @ A @ Z2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y2 @ Z2 ) @ X ) ) ) ) ).

% sup_least
thf(fact_6397_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_6398_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_6399_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_6400_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_6401_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X: A] : ( ord_less_eq @ A @ Y2 @ ( sup_sup @ A @ X @ Y2 ) ) ) ).

% sup_ge2
thf(fact_6402_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y2 ) ) ) ).

% sup_ge1
thf(fact_6403_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_6404_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_6405_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y2 ) ) ) ).

% inf_sup_ord(3)
thf(fact_6406_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y2: A,X: A] : ( ord_less_eq @ A @ Y2 @ ( sup_sup @ A @ X @ Y2 ) ) ) ).

% inf_sup_ord(4)
thf(fact_6407_Un__mono,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ ( sup_sup @ ( set @ A ) @ C5 @ D5 ) ) ) ) ).

% Un_mono
thf(fact_6408_Un__least,axiom,
    ! [A: $tType,A3: set @ A,C5: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ C5 ) ) ) ).

% Un_least
thf(fact_6409_Un__upper1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ).

% Un_upper1
thf(fact_6410_Un__upper2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ B4 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ).

% Un_upper2
thf(fact_6411_Un__absorb1,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B4 )
        = B4 ) ) ).

% Un_absorb1
thf(fact_6412_Un__absorb2,axiom,
    ! [A: $tType,B4: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B4 )
        = A3 ) ) ).

% Un_absorb2
thf(fact_6413_subset__UnE,axiom,
    ! [A: $tType,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ! [A15: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A15 @ A3 )
           => ! [B14: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B14 @ B4 )
               => ( C5
                 != ( sup_sup @ ( set @ A ) @ A15 @ B14 ) ) ) ) ) ).

% subset_UnE
thf(fact_6414_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B7: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A7 @ B7 )
            = B7 ) ) ) ).

% subset_Un_eq
thf(fact_6415_Un__Pow__subset,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A3 ) @ ( pow2 @ A @ B4 ) ) @ ( pow2 @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% Un_Pow_subset
thf(fact_6416_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U2 ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_6417_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ C5 )
        = ( inf_inf @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C5 @ A3 ) ) ).

% Un_Int_assoc_eq
thf(fact_6418_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y2: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y2 @ Z2 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y2 ) @ ( sup_sup @ A @ X @ Z2 ) ) ) ) ).

% distrib_sup_le
thf(fact_6419_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y2: A,Z2: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y2 ) @ ( inf_inf @ A @ X @ Z2 ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y2 @ Z2 ) ) ) ) ).

% distrib_inf_le
thf(fact_6420_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U2 ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_6421_Un__Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = A3 ) ).

% Un_Diff_Int
thf(fact_6422_Int__Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
      = A3 ) ).

% Int_Diff_Un
thf(fact_6423_Diff__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C5 ) )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% Diff_Int
thf(fact_6424_Diff__Un,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B4 @ C5 ) )
      = ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ ( minus_minus @ ( set @ A ) @ A3 @ C5 ) ) ) ).

% Diff_Un
thf(fact_6425_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) ) ) ) ).

% set_shuffles
thf(fact_6426_append__replicate__commute,axiom,
    ! [A: $tType,N: nat,X: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ K @ X ) )
      = ( append @ A @ ( replicate @ A @ K @ X ) @ ( replicate @ A @ N @ X ) ) ) ).

% append_replicate_commute
thf(fact_6427_enumerate__append__eq,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) @ ( enumerate @ A @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_6428_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A,Ts2: list @ A] :
      ( ( ( append @ A @ Xs2 @ Ys )
        = ( append @ A @ Zs @ Ts2 ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs2
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts2 ) )
            | ( ( ( append @ A @ Xs2 @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts2 ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_6429_append__eq__appendI,axiom,
    ! [A: $tType,Xs2: list @ A,Xs1: list @ A,Zs: list @ A,Ys: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs2 @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs2 @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_6430_Un__Diff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,C5: set @ A] :
      ( ( minus_minus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) @ C5 )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ C5 ) @ ( minus_minus @ ( set @ A ) @ B4 @ C5 ) ) ) ).

% Un_Diff
thf(fact_6431_replicate__add,axiom,
    ! [A: $tType,N: nat,M: nat,X: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N @ M ) @ X )
      = ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ M @ X ) ) ) ).

% replicate_add
thf(fact_6432_remove1__append,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] :
      ( ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs2 @ Ys ) )
          = ( append @ A @ ( remove1 @ A @ X @ Xs2 ) @ Ys ) ) )
      & ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( remove1 @ A @ X @ ( append @ A @ Xs2 @ Ys ) )
          = ( append @ A @ Xs2 @ ( remove1 @ A @ X @ Ys ) ) ) ) ) ).

% remove1_append
thf(fact_6433_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_6434_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_6435_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_6436_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_6437_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_6438_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( A4
                = ( sup_sup @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_6439_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_6440_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_6441_remdups__append2,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs2 @ ( remdups @ A @ Ys ) ) )
      = ( remdups @ A @ ( append @ A @ Xs2 @ Ys ) ) ) ).

% remdups_append2
thf(fact_6442_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2 = Ys )
     => ( Xs2
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) ).

% eq_Nil_appendI
thf(fact_6443_append_Oleft__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A2 )
      = A2 ) ).

% append.left_neutral
thf(fact_6444_append__Nil,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% append_Nil
thf(fact_6445_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs2 @ Ys )
        = ( append @ A @ Ys @ Xs2 ) )
     => ? [M4: nat,N3: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M4 @ Zs2 ) )
            = Xs2 )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
            = Ys ) ) ) ).

% comm_append_are_replicate
thf(fact_6446_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A] :
          ( ( ( sup_sup @ A @ X @ Y2 )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y2 ) ) ) ).

% sup_shunt
thf(fact_6447_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y2 ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y2 ) @ Z2 ) ) ) ) ).

% shunt1
thf(fact_6448_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y2 ) ) @ Z2 )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y2 @ Z2 ) ) ) ) ).

% shunt2
thf(fact_6449_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P2: A,Q2: A,R: A] :
          ( ( ord_less_eq @ A @ P2 @ ( sup_sup @ A @ Q2 @ R ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P2 @ ( uminus_uminus @ A @ Q2 ) ) @ R ) ) ) ).

% sup_neg_inf
thf(fact_6450_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B4: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B4 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_6451_same__length__different,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2 != Ys )
     => ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ? [Pre: list @ A,X5: A,Xs4: list @ A,Y4: A,Ys5: list @ A] :
            ( ( X5 != Y4 )
            & ( Xs2
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X5 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ Ys5 ) ) ) ) ) ) ).

% same_length_different
thf(fact_6452_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs3: list @ A,Ys4: list @ A,Zs2: list @ A,Y4: A] :
          ( Ws
          = ( append @ A @ Xs3 @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ ( append @ A @ Ys4 @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_6453_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list @ A] :
      ( ( ~ ( distinct @ A @ As3 ) )
      = ( ? [Xs: list @ A,Y: A,Ys3: list @ A] :
            ( ( member @ A @ Y @ ( set2 @ A @ Xs ) )
            & ( distinct @ A @ Xs )
            & ( As3
              = ( append @ A @ Xs @ ( cons @ A @ Y @ Ys3 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_6454_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U2 ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_6455_replicate__append__same,axiom,
    ! [A: $tType,I2: nat,X: A] :
      ( ( append @ A @ ( replicate @ A @ I2 @ X ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( replicate @ A @ I2 @ X ) ) ) ).

% replicate_append_same
thf(fact_6456_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L2 ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) )
            = ( set_ord_lessThan @ A @ U2 ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_6457_card__Un__le,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ).

% card_Un_le
thf(fact_6458_list__update__append1,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ I2 @ X )
        = ( append @ A @ ( list_update @ A @ Xs2 @ I2 @ X ) @ Ys ) ) ) ).

% list_update_append1
thf(fact_6459_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U2 ) )
              = ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_6460_remove1__split,axiom,
    ! [A: $tType,A2: A,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ A @ A2 @ ( set2 @ A @ Xs2 ) )
     => ( ( ( remove1 @ A @ A2 @ Xs2 )
          = Ys )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs2
                = ( append @ A @ Ls @ ( cons @ A @ A2 @ Rs ) ) )
              & ~ ( member @ A @ A2 @ ( set2 @ A @ Ls ) )
              & ( Ys
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_6461_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L2 ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) )
            = ( set_ord_atMost @ A @ U2 ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_6462_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs2 ) )
      = ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_6463_nths__append,axiom,
    ! [A: $tType,L2: list @ A,L3: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( append @ A @ L2 @ L3 ) @ A3 )
      = ( append @ A @ ( nths @ A @ L2 @ A3 )
        @ ( nths @ A @ L3
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( plus_plus @ nat @ J3 @ ( size_size @ ( list @ A ) @ L2 ) ) @ A3 ) ) ) ) ) ).

% nths_append
thf(fact_6464_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: A,Ys: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs2 ) @ Ys ) ) ) ) ).

% shuffles.simps(3)
thf(fact_6465_Inter__Un__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B4: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B4 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B4 ) ) ) ).

% Inter_Un_subset
thf(fact_6466_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( suc @ N ) )
      = ( ? [Y: A,Ys3: list @ A] :
            ( ( Xs2
              = ( append @ A @ Ys3 @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_6467_length__append__singleton,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% length_append_singleton
thf(fact_6468_nth__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ N )
          = ( nth @ A @ Xs2 @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( nth @ A @ ( append @ A @ Xs2 @ Ys ) @ N )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nth_append
thf(fact_6469_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U2 ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_6470_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_6471_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_6472_card__Un__Int,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_6473_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A,Ys: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ N @ X )
          = ( append @ A @ ( list_update @ A @ Xs2 @ N @ X ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ( list_update @ A @ ( append @ A @ Xs2 @ Ys ) @ N @ X )
          = ( append @ A @ Xs2 @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_6474_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U2 ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_6475_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U2 ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_6476_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L2 ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) )
            = ( set_ord_atMost @ A @ U2 ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_6477_listrel1I,axiom,
    ! [A: $tType,X: A,Y2: A,R: set @ ( product_prod @ A @ A ),Xs2: list @ A,Us: list @ A,Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R )
     => ( ( Xs2
          = ( append @ A @ Us @ ( cons @ A @ X @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y2 @ Vs ) ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% listrel1I
thf(fact_6478_listrel1E,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) )
     => ~ ! [X5: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y4 ) @ R )
           => ! [Us3: list @ A,Vs2: list @ A] :
                ( ( Xs2
                  = ( append @ A @ Us3 @ ( cons @ A @ X5 @ Vs2 ) ) )
               => ( Ys
                 != ( append @ A @ Us3 @ ( cons @ A @ Y4 @ Vs2 ) ) ) ) ) ) ).

% listrel1E
thf(fact_6479_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U2 ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_6480_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L2 ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) )
            = ( set_ord_lessThan @ A @ U2 ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_6481_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U2 ) )
              = ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_6482_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B4: A] :
          ( ( sup_sup @ A @ A3
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X2: nat] : B4
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A3 @ B4 ) ) ) ).

% SUP_nat_binary
thf(fact_6483_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs: list @ A,Ys3: list @ A] :
                ? [Us2: list @ A,Z: A,Z6: A,Vs3: list @ A] :
                  ( ( Xs
                    = ( append @ A @ Us2 @ ( cons @ A @ Z @ Vs3 ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z @ Z6 ) @ R5 )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z6 @ Vs3 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_6484_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X2: A,Y: A] : ( ord_less_eq @ A @ Y @ X2 )
        @ ^ [X2: A,Y: A] : ( ord_less @ A @ Y @ X2 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_6485_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( G @ X5 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_6486_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_6487_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_6488_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( G @ X5 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_6489_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B4 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B4 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_6490_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) @ ( insert @ A @ U2 @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_6491_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_6492_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A3: set @ A,B4: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_6493_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B4 @ A3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_6494_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B4 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_6495_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Ys: list @ A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( X = Y2 ) )
        | ( ( Xs2 = Ys )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_6496_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs2: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs2 @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs2 ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs2 ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_6497_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L2 @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) )
            = ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_6498_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ M )
         => ( ( ord_less @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U2 ) )
              = ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_6499_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L2 @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) )
            = ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_6500_sum__Un__nat,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B4 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B4 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_6501_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,M: A,U2: A] :
          ( ( ord_less @ A @ L2 @ M )
         => ( ( ord_less_eq @ A @ M @ U2 )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U2 ) )
              = ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_6502_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) @ ( insert @ A @ U2 @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_6503_nths__Cons,axiom,
    ! [A: $tType,X: A,L2: list @ A,A3: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L2 ) @ A3 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L2
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( suc @ J3 ) @ A3 ) ) ) ) ) ).

% nths_Cons
thf(fact_6504_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs2 @ Ys )
            = ( append @ A @ Ys @ Xs2 ) )
         => ? [N3: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N3 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N3 @ Zs2 ) )
                = ( append @ A @ Xs2 @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_6505_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A3: set @ B,B4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B4 )
           => ( ! [X5: B] :
                  ( ( member @ B @ X5 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) )
                 => ( ( F2 @ X5 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B4 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B4 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B4 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_6506_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_6507_shuffles_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y2: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X @ Xa2 )
        = Y2 )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y2
           != ( insert @ ( list @ A ) @ Xa2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ( Y2
             != ( insert @ ( list @ A ) @ X @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X5: A,Xs3: list @ A] :
                ( ( X
                  = ( cons @ A @ X5 @ Xs3 ) )
               => ! [Y4: A,Ys4: list @ A] :
                    ( ( Xa2
                      = ( cons @ A @ Y4 @ Ys4 ) )
                   => ( Y2
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 ) @ ( shuffles @ A @ Xs3 @ ( cons @ A @ Y4 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y4 ) @ ( shuffles @ A @ ( cons @ A @ X5 @ Xs3 ) @ Ys4 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_6508_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) ) )
     => ( ( shuffles @ A @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) )
        = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X @ Xs2 ) @ Ys ) ) ) ) ) ).

% shuffles.psimps(3)
thf(fact_6509_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N2: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs )
                    = N2 )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N2 )
                  & ? [Xys: list @ A,X2: A,Y: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs
                        = ( append @ A @ Xys @ ( cons @ A @ X2 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y @ Ys7 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_6510_these__insert__Some,axiom,
    ! [A: $tType,X: A,A3: set @ ( option @ A )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( some @ A @ X ) @ A3 ) )
      = ( insert @ A @ X @ ( these @ A @ A3 ) ) ) ).

% these_insert_Some
thf(fact_6511_these__image__Some__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( these @ A @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) )
      = A3 ) ).

% these_image_Some_eq
thf(fact_6512_these__insert__None,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( none @ A ) @ A3 ) )
      = ( these @ A @ A3 ) ) ).

% these_insert_None
thf(fact_6513_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R2 )
        @ ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ S2 ) )
      = ( ^ [X2: A,Y: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S2 ) ) ) ) ).

% sup_Un_eq2
thf(fact_6514_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_6515_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_6516_in__these__eq,axiom,
    ! [A: $tType,X: A,A3: set @ ( option @ A )] :
      ( ( member @ A @ X @ ( these @ A @ A3 ) )
      = ( member @ ( option @ A ) @ ( some @ A @ X ) @ A3 ) ) ).

% in_these_eq
thf(fact_6517_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_6518_atLeastLessThan__add__Un,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I2 @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I2 @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_6519_lexn__length,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lexn @ A @ R @ N ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = N )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N ) ) ) ).

% lexn_length
thf(fact_6520_Option_Othese__def,axiom,
    ! [A: $tType] :
      ( ( these @ A )
      = ( ^ [A7: set @ ( option @ A )] :
            ( image @ ( option @ A ) @ A @ ( the2 @ A )
            @ ( collect @ ( option @ A )
              @ ^ [X2: option @ A] :
                  ( ( member @ ( option @ A ) @ X2 @ A7 )
                  & ( X2
                   != ( none @ A ) ) ) ) ) ) ) ).

% Option.these_def
thf(fact_6521_Pow__set_I2_J,axiom,
    ! [B: $tType,X: B,Xs2: list @ B] :
      ( ( pow2 @ B @ ( set2 @ B @ ( cons @ B @ X @ Xs2 ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow2 @ B @ ( set2 @ B @ Xs2 ) ) @ ( image @ ( set @ B ) @ ( set @ B ) @ ( insert @ B @ X ) @ ( pow2 @ B @ ( set2 @ B @ Xs2 ) ) ) ) ) ).

% Pow_set(2)
thf(fact_6522_these__empty__eq,axiom,
    ! [A: $tType,B4: set @ ( option @ A )] :
      ( ( ( these @ A @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( B4
          = ( bot_bot @ ( set @ ( option @ A ) ) ) )
        | ( B4
          = ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_empty_eq
thf(fact_6523_these__not__empty__eq,axiom,
    ! [A: $tType,B4: set @ ( option @ A )] :
      ( ( ( ( these @ A @ B4 )
         != ( bot_bot @ ( set @ A ) ) ) )
      = ( ( B4
         != ( bot_bot @ ( set @ ( option @ A ) ) ) )
        & ( B4
         != ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_not_empty_eq
thf(fact_6524_Some__image__these__eq,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( these @ A @ A3 ) )
      = ( collect @ ( option @ A )
        @ ^ [X2: option @ A] :
            ( ( member @ ( option @ A ) @ X2 @ A3 )
            & ( X2
             != ( none @ A ) ) ) ) ) ).

% Some_image_these_eq
thf(fact_6525_list__encode_Oelims,axiom,
    ! [X: list @ nat,Y2: nat] :
      ( ( ( nat_list_encode @ X )
        = Y2 )
     => ( ( ( X
            = ( nil @ nat ) )
         => ( Y2
           != ( zero_zero @ nat ) ) )
       => ~ ! [X5: nat,Xs3: list @ nat] :
              ( ( X
                = ( cons @ nat @ X5 @ Xs3 ) )
             => ( Y2
               != ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X5 @ ( nat_list_encode @ Xs3 ) ) ) ) ) ) ) ) ).

% list_encode.elims
thf(fact_6526_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys: list @ A,X2: A,Y: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs
                        = ( append @ A @ Xys @ ( cons @ A @ X2 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y @ Ys7 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_6527_Cons__in__lex,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Y2: A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( lex @ A @ R ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R )
          & ( ( size_size @ ( list @ A ) @ Xs2 )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X = Y2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lex @ A @ R ) ) ) ) ) ).

% Cons_in_lex
thf(fact_6528_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) @ ( lex @ A @ R ) ) ).

% Nil2_notin_lex
thf(fact_6529_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) @ ( lex @ A @ R ) ) ).

% Nil_notin_lex
thf(fact_6530_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A ),Xs2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) @ ( append @ A @ Xs2 @ Zs ) ) @ ( lex @ A @ R ) ) ) ).

% lex_append_leftI
thf(fact_6531_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_6532_lex__append__left__iff,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) @ ( append @ A @ Xs2 @ Zs ) ) @ ( lex @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_left_iff
thf(fact_6533_lex__append__leftD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) @ ( append @ A @ Xs2 @ Zs ) ) @ ( lex @ A @ R ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_leftD
thf(fact_6534_lex__append__rightI,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R ) ) ) ) ).

% lex_append_rightI
thf(fact_6535_list__encode_Osimps_I2_J,axiom,
    ! [X: nat,Xs2: list @ nat] :
      ( ( nat_list_encode @ ( cons @ nat @ X @ Xs2 ) )
      = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X @ ( nat_list_encode @ Xs2 ) ) ) ) ) ).

% list_encode.simps(2)
thf(fact_6536_list__encode_Opelims,axiom,
    ! [X: list @ nat,Y2: nat] :
      ( ( ( nat_list_encode @ X )
        = Y2 )
     => ( ( accp @ ( list @ nat ) @ nat_list_encode_rel @ X )
       => ( ( ( X
              = ( nil @ nat ) )
           => ( ( Y2
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( nil @ nat ) ) ) )
         => ~ ! [X5: nat,Xs3: list @ nat] :
                ( ( X
                  = ( cons @ nat @ X5 @ Xs3 ) )
               => ( ( Y2
                    = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X5 @ ( nat_list_encode @ Xs3 ) ) ) ) )
                 => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( cons @ nat @ X5 @ Xs3 ) ) ) ) ) ) ) ).

% list_encode.pelims
thf(fact_6537_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ Js @ ( upto_aux @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) @ ( cons @ int @ J3 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_6538_upto_Opelims,axiom,
    ! [X: int,Xa2: int,Y2: list @ int] :
      ( ( ( upto @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa2 )
               => ( Y2
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa2 )
               => ( Y2
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa2 ) ) ) ) ) ).

% upto.pelims
thf(fact_6539_upto_Opsimps,axiom,
    ! [I2: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J ) )
     => ( ( ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I2 @ J )
         => ( ( upto @ I2 @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_6540_upto__Nil,axiom,
    ! [I2: int,J: int] :
      ( ( ( upto @ I2 @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil
thf(fact_6541_upto__Nil2,axiom,
    ! [I2: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I2 @ J ) )
      = ( ord_less @ int @ J @ I2 ) ) ).

% upto_Nil2
thf(fact_6542_upto__empty,axiom,
    ! [J: int,I2: int] :
      ( ( ord_less @ int @ J @ I2 )
     => ( ( upto @ I2 @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_6543_upto__single,axiom,
    ! [I2: int] :
      ( ( upto @ I2 @ I2 )
      = ( cons @ int @ I2 @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_6544_nth__upto,axiom,
    ! [I2: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I2 @ J ) @ K )
        = ( plus_plus @ int @ I2 @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_6545_length__upto,axiom,
    ! [I2: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I2 @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I2 ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_6546_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_6547_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_6548_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_6549_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_6550_upto__code,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( upto_aux @ I4 @ J3 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_6551_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int] : ( append @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% upto_aux_def
thf(fact_6552_distinct__upto,axiom,
    ! [I2: int,J: int] : ( distinct @ int @ ( upto @ I2 @ J ) ) ).

% distinct_upto
thf(fact_6553_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_6554_upto__split2,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_6555_upto__split1,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_6556_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_6557_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_6558_upto__rec1,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( cons @ int @ I2 @ ( upto @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_6559_upto_Osimps,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I4 @ J3 ) @ ( cons @ int @ I4 @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_6560_upto_Oelims,axiom,
    ! [X: int,Xa2: int,Y2: list @ int] :
      ( ( ( upto @ X @ Xa2 )
        = Y2 )
     => ( ( ( ord_less_eq @ int @ X @ Xa2 )
         => ( Y2
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa2 )
         => ( Y2
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_6561_upto__rec2,axiom,
    ! [I2: int,J: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( upto @ I2 @ J )
        = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_6562_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_6563_upto__split3,axiom,
    ! [I2: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I2 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I2 @ K )
          = ( append @ int @ ( upto @ I2 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_6564_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_6565_splice_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [X5: A,Xs3: list @ A,Ys4: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Ys4 ) )
             => ( ( P @ Ys4 @ Xs3 )
               => ( P @ ( cons @ A @ X5 @ Xs3 ) @ Ys4 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) ).

% splice.pinduct
thf(fact_6566_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_6567_lenlex__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs2: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Xs2 ) @ ( lenlex @ A @ R ) ) ) ).

% lenlex_irreflexive
thf(fact_6568_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R ) ) ).

% Nil_lenlex_iff2
thf(fact_6569_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_6570_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs2: list @ A,R2: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs2 ) @ ( lenlex @ A @ R2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs2 @ Ys ) ) @ ( lenlex @ A @ R2 ) ) ) ) ).

% lenlex_append1
thf(fact_6571_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N: A,Ns: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N ) @ R ) )
        | ( ( M = N )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_6572_splice_Opelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y2: list @ A] :
      ( ( ( splice @ A @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Xa2 ) )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y2 = Xa2 )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa2 ) ) ) )
         => ~ ! [X5: A,Xs3: list @ A] :
                ( ( X
                  = ( cons @ A @ X5 @ Xs3 ) )
               => ( ( Y2
                    = ( cons @ A @ X5 @ ( splice @ A @ Xa2 @ Xs3 ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Xa2 ) ) ) ) ) ) ) ).

% splice.pelims
thf(fact_6573_extract__SomeE,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,Ys: list @ A,Y2: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs2 )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs ) ) ) )
     => ( ( Xs2
          = ( append @ A @ Ys @ ( cons @ A @ Y2 @ Zs ) ) )
        & ( P @ Y2 )
        & ~ ? [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
              & ( P @ X3 ) ) ) ) ).

% extract_SomeE
thf(fact_6574_split__Nil__iff,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( splice @ A @ Xs2 @ Ys )
        = ( nil @ A ) )
      = ( ( Xs2
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% split_Nil_iff
thf(fact_6575_splice__Nil2,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( splice @ A @ Xs2 @ ( nil @ A ) )
      = Xs2 ) ).

% splice_Nil2
thf(fact_6576_splice__in__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] : ( member @ ( list @ A ) @ ( splice @ A @ Xs2 @ Ys ) @ ( shuffles @ A @ Xs2 @ Ys ) ) ).

% splice_in_shuffles
thf(fact_6577_length__splice,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( splice @ A @ Xs2 @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_splice
thf(fact_6578_splice__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N: nat] :
      ( ( splice @ A @ ( replicate @ A @ M @ X ) @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ ( plus_plus @ nat @ M @ N ) @ X ) ) ).

% splice_replicate
thf(fact_6579_extract__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( extract @ A @ P @ Xs2 )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
              & ( P @ X2 ) ) ) ) ).

% extract_None_iff
thf(fact_6580_splice_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] :
      ( ( splice @ A @ ( cons @ A @ X @ Xs2 ) @ Ys )
      = ( cons @ A @ X @ ( splice @ A @ Ys @ Xs2 ) ) ) ).

% splice.simps(2)
thf(fact_6581_splice_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( splice @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% splice.simps(1)
thf(fact_6582_extract__Nil__code,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( extract @ A @ P @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_6583_splice_Oelims,axiom,
    ! [A: $tType,X: list @ A,Xa2: list @ A,Y2: list @ A] :
      ( ( ( splice @ A @ X @ Xa2 )
        = Y2 )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y2 != Xa2 ) )
       => ~ ! [X5: A,Xs3: list @ A] :
              ( ( X
                = ( cons @ A @ X5 @ Xs3 ) )
             => ( Y2
               != ( cons @ A @ X5 @ ( splice @ A @ Xa2 @ Xs3 ) ) ) ) ) ) ).

% splice.elims
thf(fact_6584_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ( ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X @ Xs2 ) ) ) ) )
      & ( ~ ( P @ X )
       => ( ( extract @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys3: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X @ Ys3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P @ Xs2 ) ) ) ) ) ).

% extract_Cons_code
thf(fact_6585_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ Ys ) )
     => ( ( splice @ A @ ( cons @ A @ X @ Xs2 ) @ Ys )
        = ( cons @ A @ X @ ( splice @ A @ Ys @ Xs2 ) ) ) ) ).

% splice.psimps(2)
thf(fact_6586_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( splice @ A @ ( nil @ A ) @ Ys )
        = Ys ) ) ).

% splice.psimps(1)
thf(fact_6587_extract__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,Ys: list @ A,Y2: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs2 )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs ) ) ) )
      = ( ( Xs2
          = ( append @ A @ Ys @ ( cons @ A @ Y2 @ Zs ) ) )
        & ( P @ Y2 )
        & ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
              & ( P @ X2 ) ) ) ) ).

% extract_Some_iff
thf(fact_6588_DERIV__even__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
       => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_6589_DERIV__real__root__generic,axiom,
    ! [N: nat,X: real,D5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( D5
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
             => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
               => ( D5
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
               => ( D5
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N ) @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_6590_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa2: A] :
          ( has_field_derivative @ A
          @ ^ [X2: A] : ( cos @ A @ ( plus_plus @ A @ X2 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa2 @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_6591_DERIV__local__const,axiom,
    ! [F2: real > real,L2: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y4: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D2 )
             => ( ( F2 @ X )
                = ( F2 @ Y4 ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_6592_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H6 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_6593_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H6 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_6594_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H6 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_6595_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L2: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( ord_less @ real @ H6 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H6 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_6596_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L2: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H6 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_6597_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L2: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H6 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_6598_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L2: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H6 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_6599_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L2: real,X: real,S2: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ S2 ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H6 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H6 ) @ S2 )
                 => ( ( ord_less @ real @ H6 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H6 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_6600_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ E5 ) @ ( times_times @ A @ D5 @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult'
thf(fact_6601_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,X: A,S: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X ) ) @ ( times_times @ A @ Db @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_mult
thf(fact_6602_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D5 @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ E5 ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_6603_field__differentiable__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,F4: filter @ A,G: A > A,G6: A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ F4 )
         => ( ( has_field_derivative @ A @ G @ G6 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z: A] : ( minus_minus @ A @ ( F2 @ Z ) @ ( G @ Z ) )
              @ ( minus_minus @ A @ F8 @ G6 )
              @ F4 ) ) ) ) ).

% field_differentiable_diff
thf(fact_6604_DERIV__diff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( minus_minus @ A @ D5 @ E5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_diff
thf(fact_6605_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
            @ ( times_times @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult_right
thf(fact_6606_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
            @ ( times_times @ A @ C2 @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cmult
thf(fact_6607_has__field__derivative__sinh,axiom,
    ! [A16: $tType] :
      ( ( ( real_Vector_banach @ A16 )
        & ( real_V3459762299906320749_field @ A16 ) )
     => ! [G: A16 > A16,Db: A16,X: A16,S: set @ A16] :
          ( ( has_field_derivative @ A16 @ G @ Db @ ( topolo174197925503356063within @ A16 @ X @ S ) )
         => ( has_field_derivative @ A16
            @ ^ [X2: A16] : ( sinh @ A16 @ ( G @ X2 ) )
            @ ( times_times @ A16 @ ( cosh @ A16 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A16 @ X @ S ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_6608_has__field__derivative__cosh,axiom,
    ! [A16: $tType] :
      ( ( ( real_Vector_banach @ A16 )
        & ( real_V3459762299906320749_field @ A16 ) )
     => ! [G: A16 > A16,Db: A16,X: A16,S: set @ A16] :
          ( ( has_field_derivative @ A16 @ G @ Db @ ( topolo174197925503356063within @ A16 @ X @ S ) )
         => ( has_field_derivative @ A16
            @ ^ [X2: A16] : ( cosh @ A16 @ ( G @ X2 ) )
            @ ( times_times @ A16 @ ( sinh @ A16 @ ( G @ X ) ) @ Db )
            @ ( topolo174197925503356063within @ A16 @ X @ S ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_6609_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ C2 )
            @ ( divide_divide @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_cdivide
thf(fact_6610_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X: A,S: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ).

% DERIV_cmult_Id
thf(fact_6611_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ D5 ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_6612_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( plus_plus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( plus_plus @ A @ D5 @ E5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_add
thf(fact_6613_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,F4: filter @ A,G: A > A,G6: A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ F4 )
         => ( ( has_field_derivative @ A @ G @ G6 @ F4 )
           => ( has_field_derivative @ A
              @ ^ [Z: A] : ( plus_plus @ A @ ( F2 @ Z ) @ ( G @ Z ) )
              @ ( plus_plus @ A @ F8 @ G6 )
              @ F4 ) ) ) ) ).

% field_differentiable_add
thf(fact_6614_DERIV__ident,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X2: A] : X2
          @ ( one_one @ A )
          @ F4 ) ) ).

% DERIV_ident
thf(fact_6615_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain
thf(fact_6616_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,X: A,Z2: A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ X2 @ Z2 ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_6617_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X5: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_6618_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X5: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ real @ B2 @ A2 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_6619_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( exp @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_6620_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( sin @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_6621_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ ( F2 @ X ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
              @ ( times_times @ A @ E5 @ D5 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain'
thf(fact_6622_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,Db: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_chain2
thf(fact_6623_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G6: A > A,F2: A > A,F8: A,X: A] :
          ( ! [X5: A] : ( has_field_derivative @ A @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
              @ ( times_times @ A @ F8 @ ( G6 @ ( F2 @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_6624_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S: set @ A,G: A > A,G6: A > A,F2: A > A,F8: A,X: A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ S )
             => ( has_field_derivative @ A @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F2 @ X ) @ S )
             => ( has_field_derivative @ A
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( times_times @ A @ F8 @ ( G6 @ ( F2 @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_6625_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( cos @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_6626_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y3 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y3 ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_6627_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y3 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y3 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_6628_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G6: real > real] :
      ( ! [X5: real] :
          ( ( member @ real @ X5 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G6 @ X5 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_6629_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,T2: set @ A,X: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X @ S ) @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ).

% at_le
thf(fact_6630_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_6631_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,X: A,S: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_6632_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z5: real] :
            ( ( ord_less @ real @ A2 @ Z5 )
            & ( ord_less @ real @ Z5 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F8 @ Z5 ) ) ) ) ) ) ).

% MVT2
thf(fact_6633_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y3 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y3 ) ) ) )
       => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_6634_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ord_less_eq @ real @ A2 @ X5 )
           => ( ( ord_less_eq @ real @ X5 @ B2 )
             => ? [Y3: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y3 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y3 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_6635_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,Z2: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z2 @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z2 ) @ S2 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ Z2 @ X2 ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_6636_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,Z2: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z2 @ X ) @ ( image @ A @ A @ ( plus_plus @ A @ Z2 ) @ S2 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ ( plus_plus @ A @ Z2 ) ) @ Y2 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_6637_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X: A,S: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X ) @ ( image @ A @ A @ G @ S ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_6638_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( power_power @ A @ ( F2 @ X2 ) @ ( suc @ N ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power_Suc
thf(fact_6639_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X5: real] : ( has_field_derivative @ real @ V @ K @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V @ A2 ) @ ( V @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_6640_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_inverse
thf(fact_6641_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( power_power @ A @ ( F2 @ X2 ) @ N )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% DERIV_power
thf(fact_6642_DERIV__local__max,axiom,
    ! [F2: real > real,L2: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y4: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ Y4 ) @ ( F2 @ X ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_6643_DERIV__local__min,axiom,
    ! [F2: real > real,L2: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y4: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y4 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ X ) @ ( F2 @ Y4 ) ) )
         => ( L2
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_6644_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_6645_DERIV__pow,axiom,
    ! [N: nat,X: real,S: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X2: real] : ( power_power @ real @ X2 @ N )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X @ S ) ) ).

% DERIV_pow
thf(fact_6646_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y4: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y4 @ N2 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
            @ ( suminf @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_6647_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo174197925503356063within @ A @ X @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_6648_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X: real,N: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X2: real] : ( power_power @ real @ ( G @ X2 ) @ N )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( G @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_6649_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_6650_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A,G: A > A,E: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( has_field_derivative @ A @ G @ E @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y: A] : ( divide_divide @ A @ ( F2 @ Y ) @ ( G @ Y ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X ) ) @ ( times_times @ A @ E @ ( F2 @ X ) ) ) @ ( power_power @ A @ ( G @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_6651_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_6652_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F2: A > A,F8: A,Z2: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z5 ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z5 @ N2 ) )
                @ ( F2 @ Z5 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
             => ( sums @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) )
                @ F8 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_6653_has__real__derivative__powr,axiom,
    ! [Z2: real,R: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z2 )
     => ( has_field_derivative @ real
        @ ^ [Z: real] : ( powr @ real @ Z @ R )
        @ ( times_times @ real @ R @ ( powr @ real @ Z2 @ ( minus_minus @ real @ R @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_6654_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
           => ( ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X2: A] :
                      ( suminf @ A
                      @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
                  @ ( suminf @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_6655_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ X @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_6656_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z2: A] :
          ( ! [Z5: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z5 ) @ K5 )
             => ( summable @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z5 @ N2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z2 ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) )
              @ ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N2 ) @ ( power_power @ A @ Z2 @ N2 ) ) )
              @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_6657_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_6658_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X: real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( has_field_derivative @ real
          @ ^ [X2: real] : ( powr @ real @ ( G @ X2 ) @ R )
          @ ( times_times @ real @ ( times_times @ real @ R @ ( powr @ real @ ( G @ X ) @ ( minus_minus @ real @ R @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_6659_DERIV__powr,axiom,
    ! [G: real > real,M: real,X: real,F2: real > real,R: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( ( has_field_derivative @ real @ F2 @ R @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X2: real] : ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ R @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_6660_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_6661_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_6662_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F8: real > nat > real,X0: real,A2: real,B2: real,L6: nat > real] :
      ( ! [N3: nat] :
          ( has_field_derivative @ real
          @ ^ [X2: real] : ( F2 @ X2 @ N3 )
          @ ( F8 @ X0 @ N3 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X5 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F8 @ X0 ) )
           => ( ( summable @ real @ L6 )
             => ( ! [N3: nat,X5: real,Y4: real] :
                    ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y4 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X5 @ N3 ) @ ( F2 @ Y4 @ N3 ) ) ) @ ( times_times @ real @ ( L6 @ N3 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X5 @ Y4 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X2: real] : ( suminf @ real @ ( F2 @ X2 ) )
                  @ ( suminf @ real @ ( F8 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_6663_DERIV__arctan,axiom,
    ! [X: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_6664_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_6665_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_6666_has__field__derivative__tanh,axiom,
    ! [A16: $tType] :
      ( ( ( real_Vector_banach @ A16 )
        & ( real_V3459762299906320749_field @ A16 ) )
     => ! [G: A16 > A16,X: A16,Db: A16,S: set @ A16] :
          ( ( ( cosh @ A16 @ ( G @ X ) )
           != ( zero_zero @ A16 ) )
         => ( ( has_field_derivative @ A16 @ G @ Db @ ( topolo174197925503356063within @ A16 @ X @ S ) )
           => ( has_field_derivative @ A16
              @ ^ [X2: A16] : ( tanh @ A16 @ ( G @ X2 ) )
              @ ( times_times @ A16 @ ( minus_minus @ A16 @ ( one_one @ A16 ) @ ( power_power @ A16 @ ( tanh @ A16 @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A16 @ X @ S ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_6667_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D5: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( D5
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
           => ( D5
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_6668_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_6669_artanh__real__has__field__derivative,axiom,
    ! [X: real,A3: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A3 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_6670_DERIV__power__series_H,axiom,
    ! [R2: real,F2: nat > real,X0: real] :
      ( ! [X5: real] :
          ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R2 ) @ R2 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X5 @ N2 ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R2 ) @ R2 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( has_field_derivative @ real
            @ ^ [X2: real] :
                ( suminf @ real
                @ ^ [N2: nat] : ( times_times @ real @ ( F2 @ N2 ) @ ( power_power @ real @ X2 @ ( suc @ N2 ) ) ) )
            @ ( suminf @ real
              @ ^ [N2: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) @ ( power_power @ real @ X0 @ N2 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_6671_DERIV__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_6672_DERIV__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_6673_DERIV__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_6674_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,X5: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T6: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_6675_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M4: nat,X5: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T6: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
          & ( ( F2 @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_6676_DERIV__odd__real__root,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_6677_Maclaurin,axiom,
    ! [H2: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T6: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
                  & ( ord_less_eq @ real @ T6 @ H2 ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T6 )
                & ( ord_less @ real @ T6 @ H2 )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_6678_Maclaurin2,axiom,
    ! [H2: real,Diff: nat > real > real,F2: real > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T6: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
                & ( ord_less_eq @ real @ T6 @ H2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T6 )
              & ( ord_less_eq @ real @ T6 @ H2 )
              & ( ( F2 @ H2 )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                    @ ( set_ord_lessThan @ nat @ N ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_6679_Maclaurin__minus,axiom,
    ! [H2: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T6: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ H2 @ T6 )
                  & ( ord_less_eq @ real @ T6 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T6: real] :
                ( ( ord_less @ real @ H2 @ T6 )
                & ( ord_less @ real @ T6 @ ( zero_zero @ real ) )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_6680_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( X
           != ( zero_zero @ real ) )
         => ( ! [M4: nat,X5: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T6 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
                & ( ( F2 @ X )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_6681_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,T6: real] :
            ( ( ( ord_less @ nat @ M4 @ N )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T6: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T6 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_6682_Taylor,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T6: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T6 )
                & ( ord_less_eq @ real @ T6 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X )
               => ( ( ord_less_eq @ real @ X @ B2 )
                 => ( ( X != C2 )
                   => ? [T6: real] :
                        ( ( ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ X @ T6 )
                            & ( ord_less @ real @ T6 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ C2 @ T6 )
                            & ( ord_less @ real @ T6 @ X ) ) )
                        & ( ( F2 @ X )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ M3 ) )
                              @ ( set_ord_lessThan @ nat @ N ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_6683_Taylor__up,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T6: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T6 )
                & ( ord_less_eq @ real @ T6 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T6: real] :
                  ( ( ord_less @ real @ C2 @ T6 )
                  & ( ord_less @ real @ T6 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_6684_Taylor__down,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T6: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T6 )
                & ( ord_less_eq @ real @ T6 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T6: real] :
                  ( ( ord_less @ real @ A2 @ T6 )
                  & ( ord_less @ real @ T6 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T6 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_6685_Maclaurin__lemma2,axiom,
    ! [N: nat,H2: real,Diff: nat > real > real,K: nat,B4: real] :
      ( ! [M4: nat,T6: real] :
          ( ( ( ord_less @ nat @ M4 @ N )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T6 )
            & ( ord_less_eq @ real @ T6 @ H2 ) )
         => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T6 ) @ ( topolo174197925503356063within @ real @ T6 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N
          = ( suc @ K ) )
       => ! [M2: nat,T8: real] :
            ( ( ( ord_less @ nat @ M2 @ N )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H2 ) )
           => ( has_field_derivative @ real
              @ ^ [U3: real] :
                  ( minus_minus @ real @ ( Diff @ M2 @ U3 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P5: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M2 @ P5 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ real @ U3 @ P5 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ M2 ) ) )
                    @ ( times_times @ real @ B4 @ ( divide_divide @ real @ ( power_power @ real @ U3 @ ( minus_minus @ nat @ N @ M2 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M2 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P5: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M2 ) @ P5 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ real @ T8 @ P5 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) )
                  @ ( times_times @ real @ B4 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_6686_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X9: real] :
            ( suminf @ real
            @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X9 @ ( plus_plus @ nat @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K2 ) @ ( power_power @ real @ X @ ( times_times @ nat @ K2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_6687_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( arcsin @ ( G @ X2 ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_6688_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( arccos @ ( G @ X2 ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_6689_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F5: A > A,D7: A] : ( has_derivative @ A @ A @ F5 @ ( times_times @ A @ D7 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_6690_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A > A,F4: filter @ A,D8: A] :
          ( ( has_derivative @ A @ A @ F2 @ D5 @ F4 )
         => ( ! [X5: A] :
                ( ( times_times @ A @ X5 @ D8 )
                = ( D5 @ X5 ) )
           => ( has_field_derivative @ A @ F2 @ D8 @ F4 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_6691_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,F4: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ F4 )
         => ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ F4 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_6692_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: D > real,F8: D > real,X: D,S: set @ D,G: D > C,G6: D > C] :
          ( ( has_derivative @ D @ real @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ C @ G @ G6 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ C
              @ ^ [X2: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ^ [H: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F2 @ X ) @ ( G6 @ H ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F8 @ H ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_6693_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_6694_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,F4: filter @ A,G: A > B,G6: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ F4 )
         => ( ( has_derivative @ A @ B @ G @ G6 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ^ [X2: A] : ( plus_plus @ B @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
              @ F4 ) ) ) ) ).

% has_derivative_add
thf(fact_6695_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G6: C > A,F4: filter @ C,Y2: A] :
          ( ( has_derivative @ C @ A @ G @ G6 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ ( G @ X2 ) @ Y2 )
            @ ^ [X2: C] : ( times_times @ A @ ( G6 @ X2 ) @ Y2 )
            @ F4 ) ) ) ).

% has_derivative_mult_left
thf(fact_6696_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G6: C > A,F4: filter @ C,X: A] :
          ( ( has_derivative @ C @ A @ G @ G6 @ F4 )
         => ( has_derivative @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ X @ ( G @ X2 ) )
            @ ^ [X2: C] : ( times_times @ A @ X @ ( G6 @ X2 ) )
            @ F4 ) ) ) ).

% has_derivative_mult_right
thf(fact_6697_has__derivative__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,F4: filter @ A,G: A > B,G6: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ F4 )
         => ( ( has_derivative @ A @ B @ G @ G6 @ F4 )
           => ( has_derivative @ A @ B
              @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ^ [X2: A] : ( minus_minus @ B @ ( F8 @ X2 ) @ ( G6 @ X2 ) )
              @ F4 ) ) ) ) ).

% has_derivative_diff
thf(fact_6698_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F2: D > A,F8: D > A,X: D,S: set @ D,G: D > A,G6: D > A] :
          ( ( has_derivative @ D @ A @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X @ S ) )
         => ( ( has_derivative @ D @ A @ G @ G6 @ ( topolo174197925503356063within @ D @ X @ S ) )
           => ( has_derivative @ D @ A
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ^ [H: D] : ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X ) @ ( G6 @ H ) ) @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ D @ X @ S ) ) ) ) ) ).

% has_derivative_mult
thf(fact_6699_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G: A > B,G6: A > A > B,F2: C > A,S: set @ C,X: C,F8: C > A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ T2 )
             => ( has_derivative @ A @ B @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ A @ X5 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
           => ( ( member @ C @ X @ S )
             => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S ) )
               => ( has_derivative @ C @ B
                  @ ^ [X2: C] : ( G @ ( F2 @ X2 ) )
                  @ ^ [Y: C] : ( G6 @ ( F2 @ X ) @ ( F8 @ Y ) )
                  @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_6700_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( exp @ real @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( exp @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_exp
thf(fact_6701_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( sin @ real @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( cos @ real @ ( G @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sin
thf(fact_6702_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X2: A] : ( cosh @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cosh
thf(fact_6703_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X: A,S: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ A
            @ ^ [X2: A] : ( sinh @ A @ ( G @ X2 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_sinh
thf(fact_6704_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F8: C > A,X: C,S2: set @ C,G: C > A,G6: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G6 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ^ [H: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ ( G6 @ H ) ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_6705_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X: C,F8: C > A,S2: set @ C] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( has_derivative @ C @ A
              @ ^ [X2: C] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ^ [H: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ ( F8 @ H ) ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_6706_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X ) @ H ) @ ( inverse_inverse @ A @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_6707_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F8: real,G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( has_field_derivative @ real @ F2 @ F8 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ F8 )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_6708_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( cos @ real @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_cos
thf(fact_6709_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S2: set @ A,N: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_derivative @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ ^ [Y: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N ) @ ( F8 @ Y ) ) @ ( power_power @ B @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_power
thf(fact_6710_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( ln_ln @ real @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_ln
thf(fact_6711_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F8: C > A,X: C,S2: set @ C,G: C > A,G6: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
         => ( ( has_derivative @ C @ A @ G @ G6 @ ( topolo174197925503356063within @ C @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ^ [H: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X ) ) @ ( G6 @ H ) ) @ ( inverse_inverse @ A @ ( G @ X ) ) ) ) @ ( divide_divide @ A @ ( F8 @ H ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_6712_has__derivative__prod,axiom,
    ! [B: $tType,I7: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I5: set @ I7,F2: I7 > A > B,F8: I7 > A > B,X: A,S2: set @ A] :
          ( ! [I3: I7] :
              ( ( member @ I7 @ I3 @ I5 )
             => ( has_derivative @ A @ B @ ( F2 @ I3 ) @ ( F8 @ I3 ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X2: A] :
                ( groups7121269368397514597t_prod @ I7 @ B
                @ ^ [I4: I7] : ( F2 @ I4 @ X2 )
                @ I5 )
            @ ^ [Y: A] :
                ( groups7311177749621191930dd_sum @ I7 @ B
                @ ^ [I4: I7] :
                    ( times_times @ B @ ( F8 @ I4 @ Y )
                    @ ( groups7121269368397514597t_prod @ I7 @ B
                      @ ^ [J3: I7] : ( F2 @ J3 @ X )
                      @ ( minus_minus @ ( set @ I7 ) @ I5 @ ( insert @ I7 @ I4 @ ( bot_bot @ ( set @ I7 ) ) ) ) ) )
                @ I5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_prod
thf(fact_6713_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,X8: set @ A,F2: A > real,F8: A > real] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ X8 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
             => ( ( member @ A @ X @ X8 )
               => ( has_derivative @ A @ real
                  @ ^ [X2: A] : ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
                  @ ^ [H: A] : ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F8 @ H ) @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G6 @ H ) @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ X8 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_6714_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( sqrt @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_6715_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X: A,S: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( arctan @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_arctan
thf(fact_6716_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G6: A > real,S: set @ A] :
          ( ( ( cos @ real @ ( G @ X ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( tan @ real @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_tan
thf(fact_6717_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X: A,F2: real > Aa,G6: A > real,S: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G @ X ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X @ S ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G @ X2 ) ) ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G6 @ X2 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_6718_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X @ H ) @ N2 ) @ ( power_power @ A @ X @ N2 ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_6719_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L2: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_6720_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L2: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L2 @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_6721_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real
          @ ^ [X2: A] : ( power_power @ real @ ( F2 @ X2 ) @ N )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_6722_isCont__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% isCont_Pair
thf(fact_6723_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: B > C,L2: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L2 ) @ ( topolo174197925503356063within @ B @ ( F2 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X5 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_6724_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
          = ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_6725_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( filterlim @ A @ A
            @ ^ [Y: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y ) @ ( F2 @ X ) ) @ ( minus_minus @ A @ Y @ X ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_field_derivativeD
thf(fact_6726_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L6: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L6 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_6727_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L6: B] :
          ( ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_6728_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_6729_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_6730_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ X @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_6731_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L6: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ X2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L6 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_6732_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X5: A] :
                ( ( X5 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X5 ) ) )
           => ( ! [X5: A] :
                  ( ( X5 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X5 ) @ ( F2 @ X5 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_6733_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L2: B,A2: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X5: A] :
                ( ( X5 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X5 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L2 ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_6734_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > B,L2: filter @ B,X: A,S2: set @ A,T4: set @ A] :
          ( ( filterlim @ A @ B @ F2 @ L2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T4 @ S2 )
           => ( filterlim @ A @ B @ F2 @ L2 @ ( topolo174197925503356063within @ A @ X @ T4 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_6735_continuous__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F4: filter @ A,F2: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ F4
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_Pair
thf(fact_6736_tendsto__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,G: A > C,B2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ B2 ) @ F4 )
           => ( filterlim @ A @ ( product_prod @ B @ C )
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_Pair
thf(fact_6737_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_6738_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_6739_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X2: B] : ( arcosh @ real @ ( F2 @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_6740_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( artanh @ real @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_6741_tendsto__one__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I5: set @ B,F2: A > B > C,F4: filter @ A] :
          ( ! [I3: B] :
              ( ( member @ B @ I3 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( F2 @ X2 @ I3 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I4: A] : ( groups7121269368397514597t_prod @ B @ C @ ( F2 @ I4 ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
            @ F4 ) ) ) ).

% tendsto_one_prod'
thf(fact_6742_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,G: B > A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform_eq
thf(fact_6743_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ L2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 ) ) ) ).

% LIM_zero_cancel
thf(fact_6744_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform2
thf(fact_6745_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A2: A,F4: filter @ B,F2: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform
thf(fact_6746_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ L2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 ) ) ) ).

% LIM_zero_iff
thf(fact_6747_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ L2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 ) ) ) ).

% LIM_zero
thf(fact_6748_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_6749_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_6750_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X2: D] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_6751_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_6752_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_6753_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X2: D] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_one
thf(fact_6754_tendsto__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( minus_minus @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_diff
thf(fact_6755_continuous__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [F4: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_diff
thf(fact_6756_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ D,F2: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F4
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_6757_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X2: D] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_6758_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_6759_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F4: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F4
            @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_6760_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L2 @ C2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_right
thf(fact_6761_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L2 ) )
            @ F4 ) ) ) ).

% tendsto_mult_left
thf(fact_6762_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_mult
thf(fact_6763_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N ) ) ) ) ).

% continuous_power
thf(fact_6764_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F4: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_6765_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F2: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_6766_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_6767_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X ) )
        @ F4 ) ) ).

% tendsto_real_sqrt
thf(fact_6768_tendsto__real__root,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A,N: nat] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( root @ N @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N @ X ) )
        @ F4 ) ) ).

% tendsto_real_root
thf(fact_6769_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F4: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F4
              @ ^ [X2: D] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_add
thf(fact_6770_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_add
thf(fact_6771_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F2: B > A,D2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X2: B] : ( plus_plus @ A @ C2 @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F4 )
          = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F4 ) ) ) ).

% tendsto_add_const_iff
thf(fact_6772_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X2: D] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_6773_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F24: filter @ B,F13: filter @ A,F25: filter @ B,F14: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ F24 @ F13 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F24 @ F25 )
       => ( ( ord_less_eq @ ( filter @ A ) @ F14 @ F13 )
         => ( filterlim @ A @ B @ F2 @ F25 @ F14 ) ) ) ) ).

% filterlim_mono
thf(fact_6774_tendsto__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F4: filter @ B,F11: filter @ B,F2: B > A,L2: A] :
          ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F11 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% tendsto_mono
thf(fact_6775_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y2: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X5: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X5 )
                      & ( ord_less_eq @ A @ X5 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT
thf(fact_6776_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y2: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X5: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X5 )
                      & ( ord_less_eq @ A @ X5 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT2
thf(fact_6777_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L6: B,A2: A,R: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X3: A] :
                    ( ( ( X3 != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L6 ) ) @ R ) ) ) ) ) ) ).

% LIM_D
thf(fact_6778_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,L6: B] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [S9: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S9 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ S9 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L6 ) ) @ R4 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_6779_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L6: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S7: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                    & ! [X2: A] :
                        ( ( ( X2 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ S7 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X2 ) @ L6 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_6780_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R2: real,A2: A,F2: A > B,G: A > B,L2: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( ! [X5: A] :
                ( ( X5 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ R2 )
                 => ( ( F2 @ X5 )
                    = ( G @ X5 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_6781_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D5: A] :
          ( ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H ) ) @ ( F2 @ A2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X2 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_6782_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X5 )
              & ( ord_less_eq @ real @ X5 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L7: real,M8: real] :
            ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( ( ord_less_eq @ real @ L7 @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ M8 ) ) )
            & ! [Y3: real] :
                ( ( ( ord_less_eq @ real @ L7 @ Y3 )
                  & ( ord_less_eq @ real @ Y3 @ M8 ) )
               => ? [X5: real] :
                    ( ( ord_less_eq @ real @ A2 @ X5 )
                    & ( ord_less_eq @ real @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y3 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_6783_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L2 @ ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X3 ) ) @ R4 ) )
               => ( ord_less @ real @ ( F2 @ X3 ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_6784_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L2
         != ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X3 ) ) @ R4 ) )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_6785_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L2: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L2 )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X3: real] :
                ( ( ( X3 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X3 ) ) @ R4 ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_6786_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X5: A] :
                      ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X5 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_6787_isCont__real__sqrt,axiom,
    ! [X: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ sqrt ) ).

% isCont_real_sqrt
thf(fact_6788_isCont__real__root,axiom,
    ! [X: real,N: nat] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( root @ N ) ) ).

% isCont_real_root
thf(fact_6789_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S )
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_6790_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_6791_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% isCont_add
thf(fact_6792_isCont__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% isCont_diff
thf(fact_6793_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N ) ) ) ) ).

% isCont_power
thf(fact_6794_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_6795_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_6796_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z ) @ ( one_one @ A ) ) @ Z )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_6797_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_6798_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X3: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X3 )
                      & ( ord_less_eq @ real @ X3 @ B2 ) )
                   => ( ord_less_eq @ A @ M8 @ ( F2 @ X3 ) ) )
                & ? [X5: real] :
                    ( ( ord_less_eq @ real @ A2 @ X5 )
                    & ( ord_less_eq @ real @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_6799_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X3: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X3 )
                      & ( ord_less_eq @ real @ X3 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M8 ) )
                & ? [X5: real] :
                    ( ( ord_less_eq @ real @ A2 @ X5 )
                    & ( ord_less_eq @ real @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_6800_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
              ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M8 ) ) ) ) ) ).

% isCont_bounded
thf(fact_6801_isCont__inverse__function2,axiom,
    ! [A2: real,X: real,B2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ A2 @ Z5 )
             => ( ( ord_less_eq @ real @ Z5 @ B2 )
               => ( ( G @ ( F2 @ Z5 ) )
                  = Z5 ) ) )
         => ( ! [Z5: real] :
                ( ( ord_less_eq @ real @ A2 @ Z5 )
               => ( ( ord_less_eq @ real @ Z5 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_6802_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_6803_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_6804_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ X2 @ A2 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_6805_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L2: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ L2 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G4: A > A] :
                ( ! [Z: A] :
                    ( ( minus_minus @ A @ ( F2 @ Z ) @ ( F2 @ X ) )
                    = ( times_times @ A @ ( G4 @ Z ) @ ( minus_minus @ A @ Z @ X ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ G4 )
                & ( ( G4 @ X )
                  = L2 ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_6806_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X3: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X3 )
                      & ( ord_less_eq @ real @ X3 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M8 ) )
                & ! [N7: A] :
                    ( ( ord_less @ A @ N7 @ M8 )
                   => ? [X5: real] :
                        ( ( ord_less_eq @ real @ A2 @ X5 )
                        & ( ord_less_eq @ real @ X5 @ B2 )
                        & ( ord_less @ A @ N7 @ ( F2 @ X5 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_6807_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,D2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_6808_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A,D2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F4 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_6809_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X5: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ S )
               => ( sums @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) )
                  @ ( F2 @ X5 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_6810_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
         => ( ! [X5: A] :
                ( ( X5
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ S )
                 => ( sums @ A
                    @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ ( power_power @ A @ X5 @ N2 ) )
                    @ ( F2 @ X5 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_6811_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N3: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N3 ) ) @ ( times_times @ real @ ( F2 @ N3 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H: A] : ( suminf @ B @ ( G @ H ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_6812_isCont__arcosh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_6813_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X2: real] : ( divide_divide @ real @ ( cos @ real @ X2 ) @ ( sin @ real @ X2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_6814_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W3 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% isCont_polynom
thf(fact_6815_isCont__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_6816_isCont__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_6817_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y4: A] :
              ( summable @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ Y4 @ N2 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
            @ ^ [X2: A] :
                ( suminf @ A
                @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_6818_LIM__less__bound,axiom,
    ! [B2: real,X: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ).

% LIM_less_bound
thf(fact_6819_isCont__artanh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_6820_isCont__inverse__function,axiom,
    ! [D2: real,X: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z5: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z5 @ X ) ) @ D2 )
           => ( ( G @ ( F2 @ Z5 ) )
              = Z5 ) )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z5 @ X ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_6821_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real,G6: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z5: real] :
            ( ( ord_less_eq @ real @ A2 @ Z5 )
           => ( ( ord_less_eq @ real @ Z5 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z5: real] :
              ( ( ord_less_eq @ real @ A2 @ Z5 )
             => ( ( ord_less_eq @ real @ Z5 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z5: real] :
                ( ( ord_less @ real @ A2 @ Z5 )
               => ( ( ord_less @ real @ Z5 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G6 @ Z5 ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z5: real] :
                  ( ( ord_less @ real @ A2 @ Z5 )
                 => ( ( ord_less @ real @ Z5 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F8 @ Z5 ) @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C4: real] :
                  ( ( ord_less @ real @ A2 @ C4 )
                  & ( ord_less @ real @ C4 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G6 @ C4 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F8 @ C4 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_6822_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ K5 @ N2 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X2: A] :
                    ( suminf @ Aa
                    @ ^ [N2: nat] : ( times_times @ Aa @ ( C2 @ N2 ) @ ( power_power @ Aa @ ( F2 @ X2 ) @ N2 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_6823_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X: A] :
          ( ( summable @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ K5 @ N2 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] :
                  ( suminf @ A
                  @ ^ [N2: nat] : ( times_times @ A @ ( C2 @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_6824_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_6825_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_6826_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ C2 @ ( A2 @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_6827_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( times_times @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_6828_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( divide_divide @ A @ ( A2 @ N2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_6829_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ? [U4: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ X @ ( U4 @ N9 ) )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_6830_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ? [U4: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ ( U4 @ N9 ) @ X )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_6831_seq__offset__neg,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [I4: nat] : ( F2 @ ( minus_minus @ nat @ I4 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( at_top @ nat ) ) ) ) ).

% seq_offset_neg
thf(fact_6832_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_6833_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X2: A] : ( root @ N @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_real_root
thf(fact_6834_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_6835_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( F2 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_6836_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N4: nat,X8: nat > A,Y8: nat > A,X: A,Y2: A] :
          ( ! [N3: nat] :
              ( ( ord_less_eq @ nat @ N4 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y8 @ N3 ) ) )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y8 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ) ).

% lim_mono
thf(fact_6837_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,Y8: nat > A,Y2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y8 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( at_top @ nat ) )
           => ( ? [N7: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N3 )
                 => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( Y8 @ N3 ) ) )
             => ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_6838_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L2: A,M7: nat,C5: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N3 )
               => ( ord_less_eq @ A @ ( F2 @ N3 ) @ C5 ) )
           => ( ord_less_eq @ A @ L2 @ C5 ) ) ) ) ).

% Lim_bounded
thf(fact_6839_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L2: A,N4: nat,C5: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_top @ nat ) )
         => ( ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N3 )
               => ( ord_less_eq @ A @ C5 @ ( F2 @ N3 ) ) )
           => ( ord_less_eq @ A @ C5 @ L2 ) ) ) ) ).

% Lim_bounded2
thf(fact_6840_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N7: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N3 )
               => ( ord_less_eq @ A @ A2 @ ( X8 @ N3 ) ) )
           => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_6841_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N7: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N3 )
               => ( ord_less_eq @ A @ ( X8 @ N3 ) @ A2 ) )
           => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_6842_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ).

% Sup_lim
thf(fact_6843_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S: set @ A,A2: A] :
          ( ! [N3: nat] : ( member @ A @ ( B2 @ N3 ) @ S )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_6844_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_6845_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X2: nat] : ( times_times @ nat @ X2 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_6846_monoseq__convergent,axiom,
    ! [X8: nat > real,B4: real] :
      ( ( topological_monoseq @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X8 @ I3 ) ) @ B4 )
       => ~ ! [L7: real] :
              ~ ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_6847_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( root @ N2 @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_6848_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( ! [N9: nat] : ( ord_less_eq @ A @ ( A2 @ N9 ) @ X )
                & ! [M2: nat,N9: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N9 )
                   => ( ord_less_eq @ A @ ( A2 @ M2 ) @ ( A2 @ N9 ) ) ) )
              | ( ! [N9: nat] : ( ord_less_eq @ A @ X @ ( A2 @ N9 ) )
                & ! [M2: nat,N9: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N9 )
                   => ( ord_less_eq @ A @ ( A2 @ N9 ) @ ( A2 @ M2 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_6849_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N2: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_6850_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X8: nat > A,X: A,L2: nat] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L2 )
           => ( filterlim @ nat @ A
              @ ^ [N2: nat] : ( X8 @ ( times_times @ nat @ N2 @ L2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_6851_telescope__summable,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) ) ) ) ) ).

% telescope_summable
thf(fact_6852_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) ) ) ) ) ).

% telescope_summable'
thf(fact_6853_nested__sequence__unique,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N3 ) ) @ ( G @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N2: nat] : ( minus_minus @ real @ ( F2 @ N2 ) @ ( G @ N2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L4: real] :
                ( ! [N9: nat] : ( ord_less_eq @ real @ ( F2 @ N9 ) @ L4 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L4 ) @ ( at_top @ nat ) )
                & ! [N9: nat] : ( ord_less_eq @ real @ L4 @ ( G @ N9 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L4 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_6854_LIMSEQ__inverse__zero,axiom,
    ! [X8: nat > real] :
      ( ! [R4: real] :
        ? [N7: nat] :
        ! [N3: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N3 )
         => ( ord_less @ real @ R4 @ ( X8 @ N3 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( X8 @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_6855_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N2: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_6856_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( root @ N2 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_6857_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_6858_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S )
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_6859_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L2: real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ L2 )
       => ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [N9: nat] : ( ord_less_eq @ real @ L2 @ ( plus_plus @ real @ ( F2 @ N9 ) @ E2 ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L2 ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_6860_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_6861_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_6862_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_6863_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_6864_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_6865_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N2: nat] : ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_6866_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_6867_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_6868_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_6869_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X @ N2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_6870_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N2: nat] : ( root @ N2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_6871_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( plus_plus @ real @ R @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_6872_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_6873_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L6: A,R: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No @ N9 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N9 ) @ L6 ) ) @ R ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_6874_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L6: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N3 ) @ L6 ) ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_6875_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N2 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N2 ) @ L6 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_6876_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_6877_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_6878_tendsto__at__iff__sequentially,axiom,
    ! [C: $tType,A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > C,A2: C,X: A,S: set @ A] :
          ( ( filterlim @ A @ C @ F2 @ ( topolo7230453075368039082e_nhds @ C @ A2 ) @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ! [X4: nat > A] :
                ( ! [I4: nat] : ( member @ A @ ( X4 @ I4 ) @ ( minus_minus @ ( set @ A ) @ S @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( filterlim @ nat @ A @ X4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
                 => ( filterlim @ nat @ C @ ( comp @ A @ C @ nat @ F2 @ X4 ) @ ( topolo7230453075368039082e_nhds @ C @ A2 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% tendsto_at_iff_sequentially
thf(fact_6879_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F4: filter @ B,X: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y: B] : ( power_power @ A @ X @ ( F2 @ Y ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_6880_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R: real] :
      ( filterlim @ nat @ real
      @ ^ [N2: nat] : ( times_times @ real @ R @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_6881_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_6882_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_6883_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z2: A,S: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N3: nat] :
                  ( ( S @ N3 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N2: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z2 @ ( S @ N2 ) ) ) @ ( F2 @ Z2 ) ) @ ( S @ N2 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_6884_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_6885_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A
            @ ^ [N2: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ X @ N2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_6886_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( summable @ real
            @ ^ [N2: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) @ ( A2 @ N2 ) ) ) ) ) ) ).

% summable
thf(fact_6887_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J3 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K3: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_6888_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( Theta @ J3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K3: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K3 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_6889_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_6890_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N2: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_6891_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_6892_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_6893_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L4: real] :
              ( ! [N9: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                  @ L4 )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) )
              & ! [N9: nat] :
                  ( ord_less_eq @ real @ L4
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N2: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_6894_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N2: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_6895_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( filterlim @ nat @ real
            @ ^ [N2: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_6896_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N3 ) )
       => ( ! [N3: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N3 ) ) @ ( A2 @ N3 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_6897_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A4: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A4 )
               => ! [B3: nat] :
                    ( ( ord_less @ nat @ A4 @ B3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A4 @ B3 ) ) ) @ ( G @ A4 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_6898_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ ( minus_minus @ A @ Y @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_6899_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N2: nat] : ( P @ ( plus_plus @ nat @ N2 @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_6900_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F4: filter @ B,G7: filter @ A,F11: filter @ B,G8: filter @ A,F8: A > B] :
      ( ( filterlim @ A @ B @ F2 @ F4 @ G7 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F4 @ F11 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G8 @ G7 )
         => ( ( eventually @ A
              @ ^ [X2: A] :
                  ( ( F2 @ X2 )
                  = ( F8 @ X2 ) )
              @ G8 )
           => ( filterlim @ A @ B @ F8 @ F11 @ G8 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_6901_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_6902_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6903_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X5: A] :
              ( ( ord_less_eq @ A @ C2 @ X5 )
             => ( P @ X5 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_6904_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N6 @ N2 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_6905_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X5: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X5 )
         => ( P @ X5 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6906_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N6: nat] :
          ! [N2: nat] :
            ( ( ord_less_eq @ nat @ N6 @ N2 )
           => ( P @ N2 ) ) ) ) ).

% eventually_sequentially
thf(fact_6907_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I4: nat] : ( P @ ( plus_plus @ nat @ I4 @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_6908_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N6 @ N2 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_6909_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_6910_eventually__ex,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] :
          ? [X4: B] : ( P @ X2 @ X4 )
        @ F4 )
      = ( ? [Y9: A > B] :
            ( eventually @ A
            @ ^ [X2: A] : ( P @ X2 @ ( Y9 @ X2 ) )
            @ F4 ) ) ) ).

% eventually_ex
thf(fact_6911_bounded__linear__sub,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% bounded_linear_sub
thf(fact_6912_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X ) ) ) ).

% bounded_linear_mult_right
thf(fact_6913_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y2: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ ( G @ X2 ) @ Y2 ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_6914_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X2: C] : ( times_times @ A @ X @ ( G @ X2 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_6915_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X2: A] : ( times_times @ A @ X2 @ Y2 ) ) ) ).

% bounded_linear_mult_left
thf(fact_6916_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X2: A] : ( divide_divide @ A @ X2 @ Y2 ) ) ) ).

% bounded_linear_divide
thf(fact_6917_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F5: real > real] :
        ? [C3: real] :
          ( F5
          = ( ^ [X2: real] : ( times_times @ real @ X2 @ C3 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_6918_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_6919_filter__leD,axiom,
    ! [A: $tType,F4: filter @ A,F11: filter @ A,P: A > $o] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 )
     => ( ( eventually @ A @ P @ F11 )
       => ( eventually @ A @ P @ F4 ) ) ) ).

% filter_leD
thf(fact_6920_filter__leI,axiom,
    ! [A: $tType,F11: filter @ A,F4: filter @ A] :
      ( ! [P8: A > $o] :
          ( ( eventually @ A @ P8 @ F11 )
         => ( eventually @ A @ P8 @ F4 ) )
     => ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 ) ) ).

% filter_leI
thf(fact_6921_le__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
          ! [P4: A > $o] :
            ( ( eventually @ A @ P4 @ F10 )
           => ( eventually @ A @ P4 @ F9 ) ) ) ) ).

% le_filter_def
thf(fact_6922_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ ( top_top @ A ) )
                  & ! [Z: A] :
                      ( ( ord_less @ A @ B3 @ Z )
                     => ( P @ Z ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_6923_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A] :
          ( ! [X5: A,Y4: A] :
              ( ( Q @ X5 )
             => ( ( Q @ Y4 )
               => ( ( ord_less_eq @ A @ X5 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) ) ) )
         => ( ! [X5: B] :
                ( ( P @ X5 )
               => ( ( F2 @ ( G @ X5 ) )
                  = X5 ) )
           => ( ! [X5: B] :
                  ( ( P @ X5 )
                 => ( Q @ ( G @ X5 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6924_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ B3 @ X )
                & ! [Y: A] :
                    ( ( ord_less @ A @ B3 @ Y )
                   => ( ( ord_less @ A @ Y @ X )
                     => ( P @ Y ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_6925_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y2: A,X: A,P: A > $o] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ X )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ B3 @ Y )
                     => ( ( ord_less @ A @ Y @ X )
                       => ( P @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_6926_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K10: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K10 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_6927_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G: B > A,Net: filter @ B,H2: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N2: B] : ( ord_less_eq @ A @ ( G @ N2 ) @ ( H2 @ N2 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6928_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ A2 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_6929_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y2: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 )
         => ( ( ord_less @ A @ A2 @ Y2 )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ A @ A2 @ ( F2 @ X2 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_6930_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y2: A,F2: B > A,F4: filter @ B] :
          ( ! [A6: A] :
              ( ( ord_less @ A @ A6 @ Y2 )
             => ( eventually @ B
                @ ^ [X2: B] : ( ord_less @ A @ A6 @ ( F2 @ X2 ) )
                @ F4 ) )
         => ( ! [A6: A] :
                ( ( ord_less @ A @ Y2 @ A6 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ A6 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_6931_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
          = ( ! [L: A] :
                ( ( ord_less @ A @ L @ X )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ L @ ( F2 @ X2 ) )
                  @ F4 ) )
            & ! [U3: A] :
                ( ( ord_less @ A @ X @ U3 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ U3 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_6932_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X2: A] :
              ! [Y: A] :
                ( ( ord_less_eq @ A @ X2 @ Y )
               => ( P @ Y ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_6933_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X2 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_6934_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X2 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6935_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6936_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ Z9 @ ( F2 @ X2 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_6937_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G: B > real,Net: filter @ B,H2: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N2: B] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( G @ N2 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N2: B] : ( ord_less_eq @ real @ ( G @ N2 ) @ ( H2 @ N2 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_6938_eventually__Inf__base,axiom,
    ! [A: $tType,B4: set @ ( filter @ A ),P: A > $o] :
      ( ( B4
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F6: filter @ A] :
            ( ( member @ ( filter @ A ) @ F6 @ B4 )
           => ! [G5: filter @ A] :
                ( ( member @ ( filter @ A ) @ G5 @ B4 )
               => ? [X3: filter @ A] :
                    ( ( member @ ( filter @ A ) @ X3 @ B4 )
                    & ( ord_less_eq @ ( filter @ A ) @ X3 @ ( inf_inf @ ( filter @ A ) @ F6 @ G5 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B4 ) )
          = ( ? [X2: filter @ A] :
                ( ( member @ ( filter @ A ) @ X2 @ B4 )
                & ( eventually @ A @ P @ X2 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_6939_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X5 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_6940_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K10: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K10 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_6941_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X2: A] : ( P @ ( plus_plus @ A @ X2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6942_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L2: A,F2: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ L2 @ ( F2 @ N2 ) )
            @ F4 )
         => ( ! [X5: A] :
                ( ( ord_less @ A @ L2 @ X5 )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ ( F2 @ N2 ) @ X5 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6943_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L2: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N2: B] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ L2 )
            @ F4 )
         => ( ! [X5: A] :
                ( ( ord_less @ A @ X5 @ L2 )
               => ( eventually @ B
                  @ ^ [N2: B] : ( ord_less @ A @ X5 @ ( F2 @ N2 ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_6944_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X2 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6945_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F2: B > A,X: A,G: B > A,Y2: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X2: B] : ( ord_less_eq @ A @ ( G @ X2 ) @ ( F2 @ X2 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y2 @ X ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6946_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I4 ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6947_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ ( F2 @ I4 ) @ A2 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6948_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F4: B > ( filter @ A ),B4: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ B4 ) ) )
      = ( ? [X4: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X4 @ B4 )
            & ( finite_finite @ B @ X4 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F4 @ X4 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_6949_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6950_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K10 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_6951_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K5: real] :
          ( ! [X5: A,Y4: A] :
              ( ( F2 @ ( plus_plus @ A @ X5 @ Y4 ) )
              = ( plus_plus @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
         => ( ! [R4: real,X5: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R4 @ X5 ) )
                = ( real_V8093663219630862766scaleR @ B @ R4 @ ( F2 @ X5 ) ) )
           => ( ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_6952_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L6: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ L6 )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L6 @ ( set_ord_lessThan @ B @ L6 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_6953_eventually__Inf,axiom,
    ! [A: $tType,P: A > $o,B4: set @ ( filter @ A )] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B4 ) )
      = ( ? [X4: set @ ( filter @ A )] :
            ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X4 @ B4 )
            & ( finite_finite @ ( filter @ A ) @ X4 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ X4 ) ) ) ) ) ).

% eventually_Inf
thf(fact_6954_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G @ N2 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_6955_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X2: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X2: B] : ( arcosh @ real @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_6956_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X5: A,Y4: A] :
              ( ( Q @ X5 )
             => ( ( Q @ Y4 )
               => ( ( ord_less_eq @ A @ X5 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) ) ) )
         => ( ! [X5: B] :
                ( ( P @ X5 )
               => ( ( F2 @ ( G @ X5 ) )
                  = X5 ) )
           => ( ! [X5: B] :
                  ( ( P @ X5 )
                 => ( Q @ ( G @ X5 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ B6 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_6957_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B4: set @ A,F4: A > ( filter @ B ),P: B > $o] :
      ( ( B4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A6: A] :
            ( ( member @ A @ A6 @ B4 )
           => ! [B6: A] :
                ( ( member @ A @ B6 @ B4 )
               => ? [X3: A] :
                    ( ( member @ A @ X3 @ B4 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F4 @ X3 ) @ ( inf_inf @ ( filter @ B ) @ ( F4 @ A6 ) @ ( F4 @ B6 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F4 @ B4 ) ) )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ B4 )
                & ( eventually @ B @ P @ ( F4 @ X2 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_6958_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ K5 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_6959_filterlim__at__withinI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,A3: set @ A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X2: B] : ( member @ A @ ( F2 @ X2 ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) ) )
              @ F4 )
           => ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ C2 @ A3 ) @ F4 ) ) ) ) ).

% filterlim_at_withinI
thf(fact_6960_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
                @ F4 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr'
thf(fact_6961_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F4 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_6962_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F4 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_6963_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L2 ) ) @ ( F2 @ X2 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_6964_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L2: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L2 ) @ F4 )
         => ( ~ ( member @ B @ L2 @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L2 ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_6965_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ real
              @ ^ [Y: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_6966_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_6967_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F8: A > B,X: A,F2: A > B,S: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F8 )
         => ( ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivativeI
thf(fact_6968_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ? [E4: A > B] :
                ( ! [H: A] :
                    ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ H ) ) @ ( E4 @ H ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E4 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_6969_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X: A,S: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ ( minus_minus @ A @ Y @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% has_derivative_within
thf(fact_6970_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D5 )
            & ( filterlim @ A @ real
              @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ ( D5 @ H ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_6971_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M3: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ M3 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N2 ) ) ) @ ( G @ M3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_6972_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N: nat,B4: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N )
             => ( eventually @ A
                @ ^ [Z: A] :
                    ( ord_less_eq @ real @ B4
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_6973_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F5: A > B,F15: A > B,F9: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F15 )
              & ( filterlim @ A @ B
                @ ^ [Y: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X2: A] : X2 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F5 @ Y )
                        @ ( F5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X2: A] : X2 ) ) )
                      @ ( F15
                        @ ( minus_minus @ A @ Y
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X2: A] : X2 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F9 ) ) ) ) ) ).

% has_derivative_def
thf(fact_6974_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_6975_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_6976_filterlim__at__top__add__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( plus_plus @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_at_top_add_at_top
thf(fact_6977_filterlim__tendsto__add__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( plus_plus @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_tendsto_add_at_top
thf(fact_6978_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
              ! [X2: A] :
                ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_6979_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( power_power @ real @ ( F2 @ X2 ) @ N )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_6980_tanh__real__at__top,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) ) @ ( at_top @ real ) ).

% tanh_real_at_top
thf(fact_6981_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_6982_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,C2: B,F4: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F4 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_6983_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_6984_artanh__real__at__left__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_lessThan @ real @ ( one_one @ real ) ) ) ).

% artanh_real_at_left_1
thf(fact_6985_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_6986_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_6987_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_6988_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F4: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_6989_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_6990_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_6991_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P2: A > $o] :
          ( ( eventually @ A @ P2 @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B3 )
                & ! [X2: A] :
                    ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
                   => ( P2 @ X2 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_6992_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X2: real] : ( divide_divide @ real @ ( power_power @ real @ X2 @ K ) @ ( exp @ real @ X2 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_6993_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X2: A] : X2 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X2: A] : X2 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_6994_tendsto__exp__limit__at__top,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ Y ) ) @ Y )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_6995_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F4: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_6996_continuous__artanh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( member @ real
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) )
              @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( artanh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_artanh
thf(fact_6997_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_6998_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X5: real] :
          ( ( ord_less_eq @ real @ B2 @ X5 )
         => ? [Y3: real] :
              ( ( has_field_derivative @ real @ F2 @ Y3 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y3 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_6999_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_7000_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F4: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F4 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X2: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) )
                    @ F4 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_7001_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_7002_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L2: A] :
          ( ( filterlim @ A @ A
            @ ^ [X2: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L2 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_7003_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X: A,S2: set @ A,F2: A > B,F8: A > B] :
          ( ( member @ A @ X @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
                & ? [E4: A > B] :
                    ( ! [H: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X @ H ) @ S2 )
                       => ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F8 @ H ) ) @ ( E4 @ H ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E4 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_7004_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E: real,F8: A > B,S: set @ A,X: A,F2: A > B,H7: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
         => ( ( real_V3181309239436604168linear @ A @ B @ F8 )
           => ( ! [Y4: A] :
                  ( ( member @ A @ Y4 @ S )
                 => ( ( Y4 != X )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X ) @ E )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F8 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( H7 @ Y4 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H7 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X @ S ) )
               => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_7005_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_7006_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_7007_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y2 ) @ ( zero_zero @ real ) )
          = ( X = Y2 ) ) ) ).

% dist_le_zero_iff
thf(fact_7008_dist__diff_I1_J,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V557655796197034286t_dist @ A @ A2 @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ).

% dist_diff(1)
thf(fact_7009_dist__diff_I2_J,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( minus_minus @ A @ A2 @ B2 ) @ A2 )
          = ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ).

% dist_diff(2)
thf(fact_7010_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: real,A2: A,Y2: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y2 ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_7011_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y2 ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z2 ) ) ) ) ).

% dist_triangle
thf(fact_7012_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y2: A,Z2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z2 ) ) ) ) ).

% dist_triangle2
thf(fact_7013_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y2: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y2 ) ) ) ) ).

% dist_triangle3
thf(fact_7014_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y2: A,E: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z2 ) ) @ E )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y2 ) @ E ) ) ) ).

% dist_triangle_le
thf(fact_7015_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y2 ) ) ) ).

% zero_le_dist
thf(fact_7016_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I: nat] :
              ( ( member @ A @ X @ ( A8 @ I ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) ) )
          & ! [S10: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S10 )
                & ( member @ A @ X @ S10 ) )
             => ? [I3: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I3 ) @ S10 ) ) ) ) ).

% first_countable_basis
thf(fact_7017_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S5: set @ A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ S5 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member @ A @ X2 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S5 ) ) ) ) ) ) ).

% open_subopen
thf(fact_7018_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ S2 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member @ A @ X5 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S2 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S2 ) ) ) ).

% openI
thf(fact_7019_at__top__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_top @ real ) @ ( at_infinity @ real ) ).

% at_top_le_at_infinity
thf(fact_7020_open__diagonal__complement,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y ) )
              & ( X2 != Y ) ) ) ) ) ).

% open_diagonal_complement
thf(fact_7021_open__Collect__ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [P: B > A > $o] :
          ( ! [I3: B] : ( topolo1002775350975398744n_open @ A @ ( collect @ A @ ( P @ I3 ) ) )
         => ( topolo1002775350975398744n_open @ A
            @ ( collect @ A
              @ ^ [X2: A] :
                ? [I4: B] : ( P @ I4 @ X2 ) ) ) ) ) ).

% open_Collect_ex
thf(fact_7022_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,Y2: A,E1: real,X22: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ Y2 ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y2 ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_7023_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z2: A,Y2: A,E: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z2 ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z2 ) ) @ E )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y2 ) @ E ) ) ) ).

% dist_triangle_lt
thf(fact_7024_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ord_less @ A @ X @ X5 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A3 ) @ A3 ) ) ) ) ).

% Inf_notin_open
thf(fact_7025_dist__real__def,axiom,
    ( ( real_V557655796197034286t_dist @ real )
    = ( ^ [X2: real,Y: real] : ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y ) ) ) ) ).

% dist_real_def
thf(fact_7026_dist__norm,axiom,
    ! [A: $tType] :
      ( ( real_V6936659425649961206t_norm @ A )
     => ( ( real_V557655796197034286t_dist @ A )
        = ( ^ [X2: A,Y: A] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y ) ) ) ) ) ).

% dist_norm
thf(fact_7027_dist__complex__def,axiom,
    ( ( real_V557655796197034286t_dist @ complex )
    = ( ^ [X2: complex,Y: complex] : ( real_V7770717601297561774m_norm @ complex @ ( minus_minus @ complex @ X2 @ Y ) ) ) ) ).

% dist_complex_def
thf(fact_7028_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ord_less @ A @ X5 @ X ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A3 ) @ A3 ) ) ) ) ).

% Sup_notin_open
thf(fact_7029_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S2: set @ A,T4: set @ A] :
          ( ( member @ A @ A2 @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ T4 )
             => ( ( topolo174197925503356063within @ A @ A2 @ T4 )
                = ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_7030_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ X @ Y2 )
             => ? [B6: A] :
                  ( ( ord_less @ A @ X @ B6 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X @ B6 ) @ S2 ) ) ) ) ) ) ).

% open_right
thf(fact_7031_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A,X: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( member @ A @ X @ S2 )
           => ( ( ord_less @ A @ Y2 @ X )
             => ? [B6: A] :
                  ( ( ord_less @ A @ B6 @ X )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B6 @ X ) @ S2 ) ) ) ) ) ) ).

% open_left
thf(fact_7032_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_7033_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y ) )
              & ( ord_less @ A @ Y @ X2 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_7034_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y ) )
              & ( ord_less @ A @ X2 @ Y ) ) ) ) ) ).

% open_subdiagonal
thf(fact_7035_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) )
             => ( ! [I: nat] : ( member @ A @ X @ ( A8 @ I ) )
               => ~ ! [S10: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S10 )
                     => ( ( member @ A @ X @ S10 )
                       => ( eventually @ nat
                          @ ^ [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I4 ) @ S10 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_7036_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% metric_CauchyI
thf(fact_7037_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,E: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M2 ) @ ( X8 @ N9 ) ) @ E ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_7038_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S7: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [N6: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S7 @ N2 ) @ ( S7 @ N6 ) ) @ E4 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_7039_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X4 @ M3 ) @ ( X4 @ N2 ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_7040_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S5: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S5 )
               => ( ( member @ A @ F0 @ S5 )
                 => ? [N6: nat] :
                    ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N2 )
                     => ( member @ A @ ( F2 @ N2 ) @ S5 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_7041_dist__of__int,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: int,N: int] :
          ( ( real_V557655796197034286t_dist @ A @ ( ring_1_of_int @ A @ M ) @ ( ring_1_of_int @ A @ N ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ M @ N ) ) ) ) ) ).

% dist_of_int
thf(fact_7042_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( eventually @ C
              @ ^ [X2: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X2 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ A2 ) )
              @ F4 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F4 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_7043_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L2: A,A2: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L2 ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X5: C] :
                ( ( X5 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X5 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L2 ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_7044_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y2: A,X1: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X1 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_r
thf(fact_7045_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,Y2: A,E: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ Y2 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y2 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ E ) ) ) ) ).

% dist_triangle_half_l
thf(fact_7046_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S2: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ S2 )
                   => ( ( ( X2 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D3 ) )
                     => ( P @ X2 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_7047_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,X22: A,E: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ X32 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X42 ) @ E ) ) ) ) ) ).

% dist_triangle_third
thf(fact_7048_at__within__nhd,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X: A,S2: set @ A,T4: set @ A,U5: set @ A] :
          ( ( member @ A @ X @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ S2 )
           => ( ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ T4 @ S2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ U5 @ S2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( topolo174197925503356063within @ A @ X @ T4 )
                = ( topolo174197925503356063within @ A @ X @ U5 ) ) ) ) ) ) ).

% at_within_nhd
thf(fact_7049_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G7: filter @ B,X: A,S2: set @ A,F4: filter @ B,D2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ G7 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G7 @ F4 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X16: A] :
                    ( ( member @ A @ X16 @ S2 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X ) @ D2 )
                       => ( ( F2 @ X16 )
                          = ( G @ X16 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_7050_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F5: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M3 )
                 => ! [N2: nat] :
                      ( ( ord_less @ nat @ M3 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F5 @ M3 ) @ ( F5 @ N2 ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_7051_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E2: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
             => ? [M10: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M4 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M4 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M4 ) @ ( X8 @ N3 ) ) @ E2 ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI'
thf(fact_7052_dist__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( real_V557655796197034286t_dist @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ) ).

% dist_of_nat
thf(fact_7053_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N2 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N2 ) @ L6 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_7054_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L6: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L6 ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_7055_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L6: A,R: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ? [No: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No @ N9 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N9 ) @ L6 ) @ R ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_7056_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [J3: nat] :
            ? [M9: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ M9 @ M3 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X4 @ M3 ) @ ( X4 @ N2 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_7057_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S2: set @ A,F2: A > D,L6: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S2 )
           => ( ( topolo1002775350975398744n_open @ A @ S2 )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L6 ) @ ( topolo174197925503356063within @ A @ A2 @ S2 ) )
                = ( filterlim @ A @ D
                  @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L6 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_7058_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L6: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No3 )
                    & ! [N2: nat] :
                        ( ( ord_less_eq @ nat @ No3 @ N2 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N2 ) @ L6 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_7059_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S5: set @ A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [K2: set @ A] :
                  ( ( finite_finite @ A @ K2 )
                  & ( ord_less_eq @ ( set @ A ) @ S5
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X2: A] :
                            ( collect @ A
                            @ ^ [Y: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y ) @ E4 ) )
                        @ K2 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_7060_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X2: real] : ( power_power @ real @ ( F2 @ X2 ) @ N )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_7061_at__bot__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_bot @ real ) @ ( at_infinity @ real ) ).

% at_bot_le_at_infinity
thf(fact_7062_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S2: set @ A,T4: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T4 @ S2 )
           => ( topolo6688025880775521714ounded @ A @ T4 ) ) ) ) ).

% totally_bounded_subset
thf(fact_7063_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less_eq @ A @ N2 @ N6 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_7064_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N2: A] :
                ( ( ord_less @ A @ N2 @ N6 )
               => ( P @ N2 ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_7065_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_7066_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_7067_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_7068_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_7069_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ Z9 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_7070_tanh__real__at__bot,axiom,
    filterlim @ real @ real @ ( tanh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) @ ( at_bot @ real ) ).

% tanh_real_at_bot
thf(fact_7071_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_7072_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z9 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_7073_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_7074_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X5: real] :
          ( ( ord_less_eq @ real @ X5 @ B2 )
         => ? [Y3: real] :
              ( ( has_field_derivative @ real @ F2 @ Y3 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y3 ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_7075_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X2: real] : ( power_power @ real @ ( F2 @ X2 ) @ N )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_7076_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_7077_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F9: filter @ A] :
            ? [Y: B,K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ X2 ) @ Y ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_7078_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F4 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ B9 )
                    @ F4 ) ) ) ) ).

% BfunE
thf(fact_7079_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X8 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_7080_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X2: nat] : ( plus_plus @ A @ ( F2 @ X2 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_7081_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N2: nat] : ( X8 @ ( plus_plus @ nat @ N2 @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_7082_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X2: nat] : ( plus_plus @ A @ ( F2 @ X2 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_7083_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X2: nat] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_7084_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,K5: real] :
          ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K5 )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_7085_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X2: nat] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_7086_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N2 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_7087_Bseq__eq__bounded,axiom,
    ! [F2: nat > real,A2: real,B2: real] :
      ( ( ord_less_eq @ ( set @ real ) @ ( image @ nat @ real @ F2 @ ( top_top @ ( set @ nat ) ) ) @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
     => ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ).

% Bseq_eq_bounded
thf(fact_7088_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N2 ) ) @ K6 ) ) ) ) ) ).

% Bseq_def
thf(fact_7089_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K5: real,X8: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
         => ( ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K5 )
           => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_7090_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ~ ! [K10: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
               => ~ ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N9 ) ) @ K10 ) ) ) ) ).

% BseqE
thf(fact_7091_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ? [K10: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K10 )
              & ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N9 ) ) @ K10 ) ) ) ) ).

% BseqD
thf(fact_7092_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_7093_Bseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_7094_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K5: real,F4: filter @ A] :
          ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ K5 )
            @ F4 )
         => ( bfun @ A @ B @ F2 @ F4 ) ) ) ).

% BfunI
thf(fact_7095_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [N6: nat] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N2 ) @ ( uminus_uminus @ A @ ( X8 @ N6 ) ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_7096_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K2: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K2 )
                & ? [X2: A] :
                  ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N2 ) @ ( uminus_uminus @ A @ X2 ) ) ) @ K2 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_7097_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F9: filter @ A] :
            ? [K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X2 ) ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_def
thf(fact_7098_tendsto__exp__limit__at__right,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_7099_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_7100_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I2 ) ) ) ).

% greaterThan_iff
thf(fact_7101_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X ) @ ( set_ord_greaterThan @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) ).

% greaterThan_subset_iff
thf(fact_7102_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ X @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_7103_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L: A] : ( collect @ A @ ( ord_less @ A @ L ) ) ) ) ) ).

% greaterThan_def
thf(fact_7104_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ X @ B3 )
                & ! [Y: A] :
                    ( ( ord_less @ A @ X @ Y )
                   => ( ( ord_less @ A @ Y @ B3 )
                     => ( P @ Y ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_7105_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y2: A,P: A > $o] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ X @ B3 )
                  & ! [Y: A] :
                      ( ( ord_less @ A @ X @ Y )
                     => ( ( ord_less @ A @ Y @ B3 )
                       => ( P @ Y ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_7106_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_7107_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L2 @ U2 ) @ ( set_ord_greaterThan @ A @ U2 ) )
            = ( set_ord_greaterThan @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_7108_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X2: real] : ( P @ ( plus_plus @ real @ X2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_7109_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A] : ( eventually @ A @ ( ord_less @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) ) ) ).

% eventually_at_right_less
thf(fact_7110_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ? [A6: A,B6: A] :
              ( ( member @ A @ X @ ( set_ord_lessThan @ A @ A6 ) )
              & ( member @ A @ Y2 @ ( set_ord_greaterThan @ A @ B6 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A6 ) @ ( set_ord_greaterThan @ A @ B6 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_7111_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X5 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_7112_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X2: real] : ( F2 @ ( plus_plus @ real @ X2 @ A2 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_7113_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P2: A,F13: filter @ B,C2: A,L2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P2 @ ( set_ord_greaterThan @ A @ P2 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L2
                = ( times_times @ A @ C2 @ P2 ) )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
                @ ( topolo174197925503356063within @ A @ L2 @ ( set_ord_greaterThan @ A @ L2 ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_7114_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L6: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L6 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ L6 @ ( F2 @ X2 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L6 @ ( set_ord_greaterThan @ B @ L6 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_7115_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X5: A,Y4: A] :
              ( ( Q @ X5 )
             => ( ( Q @ Y4 )
               => ( ( ord_less_eq @ A @ X5 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) ) ) )
         => ( ! [X5: B] :
                ( ( P @ X5 )
               => ( ( F2 @ ( G @ X5 ) )
                  = X5 ) )
           => ( ! [X5: B] :
                  ( ( P @ X5 )
                 => ( Q @ ( G @ X5 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B6: A] :
                      ( ( Q @ B6 )
                     => ( ord_less @ A @ A2 @ B6 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_7116_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_7117_artanh__real__at__right__1,axiom,
    filterlim @ real @ real @ ( artanh @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ).

% artanh_real_at_right_1
thf(fact_7118_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( if @ B @ ( ord_less_eq @ A @ X2 @ A2 ) @ ( G @ X2 ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_7119_at__within__order,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,S: set @ A] :
          ( ( ( top_top @ ( set @ A ) )
           != ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ( topolo174197925503356063within @ A @ X @ S )
            = ( inf_inf @ ( filter @ A )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A4: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A4 ) @ S ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_greaterThan @ A @ X ) ) )
              @ ( complete_Inf_Inf @ ( filter @ A )
                @ ( image @ A @ ( filter @ A )
                  @ ^ [A4: A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A4 ) @ S ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
                  @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ) ).

% at_within_order
thf(fact_7120_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S2: set @ A] :
          ( ! [A6: A,B6: A,X5: A] :
              ( ( member @ A @ A6 @ S2 )
             => ( ( member @ A @ B6 @ S2 )
               => ( ( ord_less_eq @ A @ A6 @ X5 )
                 => ( ( ord_less_eq @ A @ X5 @ B6 )
                   => ( member @ A @ X5 @ S2 ) ) ) ) )
         => ? [A6: A,B6: A] :
              ( ( S2
                = ( bot_bot @ ( set @ A ) ) )
              | ( S2
                = ( top_top @ ( set @ A ) ) )
              | ( S2
                = ( set_ord_lessThan @ A @ B6 ) )
              | ( S2
                = ( set_ord_atMost @ A @ B6 ) )
              | ( S2
                = ( set_ord_greaterThan @ A @ A6 ) )
              | ( S2
                = ( set_ord_atLeast @ A @ A6 ) )
              | ( S2
                = ( set_or5935395276787703475ssThan @ A @ A6 @ B6 ) )
              | ( S2
                = ( set_or3652927894154168847AtMost @ A @ A6 @ B6 ) )
              | ( S2
                = ( set_or7035219750837199246ssThan @ A @ A6 @ B6 ) )
              | ( S2
                = ( set_or1337092689740270186AtMost @ A @ A6 @ B6 ) ) ) ) ) ).

% interval_cases
thf(fact_7121_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I2: A,K: A] :
          ( ( member @ A @ I2 @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I2 ) ) ) ).

% atLeast_iff
thf(fact_7122_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X ) @ ( set_ord_atLeast @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) ).

% atLeast_subset_iff
thf(fact_7123_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I2 ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I2 ) ) ) ) ).

% image_add_atLeast
thf(fact_7124_principal__le__iff,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A3 ) @ ( principal @ A @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ).

% principal_le_iff
thf(fact_7125_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L2: A,H2: A,L3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) )
          = ( ~ ( ord_less_eq @ A @ L2 @ H2 )
            | ( ord_less_eq @ A @ L3 @ L2 ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_7126_image__minus__const__AtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_ord_atMost @ A @ B2 ) )
          = ( set_ord_atLeast @ A @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% image_minus_const_AtMost
thf(fact_7127_image__minus__const__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( minus_minus @ A @ C2 ) @ ( set_ord_atLeast @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( minus_minus @ A @ C2 @ A2 ) ) ) ) ).

% image_minus_const_atLeast
thf(fact_7128_le__principal,axiom,
    ! [A: $tType,F4: filter @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ ( principal @ A @ A3 ) )
      = ( eventually @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A3 )
        @ F4 ) ) ).

% le_principal
thf(fact_7129_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% Ioi_le_Ico
thf(fact_7130_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L: A] : ( collect @ A @ ( ord_less_eq @ A @ L ) ) ) ) ) ).

% atLeast_def
thf(fact_7131_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L2: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L2 ) @ ( set_ord_atMost @ A @ H3 ) ) ) ).

% not_Ici_le_Iic
thf(fact_7132_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) ) ) ).

% not_Iic_le_Ici
thf(fact_7133_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L2 ) ) ) ).

% not_UNIV_le_Ici
thf(fact_7134_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L2: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L2 ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Ici_le_Icc
thf(fact_7135_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L2 @ U2 ) @ ( set_ord_atLeast @ A @ U2 ) )
            = ( set_ord_atLeast @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_7136_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_7137_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less_eq @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L2 @ U2 ) @ ( set_ord_greaterThan @ A @ U2 ) )
            = ( set_ord_atLeast @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_7138_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: A,U2: A] :
          ( ( ord_less @ A @ L2 @ U2 )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L2 @ U2 ) @ ( set_ord_atLeast @ A @ U2 ) )
            = ( set_ord_greaterThan @ A @ L2 ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_7139_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_7140_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_7141_filterlim__base__iff,axiom,
    ! [A: $tType,C: $tType,B: $tType,D: $tType,I5: set @ A,F4: A > ( set @ B ),F2: B > C,G7: D > ( set @ C ),J4: set @ D] :
      ( ( I5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I5 )
           => ! [J2: A] :
                ( ( member @ A @ J2 @ I5 )
               => ( ( ord_less_eq @ ( set @ B ) @ ( F4 @ I3 ) @ ( F4 @ J2 ) )
                  | ( ord_less_eq @ ( set @ B ) @ ( F4 @ J2 ) @ ( F4 @ I3 ) ) ) ) )
       => ( ( filterlim @ B @ C @ F2
            @ ( complete_Inf_Inf @ ( filter @ C )
              @ ( image @ D @ ( filter @ C )
                @ ^ [J3: D] : ( principal @ C @ ( G7 @ J3 ) )
                @ J4 ) )
            @ ( complete_Inf_Inf @ ( filter @ B )
              @ ( image @ A @ ( filter @ B )
                @ ^ [I4: A] : ( principal @ B @ ( F4 @ I4 ) )
                @ I5 ) ) )
          = ( ! [X2: D] :
                ( ( member @ D @ X2 @ J4 )
               => ? [Y: A] :
                    ( ( member @ A @ Y @ I5 )
                    & ! [Z: B] :
                        ( ( member @ B @ Z @ ( F4 @ Y ) )
                       => ( member @ C @ ( F2 @ Z ) @ ( G7 @ X2 ) ) ) ) ) ) ) ) ) ).

% filterlim_base_iff
thf(fact_7142_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X2: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_7143_at__within__def,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo174197925503356063within @ A )
        = ( ^ [A4: A,S7: set @ A] : ( inf_inf @ ( filter @ A ) @ ( topolo7230453075368039082e_nhds @ A @ A4 ) @ ( principal @ A @ ( minus_minus @ ( set @ A ) @ S7 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% at_within_def
thf(fact_7144_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less @ A @ Y2 @ X )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A4: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A4 @ X ) )
                @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ).

% at_left_eq
thf(fact_7145_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A4: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X @ A4 ) )
                @ ( set_ord_greaterThan @ A @ X ) ) ) ) ) ) ).

% at_right_eq
thf(fact_7146_at__within__eq,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo174197925503356063within @ A )
        = ( ^ [X2: A,S7: set @ A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ ( set @ A ) @ ( filter @ A )
                @ ^ [S5: set @ A] : ( principal @ A @ ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ S5 @ S7 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
                @ ( collect @ ( set @ A )
                  @ ^ [S5: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S5 )
                      & ( member @ A @ X2 @ S5 ) ) ) ) ) ) ) ) ).

% at_within_eq
thf(fact_7147_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F3: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ A2 @ ( F3 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F3 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F3 )
                   => ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P @ ( F3 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_7148_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y8: set @ B,X8: set @ A,F4: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ Y8 ) @ X8 )
     => ( ( eventually @ B
          @ ^ [X2: B] : ( member @ B @ X2 @ Y8 )
          @ F4 )
       => ( ( map_filter_on @ A @ C @ X8 @ F2 @ ( map_filter_on @ B @ A @ Y8 @ G @ F4 ) )
          = ( map_filter_on @ B @ C @ Y8 @ ( comp @ A @ C @ B @ F2 @ G ) @ F4 ) ) ) ) ).

% map_filter_on_comp
thf(fact_7149_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ord_less_eq @ A @ ( F2 @ J ) @ ( F2 @ I2 ) ) ) ) ) ).

% decseqD
thf(fact_7150_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X4: nat > A] :
            ! [M3: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N2 )
             => ( ord_less_eq @ A @ ( X4 @ N2 ) @ ( X4 @ M3 ) ) ) ) ) ) ).

% decseq_def
thf(fact_7151_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I2: nat] :
          ( ( order_antimono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ ( suc @ I2 ) ) @ ( A3 @ I2 ) ) ) ) ).

% decseq_SucD
thf(fact_7152_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) )
         => ( order_antimono @ nat @ A @ X8 ) ) ) ).

% decseq_SucI
thf(fact_7153_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F5 @ ( suc @ N2 ) ) @ ( F5 @ N2 ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_7154_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoD
thf(fact_7155_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoE
thf(fact_7156_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X5: A,Y4: A] :
              ( ( ord_less_eq @ A @ X5 @ Y4 )
             => ( ord_less_eq @ B @ ( F2 @ Y4 ) @ ( F2 @ X5 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_7157_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
             => ( ord_less_eq @ B @ ( F5 @ Y ) @ ( F5 @ X2 ) ) ) ) ) ) ).

% antimono_def
thf(fact_7158_decseq__bounded,axiom,
    ! [X8: nat > real,B4: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ B4 @ ( X8 @ I3 ) )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_7159_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L6: A,N: nat] :
          ( ( order_antimono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L6 @ ( X8 @ N ) ) ) ) ) ).

% decseq_ge
thf(fact_7160_decseq__convergent,axiom,
    ! [X8: nat > real,B4: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ B4 @ ( X8 @ I3 ) )
       => ~ ! [L7: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) )
             => ~ ! [I: nat] : ( ord_less_eq @ real @ L7 @ ( X8 @ I ) ) ) ) ) ).

% decseq_convergent
thf(fact_7161_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X8: B > C,L6: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S6: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ A2 @ ( S6 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ B @ ( S6 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S6 )
                   => ( ( filterlim @ nat @ B @ S6 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N2: nat] : ( X8 @ ( S6 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L6 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X8 @ ( topolo7230453075368039082e_nhds @ C @ L6 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_7162_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X5: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X5 )
              & ( ord_less_eq @ real @ X5 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X5: real] :
              ( ( ( ord_less @ real @ A2 @ X5 )
                & ( ord_less @ real @ X5 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X5: real] :
                  ( ( ( ord_less @ real @ A2 @ X5 )
                    & ( ord_less @ real @ X5 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C4: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C4 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C4 )
                  & ( ord_less @ real @ C4 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_7163_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X2: list @ A,Y: list @ A] :
                ? [A4: A,V5: list @ A] :
                  ( ( Y
                    = ( append @ A @ X2 @ ( cons @ A @ A4 @ V5 ) ) )
                  | ? [U3: list @ A,B3: A,C3: A,W3: list @ A,Z: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C3 ) @ R5 )
                      & ( X2
                        = ( append @ A @ U3 @ ( cons @ A @ B3 @ W3 ) ) )
                      & ( Y
                        = ( append @ A @ U3 @ ( cons @ A @ C3 @ Z ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_7164_lexord__cons__cons,axiom,
    ! [A: $tType,A2: A,X: list @ A,B2: A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A2 @ X ) @ ( cons @ A @ B2 @ Y2 ) ) @ ( lexord @ A @ R ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
        | ( ( A2 = B2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y2 ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_7165_lexord__Nil__left,axiom,
    ! [A: $tType,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y2 ) @ ( lexord @ A @ R ) )
      = ( ? [A4: A,X2: list @ A] :
            ( Y2
            = ( cons @ A @ A4 @ X2 ) ) ) ) ).

% lexord_Nil_left
thf(fact_7166_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q2: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q2 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_7167_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q2: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q2 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q2 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_7168_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_7169_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( differentiable @ A @ B
              @ ^ [X2: A] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ).

% differentiable_mult
thf(fact_7170_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,N: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( differentiable @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% differentiable_power
thf(fact_7171_lexord__append__leftI,axiom,
    ! [A: $tType,U2: list @ A,V: list @ A,R: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U2 @ V ) @ ( lexord @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U2 ) @ ( append @ A @ X @ V ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_leftI
thf(fact_7172_lexord__irreflexive,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs2: list @ A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Xs2 ) @ ( lexord @ A @ R ) ) ) ).

% lexord_irreflexive
thf(fact_7173_lexord__linear,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: list @ A,Y2: list @ A] :
      ( ! [A6: A,B6: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ B6 ) @ R )
          | ( A6 = B6 )
          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A6 ) @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y2 ) @ ( lexord @ A @ R ) )
        | ( X = Y2 )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y2 @ X ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_linear
thf(fact_7174_lexord__Nil__right,axiom,
    ! [A: $tType,X: list @ A,R: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) @ ( lexord @ A @ R ) ) ).

% lexord_Nil_right
thf(fact_7175_differentiable__diff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F4 )
         => ( ( differentiable @ A @ B @ G @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ F4 ) ) ) ) ).

% differentiable_diff
thf(fact_7176_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F4 )
         => ( ( differentiable @ A @ B @ G @ F4 )
           => ( differentiable @ A @ B
              @ ^ [X2: A] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ F4 ) ) ) ) ).

% differentiable_add
thf(fact_7177_lexord__partial__trans,axiom,
    ! [A: $tType,Xs2: list @ A,R: set @ ( product_prod @ A @ A ),Ys: list @ A,Zs: list @ A] :
      ( ! [X5: A,Y4: A,Z5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y4 ) @ R )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z5 ) @ R )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Z5 ) @ R ) ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lexord @ A @ R ) )
       => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Zs ) @ ( lexord @ A @ R ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_7178_lexord__append__leftD,axiom,
    ! [A: $tType,X: list @ A,U2: list @ A,V: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U2 ) @ ( append @ A @ X @ V ) ) @ ( lexord @ A @ R ) )
     => ( ! [A6: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ A6 ) @ R )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U2 @ V ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_append_leftD
thf(fact_7179_lexord__append__rightI,axiom,
    ! [A: $tType,Y2: list @ A,X: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ? [B10: A,Z3: list @ A] :
          ( Y2
          = ( cons @ A @ B10 @ Z3 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( append @ A @ X @ Y2 ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_rightI
thf(fact_7180_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_7181_lexord__sufE,axiom,
    ! [A: $tType,Xs2: list @ A,Zs: list @ A,Ys: list @ A,Qs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Zs ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R ) )
     => ( ( Xs2 != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs2 )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lexord @ A @ R ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_7182_lexord__lex,axiom,
    ! [A: $tType,X: list @ A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y2 ) @ ( lex @ A @ R ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y2 ) @ ( lexord @ A @ R ) )
        & ( ( size_size @ ( list @ A ) @ X )
          = ( size_size @ ( list @ A ) @ Y2 ) ) ) ) ).

% lexord_lex
thf(fact_7183_lexord__append__left__rightI,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),U2: list @ A,X: list @ A,Y2: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U2 @ ( cons @ A @ A2 @ X ) ) @ ( append @ A @ U2 @ ( cons @ A @ B2 @ Y2 ) ) ) @ ( lexord @ A @ R ) ) ) ).

% lexord_append_left_rightI
thf(fact_7184_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) @ ( append @ A @ Xs2 @ Zs ) ) @ ( lexord @ A @ R ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R ) )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_7185_lexord__sufI,axiom,
    ! [A: $tType,U2: list @ A,W: list @ A,R: set @ ( product_prod @ A @ A ),V: list @ A,Z2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U2 @ W ) @ ( lexord @ A @ R ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U2 ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U2 @ V ) @ ( append @ A @ W @ Z2 ) ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_sufI
thf(fact_7186_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_7187_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X5: real] :
              ( ( ord_less @ real @ A2 @ X5 )
             => ( ( ord_less @ real @ X5 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L4: real,Z5: real] :
              ( ( ord_less @ real @ A2 @ Z5 )
              & ( ord_less @ real @ Z5 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L4 @ ( topolo174197925503356063within @ real @ Z5 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L4 ) ) ) ) ) ) ).

% MVT
thf(fact_7188_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S @ G )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ S )
                 => ( ( G @ X5 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_7189_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X2: D] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_7190_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,N: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X2: A] : ( root @ N @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_7191_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A3: set @ C,F2: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A3 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A3
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_7192_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S: set @ C,F2: C > B,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S
            @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ N ) ) ) ) ).

% continuous_on_power
thf(fact_7193_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S
            @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_7194_continuous__on__op__minus,axiom,
    ! [A: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [S: set @ A,X: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( minus_minus @ A @ X ) ) ) ).

% continuous_on_op_minus
thf(fact_7195_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_7196_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_7197_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S
            @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_7198_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A3: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A3
              @ ^ [X2: D] : ( times_times @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_7199_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S: set @ D,F2: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_7200_continuous__on__diff,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo1633459387980952147up_add @ B ) )
     => ! [S: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S
              @ ^ [X2: D] : ( minus_minus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_diff
thf(fact_7201_continuous__on__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [S: set @ A,F2: A > B,G: A > C] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ C @ S @ G )
           => ( topolo81223032696312382ous_on @ A @ ( product_prod @ B @ C ) @ S
              @ ^ [X2: A] : ( product_Pair @ B @ C @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_Pair
thf(fact_7202_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y2: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT'
thf(fact_7203_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y2: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X5: A] :
                    ( ( ord_less_eq @ A @ A2 @ X5 )
                    & ( ord_less_eq @ A @ X5 @ B2 )
                    & ( ( F2 @ X5 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_7204_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S: set @ A,F2: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F2 ) ) ) ) ).

% continuous_on_subset
thf(fact_7205_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G: A > B,S: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S @ F2 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S
                @ ^ [X2: C] : ( G @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_7206_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A3 ) )
         => ( ! [X5: A,Y4: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ( member @ A @ Y4 @ A3 )
                 => ( ( ord_less_eq @ A @ X5 @ Y4 )
                   => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A3 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_7207_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_7208_continuous__on__arcosh_H,axiom,
    ! [A3: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F2 )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ A3 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X5 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X2: real] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_7209_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ? [C4: real,D4: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C4 @ D4 ) )
            & ( ord_less_eq @ real @ C4 @ D4 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_7210_continuous__on__arcosh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_7211_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S @ G )
           => ( ! [X5: C] :
                  ( ( member @ C @ X5 @ S )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
                    & ( ( ( F2 @ X5 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X5 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S
                @ ^ [X2: C] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_7212_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S @ G )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ S )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) )
             => ( ! [X5: A] :
                    ( ( member @ A @ X5 @ S )
                   => ( ( F2 @ X5 )
                     != ( one_one @ real ) ) )
               => ( ! [X5: A] :
                      ( ( member @ A @ X5 @ S )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X5 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S
                    @ ^ [X2: A] : ( log @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_7213_continuous__on__arccos_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arccos ).

% continuous_on_arccos'
thf(fact_7214_continuous__on__arcsin_H,axiom,
    topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) @ arcsin ).

% continuous_on_arcsin'
thf(fact_7215_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X5 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X5 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X2: A] : ( arccos @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_7216_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S @ F2 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ S )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X5 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X5 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S
              @ ^ [X2: A] : ( arcsin @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_7217_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X5: A] :
              ( ( ord_less_eq @ A @ A2 @ X5 )
             => ( ( ord_less_eq @ A @ X5 @ B2 )
               => ? [Y3: A] : ( has_field_derivative @ A @ F2 @ Y3 @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_7218_continuous__on__artanh_H,axiom,
    ! [A3: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F2 )
     => ( ! [X5: real] :
            ( ( member @ real @ X5 @ A3 )
           => ( member @ real @ ( F2 @ X5 ) @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X2: real] : ( artanh @ real @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_artanh'
thf(fact_7219_mvt,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X5: real] :
              ( ( ord_less @ real @ A2 @ X5 )
             => ( ( ord_less @ real @ X5 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                   != ( F8 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_7220_continuous__on__of__int__floor,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X2: A] : ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ).

% continuous_on_of_int_floor
thf(fact_7221_continuous__on__of__int__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A )
        & ( ring_1 @ B )
        & ( topolo4958980785337419405_space @ B ) )
     => ( topolo81223032696312382ous_on @ A @ B @ ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( ring_1_Ints @ A ) )
        @ ^ [X2: A] : ( ring_1_of_int @ B @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ).

% continuous_on_of_int_ceiling
thf(fact_7222_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_7223_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_7224_continuous__on__artanh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_7225_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: real > real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X5: real] :
              ( ( ord_less @ real @ A2 @ X5 )
             => ( ( ord_less @ real @ X5 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X )
           => ( ( ord_less_eq @ real @ X @ B2 )
             => ( ( F2 @ X )
                = ( F2 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_7226_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X5: A] :
                  ( ( ord_less @ A @ A2 @ X5 )
                 => ( ( ord_less @ A @ X5 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X5 ) ) @ ( topolo174197925503356063within @ A @ X5 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_7227_eventually__filtercomap__at__topological,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ B )
     => ! [P: A > $o,F2: A > B,A3: B,B4: set @ B] :
          ( ( eventually @ A @ P @ ( filtercomap @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ A3 @ B4 ) ) )
          = ( ? [S5: set @ B] :
                ( ( topolo1002775350975398744n_open @ B @ S5 )
                & ( member @ B @ A3 @ S5 )
                & ! [X2: A] :
                    ( ( member @ B @ ( F2 @ X2 ) @ ( minus_minus @ ( set @ B ) @ ( inf_inf @ ( set @ B ) @ S5 @ B4 ) @ ( insert @ B @ A3 @ ( bot_bot @ ( set @ B ) ) ) ) )
                   => ( P @ X2 ) ) ) ) ) ) ).

% eventually_filtercomap_at_topological
thf(fact_7228_relpow__finite__bounded1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R2 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
              @ ( collect @ nat
                @ ^ [N2: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                    & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_7229_relpow__1,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( one_one @ nat ) @ R2 )
      = R2 ) ).

% relpow_1
thf(fact_7230_finite__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% finite_relpow
thf(fact_7231_filtercomap__mono,axiom,
    ! [B: $tType,A: $tType,F4: filter @ A,F11: filter @ A,F2: B > A] :
      ( ( ord_less_eq @ ( filter @ A ) @ F4 @ F11 )
     => ( ord_less_eq @ ( filter @ B ) @ ( filtercomap @ B @ A @ F2 @ F4 ) @ ( filtercomap @ B @ A @ F2 @ F11 ) ) ) ).

% filtercomap_mono
thf(fact_7232_filtercomap__sup,axiom,
    ! [A: $tType,B: $tType,F2: A > B,F13: filter @ B,F24: filter @ B] : ( ord_less_eq @ ( filter @ A ) @ ( sup_sup @ ( filter @ A ) @ ( filtercomap @ A @ B @ F2 @ F13 ) @ ( filtercomap @ A @ B @ F2 @ F24 ) ) @ ( filtercomap @ A @ B @ F2 @ ( sup_sup @ ( filter @ B ) @ F13 @ F24 ) ) ) ).

% filtercomap_sup
thf(fact_7233_relpowp__relpow__eq,axiom,
    ! [A: $tType,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( A > A > $o ) @ N
        @ ^ [X2: A,Y: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R2 ) )
      = ( ^ [X2: A,Y: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpowp_relpow_eq
thf(fact_7234_relpow__Suc__I2,axiom,
    ! [A: $tType,X: A,Y2: A,R2: set @ ( product_prod @ A @ A ),Z2: A,N: nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) ) ) ) ).

% relpow_Suc_I2
thf(fact_7235_relpow__Suc__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) )
     => ~ ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ R2 )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpow_Suc_E2
thf(fact_7236_relpow__Suc__D2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) )
     => ? [Y4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpow_Suc_D2
thf(fact_7237_relpow__Suc__I,axiom,
    ! [A: $tType,X: A,Y2: A,N: nat,R2: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) ) ) ) ).

% relpow_Suc_I
thf(fact_7238_relpow__Suc__E,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N ) @ R2 ) )
     => ~ ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z2 ) @ R2 ) ) ) ).

% relpow_Suc_E
thf(fact_7239_relpow__Suc__D2_H,axiom,
    ! [A: $tType,N: nat,R2: set @ ( product_prod @ A @ A ),X3: A,Y3: A,Z3: A] :
      ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ Z3 ) @ R2 ) )
     => ? [W2: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ W2 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ W2 @ Z3 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ) ).

% relpow_Suc_D2'
thf(fact_7240_relpow__0__I,axiom,
    ! [A: $tType,X: A,R2: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R2 ) ) ).

% relpow_0_I
thf(fact_7241_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R2 ) )
     => ( X = Y2 ) ) ).

% relpow_0_E
thf(fact_7242_filterlim__iff__le__filtercomap,axiom,
    ! [B: $tType,A: $tType] :
      ( ( filterlim @ A @ B )
      = ( ^ [F5: A > B,F9: filter @ B,G9: filter @ A] : ( ord_less_eq @ ( filter @ A ) @ G9 @ ( filtercomap @ A @ B @ F5 @ F9 ) ) ) ) ).

% filterlim_iff_le_filtercomap
thf(fact_7243_relpow__E2,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y4: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ R2 )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R2 ) ) ) ) ) ) ).

% relpow_E2
thf(fact_7244_relpow__E,axiom,
    ! [A: $tType,X: A,Z2: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z2 ) )
       => ~ ! [Y4: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R2 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z2 ) @ R2 ) ) ) ) ) ).

% relpow_E
thf(fact_7245_eventually__filtercomap__at__top__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_top @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less_eq @ A @ N6 @ ( F2 @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_top_linorder
thf(fact_7246_eventually__filtercomap__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_top @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less @ A @ N6 @ ( F2 @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_top_dense
thf(fact_7247_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_7248_eventually__filtercomap__at__bot__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_bot @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less_eq @ A @ ( F2 @ X2 ) @ N6 )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_bot_linorder
thf(fact_7249_eventually__filtercomap__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_bot @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less @ A @ ( F2 @ X2 ) @ N6 )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_bot_dense
thf(fact_7250_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) )
      = ( ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F5 @ N )
              = B2 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F5 @ I4 ) @ ( F5 @ ( suc @ I4 ) ) ) @ R2 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_7251_filtercomap__SUP,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > C,F4: B > ( filter @ C ),B4: set @ B] :
      ( ord_less_eq @ ( filter @ A )
      @ ( complete_Sup_Sup @ ( filter @ A )
        @ ( image @ B @ ( filter @ A )
          @ ^ [B3: B] : ( filtercomap @ A @ C @ F2 @ ( F4 @ B3 ) )
          @ B4 ) )
      @ ( filtercomap @ A @ C @ F2 @ ( complete_Sup_Sup @ ( filter @ C ) @ ( image @ B @ ( filter @ C ) @ F4 @ B4 ) ) ) ) ).

% filtercomap_SUP
thf(fact_7252_relpow__finite__bounded,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R2 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_7253_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N2: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I4: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I4 @ R6 )
              @ ( collect @ nat
                @ ^ [I4: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I4 )
                    & ( ord_less_eq @ nat @ I4 @ ( suc @ N2 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_7254_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_trancl @ A @ R2 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
            @ ( collect @ nat
              @ ^ [N2: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
                  & ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_7255_trancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ R )
       => ~ ! [B6: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B6 ) @ ( transitive_trancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A22 ) @ R ) ) ) ) ).

% trancl.cases
thf(fact_7256_trancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R ) )
      = ( ? [A4: A,B3: A] :
            ( ( A1 = A4 )
            & ( A22 = B3 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ R ) )
        | ? [A4: A,B3: A,C3: A] :
            ( ( A1 = A4 )
            & ( A22 = C3 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( transitive_trancl @ A @ R ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C3 ) @ R ) ) ) ) ).

% trancl.simps
thf(fact_7257_trancl_Or__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) ) ) ).

% trancl.r_into_trancl
thf(fact_7258_tranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
       => ~ ! [C4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C4 ) @ ( transitive_trancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ C4 @ B2 ) @ R ) ) ) ) ).

% tranclE
thf(fact_7259_trancl__trans,axiom,
    ! [A: $tType,X: A,Y2: A,R: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_trans
thf(fact_7260_trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ R )
           => ( P @ Y4 ) )
       => ( ! [Y4: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ ( transitive_trancl @ A @ R ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z5 ) @ R )
               => ( ( P @ Y4 )
                 => ( P @ Z5 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% trancl_induct
thf(fact_7261_r__r__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R2 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ).

% r_r_into_trancl
thf(fact_7262_converse__tranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ R )
       => ~ ! [Y4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ R )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% converse_tranclE
thf(fact_7263_irrefl__trancl__rD,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: A,Y2: A] :
      ( ! [X5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R )
       => ( X != Y2 ) ) ) ).

% irrefl_trancl_rD
thf(fact_7264_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% Transitive_Closure.trancl_into_trancl
thf(fact_7265_trancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_into_trancl2
thf(fact_7266_trancl__trans__induct,axiom,
    ! [A: $tType,X: A,Y2: A,R: set @ ( product_prod @ A @ A ),P: A > A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [X5: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y4 ) @ R )
           => ( P @ X5 @ Y4 ) )
       => ( ! [X5: A,Y4: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y4 ) @ ( transitive_trancl @ A @ R ) )
             => ( ( P @ X5 @ Y4 )
               => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z5 ) @ ( transitive_trancl @ A @ R ) )
                 => ( ( P @ Y4 @ Z5 )
                   => ( P @ X5 @ Z5 ) ) ) ) )
         => ( P @ X @ Y2 ) ) ) ) ).

% trancl_trans_induct
thf(fact_7267_converse__trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ B2 ) @ R )
           => ( P @ Y4 ) )
       => ( ! [Y4: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z5 ) @ R )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ B2 ) @ ( transitive_trancl @ A @ R ) )
               => ( ( P @ Z5 )
                 => ( P @ Y4 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_trancl_induct
thf(fact_7268_trancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ! [A6: A,B6: B] :
            ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ R )
           => ( P @ A6 @ B6 ) )
       => ( ! [A6: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
               => ( ( P @ A6 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% trancl_induct2
thf(fact_7269_trancl__mono,axiom,
    ! [A: $tType,P2: product_prod @ A @ A,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P2 @ ( transitive_trancl @ A @ R ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
       => ( member @ ( product_prod @ A @ A ) @ P2 @ ( transitive_trancl @ A @ S ) ) ) ) ).

% trancl_mono
thf(fact_7270_finite__trancl__ntranl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_trancl @ A @ R2 )
        = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) @ ( one_one @ nat ) ) @ R2 ) ) ) ).

% finite_trancl_ntranl
thf(fact_7271_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs2: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs2 ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs2 ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs2 ) ) ) ).

% trancl_set_ntrancl
thf(fact_7272_trancl__power,axiom,
    ! [A: $tType,P2: product_prod @ A @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P2 @ ( transitive_trancl @ A @ R2 ) )
      = ( ? [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( member @ ( product_prod @ A @ A ) @ P2 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 ) ) ) ) ) ).

% trancl_power
thf(fact_7273_trancl__insert2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X2: A,Y: A] :
                ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A2 ) @ ( transitive_trancl @ A @ R ) )
                  | ( X2 = A2 ) )
                & ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y ) @ ( transitive_trancl @ A @ R ) )
                  | ( Y = B2 ) ) ) ) ) ) ) ).

% trancl_insert2
thf(fact_7274_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( finite_Fpow @ B @ A3 ) ) @ ( finite_Fpow @ A @ B4 ) ) ) ).

% image_Fpow_mono
thf(fact_7275_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,C5: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C5 )
               => ( topolo1002775350975398744n_open @ A @ ( F2 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C5 ) ) )
             => ~ ! [C8: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C8 @ C5 )
                   => ( ( finite_finite @ B @ C8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C8 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_7276_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ S2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S2 )
                   => ( ord_less_eq @ A @ X5 @ Xa ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_7277_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S2: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X5: A] :
                ( ( member @ A @ X5 @ S2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S2 )
                   => ( ord_less_eq @ A @ Xa @ X5 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_7278_compact__diff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T4: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ T4 )
           => ( topolo2193935891317330818ompact @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T4 ) ) ) ) ) ).

% compact_diff
thf(fact_7279_Fpow__mono,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) @ ( finite_Fpow @ A @ B4 ) ) ) ).

% Fpow_mono
thf(fact_7280_Fpow__subset__Pow,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) @ ( pow2 @ A @ A3 ) ) ).

% Fpow_subset_Pow
thf(fact_7281_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ S )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S )
                     => ( ord_less_eq @ B @ ( F2 @ Xa ) @ ( F2 @ X5 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_7282_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S @ F2 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ S )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S )
                     => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Xa ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_7283_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X4: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X4 @ A7 )
                & ( finite_finite @ A @ X4 ) ) ) ) ) ).

% Fpow_def
thf(fact_7284_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S5: set @ A] :
            ! [C9: set @ ( set @ A )] :
              ( ( ! [X2: set @ A] :
                    ( ( member @ ( set @ A ) @ X2 @ C9 )
                   => ( topolo1002775350975398744n_open @ A @ X2 ) )
                & ( ord_less_eq @ ( set @ A ) @ S5 @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) )
             => ? [D7: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D7 @ C9 )
                  & ( finite_finite @ ( set @ A ) @ D7 )
                  & ( ord_less_eq @ ( set @ A ) @ S5 @ ( complete_Sup_Sup @ ( set @ A ) @ D7 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_7285_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A] :
          ( ! [C7: set @ ( set @ A )] :
              ( ! [X3: set @ A] :
                  ( ( member @ ( set @ A ) @ X3 @ C7 )
                 => ( topolo1002775350975398744n_open @ A @ X3 ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C7 ) )
               => ? [C10: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C10 @ C7 )
                    & ( finite_finite @ ( set @ A ) @ C10 )
                    & ( ord_less_eq @ ( set @ A ) @ S @ ( complete_Sup_Sup @ ( set @ A ) @ C10 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S ) ) ) ).

% compactI
thf(fact_7286_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B9: set @ A] :
                  ( ( member @ ( set @ A ) @ B9 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B9 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_7287_Id__on__def,axiom,
    ! [A: $tType] :
      ( ( id_on @ A )
      = ( ^ [A7: set @ A] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [X2: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
              @ A7 ) ) ) ) ).

% Id_on_def
thf(fact_7288_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B4: set @ A,X: B,A3: set @ ( product_prod @ B @ A )] :
      ( ( finite_finite @ A @ B4 )
     => ( ( sup_sup @ ( set @ ( product_prod @ B @ A ) )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ B @ A ) )
              @ ^ [Y: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
              @ B4 ) )
          @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
          @ ^ [Y: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) )
          @ A3
          @ B4 ) ) ) ).

% fold_union_pair
thf(fact_7289_Id__onI,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( id_on @ A @ A3 ) ) ) ).

% Id_onI
thf(fact_7290_Id__on__fold,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( id_on @ A @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ A @ A ) )
          @ ^ [X2: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) )
          @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) )
          @ A3 ) ) ) ).

% Id_on_fold
thf(fact_7291_Id__on__iff,axiom,
    ! [A: $tType,X: A,Y2: A,A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( id_on @ A @ A3 ) )
      = ( ( X = Y2 )
        & ( member @ A @ X @ A3 ) ) ) ).

% Id_on_iff
thf(fact_7292_Id__on__eqI,axiom,
    ! [A: $tType,A2: A,B2: A,A3: set @ A] :
      ( ( A2 = B2 )
     => ( ( member @ A @ A2 @ A3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id_on @ A @ A3 ) ) ) ) ).

% Id_on_eqI
thf(fact_7293_Id__onE,axiom,
    ! [A: $tType,C2: product_prod @ A @ A,A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ C2 @ ( id_on @ A @ A3 ) )
     => ~ ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( C2
             != ( product_Pair @ A @ A @ X5 @ X5 ) ) ) ) ).

% Id_onE
thf(fact_7294_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G4: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_7295_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G4: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G4 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_7296_the__elem__set,axiom,
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) ).

% the_elem_set
thf(fact_7297_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F3: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ B2 @ ( F3 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F3 @ N9 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F3 )
                   => ( ( filterlim @ nat @ A @ F3 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N2: nat] : ( P @ ( F3 @ N2 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_7298_incseq__bounded,axiom,
    ! [X8: nat > real,B4: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( X8 @ I3 ) @ B4 )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_7299_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A3: A,B4: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A3 ) @ ( F2 @ B4 ) ) @ ( F2 @ ( sup_sup @ A @ A3 @ B4 ) ) ) ) ) ).

% mono_sup
thf(fact_7300_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) )
           => ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ).

% mono_invE
thf(fact_7301_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) ) ) ) ) ).

% monoD
thf(fact_7302_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) ) ) ) ) ).

% monoE
thf(fact_7303_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X5: A,Y4: A] :
              ( ( ord_less_eq @ A @ X5 @ Y4 )
             => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_7304_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
             => ( ord_less_eq @ B @ ( F5 @ X2 ) @ ( F5 @ Y ) ) ) ) ) ) ).

% mono_def
thf(fact_7305_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I2: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( F2 @ J ) ) ) ) ) ).

% incseqD
thf(fact_7306_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X4: nat > A] :
            ! [M3: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N2 )
             => ( ord_less_eq @ A @ ( X4 @ M3 ) @ ( X4 @ N2 ) ) ) ) ) ) ).

% incseq_def
thf(fact_7307_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I2: nat] :
          ( ( order_mono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ I2 ) @ ( A3 @ ( suc @ I2 ) ) ) ) ) ).

% incseq_SucD
thf(fact_7308_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
         => ( order_mono @ nat @ A @ X8 ) ) ) ).

% incseq_SucI
thf(fact_7309_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N2: nat] : ( ord_less_eq @ A @ ( F5 @ N2 ) @ ( F5 @ ( suc @ N2 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_7310_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A3: A,B4: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A3 @ B4 ) ) @ ( inf_inf @ B @ ( F2 @ A3 ) @ ( F2 @ B4 ) ) ) ) ) ).

% mono_inf
thf(fact_7311_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_7312_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) )
           => ( ord_less @ A @ X @ Y2 ) ) ) ) ).

% mono_strict_invE
thf(fact_7313_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_7314_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_7315_mono__times__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N ) ) ) ).

% mono_times_nat
thf(fact_7316_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ) ).

% mono_pow
thf(fact_7317_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_7318_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A3: A,B4: A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A3 @ B4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ A3 ) @ ( compow @ ( A > A ) @ N @ F2 @ B4 ) ) ) ) ) ).

% funpow_mono
thf(fact_7319_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P2: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P2 @ ( F2 @ P2 ) )
           => ( ord_less_eq @ A @ P2 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_7320_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P2: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P2 ) @ P2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P2 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_7321_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I2: nat,J: nat,X: A,Y2: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less_eq @ A @ X @ Y2 )
             => ( ( ord_less_eq @ A @ X @ ( F2 @ X ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I2 @ F2 @ X ) @ ( compow @ ( A > A ) @ J @ F2 @ Y2 ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_7322_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N: A,M6: B,N5: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
              = ( set_or7035219750837199246ssThan @ B @ M6 @ N5 ) )
           => ( ( ord_less @ A @ M @ N )
             => ( ( F2 @ M )
                = M6 ) ) ) ) ) ).

% mono_image_least
thf(fact_7323_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                @ I5 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I5 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_7324_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% mono_Sup
thf(fact_7325_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ) ).

% mono_Inf
thf(fact_7326_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I5 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A3 @ X2 ) )
                @ I5 ) ) ) ) ) ).

% mono_INF
thf(fact_7327_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_7328_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L6: A,N: nat] :
          ( ( order_mono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X8 @ N ) @ L6 ) ) ) ) ).

% incseq_le
thf(fact_7329_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_7330_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_7331_incseq__convergent,axiom,
    ! [X8: nat > real,B4: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I3: nat] : ( ord_less_eq @ real @ ( X8 @ I3 ) @ B4 )
       => ~ ! [L7: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L7 ) @ ( at_top @ nat ) )
             => ~ ! [I: nat] : ( ord_less_eq @ real @ ( X8 @ I ) @ L7 ) ) ) ) ).

% incseq_convergent
thf(fact_7332_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X2: A] : X2 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_7333_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M3 ) @ M3 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_7334_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N3: nat] :
                  ( ( ( F2 @ N3 )
                    = ( F2 @ ( suc @ N3 ) ) )
                 => ( ( F2 @ ( suc @ N3 ) )
                    = ( F2 @ ( suc @ ( suc @ N3 ) ) ) ) )
             => ? [N8: nat] :
                  ( ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N8 )
                     => ! [M2: nat] :
                          ( ( ord_less_eq @ nat @ M2 @ N8 )
                         => ( ( ord_less @ nat @ M2 @ N9 )
                           => ( ord_less @ A @ ( F2 @ M2 ) @ ( F2 @ N9 ) ) ) ) )
                  & ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ N9 )
                     => ( ( F2 @ N8 )
                        = ( F2 @ N9 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_7335_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X8: B > A,L6: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S6: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ ( S6 @ N9 ) @ A2 )
               => ( ! [N9: nat] : ( ord_less @ B @ B2 @ ( S6 @ N9 ) )
                 => ( ( order_mono @ nat @ B @ S6 )
                   => ( ( filterlim @ nat @ B @ S6 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N2: nat] : ( X8 @ ( S6 @ N2 ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L6 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L6 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_7336_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs2 )
        = Ys )
      = ( ? [F5: nat > nat] :
            ( ( order_mono @ nat @ nat @ F5 )
            & ( ( image @ nat @ nat @ F5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( nth @ A @ Xs2 @ I4 )
                  = ( nth @ A @ Ys @ ( F5 @ I4 ) ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ( ( nth @ A @ Xs2 @ I4 )
                    = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) )
                  = ( ( F5 @ I4 )
                    = ( F5 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_7337_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B ),X: product_prod @ C @ A,X8: set @ ( product_prod @ C @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S2 )
     => ( ( sup_sup @ ( set @ ( product_prod @ C @ B ) ) @ ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X @ ( bot_bot @ ( set @ ( product_prod @ C @ A ) ) ) ) @ S2 ) @ X8 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z: B,A17: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X ) @ Z ) @ A17 )
                @ A17 ) )
          @ X8
          @ S2 ) ) ) ).

% insert_relcomp_union_fold
thf(fact_7338_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( remdups_adj @ A @ Xs2 )
        = ( nil @ A ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_7339_remdups__adj__set,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs2 ) )
      = ( set2 @ A @ Xs2 ) ) ).

% remdups_adj_set
thf(fact_7340_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A3: set @ A,B4: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ A3 ) @ ( F2 @ B4 ) ) @ ( F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) ) ) ) ).

% mono_Un
thf(fact_7341_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A3: set @ A,B4: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A3 ) @ ( F2 @ B4 ) ) ) ) ).

% mono_Int
thf(fact_7342_tranclp_Omono,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P5: A > A > $o,X17: A,X24: A] :
          ( ? [A4: A,B3: A] :
              ( ( X17 = A4 )
              & ( X24 = B3 )
              & ( R @ A4 @ B3 ) )
          | ? [A4: A,B3: A,C3: A] :
              ( ( X17 = A4 )
              & ( X24 = C3 )
              & ( P5 @ A4 @ B3 )
              & ( R @ B3 @ C3 ) ) ) ) ).

% tranclp.mono
thf(fact_7343_rtranclp_Omono,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( order_mono @ ( A > A > $o ) @ ( A > A > $o )
      @ ^ [P5: A > A > $o,X17: A,X24: A] :
          ( ? [A4: A] :
              ( ( X17 = A4 )
              & ( X24 = A4 ) )
          | ? [A4: A,B3: A,C3: A] :
              ( ( X17 = A4 )
              & ( X24 = C3 )
              & ( P5 @ A4 @ B3 )
              & ( R @ B3 @ C3 ) ) ) ) ).

% rtranclp.mono
thf(fact_7344_relpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,R2: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( plus_plus @ nat @ M @ N ) @ R2 )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M @ R2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R2 ) ) ) ).

% relpow_add
thf(fact_7345_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( remdups_adj @ A @ Xs2 )
        = Xs2 ) ) ).

% remdups_adj_distinct
thf(fact_7346_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Y2: A,Xs2: list @ A] :
      ( ( ( X = Y2 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X @ Xs2 ) ) ) )
      & ( ( X != Y2 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) ) )
          = ( cons @ A @ X @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_7347_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_7348_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_7349_remdups__adj_Oelims,axiom,
    ! [A: $tType,X: list @ A,Y2: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y2 )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y2
           != ( nil @ A ) ) )
       => ( ! [X5: A] :
              ( ( X
                = ( cons @ A @ X5 @ ( nil @ A ) ) )
             => ( Y2
               != ( cons @ A @ X5 @ ( nil @ A ) ) ) )
         => ~ ! [X5: A,Y4: A,Xs3: list @ A] :
                ( ( X
                  = ( cons @ A @ X5 @ ( cons @ A @ Y4 @ Xs3 ) ) )
               => ~ ( ( ( X5 = Y4 )
                     => ( Y2
                        = ( remdups_adj @ A @ ( cons @ A @ X5 @ Xs3 ) ) ) )
                    & ( ( X5 != Y4 )
                     => ( Y2
                        = ( cons @ A @ X5 @ ( remdups_adj @ A @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_7350_relcomp_Ocases,axiom,
    ! [A: $tType,C: $tType,B: $tType,A1: A,A22: C,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A1 @ A22 ) @ ( relcomp @ A @ B @ C @ R @ S ) )
     => ~ ! [B6: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A1 @ B6 ) @ R )
           => ~ ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B6 @ A22 ) @ S ) ) ) ).

% relcomp.cases
thf(fact_7351_relcomp_Osimps,axiom,
    ! [B: $tType,C: $tType,A: $tType,A1: A,A22: C,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A1 @ A22 ) @ ( relcomp @ A @ B @ C @ R @ S ) )
      = ( ? [A4: A,B3: B,C3: C] :
            ( ( A1 = A4 )
            & ( A22 = C3 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ R )
            & ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B3 @ C3 ) @ S ) ) ) ) ).

% relcomp.simps
thf(fact_7352_relcomp_OrelcompI,axiom,
    ! [A: $tType,C: $tType,B: $tType,A2: A,B2: B,R: set @ ( product_prod @ A @ B ),C2: C,S: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B2 @ C2 ) @ S )
       => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ C2 ) @ ( relcomp @ A @ B @ C @ R @ S ) ) ) ) ).

% relcomp.relcompI
thf(fact_7353_relcompE,axiom,
    ! [A: $tType,B: $tType,C: $tType,Xz: product_prod @ A @ B,R: set @ ( product_prod @ A @ C ),S: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Xz @ ( relcomp @ A @ C @ B @ R @ S ) )
     => ~ ! [X5: A,Y4: C,Z5: B] :
            ( ( Xz
              = ( product_Pair @ A @ B @ X5 @ Z5 ) )
           => ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X5 @ Y4 ) @ R )
             => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y4 @ Z5 ) @ S ) ) ) ) ).

% relcompE
thf(fact_7354_relcompEpair,axiom,
    ! [A: $tType,B: $tType,C: $tType,A2: A,C2: B,R: set @ ( product_prod @ A @ C ),S: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ C2 ) @ ( relcomp @ A @ C @ B @ R @ S ) )
     => ~ ! [B6: C] :
            ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ B6 ) @ R )
           => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ B6 @ C2 ) @ S ) ) ) ).

% relcompEpair
thf(fact_7355_relcomp__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType,R3: set @ ( product_prod @ A @ B ),R: set @ ( product_prod @ A @ B ),S8: set @ ( product_prod @ B @ C ),S: set @ ( product_prod @ B @ C )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ R )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S8 @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R3 @ S8 ) @ ( relcomp @ A @ B @ C @ R @ S ) ) ) ) ).

% relcomp_mono
thf(fact_7356_remdups__adj__length,axiom,
    ! [A: $tType,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% remdups_adj_length
thf(fact_7357_trancl__Int__subset,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R ) @ S ) @ R ) @ S )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R ) @ S ) ) ) ).

% trancl_Int_subset
thf(fact_7358_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs2: list @ A,X: A,Y2: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X = Y2 ) @ ( nil @ A ) @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_7359_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ C ),S7: set @ ( product_prod @ C @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X2: A,Z: B] :
                ? [Y: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Y ) @ R5 )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y @ Z ) @ S7 ) ) ) ) ) ) ).

% relcomp_unfold
thf(fact_7360_finite_Omono,axiom,
    ! [A: $tType] :
      ( order_mono @ ( ( set @ A ) > $o ) @ ( ( set @ A ) > $o )
      @ ^ [P5: ( set @ A ) > $o,X2: set @ A] :
          ( ( X2
            = ( bot_bot @ ( set @ A ) ) )
          | ? [A7: set @ A,A4: A] :
              ( ( X2
                = ( insert @ A @ A4 @ A7 ) )
              & ( P5 @ A7 ) ) ) ) ).

% finite.mono
thf(fact_7361_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X24: list @ A] :
          ( ? [Y: A,Ys3: list @ A] :
              ( ( X17
                = ( nil @ A ) )
              & ( X24
                = ( cons @ A @ Y @ Ys3 ) ) )
          | ? [X2: A,Y: A,Xs: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X2 @ Xs ) )
              & ( X24
                = ( cons @ A @ Y @ Ys3 ) )
              & ( Less @ X2 @ Y ) )
          | ? [X2: A,Y: A,Xs: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X2 @ Xs ) )
              & ( X24
                = ( cons @ A @ Y @ Ys3 ) )
              & ~ ( Less @ X2 @ Y )
              & ~ ( Less @ Y @ X2 )
              & ( P5 @ Xs @ Ys3 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_7362_remdups__adj__adjacent,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I2 ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ I2 )
       != ( nth @ A @ ( remdups_adj @ A @ Xs2 ) @ ( suc @ I2 ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_7363_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_7364_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( ( remdups_adj @ A @ Xs2 )
        = ( cons @ A @ X @ ( nil @ A ) ) )
     => ( Xs2
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ X ) ) ) ).

% remdups_adj_singleton
thf(fact_7365_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R2: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ B @ C )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ R2 )
     => ( ( finite_finite @ ( product_prod @ B @ C ) @ S2 )
       => ( ( relcomp @ A @ B @ C @ R2 @ S2 )
          = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ A @ C ) )
            @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
              @ ^ [X2: A,Y: B,A7: set @ ( product_prod @ A @ C )] :
                  ( finite_fold @ ( product_prod @ B @ C ) @ ( set @ ( product_prod @ A @ C ) )
                  @ ( product_case_prod @ B @ C @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
                    @ ^ [W3: B,Z: C,A17: set @ ( product_prod @ A @ C )] : ( if @ ( set @ ( product_prod @ A @ C ) ) @ ( Y = W3 ) @ ( insert @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X2 @ Z ) @ A17 ) @ A17 ) )
                  @ A7
                  @ S2 ) )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) )
            @ R2 ) ) ) ) ).

% relcomp_fold
thf(fact_7366_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X24: list @ A] :
            ( ? [Y: A,Ys3: list @ A] :
                ( ( X17
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) ) )
            | ? [X2: A,Y: A,Xs: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X2 @ Xs ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) )
                & ( ord_less @ A @ X2 @ Y ) )
            | ? [X2: A,Y: A,Xs: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X2 @ Xs ) )
                & ( X24
                  = ( cons @ A @ Y @ Ys3 ) )
                & ~ ( ord_less @ A @ X2 @ Y )
                & ~ ( ord_less @ A @ Y @ X2 )
                & ( P5 @ Xs @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_7367_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_7368_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S2: set @ ( product_prod @ A @ B ),X: product_prod @ C @ A,R2: set @ ( product_prod @ C @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S2 )
     => ( ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X @ R2 ) @ S2 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z: B,A17: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X ) @ Z ) @ A17 )
                @ A17 ) )
          @ ( relcomp @ C @ A @ B @ R2 @ S2 )
          @ S2 ) ) ) ).

% insert_relcomp_fold
thf(fact_7369_remdups__adj_Opelims,axiom,
    ! [A: $tType,X: list @ A,Y2: list @ A] :
      ( ( ( remdups_adj @ A @ X )
        = Y2 )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ A ) )
           => ( ( Y2
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X5: A] :
                ( ( X
                  = ( cons @ A @ X5 @ ( nil @ A ) ) )
               => ( ( Y2
                    = ( cons @ A @ X5 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X5 @ ( nil @ A ) ) ) ) )
           => ~ ! [X5: A,Y4: A,Xs3: list @ A] :
                  ( ( X
                    = ( cons @ A @ X5 @ ( cons @ A @ Y4 @ Xs3 ) ) )
                 => ( ( ( ( X5 = Y4 )
                       => ( Y2
                          = ( remdups_adj @ A @ ( cons @ A @ X5 @ Xs3 ) ) ) )
                      & ( ( X5 != Y4 )
                       => ( Y2
                          = ( cons @ A @ X5 @ ( remdups_adj @ A @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X5 @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_7370_min__ext__compat,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R2 @ S2 ) @ R2 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R2 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S2 ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R2 ) ) ) ).

% min_ext_compat
thf(fact_7371_max__ext__compat,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R2 @ S2 ) @ R2 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R2 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S2 ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R2 ) ) ) ).

% max_ext_compat
thf(fact_7372_comp__fun__commute__relcomp__fold,axiom,
    ! [A: $tType,B: $tType,C: $tType,S2: set @ ( product_prod @ A @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S2 )
     => ( finite6289374366891150609ommute @ ( product_prod @ C @ A ) @ ( set @ ( product_prod @ C @ B ) )
        @ ( product_case_prod @ C @ A @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
          @ ^ [X2: C,Y: A,A7: set @ ( product_prod @ C @ B )] :
              ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
              @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
                @ ^ [W3: A,Z: B,A17: set @ ( product_prod @ C @ B )] : ( if @ ( set @ ( product_prod @ C @ B ) ) @ ( Y = W3 ) @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ X2 @ Z ) @ A17 ) @ A17 ) )
              @ A7
              @ S2 ) ) ) ) ).

% comp_fun_commute_relcomp_fold
thf(fact_7373_max__ext__additive,axiom,
    ! [A: $tType,A3: set @ A,B4: set @ A,R2: set @ ( product_prod @ A @ A ),C5: set @ A,D5: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A3 @ B4 ) @ ( max_ext @ A @ R2 ) )
     => ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ C5 @ D5 ) @ ( max_ext @ A @ R2 ) )
       => ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ C5 ) @ ( sup_sup @ ( set @ A ) @ B4 @ D5 ) ) @ ( max_ext @ A @ R2 ) ) ) ) ).

% max_ext_additive
thf(fact_7374_max__ext_Ocases,axiom,
    ! [A: $tType,A1: set @ A,A22: set @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A1 @ A22 ) @ ( max_ext @ A @ R2 ) )
     => ~ ( ( finite_finite @ A @ A1 )
         => ( ( finite_finite @ A @ A22 )
           => ( ( A22
               != ( bot_bot @ ( set @ A ) ) )
             => ~ ! [X3: A] :
                    ( ( member @ A @ X3 @ A1 )
                   => ? [Xa3: A] :
                        ( ( member @ A @ Xa3 @ A22 )
                        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Xa3 ) @ R2 ) ) ) ) ) ) ) ).

% max_ext.cases
thf(fact_7375_max__ext_Osimps,axiom,
    ! [A: $tType,A1: set @ A,A22: set @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A1 @ A22 ) @ ( max_ext @ A @ R2 ) )
      = ( ( finite_finite @ A @ A1 )
        & ( finite_finite @ A @ A22 )
        & ( A22
         != ( bot_bot @ ( set @ A ) ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ A1 )
           => ? [Y: A] :
                ( ( member @ A @ Y @ A22 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R2 ) ) ) ) ) ).

% max_ext.simps
thf(fact_7376_max__ext_Omax__extI,axiom,
    ! [A: $tType,X8: set @ A,Y8: set @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ A @ X8 )
     => ( ( finite_finite @ A @ Y8 )
       => ( ( Y8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ X8 )
               => ? [Xa: A] :
                    ( ( member @ A @ Xa @ Y8 )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Xa ) @ R2 ) ) )
           => ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X8 @ Y8 ) @ ( max_ext @ A @ R2 ) ) ) ) ) ) ).

% max_ext.max_extI
thf(fact_7377_comp__fun__commute__product__fold,axiom,
    ! [A: $tType,B: $tType,B4: set @ A] :
      ( ( finite_finite @ A @ B4 )
     => ( finite6289374366891150609ommute @ B @ ( set @ ( product_prod @ B @ A ) )
        @ ^ [X2: B,Z: set @ ( product_prod @ B @ A )] :
            ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
            @ ^ [Y: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y ) )
            @ Z
            @ B4 ) ) ) ).

% comp_fun_commute_product_fold
thf(fact_7378_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys2 ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys2 ) ) ) ) ).

% set_relcomp
thf(fact_7379_max__extp__eq,axiom,
    ! [A: $tType] :
      ( ( max_extp @ A )
      = ( ^ [R5: A > A > $o,X2: set @ A,Y: set @ A] : ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X2 @ Y ) @ ( max_ext @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% max_extp_eq
thf(fact_7380_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2 )
      = ( ^ [Xs: list @ A] : Xs ) ) ).

% map_ident
thf(fact_7381_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: list @ A] :
      ( ( ( map @ A @ B @ F2 @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_7382_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs2 ) )
      = ( Xs2
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_7383_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( nil @ A ) )
      = ( Xs2
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_7384_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F2: A > B,V: list @ A] :
      ( ( map @ B @ C @ G @ ( map @ A @ B @ F2 @ V ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G @ F2 ) @ V ) ) ).

% list.map_comp
thf(fact_7385_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C,G: A > B,List: list @ A] :
      ( ( map @ B @ C @ F2 @ ( map @ A @ B @ G @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) @ List ) ) ).

% List.map.compositionality
thf(fact_7386_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > A,G: C > B,Xs2: list @ C] :
      ( ( map @ B @ A @ F2 @ ( map @ C @ B @ G @ Xs2 ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F2 @ G ) @ Xs2 ) ) ).

% map_map
thf(fact_7387_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,G: B > A] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( map @ B @ A @ G @ Xs2 ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ ( set2 @ B @ Xs2 ) )
           => ( ( F2 @ X2 )
              = ( G @ X2 ) ) ) ) ) ).

% map_eq_conv
thf(fact_7388_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( size_size @ ( list @ B ) @ Xs2 ) ) ).

% length_map
thf(fact_7389_map__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,Ys: list @ B] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs2 @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs2 ) @ ( map @ B @ A @ F2 @ Ys ) ) ) ).

% map_append
thf(fact_7390_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A,N: nat,X: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( replicate @ A @ N @ ( F2 @ X ) ) ) ).

% map_replicate
thf(fact_7391_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: A > nat,G: B > A,Xs2: list @ B] :
      ( ( size_list @ A @ F2 @ ( map @ B @ A @ G @ Xs2 ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F2 @ G ) @ Xs2 ) ) ).

% size_list_map
thf(fact_7392_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,V: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F2 @ V ) )
      = ( image @ A @ B @ F2 @ ( set2 @ A @ V ) ) ) ).

% list.set_map
thf(fact_7393_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,G: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F2 ) @ ( map @ A @ C @ G ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F2 @ G ) ) ) ).

% map_comp_map
thf(fact_7394_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > C,G: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F2 ) @ ( map @ A @ B @ G ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) ) ) ).

% List.map.comp
thf(fact_7395_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs2: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs2 ) @ N )
        = ( F2 @ ( nth @ A @ Xs2 @ N ) ) ) ) ).

% nth_map
thf(fact_7396_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X2: B] : ( cons @ A @ ( F2 @ X2 ) @ ( nil @ A ) )
          @ Xs2 ) )
      = ( map @ B @ A @ F2 @ Xs2 ) ) ).

% concat_map_singleton
thf(fact_7397_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_7398_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F2 @ ( remdups @ B @ Xs2 ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ).

% remdups_map_remdups
thf(fact_7399_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( map @ B @ A @ F2 @ ( rotate1 @ B @ Xs2 ) ) ) ).

% rotate1_map
thf(fact_7400_map__update,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,K: nat,Y2: B] :
      ( ( map @ B @ A @ F2 @ ( list_update @ B @ Xs2 @ K @ Y2 ) )
      = ( list_update @ A @ ( map @ B @ A @ F2 @ Xs2 ) @ K @ ( F2 @ Y2 ) ) ) ).

% map_update
thf(fact_7401_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( concat @ B @ Xs2 ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs2 ) ) ) ).

% map_concat
thf(fact_7402_list_Omap__ident,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A
        @ ^ [X2: A] : X2
        @ T2 )
      = T2 ) ).

% list.map_ident
thf(fact_7403_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs2 )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs2 )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys ) )
       => ( Xs2 = Ys ) ) ) ).

% pair_list_eqI
thf(fact_7404_nths__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,I5: set @ nat] :
      ( ( nths @ A @ ( map @ B @ A @ F2 @ Xs2 ) @ I5 )
      = ( map @ B @ A @ F2 @ ( nths @ B @ Xs2 @ I5 ) ) ) ).

% nths_map
thf(fact_7405_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X21: A,X222: list @ A] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X222 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X222 ) ) ) ).

% list.simps(9)
thf(fact_7406_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X: A,Xs2: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ? [Z5: B,Zs2: list @ B] :
          ( ( Ys
            = ( cons @ B @ Z5 @ Zs2 ) )
          & ( X
            = ( F2 @ Z5 ) )
          & ( Xs2
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_7407_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: B > A,Xs2: list @ B,Y2: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( cons @ A @ Y2 @ Ys ) )
     => ? [Z5: B,Zs2: list @ B] :
          ( ( Xs2
            = ( cons @ B @ Z5 @ Zs2 ) )
          & ( ( F2 @ Z5 )
            = Y2 )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys ) ) ) ).

% map_eq_Cons_D
thf(fact_7408_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X: A,Xs2: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( map @ B @ A @ F2 @ Ys ) )
      = ( ? [Z: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z @ Zs3 ) )
            & ( X
              = ( F2 @ Z ) )
            & ( Xs2
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_7409_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,Y2: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( ? [Z: B,Zs3: list @ B] :
            ( ( Xs2
              = ( cons @ B @ Z @ Zs3 ) )
            & ( ( F2 @ Z )
              = Y2 )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_7410_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( n_lists @ A @ ( suc @ N ) @ Xs2 )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y: A] : ( cons @ A @ Y @ Ys3 )
              @ Xs2 )
          @ ( n_lists @ A @ N @ Xs2 ) ) ) ) ).

% n_lists.simps(2)
thf(fact_7411_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,Ys: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( append @ A @ Ys @ Zs ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs2
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% map_eq_append_conv
thf(fact_7412_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ A,Zs: list @ A,F2: B > A,Xs2: list @ B] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( map @ B @ A @ F2 @ Xs2 ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs2
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% append_eq_map_conv
thf(fact_7413_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs2: list @ B,G: C > A,Ys: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( map @ C @ A @ G @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs2 )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) ).

% map_eq_imp_length_eq
thf(fact_7414_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X2: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_7415_image__set,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( image @ B @ A @ F2 @ ( set2 @ B @ Xs2 ) )
      = ( set2 @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ).

% image_set
thf(fact_7416_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Ya: list @ A,F2: A > B,G: A > B] :
      ( ( X = Ya )
     => ( ! [Z5: A] :
            ( ( member @ A @ Z5 @ ( set2 @ A @ Ya ) )
           => ( ( F2 @ Z5 )
              = ( G @ Z5 ) ) )
       => ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ G @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_7417_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X: list @ A,F2: A > B,G: A > B] :
      ( ! [Z5: A] :
          ( ( member @ A @ Z5 @ ( set2 @ A @ X ) )
         => ( ( F2 @ Z5 )
            = ( G @ Z5 ) ) )
     => ( ( map @ A @ B @ F2 @ X )
        = ( map @ A @ B @ G @ X ) ) ) ).

% list.map_cong0
thf(fact_7418_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X: list @ A,Xa2: list @ A,F2: A > B,Fa: A > B] :
      ( ! [Z5: A,Za: A] :
          ( ( member @ A @ Z5 @ ( set2 @ A @ X ) )
         => ( ( member @ A @ Za @ ( set2 @ A @ Xa2 ) )
           => ( ( ( F2 @ Z5 )
                = ( Fa @ Za ) )
             => ( Z5 = Za ) ) ) )
     => ( ( ( map @ A @ B @ F2 @ X )
          = ( map @ A @ B @ Fa @ Xa2 ) )
       => ( X = Xa2 ) ) ) ).

% list.inj_map_strong
thf(fact_7419_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,F2: A > B,G: A > B] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( ( F2 @ X5 )
            = ( G @ X5 ) ) )
     => ( ( map @ A @ B @ F2 @ Xs2 )
        = ( map @ A @ B @ G @ Xs2 ) ) ) ).

% map_ext
thf(fact_7420_map__idI,axiom,
    ! [A: $tType,Xs2: list @ A,F2: A > A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( ( F2 @ X5 )
            = X5 ) )
     => ( ( map @ A @ A @ F2 @ Xs2 )
        = Xs2 ) ) ).

% map_idI
thf(fact_7421_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ A,F2: A > B,G: A > B] :
      ( ( Xs2 = Ys )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
           => ( ( F2 @ X5 )
              = ( G @ X5 ) ) )
       => ( ( map @ A @ B @ F2 @ Xs2 )
          = ( map @ A @ B @ G @ Ys ) ) ) ) ).

% map_cong
thf(fact_7422_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,F2: A > B] :
      ( ( ? [Xs: list @ A] :
            ( Ys
            = ( map @ A @ B @ F2 @ Xs ) ) )
      = ( ! [X2: B] :
            ( ( member @ B @ X2 @ ( set2 @ B @ Ys ) )
           => ? [Y: A] :
                ( X2
                = ( F2 @ Y ) ) ) ) ) ).

% ex_map_conv
thf(fact_7423_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: B > nat,G: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F2 ) @ ( map @ A @ B @ G ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F2 @ G ) ) ) ).

% list.size_gen_o_map
thf(fact_7424_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs2: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) ) )
          = ( ~ ( member @ A @ ( F2 @ X ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs2 ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ) ).

% distinct_insort_key
thf(fact_7425_eq__key__imp__eq__value,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ ( product_prod @ A @ B ),K: A,V1: B,V22: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs2 ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V1 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs2 ) )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V22 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs2 ) )
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
thf(fact_7426_max__ext__def,axiom,
    ! [A: $tType] :
      ( ( max_ext @ A )
      = ( ^ [R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
              @ ( max_extp @ A
                @ ^ [X2: A,Y: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R6 ) ) ) ) ) ) ).

% max_ext_def
thf(fact_7427_max__extp__max__ext__eq,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( max_extp @ A
        @ ^ [X2: A,Y: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R2 ) )
      = ( ^ [X2: set @ A,Y: set @ A] : ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X2 @ Y ) @ ( max_ext @ A @ R2 ) ) ) ) ).

% max_extp_max_ext_eq
thf(fact_7428_map__of__is__SomeI,axiom,
    ! [A: $tType,B: $tType,Xys2: list @ ( product_prod @ A @ B ),X: A,Y2: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) )
       => ( ( map_of @ A @ B @ Xys2 @ X )
          = ( some @ B @ Y2 ) ) ) ) ).

% map_of_is_SomeI
thf(fact_7429_Some__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),Y2: B,X: A] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( some @ B @ Y2 )
          = ( map_of @ A @ B @ Xys2 @ X ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% Some_eq_map_of_iff
thf(fact_7430_map__snd__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) )
      = Xs2 ) ).

% map_snd_enumerate
thf(fact_7431_map__of__eq__empty__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( map_of @ A @ B @ Xys2 )
        = ( ^ [X2: A] : ( none @ B ) ) )
      = ( Xys2
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% map_of_eq_empty_iff
thf(fact_7432_empty__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X2: A] : ( none @ B ) )
        = ( map_of @ A @ B @ Xys2 ) )
      = ( Xys2
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% empty_eq_map_of_iff
thf(fact_7433_map__of__eq__Some__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),X: A,Y2: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( map_of @ A @ B @ Xys2 @ X )
          = ( some @ B @ Y2 ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% map_of_eq_Some_iff
thf(fact_7434_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,Xs2: list @ ( product_prod @ A @ C )] :
      ( ( map_of @ A @ B
        @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
            @ ^ [K2: A,V5: C] : ( product_Pair @ A @ B @ K2 @ ( F2 @ V5 ) ) )
          @ Xs2 ) )
      = ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ ( map_of @ A @ C @ Xs2 ) ) ) ).

% map_of_map
thf(fact_7435_enumerate__Suc__eq,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( enumerate @ A @ ( suc @ N ) @ Xs2 )
      = ( map @ ( product_prod @ nat @ A ) @ ( product_prod @ nat @ A ) @ ( product_apfst @ nat @ nat @ A @ suc ) @ ( enumerate @ A @ N @ Xs2 ) ) ) ).

% enumerate_Suc_eq
thf(fact_7436_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs2: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs2 @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X2: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( product_lists @ A @ Xss ) )
          @ Xs2 ) ) ) ).

% product_lists.simps(2)
thf(fact_7437_map__of__Cons__code_I1_J,axiom,
    ! [B: $tType,A: $tType,K: B] :
      ( ( map_of @ B @ A @ ( nil @ ( product_prod @ B @ A ) ) @ K )
      = ( none @ A ) ) ).

% map_of_Cons_code(1)
thf(fact_7438_map__of_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_of @ A @ B @ ( nil @ ( product_prod @ A @ B ) ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% map_of.simps(1)
thf(fact_7439_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs2 ) ) ) ) ).

% distinct_set_subseqs
thf(fact_7440_weak__map__of__SomeI,axiom,
    ! [A: $tType,B: $tType,K: A,X: B,L2: list @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X ) @ ( set2 @ ( product_prod @ A @ B ) @ L2 ) )
     => ? [X5: B] :
          ( ( map_of @ A @ B @ L2 @ K )
          = ( some @ B @ X5 ) ) ) ).

% weak_map_of_SomeI
thf(fact_7441_map__of__SomeD,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ ( product_prod @ B @ A ),K: B,Y2: A] :
      ( ( ( map_of @ B @ A @ Xs2 @ K )
        = ( some @ A @ Y2 ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ Y2 ) @ ( set2 @ ( product_prod @ B @ A ) @ Xs2 ) ) ) ).

% map_of_SomeD
thf(fact_7442_map__of__eqI,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs2 ) )
        = ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs2 ) ) )
           => ( ( map_of @ A @ B @ Xs2 @ X5 )
              = ( map_of @ A @ B @ Ys @ X5 ) ) )
       => ( ( map_of @ A @ B @ Xs2 )
          = ( map_of @ A @ B @ Ys ) ) ) ) ).

% map_of_eqI
thf(fact_7443_map__of__Cons__code_I2_J,axiom,
    ! [C: $tType,B: $tType,L2: B,K: B,V: C,Ps: list @ ( product_prod @ B @ C )] :
      ( ( ( L2 = K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L2 @ V ) @ Ps ) @ K )
          = ( some @ C @ V ) ) )
      & ( ( L2 != K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L2 @ V ) @ Ps ) @ K )
          = ( map_of @ B @ C @ Ps @ K ) ) ) ) ).

% map_of_Cons_code(2)
thf(fact_7444_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X @ Xs2 ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( subseqs @ A @ Xs2 ) ) @ ( subseqs @ A @ Xs2 ) ) ) ).

% subseqs.simps(2)
thf(fact_7445_Id__on__set,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs2 ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
          @ Xs2 ) ) ) ).

% Id_on_set
thf(fact_7446_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X: A,Xs2: list @ A,Ys: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X @ Xs2 ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ Ys ) @ ( product @ A @ B @ Xs2 @ Ys ) ) ) ).

% product.simps(2)
thf(fact_7447_map__of__eq__None__iff,axiom,
    ! [A: $tType,B: $tType,Xys2: list @ ( product_prod @ B @ A ),X: B] :
      ( ( ( map_of @ B @ A @ Xys2 @ X )
        = ( none @ A ) )
      = ( ~ ( member @ B @ X @ ( image @ ( product_prod @ B @ A ) @ B @ ( product_fst @ B @ A ) @ ( set2 @ ( product_prod @ B @ A ) @ Xys2 ) ) ) ) ) ).

% map_of_eq_None_iff
thf(fact_7448_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs: list @ A,Ys3: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys3 )
              @ Xs ) ) ) ) ).

% product_concat_map
thf(fact_7449_set__map__of__compr,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs2 ) )
     => ( ( set2 @ ( product_prod @ A @ B ) @ Xs2 )
        = ( collect @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [K2: A,V5: B] :
                ( ( map_of @ A @ B @ Xs2 @ K2 )
                = ( some @ B @ V5 ) ) ) ) ) ) ).

% set_map_of_compr
thf(fact_7450_product__code,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs2 ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X2: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys )
            @ Xs2 ) ) ) ) ).

% product_code
thf(fact_7451_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(4)
thf(fact_7452_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: B > C,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( H2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( case_list @ C @ A @ ( H2 @ F1 )
        @ ^ [X17: A,X24: list @ A] : ( H2 @ ( F22 @ X17 @ X24 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_7453_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > ( list @ A ) > B,X21: A,X222: list @ A] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( cons @ A @ X21 @ X222 ) )
      = ( F22 @ X21 @ X222 ) ) ).

% list.simps(5)
thf(fact_7454_remdups__adj__Cons,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs2 ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X @ ( nil @ A ) )
        @ ^ [Y: A,Xs: list @ A] : ( if @ ( list @ A ) @ ( X = Y ) @ ( cons @ A @ Y @ Xs ) @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
        @ ( remdups_adj @ A @ Xs2 ) ) ) ).

% remdups_adj_Cons
thf(fact_7455_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P @ Xss2 )
               => ( P @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X5: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Xss2 ) )
               => ( ( P
                    @ ( cons @ ( list @ A ) @ Xs3
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P @ ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Xss2 ) ) ) )
           => ( P @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_7456_transpose_Oelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y2: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y2 )
     => ( ( ( X
            = ( nil @ ( list @ A ) ) )
         => ( Y2
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y2
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X5: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Xss2 ) )
               => ( Y2
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X5
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs3
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_7457_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs2 ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( transpose @ B @ Xs2 ) ) ) ).

% transpose_map_map
thf(fact_7458_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu3: A,Uv3: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_7459_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu3: A,Uv3: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_7460_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
      = ( transpose @ A @ Xss ) ) ).

% transpose.simps(2)
thf(fact_7461_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
        = ( transpose @ A @ Xss ) ) ) ).

% transpose.psimps(2)
thf(fact_7462_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_7463_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_7464_transpose__empty,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs2 )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X2: list @ A] :
            ( ( member @ ( list @ A ) @ X2 @ ( set2 @ ( list @ A ) @ Xs2 ) )
           => ( X2
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_7465_transpose_Opelims,axiom,
    ! [A: $tType,X: list @ ( list @ A ),Y2: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X )
        = Y2 )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X )
       => ( ( ( X
              = ( nil @ ( list @ A ) ) )
           => ( ( Y2
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y2
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X5: A,Xs3: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Xss2 ) )
                 => ( ( Y2
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X5
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs3
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X5 @ Xs3 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_7466_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs2
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_7467_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs2
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_7468_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Ks: list @ A] :
      ( ( map_of @ A @ B
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [K2: A] : ( product_Pair @ A @ B @ K2 @ ( F2 @ K2 ) )
          @ Ks ) )
      = ( restrict_map @ A @ B @ ( comp @ B @ ( option @ B ) @ A @ ( some @ B ) @ F2 ) @ ( set2 @ A @ Ks ) ) ) ).

% map_of_map_restrict
thf(fact_7469_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_7470_remdups__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( remdups @ nat @ ( upt @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% remdups_upt
thf(fact_7471_length__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I2 @ J ) )
      = ( minus_minus @ nat @ J @ I2 ) ) ).

% length_upt
thf(fact_7472_restrict__out,axiom,
    ! [A: $tType,B: $tType,X: A,A3: set @ A,M: A > ( option @ B )] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( restrict_map @ A @ B @ M @ A3 @ X )
        = ( none @ B ) ) ) ).

% restrict_out
thf(fact_7473_restrict__map__empty,axiom,
    ! [B: $tType,A: $tType,D5: set @ A] :
      ( ( restrict_map @ A @ B
        @ ^ [X2: A] : ( none @ B )
        @ D5 )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% restrict_map_empty
thf(fact_7474_restrict__map__to__empty,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B )] :
      ( ( restrict_map @ A @ B @ M @ ( bot_bot @ ( set @ A ) ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% restrict_map_to_empty
thf(fact_7475_upt__conv__Nil,axiom,
    ! [J: nat,I2: nat] :
      ( ( ord_less_eq @ nat @ J @ I2 )
     => ( ( upt @ I2 @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_7476_sorted__list__of__set__range,axiom,
    ! [M: nat,N: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( upt @ M @ N ) ) ).

% sorted_list_of_set_range
thf(fact_7477_upt__eq__Nil__conv,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( upt @ I2 @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I2 ) ) ) ).

% upt_eq_Nil_conv
thf(fact_7478_nth__upt,axiom,
    ! [I2: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I2 @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I2 @ J ) @ K )
        = ( plus_plus @ nat @ I2 @ K ) ) ) ).

% nth_upt
thf(fact_7479_map__fst__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) )
      = ( upt @ N @ ( plus_plus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% map_fst_enumerate
thf(fact_7480_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_7481_upt__0,axiom,
    ! [I2: nat] :
      ( ( upt @ I2 @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_7482_restrict__map__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( restrict_map @ A @ B )
      = ( ^ [M3: A > ( option @ B ),A7: set @ A,X2: A] : ( if @ ( option @ B ) @ ( member @ A @ X2 @ A7 ) @ ( M3 @ X2 ) @ ( none @ B ) ) ) ) ).

% restrict_map_def
thf(fact_7483_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast_upt
thf(fact_7484_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ ( suc @ M3 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_7485_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I4: nat,J3: nat] : ( set2 @ nat @ ( upt @ I4 @ J3 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_7486_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ ( suc @ N2 ) @ M3 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_7487_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N2: nat,M3: nat] : ( set2 @ nat @ ( upt @ N2 @ ( suc @ M3 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_7488_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N2: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ) ) ) ).

% atMost_upto
thf(fact_7489_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N: nat,Ns: list @ nat,Q2: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N @ Ns ) )
        = ( upt @ M @ Q2 ) )
      = ( ( cons @ nat @ N @ Ns )
        = ( upt @ ( suc @ M ) @ Q2 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_7490_distinct__upt,axiom,
    ! [I2: nat,J: nat] : ( distinct @ nat @ ( upt @ I2 @ J ) ) ).

% distinct_upt
thf(fact_7491_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I2: nat] :
      ( ( map @ nat @ A
        @ ^ [I4: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I2 ) )
      = ( replicate @ A @ I2 @ X ) ) ).

% map_replicate_trivial
thf(fact_7492_map__add__upt,axiom,
    ! [N: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ I4 @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N @ ( plus_plus @ nat @ M @ N ) ) ) ).

% map_add_upt
thf(fact_7493_map__Suc__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% map_Suc_upt
thf(fact_7494_enumerate__map__upt,axiom,
    ! [A: $tType,N: nat,F2: nat > A,M: nat] :
      ( ( enumerate @ A @ N @ ( map @ nat @ A @ F2 @ ( upt @ N @ M ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K2: nat] : ( product_Pair @ nat @ A @ K2 @ ( F2 @ K2 ) )
        @ ( upt @ N @ M ) ) ) ).

% enumerate_map_upt
thf(fact_7495_upt__conv__Cons,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( upt @ I2 @ J )
        = ( cons @ nat @ I2 @ ( upt @ ( suc @ I2 ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_7496_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I4: nat] : ( F2 @ ( suc @ I4 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_7497_map__decr__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N ) ) )
      = ( upt @ M @ N ) ) ).

% map_decr_upt
thf(fact_7498_map__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs2 ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
      = Xs2 ) ).

% map_nth
thf(fact_7499_upt__add__eq__append,axiom,
    ! [I2: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_7500_nth__map__upt,axiom,
    ! [A: $tType,I2: nat,N: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I2 @ ( minus_minus @ nat @ N @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N ) ) @ I2 )
        = ( F2 @ ( plus_plus @ nat @ M @ I2 ) ) ) ) ).

% nth_map_upt
thf(fact_7501_upt__eq__Cons__conv,axiom,
    ! [I2: nat,J: nat,X: nat,Xs2: list @ nat] :
      ( ( ( upt @ I2 @ J )
        = ( cons @ nat @ X @ Xs2 ) )
      = ( ( ord_less @ nat @ I2 @ J )
        & ( I2 = X )
        & ( ( upt @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) @ J )
          = Xs2 ) ) ) ).

% upt_eq_Cons_conv
thf(fact_7502_upt__rec,axiom,
    ( upt
    = ( ^ [I4: nat,J3: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I4 @ J3 ) @ ( cons @ nat @ I4 @ ( upt @ ( suc @ I4 ) @ J3 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_7503_enumerate__replicate__eq,axiom,
    ! [A: $tType,N: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N @ ( plus_plus @ nat @ N @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_7504_map__upt__eqI,axiom,
    ! [A: $tType,Xs2: list @ A,N: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( minus_minus @ nat @ N @ M ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
           => ( ( nth @ A @ Xs2 @ I3 )
              = ( F2 @ ( plus_plus @ nat @ M @ I3 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N ) )
          = Xs2 ) ) ) ).

% map_upt_eqI
thf(fact_7505_upt__Suc,axiom,
    ! [I2: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I2 @ J )
       => ( ( upt @ I2 @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_7506_upt__Suc__append,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I2 @ J )
     => ( ( upt @ I2 @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I2 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_7507_transpose__rectangle,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),N: nat] :
      ( ( ( Xs2
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I3: nat] :
            ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I3 ) )
              = N ) )
       => ( ( transpose @ A @ Xs2 )
          = ( map @ nat @ ( list @ A )
            @ ^ [I4: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J3 ) @ I4 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_7508_restrict__map__upds,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,D5: set @ A,M: A > ( option @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ D5 )
       => ( ( restrict_map @ A @ B @ ( map_upds @ A @ B @ M @ Xs2 @ Ys ) @ D5 )
          = ( map_upds @ A @ B @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( set2 @ A @ Xs2 ) ) ) @ Xs2 @ Ys ) ) ) ) ).

% restrict_map_upds
thf(fact_7509_UNION__fun__upd,axiom,
    ! [B: $tType,A: $tType,A3: B > ( set @ A ),I2: B,B4: set @ A,J4: set @ B] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ ( fun_upd @ B @ ( set @ A ) @ A3 @ I2 @ B4 ) @ J4 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ B ) @ J4 @ ( insert @ B @ I2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) @ ( if @ ( set @ A ) @ ( member @ B @ I2 @ J4 ) @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% UNION_fun_upd
thf(fact_7510_map__upds__apply__nontin,axiom,
    ! [B: $tType,A: $tType,X: A,Xs2: list @ A,F2: A > ( option @ B ),Ys: list @ B] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ( map_upds @ A @ B @ F2 @ Xs2 @ Ys @ X )
        = ( F2 @ X ) ) ) ).

% map_upds_apply_nontin
thf(fact_7511_map__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y2: A,Xs2: list @ A,F2: A > B,V: B] :
      ( ~ ( member @ A @ Y2 @ ( set2 @ A @ Xs2 ) )
     => ( ( map @ A @ B @ ( fun_upd @ A @ B @ F2 @ Y2 @ V ) @ Xs2 )
        = ( map @ A @ B @ F2 @ Xs2 ) ) ) ).

% map_fun_upd
thf(fact_7512_fun__upds__append2__drop,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ Xs2 @ ( append @ B @ Ys @ Zs ) )
        = ( map_upds @ A @ B @ M @ Xs2 @ Ys ) ) ) ).

% fun_upds_append2_drop
thf(fact_7513_fun__upds__append__drop,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs2 @ Zs ) @ Ys )
        = ( map_upds @ A @ B @ M @ Xs2 @ Ys ) ) ) ).

% fun_upds_append_drop
thf(fact_7514_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,I2: nat,M: A > ( option @ B ),Ys: list @ B,Y2: B] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ I2 )
     => ( ( map_upds @ A @ B @ M @ Xs2 @ ( list_update @ B @ Ys @ I2 @ Y2 ) )
        = ( map_upds @ A @ B @ M @ Xs2 @ Ys ) ) ) ).

% map_upds_list_update2_drop
thf(fact_7515_fun__upd__image,axiom,
    ! [A: $tType,B: $tType,X: B,A3: set @ B,F2: B > A,Y2: A] :
      ( ( ( member @ B @ X @ A3 )
       => ( ( image @ B @ A @ ( fun_upd @ B @ A @ F2 @ X @ Y2 ) @ A3 )
          = ( insert @ A @ Y2 @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
      & ( ~ ( member @ B @ X @ A3 )
       => ( ( image @ B @ A @ ( fun_upd @ B @ A @ F2 @ X @ Y2 ) @ A3 )
          = ( image @ B @ A @ F2 @ A3 ) ) ) ) ).

% fun_upd_image
thf(fact_7516_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B,M: A > ( option @ B ),X: A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) @ Ys )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ Xs2 @ Ys ) @ X @ ( some @ B @ ( nth @ B @ Ys @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% map_upds_append1
thf(fact_7517_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs2: list @ A,X8: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X2: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X2 ) @ ( F2 @ X2 ) )
            @ X8 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_7518_empty__upd__none,axiom,
    ! [B: $tType,A: $tType,X: A] :
      ( ( fun_upd @ A @ ( option @ B )
        @ ^ [X2: A] : ( none @ B )
        @ X
        @ ( none @ B ) )
      = ( ^ [X2: A] : ( none @ B ) ) ) ).

% empty_upd_none
thf(fact_7519_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ns ) )
               => ( X2
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_7520_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X @ Xs2 ) )
          = ( plus_plus @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% sum_list.Cons
thf(fact_7521_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs2 @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_7522_image__map__upd,axiom,
    ! [B: $tType,A: $tType,X: A,A3: set @ A,M: A > ( option @ B ),Y2: B] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( image @ A @ ( option @ B ) @ ( fun_upd @ A @ ( option @ B ) @ M @ X @ ( some @ B @ Y2 ) ) @ A3 )
        = ( image @ A @ ( option @ B ) @ M @ A3 ) ) ) ).

% image_map_upd
thf(fact_7523_map__upds__Cons,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),A2: A,As3: list @ A,B2: B,Bs: list @ B] :
      ( ( map_upds @ A @ B @ M @ ( cons @ A @ A2 @ As3 ) @ ( cons @ B @ B2 @ Bs ) )
      = ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ B2 ) ) @ As3 @ Bs ) ) ).

% map_upds_Cons
thf(fact_7524_map__upds__twist,axiom,
    ! [A: $tType,B: $tType,A2: A,As3: list @ A,M: A > ( option @ B ),B2: B,Bs: list @ B] :
      ( ~ ( member @ A @ A2 @ ( set2 @ A @ As3 ) )
     => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ B2 ) ) @ As3 @ Bs )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ As3 @ Bs ) @ A2 @ ( some @ B @ B2 ) ) ) ) ).

% map_upds_twist
thf(fact_7525_map__option__o__map__upd,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > B,M: A > ( option @ C ),A2: A,B2: C] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ ( fun_upd @ A @ ( option @ C ) @ M @ A2 @ ( some @ C @ B2 ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ M ) @ A2 @ ( some @ B @ ( F2 @ B2 ) ) ) ) ).

% map_option_o_map_upd
thf(fact_7526_restrict__fun__upd,axiom,
    ! [B: $tType,A: $tType,X: A,D5: set @ A,M: A > ( option @ B ),Y2: option @ B] :
      ( ( ( member @ A @ X @ D5 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ X @ Y2 ) @ D5 )
          = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X @ Y2 ) ) )
      & ( ~ ( member @ A @ X @ D5 )
       => ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ X @ Y2 ) @ D5 )
          = ( restrict_map @ A @ B @ M @ D5 ) ) ) ) ).

% restrict_fun_upd
thf(fact_7527_fun__upd__restrict__conv,axiom,
    ! [A: $tType,B: $tType,X: A,D5: set @ A,M: A > ( option @ B ),Y2: option @ B] :
      ( ( member @ A @ X @ D5 )
     => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D5 ) @ X @ Y2 )
        = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X @ Y2 ) ) ) ).

% fun_upd_restrict_conv
thf(fact_7528_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum_list_upt
thf(fact_7529_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X: A,D5: set @ A,M: A > ( option @ B )] :
      ( ( ( member @ A @ X @ D5 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D5 ) @ X @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
      & ( ~ ( member @ A @ X @ D5 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D5 ) @ X @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ D5 ) ) ) ) ).

% fun_upd_None_restrict
thf(fact_7530_restrict__upd__same,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),X: A,Y2: B] :
      ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ X @ ( some @ B @ Y2 ) ) @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( restrict_map @ A @ B @ M @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% restrict_upd_same
thf(fact_7531_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_7532_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ Xs2 ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum_list_addf
thf(fact_7533_sum__list__subtractf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: B > A,G: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ Xs2 ) )
          = ( minus_minus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum_list_subtractf
thf(fact_7534_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ Xs2 ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_7535_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs2: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ Xs2 ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_7536_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_7537_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs2 )
              = ( zero_zero @ A ) )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
                 => ( X2
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_7538_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs2: list @ A] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ A @ X5 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_7539_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
         => ( ord_less_eq @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) ) ) ).

% member_le_sum_list
thf(fact_7540_map__upd__nonempty,axiom,
    ! [B: $tType,A: $tType,T2: A > ( option @ B ),K: A,X: B] :
      ( ( fun_upd @ A @ ( option @ B ) @ T2 @ K @ ( some @ B @ X ) )
     != ( ^ [X2: A] : ( none @ B ) ) ) ).

% map_upd_nonempty
thf(fact_7541_map__upd__eqD1,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),A2: A,X: B,N: A > ( option @ B ),Y2: B] :
      ( ( ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ X ) )
        = ( fun_upd @ A @ ( option @ B ) @ N @ A2 @ ( some @ B @ Y2 ) ) )
     => ( X = Y2 ) ) ).

% map_upd_eqD1
thf(fact_7542_map__upd__triv,axiom,
    ! [A: $tType,B: $tType,T2: B > ( option @ A ),K: B,X: A] :
      ( ( ( T2 @ K )
        = ( some @ A @ X ) )
     => ( ( fun_upd @ B @ ( option @ A ) @ T2 @ K @ ( some @ A @ X ) )
        = T2 ) ) ).

% map_upd_triv
thf(fact_7543_map__upd__Some__unfold,axiom,
    ! [B: $tType,A: $tType,M: B > ( option @ A ),A2: B,B2: A,X: B,Y2: A] :
      ( ( ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) @ X )
        = ( some @ A @ Y2 ) )
      = ( ( ( X = A2 )
          & ( B2 = Y2 ) )
        | ( ( X != A2 )
          & ( ( M @ X )
            = ( some @ A @ Y2 ) ) ) ) ) ).

% map_upd_Some_unfold
thf(fact_7544_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs2: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs2 ) ) ) ) ).

% sum_list_abs
thf(fact_7545_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_7546_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs2: list @ A,F2: A > B,G: A > B] :
          ( ! [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
             => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs2 ) ) ) ) ) ).

% sum_list_mono
thf(fact_7547_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs2: list @ A] :
          ( ( distinct @ A @ Xs2 )
         => ( ( groups8242544230860333062m_list @ A @ Xs2 )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X2: A] : X2
              @ ( set2 @ A @ Xs2 ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_7548_fun__upd__restrict,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),D5: set @ A,X: A,Y2: option @ B] :
      ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D5 ) @ X @ Y2 )
      = ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ X @ Y2 ) ) ).

% fun_upd_restrict
thf(fact_7549_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_7550_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs2: list @ A,F2: A > B,G: A > B] :
          ( ( Xs2
           != ( nil @ A ) )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
               => ( ord_less @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs2 ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs2 ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_7551_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs2: list @ B,F2: B > C] :
          ( ( distinct @ B @ Xs2 )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F2 @ Xs2 ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F2 @ ( set2 @ B @ Xs2 ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_7552_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs2: list @ B,G: B > A] :
          ( ( distinct @ B @ Xs2 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs2 ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs2 ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_7553_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X: B,Xs2: list @ B,F2: B > A] :
          ( ( member @ B @ X @ ( set2 @ B @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
            = ( plus_plus @ A @ ( F2 @ X ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs2 ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_7554_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,Xs2: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs2 ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ ( remdups @ B @ Xs2 ) ) ) ) ) ).

% sum_code
thf(fact_7555_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F5: B > nat,Xs: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F5 @ Xs ) ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_7556_finite__range__updI,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),A2: B,B2: A] :
      ( ( finite_finite @ ( option @ A ) @ ( image @ B @ ( option @ A ) @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( finite_finite @ ( option @ A ) @ ( image @ B @ ( option @ A ) @ ( fun_upd @ B @ ( option @ A ) @ F2 @ A2 @ ( some @ A @ B2 ) ) @ ( top_top @ ( set @ B ) ) ) ) ) ).

% finite_range_updI
thf(fact_7557_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R: B,Xs2: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X2: C] : R
              @ Xs2 ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs2 ) ) @ R ) ) ) ).

% sum_list_triv
thf(fact_7558_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X2: A] : ( suc @ ( F2 @ X2 ) )
          @ Xs2 ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ).

% sum_list_Suc
thf(fact_7559_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B ),X: A] :
      ( ( restrict_map @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ F2 @ X @ ( none @ B ) ) ) ).

% restrict_complement_singleton_eq
thf(fact_7560_map__of_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B,Ps: list @ ( product_prod @ A @ B )] :
      ( ( map_of @ A @ B @ ( cons @ ( product_prod @ A @ B ) @ P2 @ Ps ) )
      = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ Ps ) @ ( product_fst @ A @ B @ P2 ) @ ( some @ B @ ( product_snd @ A @ B @ P2 ) ) ) ) ).

% map_of.simps(2)
thf(fact_7561_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_7562_card__length__sum__list__rec,axiom,
    ! [M: nat,N4: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L )
                  = N4 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L )
                    = N4 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L ) @ ( one_one @ nat ) )
                    = N4 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_7563_card__length__sum__list,axiom,
    ! [M: nat,N4: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L )
                = N4 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N4 @ M ) @ ( one_one @ nat ) ) @ N4 ) ) ).

% card_length_sum_list
thf(fact_7564_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs2: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X2: A] : ( times_times @ nat @ ( count_list @ A @ Xs2 @ X2 ) @ ( F2 @ X2 ) )
        @ ( set2 @ A @ Xs2 ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_7565_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs2: list @ A,X: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs2 @ K @ X ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs2 ) @ X ) @ ( nth @ A @ Xs2 @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_7566_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X5: nat,Y4: nat] :
              ( ( ord_less_eq @ nat @ X5 @ Y4 )
             => ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_7567_graph__map__upd,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),K: A,V: B] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( some @ B @ V ) ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) ) ) ) ) ).

% graph_map_upd
thf(fact_7568_graph__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B
        @ ^ [X2: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% graph_empty
thf(fact_7569_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ).

% sorted_insort_key
thf(fact_7570_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs2 ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_7571_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
          = ( sorted_wrt @ B
            @ ^ [X2: B,Y: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y ) )
            @ Xs2 ) ) ) ).

% sorted_map
thf(fact_7572_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R2: A > A > $o,F2: B > A,Xs2: list @ B] :
      ( ( sorted_wrt @ A @ R2 @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( sorted_wrt @ B
        @ ^ [X2: B,Y: B] : ( R2 @ ( F2 @ X2 ) @ ( F2 @ Y ) )
        @ Xs2 ) ) ).

% sorted_wrt_map
thf(fact_7573_graph__restrictD_I1_J,axiom,
    ! [B: $tType,A: $tType,K: A,V: B,M: A > ( option @ B ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M @ A3 ) ) )
     => ( member @ A @ K @ A3 ) ) ).

% graph_restrictD(1)
thf(fact_7574_sorted__wrt__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_wrt_upt
thf(fact_7575_sorted__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_upt
thf(fact_7576_sorted__wrt1,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( sorted_wrt @ A @ P @ ( cons @ A @ X @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_7577_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y2 @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y2 @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_7578_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_7579_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7580_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_7581_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs2 ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted_insort
thf(fact_7582_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_7583_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X ) ) ) ).

% sorted_replicate
thf(fact_7584_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs2 ) ) ) ) ).

% sorted_remove1
thf(fact_7585_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I5: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs2 @ I5 ) ) ) ) ).

% sorted_nths
thf(fact_7586_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_7587_sorted__wrt__true,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu3: A,Uv3: A] : $true
      @ Xs2 ) ).

% sorted_wrt_true
thf(fact_7588_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_7589_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_7590_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > A > $o] : ( sorted_wrt @ A @ P @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_7591_in__graphD,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M: A > ( option @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ M ) )
     => ( ( M @ K )
        = ( some @ B @ V ) ) ) ).

% in_graphD
thf(fact_7592_in__graphI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),K: B,V: A] :
      ( ( ( M @ K )
        = ( some @ A @ V ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ V ) @ ( graph @ B @ A @ M ) ) ) ).

% in_graphI
thf(fact_7593_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs2: list @ A,I2: nat,J: nat] :
      ( ( sorted_wrt @ A @ P @ Xs2 )
     => ( ( ord_less @ nat @ I2 @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
         => ( P @ ( nth @ A @ Xs2 @ I2 ) @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_7594_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P4: A > A > $o,Xs: list @ A] :
          ! [I4: nat,J3: nat] :
            ( ( ord_less @ nat @ I4 @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( P4 @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_7595_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs2 )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys )
           => ( ( ( set2 @ A @ Ys )
                = ( set2 @ A @ Xs2 ) )
             => ( Ys = Xs2 ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_7596_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > A > $o,Q: A > A > $o] :
      ( ! [X5: A,Y4: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( ( member @ A @ Y4 @ ( set2 @ A @ Xs2 ) )
           => ( ( P @ X5 @ Y4 )
             => ( Q @ X5 @ Y4 ) ) ) )
     => ( ( sorted_wrt @ A @ P @ Xs2 )
       => ( sorted_wrt @ A @ Q @ Xs2 ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_7597_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs2 ) ) ) ) ).

% sorted_remdups
thf(fact_7598_sorted__wrt01,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs2 ) ) ).

% sorted_wrt01
thf(fact_7599_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_7600_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa2 )
     => ~ ! [X5: A,Ys4: list @ A] :
            ( ( Xa2
              = ( cons @ A @ X5 @ Ys4 ) )
           => ( ! [Xa3: A] :
                  ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                 => ( X @ X5 @ Xa3 ) )
              & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_7601_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( cons @ A @ X @ Ys ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
           => ( P @ X @ X2 ) )
        & ( sorted_wrt @ A @ P @ Ys ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_7602_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X @ Ys ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
               => ( ord_less @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_7603_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L2 )
            & ( distinct @ A @ L2 ) ) ) ) ).

% strict_sorted_iff
thf(fact_7604_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs2 @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
               => ! [Y: A] :
                    ( ( member @ A @ Y @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X2 @ Y ) ) ) ) ) ) ).

% sorted_append
thf(fact_7605_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs2 )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs2 = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_7606_sorted__wrt__append,axiom,
    ! [A: $tType,P: A > A > $o,Xs2: list @ A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
      = ( ( sorted_wrt @ A @ P @ Xs2 )
        & ( sorted_wrt @ A @ P @ Ys )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ! [Y: A] :
                ( ( member @ A @ Y @ ( set2 @ A @ Ys ) )
               => ( P @ X2 @ Y ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_7607_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I4 ) @ ( nth @ A @ Xs2 @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_7608_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 ) ) ) ).

% sorted01
thf(fact_7609_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A,Y2: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa2 )
        = Y2 )
     => ( ( ( Xa2
            = ( nil @ A ) )
         => ~ Y2 )
       => ~ ! [X5: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X5 @ Ys4 ) )
             => ( Y2
                = ( ~ ( ! [Y: A] :
                          ( ( member @ A @ Y @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X5 @ Y ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_7610_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa2 )
     => ( ( Xa2
         != ( nil @ A ) )
       => ~ ! [X5: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X5 @ Ys4 ) )
             => ~ ( ! [Xa: A] :
                      ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                     => ( X @ X5 @ Xa ) )
                  & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_7611_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ? [X5: list @ A] :
              ( ( ( set2 @ A @ X5 )
                = A3 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X5 )
              & ( distinct @ A @ X5 )
              & ! [Y3: list @ A] :
                  ( ( ( ( set2 @ A @ Y3 )
                      = A3 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y3 )
                    & ( distinct @ A @ Y3 ) )
                 => ( Y3 = X5 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_7612_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( distinct @ A @ Xs2 )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_7613_graph__restrictD_I2_J,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M: A > ( option @ B ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M @ A3 ) ) )
     => ( ( M @ K )
        = ( some @ B @ V ) ) ) ).

% graph_restrictD(2)
thf(fact_7614_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs2: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A2
                @ ( remove1 @ A @ A2 @ Xs2 ) )
              = Xs2 ) ) ) ) ).

% insort_remove1
thf(fact_7615_graph__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A4: A,B3: B] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ A4 @ B3 ) )
                & ( ( M3 @ A4 )
                  = ( some @ B @ B3 ) ) ) ) ) ) ).

% graph_def
thf(fact_7616_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I4 ) @ ( nth @ A @ Xs2 @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_7617_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ~ ! [L4: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L4 )
               => ( ( ( set2 @ A @ L4 )
                    = A3 )
                 => ( ( size_size @ ( list @ A ) @ L4 )
                   != ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_7618_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I2 ) @ ( nth @ A @ Xs2 @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_7619_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ I4 ) @ ( nth @ A @ Xs2 @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_7620_graph__fun__upd__None,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),K: A] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [E4: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ E4 @ ( graph @ A @ B @ M ) )
            & ( ( product_fst @ A @ B @ E4 )
             != K ) ) ) ) ).

% graph_fun_upd_None
thf(fact_7621_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I2 @ ( nth @ nat @ Ns @ I2 ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_7622_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs2 ) ) ) ).

% sorted_enumerate
thf(fact_7623_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,L2: list @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L2 )
              & ( ( set2 @ A @ L2 )
                = A3 )
              & ( ( size_size @ ( list @ A ) @ L2 )
                = ( finite_card @ A @ A3 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A3 )
              = L2 ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_7624_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
               => ( ord_less_eq @ A @ X5 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A2
                @ Xs2 )
              = ( append @ A @ Xs2 @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_7625_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ( sorted_wrt @ A @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa2 ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) )
         => ~ ! [X5: A,Ys4: list @ A] :
                ( ( Xa2
                  = ( cons @ A @ X5 @ Ys4 ) )
               => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X5 @ Ys4 ) ) )
                 => ~ ( ! [Xa: A] :
                          ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X5 @ Xa ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
thf(fact_7626_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A,Y2: $o] :
      ( ( ( sorted_wrt @ A @ X @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa2 ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ( Y2
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) )
         => ~ ! [X5: A,Ys4: list @ A] :
                ( ( Xa2
                  = ( cons @ A @ X5 @ Ys4 ) )
               => ( ( Y2
                    = ( ! [Y: A] :
                          ( ( member @ A @ Y @ ( set2 @ A @ Ys4 ) )
                         => ( X @ X5 @ Y ) )
                      & ( sorted_wrt @ A @ X @ Ys4 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X5 @ Ys4 ) ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
thf(fact_7627_sorted__upto,axiom,
    ! [M: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N ) ) ).

% sorted_upto
thf(fact_7628_sorted__wrt__upto,axiom,
    ! [I2: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I2 @ J ) ) ).

% sorted_wrt_upto
thf(fact_7629_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X: A > A > $o,Xa2: list @ A] :
      ( ~ ( sorted_wrt @ A @ X @ Xa2 )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ Xa2 ) )
       => ~ ! [X5: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X5 @ Ys4 ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X @ ( cons @ A @ X5 @ Ys4 ) ) )
               => ( ! [Xa3: A] :
                      ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                     => ( X @ X5 @ Xa3 ) )
                  & ( sorted_wrt @ A @ X @ Ys4 ) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
thf(fact_7630_length__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ( Xs2
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs2
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_7631_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ~ ! [L4: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L4 ) )
               => ( ( ( set2 @ B @ L4 )
                    = A3 )
                 => ( ( size_size @ ( list @ B ) @ L4 )
                   != ( finite_card @ B @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_7632_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs2 )
        = ( rev @ A @ Ys ) )
      = ( Xs2 = Ys ) ) ).

% rev_is_rev_conv
thf(fact_7633_rev__rev__ident,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs2 ) )
      = Xs2 ) ).

% rev_rev_ident
thf(fact_7634_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( rev @ A @ Xs2 )
        = ( nil @ A ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_7635_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs2 ) )
      = ( Xs2
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_7636_set__rev,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs2 ) )
      = ( set2 @ A @ Xs2 ) ) ).

% set_rev
thf(fact_7637_length__rev,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs2 ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_rev
thf(fact_7638_rev__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs2 ) ) ) ).

% rev_append
thf(fact_7639_distinct__rev,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs2 ) )
      = ( distinct @ A @ Xs2 ) ) ).

% distinct_rev
thf(fact_7640_rev__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( rev @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ N @ X ) ) ).

% rev_replicate
thf(fact_7641_remdups__adj__rev,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs2 ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs2 ) ) ) ).

% remdups_adj_rev
thf(fact_7642_singleton__rev__conv,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( ( cons @ A @ X @ ( nil @ A ) )
        = ( rev @ A @ Xs2 ) )
      = ( ( cons @ A @ X @ ( nil @ A ) )
        = Xs2 ) ) ).

% singleton_rev_conv
thf(fact_7643_rev__singleton__conv,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( ( rev @ A @ Xs2 )
        = ( cons @ A @ X @ ( nil @ A ) ) )
      = ( Xs2
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_7644_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs2: list @ A,Y2: A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs2 )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( Xs2
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_7645_sorted__wrt__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs2: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( rev @ A @ Xs2 ) )
      = ( sorted_wrt @ A
        @ ^ [X2: A,Y: A] : ( P @ Y @ X2 )
        @ Xs2 ) ) ).

% sorted_wrt_rev
thf(fact_7646_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X @ Xs2 ) )
      = ( append @ A @ ( rev @ A @ Xs2 ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_7647_rev__swap,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs2 )
        = Ys )
      = ( Xs2
        = ( rev @ A @ Ys ) ) ) ).

% rev_swap
thf(fact_7648_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_7649_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs2 ) ) ) ).

% rev_map
thf(fact_7650_rev__concat,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs2 ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs2 ) ) ) ) ).

% rev_concat
thf(fact_7651_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs2: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
       => ( distinct @ B @ Xs2 ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_7652_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X2: A] : X2 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_7653_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( nth @ A @ ( rev @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_7654_rev__update,axiom,
    ! [A: $tType,K: nat,Xs2: list @ A,Y2: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs2 @ K @ Y2 ) )
        = ( list_update @ A @ ( rev @ A @ Xs2 ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ K ) @ ( one_one @ nat ) ) @ Y2 ) ) ) ).

% rev_update
thf(fact_7655_sorted__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) ) ) ).

% sorted_transpose
thf(fact_7656_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ ( suc @ I4 ) ) @ ( nth @ A @ Xs2 @ I4 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_7657_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,I2: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ord_less_eq @ nat @ I2 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J ) @ ( nth @ A @ Xs2 @ I2 ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_7658_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs2 ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs2 @ J3 ) @ ( nth @ A @ Xs2 @ I4 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_7659_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I2: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs2 ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs2 ) @ I2 ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs2 @ J ) @ I2 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_7660_transpose__column,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I2 )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( nth @ ( list @ A ) @ Xs2 @ I2 ) ) ) ) ).

% transpose_column
thf(fact_7661_filter__filter,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,Xs2: list @ A] :
      ( ( filter2 @ A @ P @ ( filter2 @ A @ Q @ Xs2 ) )
      = ( filter2 @ A
        @ ^ [X2: A] :
            ( ( Q @ X2 )
            & ( P @ X2 ) )
        @ Xs2 ) ) ).

% filter_filter
thf(fact_7662_filter__True,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( P @ X5 ) )
     => ( ( filter2 @ A @ P @ Xs2 )
        = Xs2 ) ) ).

% filter_True
thf(fact_7663_filter__append,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,Ys: list @ A] :
      ( ( filter2 @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
      = ( append @ A @ ( filter2 @ A @ P @ Xs2 ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_append
thf(fact_7664_remove1__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ~ ( P @ X )
     => ( ( remove1 @ A @ X @ ( filter2 @ A @ P @ Xs2 ) )
        = ( filter2 @ A @ P @ Xs2 ) ) ) ).

% remove1_filter_not
thf(fact_7665_removeAll__filter__not,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ~ ( P @ X )
     => ( ( removeAll @ A @ X @ ( filter2 @ A @ P @ Xs2 ) )
        = ( filter2 @ A @ P @ Xs2 ) ) ) ).

% removeAll_filter_not
thf(fact_7666_set__filter,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P @ Xs2 ) )
      = ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
            & ( P @ X2 ) ) ) ) ).

% set_filter
thf(fact_7667_filter__False,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ~ ( P @ X5 ) )
     => ( ( filter2 @ A @ P @ Xs2 )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_7668_length__concat__rev,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs2 ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs2 ) ) ) ).

% length_concat_rev
thf(fact_7669_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs2: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs2 ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs2 ) ) ) ).

% length_filter_map
thf(fact_7670_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs2: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X2: B] :
                  ( ( F2 @ X2 )
                  = ( G @ Xs2 ) )
              @ Xs2 ) ) ) ) ).

% sorted_map_same
thf(fact_7671_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ).

% sorted_filter
thf(fact_7672_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs2: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X2: A] :
                ( X2
                = ( G @ Xs2 ) )
            @ Xs2 ) ) ) ).

% sorted_same
thf(fact_7673_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: A > A > $o,Xs2: list @ A,P: A > $o] :
      ( ( sorted_wrt @ A @ F2 @ Xs2 )
     => ( sorted_wrt @ A @ F2 @ ( filter2 @ A @ P @ Xs2 ) ) ) ).

% sorted_wrt_filter
thf(fact_7674_rev__filter,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( rev @ A @ ( filter2 @ A @ P @ Xs2 ) )
      = ( filter2 @ A @ P @ ( rev @ A @ Xs2 ) ) ) ).

% rev_filter
thf(fact_7675_filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs2: list @ B] :
      ( ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( map @ B @ A @ F2 @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs2 ) ) ) ).

% filter_map
thf(fact_7676_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,P: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
     => ( distinct @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ).

% distinct_map_filter
thf(fact_7677_filter__concat,axiom,
    ! [A: $tType,P2: A > $o,Xs2: list @ ( list @ A )] :
      ( ( filter2 @ A @ P2 @ ( concat @ A @ Xs2 ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P2 ) @ Xs2 ) ) ) ).

% filter_concat
thf(fact_7678_distinct__filter,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ A @ ( filter2 @ A @ P @ Xs2 ) ) ) ).

% distinct_filter
thf(fact_7679_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X: A,Xs2: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X @ Xs2 ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs3 ) ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X2 ) )
            & ( P @ X )
            & ( Xs2
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_7680_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( filter2 @ A @ P @ Ys ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X @ Vs3 ) ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X2 ) )
            & ( P @ X )
            & ( Xs2
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_7681_filter__eq__ConsD,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X: A,Xs2: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X @ Xs2 ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs2 ) ) )
          & ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X3 ) )
          & ( P @ X )
          & ( Xs2
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_7682_Cons__eq__filterD,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X @ Xs2 )
        = ( filter2 @ A @ P @ Ys ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X @ Vs2 ) ) )
          & ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X3 ) )
          & ( P @ X )
          & ( Xs2
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_7683_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_filter_le
thf(fact_7684_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs2 ) ) @ ( set2 @ A @ Xs2 ) ) ).

% filter_is_subset
thf(fact_7685_inter__set__filter,axiom,
    ! [A: $tType,A3: set @ A,Xs2: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( set2 @ A @ Xs2 ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ A3 )
          @ Xs2 ) ) ) ).

% inter_set_filter
thf(fact_7686_filter__id__conv,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs2 )
        = Xs2 )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X2 ) ) ) ) ).

% filter_id_conv
thf(fact_7687_filter__cong,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs2 = Ys )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( filter2 @ A @ P @ Xs2 )
          = ( filter2 @ A @ Q @ Ys ) ) ) ) ).

% filter_cong
thf(fact_7688_filter__empty__conv,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs2 )
        = ( nil @ A ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ~ ( P @ X2 ) ) ) ) ).

% filter_empty_conv
thf(fact_7689_empty__filter__conv,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( filter2 @ A @ P @ Xs2 ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ~ ( P @ X2 ) ) ) ) ).

% empty_filter_conv
thf(fact_7690_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ~ ( P @ X )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ).

% length_filter_less
thf(fact_7691_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 )
            @ Xs2 ) ) )
      = ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% sum_length_filter_compl
thf(fact_7692_replicate__length__filter,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
              @ X )
            @ Xs2 ) )
        @ X )
      = ( filter2 @ A
        @ ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
          @ X )
        @ Xs2 ) ) ).

% replicate_length_filter
thf(fact_7693_remdups__filter,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( remdups @ A @ ( filter2 @ A @ P @ Xs2 ) )
      = ( filter2 @ A @ P @ ( remdups @ A @ Xs2 ) ) ) ).

% remdups_filter
thf(fact_7694_filter__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N: nat] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_7695_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( filter2 @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_7696_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,X: B,F2: B > A,Xs2: list @ B] :
          ( ~ ( P @ X )
         => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
            = ( filter2 @ B @ P @ Xs2 ) ) ) ) ).

% filter_insort_triv
thf(fact_7697_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X2: A] :
            ( filter2 @ A
            @ ^ [Y: A] : ( X2 != Y ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_7698_filter__remove1,axiom,
    ! [A: $tType,Q: A > $o,X: A,Xs2: list @ A] :
      ( ( filter2 @ A @ Q @ ( remove1 @ A @ X @ Xs2 ) )
      = ( remove1 @ A @ X @ ( filter2 @ A @ Q @ Xs2 ) ) ) ).

% filter_remove1
thf(fact_7699_partition__in__shuffles,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( member @ ( list @ A ) @ Xs2
      @ ( shuffles @ A @ ( filter2 @ A @ P @ Xs2 )
        @ ( filter2 @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 )
          @ Xs2 ) ) ) ).

% partition_in_shuffles
thf(fact_7700_filter__shuffles,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,Ys: list @ A] :
      ( ( image @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P ) @ ( shuffles @ A @ Xs2 @ Ys ) )
      = ( shuffles @ A @ ( filter2 @ A @ P @ Xs2 ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_shuffles
thf(fact_7701_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ( ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ ( filter2 @ A @ P @ Xs2 ) ) ) )
      & ( ~ ( P @ X )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( filter2 @ A @ P @ Xs2 ) ) ) ) ).

% filter.simps(2)
thf(fact_7702_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs2 ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs2 ) ) ) ).

% sum_list_filter_le_nat
thf(fact_7703_filter__in__nths,axiom,
    ! [A: $tType,Xs2: list @ A,S: set @ nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ( filter2 @ A
          @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ ( nths @ A @ Xs2 @ S ) ) )
          @ Xs2 )
        = ( nths @ A @ Xs2 @ S ) ) ) ).

% filter_in_nths
thf(fact_7704_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs2: list @ B,P: B > $o,F2: B > A] :
          ( ! [X5: B] :
              ( ( member @ B @ X5 @ ( set2 @ B @ Xs2 ) )
             => ( ~ ( P @ X5 )
               => ( ( F2 @ X5 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_7705_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,P: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( ( P @ X )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs2 ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X @ ( filter2 @ B @ P @ Xs2 ) ) ) ) ) ) ).

% filter_insort
thf(fact_7706_set__minus__filter__out,axiom,
    ! [A: $tType,Xs2: list @ A,Y2: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X2: A] : ( X2 != Y2 )
          @ Xs2 ) ) ) ).

% set_minus_filter_out
thf(fact_7707_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_7708_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Xs2 ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_7709_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] : ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
            @ Zs )
          = Xs2 ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_7710_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X2: A] :
                ~ ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_7711_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P4: A > $o,Xs: list @ A] :
            ( nths @ A @ Xs
            @ ( collect @ nat
              @ ^ [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( P4 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_7712_length__filter__conv__card,axiom,
    ! [A: $tType,P2: A > $o,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P2 @ Xs2 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
              & ( P2 @ ( nth @ A @ Xs2 @ I4 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_7713_distinct__length__filter,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs2 )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs2 ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs2 ) ) ) ) ) ).

% distinct_length_filter
thf(fact_7714_nth__transpose,axiom,
    ! [A: $tType,I2: nat,Xs2: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs2 ) @ I2 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs: list @ A] : ( nth @ A @ Xs @ I2 )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs2 ) ) ) ) ).

% nth_transpose
thf(fact_7715_transpose__column__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),I2: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs2 ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs2 ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs2 @ I2 ) ) ) ) ) ).

% transpose_column_length
thf(fact_7716_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F5: A > ( option @ B ),Xs: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F5 )
            @ ( filter2 @ A
              @ ^ [X2: A] :
                  ( ( F5 @ X2 )
                 != ( none @ B ) )
              @ Xs ) ) ) ) ).

% map_filter_def
thf(fact_7717_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B,L2: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L2 ) )
              & ( ( set2 @ B @ L2 )
                = A3 )
              & ( ( size_size @ ( list @ B ) @ L2 )
                = ( finite_card @ B @ A3 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = L2 ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_7718_map__of__filter__in,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ ( product_prod @ B @ A ),K: B,Z2: A,P: B > A > $o] :
      ( ( ( map_of @ B @ A @ Xs2 @ K )
        = ( some @ A @ Z2 ) )
     => ( ( P @ K @ Z2 )
       => ( ( map_of @ B @ A @ ( filter2 @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ P ) @ Xs2 ) @ K )
          = ( some @ A @ Z2 ) ) ) ) ).

% map_of_filter_in
thf(fact_7719_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_7720_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_7721_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,Xs2: list @ B] :
      ( ( map_filter @ B @ A @ F2 @ ( cons @ B @ X @ Xs2 ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F2 @ Xs2 )
        @ ^ [Y: A] : ( cons @ A @ Y @ ( map_filter @ B @ A @ F2 @ Xs2 ) )
        @ ( F2 @ X ) ) ) ).

% map_filter_simps(1)
thf(fact_7722_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B,B4: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( ord_less_eq @ ( set @ B ) @ B4 @ S2 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ B4 ) )
           => ( ( finite_finite @ B @ A3 )
             => ( ( finite_finite @ B @ B4 )
               => ( A3 = B4 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_7723_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_7724_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) )
            = A3 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_7725_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) )
          = ( finite_card @ B @ A3 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_7726_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_7727_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_7728_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_7729_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = ( nil @ B ) )
            = ( A3
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_7730_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,Xs2: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ S2 )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ Xs2 ) )
         => ( ( distinct @ B @ Xs2 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( set2 @ B @ Xs2 ) )
              = Xs2 ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_7731_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o,Xs2: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs2 ) )
      = ( map_filter @ B @ A
        @ ^ [X2: B] : ( if @ ( option @ A ) @ ( P @ X2 ) @ ( some @ A @ ( F2 @ X2 ) ) @ ( none @ A ) )
        @ Xs2 ) ) ).

% map_filter_map_filter
thf(fact_7732_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_7733_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert @ B @ X @ A3 ) )
            = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_7734_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_7735_tl__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( tl @ nat @ ( upt @ M @ N ) )
      = ( upt @ ( suc @ M ) @ N ) ) ).

% tl_upt
thf(fact_7736_tl__append2,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs2 @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs2 ) @ Ys ) ) ) ).

% tl_append2
thf(fact_7737_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( cons @ A @ X @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs2 ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X @ Xs2 ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_7738_length__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_7739_tl__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( tl @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ).

% tl_replicate
thf(fact_7740_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs2 ) ) ) ) ).

% sorted_tl
thf(fact_7741_distinct__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ A @ ( tl @ A @ Xs2 ) ) ) ).

% distinct_tl
thf(fact_7742_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A2: list @ A,X: A] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( member @ A @ X @ ( set2 @ A @ ( tl @ A @ A2 ) ) )
       => ( member @ A @ X @ ( set2 @ A @ A2 ) ) ) ) ).

% list.set_sel(2)
thf(fact_7743_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_7744_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_7745_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X222 ) )
      = X222 ) ).

% list.sel(3)
thf(fact_7746_Nil__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs2 ) )
      = ( ( Xs2
          = ( nil @ A ) )
        | ? [X2: A] :
            ( Xs2
            = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_7747_tl__Nil,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( tl @ A @ Xs2 )
        = ( nil @ A ) )
      = ( ( Xs2
          = ( nil @ A ) )
        | ? [X2: A] :
            ( Xs2
            = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_7748_tl__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs2 @ Ys ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys )
        @ ^ [Z: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys )
        @ Xs2 ) ) ).

% tl_append
thf(fact_7749_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X224: list @ A] : X224 ) ) ).

% tl_def
thf(fact_7750_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A2 ) ) ) ) ).

% list.map_sel(2)
thf(fact_7751_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs2 ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) ) ).

% map_tl
thf(fact_7752_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs: list @ A] :
            ( if @ nat
            @ ( Xs
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_7753_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs2: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs2 ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs2 ) @ N )
        = ( nth @ A @ Xs2 @ ( suc @ N ) ) ) ) ).

% nth_tl
thf(fact_7754_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_7755_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,Y2: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( member @ B @ X @ S2 )
       => ( ( member @ B @ Y2 @ S2 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y2 ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y2 ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_7756_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A,X: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X @ A3 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert @ B @ X @ A3 ) )
              = ( insort_key @ A @ B @ Less_eq @ F2 @ X @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_7757_transpose__max__length,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( transpose @ A @ Xs2 )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_max_length
thf(fact_7758_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs2 ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs2 )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X2: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_7759_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Xs2: list @ B,Ys: list @ B,A2: A] :
      ( ( foldr @ B @ A @ F2 @ ( append @ B @ Xs2 @ Ys ) @ A2 )
      = ( foldr @ B @ A @ F2 @ Xs2 @ ( foldr @ B @ A @ F2 @ Ys @ A2 ) ) ) ).

% foldr_append
thf(fact_7760_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N: nat,X: B] :
      ( ( foldr @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( compow @ ( A > A ) @ N @ ( F2 @ X ) ) ) ).

% foldr_replicate
thf(fact_7761_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,L2: list @ B,K: list @ B,F2: B > A > A,G: B > A > A] :
      ( ( A2 = B2 )
     => ( ( L2 = K )
       => ( ! [A6: A,X5: B] :
              ( ( member @ B @ X5 @ ( set2 @ B @ L2 ) )
             => ( ( F2 @ X5 @ A6 )
                = ( G @ X5 @ A6 ) ) )
         => ( ( foldr @ B @ A @ F2 @ L2 @ A2 )
            = ( foldr @ B @ A @ G @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_7762_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X: A,Xs2: list @ A] :
      ( ( foldr @ A @ B @ F2 @ ( cons @ A @ X @ Xs2 ) )
      = ( comp @ B @ B @ B @ ( F2 @ X ) @ ( foldr @ A @ B @ F2 @ Xs2 ) ) ) ).

% foldr_Cons
thf(fact_7763_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: B > A > A,F2: C > B,Xs2: list @ C,A2: A] :
      ( ( foldr @ B @ A @ G @ ( map @ C @ B @ F2 @ Xs2 ) @ A2 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F2 ) @ Xs2 @ A2 ) ) ).

% foldr_map
thf(fact_7764_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_7765_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs: list @ B] :
              ( foldr @ B @ A
              @ ^ [X2: B,B3: A] : ( plus_plus @ A @ ( F5 @ X2 ) @ ( times_times @ A @ A4 @ B3 ) )
              @ Xs
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_7766_length__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs2 ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs ) )
        @ Xs2
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_7767_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,Y2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs2 ) )
         => ( ( ( Xs2
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y2 )
                = Y2 ) )
            & ( ( Xs2
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs2 @ Y2 )
                = ( ord_max @ A @ ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) @ Y2 ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_7768_transpose__transpose,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs2 ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs2 ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs2 ) ) ) ).

% transpose_transpose
thf(fact_7769_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_7770_takeWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( takeWhile @ A @ P @ ( takeWhile @ A @ P @ Xs2 ) )
      = ( takeWhile @ A @ P @ Xs2 ) ) ).

% takeWhile_idem
thf(fact_7771_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs2 )
        = Xs2 )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X2 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_7772_takeWhile__append1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
          = ( takeWhile @ A @ P @ Xs2 ) ) ) ) ).

% takeWhile_append1
thf(fact_7773_takeWhile__append2,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( P @ X5 ) )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
        = ( append @ A @ Xs2 @ ( takeWhile @ A @ P @ Ys ) ) ) ) ).

% takeWhile_append2
thf(fact_7774_takeWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N: nat] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_7775_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs2: list @ B] :
      ( ( takeWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( map @ B @ A @ F2 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs2 ) ) ) ).

% takeWhile_map
thf(fact_7776_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ).

% sorted_takeWhile
thf(fact_7777_distinct__takeWhile,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ A @ ( takeWhile @ A @ P @ Xs2 ) ) ) ).

% distinct_takeWhile
thf(fact_7778_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_takeWhile_le
thf(fact_7779_takeWhile__cong,axiom,
    ! [A: $tType,L2: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L2 = K )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ L2 ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( takeWhile @ A @ P @ L2 )
          = ( takeWhile @ A @ Q @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_7780_set__takeWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( takeWhile @ A @ P @ Xs2 ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
        & ( P @ X ) ) ) ).

% set_takeWhileD
thf(fact_7781_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( takeWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_7782_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ( ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ ( takeWhile @ A @ P @ Xs2 ) ) ) )
      & ( ~ ( P @ X )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_7783_takeWhile__tail,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A,L2: list @ A] :
      ( ~ ( P @ X )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs2 @ ( cons @ A @ X @ L2 ) ) )
        = ( takeWhile @ A @ P @ Xs2 ) ) ) ).

% takeWhile_tail
thf(fact_7784_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs2 ) @ J )
        = ( nth @ A @ Xs2 @ J ) ) ) ).

% takeWhile_nth
thf(fact_7785_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ~ ( P @ ( nth @ A @ Xs2 @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_7786_takeWhile__append,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X5 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
          = ( append @ A @ Xs2 @ ( takeWhile @ A @ P @ Ys ) ) ) )
      & ( ~ ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( P @ X3 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
          = ( takeWhile @ A @ P @ Xs2 ) ) ) ) ).

% takeWhile_append
thf(fact_7787_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_7788_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs2: list @ A] :
      ( ! [I3: nat] :
          ( ( ord_less @ nat @ I3 @ J )
         => ( P @ ( nth @ A @ Xs2 @ I3 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_7789_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs2 ) ) )
         => ( ( filter2 @ B
              @ ^ [X2: B] : ( ord_less @ A @ T2 @ ( F2 @ X2 ) )
              @ Xs2 )
            = ( takeWhile @ B
              @ ^ [X2: B] : ( ord_less @ A @ T2 @ ( F2 @ X2 ) )
              @ Xs2 ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_7790_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P4: A > $o,Xs: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y: A,Ys3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P4 ) @ Xs ) @ ( product_Pair @ A @ ( list @ A ) @ Y @ Ys3 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P4 ) @ Xs ) ) ) ) ).

% extract_def
thf(fact_7791_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_7792_dropWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( dropWhile @ A @ P @ ( dropWhile @ A @ P @ Xs2 ) )
      = ( dropWhile @ A @ P @ Xs2 ) ) ).

% dropWhile_idem
thf(fact_7793_hd__upt,axiom,
    ! [I2: nat,J: nat] :
      ( ( ord_less @ nat @ I2 @ J )
     => ( ( hd @ nat @ ( upt @ I2 @ J ) )
        = I2 ) ) ).

% hd_upt
thf(fact_7794_hd__remdups__adj,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs2 ) )
      = ( hd @ A @ Xs2 ) ) ).

% hd_remdups_adj
thf(fact_7795_hd__append2,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs2 @ Ys ) )
        = ( hd @ A @ Xs2 ) ) ) ).

% hd_append2
thf(fact_7796_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs2 )
        = ( nil @ A ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X2 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_7797_dropWhile__append2,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
         => ( P @ X5 ) )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
        = ( dropWhile @ A @ P @ Ys ) ) ) ).

% dropWhile_append2
thf(fact_7798_dropWhile__append1,axiom,
    ! [A: $tType,X: A,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
     => ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs2 ) @ Ys ) ) ) ) ).

% dropWhile_append1
thf(fact_7799_hd__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_7800_dropWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X: A,N: nat] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N @ X ) )
          = ( replicate @ A @ N @ X ) ) ) ) ).

% dropWhile_replicate
thf(fact_7801_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P @ Xs2 ) @ ( dropWhile @ A @ P @ Xs2 ) )
      = Xs2 ) ).

% takeWhile_dropWhile_id
thf(fact_7802_hd__Cons__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs2 ) @ ( tl @ A @ Xs2 ) )
        = Xs2 ) ) ).

% hd_Cons_tl
thf(fact_7803_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_7804_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs2 )
        = ( nil @ A ) )
      = ( ( Xs2
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs2 ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_7805_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_7806_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,F2: A > B] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs2 ) )
        = ( F2 @ ( hd @ A @ Xs2 ) ) ) ) ).

% hd_map
thf(fact_7807_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( F2 @ ( hd @ A @ A2 ) ) ) ) ).

% list.map_sel(1)
thf(fact_7808_hd__conv__nth,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs2 )
        = ( nth @ A @ Xs2 @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_7809_hd__append,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
      ( ( ( Xs2
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs2 @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs2
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs2 @ Ys ) )
          = ( hd @ A @ Xs2 ) ) ) ) ).

% hd_append
thf(fact_7810_longest__common__prefix,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A] :
    ? [Ps2: list @ A,Xs4: list @ A,Ys5: list @ A] :
      ( ( Xs2
        = ( append @ A @ Ps2 @ Xs4 ) )
      & ( Ys
        = ( append @ A @ Ps2 @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) ).

% longest_common_prefix
thf(fact_7811_dropWhile__append3,axiom,
    ! [A: $tType,P: A > $o,Y2: A,Xs2: list @ A,Ys: list @ A] :
      ( ~ ( P @ Y2 )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys ) ) )
        = ( append @ A @ ( dropWhile @ A @ P @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) ) ) ) ).

% dropWhile_append3
thf(fact_7812_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X: A,Xs2: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ Xs2 ) )
      = ( cons @ A @ X
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y: A] : ( Y = X )
            @ Xs2 ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_7813_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X222 ) )
      = X21 ) ).

% list.sel(1)
thf(fact_7814_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ( ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( dropWhile @ A @ P @ Xs2 ) ) )
      & ( ~ ( P @ X )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( cons @ A @ X @ Xs2 ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_7815_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs2 )
        = Xs2 )
      = ( ( Xs2
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs2 ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_7816_hd__dropWhile,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs2 )
       != ( nil @ A ) )
     => ~ ( P @ ( hd @ A @ ( dropWhile @ A @ P @ Xs2 ) ) ) ) ).

% hd_dropWhile
thf(fact_7817_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( dropWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_7818_hd__concat,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A )] :
      ( ( Xs2
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs2 )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs2 ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs2 ) ) ) ) ) ).

% hd_concat
thf(fact_7819_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( A2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ A2 ) @ ( set2 @ A @ A2 ) ) ) ).

% list.set_sel(1)
thf(fact_7820_hd__in__set,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ Xs2 ) @ ( set2 @ A @ Xs2 ) ) ) ).

% hd_in_set
thf(fact_7821_dropWhile__cong,axiom,
    ! [A: $tType,L2: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L2 = K )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ L2 ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( dropWhile @ A @ P @ L2 )
          = ( dropWhile @ A @ Q @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_7822_set__dropWhileD,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs2: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs2 ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs2 ) ) ) ).

% set_dropWhileD
thf(fact_7823_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs2 ) ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ).

% length_dropWhile_le
thf(fact_7824_distinct__dropWhile,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ A @ ( dropWhile @ A @ P @ Xs2 ) ) ) ).

% distinct_dropWhile
thf(fact_7825_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs2: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs2 )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs2 ) ) ) ) ).

% sorted_dropWhile
thf(fact_7826_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs2: list @ B] :
      ( ( dropWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( map @ B @ A @ F2 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs2 ) ) ) ).

% dropWhile_map
thf(fact_7827_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List2: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) ).

% list.expand
thf(fact_7828_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] :
                ( X2
                = ( hd @ A @ Ys ) )
            @ ( tl @ A @ Ys ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_7829_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,Y2: A,Ys: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs2 )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( ( Xs2
          = ( append @ A @ ( takeWhile @ A @ P @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) ) )
        & ~ ( P @ Y2 ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_7830_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs2 ) ) )
         => ~ ( P @ X5 ) )
     => ( ( takeWhile @ A @ P @ Xs2 )
        = ( filter2 @ A @ P @ Xs2 ) ) ) ).

% takeWhile_eq_filter
thf(fact_7831_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F12: B,F23: A > ( list @ A ) > B,List3: list @ A] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F12
            @ ( F23 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_7832_dropWhile__append,axiom,
    ! [A: $tType,Xs2: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs2 ) )
           => ( P @ X5 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
          = ( dropWhile @ A @ P @ Ys ) ) )
      & ( ~ ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs2 ) )
             => ( P @ X3 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs2 @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs2 ) @ Ys ) ) ) ) ).

% dropWhile_append
thf(fact_7833_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z2: A,Zs: list @ A,Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Z2 @ Zs ) @ ( shuffles @ A @ Xs2 @ Ys ) )
      = ( ( ( Xs2
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs2 )
            = Z2 )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs2 ) @ Ys ) ) )
        | ( ( Ys
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys )
            = Z2 )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs2 @ ( tl @ A @ Ys ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_7834_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F1 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_7835_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_7836_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs2: list @ A,Y2: A,Ys: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs2 @ ( cons @ A @ Y2 @ Ys ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs2 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X2: A] : ( X2 = Y2 )
            @ Ys ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_7837_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs2: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs2 ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs2 ) @ J )
        = ( nth @ A @ Xs2 @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs2 ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_7838_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs2 )
        = ( append @ A @ ( tl @ A @ Xs2 ) @ ( cons @ A @ ( hd @ A @ Xs2 ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_7839_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( dropWhile @ A
            @ ^ [Y: A] : ( Y != X )
            @ ( rev @ A @ Xs2 ) )
          = ( cons @ A @ X
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y: A] : ( Y != X )
                @ Xs2 ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_7840_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs2: list @ A,X: A] :
      ( ( distinct @ A @ Xs2 )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ( ( takeWhile @ A
            @ ^ [Y: A] : ( Y != X )
            @ ( rev @ A @ Xs2 ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y: A] : ( Y != X )
                @ Xs2 ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_7841_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs2 ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs2
         != ( nil @ A ) )
        & ( Xs2
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( hd @ A @ Xs2 ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7842_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F5: A > nat,Xs: list @ A] :
            ( if @ nat
            @ ( Xs
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F5 @ ( hd @ A @ Xs ) ) @ ( size_list @ A @ F5 @ ( tl @ A @ Xs ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_7843_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs2: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs2 ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X2: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X2 ) )
                    @ Xs2 ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs2 ) )
                = Xs2 ) ) ) ) ) ).

% insort_key_remove1
thf(fact_7844_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P4: A > $o,Xs: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X2: A,Xa4: list @ A] : ( some @ A @ X2 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P4 ) @ Xs ) ) ) ) ).

% find_dropWhile
thf(fact_7845_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F5: A > $o,Xs: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F5 @ Xs ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F5 ) @ Xs ) ) ) ) ).

% partition_filter_conv
thf(fact_7846_find__cong,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs2 = Ys )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X5 )
              = ( Q @ X5 ) ) )
       => ( ( find @ A @ P @ Xs2 )
          = ( find @ A @ Q @ Ys ) ) ) ) ).

% find_cong
thf(fact_7847_partition__filter1,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs2 ) )
      = ( filter2 @ A @ P @ Xs2 ) ) ).

% partition_filter1
thf(fact_7848_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ( ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( some @ A @ X ) ) )
      & ( ~ ( P @ X )
       => ( ( find @ A @ P @ ( cons @ A @ X @ Xs2 ) )
          = ( find @ A @ P @ Xs2 ) ) ) ) ).

% find.simps(2)
thf(fact_7849_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu: A > $o] :
      ( ( find @ A @ Uu @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_7850_find__None__iff2,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P @ Xs2 ) )
      = ( ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
              & ( P @ X2 ) ) ) ) ).

% find_None_iff2
thf(fact_7851_find__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( ( find @ A @ P @ Xs2 )
        = ( none @ A ) )
      = ( ~ ? [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) )
              & ( P @ X2 ) ) ) ) ).

% find_None_iff
thf(fact_7852_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( partition @ A @ P @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_7853_partition__P,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs2 )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Yes ) )
           => ( P @ X3 ) )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ No4 ) )
           => ~ ( P @ X3 ) ) ) ) ).

% partition_P
thf(fact_7854_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X: A,Xs2: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X @ Xs2 ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes2: list @ A,No3: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Yes2 ) @ No3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X @ No3 ) ) )
        @ ( partition @ A @ P @ Xs2 ) ) ) ).

% partition.simps(2)
thf(fact_7855_partition__filter2,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs2 ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs2 ) ) ).

% partition_filter2
thf(fact_7856_partition__set,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs2 )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes ) @ ( set2 @ A @ No4 ) )
        = ( set2 @ A @ Xs2 ) ) ) ).

% partition_set
thf(fact_7857_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs2: list @ A] :
      ( ( ( some @ A @ X )
        = ( find @ A @ P @ Xs2 ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( P @ ( nth @ A @ Xs2 @ I4 ) )
            & ( X
              = ( nth @ A @ Xs2 @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs2 @ J3 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_7858_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs2: list @ A,X: A] :
      ( ( ( find @ A @ P @ Xs2 )
        = ( some @ A @ X ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( P @ ( nth @ A @ Xs2 @ I4 ) )
            & ( X
              = ( nth @ A @ Xs2 @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs2 @ J3 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_7859_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X2: nat] : ( F2 @ ( G @ X2 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_7860_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A3: set @ A,B4: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ S2 )
         => ( ( finite_finite @ A @ A3 )
           => ( ( finite_finite @ A @ B4 )
             => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B4 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
                  = ( finite_fold @ A @ B @ F2 @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) @ B4 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_7861_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N @ ( F2 @ N ) ) ) ).

% strict_mono_imp_increasing
thf(fact_7862_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R: A > B,M: A,N: A] :
          ( ( order_strict_mono @ A @ B @ R )
         => ( ( ord_less_eq @ A @ M @ N )
           => ( ord_less_eq @ B @ ( R @ M ) @ ( R @ N ) ) ) ) ) ).

% strict_mono_leD
thf(fact_7863_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) )
            = ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ).

% strict_mono_less_eq
thf(fact_7864_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N2: A] : ( plus_plus @ A @ N2 @ K ) ) ) ).

% strict_mono_add
thf(fact_7865_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) )
            = ( ord_less @ A @ X @ Y2 ) ) ) ) ).

% strict_mono_less
thf(fact_7866_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X2: A,Y: A] :
              ( ( ord_less @ A @ X2 @ Y )
             => ( ord_less @ B @ ( F5 @ X2 ) @ ( F5 @ Y ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_7867_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X5: A,Y4: A] :
              ( ( ord_less @ A @ X5 @ Y4 )
             => ( ord_less @ B @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_7868_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X @ Y2 )
           => ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y2 ) ) ) ) ) ).

% strict_monoD
thf(fact_7869_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N2: nat] : ( ord_less @ A @ ( F5 @ N2 ) @ ( F5 @ ( suc @ N2 ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_7870_Finite__Set_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,G: A > B > B,A3: set @ A,S: B,T2: B,B4: set @ A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ G )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
         => ( ( finite_finite @ A @ A3 )
           => ( ! [X5: A] :
                  ( ( member @ A @ X5 @ A3 )
                 => ( ( F2 @ X5 )
                    = ( G @ X5 ) ) )
             => ( ( S = T2 )
               => ( ( A3 = B4 )
                 => ( ( finite_fold @ A @ B @ F2 @ S @ A3 )
                    = ( finite_fold @ A @ B @ G @ T2 @ B4 ) ) ) ) ) ) ) ) ) ).

% Finite_Set.fold_cong
thf(fact_7871_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S2: set @ A,F2: A > B > B,G: C > A,R2: set @ C] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S2 )
       => ( finite4664212375090638736ute_on @ C @ B @ R2 @ ( comp @ A @ ( B > B ) @ C @ F2 @ G ) ) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
thf(fact_7872_comp__fun__commute__on_Ofold__fun__left__comm,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) )
            = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A3 ) ) ) ) ) ).

% comp_fun_commute_on.fold_fun_left_comm
thf(fact_7873_comp__fun__commute__on_Ofold__insert2,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
              = ( finite_fold @ A @ B @ F2 @ ( F2 @ X @ Z2 ) @ A3 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert2
thf(fact_7874_comp__fun__commute__on_Ofold__insert,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
              = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ A3 ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert
thf(fact_7875_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ! [X5: nat,Y4: nat] :
              ( ( ord_less_eq @ nat @ X5 @ Y4 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y4 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X2: nat] : ( F2 @ ( G @ X2 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_7876_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,A3: set @ A,X: A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z2 @ A3 )
              = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_7877_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,F2: A > B > B,X: A,A3: set @ A,Z2: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S2 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ S2 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F2 @ Z2 @ ( insert @ A @ X @ A3 ) )
            = ( F2 @ X @ ( finite_fold @ A @ B @ F2 @ Z2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_7878_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S: set @ A,I5: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I5 )
               => ( topolo7761053866217962861closed @ A @ ( F2 @ I3 ) ) )
           => ( ! [I9: set @ B] :
                  ( ( finite_finite @ B @ I9 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I9 @ I5 )
                   => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I9 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I5 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_7879_ran__map__upd,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( none @ A ) )
     => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) ) )
        = ( insert @ A @ B2 @ ( ran @ B @ A @ M ) ) ) ) ).

% ran_map_upd
thf(fact_7880_closed__Diff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T4: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo1002775350975398744n_open @ A @ T4 )
           => ( topolo7761053866217962861closed @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T4 ) ) ) ) ) ).

% closed_Diff
thf(fact_7881_open__Diff,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T4: set @ A] :
          ( ( topolo1002775350975398744n_open @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T4 )
           => ( topolo1002775350975398744n_open @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T4 ) ) ) ) ) ).

% open_Diff
thf(fact_7882_ran__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ B @ A
        @ ^ [X2: B] : ( none @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% ran_empty
thf(fact_7883_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_7884_ran__restrictD,axiom,
    ! [B: $tType,A: $tType,Y2: A,M: B > ( option @ A ),A3: set @ B] :
      ( ( member @ A @ Y2 @ ( ran @ B @ A @ ( restrict_map @ B @ A @ M @ A3 ) ) )
     => ? [X5: B] :
          ( ( member @ B @ X5 @ A3 )
          & ( ( M @ X5 )
            = ( some @ A @ Y2 ) ) ) ) ).

% ran_restrictD
thf(fact_7885_ranI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( some @ A @ B2 ) )
     => ( member @ A @ B2 @ ( ran @ B @ A @ M ) ) ) ).

% ranI
thf(fact_7886_closed__diagonal,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Y: product_prod @ A @ A] :
            ? [X2: A] :
              ( Y
              = ( product_Pair @ A @ A @ X2 @ X2 ) ) ) ) ) ).

% closed_diagonal
thf(fact_7887_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y ) )
              & ( ord_less_eq @ A @ Y @ X2 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_7888_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y ) )
              & ( ord_less_eq @ A @ X2 @ Y ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_7889_ran__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( collect @ B
            @ ^ [B3: B] :
              ? [A4: A] :
                ( ( M3 @ A4 )
                = ( some @ B @ B3 ) ) ) ) ) ).

% ran_def
thf(fact_7890_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S2: set @ A,Y2: A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ~ ( member @ A @ Y2 @ S2 )
           => ? [U6: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U6 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member @ A @ Y2 @ U6 )
                & ( ord_less_eq @ ( set @ A ) @ S2 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U6 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_7891_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S2: set @ A,T4: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S2 )
         => ( ( topolo7761053866217962861closed @ A @ T4 )
           => ( ( ( inf_inf @ ( set @ A ) @ S2 @ T4 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U6: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U6 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S2 @ U6 )
                  & ( ord_less_eq @ ( set @ A ) @ T4 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U6 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_7892_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X: A,A3: set @ A] :
          ( ( member @ A @ X @ A3 )
         => ( ( topolo1002775350975398744n_open @ A @ A3 )
           => ? [A15: set @ A] :
                ( ( member @ A @ X @ A15 )
                & ( topolo7761053866217962861closed @ A @ A15 )
                & ( ord_less_eq @ ( set @ A ) @ A15 @ A3 )
                & ( eventually @ A
                  @ ^ [Y: A] : ( member @ A @ Y @ A15 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X ) ) ) ) ) ) ).

% nhds_closed
thf(fact_7893_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F4: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [T7: set @ A] :
                ( ( member @ ( set @ A ) @ T7 @ F4 )
               => ( topolo7761053866217962861closed @ A @ T7 ) )
           => ( ! [F16: set @ ( set @ A )] :
                  ( ( finite_finite @ ( set @ A ) @ F16 )
                 => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F16 @ F4 )
                   => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F16 ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ F4 ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip
thf(fact_7894_compact__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [U7: set @ A] :
            ! [A7: set @ ( set @ A )] :
              ( ! [X2: set @ A] :
                  ( ( member @ ( set @ A ) @ X2 @ A7 )
                 => ( topolo7761053866217962861closed @ A @ X2 ) )
             => ( ! [B7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B7 @ A7 )
                   => ( ( finite_finite @ ( set @ A ) @ B7 )
                     => ( ( inf_inf @ ( set @ A ) @ U7 @ ( complete_Inf_Inf @ ( set @ A ) @ B7 ) )
                       != ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( inf_inf @ ( set @ A ) @ U7 @ ( complete_Inf_Inf @ ( set @ A ) @ A7 ) )
                 != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% compact_fip
thf(fact_7895_lenlex__append2,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Us: list @ A,Xs2: list @ A,Ys: list @ A] :
      ( ( irrefl @ A @ R2 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs2 ) @ ( append @ A @ Us @ Ys ) ) @ ( lenlex @ A @ R2 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( lenlex @ A @ R2 ) ) ) ) ).

% lenlex_append2
thf(fact_7896_inj__sgn__power,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( inj_on @ real @ real
        @ ^ [Y: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_7897_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs2: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs2 )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs2 = Ys ) ) ) ).

% inj_map_eq_map
thf(fact_7898_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_7899_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B3: A] : ( divide_divide @ A @ B3 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_7900_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_7901_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_7902_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Xs2: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs2 @ Ys ) @ ( append @ A @ Xs2 @ Zs ) ) @ ( lexord @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_7903_inj__on__insert,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ A2 @ A3 ) )
      = ( ( inj_on @ A @ B @ F2 @ A3 )
        & ~ ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% inj_on_insert
thf(fact_7904_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y2: A,Xs2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ Y2 @ ( set2 @ A @ Xs2 ) ) )
     => ( ( filter2 @ A
          @ ^ [X2: A] :
              ( ( F2 @ Y2 )
              = ( F2 @ X2 ) )
          @ Xs2 )
        = ( filter2 @ A
          @ ( ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
            @ Y2 )
          @ Xs2 ) ) ) ).

% inj_on_filter_key_eq
thf(fact_7905_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs2 ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs2 ) ) ) ) ).

% map_removeAll_inj
thf(fact_7906_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ ( set2 @ B @ Ys ) ) )
       => ( Xs2 = Ys ) ) ) ).

% map_inj_on
thf(fact_7907_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs2: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs2 ) @ ( set2 @ A @ Ys ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs2 )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs2 = Ys ) ) ) ).

% inj_on_map_eq_map
thf(fact_7908_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
      = ( ( distinct @ B @ Xs2 )
        & ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs2 ) ) ) ) ).

% distinct_map
thf(fact_7909_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A3 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ A3 ) ) ).

% inj_on_mapI
thf(fact_7910_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_7911_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs2: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs2 )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( Xs2 = Ys ) ) ) ).

% map_injective
thf(fact_7912_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F2 @ Xs2 ) )
        = ( map @ A @ B @ F2 @ ( remdups_adj @ A @ Xs2 ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_7913_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I5: set @ A,A3: A > ( set @ B ),F2: B > C] :
      ( ! [I3: A,J2: A] :
          ( ( member @ A @ I3 @ I5 )
         => ( ( member @ A @ J2 @ I5 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I3 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I3 ) ) ) ) )
     => ( ! [I3: A] :
            ( ( member @ A @ I3 @ I5 )
           => ( inj_on @ B @ C @ F2 @ ( A3 @ I3 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I5 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_7914_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [X5: A,Y4: A] :
              ( ( ord_less @ A @ X5 @ Y4 )
             => ( ( member @ A @ X5 @ A3 )
               => ( ( member @ A @ Y4 @ A3 )
                 => ( ( F2 @ X5 )
                   != ( F2 @ Y4 ) ) ) ) )
         => ( ! [X5: A,Y4: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ( member @ A @ Y4 @ A3 )
                 => ( ( ord_less_eq @ A @ X5 @ Y4 )
                    | ( ord_less_eq @ A @ Y4 @ X5 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A3 ) ) ) ) ).

% linorder_inj_onI
thf(fact_7915_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B4: set @ A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
       => ( inj_on @ A @ B @ F2 @ A3 ) ) ) ).

% subset_inj_on
thf(fact_7916_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A3 )
       => ( inj_on @ A @ B @ F2 @ B4 ) ) ) ).

% inj_on_subset
thf(fact_7917_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
         => ( ( ( image @ A @ B @ F2 @ A3 )
              = ( image @ A @ B @ F2 @ B4 ) )
            = ( A3 = B4 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_7918_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B4: set @ A,A2: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B4 )
     => ( ( member @ A @ A2 @ B4 )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ A3 ) )
            = ( member @ A @ A2 @ A3 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_7919_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S2: set @ A,F2: B > A,T4: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( image @ B @ A @ F2 @ T4 ) )
      = ( ? [U7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U7 @ T4 )
            & ( inj_on @ B @ A @ F2 @ U7 )
            & ( S2
              = ( image @ B @ A @ F2 @ U7 ) ) ) ) ) ).

% subset_image_inj
thf(fact_7920_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B4 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% inj_image_subset_iff
thf(fact_7921_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,A10: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F5: A > B] :
              ( ( inj_on @ A @ B @ F5 @ A3 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ A10 ) ) )
        = ( ? [G4: B > A] :
              ( ( image @ B @ A @ G4 @ A10 )
              = A3 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_7922_finite__surj__inj,axiom,
    ! [A: $tType,A3: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ A @ A @ F2 @ A3 ) )
       => ( inj_on @ A @ A @ F2 @ A3 ) ) ) ).

% finite_surj_inj
thf(fact_7923_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B4: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B4 )
       => ( ( finite_finite @ B @ B4 )
         => ( finite_finite @ A @ A3 ) ) ) ) ).

% inj_on_finite
thf(fact_7924_endo__inj__surj,axiom,
    ! [A: $tType,A3: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F2 @ A3 ) @ A3 )
       => ( ( inj_on @ A @ A @ F2 @ A3 )
         => ( ( image @ A @ A @ F2 @ A3 )
            = A3 ) ) ) ) ).

% endo_inj_surj
thf(fact_7925_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) @ C5 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B4 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_7926_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C5: set @ A,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C5 )
       => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
         => ( ( image @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B4 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_7927_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_7928_image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) )
        = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B4 ) ) ) ) ).

% image_set_diff
thf(fact_7929_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_7930_lexord__irrefl,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R2 )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R2 ) ) ) ).

% lexord_irrefl
thf(fact_7931_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X2: A] : X2
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_7932_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_7933_inj__diff__right,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( inj_on @ A @ A
          @ ^ [B3: A] : ( minus_minus @ A @ B3 @ A2 )
          @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_diff_right
thf(fact_7934_inj__on__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( inj_on @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) ) ).

% inj_on_diff
thf(fact_7935_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B3: A] : ( plus_plus @ A @ B3 @ A2 )
          @ A3 ) ) ).

% inj_on_add'
thf(fact_7936_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 ) ) ).

% inj_on_add
thf(fact_7937_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A3 ) ) ) ).

% inj_on_mult
thf(fact_7938_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X5: A,Y4: A] :
              ( ( ord_less @ A @ X5 @ Y4 )
             => ( ( F2 @ X5 )
               != ( F2 @ Y4 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_7939_irrefl__lex,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R ) ) ) ).

% irrefl_lex
thf(fact_7940_irrefl__def,axiom,
    ! [A: $tType] :
      ( ( irrefl @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [A4: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A4 ) @ R5 ) ) ) ).

% irrefl_def
thf(fact_7941_irreflI,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ! [A6: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ A6 ) @ R2 )
     => ( irrefl @ A @ R2 ) ) ).

% irreflI
thf(fact_7942_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,X: B,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( member @ B @ X @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B4 )
         => ( member @ A @ ( the_inv_into @ A @ B @ A3 @ F2 @ X ) @ B4 ) ) ) ) ).

% the_inv_into_into
thf(fact_7943_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( finite_card @ B @ A3 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A3 ) ) ).

% pigeonhole
thf(fact_7944_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S2: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S2 @ F2 )
     => ( inj_on @ B @ A @ F2 @ S2 ) ) ).

% folding_insort_key.inj_on
thf(fact_7945_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S2: set @ A,T4: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ S2 )
     => ( ( finite_finite @ B @ T4 )
       => ( ( ( finite_card @ A @ S2 )
            = ( finite_card @ B @ T4 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ S2 ) @ T4 )
           => ( ( ! [X2: B] :
                    ( ( member @ B @ X2 @ T4 )
                   => ? [Y: A] :
                        ( ( member @ A @ Y @ S2 )
                        & ( ( F2 @ Y )
                          = X2 ) ) ) )
              = ( inj_on @ A @ B @ F2 @ S2 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_7946_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B4: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B4 )
       => ( ( inj_on @ B @ A @ G @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B4 ) @ A3 )
           => ( ( finite_finite @ A @ A3 )
             => ( ( finite_finite @ B @ B4 )
               => ( ( finite_card @ A @ A3 )
                  = ( finite_card @ B @ B4 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_7947_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_7948_lexl__not__refl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),X: list @ A] :
      ( ( irrefl @ A @ R )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ X ) @ ( lex @ A @ R ) ) ) ).

% lexl_not_refl
thf(fact_7949_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X: A,Xs2: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ X @ ( set2 @ A @ Xs2 ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X @ Xs2 ) )
        = ( removeAll @ B @ ( F2 @ X ) @ ( map @ A @ B @ F2 @ Xs2 ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_7950_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C5: set @ A,A3: set @ C,B4: C > ( set @ A ),J: C] :
      ( ( inj_on @ A @ B @ F2 @ C5 )
     => ( ! [X5: C] :
            ( ( member @ C @ X5 @ A3 )
           => ( ord_less_eq @ ( set @ A ) @ ( B4 @ X5 ) @ C5 ) )
       => ( ( member @ C @ J @ A3 )
         => ( ( image @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B4 @ A3 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X2: C] : ( image @ A @ B @ F2 @ ( B4 @ X2 ) )
                @ A3 ) ) ) ) ) ) ).

% image_INT
thf(fact_7951_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B4 )
       => ( ( ? [F5: A > B] :
                ( ( inj_on @ A @ B @ F5 @ A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ B4 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_7952_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B4: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B4 )
       => ( ( finite_finite @ B @ B4 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_7953_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B4 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B4 ) )
         => ? [F3: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A3 ) @ B4 )
              & ( inj_on @ A @ B @ F3 @ A3 ) ) ) ) ) ).

% card_le_inj
thf(fact_7954_inj__on__Un,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B4: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( inj_on @ A @ B @ F2 @ A3 )
        & ( inj_on @ A @ B @ F2 @ B4 )
        & ( ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B4 ) ) @ ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B4 @ A3 ) ) )
          = ( bot_bot @ ( set @ B ) ) ) ) ) ).

% inj_on_Un
thf(fact_7955_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_7956_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs2: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs2 ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs2 ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs2 ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs2 )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs2 = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_7957_funpow__inj__finite,axiom,
    ! [A: $tType,P2: A > A,X: A] :
      ( ( inj_on @ A @ A @ P2 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y: A] :
              ? [N2: nat] :
                ( Y
                = ( compow @ ( A > A ) @ N2 @ P2 @ X ) ) ) )
       => ~ ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( compow @ ( A > A ) @ N3 @ P2 @ X )
               != X ) ) ) ) ).

% funpow_inj_finite
thf(fact_7958_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,T2: list @ ( product_prod @ A @ C ),K: A,X: C] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map_of @ A @ C @ T2 @ K )
          = ( some @ C @ X ) )
       => ( ( map_of @ B @ C
            @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C )
              @ ( product_case_prod @ A @ C @ ( product_prod @ B @ C )
                @ ^ [K2: A] : ( product_Pair @ B @ C @ ( F2 @ K2 ) ) )
              @ T2 )
            @ ( F2 @ K ) )
          = ( some @ C @ X ) ) ) ) ).

% map_of_mapk_SomeI
thf(fact_7959_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B4: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B4 )
       => ( ( inj_on @ B @ A @ G @ B4 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B4 ) @ A3 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A3 @ B4 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_7960_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C5: set @ A,B4: set @ A,X: A] :
      ( ( inj_on @ A @ B @ G @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ C5 @ ( sup_sup @ ( set @ A ) @ B4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I4: B] : ( if @ A @ ( member @ B @ I4 @ ( image @ A @ B @ G @ C5 ) ) @ ( the_inv_into @ A @ B @ C5 @ G @ I4 ) @ X )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_7961_inj__on__rev,axiom,
    ! [A: $tType,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A3 ) ).

% inj_on_rev
thf(fact_7962_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [F3: A > nat,N3: nat] :
          ( ( ( image @ A @ nat @ F3 @ A3 )
            = ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) )
          & ( inj_on @ A @ nat @ F3 @ A3 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_7963_inj__on__Cons1,axiom,
    ! [A: $tType,X: A,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ A3 ) ).

% inj_on_Cons1
thf(fact_7964_inj__on__diff__nat,axiom,
    ! [N4: set @ nat,K: nat] :
      ( ! [N3: nat] :
          ( ( member @ nat @ N3 @ N4 )
         => ( ord_less_eq @ nat @ K @ N3 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N2: nat] : ( minus_minus @ nat @ N2 @ K )
        @ N4 ) ) ).

% inj_on_diff_nat
thf(fact_7965_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_7966_inj__Suc,axiom,
    ! [N4: set @ nat] : ( inj_on @ nat @ nat @ suc @ N4 ) ).

% inj_Suc
thf(fact_7967_inj__Some,axiom,
    ! [A: $tType,A3: set @ A] : ( inj_on @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ).

% inj_Some
thf(fact_7968_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X8: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ ( F2 @ X2 ) )
      @ X8 ) ).

% inj_on_convol_ident
thf(fact_7969_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [N3: nat,F3: nat > A] :
          ( ( A3
            = ( image @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) ) )
          & ( inj_on @ nat @ A @ F3
            @ ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_7970_inj__split__Cons,axiom,
    ! [A: $tType,X8: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs: list @ A,N2: A] : ( cons @ A @ N2 @ Xs ) )
      @ X8 ) ).

% inj_split_Cons
thf(fact_7971_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B )] :
      ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
      @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
        @ ^ [I4: A,J3: B] : ( product_Pair @ B @ A @ J3 @ I4 ) )
      @ A3 ) ).

% swap_inj_on
thf(fact_7972_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X4: $o > A,Y9: $o > A] :
              ( ( ord_less_eq @ A @ ( X4 @ $false ) @ ( Y9 @ $false ) )
              & ( ord_less_eq @ A @ ( X4 @ $true ) @ ( Y9 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_7973_inj__on__nth,axiom,
    ! [A: $tType,Xs2: list @ A,I5: set @ nat] :
      ( ( distinct @ A @ Xs2 )
     => ( ! [X5: nat] :
            ( ( member @ nat @ X5 @ I5 )
           => ( ord_less @ nat @ X5 @ ( size_size @ ( list @ A ) @ Xs2 ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs2 ) @ I5 ) ) ) ).

% inj_on_nth
thf(fact_7974_infinite__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ~ ( finite_finite @ A @ S2 )
     => ? [F3: nat > A] :
          ( ( inj_on @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F3 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ).

% infinite_countable_subset
thf(fact_7975_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S2: set @ A] :
      ( ( ~ ( finite_finite @ A @ S2 ) )
      = ( ? [F5: nat > A] :
            ( ( inj_on @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) ) @ S2 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_7976_summable__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_7977_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: A > A,S: A] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ S )
        = S )
     => ( ! [M4: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
           => ( ( ord_less @ nat @ M4 @ N )
             => ( ( compow @ ( A > A ) @ M4 @ F2 @ S )
               != S ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K2: nat] : ( compow @ ( A > A ) @ K2 @ F2 @ S )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_7978_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_7979_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_7980_suminf__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X5: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
         => ( ! [X5: nat] :
                ( ~ ( member @ nat @ X5 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X5 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_7981_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A18: set @ B,B15: set @ A,F22: C > D,B23: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F1 @ A18 )
        = B15 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F22 @ B23 ) @ A26 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B15 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A18 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_7982_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
            & ( inj_on @ B @ A @ F2 @ T9 )
            & ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_7983_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: A > B,A26: set @ A,A18: set @ B,F1: B > C,B15: set @ C,F22: D > A,B23: set @ D] :
      ( ( member @ ( A > B ) @ G @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A18 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F1 @ A18 ) @ B15 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F22 @ B23 ) @ A26 )
         => ( member @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B23 @ F1 @ F22 @ G ) @ ( bNF_Wellorder_Func @ D @ C @ B23 @ B15 ) ) ) ) ) ).

% Func_map
thf(fact_7984_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S2: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S2 ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T9 @ S2 )
              & ( inj_on @ B @ A @ F2 @ T9 ) )
           => ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_7985_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M: B > ( option @ A ),X: B,Y2: A,Z2: A] :
      ( ( ( M @ X )
        = ( some @ A @ Y2 ) )
     => ( ( inj_on @ B @ ( option @ A ) @ M @ ( dom @ B @ A @ M ) )
       => ( ~ ( member @ A @ Z2 @ ( ran @ B @ A @ M ) )
         => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M @ X @ ( some @ A @ Z2 ) ) )
            = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( ran @ B @ A @ M ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Z2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% ran_map_upd_Some
thf(fact_7986_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R2 )
     => ( ( transitive_rtrancl @ A @ R2 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N2: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R2 )
            @ ( collect @ nat
              @ ^ [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( finite_card @ ( product_prod @ A @ A ) @ R2 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_7987_dom__eq__empty__conv,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B )] :
      ( ( ( dom @ A @ B @ F2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( F2
        = ( ^ [X2: A] : ( none @ B ) ) ) ) ).

% dom_eq_empty_conv
thf(fact_7988_fun__upd__None__if__notin__dom,axiom,
    ! [B: $tType,A: $tType,K: A,M: A > ( option @ B )] :
      ( ~ ( member @ A @ K @ ( dom @ A @ B @ M ) )
     => ( ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) )
        = M ) ) ).

% fun_upd_None_if_notin_dom
thf(fact_7989_dom__const,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( some @ B @ ( F2 @ X2 ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% dom_const
thf(fact_7990_dom__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dom @ A @ B
        @ ^ [X2: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% dom_empty
thf(fact_7991_dom__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y2: option @ B,F2: A > ( option @ B ),X: A] :
      ( ( ( Y2
          = ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X @ Y2 ) )
          = ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F2 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
      & ( ( Y2
         != ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X @ Y2 ) )
          = ( insert @ A @ X @ ( dom @ A @ B @ F2 ) ) ) ) ) ).

% dom_fun_upd
thf(fact_7992_rtrancl__Un__subset,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R2 ) @ ( transitive_rtrancl @ A @ S2 ) ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S2 ) ) ) ).

% rtrancl_Un_subset
thf(fact_7993_rtrancl__mono,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_mono
thf(fact_7994_rtrancl__subset,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ S2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ S2 @ ( transitive_rtrancl @ A @ R2 ) )
       => ( ( transitive_rtrancl @ A @ S2 )
          = ( transitive_rtrancl @ A @ R2 ) ) ) ) ).

% rtrancl_subset
thf(fact_7995_rtrancl__subset__rtrancl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ ( transitive_rtrancl @ A @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R ) @ ( transitive_rtrancl @ A @ S ) ) ) ).

% rtrancl_subset_rtrancl
thf(fact_7996_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_7997_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X: list @ A,Y2: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( ( size_size @ ( list @ A ) @ X )
        = ( size_size @ ( list @ A ) @ Y2 ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_7998_rtrancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A22 != A1 )
       => ~ ! [B6: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B6 ) @ ( transitive_rtrancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B6 @ A22 ) @ R ) ) ) ) ).

% rtrancl.cases
thf(fact_7999_rtrancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R ) )
      = ( ? [A4: A] :
            ( ( A1 = A4 )
            & ( A22 = A4 ) )
        | ? [A4: A,B3: A,C3: A] :
            ( ( A1 = A4 )
            & ( A22 = C3 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B3 ) @ ( transitive_rtrancl @ A @ R ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ C3 ) @ R ) ) ) ) ).

% rtrancl.simps
thf(fact_8000_rtrancl_Ortrancl__refl,axiom,
    ! [A: $tType,A2: A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( transitive_rtrancl @ A @ R ) ) ).

% rtrancl.rtrancl_refl
thf(fact_8001_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% rtrancl.rtrancl_into_rtrancl
thf(fact_8002_rtranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A2 != B2 )
       => ~ ! [Y4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ ( transitive_rtrancl @ A @ R ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ B2 ) @ R ) ) ) ) ).

% rtranclE
thf(fact_8003_rtrancl__trans,axiom,
    ! [A: $tType,X: A,Y2: A,R: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% rtrancl_trans
thf(fact_8004_rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( P @ A2 )
       => ( ! [Y4: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ ( transitive_rtrancl @ A @ R ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z5 ) @ R )
               => ( ( P @ Y4 )
                 => ( P @ Z5 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% rtrancl_induct
thf(fact_8005_converse__rtranclE,axiom,
    ! [A: $tType,X: A,Z2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( X != Z2 )
       => ~ ! [Y4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ R )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ).

% converse_rtranclE
thf(fact_8006_converse__rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( P @ B2 )
       => ( ! [Y4: A,Z5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z5 ) @ R )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
               => ( ( P @ Z5 )
                 => ( P @ Y4 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_rtrancl_induct
thf(fact_8007_converse__rtrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% converse_rtrancl_into_rtrancl
thf(fact_8008_rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( P @ Ax @ Ay )
       => ( ! [A6: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
               => ( ( P @ A6 @ B6 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% rtrancl_induct2
thf(fact_8009_converse__rtranclE2,axiom,
    ! [B: $tType,A: $tType,Xa2: A,Xb2: B,Za2: A,Zb: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa2 @ Xb2 ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( ( product_Pair @ A @ B @ Xa2 @ Xb2 )
         != ( product_Pair @ A @ B @ Za2 @ Zb ) )
       => ~ ! [A6: A,B6: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa2 @ Xb2 ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ R )
             => ~ ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) ) ) ) ) ).

% converse_rtranclE2
thf(fact_8010_converse__rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
     => ( ( P @ Bx @ By )
       => ( ! [A6: A,B6: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B6 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R ) )
               => ( ( P @ Aa2 @ Ba )
                 => ( P @ A6 @ B6 ) ) ) )
         => ( P @ Ax @ Ay ) ) ) ) ).

% converse_rtrancl_induct2
thf(fact_8011_domI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( some @ A @ B2 ) )
     => ( member @ B @ A2 @ ( dom @ B @ A @ M ) ) ) ).

% domI
thf(fact_8012_domD,axiom,
    ! [A: $tType,B: $tType,A2: A,M: A > ( option @ B )] :
      ( ( member @ A @ A2 @ ( dom @ A @ B @ M ) )
     => ? [B6: B] :
          ( ( M @ A2 )
          = ( some @ B @ B6 ) ) ) ).

% domD
thf(fact_8013_dom__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dom @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( collect @ A
            @ ^ [A4: A] :
                ( ( M3 @ A4 )
               != ( none @ B ) ) ) ) ) ).

% dom_def
thf(fact_8014_domIff,axiom,
    ! [A: $tType,B: $tType,A2: A,M: A > ( option @ B )] :
      ( ( member @ A @ A2 @ ( dom @ A @ B @ M ) )
      = ( ( ( M @ A2 )
         != ( none @ B ) ) ) ) ).

% domIff
thf(fact_8015_finite__map__freshness,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B )] :
      ( ( finite_finite @ A @ ( dom @ A @ B @ F2 ) )
     => ( ~ ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
       => ? [X5: A] :
            ( ( F2 @ X5 )
            = ( none @ B ) ) ) ) ).

% finite_map_freshness
thf(fact_8016_tranclD,axiom,
    ! [A: $tType,X: A,Y2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_trancl @ A @ R2 ) )
     => ? [Z5: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z5 ) @ R2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ Y2 ) @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ).

% tranclD
thf(fact_8017_rtranclD,axiom,
    ! [A: $tType,A2: A,B2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R2 ) )
     => ( ( A2 = B2 )
        | ( ( A2 != B2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ) ).

% rtranclD
thf(fact_8018_tranclD2,axiom,
    ! [A: $tType,X: A,Y2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_trancl @ A @ R2 ) )
     => ? [Z5: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z5 ) @ ( transitive_rtrancl @ A @ R2 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z5 @ Y2 ) @ R2 ) ) ) ).

% tranclD2
thf(fact_8019_trancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ).

% trancl_into_rtrancl
thf(fact_8020_rtrancl__eq__or__trancl,axiom,
    ! [A: $tType,X: A,Y2: A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_rtrancl @ A @ R2 ) )
      = ( ( X = Y2 )
        | ( ( X != Y2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_trancl @ A @ R2 ) ) ) ) ) ).

% rtrancl_eq_or_trancl
thf(fact_8021_rtrancl__into__trancl1,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_into_trancl1
thf(fact_8022_rtrancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_into_trancl2
thf(fact_8023_rtrancl__trancl__trancl,axiom,
    ! [A: $tType,X: A,Y2: A,R: set @ ( product_prod @ A @ A ),Z2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z2 ) @ ( transitive_trancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% rtrancl_trancl_trancl
thf(fact_8024_trancl__rtrancl__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% trancl_rtrancl_trancl
thf(fact_8025_dom__minus,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,A3: set @ B] :
      ( ( ( F2 @ X )
        = ( none @ A ) )
     => ( ( minus_minus @ ( set @ B ) @ ( dom @ B @ A @ F2 ) @ ( insert @ B @ X @ A3 ) )
        = ( minus_minus @ ( set @ B ) @ ( dom @ B @ A @ F2 ) @ A3 ) ) ) ).

% dom_minus
thf(fact_8026_insert__dom,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X: B,Y2: A] :
      ( ( ( F2 @ X )
        = ( some @ A @ Y2 ) )
     => ( ( insert @ B @ X @ ( dom @ B @ A @ F2 ) )
        = ( dom @ B @ A @ F2 ) ) ) ).

% insert_dom
thf(fact_8027_rtrancl__Un__separator__converseE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X5: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ B2 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ X5 ) @ Q )
             => ( Y4 = X5 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separator_converseE
thf(fact_8028_rtrancl__Un__separatorE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X5: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ X5 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y4 ) @ Q )
             => ( X5 = Y4 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separatorE
thf(fact_8029_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X: A,Y2: A,R: set @ ( product_prod @ A @ A ),Xs2: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_8030_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),X: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ X @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_8031_finite__set__of__finite__maps,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B4: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B4 )
       => ( finite_finite @ ( A > ( option @ B ) )
          @ ( collect @ ( A > ( option @ B ) )
            @ ^ [M3: A > ( option @ B )] :
                ( ( ( dom @ A @ B @ M3 )
                  = A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( ran @ A @ B @ M3 ) @ B4 ) ) ) ) ) ) ).

% finite_set_of_finite_maps
thf(fact_8032_graph__eq__to__snd__dom,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M3: A > ( option @ B )] :
            ( image @ A @ ( product_prod @ A @ B )
            @ ^ [X2: A] : ( product_Pair @ A @ B @ X2 @ ( the2 @ B @ ( M3 @ X2 ) ) )
            @ ( dom @ A @ B @ M3 ) ) ) ) ).

% graph_eq_to_snd_dom
thf(fact_8033_finite__Map__induct,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),P: ( A > ( option @ B ) ) > $o] :
      ( ( finite_finite @ A @ ( dom @ A @ B @ M ) )
     => ( ( P
          @ ^ [X2: A] : ( none @ B ) )
       => ( ! [K3: A,V3: B,M4: A > ( option @ B )] :
              ( ( finite_finite @ A @ ( dom @ A @ B @ M4 ) )
             => ( ~ ( member @ A @ K3 @ ( dom @ A @ B @ M4 ) )
               => ( ( P @ M4 )
                 => ( P @ ( fun_upd @ A @ ( option @ B ) @ M4 @ K3 @ ( some @ B @ V3 ) ) ) ) ) )
         => ( P @ M ) ) ) ) ).

% finite_Map_induct
thf(fact_8034_rtrancl__insert,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X2: A,Y: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A2 ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% rtrancl_insert
thf(fact_8035_dom__eq__singleton__conv,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B ),X: A] :
      ( ( ( dom @ A @ B @ F2 )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ? [V5: B] :
            ( F2
            = ( fun_upd @ A @ ( option @ B )
              @ ^ [X2: A] : ( none @ B )
              @ X
              @ ( some @ B @ V5 ) ) ) ) ) ).

% dom_eq_singleton_conv
thf(fact_8036_trancl__insert,axiom,
    ! [A: $tType,Y2: A,X: A,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X ) @ R ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [A4: A,B3: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ Y2 ) @ ( transitive_rtrancl @ A @ R ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ B3 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ) ) ).

% trancl_insert
thf(fact_8037_map__of__map__keys,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,M: A > ( option @ B )] :
      ( ( ( set2 @ A @ Xs2 )
        = ( dom @ A @ B @ M ) )
     => ( ( map_of @ A @ B
          @ ( map @ A @ ( product_prod @ A @ B )
            @ ^ [K2: A] : ( product_Pair @ A @ B @ K2 @ ( the2 @ B @ ( M @ K2 ) ) )
            @ Xs2 ) )
        = M ) ) ).

% map_of_map_keys
thf(fact_8038_dom__override__on,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B ),G: A > ( option @ B ),A3: set @ A] :
      ( ( dom @ A @ B @ ( override_on @ A @ ( option @ B ) @ F2 @ G @ A3 ) )
      = ( sup_sup @ ( set @ A )
        @ ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F2 )
          @ ( collect @ A
            @ ^ [A4: A] : ( member @ A @ A4 @ ( minus_minus @ ( set @ A ) @ A3 @ ( dom @ A @ B @ G ) ) ) ) )
        @ ( collect @ A
          @ ^ [A4: A] : ( member @ A @ A4 @ ( inf_inf @ ( set @ A ) @ A3 @ ( dom @ A @ B @ G ) ) ) ) ) ) ).

% dom_override_on
thf(fact_8039_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs: list @ A,A7: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P5 ) @ A7 )
              @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ) ).

% nths_def
thf(fact_8040_zip__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( zip @ A @ B @ Xs2 @ Ys )
        = ( nil @ ( product_prod @ A @ B ) ) )
      = ( ( Xs2
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% zip_eq_Nil_iff
thf(fact_8041_Nil__eq__zip__iff,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( nil @ ( product_prod @ A @ B ) )
        = ( zip @ A @ B @ Xs2 @ Ys ) )
      = ( ( Xs2
          = ( nil @ A ) )
        | ( Ys
          = ( nil @ B ) ) ) ) ).

% Nil_eq_zip_iff
thf(fact_8042_zip__Nil,axiom,
    ! [B: $tType,A: $tType,Ys: list @ B] :
      ( ( zip @ A @ B @ ( nil @ A ) @ Ys )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip_Nil
thf(fact_8043_map__fst__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
        = Xs2 ) ) ).

% map_fst_zip
thf(fact_8044_map__snd__zip,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
        = Ys ) ) ).

% map_snd_zip
thf(fact_8045_zip__Cons__Cons,axiom,
    ! [A: $tType,B: $tType,X: A,Xs2: list @ A,Y2: B,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs2 ) @ ( cons @ B @ Y2 @ Ys ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ).

% zip_Cons_Cons
thf(fact_8046_zip__append,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Us: list @ B,Ys: list @ A,Vs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs2 @ Ys ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Us ) @ ( zip @ A @ B @ Ys @ Vs ) ) ) ) ).

% zip_append
thf(fact_8047_map__of__zip__is__None,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys ) @ X )
          = ( none @ B ) )
        = ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) ) ) ) ) ).

% map_of_zip_is_None
thf(fact_8048_dom__map__of__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( dom @ A @ B @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
        = ( set2 @ A @ Xs2 ) ) ) ).

% dom_map_of_zip
thf(fact_8049_nth__zip,axiom,
    ! [A: $tType,B: $tType,I2: nat,Xs2: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) @ I2 )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ I2 ) @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ).

% nth_zip
thf(fact_8050_hd__zip,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( Xs2
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ( hd @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
          = ( product_Pair @ A @ B @ ( hd @ A @ Xs2 ) @ ( hd @ B @ Ys ) ) ) ) ) ).

% hd_zip
thf(fact_8051_zip__rev,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( zip @ A @ B @ ( rev @ A @ Xs2 ) @ ( rev @ B @ Ys ) )
        = ( rev @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ) ).

% zip_rev
thf(fact_8052_zip__same__conv__map,axiom,
    ! [A: $tType,Xs2: list @ A] :
      ( ( zip @ A @ A @ Xs2 @ Xs2 )
      = ( map @ A @ ( product_prod @ A @ A )
        @ ^ [X2: A] : ( product_Pair @ A @ A @ X2 @ X2 )
        @ Xs2 ) ) ).

% zip_same_conv_map
thf(fact_8053_zip_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A] :
      ( ( zip @ A @ B @ Xs2 @ ( nil @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% zip.simps(1)
thf(fact_8054_zip__update,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,I2: nat,X: A,Ys: list @ B,Y2: B] :
      ( ( zip @ A @ B @ ( list_update @ A @ Xs2 @ I2 @ X ) @ ( list_update @ B @ Ys @ I2 @ Y2 ) )
      = ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) @ I2 @ ( product_Pair @ A @ B @ X @ Y2 ) ) ) ).

% zip_update
thf(fact_8055_zip__eq__ConsE,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,Xy2: product_prod @ A @ B,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( zip @ A @ B @ Xs2 @ Ys )
        = ( cons @ ( product_prod @ A @ B ) @ Xy2 @ Xys2 ) )
     => ~ ! [X5: A,Xs4: list @ A] :
            ( ( Xs2
              = ( cons @ A @ X5 @ Xs4 ) )
           => ! [Y4: B,Ys5: list @ B] :
                ( ( Ys
                  = ( cons @ B @ Y4 @ Ys5 ) )
               => ( ( Xy2
                    = ( product_Pair @ A @ B @ X5 @ Y4 ) )
                 => ( Xys2
                   != ( zip @ A @ B @ Xs4 @ Ys5 ) ) ) ) ) ) ).

% zip_eq_ConsE
thf(fact_8056_set__zip__rightD,axiom,
    ! [A: $tType,B: $tType,X: A,Y2: B,Xs2: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
     => ( member @ B @ Y2 @ ( set2 @ B @ Ys ) ) ) ).

% set_zip_rightD
thf(fact_8057_set__zip__leftD,axiom,
    ! [B: $tType,A: $tType,X: A,Y2: B,Xs2: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs2 ) ) ) ).

% set_zip_leftD
thf(fact_8058_in__set__zipE,axiom,
    ! [A: $tType,B: $tType,X: A,Y2: B,Xs2: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
     => ~ ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
         => ~ ( member @ B @ Y2 @ ( set2 @ B @ Ys ) ) ) ) ).

% in_set_zipE
thf(fact_8059_zip__same,axiom,
    ! [A: $tType,A2: A,B2: A,Xs2: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs2 @ Xs2 ) ) )
      = ( ( member @ A @ A2 @ ( set2 @ A @ Xs2 ) )
        & ( A2 = B2 ) ) ) ).

% zip_same
thf(fact_8060_distinct__zipI2,axiom,
    ! [B: $tType,A: $tType,Ys: list @ A,Xs2: list @ B] :
      ( ( distinct @ A @ Ys )
     => ( distinct @ ( product_prod @ B @ A ) @ ( zip @ B @ A @ Xs2 @ Ys ) ) ) ).

% distinct_zipI2
thf(fact_8061_distinct__zipI1,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs2 )
     => ( distinct @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ).

% distinct_zipI1
thf(fact_8062_map__of__zip__inject,axiom,
    ! [B: $tType,A: $tType,Ys: list @ A,Xs2: list @ B,Zs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Ys )
        = ( size_size @ ( list @ B ) @ Xs2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Zs )
          = ( size_size @ ( list @ B ) @ Xs2 ) )
       => ( ( distinct @ B @ Xs2 )
         => ( ( ( map_of @ B @ A @ ( zip @ B @ A @ Xs2 @ Ys ) )
              = ( map_of @ B @ A @ ( zip @ B @ A @ Xs2 @ Zs ) ) )
           => ( Ys = Zs ) ) ) ) ) ).

% map_of_zip_inject
thf(fact_8063_update__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B,I2: nat,Xy2: product_prod @ A @ B] :
      ( ( list_update @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) @ I2 @ Xy2 )
      = ( zip @ A @ B @ ( list_update @ A @ Xs2 @ I2 @ ( product_fst @ A @ B @ Xy2 ) ) @ ( list_update @ B @ Ys @ I2 @ ( product_snd @ A @ B @ Xy2 ) ) ) ) ).

% update_zip
thf(fact_8064_zip__map__fst__snd,axiom,
    ! [B: $tType,A: $tType,Zs: list @ ( product_prod @ A @ B )] :
      ( ( zip @ A @ B @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs ) @ ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs ) )
      = Zs ) ).

% zip_map_fst_snd
thf(fact_8065_zip__left__commute,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs2 @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ B @ ( product_prod @ A @ C ) ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ B @ ( product_prod @ A @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ^ [Y: B] :
              ( product_case_prod @ A @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
              @ ^ [X2: A,Z: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y @ Z ) ) ) )
        @ ( zip @ B @ ( product_prod @ A @ C ) @ Ys @ ( zip @ A @ C @ Xs2 @ Zs ) ) ) ) ).

% zip_left_commute
thf(fact_8066_zip__assoc,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ C] :
      ( ( zip @ A @ ( product_prod @ B @ C ) @ Xs2 @ ( zip @ B @ C @ Ys @ Zs ) )
      = ( map @ ( product_prod @ ( product_prod @ A @ B ) @ C ) @ ( product_prod @ A @ ( product_prod @ B @ C ) )
        @ ( product_case_prod @ ( product_prod @ A @ B ) @ C @ ( product_prod @ A @ ( product_prod @ B @ C ) )
          @ ( product_case_prod @ A @ B @ ( C > ( product_prod @ A @ ( product_prod @ B @ C ) ) )
            @ ^ [X2: A,Y: B,Z: C] : ( product_Pair @ A @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C @ Y @ Z ) ) ) )
        @ ( zip @ ( product_prod @ A @ B ) @ C @ ( zip @ A @ B @ Xs2 @ Ys ) @ Zs ) ) ) ).

% zip_assoc
thf(fact_8067_map2__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,H2: B > C > A,F2: D > B,Xs2: list @ D,G: D > C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ H2 ) @ ( zip @ B @ C @ ( map @ D @ B @ F2 @ Xs2 ) @ ( map @ D @ C @ G @ Xs2 ) ) )
      = ( map @ D @ A
        @ ^ [X2: D] : ( H2 @ ( F2 @ X2 ) @ ( G @ X2 ) )
        @ Xs2 ) ) ).

% map2_map_map
thf(fact_8068_zip__takeWhile__fst,axiom,
    ! [A: $tType,B: $tType,P: A > $o,Xs2: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( takeWhile @ A @ P @ Xs2 ) @ Ys )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ A @ $o @ ( product_prod @ A @ B ) @ P @ ( product_fst @ A @ B ) ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ).

% zip_takeWhile_fst
thf(fact_8069_zip__takeWhile__snd,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,P: B > $o,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs2 @ ( takeWhile @ B @ P @ Ys ) )
      = ( takeWhile @ ( product_prod @ A @ B ) @ ( comp @ B @ $o @ ( product_prod @ A @ B ) @ P @ ( product_snd @ A @ B ) ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ).

% zip_takeWhile_snd
thf(fact_8070_list__eq__iff__zip__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y5: list @ A,Z4: list @ A] : ( Y5 = Z4 ) )
      = ( ^ [Xs: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [X2: product_prod @ A @ A] :
                ( ( member @ ( product_prod @ A @ A ) @ X2 @ ( set2 @ ( product_prod @ A @ A ) @ ( zip @ A @ A @ Xs @ Ys3 ) ) )
               => ( product_case_prod @ A @ A @ $o
                  @ ^ [Y5: A,Z4: A] : ( Y5 = Z4 )
                  @ X2 ) ) ) ) ) ).

% list_eq_iff_zip_eq
thf(fact_8071_zip__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( zip @ A @ B )
      = ( ^ [Xs: list @ A,Ys3: list @ B] :
            ( map @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
            @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
              @ ^ [X2: B,Y: A] : ( product_Pair @ A @ B @ Y @ X2 ) )
            @ ( zip @ B @ A @ Ys3 @ Xs ) ) ) ) ).

% zip_commute
thf(fact_8072_in__set__impl__in__set__zip2,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,Y2: B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ B @ Y2 @ ( set2 @ B @ Ys ) )
       => ~ ! [X5: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip2
thf(fact_8073_in__set__impl__in__set__zip1,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
       => ~ ! [Y4: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y4 ) @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) ) ) ) ).

% in_set_impl_in_set_zip1
thf(fact_8074_map__of__zip__is__Some,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,X: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
        = ( ? [Y: B] :
              ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys ) @ X )
              = ( some @ B @ Y ) ) ) ) ) ).

% map_of_zip_is_Some
thf(fact_8075_zip__eq__conv,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,Zs: list @ ( product_prod @ A @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( zip @ A @ B @ Xs2 @ Ys )
          = Zs )
        = ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Zs )
            = Xs2 )
          & ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Zs )
            = Ys ) ) ) ) ).

% zip_eq_conv
thf(fact_8076_map__zip__map2,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( product_prod @ B @ C ) > A,Xs2: list @ B,G: D > C,Ys: list @ D] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ Xs2 @ ( map @ D @ C @ G @ Ys ) ) )
      = ( map @ ( product_prod @ B @ D ) @ A
        @ ( product_case_prod @ B @ D @ A
          @ ^ [X2: B,Y: D] : ( F2 @ ( product_Pair @ B @ C @ X2 @ ( G @ Y ) ) ) )
        @ ( zip @ B @ D @ Xs2 @ Ys ) ) ) ).

% map_zip_map2
thf(fact_8077_map__zip__map,axiom,
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( product_prod @ B @ C ) > A,G: D > B,Xs2: list @ D,Ys: list @ C] :
      ( ( map @ ( product_prod @ B @ C ) @ A @ F2 @ ( zip @ B @ C @ ( map @ D @ B @ G @ Xs2 ) @ Ys ) )
      = ( map @ ( product_prod @ D @ C ) @ A
        @ ( product_case_prod @ D @ C @ A
          @ ^ [X2: D,Y: C] : ( F2 @ ( product_Pair @ B @ C @ ( G @ X2 ) @ Y ) ) )
        @ ( zip @ D @ C @ Xs2 @ Ys ) ) ) ).

% map_zip_map
thf(fact_8078_zip__map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,D: $tType,F2: C > A,Xs2: list @ C,G: D > B,Ys: list @ D] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs2 ) @ ( map @ D @ B @ G @ Ys ) )
      = ( map @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X2: C,Y: D] : ( product_Pair @ A @ B @ ( F2 @ X2 ) @ ( G @ Y ) ) )
        @ ( zip @ C @ D @ Xs2 @ Ys ) ) ) ).

% zip_map_map
thf(fact_8079_zip__map2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs2: list @ A,F2: C > B,Ys: list @ C] :
      ( ( zip @ A @ B @ Xs2 @ ( map @ C @ B @ F2 @ Ys ) )
      = ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
          @ ^ [X2: A,Y: C] : ( product_Pair @ A @ B @ X2 @ ( F2 @ Y ) ) )
        @ ( zip @ A @ C @ Xs2 @ Ys ) ) ) ).

% zip_map2
thf(fact_8080_zip__map1,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: C > A,Xs2: list @ C,Ys: list @ B] :
      ( ( zip @ A @ B @ ( map @ C @ A @ F2 @ Xs2 ) @ Ys )
      = ( map @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ B @ ( product_prod @ A @ B )
          @ ^ [X2: C] : ( product_Pair @ A @ B @ ( F2 @ X2 ) ) )
        @ ( zip @ C @ B @ Xs2 @ Ys ) ) ) ).

% zip_map1
thf(fact_8081_zip__Cons,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Y2: B,Ys: list @ B] :
      ( ( zip @ A @ B @ Xs2 @ ( cons @ B @ Y2 @ Ys ) )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ A @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Z: A,Zs3: list @ A] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Z @ Y2 ) @ ( zip @ A @ B @ Zs3 @ Ys ) )
        @ Xs2 ) ) ).

% zip_Cons
thf(fact_8082_zip__Cons1,axiom,
    ! [A: $tType,B: $tType,X: A,Xs2: list @ A,Ys: list @ B] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs2 ) @ Ys )
      = ( case_list @ ( list @ ( product_prod @ A @ B ) ) @ B @ ( nil @ ( product_prod @ A @ B ) )
        @ ^ [Y: B,Ys3: list @ B] : ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( zip @ A @ B @ Xs2 @ Ys3 ) )
        @ Ys ) ) ).

% zip_Cons1
thf(fact_8083_map__of__zip__map,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,F2: A > B] :
      ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ ( map @ A @ B @ F2 @ Xs2 ) ) )
      = ( ^ [X2: A] : ( if @ ( option @ B ) @ ( member @ A @ X2 @ ( set2 @ A @ Xs2 ) ) @ ( some @ B @ ( F2 @ X2 ) ) @ ( none @ B ) ) ) ) ).

% map_of_zip_map
thf(fact_8084_map__of__zip__upd,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,Xs2: list @ A,Zs: list @ B,X: A,Y2: B,Z2: B] :
      ( ( ( size_size @ ( list @ B ) @ Ys )
        = ( size_size @ ( list @ A ) @ Xs2 ) )
     => ( ( ( size_size @ ( list @ B ) @ Zs )
          = ( size_size @ ( list @ A ) @ Xs2 ) )
       => ( ~ ( member @ A @ X @ ( set2 @ A @ Xs2 ) )
         => ( ( ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys ) ) @ X @ ( some @ B @ Y2 ) )
              = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Zs ) ) @ X @ ( some @ B @ Z2 ) ) )
           => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys ) )
              = ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Zs ) ) ) ) ) ) ) ).

% map_of_zip_upd
thf(fact_8085_ran__map__of__zip,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( distinct @ A @ Xs2 )
       => ( ( ran @ A @ B @ ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
          = ( set2 @ B @ Ys ) ) ) ) ).

% ran_map_of_zip
thf(fact_8086_nths__shift__lemma__Suc,axiom,
    ! [A: $tType,P: nat > $o,Xs2: list @ A,Is: list @ nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( P @ ( suc @ ( product_snd @ A @ nat @ P5 ) ) )
          @ ( zip @ A @ nat @ Xs2 @ Is ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( P @ ( product_snd @ A @ nat @ P5 ) )
          @ ( zip @ A @ nat @ Xs2 @ ( map @ nat @ nat @ suc @ Is ) ) ) ) ) ).

% nths_shift_lemma_Suc
thf(fact_8087_map__of__zip__nth,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,I2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( distinct @ A @ Xs2 )
       => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ B ) @ Ys ) )
         => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs2 @ Ys ) @ ( nth @ A @ Xs2 @ I2 ) )
            = ( some @ B @ ( nth @ B @ Ys @ I2 ) ) ) ) ) ) ).

% map_of_zip_nth
thf(fact_8088_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P2: product_prod @ A @ B,Xs2: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ P2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
      = ( ? [N2: nat] :
            ( ( ( nth @ A @ Xs2 @ N2 )
              = ( product_fst @ A @ B @ P2 ) )
            & ( ( nth @ B @ Ys @ N2 )
              = ( product_snd @ A @ B @ P2 ) )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs2 ) )
            & ( ord_less @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ).

% in_set_zip
thf(fact_8089_nths__shift__lemma,axiom,
    ! [A: $tType,A3: set @ nat,Xs2: list @ A,I2: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P5 ) @ A3 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ I2 @ ( plus_plus @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P5 ) @ I2 ) @ A3 )
          @ ( zip @ A @ nat @ Xs2 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_8090_listrel__iff__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs2 )
          = ( size_size @ ( list @ B ) @ Ys ) )
        & ! [X2: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ X2 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) ) )
           => ( product_case_prod @ A @ B @ $o
              @ ^ [Y: A,Z: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Z ) @ R )
              @ X2 ) ) ) ) ).

% listrel_iff_zip
thf(fact_8091_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu3: product_prod @ A @ B] :
          ? [I4: nat] :
            ( ( Uu3
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs2 @ I4 ) @ ( nth @ B @ Ys @ I4 ) ) )
            & ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% set_zip
thf(fact_8092_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_8093_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_8094_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_8095_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ Z2 @ ( ord_min @ A @ X @ Y2 ) )
          = ( ( ord_less @ A @ Z2 @ X )
            & ( ord_less @ A @ Z2 @ Y2 ) ) ) ) ).

% min_less_iff_conj
thf(fact_8096_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_8097_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_8098_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_Suc_Suc
thf(fact_8099_min__0R,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ N @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_8100_min__0L,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_8101_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% take_bit_take_bit
thf(fact_8102_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_8103_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U2 ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(1)
thf(fact_8104_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_8105_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_8106_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_8107_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_8108_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_8109_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_8110_listrel__rtrancl__refl,axiom,
    ! [A: $tType,Xs2: list @ A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Xs2 ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ).

% listrel_rtrancl_refl
thf(fact_8111_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M @ N ) ) ) ) ).

% take_bit_of_mask
thf(fact_8112_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U2 ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_8113_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(3)
thf(fact_8114_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U2: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U2 ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_8115_min__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_8116_min__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% min_numeral_Suc
thf(fact_8117_zip__replicate,axiom,
    ! [A: $tType,B: $tType,I2: nat,X: A,J: nat,Y2: B] :
      ( ( zip @ A @ B @ ( replicate @ A @ I2 @ X ) @ ( replicate @ B @ J @ Y2 ) )
      = ( replicate @ ( product_prod @ A @ B ) @ ( ord_min @ nat @ I2 @ J ) @ ( product_Pair @ A @ B @ X @ Y2 ) ) ) ).

% zip_replicate
thf(fact_8118_length__zip,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( zip @ A @ B @ Xs2 @ Ys ) )
      = ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs2 ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_zip
thf(fact_8119_listrel__rtrancl__trans,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A ),Zs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Zs ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ) ) ).

% listrel_rtrancl_trans
thf(fact_8120_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_8121_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_8122_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_8123_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_8124_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_8125_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( A4
              = ( ord_min @ A @ A4 @ B3 ) ) ) ) ) ).

% min.order_iff
thf(fact_8126_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_8127_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_8128_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = A4 ) ) ) ) ).

% min.absorb_iff1
thf(fact_8129_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A4: A] :
              ( ( ord_min @ A @ A4 @ B3 )
              = B3 ) ) ) ) ).

% min.absorb_iff2
thf(fact_8130_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_8131_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_8132_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y2 ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            | ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) ).

% min_le_iff_disj
thf(fact_8133_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ A4 @ B3 ) ) ) ) ).

% min_def
thf(fact_8134_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_min @ A @ X @ Y2 )
            = X ) ) ) ).

% min_absorb1
thf(fact_8135_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( ord_min @ A @ X @ Y2 )
            = Y2 ) ) ) ).

% min_absorb2
thf(fact_8136_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A4: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B3 ) @ A4 @ B3 ) ) ) ) ).

% min_def_raw
thf(fact_8137_listrel__mono,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( listrel @ A @ B @ R ) @ ( listrel @ A @ B @ S ) ) ) ).

% listrel_mono
thf(fact_8138_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L2: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N @ K @ L2 ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N ) @ L2 ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_8139_listrel__eq__len,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ A,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R ) )
     => ( ( size_size @ ( list @ A ) @ Xs2 )
        = ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% listrel_eq_len
thf(fact_8140_listrel__Nil2,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) )
     => ( Xs2
        = ( nil @ A ) ) ) ).

% listrel_Nil2
thf(fact_8141_listrel__Nil1,axiom,
    ! [A: $tType,B: $tType,Xs2: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs2 ) @ ( listrel @ A @ B @ R ) )
     => ( Xs2
        = ( nil @ B ) ) ) ).

% listrel_Nil1
thf(fact_8142_listrel_ONil,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B )] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) ) ).

% listrel.Nil
thf(fact_8143_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y2 ) @ Z2 )
          = ( ( ord_less @ A @ X @ Z2 )
            | ( ord_less @ A @ Y2 @ Z2 ) ) ) ) ).

% min_less_iff_disj
thf(fact_8144_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_8145_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B3: A] :
              ( ( A4
                = ( ord_min @ A @ A4 @ B3 ) )
              & ( A4 != B3 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_8146_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_8147_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_8148_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y2: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X @ Y2 ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y2 ) ) ) ) ).

% of_nat_min
thf(fact_8149_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N @ Q2 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q2 ) ) ) ).

% nat_mult_min_right
thf(fact_8150_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q2: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N ) @ Q2 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q2 ) @ ( times_times @ nat @ N @ Q2 ) ) ) ).

% nat_mult_min_left
thf(fact_8151_min__diff,axiom,
    ! [M: nat,I2: nat,N: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I2 ) @ ( minus_minus @ nat @ N @ I2 ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N ) @ I2 ) ) ).

% min_diff
thf(fact_8152_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y2 ) @ Z2 )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z2 ) @ ( minus_minus @ A @ Y2 @ Z2 ) ) ) ) ).

% min_diff_distrib_left
thf(fact_8153_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y2 @ Z2 ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y2 ) @ ( plus_plus @ A @ X @ Z2 ) ) ) ) ).

% min_add_distrib_right
thf(fact_8154_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y2 ) @ Z2 )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z2 ) @ ( plus_plus @ A @ Y2 @ Z2 ) ) ) ) ).

% min_add_distrib_left
thf(fact_8155_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y2: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y2 ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% minus_min_eq_max
thf(fact_8156_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y2: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y2 ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% minus_max_eq_min
thf(fact_8157_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L2: int,R: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N @ K @ L2 ) @ R )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N ) @ L2 @ R ) ) ) ).

% concat_bit_assoc_sym
thf(fact_8158_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_8159_listrel__Cons2,axiom,
    ! [B: $tType,A: $tType,Xs2: list @ A,Y2: B,Ys: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ ( cons @ B @ Y2 @ Ys ) ) @ ( listrel @ A @ B @ R ) )
     => ~ ! [X5: A,Xs3: list @ A] :
            ( ( Xs2
              = ( cons @ A @ X5 @ Xs3 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y2 ) @ R )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel_Cons2
thf(fact_8160_listrel__Cons1,axiom,
    ! [B: $tType,A: $tType,Y2: A,Ys: list @ A,Xs2: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y2 @ Ys ) @ Xs2 ) @ ( listrel @ A @ B @ R ) )
     => ~ ! [Y4: B,Ys4: list @ B] :
            ( ( Xs2
              = ( cons @ B @ Y4 @ Ys4 ) )
           => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y2 @ Y4 ) @ R )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys @ Ys4 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel_Cons1
thf(fact_8161_listrel_OCons,axiom,
    ! [B: $tType,A: $tType,X: A,Y2: B,R: set @ ( product_prod @ A @ B ),Xs2: list @ A,Ys: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y2 ) @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X @ Xs2 ) @ ( cons @ B @ Y2 @ Ys ) ) @ ( listrel @ A @ B @ R ) ) ) ) ).

% listrel.Cons
thf(fact_8162_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_max @ A @ X @ Y2 ) )
              = ( ord_max @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_max @ A @ X @ Y2 ) )
              = ( ord_min @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y2 ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_8163_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_min @ A @ X @ Y2 ) )
              = ( ord_min @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ P2 @ ( ord_min @ A @ X @ Y2 ) )
              = ( ord_max @ A @ ( times_times @ A @ P2 @ X ) @ ( times_times @ A @ P2 @ Y2 ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_8164_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_8165_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P2: A,X: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P2 ) @ ( times_times @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_8166_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P2: A,X: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_8167_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P2: A,X: A,Y2: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y2 ) @ P2 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P2 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y2 ) @ P2 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P2 ) @ ( divide_divide @ A @ Y2 @ P2 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_8168_min__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ N @ M5 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_8169_min__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M5: nat] : ( suc @ ( ord_min @ nat @ M5 @ N ) )
        @ M ) ) ).

% min_Suc2
thf(fact_8170_listrel__reflcl__if__listrel1,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% listrel_reflcl_if_listrel1
thf(fact_8171_enumerate__eq__zip,axiom,
    ! [A: $tType] :
      ( ( enumerate @ A )
      = ( ^ [N2: nat,Xs: list @ A] : ( zip @ nat @ A @ ( upt @ N2 @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) @ Xs ) ) ) ).

% enumerate_eq_zip
thf(fact_8172_listrel__rtrancl__eq__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( listrel @ A @ A @ ( transitive_rtrancl @ A @ R ) )
      = ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel_rtrancl_eq_rtrancl_listrel1
thf(fact_8173_rtrancl__listrel1__if__listrel,axiom,
    ! [A: $tType,Xs2: list @ A,Ys: list @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( listrel @ A @ A @ R ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ) ).

% rtrancl_listrel1_if_listrel
thf(fact_8174_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% mod_exp_eq
thf(fact_8175_listrel_Osimps,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( A1
            = ( nil @ A ) )
          & ( A22
            = ( nil @ B ) ) )
        | ? [X2: A,Y: B,Xs: list @ A,Ys3: list @ B] :
            ( ( A1
              = ( cons @ A @ X2 @ Xs ) )
            & ( A22
              = ( cons @ B @ Y @ Ys3 ) )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R )
            & ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys3 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ).

% listrel.simps
thf(fact_8176_listrel_Ocases,axiom,
    ! [B: $tType,A: $tType,A1: list @ A,A22: list @ B,R: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A22 ) @ ( listrel @ A @ B @ R ) )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ! [X5: A,Y4: B,Xs3: list @ A] :
              ( ( A1
                = ( cons @ A @ X5 @ Xs3 ) )
             => ! [Ys4: list @ B] :
                  ( ( A22
                    = ( cons @ B @ Y4 @ Ys4 ) )
                 => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y4 ) @ R )
                   => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys4 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ) ) ).

% listrel.cases
thf(fact_8177_concat__injective,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xs2 )
        = ( concat @ A @ Ys ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs2 )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ! [X5: product_prod @ ( list @ A ) @ ( list @ A )] :
              ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X5 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) ) )
             => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
                @ ^ [Y: list @ A,Z: list @ A] :
                    ( ( size_size @ ( list @ A ) @ Y )
                    = ( size_size @ ( list @ A ) @ Z ) )
                @ X5 ) )
         => ( Xs2 = Ys ) ) ) ) ).

% concat_injective
thf(fact_8178_concat__eq__concat__iff,axiom,
    ! [A: $tType,Xs2: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ! [X5: product_prod @ ( list @ A ) @ ( list @ A )] :
          ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ X5 @ ( set2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( zip @ ( list @ A ) @ ( list @ A ) @ Xs2 @ Ys ) ) )
         => ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
            @ ^ [Y: list @ A,Z: list @ A] :
                ( ( size_size @ ( list @ A ) @ Y )
                = ( size_size @ ( list @ A ) @ Z ) )
            @ X5 ) )
     => ( ( ( size_size @ ( list @ ( list @ A ) ) @ Xs2 )
          = ( size_size @ ( list @ ( list @ A ) ) @ Ys ) )
       => ( ( ( concat @ A @ Xs2 )
            = ( concat @ A @ Ys ) )
          = ( Xs2 = Ys ) ) ) ) ).

% concat_eq_concat_iff
thf(fact_8179_listrel__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel @ A @ A @ R ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R ) ) ) ).

% listrel_subset_rtrancl_listrel1

% Type constructors (769)
thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_2,axiom,
    ! [A16: $tType] : ( bounded_lattice @ ( filter @ A16 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_3,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_4,axiom,
    ! [A16: $tType] : ( bounded_lattice @ ( set @ A16 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_5,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounded_lattice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( condit1219197933456340205attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( counta3822494911875563373attice @ A19 )
     => ( counta3822494911875563373attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( comple592849572758109894attice @ A19 )
     => ( comple592849572758109894attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounde4967611905675639751up_bot @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounde4346867609351753570nf_top @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( comple6319245703460814977attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( boolea8198339166811842893lgebra @ A19 )
     => ( boolea8198339166811842893lgebra @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( semilattice_sup @ A19 )
     => ( semilattice_sup @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( semilattice_inf @ A19 )
     => ( semilattice_inf @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( order_top @ A19 )
     => ( order_top @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( order_bot @ A19 )
     => ( order_bot @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( preorder @ A19 )
     => ( preorder @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( lattice @ A19 )
     => ( lattice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( order @ A19 )
     => ( order @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( ord @ A19 )
     => ( ord @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( uminus @ A19 )
     => ( uminus @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( minus @ A19 )
     => ( minus @ ( A16 > A19 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_7,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_8,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___Groups_Ominus_14,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_23,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_24,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_25,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_26,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_27,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_28,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_29,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_30,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_31,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_32,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_33,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_34,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_35,axiom,
    topolo4987421752381908075d_mult @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_36,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_37,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_38,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_39,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_40,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_41,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_42,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_43,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_44,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_45,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_46,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_47,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_48,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_49,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_50,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_51,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_52,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_53,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_54,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_55,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_56,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_57,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_58,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_59,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_60,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_61,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_62,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_63,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_64,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_65,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_66,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_67,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_68,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_69,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_70,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_71,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_72,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_73,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_74,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_75,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_76,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_77,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_78,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_79,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_80,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_81,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_82,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_83,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_84,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_85,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_86,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_87,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_88,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_89,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_90,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_91,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_92,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_93,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_94,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_95,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_96,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_97,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_98,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_99,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_100,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_101,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_102,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_103,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_104,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_105,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_106,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_107,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_108,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_109,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_110,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_111,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_112,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_113,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_114,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_115,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_116,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_117,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_118,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_119,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_120,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_121,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_122,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_123,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_124,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_125,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_126,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_127,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_128,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_129,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_130,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_131,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_132,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_133,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_134,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_135,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_136,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_137,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_138,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_139,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_140,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_141,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_142,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_143,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_144,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_145,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_146,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_147,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_148,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_149,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_150,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_151,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_152,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_153,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_154,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_155,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_156,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_157,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_158,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_159,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_160,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_161,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_162,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_163,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_164,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_165,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_166,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_167,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_168,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_169,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_170,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_171,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_172,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_173,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_174,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_175,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_176,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_177,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_178,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_179,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_180,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_181,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_182,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_183,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_184,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_185,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_186,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_187,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_188,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_189,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_190,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_191,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_192,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_193,axiom,
    ! [A16: $tType] : ( condit1219197933456340205attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_194,axiom,
    ! [A16: $tType] : ( counta3822494911875563373attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_195,axiom,
    ! [A16: $tType] : ( comple592849572758109894attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_196,axiom,
    ! [A16: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_197,axiom,
    ! [A16: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_198,axiom,
    ! [A16: $tType] : ( comple6319245703460814977attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_199,axiom,
    ! [A16: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_200,axiom,
    ! [A16: $tType] : ( semilattice_sup @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_201,axiom,
    ! [A16: $tType] : ( semilattice_inf @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_202,axiom,
    ! [A16: $tType] : ( order_top @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_203,axiom,
    ! [A16: $tType] : ( order_bot @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_204,axiom,
    ! [A16: $tType] : ( preorder @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_205,axiom,
    ! [A16: $tType] : ( lattice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_206,axiom,
    ! [A16: $tType] : ( order @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_207,axiom,
    ! [A16: $tType] : ( ord @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_208,axiom,
    ! [A16: $tType] : ( uminus @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_209,axiom,
    ! [A16: $tType] : ( minus @ ( set @ A16 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_210,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_211,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_212,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_213,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_214,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_215,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_216,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_217,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_218,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_219,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_220,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_221,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_222,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_223,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_224,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_225,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_226,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_227,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_228,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_229,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_230,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_231,axiom,
    minus @ $o ).

thf(tcon_List_Olist___Nat_Osize_232,axiom,
    ! [A16: $tType] : ( size @ ( list @ A16 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_233,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_234,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_235,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_236,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_237,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_238,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_239,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_240,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_241,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_242,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_243,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_244,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_245,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_246,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_247,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_248,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_249,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_250,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_251,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_252,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_253,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_254,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_255,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_256,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_257,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_258,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_259,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_260,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_261,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_262,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_263,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_264,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_265,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_266,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Odist__norm,axiom,
    real_V6936659425649961206t_norm @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_267,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_268,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_269,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_270,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_271,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_272,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_273,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_274,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_275,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_276,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_277,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_278,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_279,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_280,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_281,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_282,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_283,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_284,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_285,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_286,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_287,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_288,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_289,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_290,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_291,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_292,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_293,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_294,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_295,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_296,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_297,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_298,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_299,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_300,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_301,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_302,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_303,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_304,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_305,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_306,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_307,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_308,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_309,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_310,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_311,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_312,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_313,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_314,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_315,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_316,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_317,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_318,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_319,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_320,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_321,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_322,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_323,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_324,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_325,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_326,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_327,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Groups_Ominus_328,axiom,
    minus @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_329,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_330,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_331,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_332,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_333,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_334,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_335,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_336,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_337,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_338,axiom,
    size @ char ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_339,axiom,
    ! [A16: $tType] : ( condit1219197933456340205attice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_340,axiom,
    ! [A16: $tType] : ( counta3822494911875563373attice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_341,axiom,
    ! [A16: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_342,axiom,
    ! [A16: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_343,axiom,
    ! [A16: $tType] : ( comple6319245703460814977attice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_344,axiom,
    ! [A16: $tType] : ( semilattice_sup @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_345,axiom,
    ! [A16: $tType] : ( semilattice_inf @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_346,axiom,
    ! [A16: $tType] : ( order_top @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_347,axiom,
    ! [A16: $tType] : ( order_bot @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_348,axiom,
    ! [A16: $tType] : ( preorder @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_349,axiom,
    ! [A16: $tType] : ( lattice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_350,axiom,
    ! [A16: $tType] : ( order @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_351,axiom,
    ! [A16: $tType] : ( ord @ ( filter @ A16 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_352,axiom,
    ! [A16: $tType] : ( size @ ( option @ A16 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_353,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_354,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_355,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_356,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_357,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_358,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_359,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_360,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_361,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_362,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_363,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_364,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_365,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_366,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_367,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_368,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_369,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_370,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_371,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_372,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_373,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_374,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_375,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_376,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_377,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_378,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_379,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Odist__norm_380,axiom,
    real_V6936659425649961206t_norm @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_381,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_382,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_383,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_384,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_385,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_386,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_387,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_388,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_389,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_390,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_391,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_392,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_393,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_394,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_395,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_396,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_397,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_398,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_399,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_400,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_401,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_402,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_403,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_404,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_405,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_406,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_407,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_408,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_409,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_410,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_411,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_412,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_413,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_414,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_415,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_416,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_417,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_418,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ominus_419,axiom,
    minus @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_420,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_421,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_422,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_423,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_424,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_425,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_426,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_427,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_428,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_429,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_430,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_431,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_432,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_433,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_434,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_435,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_436,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_437,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_438,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_439,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_440,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_441,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_442,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_443,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_444,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_445,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_446,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_447,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_448,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_449,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_450,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_451,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_452,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_453,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_454,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_455,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_456,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_457,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_458,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_459,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_460,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_461,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_462,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_463,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_464,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_465,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_466,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_467,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_468,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_469,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_470,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_471,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_472,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_473,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ominus_474,axiom,
    minus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_475,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_476,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_477,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_478,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_479,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_480,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_481,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( ( topolo4958980785337419405_space @ A16 )
        & ( topolo4958980785337419405_space @ A19 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A16 @ A19 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_482,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( ( topological_t2_space @ A16 )
        & ( topological_t2_space @ A19 ) )
     => ( topological_t2_space @ ( product_prod @ A16 @ A19 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_483,axiom,
    ! [A16: $tType,A19: $tType] : ( size @ ( product_prod @ A16 @ A19 ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_484,axiom,
    condit6923001295902523014norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_485,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__lattice_486,axiom,
    counta3822494911875563373attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_487,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_488,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_489,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_490,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_491,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_492,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_493,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_494,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_495,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__top_496,axiom,
    order_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_497,axiom,
    order_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_498,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_499,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_500,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_501,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_502,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_503,axiom,
    uminus @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ominus_504,axiom,
    minus @ product_unit ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_505,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_506,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_507,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_508,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_509,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_510,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_511,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_512,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_513,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_514,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_515,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_516,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_517,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_518,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_519,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_520,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_521,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_522,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_523,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_524,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_525,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_526,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_527,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_528,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_529,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_530,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_531,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_532,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_533,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_534,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_535,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_536,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_537,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_538,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_539,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_540,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_541,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_542,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_543,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_544,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_545,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_546,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_547,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_548,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_549,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_550,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_551,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_552,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_553,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_554,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_555,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_556,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_557,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_558,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_559,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_560,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_561,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_562,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_563,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_564,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_565,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_566,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_567,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_568,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_569,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_570,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_571,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_572,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_573,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_574,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_575,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_576,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_577,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_578,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_579,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_580,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_581,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_582,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_583,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_584,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_585,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_586,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_587,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_588,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_589,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_590,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_591,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_592,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_593,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_594,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_595,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_596,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_597,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_598,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_599,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_600,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_601,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_602,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_603,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y2: A] :
      ( ( if @ A @ $false @ X @ Y2 )
      = Y2 ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y2: A] :
      ( ( if @ A @ $true @ X @ Y2 )
      = X ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X4: A] : ( P @ X4 ) ) ) ).

% Conjectures (2)
thf(conj_0,hypothesis,
    ( ( vEBT_VEBT_high @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
    = ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

thf(conj_1,conjecture,
    vEBT_vebt_member @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ xa @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ia @ ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

%------------------------------------------------------------------------------
